/*!
 * The MIT License (MIT)
 *
 * Copyright (c) 2013-2021 Chananya Freiman
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */(()=>{"use strict";var t={187:t=>{var e,i="object"==typeof Reflect?Reflect:null,r=i&&"function"==typeof i.apply?i.apply:function(t,e,i){return Function.prototype.apply.call(t,e,i)};e=i&&"function"==typeof i.ownKeys?i.ownKeys:Object.getOwnPropertySymbols?function(t){return Object.getOwnPropertyNames(t).concat(Object.getOwnPropertySymbols(t))}:function(t){return Object.getOwnPropertyNames(t)};var n=Number.isNaN||function(t){return t!=t};function s(){s.init.call(this)}t.exports=s,t.exports.once=function(t,e){return new Promise((function(i,r){function n(i){t.removeListener(e,s),r(i)}function s(){"function"==typeof t.removeListener&&t.removeListener("error",n),i([].slice.call(arguments))}g(t,e,s,{once:!0}),"error"!==e&&function(t,e,i){"function"==typeof t.on&&g(t,"error",e,i)}(t,n,{once:!0})}))},s.EventEmitter=s,s.prototype._events=void 0,s.prototype._eventsCount=0,s.prototype._maxListeners=void 0;var a=10;function o(t){if("function"!=typeof t)throw new TypeError('The "listener" argument must be of type Function. Received type '+typeof t)}function l(t){return void 0===t._maxListeners?s.defaultMaxListeners:t._maxListeners}function h(t,e,i,r){var n,s,a,h;if(o(i),void 0===(s=t._events)?(s=t._events=Object.create(null),t._eventsCount=0):(void 0!==s.newListener&&(t.emit("newListener",e,i.listener?i.listener:i),s=t._events),a=s[e]),void 0===a)a=s[e]=i,++t._eventsCount;else if("function"==typeof a?a=s[e]=r?[i,a]:[a,i]:r?a.unshift(i):a.push(i),(n=l(t))>0&&a.length>n&&!a.warned){a.warned=!0;var c=new Error("Possible EventEmitter memory leak detected. "+a.length+" "+String(e)+" listeners added. Use emitter.setMaxListeners() to increase limit");c.name="MaxListenersExceededWarning",c.emitter=t,c.type=e,c.count=a.length,h=c,console&&console.warn&&console.warn(h)}return t}function c(){if(!this.fired)return this.target.removeListener(this.type,this.wrapFn),this.fired=!0,0===arguments.length?this.listener.call(this.target):this.listener.apply(this.target,arguments)}function d(t,e,i){var r={fired:!1,wrapFn:void 0,target:t,type:e,listener:i},n=c.bind(r);return n.listener=i,r.wrapFn=n,n}function u(t,e,i){var r=t._events;if(void 0===r)return[];var n=r[e];return void 0===n?[]:"function"==typeof n?i?[n.listener||n]:[n]:i?function(t){for(var e=new Array(t.length),i=0;i<e.length;++i)e[i]=t[i].listener||t[i];return e}(n):m(n,n.length)}function f(t){var e=this._events;if(void 0!==e){var i=e[t];if("function"==typeof i)return 1;if(void 0!==i)return i.length}return 0}function m(t,e){for(var i=new Array(e),r=0;r<e;++r)i[r]=t[r];return i}function g(t,e,i,r){if("function"==typeof t.on)r.once?t.once(e,i):t.on(e,i);else{if("function"!=typeof t.addEventListener)throw new TypeError('The "emitter" argument must be of type EventEmitter. Received type '+typeof t);t.addEventListener(e,(function n(s){r.once&&t.removeEventListener(e,n),i(s)}))}}Object.defineProperty(s,"defaultMaxListeners",{enumerable:!0,get:function(){return a},set:function(t){if("number"!=typeof t||t<0||n(t))throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received '+t+".");a=t}}),s.init=function(){void 0!==this._events&&this._events!==Object.getPrototypeOf(this)._events||(this._events=Object.create(null),this._eventsCount=0),this._maxListeners=this._maxListeners||void 0},s.prototype.setMaxListeners=function(t){if("number"!=typeof t||t<0||n(t))throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received '+t+".");return this._maxListeners=t,this},s.prototype.getMaxListeners=function(){return l(this)},s.prototype.emit=function(t){for(var e=[],i=1;i<arguments.length;i++)e.push(arguments[i]);var n="error"===t,s=this._events;if(void 0!==s)n=n&&void 0===s.error;else if(!n)return!1;if(n){var a;if(e.length>0&&(a=e[0]),a instanceof Error)throw a;var o=new Error("Unhandled error."+(a?" ("+a.message+")":""));throw o.context=a,o}var l=s[t];if(void 0===l)return!1;if("function"==typeof l)r(l,this,e);else{var h=l.length,c=m(l,h);for(i=0;i<h;++i)r(c[i],this,e)}return!0},s.prototype.addListener=function(t,e){return h(this,t,e,!1)},s.prototype.on=s.prototype.addListener,s.prototype.prependListener=function(t,e){return h(this,t,e,!0)},s.prototype.once=function(t,e){return o(e),this.on(t,d(this,t,e)),this},s.prototype.prependOnceListener=function(t,e){return o(e),this.prependListener(t,d(this,t,e)),this},s.prototype.removeListener=function(t,e){var i,r,n,s,a;if(o(e),void 0===(r=this._events))return this;if(void 0===(i=r[t]))return this;if(i===e||i.listener===e)0==--this._eventsCount?this._events=Object.create(null):(delete r[t],r.removeListener&&this.emit("removeListener",t,i.listener||e));else if("function"!=typeof i){for(n=-1,s=i.length-1;s>=0;s--)if(i[s]===e||i[s].listener===e){a=i[s].listener,n=s;break}if(n<0)return this;0===n?i.shift():function(t,e){for(;e+1<t.length;e++)t[e]=t[e+1];t.pop()}(i,n),1===i.length&&(r[t]=i[0]),void 0!==r.removeListener&&this.emit("removeListener",t,a||e)}return this},s.prototype.off=s.prototype.removeListener,s.prototype.removeAllListeners=function(t){var e,i,r;if(void 0===(i=this._events))return this;if(void 0===i.removeListener)return 0===arguments.length?(this._events=Object.create(null),this._eventsCount=0):void 0!==i[t]&&(0==--this._eventsCount?this._events=Object.create(null):delete i[t]),this;if(0===arguments.length){var n,s=Object.keys(i);for(r=0;r<s.length;++r)"removeListener"!==(n=s[r])&&this.removeAllListeners(n);return this.removeAllListeners("removeListener"),this._events=Object.create(null),this._eventsCount=0,this}if("function"==typeof(e=i[t]))this.removeListener(t,e);else if(void 0!==e)for(r=e.length-1;r>=0;r--)this.removeListener(t,e[r]);return this},s.prototype.listeners=function(t){return u(this,t,!0)},s.prototype.rawListeners=function(t){return u(this,t,!1)},s.listenerCount=function(t,e){return"function"==typeof t.listenerCount?t.listenerCount(e):f.call(t,e)},s.prototype.listenerCount=f,s.prototype.eventNames=function(){return this._eventsCount>0?e(this._events):[]}}},e={};function i(r){var n=e[r];if(void 0!==n)return n.exports;var s=e[r]={exports:{}};return t[r](s,s.exports,i),s.exports}(()=>{function t(t){if(t&&t.length){let e=t.lastIndexOf("/");return-1!==e&&(t=t.slice(e+1)),e=t.lastIndexOf("\\"),-1!==e&&(t=t.slice(e+1)),t}return""}function e(t){if(t&&t.length){const e=t.lastIndexOf(".");return-1!==e&&(t=t.slice(e).toLowerCase()),t}return""}class r{constructor(){this.rows=[]}load(t){if(!t.startsWith("ID"))throw new Error("WrongMagicNumber");const e=this.rows;let i=0,r=0;for(const n of t.split("\n"))if("B"!==n[0])for(const t of n.split(";")){const n=t[0],s=t.substring(1).trim();let a;"X"===n?i=parseInt(s,10)-1:"Y"===n?r=parseInt(s,10)-1:"K"===n&&(e[r]||(e[r]=[]),'"'===s[0]?a=s.substring(1,s.length-1):"TRUE"===s?a=!0:"FALSE"===s?a=!1:(a=parseFloat(s),isNaN(a)&&(a=s)),e[r][i]=a)}}save(){const t=this.rows,e=t.length,i=[];let r=0;for(let n=0;n<e;n++){const e=t[n],s=e.length;s>r&&(r=s);let a=!0;for(let t=0;t<s;t++){const r=e[t];if(void 0!==r){let e;e="string"==typeof r?`"${r}"`:"boolean"==typeof r?r?"TRUE":"FALSE":`${r}`,a?(a=!1,i.push(`C;X${t+1};Y${n+1};K${e}`)):i.push(`C;X${t+1};K${e}`)}}}return`ID;P\r\nB;X${r};Y${e}\r\n${i.join("\r\n")}\r\nE`}}class n{constructor(){this.properties=new Map,this.sections=new Map}load(t){let e=this.properties;const i=this.sections;for(const r of t.split("\r\n"))if(r.length&&!r.startsWith("//")&&!r.startsWith(";")){let t=r.match(/^\[(.+?)\]/);if(t){const r=t[1].trim().toLowerCase();e=i.get(r),e||(e=new Map,i.set(r,e))}else t=r.match(/^(.+?)=(.*?)$/),t&&e.set(t[1],t[2])}}save(){const t=[];for(const[e,i]of this.properties)t.push(`${e}=${i}`);for(const[e,i]of this.sections){t.push(`[${e}]`);for(const[e,r]of i)t.push(`${e}=${r}`)}return t.join("\r\n")}getSection(t){return this.sections.get(t.toLowerCase())}}class s{constructor(t){this.map={},t&&this.load(t)}load(t){if(t.startsWith("ID;")){const e=new r;e.load(t);const i=e.rows,n=i[0],s=this.map;for(let t=1,e=i.length;t<e;t++){const e=i[t];if(e){let t=e[0];if(t&&"_"!==t){t=t.toLowerCase(),s[t]||(s[t]={});const i=s[t];for(let t=0,r=n.length;t<r;t++){let r=n[t];void 0===r&&(r=`column${t}`),i[`${r}`]=e[t]}}}}}else{const e=new n;e.load(t);const i=e.sections,r=this.map;for(const[t,e]of i.entries()){r[t]||(r[t]={});const i=r[t];for(const[t,r]of e)i[t]=r}}}getRow(t){return this.map[t.toLowerCase()]}getProperty(t,e){return this.map[t.toLowerCase()][e]}setRow(t,e){this.map[t.toLowerCase()]=e}findRow(t,e){for(const i of Object.values(this.map))if(i[t]===e)return i}}var a=i(187);async function o(t,e){if("image"===e)return new Promise((e=>{const i=new Image;i.onload=()=>{e({ok:!0,data:i})},i.onerror=t=>{e({ok:!1,error:"Image Error",data:t})},i.src=t}));{let i;try{i=await fetch(t)}catch(t){return{ok:!1,error:"Network Error",data:t}}if(!i.ok)return{ok:!1,error:"Http Error",data:i};try{let t=null;return"text"===e?t=await i.text():"arrayBuffer"===e||"bytes"===e?t=await i.arrayBuffer():"blob"===e&&(t=await i.blob()),"bytes"===e&&(t=new Uint8Array(t)),{ok:!0,data:t}}catch(t){return{ok:!1,error:"Data Error",data:t}}}}class l{constructor(t,e=4){this.size=0,this.arrayBuffer=null,this.byteView=null,this.floatView=null,this.gl=t,this.buffer=t.createBuffer(),this.reserve(e)}reserve(t){if(this.size<t){const e=this.gl;this.size=4*Math.ceil(t/4),e.bindBuffer(e.ARRAY_BUFFER,this.buffer),e.bufferData(e.ARRAY_BUFFER,this.size,e.DYNAMIC_DRAW),this.arrayBuffer=new ArrayBuffer(this.size),this.byteView=new Uint8Array(this.arrayBuffer),this.floatView=new Float32Array(this.arrayBuffer)}}bindAndUpdate(t=this.size){const e=this.gl,i=this.byteView;e.bindBuffer(e.ARRAY_BUFFER,this.buffer),e.bufferSubData(e.ARRAY_BUFFER,0,i.subarray(0,t))}}class h{constructor(t,e=1,i=1){this.width=0,this.height=0,this.arrayBuffer=new ArrayBuffer(0),this.byteView=null,this.floatView=null,this.gl=t,this.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.NEAREST),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.NEAREST),this.reserve(e,i)}reserve(t,e){if(this.width<t||this.height<e){const i=this.gl;this.width=Math.max(this.width,t),this.height=Math.max(this.height,e),i.bindTexture(i.TEXTURE_2D,this.texture),i.texImage2D(i.TEXTURE_2D,0,i.RGBA,this.width,this.height,0,i.RGBA,i.FLOAT,null),this.arrayBuffer=new ArrayBuffer(this.width*this.height*16),this.byteView=new Uint8Array(this.arrayBuffer),this.floatView=new Float32Array(this.arrayBuffer)}}bindAndUpdate(t=this.width,e=this.height){const i=this.gl;i.bindTexture(i.TEXTURE_2D,this.texture),i.texSubImage2D(i.TEXTURE_2D,0,0,0,t,e,i.RGBA,i.FLOAT,this.byteView)}}class c{constructor(t,e=4,i=1,r=1){this.width=0,this.height=0,this.gl=t,this.texture=t.createTexture(),this.format=3===e?t.RGB:t.RGBA,t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.NEAREST),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.NEAREST),this.reserve(i,r)}reserve(t,e){if(this.width<t||this.height<e){const i=this.gl;this.width=Math.max(this.width,t),this.height=Math.max(this.height,e),i.bindTexture(i.TEXTURE_2D,this.texture),i.texImage2D(i.TEXTURE_2D,0,this.format,this.width,this.height,0,this.format,i.FLOAT,null)}}bindAndUpdate(t,e=this.width,i=this.height){const r=this.gl;r.bindTexture(r.TEXTURE_2D,this.texture),r.texSubImage2D(r.TEXTURE_2D,0,0,0,e,i,this.format,r.FLOAT,t)}bind(t){const e=this.gl;e.activeTexture(e.TEXTURE0+t),e.bindTexture(e.TEXTURE_2D,this.texture)}}class d{constructor(t,e){this.uniforms={},this.attribs={},this.attribsCount=0,this.webgl=t,this.program=e;const i=t.gl;for(let t=0,r=i.getProgramParameter(e,i.ACTIVE_UNIFORMS);t<r;t++){const r=i.getActiveUniform(e,t);if(r)if(1===r.size)this.uniforms[r.name]=i.getUniformLocation(e,r.name);else{const t=r.name.substr(0,r.name.length-3);for(let n=0;n<r.size;n++){const r=t+"["+n+"]";this.uniforms[r]=i.getUniformLocation(e,r)}}}for(let t=0,r=i.getProgramParameter(e,i.ACTIVE_ATTRIBUTES);t<r;t++){const r=i.getActiveAttrib(e,t);if(r)if(this.attribsCount+=r.size,1===r.size)this.attribs[r.name]=i.getAttribLocation(e,r.name);else{const t=r.name.substr(0,r.name.length-3);for(let n=0;n<r.size;n++){const r=t+"["+n+"]";this.attribs[r]=i.getAttribLocation(e,r)}}}}use(){this.webgl.useShader(this)}}class u{constructor(t,e={alpha:!1}){this.currentShader=null,this.extensions={};let i=t.getContext("webgl",e);if(i||(i=t.getContext("experimental-webgl",e)),!i)throw new Error("WebGL: Failed to create a WebGL context!");const r=new Uint8ClampedArray(16).fill(255),n=i.createTexture();i.bindTexture(i.TEXTURE_2D,n),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_S,i.CLAMP_TO_EDGE),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_T,i.CLAMP_TO_EDGE),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MAG_FILTER,i.NEAREST),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.NEAREST),i.texImage2D(i.TEXTURE_2D,0,i.RGBA,2,2,0,i.RGBA,i.UNSIGNED_BYTE,r),this.gl=i,this.emptyTexture=n}ensureExtension(t){const e=this.gl.getExtension(t);return!!e&&(this.extensions[t]=e,!0)}createShader(t,e){const i=this.gl,r=i.createShader(i.VERTEX_SHADER);i.shaderSource(r,t),i.compileShader(r);const n=i.createShader(i.FRAGMENT_SHADER);i.shaderSource(n,e),i.compileShader(n);const s=i.createProgram();if(i.attachShader(s,r),i.attachShader(s,n),i.linkProgram(s),!i.getProgramParameter(s,i.LINK_STATUS)){let t="Shader failed to link:";const e=i.getShaderInfoLog(r);e&&e.length&&(t+=` Vertex shader: ${e}`);const s=i.getShaderInfoLog(n);throw s&&s.length&&(t+=` Fragment shader: ${s}`),new Error(t)}return new d(this,s)}enableVertexAttribs(t,e){const i=this.gl;for(let r=t;r<e;r++)i.enableVertexAttribArray(r)}disableVertexAttribs(t,e){const i=this.gl;for(let r=t;r<e;r++)i.disableVertexAttribArray(r)}useShader(t){if(t&&t!==this.currentShader){let e=0;const i=t.attribsCount;this.currentShader&&(e=this.currentShader.attribsCount),this.gl.useProgram(t.program),i>e?this.enableVertexAttribs(e,i):i<e&&this.disableVertexAttribs(i,e),this.currentShader=t}}bindTexture(t,e){const i=this.gl;i.activeTexture(i.TEXTURE0+e),t?i.bindTexture(i.TEXTURE_2D,t.webglResource):i.bindTexture(i.TEXTURE_2D,this.emptyTexture)}bindTextureAndWrap(t,e,i,r){const n=this.gl;n.activeTexture(n.TEXTURE0+e),t?n.bindTexture(n.TEXTURE_2D,t.webglResource):n.bindTexture(n.TEXTURE_2D,this.emptyTexture),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_S,i),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_T,r)}setTextureMode(t,e,i,r){const n=this.gl;n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_S,t),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_T,e),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MAG_FILTER,i),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MIN_FILTER,r)}createClientBuffer(t=4){return new l(this.gl,t)}createDataTexture(t=4,e=1,i=1){return new c(this.gl,t,e,i)}createClientDataTexture(t=1,e=1){return new h(this.gl,t,e)}}var f=1e-6,m="undefined"!=typeof Float32Array?Float32Array:Array;Math.random;Math.PI;function g(){var t=new m(3);return m!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t}function p(t){var e=t[0],i=t[1],r=t[2];return Math.hypot(e,i,r)}function w(t,e,i){var r=new m(3);return r[0]=t,r[1]=e,r[2]=i,r}function v(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t}function b(t,e,i,r){return t[0]=e,t[1]=i,t[2]=r,t}function y(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t}function _(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t}function A(t,e){var i=e[0],r=e[1],n=e[2],s=i*i+r*r+n*n;return s>0&&(s=1/Math.sqrt(s)),t[0]=e[0]*s,t[1]=e[1]*s,t[2]=e[2]*s,t}function x(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]}function T(t,e,i){var r=e[0],n=e[1],s=e[2],a=i[0],o=i[1],l=i[2];return t[0]=n*l-s*o,t[1]=s*a-r*l,t[2]=r*o-n*a,t}function E(t,e,i){var r=e[0],n=e[1],s=e[2],a=i[3]*r+i[7]*n+i[11]*s+i[15];return a=a||1,t[0]=(i[0]*r+i[4]*n+i[8]*s+i[12])/a,t[1]=(i[1]*r+i[5]*n+i[9]*s+i[13])/a,t[2]=(i[2]*r+i[6]*n+i[10]*s+i[14])/a,t}function S(t,e,i){var r=i[0],n=i[1],s=i[2],a=i[3],o=e[0],l=e[1],h=e[2],c=n*h-s*l,d=s*o-r*h,u=r*l-n*o,f=n*u-s*d,m=s*c-r*u,g=r*d-n*c,p=2*a;return c*=p,d*=p,u*=p,f*=2,m*=2,g*=2,t[0]=o+c+f,t[1]=l+d+m,t[2]=h+u+g,t}Math.hypot||(Math.hypot=function(){for(var t=0,e=arguments.length;e--;)t+=arguments[e]*arguments[e];return Math.sqrt(t)});var B,I=function(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t[2]=e[2]-i[2],t},L=function(t,e,i){return t[0]=e[0]*i[0],t[1]=e[1]*i[1],t[2]=e[2]*i[2],t},C=p;B=g();function R(){var t=new m(4);return m!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[3]=0),t}function M(t,e,i,r,n){return t[0]=e,t[1]=i,t[2]=r,t[3]=n,t}!function(){var t=R()}();function U(){var t=new m(4);return m!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t[3]=1,t}function k(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t}function F(t,e,i){i*=.5;var r=Math.sin(i);return t[0]=r*e[0],t[1]=r*e[1],t[2]=r*e[2],t[3]=Math.cos(i),t}function D(t,e,i){i*=.5;var r=e[0],n=e[1],s=e[2],a=e[3],o=Math.sin(i),l=Math.cos(i);return t[0]=r*l+a*o,t[1]=n*l+s*o,t[2]=s*l-n*o,t[3]=a*l-r*o,t}function P(t,e,i){i*=.5;var r=e[0],n=e[1],s=e[2],a=e[3],o=Math.sin(i),l=Math.cos(i);return t[0]=r*l-s*o,t[1]=n*l+a*o,t[2]=s*l+r*o,t[3]=a*l-n*o,t}function N(t,e,i){i*=.5;var r=e[0],n=e[1],s=e[2],a=e[3],o=Math.sin(i),l=Math.cos(i);return t[0]=r*l+n*o,t[1]=n*l-r*o,t[2]=s*l+a*o,t[3]=a*l-s*o,t}function O(t,e,i,r){var n,s,a,o,l,h=e[0],c=e[1],d=e[2],u=e[3],m=i[0],g=i[1],p=i[2],w=i[3];return(s=h*m+c*g+d*p+u*w)<0&&(s=-s,m=-m,g=-g,p=-p,w=-w),1-s>f?(n=Math.acos(s),a=Math.sin(n),o=Math.sin((1-r)*n)/a,l=Math.sin(r*n)/a):(o=1-r,l=r),t[0]=o*h+l*m,t[1]=o*c+l*g,t[2]=o*d+l*p,t[3]=o*u+l*w,t}function V(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=e[3],t}var G,z,j,K,H,$,X,q=function(t,e,i,r){var n=new m(4);return n[0]=t,n[1]=e,n[2]=i,n[3]=r,n},Y=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},W=function(t,e,i){var r=e[0],n=e[1],s=e[2],a=e[3],o=i[0],l=i[1],h=i[2],c=i[3];return t[0]=r*c+a*o+n*h-s*l,t[1]=n*c+a*l+s*o-r*h,t[2]=s*c+a*h+r*l-n*o,t[3]=a*c-r*o-n*l-s*h,t},Z=function(t,e){var i=e[0],r=e[1],n=e[2],s=e[3],a=i*i+r*r+n*n+s*s;return a>0&&(a=1/Math.sqrt(a)),t[0]=i*a,t[1]=r*a,t[2]=n*a,t[3]=s*a,t},Q=(G=g(),z=w(1,0,0),j=w(0,1,0),K=U(),H=U(),function(t,e,i,r,n,s){return O(K,e,n,s),O(H,i,r,s),O(t,K,H,2*s*(1-s)),t});$=new m(9),m!=Float32Array&&($[1]=0,$[2]=0,$[3]=0,$[5]=0,$[6]=0,$[7]=0),$[0]=1,$[4]=1,$[8]=1,X=$;function J(){var t=new m(16);return m!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0),t[0]=1,t[5]=1,t[10]=1,t[15]=1,t}function tt(t,e){var i=e[0],r=e[1],n=e[2],s=e[3],a=e[4],o=e[5],l=e[6],h=e[7],c=e[8],d=e[9],u=e[10],f=e[11],m=e[12],g=e[13],p=e[14],w=e[15],v=i*o-r*a,b=i*l-n*a,y=i*h-s*a,_=r*l-n*o,A=r*h-s*o,x=n*h-s*l,T=c*g-d*m,E=c*p-u*m,S=c*w-f*m,B=d*p-u*g,I=d*w-f*g,L=u*w-f*p,C=v*L-b*I+y*B+_*S-A*E+x*T;return C?(C=1/C,t[0]=(o*L-l*I+h*B)*C,t[1]=(n*I-r*L-s*B)*C,t[2]=(g*x-p*A+w*_)*C,t[3]=(u*A-d*x-f*_)*C,t[4]=(l*S-a*L-h*E)*C,t[5]=(i*L-n*S+s*E)*C,t[6]=(p*y-m*x-w*b)*C,t[7]=(c*x-u*y+f*b)*C,t[8]=(a*I-o*S+h*T)*C,t[9]=(r*S-i*I-s*T)*C,t[10]=(m*A-g*y+w*v)*C,t[11]=(d*y-c*A-f*v)*C,t[12]=(o*E-a*B-l*T)*C,t[13]=(i*B-r*E+n*T)*C,t[14]=(g*b-m*_-p*v)*C,t[15]=(c*_-d*b+u*v)*C,t):null}function et(t,e,i,r){var n=e[0],s=e[1],a=e[2],o=e[3],l=n+n,h=s+s,c=a+a,d=n*l,u=n*h,f=n*c,m=s*h,g=s*c,p=a*c,w=o*l,v=o*h,b=o*c,y=r[0],_=r[1],A=r[2];return t[0]=(1-(m+p))*y,t[1]=(u+b)*y,t[2]=(f-v)*y,t[3]=0,t[4]=(u-b)*_,t[5]=(1-(d+p))*_,t[6]=(g+w)*_,t[7]=0,t[8]=(f+v)*A,t[9]=(g-w)*A,t[10]=(1-(d+m))*A,t[11]=0,t[12]=i[0],t[13]=i[1],t[14]=i[2],t[15]=1,t}var it=function(t,e,i){var r=e[0],n=e[1],s=e[2],a=e[3],o=e[4],l=e[5],h=e[6],c=e[7],d=e[8],u=e[9],f=e[10],m=e[11],g=e[12],p=e[13],w=e[14],v=e[15],b=i[0],y=i[1],_=i[2],A=i[3];return t[0]=b*r+y*o+_*d+A*g,t[1]=b*n+y*l+_*u+A*p,t[2]=b*s+y*h+_*f+A*w,t[3]=b*a+y*c+_*m+A*v,b=i[4],y=i[5],_=i[6],A=i[7],t[4]=b*r+y*o+_*d+A*g,t[5]=b*n+y*l+_*u+A*p,t[6]=b*s+y*h+_*f+A*w,t[7]=b*a+y*c+_*m+A*v,b=i[8],y=i[9],_=i[10],A=i[11],t[8]=b*r+y*o+_*d+A*g,t[9]=b*n+y*l+_*u+A*p,t[10]=b*s+y*h+_*f+A*w,t[11]=b*a+y*c+_*m+A*v,b=i[12],y=i[13],_=i[14],A=i[15],t[12]=b*r+y*o+_*d+A*g,t[13]=b*n+y*l+_*u+A*p,t[14]=b*s+y*h+_*f+A*w,t[15]=b*a+y*c+_*m+A*v,t};const rt=w(1,0,0),nt=w(0,1,0),st=w(0,0,1),at=g(),ot=w(1,1,1),lt=(q(0,0,0,0),U()),ht=R();function ct(t,e,i,r){const n=2*(e[0]-r[0])/r[2]-1,s=1-2*(e[1]-r[1])/r[3],a=2*e[2]-1;return M(ht,n,s,a,1),function(t,e,i){var r=e[0],n=e[1],s=e[2],a=e[3];t[0]=i[0]*r+i[4]*n+i[8]*s+i[12]*a,t[1]=i[1]*r+i[5]*n+i[9]*s+i[13]*a,t[2]=i[2]*r+i[6]*n+i[10]*s+i[14]*a,t[3]=i[3]*r+i[7]*n+i[11]*s+i[15]*a}(ht,ht,i),b(t,ht[0]/ht[3],ht[1]/ht[3],ht[2]/ht[3]),t}function dt(t,e,i){return t[0]*e+t[1]*i+t[3]}function ut(t,e,i,r){return t[0]*e+t[1]*i+t[2]*r+t[3]}function ft(t,e){const i=function(t){return Math.hypot(t[0],t[1],t[2])}(e);t[0]=e[0]/i,t[1]=e[1]/i,t[2]=e[2]/i,t[3]=e[3]/i}const mt=g(),gt=g(),pt=g();function wt(t,e,i,r){A(mt,I(mt,i,e)),A(gt,T(gt,r,mt)),T(pt,gt,mt);const n=gt[0]+pt[2]+mt[1];if(n>0){const e=.5/Math.sqrt(n+1);t[3]=.25/e,t[0]=(pt[1]-mt[2])*e,t[2]=(mt[0]-gt[1])*e,t[1]=(gt[2]-pt[0])*e}else if(gt[0]>pt[2]&&gt[0]>mt[1]){const e=2*Math.sqrt(1+gt[0]-pt[2]-mt[1]);t[3]=(pt[1]-mt[2])/e,t[0]=.25*e,t[2]=(pt[0]+gt[2])/e,t[1]=(mt[0]+gt[1])/e}else if(pt[2]>mt[1]){const e=2*Math.sqrt(1+pt[2]-gt[0]-mt[1]);t[3]=(mt[0]-gt[1])/e,t[0]=(pt[0]+gt[2])/e,t[2]=.25*e,t[1]=(mt[2]+pt[1])/e}else{const e=2*Math.sqrt(1+mt[1]-gt[0]-pt[2]);t[3]=(gt[2]-pt[0])/e,t[0]=(mt[0]+gt[1])/e,t[2]=(mt[2]+pt[1])/e,t[1]=.25*e}return t}const vt=g(),bt=g(),yt=g(),_t=U(),At=F(U(),rt,Math.PI/2);class xt{constructor(){this.isPerspective=!0,this.fov=0,this.aspect=0,this.isOrtho=!1,this.leftClipPlane=0,this.rightClipPlane=0,this.bottomClipPlane=0,this.topClipPlane=0,this.nearClipPlane=0,this.farClipPlane=0,this.location=g(),this.rotation=U(),this.inverseRotation=U(),this.viewMatrix=J(),this.projectionMatrix=J(),this.viewProjectionMatrix=J(),this.inverseViewMatrix=J(),this.inverseViewProjectionMatrix=J(),this.directionX=g(),this.directionY=g(),this.directionZ=g(),this.vectors=[w(-1,-1,0),w(-1,1,0),w(1,1,0),w(1,-1,0),w(1,0,0),w(0,1,0),w(0,0,1)],this.billboardedVectors=[g(),g(),g(),g(),g(),g(),g()],this.planes=[R(),R(),R(),R(),R(),R()]}perspective(t,e,i,r){this.isPerspective=!0,this.isOrtho=!1,this.fov=t,this.aspect=e,this.nearClipPlane=i,this.farClipPlane=r,this.update()}ortho(t,e,i,r,n,s){this.isPerspective=!1,this.isOrtho=!0,this.leftClipPlane=t,this.rightClipPlane=e,this.bottomClipPlane=i,this.topClipPlane=r,this.nearClipPlane=n,this.farClipPlane=s,this.update()}setLocation(t){v(this.location,t),this.update()}move(t){y(this.location,this.location,t),this.update()}setRotation(t){Y(this.rotation,t),this.update()}rotate(t){W(this.rotation,this.rotation,t),this.update()}face(t,e){W(this.rotation,At,wt(_t,t,this.location,e)),this.update()}moveToAndFace(t,e,i){v(this.location,t),this.face(e,i)}reset(){b(this.location,0,0,0),k(this.rotation),this.update()}update(){const t=this.location,e=this.rotation,i=this.inverseRotation,r=this.viewMatrix,n=this.projectionMatrix,s=this.viewProjectionMatrix,a=this.vectors,o=this.billboardedVectors;this.isPerspective?function(t,e,i,r,n){var s,a=1/Math.tan(e/2);t[0]=a/i,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=-1,t[12]=0,t[13]=0,t[15]=0,null!=n&&n!==1/0?(s=1/(r-n),t[10]=(n+r)*s,t[14]=2*n*r*s):(t[10]=-1,t[14]=-2*r)}(n,this.fov,this.aspect,this.nearClipPlane,this.farClipPlane):function(t,e,i,r,n,s,a){var o=1/(e-i),l=1/(r-n),h=1/(s-a);t[0]=-2*o,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*l,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*h,t[11]=0,t[12]=(e+i)*o,t[13]=(n+r)*l,t[14]=(a+s)*h,t[15]=1}(n,this.leftClipPlane,this.rightClipPlane,this.bottomClipPlane,this.topClipPlane,this.nearClipPlane,this.farClipPlane),function(t,e){var i=e[0],r=e[1],n=e[2],s=e[3],a=i+i,o=r+r,l=n+n,h=i*a,c=r*a,d=r*o,u=n*a,f=n*o,m=n*l,g=s*a,p=s*o,w=s*l;t[0]=1-d-m,t[1]=c+w,t[2]=u-p,t[3]=0,t[4]=c-w,t[5]=1-h-m,t[6]=f+g,t[7]=0,t[8]=u+p,t[9]=f-g,t[10]=1-h-d,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1}(r,e),function(t,e,i){var r,n,s,a,o,l,h,c,d,u,f,m,g=i[0],p=i[1],w=i[2];e===t?(t[12]=e[0]*g+e[4]*p+e[8]*w+e[12],t[13]=e[1]*g+e[5]*p+e[9]*w+e[13],t[14]=e[2]*g+e[6]*p+e[10]*w+e[14],t[15]=e[3]*g+e[7]*p+e[11]*w+e[15]):(r=e[0],n=e[1],s=e[2],a=e[3],o=e[4],l=e[5],h=e[6],c=e[7],d=e[8],u=e[9],f=e[10],m=e[11],t[0]=r,t[1]=n,t[2]=s,t[3]=a,t[4]=o,t[5]=l,t[6]=h,t[7]=c,t[8]=d,t[9]=u,t[10]=f,t[11]=m,t[12]=r*g+o*p+d*w+e[12],t[13]=n*g+l*p+u*w+e[13],t[14]=s*g+h*p+f*w+e[14],t[15]=a*g+c*p+m*w+e[15])}(r,r,function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t}(vt,t)),it(s,n,r),tt(this.inverseViewMatrix,r),tt(this.inverseViewProjectionMatrix,s),function(t,e){const i=e[0],r=e[4],n=e[8],s=e[12],a=e[1],o=e[5],l=e[9],h=e[13],c=e[2],d=e[6],u=e[10],f=e[14],m=e[3],g=e[7],p=e[11],w=e[15];let v;v=t[0],v[0]=m+i,v[1]=g+r,v[2]=p+n,v[3]=w+s,v=t[1],v[0]=m-i,v[1]=g-r,v[2]=p-n,v[3]=w-s,v=t[2],v[0]=m-a,v[1]=g-o,v[2]=p-l,v[3]=w-h,v=t[3],v[0]=m+a,v[1]=g+o,v[2]=p+l,v[3]=w+h,v=t[4],v[0]=m+c,v[1]=g+d,v[2]=p+u,v[3]=w+f,v=t[5],v[0]=m-c,v[1]=g-d,v[2]=p-u,v[3]=w-f,ft(t[0],t[0]),ft(t[1],t[1]),ft(t[2],t[2]),ft(t[3],t[3]),ft(t[4],t[4]),ft(t[5],t[5])}(this.planes,s),V(i,e),S(this.directionX,rt,i),S(this.directionY,nt,i),S(this.directionZ,st,i);for(let t=0;t<7;t++)S(o[t],a[t],i)}cameraToWorld(t,e){return E(t,e,this.inverseViewMatrix)}worldToCamera(t,e){return E(t,e,this.viewMatrix)}worldToScreen(t,e,i){return E(vt,e,this.viewProjectionMatrix),t[0]=Math.round((vt[0]+1)/2*i[2]),t[1]=Math.round((vt[1]+1)/2*i[3]),t}screenToWorldRay(t,e,i){const r=vt,n=bt,s=yt,a=e[0],o=e[1],l=this.inverseViewProjectionMatrix;return ct(r,b(s,a,o,0),l,i),ct(n,b(s,a,o,1),l,i),t.set(r,0),t.set(n,3),t}}class Tt{constructor(t,e,i,r){this.plane=-1,this.instances=[],this.visible=!1,this.left=t,this.right=e,this.bottom=i,this.top=r}add(t){this.instances.push(t)}remove(t){const e=this.instances.indexOf(t);this.instances.splice(e,1)}clear(){this.instances.length=0}isVisible(t){return this.plane=function(t,e,i,r,n,s){-1===s&&(s=0);for(let a=0;a<6;a++){const o=(s+a)%6,l=t[o];if(dt(l,e,r)<0&&dt(l,e,n)<0&&dt(l,i,n)<0&&dt(l,i,r)<0)return o}return-1}(t.planes,this.left,this.right,this.bottom,this.top,this.plane),-1===this.plane}}class Et{constructor(t,e,i,r,n,s){this.cells=[];const a=i/n,o=r/s;this.x=t,this.y=e,this.width=i,this.depth=r,this.cellWidth=n,this.cellDepth=s,this.columns=a,this.rows=o;for(let i=0;i<o;i++)for(let r=0;r<a;r++){const o=t+r*n,l=o+n,h=e+i*s,c=h+s;this.cells[i*a+r]=new Tt(o,l,h,c)}}add(t){const e=this.cells,i=this.columns,r=t.left,n=t.right+1,s=t.bottom,a=t.top+1;if(-1!==r)for(let o=s;o<a;o++)for(let s=r;s<n;s++)e[o*i+s].add(t)}remove(t){const e=this.cells,i=this.columns,r=t.left,n=t.right+1,s=t.bottom,a=t.top+1;if(-1!==r){t.left=-1;for(let o=s;o<a;o++)for(let s=r;s<n;s++)e[o*i+s].remove(t)}}moved(t){const e=this.cellWidth,i=this.cellDepth,r=t.model.bounds,n=t.worldLocation[0]+r.x-this.x,s=t.worldLocation[1]+r.y-this.y,a=r.r,o=t.worldScale;let l=Math.floor((n-a*o[0])/e),h=Math.floor((n+a*o[0])/e),c=Math.floor((s-a*o[1])/i),d=Math.floor((s+a*o[1])/i);h<0||l>this.columns-1||d<0||c>this.rows-1?this.remove(t):(l=Math.max(l,0),h=Math.min(h,this.columns-1),c=Math.max(c,0),d=Math.min(d,this.rows-1),l===t.left&&h===t.right&&c===t.bottom&&d===t.top||(this.remove(t),t.left=l,t.right=h,t.bottom=c,t.top=d,this.add(t)))}clear(){for(const t of this.cells)t.clear()}}class St{constructor(){this.objects=[],this.alive=0}add(t){this.objects[this.alive++]=t}update(t){const e=this.objects;for(let i=0;i<this.alive;i++){const r=e[i];r.update(t*r.emitter.instance.timeScale),r.health<=0&&(this.alive-=1,r.emitter.kill(r),i!==this.alive&&(e[i]=e[this.alive],i-=1))}}}class Bt{constructor(t){this.camera=new xt,this.grid=new Et(-1e5,-1e5,2e5,2e5,2e5,2e5),this.visibleCells=0,this.visibleInstances=0,this.updatedParticles=0,this.audioEnabled=!1,this.audioContext=null,this.instances=[],this.emittedObjectUpdater=new St,this.alpha=!1,this.color=g(),this.viewport=R(),this.lightPosition=w(0,0,1e4),this.viewer=t;const e=t.canvas,i=e.width,r=e.height;this.viewport[2]=i,this.viewport[3]=r,this.camera.perspective(Math.PI/4,i/r,8,1e4)}async enableAudio(){return"function"==typeof AudioContext&&(this.audioContext||(this.audioContext=new AudioContext),"suspended"!==this.audioContext.state&&await this.audioContext.resume(),this.audioEnabled="running"===this.audioContext.state,this.audioEnabled)}disableAudio(){this.audioContext&&this.audioContext.suspend(),this.audioEnabled=!1}addInstance(t){return t.scene!==this&&(t.scene&&t.scene.removeInstance(t),t.scene=this,this.grid.moved(t),!0)}removeInstance(t){return t.scene===this&&(this.grid.remove(t),t.scene=null,!0)}clear(){for(const t of this.grid.cells)for(const e of t.instances)e.scene=null;this.grid.clear()}detach(){return!!this.viewer&&this.viewer.removeScene(this)}update(t){const e=this.camera;if(this.audioContext){const t=this.audioContext.listener,i=e.location,r=e.directionY,n=e.directionZ;t.positionX.value=-i[0],t.positionY.value=-i[1],t.positionZ.value=-i[2],t.forwardX.value=r[0],t.forwardY.value=r[1],t.forwardZ.value=r[2],t.upX.value=n[0],t.upY.value=n[1],t.upZ.value=n[2]}const i=this.viewer.frame,r=this.instances;this.visibleCells=0,this.visibleInstances=0;for(const r of this.grid.cells)if(r.isVisible(e)){this.visibleCells+=1;for(const e of r.instances)e.rendered&&e.updateFrame<i&&!e.parent&&(e.updateFrame=i,e.update(t))}r.length=this.visibleInstances,r.sort(((t,e)=>t.depth-e.depth)),this.emittedObjectUpdater.update(t),this.updatedParticles=this.emittedObjectUpdater.alive}renderInstance(t){this.instances[this.visibleInstances++]=t}startFrame(){const t=this.viewer.gl,e=this.viewport;if(t.viewport(e[0],e[1],e[2],e[3]),t.scissor(e[0],e[1],e[2],e[3]),!this.alpha){const e=this.color;t.depthMask(!0),t.clearColor(e[0],e[1],e[2],1),t.clear(t.COLOR_BUFFER_BIT|t.DEPTH_BUFFER_BIT)}}renderOpaque(){const t=this.instances;for(let e=0,i=t.length;e<i;e++)t[e].renderOpaque()}renderTranslucent(){const t=this.instances;for(let e=t.length-1;e>=0;e--)t[e].renderTranslucent()}render(){this.startFrame(),this.renderOpaque(),this.renderTranslucent()}clearEmittedObjects(){for(const t of this.emittedObjectUpdater.objects)t.health=0}}class It{constructor(t){this.blockers=[],this.viewer=t.viewer,this.fetchUrl=t.fetchUrl}detach(){return this.viewer.unload(this)}}class Lt extends It{constructor(t,e){super(e),this.data=null,this.data=t}}function Ct(t){return t*(Math.PI/180)}function Rt(t,e){return t+Math.random()*(e-t)}function Mt(t){return 0!==t&&0==(t&t-1)}class Ut extends It{constructor(t){super(t),this.pathSolver=t.pathSolver}}class kt extends Ut{constructor(){super(...arguments),this.webglResource=null,this.width=0,this.height=0}}function Ft(t){return(e=t)instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&137===e[0]&&80===e[1]&&78===e[2]&&71===e[3]&&13===e[4]&&10===e[5]&&26===e[6]&&10===e[7]?"image/png":function(t){return t instanceof ArrayBuffer&&(t=new Uint8Array(t)),t instanceof Uint8Array&&255===t[0]&&216===t[1]&&255===t[t.length-2]&&217===t[t.length-1]}(t)?"image/jpeg":function(t){return t instanceof ArrayBuffer&&(t=new Uint8Array(t)),t instanceof Uint8Array&&71===t[0]&&73===t[1]&&70===t[2]&&56===t[3]&&(55===t[4]||57===t[4])&&97===t[5]}(t)?"image/gif":function(t){return t instanceof ArrayBuffer&&(t=new Uint8Array(t)),t instanceof Uint8Array&&82===t[0]&&73===t[1]&&70===t[2]&&70===t[3]&&87===t[8]&&69===t[9]&&66===t[10]&&80===t[11]}(t)?"image/webp":"";var e}class Dt extends kt{constructor(t,e){super(e);const i=this.viewer.gl;this.webglResource=i.createTexture(),i.bindTexture(i.TEXTURE_2D,this.webglResource),i.texImage2D(i.TEXTURE_2D,0,i.RGBA,i.RGBA,i.UNSIGNED_BYTE,t),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MAG_FILTER,i.LINEAR),Mt(t.width)&&Mt(t.height)?(i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.LINEAR_MIPMAP_LINEAR),i.generateMipmap(i.TEXTURE_2D)):(i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.LINEAR),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_S,i.CLAMP_TO_EDGE),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_T,i.CLAMP_TO_EDGE)),this.width=t.width,this.height=t.height}}let Pt,Nt,Ot,Vt;var Gt;"object"==typeof window&&(Pt=document.createElement("canvas"),Nt=Pt.getContext("2d"),Ot=document.createElement("canvas"),Vt=Ot.getContext("2d")),function(t){t[t.None=0]="None",t[t.Diffuse=1]="Diffuse",t[t.NormalMap=2]="NormalMap",t[t.Occlusion=3]="Occlusion",t[t.Roughness=4]="Roughness",t[t.Metallic=5]="Metallic",t[t.TCFactor=6]="TCFactor",t[t.Emissive=7]="Emissive",t[t.TexCoords=8]="TexCoords",t[t.Normals=9]="Normals",t[t.Tangents=10]="Tangents"}(Gt||(Gt={}));class zt extends a.EventEmitter{constructor(t,e){super(),this.resources=[],this.resourceMap=new Map,this.promiseMap=new Map,this.handlers=new Set,this.scenes=[],this.frame=0,this.visibleCells=0,this.visibleInstances=0,this.updatedParticles=0,this.audioEnabled=!1,this.sharedCache=new Map,this.debugRenderMode=Gt.None,this.directLoadId=0;const i=new u(t,e),r=i.gl;this.canvas=t,this.gl=r,this.webgl=i,this.buffer=i.createClientBuffer(),r.depthFunc(r.LEQUAL),r.enable(r.DEPTH_TEST),r.enable(r.SCISSOR_TEST)}enableAudio(){return"function"==typeof AudioContext&&(this.audioEnabled=!0,!0)}addHandler(t,...e){if(t){const i=this.handlers;if(!i.has(t)){if(!t.isValidSource)return this.emit("error",{viewer:this,error:"Handler missing the isValidSource function",handler:t}),!1;if(t.load)try{t.load(this,...e)}catch(e){return this.emit("error",{viewer:this,error:"Handler failed to load",handler:t,reason:e}),!1}return i.add(t),!0}}return!1}addScene(){const t=new Bt(this);return this.scenes.push(t),t}removeScene(t){const e=this.scenes,i=e.indexOf(t);return-1!==i&&(e.splice(i,1),!0)}clear(){this.scenes.length=0}async load(t,e,i){let r,n,s="";if(e)try{r=e(t,i)}catch(r){return void this.emit("error",{viewer:this,error:"Path solver failed",src:t,reason:r,pathSolver:e,solverParams:i})}else r=t;if(r){if(r instanceof Promise&&(r=await r),r instanceof It)return r;if("string"!=typeof r||this.detectFormat(r))s="__DIRECT_LOAD_"+this.directLoadId++,n=Promise.resolve(r);else{if(s=r,n=this.promiseMap.get(s),n)return n;const t=this.resourceMap.get(s);if(t)return t;n=o(s,"arrayBuffer").then((t=>t.ok?t.data:void this.emit("error",{viewer:this,error:`Failed to fetch a resource: ${t.error}`,fetchUrl:s,reason:t.data})))}return n=n.then((async i=>{if(i){if(i instanceof ArrayBuffer&&(i=new Uint8Array(i)),function(t){return t instanceof ImageData||t instanceof HTMLImageElement||t instanceof HTMLCanvasElement||t instanceof HTMLVideoElement}(i))return new Dt(i,{viewer:this,fetchUrl:s,pathSolver:e});if(i instanceof Uint8Array){const t=Ft(i);if(t.length)return new Dt(await(r=new Blob([i.buffer],{type:t}),new Promise(((t,e)=>{const i=URL.createObjectURL(r),n=new Image;n.onload=()=>{t(n)},n.onerror=t=>{e(t)},n.src=i}))),{viewer:this,fetchUrl:s,pathSolver:e})}const n=this.detectFormat(i);if(n)try{const t=new n.resource(i,{viewer:this,fetchUrl:s,pathSolver:e});return await Promise.all(t.blockers),t.blockers.length=0,t}catch(e){this.emit("error",{viewer:this,error:"Failed to create a resource",fetchUrl:s,src:t,reason:e})}else this.emit("error",{viewer:this,error:"Source has no matching handler",fetchUrl:s,src:t})}var r})).then((t=>(this.promiseMap.delete(s),t&&(this.resourceMap.set(s,t),this.resources.push(t),this.emit("load",{viewer:this,fetchUrl:s,resource:t})),this.emit("loadend",{viewer:this,fetchUrl:s,resource:t}),this.checkLoadingStatus(),t))),this.promiseMap.set(s,n),this.emit("loadstart",{viewer:this,fetchUrl:s,promise:n}),n}}detectFormat(t){for(const e of this.handlers)if(e.isValidSource(t))return e}has(t){return this.resourceMap.has(t)}get(t){return this.resourceMap.get(t)}async loadGeneric(t,e,i){const r=this.promiseMap.get(t);if(r)return r;const n=this.resourceMap.get(t);if(n)return n;const s=o(t,e).then((async e=>{let r;if(this.promiseMap.delete(t),e.ok){let n=e.data;i&&(n=await i(n)),r=new Lt(n,{viewer:this,fetchUrl:t}),this.resourceMap.set(t,r),this.resources.push(r),this.emit("load",{viewer:this,fetchUrl:t,resource:r})}else this.emit("error",{viewer:this,error:"Failed to fetch a generic resource",fetchUrl:t});return this.emit("loadend",{viewer:this,fetchUrl:t,resource:r}),this.checkLoadingStatus(),r}));return this.promiseMap.set(t,s),this.emit("loadstart",{viewer:this,fetchUrl:t}),s}unload(t){const e=t.fetchUrl;""!==e&&this.resourceMap.delete(e);const i=this.resources,r=i.indexOf(t);return-1!==r&&(i.splice(r,1),!0)}promise(){const t=Promise.resolve(void 0),e=`${performance.now()}`;return this.promiseMap.set(e,t),()=>{this.promiseMap.delete(e),this.checkLoadingStatus()}}checkLoadingStatus(){0===this.promiseMap.size&&setTimeout((()=>this.emit("idle")),0)}whenAllLoaded(t){const e=new Promise((t=>{0===this.promiseMap.size?t(this):this.once("idle",(()=>t(this)))}));if(!t)return e;e.then((()=>t(this)))}toBlob(t){const e=new Promise((t=>this.canvas.toBlob((e=>t(e)))));return t?void e.then((e=>t(e))):e}updateAndRender(t=1e3/60){this.update(t),this.startFrame(),this.render()}update(t=1e3/60){t*=.001,this.frame+=1,this.visibleCells=0,this.visibleInstances=0,this.updatedParticles=0;for(const e of this.scenes)e.update(t),this.visibleCells+=e.visibleCells,this.visibleInstances+=e.visibleInstances,this.updatedParticles+=e.updatedParticles}startFrame(){const t=this.gl;t.depthMask(!0),t.clearColor(0,0,0,1),t.clear(t.COLOR_BUFFER_BIT|t.DEPTH_BUFFER_BIT)}render(){for(const t of this.scenes)t.render()}clearEmittedObjects(){for(const t of this.scenes)t.clearEmittedObjects()}}let jt;"function"==typeof OfflineAudioContext&&(jt=new OfflineAudioContext(1,1,48e3));const Kt=new TextDecoder,Ht=new TextEncoder;function $t(t){return Kt.decode(t)}function Xt(t){return Ht.encode(t)}function qt(t){let e=t.length;for(let i=t.length-1;i>=0;i--){const r=t.charCodeAt(i);r>127&&r<=2047?e++:r>2047&&r<=65535&&(e+=2),r>=56320&&r<=57343&&i--}return e}function Yt(t){return t instanceof Uint8Array?t:"string"==typeof t?Xt(t):new Uint8Array(t)}function Wt(t,e,i=0,r=1/0){const n=Math.max(i,0),s=Math.min(n+r,t.length);let a=0,o=e.charCodeAt(0);for(let i=n;i<s;i++){if(t[i]===o){if(a+=1,a===e.length)return!0;o=e.charCodeAt(a)}else a>0&&(a=0,o=e.charCodeAt(0))}return!1}const Zt=new ArrayBuffer(8),Qt=new Int8Array(Zt),Jt=new Int16Array(Zt),te=new Int32Array(Zt),ee=new Uint8Array(Zt),ie=new Uint16Array(Zt),re=new Uint32Array(Zt),ne=new Float32Array(Zt),se=new Float64Array(Zt);function ae(t){return ee[0]=t,Qt[0]}function oe(t,e){return ee[0]=t,ee[1]=e,Jt[0]}function le(t,e,i,r){return ee[0]=t,ee[1]=e,ee[2]=i,ee[3]=r,te[0]}function he(t,e){return ee[0]=t,ee[1]=e,ie[0]}function ce(t,e,i,r){return ee[0]=t,ee[1]=e,ee[2]=i,ee[3]=r,re[0]}function de(t,e,i,r){return ee[0]=t,ee[1]=e,ee[2]=i,ee[3]=r,ne[0]}function ue(t,e,i,r,n,s,a,o){return ee[0]=t,ee[1]=e,ee[2]=i,ee[3]=r,ee[4]=n,ee[5]=s,ee[6]=a,ee[7]=o,se[0]}function fe(t){return ee[0]=t,Qt[0]}function me(t,e){return Jt[0]=e,t[0]=ee[0],t[1]=ee[1],t}function ge(t,e){return te[0]=e,t[0]=ee[0],t[1]=ee[1],t[2]=ee[2],t[3]=ee[3],t}function pe(t,e){return ie[0]=e,t[0]=ee[0],t[1]=ee[1],t}function we(t,e){return re[0]=e,t[0]=ee[0],t[1]=ee[1],t[2]=ee[2],t[3]=ee[3],t}function ve(t,e){return ne[0]=e,t[0]=ee[0],t[1]=ee[1],t[2]=ee[2],t[3]=ee[3],t}function be(t,e){return se[0]=e,t[0]=ee[0],t[1]=ee[1],t[2]=ee[2],t[3]=ee[3],t[4]=ee[4],t[5]=ee[5],t[6]=ee[6],t[7]=ee[7],t}function ye(t){return re[0]=t,re[0]}const _e=new Uint8Array(8);class Ae{constructor(t,e,i){this.index=0;const r=Yt(t);e=e||0,i=i||r.length,this.buffer=t,this.uint8array=r.subarray(e,e+i),this.byteLength=i,this.remaining=i}substream(t){if(this.remaining<t)throw new Error(`ByteStream: substream: want ${t} bytes but have ${this.remaining}`);const e=this.index;return this.index+=t,new Ae(this.uint8array.subarray(e,e+t))}skip(t){if(this.remaining<t)throw new Error(`ByteStream: skip: premature end - want ${t} bytes but have ${this.remaining}`);this.index+=t,this.remaining-=t}seek(t){this.index=t,this.remaining=this.byteLength-t}read(t){if(this.remaining<t)throw new Error(`ByteStream: read: premature end - want ${t} bytes but have ${this.remaining}`);const e=this.uint8array,i=this.index;let r=function(t,e,i=0,r=1/0){const n=Math.max(i,0),s=Math.min(n+r,t.length);for(let i=n;i<s;i++)if(t[i]===e)return i;return-1}(e,0,i,t);return-1===r&&(r=i+t),this.index+=t,this.remaining-=t,$t(e.subarray(i,r))}readNull(){if(this.remaining<1)throw new Error("ByteStream: readNull: premature end - want at least 1 byte but have 0");const t=this.uint8array,e=this.index;let i=t.indexOf(0,e);-1===i&&(i=t.length-1);const r=i-e+1;return this.index+=r,this.remaining-=r,$t(t.subarray(e,i))}readBinary(t){if(this.remaining<t)throw new Error(`ByteStream: readBinary: premature end - want ${t} bytes but have ${this.remaining}`);const e=this.uint8array,i=this.index;let r="";for(let n=0;n<t;n++)r+=String.fromCharCode(e[i+n]);return this.index+=t,this.remaining-=t,r}readInt8(){if(this.remaining<1)throw new Error(`ByteStream: readInt8: premature end - want 1 byte but have ${this.remaining}`);const t=this.index,e=ae(this.uint8array[t]);return this.index+=1,this.remaining-=1,e}readInt16(){if(this.remaining<2)throw new Error(`ByteStream: readInt16: premature end - want 2 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=oe(e[t],e[t+1]);return this.index+=2,this.remaining-=2,i}readInt32(){if(this.remaining<4)throw new Error(`ByteStream: readInt32: premature end - want 4 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=le(e[t],e[t+1],e[t+2],e[t+3]);return this.index+=4,this.remaining-=4,i}readUint8(){if(this.remaining<1)throw new Error(`ByteStream: readUint8: premature end - want 1 byte but have ${this.remaining}`);const t=this.uint8array[this.index];return this.index+=1,this.remaining-=1,t}readUint16(){if(this.remaining<2)throw new Error(`ByteStream: readUint16: premature end - want 2 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=he(e[t],e[t+1]);return this.index+=2,this.remaining-=2,i}readUint32(){if(this.remaining<4)throw new Error(`ByteStream: readUint32: premature end - want 4 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=ce(e[t],e[t+1],e[t+2],e[t+3]);return this.index+=4,this.remaining-=4,i}readFloat32(){if(this.remaining<4)throw new Error(`ByteStream: readFloat32: premature end - want 4 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=de(e[t],e[t+1],e[t+2],e[t+3]);return this.index+=4,this.remaining-=4,i}readFloat64(){if(this.remaining<8)throw new Error(`ByteStream: readFloat64: premature end - want 8 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=ue(e[t],e[t+1],e[t+2],e[t+3],e[t+4],e[t+5],e[t+6],e[t+7]);return this.index+=8,this.remaining-=8,i}readInt8Array(t){if(ArrayBuffer.isView(t)||(t=new Int8Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readInt8Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++)t[r]=ae(i[e+r]);return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readInt16Array(t){if(ArrayBuffer.isView(t)||(t=new Int16Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readInt16Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+2*r;t[r]=oe(i[n],i[n+1])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readInt32Array(t){if(ArrayBuffer.isView(t)||(t=new Int32Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readInt32Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+4*r;t[r]=le(i[n],i[n+1],i[n+2],i[n+3])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readUint8Array(t){if(ArrayBuffer.isView(t)||(t=new Uint8Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readUint8Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++)t[r]=i[e+r];return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readUint16Array(t){if(ArrayBuffer.isView(t)||(t=new Uint16Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readUint16Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+2*r;t[r]=he(i[n],i[n+1])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readUint32Array(t){if(ArrayBuffer.isView(t)||(t=new Uint32Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readUint32Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+4*r;t[r]=ce(i[n],i[n+1],i[n+2],i[n+3])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readFloat32Array(t){if(ArrayBuffer.isView(t)||(t=new Float32Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readFloat32Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+4*r;t[r]=de(i[n],i[n+1],i[n+2],i[n+3])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readFloat64Array(t){if(ArrayBuffer.isView(t)||(t=new Float64Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readFloat64Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+8*r;t[r]=ue(i[n],i[n+1],i[n+2],i[n+3],i[n+4],i[n+5],i[n+6],i[n+7])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}write(t){const e=Xt(t);return this.writeUint8Array(e),e.length}writeNull(t){const e=this.write(t);return this.index++,this.remaining--,e+1}writeBinary(t){const e=this.index,i=this.uint8array,r=t.length;for(let n=0;n<r;n++)i[e+n]=t.charCodeAt(n);this.index+=r}writeInt8(t){this.uint8array[this.index]=fe(t),this.index+=1}writeInt16(t){const e=this.index,i=this.uint8array;me(_e,t),i[e]=_e[0],i[e+1]=_e[1],this.index+=2}writeInt32(t){const e=this.index,i=this.uint8array;ge(_e,t),i[e]=_e[0],i[e+1]=_e[1],i[e+2]=_e[2],i[e+3]=_e[3],this.index+=4}writeUint8(t){this.uint8array[this.index]=t,this.index+=1}writeUint16(t){const e=this.index,i=this.uint8array;pe(_e,t),i[e]=_e[0],i[e+1]=_e[1],this.index+=2}writeUint32(t){const e=this.index,i=this.uint8array;we(_e,t),i[e]=_e[0],i[e+1]=_e[1],i[e+2]=_e[2],i[e+3]=_e[3],this.index+=4}writeFloat32(t){const e=this.index,i=this.uint8array;ve(_e,t),i[e]=_e[0],i[e+1]=_e[1],i[e+2]=_e[2],i[e+3]=_e[3],this.index+=4}writeFloat64(t){const e=this.index,i=this.uint8array;be(_e,t),i[e]=_e[0],i[e+1]=_e[1],i[e+2]=_e[2],i[e+3]=_e[3],i[e+4]=_e[4],i[e+5]=_e[5],i[e+6]=_e[6],i[e+7]=_e[7],this.index+=8}writeInt8Array(t){const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++)i[e+r]=fe(t[r]);this.index+=t.byteLength}writeInt16Array(t){const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+2*r;me(_e,t[r]),i[n]=_e[0],i[n+1]=_e[1]}this.index+=t.byteLength}writeInt32Array(t){const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+4*r;ge(_e,t[r]),i[n]=_e[0],i[n+1]=_e[1],i[n+2]=_e[2],i[n+3]=_e[3]}this.index+=t.byteLength}writeUint8Array(t){const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++)i[e+r]=t[r];this.index+=t.byteLength}writeUint16Array(t){const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+2*r;pe(_e,t[r]),i[n]=_e[0],i[n+1]=_e[1]}this.index+=t.byteLength}writeUint32Array(t){const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+4*r;we(_e,t[r]),i[n]=_e[0],i[n+1]=_e[1],i[n+2]=_e[2],i[n+3]=_e[3]}this.index+=t.byteLength}writeFloat32Array(t){const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+4*r;ve(_e,t[r]),i[n]=_e[0],i[n+1]=_e[1],i[n+2]=_e[2],i[n+3]=_e[3]}this.index+=t.byteLength}writeFloat64Array(t){const e=this.index,i=this.uint8array;for(let r=0,n=t.length;r<n;r++){const n=e+8*r;be(_e,t[r]),i[n]=_e[0],i[n+1]=_e[1],i[n+2]=_e[2],i[n+3]=_e[3],i[n+4]=_e[4],i[n+5]=_e[5],i[n+6]=_e[6],i[n+7]=_e[7]}this.index+=t.byteLength}}class xe{constructor(t){this.index=0,this.ident=0,this.indentSpaces=4,this.precision=1e6,this.buffer=t||""}clear(){this.buffer="",this.index=0,this.ident=0}readToken(){const t=this.buffer,e=t.length;let i=!1,r=!1,n="";for(;this.index<e;){const e=t[this.index++];if(i)"\n"===e&&(i=!1);else if(r)if("\\"===e)n+=e+t[this.index++];else if("\n"===e)n+="\\n";else if("\r"===e)n+="\\r";else{if('"'===e)return n;n+=e}else if(" "===e||","===e||"\t"===e||"\n"===e||":"===e||"\r"===e){if(n.length)return n}else{if("{"===e||"}"===e)return n.length?(this.index--,n):e;if("/"===e&&"/"===t[this.index]){if(n.length)return this.index--,n;i=!0}else if('"'===e){if(n.length)return this.index--,n;r=!0}else n+=e}}}read(){const t=this.readToken();if(void 0===t)throw new Error("End of stream reached prematurely");return t}peek(){const t=this.index,e=this.read();return this.index=t,e}readInt(){return parseInt(this.read())}readFloat(){return parseFloat(this.read())}readVector(t){this.read();for(let e=0,i=t.length;e<i;e++)t[e]=this.readFloat();return this.read(),t}readVectorsBlock(t,e){this.read();for(let i=0,r=t.length;i<r;i+=e)this.readVector(t.subarray(i,i+e));return this.read(),t}readColor(t){return this.read(),t[2]=this.readFloat(),t[1]=this.readFloat(),t[0]=this.readFloat(),this.read(),t}*readBlock(){this.read();let t=this.read();for(;"}"!==t;)yield t,t=this.read()}writeLine(t){this.buffer+=`${" ".repeat(this.ident*this.indentSpaces)}${t}\n`}writeFlag(t){this.writeLine(`${t},`)}writeFlagAttrib(t,e){this.writeLine(`${t} ${e},`)}writeNumberAttrib(t,e){this.writeLine(`${t} ${this.floatDecimals(e)},`)}writeStringAttrib(t,e){this.writeLine(`${t} "${e}",`)}writeVectorAttrib(t,e){this.writeLine(`${t} { ${this.floatArrayDecimals(e)} },`)}writeColor(t,e){const i=this.floatDecimals(e[0]),r=this.floatDecimals(e[1]),n=this.floatDecimals(e[2]);this.writeLine(`${t} { ${n}, ${r}, ${i} },`)}writeVector(t){this.writeLine(`{ ${this.floatArrayDecimals(t)} },`)}writeVectorArrayBlock(t,e,i){this.startBlock(t,e.length/i);for(let t=0,r=e.length;t<r;t+=i)this.writeVector(e.subarray(t,t+i));this.endBlock()}startBlock(t,...e){e.length&&(t=`${t} ${e.join(" ")}`),this.writeLine(`${t} {`),this.ident+=1}startObjectBlock(t,e){this.writeLine(`${t} "${e.replace(/"/g,'\\"')}" {`),this.ident+=1}endBlock(){this.ident-=1,this.writeLine("}")}endBlockComma(){this.ident-=1,this.writeLine("},")}indent(){this.ident+=1}unindent(){this.ident-=1}floatDecimals(t){return""+Math.trunc(t*this.precision)/this.precision}floatArrayDecimals(t){if(t instanceof Float32Array){const e=[];for(let i=0,r=t.length;i<r;i++)e[i]=this.floatDecimals(t[i]);return e.join(", ")}return t.join(", ")}}class Te{constructor(){this.boundsRadius=0,this.min=new Float32Array(3),this.max=new Float32Array(3)}readMdx(t){this.boundsRadius=t.readFloat32(),t.readFloat32Array(this.min),t.readFloat32Array(this.max)}writeMdx(t){t.writeFloat32(this.boundsRadius),t.writeFloat32Array(this.min),t.writeFloat32Array(this.max)}writeMdl(t){0===this.min[0]&&0===this.min[1]&&0===this.min[2]||t.writeVectorAttrib("MinimumExtent",this.min),0===this.max[0]&&0===this.max[1]&&0===this.max[2]||t.writeVectorAttrib("MaximumExtent",this.max),0!==this.boundsRadius&&t.writeNumberAttrib("BoundsRadius",this.boundsRadius)}}class Ee{constructor(){this.name="",this.interval=new Uint32Array(2),this.moveSpeed=0,this.nonLooping=0,this.rarity=0,this.syncPoint=0,this.extent=new Te}readMdx(t){this.name=t.read(80),t.readUint32Array(this.interval),this.moveSpeed=t.readFloat32(),this.nonLooping=t.readUint32(),this.rarity=t.readFloat32(),this.syncPoint=t.readUint32(),this.extent.readMdx(t)}writeMdx(t){t.skip(80-t.write(this.name)),t.writeUint32Array(this.interval),t.writeFloat32(this.moveSpeed),t.writeUint32(this.nonLooping),t.writeFloat32(this.rarity),t.writeUint32(this.syncPoint),this.extent.writeMdx(t)}readMdl(t){this.name=t.read();for(const e of t.readBlock())if("Interval"===e)t.readVector(this.interval);else if("NonLooping"===e)this.nonLooping=1;else if("MoveSpeed"===e)this.moveSpeed=t.readFloat();else if("Rarity"===e)this.rarity=t.readFloat();else if("MinimumExtent"===e)t.readVector(this.extent.min);else if("MaximumExtent"===e)t.readVector(this.extent.max);else{if("BoundsRadius"!==e)throw new Error(`Unknown token in Sequence: "${e}"`);this.extent.boundsRadius=t.readFloat()}}writeMdl(t){t.startObjectBlock("Anim",this.name),t.writeVectorAttrib("Interval",this.interval),1===this.nonLooping&&t.writeFlag("NonLooping"),0!==this.moveSpeed&&t.writeNumberAttrib("MoveSpeed",this.moveSpeed),0!==this.rarity&&t.writeNumberAttrib("Rarity",this.rarity),this.extent.writeMdl(t),t.endBlock()}}class Se{constructor(){this.name="",this.interpolationType=0,this.globalSequenceId=-1,this.frames=[],this.values=[],this.inTans=[],this.outTans=[]}readMdx(t,e){const i=this.frames,r=this.values,n=this.inTans,s=this.outTans,a=t.readUint32(),o=t.readUint32();this.name=e,this.interpolationType=o,this.globalSequenceId=t.readInt32();for(let e=0;e<a;e++)i.push(t.readInt32()),r.push(this.readMdxValue(t)),o>1&&(n.push(this.readMdxValue(t)),s.push(this.readMdxValue(t)))}writeMdx(t){const e=this.interpolationType,i=this.frames,r=this.values,n=this.inTans,s=this.outTans,a=i.length;t.writeBinary(this.name),t.writeUint32(a),t.writeUint32(e),t.writeInt32(this.globalSequenceId);for(let o=0;o<a;o++)t.writeInt32(i[o]),this.writeMdxValue(t,r[o]),e>1&&(this.writeMdxValue(t,n[o]),this.writeMdxValue(t,s[o]))}readMdl(t,e){const i=this.frames,r=this.values,n=this.inTans,s=this.outTans;this.name=e;const a=t.readInt();t.read();let o=0;const l=t.read();"DontInterp"===l?o=0:"Linear"===l?o=1:"Hermite"===l?o=2:"Bezier"===l&&(o=3),this.interpolationType=o,"GlobalSeqId"===t.peek()&&(t.read(),this.globalSequenceId=t.readInt());for(let e=0;e<a;e++)i[e]=t.readInt(),r[e]=this.readMdlValue(t),o>1&&(t.read(),n[e]=this.readMdlValue(t),t.read(),s[e]=this.readMdlValue(t));t.read()}writeMdl(t,e){const i=this.interpolationType,r=this.frames,n=this.values,s=this.inTans,a=this.outTans,o=r.length;t.startBlock(e,this.frames.length);let l="";0===this.interpolationType?l="DontInterp":1===this.interpolationType?l="Linear":2===this.interpolationType?l="Hermite":3===this.interpolationType&&(l="Bezier"),t.writeFlag(l),-1!==this.globalSequenceId&&t.writeNumberAttrib("GlobalSeqId",this.globalSequenceId);for(let e=0;e<o;e++)this.writeMdlValue(t,`${r[e]}:`,n[e]),i>1&&(t.indent(),this.writeMdlValue(t,"InTan",s[e]),this.writeMdlValue(t,"OutTan",a[e]),t.unindent());t.endBlock()}getByteLength(){const t=this.frames.length;let e=16;if(t){const i=this.values[0].byteLength;let r=1;this.interpolationType>1&&(r=3),e+=(4+r*i)*t}return e}}class Be extends Se{readMdxValue(t){return t.readUint32Array(1)}writeMdxValue(t,e){t.writeUint32(e[0])}readMdlValue(t){return new Uint32Array([t.readInt()])}writeMdlValue(t,e,i){t.writeNumberAttrib(e,i[0])}}class Ie extends Se{readMdxValue(t){return t.readFloat32Array(1)}writeMdxValue(t,e){t.writeFloat32(e[0])}readMdlValue(t){return new Float32Array([t.readFloat()])}writeMdlValue(t,e,i){t.writeNumberAttrib(e,i[0])}}class Le extends Se{readMdxValue(t){return t.readFloat32Array(3)}writeMdxValue(t,e){t.writeFloat32Array(e)}readMdlValue(t){return t.readVector(new Float32Array(3))}writeMdlValue(t,e,i){t.writeVectorAttrib(e,i)}}class Ce extends Se{readMdxValue(t){return t.readFloat32Array(4)}writeMdxValue(t,e){t.writeFloat32Array(e)}readMdlValue(t){return t.readVector(new Float32Array(4))}writeMdlValue(t,e,i){t.writeVectorAttrib(e,i)}}const Re={KMTF:["TextureID",Be],KMTA:["Alpha",Ie],KMTE:["EmissiveGain",Ie],KFC3:["FresnelColor",Le],KFCA:["FresnelOpacity",Ie],KFTC:["FresnelTeamColor",Be],KTAT:["Translation",Le],KTAR:["Rotation",Ce],KTAS:["Scaling",Le],KGAO:["Alpha",Ie],KGAC:["Color",Le],KGTR:["Translation",Le],KGRT:["Rotation",Ce],KGSC:["Scaling",Le],KLAS:["AttenuationStart",Ie],KLAE:["AttenuationEnd",Ie],KLAC:["Color",Le],KLAI:["Intensity",Ie],KLBI:["AmbIntensity",Ie],KLBC:["AmbColor",Le],KLAV:["Visibility",Ie],KATV:["Visibility",Ie],KPEE:["EmissionRate",Ie],KPEG:["Gravity",Ie],KPLN:["Longitude",Ie],KPLT:["Latitude",Ie],KPEL:["LifeSpan",Ie],KPES:["InitVelocity",Ie],KPEV:["Visibility",Ie],KP2S:["Speed",Ie],KP2R:["Variation",Ie],KP2L:["Latitude",Ie],KP2G:["Gravity",Ie],KP2E:["EmissionRate",Ie],KP2N:["Width",Ie],KP2W:["Length",Ie],KP2V:["Visibility",Ie],KPPA:["Alpha",Ie],KPPC:["Color",Le],KPPE:["EmissionRate",Ie],KPPL:["LifeSpan",Ie],KPPS:["Speed",Ie],KPPV:["Visibility",Ie],KRHA:["HeightAbove",Ie],KRHB:["HeightBelow",Ie],KRAL:["Alpha",Ie],KRCO:["Color",Le],KRTX:["TextureSlot",Be],KRVS:["Visibility",Ie],KCTR:["Translation",Le],KTTR:["Translation",Le],KCRL:["Rotation",Ie]};class Me{constructor(){this.animations=[]}readAnimations(t,e){const i=t.index+e;for(;t.index<i;){const e=t.readBinary(4),i=new Re[e][1];i.readMdx(t,e),this.animations.push(i)}}writeAnimations(t){for(const e of this.animations)e.writeMdx(t)}*readAnimatedBlock(t){for(const e of t.readBlock())"static"===e?yield`static ${t.read()}`:yield e}readAnimation(t,e){const i=new Re[e][1];i.readMdl(t,e),this.animations.push(i)}writeAnimation(t,e){for(const i of this.animations)if(i.name===e)return i.writeMdl(t,Re[e][0]),!0;return!1}getByteLength(t){let e=0;for(const t of this.animations)e+=t.getByteLength();return e}}function Ue(t){return"None"===t?0:"Transparent"===t?1:"Blend"===t?2:"Additive"===t?3:"AddAlpha"===t?4:"Modulate"===t?5:"Modulate2x"===t?6:0}class ke extends Me{constructor(){super(...arguments),this.filterMode=0,this.flags=0,this.textureId=-1,this.textureAnimationId=-1,this.coordId=0,this.alpha=1,this.emissiveGain=1,this.fresnelColor=new Float32Array([1,1,1]),this.fresnelOpacity=0,this.fresnelTeamColor=0}readMdx(t,e){const i=t.index,r=t.readUint32();this.filterMode=t.readUint32(),this.flags=t.readUint32(),this.textureId=t.readInt32(),this.textureAnimationId=t.readInt32(),this.coordId=t.readUint32(),this.alpha=t.readFloat32(),e>800&&(this.emissiveGain=t.readFloat32(),t.readFloat32Array(this.fresnelColor),this.fresnelOpacity=t.readFloat32(),this.fresnelTeamColor=t.readFloat32()),this.readAnimations(t,r-(t.index-i))}writeMdx(t,e){t.writeUint32(this.getByteLength(e)),t.writeUint32(this.filterMode),t.writeUint32(this.flags),t.writeInt32(this.textureId),t.writeInt32(this.textureAnimationId),t.writeUint32(this.coordId),t.writeFloat32(this.alpha),e>800&&(t.writeFloat32(this.emissiveGain),t.writeFloat32Array(this.fresnelColor),t.writeFloat32(this.fresnelOpacity),t.writeFloat32(this.fresnelTeamColor)),this.writeAnimations(t)}readMdl(t){for(const e of super.readAnimatedBlock(t))if("FilterMode"===e)this.filterMode=Ue(t.read());else if("Unshaded"===e)this.flags|=1;else if("SphereEnvMap"===e)this.flags|=2;else if("TwoSided"===e)this.flags|=16;else if("Unfogged"===e)this.flags|=32;else if("NoDepthTest"===e)this.flags|=64;else if("NoDepthSet"===e)this.flags|=128;else if("Unlit"===e)this.flags|=256;else if("static TextureID"===e)this.textureId=t.readInt();else if("TextureID"===e)this.readAnimation(t,"KMTF");else if("TVertexAnimId"===e)this.textureAnimationId=t.readInt();else if("CoordId"===e)this.coordId=t.readInt();else if("static Alpha"===e)this.alpha=t.readFloat();else if("Alpha"===e)this.readAnimation(t,"KMTA");else if("static EmissiveGain"===e)this.emissiveGain=t.readFloat();else if("EmissiveGain"===e)this.readAnimation(t,"KMTE");else if("static FresnelColor"===e)t.readVector(this.fresnelColor);else if("FresnelColor"===e)this.readAnimation(t,"KFC3");else if("static FresnelOpacity"===e)this.fresnelOpacity=t.readFloat();else if("FresnelOpacity"===e)this.readAnimation(t,"KFCA");else if("static FresnelTeamColor"===e)this.fresnelTeamColor=t.readFloat();else{if("FresnelTeamColor"!==e)throw new Error(`Unknown token in Layer: "${e}"`);this.readAnimation(t,"KFTC")}}writeMdl(t,e){var i;t.startBlock("Layer"),t.writeFlagAttrib("FilterMode",0===(i=this.filterMode)?"None":1===i?"Transparent":2===i?"Blend":3===i?"Additive":4===i?"AddAlpha":5===i?"Modulate":6===i?"Modulate2x":"None"),1&this.flags&&t.writeFlag("Unshaded"),2&this.flags&&t.writeFlag("SphereEnvMap"),16&this.flags&&t.writeFlag("TwoSided"),32&this.flags&&t.writeFlag("Unfogged"),64&this.flags&&t.writeFlag("NoDepthTest"),128&this.flags&&t.writeFlag("NoDepthSet"),e>800&&256&this.flags&&t.writeFlag("Unlit"),this.writeAnimation(t,"KMTF")||t.writeNumberAttrib("static TextureID",this.textureId),-1!==this.textureAnimationId&&t.writeNumberAttrib("TVertexAnimId",this.textureAnimationId),0!==this.coordId&&t.writeNumberAttrib("CoordId",this.coordId),this.writeAnimation(t,"KMTA")||1===this.alpha||t.writeNumberAttrib("static Alpha",this.alpha),e>800&&(this.writeAnimation(t,"KMTE")||1===this.emissiveGain||t.writeNumberAttrib("static EmissiveGain",this.emissiveGain),this.writeAnimation(t,"KFC3")||1===this.fresnelColor[0]&&1===this.fresnelColor[1]&&1===this.fresnelColor[2]||t.writeVectorAttrib("static FresnelColor",this.fresnelColor),this.writeAnimation(t,"KFCA")||0===this.fresnelOpacity||t.writeNumberAttrib("static FresnelOpacity",this.fresnelOpacity),this.writeAnimation(t,"KFTC")||0===this.fresnelTeamColor||t.writeNumberAttrib("static FresnelTeamColor",this.fresnelTeamColor)),t.endBlock()}getByteLength(t){let e=28+super.getByteLength();return t>800&&(e+=24),e}}class Fe{constructor(){this.priorityPlane=0,this.flags=0,this.shader="",this.layers=[]}readMdx(t,e){t.readUint32(),this.priorityPlane=t.readInt32(),this.flags=t.readUint32(),e>800&&(this.shader=t.read(80)),t.skip(4);for(let i=0,r=t.readUint32();i<r;i++){const i=new ke;i.readMdx(t,e),this.layers.push(i)}}writeMdx(t,e){t.writeUint32(this.getByteLength(e)),t.writeInt32(this.priorityPlane),t.writeUint32(this.flags),e>800&&t.skip(80-t.write(this.shader)),t.writeBinary("LAYS"),t.writeUint32(this.layers.length);for(const i of this.layers)i.writeMdx(t,e)}readMdl(t){for(const e of t.readBlock())if("ConstantColor"===e)this.flags|=1;else if("TwoSided"===e)this.flags|=2;else if("SortPrimsNearZ"===e)this.flags|=8;else if("SortPrimsFarZ"===e)this.flags|=16;else if("FullResolution"===e)this.flags|=32;else if("PriorityPlane"===e)this.priorityPlane=t.readInt();else if("Shader"===e)this.shader=t.read();else{if("Layer"!==e)throw new Error(`Unknown token in Material: "${e}"`);{const e=new ke;e.readMdl(t),this.layers.push(e)}}}writeMdl(t,e){t.startBlock("Material"),1&this.flags&&t.writeFlag("ConstantColor"),e>800&&2&this.flags&&t.writeFlag("TwoSided"),8&this.flags&&t.writeFlag("SortPrimsNearZ"),16&this.flags&&t.writeFlag("SortPrimsFarZ"),32&this.flags&&t.writeFlag("FullResolution"),0!==this.priorityPlane&&t.writeNumberAttrib("PriorityPlane",this.priorityPlane),e>800&&t.writeStringAttrib("Shader",this.shader);for(const i of this.layers)i.writeMdl(t,e);t.endBlock()}getByteLength(t){let e=20;t>800&&(e+=80);for(const i of this.layers)e+=i.getByteLength(t);return e}}class De{constructor(){this.replaceableId=0,this.path="",this.wrapMode=0}readMdx(t){this.replaceableId=t.readUint32(),this.path=t.read(260),this.wrapMode=t.readUint32()}writeMdx(t){t.writeUint32(this.replaceableId),t.skip(260-t.write(this.path)),t.writeUint32(this.wrapMode)}readMdl(t){for(const e of t.readBlock())if("Image"===e)this.path=t.read();else if("ReplaceableId"===e)this.replaceableId=t.readInt();else if("WrapWidth"===e)this.wrapMode|=1;else{if("WrapHeight"!==e)throw new Error(`Unknown token in Texture: "${e}"`);this.wrapMode|=2}}writeMdl(t){t.startBlock("Bitmap"),this.path.length&&t.writeStringAttrib("Image",this.path),0!==this.replaceableId&&t.writeNumberAttrib("ReplaceableId",this.replaceableId),1&this.wrapMode&&t.writeFlag("WrapWidth"),2&this.wrapMode&&t.writeFlag("WrapHeight"),t.endBlock()}}class Pe extends Me{readMdx(t){const e=t.readUint32();this.readAnimations(t,e-4)}writeMdx(t){t.writeUint32(this.getByteLength()),this.writeAnimations(t)}readMdl(t){for(const e of t.readBlock())if("Translation"===e)this.readAnimation(t,"KTAT");else if("Rotation"===e)this.readAnimation(t,"KTAR");else{if("Scaling"!==e)throw new Error(`Unknown token in TextureAnimation: "${e}"`);this.readAnimation(t,"KTAS")}}writeMdl(t){t.startBlock("TVertexAnim "),this.writeAnimation(t,"KTAT"),this.writeAnimation(t,"KTAR"),this.writeAnimation(t,"KTAS"),t.endBlock()}getByteLength(){return 4+super.getByteLength()}}class Ne{constructor(){this.vertices=new Float32Array(0),this.normals=new Float32Array(0),this.faceTypeGroups=new Uint32Array(0),this.faceGroups=new Uint32Array(0),this.faces=new Uint16Array(0),this.vertexGroups=new Uint8Array(0),this.matrixGroups=new Uint32Array(0),this.matrixIndices=new Uint32Array(0),this.materialId=0,this.selectionGroup=0,this.selectionFlags=0,this.lod=-1,this.lodName="",this.extent=new Te,this.sequenceExtents=[],this.tangents=new Float32Array(0),this.skin=new Uint8Array(0),this.uvSets=[]}readMdx(t,e){t.readUint32(),t.skip(4),this.vertices=t.readFloat32Array(3*t.readUint32()),t.skip(4),this.normals=t.readFloat32Array(3*t.readUint32()),t.skip(4),this.faceTypeGroups=t.readUint32Array(t.readUint32()),t.skip(4),this.faceGroups=t.readUint32Array(t.readUint32()),t.skip(4),this.faces=t.readUint16Array(t.readUint32()),t.skip(4),this.vertexGroups=t.readUint8Array(t.readUint32()),t.skip(4),this.matrixGroups=t.readUint32Array(t.readUint32()),t.skip(4),this.matrixIndices=t.readUint32Array(t.readUint32()),this.materialId=t.readUint32(),this.selectionGroup=t.readUint32(),this.selectionFlags=t.readUint32(),e>800&&(this.lod=t.readInt32(),this.lodName=t.read(80)),this.extent.readMdx(t);for(let e=0,i=t.readUint32();e<i;e++){const e=new Te;e.readMdx(t),this.sequenceExtents.push(e)}e>800&&("TANG"===t.readBinary(4)?this.tangents=t.readFloat32Array(4*t.readUint32()):t.skip(-4),"SKIN"===t.readBinary(4)?this.skin=t.readUint8Array(t.readUint32()):t.skip(-4)),t.skip(4);for(let e=0,i=t.readUint32();e<i;e++)t.skip(4),this.uvSets.push(t.readFloat32Array(2*t.readUint32()))}writeMdx(t,e){t.writeUint32(this.getByteLength(e)),t.writeBinary("VRTX"),t.writeUint32(this.vertices.length/3),t.writeFloat32Array(this.vertices),t.writeBinary("NRMS"),t.writeUint32(this.normals.length/3),t.writeFloat32Array(this.normals),t.writeBinary("PTYP"),t.writeUint32(this.faceTypeGroups.length),t.writeUint32Array(this.faceTypeGroups),t.writeBinary("PCNT"),t.writeUint32(this.faceGroups.length),t.writeUint32Array(this.faceGroups),t.writeBinary("PVTX"),t.writeUint32(this.faces.length),t.writeUint16Array(this.faces),t.writeBinary("GNDX"),t.writeUint32(this.vertexGroups.length),t.writeUint8Array(this.vertexGroups),t.writeBinary("MTGC"),t.writeUint32(this.matrixGroups.length),t.writeUint32Array(this.matrixGroups),t.writeBinary("MATS"),t.writeUint32(this.matrixIndices.length),t.writeUint32Array(this.matrixIndices),t.writeUint32(this.materialId),t.writeUint32(this.selectionGroup),t.writeUint32(this.selectionFlags),e>800&&(t.writeInt32(this.lod),t.skip(80-t.write(this.lodName))),this.extent.writeMdx(t),t.writeUint32(this.sequenceExtents.length);for(const e of this.sequenceExtents)e.writeMdx(t);e>800&&(this.tangents.length&&(t.writeBinary("TANG"),t.writeUint32(this.tangents.length/4),t.writeFloat32Array(this.tangents)),this.skin.length&&(t.writeBinary("SKIN"),t.writeUint32(this.skin.length),t.writeUint8Array(this.skin))),t.writeBinary("UVAS"),t.writeUint32(this.uvSets.length);for(const e of this.uvSets)t.writeBinary("UVBS"),t.writeUint32(e.length/2),t.writeFloat32Array(e)}readMdl(t){for(let e of t.readBlock())if("Vertices"===e)this.vertices=t.readVectorsBlock(new Float32Array(3*t.readInt()),3);else if("Normals"===e)this.normals=t.readVectorsBlock(new Float32Array(3*t.readInt()),3);else if("TVertices"===e)this.uvSets.push(t.readVectorsBlock(new Float32Array(2*t.readInt()),2));else if("VertexGroup"===e){const e=[];for(const i of t.readBlock())e.push(parseInt(i));this.vertexGroups=new Uint8Array(e)}else if("Tangents"===e)this.tangents=t.readVectorsBlock(new Float32Array(4*t.readInt()),4);else if("SkinWeights"===e)this.skin=t.readVector(new Uint8Array(8*t.readInt()));else if("Faces"===e){this.faceTypeGroups=new Uint32Array([4]);const e=t.readInt(),i=t.readInt();t.read(),t.read(),this.faces=t.readVectorsBlock(new Uint16Array(i),i/e),this.faceGroups=new Uint32Array([i]),t.read()}else if("Groups"===e){const e=[],i=[];t.readInt(),t.readInt();for(const r of t.readBlock()){let r=0;for(const i of t.readBlock())e.push(parseInt(i)),r+=1;i.push(r)}this.matrixIndices=new Uint32Array(e),this.matrixGroups=new Uint32Array(i)}else if("MinimumExtent"===e)t.readVector(this.extent.min);else if("MaximumExtent"===e)t.readVector(this.extent.max);else if("BoundsRadius"===e)this.extent.boundsRadius=t.readFloat();else if("Anim"===e){const i=new Te;for(e of t.readBlock())"MinimumExtent"===e?t.readVector(i.min):"MaximumExtent"===e?t.readVector(i.max):"BoundsRadius"===e&&(i.boundsRadius=t.readFloat());this.sequenceExtents.push(i)}else if("MaterialID"===e)this.materialId=t.readInt();else if("SelectionGroup"===e)this.selectionGroup=t.readInt();else if("Unselectable"===e)this.selectionFlags=4;else if("LevelOfDetail"===e)this.lod=t.readInt();else{if("Name"!==e)throw new Error(`Unknown token in Geoset: "${e}"`);this.lodName=t.read()}}writeMdl(t,e){t.startBlock("Geoset"),t.writeVectorArrayBlock("Vertices",this.vertices,3),t.writeVectorArrayBlock("Normals",this.normals,3);for(const e of this.uvSets)t.writeVectorArrayBlock("TVertices",e,2);if(e>800&&this.tangents.length&&t.writeVectorArrayBlock("Tangents",this.tangents,4),this.vertexGroups.length){t.startBlock("VertexGroup");for(let e=0,i=this.vertexGroups.length;e<i;e++)t.writeLine(`${this.vertexGroups[e]},`);t.endBlock()}if(e>800&&this.skin.length){t.startBlock("SkinWeights",this.skin.length/8);for(let e=0,i=this.skin.length;e<i;e+=8)t.writeLine(`${this.skin.subarray(e,e+8).join(", ")},`);t.endBlock()}t.startBlock("Faces",1,this.faces.length),t.startBlock("Triangles"),t.writeVector(this.faces),t.endBlock(),t.endBlock(),t.startBlock("Groups",this.matrixGroups.length,this.matrixIndices.length);let i=0;for(const e of this.matrixGroups)t.writeVectorAttrib("Matrices",this.matrixIndices.subarray(i,i+e)),i+=e;t.endBlock(),this.extent.writeMdl(t);for(const e of this.sequenceExtents)t.startBlock("Anim"),e.writeMdl(t),t.endBlock();t.writeNumberAttrib("MaterialID",this.materialId),t.writeNumberAttrib("SelectionGroup",this.selectionGroup),4===this.selectionFlags&&t.writeFlag("Unselectable"),e>800&&(t.writeNumberAttrib("LevelOfDetail",this.lod),this.lodName.length&&t.writeStringAttrib("Name",this.lodName)),t.endBlock()}getByteLength(t){let e=120+this.vertices.byteLength+this.normals.byteLength+this.faceTypeGroups.byteLength+this.faceGroups.byteLength+this.faces.byteLength+this.vertexGroups.byteLength+this.matrixGroups.byteLength+this.matrixIndices.byteLength+28*this.sequenceExtents.length;t>800&&(e+=84,this.tangents.length&&(e+=8+this.tangents.byteLength),this.skin.length&&(e+=8+this.skin.byteLength));for(const t of this.uvSets)e+=8+t.byteLength;return e}}class Oe extends Me{constructor(){super(...arguments),this.alpha=1,this.flags=0,this.color=new Float32Array([1,1,1]),this.geosetId=-1}readMdx(t){const e=t.readUint32();this.alpha=t.readFloat32(),this.flags=t.readUint32(),t.readFloat32Array(this.color),this.geosetId=t.readInt32(),this.readAnimations(t,e-28)}writeMdx(t){t.writeUint32(this.getByteLength()),t.writeFloat32(this.alpha),t.writeUint32(this.flags),t.writeFloat32Array(this.color),t.writeInt32(this.geosetId),this.writeAnimations(t)}readMdl(t){for(const e of super.readAnimatedBlock(t))if("DropShadow"===e)this.flags|=1;else if("static Alpha"===e)this.alpha=t.readFloat();else if("Alpha"===e)this.readAnimation(t,"KGAO");else if("static Color"===e)this.flags|=2,t.readColor(this.color);else if("Color"===e)this.flags|=2,this.readAnimation(t,"KGAC");else{if("GeosetId"!==e)throw new Error(`Unknown token in GeosetAnimation: "${e}"`);this.geosetId=t.readInt()}}writeMdl(t){t.startBlock("GeosetAnim"),1&this.flags&&t.writeFlag("DropShadow"),this.writeAnimation(t,"KGAO")||t.writeNumberAttrib("static Alpha",this.alpha),2&this.flags&&(this.writeAnimation(t,"KGAC")||1===this.color[0]&&1===this.color[1]&&1===this.color[2]||t.writeColor("static Color ",this.color)),t.writeNumberAttrib("GeosetId",this.geosetId),t.endBlock()}getByteLength(){return 28+super.getByteLength()}}class Ve extends Me{constructor(t=0){super(),this.name="",this.objectId=-1,this.parentId=-1,this.flags=t}readMdx(t){const e=t.readUint32();this.name=t.read(80),this.objectId=t.readInt32(),this.parentId=t.readInt32(),this.flags=t.readUint32(),this.readAnimations(t,e-96)}writeMdx(t){t.writeUint32(this.getGenericByteLength()),t.skip(80-t.write(this.name)),t.writeInt32(this.objectId),t.writeInt32(this.parentId),t.writeUint32(this.flags);for(const e of this.eachAnimation(!0))e.writeMdx(t)}writeNonGenericAnimationChunks(t){for(const e of this.eachAnimation(!1))e.writeMdx(t)}*readGenericBlock(t){this.name=t.read();for(let e of this.readAnimatedBlock(t))if("ObjectId"===e)this.objectId=t.readInt();else if("Parent"===e)this.parentId=t.readInt();else if("BillboardedLockZ"===e)this.flags|=64;else if("BillboardedLockY"===e)this.flags|=32;else if("BillboardedLockX"===e)this.flags|=16;else if("Billboarded"===e)this.flags|=8;else if("CameraAnchored"===e)this.flags|=128;else if("DontInherit"===e)for(e of t.readBlock())"Rotation"===e?this.flags|=2:"Translation"===e?this.flags|=1:"Scaling"===e&&(this.flags|=4);else"Translation"===e?this.readAnimation(t,"KGTR"):"Rotation"===e?this.readAnimation(t,"KGRT"):"Scaling"===e?this.readAnimation(t,"KGSC"):yield e}writeGenericHeader(t){t.writeNumberAttrib("ObjectId",this.objectId),-1!==this.parentId&&t.writeNumberAttrib("Parent",this.parentId),64&this.flags&&t.writeFlag("BillboardedLockZ"),32&this.flags&&t.writeFlag("BillboardedLockY"),16&this.flags&&t.writeFlag("BillboardedLockX"),8&this.flags&&t.writeFlag("Billboarded"),128&this.flags&&t.writeFlag("CameraAnchored"),2&this.flags&&t.writeFlag("DontInherit { Rotation }"),1&this.flags&&t.writeFlag("DontInherit { Translation }"),4&this.flags&&t.writeFlag("DontInherit { Scaling }")}writeGenericAnimations(t){this.writeAnimation(t,"KGTR"),this.writeAnimation(t,"KGRT"),this.writeAnimation(t,"KGSC")}*eachAnimation(t){for(const e of this.animations){const i=e.name,r="KGTR"===i||"KGRT"===i||"KGSC"===i;(t&&r||!t&&!r)&&(yield e)}}getGenericByteLength(){let t=96;for(const e of this.eachAnimation(!0))t+=e.getByteLength();return t}getByteLength(){return 96+super.getByteLength()}}class Ge extends Ve{constructor(){super(256),this.geosetId=-1,this.geosetAnimationId=-1}readMdx(t){super.readMdx(t),this.geosetId=t.readInt32(),this.geosetAnimationId=t.readInt32()}writeMdx(t){super.writeMdx(t),t.writeInt32(this.geosetId),t.writeInt32(this.geosetAnimationId)}readMdl(t){for(let e of super.readGenericBlock(t))if("GeosetId"===e)e=t.read(),this.geosetId="Multiple"===e?-1:parseInt(e);else{if("GeosetAnimId"!==e)throw new Error(`Unknown token in Bone ${this.name}: "${e}"`);e=t.read(),this.geosetAnimationId="None"===e?-1:parseInt(e)}}writeMdl(t){t.startObjectBlock("Bone",this.name),this.writeGenericHeader(t),-1===this.geosetId?t.writeFlagAttrib("GeosetId","Multiple"):t.writeNumberAttrib("GeosetId",this.geosetId),-1===this.geosetAnimationId?t.writeFlagAttrib("GeosetAnimId","None"):t.writeNumberAttrib("GeosetAnimId",this.geosetAnimationId),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 8+super.getByteLength()}}class ze extends Ve{constructor(){super(512),this.type=-1,this.attenuation=new Float32Array(2),this.color=new Float32Array(3),this.intensity=0,this.ambientColor=new Float32Array(3),this.ambientIntensity=0}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.type=t.readUint32(),t.readFloat32Array(this.attenuation),t.readFloat32Array(this.color),this.intensity=t.readFloat32(),t.readFloat32Array(this.ambientColor),this.ambientIntensity=t.readFloat32(),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.writeUint32(this.type),t.writeFloat32Array(this.attenuation),t.writeFloat32Array(this.color),t.writeFloat32(this.intensity),t.writeFloat32Array(this.ambientColor),t.writeFloat32(this.ambientIntensity),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(const e of super.readGenericBlock(t))if("Omnidirectional"===e)this.type=0;else if("Directional"===e)this.type=1;else if("Ambient"===e)this.type=2;else if("static AttenuationStart"===e)this.attenuation[0]=t.readFloat();else if("AttenuationStart"===e)this.readAnimation(t,"KLAS");else if("static AttenuationEnd"===e)this.attenuation[1]=t.readFloat();else if("AttenuationEnd"===e)this.readAnimation(t,"KLAE");else if("static Intensity"===e)this.intensity=t.readFloat();else if("Intensity"===e)this.readAnimation(t,"KLAI");else if("static Color"===e)t.readColor(this.color);else if("Color"===e)this.readAnimation(t,"KLAC");else if("static AmbIntensity"===e)this.ambientIntensity=t.readFloat();else if("AmbIntensity"===e)this.readAnimation(t,"KLBI");else if("static AmbColor"===e)t.readColor(this.ambientColor);else if("AmbColor"===e)this.readAnimation(t,"KLBC");else{if("Visibility"!==e)throw new Error(`Unknown token in Light: "${e}"`);this.readAnimation(t,"KLAV")}}writeMdl(t){t.startObjectBlock("Light",this.name),this.writeGenericHeader(t),0===this.type?t.writeFlag("Omnidirectional"):1===this.type?t.writeFlag("Directional"):2===this.type&&t.writeFlag("Ambient"),this.writeAnimation(t,"KLAS")||t.writeNumberAttrib("static AttenuationStart",this.attenuation[0]),this.writeAnimation(t,"KLAE")||t.writeNumberAttrib("static AttenuationEnd",this.attenuation[1]),this.writeAnimation(t,"KLAI")||t.writeNumberAttrib("static Intensity",this.intensity),this.writeAnimation(t,"KLAC")||t.writeColor("static Color",this.color),this.writeAnimation(t,"KLBI")||t.writeNumberAttrib("static AmbIntensity",this.ambientIntensity),this.writeAnimation(t,"KLBC")||t.writeColor("static AmbColor",this.ambientColor),this.writeAnimation(t,"KLAV"),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 48+super.getByteLength()}}class je extends Ve{readMdl(t){for(const e of super.readGenericBlock(t))throw new Error(`Unknown token in Helper: "${e}"`)}writeMdl(t){t.startObjectBlock("Helper",this.name),this.writeGenericHeader(t),this.writeGenericAnimations(t),t.endBlock()}}class Ke extends Ve{constructor(){super(2048),this.path="",this.attachmentId=0}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.path=t.read(260),this.attachmentId=t.readInt32(),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.skip(260-t.write(this.path)),t.writeInt32(this.attachmentId),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(const e of super.readGenericBlock(t))if("AttachmentID"===e)this.attachmentId=t.readInt();else if("Path"===e)this.path=t.read();else{if("Visibility"!==e)throw new Error(`Unknown token in Attachment ${this.name}: "${e}"`);this.readAnimation(t,"KATV")}}writeMdl(t){t.startObjectBlock("Attachment",this.name),this.writeGenericHeader(t),t.writeNumberAttrib("AttachmentID",this.attachmentId),this.path.length&&t.writeStringAttrib("Path",this.path),this.writeAnimation(t,"KATV"),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 268+super.getByteLength()}}class He extends Ve{constructor(){super(4096),this.emissionRate=0,this.gravity=0,this.longitude=0,this.latitude=0,this.path="",this.lifeSpan=0,this.speed=0}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.emissionRate=t.readFloat32(),this.gravity=t.readFloat32(),this.longitude=t.readFloat32(),this.latitude=t.readFloat32(),this.path=t.read(260),this.lifeSpan=t.readFloat32(),this.speed=t.readFloat32(),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.writeFloat32(this.emissionRate),t.writeFloat32(this.gravity),t.writeFloat32(this.longitude),t.writeFloat32(this.latitude),t.skip(260-t.write(this.path)),t.writeFloat32(this.lifeSpan),t.writeFloat32(this.speed),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(let e of super.readGenericBlock(t))if("EmitterUsesMDL"===e)this.flags|=32768;else if("EmitterUsesTGA"===e)this.flags|=65536;else if("static EmissionRate"===e)this.emissionRate=t.readFloat();else if("EmissionRate"===e)this.readAnimation(t,"KPEE");else if("static Gravity"===e)this.gravity=t.readFloat();else if("Gravity"===e)this.readAnimation(t,"KPEG");else if("static Longitude"===e)this.longitude=t.readFloat();else if("Longitude"===e)this.readAnimation(t,"KPLN");else if("static Latitude"===e)this.latitude=t.readFloat();else if("Latitude"===e)this.readAnimation(t,"KPLT");else if("Visibility"===e)this.readAnimation(t,"KPEV");else{if("Particle"!==e)throw new Error(`Unknown token in ParticleEmitter: "${e}"`);for(e of this.readAnimatedBlock(t))"static LifeSpan"===e?this.lifeSpan=t.readFloat():"LifeSpan"===e?this.readAnimation(t,"KPEL"):"static InitVelocity"===e?this.speed=t.readFloat():"InitVelocity"===e?this.readAnimation(t,"KPES"):"Path"===e&&(this.path=t.read())}}writeMdl(t){t.startObjectBlock("ParticleEmitter",this.name),this.writeGenericHeader(t),32768&this.flags&&t.writeFlag("EmitterUsesMDL"),65536&this.flags&&t.writeFlag("EmitterUsesTGA"),this.writeAnimation(t,"KPEE")||t.writeNumberAttrib("static EmissionRate",this.emissionRate),this.writeAnimation(t,"KPEG")||t.writeNumberAttrib("static Gravity",this.gravity),this.writeAnimation(t,"KPLN")||t.writeNumberAttrib("static Longitude",this.longitude),this.writeAnimation(t,"KPLT")||t.writeNumberAttrib("static Latitude",this.latitude),this.writeAnimation(t,"KPEV"),t.startBlock("Particle"),this.writeAnimation(t,"KPEL")||t.writeNumberAttrib("static LifeSpan",this.lifeSpan),this.writeAnimation(t,"KPES")||t.writeNumberAttrib("static InitVelocity",this.speed),(32768&this.flags||65536&this.flags)&&t.writeStringAttrib("Path",this.path),t.endBlock(),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 288+super.getByteLength()}}class $e extends Ve{constructor(){super(...arguments),this.speed=0,this.variation=0,this.latitude=0,this.gravity=0,this.lifeSpan=0,this.emissionRate=0,this.width=0,this.length=0,this.filterMode=0,this.rows=0,this.columns=0,this.headOrTail=0,this.tailLength=0,this.timeMiddle=0,this.segmentColors=[new Float32Array(3),new Float32Array(3),new Float32Array(3)],this.segmentAlphas=new Uint8Array(3),this.segmentScaling=new Float32Array(3),this.headIntervals=[new Uint32Array(3),new Uint32Array(3)],this.tailIntervals=[new Uint32Array(3),new Uint32Array(3)],this.textureId=-1,this.squirt=0,this.priorityPlane=0,this.replaceableId=0}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.speed=t.readFloat32(),this.variation=t.readFloat32(),this.latitude=t.readFloat32(),this.gravity=t.readFloat32(),this.lifeSpan=t.readFloat32(),this.emissionRate=t.readFloat32(),this.width=t.readFloat32(),this.length=t.readFloat32(),this.filterMode=t.readUint32(),this.rows=t.readUint32(),this.columns=t.readUint32(),this.headOrTail=t.readUint32(),this.tailLength=t.readFloat32(),this.timeMiddle=t.readFloat32(),t.readFloat32Array(this.segmentColors[0]),t.readFloat32Array(this.segmentColors[1]),t.readFloat32Array(this.segmentColors[2]),t.readUint8Array(this.segmentAlphas),t.readFloat32Array(this.segmentScaling),t.readUint32Array(this.headIntervals[0]),t.readUint32Array(this.headIntervals[1]),t.readUint32Array(this.tailIntervals[0]),t.readUint32Array(this.tailIntervals[1]),this.textureId=t.readInt32(),this.squirt=t.readUint32(),this.priorityPlane=t.readInt32(),this.replaceableId=t.readUint32(),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.writeFloat32(this.speed),t.writeFloat32(this.variation),t.writeFloat32(this.latitude),t.writeFloat32(this.gravity),t.writeFloat32(this.lifeSpan),t.writeFloat32(this.emissionRate),t.writeFloat32(this.width),t.writeFloat32(this.length),t.writeUint32(this.filterMode),t.writeUint32(this.rows),t.writeUint32(this.columns),t.writeUint32(this.headOrTail),t.writeFloat32(this.tailLength),t.writeFloat32(this.timeMiddle),t.writeFloat32Array(this.segmentColors[0]),t.writeFloat32Array(this.segmentColors[1]),t.writeFloat32Array(this.segmentColors[2]),t.writeUint8Array(this.segmentAlphas),t.writeFloat32Array(this.segmentScaling),t.writeUint32Array(this.headIntervals[0]),t.writeUint32Array(this.headIntervals[1]),t.writeUint32Array(this.tailIntervals[0]),t.writeUint32Array(this.tailIntervals[1]),t.writeInt32(this.textureId),t.writeUint32(this.squirt),t.writeInt32(this.priorityPlane),t.writeUint32(this.replaceableId),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(const e of super.readGenericBlock(t))if("SortPrimsFarZ"===e)this.flags|=65536;else if("Unshaded"===e)this.flags|=32768;else if("LineEmitter"===e)this.flags|=131072;else if("Unfogged"===e)this.flags|=262144;else if("ModelSpace"===e)this.flags|=524288;else if("XYQuad"===e)this.flags|=1048576;else if("static Speed"===e)this.speed=t.readFloat();else if("Speed"===e)this.readAnimation(t,"KP2S");else if("static Variation"===e)this.variation=t.readFloat();else if("Variation"===e)this.readAnimation(t,"KP2R");else if("static Latitude"===e)this.latitude=t.readFloat();else if("Latitude"===e)this.readAnimation(t,"KP2L");else if("static Gravity"===e)this.gravity=t.readFloat();else if("Gravity"===e)this.readAnimation(t,"KP2G");else if("Visibility"===e)this.readAnimation(t,"KP2V");else if("Squirt"===e)this.squirt=1;else if("LifeSpan"===e)this.lifeSpan=t.readFloat();else if("static EmissionRate"===e)this.emissionRate=t.readFloat();else if("EmissionRate"===e)this.readAnimation(t,"KP2E");else if("static Width"===e)this.width=t.readFloat();else if("Width"===e)this.readAnimation(t,"KP2N");else if("static Length"===e)this.length=t.readFloat();else if("Length"===e)this.readAnimation(t,"KP2W");else if("Blend"===e)this.filterMode=0;else if("Additive"===e)this.filterMode=1;else if("Modulate"===e)this.filterMode=2;else if("Modulate2x"===e)this.filterMode=3;else if("AlphaKey"===e)this.filterMode=4;else if("Rows"===e)this.rows=t.readInt();else if("Columns"===e)this.columns=t.readInt();else if("Head"===e)this.headOrTail=0;else if("Tail"===e)this.headOrTail=1;else if("Both"===e)this.headOrTail=2;else if("TailLength"===e)this.tailLength=t.readFloat();else if("Time"===e)this.timeMiddle=t.readFloat();else if("SegmentColor"===e){t.read();for(let e=0;e<3;e++)t.read(),t.readColor(this.segmentColors[e]);t.read()}else if("Alpha"===e)t.readVector(this.segmentAlphas);else if("ParticleScaling"===e)t.readVector(this.segmentScaling);else if("LifeSpanUVAnim"===e)t.readVector(this.headIntervals[0]);else if("DecayUVAnim"===e)t.readVector(this.headIntervals[1]);else if("TailUVAnim"===e)t.readVector(this.tailIntervals[0]);else if("TailDecayUVAnim"===e)t.readVector(this.tailIntervals[1]);else if("TextureID"===e)this.textureId=t.readInt();else if("ReplaceableId"===e)this.replaceableId=t.readInt();else{if("PriorityPlane"!==e)throw new Error(`Unknown token in ParticleEmitter2: "${e}"`);this.priorityPlane=t.readInt()}}writeMdl(t){t.startObjectBlock("ParticleEmitter2",this.name),this.writeGenericHeader(t),65536&this.flags&&t.writeFlag("SortPrimsFarZ"),32768&this.flags&&t.writeFlag("Unshaded"),131072&this.flags&&t.writeFlag("LineEmitter"),262144&this.flags&&t.writeFlag("Unfogged"),524288&this.flags&&t.writeFlag("ModelSpace"),1048576&this.flags&&t.writeFlag("XYQuad"),this.writeAnimation(t,"KP2S")||t.writeNumberAttrib("static Speed",this.speed),this.writeAnimation(t,"KP2R")||t.writeNumberAttrib("static Variation",this.variation),this.writeAnimation(t,"KP2L")||t.writeNumberAttrib("static Latitude",this.latitude),this.writeAnimation(t,"KP2G")||t.writeNumberAttrib("static Gravity",this.gravity),this.writeAnimation(t,"KP2V"),this.squirt&&t.writeFlag("Squirt"),t.writeNumberAttrib("LifeSpan",this.lifeSpan),this.writeAnimation(t,"KP2E")||t.writeNumberAttrib("static EmissionRate",this.emissionRate),this.writeAnimation(t,"KP2N")||t.writeNumberAttrib("static Width",this.width),this.writeAnimation(t,"KP2W")||t.writeNumberAttrib("static Length",this.length),0===this.filterMode?t.writeFlag("Blend"):1===this.filterMode?t.writeFlag("Additive"):2===this.filterMode?t.writeFlag("Modulate"):3===this.filterMode?t.writeFlag("Modulate2x"):4===this.filterMode&&t.writeFlag("AlphaKey"),t.writeNumberAttrib("Rows",this.rows),t.writeNumberAttrib("Columns",this.columns),0===this.headOrTail?t.writeFlag("Head"):1===this.headOrTail?t.writeFlag("Tail"):2===this.headOrTail&&t.writeFlag("Both"),t.writeNumberAttrib("TailLength",this.tailLength),t.writeNumberAttrib("Time",this.timeMiddle),t.startBlock("SegmentColor"),t.writeColor("Color",this.segmentColors[0]),t.writeColor("Color",this.segmentColors[1]),t.writeColor("Color",this.segmentColors[2]),t.endBlockComma(),t.writeVectorAttrib("Alpha",this.segmentAlphas),t.writeVectorAttrib("ParticleScaling",this.segmentScaling),t.writeVectorAttrib("LifeSpanUVAnim",this.headIntervals[0]),t.writeVectorAttrib("DecayUVAnim",this.headIntervals[1]),t.writeVectorAttrib("TailUVAnim",this.tailIntervals[0]),t.writeVectorAttrib("TailDecayUVAnim",this.tailIntervals[1]),t.writeNumberAttrib("TextureID",this.textureId),0!==this.replaceableId&&t.writeNumberAttrib("ReplaceableId",this.replaceableId),0!==this.priorityPlane&&t.writeNumberAttrib("PriorityPlane",this.priorityPlane),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 175+super.getByteLength()}}class Xe extends Ve{constructor(){super(...arguments),this.lifeSpan=0,this.emissionRate=0,this.speed=0,this.color=new Float32Array(3),this.alpha=1,this.replaceableId=0,this.path="",this.animationVisiblityGuide=""}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.lifeSpan=t.readFloat32(),this.emissionRate=t.readFloat32(),this.speed=t.readFloat32(),t.readFloat32Array(this.color),this.alpha=t.readFloat32(),this.replaceableId=t.readUint32(),this.path=t.read(260),this.animationVisiblityGuide=t.read(260),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.writeFloat32(this.lifeSpan),t.writeFloat32(this.emissionRate),t.writeFloat32(this.speed),t.writeFloat32Array(this.color),t.writeFloat32(this.alpha),t.writeUint32(this.replaceableId),t.skip(260-t.write(this.path)),t.skip(260-t.write(this.animationVisiblityGuide)),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(const e of super.readGenericBlock(t))if("SortPrimsFarZ"===e)this.flags|=65536;else if("Unshaded"===e)this.flags|=32768;else if("Unfogged"===e)this.flags|=262144;else if("static LifeSpan"===e)this.lifeSpan=t.readFloat();else if("LifeSpan"===e)this.readAnimation(t,"KPPL");else if("static EmissionRate"===e)this.emissionRate=t.readFloat();else if("EmissionRate"===e)this.readAnimation(t,"KPPE");else if("static Speed"===e)this.speed=t.readFloat();else if("Speed"===e)this.readAnimation(t,"KPPS");else if("static Color"===e)t.readVector(this.color);else if("Color"===e)this.readAnimation(t,"KPPC");else if("static Alpha"===e)this.alpha=t.readFloat();else if("Alpha"===e)this.readAnimation(t,"KPPA");else if("Visibility"===e)this.readAnimation(t,"KPPV");else if("ReplaceableId"===e)this.replaceableId=t.readInt();else if("Path"===e)this.path=t.read();else{if("AnimVisibilityGuide"!==e)throw new Error(`Unknown token in ParticleEmitterPopcorn: "${e}"`);this.animationVisiblityGuide=t.read()}}writeMdl(t){t.startObjectBlock("ParticleEmitterPopcorn",this.name),this.writeGenericHeader(t),65536&this.flags&&t.writeFlag("SortPrimsFarZ"),32768&this.flags&&t.writeFlag("Unshaded"),262144&this.flags&&t.writeFlag("Unfogged"),this.writeAnimation(t,"KPPL")||t.writeNumberAttrib("static LifeSpan",this.lifeSpan),this.writeAnimation(t,"KPPE")||t.writeNumberAttrib("static EmissionRate",this.emissionRate),this.writeAnimation(t,"KPPS")||t.writeNumberAttrib("static Speed",this.speed),this.writeAnimation(t,"KPPC")||t.writeVectorAttrib("static Color",this.color),this.writeAnimation(t,"KPPA")||t.writeNumberAttrib("static Alpha",this.alpha),this.writeAnimation(t,"KPPV"),0!==this.replaceableId&&t.writeNumberAttrib("ReplaceableId",this.replaceableId),this.path.length&&t.writeStringAttrib("Path",this.path),this.animationVisiblityGuide.length&&t.writeStringAttrib("AnimVisibilityGuide",this.animationVisiblityGuide),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 556+super.getByteLength()}}class qe extends Ve{constructor(){super(16384),this.heightAbove=0,this.heightBelow=0,this.alpha=0,this.color=new Float32Array(3),this.lifeSpan=0,this.textureSlot=0,this.emissionRate=0,this.rows=0,this.columns=0,this.materialId=0,this.gravity=0}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.heightAbove=t.readFloat32(),this.heightBelow=t.readFloat32(),this.alpha=t.readFloat32(),t.readFloat32Array(this.color),this.lifeSpan=t.readFloat32(),this.textureSlot=t.readUint32(),this.emissionRate=t.readUint32(),this.rows=t.readUint32(),this.columns=t.readUint32(),this.materialId=t.readInt32(),this.gravity=t.readFloat32(),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.writeFloat32(this.heightAbove),t.writeFloat32(this.heightBelow),t.writeFloat32(this.alpha),t.writeFloat32Array(this.color),t.writeFloat32(this.lifeSpan),t.writeUint32(this.textureSlot),t.writeUint32(this.emissionRate),t.writeUint32(this.rows),t.writeUint32(this.columns),t.writeInt32(this.materialId),t.writeFloat32(this.gravity),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(const e of super.readGenericBlock(t))if("static HeightAbove"===e)this.heightAbove=t.readFloat();else if("HeightAbove"===e)this.readAnimation(t,"KRHA");else if("static HeightBelow"===e)this.heightBelow=t.readFloat();else if("HeightBelow"===e)this.readAnimation(t,"KRHB");else if("static Alpha"===e)this.alpha=t.readFloat();else if("Alpha"===e)this.readAnimation(t,"KRAL");else if("static Color"===e)t.readColor(this.color);else if("Color"===e)this.readAnimation(t,"KRCO");else if("static TextureSlot"===e)this.textureSlot=t.readInt();else if("TextureSlot"===e)this.readAnimation(t,"KRTX");else if("Visibility"===e)this.readAnimation(t,"KRVS");else if("EmissionRate"===e)this.emissionRate=t.readInt();else if("LifeSpan"===e)this.lifeSpan=t.readFloat();else if("Gravity"===e)this.gravity=t.readFloat();else if("Rows"===e)this.rows=t.readInt();else if("Columns"===e)this.columns=t.readInt();else{if("MaterialID"!==e)throw new Error(`Unknown token in RibbonEmitter: "${e}"`);this.materialId=t.readInt()}}writeMdl(t){t.startObjectBlock("RibbonEmitter",this.name),this.writeGenericHeader(t),this.writeAnimation(t,"KRHA")||t.writeNumberAttrib("static HeightAbove",this.heightAbove),this.writeAnimation(t,"KRHB")||t.writeNumberAttrib("static HeightBelow",this.heightBelow),this.writeAnimation(t,"KRAL")||t.writeNumberAttrib("static Alpha",this.alpha),this.writeAnimation(t,"KRCO")||t.writeColor("static Color",this.color),this.writeAnimation(t,"KRTX")||t.writeNumberAttrib("static TextureSlot",this.textureSlot),this.writeAnimation(t,"KRVS"),t.writeNumberAttrib("EmissionRate",this.emissionRate),t.writeNumberAttrib("LifeSpan",this.lifeSpan),0!==this.gravity&&t.writeNumberAttrib("Gravity",this.gravity),t.writeNumberAttrib("Rows",this.rows),t.writeNumberAttrib("Columns",this.columns),t.writeNumberAttrib("MaterialID",this.materialId),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 56+super.getByteLength()}}class Ye extends Me{constructor(){super(...arguments),this.name="",this.position=new Float32Array(3),this.fieldOfView=0,this.farClippingPlane=0,this.nearClippingPlane=0,this.targetPosition=new Float32Array(3)}readMdx(t){const e=t.readUint32();this.name=t.read(80),t.readFloat32Array(this.position),this.fieldOfView=t.readFloat32(),this.farClippingPlane=t.readFloat32(),this.nearClippingPlane=t.readFloat32(),t.readFloat32Array(this.targetPosition),this.readAnimations(t,e-120)}writeMdx(t){t.writeUint32(this.getByteLength()),t.skip(80-t.write(this.name)),t.writeFloat32Array(this.position),t.writeFloat32(this.fieldOfView),t.writeFloat32(this.farClippingPlane),t.writeFloat32(this.nearClippingPlane),t.writeFloat32Array(this.targetPosition),this.writeAnimations(t)}readMdl(t){this.name=t.read();for(let e of t.readBlock())if("Position"===e)t.readVector(this.position);else if("Translation"===e)this.readAnimation(t,"KCTR");else if("Rotation"===e)this.readAnimation(t,"KCRL");else if("FieldOfView"===e)this.fieldOfView=t.readFloat();else if("FarClip"===e)this.farClippingPlane=t.readFloat();else if("NearClip"===e)this.nearClippingPlane=t.readFloat();else{if("Target"!==e)throw new Error(`Unknown token in Camera ${this.name}: "${e}"`);for(e of t.readBlock())if("Position"===e)t.readVector(this.targetPosition);else{if("Translation"!==e)throw new Error(`Unknown token in Camera ${this.name}'s Target: "${e}"`);this.readAnimation(t,"KTTR")}}}writeMdl(t){t.startObjectBlock("Camera",this.name),t.writeVectorAttrib("Position",this.position),this.writeAnimation(t,"KCTR"),this.writeAnimation(t,"KCRL"),t.writeNumberAttrib("FieldOfView",this.fieldOfView),t.writeNumberAttrib("FarClip",this.farClippingPlane),t.writeNumberAttrib("NearClip",this.nearClippingPlane),t.startBlock("Target"),t.writeVectorAttrib("Position",this.targetPosition),this.writeAnimation(t,"KTTR"),t.endBlock(),t.endBlock()}getByteLength(){return 120+super.getByteLength()}}class We extends Ve{constructor(){super(1024),this.globalSequenceId=-1,this.tracks=new Uint32Array(0)}readMdx(t){super.readMdx(t),t.skip(4);const e=t.readUint32();this.globalSequenceId=t.readInt32(),this.tracks=t.readUint32Array(e)}writeMdx(t){super.writeMdx(t),t.writeBinary("KEVT"),t.writeUint32(this.tracks.length),t.writeInt32(this.globalSequenceId),t.writeUint32Array(this.tracks)}readMdl(t){for(const e of super.readGenericBlock(t)){if("EventTrack"!==e)throw new Error(`Unknown token in EventObject: "${e}"`);{const e=t.readInt();this.tracks=new Uint32Array(e),t.read(),"GlobalSeqId"===t.peek()&&(t.read(),this.globalSequenceId=t.readInt());for(let i=0;i<e;i++)this.tracks[i]=t.readInt();t.read()}}}writeMdl(t){t.startObjectBlock("EventObject",this.name),this.writeGenericHeader(t),t.startBlock("EventTrack",this.tracks.length),-1!==this.globalSequenceId&&t.writeNumberAttrib("GlobalSeqId",this.globalSequenceId);for(const e of this.tracks)t.writeFlag(`${e}`);t.endBlock(),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 12+this.tracks.byteLength+super.getByteLength()}}class Ze extends Ve{constructor(){super(8192),this.type=0,this.vertices=[new Float32Array(3),new Float32Array(3)],this.boundsRadius=0}readMdx(t){super.readMdx(t),this.type=t.readUint32(),t.readFloat32Array(this.vertices[0]),2!==this.type&&t.readFloat32Array(this.vertices[1]),2!==this.type&&3!==this.type||(this.boundsRadius=t.readFloat32())}writeMdx(t){super.writeMdx(t),t.writeUint32(this.type),t.writeFloat32Array(this.vertices[0]),2!==this.type&&t.writeFloat32Array(this.vertices[1]),2!==this.type&&3!==this.type||t.writeFloat32(this.boundsRadius)}readMdl(t){for(const e of super.readGenericBlock(t))if("Box"===e)this.type=0;else if("Plane"===e)this.type=1;else if("Sphere"===e)this.type=2;else if("Cylinder"===e)this.type=3;else if("Vertices"===e){const e=t.readInt();t.read(),t.readVector(this.vertices[0]),2===e&&t.readVector(this.vertices[1]),t.read()}else{if("BoundsRadius"!==e)throw new Error(`Unknown token in CollisionShape: "${e}"`);this.boundsRadius=t.readFloat()}}writeMdl(t){t.startObjectBlock("CollisionShape",this.name),this.writeGenericHeader(t);let e="",i=2,r=!1;0===this.type?e="Box":1===this.type?e="Plane":2===this.type?(e="Sphere",i=1,r=!0):3===this.type&&(e="Cylinder",r=!0),t.writeFlag(e),t.startBlock("Vertices",i),t.writeVector(this.vertices[0]),2===i&&t.writeVector(this.vertices[1]),t.endBlock(),r&&t.writeNumberAttrib("BoundsRadius",this.boundsRadius),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){let t=16+super.getByteLength();return 2!==this.type&&(t+=12),2!==this.type&&3!==this.type||(t+=4),t}}class Qe{constructor(){this.type="",this.path=""}readMdx(t){this.type=t.read(80),this.path=t.read(260)}writeMdx(t){t.skip(80-t.write(this.type)),t.skip(260-t.write(this.path))}readMdl(t){this.type=t.read();for(const e of t.readBlock()){if("Path"!==e)throw new Error(`Unknown token in FaceEffect: "${e}"`);this.path=t.read()}}writeMdl(t){t.startObjectBlock("FaceFX",this.type),t.writeStringAttrib("Path",this.path),t.endBlock()}}class Je{constructor(t,e,i){this.tag=i,this.chunk=t.readUint8Array(new Uint8Array(e))}writeMdx(t){t.writeBinary(this.tag),t.writeUint32(this.chunk.byteLength),t.writeUint8Array(this.chunk)}getByteLength(){return 8+this.chunk.byteLength}}function ti(t){return t instanceof ArrayBuffer&&(t=new Uint8Array(t)),t instanceof Uint8Array&&77===t[0]&&68===t[1]&&76===t[2]&&88===t[3]}function ei(t){return t instanceof ArrayBuffer&&(t=new Uint8Array(t)),!!(t instanceof Uint8Array&&Wt(t,"FormatVersion",0,4096))||!("string"!=typeof t||!function(t,e,i=0,r=1/0){const n=Math.max(i,0),s=Math.min(n+r,t.length);let a=0,o=e[0];for(let i=n;i<s;i++)if(t[i]===o){if(a+=1,a===e.length)return!0;o=e[a]}else a>0&&(a=0,o=e[0]);return!1}(t,"FormatVersion",0,4096))}class ii{constructor(){this.version=800,this.name="",this.animationFile="",this.extent=new Te,this.blendTime=0,this.sequences=[],this.globalSequences=[],this.materials=[],this.textures=[],this.textureAnimations=[],this.geosets=[],this.geosetAnimations=[],this.bones=[],this.lights=[],this.helpers=[],this.attachments=[],this.pivotPoints=[],this.particleEmitters=[],this.particleEmitters2=[],this.particleEmittersPopcorn=[],this.ribbonEmitters=[],this.cameras=[],this.eventObjects=[],this.collisionShapes=[],this.faceEffects=[],this.bindPose=[],this.unknownChunks=[]}load(t){if(ti(t))this.loadMdx(t);else{if(!ei(t))throw new Error("Not a valid MDX/MDL buffer");"string"==typeof t?this.loadMdl(t):this.loadMdl($t(t))}}loadMdx(t){const e=new Ae(t);let i,r;for(e.skip(4);e.remaining>0;)i=e.readBinary(4),r=e.readUint32(),"VERS"===i?this.loadVersionChunk(e):"MODL"===i?this.loadModelChunk(e):"SEQS"===i?this.loadStaticObjects(this.sequences,Ee,e,r/132):"GLBS"===i?this.loadGlobalSequenceChunk(e,r):"MTLS"===i?this.loadDynamicObjects(this.materials,Fe,e,r):"TEXS"===i?this.loadStaticObjects(this.textures,De,e,r/268):"TXAN"===i?this.loadDynamicObjects(this.textureAnimations,Pe,e,r):"GEOS"===i?this.loadDynamicObjects(this.geosets,Ne,e,r):"GEOA"===i?this.loadDynamicObjects(this.geosetAnimations,Oe,e,r):"BONE"===i?this.loadDynamicObjects(this.bones,Ge,e,r):"LITE"===i?this.loadDynamicObjects(this.lights,ze,e,r):"HELP"===i?this.loadDynamicObjects(this.helpers,je,e,r):"ATCH"===i?this.loadDynamicObjects(this.attachments,Ke,e,r):"PIVT"===i?this.loadPivotPointChunk(e,r):"PREM"===i?this.loadDynamicObjects(this.particleEmitters,He,e,r):"PRE2"===i?this.loadDynamicObjects(this.particleEmitters2,$e,e,r):"CORN"===i?this.loadDynamicObjects(this.particleEmittersPopcorn,Xe,e,r):"RIBB"===i?this.loadDynamicObjects(this.ribbonEmitters,qe,e,r):"CAMS"===i?this.loadDynamicObjects(this.cameras,Ye,e,r):"EVTS"===i?this.loadDynamicObjects(this.eventObjects,We,e,r):"CLID"===i?this.loadDynamicObjects(this.collisionShapes,Ze,e,r):"FAFX"===i?this.loadStaticObjects(this.faceEffects,Qe,e,r/340):"BPOS"===i?this.loadBindPoseChunk(e,r):this.unknownChunks.push(new Je(e,r,i))}loadVersionChunk(t){this.version=t.readUint32()}loadModelChunk(t){this.name=t.read(80),this.animationFile=t.read(260),this.extent.readMdx(t),this.blendTime=t.readUint32()}loadStaticObjects(t,e,i,r){for(let n=0;n<r;n++){const r=new e;r.readMdx(i),t.push(r)}}loadGlobalSequenceChunk(t,e){for(let i=0,r=e/4;i<r;i++)this.globalSequences.push(t.readUint32())}loadDynamicObjects(t,e,i,r){const n=i.index+r;for(;i.index<n;){const r=new e;r.readMdx(i,this.version),t.push(r)}}loadPivotPointChunk(t,e){for(let i=0,r=e/12;i<r;i++)this.pivotPoints.push(t.readFloat32Array(3))}loadBindPoseChunk(t,e){for(let e=0,i=t.readUint32();e<i;e++)this.bindPose[e]=t.readFloat32Array(12)}saveMdx(){const t=new Ae(new ArrayBuffer(this.getByteLength()));t.writeBinary("MDLX"),this.saveVersionChunk(t),this.saveModelChunk(t),this.saveStaticObjectChunk(t,"SEQS",this.sequences,132),this.saveGlobalSequenceChunk(t),this.saveDynamicObjectChunk(t,"MTLS",this.materials),this.saveStaticObjectChunk(t,"TEXS",this.textures,268),this.saveDynamicObjectChunk(t,"TXAN",this.textureAnimations),this.saveDynamicObjectChunk(t,"GEOS",this.geosets),this.saveDynamicObjectChunk(t,"GEOA",this.geosetAnimations),this.saveDynamicObjectChunk(t,"BONE",this.bones),this.saveDynamicObjectChunk(t,"LITE",this.lights),this.saveDynamicObjectChunk(t,"HELP",this.helpers),this.saveDynamicObjectChunk(t,"ATCH",this.attachments),this.savePivotPointChunk(t),this.saveDynamicObjectChunk(t,"PREM",this.particleEmitters),this.saveDynamicObjectChunk(t,"PRE2",this.particleEmitters2),this.version>800&&this.saveDynamicObjectChunk(t,"CORN",this.particleEmittersPopcorn),this.saveDynamicObjectChunk(t,"RIBB",this.ribbonEmitters),this.saveDynamicObjectChunk(t,"CAMS",this.cameras),this.saveDynamicObjectChunk(t,"EVTS",this.eventObjects),this.saveDynamicObjectChunk(t,"CLID",this.collisionShapes),this.version>800&&(this.saveStaticObjectChunk(t,"FAFX",this.faceEffects,340),this.saveBindPoseChunk(t));for(const e of this.unknownChunks)e.writeMdx(t);return t.uint8array}saveVersionChunk(t){t.writeBinary("VERS"),t.writeUint32(4),t.writeUint32(this.version)}saveModelChunk(t){t.writeBinary("MODL"),t.writeUint32(372),t.skip(80-t.write(this.name)),t.skip(260-t.write(this.animationFile)),this.extent.writeMdx(t),t.writeUint32(this.blendTime)}saveStaticObjectChunk(t,e,i,r){if(i.length){t.writeBinary(e),t.writeUint32(i.length*r);for(const e of i)e.writeMdx(t)}}saveGlobalSequenceChunk(t){if(this.globalSequences.length){t.writeBinary("GLBS"),t.writeUint32(4*this.globalSequences.length);for(const e of this.globalSequences)t.writeUint32(e)}}saveDynamicObjectChunk(t,e,i){if(i.length){t.writeBinary(e),t.writeUint32(this.getObjectsByteLength(i));for(const e of i)e.writeMdx(t,this.version)}}savePivotPointChunk(t){if(this.pivotPoints.length){t.writeBinary("PIVT"),t.writeUint32(12*this.pivotPoints.length);for(const e of this.pivotPoints)t.writeFloat32Array(e)}}saveBindPoseChunk(t){if(this.bindPose.length){t.writeBinary("BPOS"),t.writeUint32(4+48*this.bindPose.length),t.writeUint32(this.bindPose.length);for(const e of this.bindPose)t.writeFloat32Array(e)}}loadMdl(t){let e;const i=new xe(t);for(;e=i.readToken();)if("Version"===e)this.loadVersionBlock(i);else if("Model"===e)this.loadModelBlock(i);else if("Sequences"===e)this.loadNumberedObjectBlock(this.sequences,Ee,"Anim",i);else if("GlobalSequences"===e)this.loadGlobalSequenceBlock(i);else if("Textures"===e)this.loadNumberedObjectBlock(this.textures,De,"Bitmap",i);else if("Materials"===e)this.loadNumberedObjectBlock(this.materials,Fe,"Material",i);else if("TextureAnims"===e)this.loadNumberedObjectBlock(this.textureAnimations,Pe,"TVertexAnim",i);else if("Geoset"===e)this.loadObject(this.geosets,Ne,i);else if("GeosetAnim"===e)this.loadObject(this.geosetAnimations,Oe,i);else if("Bone"===e)this.loadObject(this.bones,Ge,i);else if("Light"===e)this.loadObject(this.lights,ze,i);else if("Helper"===e)this.loadObject(this.helpers,je,i);else if("Attachment"===e)this.loadObject(this.attachments,Ke,i);else if("PivotPoints"===e)this.loadPivotPointBlock(i);else if("ParticleEmitter"===e)this.loadObject(this.particleEmitters,He,i);else if("ParticleEmitter2"===e)this.loadObject(this.particleEmitters2,$e,i);else if("ParticleEmitterPopcorn"===e)this.loadObject(this.particleEmittersPopcorn,Xe,i);else if("RibbonEmitter"===e)this.loadObject(this.ribbonEmitters,qe,i);else if("Camera"===e)this.loadObject(this.cameras,Ye,i);else if("EventObject"===e)this.loadObject(this.eventObjects,We,i);else if("CollisionShape"===e)this.loadObject(this.collisionShapes,Ze,i);else if("FaceFX"===e)this.loadObject(this.faceEffects,Qe,i);else{if("BindPose"!==e)throw new Error(`Unsupported block: ${e}`);this.loadBindPoseBlock(i)}}loadVersionBlock(t){for(const e of t.readBlock()){if("FormatVersion"!==e)throw new Error(`Unknown token in Version: "${e}"`);this.version=t.readInt()}}loadModelBlock(t){this.name=t.read();for(const e of t.readBlock())if(e.startsWith("Num"))t.read();else if("BlendTime"===e)this.blendTime=t.readInt();else if("MinimumExtent"===e)t.readVector(this.extent.min);else if("MaximumExtent"===e)t.readVector(this.extent.max);else if("BoundsRadius"===e)this.extent.boundsRadius=t.readFloat();else{if("AnimationFile"!==e)throw new Error(`Unknown token in Model: "${e}"`);this.animationFile=t.read()}}loadNumberedObjectBlock(t,e,i,r){r.read();for(const n of r.readBlock()){if(n!==i)throw new Error(`Unknown token in ${i}: "${n}"`);{const i=new e;i.readMdl(r),t.push(i)}}}loadGlobalSequenceBlock(t){t.read();for(const e of t.readBlock()){if("Duration"!==e)throw new Error(`Unknown token in GlobalSequences: "${e}"`);this.globalSequences.push(t.readInt())}}loadObject(t,e,i){const r=new e;r.readMdl(i),t.push(r)}loadPivotPointBlock(t){const e=t.readInt();t.read();for(let i=0;i<e;i++)this.pivotPoints.push(t.readVector(new Float32Array(3)));t.read()}loadBindPoseBlock(t){for(const e of t.readBlock()){if("Matrices"!==e)throw new Error(`Unknown token in BindPose: "${e}"`);{const e=t.readInt();t.read();for(let i=0;i<e;i++)this.bindPose[i]=t.readVector(new Float32Array(12));t.read()}}}saveMdl(){const t=new xe;return this.saveVersionBlock(t),this.saveModelBlock(t),this.saveStaticObjectsBlock(t,"Sequences",this.sequences),this.saveGlobalSequenceBlock(t),this.saveStaticObjectsBlock(t,"Textures",this.textures),this.saveStaticObjectsBlock(t,"Materials",this.materials),this.saveStaticObjectsBlock(t,"TextureAnims",this.textureAnimations),this.saveObjects(t,this.geosets),this.saveObjects(t,this.geosetAnimations),this.saveObjects(t,this.bones),this.saveObjects(t,this.lights),this.saveObjects(t,this.helpers),this.saveObjects(t,this.attachments),this.savePivotPointBlock(t),this.saveObjects(t,this.particleEmitters),this.saveObjects(t,this.particleEmitters2),this.version>800&&this.saveObjects(t,this.particleEmittersPopcorn),this.saveObjects(t,this.ribbonEmitters),this.saveObjects(t,this.cameras),this.saveObjects(t,this.eventObjects),this.saveObjects(t,this.collisionShapes),this.version>800&&(this.saveObjects(t,this.faceEffects),this.saveBindPoseBlock(t)),t.buffer}saveVersionBlock(t){t.startBlock("Version"),t.writeNumberAttrib("FormatVersion",this.version),t.endBlock()}saveModelBlock(t){t.startObjectBlock("Model",this.name),t.writeNumberAttrib("BlendTime",this.blendTime),this.extent.writeMdl(t),this.animationFile.length&&t.writeStringAttrib("AnimationFile",this.animationFile),t.endBlock()}saveStaticObjectsBlock(t,e,i){if(i.length){t.startBlock(e,i.length);for(const e of i)e.writeMdl(t,this.version);t.endBlock()}}saveGlobalSequenceBlock(t){if(this.globalSequences.length){t.startBlock("GlobalSequences",this.globalSequences.length);for(const e of this.globalSequences)t.writeNumberAttrib("Duration",e);t.endBlock()}}saveObjects(t,e){for(const i of e)i.writeMdl(t,this.version)}savePivotPointBlock(t){if(this.pivotPoints.length){t.startBlock("PivotPoints",this.pivotPoints.length);for(const e of this.pivotPoints)t.writeVector(e);t.endBlock()}}saveBindPoseBlock(t){if(this.bindPose.length){t.startBlock("BindPose"),t.startBlock("Matrices",this.bindPose.length);for(const e of this.bindPose)t.writeVector(e);t.endBlock(),t.endBlock()}}getByteLength(){let t=396;return t+=this.getStaticObjectsChunkByteLength(this.sequences,132),t+=this.getStaticObjectsChunkByteLength(this.globalSequences,4),t+=this.getDynamicObjectsChunkByteLength(this.materials),t+=this.getStaticObjectsChunkByteLength(this.textures,268),t+=this.getDynamicObjectsChunkByteLength(this.textureAnimations),t+=this.getDynamicObjectsChunkByteLength(this.geosets),t+=this.getDynamicObjectsChunkByteLength(this.geosetAnimations),t+=this.getDynamicObjectsChunkByteLength(this.bones),t+=this.getDynamicObjectsChunkByteLength(this.lights),t+=this.getDynamicObjectsChunkByteLength(this.helpers),t+=this.getDynamicObjectsChunkByteLength(this.attachments),t+=this.getStaticObjectsChunkByteLength(this.pivotPoints,12),t+=this.getDynamicObjectsChunkByteLength(this.particleEmitters),t+=this.getDynamicObjectsChunkByteLength(this.particleEmitters2),this.version>800&&(t+=this.getDynamicObjectsChunkByteLength(this.particleEmittersPopcorn)),t+=this.getDynamicObjectsChunkByteLength(this.ribbonEmitters),t+=this.getDynamicObjectsChunkByteLength(this.cameras),t+=this.getDynamicObjectsChunkByteLength(this.eventObjects),t+=this.getDynamicObjectsChunkByteLength(this.collisionShapes),this.version>800&&(t+=this.getStaticObjectsChunkByteLength(this.faceEffects,340),t+=this.getBindPoseChunkByteLength()),t+=this.getObjectsByteLength(this.unknownChunks),t}getObjectsByteLength(t){let e=0;for(const i of t)e+=i.getByteLength(this.version);return e}getDynamicObjectsChunkByteLength(t){return t.length?8+this.getObjectsByteLength(t):0}getStaticObjectsChunkByteLength(t,e){return t.length?8+t.length*e:0}getBindPoseChunkByteLength(){return this.bindPose.length?12+48*this.bindPose.length:0}}class ri{constructor(){this.x=0,this.y=0,this.z=0,this.r=0}fromExtents(t,e){const i=t[0],r=t[1],n=t[2],s=e[0]-i,a=e[1]-r,o=e[2]-n;this.x=i+s/2,this.y=r+a/2,this.z=n+o/2,this.r=Math.max(0,Math.max(s,a,o)/2)}}class ni{constructor(t){this.name=t.name,this.interval=t.interval,this.nonLooping=t.nonLooping,this.rarity=t.rarity,this.bounds=new ri;const e=t.extent;this.bounds.fromExtents(e.min,e.max)}}class si extends Ut{constructor(){super(...arguments),this.bounds=new ri}}class ai{constructor(t,e,i,r,n){this.frames=[],this.values=[],this.inTans=[],this.outTans=[],this.constant=!1,this.sd=t,this.start=e,this.end=i;const s=t.interpolationType,a=r.frames,o=r.values,l=r.inTans,h=r.outTans,c=t.defval;n&&a[0]>i&&(this.frames[0]=a[0],this.values[0]=o[0]);for(let t=0,r=a.length;t<r;t++){const r=a[t];r>=e&&r<=i&&(this.frames.push(r),this.values.push(o[t]),s>1&&(this.inTans.push(l[t]),this.outTans.push(h[t])))}const d=this.frames.length;if(0===d)this.constant=!0,this.frames[0]=e,this.values[0]=c;else if(1===d)this.constant=!0;else{const t=this.values[0];this.constant=this.values.every((e=>t.every(((t,i)=>t===e[i]))))}}getValue(t,e){const i=this.frames.length;if(this.constant||e<this.start)return this.sd.copy(t,this.values[0]),-1;{let r=-1,n=-1;const s=i-1;if(e<this.frames[0]||e>=this.frames[s])r=s,n=0;else for(let t=1;t<i;t++)if(this.frames[t]>e){r=t-1,n=t;break}let a=this.frames[r];const o=this.frames[n];let l=o-a;l<0&&(l+=this.end-this.start,e<a&&(a=o));const h=0==l?0:(e-a)/l;return this.sd.interpolate(t,this.values,this.inTans,this.outTans,r,n,h),r}}}const oi={KLAV:0,KATV:0,KPEV:0,KP2V:0,KRVS:0},li=new Float32Array(1),hi=new Uint32Array(1),ci=new Float32Array([1]),di=g(),ui=U(),fi=w(1,1,1),mi=di,gi={KMTF:li,KMTA:ci,KTAT:di,KTAR:ui,KTAS:fi,KGAO:ci,KGAC:mi,KLAS:li,KLAE:li,KLAC:mi,KLAI:li,KLBI:li,KLBC:mi,KLAV:ci,KATV:ci,KPEE:li,KPEG:li,KPLN:li,KPLT:li,KPEL:li,KPES:li,KPEV:ci,KP2S:li,KP2R:li,KP2L:li,KP2G:li,KP2E:li,KP2N:li,KP2W:li,KP2V:ci,KRHA:li,KRHB:li,KRAL:new Float32Array([0]),KRCO:mi,KRTX:li,KRVS:ci,KCTR:di,KTTR:di,KCRL:hi,KGTR:di,KGRT:ui,KGSC:fi};class pi{constructor(t,e){this.globalSequence=null,this.sequences=[];const i=t.globalSequences,r=e.globalSequenceId,n=oi[e.name];if(this.model=t,this.name=e.name,this.defval=gi[e.name],this.interpolationType=void 0!==n?n:e.interpolationType,-1!==r&&i)this.globalSequence=new ai(this,0,i[r],e,!0);else for(const i of t.sequences){const t=i.interval;this.sequences.push(new ai(this,t[0],t[1],e,!1))}}getValue(t,e,i,r){return this.globalSequence?this.globalSequence.getValue(t,r%this.globalSequence.end):this.sequences[e].getValue(t,i)}isVariant(t){return this.globalSequence?!this.globalSequence.constant:!this.sequences[t].constant}}class wi extends pi{copy(t,e){t[0]=e[0]}interpolate(t,e,i,r,n,s,a){const o=this.interpolationType,l=e[n][0];0===o?t[0]=l:1===o?t[0]=function(t,e,i){return t+i*(e-t)}(l,e[s][0],a):2===o?t[0]=function(t,e,i,r,n){const s=n*n;return t*(s*(2*n-3)+1)+e*(s*(n-2)+n)+i*(s*(n-1))+r*(s*(3-2*n))}(l,r[n][0],i[s][0],e[s][0],a):3===o&&(t[0]=function(t,e,i,r,n){const s=1-n,a=n*n,o=s*s;return t*(o*s)+e*(3*n*o)+i*(3*a*s)+r*(a*n)}(l,r[n][0],i[s][0],e[s][0],a))}}class vi extends pi{copy(t,e){v(t,e)}interpolate(t,e,i,r,n,s,a){const o=this.interpolationType;0===o?v(t,e[n]):1===o?function(t,e,i,r){var n=e[0],s=e[1],a=e[2];t[0]=n+r*(i[0]-n),t[1]=s+r*(i[1]-s),t[2]=a+r*(i[2]-a)}(t,e[n],e[s],a):2===o?function(t,e,i,r,n,s){var a=s*s,o=a*(2*s-3)+1,l=a*(s-2)+s,h=a*(s-1),c=a*(3-2*s);t[0]=e[0]*o+i[0]*l+r[0]*h+n[0]*c,t[1]=e[1]*o+i[1]*l+r[1]*h+n[1]*c,t[2]=e[2]*o+i[2]*l+r[2]*h+n[2]*c}(t,e[n],r[n],i[s],e[s],a):3===o&&function(t,e,i,r,n,s){var a=1-s,o=a*a,l=s*s,h=o*a,c=3*s*o,d=3*l*a,u=l*s;t[0]=e[0]*h+i[0]*c+r[0]*d+n[0]*u,t[1]=e[1]*h+i[1]*c+r[1]*d+n[1]*u,t[2]=e[2]*h+i[2]*c+r[2]*d+n[2]*u}(t,e[n],r[n],i[s],e[s],a)}}class bi extends pi{copy(t,e){Y(t,e)}interpolate(t,e,i,r,n,s,a){const o=this.interpolationType;0===o?Y(t,e[n]):1===o?O(t,e[n],e[s],a):2!==o&&3!==o||Q(t,e[n],r[n],i[s],e[s],a)}}function yi(t,e){return e instanceof Be||e instanceof Ie?new wi(t,e):e instanceof Le?new vi(t,e):new bi(t,e)}class _i{constructor(t,e){this.animations=new Map,this.variants={},this.model=t;for(const i of e.animations)this.animations.set(i.name,yi(t,i))}getScalarValue(t,e,i,r,n,s){if(-1!==i){const s=this.animations.get(e);if(s)return s.getValue(t,i,r,n)}return t[0]=s,-1}getVectorValue(t,e,i,r,n,s){if(-1!==i){const s=this.animations.get(e);if(s)return s.getValue(t,i,r,n)}return t[0]=s[0],t[1]=s[1],t[2]=s[2],-1}getQuatValue(t,e,i,r,n,s){if(-1!==i){const s=this.animations.get(e);if(s)return s.getValue(t,i,r,n)}return t[0]=s[0],t[1]=s[1],t[2]=s[2],t[3]=s[3],-1}addVariants(t,e){const i=this.animations.get(t),r=this.model.sequences.length,n=new Uint8Array(r);if(i)for(let t=0;t<r;t++)i.isVariant(t)&&(n[t]=1);this.variants[e]=n}addVariantIntersection(t,e){const i=this.model.sequences.length,r=new Uint8Array(i);for(let e=0;e<i;e++)for(const i of t)this.variants[i][e]&&(r[e]=1);this.variants[e]=r}}class Ai extends _i{constructor(t,e){super(t,e),this.addVariants("KTAT","translation"),this.addVariants("KTAR","rotation"),this.addVariants("KTAS","scale")}getTranslation(t,e,i,r){return this.getVectorValue(t,"KTAT",e,i,r,at)}getRotation(t,e,i,r){return this.getQuatValue(t,"KTAR",e,i,r,lt)}getScale(t,e,i,r){return this.getVectorValue(t,"KTAS",e,i,r,ot)}}function xi(t,e){return 0===t?[e.SRC_ALPHA,e.ONE_MINUS_SRC_ALPHA]:1===t?[e.SRC_ALPHA,e.ONE]:2===t?[e.ZERO,e.SRC_COLOR]:3===t?[e.DST_COLOR,e.SRC_COLOR]:4===t?[e.SRC_ALPHA,e.ONE_MINUS_SRC_ALPHA]:[0,0]}class Ti extends _i{constructor(t,e,i,r){super(t,e),this.textureId=0,this.blendSrc=0,this.blendDst=0,this.blended=!1,this.textureAnimation=null;let n=e.filterMode;const s=e.textureAnimationId,a=t.viewer.gl;this.index=i,this.priorityPlane=r,n>6&&(n=2),this.filterMode=n,-1!==e.textureId&&(this.textureId=e.textureId),this.coordId=e.coordId,this.alpha=e.alpha;const o=e.flags;if(this.unshaded=1&o,this.sphereEnvironmentMap=2&o,this.twoSided=16&o,this.unfogged=32&o,this.noDepthTest=64&o,this.noDepthSet=128&o,this.depthMaskValue=0===n||1===n,n>1&&(this.blended=!0,[this.blendSrc,this.blendDst]=function(t,e){return 2===t?[e.SRC_ALPHA,e.ONE_MINUS_SRC_ALPHA]:3===t||4===t?[e.SRC_ALPHA,e.ONE]:5===t?[e.ZERO,e.SRC_COLOR]:6===t?[e.DST_COLOR,e.SRC_COLOR]:[0,0]}(n,a)),-1!==s){const e=t.textureAnimations[s];e&&(this.textureAnimation=e)}this.addVariants("KMTA","alpha"),this.addVariants("KMTF","textureId")}bind(t){const e=this.model.viewer.gl;e.uniform1f(t.uniforms.u_filterMode,this.filterMode),this.blended?(e.enable(e.BLEND),e.blendFunc(this.blendSrc,this.blendDst)):e.disable(e.BLEND),this.twoSided?e.disable(e.CULL_FACE):e.enable(e.CULL_FACE),this.noDepthTest?e.disable(e.DEPTH_TEST):e.enable(e.DEPTH_TEST),this.noDepthSet?e.depthMask(!1):e.depthMask(this.depthMaskValue)}getAlpha(t,e,i,r){return this.getScalarValue(t,"KMTA",e,i,r,this.alpha)}getTextureId(t,e,i,r){return this.getScalarValue(t,"KMTF",e,i,r,this.textureId)}}class Ei{constructor(t,e,i){this.model=t,this.shader=e,this.layers=i}}class Si extends _i{constructor(t,e){super(t,e);const i=e.color;this.alpha=e.alpha,this.color=w(i[2],i[1],i[0]),this.geosetId=e.geosetId,this.addVariants("KGAO","alpha"),this.addVariants("KGAC","color")}getAlpha(t,e,i,r){return this.getScalarValue(t,"KGAO",e,i,r,this.alpha)}getColor(t,e,i,r){return this.getVectorValue(t,"KGAC",e,i,r,this.color)}}const Bi={1:"TeamColor/TeamColor00",2:"TeamGlow/TeamGlow00",11:"Cliff/Cliff0",21:"",31:"LordaeronTree/LordaeronSummerTree",32:"AshenvaleTree/AshenTree",33:"BarrensTree/BarrensTree",34:"NorthrendTree/NorthTree",35:"Mushroom/MushroomTree",36:"RuinsTree/RuinsTree",37:"OutlandMushroomTree/MushroomTree"};class Ii extends _i{constructor(t,e,i){super(t,e),this.index=i,this.name=e.name,this.objectId=e.objectId,this.parentId=e.parentId,this.pivot=t.pivotPoints[e.objectId]||g();const r=e.flags;this.dontInheritTranslation=1&r,this.dontInheritRotation=2&r,this.dontInheritScaling=4&r,this.billboarded=8&r,this.billboardedX=16&r,this.billboardedY=32&r,this.billboardedZ=64&r,this.cameraAnchored=128&r,this.anyBillboarding=0!==(this.billboarded||this.billboardedX||this.billboardedY||this.billboardedZ),e.objectId===e.parentId&&(this.parentId=-1),this.addVariants("KGTR","translation"),this.addVariants("KGRT","rotation"),this.addVariants("KGSC","scale"),this.addVariantIntersection(["translation","rotation","scale"],"generic")}getVisibility(t,e,i,r){return t[0]=1,-1}getTranslation(t,e,i,r){return this.getVectorValue(t,"KGTR",e,i,r,at)}getRotation(t,e,i,r){return this.getQuatValue(t,"KGRT",e,i,r,lt)}getScale(t,e,i,r){return this.getVectorValue(t,"KGSC",e,i,r,ot)}}class Li extends Ii{constructor(t,e,i){super(t,e,i),this.geosetAnimation=t.geosetAnimations[e.geosetAnimationId]}getVisibility(t,e,i,r){return this.geosetAnimation?this.geosetAnimation.getAlpha(t,e,i,r):(t[0]=1,-1)}}class Ci extends Ii{constructor(t,e,i){super(t,e,i),this.type=e.type,this.attenuation=e.attenuation,this.color=e.color,this.intensity=e.intensity,this.ambientColor=e.ambientColor,this.ambientIntensity=e.ambientIntensity}getAttenuationStart(t,e,i,r){return this.getScalarValue(t,"KLAS",e,i,r,this.attenuation[0])}getAttenuationEnd(t,e,i,r){return this.getScalarValue(t,"KLAE",e,i,r,this.attenuation[1])}getIntensity(t,e,i,r){return this.getScalarValue(t,"KLAI",e,i,r,this.intensity)}getColor(t,e,i,r){return this.getVectorValue(t,"KLAC",e,i,r,this.color)}getAmbientIntensity(t,e,i,r){return this.getScalarValue(t,"KLBI",e,i,r,this.ambientIntensity)}getAmbientColor(t,e,i,r){return this.getVectorValue(t,"KLBC",e,i,r,this.ambientColor)}}class Ri extends Ii{}class Mi extends Ii{constructor(t,e,i){super(t,e,i),this.internalModel=null;const r=e.path.replace(/\\/g,"/").toLowerCase().replace(".mdl",".mdx");if(this.path=r,this.attachmentId=e.attachmentId,""!==r&&-1!=r.indexOf(".mdx")){const e=t.viewer.load(r,t.pathSolver,t.solverParams);e.then((t=>{t&&(this.internalModel=t)})),t.blockers.push(e)}}getVisibility(t,e,i,r){return this.getScalarValue(t,"KATV",e,i,r,1)}}class Ui extends Ii{constructor(t,e,i){super(t,e,i),this.internalModel=null,this.ok=!1,this.speed=e.speed,this.latitude=e.latitude,this.longitude=e.longitude,this.lifeSpan=e.lifeSpan,this.gravity=e.gravity,this.emissionRate=e.emissionRate,t.viewer.load(e.path.replace(/\\/g,"/").toLowerCase().replace(".mdl",".mdx"),t.pathSolver,t.solverParams).then((t=>{t&&(this.internalModel=t,this.ok=!0)}))}getSpeed(t,e,i,r){return this.getScalarValue(t,"KPES",e,i,r,this.speed)}getLatitude(t,e,i,r){return this.getScalarValue(t,"KPLTV",e,i,r,this.latitude)}getLongitude(t,e,i,r){return this.getScalarValue(t,"KPLN",e,i,r,this.longitude)}getLifeSpan(t,e,i,r){return this.getScalarValue(t,"KPEL",e,i,r,this.lifeSpan)}getGravity(t,e,i,r){return this.getScalarValue(t,"KPEG",e,i,r,this.gravity)}getEmissionRate(t,e,i,r){return this.getScalarValue(t,"KPEE",e,i,r,this.emissionRate)}getVisibility(t,e,i,r){return this.getScalarValue(t,"KPEV",e,i,r,1)}}const ki=g(),Fi=g(),Di=g(),Pi=60,Ni=1e4;function Oi(t,e){const i=t.objects,r=e.floatView;let n=0;for(const t of i){const e=15*n,i=e+0,s=t.vertices;r[i+0]=s[0],r[i+1]=s[1],r[i+2]=s[2],r[i+3]=s[3],r[i+4]=s[4],r[i+5]=s[5],r[i+6]=s[6],r[i+7]=s[7],r[i+8]=s[8],r[i+9]=s[9],r[i+10]=s[10],r[i+11]=s[11],r[e+12]=t.health,n+=1}}function Vi(t,e){let i=t.alive;const r=t.emitterObject.geometryEmitterType;if(1===r&&(i-=1),i>0){const n=t.instance.model.viewer,s=n.buffer,a=n.gl,o=n.webgl.extensions.ANGLE_instanced_arrays,l=i*Pi,h=e.attribs;s.reserve(l),0===r?(function(t,e){const i=t.instance,r=t.objects,n=e.byteView,s=e.floatView,a=t.emitterObject,o=a.modelSpace,l=a.tailLength,h=t.node,c=i.teamColor;let d=0;for(const t of r){const e=d*Pi,i=15*d,r=i+0;let a=t.location;const u=t.scale,f=t.tail;if(0===f)o&&(a=E(ki,a,h.worldMatrix)),s[r+0]=a[0],s[r+1]=a[1],s[r+2]=a[2],s[r+3]=t.facing;else{const e=t.velocity;let i=Fi,n=a;i[0]=n[0]-l*e[0],i[1]=n[1]-l*e[1],i[2]=n[2]-l*e[2],o&&(i=E(i,i,h.worldMatrix),n=E(Di,n,h.worldMatrix)),s[r+0]=i[0],s[r+1]=i[1],s[r+2]=i[2],s[r+3]=n[0],s[r+4]=n[1],s[r+5]=n[2]}s[r+6]=u[0],s[r+7]=u[0],s[r+8]=u[0],s[i+12]=t.health,n[e+56]=f,n[e+57]=c,d+=1}}(t,s),function(t,e){const i=t.instance,r=i.textureOverrides,n=i.scene.camera,s=t.emitterObject,a=s.model,o=a.viewer,l=o.gl,h=o.sharedCache.get("mdx"),c=e.uniforms,d=s.colors,u=s.intervals,f=s.replaceableId;let m,g=s.internalTexture;l.blendFunc(s.blendSrc,s.blendDst),l.uniform1f(c.u_filterMode,s.filterMode),g=s.internalTexture?s.internalTexture:1===f?h.teamColors[i.teamColor]:2===f?h.teamGlows[i.teamColor]:a.textures[s.textureId];let p=r.get(1e3+s.index);p||(0===f&&(p=r.get(s.textureId)),p||(p=g.texture)),o.webgl.bindTextureAndWrap(p,0,g.wrapS,g.wrapT),m=s.xYQuad?n.vectors:n.billboardedVectors,l.uniform1f(c.u_lifeSpan,s.lifeSpan),l.uniform1f(c.u_timeMiddle,s.timeMiddle),l.uniform1f(c.u_columns,s.columns),l.uniform1f(c.u_rows,s.rows),l.uniform1f(c.u_teamColored,s.teamColored),l.uniform3fv(c["u_intervals[0]"],u[0]),l.uniform3fv(c["u_intervals[1]"],u[1]),l.uniform3fv(c["u_intervals[2]"],u[2]),l.uniform3fv(c["u_intervals[3]"],u[3]),l.uniform4fv(c["u_colors[0]"],d[0]),l.uniform4fv(c["u_colors[1]"],d[1]),l.uniform4fv(c["u_colors[2]"],d[2]),l.uniform3fv(c.u_scaling,s.scaling),s.head&&(l.uniform3fv(c["u_vertices[0]"],m[0]),l.uniform3fv(c["u_vertices[1]"],m[1]),l.uniform3fv(c["u_vertices[2]"],m[2]),l.uniform3fv(c["u_vertices[3]"],m[3])),s.tail&&l.uniform3fv(c.u_cameraZ,n.directionZ)}(t,e)):1===r?(function(t,e){let i=t.first;const r=e.byteView,n=e.floatView,s=t.emitterObject.columns,a=1/(t.alive-1);let o=0;for(;i.next;){const t=i.next.vertices,e=o*Pi,l=15*o+0,h=e+52,c=e+57,d=(i.slot%s+(1-o*a-a))/s,u=i.slot/s,f=d+a,m=i.vertices,g=i.color;n[l+0]=m[0],n[l+1]=m[1],n[l+2]=m[2],n[l+3]=m[3],n[l+4]=m[4],n[l+5]=m[5],n[l+6]=t[3],n[l+7]=t[4],n[l+8]=t[5],n[l+9]=t[0],n[l+10]=t[1],n[l+11]=t[2],r[h+0]=g[0],r[h+1]=g[1],r[h+2]=g[2],r[h+3]=g[3],r[c+0]=255*d,r[c+1]=255*f,r[c+2]=255*u,i=i.next,o+=1}}(t,s),function(t,e){const i=t.instance.textureOverrides,r=t.emitterObject,n=r.layer,s=r.model,a=s.viewer.gl,o=e.uniforms,l=s.textures[n.textureId],h=i.get(n.textureId)||l.texture;n.bind(e),a.uniform1f(o.u_filterMode,n.filterMode),s.viewer.webgl.bindTextureAndWrap(h,0,l.wrapS,l.wrapT),a.uniform1f(o.u_columns,r.columns),a.uniform1f(o.u_rows,r.rows)}(t,e)):2===r?(Oi(t,s),function(t,e){const i=t.instance.textureOverrides,r=t.emitterObject,n=r.intervalTimes,s=r.intervals,a=r.colors,o=r.model,l=o.viewer.gl,h=e.uniforms,c=r.internalTexture,d=i.get(Ni+r.index)||c.texture;l.blendFunc(r.blendSrc,r.blendDst),o.viewer.webgl.bindTextureAndWrap(d,0,c.wrapS,c.wrapT),l.uniform1f(h.u_lifeSpan,r.lifeSpan),l.uniform1f(h.u_columns,r.columns),l.uniform1f(h.u_rows,r.rows),l.uniform3f(h.u_intervalTimes,n[0],n[1],0),l.uniform3fv(h["u_intervals[0]"],s[0]),l.uniform3fv(h["u_intervals[1]"],s[1]),l.uniform4fv(h["u_colors[0]"],a[0]),l.uniform4fv(h["u_colors[1]"],a[1]),l.uniform4fv(h["u_colors[2]"],a[2])}(t,e)):(Oi(t,s),function(t,e){const i=t.instance.textureOverrides,r=t.emitterObject,n=r.intervalTimes,s=r.colors,a=r.model,o=a.viewer.gl,l=e.uniforms,h=r.internalTexture,c=i.get(Ni+r.index)||h.texture;o.blendFunc(r.blendSrc,r.blendDst),a.viewer.webgl.bindTextureAndWrap(c,0,h.wrapS,h.wrapT),o.uniform1f(l.u_lifeSpan,r.lifeSpan),o.uniform1f(l.u_columns,r.columns),o.uniform1f(l.u_rows,r.rows),o.uniform3fv(l.u_intervalTimes,n),o.uniform4fv(l["u_colors[0]"],s[0]),o.uniform4fv(l["u_colors[1]"],s[1]),o.uniform4fv(l["u_colors[2]"],s[2])}(t,e)),s.bindAndUpdate(l),a.uniform1i(e.uniforms.u_emitter,r),a.vertexAttribPointer(h.a_p0,3,a.FLOAT,!1,Pi,0),a.vertexAttribPointer(h.a_p1,3,a.FLOAT,!1,Pi,12),a.vertexAttribPointer(h.a_p2,3,a.FLOAT,!1,Pi,24),a.vertexAttribPointer(h.a_p3,3,a.FLOAT,!1,Pi,36),a.vertexAttribPointer(h.a_health,1,a.FLOAT,!1,Pi,48),a.vertexAttribPointer(h.a_color,4,a.UNSIGNED_BYTE,!0,Pi,52),a.vertexAttribPointer(h.a_tail,1,a.UNSIGNED_BYTE,!1,Pi,56),a.vertexAttribPointer(h.a_leftRightTop,3,a.UNSIGNED_BYTE,!1,Pi,57),o.drawArraysInstancedANGLE(a.TRIANGLES,0,6,i)}}class Gi{constructor(t,e){this.texture=null,this.wrapS=33071,this.wrapT=33071,this.replaceableId=t,1&e&&(this.wrapS=10497),2&e&&(this.wrapT=10497)}}class zi extends Ii{constructor(t,e,i){super(t,e,i),this.geometryEmitterType=0,this.teamColored=0,this.internalTexture=null,this.colors=[],this.ok=!0,this.width=e.width,this.length=e.length,this.speed=e.speed,this.latitude=e.latitude,this.gravity=e.gravity,this.emissionRate=2*e.emissionRate,this.squirt=e.squirt,this.lifeSpan=e.lifeSpan,this.variation=e.variation,this.tailLength=e.tailLength,this.timeMiddle=e.timeMiddle;const r=e.flags;this.lineEmitter=131072&r,this.unfogged=262144&r,this.modelSpace=524288&r,this.xYQuad=1048576&r;const n=e.replaceableId;if(this.columns=e.columns,this.rows=e.rows,1===n||2===n)this.teamColored=1;else if(n>2){const e=t.reforged?".dds":".blp";this.internalTexture=new Gi(n,0),t.viewer.load(`ReplaceableTextures\\${Bi[n]}${e}`,t.pathSolver,t.solverParams).then((t=>{t&&(this.internalTexture.texture=t)}))}this.replaceableId=e.replaceableId,this.textureId=e.textureId;const s=e.headOrTail;this.head=0===s||2===s,this.tail=1===s||2===s,this.cellWidth=1/e.columns,this.cellHeight=1/e.rows;const a=e.segmentColors,o=e.segmentAlphas;for(let t=0;t<3;t++){const e=a[t];this.colors[t]=new Float32Array([e[0],e[1],e[2],o[t]/255])}this.scaling=e.segmentScaling;const l=e.headIntervals,h=e.tailIntervals;this.intervals=[new Float32Array(l[0]),new Float32Array(l[1]),new Float32Array(h[0]),new Float32Array(h[1])];const c=xi(e.filterMode,this.model.viewer.gl);this.filterMode=e.filterMode,this.blendSrc=c[0],this.blendDst=c[1],this.priorityPlane=e.priorityPlane}getWidth(t,e,i,r){return this.getScalarValue(t,"KP2N",e,i,r,this.width)}getLength(t,e,i,r){return this.getScalarValue(t,"KP2W",e,i,r,this.length)}getSpeed(t,e,i,r){return this.getScalarValue(t,"KP2S",e,i,r,this.speed)}getLatitude(t,e,i,r){return this.getScalarValue(t,"KP2L",e,i,r,this.latitude)}getGravity(t,e,i,r){return this.getScalarValue(t,"KP2G",e,i,r,this.gravity)}getEmissionRate(t,e,i,r){return this.getScalarValue(t,"KP2E",e,i,r,this.emissionRate)}getVariation(t,e,i,r){return this.getScalarValue(t,"KP2R",e,i,r,this.variation)}getVisibility(t,e,i,r){return this.getScalarValue(t,"KP2V",e,i,r,1)}}class ji extends Ii{constructor(t,e,i){super(t,e,i),this.geometryEmitterType=1,this.ok=!0,this.layer=t.materials[e.materialId].layers[0],this.heightAbove=e.heightAbove,this.heightBelow=e.heightBelow,this.alpha=e.alpha,this.color=e.color,this.lifeSpan=e.lifeSpan,this.textureSlot=e.textureSlot,this.emissionRate=2*e.emissionRate,this.gravity=e.gravity,this.columns=e.columns,this.rows=e.rows}getHeightBelow(t,e,i,r){return this.getScalarValue(t,"KRHB",e,i,r,this.heightBelow)}getHeightAbove(t,e,i,r){return this.getScalarValue(t,"KRHA",e,i,r,this.heightAbove)}getTextureSlot(t,e,i,r){return this.getScalarValue(t,"KRTX",e,i,r,0)}getColor(t,e,i,r){return this.getVectorValue(t,"KRCO",e,i,r,this.color)}getAlpha(t,e,i,r){return this.getScalarValue(t,"KRAL",e,i,r,this.alpha)}getVisibility(t,e,i,r){const n=this.getAlpha(t,e,i,r);return 0===t[0]?n:this.getScalarValue(t,"KRVS",e,i,r,1)}}class Ki extends _i{constructor(t,e){super(t,e),this.name=e.name,this.position=e.position,this.fieldOfView=e.fieldOfView,this.farClippingPlane=e.farClippingPlane,this.nearClippingPlane=e.nearClippingPlane,this.targetPosition=e.targetPosition}getTranslation(t,e,i,r){return this.getVectorValue(t,"KCTR",e,i,r,at)}getTargetTranslation(t,e,i,r){return this.getVectorValue(t,"KTTR",e,i,r,at)}getRotation(t,e,i,r){return this.getScalarValue(t,"KCRL",e,i,r,0)}}class Hi extends Ii{constructor(t,e,i){super(t,e,i),this.geometryEmitterType=-1,this.globalSequence=-1,this.defval=new Uint32Array(1),this.internalModel=null,this.internalTexture=null,this.colors=[],this.intervalTimes=new Float32Array(3),this.scale=0,this.columns=0,this.rows=0,this.lifeSpan=0,this.blendSrc=0,this.blendDst=0,this.intervals=[],this.distanceCutoff=0,this.maxDistance=0,this.minDistance=0,this.pitch=0,this.pitchVariance=0,this.volume=0,this.decodedBuffers=[],this.ok=!1;const r=t.viewer,n=e.name;let s=n.substring(0,3);const a=n.substring(4);"FPT"===s&&(s="SPL"),"SPL"===s?this.geometryEmitterType=2:"UBR"===s&&(this.geometryEmitterType=3),this.type=s,this.id=a,this.tracks=e.tracks;const o=e.globalSequenceId;if(-1!==o&&(this.globalSequence=t.globalSequences[o]),"SND"===s&&!r.audioEnabled)return;const l=r.promise();gn.getEventObjectData(r,s,a,t.hd).then((t=>{if(l(),t){const{row:e,resources:i}=t;if(this.ok=!0,"SPN"===s)this.internalModel=i[0];else if("SPL"===s||"UBR"===s){this.internalTexture=new Gi(0,3),this.internalTexture.texture=i[0],this.scale=e.Scale,this.colors[0]=new Float32Array([e.StartR,e.StartG,e.StartB,e.StartA]),this.colors[1]=new Float32Array([e.MiddleR,e.MiddleG,e.MiddleB,e.MiddleA]),this.colors[2]=new Float32Array([e.EndR,e.EndG,e.EndB,e.EndA]),"SPL"===s?(this.columns=e.Columns,this.rows=e.Rows,this.lifeSpan=e.Lifespan+e.Decay,this.intervalTimes[0]=e.Lifespan,this.intervalTimes[1]=e.Decay,this.intervals[0]=new Float32Array([e.UVLifespanStart,e.UVLifespanEnd,e.LifespanRepeat]),this.intervals[1]=new Float32Array([e.UVDecayStart,e.UVDecayEnd,e.DecayRepeat])):(this.columns=1,this.rows=1,this.lifeSpan=e.BirthTime+e.PauseTime+e.Decay,this.intervalTimes[0]=e.BirthTime,this.intervalTimes[1]=e.PauseTime,this.intervalTimes[2]=e.Decay);const t=xi(e.BlendMode,r.gl);this.blendSrc=t[0],this.blendDst=t[1]}else{this.distanceCutoff=e.DistanceCutoff,this.maxDistance=e.MaxDistance,this.minDistance=e.MinDistance,this.pitch=e.Pitch,this.pitchVariance=e.PitchVariance,this.volume=e.Volume;for(const t of i)this.decodedBuffers.push(t.data)}}}))}getValue(t,e){if(-1!==this.globalSequence){const i=this.globalSequence;return this.getValueAtTime(t,e.counter%i,0,i)}if(-1!==e.sequence){const i=this.model.sequences[e.sequence].interval;return this.getValueAtTime(t,e.frame,i[0],i[1])}return t[0]=this.defval[0],-1}getValueAtTime(t,e,i,r){const n=this.tracks;if(e>=i&&e<=r)for(let r=n.length-1;r>-1;r--){if(n[r]<i)return t[0]=0,r;if(n[r]<=e)return t[0]=1,r}return t[0]=0,-1}}class $i extends Ii{}var Xi;!function(t){t[t.VertexGroups=0]="VertexGroups",t[t.ExtendedVertexGroups=1]="ExtendedVertexGroups",t[t.Skin=2]="Skin"}(Xi||(Xi={}));class qi{constructor(t,e,i,r,n){let s,a;n?(s=i,a=s.layers[0]):(s=null,a=i),this.index=t,this.geoset=e,this.skinningType=r,this.isHd=n,this.layer=a,this.material=s}}class Yi{constructor(t,e,i,r,n,s,a,o,l,h,c){this.geosetAnimation=null,this.model=t,this.index=e,this.positionOffset=i,this.normalOffset=r,this.uvOffset=n,this.tangentOffset=s,this.skinOffset=a,this.faceOffset=o,this.vertices=l,this.elements=h,this.faceType=c;for(const i of t.geosetAnimations)i.geosetId===e&&(this.geosetAnimation=i)}bindShared(t,e,i){t.vertexAttribPointer(e.a_position,3,t.FLOAT,!1,0,this.positionOffset),t.vertexAttribPointer(e.a_normal,3,t.FLOAT,!1,0,this.normalOffset),t.vertexAttribPointer(e.a_uv,2,t.FLOAT,!1,0,this.uvOffset+i*this.vertices*8)}bindVertexGroups(t,e){const i=this.model,r=i.skinDataType,n=i.bytesPerSkinElement;t.vertexAttribPointer(e.a_bones,4,r,!1,5*n,this.skinOffset),t.vertexAttribPointer(e.a_boneNumber,1,r,!1,5*n,this.skinOffset+4*n)}bindVertexGroupsExtended(t,e){const i=this.model,r=i.skinDataType,n=i.bytesPerSkinElement;t.vertexAttribPointer(e.a_bones,4,r,!1,9*n,this.skinOffset),t.vertexAttribPointer(e.a_extendedBones,4,r,!1,9*n,this.skinOffset+4*n),t.vertexAttribPointer(e.a_boneNumber,1,r,!1,9*n,this.skinOffset+8*n)}bindSkin(t,e){t.vertexAttribPointer(e.a_bones,4,t.UNSIGNED_BYTE,!1,8,this.skinOffset),t.vertexAttribPointer(e.a_weights,4,t.UNSIGNED_BYTE,!0,8,this.skinOffset+4)}bind(t,e){const i=this.model.viewer.gl,r=t.attribs;this.bindShared(i,r,e),this.bindVertexGroups(i,r)}bindExtended(t,e){const i=this.model.viewer.gl,r=t.attribs;this.bindShared(i,r,e),this.bindVertexGroupsExtended(i,r)}bindHd(t,e,i){const r=this.model.viewer.gl,n=t.attribs;this.bindShared(r,n,i),r.vertexAttribPointer(n.a_tangent,4,r.FLOAT,!1,0,this.tangentOffset),e===Xi.Skin?this.bindSkin(r,n):e===Xi.VertexGroups?this.bindVertexGroupsExtended(r,n):this.bindVertexGroups(r,n)}render(){const t=this.model.viewer.gl;t.drawElements(this.faceType,this.elements,t.UNSIGNED_SHORT,this.faceOffset)}}class Wi{constructor(t,e,i){this.objects=[],this.model=t,this.skinningType=e,this.isHd=i}render(t){const e=t.scene,i=e.camera,r=t.textureOverrides,n=t.layerAlphas,s=this.model,a=s.textures,o=s.batches,l=s.viewer,h=l.sharedCache.get("mdx"),c=l.gl,d=l.webgl,u=this.skinningType,f=this.isHd,m=h.teamColors,g=h.teamGlows,p=gn.getBatchShader(l,u,f);p.use();const w=p.uniforms;c.uniformMatrix4fv(w.u_VP,!1,i.viewProjectionMatrix);const v=t.boneTexture;if(v?(v.bind(15),c.uniform1f(w.u_hasBones,1),c.uniform1i(w.u_boneMap,15),c.uniform1f(w.u_vectorSize,1/v.width),c.uniform1f(w.u_rowSize,1)):c.uniform1f(w.u_hasBones,0),c.uniform3fv(w.u_lightPos,e.lightPosition),c.bindBuffer(c.ARRAY_BUFFER,s.arrayBuffer),c.bindBuffer(c.ELEMENT_ARRAY_BUFFER,s.elementBuffer),f){c.uniform1i(w.u_diffuseMap,0),c.uniform1i(w.u_normalsMap,1),c.uniform1i(w.u_ormMap,2),c.uniform1i(w.u_emissiveMap,3),c.uniform1i(w.u_teamColorMap,4),c.uniform1i(w.u_environmentMap,5),c.disable(c.BLEND),c.enable(c.DEPTH_TEST),c.depthMask(!0),c.uniformMatrix4fv(w.u_MV,!1,i.viewMatrix),c.uniform3fv(w.u_eyePos,i.location);for(const e of this.objects){const i=o[e],s=i.geoset,l=i.material,[h,u,f,g,v,b]=l.layers,y=n[h.index];if(y>0){c.uniform1f(w.u_layerAlpha,y),c.uniform1f(w.u_filterMode,h.filterMode);const e=h.textureId,n=u.textureId,o=f.textureId,l=g.textureId,_=v.textureId,A=b.textureId,x=a[e],T=a[n],E=a[o],S=a[l];let B=a[_];const I=a[A];0!==B.replaceableId&&1!==B.replaceableId||(B=m[t.teamColor]);const L=r.get(e)||x.texture,C=r.get(n)||T.texture,R=r.get(o)||E.texture,M=r.get(l)||S.texture,U=r.get(_)||B.texture,k=r.get(A)||I.texture;d.bindTextureAndWrap(L,0,x.wrapS,x.wrapT),d.bindTextureAndWrap(C,1,T.wrapS,T.wrapT),d.bindTextureAndWrap(R,2,E.wrapS,E.wrapT),d.bindTextureAndWrap(M,3,S.wrapS,S.wrapT),d.bindTextureAndWrap(U,4,B.wrapS,B.wrapT),d.bindTextureAndWrap(k,5,I.wrapS,I.wrapT),s.bindHd(p,i.skinningType,h.coordId),s.render()}}}else{const e=t.geosetColors,i=t.layerTextures,s=t.uvAnims;c.uniform4fv(w.u_vertexColor,t.vertexColor),c.uniform1i(w.u_texture,0);for(const l of this.objects){const h=o[l],f=h.geoset,v=h.layer,b=f.index,y=v.index,_=e[b],A=n[y];if(_[3]>.01&&A>.01){const e=i[y],n=a[e],o=s[y];c.uniform4fv(w.u_geosetColor,_),c.uniform1f(w.u_layerAlpha,A),c.uniform1f(w.u_unshaded,v.unshaded),c.uniform2f(w.u_uvTrans,o[0],o[1]),c.uniform2f(w.u_uvRot,o[2],o[3]),c.uniform1f(w.u_uvScale,o[4]),v.bind(p);let l=r.get(e);if(!l){const e=n.replaceableId;let i;i=1===e?m[t.teamColor]:2===e?g[t.teamColor]:n,i&&(l=i.texture)}d.bindTextureAndWrap(l,0,n.wrapS,n.wrapT),u===Xi.ExtendedVertexGroups?f.bindExtended(p,v.coordId):f.bind(p,v.coordId),f.render()}}}}}class Zi{constructor(t){this.objects=[],this.model=t}render(t){const e=t.scene,i=t.nodes,r=t.model.viewer,n=r.gl,s=r.webgl.extensions.ANGLE_instanced_arrays,a=r.sharedCache.get("mdx"),o=a.particlesShader,l=o.uniforms,h=o.attribs,c=a.rectBuffer;n.depthMask(!1),n.enable(n.BLEND),n.disable(n.CULL_FACE),n.enable(n.DEPTH_TEST),o.use(),n.uniformMatrix4fv(l.u_VP,!1,e.camera.viewProjectionMatrix),n.uniform1i(l.u_texture,0),s.vertexAttribDivisorANGLE(h.a_position,0),n.bindBuffer(n.ARRAY_BUFFER,c),n.vertexAttribPointer(h.a_position,1,n.UNSIGNED_BYTE,!1,0,0),s.vertexAttribDivisorANGLE(h.a_p0,1),s.vertexAttribDivisorANGLE(h.a_p1,1),s.vertexAttribDivisorANGLE(h.a_p2,1),s.vertexAttribDivisorANGLE(h.a_p3,1),s.vertexAttribDivisorANGLE(h.a_health,1),s.vertexAttribDivisorANGLE(h.a_color,1),s.vertexAttribDivisorANGLE(h.a_tail,1),s.vertexAttribDivisorANGLE(h.a_leftRightTop,1);for(const t of this.objects)Vi(i[t].object,o);s.vertexAttribDivisorANGLE(h.a_leftRightTop,0),s.vertexAttribDivisorANGLE(h.a_tail,0),s.vertexAttribDivisorANGLE(h.a_color,0),s.vertexAttribDivisorANGLE(h.a_health,0),s.vertexAttribDivisorANGLE(h.a_p3,0),s.vertexAttribDivisorANGLE(h.a_p2,0),s.vertexAttribDivisorANGLE(h.a_p1,0),s.vertexAttribDivisorANGLE(h.a_p0,0)}}function Qi(t){return t instanceof qi||t instanceof ji?t.layer.priorityPlane:t instanceof zi?t.priorityPlane:0}function Ji(t,e){return t instanceof Wi?e instanceof qi&&e.skinningType===t.skinningType&&e.isHd===t.isHd:e instanceof Ii}function tr(t,e){return e instanceof qi?new Wi(t,e.skinningType,e.isHd):new Zi(t)}const er=g(),ir=U(),rr=g();const nr=U(),sr=g(),ar=g(),or=U();class lr{constructor(t,e,i,r,n,s,a,o,l,h,c,d){this.dontInheritTranslation=!1,this.dontInheritRotation=!1,this.dontInheritScaling=!1,this.billboarded=!1,this.billboardedX=!1,this.billboardedY=!1,this.billboardedZ=!1,this.dirty=!0,this.wasDirty=!1,this.parent=null,this.children=[],this.object=null,this.pivot=t,this.localLocation=e,this.localRotation=i,this.localScale=r,this.worldLocation=n,this.worldRotation=s,this.worldScale=a,this.inverseWorldLocation=o,this.inverseWorldRotation=l,this.inverseWorldScale=h,this.localMatrix=c,this.worldMatrix=d,this.localRotation[3]=1,this.localScale.fill(1),this.localMatrix[0]=1,this.localMatrix[5]=1,this.localMatrix[10]=1,this.localMatrix[15]=1}recalculateTransformation(t){const e=this.localMatrix,i=this.localRotation,r=this.localScale,n=this.worldMatrix,s=this.worldLocation,a=this.worldRotation,o=this.worldScale,l=this.pivot,h=this.inverseWorldLocation,c=this.inverseWorldRotation,d=this.inverseWorldScale,u=this.parent;let f,m;if(this.dontInheritScaling){m=sr;const t=u.inverseWorldScale;m[0]=t[0]*r[0],m[1]=t[1]*r[1],m[2]=t[2]*r[2],o[0]=r[0],o[1]=r[1],o[2]=r[2]}else{m=r;const t=u.worldScale;o[0]=t[0]*r[0],o[1]=t[1]*r[1],o[2]=t[2]*r[2]}if(this.billboarded)f=nr,Y(f,u.inverseWorldRotation),W(f,f,t.camera.inverseRotation),this.convertBasis(f),W(f,f,i);else{const{billboardedX:e,billboardedY:n,billboardedZ:s}=this;e||n||s?(e&&(m===r&&(m=sr,v(m,r)),m[2]*=-1),or[0]=-i[0],or[1]=-i[1],or[2]=-i[2],W(or,or,u.inverseWorldRotation),S(ar,t.camera.billboardedVectors[6],or),e?F(or,rt,Math.atan2(ar[2],ar[1])):n?F(or,nt,Math.atan2(-ar[2],ar[0])):F(or,st,Math.atan2(ar[1],ar[0])),f=nr,W(f,i,or)):f=i}!function(t,e,i,r,n){var s=e[0],a=e[1],o=e[2],l=e[3],h=s+s,c=a+a,d=o+o,u=s*h,f=s*c,m=s*d,g=a*c,p=a*d,w=o*d,v=l*h,b=l*c,y=l*d,_=r[0],A=r[1],x=r[2],T=n[0],E=n[1],S=n[2],B=(1-(g+w))*_,I=(f+y)*_,L=(m-b)*_,C=(f-y)*A,R=(1-(u+w))*A,M=(p+v)*A,U=(m+b)*x,k=(p-v)*x,F=(1-(u+g))*x;t[0]=B,t[1]=I,t[2]=L,t[3]=0,t[4]=C,t[5]=R,t[6]=M,t[7]=0,t[8]=U,t[9]=k,t[10]=F,t[11]=0,t[12]=i[0]+T-(B*T+C*E+U*S),t[13]=i[1]+E-(I*T+R*E+k*S),t[14]=i[2]+S-(L*T+M*E+F*S),t[15]=1}(e,f,this.localLocation,m,l),it(n,u.worldMatrix,e),W(a,u.worldRotation,f),c[0]=-a[0],c[1]=-a[1],c[2]=-a[2],c[3]=a[3],d[0]=1/o[0],d[1]=1/o[1],d[2]=1/o[2];const g=l[0],p=l[1],w=l[2];s[0]=n[0]*g+n[4]*p+n[8]*w+n[12],s[1]=n[1]*g+n[5]*p+n[9]*w+n[13],s[2]=n[2]*g+n[6]*p+n[10]*w+n[14],h[0]=-s[0],h[1]=-s[1],h[2]=-s[2]}convertBasis(t){}}class hr extends lr{convertBasis(t){P(t,t,-Math.PI/2),D(t,t,-Math.PI/2)}}const cr=new Float32Array(1);class dr{constructor(t,e){const i=e.internalModel.addInstance();i.setSequenceLoopMode(2),i.dontInheritScaling=!1,i.hide(),i.setParent(t.nodes[e.objectId]),this.instance=t,this.attachment=e,this.internalInstance=i}update(){const t=this.instance,e=this.internalInstance;t.scene&&-1!==t.sequence&&(this.attachment.getVisibility(cr,t.sequence,t.frame,t.counter),cr[0]>.1?(t.scene.addInstance(e),e.hidden()&&(e.show(),e.setSequence(0))):e.hide())}}class ur extends class{constructor(t){this.objects=[],this.alive=0,this.currentEmission=0,this.instance=t}update(t){this.updateEmission(t);const e=this.currentEmission;if(e>=1)for(let t=0;t<e;t+=1)this.emit()}clear(){const t=this.objects;for(let e=0,i=this.alive;e<i;e++){t[e].health=0}this.currentEmission=0}emitObject(t){const e=this.objects;this.alive===e.length&&e.push(this.createObject());const i=e[this.alive];i.index=this.alive,i.bind(t),this.alive+=1,this.currentEmission-=1;return this.instance.scene.emittedObjectUpdater.add(i),i}kill(t){const e=this.objects;this.alive-=1;const i=e[this.alive];e[t.index]=i,e[this.alive]=t,i.index=t.index,t.index=-1}}{constructor(t,e){super(t),this.emitterObject=e}update(t){this.emitterObject.ok&&super.update(t)}}class fr{constructor(t){this.index=-1,this.health=0,this.emitter=t}}const mr=U(),gr=g(),pr=new Float32Array(1),wr=new Float32Array(1),vr=new Float32Array(1),br=new Float32Array(1);class yr extends fr{constructor(t){super(t),this.velocity=g(),this.gravity=0;const e=t.emitterObject.internalModel;this.internalInstance=e.addInstance()}bind(){const t=this.emitter,e=t.instance,i=e.sequence,r=e.frame,n=e.counter,s=e.scene,a=t.emitterObject,o=e.nodes[a.index],l=this.internalInstance,h=o.worldScale,c=this.velocity;a.getLatitude(pr,i,r,n),a.getLifeSpan(wr,i,r,n),a.getGravity(vr,i,r,n),a.getSpeed(br,i,r,n),this.health=wr[0],this.gravity=vr[0]*h[2],k(mr),N(mr,mr,Rt(-Math.PI,Math.PI)),P(mr,mr,Rt(-pr[0],pr[0])),S(c,st,mr),S(c,c,o.worldRotation),_(c,c,br[0]),L(c,c,h),l.setScene(s),l.setSequence(0),l.setTransformation(o.worldLocation,F(mr,st,Rt(0,2*Math.PI)),o.worldScale),l.show()}update(t){const e=this.internalInstance;if(this.health-=t,this.health>0){const i=this.velocity;i[2]-=this.gravity*t,e.move(_(gr,i,t))}else e.hide()}}const _r=new Float32Array(1);class Ar extends ur{updateEmission(t){const e=this.instance;if(e.allowParticleSpawn){this.emitterObject.getEmissionRate(_r,e.sequence,e.frame,e.counter),this.currentEmission+=_r[0]*t}}emit(){this.emitObject()}createObject(){return new yr(this)}}const xr=U(),Tr=new Float32Array(1),Er=new Float32Array(1),Sr=new Float32Array(1),Br=new Float32Array(1),Ir=new Float32Array(1),Lr=new Float32Array(1);class Cr extends fr{constructor(){super(...arguments),this.tail=0,this.gravity=0,this.location=g(),this.velocity=g(),this.scale=g(),this.facing=0}bind(t){const e=this.emitter,i=e.instance,r=i.sequence,n=i.frame,s=i.counter,a=e.emitterObject;a.getWidth(Tr,r,n,s),a.getLength(Er,r,n,s),a.getLatitude(Sr,r,n,s),a.getVariation(Br,r,n,s),a.getSpeed(Ir,r,n,s),a.getGravity(Lr,r,n,s);const o=e.node,l=o.pivot,h=o.worldScale,c=.5*Tr[0],d=.5*Er[0],u=Ct(Sr[0]),f=Br[0],m=Ir[0],g=this.location,p=this.velocity;this.health=a.lifeSpan,this.tail=t,this.gravity=Lr[0]*h[2],v(this.scale,h),g[0]=l[0]+Rt(-c,c),g[1]=l[1]+Rt(-d,d),g[2]=l[2],a.modelSpace||E(g,g,o.worldMatrix),k(xr),N(xr,xr,Math.PI/2),P(xr,xr,Rt(-u,u)),a.lineEmitter||D(xr,xr,Rt(-u,u)),a.modelSpace||W(xr,o.worldRotation,xr),S(p,st,xr),_(p,p,m*(1+Rt(-f,f))),a.modelSpace||L(p,p,h),a.xYQuad&&(this.facing=Math.atan2(p[1],p[0])-Math.PI+Math.PI/8)}update(t){if(this.health-=t,this.health>0){const e=this.location,i=this.velocity;i[2]-=this.gravity*t,e[0]+=i[0]*t,e[1]+=i[1]*t,e[2]+=i[2]*t}}}const Rr=new Float32Array(1);class Mr extends ur{constructor(t,e){super(t,e),this.lastEmissionKey=-1,this.node=t.nodes[e.index]}updateEmission(t){const e=this.instance;if(e.allowParticleSpawn){const i=this.emitterObject,r=i.getEmissionRate(Rr,e.sequence,e.frame,e.counter);i.squirt?(r!==this.lastEmissionKey&&(this.currentEmission+=Rr[0]),this.lastEmissionKey=r):this.currentEmission+=Rr[0]*t}}emit(){const t=this.emitterObject;t.head&&this.emitObject(0),t.tail&&this.emitObject(1)}createObject(){return new Cr(this)}}const Ur=g(),kr=g(),Fr=new Float32Array(3),Dr=new Float32Array(1),Pr=new Uint32Array(1);class Nr extends fr{constructor(){super(...arguments),this.vertices=new Float32Array(6),this.color=new Uint8Array(4),this.slot=0,this.prev=null,this.next=null}bind(){const t=this.emitter,e=t.instance,i=e.sequence,r=e.frame,n=e.counter,s=t.emitterObject,a=e.nodes[s.index],[o,l,h]=a.pivot,c=a.worldMatrix,d=this.vertices;this.health=t.emitterObject.lifeSpan,s.getHeightBelow(Ur,i,r,n),s.getHeightAbove(kr,i,r,n),Ur[1]=l-Ur[0],Ur[0]=o,Ur[2]=h,kr[1]=l+kr[0],kr[0]=o,kr[2]=h,E(Ur,Ur,c),E(kr,kr,c),d[0]=kr[0],d[1]=kr[1],d[2]=kr[2],d[3]=Ur[0],d[4]=Ur[1],d[5]=Ur[2]}update(t){if(this.health-=t,this.health>0){const e=this.emitter,i=e.instance,r=i.sequence,n=i.frame,s=i.counter,a=e.emitterObject,o=this.color,l=this.vertices,h=a.gravity*t*t;a.getColor(Fr,r,n,s),a.getAlpha(Dr,r,n,s),a.getTextureSlot(Pr,r,n,s),l[1]-=h,l[4]-=h,o[0]=255*Fr[0],o[1]=255*Fr[1],o[2]=255*Fr[2],o[3]=255*Dr[0],this.slot=Pr[0]}}}class Or extends ur{constructor(){super(...arguments),this.first=null,this.last=null}updateEmission(t){if(this.instance.allowParticleSpawn){const e=this.emitterObject;this.currentEmission+=e.emissionRate*t}}emit(){const t=this.emitObject(),e=this.last;e?(e.next=t,t.prev=e):this.first=t,this.last=t}kill(t){super.kill(t);const e=t.prev,i=t.next;t===this.first&&(this.first=i),t===this.last&&(this.first=null,this.last=null),e&&(e.next=i),i&&(i.prev=e),t.prev=null,t.next=null}createObject(){return new Nr(this)}}const Vr=new Uint32Array(1);class Gr extends ur{constructor(){super(...arguments),this.lastValue=0}updateEmission(t){const e=this.instance;if(e.allowParticleSpawn){this.emitterObject.getValue(Vr,e);const t=Vr[0];1===t&&t!==this.lastValue&&(this.currentEmission+=1),this.lastValue=t}}emit(){this.emitObject()}}class zr extends fr{constructor(t){super(t);const e=t.emitterObject.internalModel;this.internalInstance=e.addInstance()}bind(){const t=this.emitter,e=t.instance,i=e.scene,r=e.nodes[t.emitterObject.index],n=this.internalInstance;n.setScene(i),n.setSequence(0),n.setTransformation(r.worldLocation,r.worldRotation,r.worldScale),n.show(),this.health=1}update(t){const e=this.internalInstance,i=e.model;e.frame>=i.sequences[0].interval[1]&&(this.health=0,e.hide())}}class jr extends Gr{createObject(){return new zr(this)}}const Kr=g();class Hr extends fr{constructor(){super(...arguments),this.vertices=new Float32Array(12)}bind(){const t=this.emitter,e=t.instance,i=t.emitterObject,r=this.vertices,n=i.scale,{worldLocation:s,worldRotation:a}=e.nodes[i.index];this.health=i.lifeSpan,b(Kr,n,n,0),S(Kr,Kr,a),y(r.subarray(0,2),Kr,s),b(Kr,-n,n,0),S(Kr,Kr,a),y(r.subarray(3,5),Kr,s),b(Kr,-n,-n,0),S(Kr,Kr,a),y(r.subarray(6,8),Kr,s),b(Kr,n,-n,0),S(Kr,Kr,a),y(r.subarray(9,11),Kr,s)}update(t){this.health-=t}}class $r extends Gr{createObject(){return new Hr(this)}}class Xr extends Gr{createObject(){return new Hr(this)}}class qr extends fr{bind(){const t=this.emitter,e=t.instance,i=e.model.viewer,r=e.scene;if(i.audioEnabled&&r.audioEnabled){const i=t.emitterObject,n=e.nodes[i.index],s=r.audioContext,a=i.decodedBuffers,o=s.createPanner(),l=s.createBufferSource(),h=n.worldLocation;o.positionX.value=h[0],o.positionY.value=h[1],o.positionZ.value=h[2],o.maxDistance=i.distanceCutoff,o.refDistance=i.minDistance,o.connect(s.destination),l.buffer=a[Math.random()*a.length|0],l.connect(o),l.start(0)}}update(t){}}class Yr extends Gr{createObject(){return new qr(this)}}const Wr=new Float32Array(1),Zr=g(),Qr=U(),Jr=g(),tn=new Float32Array(3),en=new Float32Array(1),rn=new Uint32Array(1);class nn extends class extends class{constructor(){this.pivot=g(),this.localLocation=g(),this.localRotation=U(),this.localScale=w(1,1,1),this.worldLocation=g(),this.worldRotation=U(),this.worldScale=w(1,1,1),this.inverseWorldLocation=g(),this.inverseWorldRotation=U(),this.inverseWorldScale=w(1,1,1),this.localMatrix=J(),this.worldMatrix=J(),this.dontInheritTranslation=!1,this.dontInheritRotation=!1,this.dontInheritScaling=!0,this.parent=null,this.children=[]}setPivot(t){return v(this.pivot,t),this.recalculateTransformation(),this}setLocation(t){return v(this.localLocation,t),this.recalculateTransformation(),this}setRotation(t){return Y(this.localRotation,t),this.recalculateTransformation(),this}setScale(t){return v(this.localScale,t),this.recalculateTransformation(),this}setUniformScale(t){return b(this.localScale,t,t,t),this.recalculateTransformation(),this}setTransformation(t,e,i){const r=this.localLocation,n=this.localRotation,s=this.localScale;return r[0]=t[0],r[1]=t[1],r[2]=t[2],n[0]=e[0],n[1]=e[1],n[2]=e[2],n[3]=e[3],s[0]=i[0],s[1]=i[1],s[2]=i[2],this.recalculateTransformation(),this}resetTransformation(){return v(this.pivot,at),v(this.localLocation,at),Y(this.localRotation,lt),v(this.localScale,ot),this.recalculateTransformation(),this}movePivot(t){return y(this.pivot,this.pivot,t),this.recalculateTransformation(),this}move(t){return y(this.localLocation,this.localLocation,t),this.recalculateTransformation(),this}rotate(t){return W(this.localRotation,this.localRotation,t),this.recalculateTransformation(),this}rotateLocal(t){return W(this.localRotation,t,this.localRotation),this.recalculateTransformation(),this}scale(t){return L(this.localScale,this.localScale,t),this.recalculateTransformation(),this}uniformScale(t){return _(this.localScale,this.localScale,t),this.recalculateTransformation(),this}face(t,e){return V(this.localRotation,wt(this.localRotation,this.localLocation,t,e)),this.recalculateTransformation(),this}setParent(t){if(this.parent){const t=this.parent.children,e=t.indexOf(this);-1!==e&&t.splice(e,1)}return this.parent=t||null,t&&t.children.push(this),this.recalculateTransformation(),this}recalculateTransformation(){const t=this.parent,e=this.localMatrix,i=this.localLocation,r=this.localRotation,n=this.localScale,s=this.worldMatrix,a=this.worldLocation,o=this.worldRotation,l=this.worldScale,h=this.inverseWorldLocation,c=this.inverseWorldRotation,d=this.inverseWorldScale;if(t){const a=er,h=t.pivot;let c,d;if(a[0]=i[0]+h[0],a[1]=i[1]+h[1],a[2]=i[2]+h[2],this.dontInheritRotation?(c=ir,W(c,r,t.inverseWorldRotation)):c=r,this.dontInheritScaling){d=rr;const e=t.inverseWorldScale;d[0]=e[0]*n[0],d[1]=e[1]*n[1],d[2]=e[2]*n[2],l[0]=n[0],l[1]=n[1],l[2]=n[2]}else{d=n;const e=t.worldScale;l[0]=e[0]*n[0],l[1]=e[1]*n[1],l[2]=e[2]*n[2]}et(e,c,a,d),it(s,t.worldMatrix,e),W(o,t.worldRotation,c)}else et(e,r,i,n),s[0]=e[0],s[1]=e[1],s[2]=e[2],s[3]=e[3],s[4]=e[4],s[5]=e[5],s[6]=e[6],s[7]=e[7],s[8]=e[8],s[9]=e[9],s[10]=e[10],s[11]=e[11],s[12]=e[12],s[13]=e[13],s[14]=e[14],s[15]=e[15],o[0]=r[0],o[1]=r[1],o[2]=r[2],o[3]=r[3],l[0]=n[0],l[1]=n[1],l[2]=n[2];c[0]=-o[0],c[1]=-o[1],c[2]=-o[2],c[3]=o[3],d[0]=1/l[0],d[1]=1/l[1],d[2]=1/l[2],a[0]=s[12],a[1]=s[13],a[2]=s[14],h[0]=-a[0],h[1]=-a[1],h[2]=-a[2];for(const t of this.children)t.recalculateTransformation()}update(t){for(const e of this.children)e.update(t)}}{constructor(t){super(),this.scene=null,this.left=-1,this.right=-1,this.bottom=-1,this.top=-1,this.plane=-1,this.depth=0,this.updateFrame=0,this.timeScale=1,this.rendered=!0,this.textureOverrides=new Map,this.model=t}show(){this.rendered=!0}hide(){this.rendered=!1}shown(){return this.rendered}hidden(){return!this.rendered}detach(){return!!this.scene&&this.scene.removeInstance(this)}overrideTexture(t,e){e?this.textureOverrides.set(t,e):this.textureOverrides.delete(t)}getBounds(){return this.model.bounds}clearEmittedObjects(){}setScene(t){return t.addInstance(this)}recalculateTransformation(){super.recalculateTransformation(),this.scene&&this.scene.grid.moved(this)}update(t){const e=this.scene;e&&this.rendered&&this.isVisible(e.camera)&&(e.renderInstance(this),this.updateAnimations(t*this.timeScale),super.update(t))}updateAnimations(t){}renderOpaque(){}renderTranslucent(){}isVisible(t){const[e,i,r]=this.worldLocation,[n,s,a]=this.worldScale,o=this.getBounds(),l=t.planes;let h=n;return s>h&&(h=s),a>h&&(h=a),this.plane=function(t,e,i,r,n,s){-1===s&&(s=0);for(let a=0;a<6;a++){const o=(s+a)%6;if(ut(t[o],e,i,r)<=-n)return o}return-1}(l,e+o.x,i+o.y,r+o.z,o.r*h,this.plane),-1===this.plane&&(this.depth=ut(l[4],e,i,r),!0)}}{constructor(t){super(t),this.attachments=[],this.particleEmitters=[],this.particleEmitters2=[],this.ribbonEmitters=[],this.eventObjectEmitters=[],this.nodes=[],this.sortedNodes=[],this.frame=0,this.counter=0,this.sequence=-1,this.sequenceLoopMode=0,this.sequenceEnded=!1,this.teamColor=0,this.vertexColor=new Float32Array([1,1,1,1]),this.allowParticleSpawn=!1,this.forced=!0,this.geosetColors=[],this.layerAlphas=[],this.layerTextures=[],this.uvAnims=[],this.worldMatrices=null,this.boneTexture=null;for(let e=0,i=t.geosets.length;e<i;e++)this.geosetColors[e]=new Float32Array(4);for(let e=0,i=t.layers.length;e<i;e++)this.layerAlphas[e]=0,this.layerTextures[e]=0,this.uvAnims[e]=new Float32Array(5);const e=function(t,e=lr){const i=new Float32Array(65*t),r=[];let n=0;const s=3*t,a=4*t,o=16*t,l=i.subarray(n,n+s);n+=s;const h=i.subarray(n,n+s);n+=s;const c=i.subarray(n,n+a);n+=a;const d=i.subarray(n,n+s);n+=s;const u=i.subarray(n,n+s);n+=s;const f=i.subarray(n,n+a);n+=a;const m=i.subarray(n,n+s);n+=s;const g=i.subarray(n,n+s);n+=s;const p=i.subarray(n,n+a);n+=a;const w=i.subarray(n,n+s);n+=s;const v=i.subarray(n,n+o);n+=o;const b=i.subarray(n,n+o);for(let i=0;i<t;i++){const t=3*i,n=t+3,s=4*i,a=s+4,o=16*i,y=o+16;r[i]=new e(l.subarray(t,n),h.subarray(t,n),c.subarray(s,a),d.subarray(t,n),u.subarray(t,n),f.subarray(s,a),m.subarray(t,n),g.subarray(t,n),p.subarray(s,a),w.subarray(t,n),v.subarray(o,y),b.subarray(o,y))}return{data:i,nodes:r,pivots:l,localLocations:h,localRotations:c,localScales:d,worldLocations:u,worldRotations:f,worldScales:m,inverseWorldLocations:g,invereseWorldRotations:p,inverseWorldScales:w,localMatrices:v,worldMatrices:b}}(t.genericObjects.length,hr),i=e.nodes;let r=0;this.nodes.push(...i),this.worldMatrices=e.worldMatrices;for(const e of t.bones)this.initNode(i,i[r++],e);for(const e of t.lights)this.initNode(i,i[r++],e);for(const e of t.helpers)this.initNode(i,i[r++],e);for(const e of t.attachments){let t;e.internalModel&&(t=new dr(this,e),this.attachments.push(t)),this.initNode(i,i[r++],e,t)}for(const e of t.particleEmitters){const t=new Ar(this,e);this.particleEmitters.push(t),this.initNode(i,i[r++],e,t)}for(const e of t.particleEmitters2){const t=new Mr(this,e);this.particleEmitters2.push(t),this.initNode(i,i[r++],e,t)}for(const e of t.ribbonEmitters){const t=new Or(this,e);this.ribbonEmitters.push(t),this.initNode(i,i[r++],e,t)}for(const e of t.eventObjects){const t=e.type;let n;n="SPN"===t?new jr(this,e):"SPL"===t?new $r(this,e):"UBR"===t?new Xr(this,e):new Yr(this,e),this.eventObjectEmitters.push(n),this.initNode(i,i[r++],e,n)}for(const e of t.collisionShapes)this.initNode(i,i[r++],e);const n=t.hierarchy;for(let t=0,e=i.length;t<e;t++)this.sortedNodes[t]=i[n[t]];t.bones.length&&(this.boneTexture=new c(t.viewer.gl,4,4*t.bones.length,1))}setTexture(t,e){this.overrideTexture(t,e)}setParticle2Texture(t,e){this.overrideTexture(1e3+t,e)}setEventTexture(t,e){this.overrideTexture(Ni+t,e)}clearEmittedObjects(){for(const t of this.particleEmitters)t.clear();for(const t of this.particleEmitters2)t.clear();for(const t of this.ribbonEmitters)t.clear();for(const t of this.eventObjectEmitters)t.clear()}initNode(t,e,i,r){v(e.pivot,i.pivot),-1===i.parentId?e.parent=this:e.parent=t[i.parentId],i.billboarded?e.billboarded=!0:i.billboardedX?e.billboardedX=!0:i.billboardedY?e.billboardedY=!0:i.billboardedZ&&(e.billboardedZ=!0),r&&(e.object=r)}hide(){super.hide(),this.resetAttachments()}updateNodes(t,e){const i=this.sequence,r=this.frame,n=this.counter,s=this.sortedNodes,a=this.model.sortedGenericObjects,o=this.scene;for(let l=0,h=s.length;l<h;l++){const h=a[l],c=s[l],d=c.parent;let u=e||d.wasDirty||h.anyBillboarding;const f=h.variants;(e||f.generic[i])&&(u=!0,(e||f.translation[i])&&h.getTranslation(c.localLocation,i,r,n),(e||f.rotation[i])&&h.getRotation(c.localRotation,i,r,n),(e||f.scale[i])&&h.getScale(c.localScale,i,r,n)),c.wasDirty=u,u&&c.recalculateTransformation(o),c.object&&(h.getVisibility(Wr,i,r,n),Wr[0]>0&&c.object.update(t));for(const e of c.children)u&&e.recalculateTransformation(),e.update(t)}}recalculateTransformation(){super.recalculateTransformation(),this.forced=!0}updateBatches(t){const e=this.sequence,i=this.frame,r=this.counter,n=this.model,s=n.geosets,a=n.layers,o=this.geosetColors,l=this.layerAlphas,h=this.layerTextures,c=this.uvAnims;for(let n=0,a=s.length;n<a;n++){const a=s[n].geosetAnimation,l=o[n];a?((t||a.variants.color[e])&&(a.getColor(tn,e,i,r),l[0]=tn[0],l[1]=tn[1],l[2]=tn[2]),(t||a.variants.alpha[e])&&(a.getAlpha(en,e,i,r),l[3]=en[0])):t&&(l[0]=1,l[1]=1,l[2]=1,l[3]=1)}for(let n=0,s=a.length;n<s;n++){const s=a[n],o=s.textureAnimation,d=c[n];(t||s.variants.alpha[e])&&(s.getAlpha(en,e,i,r),l[n]=en[0]),(t||s.variants.textureId[e])&&(s.getTextureId(rn,e,i,r),h[n]=rn[0]),o?((t||o.variants.translation[e])&&(o.getTranslation(Zr,e,i,r),d[0]=Zr[0],d[1]=Zr[1]),(t||o.variants.rotation[e])&&(o.getRotation(Qr,e,i,r),d[2]=Qr[2],d[3]=Qr[3]),(t||o.variants.scale[e])&&(o.getScale(Jr,e,i,r),d[4]=Jr[0])):t&&(d[0]=0,d[1]=0,d[2]=0,d[3]=1,d[4]=1)}}updateBoneTexture(){this.boneTexture&&this.boneTexture.bindAndUpdate(this.worldMatrices)}renderOpaque(){const t=this.model;for(const e of t.opaqueGroups)e.render(this)}renderTranslucent(){const t=this.model;for(const e of t.translucentGroups)e.render(this)}updateAnimations(t){const e=this.model,i=this.sequence;if(-1!==i){const r=e.sequences[i],n=r.interval,s=1e3*t;this.frame+=s,this.counter+=s,this.allowParticleSpawn=!0,this.frame>=n[1]?(2===this.sequenceLoopMode||0===this.sequenceLoopMode&&0===r.nonLooping?(this.frame=n[0],this.resetEventEmitters()):(this.frame=n[1],this.counter-=s,this.allowParticleSpawn=!1),this.sequenceEnded=!0):this.sequenceEnded=!1}const r=this.forced;(-1!==i||r)&&(this.updateNodes(t,r),this.updateBoneTexture(),this.updateBatches(r)),this.forced=!1}setTeamColor(t){return this.teamColor=t,this}setVertexColor(t){return this.vertexColor.set(t),this}setSequence(t){const e=this.model.sequences;return this.sequence=t,t<0||t>e.length-1?(this.sequence=-1,this.frame=0,this.allowParticleSpawn=!1):this.frame=e[t].interval[0],this.resetEventEmitters(),this.resetAttachments(),this.forced=!0,this}getBounds(){const t=this.model;if(-1===this.sequence)return t.bounds;const e=t.sequences[this.sequence].bounds;return 0===e.r?t.bounds:e}setSequenceLoopMode(t){return this.sequenceLoopMode=t,this}getAttachment(t){const e=this.model.attachments[t];if(e)return this.nodes[e.index]}resetEventEmitters(){for(const t of this.eventObjectEmitters)t.lastValue=0}resetAttachments(){for(const t of this.attachments)t.internalInstance.hide()}}const sn="\nuniform sampler2D u_boneMap;\nuniform float u_vectorSize;\nuniform float u_rowSize;\n\nmat4 fetchMatrix(float column, float row) {\n  column *= u_vectorSize * 4.0;\n  row *= u_rowSize;\n  // Add in half a texel, to sample in the middle of the texel.\n  // Otherwise, since the sample is directly on the boundary, floating point errors can cause the sample to get the wrong pixel.\n  // This is most noticeable with NPOT textures, which the bone maps are.\n  column += 0.5 * u_vectorSize;\n  row += 0.5 * u_rowSize;\n\n  return mat4(texture2D(u_boneMap, vec2(column, row)),\n              texture2D(u_boneMap, vec2(column + u_vectorSize, row)),\n              texture2D(u_boneMap, vec2(column + u_vectorSize * 2.0, row)),\n              texture2D(u_boneMap, vec2(column + u_vectorSize * 3.0, row)));\n}\n",an="\n#ifdef SKIN\nattribute vec4 a_bones;\nattribute vec4 a_weights;\n\nvoid transformSkin(inout vec3 position, inout vec3 normal, inout vec3 tangent, inout vec3 binormal) {\n  mat4 bone;\n\n  bone += fetchMatrix(a_bones[0], 0.0) * a_weights[0];\n  bone += fetchMatrix(a_bones[1], 0.0) * a_weights[1];\n  bone += fetchMatrix(a_bones[2], 0.0) * a_weights[2];\n  bone += fetchMatrix(a_bones[3], 0.0) * a_weights[3];\n\n  mat3 rotation = mat3(bone);\n\n  position = vec3(bone * vec4(position, 1.0));\n  normal = rotation * normal;\n  tangent = rotation * tangent;\n  binormal = rotation * binormal;\n}\n#else\nattribute vec4 a_bones;\n#ifdef EXTENDED_BONES\nattribute vec4 a_extendedBones;\n#endif\nattribute float a_boneNumber;\n\nmat4 getVertexGroupMatrix() {\n  mat4 bone;\n\n  // For the broken models out there, since the game supports this.\n  if (a_boneNumber > 0.0) {\n    for (int i = 0; i < 4; i++) {\n      if (a_bones[i] > 0.0) {\n        bone += fetchMatrix(a_bones[i] - 1.0, 0.0);\n      }\n    }\n\n    #ifdef EXTENDED_BONES\n      for (int i = 0; i < 4; i++) {\n        if (a_extendedBones[i] > 0.0) {\n          bone += fetchMatrix(a_extendedBones[i] - 1.0, 0.0);\n        }\n      }\n    #endif\n  }\n\n  return bone / a_boneNumber;\n}\n\nvoid transformVertexGroups(inout vec3 position, inout vec3 normal) {\n  mat4 bone = getVertexGroupMatrix();\n  mat3 rotation = mat3(bone);\n\n  position = vec3(bone * vec4(position, 1.0));\n  normal = normalize(rotation * normal);\n}\n\nvoid transformVertexGroupsHD(inout vec3 position, inout vec3 normal, inout vec3 tangent, inout vec3 binormal) {\n  mat4 bone = getVertexGroupMatrix();\n  mat3 rotation = mat3(bone);\n\n  position = vec3(bone * vec4(position, 1.0));\n  normal = normalize(rotation * normal);\n  tangent = normalize(rotation * tangent);\n  binormal = normalize(rotation * binormal);\n}\n#endif\n",on=`\nuniform mat4 u_VP;\nuniform vec3 u_lightPos;\nuniform vec4 u_vertexColor;\nuniform vec4 u_geosetColor;\nuniform float u_layerAlpha;\nuniform vec2 u_uvTrans;\nuniform vec2 u_uvRot;\nuniform float u_uvScale;\nuniform bool u_hasBones;\n\nattribute vec3 a_position;\nattribute vec3 a_normal;\nattribute vec2 a_uv;\n\nvarying vec2 v_uv;\nvarying vec3 v_normal;\nvarying vec4 v_color;\nvarying vec4 v_uvTransRot;\nvarying float v_uvScale;\nvarying vec3 v_lightDir;\n\n${sn}\n${an}\n\nvoid main() {\n  vec3 position = a_position;\n  vec3 normal = a_normal;\n\n  if (u_hasBones) {\n    transformVertexGroups(position, normal);\n  }\n\n  v_uv = a_uv;\n  v_normal = normal;\n  v_color = u_vertexColor * u_geosetColor.bgra * vec4(1.0, 1.0, 1.0, u_layerAlpha);\n  v_uvTransRot = vec4(u_uvTrans, u_uvRot);\n  v_uvScale = u_uvScale;\n  v_lightDir = normalize(u_lightPos - position);\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n`,ln="\n#ifdef GL_FRAGMENT_PRECISION_HIGH\nprecision highp float;\n#else\nprecision mediump float;\n#endif\n",hn=`\n${ln}\n\n\n// A 2D quaternion*vector.\n// q is the zw components of the original quaternion.\nvec2 quat_transform(vec2 q, vec2 v) {\n  vec2 uv = vec2(-q.x * v.y, q.x * v.x);\n  vec2 uuv = vec2(-q.x * uv.y, q.x * uv.x);\n\n  return v + 2.0 * (uv * q.y + uuv);\n}\n\n\nuniform sampler2D u_texture;\nuniform float u_filterMode;\nuniform bool u_unshaded;\n\nvarying vec2 v_uv;\nvarying vec3 v_normal;\nvarying vec4 v_color;\nvarying vec4 v_uvTransRot;\nvarying float v_uvScale;\nvarying vec3 v_lightDir;\n\nvec4 getDiffuseColor() {\n  vec2 uv = v_uv;\n\n  // Translation animation\n  uv += v_uvTransRot.xy;\n\n  // Rotation animation\n  uv = quat_transform(v_uvTransRot.zw, uv - 0.5) + 0.5;\n\n  // Scale animation\n  uv = v_uvScale * (uv - 0.5) + 0.5;\n\n  vec4 texel = texture2D(u_texture, uv);\n  vec4 color = texel * v_color;\n\n  // 1bit Alpha\n  if (u_filterMode == 1.0 && color.a < 0.75) {\n    discard;\n  }\n\n  // "Close to 0 alpha"\n  if (u_filterMode >= 5.0 && color.a < 0.02) {\n    discard;\n  }\n\n  return color;\n}\n\nvoid onlyTexCoords() {\n  gl_FragColor = vec4(v_uv, 0.0, 1.0);\n}\n\nvoid onlyNormals() {\n  gl_FragColor = vec4(v_normal, 1.0);\n}\n\nvoid onlyDiffuse() {\n  gl_FragColor = getDiffuseColor();\n}\n\nvoid lambert() {\n  vec4 color = getDiffuseColor();\n\n  if (!u_unshaded) {\n    float lambertFactor = clamp(dot(v_normal, v_lightDir), 0.0, 1.0);\n    lambertFactor = clamp(lambertFactor + 0.7, 0.0, 1.0);\n\n    color.rgb *= lambertFactor;\n  }\n\n  gl_FragColor = color;\n}\n\nvoid main() {\n  #if defined(ONLY_DIFFUSE)\n  onlyDiffuse();\n  #elif defined(ONLY_TEXCOORDS)\n  onlyTexCoords();\n  #elif defined(ONLY_NORMALS)\n  onlyNormals();\n  #else\n  lambert();\n  #endif\n}\n`,cn=`\nuniform mat4 u_VP;\nuniform mat4 u_MV;\nuniform vec3 u_eyePos;\nuniform vec3 u_lightPos;\nuniform float u_layerAlpha;\nuniform bool u_hasBones;\n\nattribute vec3 a_position;\nattribute vec3 a_normal;\nattribute vec2 a_uv;\nattribute vec4 a_tangent;\n\nvarying vec2 v_uv;\nvarying float v_layerAlpha;\nvarying vec3 v_lightDir;\nvarying vec3 v_eyeVec;\nvarying vec3 v_normal;\n// varying vec3 v_lightDirWorld;\n\n#if defined(ONLY_TANGENTS)\nvarying vec3 v_tangent;\n#endif\n\n${sn}\n${an}\n\nvec3 TBN(vec3 vector, vec3 tangent, vec3 binormal, vec3 normal) {\n  return vec3(dot(vector, tangent), dot(vector, binormal), dot(vector, normal));\n}\n\nvoid main() {\n  vec3 position = a_position;\n  vec3 normal = a_normal;\n  vec3 tangent = a_tangent.xyz;\n\n  // Re-orthogonalize the tangent in case it wasnt normalized.\n  // See "One last thing" at https://learnopengl.com/Advanced-Lighting/Normal-Mapping\n  tangent = normalize(tangent - dot(tangent, normal) * normal);\n\n  vec3 binormal = cross(normal, tangent) * a_tangent.w;\n\n  if (u_hasBones) {\n    #ifdef SKIN\n      transformSkin(position, normal, tangent, binormal);\n    #else\n      transformVertexGroupsHD(position, normal, tangent, binormal);\n    #endif\n  }\n\n  vec3 position_mv = vec3(u_MV * vec4(position, 1));\n\n  mat3 mv = mat3(u_MV);\n  vec3 t = normalize(mv * tangent);\n  vec3 b = normalize(mv * binormal);\n  vec3 n = normalize(mv * normal);\n\n  v_eyeVec = normalize(u_eyePos - position_mv);\n\n  vec3 lightDir = normalize(u_lightPos - position_mv);\n  v_lightDir = normalize(TBN(lightDir, t, b, n));\n  \n  v_uv = a_uv;\n  v_layerAlpha = u_layerAlpha;\n\n  v_normal = normal;\n  // v_lightDirWorld = normalize(lightDir);\n\n  #if defined(ONLY_TANGENTS)\n  v_tangent = tangent;\n  #endif\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n`,dn=`\n${ln}\n\nuniform sampler2D u_diffuseMap;\nuniform sampler2D u_normalsMap;\nuniform sampler2D u_ormMap;\nuniform sampler2D u_emissiveMap;\nuniform sampler2D u_teamColorMap;\nuniform sampler2D u_environmentMap;\nuniform float u_filterMode;\n\n// uniform sampler2D u_lutMap;\n// uniform sampler2D u_envDiffuseMap;\n// uniform sampler2D u_envSpecularMap;\n\nvarying vec2 v_uv;\nvarying float v_layerAlpha;\nvarying vec3 v_lightDir;\nvarying vec3 v_eyeVec;\nvarying vec3 v_normal;\n// varying vec3 v_lightDirWorld;\n\n#if defined(ONLY_TANGENTS)\nvarying vec3 v_tangent;\n#endif\n\nvec3 decodeNormal() {\n  vec2 xy = texture2D(u_normalsMap, v_uv).xy * 2.0 - 1.0;\n  \n  return vec3(xy, sqrt(1.0 - dot(xy, xy)));\n}\n\nconst vec2 invAtan = vec2(0.1591, 0.3183);\nvec2 sampleEnvironmentMap(vec3 normal) {\n  vec2 uv = vec2(atan(normal.x, normal.y), -asin(normal.z));\n  uv *= invAtan;\n  uv += 0.5;\n  return uv;\n}\n\nvec4 getDiffuseColor() {\n  vec4 color = texture2D(u_diffuseMap, v_uv);\n\n  // 1bit Alpha\n  if (u_filterMode == 1.0 && color.a < 0.75) {\n    discard;\n  }\n\n  return color;\n}\n\nvec4 getOrmColor() {\n  return texture2D(u_ormMap, v_uv);\n}\n\nvec3 getEmissiveColor() {\n  return texture2D(u_emissiveMap, v_uv).rgb;\n}\n\nvec3 getTeamColor() {\n  return texture2D(u_teamColorMap, v_uv).rgb;\n}\n\n// const float PI = 3.14159265359;\n// const float RECIPROCAL_PI = 0.31830988618;\n// const float RECIPROCAL_PI2 = 0.15915494;\n// const float LN2 = 0.6931472;\n// const float ENV_LODS = 6.0;\n// vec4 SRGBtoLinear(vec4 srgb) {\n//     vec3 linOut = pow(srgb.xyz, vec3(2.2));\n//     return vec4(linOut, srgb.w);;\n// }\n// vec4 RGBMToLinear(in vec4 value) {\n//     float maxRange = 6.0;\n//     return vec4(value.xyz * value.w * maxRange, 1.0);\n// }\n// vec3 linearToSRGB(vec3 color) {\n//     return pow(color, vec3(1.0 / 2.2));\n// }\n// // vec3 getNormal() {\n// //     vec3 pos_dx = dFdx(vMPos.xyz);\n// //     vec3 pos_dy = dFdy(vMPos.xyz);\n// //     vec2 tex_dx = dFdx(vUv);\n// //     vec2 tex_dy = dFdy(vUv);\n// //     vec3 t = normalize(pos_dx * tex_dy.t - pos_dy * tex_dx.t);\n// //     vec3 b = normalize(-pos_dx * tex_dy.s + pos_dy * tex_dx.s);\n// //     mat3 tbn = mat3(t, b, normalize(vNormal));\n// //     vec3 n = texture2D(tNormal, vUv * uNormalUVScale).rgb * 2.0 - 1.0;\n// //     n.xy *= uNormalScale;\n// //     vec3 normal = normalize(tbn * n);\n// //     // Get world normal from view normal (normalMatrix * normal)\n// //     return normalize((vec4(normal, 0.0) * viewMatrix).xyz);\n// // }\n// vec3 specularReflection(vec3 specularEnvR0, vec3 specularEnvR90, float VdH) {\n//     return specularEnvR0 + (specularEnvR90 - specularEnvR0) * pow(clamp(1.0 - VdH, 0.0, 1.0), 5.0);\n// }\n// float geometricOcclusion(float NdL, float NdV, float roughness) {\n//     float r = roughness;\n//     float attenuationL = 2.0 * NdL / (NdL + sqrt(r * r + (1.0 - r * r) * (NdL * NdL)));\n//     float attenuationV = 2.0 * NdV / (NdV + sqrt(r * r + (1.0 - r * r) * (NdV * NdV)));\n//     return attenuationL * attenuationV;\n// }\n// float microfacetDistribution(float roughness, float NdH) {\n//     float roughnessSq = roughness * roughness;\n//     float f = (NdH * roughnessSq - NdH) * NdH + 1.0;\n//     return roughnessSq / (PI * f * f);\n// }\n// vec2 cartesianToPolar(vec3 n) {\n//     vec2 uv;\n//     uv.x = atan(n.z, n.x) * RECIPROCAL_PI2 + 0.5;\n//     uv.y = asin(n.y) * RECIPROCAL_PI + 0.5;\n//     return uv;\n// }\n// void getIBLContribution(inout vec3 diffuse, inout vec3 specular, float NdV, float roughness, vec3 n, vec3 reflection, vec3 diffuseColor, vec3 specularColor) {\n//   vec3 brdf = SRGBtoLinear(texture2D(u_lutMap, vec2(NdV, roughness))).rgb;\n//   vec3 diffuseLight = RGBMToLinear(texture2D(u_envDiffuseMap, sampleEnvironmentMap(n))).rgb;\n//   // Sample 2 levels and mix between to get smoother degradation\n//   float blend = roughness * ENV_LODS;\n//   float level0 = floor(blend);\n//   float level1 = min(ENV_LODS, level0 + 1.0);\n//   blend -= level0;\n  \n//   // Sample the specular env map atlas depending on the roughness value\n//   vec2 uvSpec = sampleEnvironmentMap(reflection);\n//   uvSpec.y /= 2.0;\n//   vec2 uv0 = uvSpec;\n//   vec2 uv1 = uvSpec;\n//   uv0 /= pow(2.0, level0);\n//   uv0.y += 1.0 - exp(-LN2 * level0);\n//   uv1 /= pow(2.0, level1);\n//   uv1.y += 1.0 - exp(-LN2 * level1);\n//   vec3 specular0 = RGBMToLinear(texture2D(u_envSpecularMap, uv0)).rgb;\n//   vec3 specular1 = RGBMToLinear(texture2D(u_envSpecularMap, uv1)).rgb;\n//   vec3 specularLight = mix(specular0, specular1, blend);\n//   diffuse = diffuseLight * diffuseColor;\n  \n//   // Bit of extra reflection for smooth materials\n//   float reflectivity = pow((1.0 - roughness), 2.0) * 0.05;\n//   specular = specularLight * (specularColor * brdf.x + brdf.y + reflectivity);\n//   // specular *= uEnvSpecular;\n// }\n\n// void PBR() {\n//   vec4 baseDiffuseColor = getDiffuseColor();\n//   vec3 baseColor = baseDiffuseColor.rgb;\n//   vec4 orm = getOrmColor();\n//   vec3 tc = getTeamColor();\n//   float tcFactor = getOrmColor().a;\n\n//   if (tcFactor > 0.1) {\n//     baseColor *= tc * tcFactor;\n//   }\n\n//   float roughness = clamp(orm.g, 0.04, 1.0);\n//   float metallic = clamp(orm.b, 0.04, 1.0);\n\n//   vec3 f0 = vec3(0.04);\n//   vec3 diffuseColor = baseColor * (vec3(1.0) - f0) * (1.0 - metallic);\n//   vec3 specularColor = mix(f0, baseColor, metallic);\n//   vec3 specularEnvR0 = specularColor;\n//   vec3 specularEnvR90 = vec3(clamp(max(max(specularColor.r, specularColor.g), specularColor.b) * 25.0, 0.0, 1.0));\n\n//   vec3 N = v_normal;\n//   vec3 V = normalize(v_eyeVec);\n//   vec3 L = normalize(v_lightDirWorld);\n//   vec3 H = normalize(L + V);\n//   vec3 reflection = normalize(reflect(-V, N));\n\n//   float NdL = clamp(dot(N, L), 0.001, 1.0);\n//   float NdV = clamp(abs(dot(N, V)), 0.001, 1.0);\n//   float NdH = clamp(dot(N, H), 0.0, 1.0);\n//   float LdH = clamp(dot(L, H), 0.0, 1.0);\n//   float VdH = clamp(dot(V, H), 0.0, 1.0);\n\n//   vec3 F = specularReflection(specularEnvR0, specularEnvR90, VdH);\n//   float G = geometricOcclusion(NdL, NdV, roughness);\n//   float D = microfacetDistribution(roughness, NdH);\n\n//   vec3 diffuseContrib = (1.0 - F) * (diffuseColor / PI);\n//   vec3 specContrib = F * G * D / (4.0 * NdL * NdV);\n  \n//   // Shading based off lights\n//   // vec3 color = NdL * uLightColor * (diffuseContrib + specContrib);\n//   vec3 color = NdL * (diffuseContrib + specContrib);\n\n//   // Calculate IBL lighting\n//   vec3 diffuseIBL;\n//   vec3 specularIBL;\n//   getIBLContribution(diffuseIBL, specularIBL, NdV, roughness, N, reflection, diffuseColor, specularColor);\n\n//   // Add IBL on top of color\n//   color +=  specularIBL;\n\n//   color *= orm.r;\n\n//   color += getEmissiveColor();\n\n//   // Convert to sRGB to display\n//   gl_FragColor.rgb = color;\n//   gl_FragColor.a = baseDiffuseColor.a;\n// }\n\nvoid onlyDiffuse() {\n  vec4 baseColor = getDiffuseColor();\n  vec3 tc = getTeamColor();\n  float tcFactor = getOrmColor().a;\n\n  if (tcFactor > 0.1) {\n    baseColor.rgb *= tc * tcFactor;\n  }\n\n  gl_FragColor = baseColor;\n}\n\nvoid onlyNormalMap() {\n  gl_FragColor = vec4(decodeNormal(), 1.0);\n}\n\nvoid onlyOcclusion() {\n  gl_FragColor = vec4(getOrmColor().rrr, 1.0);\n}\n\nvoid onlyRoughness() {\n  gl_FragColor = vec4(getOrmColor().ggg, 1.0);\n}\n\nvoid onlyMetallic() {\n  gl_FragColor = vec4(getOrmColor().bbb, 1.0);\n}\n\nvoid onlyTeamColorFactor() {\n  gl_FragColor = vec4(getOrmColor().aaa, 1.0);\n}\n\nvoid onlyEmissiveMap() {\n  gl_FragColor = vec4(getEmissiveColor(), 1.0);\n}\n\nvoid onlyTexCoords() {\n  gl_FragColor = vec4(v_uv, 0.0, 1.0);\n}\n\nvoid onlyNormals() {\n  gl_FragColor = vec4(v_normal, 1.0);\n}\n\n#if defined(ONLY_TANGENTS)\nvoid onlyTangents() {\n  gl_FragColor = vec4(v_tangent, 1.0);\n}\n#endif\n\nvoid lambert() {\n  vec4 baseColor = getDiffuseColor();\n  vec3 normal = decodeNormal();\n  vec4 orm = getOrmColor();\n  vec3 emissive = getEmissiveColor();\n  vec3 tc = getTeamColor();\n  float aoFactor = orm.r;\n  float tcFactor = orm.a;\n  float lambertFactor = clamp(dot(normal, v_lightDir), 0.0, 1.0);\n  vec3 color = baseColor.rgb;\n\n  if (tcFactor > 0.1) {\n    color *= tc * tcFactor;\n  }\n  \n  color *= clamp(lambertFactor * aoFactor + 0.1, 0.0, 1.0);\n  color += emissive;\n\n  gl_FragColor = vec4(color, baseColor.a);\n}\n\nvoid main() {\n  #if defined(ONLY_DIFFUSE)\n  onlyDiffuse();\n  #elif defined(ONLY_NORMAL_MAP)\n  onlyNormalMap();\n  #elif defined(ONLY_OCCLUSION)\n  onlyOcclusion();\n  #elif defined(ONLY_ROUGHNESS)\n  onlyRoughness();\n  #elif defined(ONLY_METALLIC)\n  onlyMetallic();\n  #elif defined(ONLY_TC_FACTOR)\n  onlyTeamColorFactor();\n  #elif defined(ONLY_EMISSIVE)\n  onlyEmissiveMap();\n  #elif defined(ONLY_TEXCOORDS)\n  onlyTexCoords();\n  #elif defined(ONLY_NORMALS)\n  onlyNormals();\n  #elif defined(ONLY_TANGENTS)\n  onlyTangents();\n  #else\n  lambert();\n  #endif\n}\n`,un=`\n${ln}\n\n#define EMITTER_PARTICLE2 0\n#define EMITTER_RIBBON 1\n\nuniform sampler2D u_texture;\nuniform highp int u_emitter;\nuniform float u_filterMode;\n\nvarying vec2 v_texcoord;\nvarying vec4 v_color;\n\nvoid main() {\n  vec4 texel = texture2D(u_texture, v_texcoord);\n  vec4 color = texel * v_color;\n\n  // 1bit Alpha, used by ribbon emitters.\n  if (u_emitter == EMITTER_RIBBON && u_filterMode == 1.0 && color.a < 0.75) {\n    discard;\n  }\n\n  // "Close to 0 alpha"\n  if (u_emitter == EMITTER_PARTICLE2 && (u_filterMode == 2.0 || u_filterMode == 3.0) && color.a < 0.02) {\n    discard;\n  }\n\n  // Alpha key.\n  if (u_emitter == EMITTER_PARTICLE2 && (u_filterMode == 4.0) && color.a < 0.75) {\n    discard;\n  }\n\n  gl_FragColor = color;\n}\n`,fn=t=>new s(t),mn=t=>function(t){if(jt)return jt.decodeAudioData(t)}(t),gn={load(t,e,i=!1){const r=t.gl,n=t.webgl;if(!n.ensureExtension("OES_texture_float"))throw new Error("MDX: No float texture support!");if(!n.ensureExtension("ANGLE_instanced_arrays"))throw new Error("MDX: No instanced rendering support!");const s="#define EXTENDED_BONES\n"+on,a="#define ONLY_DIFFUSE\n"+hn,o="#define ONLY_TEXCOORDS\n"+hn,l="#define ONLY_NORMALS\n"+hn,h="#define EXTENDED_BONES\n"+cn,c="#define SKIN\n"+cn,d="#define ONLY_DIFFUSE\n"+dn,u="#define ONLY_NORMAL_MAP\n"+dn,f="#define ONLY_OCCLUSION\n"+dn,m="#define ONLY_ROUGHNESS\n"+dn,g="#define ONLY_METALLIC\n"+dn,p="#define ONLY_TC_FACTOR\n"+dn,w="#define ONLY_EMISSIVE\n"+dn,v="#define ONLY_TEXCOORDS\n"+dn,b="#define ONLY_NORMALS\n"+dn,y="#define ONLY_TANGENTS\n"+dn,_=n.createShader(on,hn),A=n.createShader(s,hn),x=n.createShader(cn,dn),T=n.createShader(h,dn),E=n.createShader(c,dn),S=n.createShader("\n#define EMITTER_PARTICLE2 0\n#define EMITTER_RIBBON 1\n#define EMITTER_SPLAT 2\n#define EMITTER_UBERSPLAT 3\n#define HEAD 0.0\n\nuniform mat4 u_VP;\nuniform int u_emitter;\n\n// Shared\nuniform vec4 u_colors[3];\nuniform vec3 u_vertices[4];\nuniform vec3 u_intervals[4];\nuniform float u_lifeSpan;\nuniform float u_columns;\nuniform float u_rows;\n\n// Particle2\nuniform vec3 u_scaling;\nuniform vec3 u_cameraZ;\nuniform float u_timeMiddle;\nuniform bool u_teamColored;\n\n// Splat and Uber.\nuniform vec3 u_intervalTimes;\n\n// Vertices\nattribute float a_position;\n\n// Instances\nattribute vec3 a_p0;\nattribute vec3 a_p1;\nattribute vec3 a_p2;\nattribute vec3 a_p3;\nattribute float a_health;\nattribute vec4 a_color;\nattribute float a_tail;\nattribute vec3 a_leftRightTop;\n\nvarying vec2 v_texcoord;\nvarying vec4 v_color;\n\nfloat getCell(vec3 interval, float factor) {\n  float start = interval[0];\n  float end = interval[1];\n  float repeat = interval[2];\n  float spriteCount = end - start;\n\n  if (spriteCount > 0.0) {\n    // Repeating speeds up the sprite animation, which makes it effectively run N times in its interval.\n    // E.g. if repeat is 4, the sprite animation will be seen 4 times, and thus also run 4 times as fast.\n    // The sprite index is limited to the number of actual sprites.\n    return min(start + mod(floor(spriteCount * repeat * factor), spriteCount), u_columns * u_rows - 1.0);\n  }\n\n  return start;\n}\n\nvoid particle2() {\n  float factor = (u_lifeSpan - a_health) / u_lifeSpan;\n  int index = 0;\n\n  if (factor < u_timeMiddle) {\n    factor = factor / u_timeMiddle;\n    index = 0;\n  } else {\n    factor = (factor - u_timeMiddle) / (1.0 - u_timeMiddle);\n    index = 1;\n  }\n\n  factor = min(factor, 1.0);\n\n  float scale = mix(u_scaling[index], u_scaling[index + 1], factor);\n  vec4 color = mix(u_colors[index], u_colors[index + 1], factor);\n\n  float cell = 0.0;\n\n  if (u_teamColored) {\n    cell = a_leftRightTop[0];\n  } else {\n    vec3 interval;\n\n    if (a_tail == HEAD) {\n      interval = u_intervals[index];\n    } else {\n      interval = u_intervals[index + 2];\n    }\n\n    cell = getCell(interval, factor);\n  }\n\n  float left = floor(mod(cell, u_columns));\n  float top = floor(cell / u_columns);\n  float right = left + 1.0;\n  float bottom = top + 1.0;\n\n  left /= u_columns;\n  right /= u_columns;\n  top /= u_rows;\n  bottom /= u_rows;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(right, top);\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(left, top);\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(left, bottom);\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(right, bottom);\n  }\n\n  v_color = color;\n  \n  if (a_tail == HEAD) {\n    vec3 v = u_vertices[int(a_position)];\n    float cs = cos(a_p1.x);\n    float sn = sin(a_p1.x);\n\n    float x = v.x * cs - v.y * sn;\n    float y = v.x * sn + v.y * cs;\n\n    vec3 fv = vec3(\n      v.x * cs - v.y * sn,\n      v.x * sn + v.y * cs,\n      v.z);\n\n    gl_Position = u_VP * vec4(a_p0 + fv * scale, 1.0);\n  } else {\n    // Get the normal to the tail in camera space.\n    // This allows to build a 2D rectangle around the 3D tail.\n    vec3 normal = cross(u_cameraZ, normalize(a_p1 - a_p0));\n    vec3 boundary = normal * scale * a_p2[0];\n    vec3 position;\n\n    if (a_position == 0.0) {\n      position = a_p0 - boundary;\n    } else if (a_position == 1.0) {\n      position = a_p1 - boundary;\n    } else if (a_position == 2.0) {\n      position = a_p1 + boundary;\n    } else if (a_position == 3.0) {\n      position = a_p0 + boundary;\n    }\n\n    gl_Position = u_VP * vec4(position, 1.0);\n  }\n}\n\nvoid ribbon() {\n  vec3 position;\n  float left = a_leftRightTop[0] / 255.0;\n  float right = a_leftRightTop[1] / 255.0;\n  float top = a_leftRightTop[2] / 255.0;\n  float bottom = top + 1.0;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(right, top);\n    position = a_p0;\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(right, bottom);\n    position = a_p1;\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(left, bottom);\n    position = a_p2;\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(left, top);\n    position = a_p3;\n  }\n\n  v_texcoord[0] /= u_columns;\n  v_texcoord[1] /= u_rows;\n\n  v_color = a_color;\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n\nvoid splat() {\n  float factor = u_lifeSpan - a_health;\n  int index;\n\n  if (factor < u_intervalTimes[0]) {\n    factor = factor / u_intervalTimes[0];\n    index = 0;\n  } else {\n    factor = (factor - u_intervalTimes[0]) / u_intervalTimes[1];\n    index = 1;\n  }\n\n  float cell = getCell(u_intervals[index], factor);\n  float left = floor(mod(cell, u_columns));\n  float top = floor(cell / u_columns);\n  float right = left + 1.0;\n  float bottom = top + 1.0;\n  vec3 position;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(left, top);\n    position = a_p0;\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(left, bottom);\n    position = a_p1;\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(right, bottom);\n    position = a_p2;\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(right, top);\n    position = a_p3;\n  }\n\n  v_texcoord[0] /= u_columns;\n  v_texcoord[1] /= u_rows;\n\n  v_color = mix(u_colors[index], u_colors[index + 1], factor) / 255.0;\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n\nvoid ubersplat() {\n  float factor = u_lifeSpan - a_health;\n  vec4 color;\n\n  if (factor < u_intervalTimes[0]) {\n    color = mix(u_colors[0], u_colors[1], factor / u_intervalTimes[0]);\n  } else if (factor < u_intervalTimes[0] + u_intervalTimes[1]) {\n    color = u_colors[1];\n  } else {\n    color = mix(u_colors[1], u_colors[2], (factor - u_intervalTimes[0] - u_intervalTimes[1]) / u_intervalTimes[2]);\n  }\n\n  vec3 position;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(0.0, 0.0);\n    position = a_p0;\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(0.0, 1.0);\n    position = a_p1;\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(1.0, 1.0);\n    position = a_p2;\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(1.0, 0.0);\n    position = a_p3;\n  }\n\n  v_color = color / 255.0;\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n\nvoid main() {\n  if (u_emitter == EMITTER_PARTICLE2) {\n    particle2();\n  } else if (u_emitter == EMITTER_RIBBON) {\n    ribbon();\n  } else if (u_emitter == EMITTER_SPLAT) {\n    splat();\n  } else if (u_emitter == EMITTER_UBERSPLAT) {\n    ubersplat();\n  }\n}\n",un),B=[],I=[];let L=[];L[Gt.Diffuse]=n.createShader(on,a),L[Gt.TexCoords]=n.createShader(on,o),L[Gt.Normals]=n.createShader(on,l),B[Xi.VertexGroups]=L,L=[],L[Gt.Diffuse]=n.createShader(s,a),L[Gt.TexCoords]=n.createShader(s,o),L[Gt.Normals]=n.createShader(s,l),B[Xi.ExtendedVertexGroups]=L,L=[],L[Gt.Diffuse]=n.createShader(cn,d),L[Gt.NormalMap]=n.createShader(cn,u),L[Gt.Occlusion]=n.createShader(cn,f),L[Gt.Roughness]=n.createShader(cn,m),L[Gt.Metallic]=n.createShader(cn,g),L[Gt.TCFactor]=n.createShader(cn,p),L[Gt.Emissive]=n.createShader(cn,w),L[Gt.TexCoords]=n.createShader(cn,v),L[Gt.Normals]=n.createShader(cn,b),L[Gt.Tangents]=n.createShader("#define ONLY_TANGENTS\n"+cn,y),I[Xi.VertexGroups]=L,L=[],L[Gt.Diffuse]=n.createShader(h,d),L[Gt.NormalMap]=n.createShader(h,u),L[Gt.Occlusion]=n.createShader(h,f),L[Gt.Roughness]=n.createShader(h,m),L[Gt.Metallic]=n.createShader(h,g),L[Gt.TCFactor]=n.createShader(h,p),L[Gt.Emissive]=n.createShader(h,w),L[Gt.TexCoords]=n.createShader(h,v),L[Gt.Normals]=n.createShader(h,b),L[Gt.Tangents]=n.createShader("#define ONLY_TANGENTS\n"+h,y),I[Xi.ExtendedVertexGroups]=L,L=[],L[Gt.Diffuse]=n.createShader(c,d),L[Gt.NormalMap]=n.createShader(c,u),L[Gt.Occlusion]=n.createShader(c,f),L[Gt.Roughness]=n.createShader(c,m),L[Gt.Metallic]=n.createShader(c,g),L[Gt.TCFactor]=n.createShader(c,p),L[Gt.Emissive]=n.createShader(c,w),L[Gt.TexCoords]=n.createShader(c,v),L[Gt.Normals]=n.createShader(c,b),L[Gt.Tangents]=n.createShader("#define ONLY_TANGENTS\n"+c,y),I[Xi.Skin]=L;const C=r.createBuffer();r.bindBuffer(r.ARRAY_BUFFER,C),r.bufferData(r.ARRAY_BUFFER,new Uint8Array([0,1,2,0,2,3]),r.STATIC_DRAW);const R={pathSolver:e,reforged:i,sdShader:_,sdExtendedShader:A,hdShader:x,hdExtendedShader:T,hdSkinShader:E,particlesShader:S,sdDebugShaders:B,hdDebugShaders:I,rectBuffer:C,teamColors:[],teamGlows:[],eventObjectTables:{}};t.sharedCache.set("mdx",R)},isValidSource:t=>t instanceof ii||(ti(t)||ei(t)),resource:class extends si{constructor(t,e){let i;if(super(e),this.reforged=!1,this.hd=!1,this.solverParams={},this.name="",this.sequences=[],this.globalSequences=[],this.materials=[],this.layers=[],this.textures=[],this.textureAnimations=[],this.geosets=[],this.geosetAnimations=[],this.bones=[],this.lights=[],this.helpers=[],this.attachments=[],this.pivotPoints=[],this.particleEmitters=[],this.particleEmitters2=[],this.ribbonEmitters=[],this.cameras=[],this.eventObjects=[],this.collisionShapes=[],this.hasLayerAnims=!1,this.hasGeosetAnims=!1,this.batches=[],this.genericObjects=[],this.sortedGenericObjects=[],this.hierarchy=[],this.opaqueGroups=[],this.translucentGroups=[],this.arrayBuffer=null,this.elementBuffer=null,this.skinDataType=0,this.bytesPerSkinElement=1,t instanceof ii)i=t;else{i=new ii;try{i.load(t)}catch(t){}}const r=this.viewer,n=this.pathSolver,s=this.solverParams,a=i.version>800,o=a?".dds":".blp";let l=!1;this.reforged=a,this.name=i.name;const h=i.extent;this.bounds.fromExtents(h.min,h.max);for(const t of i.sequences)this.sequences.push(new ni(t));for(const t of i.globalSequences)this.globalSequences.push(t);for(const t of i.textureAnimations)this.textureAnimations.push(new Ai(this,t));let c=0;for(const t of i.materials){const e=[];for(const i of t.layers){const r=new Ti(this,i,c++,t.priorityPlane);e.push(r),this.layers.push(r)}this.materials.push(new Ei(this,t.shader,e)),""!==t.shader&&(this.hd=!0)}a&&(s.reforged=!0),this.hd&&(s.hd=!0);const d=i.textures;for(let t=0,e=d.length;t<e;t++){const e=d[t];let i=e.path;const a=e.replaceableId,h=e.wrapMode;""===i&&0!==a&&(i=`ReplaceableTextures\\${Bi[a]}${o}`,1!==a&&2!==a||(l=!0));const c=new Gi(a,h);r.load(i,n,s).then((t=>{t&&(c.texture=t)})),this.textures[t]=c}for(const t of i.geosetAnimations)this.geosetAnimations.push(new Si(this,t));this.pivotPoints=i.pivotPoints;let u=0;for(const t of i.bones)this.bones.push(new Li(this,t,u++));for(const t of i.lights)this.lights.push(new Ci(this,t,u++));for(const t of i.helpers)this.helpers.push(new Ri(this,t,u++));for(const t of i.attachments)this.attachments.push(new Mi(this,t,u++));for(const t of i.particleEmitters)this.particleEmitters.push(new Ui(this,t,u++));for(const t of i.particleEmitters2){const e=new zi(this,t,u++);this.particleEmitters2.push(e),e.teamColored&&(l=!0)}for(const t of i.ribbonEmitters)this.ribbonEmitters.push(new ji(this,t,u++));for(const t of i.cameras)this.cameras.push(new Ki(this,t));for(const t of i.eventObjects)this.eventObjects.push(new Hi(this,t,u++));for(const t of i.collisionShapes)this.collisionShapes.push(new $i(this,t,u++));this.genericObjects.push(...this.bones,...this.lights,...this.helpers,...this.attachments,...this.particleEmitters,...this.particleEmitters2,...this.ribbonEmitters,...this.eventObjects,...this.collisionShapes),function(t,e){if(e.length>0){const i=t.viewer.gl;let r=0,n=0,s=0,a=0,o=0,l=0;const h=[];for(let t=0,i=e.length;t<i;t++){const i=e[t];if(0===i.lod||-1===i.lod){const e=i.vertices.length/3;if(r+=12*e,n+=12*e,s+=i.uvSets.length*e*8,i.tangents.length&&(a+=16*e),i.skin.length)o+=8*e,h[t]=Xi.Skin;else{let r=0;for(const t of i.matrixGroups)t>r&&(r=t);r>4?(o+=9*e,h[t]=Xi.ExtendedVertexGroups):(o+=5*e,h[t]=Xi.VertexGroups)}l+=i.faces.byteLength}}let c=0,d=c+r,u=d+n,f=u+s,m=f+a,g=0,p=Uint8Array,w=i.UNSIGNED_BYTE;t.bones.length>255&&(o*=2,p=Uint16Array,w=i.UNSIGNED_SHORT),t.skinDataType=w,t.bytesPerSkinElement=p.BYTES_PER_ELEMENT,t.arrayBuffer=i.createBuffer(),i.bindBuffer(i.ARRAY_BUFFER,t.arrayBuffer),i.bufferData(i.ARRAY_BUFFER,m+o,i.STATIC_DRAW),t.elementBuffer=i.createBuffer(),i.bindBuffer(i.ELEMENT_ARRAY_BUFFER,t.elementBuffer),i.bufferData(i.ELEMENT_ARRAY_BUFFER,l,i.STATIC_DRAW);for(let r=0,n=e.length;r<n;r++){const n=e[r];if(0===n.lod||-1===n.lod){const e=n.vertices,s=n.normals,a=n.uvSets,o=n.tangents,l=n.faces;let w;const v=n.vertices.length/3,b=h[r];if(b===Xi.Skin)w=n.skin;else{const t=n.matrixIndices,e=n.vertexGroups,i=[];let r=0,s=4;b===Xi.ExtendedVertexGroups&&(s=8),w=new p(v*(s+1));for(const e of n.matrixGroups)i.push(t.subarray(r,r+e)),r+=e;for(let t=0;t<v;t++){const n=i[e[t]];if(r=t*(s+1),n){const t=Math.min(n.length,s);for(let e=0;e<t;e++)w[r+e]=n[e]+1;w[r+s]=t}}}const y=new Yi(t,t.geosets.length,c,d,u,f,m,g,v,l.length,n.faceTypeGroups[0]);t.geosets.push(y);const _=t.materials[n.materialId];if("Shader_HD_DefaultUnit"===_.shader)t.batches.push(new qi(t.batches.length,y,_,b,!0));else for(const e of _.layers)t.batches.push(new qi(t.batches.length,y,e,b,!1));i.bufferSubData(i.ARRAY_BUFFER,c,e),c+=e.byteLength,i.bufferSubData(i.ARRAY_BUFFER,d,s),d+=s.byteLength;for(const t of a)i.bufferSubData(i.ARRAY_BUFFER,u,t),u+=t.byteLength;o.length&&(i.bufferSubData(i.ARRAY_BUFFER,f,o),f+=o.byteLength),i.bufferSubData(i.ARRAY_BUFFER,m,w),m+=w.byteLength,i.bufferSubData(i.ELEMENT_ARRAY_BUFFER,g,l),g+=l.byteLength}}}}(this,i.geosets),function(t){const e=[];let i=[];for(const r of t.batches)r.layer.filterMode<2?e.push(r):i.push(r);const r=t.opaqueGroups,n=t.translucentGroups;let s=null;for(const i of e)s&&Ji(s,i)||(s=tr(t,i),r.push(s)),s.objects.push(i.index);i=i.sort(((t,e)=>t.layer.filterMode-e.layer.filterMode));const a=[...i,...t.eventObjects,...t.particleEmitters2,...t.ribbonEmitters].sort(((t,e)=>Qi(t)-Qi(e)));s=null;for(const e of a)(e instanceof qi||-1!==e.geometryEmitterType)&&(s&&Ji(s,e)||(s=tr(t,e),n.push(s)),s.objects.push(e.index))}(this),this.setupHierarchy(-1);for(let t=0,e=this.genericObjects.length;t<e;t++)this.sortedGenericObjects[t]=this.genericObjects[this.hierarchy[t]];l&&gn.loadTeamTextures(r)}addInstance(){return new nn(this)}setupHierarchy(t){for(let e=0,i=this.genericObjects.length;e<i;e++){const i=this.genericObjects[e];i.parentId===t&&(this.hierarchy.push(e),this.setupHierarchy(i.objectId))}}},loadTeamTextures(t){const{pathSolver:e,reforged:i,teamColors:r,teamGlows:n}=t.sharedCache.get("mdx");if(0===r.length){const s=i?28:16,a=i?"dds":"blp",o=i?{reforged:!0}:void 0;for(let i=0;i<s;i++){const s=`${`${i}`.padStart(2,"0")}.${a}`,l=new Gi(1,3),h=new Gi(2,3);t.load(`ReplaceableTextures\\TeamColor\\TeamColor${s}`,e,o).then((t=>l.texture=t)),t.load(`ReplaceableTextures\\TeamGlow\\TeamGlow${s}`,e,o).then((t=>h.texture=t)),r[i]=l,n[i]=h}}},getEventObjectSoundFile(t,i,r,n){if(!i||".flac"===e(t))return t;for(let e=1,i=n.length;e<i;e++){const i=n[e].data.getRow(t);if(i){const t=i.Flags,e=i.Filepath;if("SD_ONLY"===t){if(!r)return e}else{if("HD_ONLY"!==t)return e;if(r)return e}}}},async getEventObjectData(t,e,i,r){if("SPN"!==e&&"SPL"!==e&&"UBR"!==e&&"SND"!==e)return;const{pathSolver:n,reforged:s,eventObjectTables:a}=t.sharedCache.get("mdx"),o=s?{reforged:!0}:void 0,l=(t,e)=>n?n(t,e):t;if(!a[e]){const i=[];"SPN"===e?i.push("Splats\\SpawnData.slk"):"SPL"===e?i.push("Splats\\SplatData.slk"):"UBR"===e?i.push("Splats\\UberSplatData.slk"):"SND"===e&&(i.push("UI\\SoundInfo\\AnimSounds.slk"),s?i.push("UI\\SoundInfo\\DialogueHumanBase.slk","UI\\SoundInfo\\DialogueOrcBase.slk","UI\\SoundInfo\\DialogueUndeadBase.slk","UI\\SoundInfo\\DialogueNightElfBase.slk","UI\\SoundInfo\\DialogueNagaBase.slk","UI\\SoundInfo\\DialogueDemonBase.slk","UI\\SoundInfo\\DialogueCreepsBase.slk"):i.push("UI\\SoundInfo\\AnimLookups.slk"));const r=i.map((e=>t.loadGeneric(l(e,o),"text",fn))),n=await Promise.all(r);for(const t of n)if(!t)return;a[e]=n}const h=a[e],c=h[0].data;let d;const u=[];if("SND"===e){if(s)d=c.findRow("AnimationEventCode",i);else{const t=h[1].data.getRow(i);t&&(d=c.getRow(t.SoundLabel))}if(d)for(const e of d.FileNames.split(",")){const i=this.getEventObjectSoundFile(e,s,r,h);i&&u.push(t.loadGeneric(l(i,o),"arrayBuffer",mn))}}else d=c.getRow(i),d&&("SPN"===e?u.push(t.load(d.Model.replace(".mdl",".mdx"),l,o)):"SPL"!==e&&"UBR"!==e||u.push(t.load(`ReplaceableTextures\\Splats\\${d.file}${s?".dds":".blp"}`,l,o)));if(d&&u.length){const t=(await Promise.all(u)).filter((t=>t));if(t.length)return{row:d,resources:t}}},getBatchShader(t,e,i){const r=t.sharedCache.get("mdx"),n=t.debugRenderMode;if(i){if(n!==Gt.None){const t=r.hdDebugShaders[e];if(t){const e=t[n];if(e)return e}}return e===Xi.Skin?r.hdSkinShader:e===Xi.VertexGroups?r.hdShader:r.hdExtendedShader}if(n!==Gt.None){const t=r.sdDebugShaders[e];if(t){const e=t[n];if(e)return e}}return e===Xi.VertexGroups?r.sdShader:r.sdExtendedShader}};class pn{constructor(t,e,i){this.index=0,this.bitBuffer=0,this.bits=0;const r=Yt(t);e=e||0,i=i||r.length,this.buffer=t,this.uint8array=r.subarray(e,e+i),this.byteLength=t.byteLength}peekBits(t){return this.loadBits(t),this.bitBuffer&(1<<t)-1}readBits(t){const e=this.peekBits(t);return this.bitBuffer>>>=t,this.bits-=t,e}skipBits(t){this.loadBits(t),this.bitBuffer>>>=t,this.bits-=t}loadBits(t){for(;this.bits<t;)this.bitBuffer+=this.uint8array[this.index]<<this.bits,this.bits+=8,this.index+=1}}function wn(t,e){return((1<<e)-1)/((1<<t)-1)}let vn="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},bn=function(){function t(t){this.message="JPEG error: "+t}return t.prototype=new Error,t.prototype.name="JpegError",t.constructor=t,t}(),yn=new Uint8Array([0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5,12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28,35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63]),_n=4017,An=799,xn=3406,Tn=2276,En=1567,Sn=3784,Bn=5793,In=2896;function Ln(t,e){let i,r,n=0,s=[],a=16;for(;a>0&&!t[a-1];)a--;s.push({children:[],index:0});let o,l=s[0];for(i=0;i<a;i++){for(r=0;r<t[i];r++){for(l=s.pop(),l.children[l.index]=e[n];l.index>0;)l=s.pop();for(l.index++,s.push(l);s.length<=i;)s.push(o={children:[],index:0}),l.children[l.index]=o.children,l=o;n++}i+1<a&&(s.push(o={children:[],index:0}),l.children[l.index]=o.children,l=o)}return s[0].children}function Cn(t,e,i){return 64*((t.blocksPerLine+1)*e+i)}function Rn(t,e,i,r,n,s,a,o,l){let h=i.mcusPerLine,c=i.progressive,d=e,u=0,f=0;function m(){if(f>0)return f--,u>>f&1;if(u=t[e++],255===u){let i=t[e++];if(i)throw new bn("unexpected marker "+(u<<8|i).toString(16))}return f=7,u>>>7}function g(t){let e=t;for(;;){if(e=e[m()],"number"==typeof e)return e;if("object"!==(void 0===e?"undefined":vn(e)))throw new bn("invalid huffman sequence")}}function p(t){let e=0;for(;t>0;)e=e<<1|m(),t--;return e}function w(t){if(1===t)return 1===m()?1:-1;let e=p(t);return e>=1<<t-1?e:e+(-1<<t)+1}let v=0;let b,y=0;function _(t,e,i,r,n){let s=i%h;e(t,Cn(t,(i/h|0)*t.v+r,s*t.h+n))}function A(t,e,i){e(t,Cn(t,i/t.blocksPerLine|0,i%t.blocksPerLine))}let x,T,E,S,B,I,L=r.length;I=c?0===s?0===o?function(t,e){let i=g(t.huffmanTableDC),r=0===i?0:w(i)<<l;t.blockData[e]=t.pred+=r}:function(t,e){t.blockData[e]|=m()<<l}:0===o?function(t,e){if(v>0)return void v--;let i=s,r=a;for(;i<=r;){let r=g(t.huffmanTableAC),n=15&r,s=r>>4;if(0===n){if(s<15){v=p(s)+(1<<s)-1;break}i+=16;continue}i+=s;let a=yn[i];t.blockData[e+a]=w(n)*(1<<l),i++}}:function(t,e){let i,r,n=s,o=a,h=0;for(;n<=o;){let s=yn[n];switch(y){case 0:if(r=g(t.huffmanTableAC),i=15&r,h=r>>4,0===i)h<15?(v=p(h)+(1<<h),y=4):(h=16,y=1);else{if(1!==i)throw new bn("invalid ACn encoding");b=w(i),y=h?2:3}continue;case 1:case 2:t.blockData[e+s]?t.blockData[e+s]+=m()<<l:(h--,0===h&&(y=2===y?3:0));break;case 3:t.blockData[e+s]?t.blockData[e+s]+=m()<<l:(t.blockData[e+s]=b<<l,y=0);break;case 4:t.blockData[e+s]&&(t.blockData[e+s]+=m()<<l)}n++}4===y&&(v--,0===v&&(y=0))}:function(t,e){let i=g(t.huffmanTableDC),r=0===i?0:w(i);t.blockData[e]=t.pred+=r;let n=1;for(;n<64;){let i=g(t.huffmanTableAC),r=15&i,s=i>>4;if(0===r){if(s<15)break;n+=16;continue}n+=s;let a=yn[n];t.blockData[e+a]=w(r),n++}};let C,R,M,U,k=0;for(R=1===L?r[0].blocksPerLine*r[0].blocksPerColumn:h*i.mcusPerColumn;k<R;){let i=n?Math.min(R-k,n):R;for(T=0;T<L;T++)r[T].pred=0;if(v=0,1===L)for(x=r[0],B=0;B<i;B++)A(x,I,k),k++;else for(B=0;B<i;B++){for(T=0;T<L;T++)for(x=r[T],M=x.h,U=x.v,E=0;E<U;E++)for(S=0;S<M;S++)_(x,I,k,E,S);k++}f=0,C=kn(t,e),C&&C.invalid&&(e=C.offset);let s=C&&C.marker;if(!s||s<=65280)throw new bn("marker was not found");if(!(s>=65488&&s<=65495))break;e+=2}return C=kn(t,e),C&&C.invalid&&(e=C.offset),e-d}function Mn(t,e,i){let r,n,s,a,o,l,h,c,d,u,f,m,g,p,w,v,b,y=t.quantizationTable,_=t.blockData;if(!y)throw new bn("missing required Quantization Table.");for(let t=0;t<64;t+=8)d=_[e+t],u=_[e+t+1],f=_[e+t+2],m=_[e+t+3],g=_[e+t+4],p=_[e+t+5],w=_[e+t+6],v=_[e+t+7],d*=y[t],0!=(u|f|m|g|p|w|v)?(u*=y[t+1],f*=y[t+2],m*=y[t+3],g*=y[t+4],p*=y[t+5],w*=y[t+6],v*=y[t+7],r=Bn*d+128>>8,n=Bn*g+128>>8,s=f,a=w,o=In*(u-v)+128>>8,c=In*(u+v)+128>>8,l=m<<4,h=p<<4,r=r+n+1>>1,n=r-n,b=s*Sn+a*En+128>>8,s=s*En-a*Sn+128>>8,a=b,o=o+h+1>>1,h=o-h,c=c+l+1>>1,l=c-l,r=r+a+1>>1,a=r-a,n=n+s+1>>1,s=n-s,b=o*Tn+c*xn+2048>>12,o=o*xn-c*Tn+2048>>12,c=b,b=l*An+h*_n+2048>>12,l=l*_n-h*An+2048>>12,h=b,i[t]=r+c,i[t+7]=r-c,i[t+1]=n+h,i[t+6]=n-h,i[t+2]=s+l,i[t+5]=s-l,i[t+3]=a+o,i[t+4]=a-o):(b=Bn*d+512>>10,i[t]=b,i[t+1]=b,i[t+2]=b,i[t+3]=b,i[t+4]=b,i[t+5]=b,i[t+6]=b,i[t+7]=b);for(let t=0;t<8;++t)d=i[t],u=i[t+8],f=i[t+16],m=i[t+24],g=i[t+32],p=i[t+40],w=i[t+48],v=i[t+56],0!=(u|f|m|g|p|w|v)?(r=Bn*d+2048>>12,n=Bn*g+2048>>12,s=f,a=w,o=In*(u-v)+2048>>12,c=In*(u+v)+2048>>12,l=m,h=p,r=4112+(r+n+1>>1),n=r-n,b=s*Sn+a*En+2048>>12,s=s*En-a*Sn+2048>>12,a=b,o=o+h+1>>1,h=o-h,c=c+l+1>>1,l=c-l,r=r+a+1>>1,a=r-a,n=n+s+1>>1,s=n-s,b=o*Tn+c*xn+2048>>12,o=o*xn-c*Tn+2048>>12,c=b,b=l*An+h*_n+2048>>12,l=l*_n-h*An+2048>>12,h=b,d=r+c,v=r-c,u=n+h,w=n-h,f=s+l,p=s-l,m=a+o,g=a-o,d=d<16?0:d>=4080?255:d>>4,u=u<16?0:u>=4080?255:u>>4,f=f<16?0:f>=4080?255:f>>4,m=m<16?0:m>=4080?255:m>>4,g=g<16?0:g>=4080?255:g>>4,p=p<16?0:p>=4080?255:p>>4,w=w<16?0:w>=4080?255:w>>4,v=v<16?0:v>=4080?255:v>>4,_[e+t]=d,_[e+t+8]=u,_[e+t+16]=f,_[e+t+24]=m,_[e+t+32]=g,_[e+t+40]=p,_[e+t+48]=w,_[e+t+56]=v):(b=Bn*d+8192>>14,b=b<-2040?0:b>=2024?255:b+2056>>4,_[e+t]=b,_[e+t+8]=b,_[e+t+16]=b,_[e+t+24]=b,_[e+t+32]=b,_[e+t+40]=b,_[e+t+48]=b,_[e+t+56]=b)}function Un(t,e){let i=e.blocksPerLine,r=e.blocksPerColumn,n=new Int16Array(64);for(let t=0;t<r;t++)for(let r=0;r<i;r++){Mn(e,Cn(e,t,r),n)}return e.blockData}function kn(t,e,i){function r(e){return t[e]<<8|t[e+1]}let n=t.length-1,s=i<e?i:e;if(e>=n)return null;let a=r(e);if(a>=65472&&a<=65534)return{invalid:null,marker:a,offset:e};let o=r(s);for(;!(o>=65472&&o<=65534);){if(++s>=n)return null;o=r(s)}return{invalid:a.toString(16),marker:o,offset:s}}class Fn{constructor(){this.decodeTransform=null,this.colorTransform=-1,this.width=0,this.height=0}parse(t){function e(){let e=t[n]<<8|t[n+1];return n+=2,e}function i(){let i=e(),r=n+i-2,s=kn(t,r,n);s&&s.invalid&&(r=s.offset);let a=t.subarray(n,r);return n+=a.length,a}function r(t){let e=Math.ceil(t.samplesPerLine/8/t.maxH),i=Math.ceil(t.scanLines/8/t.maxV);for(let r=0;r<t.components.length;r++){x=t.components[r];let n=Math.ceil(Math.ceil(t.samplesPerLine/8)*x.h/t.maxH),s=Math.ceil(Math.ceil(t.scanLines/8)*x.v/t.maxV),a=e*x.h,o=64*(i*x.v)*(a+1);x.blockData=new Int16Array(o),x.blocksPerLine=n,x.blocksPerColumn=s}t.mcusPerLine=e,t.mcusPerColumn=i}var n=0;let s,a,o=null,l=null,h=[],c=[],d=[],u=e();if(65496!==u)throw new bn("SOI not found");for(u=e();65497!==u;){var f,m,g;switch(u){case 65504:case 65505:case 65506:case 65507:case 65508:case 65509:case 65510:case 65511:case 65512:case 65513:case 65514:case 65515:case 65516:case 65517:case 65518:case 65519:case 65534:var p=i();65504===u&&74===p[0]&&70===p[1]&&73===p[2]&&70===p[3]&&0===p[4]&&(o={version:{major:p[5],minor:p[6]},densityUnits:p[7],xDensity:p[8]<<8|p[9],yDensity:p[10]<<8|p[11],thumbWidth:p[12],thumbHeight:p[13],thumbData:p.subarray(14,14+3*p[12]*p[13])}),65518===u&&65===p[0]&&100===p[1]&&111===p[2]&&98===p[3]&&101===p[4]&&(l={version:p[5]<<8|p[6],flags0:p[7]<<8|p[8],flags1:p[9]<<8|p[10],transformCode:p[11]});break;case 65499:for(var w=e()+n-2;n<w;){let i=t[n++],r=new Uint16Array(64);if(i>>4==0)for(m=0;m<64;m++)r[yn[m]]=t[n++];else{if(i>>4!=1)throw new bn("DQT - invalid table spec");for(m=0;m<64;m++)r[yn[m]]=e()}h[15&i]=r}break;case 65472:case 65473:case 65474:if(s)throw new bn("Only single frame JPEGs supported");e(),s={},s.extended=65473===u,s.progressive=65474===u,s.precision=t[n++],s.scanLines=e(),s.samplesPerLine=e(),s.components=[],s.componentIds={};var v,b=t[n++],y=0,_=0;for(f=0;f<b;f++){v=t[n];let e=t[n+1]>>4,i=15&t[n+1];y<e&&(y=e),_<i&&(_=i);let r=t[n+2];g=s.components.push({h:e,v:i,quantizationId:r,quantizationTable:null}),s.componentIds[v]=g-1,n+=3}s.maxH=y,s.maxV=_,r(s);break;case 65476:var A=e();for(f=2;f<A;){let e=t[n++],i=new Uint8Array(16),r=0;for(m=0;m<16;m++,n++)r+=i[m]=t[n];let s=new Uint8Array(r);for(m=0;m<r;m++,n++)s[m]=t[n];f+=17+r,(e>>4==0?d:c)[15&e]=Ln(i,s)}break;case 65501:e(),a=e();break;case 65498:e();var x,T=t[n++],E=[];for(f=0;f<T;f++){let e=s.componentIds[t[n++]];x=s.components[e];let i=t[n++];x.huffmanTableDC=d[i>>4],x.huffmanTableAC=c[15&i],E.push(x)}var S=t[n++],B=t[n++],I=t[n++],L=Rn(t,n,s,E,a,S,B,I>>4,15&I);n+=L;break;case 65535:255!==t[n]&&n--;break;default:if(255===t[n-3]&&t[n-2]>=192&&t[n-2]<=254){n-=3;break}throw new bn("unknown marker "+u.toString(16))}u=e()}for(this.width=s.samplesPerLine,this.height=s.scanLines,this.jfif=o,this.adobe=l,this.components=[],f=0;f<s.components.length;f++){let t=h[(x=s.components[f]).quantizationId];t&&(x.quantizationTable=t),this.components.push({output:Un(0,x),scaleX:x.h/s.maxH,scaleY:x.v/s.maxV,blocksPerLine:x.blocksPerLine,blocksPerColumn:x.blocksPerColumn})}this.numComponents=this.components.length}getData(t){let e=t.data,i=this.components,r=new Uint8Array((i[0].blocksPerLine<<3)*i[0].blocksPerColumn*8);[i[0],i[2]]=[i[2],i[0]];for(let t=0,o=i.length;t<o;t++){let l=i[t],h=l.blocksPerLine,c=l.blocksPerColumn,d=h<<3;var n,s,a=0;for(let t=0;t<c;t++){let e=t<<3;for(let i=0;i<h;i++){let o=Cn(l,t,i),h=0,c=i<<3;for(n=0;n<8;n++){a=(e+n)*d;for(s=0;s<8;s++)r[a+c+s]=l.output[o+h++]}}}let u=t;for(let t=0;t<this.height;t++)for(let i=0;i<this.width;i++)e[u]=r[t*d+i],u+=o}return e}}class Dn{constructor(){this.content=0,this.alphaBits=0,this.width=0,this.height=0,this.type=0,this.hasMipmaps=!1,this.mipmapOffsets=new Uint32Array(16),this.mipmapSizes=new Uint32Array(16),this.uint8array=null,this.jpgHeader=null,this.pallete=null}load(t){const e=Yt(t),i=new Int32Array(e.buffer,0,40);if(827345986!==i[0])throw new Error("WrongMagicNumber");this.content=i[1],this.alphaBits=i[2],this.width=i[3],this.height=i[4],this.type=i[5],this.hasMipmaps=0!==i[6];for(let t=0;t<16;t++)this.mipmapOffsets[t]=i[7+t],this.mipmapSizes[t]=i[23+t];this.uint8array=e,0===this.content?this.jpgHeader=e.subarray(160,160+i[39]):this.pallete=e.subarray(156,1180)}getMipmap(t){const e=this.uint8array,i=this.mipmapOffsets[t],r=this.mipmapSizes[t];let n;if(0===this.content){const t=this.jpgHeader,s=new Uint8Array(t.length+r),a=new Fn;s.set(t),s.set(e.subarray(i,i+r),t.length),a.parse(s),n=new ImageData(a.width,a.height),a.getData(n)}else{const r=this.pallete,s=Math.max(this.width/(1<<t),1),a=Math.max(this.height/(1<<t),1),o=s*a;let l,h=this.alphaBits,c=0;n=new ImageData(s,a),h>0&&(h>8&&(h=8),l=new pn(e.buffer,i+o,Math.ceil(o*h/8)),c=wn(h,8));const d=n.data;for(let t=0;t<o;t++){const n=4*t,s=4*e[i+t];d[n]=r[s+2],d[n+1]=r[s+1],d[n+2]=r[s],d[n+3]=h>0?l.readBits(h)*c:255}}return n}mipmaps(){let t=0;for(const e of this.mipmapSizes)e>0&&(t+=1);return t}fakeMipmaps(){const t=this.mipmapOffsets;let e=0;for(let i=0;i<16;i++){const r=t[i];if(r>0)for(let n=i+1;n<16;n++)if(r===t[n]){e+=1;break}}return e}}const Pn={isValidSource(t){return t instanceof Dn||((e=t)instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&66===e[0]&&76===e[1]&&80===e[2]&&49===e[3]);var e},resource:class extends kt{constructor(t,e){let i;super(e),t instanceof Dn?i=t:(i=new Dn,i.load(t));const r=this.viewer.gl,n=r.createTexture();r.bindTexture(r.TEXTURE_2D,n),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.LINEAR);const s=Mt(i.width)&&Mt(i.height);s||(r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,r.CLAMP_TO_EDGE),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,r.CLAMP_TO_EDGE));const a=i.mipmaps();if(1===a||i.fakeMipmaps()||!s){const t=i.getMipmap(0);r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.LINEAR),r.texImage2D(r.TEXTURE_2D,0,r.RGBA,r.RGBA,r.UNSIGNED_BYTE,t)}else{r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.LINEAR_MIPMAP_LINEAR);let t=i.width,e=i.height;for(let n=0;n<a;n++){const s=i.getMipmap(n);r.texImage2D(r.TEXTURE_2D,n,r.RGBA,t,e,0,r.RGBA,r.UNSIGNED_BYTE,s.data),t=Math.ceil(t/2),e=Math.ceil(e/2)}}this.width=i.width,this.height=i.height,this.webglResource=n}}};class Nn{constructor(){this.width=0,this.height=0,this.data=null}load(t){const e=Yt(t),i=new class{_checkHeader(){const t=this.header;if(0===t.imageType)throw Error("No data");if(t.hasColorMap){if(t.colorMapLength>256||24!==t.colorMapDepth||1!==t.colorMapType)throw Error("Invalid colormap for indexed type")}else if(t.colorMapType)throw Error("Why does the image contain a palette ?");if(!t.width||!t.height)throw Error("Invalid image size");if(8!==t.pixelDepth&&16!==t.pixelDepth&&24!==t.pixelDepth&&32!==t.pixelDepth)throw Error('Invalid pixel size "'+t.pixelDepth+'"')}_decodeRLE(t,e,i,r){const n=new Uint8Array(r),s=new Uint8Array(i);let a=0;for(;a<r;){const r=t[e++];let o=1+(127&r);if(128&r){for(let r=0;r<i;++r)s[r]=t[e+r];e+=i;for(let t=0;t<o;++t)n.set(s,a),a+=i}else{o*=i;for(let i=0;i<o;++i)n[a+i]=t[e+i];a+=o,e+=o}}return n}_getImageData8bits(t,e,i,r,n,s,a,o,l,h){for(let c=0,d=n;d!==a;d+=s)for(let n=o;n!==h;n+=l,c++){const s=e[c];t[4*(n+r*d)+3]=255,t[4*(n+r*d)+2]=i[3*s+0],t[4*(n+r*d)+1]=i[3*s+1],t[4*(n+r*d)+0]=i[3*s+2]}return t}_getImageData16bits(t,e,i,r,n,s,a,o,l,h){for(let i=0,c=n;c!==a;c+=s)for(let n=o;n!==h;n+=l,i+=2){const s=e[i+0]|e[i+1]<<8;t[4*(n+r*c)+0]=(31744&s)>>7,t[4*(n+r*c)+1]=(992&s)>>2,t[4*(n+r*c)+2]=(31&s)>>3,t[4*(n+r*c)+3]=32768&s?0:255}return t}_getImageData24bits(t,e,i,r,n,s,a,o,l,h){for(let i=0,c=n;c!==a;c+=s)for(let n=o;n!==h;n+=l,i+=3)t[4*(n+r*c)+3]=255,t[4*(n+r*c)+2]=e[i+0],t[4*(n+r*c)+1]=e[i+1],t[4*(n+r*c)+0]=e[i+2];return t}_getImageData32bits(t,e,i,r,n,s,a,o,l,h){for(let i=0,c=n;c!==a;c+=s)for(let n=o;n!==h;n+=l,i+=4)t[4*(n+r*c)+2]=e[i+0],t[4*(n+r*c)+1]=e[i+1],t[4*(n+r*c)+0]=e[i+2],t[4*(n+r*c)+3]=e[i+3];return t}_getImageDataGrey8bits(t,e,i,r,n,s,a,o,l,h){for(let i=0,c=n;c!==a;c+=s)for(let n=o;n!==h;n+=l,i++){const s=e[i];t[4*(n+r*c)+0]=s,t[4*(n+r*c)+1]=s,t[4*(n+r*c)+2]=s,t[4*(n+r*c)+3]=255}return t}_getImageDataGrey16bits(t,e,i,r,n,s,a,o,l,h){for(let i=0,c=n;c!==a;c+=s)for(let n=o;n!==h;n+=l,i+=2)t[4*(n+r*c)+0]=e[i+0],t[4*(n+r*c)+1]=e[i+0],t[4*(n+r*c)+2]=e[i+0],t[4*(n+r*c)+3]=e[i+1];return t}open(t,e){const i=new XMLHttpRequest;i.responseType="arraybuffer",i.open("GET",t,!0),i.onload=()=>{200===i.status&&(this.load(new Uint8Array(i.response)),e&&e())},i.send(null)}load(t){let e=0;if(t.length<18)throw Error("Not enough data to contain header");const i={idLength:t[e++],colorMapType:t[e++],imageType:t[e++],colorMapIndex:t[e++]|t[e++]<<8,colorMapLength:t[e++]|t[e++]<<8,colorMapDepth:t[e++],offsetX:t[e++]|t[e++]<<8,offsetY:t[e++]|t[e++]<<8,width:t[e++]|t[e++]<<8,height:t[e++]|t[e++]<<8,pixelDepth:t[e++],flags:t[e++]};if(i.hasEncoding=9===i.imageType||10===i.imageType||11===i.imageType,i.hasColorMap=9===i.imageType||1===i.imageType,i.isGreyColor=11===i.imageType||3===i.imageType,this.header=i,this._checkHeader(),(e+=i.idLength)>=t.length)throw Error("No data");if(i.hasColorMap){const r=i.colorMapLength*(i.colorMapDepth>>3);this.palette=t.subarray(e,e+r),e+=r}const r=i.pixelDepth>>3,n=i.width*i.height,s=n*r;i.hasEncoding?this.imageData=this._decodeRLE(t,e,r,s):this.imageData=t.subarray(e,e+(i.hasColorMap?n:s))}getImageData(t){const{width:e,height:i,flags:r,pixelDepth:n,isGreyColor:s}=this.header,a=(48&r)>>4;let o,l,h,c,d,u,f;switch(t||(t=document?document.createElement("canvas").getContext("2d").createImageData(e,i):{width:e,height:i,data:new Uint8ClampedArray(e*i*4)}),2===a||3===a?(c=0,d=1,u=i):(c=i-1,d=-1,u=-1),2===a||0===a?(o=0,l=1,h=e):(o=e-1,l=-1,h=-1),n){case 8:f=s?this._getImageDataGrey8bits:this._getImageData8bits;break;case 16:f=s?this._getImageDataGrey16bits:this._getImageData16bits;break;case 24:f=this._getImageData24bits;break;case 32:f=this._getImageData32bits}return f.call(this,t.data,this.imageData,this.palette,e,c,d,u,o,l,h),t}getCanvas(){const{width:t,height:e}=this.header,i=document.createElement("canvas"),r=i.getContext("2d"),n=r.createImageData(t,e);return i.width=t,i.height=e,r.putImageData(this.getImageData(n),0,0),i}getDataURL(t){return this.getCanvas().toDataURL(t||"image/png")}};i.load(e);const r=i.header;this.width=r.width,this.height=r.height,this.data=new ImageData(r.width,r.height),i.getImageData(this.data)}}const On={isValidSource(t){return t instanceof Nn||((e=t)instanceof ArrayBuffer&&(e=new Uint8Array(e)),!!(e instanceof Uint8Array&&Wt(e,"TRUEVISION-XFILE.\0",e.length-18)));var e},resource:class extends kt{constructor(t,e){let i;super(e),t instanceof Nn?i=t:(i=new Nn,i.load(t));const r=i.width,n=i.height,s=this.viewer.gl,a=s.createTexture();s.bindTexture(s.TEXTURE_2D,a),s.texImage2D(s.TEXTURE_2D,0,s.RGBA,s.RGBA,s.UNSIGNED_BYTE,i.data),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MAG_FILTER,s.LINEAR),Mt(r)&&Mt(n)?(s.generateMipmap(s.TEXTURE_2D),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MIN_FILTER,s.LINEAR_MIPMAP_LINEAR)):s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MIN_FILTER,s.LINEAR),this.webglResource=a,this.width=r,this.height=n}}},Vn=wn(4,8),Gn=wn(5,8),zn=wn(6,8),jn=new Uint8Array(16),Kn=new Uint8Array(12),Hn=new Uint8Array(8),$n=new Uint8Array(8),Xn=new Uint8Array(8);function qn(t,e,i){const r=(e>>11&31)*Gn,n=(e>>5&63)*zn,s=(31&e)*Gn,a=(i>>11&31)*Gn,o=(i>>5&63)*zn,l=(31&i)*Gn;t[0]=r,t[1]=n,t[2]=s,t[3]=255,t[4]=a,t[5]=o,t[6]=l,t[7]=255,e>i?(t[8]=5*r+3*a>>3,t[9]=5*n+3*o>>3,t[10]=5*s+3*l>>3,t[11]=255,t[12]=5*a+3*r>>3,t[13]=5*o+3*n>>3,t[14]=5*l+3*s>>3,t[15]=255):(t[8]=r+a>>1,t[9]=n+o>>1,t[10]=s+l>>1,t[11]=255,t[12]=0,t[13]=0,t[14]=0,t[15]=0)}function Yn(t,e,i){const r=(e>>11&31)*Gn,n=(e>>5&63)*zn,s=(31&e)*Gn,a=(i>>11&31)*Gn,o=(i>>5&63)*zn,l=(31&i)*Gn;t[0]=r,t[1]=n,t[2]=s,t[3]=a,t[4]=o,t[5]=l,t[6]=5*r+3*a>>3,t[7]=5*n+3*o>>3,t[8]=5*s+3*l>>3,t[9]=5*a+3*r>>3,t[10]=5*o+3*n>>3,t[11]=5*l+3*s>>3}function Wn(t,e,i){t[0]=e,t[1]=i,e>i?(t[2]=54*e+9*i>>6,t[3]=45*e+18*i>>6,t[4]=36*e+27*i>>6,t[5]=27*e+36*i>>6,t[6]=18*e+45*i>>6,t[7]=9*e+54*i>>6):(t[2]=12*e+3*i>>4,t[3]=9*e+6*i>>4,t[4]=6*e+9*i>>4,t[5]=3*e+12*i>>4,t[6]=0,t[7]=255)}function Zn(t,e,i){t[0]=e,t[1]=i,e>i?(t[2]=(6*e+1*i)/7,t[3]=(5*e+2*i)/7,t[4]=(4*e+3*i)/7,t[5]=(3*e+4*i)/7,t[6]=(2*e+5*i)/7,t[7]=(1*e+6*i)/7):(t[2]=(4*e+1*i)/5,t[3]=(3*e+2*i)/5,t[4]=(2*e+3*i)/5,t[5]=(1*e+4*i)/5,t[6]=0,t[7]=1)}const Qn=827611204,Jn=861165636,ts=894720068,es=843666497;class is{constructor(){this.width=0,this.height=0,this.format=0,this.mipmapWidths=[],this.mipmapHeights=[],this.mipmapDatas=[]}load(t){const e=Yt(t),i=new Int32Array(e.buffer,0,31);let r=128;if(542327876!==i[0])throw new Error("Wrong magic number");if(!(4&i[20]))throw new Error("Not FourCC");let n=i[21];if(n!==Qn&&n!==Jn&&n!==ts&&n!==es){if(808540228!==n)throw new Error(`Unsupported FourCC: ${function(t){const e=[];for(;t>0;)e.push(String.fromCharCode(t%256)),t=Math.floor(t/256);return e.reverse().join("")}(n)}`);{r+=20;const t=new Int32Array(e.buffer,128,5),i=t[0];if(71===i)n=Qn;else if(74===i)n=Jn;else if(77===i)n=ts;else{if(83!==i)throw new Error(`Unsupported DXGI format: ${i}`);n=es}console.log(t)}}this.format=n;let s=1;131072&i[2]&&(s=Math.max(1,i[7]));let a=i[4],o=i[3],l=16;n===Qn&&(l=8),this.width=a,this.height=o;for(let t=0;t<s;t++){const i=Math.max(4,a)/4*Math.max(4,o)/4*l;this.mipmapWidths[t]=a,this.mipmapHeights[t]=o,this.mipmapDatas[t]=e.subarray(r,r+i),r+=i,a=Math.max(a/2,1),o=Math.max(o/2,1)}}mipmaps(){return this.mipmapDatas.length}getMipmap(t,e=!1){const i=this.mipmapWidths[t],r=this.mipmapHeights[t],n=this.mipmapDatas[t];let s;return s=e?n:this.format===Qn?function(t,e,i){const r=new Uint8Array(e*i*4);for(let n=0,s=i/4;n<s;n++)for(let i=0,s=e/4;i<s;i++){const a=8*(n*s+i);qn(jn,t[a]+256*t[a+1],t[a+2]+256*t[a+3]);const o=16*n*e+16*i,l=t[a+4]|t[a+5]<<8|t[a+6]<<16|t[a+7]<<24;for(let t=0;t<4;t++){const i=8*t,n=o+t*e*4;for(let t=0;t<4;t++){const e=n+4*t,s=4*(l>>i+2*t&3);r[e+0]=jn[s+0],r[e+1]=jn[s+1],r[e+2]=jn[s+2],r[e+3]=jn[s+3]}}}return r}(n,i,r):this.format===Jn?function(t,e,i){const r=new Uint8Array(e*i*4),n=4*e;for(let s=0,a=i/4;s<a;s++)for(let i=0,a=e/4;i<a;i++){const o=16*(s*a+i);Yn(Kn,t[o+8]+256*t[o+9],t[o+10]+256*t[o+11]);let l=16*s*e+16*i;for(let e=0;e<4;e++){const i=t[o+2*e]+256*t[o+1+2*e],s=t[o+12+e];for(let t=0;t<4;t++){const e=l+4*t,n=3*(s>>2*t&3);r[e+0]=Kn[n+0],r[e+1]=Kn[n+1],r[e+2]=Kn[n+2],r[e+3]=(i>>4*t&15)*Vn}l+=n}}return r}(n,i,r):this.format===ts?function(t,e,i){const r=new Uint8Array(e*i*4),n=4*e;for(let s=0,a=i/4;s<a;s++)for(let i=0,a=e/4;i<a;i++){const o=16*(s*a+i);Wn(Hn,t[o],t[o+1]),Yn(Kn,t[o+8]+256*t[o+9],t[o+10]+256*t[o+11]);let l=16*s*e+16*i;for(let e=0;e<2;e++){const i=o+2+3*e,s=o+12+2*e,a=t[i]+256*(t[i+1]+256*t[i+2]);for(let e=0;e<2;e++){const i=t[s+e];for(let t=0;t<4;t++){const n=l+4*t,s=3*(i>>2*t&3),o=a>>12*e+3*t&7;r[n+0]=Kn[s+0],r[n+1]=Kn[s+1],r[n+2]=Kn[s+2],r[n+3]=Hn[o]}l+=n}}}return r}(n,i,r):function(t,e,i){const r=new Uint8Array(e*i*2),n=2*e;for(let s=0,a=i/4;s<a;s++)for(let i=0,a=e/4;i<a;i++){const o=16*(s*a+i);Zn($n,t[o],t[o+1]),Zn(Xn,t[o+8],t[o+9]);let l=8*s*e+8*i;for(let e=0;e<2;e++){const i=o+3*e,s=t[i+2]+256*(t[i+3]+256*t[i+4]),a=t[i+10]+256*(t[i+11]+256*t[i+12]);for(let t=0;t<2;t++){const e=4*t;for(let t=0;t<4;t++){const i=l+2*t,n=3*(e+t);r[i+1]=$n[s>>n&7],r[i+2]=Xn[a>>n&7]}l+=n}}}return r}(n,i,r),{width:i,height:r,data:s}}}const rs={load(t){t.webgl.ensureExtension("WEBGL_compressed_texture_s3tc")||console.warn("DDS: No compressed textures support! This might reduce performance.")},isValidSource(t){return t instanceof is||((e=t)instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&68===e[0]&&68===e[1]&&83===e[2]&&32===e[3]);var e},resource:class extends kt{constructor(t,e){let i;super(e),t instanceof is?i=t:(i=new is,i.load(t));const r=this.viewer,n=r.gl,s=r.webgl.extensions.WEBGL_compressed_texture_s3tc,a=i.format;let o=0;s&&(a===Qn?o=s.COMPRESSED_RGB_S3TC_DXT1_EXT:a===Jn?o=s.COMPRESSED_RGBA_S3TC_DXT3_EXT:a===ts&&(o=s.COMPRESSED_RGBA_S3TC_DXT5_EXT));const l=n.createTexture();this.width=i.width,this.height=i.height,this.webglResource=l,n.bindTexture(n.TEXTURE_2D,l);const h=i.mipmaps();a!==Qn&&a!==es||n.pixelStorei(n.UNPACK_ALIGNMENT,2);for(let t=0;t<h;t++){const{width:e,height:r,data:s}=i.getMipmap(t,0!==o);o?n.compressedTexImage2D(n.TEXTURE_2D,t,o,e,r,0,s):a===Qn||a===Jn||a===ts?n.texImage2D(n.TEXTURE_2D,t,n.RGBA,e,r,0,n.RGBA,n.UNSIGNED_BYTE,s):n.texImage2D(n.TEXTURE_2D,t,n.LUMINANCE_ALPHA,e,r,0,n.LUMINANCE_ALPHA,n.UNSIGNED_BYTE,s)}n.pixelStorei(n.UNPACK_ALIGNMENT,4),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MAG_FILTER,n.LINEAR),h>1?n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MIN_FILTER,n.LINEAR_MIPMAP_LINEAR):n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MIN_FILTER,n.LINEAR)}}},ns=`\n${ln}\n\nuniform sampler2D u_tilesets[15];\n\nvarying vec4 v_tilesets;\nvarying vec2 v_uv[4];\nvarying vec3 v_normal;\n\nconst vec3 lightDirection = normalize(vec3(-0.3, -0.3, 0.25));\n\nvec4 sample(float tileset, vec2 uv) {\n  // 1.0 - 1.0 == 0.0 is not always true.\n  int i = int(tileset - 0.6);\n\n  if (i == 0) {\n    return texture2D(u_tilesets[0], uv);\n  } else if (i == 1) {\n    return texture2D(u_tilesets[1], uv);\n  } else if (i == 2) {\n    return texture2D(u_tilesets[2], uv);\n  } else if (i == 3) {\n    return texture2D(u_tilesets[3], uv);\n  } else if (i == 4) {\n    return texture2D(u_tilesets[4], uv);\n  } else if (i == 5) {\n    return texture2D(u_tilesets[5], uv);\n  } else if (i == 6) {\n    return texture2D(u_tilesets[6], uv);\n  } else if (i == 7) {\n    return texture2D(u_tilesets[7], uv);\n  } else if (i == 8) {\n    return texture2D(u_tilesets[8], uv);\n  } else if (i == 9) {\n    return texture2D(u_tilesets[9], uv);\n  } else if (i == 10) {\n    return texture2D(u_tilesets[10], uv);\n  } else if (i == 11) {\n    return texture2D(u_tilesets[11], uv);\n  } else if (i == 12) {\n    return texture2D(u_tilesets[12], uv);\n  } else if (i == 13) {\n    return texture2D(u_tilesets[13], uv);\n  } else if (i == 14) {\n    return texture2D(u_tilesets[14], uv);\n  }\n}\n\nvec4 blend(vec4 color, float tileset, vec2 uv) {\n  vec4 texel = sample(tileset, uv);\n\n  return mix(color, texel, texel.a);\n}\n\nvoid main() {\n  vec4 color = sample(v_tilesets[0], v_uv[0]);\n\n  if (v_tilesets[1] > 0.5) {\n    color = blend(color, v_tilesets[1], v_uv[1]);\n  }\n\n  if (v_tilesets[2] > 0.5) {\n    color = blend(color, v_tilesets[2], v_uv[2]);\n  }\n\n  if (v_tilesets[3] > 0.5) {\n    color = blend(color, v_tilesets[3], v_uv[3]);\n  }\n\n  //color *= clamp(dot(v_normal, lightDirection) + 0.45, 0.0, 1.0);\n\n  gl_FragColor = vec4(color.rgb, 1.0);\n}\n`,ss=`\n${ln}\n\nuniform sampler2D u_waterTexture;\n\nvarying vec2 v_uv;\nvarying vec4 v_color;\n\nvoid main() {\n  gl_FragColor = texture2D(u_waterTexture, v_uv) * v_color;\n}\n`,as=`\n// #extension GL_OES_standard_derivatives : enable\n\n${ln}\n\nuniform sampler2D u_texture1;\nuniform sampler2D u_texture2;\n\nvarying vec3 v_normal;\nvarying vec2 v_uv;\nvarying float v_texture;\nvarying vec3 v_position;\n\n// const vec3 lightDirection = normalize(vec3(-0.3, -0.3, 0.25));\n\nvec4 sample(float texture, vec2 uv) {\n  // int(0.0) == 0 is not always true.\n  int i = int(texture + 0.1);\n\n  if (i == 0) {\n    return texture2D(u_texture1, uv);\n  } else {\n    return texture2D(u_texture2, uv);\n  }\n}\n\nvoid main() {\n  vec4 color = sample(v_texture, v_uv);\n\n  // vec3 faceNormal = cross(dFdx(v_position), dFdy(v_position));\n  // vec3 normal = normalize((faceNormal + v_normal) * 0.5);\n\n  // color *= clamp(dot(normal, lightDirection) + 0.45, 0.1, 1.0);\n\n  gl_FragColor = color;\n}\n`;function os(t){return t.reverse().filter(((t,e,i)=>-1===i.indexOf(t,e+1))).reverse()}class ls{constructor(){this.offset=0,this.compressedSize=0,this.normalSize=0,this.flags=0}load(t){this.offset=t[0],this.compressedSize=t[1],this.normalSize=t[2],this.flags=t[3]}save(t){t[0]=this.offset,t[1]=this.compressedSize,t[2]=this.normalSize,t[3]=this.flags}}const hs=3283040112,cs=4294967294,ds=4294967295,us=3968054179,fs=65536,ms=131072,gs=16777216,ps=2147483648;class ws{constructor(t){this.c=t,this.entries=[]}add(t){const e=new ls;return e.normalSize=t.byteLength,this.entries.push(e),e}clear(){this.entries.length=0}addEmpties(t){for(let e=0;e<t;e++)this.entries.push(new ls)}load(t){const e=t.byteLength/16,i=new Uint32Array(this.c.decryptBlock(t,us).buffer);let r=0;this.clear(),this.addEmpties(e);for(const t of this.entries)t.load(i.subarray(r,r+4)),r+=4}save(t){const e=new Uint32Array(4*this.entries.length);let i=0;for(const t of this.entries)t.save(e.subarray(i,i+4)),i+=4;const r=new Uint8Array(e.buffer);this.c.encryptBlock(r,us),t.set(r)}}const vs=new Uint8Array(4),bs=new Uint32Array(vs.buffer);class ys{constructor(){this.cryptTable=new Uint32Array(1280);let t=1048577,e=0,i=0;for(let r=0;r<256;r++)for(let n=r,s=0;s<5;s+=1,n+=256)t=(125*t+3)%2796203,e=(65535&t)<<16,t=(125*t+3)%2796203,i=65535&t,this.cryptTable[n]=e|i}hash(t,e){const i=this.cryptTable;let r=2146271213,n=4008636142;t=t.toUpperCase();for(let s=0;s<t.length;s++){const a=t.charCodeAt(s);r=i[(e<<8)+a]^r+n,n=a+r+n+(n<<5)+3}return r>>>0}decryptBlock(t,e){const i=this.cryptTable;let r=4008636142;const n=new Uint8Array(t.buffer,t.byteOffset,t.byteLength);for(let s=0,a=t.byteLength>>>2;s<a;s++)r+=i[1024+(255&e)],vs[0]=n[4*s],vs[1]=n[4*s+1],vs[2]=n[4*s+2],vs[3]=n[4*s+3],bs[0]^=e+r,e=286331153+(~e<<21)|e>>>11,r=bs[0]+r+(r<<5)+3,n[4*s]=vs[0],n[4*s+1]=vs[1],n[4*s+2]=vs[2],n[4*s+3]=vs[3];return t}encryptBlock(t,e){const i=this.cryptTable;let r=4008636142;const n=new Uint8Array(t.buffer,t.byteOffset,t.byteLength);for(let s=0,a=t.byteLength>>>2;s<a;s++){r+=i[1024+(255&e)],vs[0]=n[4*s],vs[1]=n[4*s+1],vs[2]=n[4*s+2],vs[3]=n[4*s+3];const t=bs[0];bs[0]^=e+r,e=286331153+(~e<<21)|e>>>11,r=t+r+(r<<5)+3,n[4*s]=vs[0],n[4*s+1]=vs[1],n[4*s+2]=vs[2],n[4*s+3]=vs[3]}return t}computeFileKey(t,e){const i=t.lastIndexOf("\\"),r=t.substring(i+1);let n=this.hash(r,3);return e.flags&ms&&(n=n+e.offset^e.normalSize),n}}function _s(t){let e=t.length;for(;--e>=0;)t[e]=0}const As=256,xs=286,Ts=30,Es=15,Ss=new Uint8Array([0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0]),Bs=new Uint8Array([0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13]),Is=new Uint8Array([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7]),Ls=new Uint8Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]),Cs=new Array(576);_s(Cs);const Rs=new Array(60);_s(Rs);const Ms=new Array(512);_s(Ms);const Us=new Array(256);_s(Us);const ks=new Array(29);_s(ks);const Fs=new Array(Ts);function Ds(t,e,i,r,n){this.static_tree=t,this.extra_bits=e,this.extra_base=i,this.elems=r,this.max_length=n,this.has_stree=t&&t.length}let Ps,Ns,Os;function Vs(t,e){this.dyn_tree=t,this.max_code=0,this.stat_desc=e}_s(Fs);const Gs=t=>t<256?Ms[t]:Ms[256+(t>>>7)],zs=(t,e)=>{t.pending_buf[t.pending++]=255&e,t.pending_buf[t.pending++]=e>>>8&255},js=(t,e,i)=>{t.bi_valid>16-i?(t.bi_buf|=e<<t.bi_valid&65535,zs(t,t.bi_buf),t.bi_buf=e>>16-t.bi_valid,t.bi_valid+=i-16):(t.bi_buf|=e<<t.bi_valid&65535,t.bi_valid+=i)},Ks=(t,e,i)=>{js(t,i[2*e],i[2*e+1])},Hs=(t,e)=>{let i=0;do{i|=1&t,t>>>=1,i<<=1}while(--e>0);return i>>>1},$s=(t,e,i)=>{const r=new Array(16);let n,s,a=0;for(n=1;n<=Es;n++)r[n]=a=a+i[n-1]<<1;for(s=0;s<=e;s++){let e=t[2*s+1];0!==e&&(t[2*s]=Hs(r[e]++,e))}},Xs=t=>{let e;for(e=0;e<xs;e++)t.dyn_ltree[2*e]=0;for(e=0;e<Ts;e++)t.dyn_dtree[2*e]=0;for(e=0;e<19;e++)t.bl_tree[2*e]=0;t.dyn_ltree[512]=1,t.opt_len=t.static_len=0,t.last_lit=t.matches=0},qs=t=>{t.bi_valid>8?zs(t,t.bi_buf):t.bi_valid>0&&(t.pending_buf[t.pending++]=t.bi_buf),t.bi_buf=0,t.bi_valid=0},Ys=(t,e,i,r)=>{const n=2*e,s=2*i;return t[n]<t[s]||t[n]===t[s]&&r[e]<=r[i]},Ws=(t,e,i)=>{const r=t.heap[i];let n=i<<1;for(;n<=t.heap_len&&(n<t.heap_len&&Ys(e,t.heap[n+1],t.heap[n],t.depth)&&n++,!Ys(e,r,t.heap[n],t.depth));)t.heap[i]=t.heap[n],i=n,n<<=1;t.heap[i]=r},Zs=(t,e,i)=>{let r,n,s,a,o=0;if(0!==t.last_lit)do{r=t.pending_buf[t.d_buf+2*o]<<8|t.pending_buf[t.d_buf+2*o+1],n=t.pending_buf[t.l_buf+o],o++,0===r?Ks(t,n,e):(s=Us[n],Ks(t,s+As+1,e),a=Ss[s],0!==a&&(n-=ks[s],js(t,n,a)),r--,s=Gs(r),Ks(t,s,i),a=Bs[s],0!==a&&(r-=Fs[s],js(t,r,a)))}while(o<t.last_lit);Ks(t,256,e)},Qs=(t,e)=>{const i=e.dyn_tree,r=e.stat_desc.static_tree,n=e.stat_desc.has_stree,s=e.stat_desc.elems;let a,o,l,h=-1;for(t.heap_len=0,t.heap_max=573,a=0;a<s;a++)0!==i[2*a]?(t.heap[++t.heap_len]=h=a,t.depth[a]=0):i[2*a+1]=0;for(;t.heap_len<2;)l=t.heap[++t.heap_len]=h<2?++h:0,i[2*l]=1,t.depth[l]=0,t.opt_len--,n&&(t.static_len-=r[2*l+1]);for(e.max_code=h,a=t.heap_len>>1;a>=1;a--)Ws(t,i,a);l=s;do{a=t.heap[1],t.heap[1]=t.heap[t.heap_len--],Ws(t,i,1),o=t.heap[1],t.heap[--t.heap_max]=a,t.heap[--t.heap_max]=o,i[2*l]=i[2*a]+i[2*o],t.depth[l]=(t.depth[a]>=t.depth[o]?t.depth[a]:t.depth[o])+1,i[2*a+1]=i[2*o+1]=l,t.heap[1]=l++,Ws(t,i,1)}while(t.heap_len>=2);t.heap[--t.heap_max]=t.heap[1],((t,e)=>{const i=e.dyn_tree,r=e.max_code,n=e.stat_desc.static_tree,s=e.stat_desc.has_stree,a=e.stat_desc.extra_bits,o=e.stat_desc.extra_base,l=e.stat_desc.max_length;let h,c,d,u,f,m,g=0;for(u=0;u<=Es;u++)t.bl_count[u]=0;for(i[2*t.heap[t.heap_max]+1]=0,h=t.heap_max+1;h<573;h++)c=t.heap[h],u=i[2*i[2*c+1]+1]+1,u>l&&(u=l,g++),i[2*c+1]=u,c>r||(t.bl_count[u]++,f=0,c>=o&&(f=a[c-o]),m=i[2*c],t.opt_len+=m*(u+f),s&&(t.static_len+=m*(n[2*c+1]+f)));if(0!==g){do{for(u=l-1;0===t.bl_count[u];)u--;t.bl_count[u]--,t.bl_count[u+1]+=2,t.bl_count[l]--,g-=2}while(g>0);for(u=l;0!==u;u--)for(c=t.bl_count[u];0!==c;)d=t.heap[--h],d>r||(i[2*d+1]!==u&&(t.opt_len+=(u-i[2*d+1])*i[2*d],i[2*d+1]=u),c--)}})(t,e),$s(i,h,t.bl_count)},Js=(t,e,i)=>{let r,n,s=-1,a=e[1],o=0,l=7,h=4;for(0===a&&(l=138,h=3),e[2*(i+1)+1]=65535,r=0;r<=i;r++)n=a,a=e[2*(r+1)+1],++o<l&&n===a||(o<h?t.bl_tree[2*n]+=o:0!==n?(n!==s&&t.bl_tree[2*n]++,t.bl_tree[32]++):o<=10?t.bl_tree[34]++:t.bl_tree[36]++,o=0,s=n,0===a?(l=138,h=3):n===a?(l=6,h=3):(l=7,h=4))},ta=(t,e,i)=>{let r,n,s=-1,a=e[1],o=0,l=7,h=4;for(0===a&&(l=138,h=3),r=0;r<=i;r++)if(n=a,a=e[2*(r+1)+1],!(++o<l&&n===a)){if(o<h)do{Ks(t,n,t.bl_tree)}while(0!=--o);else 0!==n?(n!==s&&(Ks(t,n,t.bl_tree),o--),Ks(t,16,t.bl_tree),js(t,o-3,2)):o<=10?(Ks(t,17,t.bl_tree),js(t,o-3,3)):(Ks(t,18,t.bl_tree),js(t,o-11,7));o=0,s=n,0===a?(l=138,h=3):n===a?(l=6,h=3):(l=7,h=4)}};let ea=!1;const ia=(t,e,i,r)=>{js(t,0+(r?1:0),3),((t,e,i,r)=>{qs(t),r&&(zs(t,i),zs(t,~i)),t.pending_buf.set(t.window.subarray(e,e+i),t.pending),t.pending+=i})(t,e,i,!0)};var ra=t=>{ea||((()=>{let t,e,i,r,n;const s=new Array(16);for(i=0,r=0;r<28;r++)for(ks[r]=i,t=0;t<1<<Ss[r];t++)Us[i++]=r;for(Us[i-1]=r,n=0,r=0;r<16;r++)for(Fs[r]=n,t=0;t<1<<Bs[r];t++)Ms[n++]=r;for(n>>=7;r<Ts;r++)for(Fs[r]=n<<7,t=0;t<1<<Bs[r]-7;t++)Ms[256+n++]=r;for(e=0;e<=Es;e++)s[e]=0;for(t=0;t<=143;)Cs[2*t+1]=8,t++,s[8]++;for(;t<=255;)Cs[2*t+1]=9,t++,s[9]++;for(;t<=279;)Cs[2*t+1]=7,t++,s[7]++;for(;t<=287;)Cs[2*t+1]=8,t++,s[8]++;for($s(Cs,287,s),t=0;t<Ts;t++)Rs[2*t+1]=5,Rs[2*t]=Hs(t,5);Ps=new Ds(Cs,Ss,257,xs,Es),Ns=new Ds(Rs,Bs,0,Ts,Es),Os=new Ds(new Array(0),Is,0,19,7)})(),ea=!0),t.l_desc=new Vs(t.dyn_ltree,Ps),t.d_desc=new Vs(t.dyn_dtree,Ns),t.bl_desc=new Vs(t.bl_tree,Os),t.bi_buf=0,t.bi_valid=0,Xs(t)},na=(t,e,i,r)=>{let n,s,a=0;t.level>0?(2===t.strm.data_type&&(t.strm.data_type=(t=>{let e,i=4093624447;for(e=0;e<=31;e++,i>>>=1)if(1&i&&0!==t.dyn_ltree[2*e])return 0;if(0!==t.dyn_ltree[18]||0!==t.dyn_ltree[20]||0!==t.dyn_ltree[26])return 1;for(e=32;e<As;e++)if(0!==t.dyn_ltree[2*e])return 1;return 0})(t)),Qs(t,t.l_desc),Qs(t,t.d_desc),a=(t=>{let e;for(Js(t,t.dyn_ltree,t.l_desc.max_code),Js(t,t.dyn_dtree,t.d_desc.max_code),Qs(t,t.bl_desc),e=18;e>=3&&0===t.bl_tree[2*Ls[e]+1];e--);return t.opt_len+=3*(e+1)+5+5+4,e})(t),n=t.opt_len+3+7>>>3,s=t.static_len+3+7>>>3,s<=n&&(n=s)):n=s=i+5,i+4<=n&&-1!==e?ia(t,e,i,r):4===t.strategy||s===n?(js(t,2+(r?1:0),3),Zs(t,Cs,Rs)):(js(t,4+(r?1:0),3),((t,e,i,r)=>{let n;for(js(t,e-257,5),js(t,i-1,5),js(t,r-4,4),n=0;n<r;n++)js(t,t.bl_tree[2*Ls[n]+1],3);ta(t,t.dyn_ltree,e-1),ta(t,t.dyn_dtree,i-1)})(t,t.l_desc.max_code+1,t.d_desc.max_code+1,a+1),Zs(t,t.dyn_ltree,t.dyn_dtree)),Xs(t),r&&qs(t)},sa=(t,e,i)=>(t.pending_buf[t.d_buf+2*t.last_lit]=e>>>8&255,t.pending_buf[t.d_buf+2*t.last_lit+1]=255&e,t.pending_buf[t.l_buf+t.last_lit]=255&i,t.last_lit++,0===e?t.dyn_ltree[2*i]++:(t.matches++,e--,t.dyn_ltree[2*(Us[i]+As+1)]++,t.dyn_dtree[2*Gs(e)]++),t.last_lit===t.lit_bufsize-1),aa=t=>{js(t,2,3),Ks(t,256,Cs),(t=>{16===t.bi_valid?(zs(t,t.bi_buf),t.bi_buf=0,t.bi_valid=0):t.bi_valid>=8&&(t.pending_buf[t.pending++]=255&t.bi_buf,t.bi_buf>>=8,t.bi_valid-=8)})(t)},oa={_tr_init:ra,_tr_stored_block:ia,_tr_flush_block:na,_tr_tally:sa,_tr_align:aa};var la=(t,e,i,r)=>{let n=65535&t|0,s=t>>>16&65535|0,a=0;for(;0!==i;){a=i>2e3?2e3:i,i-=a;do{n=n+e[r++]|0,s=s+n|0}while(--a);n%=65521,s%=65521}return n|s<<16|0};const ha=new Uint32Array((()=>{let t,e=[];for(var i=0;i<256;i++){t=i;for(var r=0;r<8;r++)t=1&t?3988292384^t>>>1:t>>>1;e[i]=t}return e})());var ca=(t,e,i,r)=>{const n=ha,s=r+i;t^=-1;for(let i=r;i<s;i++)t=t>>>8^n[255&(t^e[i])];return-1^t},da={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"},ua={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_MEM_ERROR:-4,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8};const{_tr_init:fa,_tr_stored_block:ma,_tr_flush_block:ga,_tr_tally:pa,_tr_align:wa}=oa,{Z_NO_FLUSH:va,Z_PARTIAL_FLUSH:ba,Z_FULL_FLUSH:ya,Z_FINISH:_a,Z_BLOCK:Aa,Z_OK:xa,Z_STREAM_END:Ta,Z_STREAM_ERROR:Ea,Z_DATA_ERROR:Sa,Z_BUF_ERROR:Ba,Z_DEFAULT_COMPRESSION:Ia,Z_FILTERED:La,Z_HUFFMAN_ONLY:Ca,Z_RLE:Ra,Z_FIXED:Ma,Z_DEFAULT_STRATEGY:Ua,Z_UNKNOWN:ka,Z_DEFLATED:Fa}=ua,Da=258,Pa=262,Na=103,Oa=113,Va=666,Ga=(t,e)=>(t.msg=da[e],e),za=t=>(t<<1)-(t>4?9:0),ja=t=>{let e=t.length;for(;--e>=0;)t[e]=0};let Ka=(t,e,i)=>(e<<t.hash_shift^i)&t.hash_mask;const Ha=t=>{const e=t.state;let i=e.pending;i>t.avail_out&&(i=t.avail_out),0!==i&&(t.output.set(e.pending_buf.subarray(e.pending_out,e.pending_out+i),t.next_out),t.next_out+=i,e.pending_out+=i,t.total_out+=i,t.avail_out-=i,e.pending-=i,0===e.pending&&(e.pending_out=0))},$a=(t,e)=>{ga(t,t.block_start>=0?t.block_start:-1,t.strstart-t.block_start,e),t.block_start=t.strstart,Ha(t.strm)},Xa=(t,e)=>{t.pending_buf[t.pending++]=e},qa=(t,e)=>{t.pending_buf[t.pending++]=e>>>8&255,t.pending_buf[t.pending++]=255&e},Ya=(t,e,i,r)=>{let n=t.avail_in;return n>r&&(n=r),0===n?0:(t.avail_in-=n,e.set(t.input.subarray(t.next_in,t.next_in+n),i),1===t.state.wrap?t.adler=la(t.adler,e,n,i):2===t.state.wrap&&(t.adler=ca(t.adler,e,n,i)),t.next_in+=n,t.total_in+=n,n)},Wa=(t,e)=>{let i,r,n=t.max_chain_length,s=t.strstart,a=t.prev_length,o=t.nice_match;const l=t.strstart>t.w_size-Pa?t.strstart-(t.w_size-Pa):0,h=t.window,c=t.w_mask,d=t.prev,u=t.strstart+Da;let f=h[s+a-1],m=h[s+a];t.prev_length>=t.good_match&&(n>>=2),o>t.lookahead&&(o=t.lookahead);do{if(i=e,h[i+a]===m&&h[i+a-1]===f&&h[i]===h[s]&&h[++i]===h[s+1]){s+=2,i++;do{}while(h[++s]===h[++i]&&h[++s]===h[++i]&&h[++s]===h[++i]&&h[++s]===h[++i]&&h[++s]===h[++i]&&h[++s]===h[++i]&&h[++s]===h[++i]&&h[++s]===h[++i]&&s<u);if(r=Da-(u-s),s=u-Da,r>a){if(t.match_start=e,a=r,r>=o)break;f=h[s+a-1],m=h[s+a]}}}while((e=d[e&c])>l&&0!=--n);return a<=t.lookahead?a:t.lookahead},Za=t=>{const e=t.w_size;let i,r,n,s,a;do{if(s=t.window_size-t.lookahead-t.strstart,t.strstart>=e+(e-Pa)){t.window.set(t.window.subarray(e,e+e),0),t.match_start-=e,t.strstart-=e,t.block_start-=e,r=t.hash_size,i=r;do{n=t.head[--i],t.head[i]=n>=e?n-e:0}while(--r);r=e,i=r;do{n=t.prev[--i],t.prev[i]=n>=e?n-e:0}while(--r);s+=e}if(0===t.strm.avail_in)break;if(r=Ya(t.strm,t.window,t.strstart+t.lookahead,s),t.lookahead+=r,t.lookahead+t.insert>=3)for(a=t.strstart-t.insert,t.ins_h=t.window[a],t.ins_h=Ka(t,t.ins_h,t.window[a+1]);t.insert&&(t.ins_h=Ka(t,t.ins_h,t.window[a+3-1]),t.prev[a&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=a,a++,t.insert--,!(t.lookahead+t.insert<3)););}while(t.lookahead<Pa&&0!==t.strm.avail_in)},Qa=(t,e)=>{let i,r;for(;;){if(t.lookahead<Pa){if(Za(t),t.lookahead<Pa&&e===va)return 1;if(0===t.lookahead)break}if(i=0,t.lookahead>=3&&(t.ins_h=Ka(t,t.ins_h,t.window[t.strstart+3-1]),i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart),0!==i&&t.strstart-i<=t.w_size-Pa&&(t.match_length=Wa(t,i)),t.match_length>=3)if(r=pa(t,t.strstart-t.match_start,t.match_length-3),t.lookahead-=t.match_length,t.match_length<=t.max_lazy_match&&t.lookahead>=3){t.match_length--;do{t.strstart++,t.ins_h=Ka(t,t.ins_h,t.window[t.strstart+3-1]),i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart}while(0!=--t.match_length);t.strstart++}else t.strstart+=t.match_length,t.match_length=0,t.ins_h=t.window[t.strstart],t.ins_h=Ka(t,t.ins_h,t.window[t.strstart+1]);else r=pa(t,0,t.window[t.strstart]),t.lookahead--,t.strstart++;if(r&&($a(t,!1),0===t.strm.avail_out))return 1}return t.insert=t.strstart<2?t.strstart:2,e===_a?($a(t,!0),0===t.strm.avail_out?3:4):t.last_lit&&($a(t,!1),0===t.strm.avail_out)?1:2},Ja=(t,e)=>{let i,r,n;for(;;){if(t.lookahead<Pa){if(Za(t),t.lookahead<Pa&&e===va)return 1;if(0===t.lookahead)break}if(i=0,t.lookahead>=3&&(t.ins_h=Ka(t,t.ins_h,t.window[t.strstart+3-1]),i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart),t.prev_length=t.match_length,t.prev_match=t.match_start,t.match_length=2,0!==i&&t.prev_length<t.max_lazy_match&&t.strstart-i<=t.w_size-Pa&&(t.match_length=Wa(t,i),t.match_length<=5&&(t.strategy===La||3===t.match_length&&t.strstart-t.match_start>4096)&&(t.match_length=2)),t.prev_length>=3&&t.match_length<=t.prev_length){n=t.strstart+t.lookahead-3,r=pa(t,t.strstart-1-t.prev_match,t.prev_length-3),t.lookahead-=t.prev_length-1,t.prev_length-=2;do{++t.strstart<=n&&(t.ins_h=Ka(t,t.ins_h,t.window[t.strstart+3-1]),i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart)}while(0!=--t.prev_length);if(t.match_available=0,t.match_length=2,t.strstart++,r&&($a(t,!1),0===t.strm.avail_out))return 1}else if(t.match_available){if(r=pa(t,0,t.window[t.strstart-1]),r&&$a(t,!1),t.strstart++,t.lookahead--,0===t.strm.avail_out)return 1}else t.match_available=1,t.strstart++,t.lookahead--}return t.match_available&&(r=pa(t,0,t.window[t.strstart-1]),t.match_available=0),t.insert=t.strstart<2?t.strstart:2,e===_a?($a(t,!0),0===t.strm.avail_out?3:4):t.last_lit&&($a(t,!1),0===t.strm.avail_out)?1:2};function to(t,e,i,r,n){this.good_length=t,this.max_lazy=e,this.nice_length=i,this.max_chain=r,this.func=n}const eo=[new to(0,0,0,0,((t,e)=>{let i=65535;for(i>t.pending_buf_size-5&&(i=t.pending_buf_size-5);;){if(t.lookahead<=1){if(Za(t),0===t.lookahead&&e===va)return 1;if(0===t.lookahead)break}t.strstart+=t.lookahead,t.lookahead=0;const r=t.block_start+i;if((0===t.strstart||t.strstart>=r)&&(t.lookahead=t.strstart-r,t.strstart=r,$a(t,!1),0===t.strm.avail_out))return 1;if(t.strstart-t.block_start>=t.w_size-Pa&&($a(t,!1),0===t.strm.avail_out))return 1}return t.insert=0,e===_a?($a(t,!0),0===t.strm.avail_out?3:4):(t.strstart>t.block_start&&($a(t,!1),t.strm.avail_out),1)})),new to(4,4,8,4,Qa),new to(4,5,16,8,Qa),new to(4,6,32,32,Qa),new to(4,4,16,16,Ja),new to(8,16,32,32,Ja),new to(8,16,128,128,Ja),new to(8,32,128,256,Ja),new to(32,128,258,1024,Ja),new to(32,258,258,4096,Ja)];function io(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=Fa,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new Uint16Array(1146),this.dyn_dtree=new Uint16Array(122),this.bl_tree=new Uint16Array(78),ja(this.dyn_ltree),ja(this.dyn_dtree),ja(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new Uint16Array(16),this.heap=new Uint16Array(573),ja(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new Uint16Array(573),ja(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0}const ro=t=>{if(!t||!t.state)return Ga(t,Ea);t.total_in=t.total_out=0,t.data_type=ka;const e=t.state;return e.pending=0,e.pending_out=0,e.wrap<0&&(e.wrap=-e.wrap),e.status=e.wrap?42:Oa,t.adler=2===e.wrap?0:1,e.last_flush=va,fa(e),xa},no=t=>{const e=ro(t);return e===xa&&(t=>{t.window_size=2*t.w_size,ja(t.head),t.max_lazy_match=eo[t.level].max_lazy,t.good_match=eo[t.level].good_length,t.nice_match=eo[t.level].nice_length,t.max_chain_length=eo[t.level].max_chain,t.strstart=0,t.block_start=0,t.lookahead=0,t.insert=0,t.match_length=t.prev_length=2,t.match_available=0,t.ins_h=0})(t.state),e},so=(t,e,i,r,n,s)=>{if(!t)return Ea;let a=1;if(e===Ia&&(e=6),r<0?(a=0,r=-r):r>15&&(a=2,r-=16),n<1||n>9||i!==Fa||r<8||r>15||e<0||e>9||s<0||s>Ma)return Ga(t,Ea);8===r&&(r=9);const o=new io;return t.state=o,o.strm=t,o.wrap=a,o.gzhead=null,o.w_bits=r,o.w_size=1<<o.w_bits,o.w_mask=o.w_size-1,o.hash_bits=n+7,o.hash_size=1<<o.hash_bits,o.hash_mask=o.hash_size-1,o.hash_shift=~~((o.hash_bits+3-1)/3),o.window=new Uint8Array(2*o.w_size),o.head=new Uint16Array(o.hash_size),o.prev=new Uint16Array(o.w_size),o.lit_bufsize=1<<n+6,o.pending_buf_size=4*o.lit_bufsize,o.pending_buf=new Uint8Array(o.pending_buf_size),o.d_buf=1*o.lit_bufsize,o.l_buf=3*o.lit_bufsize,o.level=e,o.strategy=s,o.method=i,no(t)};var ao=(t,e)=>{let i,r;if(!t||!t.state||e>Aa||e<0)return t?Ga(t,Ea):Ea;const n=t.state;if(!t.output||!t.input&&0!==t.avail_in||n.status===Va&&e!==_a)return Ga(t,0===t.avail_out?Ba:Ea);n.strm=t;const s=n.last_flush;if(n.last_flush=e,42===n.status)if(2===n.wrap)t.adler=0,Xa(n,31),Xa(n,139),Xa(n,8),n.gzhead?(Xa(n,(n.gzhead.text?1:0)+(n.gzhead.hcrc?2:0)+(n.gzhead.extra?4:0)+(n.gzhead.name?8:0)+(n.gzhead.comment?16:0)),Xa(n,255&n.gzhead.time),Xa(n,n.gzhead.time>>8&255),Xa(n,n.gzhead.time>>16&255),Xa(n,n.gzhead.time>>24&255),Xa(n,9===n.level?2:n.strategy>=Ca||n.level<2?4:0),Xa(n,255&n.gzhead.os),n.gzhead.extra&&n.gzhead.extra.length&&(Xa(n,255&n.gzhead.extra.length),Xa(n,n.gzhead.extra.length>>8&255)),n.gzhead.hcrc&&(t.adler=ca(t.adler,n.pending_buf,n.pending,0)),n.gzindex=0,n.status=69):(Xa(n,0),Xa(n,0),Xa(n,0),Xa(n,0),Xa(n,0),Xa(n,9===n.level?2:n.strategy>=Ca||n.level<2?4:0),Xa(n,3),n.status=Oa);else{let e=Fa+(n.w_bits-8<<4)<<8,i=-1;i=n.strategy>=Ca||n.level<2?0:n.level<6?1:6===n.level?2:3,e|=i<<6,0!==n.strstart&&(e|=32),e+=31-e%31,n.status=Oa,qa(n,e),0!==n.strstart&&(qa(n,t.adler>>>16),qa(n,65535&t.adler)),t.adler=1}if(69===n.status)if(n.gzhead.extra){for(i=n.pending;n.gzindex<(65535&n.gzhead.extra.length)&&(n.pending!==n.pending_buf_size||(n.gzhead.hcrc&&n.pending>i&&(t.adler=ca(t.adler,n.pending_buf,n.pending-i,i)),Ha(t),i=n.pending,n.pending!==n.pending_buf_size));)Xa(n,255&n.gzhead.extra[n.gzindex]),n.gzindex++;n.gzhead.hcrc&&n.pending>i&&(t.adler=ca(t.adler,n.pending_buf,n.pending-i,i)),n.gzindex===n.gzhead.extra.length&&(n.gzindex=0,n.status=73)}else n.status=73;if(73===n.status)if(n.gzhead.name){i=n.pending;do{if(n.pending===n.pending_buf_size&&(n.gzhead.hcrc&&n.pending>i&&(t.adler=ca(t.adler,n.pending_buf,n.pending-i,i)),Ha(t),i=n.pending,n.pending===n.pending_buf_size)){r=1;break}r=n.gzindex<n.gzhead.name.length?255&n.gzhead.name.charCodeAt(n.gzindex++):0,Xa(n,r)}while(0!==r);n.gzhead.hcrc&&n.pending>i&&(t.adler=ca(t.adler,n.pending_buf,n.pending-i,i)),0===r&&(n.gzindex=0,n.status=91)}else n.status=91;if(91===n.status)if(n.gzhead.comment){i=n.pending;do{if(n.pending===n.pending_buf_size&&(n.gzhead.hcrc&&n.pending>i&&(t.adler=ca(t.adler,n.pending_buf,n.pending-i,i)),Ha(t),i=n.pending,n.pending===n.pending_buf_size)){r=1;break}r=n.gzindex<n.gzhead.comment.length?255&n.gzhead.comment.charCodeAt(n.gzindex++):0,Xa(n,r)}while(0!==r);n.gzhead.hcrc&&n.pending>i&&(t.adler=ca(t.adler,n.pending_buf,n.pending-i,i)),0===r&&(n.status=Na)}else n.status=Na;if(n.status===Na&&(n.gzhead.hcrc?(n.pending+2>n.pending_buf_size&&Ha(t),n.pending+2<=n.pending_buf_size&&(Xa(n,255&t.adler),Xa(n,t.adler>>8&255),t.adler=0,n.status=Oa)):n.status=Oa),0!==n.pending){if(Ha(t),0===t.avail_out)return n.last_flush=-1,xa}else if(0===t.avail_in&&za(e)<=za(s)&&e!==_a)return Ga(t,Ba);if(n.status===Va&&0!==t.avail_in)return Ga(t,Ba);if(0!==t.avail_in||0!==n.lookahead||e!==va&&n.status!==Va){let i=n.strategy===Ca?((t,e)=>{let i;for(;;){if(0===t.lookahead&&(Za(t),0===t.lookahead)){if(e===va)return 1;break}if(t.match_length=0,i=pa(t,0,t.window[t.strstart]),t.lookahead--,t.strstart++,i&&($a(t,!1),0===t.strm.avail_out))return 1}return t.insert=0,e===_a?($a(t,!0),0===t.strm.avail_out?3:4):t.last_lit&&($a(t,!1),0===t.strm.avail_out)?1:2})(n,e):n.strategy===Ra?((t,e)=>{let i,r,n,s;const a=t.window;for(;;){if(t.lookahead<=Da){if(Za(t),t.lookahead<=Da&&e===va)return 1;if(0===t.lookahead)break}if(t.match_length=0,t.lookahead>=3&&t.strstart>0&&(n=t.strstart-1,r=a[n],r===a[++n]&&r===a[++n]&&r===a[++n])){s=t.strstart+Da;do{}while(r===a[++n]&&r===a[++n]&&r===a[++n]&&r===a[++n]&&r===a[++n]&&r===a[++n]&&r===a[++n]&&r===a[++n]&&n<s);t.match_length=Da-(s-n),t.match_length>t.lookahead&&(t.match_length=t.lookahead)}if(t.match_length>=3?(i=pa(t,1,t.match_length-3),t.lookahead-=t.match_length,t.strstart+=t.match_length,t.match_length=0):(i=pa(t,0,t.window[t.strstart]),t.lookahead--,t.strstart++),i&&($a(t,!1),0===t.strm.avail_out))return 1}return t.insert=0,e===_a?($a(t,!0),0===t.strm.avail_out?3:4):t.last_lit&&($a(t,!1),0===t.strm.avail_out)?1:2})(n,e):eo[n.level].func(n,e);if(3!==i&&4!==i||(n.status=Va),1===i||3===i)return 0===t.avail_out&&(n.last_flush=-1),xa;if(2===i&&(e===ba?wa(n):e!==Aa&&(ma(n,0,0,!1),e===ya&&(ja(n.head),0===n.lookahead&&(n.strstart=0,n.block_start=0,n.insert=0))),Ha(t),0===t.avail_out))return n.last_flush=-1,xa}return e!==_a?xa:n.wrap<=0?Ta:(2===n.wrap?(Xa(n,255&t.adler),Xa(n,t.adler>>8&255),Xa(n,t.adler>>16&255),Xa(n,t.adler>>24&255),Xa(n,255&t.total_in),Xa(n,t.total_in>>8&255),Xa(n,t.total_in>>16&255),Xa(n,t.total_in>>24&255)):(qa(n,t.adler>>>16),qa(n,65535&t.adler)),Ha(t),n.wrap>0&&(n.wrap=-n.wrap),0!==n.pending?xa:Ta)},oo=(t,e)=>{let i=e.length;if(!t||!t.state)return Ea;const r=t.state,n=r.wrap;if(2===n||1===n&&42!==r.status||r.lookahead)return Ea;if(1===n&&(t.adler=la(t.adler,e,i,0)),r.wrap=0,i>=r.w_size){0===n&&(ja(r.head),r.strstart=0,r.block_start=0,r.insert=0);let t=new Uint8Array(r.w_size);t.set(e.subarray(i-r.w_size,i),0),e=t,i=r.w_size}const s=t.avail_in,a=t.next_in,o=t.input;for(t.avail_in=i,t.next_in=0,t.input=e,Za(r);r.lookahead>=3;){let t=r.strstart,e=r.lookahead-2;do{r.ins_h=Ka(r,r.ins_h,r.window[t+3-1]),r.prev[t&r.w_mask]=r.head[r.ins_h],r.head[r.ins_h]=t,t++}while(--e);r.strstart=t,r.lookahead=2,Za(r)}return r.strstart+=r.lookahead,r.block_start=r.strstart,r.insert=r.lookahead,r.lookahead=0,r.match_length=r.prev_length=2,r.match_available=0,t.next_in=a,t.input=o,t.avail_in=s,r.wrap=n,xa},lo={deflateInit:(t,e)=>so(t,e,Fa,15,8,Ua),deflateInit2:so,deflateReset:no,deflateResetKeep:ro,deflateSetHeader:(t,e)=>t&&t.state?2!==t.state.wrap?Ea:(t.state.gzhead=e,xa):Ea,deflate:ao,deflateEnd:t=>{if(!t||!t.state)return Ea;const e=t.state.status;return 42!==e&&69!==e&&73!==e&&91!==e&&e!==Na&&e!==Oa&&e!==Va?Ga(t,Ea):(t.state=null,e===Oa?Ga(t,Sa):xa)},deflateSetDictionary:oo,deflateInfo:"pako deflate (from Nodeca project)"};const ho=(t,e)=>Object.prototype.hasOwnProperty.call(t,e);var co=function(t){const e=Array.prototype.slice.call(arguments,1);for(;e.length;){const i=e.shift();if(i){if("object"!=typeof i)throw new TypeError(i+"must be non-object");for(const e in i)ho(i,e)&&(t[e]=i[e])}}return t},uo=t=>{let e=0;for(let i=0,r=t.length;i<r;i++)e+=t[i].length;const i=new Uint8Array(e);for(let e=0,r=0,n=t.length;e<n;e++){let n=t[e];i.set(n,r),r+=n.length}return i};let fo=!0;try{String.fromCharCode.apply(null,new Uint8Array(1))}catch(t){fo=!1}const mo=new Uint8Array(256);for(let t=0;t<256;t++)mo[t]=t>=252?6:t>=248?5:t>=240?4:t>=224?3:t>=192?2:1;mo[254]=mo[254]=1;var go=t=>{if("function"==typeof TextEncoder&&TextEncoder.prototype.encode)return(new TextEncoder).encode(t);let e,i,r,n,s,a=t.length,o=0;for(n=0;n<a;n++)i=t.charCodeAt(n),55296==(64512&i)&&n+1<a&&(r=t.charCodeAt(n+1),56320==(64512&r)&&(i=65536+(i-55296<<10)+(r-56320),n++)),o+=i<128?1:i<2048?2:i<65536?3:4;for(e=new Uint8Array(o),s=0,n=0;s<o;n++)i=t.charCodeAt(n),55296==(64512&i)&&n+1<a&&(r=t.charCodeAt(n+1),56320==(64512&r)&&(i=65536+(i-55296<<10)+(r-56320),n++)),i<128?e[s++]=i:i<2048?(e[s++]=192|i>>>6,e[s++]=128|63&i):i<65536?(e[s++]=224|i>>>12,e[s++]=128|i>>>6&63,e[s++]=128|63&i):(e[s++]=240|i>>>18,e[s++]=128|i>>>12&63,e[s++]=128|i>>>6&63,e[s++]=128|63&i);return e},po=(t,e)=>{const i=e||t.length;if("function"==typeof TextDecoder&&TextDecoder.prototype.decode)return(new TextDecoder).decode(t.subarray(0,e));let r,n;const s=new Array(2*i);for(n=0,r=0;r<i;){let e=t[r++];if(e<128){s[n++]=e;continue}let a=mo[e];if(a>4)s[n++]=65533,r+=a-1;else{for(e&=2===a?31:3===a?15:7;a>1&&r<i;)e=e<<6|63&t[r++],a--;a>1?s[n++]=65533:e<65536?s[n++]=e:(e-=65536,s[n++]=55296|e>>10&1023,s[n++]=56320|1023&e)}}return((t,e)=>{if(e<65534&&t.subarray&&fo)return String.fromCharCode.apply(null,t.length===e?t:t.subarray(0,e));let i="";for(let r=0;r<e;r++)i+=String.fromCharCode(t[r]);return i})(s,n)},wo=(t,e)=>{(e=e||t.length)>t.length&&(e=t.length);let i=e-1;for(;i>=0&&128==(192&t[i]);)i--;return i<0||0===i?e:i+mo[t[i]]>e?i:e};var vo=function(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0};const bo=Object.prototype.toString,{Z_NO_FLUSH:yo,Z_SYNC_FLUSH:_o,Z_FULL_FLUSH:Ao,Z_FINISH:xo,Z_OK:To,Z_STREAM_END:Eo,Z_DEFAULT_COMPRESSION:So,Z_DEFAULT_STRATEGY:Bo,Z_DEFLATED:Io}=ua;function Lo(t){this.options=co({level:So,method:Io,chunkSize:16384,windowBits:15,memLevel:8,strategy:Bo},t||{});let e=this.options;e.raw&&e.windowBits>0?e.windowBits=-e.windowBits:e.gzip&&e.windowBits>0&&e.windowBits<16&&(e.windowBits+=16),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new vo,this.strm.avail_out=0;let i=lo.deflateInit2(this.strm,e.level,e.method,e.windowBits,e.memLevel,e.strategy);if(i!==To)throw new Error(da[i]);if(e.header&&lo.deflateSetHeader(this.strm,e.header),e.dictionary){let t;if(t="string"==typeof e.dictionary?go(e.dictionary):"[object ArrayBuffer]"===bo.call(e.dictionary)?new Uint8Array(e.dictionary):e.dictionary,i=lo.deflateSetDictionary(this.strm,t),i!==To)throw new Error(da[i]);this._dict_set=!0}}function Co(t,e){const i=new Lo(e);if(i.push(t,!0),i.err)throw i.msg||da[i.err];return i.result}Lo.prototype.push=function(t,e){const i=this.strm,r=this.options.chunkSize;let n,s;if(this.ended)return!1;for(s=e===~~e?e:!0===e?xo:yo,"string"==typeof t?i.input=go(t):"[object ArrayBuffer]"===bo.call(t)?i.input=new Uint8Array(t):i.input=t,i.next_in=0,i.avail_in=i.input.length;;)if(0===i.avail_out&&(i.output=new Uint8Array(r),i.next_out=0,i.avail_out=r),(s===_o||s===Ao)&&i.avail_out<=6)this.onData(i.output.subarray(0,i.next_out)),i.avail_out=0;else{if(n=lo.deflate(i,s),n===Eo)return i.next_out>0&&this.onData(i.output.subarray(0,i.next_out)),n=lo.deflateEnd(this.strm),this.onEnd(n),this.ended=!0,n===To;if(0!==i.avail_out){if(s>0&&i.next_out>0)this.onData(i.output.subarray(0,i.next_out)),i.avail_out=0;else if(0===i.avail_in)break}else this.onData(i.output)}return!0},Lo.prototype.onData=function(t){this.chunks.push(t)},Lo.prototype.onEnd=function(t){t===To&&(this.result=uo(this.chunks)),this.chunks=[],this.err=t,this.msg=this.strm.msg};var Ro={Deflate:Lo,deflate:Co,deflateRaw:function(t,e){return(e=e||{}).raw=!0,Co(t,e)},gzip:function(t,e){return(e=e||{}).gzip=!0,Co(t,e)},constants:ua};var Mo=function(t,e){let i,r,n,s,a,o,l,h,c,d,u,f,m,g,p,w,v,b,y,_,A,x,T,E;const S=t.state;i=t.next_in,T=t.input,r=i+(t.avail_in-5),n=t.next_out,E=t.output,s=n-(e-t.avail_out),a=n+(t.avail_out-257),o=S.dmax,l=S.wsize,h=S.whave,c=S.wnext,d=S.window,u=S.hold,f=S.bits,m=S.lencode,g=S.distcode,p=(1<<S.lenbits)-1,w=(1<<S.distbits)-1;t:do{f<15&&(u+=T[i++]<<f,f+=8,u+=T[i++]<<f,f+=8),v=m[u&p];e:for(;;){if(b=v>>>24,u>>>=b,f-=b,b=v>>>16&255,0===b)E[n++]=65535&v;else{if(!(16&b)){if(0==(64&b)){v=m[(65535&v)+(u&(1<<b)-1)];continue e}if(32&b){S.mode=12;break t}t.msg="invalid literal/length code",S.mode=30;break t}y=65535&v,b&=15,b&&(f<b&&(u+=T[i++]<<f,f+=8),y+=u&(1<<b)-1,u>>>=b,f-=b),f<15&&(u+=T[i++]<<f,f+=8,u+=T[i++]<<f,f+=8),v=g[u&w];i:for(;;){if(b=v>>>24,u>>>=b,f-=b,b=v>>>16&255,!(16&b)){if(0==(64&b)){v=g[(65535&v)+(u&(1<<b)-1)];continue i}t.msg="invalid distance code",S.mode=30;break t}if(_=65535&v,b&=15,f<b&&(u+=T[i++]<<f,f+=8,f<b&&(u+=T[i++]<<f,f+=8)),_+=u&(1<<b)-1,_>o){t.msg="invalid distance too far back",S.mode=30;break t}if(u>>>=b,f-=b,b=n-s,_>b){if(b=_-b,b>h&&S.sane){t.msg="invalid distance too far back",S.mode=30;break t}if(A=0,x=d,0===c){if(A+=l-b,b<y){y-=b;do{E[n++]=d[A++]}while(--b);A=n-_,x=E}}else if(c<b){if(A+=l+c-b,b-=c,b<y){y-=b;do{E[n++]=d[A++]}while(--b);if(A=0,c<y){b=c,y-=b;do{E[n++]=d[A++]}while(--b);A=n-_,x=E}}}else if(A+=c-b,b<y){y-=b;do{E[n++]=d[A++]}while(--b);A=n-_,x=E}for(;y>2;)E[n++]=x[A++],E[n++]=x[A++],E[n++]=x[A++],y-=3;y&&(E[n++]=x[A++],y>1&&(E[n++]=x[A++]))}else{A=n-_;do{E[n++]=E[A++],E[n++]=E[A++],E[n++]=E[A++],y-=3}while(y>2);y&&(E[n++]=E[A++],y>1&&(E[n++]=E[A++]))}break}}break}}while(i<r&&n<a);y=f>>3,i-=y,f-=y<<3,u&=(1<<f)-1,t.next_in=i,t.next_out=n,t.avail_in=i<r?r-i+5:5-(i-r),t.avail_out=n<a?a-n+257:257-(n-a),S.hold=u,S.bits=f};const Uo=15,ko=new Uint16Array([3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0]),Fo=new Uint8Array([16,16,16,16,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,16,72,78]),Do=new Uint16Array([1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577,0,0]),Po=new Uint8Array([16,16,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,64,64]);var No=(t,e,i,r,n,s,a,o)=>{const l=o.bits;let h,c,d,u,f,m,g=0,p=0,w=0,v=0,b=0,y=0,_=0,A=0,x=0,T=0,E=null,S=0;const B=new Uint16Array(16),I=new Uint16Array(16);let L,C,R,M=null,U=0;for(g=0;g<=Uo;g++)B[g]=0;for(p=0;p<r;p++)B[e[i+p]]++;for(b=l,v=Uo;v>=1&&0===B[v];v--);if(b>v&&(b=v),0===v)return n[s++]=20971520,n[s++]=20971520,o.bits=1,0;for(w=1;w<v&&0===B[w];w++);for(b<w&&(b=w),A=1,g=1;g<=Uo;g++)if(A<<=1,A-=B[g],A<0)return-1;if(A>0&&(0===t||1!==v))return-1;for(I[1]=0,g=1;g<Uo;g++)I[g+1]=I[g]+B[g];for(p=0;p<r;p++)0!==e[i+p]&&(a[I[e[i+p]]++]=p);if(0===t?(E=M=a,m=19):1===t?(E=ko,S-=257,M=Fo,U-=257,m=256):(E=Do,M=Po,m=-1),T=0,p=0,g=w,f=s,y=b,_=0,d=-1,x=1<<b,u=x-1,1===t&&x>852||2===t&&x>592)return 1;for(;;){L=g-_,a[p]<m?(C=0,R=a[p]):a[p]>m?(C=M[U+a[p]],R=E[S+a[p]]):(C=96,R=0),h=1<<g-_,c=1<<y,w=c;do{c-=h,n[f+(T>>_)+c]=L<<24|C<<16|R|0}while(0!==c);for(h=1<<g-1;T&h;)h>>=1;if(0!==h?(T&=h-1,T+=h):T=0,p++,0==--B[g]){if(g===v)break;g=e[i+a[p]]}if(g>b&&(T&u)!==d){for(0===_&&(_=b),f+=w,y=g-_,A=1<<y;y+_<v&&(A-=B[y+_],!(A<=0));)y++,A<<=1;if(x+=1<<y,1===t&&x>852||2===t&&x>592)return 1;d=T&u,n[d]=b<<24|y<<16|f-s|0}}return 0!==T&&(n[f+T]=g-_<<24|64<<16|0),o.bits=b,0};const{Z_FINISH:Oo,Z_BLOCK:Vo,Z_TREES:Go,Z_OK:zo,Z_STREAM_END:jo,Z_NEED_DICT:Ko,Z_STREAM_ERROR:Ho,Z_DATA_ERROR:$o,Z_MEM_ERROR:Xo,Z_BUF_ERROR:qo,Z_DEFLATED:Yo}=ua,Wo=12,Zo=30,Qo=t=>(t>>>24&255)+(t>>>8&65280)+((65280&t)<<8)+((255&t)<<24);function Jo(){this.mode=0,this.last=!1,this.wrap=0,this.havedict=!1,this.flags=0,this.dmax=0,this.check=0,this.total=0,this.head=null,this.wbits=0,this.wsize=0,this.whave=0,this.wnext=0,this.window=null,this.hold=0,this.bits=0,this.length=0,this.offset=0,this.extra=0,this.lencode=null,this.distcode=null,this.lenbits=0,this.distbits=0,this.ncode=0,this.nlen=0,this.ndist=0,this.have=0,this.next=null,this.lens=new Uint16Array(320),this.work=new Uint16Array(288),this.lendyn=null,this.distdyn=null,this.sane=0,this.back=0,this.was=0}const tl=t=>{if(!t||!t.state)return Ho;const e=t.state;return t.total_in=t.total_out=e.total=0,t.msg="",e.wrap&&(t.adler=1&e.wrap),e.mode=1,e.last=0,e.havedict=0,e.dmax=32768,e.head=null,e.hold=0,e.bits=0,e.lencode=e.lendyn=new Int32Array(852),e.distcode=e.distdyn=new Int32Array(592),e.sane=1,e.back=-1,zo},el=t=>{if(!t||!t.state)return Ho;const e=t.state;return e.wsize=0,e.whave=0,e.wnext=0,tl(t)},il=(t,e)=>{let i;if(!t||!t.state)return Ho;const r=t.state;return e<0?(i=0,e=-e):(i=1+(e>>4),e<48&&(e&=15)),e&&(e<8||e>15)?Ho:(null!==r.window&&r.wbits!==e&&(r.window=null),r.wrap=i,r.wbits=e,el(t))},rl=(t,e)=>{if(!t)return Ho;const i=new Jo;t.state=i,i.window=null;const r=il(t,e);return r!==zo&&(t.state=null),r};let nl,sl,al=!0;const ol=t=>{if(al){nl=new Int32Array(512),sl=new Int32Array(32);let e=0;for(;e<144;)t.lens[e++]=8;for(;e<256;)t.lens[e++]=9;for(;e<280;)t.lens[e++]=7;for(;e<288;)t.lens[e++]=8;for(No(1,t.lens,0,288,nl,0,t.work,{bits:9}),e=0;e<32;)t.lens[e++]=5;No(2,t.lens,0,32,sl,0,t.work,{bits:5}),al=!1}t.lencode=nl,t.lenbits=9,t.distcode=sl,t.distbits=5},ll=(t,e,i,r)=>{let n;const s=t.state;return null===s.window&&(s.wsize=1<<s.wbits,s.wnext=0,s.whave=0,s.window=new Uint8Array(s.wsize)),r>=s.wsize?(s.window.set(e.subarray(i-s.wsize,i),0),s.wnext=0,s.whave=s.wsize):(n=s.wsize-s.wnext,n>r&&(n=r),s.window.set(e.subarray(i-r,i-r+n),s.wnext),(r-=n)?(s.window.set(e.subarray(i-r,i),0),s.wnext=r,s.whave=s.wsize):(s.wnext+=n,s.wnext===s.wsize&&(s.wnext=0),s.whave<s.wsize&&(s.whave+=n))),0};var hl=(t,e)=>{let i,r,n,s,a,o,l,h,c,d,u,f,m,g,p,w,v,b,y,_,A,x,T=0;const E=new Uint8Array(4);let S,B;const I=new Uint8Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]);if(!t||!t.state||!t.output||!t.input&&0!==t.avail_in)return Ho;i=t.state,i.mode===Wo&&(i.mode=13),a=t.next_out,n=t.output,l=t.avail_out,s=t.next_in,r=t.input,o=t.avail_in,h=i.hold,c=i.bits,d=o,u=l,x=zo;t:for(;;)switch(i.mode){case 1:if(0===i.wrap){i.mode=13;break}for(;c<16;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}if(2&i.wrap&&35615===h){i.check=0,E[0]=255&h,E[1]=h>>>8&255,i.check=ca(i.check,E,2,0),h=0,c=0,i.mode=2;break}if(i.flags=0,i.head&&(i.head.done=!1),!(1&i.wrap)||(((255&h)<<8)+(h>>8))%31){t.msg="incorrect header check",i.mode=Zo;break}if((15&h)!==Yo){t.msg="unknown compression method",i.mode=Zo;break}if(h>>>=4,c-=4,A=8+(15&h),0===i.wbits)i.wbits=A;else if(A>i.wbits){t.msg="invalid window size",i.mode=Zo;break}i.dmax=1<<i.wbits,t.adler=i.check=1,i.mode=512&h?10:Wo,h=0,c=0;break;case 2:for(;c<16;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}if(i.flags=h,(255&i.flags)!==Yo){t.msg="unknown compression method",i.mode=Zo;break}if(57344&i.flags){t.msg="unknown header flags set",i.mode=Zo;break}i.head&&(i.head.text=h>>8&1),512&i.flags&&(E[0]=255&h,E[1]=h>>>8&255,i.check=ca(i.check,E,2,0)),h=0,c=0,i.mode=3;case 3:for(;c<32;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}i.head&&(i.head.time=h),512&i.flags&&(E[0]=255&h,E[1]=h>>>8&255,E[2]=h>>>16&255,E[3]=h>>>24&255,i.check=ca(i.check,E,4,0)),h=0,c=0,i.mode=4;case 4:for(;c<16;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}i.head&&(i.head.xflags=255&h,i.head.os=h>>8),512&i.flags&&(E[0]=255&h,E[1]=h>>>8&255,i.check=ca(i.check,E,2,0)),h=0,c=0,i.mode=5;case 5:if(1024&i.flags){for(;c<16;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}i.length=h,i.head&&(i.head.extra_len=h),512&i.flags&&(E[0]=255&h,E[1]=h>>>8&255,i.check=ca(i.check,E,2,0)),h=0,c=0}else i.head&&(i.head.extra=null);i.mode=6;case 6:if(1024&i.flags&&(f=i.length,f>o&&(f=o),f&&(i.head&&(A=i.head.extra_len-i.length,i.head.extra||(i.head.extra=new Uint8Array(i.head.extra_len)),i.head.extra.set(r.subarray(s,s+f),A)),512&i.flags&&(i.check=ca(i.check,r,f,s)),o-=f,s+=f,i.length-=f),i.length))break t;i.length=0,i.mode=7;case 7:if(2048&i.flags){if(0===o)break t;f=0;do{A=r[s+f++],i.head&&A&&i.length<65536&&(i.head.name+=String.fromCharCode(A))}while(A&&f<o);if(512&i.flags&&(i.check=ca(i.check,r,f,s)),o-=f,s+=f,A)break t}else i.head&&(i.head.name=null);i.length=0,i.mode=8;case 8:if(4096&i.flags){if(0===o)break t;f=0;do{A=r[s+f++],i.head&&A&&i.length<65536&&(i.head.comment+=String.fromCharCode(A))}while(A&&f<o);if(512&i.flags&&(i.check=ca(i.check,r,f,s)),o-=f,s+=f,A)break t}else i.head&&(i.head.comment=null);i.mode=9;case 9:if(512&i.flags){for(;c<16;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}if(h!==(65535&i.check)){t.msg="header crc mismatch",i.mode=Zo;break}h=0,c=0}i.head&&(i.head.hcrc=i.flags>>9&1,i.head.done=!0),t.adler=i.check=0,i.mode=Wo;break;case 10:for(;c<32;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}t.adler=i.check=Qo(h),h=0,c=0,i.mode=11;case 11:if(0===i.havedict)return t.next_out=a,t.avail_out=l,t.next_in=s,t.avail_in=o,i.hold=h,i.bits=c,Ko;t.adler=i.check=1,i.mode=Wo;case Wo:if(e===Vo||e===Go)break t;case 13:if(i.last){h>>>=7&c,c-=7&c,i.mode=27;break}for(;c<3;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}switch(i.last=1&h,h>>>=1,c-=1,3&h){case 0:i.mode=14;break;case 1:if(ol(i),i.mode=20,e===Go){h>>>=2,c-=2;break t}break;case 2:i.mode=17;break;case 3:t.msg="invalid block type",i.mode=Zo}h>>>=2,c-=2;break;case 14:for(h>>>=7&c,c-=7&c;c<32;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}if((65535&h)!=(h>>>16^65535)){t.msg="invalid stored block lengths",i.mode=Zo;break}if(i.length=65535&h,h=0,c=0,i.mode=15,e===Go)break t;case 15:i.mode=16;case 16:if(f=i.length,f){if(f>o&&(f=o),f>l&&(f=l),0===f)break t;n.set(r.subarray(s,s+f),a),o-=f,s+=f,l-=f,a+=f,i.length-=f;break}i.mode=Wo;break;case 17:for(;c<14;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}if(i.nlen=257+(31&h),h>>>=5,c-=5,i.ndist=1+(31&h),h>>>=5,c-=5,i.ncode=4+(15&h),h>>>=4,c-=4,i.nlen>286||i.ndist>30){t.msg="too many length or distance symbols",i.mode=Zo;break}i.have=0,i.mode=18;case 18:for(;i.have<i.ncode;){for(;c<3;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}i.lens[I[i.have++]]=7&h,h>>>=3,c-=3}for(;i.have<19;)i.lens[I[i.have++]]=0;if(i.lencode=i.lendyn,i.lenbits=7,S={bits:i.lenbits},x=No(0,i.lens,0,19,i.lencode,0,i.work,S),i.lenbits=S.bits,x){t.msg="invalid code lengths set",i.mode=Zo;break}i.have=0,i.mode=19;case 19:for(;i.have<i.nlen+i.ndist;){for(;T=i.lencode[h&(1<<i.lenbits)-1],p=T>>>24,w=T>>>16&255,v=65535&T,!(p<=c);){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}if(v<16)h>>>=p,c-=p,i.lens[i.have++]=v;else{if(16===v){for(B=p+2;c<B;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}if(h>>>=p,c-=p,0===i.have){t.msg="invalid bit length repeat",i.mode=Zo;break}A=i.lens[i.have-1],f=3+(3&h),h>>>=2,c-=2}else if(17===v){for(B=p+3;c<B;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}h>>>=p,c-=p,A=0,f=3+(7&h),h>>>=3,c-=3}else{for(B=p+7;c<B;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}h>>>=p,c-=p,A=0,f=11+(127&h),h>>>=7,c-=7}if(i.have+f>i.nlen+i.ndist){t.msg="invalid bit length repeat",i.mode=Zo;break}for(;f--;)i.lens[i.have++]=A}}if(i.mode===Zo)break;if(0===i.lens[256]){t.msg="invalid code -- missing end-of-block",i.mode=Zo;break}if(i.lenbits=9,S={bits:i.lenbits},x=No(1,i.lens,0,i.nlen,i.lencode,0,i.work,S),i.lenbits=S.bits,x){t.msg="invalid literal/lengths set",i.mode=Zo;break}if(i.distbits=6,i.distcode=i.distdyn,S={bits:i.distbits},x=No(2,i.lens,i.nlen,i.ndist,i.distcode,0,i.work,S),i.distbits=S.bits,x){t.msg="invalid distances set",i.mode=Zo;break}if(i.mode=20,e===Go)break t;case 20:i.mode=21;case 21:if(o>=6&&l>=258){t.next_out=a,t.avail_out=l,t.next_in=s,t.avail_in=o,i.hold=h,i.bits=c,Mo(t,u),a=t.next_out,n=t.output,l=t.avail_out,s=t.next_in,r=t.input,o=t.avail_in,h=i.hold,c=i.bits,i.mode===Wo&&(i.back=-1);break}for(i.back=0;T=i.lencode[h&(1<<i.lenbits)-1],p=T>>>24,w=T>>>16&255,v=65535&T,!(p<=c);){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}if(w&&0==(240&w)){for(b=p,y=w,_=v;T=i.lencode[_+((h&(1<<b+y)-1)>>b)],p=T>>>24,w=T>>>16&255,v=65535&T,!(b+p<=c);){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}h>>>=b,c-=b,i.back+=b}if(h>>>=p,c-=p,i.back+=p,i.length=v,0===w){i.mode=26;break}if(32&w){i.back=-1,i.mode=Wo;break}if(64&w){t.msg="invalid literal/length code",i.mode=Zo;break}i.extra=15&w,i.mode=22;case 22:if(i.extra){for(B=i.extra;c<B;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}i.length+=h&(1<<i.extra)-1,h>>>=i.extra,c-=i.extra,i.back+=i.extra}i.was=i.length,i.mode=23;case 23:for(;T=i.distcode[h&(1<<i.distbits)-1],p=T>>>24,w=T>>>16&255,v=65535&T,!(p<=c);){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}if(0==(240&w)){for(b=p,y=w,_=v;T=i.distcode[_+((h&(1<<b+y)-1)>>b)],p=T>>>24,w=T>>>16&255,v=65535&T,!(b+p<=c);){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}h>>>=b,c-=b,i.back+=b}if(h>>>=p,c-=p,i.back+=p,64&w){t.msg="invalid distance code",i.mode=Zo;break}i.offset=v,i.extra=15&w,i.mode=24;case 24:if(i.extra){for(B=i.extra;c<B;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}i.offset+=h&(1<<i.extra)-1,h>>>=i.extra,c-=i.extra,i.back+=i.extra}if(i.offset>i.dmax){t.msg="invalid distance too far back",i.mode=Zo;break}i.mode=25;case 25:if(0===l)break t;if(f=u-l,i.offset>f){if(f=i.offset-f,f>i.whave&&i.sane){t.msg="invalid distance too far back",i.mode=Zo;break}f>i.wnext?(f-=i.wnext,m=i.wsize-f):m=i.wnext-f,f>i.length&&(f=i.length),g=i.window}else g=n,m=a-i.offset,f=i.length;f>l&&(f=l),l-=f,i.length-=f;do{n[a++]=g[m++]}while(--f);0===i.length&&(i.mode=21);break;case 26:if(0===l)break t;n[a++]=i.length,l--,i.mode=21;break;case 27:if(i.wrap){for(;c<32;){if(0===o)break t;o--,h|=r[s++]<<c,c+=8}if(u-=l,t.total_out+=u,i.total+=u,u&&(t.adler=i.check=i.flags?ca(i.check,n,u,a-u):la(i.check,n,u,a-u)),u=l,(i.flags?h:Qo(h))!==i.check){t.msg="incorrect data check",i.mode=Zo;break}h=0,c=0}i.mode=28;case 28:if(i.wrap&&i.flags){for(;c<32;){if(0===o)break t;o--,h+=r[s++]<<c,c+=8}if(h!==(4294967295&i.total)){t.msg="incorrect length check",i.mode=Zo;break}h=0,c=0}i.mode=29;case 29:x=jo;break t;case Zo:x=$o;break t;case 31:return Xo;default:return Ho}return t.next_out=a,t.avail_out=l,t.next_in=s,t.avail_in=o,i.hold=h,i.bits=c,(i.wsize||u!==t.avail_out&&i.mode<Zo&&(i.mode<27||e!==Oo))&&ll(t,t.output,t.next_out,u-t.avail_out),d-=t.avail_in,u-=t.avail_out,t.total_in+=d,t.total_out+=u,i.total+=u,i.wrap&&u&&(t.adler=i.check=i.flags?ca(i.check,n,u,t.next_out-u):la(i.check,n,u,t.next_out-u)),t.data_type=i.bits+(i.last?64:0)+(i.mode===Wo?128:0)+(20===i.mode||15===i.mode?256:0),(0===d&&0===u||e===Oo)&&x===zo&&(x=qo),x},cl={inflateReset:el,inflateReset2:il,inflateResetKeep:tl,inflateInit:t=>rl(t,15),inflateInit2:rl,inflate:hl,inflateEnd:t=>{if(!t||!t.state)return Ho;let e=t.state;return e.window&&(e.window=null),t.state=null,zo},inflateGetHeader:(t,e)=>{if(!t||!t.state)return Ho;const i=t.state;return 0==(2&i.wrap)?Ho:(i.head=e,e.done=!1,zo)},inflateSetDictionary:(t,e)=>{const i=e.length;let r,n,s;return t&&t.state?(r=t.state,0!==r.wrap&&11!==r.mode?Ho:11===r.mode&&(n=1,n=la(n,e,i,0),n!==r.check)?$o:(s=ll(t,e,i,i),s?(r.mode=31,Xo):(r.havedict=1,zo))):Ho},inflateInfo:"pako inflate (from Nodeca project)"};var dl=function(){this.text=0,this.time=0,this.xflags=0,this.os=0,this.extra=null,this.extra_len=0,this.name="",this.comment="",this.hcrc=0,this.done=!1};const ul=Object.prototype.toString,{Z_NO_FLUSH:fl,Z_FINISH:ml,Z_OK:gl,Z_STREAM_END:pl,Z_NEED_DICT:wl,Z_STREAM_ERROR:vl,Z_DATA_ERROR:bl,Z_MEM_ERROR:yl}=ua;function _l(t){this.options=co({chunkSize:65536,windowBits:15,to:""},t||{});const e=this.options;e.raw&&e.windowBits>=0&&e.windowBits<16&&(e.windowBits=-e.windowBits,0===e.windowBits&&(e.windowBits=-15)),!(e.windowBits>=0&&e.windowBits<16)||t&&t.windowBits||(e.windowBits+=32),e.windowBits>15&&e.windowBits<48&&0==(15&e.windowBits)&&(e.windowBits|=15),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new vo,this.strm.avail_out=0;let i=cl.inflateInit2(this.strm,e.windowBits);if(i!==gl)throw new Error(da[i]);if(this.header=new dl,cl.inflateGetHeader(this.strm,this.header),e.dictionary&&("string"==typeof e.dictionary?e.dictionary=go(e.dictionary):"[object ArrayBuffer]"===ul.call(e.dictionary)&&(e.dictionary=new Uint8Array(e.dictionary)),e.raw&&(i=cl.inflateSetDictionary(this.strm,e.dictionary),i!==gl)))throw new Error(da[i])}function Al(t,e){const i=new _l(e);if(i.push(t),i.err)throw i.msg||da[i.err];return i.result}_l.prototype.push=function(t,e){const i=this.strm,r=this.options.chunkSize,n=this.options.dictionary;let s,a,o;if(this.ended)return!1;for(a=e===~~e?e:!0===e?ml:fl,"[object ArrayBuffer]"===ul.call(t)?i.input=new Uint8Array(t):i.input=t,i.next_in=0,i.avail_in=i.input.length;;){for(0===i.avail_out&&(i.output=new Uint8Array(r),i.next_out=0,i.avail_out=r),s=cl.inflate(i,a),s===wl&&n&&(s=cl.inflateSetDictionary(i,n),s===gl?s=cl.inflate(i,a):s===bl&&(s=wl));i.avail_in>0&&s===pl&&i.state.wrap>0&&0!==t[i.next_in];)cl.inflateReset(i),s=cl.inflate(i,a);switch(s){case vl:case bl:case wl:case yl:return this.onEnd(s),this.ended=!0,!1}if(o=i.avail_out,i.next_out&&(0===i.avail_out||s===pl))if("string"===this.options.to){let t=wo(i.output,i.next_out),e=i.next_out-t,n=po(i.output,t);i.next_out=e,i.avail_out=r-e,e&&i.output.set(i.output.subarray(t,t+e),0),this.onData(n)}else this.onData(i.output.length===i.next_out?i.output:i.output.subarray(0,i.next_out));if(s!==gl||0!==o){if(s===pl)return s=cl.inflateEnd(this.strm),this.onEnd(s),this.ended=!0,!0;if(0===i.avail_in)break}}return!0},_l.prototype.onData=function(t){this.chunks.push(t)},_l.prototype.onEnd=function(t){t===gl&&("string"===this.options.to?this.result=this.chunks.join(""):this.result=uo(this.chunks)),this.chunks=[],this.err=t,this.msg=this.strm.msg};var xl={Inflate:_l,inflate:Al,inflateRaw:function(t,e){return(e=e||{}).raw=!0,Al(t,e)},ungzip:Al,constants:ua};const{Deflate:Tl,deflate:El,deflateRaw:Sl,gzip:Bl}=Ro,{Inflate:Il,inflate:Ll,inflateRaw:Cl,ungzip:Rl}=xl;var Ml=El,Ul=Ll;class kl{constructor(t){this.ctype=0,this.outputPos=0,this.dsize_bits=0,this.dsize_mask=0,this.bit_buff=0,this.extra_bits=0,this.in_pos=0,this.out_buff=[],this.in_buff=t}}const Fl=new Uint8Array([2,4,4,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8]),Dl=new Uint8Array([3,13,5,25,9,17,1,62,30,46,14,54,22,38,6,58,26,42,10,50,18,34,66,2,124,60,92,28,108,44,76,12,116,52,84,20,100,36,68,4,120,56,88,24,104,40,72,8,240,112,176,48,208,80,144,16,224,96,160,32,192,64,128,0]),Pl=new Uint8Array([0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8]),Nl=new Uint16Array([0,1,2,3,4,5,6,7,8,10,14,22,38,70,134,262]),Ol=new Uint8Array([3,2,3,3,4,4,4,5,5,5,5,6,6,6,7,7]),Vl=new Uint8Array([5,3,1,6,10,2,12,20,4,24,8,48,16,32,64,0]),Gl=new Uint8Array([11,12,12,12,12,12,12,12,12,8,7,12,12,7,12,12,12,12,12,12,12,12,12,12,12,12,13,12,12,12,12,12,4,10,8,12,10,12,10,8,7,7,8,9,7,6,7,8,7,6,7,7,7,7,8,7,7,8,8,12,11,7,9,11,12,6,7,6,6,5,7,8,8,6,11,9,6,7,6,6,7,11,6,6,6,7,9,8,9,9,11,8,11,9,12,8,12,5,6,6,6,5,6,6,6,5,11,7,5,6,5,5,6,10,5,5,5,5,8,7,8,8,10,11,11,12,12,12,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,12,13,13,13,12,13,13,13,12,13,13,13,13,12,13,13,13,12,12,12,13,13,13,13,13,13,13,13,13,13,13]),zl=new Uint16Array([1168,4064,2016,3040,992,3552,1504,2528,480,184,98,3808,1760,34,2784,736,3296,1248,2272,224,3936,1888,2912,864,3424,1376,4672,2400,352,3680,1632,2656,15,592,56,608,80,3168,912,216,66,2,88,432,124,41,60,152,92,9,28,108,44,76,24,12,116,232,104,1120,144,52,176,1808,2144,49,84,17,33,23,20,168,40,1,784,304,62,100,30,46,36,1296,14,54,22,68,48,200,464,208,272,72,1552,336,96,136,4e3,7,38,6,58,27,26,42,10,11,528,4,19,50,3,29,18,400,13,21,5,25,8,120,240,112,656,1040,16,1952,2976,928,576,7232,3136,5184,1088,6208,2112,4160,64,8064,3968,6016,1920,7040,2944,4992,896,7552,3456,5504,1408,6528,2432,4480,384,7808,3712,5760,1664,6784,2688,4736,640,7296,3200,5248,1152,6272,2176,4224,128,7936,3840,5888,1792,6912,2816,4864,3488,1440,2464,416,3744,1696,2720,672,3232,1184,2208,160,3872,1824,2848,800,3360,1312,2336,288,3616,1568,2592,544,3104,1056,2080,32,4032,1984,3008,960,3520,1472,2496,448,3776,1728,2752,704,3264,1216,2240,192,3904,1856,2880,832,768,3392,7424,3328,5376,1344,1280,6400,2304,2368,4352,256,7680,3584,320,5632,1536,6656,3648,1600,2624,2560,4608,512,7168,3072,5120,1024,6144,2048,4096,0]);let jl=!1;const Kl=new Uint8Array(256),Hl=new Uint8Array(256);let $l=!1;const Xl=new Uint8Array(256),ql=new Uint8Array(256),Yl=new Uint8Array(128),Wl=new Uint8Array(256);function Zl(t,e,i){for(let r=0,n=e.length;r<n;r++){const n=1<<i[r];for(let i=e[r];i<256;i+=n)t[i]=r}}function Ql(t,e){return e<=t.extra_bits?(t.extra_bits-=e,t.bit_buff>>=e,0):(t.bit_buff>>=t.extra_bits,t.in_pos===t.in_buff.byteLength?1:(t.bit_buff|=t.in_buff[t.in_pos++]<<8,t.bit_buff>>=e-t.extra_bits,t.extra_bits=t.extra_bits-e+8,0))}function Jl(t){if(1&t.bit_buff){if(Ql(t,1))return 774;let e,i=Hl[255&t.bit_buff];if(Ql(t,Ol[i]))return 774;if(0!=(e=Pl[i])){const r=t.bit_buff&(1<<e)-1;if(Ql(t,e)&&i+r!=270)return 774;i=Nl[i]+r}return i+256}if(Ql(t,1))return 774;if(0==t.ctype){const e=255&t.bit_buff;return Ql(t,8)?774:e}let e;if(255&t.bit_buff){if(e=Xl[255&t.bit_buff],255==e)if(63&t.bit_buff){if(Ql(t,4))return 774;e=ql[255&t.bit_buff]}else{if(Ql(t,6))return 774;e=Yl[127&t.bit_buff]}}else{if(Ql(t,8))return 774;e=Wl[255&t.bit_buff]}return Ql(t,Gl[e])?774:e}function th(t,e){const i=Kl[255&t.bit_buff];if(Ql(t,Fl[i]))return 0;let r;if(2==e){if(r=i<<2|3&t.bit_buff,Ql(t,2))return 0}else if(r=i<<t.dsize_bits|t.bit_buff&t.dsize_mask,Ql(t,t.dsize_bits))return 0;return r+1}function eh(t){const e=new kl(t);if(e.in_buff.byteLength<=4)throw new Error("Bad data");if(e.ctype=e.in_buff[0],e.dsize_bits=e.in_buff[1],e.bit_buff=e.in_buff[2],e.extra_bits=0,e.in_pos=3,4>e.dsize_bits||e.dsize_bits>6)throw new Error("Invalid dictionary size");if(e.dsize_mask=65535>>16-e.dsize_bits,0!==e.ctype){if(1!==e.ctype)throw new Error("Invalid mode");$l||(!function(){let t,e,i=255;for(let r=255;i>=0;i--,r--){const n=r;let s=Gl[n];if(s<=8){e=1<<s,t=zl[i];do{Xl[t]=r,t+=e}while(t<256)}else if(0!=(t=255&zl[i]))if(Xl[t]=255,63&zl[i]){s-=4,Gl[n]=s,e=1<<s,t=zl[i]>>4;do{ql[t]=r,t+=e}while(t<256)}else{s-=6,Gl[n]=s,e=1<<s,t=zl[i]>>6;do{Yl[t]=r,t+=e}while(t<128)}else{s-=8,Gl[n]=s,e=1<<s,t=zl[i]>>8;do{Wl[t]=r,t+=e}while(t<256)}}}(),$l=!0)}if(jl||(Zl(Hl,Vl,Ol),Zl(Kl,Dl,Fl),jl=!0),774===function(t){let e;for(;(e=Jl(t))<773;)if(e>=256){let i,r=e-254;if(0==(i=th(t,r)))return 774;let n=t.outputPos,s=n-i;for(t.outputPos+=r;r-- >0;)t.out_buff[n++]=t.out_buff[s++]}else t.out_buff[t.outputPos++]=e;return e}(e))throw new Error("Error while expanding");return new Uint8Array(e.out_buff)}function ih(t){let e=-1;for(let i=0,r=Math.ceil(t.byteLength/512);i<r;i++){const r=512*i;77===t[r]&&80===t[r+1]&&81===t[r+2]&&26===t[r+3]&&(e=r)}return e}class rh{constructor(t,e,i,r,n){this.rawBuffer=null,this.buffer=null;const s=t.headerOffset;this.archive=t,this.c=t.c,this.name=`File${`${e.blockIndex}`.padStart(8,"0")}`,this.nameResolved=!1,this.hash=e,this.block=i,r&&(this.rawBuffer=r.slice(s+i.offset,s+i.offset+i.compressedSize)),n&&(this.buffer=n)}bytes(){return null===this.buffer&&this.decode(),this.buffer}arrayBuffer(){return this.bytes().buffer}text(){return $t(this.bytes())}set(t){if(this.archive.readonly)return!1;const e=this.hash,i=this.block;return e.locale=0,e.platform=0,i.compressedSize=0,i.normalSize=t.byteLength,i.flags=0,this.buffer=t,this.rawBuffer=null,!0}delete(){if(this.archive.readonly)return!1;const t=this.archive,e=this.hash,i=e.blockIndex;e.delete();for(const e of t.hashTable.entries)e.blockIndex<cs&&e.blockIndex>i&&(e.blockIndex-=1);return t.blockTable.entries.splice(i,1),t.files.splice(i,1),!0}rename(t){if(this.archive.readonly)return!1;const e=this.hash,i=e.locale,r=e.platform,n=e.blockIndex;e.delete();const s=this.archive.hashTable.add(t,n);return s.locale=i,s.platform=r,this.name=t,this.nameResolved=!0,this.hash=s,!0}decode(){if(!this.rawBuffer)throw new Error(`File ${this.name}: Nothing to decode`);const t=this.archive,e=this.block,i=t.c,r=i.computeFileKey(this.name,e),n=this.rawBuffer,s=e.flags;if(s===ps)this.buffer=n.slice(0,e.normalSize);else if(s&gs){let t;t=s&fs?i.decryptBlock(n.slice(0,e.compressedSize),r):n.subarray(0,e.compressedSize),t=512&s?this.decompressSector(t,e.normalSize):t.slice(),this.buffer=t}else{const a=Math.ceil(e.normalSize/t.sectorSize),o=new Uint8Array(e.normalSize);let l=new Uint32Array(n.buffer,0,a+1);s&fs&&(l=i.decryptBlock(l.slice(),r-1));let h=l[0],c=l[1],d=0;for(let u=0;u<a;u++){let f;if(f=s&fs?i.decryptBlock(n.slice(h,c),r+u):n.subarray(h,c),512&s){let i=t.sectorSize;e.normalSize-d<i&&(i=e.normalSize-d),f=this.decompressSector(f,i)}256&s&&(f=eh(f)),o.set(f,d),d+=f.byteLength,u<a&&(h=c,c=l[u+2])}this.buffer=o}t.readonly&&(this.rawBuffer=null)}decompressSector(t,e){if(t.byteLength===e)return t;{const e=t[0];if(16&e)throw new Error(`File ${this.name}: compression type 'bzip2' not supported`);if(8&e)try{t=eh(t.subarray(1))}catch(t){throw new Error(`File ${this.name}: failed to decompress with 'explode': ${t}`)}if(2&e)try{t=Ul(t.subarray(1))}catch(t){throw new Error(`File ${this.name}: failed to decompress with 'zlib': ${t}`)}if(1&e)throw new Error(`File ${this.name}: compression type 'huffman' not supported`);if(128&e)throw new Error(`File ${this.name}: compression type 'adpcm stereo' not supported`);if(64&e)throw new Error(`File ${this.name}: compression type 'adpcm mono' not supported`);return t}}encode(){if(null!==this.buffer&&null===this.rawBuffer){const e=this.buffer;if(72===(t=e)[0]&&77===t[1]&&51===t[2]&&87===t[3]||-1!==ih(t))this.rawBuffer=this.buffer,this.block.compressedSize=this.buffer.byteLength,this.block.flags=ps;else{const t=this.archive.sectorSize,i=Math.ceil(e.byteLength/t),r=new Uint32Array(i+1);let n=r.byteLength;const s=[],a=[];r[0]=n;for(let o=0;o<i;o++){const i=o*t;let l=e.subarray(i,i+t),h=l.byteLength;const c=Ml(l);let d=!1;c.byteLength+1<h&&(l=c,h=c.byteLength+1,d=!0),n+=h,r[o+1]=n,s[o]=l,a[o]=d}if(n<e.byteLength){const t=new Uint8Array(n);t.set(new Uint8Array(r.buffer)),n=r.byteLength;for(let e=0;e<i;e++){a[e]&&(t[n]=2,n+=1);const i=s[e];t.set(i,n),n+=i.byteLength}this.rawBuffer=t,this.block.compressedSize=t.byteLength,this.block.flags=2147484160}else this.rawBuffer=this.buffer,this.block.compressedSize=this.buffer.byteLength,this.block.flags=ps}}var t}reEncrypt(t){if(!this.rawBuffer)return!1;const e=this.archive,i=this.block,r=e.c,n=this.rawBuffer,s=i.flags,a=r.computeFileKey(this.name,i);i.offset=t;const o=r.computeFileKey(this.name,i);if(s&gs)r.decryptBlock(n,a),r.encryptBlock(n,o);else{const t=Math.ceil(i.normalSize/e.sectorSize),s=new Uint32Array(n.buffer,0,t+1);r.decryptBlock(s,a-1);let l=s[0],h=s[1];for(let e=0;e<t;e++){const i=n.subarray(l,h);r.decryptBlock(i,a+e),r.encryptBlock(i,o+e),e<t&&(l=h,h=s[e+2])}r.encryptBlock(s,o-1)}return!0}offsetChanged(t){const e=this.block;return e.offset!==t&&e.flags&ms?!!this.nameResolved&&this.reEncrypt(t):(e.offset=t,!0)}}class nh{constructor(){this.nameA=4294967295,this.nameB=4294967295,this.locale=65535,this.platform=65535,this.blockIndex=ds}load(t){const e=t[2];this.nameA=t[0],this.nameB=t[1],this.locale=65535&e,this.platform=e>>>16,this.blockIndex=t[3]}copy(t){this.nameA=t.nameA,this.nameB=t.nameB,this.locale=t.locale,this.platform=t.platform,this.blockIndex=t.blockIndex}save(t){t[0]=this.nameA,t[1]=this.nameB,t[2]=this.locale<<16|this.platform,t[3]=this.blockIndex}delete(){this.nameA=4294967295,this.nameB=4294967295,this.locale=65535,this.platform=65535,this.blockIndex=cs}}class sh{constructor(t){this.c=t,this.entries=[],this.addEmpties(4)}clear(){this.entries.length=0}addEmpties(t){for(let e=0;e<t;e++)this.entries.push(new nh)}getInsertionIndex(t){const e=this.entries,i=this.c.hash(t,0)&e.length-1;for(let t=0,r=e.length;t<r;t++){const n=(t+i)%r;if(65535===e[n].platform)return n}return-1}add(t,e){const i=this.getInsertionIndex(t);if(-1!==i){const r=this.entries[i];return r.nameA=this.c.hash(t,1),r.nameB=this.c.hash(t,2),r.locale=0,r.platform=0,r.blockIndex=e,r}}load(t){const e=t.byteLength/16,i=new Uint32Array(this.c.decryptBlock(t,hs).buffer);let r=0;this.clear(),this.addEmpties(e);for(const t of this.entries)t.load(i.subarray(r,r+4)),r+=4}save(t){const e=new Uint32Array(4*this.entries.length);let i=0;for(const t of this.entries)t.save(e.subarray(i,i+4)),i+=4;const r=new Uint8Array(e.buffer);this.c.encryptBlock(r,hs),t.set(r)}get(t){const e=this.c,i=this.entries,r=e.hash(t,0)&i.length-1,n=e.hash(t,1),s=e.hash(t,2);for(let t=0,e=i.length;t<e;t++){const a=i[(t+r)%e];if(n===a.nameA&&s===a.nameB)return a;if(4294967295===a.blockIndex)return null}return null}}class ah{constructor(){this.readonly=!1,this.headerOffset=0,this.sectorSize=4096,this.c=new ys,this.hashTable=new sh(this.c),this.blockTable=new ws(this.c),this.files=[]}load(t,e=!1){const i=Yt(t);this.readonly=e;const r=ih(i);if(-1===r)throw new Error("No MPQ header");const n=new Uint32Array(i.buffer,r,8),s=n[3],a=ye(n[4]+r),o=ye(n[5]+r),l=n[6];let h=n[7];h>l&&(h=l),this.headerOffset=r,this.sectorSize=512*(1<<(s>>>16)),this.hashTable.load(i.slice(a,a+16*l)),this.blockTable.load(i.slice(o,o+16*h)),this.files.length=0;for(const t of this.hashTable.entries){const e=t.blockIndex;e<this.blockTable.entries.length&&(this.files[e]=new rh(this,t,this.blockTable.entries[e],i,null))}const c=this.get("(listfile)");if(c){const t=c.text();if(t)for(const e of t.split("\r\n"))this.get(e)}}save(){if(this.readonly)return null;const t=32;this.delete("(attributes)"),this.saveMemory(),this.set("(listfile)",this.getFileNames().join("\r\n"));let e=t;for(const t of this.files)if(t){if(!t.offsetChanged(e))return null;t.encode(),e+=t.block.compressedSize}const i=this.hashTable,r=this.blockTable,n=i.entries.length,s=r.entries.length,a=e-t,o=t+a+16*n+16*s,l=t+a,h=l+16*n,c=new Uint8Array(o),d=new Uint32Array(c.buffer,0,8);d[0]=441536589,d[1]=t,d[2]=o,d[3]=Math.log2(this.sectorSize/512)<<16,d[4]=l,d[5]=h,d[6]=n,d[7]=s,e=t;for(const t of this.files)t&&(t.rawBuffer&&c.set(t.rawBuffer,e),e+=t.block.compressedSize);return i.save(c.subarray(e,e+16*i.entries.length)),e+=16*i.entries.length,r.save(c.subarray(e,e+16*r.entries.length)),c}saveMemory(){if(this.readonly)return 0;const t=this.blockTable.entries,e=this.hashTable.entries;let i=t.length,r=0;for(;i--;){const n=t[i];if(0===n.normalSize)this.removeBlock(i),r+=n.compressedSize;else{let t=!1;for(const r of e)if(r.blockIndex===i){t=!0;break}t||(this.removeBlock(i),r+=n.compressedSize)}}return r}removeBlock(t){for(const e of this.hashTable.entries)e.blockIndex<cs&&e.blockIndex>t&&(e.blockIndex-=1);this.blockTable.entries.splice(t,1)}getFileNames(){const t=[];for(const e of this.files)e&&""!==e.name&&t.push(e.name);return t}countUnresolved(){let t=0;for(const e of this.files)e.nameResolved||t++;return t}applyListfile(t){for(const e of t)this.get(e)}set(t,e){if(this.readonly)return!1;const i=Yt(e);let r=this.get(t);if(r)r.set(i);else{const e=this.blockTable.entries.length,n=this.hashTable.add(t,e);if(!n)return!1;const s=this.blockTable.add(i);r=new rh(this,n,s,null,i),r.name=t,r.nameResolved=!0,this.files[e]=r}return!0}get(t){const e=this.hashTable.get(t);if(e){const i=e.blockIndex;if(i<cs){const e=this.files[i];if(e)return e.name=t,e.nameResolved=!0,e}}return null}has(t){return!!this.get(t)}delete(t){if(this.readonly)return!1;const e=this.get(t);return!!e&&(e.delete(),!0)}rename(t,e){if(this.readonly)return!1;const i=this.get(t);return!!i&&(i.rename(e),!0)}resizeHashtable(t){if(this.readonly)return!1;var e;t=Math.max(4,(e=t,e--,e|=e>>1,e|=e>>2,e|=e>>4,e|=e>>8,e|=e>>16,++e));const i=this.files;if(i.length>t)return!1;for(const t of i)if(!t.nameResolved)return!1;const r=this.hashTable,n=r.entries,s=n.slice();r.clear(),r.addEmpties(t);for(const t of s)if(t.blockIndex!==ds){const e=i[t.blockIndex];n[r.getInsertionIndex(e.name)].copy(t)}return!0}}class oh{constructor(){this.isCustom=0,this.path=""}load(t){this.isCustom=t.readUint8(),this.path=t.readNull()}save(t){t.writeUint8(this.isCustom),t.writeNull(this.path)}getByteLength(){return 2+qt(this.path)}}class lh{constructor(){this.version=1,this.entries=new Map}load(t){const e=new Ae(t);this.version=e.readUint32();for(let t=0,i=e.readUint32();t<i;t++){const t=new oh;t.load(e),t.isCustom?this.entries.set(t.path,t):this.entries.set(`war3mapimported\\${t.path}`,t)}}save(){const t=new Ae(new ArrayBuffer(this.getByteLength()));t.writeUint32(this.version),t.writeUint32(this.entries.size);for(const e of this.entries.values())e.save(t);return t.uint8array}getByteLength(){let t=8;for(const e of this.entries.values())t+=e.getByteLength();return t}set(t){if(!this.entries.has(t)){const e=new oh;return e.isCustom=10,e.path=t,this.entries.set(t,e),!0}return!1}has(t){return this.entries.has(t)}delete(t){return this.entries.delete(t)}rename(t,e){const i=this.entries.get(t);return!!i&&(i.isCustom=10,i.path=e,!0)}}class hh{constructor(){this.id="\0\0\0\0",this.variableType=0,this.levelOrVariation=0,this.dataPointer=0,this.value=0,this.u1=0}load(t,e){if(this.id=t.readBinary(4),this.variableType=t.readInt32(),e&&(this.levelOrVariation=t.readInt32(),this.dataPointer=t.readInt32()),0===this.variableType)this.value=t.readInt32();else if(1===this.variableType||2===this.variableType)this.value=t.readFloat32();else{if(3!==this.variableType)throw new Error(`Modification: unknown variable type ${this.variableType}`);this.value=t.readNull()}this.u1=t.readInt32()}save(t,e){if(t.writeBinary(this.id),t.writeInt32(this.variableType),e&&(t.writeInt32(this.levelOrVariation),t.writeInt32(this.dataPointer)),0===this.variableType)t.writeInt32(this.value);else if(1===this.variableType||2===this.variableType)t.writeFloat32(this.value);else{if(3!==this.variableType)throw new Error(`Modification: unknown variable type ${this.variableType}`);t.writeNull(this.value)}t.writeInt32(this.u1)}getByteLength(t){let e=12;return t&&(e+=8),3===this.variableType?e+=qt(this.value)+1:e+=4,e}}class ch{constructor(){this.oldId="\0\0\0\0",this.newId="\0\0\0\0",this.modifications=[]}load(t,e){this.oldId=t.readBinary(4),this.newId=t.readBinary(4);for(let i=0,r=t.readUint32();i<r;i++){const r=new hh;r.load(t,e),this.modifications[i]=r}}save(t,e){"\0\0\0\0"!==this.oldId?t.writeBinary(this.oldId):t.writeUint32(0),"\0\0\0\0"!==this.newId?t.writeBinary(this.newId):t.writeUint32(0),t.writeUint32(this.modifications.length);for(const i of this.modifications)i.save(t,e)}getByteLength(t){let e=12;for(const i of this.modifications)e+=i.getByteLength(t);return e}}class dh{constructor(){this.objects=[]}load(t,e){for(let i=0,r=t.readUint32();i<r;i++){const r=new ch;r.load(t,e),this.objects[i]=r}}save(t,e){t.writeUint32(this.objects.length);for(const i of this.objects)i.save(t,e)}getByteLength(t){let e=4;for(const i of this.objects)e+=i.getByteLength(t);return e}}class uh{constructor(){this.version=0,this.originalTable=new dh,this.customTable=new dh}load(t){let e;e=t instanceof Ae?t:new Ae(t),this.version=e.readInt32(),this.originalTable.load(e,!0),this.customTable.load(e,!0)}save(){const t=new Ae(new ArrayBuffer(this.getByteLength()));return t.writeInt32(this.version),this.originalTable.save(t,!0),this.customTable.save(t,!0),t.uint8array}getByteLength(){return 4+this.originalTable.getByteLength(!0)+this.customTable.getByteLength(!0)}}class fh{constructor(){this.version=0,this.originalTable=new dh,this.customTable=new dh}load(t){let e;e=t instanceof Ae?t:new Ae(t),this.version=e.readInt32(),this.originalTable.load(e,!1),this.customTable.load(e,!1)}save(){const t=new Ae(new ArrayBuffer(this.getByteLength()));return t.writeInt32(this.version),this.originalTable.save(t,!1),this.customTable.save(t,!1),t.uint8array}getByteLength(){return 4+this.originalTable.getByteLength(!1)+this.customTable.getByteLength(!1)}}class mh{constructor(){this.text=""}load(t){const e=t.readInt32();e&&(this.text=t.read(e-1),t.skip(1))}save(t){this.text.length?(t.writeInt32(qt(this.text)+1),t.write(this.text),t.skip(1)):t.writeInt32(0)}getByteLength(){let t=4;return this.text.length&&(t+=qt(this.text)+1),t}}class gh{constructor(){this.version=0,this.comment="",this.trigger=new mh,this.triggers=[]}load(t){const e=new Ae(t);this.version=e.readInt32(),1===this.version&&(this.comment=e.readNull(),this.trigger.load(e));for(let t=0,i=e.readUint32();t<i;t++){const i=new mh;i.load(e),this.triggers[t]=i}}save(){const t=new Ae(new ArrayBuffer(this.getByteLength()));t.writeInt32(this.version),1===this.version&&(t.writeNull(this.comment),this.trigger.save(t)),t.writeUint32(this.triggers.length);for(const e of this.triggers)e.save(t);return t.uint8array}getByteLength(){let t=8;1===this.version&&(t+=qt(this.comment)+1+this.trigger.getByteLength());for(const e of this.triggers)t+=e.getByteLength();return t}}class ph{constructor(){this.id=0,this.name="",this.isComment=0}load(t,e){this.id=t.readInt32(),this.name=t.readNull(),7===e&&(this.isComment=t.readInt32())}save(t,e){t.writeInt32(this.id),t.writeNull(this.name),7===e&&t.writeInt32(this.isComment)}getByteLength(t){let e=5+qt(this.name);return 7===t&&(e+=4),e}}class wh{constructor(){this.name="",this.type="",this.u1=0,this.isArray=0,this.arraySize=0,this.isInitialized=0,this.initialValue=""}load(t,e){this.name=t.readNull(),this.type=t.readNull(),this.u1=t.readInt32(),this.isArray=t.readInt32(),7===e&&(this.arraySize=t.readInt32()),this.isInitialized=t.readInt32(),this.initialValue=t.readNull()}save(t,e){t.writeNull(this.name),t.writeNull(this.type),t.writeInt32(this.u1),t.writeInt32(this.isArray),7===e&&t.writeInt32(this.arraySize),t.writeInt32(this.isInitialized),t.writeNull(this.initialValue)}getByteLength(t){let e=15+qt(this.name)+qt(this.type)+qt(this.initialValue);return 7===t&&(e+=4),e}}class vh{constructor(){this.type=0,this.name="",this.beginParameters=0,this.parameters=[]}load(t,e,i){if(this.type=t.readInt32(),this.type<0||this.type>3)throw new Error(`SubParameters: Bad type: ${this.type}`);if(this.name=t.readNull(),0===this.name.length)throw new Error("SubParameters: Empty name");if(this.beginParameters=t.readInt32(),this.beginParameters){const r=i.getFunction(this.type,this.name);if(!r)throw new Error(`SubParameters "${this.name}:${this.type}": Unknown signature`);for(let n=0,s=r.args.length;n<s;n++){const r=new bh;try{r.load(t,e,i)}catch(t){throw new Error(`SubParameters "${this.name}": Parameter ${n}: ${t}`)}this.parameters[n]=r}}}save(t,e){t.writeInt32(this.type),t.writeNull(this.name),t.writeInt32(this.beginParameters);for(const i of this.parameters)i.save(t,e)}getByteLength(t){let e=9+qt(this.name);if(this.parameters.length)for(const i of this.parameters)e+=i.getByteLength(t);return e}}class bh{constructor(){this.type=0,this.value="",this.subParameters=null,this.u1=0,this.isArray=0,this.arrayIndex=null}load(t,e,i){if(this.type=t.readInt32(),this.type<-1||this.type>3)throw new Error(`Parameter: Bad type: ${this.type}`);if(this.value=t.readNull(),t.readInt32()){const r=new vh;try{r.load(t,e,i)}catch(t){throw new Error(`Parameter "${this.value}": SubParameters ${t}`)}this.subParameters=r}if((4===e&&2===this.type||7===e&&this.subParameters)&&(this.u1=t.readInt32()),(4===e&&2!==this.type||7===e)&&(this.isArray=t.readInt32()),this.isArray){const r=new bh;try{r.load(t,e,i)}catch(t){throw new Error(`Parameter "${this.value}": ArrayIndex: ${t}`)}this.arrayIndex=r}}save(t,e){t.writeInt32(this.type),t.writeNull(this.value),this.subParameters?(t.writeInt32(1),this.subParameters.save(t,e)):t.writeInt32(0),(4===e&&2===this.type||7===e&&this.subParameters)&&t.writeInt32(this.u1),(4===e&&2!==this.type||7===e)&&t.writeInt32(this.isArray),this.isArray&&this.arrayIndex&&this.arrayIndex.save(t,e)}getByteLength(t){let e=9+qt(this.value);return this.subParameters&&(e+=this.subParameters.getByteLength(t)),(4===t&&2===this.type||7===t&&this.subParameters)&&(e+=4),(4===t&&2!==this.type||7===t)&&(e+=4),this.isArray&&this.arrayIndex&&(e+=this.arrayIndex.getByteLength(t)),e}}class yh{constructor(){this.type=-1,this.group=-1,this.name="",this.isEnabled=0,this.parameters=[],this.ecas=[]}load(t,e,i,r){if(this.type=t.readInt32(),this.type<0||this.type>3)throw new Error(`ECA: Bad type: ${this.type}`);if(i&&(this.group=t.readUint32()),this.name=t.readNull(),0===this.name.length)throw new Error("ECA: Empty name");this.isEnabled=t.readInt32();const n=r.getFunction(this.type,this.name);if(!n)throw new Error(`ECA "${this.name}:${this.type}": Unknown signature`);for(let i=0,s=n.args.length;i<s;i++){const n=new bh;try{n.load(t,e,r)}catch(t){throw new Error(`ECA "${this.name}": Parameter ${i}: ${t}`)}this.parameters[i]=n}if(7===e)for(let i=0,n=t.readUint32();i<n;i++){const n=new yh;try{n.load(t,e,!0,r)}catch(t){throw new Error(`ECA "${this.name}": Child ECA ${i} ${t}`)}this.ecas[i]=n}}save(t,e){t.writeInt32(this.type),-1!==this.group&&t.writeInt32(this.group),t.writeNull(this.name),t.writeInt32(this.isEnabled);for(const i of this.parameters)i.save(t,e);if(7===e){t.writeUint32(this.ecas.length);for(const i of this.ecas)i.save(t,e)}}getByteLength(t){let e=9+qt(this.name);-1!==this.group&&(e+=4);for(const i of this.parameters)e+=i.getByteLength(t);if(7===t){e+=4;for(const i of this.ecas)e+=i.getByteLength(t)}return e}}class _h{constructor(){this.name="",this.description="",this.isComment=0,this.isEnabled=0,this.isCustom=0,this.isInitiallyOff=0,this.runOnInitialization=0,this.category=0,this.ecas=[]}load(t,e,i){this.name=t.readNull(),this.description=t.readNull(),7===e&&(this.isComment=t.readInt32()),this.isEnabled=t.readInt32(),this.isCustom=t.readInt32(),this.isInitiallyOff=t.readInt32(),this.runOnInitialization=t.readInt32(),this.category=t.readInt32();for(let r=0,n=t.readUint32();r<n;r++){const n=new yh;try{n.load(t,e,!1,i)}catch(t){throw new Error(`Trigger "${this.name}": ECA ${r}: ${t}`)}this.ecas[r]=n}}save(t,e){t.writeNull(this.name),t.writeNull(this.description),7===e&&t.writeInt32(this.isComment),t.writeInt32(this.isEnabled),t.writeInt32(this.isCustom),t.writeInt32(this.isInitiallyOff),t.writeInt32(this.runOnInitialization),t.writeInt32(this.category),t.writeUint32(this.ecas.length);for(const i of this.ecas)i.save(t,e)}getByteLength(t){let e=26+qt(this.name)+qt(this.description);7===t&&(e+=4);for(const i of this.ecas)e+=i.getByteLength(t);return e}}class Ah{constructor(){this.version=0,this.categories=[],this.u1=0,this.variables=[],this.triggers=[]}load(t,e){const i=new Ae(t);if("WTG!"!==i.readBinary(4))throw new Error("Not a WTG file");this.version=i.readInt32();for(let t=0,e=i.readUint32();t<e;t++){const e=new ph;e.load(i,this.version),this.categories[t]=e}this.u1=i.readInt32();for(let t=0,e=i.readUint32();t<e;t++){const e=new wh;e.load(i,this.version),this.variables[t]=e}for(let t=0,r=i.readUint32();t<r;t++){const r=new _h;try{r.load(i,this.version,e)}catch(e){throw new Error(`Trigger ${t}: ${e}`)}this.triggers[t]=r}}save(){const t=new Ae(new ArrayBuffer(this.getByteLength()));t.writeBinary("WTG!"),t.writeInt32(this.version),t.writeUint32(this.categories.length);for(const e of this.categories)e.save(t,this.version);t.writeInt32(this.u1),t.writeUint32(this.variables.length);for(const e of this.variables)e.save(t,this.version);t.writeUint32(this.triggers.length);for(const e of this.triggers)e.save(t,this.version);return t.uint8array}getByteLength(){let t=24;const e=this.version;for(const i of this.categories)t+=i.getByteLength(e);for(const i of this.variables)t+=i.getByteLength(e);for(const i of this.triggers)t+=i.getByteLength(e);return t}}class xh{constructor(){this.stringMap=new Map}load(t){const e=new xe(t);let i;const r=t.indexOf("STRING");if(-1===r)throw new Error("Not a valid war3map.wts buffer");for(e.index=r;i=e.readToken();)if("STRING"===i){const i=e.readInt();e.read();const r=t.indexOf("}",e.index);if(-1===r)throw this.stringMap.set(i,t.slice(e.index,t.length).trim()),new Error(`WTS: missing data in string ${this.stringMap.size} (and maybe more)`);this.stringMap.set(i,t.slice(e.index,r).trim()),e.index=r}}save(){let t="";for(const[e,i]of this.stringMap)t+=`STRING ${e}\r\n{\r\n${i}\r\n}\r\n\r\n`;return t}getString(t){return"string"!=typeof t?this.stringMap.get(t):t.startsWith("TRIGSTR_")?this.stringMap.get(parseInt(t.slice(8))):void 0}setString(t,e){"string"==typeof t?t.startsWith("TRIGSTR_")&&this.stringMap.set(parseInt(t.slice(8)),e):this.stringMap.set(t,e)}}class Th{constructor(){this.flags=0,this.playerMasks=0,this.name=""}load(t){this.flags=t.readUint32(),this.playerMasks=t.readUint32(),this.name=t.readNull()}save(t){t.writeUint32(this.flags),t.writeUint32(this.playerMasks),t.writeNull(this.name)}getByteLength(){return 9+qt(this.name)}}class Eh{constructor(){this.id=0,this.type=0,this.race=0,this.isFixedStartPosition=0,this.name="",this.startLocation=new Float32Array(2),this.allyLowPriorities=0,this.allyHighPriorities=0,this.unknown1=new Uint8Array(8)}load(t,e){this.id=t.readInt32(),this.type=t.readInt32(),this.race=t.readInt32(),this.isFixedStartPosition=t.readInt32(),this.name=t.readNull(),t.readFloat32Array(this.startLocation),this.allyLowPriorities=t.readUint32(),this.allyHighPriorities=t.readUint32(),e>30&&t.readUint8Array(this.unknown1)}save(t,e){t.writeInt32(this.id),t.writeInt32(this.type),t.writeInt32(this.race),t.writeInt32(this.isFixedStartPosition),t.writeNull(this.name),t.writeFloat32Array(this.startLocation),t.writeUint32(this.allyLowPriorities),t.writeUint32(this.allyHighPriorities),e>30&&t.writeUint8Array(this.unknown1)}getByteLength(t){return(t>30?41:33)+qt(this.name)}}class Sh{constructor(){this.chance=0,this.id="\0\0\0\0"}load(t){this.chance=t.readInt32(),this.id=t.readBinary(4)}save(t){t.writeInt32(this.chance),t.writeBinary(this.id)}}class Bh{constructor(){this.items=[]}load(t){for(let e=0,i=t.readUint32();e<i;e++){const i=new Sh;i.load(t),this.items[e]=i}}save(t){t.writeUint32(this.items.length);for(const e of this.items)e.save(t)}getByteLength(){return 4+8*this.items.length}}class Ih{constructor(){this.id=0,this.name="",this.sets=[]}load(t){this.id=t.readInt32(),this.name=t.readNull();for(let e=0,i=t.readUint32();e<i;e++){const i=new Bh;i.load(t),this.sets[e]=i}}save(t){t.writeInt32(this.id),t.writeNull(this.name),t.writeUint32(this.sets.length);for(const e of this.sets)e.save(t)}getByteLength(){let t=9+qt(this.name);for(const e of this.sets)t+=e.getByteLength();return t}}class Lh{constructor(){this.chance=0,this.ids=[]}load(t,e){this.chance=t.readInt32();for(let i=0;i<e;i++)this.ids[i]=t.readBinary(4)}save(t){t.writeInt32(this.chance);for(const e of this.ids)t.writeBinary(e)}}class Ch{constructor(){this.id=0,this.name="",this.positions=0,this.columnTypes=new Int32Array(0),this.units=[]}load(t){this.id=t.readInt32(),this.name=t.readNull(),this.positions=t.readInt32(),this.columnTypes=t.readInt32Array(this.positions);for(let e=0,i=t.readUint32();e<i;e++){const i=new Lh;i.load(t,this.positions),this.units[e]=i}}save(t){t.writeInt32(this.id),t.writeNull(this.name),t.writeInt32(this.positions),t.writeInt32Array(this.columnTypes),t.writeUint32(this.units.length);for(const e of this.units)e.save(t)}getByteLength(){return 13+qt(this.name)+this.columnTypes.byteLength+this.units.length*(4+4*this.positions)}}class Rh{constructor(){this.playerFlags=0,this.id="\0\0\0\0"}load(t){this.playerFlags=t.readUint32(),this.id=t.readBinary(4)}save(t){t.writeUint32(this.playerFlags),t.writeBinary(this.id)}}class Mh{constructor(){this.playerFlags=0,this.id="\0\0\0\0",this.levelAffected=0,this.availability=0}load(t){this.playerFlags=t.readUint32(),this.id=t.readBinary(4),this.levelAffected=t.readInt32(),this.availability=t.readInt32()}save(t){t.writeUint32(this.playerFlags),t.writeBinary(this.id),t.writeInt32(this.levelAffected),t.writeInt32(this.availability)}}class Uh{constructor(){this.version=0,this.saves=0,this.editorVersion=0,this.buildVersion=new Uint32Array(4),this.name="",this.author="",this.description="",this.recommendedPlayers="",this.cameraBounds=new Float32Array(8),this.cameraBoundsComplements=new Int32Array(4),this.playableSize=new Int32Array(2),this.flags=0,this.tileset="A",this.campaignBackground=0,this.loadingScreenModel="",this.loadingScreenText="",this.loadingScreenTitle="",this.loadingScreenSubtitle="",this.loadingScreen=0,this.prologueScreenModel="",this.prologueScreenText="",this.prologueScreenTitle="",this.prologueScreenSubtitle="",this.useTerrainFog=0,this.fogHeight=new Float32Array(2),this.fogDensity=0,this.fogColor=new Uint8Array(4),this.globalWeather=0,this.soundEnvironment="",this.lightEnvironmentTileset="\0",this.waterVertexColor=new Uint8Array(4),this.scriptMode=0,this.graphicsMode=0,this.players=[],this.forces=[],this.upgradeAvailabilityChanges=[],this.techAvailabilityChanges=[],this.randomUnitTables=[],this.randomItemTables=[],this.unknown1=0}load(t){const e=new Ae(t);this.version=e.readInt32(),this.saves=e.readInt32(),this.editorVersion=e.readInt32(),this.version>27&&e.readUint32Array(this.buildVersion),this.name=e.readNull(),this.author=e.readNull(),this.description=e.readNull(),this.recommendedPlayers=e.readNull(),e.readFloat32Array(this.cameraBounds),e.readInt32Array(this.cameraBoundsComplements),e.readInt32Array(this.playableSize),this.flags=e.readUint32(),this.tileset=e.readBinary(1),this.campaignBackground=e.readInt32(),this.version>24&&(this.loadingScreenModel=e.readNull()),this.loadingScreenText=e.readNull(),this.loadingScreenTitle=e.readNull(),this.loadingScreenSubtitle=e.readNull(),this.loadingScreen=e.readInt32(),this.version>24&&(this.prologueScreenModel=e.readNull()),this.prologueScreenText=e.readNull(),this.prologueScreenTitle=e.readNull(),this.prologueScreenSubtitle=e.readNull(),this.version>24&&(this.useTerrainFog=e.readInt32(),e.readFloat32Array(this.fogHeight),this.fogDensity=e.readFloat32(),e.readUint8Array(this.fogColor),this.globalWeather=e.readInt32(),this.soundEnvironment=e.readNull(),this.lightEnvironmentTileset=e.readBinary(1),e.readUint8Array(this.waterVertexColor)),this.version>27&&(this.scriptMode=e.readUint32()),this.version>30&&(this.graphicsMode=e.readUint32(),this.unknown1=e.readUint32());for(let t=0,i=e.readInt32();t<i;t++){const i=new Eh;i.load(e,this.version),this.players[t]=i}for(let t=0,i=e.readInt32();t<i;t++){const i=new Th;i.load(e),this.forces[t]=i}for(let t=0,i=e.readInt32();t<i;t++){const i=new Mh;i.load(e),this.upgradeAvailabilityChanges[t]=i}for(let t=0,i=e.readInt32();t<i;t++){const i=new Rh;i.load(e),this.techAvailabilityChanges[t]=i}for(let t=0,i=e.readInt32();t<i;t++){const i=new Ch;i.load(e),this.randomUnitTables[t]=i}if(this.version>24)for(let t=0,i=e.readInt32();t<i;t++){const i=new Ih;i.load(e),this.randomItemTables[t]=i}}save(){const t=new Ae(new ArrayBuffer(this.getByteLength()));t.writeInt32(this.version),t.writeInt32(this.saves),t.writeInt32(this.editorVersion),this.version>27&&t.writeUint32Array(this.buildVersion),t.writeNull(this.name),t.writeNull(this.author),t.writeNull(this.description),t.writeNull(this.recommendedPlayers),t.writeFloat32Array(this.cameraBounds),t.writeInt32Array(this.cameraBoundsComplements),t.writeInt32Array(this.playableSize),t.writeUint32(this.flags),t.writeBinary(this.tileset),t.writeInt32(this.campaignBackground),this.version>24&&t.writeNull(this.loadingScreenModel),t.writeNull(this.loadingScreenText),t.writeNull(this.loadingScreenTitle),t.writeNull(this.loadingScreenSubtitle),t.writeInt32(this.loadingScreen),this.version>24&&t.writeNull(this.prologueScreenModel),t.writeNull(this.prologueScreenText),t.writeNull(this.prologueScreenTitle),t.writeNull(this.prologueScreenSubtitle),this.version>24&&(t.writeInt32(this.useTerrainFog),t.writeFloat32Array(this.fogHeight),t.writeFloat32(this.fogDensity),t.writeUint8Array(this.fogColor),t.writeInt32(this.globalWeather),t.writeNull(this.soundEnvironment),t.writeBinary(this.lightEnvironmentTileset),t.writeUint8Array(this.waterVertexColor)),this.version>27&&t.writeUint32(this.scriptMode),this.version>30&&(t.writeUint32(this.graphicsMode),t.writeUint32(this.unknown1)),t.writeUint32(this.players.length);for(const e of this.players)e.save(t,this.version);t.writeUint32(this.forces.length);for(const e of this.forces)e.save(t);t.writeUint32(this.upgradeAvailabilityChanges.length);for(const e of this.upgradeAvailabilityChanges)e.save(t);t.writeUint32(this.techAvailabilityChanges.length);for(const e of this.techAvailabilityChanges)e.save(t);t.writeUint32(this.randomUnitTables.length);for(const e of this.randomUnitTables)e.save(t);if(this.version>24){t.writeUint32(this.randomItemTables.length);for(const e of this.randomItemTables)e.save(t)}return t.uint8array}getByteLength(){let t=111+qt(this.name)+qt(this.author)+qt(this.description)+qt(this.recommendedPlayers)+qt(this.loadingScreenText)+qt(this.loadingScreenTitle)+qt(this.loadingScreenSubtitle)+qt(this.prologueScreenText)+qt(this.prologueScreenTitle)+qt(this.prologueScreenSubtitle);for(const e of this.players)t+=e.getByteLength(this.version);for(const e of this.forces)t+=e.getByteLength();t+=16*this.upgradeAvailabilityChanges.length,t+=8*this.techAvailabilityChanges.length;for(const e of this.randomUnitTables)t+=e.getByteLength();if(this.version>24){t+=36+qt(this.loadingScreenModel)+qt(this.prologueScreenModel)+qt(this.soundEnvironment);for(const e of this.randomItemTables)t+=e.getByteLength()}return this.version>27&&(t+=20),this.version>30&&(t+=8),t}getBuildVersion(){return 100*this.buildVersion[0]+this.buildVersion[1]}}class kh{constructor(){this.u1=0,this.name="",this.flags=0,this.maxPlayers=0,this.archive=new ah,this.imports=new lh,this.readonly=!1}load(t,e=!1){const i=new Ae(t);"HM3W"===i.readBinary(4)&&(this.u1=i.readUint32(),this.name=i.readNull(),this.flags=i.readUint32(),this.maxPlayers=i.readUint32()),this.readonly=e,this.archive.load(t,e),this.readImports()}save(){if(this.readonly)return null;this.setImportsFile();const t=this.archive.save();if(!t)return null;const e=this.getMapInformation();if(!e||e.getBuildVersion()<131){const e=new Uint8Array(512+t.byteLength),i=new Ae(e);return i.writeBinary("HM3W"),i.writeUint32(this.u1),i.writeNull(this.name),i.writeUint32(this.flags),i.writeUint32(this.maxPlayers),e.set(t,512),e}return t}getFileNames(){return this.archive.getFileNames()}getImportNames(){const t=[];for(const e of this.imports.entries.values()){const i=e.isCustom;10===i||13===i?t.push(e.path):t.push(`war3mapImported\\${e.path}`)}return t}setImportsFile(){return!this.readonly&&(this.imports.entries.size>0&&this.set("war3map.imp",this.imports.save()))}import(t,e){return!this.readonly&&(!!this.archive.set(t,e)&&(this.imports.set(t),!0))}set(t,e){return!this.readonly&&this.archive.set(t,e)}get(t){return this.archive.get(t)}getScriptFile(){return this.get("war3map.j")||this.get("scripts\\war3map.j")||this.get("war3map.lua")||this.get("scripts\\war3map.lua")}has(t){return this.archive.has(t)}delete(t){return!this.readonly&&(this.imports.delete(t),this.archive.delete(t))}rename(t,e){return!this.readonly&&(!!this.archive.rename(t,e)&&(this.imports.rename(t,e),!0))}getMapInformation(){const t=this.archive.get("war3map.w3i");if(!t)throw new Error("File does not exist");const e=new Uh;return e.load(t.bytes()),e}readImports(){const t=this.archive.get("war3map.imp");if(t){const e=t.arrayBuffer();e&&this.imports.load(e)}}readTriggers(t){const e=this.archive.get("war3map.wtg");if(e){const i=e.arrayBuffer();if(i){const e=new Ah;return e.load(i,t),e}}}readCustomTextTriggers(){const t=this.archive.get("war3map.wct");if(t){const e=t.arrayBuffer();if(e){const t=new gh;return t.load(e),t}}}readStringTable(){const t=this.archive.get("war3map.wts");if(t){const e=t.text();if(e){const t=new xh;return t.load(e),t}}}readModifications(){const t={},e=["w3u","w3t","w3b","w3d","w3a","w3h","w3q"],i=[!1,!1,!1,!0,!0,!1,!0];for(let r=0,n=e.length;r<n;r++){const n=this.archive.get(`war3map.${e[r]}`);if(n){const s=n.arrayBuffer();if(s){let n;n=i[r]?new uh:new fh,n.load(s),t[e[r]]=n}}}return t}}class Fh{constructor(){this.groundHeight=0,this.waterHeight=0,this.mapEdge=0,this.ramp=0,this.blight=0,this.water=0,this.boundary=0,this.groundTexture=0,this.cliffVariation=0,this.groundVariation=0,this.cliffTexture=0,this.layerHeight=0}load(t){this.groundHeight=(t.readInt16()-8192)/512;const e=t.readInt16();this.waterHeight=((16383&e)-8192)/512,this.mapEdge=16384&e;const i=t.readUint8();this.ramp=16&i,this.blight=32&i,this.water=64&i,this.boundary=128&i,this.groundTexture=15&i;const r=t.readUint8();this.cliffVariation=(224&r)>>>5,this.groundVariation=31&r;const n=t.readUint8();this.cliffTexture=(240&n)>>>4,this.layerHeight=15&n}save(t){t.writeInt16(512*this.groundHeight+8192),t.writeInt16(512*this.waterHeight+8192+this.mapEdge<<14),t.writeUint8(this.ramp<<4|this.blight<<5|this.water<<6|this.boundary<<7|this.groundTexture),t.writeUint8(this.cliffVariation<<5|this.groundVariation),t.writeUint8((this.cliffTexture<<4)+this.layerHeight)}}class Dh{constructor(){this.version=0,this.tileset="A",this.haveCustomTileset=0,this.groundTilesets=[],this.cliffTilesets=[],this.mapSize=new Int32Array(2),this.centerOffset=new Float32Array(2),this.corners=[]}load(t){const e=new Ae(t);if("W3E!"===e.readBinary(4)){this.version=e.readInt32(),this.tileset=e.readBinary(1),this.haveCustomTileset=e.readInt32();for(let t=0,i=e.readInt32();t<i;t++)this.groundTilesets[t]=e.readBinary(4);for(let t=0,i=e.readInt32();t<i;t++)this.cliffTilesets[t]=e.readBinary(4);e.readInt32Array(this.mapSize),e.readFloat32Array(this.centerOffset);for(let t=0,i=this.mapSize[1];t<i;t++){this.corners[t]=[];for(let i=0,r=this.mapSize[0];i<r;i++){const r=new Fh;r.load(e),this.corners[t][i]=r}}}}save(){const t=new Ae(new ArrayBuffer(this.getByteLength()));t.writeBinary("W3E!"),t.writeInt32(this.version),t.writeBinary(this.tileset),t.writeInt32(this.haveCustomTileset),t.writeUint32(this.groundTilesets.length);for(const e of this.groundTilesets)t.writeBinary(e);t.writeUint32(this.cliffTilesets.length);for(const e of this.cliffTilesets)t.writeBinary(e);t.writeInt32Array(this.mapSize),t.writeFloat32Array(this.centerOffset);for(const e of this.corners)for(const i of e)i.save(t);return t.uint8array}getByteLength(){return 37+4*this.groundTilesets.length+4*this.cliffTilesets.length+this.mapSize[0]*this.mapSize[1]*7}}const Ph={AAAB:1,AAAC:1,AABA:1,AABB:2,AABC:0,AACA:1,AACB:0,AACC:1,ABAA:1,ABAB:1,ABAC:0,ABBA:2,ABBB:1,ABBC:0,ABCA:0,ABCB:0,ABCC:0,ACAA:1,ACAB:0,ACAC:1,ACBA:0,ACBB:0,ACBC:0,ACCA:1,ACCB:0,ACCC:1,BAAA:1,BAAB:1,BAAC:0,BABA:1,BABB:1,BABC:0,BACA:0,BACB:0,BACC:0,BBAA:1,BBAB:1,BBAC:0,BBBA:1,BBCA:0,BCAA:0,BCAB:0,BCAC:0,BCBA:0,BCCA:0,CAAA:1,CAAB:0,CAAC:1,CABA:0,CABB:0,CABC:0,CACA:1,CACB:0,CACC:1,CBAA:0,CBAB:0,CBAC:0,CBBA:0,CBCA:0,CCAA:1,CCAB:0,CCAC:1,CCBA:0,CCCA:1},Nh={AAAB:2,AAAC:1,AABA:1,AABB:3,AABC:0,AACA:1,AACB:0,AACC:3,ABAA:1,ABAB:2,ABAC:0,ABBA:3,ABBB:0,ABBC:0,ABCA:0,ABCB:0,ABCC:0,ACAA:1,ACAB:0,ACAC:2,ACBA:0,ACBB:0,ACBC:0,ACCA:3,ACCB:0,ACCC:1,BAAA:1,BAAB:3,BAAC:0,BABA:2,BABB:0,BABC:0,BACA:0,BACB:0,BACC:0,BBAA:3,BBAB:1,BBAC:0,BBBA:1,BBCA:0,BCAA:0,BCAB:0,BCAC:0,BCBA:0,BCCA:0,CAAA:1,CAAB:0,CAAC:3,CABA:0,CABB:0,CABC:0,CACA:2,CACB:0,CACC:1,CBAA:0,CBAB:0,CBAC:0,CBBA:0,CBCA:0,CCAA:3,CCAB:0,CCAC:1,CCBA:0,CCCA:1};function Oh(t,e,i){return"Cliffs"===t?Math.min(i,Ph[e]):Math.min(i,Nh[e])}class Vh{constructor(t,e,i,r,n){const s=t.viewer.gl,a=t.viewer.webgl,o=a.extensions.ANGLE_instanced_arrays,l=a.extensions.OES_vertex_array_object,h=new ii;h.load(e);const c=h.geosets[0],d=c.vertices,u=c.normals,f=c.uvSets[0],m=c.faces,g=d.byteLength,p=g+u.byteLength;let w=null;const v=n.attribs;l&&(w=l.createVertexArrayOES(),l.bindVertexArrayOES(w));const b=s.createBuffer();s.bindBuffer(s.ARRAY_BUFFER,b),s.bufferData(s.ARRAY_BUFFER,p+f.byteLength,s.STATIC_DRAW),s.bufferSubData(s.ARRAY_BUFFER,0,d),s.bufferSubData(s.ARRAY_BUFFER,g,u),s.bufferSubData(s.ARRAY_BUFFER,p,f),l&&(s.vertexAttribPointer(v.a_position,3,s.FLOAT,!1,0,0),s.enableVertexAttribArray(v.a_position),s.vertexAttribPointer(v.a_normal,3,s.FLOAT,!1,0,g),s.enableVertexAttribArray(v.a_normal),s.vertexAttribPointer(v.a_uv,2,s.FLOAT,!1,0,p),s.enableVertexAttribArray(v.a_uv));const y=4*i.length,_=s.createBuffer();s.bindBuffer(s.ARRAY_BUFFER,_),s.bufferData(s.ARRAY_BUFFER,y+r.length,s.STATIC_DRAW),s.bufferSubData(s.ARRAY_BUFFER,0,new Float32Array(i)),s.bufferSubData(s.ARRAY_BUFFER,y,new Uint8Array(r)),l&&(s.vertexAttribPointer(v.a_instancePosition,3,s.FLOAT,!1,0,0),s.enableVertexAttribArray(v.a_instancePosition),o.vertexAttribDivisorANGLE(v.a_instancePosition,1),s.vertexAttribPointer(v.a_instanceTexture,1,s.UNSIGNED_BYTE,!1,0,y),s.enableVertexAttribArray(v.a_instanceTexture),o.vertexAttribDivisorANGLE(v.a_instanceTexture,1));const A=s.createBuffer();s.bindBuffer(s.ELEMENT_ARRAY_BUFFER,A),s.bufferData(s.ELEMENT_ARRAY_BUFFER,m,s.STATIC_DRAW),l&&l.bindVertexArrayOES(null),this.map=t,this.vertexBuffer=b,this.faceBuffer=A,this.normalsOffset=g,this.uvsOffset=p,this.elements=m.length,this.locationAndTextureBuffer=_,this.texturesOffset=y,this.instances=i.length/3,this.vao=w}render(t){const e=this.map.viewer,i=e.gl,r=e.webgl,n=r.extensions.ANGLE_instanced_arrays,s=r.extensions.OES_vertex_array_object,a=t.attribs;s?s.bindVertexArrayOES(this.vao):(i.bindBuffer(i.ARRAY_BUFFER,this.locationAndTextureBuffer),i.vertexAttribPointer(a.a_instancePosition,3,i.FLOAT,!1,0,0),i.vertexAttribPointer(a.a_instanceTexture,1,i.UNSIGNED_BYTE,!1,0,this.texturesOffset),i.bindBuffer(i.ARRAY_BUFFER,this.vertexBuffer),i.vertexAttribPointer(a.a_position,3,i.FLOAT,!1,0,0),i.vertexAttribPointer(a.a_normal,3,i.FLOAT,!1,0,this.normalsOffset),i.vertexAttribPointer(a.a_uv,2,i.FLOAT,!1,0,this.uvsOffset),i.bindBuffer(i.ELEMENT_ARRAY_BUFFER,this.faceBuffer)),n.drawElementsInstancedANGLE(i.TRIANGLES,this.elements,i.UNSIGNED_SHORT,0,this.instances),s&&s.bindVertexArrayOES(null)}}function Gh(t,e){return t.sequence.rarity-e.sequence.rarity}function zh(t){const e=function(t,e){const i=function(t,e){const i=[];for(let r=0,n=e.length;r<n;r++){const n=e[r];n.name.split("-")[0].replace(/\d/g,"").trim().toLowerCase()===t&&i.push({sequence:n,index:r})}return i}(t,e);let r,n;for(i.sort(Gh),r=0,n=i.length;r<n;r++){const t=i[r].sequence.rarity;if(0===t)break;if(10*Math.random()>t)return i[r]}const s=i.length-r;return i[r+Math.floor(Math.random()*s)]}("stand",t.model.sequences);e&&t.setSequence(e.index)}var jh;!function(t){t[t.IDLE=0]="IDLE",t[t.WALK=1]="WALK"}(jh||(jh={}));class Kh{constructor(t,e){this.state=jh.IDLE,this.instance=e.addInstance(),this.instance.setScene(t.worldScene)}update(){(this.instance.sequenceEnded||-1===this.instance.sequence)&&this.state===jh.IDLE&&zh(this.instance)}}const Hh=g();class $h extends Kh{constructor(t,e,i,r){super(t,e);const n=this.instance;n.move(r.location),n.rotateLocal(F(U(),st,r.angle)),n.scale(r.scale),n.setTeamColor(r.player),n.setScene(t.worldScene),i&&(Hh[2]=i.moveHeight,n.move(Hh),n.setVertexColor([i.red/255,i.green/255,i.blue/255,1]),n.uniformScale(i.modelScale)),this.instance=n,this.row=i}}class Xh extends Kh{constructor(t,e,i,r){super(t,e);const n=this.instance;n.move(r.location),n.rotateLocal(F(U(),st,r.angle)),n.scale(r.scale),n.setScene(t.worldScene),this.instance=n,this.row=i}}const qh=g();class Yh{constructor(t,e,i,r){const n=t.centerOffset,s=e.addInstance();qh[0]=128*r.location[0]+n[0]+128,qh[1]=128*r.location[1]+n[1]+128,s.move(qh),s.rotateLocal(F(U(),st,Ct(i.fixedRot))),s.setScene(t.worldScene),this.instance=s,this.row=i}}class Wh{constructor(){this.id="\0\0\0\0",this.chance=0}load(t){this.id=t.readBinary(4),this.chance=t.readInt32()}save(t){t.writeBinary(this.id),t.writeInt32(this.chance)}}class Zh{constructor(){this.items=[]}load(t){for(let e=0,i=t.readUint32();e<i;e++){const e=new Wh;e.load(t),this.items.push(e)}}save(t){t.writeUint32(this.items.length);for(const e of this.items)e.save(t)}getByteLength(){return 4+8*this.items.length}}class Qh{constructor(){this.id="\0\0\0\0",this.variation=0,this.location=new Float32Array(3),this.angle=0,this.scale=new Float32Array([1,1,1]),this.skin="\0\0\0\0",this.flags=0,this.life=0,this.itemTable=-1,this.itemSets=[],this.editorId=0,this.u1=new Uint8Array(8)}load(t,e,i){if(this.id=t.readBinary(4),this.variation=t.readInt32(),t.readFloat32Array(this.location),this.angle=t.readFloat32(),t.readFloat32Array(this.scale),i>131&&(this.skin=t.readBinary(4)),this.flags=t.readUint8(),this.life=t.readUint8(),e>7){this.itemTable=t.readUint32();for(let e=0,i=t.readUint32();e<i;e++){const e=new Zh;e.load(t),this.itemSets.push(e)}}this.editorId=t.readInt32()}save(t,e,i){if(t.writeBinary(this.id),t.writeInt32(this.variation),t.writeFloat32Array(this.location),t.writeFloat32(this.angle),t.writeFloat32Array(this.scale),i>131&&t.writeBinary(this.skin),t.writeUint8(this.flags),t.writeUint8(this.life),e>7){t.writeUint32(this.itemTable),t.writeUint32(this.itemSets.length);for(const e of this.itemSets)e.save(t)}t.writeInt32(this.editorId)}getByteLength(t,e){let i=42;if(e>131&&(i+=4),t>7){i+=8;for(const t of this.itemSets)i+=t.getByteLength()}return i}}class Jh{constructor(){this.id="\0\0\0\0",this.u1=0,this.location=new Uint32Array(2)}load(t,e){this.id=t.readBinary(4),this.u1=t.readUint32(),t.readUint32Array(this.location)}save(t,e){t.writeBinary(this.id),t.writeUint32(this.u1),t.writeUint32Array(this.location)}}class tc{constructor(){this.version=0,this.u1=new Uint8Array(4),this.doodads=[],this.u2=new Uint8Array(4),this.terrainDoodads=[]}load(t,e){const i=new Ae(t);if("W3do"!==i.readBinary(4))throw new Error("Not a valid war3map.doo buffer");this.version=i.readInt32(),i.readUint8Array(this.u1);for(let t=0,r=i.readInt32();t<r;t++){const t=new Qh;t.load(i,this.version,e),this.doodads.push(t)}i.readUint8Array(this.u2);for(let t=0,e=i.readInt32();t<e;t++){const t=new Jh;t.load(i,this.version),this.terrainDoodads.push(t)}}save(t){const e=new Ae(new ArrayBuffer(this.getByteLength(t)));e.writeBinary("W3do"),e.writeInt32(this.version),e.writeUint8Array(this.u1),e.writeUint32(this.doodads.length);for(const i of this.doodads)i.save(e,this.version,t);e.writeUint8Array(this.u2),e.writeUint32(this.terrainDoodads.length);for(const t of this.terrainDoodads)t.save(e,this.version);return e.uint8array}getByteLength(t){let e=24+16*this.terrainDoodads.length;for(const i of this.doodads)e+=i.getByteLength(this.version,t);return e}}class ec{constructor(){this.id="\0\0\0\0",this.chance=0}load(t){this.id=t.readBinary(4),this.chance=t.readInt32()}save(t){t.writeBinary(this.id),t.writeInt32(this.chance)}}class ic{constructor(){this.items=[]}load(t){for(let e=0,i=t.readInt32();e<i;e++){const i=new ec;i.load(t),this.items[e]=i}}save(t){t.writeInt32(this.items.length);for(const e of this.items)e.save(t)}getByteLength(){return 4+8*this.items.length}}class rc{constructor(){this.slot=0,this.id="\0\0\0\0"}load(t){this.slot=t.readInt32(),this.id=t.readBinary(4)}save(t){t.writeInt32(this.slot),t.writeBinary(this.id)}}class nc{constructor(){this.id="\0\0\0\0",this.activeForAutocast=0,this.heroLevel=1}load(t){this.id=t.readBinary(4),this.activeForAutocast=t.readInt32(),this.heroLevel=t.readInt32()}save(t){t.writeBinary(this.id),t.writeInt32(this.activeForAutocast),t.writeInt32(this.heroLevel)}}class sc{constructor(){this.id="\0\0\0\0",this.chance=0}load(t){this.id=t.readBinary(4),this.chance=t.readInt32()}save(t){t.writeBinary(this.id),t.writeInt32(this.chance)}}class ac{constructor(){this.id="\0\0\0\0",this.variation=0,this.location=new Float32Array(3),this.angle=0,this.scale=new Float32Array([1,1,1]),this.skin="\0\0\0\0",this.flags=0,this.player=0,this.unknown=0,this.hitpoints=-1,this.mana=-1,this.droppedItemTable=0,this.droppedItemSets=[],this.goldAmount=0,this.targetAcquisition=0,this.heroLevel=0,this.heroStrength=0,this.heroAgility=0,this.heroIntelligence=0,this.itemsInInventory=[],this.modifiedAbilities=[],this.randomFlag=0,this.level=new Uint8Array(3),this.itemClass=0,this.unitGroup=0,this.positionInGroup=0,this.randomUnitTables=[],this.customTeamColor=0,this.waygate=0,this.creationNumber=0}load(t,e,i,r){this.id=t.readBinary(4),this.variation=t.readInt32(),t.readFloat32Array(this.location),this.angle=t.readFloat32(),t.readFloat32Array(this.scale),r>131&&(this.skin=t.readBinary(4)),this.flags=t.readUint8(),this.player=t.readInt32(),this.unknown=t.readUint16(),this.hitpoints=t.readInt32(),this.mana=t.readInt32(),i>10&&(this.droppedItemTable=t.readInt32());for(let e=0,i=t.readInt32();e<i;e++){const i=new ic;i.load(t),this.droppedItemSets[e]=i}this.goldAmount=t.readInt32(),this.targetAcquisition=t.readFloat32(),this.heroLevel=t.readInt32(),i>10&&(this.heroStrength=t.readInt32(),this.heroAgility=t.readInt32(),this.heroIntelligence=t.readInt32());for(let e=0,i=t.readInt32();e<i;e++){const i=new rc;i.load(t),this.itemsInInventory[e]=i}for(let e=0,i=t.readInt32();e<i;e++){const i=new nc;i.load(t),this.modifiedAbilities[e]=i}if(this.randomFlag=t.readInt32(),0===this.randomFlag)t.readUint8Array(this.level),this.itemClass=t.readUint8();else if(1===this.randomFlag)this.unitGroup=t.readUint32(),this.positionInGroup=t.readUint32();else if(2===this.randomFlag)for(let e=0,i=t.readInt32();e<i;e++){const i=new sc;i.load(t),this.randomUnitTables[e]=i}this.customTeamColor=t.readInt32(),this.waygate=t.readInt32(),this.creationNumber=t.readInt32()}save(t,e,i,r){t.writeBinary(this.id),t.writeInt32(this.variation),t.writeFloat32Array(this.location),t.writeFloat32(this.angle),t.writeFloat32Array(this.scale),r>131&&t.writeBinary(this.skin),t.writeUint8(this.flags),t.writeInt32(this.player),t.writeUint16(this.unknown),t.writeInt32(this.hitpoints),t.writeInt32(this.mana),i>10&&t.writeInt32(this.droppedItemTable),t.writeInt32(this.droppedItemSets.length);for(const e of this.droppedItemSets)e.save(t);t.writeInt32(this.goldAmount),t.writeFloat32(this.targetAcquisition),t.writeInt32(this.heroLevel),i>10&&(t.writeInt32(this.heroStrength),t.writeInt32(this.heroAgility),t.writeInt32(this.heroIntelligence)),t.writeInt32(this.itemsInInventory.length);for(const e of this.itemsInInventory)e.save(t);t.writeInt32(this.modifiedAbilities.length);for(const e of this.modifiedAbilities)e.save(t);if(t.writeInt32(this.randomFlag),0===this.randomFlag)t.writeUint8Array(this.level),t.writeUint8(this.itemClass);else if(1===this.randomFlag)t.writeUint32(this.unitGroup),t.writeUint32(this.positionInGroup);else if(2===this.randomFlag){t.writeInt32(this.randomUnitTables.length);for(const e of this.randomUnitTables)e.save(t)}t.writeInt32(this.customTeamColor),t.writeInt32(this.waygate),t.writeInt32(this.creationNumber)}getByteLength(t,e,i){let r=91;i>131&&(r+=4),e>10&&(r+=16);for(const t of this.droppedItemSets)r+=t.getByteLength();return r+=8*this.itemsInInventory.length,r+=12*this.modifiedAbilities.length,0===this.randomFlag?r+=4:1===this.randomFlag?r+=8:2===this.randomFlag&&(r+=4+8*this.randomUnitTables.length),r}}class oc{constructor(){this.version=8,this.subversion=11,this.units=[]}load(t,e){const i=new Ae(t);if("W3do"!==i.readBinary(4))throw new Error("Not a valid war3mapUnits.doo buffer");this.version=i.readInt32(),this.subversion=i.readUint32();for(let t=0,r=i.readInt32();t<r;t++){const r=new ac;r.load(i,this.version,this.subversion,e),this.units[t]=r}}save(t){const e=new Ae(new ArrayBuffer(this.getByteLength(t)));e.writeBinary("W3do"),e.writeInt32(this.version),e.writeUint32(this.subversion),e.writeInt32(this.units.length);for(const i of this.units)i.save(e,this.version,this.subversion,t);return e.uint8array}getByteLength(t){let e=16;for(const i of this.units)e+=i.getByteLength(this.version,this.subversion,t);return e}}const lc=g(),hc=g();class cc{constructor(t,e){this.buildVersion=0,this.solverParams={tileset:"a"},this.waterIndex=0,this.waterIncreasePerFrame=0,this.waterHeightOffset=0,this.waterTextures=[],this.maxDeepColor=new Float32Array(4),this.minDeepColor=new Float32Array(4),this.maxShallowColor=new Float32Array(4),this.minShallowColor=new Float32Array(4),this.anyReady=!1,this.terrainReady=!1,this.cliffsReady=!1,this.doodads=[],this.terrainDoodads=[],this.doodadsReady=!1,this.units=[],this.unitsReady=!1,this.tilesetTextures=[],this.cliffTextures=[],this.cliffModels=[],this.corners=[],this.centerOffset=new Float32Array(2),this.mapSize=new Int32Array(2),this.tilesets=[],this.blightTextureIndex=-1,this.cliffTilesets=[],this.columns=0,this.rows=0,this.vertexBuffer=null,this.faceBuffer=null,this.instanceBuffer=null,this.textureBuffer=null,this.variationBuffer=null,this.waterBuffer=null,this.heightMap=null,this.waterHeightMap=null,this.cliffHeightMap=null,this.viewer=t,this.worldScene=t.addScene(),this.map=new kh,this.map.load(e,!0),this.loadMapInformation(),this.pathSolver=(e,i)=>{if("string"==typeof e){const r=e.replace(/\//g,"\\"),n=this.map.get(r);return n?n.arrayBuffer():t.wc3PathSolver(e,i)}return e},this.loadTerrainCliffsAndWater();const i=this.map.readModifications();this.applyModificationFile(t.doodadsData,t.doodadMetaData,i.w3d),this.applyModificationFile(t.doodadsData,t.destructableMetaData,i.w3b),this.applyModificationFile(t.unitsData,t.unitMetaData,i.w3u),this.applyModificationFile(t.unitsData,t.unitMetaData,i.w3t),this.loadDoodadsAndDestructibles(),this.loadUnitsAndItems()}die(){this.worldScene.detach()}load(t){return this.viewer.load(t,this.pathSolver,this.solverParams)}loadMapInformation(){const t=this.map.get("war3map.w3i");if(!t)return void console.warn("Attempted to load war3map.w3i but it is not there. Using default tileset A.");const e=new Uh;try{e.load(t.bytes())}catch(t){console.warn("Failed to correctly parse the map information file")}this.solverParams.tileset=e.tileset.toLowerCase(),this.buildVersion=e.getBuildVersion(),this.buildVersion>131&&(this.solverParams.reforged=!0)}async loadTerrainCliffsAndWater(){const t=this.map.get("war3map.w3e");if(!t)return void console.warn("Attempted to load war3map.w3e, but it is not there.");const e=new Dh;try{e.load(t.bytes())}catch(t){return void console.warn(`Failed to load war3map.w3e: ${t}`)}const i=this.viewer,r=e.centerOffset,n=e.mapSize;this.corners=e.corners,this.centerOffset.set(r),this.mapSize.set(n),this.worldScene.grid=new Et(r[0],r[1],128*n[0]-128,128*n[1]-128,2048,2048);const s=this.solverParams.reforged?".dds":".blp",a=e.tileset,o=[],l=[],h=[];for(const t of e.groundTilesets){const e=i.terrainData.getRow(t);this.tilesets.push(e),o.push(this.load(`${e.dir}\\${e.file}${s}`))}this.blightTextureIndex=this.tilesetTextures.length,o.push(this.load(`TerrainArt\\Blight\\${{A:"Ashen",B:"Barrens",C:"Felwood",D:"Cave",F:"Lordf",G:"Dungeon",I:"Ice",J:"DRuins",K:"Citadel",L:"Lords",N:"North",O:"Outland",Q:"VillageFall",V:"Village",W:"Lordw",X:"Village",Y:"Village",Z:"Ruins"}[a]}_Blight${s}`));for(const t of e.cliffTilesets){const e=i.cliffTypesData.getRow(t);this.cliffTilesets.push(e),l.push(this.load(`${e.texDir}\\${e.texFile}${s}`))}const c=i.waterData.getRow(`${a}Sha`);this.waterHeightOffset=c.height,this.waterIncreasePerFrame=c.texRate/60,this.waterTextures.length=0,this.maxDeepColor.set([c.Dmax_R,c.Dmax_G,c.Dmax_B,c.Dmax_A]),this.minDeepColor.set([c.Dmin_R,c.Dmin_G,c.Dmin_B,c.Dmin_A]),this.maxShallowColor.set([c.Smax_R,c.Smax_G,c.Smax_B,c.Smax_A]),this.minShallowColor.set([c.Smin_R,c.Smin_G,c.Smin_B,c.Smin_A]);for(let t=0,e=c.numTex;t<e;t++)h.push(this.load(`${c.texFile}${t<10?"0":""}${t}${s}`));this.tilesetTextures=await Promise.all(o),this.cliffTextures=await Promise.all(l),this.waterTextures=await Promise.all(h);const d=e.corners,[u,f]=this.mapSize,m=(u-1)*(f-1),g=new Float32Array(u*f),p=new Float32Array(u*f),w=new Float32Array(u*f),v=new Uint8Array(4*m),b=new Uint8Array(4*m),y=new Uint8Array(m);let _=0;const A={};this.columns=u-1,this.rows=f-1;for(let t=0;t<f;t++)for(let e=0;e<u;e++){const i=d[t][e],n=t*u+e;if(g[n]=i.groundHeight,p[n]=i.groundHeight+i.layerHeight-2,w[n]=i.waterHeight,t<f-1&&e<u-1){if(y[_]=this.isWater(e,t),this.isCliff(e,t)){const n=i.layerHeight,s=d[t][e+1].layerHeight,a=d[t+1][e].layerHeight,o=d[t+1][e+1].layerHeight,l=Math.min(n,s,a,o),h=this.cliffFileName(n,s,a,o,l);if("AAAA"!==h){let n=i.cliffTexture;15===n&&(n=1);const s=this.cliffTilesets[n].cliffModelDir,a=`Doodads\\Terrain\\${s}\\${s}${h}${Oh(s,h,i.cliffVariation)}.mdx`;A[a]||(A[a]={locations:[],textures:[]}),A[a].locations.push(128*(e+1)+r[0],128*t+r[1],128*(l-2)),A[a].textures.push(n)}}else{const r=this.cornerTexture(e,t),n=this.cornerTexture(e+1,t),s=this.cornerTexture(e,t+1),a=this.cornerTexture(e+1,t+1),o=os([r,n,s,a]).sort();let l=o[0];v[4*_]=l+1,b[4*_]=this.getVariation(l,i.groundVariation),o.shift();for(let t=0,e=o.length;t<e;t++){let e=0;l=o[t],n===l&&(e|=1),r===l&&(e|=2),a===l&&(e|=4),s===l&&(e|=8),v[4*_+1+t]=l+1,b[4*_+1+t]=e}}_+=1}}const x=this.viewer.gl,T=this.viewer.webgl;this.vertexBuffer=x.createBuffer(),x.bindBuffer(x.ARRAY_BUFFER,this.vertexBuffer),x.bufferData(x.ARRAY_BUFFER,new Float32Array([0,0,1,0,0,1,1,1]),x.STATIC_DRAW),this.faceBuffer=x.createBuffer(),x.bindBuffer(x.ELEMENT_ARRAY_BUFFER,this.faceBuffer),x.bufferData(x.ELEMENT_ARRAY_BUFFER,new Uint8Array([0,1,2,1,3,2]),x.STATIC_DRAW),this.cliffHeightMap=x.createTexture(),x.bindTexture(x.TEXTURE_2D,this.cliffHeightMap),T.setTextureMode(x.CLAMP_TO_EDGE,x.CLAMP_TO_EDGE,x.NEAREST,x.NEAREST),x.texImage2D(x.TEXTURE_2D,0,x.ALPHA,u,f,0,x.ALPHA,x.FLOAT,g),this.heightMap=x.createTexture(),x.bindTexture(x.TEXTURE_2D,this.heightMap),T.setTextureMode(x.CLAMP_TO_EDGE,x.CLAMP_TO_EDGE,x.NEAREST,x.NEAREST),x.texImage2D(x.TEXTURE_2D,0,x.ALPHA,u,f,0,x.ALPHA,x.FLOAT,p),this.waterHeightMap=x.createTexture(),x.bindTexture(x.TEXTURE_2D,this.waterHeightMap),T.setTextureMode(x.CLAMP_TO_EDGE,x.CLAMP_TO_EDGE,x.NEAREST,x.NEAREST),x.texImage2D(x.TEXTURE_2D,0,x.ALPHA,u,f,0,x.ALPHA,x.FLOAT,w),this.instanceBuffer=x.createBuffer(),x.bindBuffer(x.ARRAY_BUFFER,this.instanceBuffer),x.bufferData(x.ARRAY_BUFFER,new Float32Array(m).map(((t,e)=>e)),x.STATIC_DRAW),this.textureBuffer=x.createBuffer(),x.bindBuffer(x.ARRAY_BUFFER,this.textureBuffer),x.bufferData(x.ARRAY_BUFFER,v,x.STATIC_DRAW),this.variationBuffer=x.createBuffer(),x.bindBuffer(x.ARRAY_BUFFER,this.variationBuffer),x.bufferData(x.ARRAY_BUFFER,b,x.STATIC_DRAW),this.waterBuffer=x.createBuffer(),x.bindBuffer(x.ARRAY_BUFFER,this.waterBuffer),x.bufferData(x.ARRAY_BUFFER,y,x.STATIC_DRAW),this.terrainReady=!0,this.anyReady=!0;const E=i.cliffShader,S=Object.entries(A).map((async t=>{const e=t[0],{locations:r,textures:n}=t[1],s=await i.loadBaseFile(e,"arrayBuffer");if(s)return new Vh(this,s.data,r,n,E)})).filter((t=>t));this.cliffModels=await Promise.all(S),this.cliffsReady=!0}loadDoodadsAndDestructibles(){const t=this.map.get("war3map.doo");if(!t)return void console.warn("Attempted to load war3map.doo but it is not there");const e=new tc;try{e.load(t.bytes(),this.buildVersion)}catch(t){return void console.warn(`Failed to load war3map.doo: ${t}`)}for(const t of e.doodads)try{const e=this.viewer.doodadsData.getRow(t.id);let i=e.file;if(i){const r=e.numVar;i.endsWith(".mdl")&&(i=i.slice(0,-4));let n=i;i+=".mdx",r>1&&(n+=Math.min(t.variation,r-1)),n+=".mdx";const s=this.map.get(n)||this.map.get(i);let a;a=s?this.load(s.name):this.load(n),a.then((i=>{i&&this.doodads.push(new Xh(this,i,e,t))}))}else console.log("Unknown doodad ID",t.id,t)}catch(e){console.warn(`Failed to load doodad/destructible ID ${t.id}: ${e}`)}for(const t of e.terrainDoodads)try{const e=this.viewer.doodadsData.getRow(t.id);this.load(`${e.file}.mdx`).then((i=>{i&&this.terrainDoodads.push(new Yh(this,i,e,t))}))}catch(e){console.warn(`Failed to load cliff/terrain doodad ID ${t.id}: ${e}`)}this.doodadsReady=!0,this.anyReady=!0}loadUnitsAndItems(){const t=this.map.get("war3mapUnits.doo");if(!t)return void console.warn("Attempted to load war3mapUnits.doo but it is not there");const e=new oc;try{e.load(t.bytes(),this.buildVersion)}catch(t){return void console.warn(`Failed to load war3mapUnits.doo: ${t}`)}for(const t of e.units)try{let e,i;"sloc"===t.id?i="Objects\\StartLocation\\StartLocation.mdx":(e=this.viewer.unitsData.getRow(t.id),i=e.file,i&&(i.endsWith(".mdl")&&(i=i.slice(0,-4)),i+=".mdx")),i?this.load(i).then((i=>{i&&this.units.push(new $h(this,i,e,t))})):console.log("Unknown unit ID",t.id,t)}catch(e){console.warn(`Failed to load unit/item ID ${t.id}: ${e}`)}this.unitsReady=!0,this.anyReady=!0}update(){if(this.anyReady){this.waterIndex+=this.waterIncreasePerFrame,this.waterIndex>=this.waterTextures.length&&(this.waterIndex=0);for(const t of this.doodads)t.update();for(const t of this.units)t.update()}}render(){if(this.anyReady){const t=this.worldScene;t.startFrame(),this.renderGround(),this.renderCliffs(),t.renderOpaque(),this.renderWater(),t.renderTranslucent()}}renderGround(){if(this.terrainReady){const t=this.viewer.gl,e=this.viewer.webgl,i=e.extensions.ANGLE_instanced_arrays,r=this.viewer.groundShader,n=r.uniforms,s=r.attribs,a=this.tilesetTextures,o=s.a_InstanceID,l=s.a_position,h=s.a_textures,c=s.a_variations,d=a.length;t.enable(t.BLEND),t.blendFunc(t.SRC_ALPHA,t.ONE_MINUS_SRC_ALPHA),e.useShader(r),t.uniformMatrix4fv(n.u_VP,!1,this.worldScene.camera.viewProjectionMatrix),t.uniform2fv(n.u_offset,this.centerOffset),t.uniform2f(n.u_size,this.columns,this.rows),t.uniform1i(n.u_heightMap,15),t.activeTexture(t.TEXTURE15),t.bindTexture(t.TEXTURE_2D,this.heightMap),t.bindBuffer(t.ARRAY_BUFFER,this.vertexBuffer),t.vertexAttribPointer(l,2,t.FLOAT,!1,0,0),t.bindBuffer(t.ARRAY_BUFFER,this.instanceBuffer),t.vertexAttribPointer(o,1,t.FLOAT,!1,0,0),i.vertexAttribDivisorANGLE(o,1),t.bindBuffer(t.ARRAY_BUFFER,this.textureBuffer),t.vertexAttribPointer(h,4,t.UNSIGNED_BYTE,!1,0,0),i.vertexAttribDivisorANGLE(h,1),t.bindBuffer(t.ARRAY_BUFFER,this.variationBuffer),t.vertexAttribPointer(c,4,t.UNSIGNED_BYTE,!1,0,0),i.vertexAttribDivisorANGLE(c,1),t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,this.faceBuffer),t.uniform1f(n.u_baseTileset,0);for(let i=0,r=Math.min(d,15);i<r;i++){const r=a[i].width>a[i].height?1:0;t.uniform1f(n[`u_extended[${i}]`],r),t.uniform1i(n[`u_tilesets[${i}]`],i),e.bindTexture(a[i],i)}if(i.drawElementsInstancedANGLE(t.TRIANGLES,6,t.UNSIGNED_BYTE,0,this.rows*this.columns),d>15){t.uniform1f(n.u_baseTileset,15);for(let i=0,r=d-15;i<r;i++){const r=a[i+15].width>a[i+15].height?1:0;t.uniform1f(n[`u_extended[${i}]`],r),e.bindTexture(a[i+15],i)}i.drawElementsInstancedANGLE(t.TRIANGLES,6,t.UNSIGNED_BYTE,0,this.rows*this.columns)}i.vertexAttribDivisorANGLE(h,0),i.vertexAttribDivisorANGLE(c,0),i.vertexAttribDivisorANGLE(o,0)}}renderWater(){if(this.terrainReady){const t=this.viewer.gl,e=this.viewer.webgl,i=e.extensions.ANGLE_instanced_arrays,r=this.viewer.waterShader,n=r.uniforms,s=r.attribs,a=s.a_InstanceID,o=s.a_position,l=s.a_isWater;t.depthMask(!1),t.enable(t.BLEND),t.blendFunc(t.SRC_ALPHA,t.ONE_MINUS_SRC_ALPHA),e.useShader(r),t.uniformMatrix4fv(n.u_VP,!1,this.worldScene.camera.viewProjectionMatrix),t.uniform2fv(n.u_offset,this.centerOffset),t.uniform2f(n.u_size,this.columns,this.rows),t.uniform1i(n.u_heightMap,0),t.uniform1i(n.u_waterHeightMap,1),t.uniform1i(n.u_waterTexture,2),t.uniform1f(n.u_offsetHeight,this.waterHeightOffset),t.uniform4fv(n.u_maxDeepColor,this.maxDeepColor),t.uniform4fv(n.u_minDeepColor,this.minDeepColor),t.uniform4fv(n.u_maxShallowColor,this.maxShallowColor),t.uniform4fv(n.u_minShallowColor,this.minShallowColor),t.activeTexture(t.TEXTURE0),t.bindTexture(t.TEXTURE_2D,this.heightMap),t.activeTexture(t.TEXTURE1),t.bindTexture(t.TEXTURE_2D,this.waterHeightMap),e.bindTexture(this.waterTextures[0|this.waterIndex],2),t.bindBuffer(t.ARRAY_BUFFER,this.vertexBuffer),t.vertexAttribPointer(o,2,t.FLOAT,!1,8,0),t.bindBuffer(t.ARRAY_BUFFER,this.instanceBuffer),t.vertexAttribPointer(a,1,t.FLOAT,!1,4,0),i.vertexAttribDivisorANGLE(a,1),t.bindBuffer(t.ARRAY_BUFFER,this.waterBuffer),t.vertexAttribPointer(l,1,t.UNSIGNED_BYTE,!1,1,0),i.vertexAttribDivisorANGLE(l,1),t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,this.faceBuffer),i.drawElementsInstancedANGLE(t.TRIANGLES,6,t.UNSIGNED_BYTE,0,this.rows*this.columns),i.vertexAttribDivisorANGLE(l,0),i.vertexAttribDivisorANGLE(a,0)}}renderCliffs(){if(this.cliffsReady){const t=this.viewer.gl,e=this.viewer.webgl,i=e.extensions.ANGLE_instanced_arrays,r=e.extensions.OES_vertex_array_object,n=this.viewer.cliffShader,s=n.attribs,a=n.uniforms;t.disable(t.BLEND),n.use(),t.uniformMatrix4fv(a.u_VP,!1,this.worldScene.camera.viewProjectionMatrix),t.uniform1i(a.u_heightMap,0),t.uniform2f(a.u_pixel,1/(this.columns+1),1/(this.rows+1)),t.uniform2fv(a.u_centerOffset,this.centerOffset),t.uniform1i(a.u_texture1,1),t.uniform1i(a.u_texture2,2),t.activeTexture(t.TEXTURE0),t.bindTexture(t.TEXTURE_2D,this.cliffHeightMap),t.activeTexture(t.TEXTURE1),t.bindTexture(t.TEXTURE_2D,this.cliffTextures[0].webglResource),this.cliffTextures.length>1&&(t.activeTexture(t.TEXTURE2),t.bindTexture(t.TEXTURE_2D,this.cliffTextures[1].webglResource)),r||(i.vertexAttribDivisorANGLE(s.a_instancePosition,1),i.vertexAttribDivisorANGLE(s.a_instanceTexture,1));for(const t of this.cliffModels)t.render(n);r||(i.vertexAttribDivisorANGLE(s.a_instancePosition,0),i.vertexAttribDivisorANGLE(s.a_instanceTexture,0))}}cliffFileName(t,e,i,r,n){return String.fromCharCode(65+t-n)+String.fromCharCode(65+i-n)+String.fromCharCode(65+r-n)+String.fromCharCode(65+e-n)}getVariation(t,e){const i=this.tilesetTextures[t];return i.width>i.height?e<16?16+e:16===e?15:0:0===e?0:15}isCliff(t,e){if(t<1||t>this.columns-1||e<1||e>this.rows-1)return!1;const i=this.corners,r=i[e][t].layerHeight,n=i[e][t+1].layerHeight,s=i[e+1][t].layerHeight,a=i[e+1][t+1].layerHeight;return r!==n||r!==s||r!==a}isWater(t,e){const i=this.corners;return i[e][t].water||i[e][t+1].water||i[e+1][t].water||i[e+1][t+1].water}cliffGroundIndex(t){const e=this.cliffTilesets[t].groundTile,i=this.tilesets;for(let t=0,r=i.length;t<r;t++)if(i[t].tileID===e)return t;return 0}cornerTexture(t,e){const i=this.corners,r=this.columns,n=this.rows;for(let s=-1;s<1;s++)for(let a=-1;a<1;a++)if(t+a>0&&t+a<r-1&&e+s>0&&e+s<n-1&&this.isCliff(t+a,e+s)){let r=i[e+s][t+a].cliffTexture;return 15===r&&(r=1),this.cliffGroundIndex(r)}const s=i[e][t];return s.blight?this.blightTextureIndex:s.groundTexture}applyModificationFile(t,e,i){i&&(this.applyModificationTable(t,e,i.originalTable),this.applyModificationTable(t,e,i.customTable))}applyModificationTable(t,e,i){for(const r of i.objects){let i;""!==r.newId?(i=t.getRow(r.newId),i||(i=Object.assign({},t.getRow(r.oldId)),t.setRow(r.newId,i))):i=t.getRow(r.oldId);for(const t of r.modifications){const r=e.getRow(t.id);r?i[r.field]=t.value:console.warn("Unknown modification ID",t)}}}groundNormal(t,e,i){const r=this.centerOffset,n=this.mapSize,s=0|(e=(e-r[0])/128),a=0|(i=(i-r[1])/128);if(s>=0&&s<n[0]-1&&a>=0&&a<n[1]-1){const r=this.corners,n=r[a][s].groundHeight,o=r[a][s+1].groundHeight,l=r[a+1][s].groundHeight,h=r[a+1][s+1].groundHeight;e-s+(i-a)<1?(b(lc,1,0,o-n),b(hc,0,1,l-n)):(b(lc,-1,0,h-l),b(hc,0,1,h-o)),A(t,T(t,lc,hc))}else b(t,0,0,1);return t}}const dc=g(),uc=g(),fc=U(),mc=new Float32Array(1);function gc(t,e){let i=e.clientX-t.clientX,r=e.clientY-t.clientY;return Math.sqrt(i*i+r*r)}class pc{constructor(t,e={}){this.scene=t,this.canvas=t.viewer.canvas,this.camera=t.camera,this.moveSpeed=e.moveSpeed||2,this.rotationSpeed=e.rotationSpeed||Math.PI/180,this.zoomFactor=e.zoomFactor||.1,this.horizontalAngle=e.horizontalAngle||Math.PI/2,this.verticalAngle=e.verticalAngle||Math.PI/4,this.distance=e.distance||500,this.position=e.position||g(),this.target=e.target||g(),this.twist=e.twist||0,this.mouse={buttons:[!1,!1,!1],x:0,y:0,x2:0,y2:0},this.touchMode=-1,this.touches=[],this.instance=null,this.onManualChange=e.onManualChange||null,this.fov=e.fov||Math.PI/4,this.nearClipPlane=e.nearClipPlane||1,this.farClipPlane=e.farClipPlane||2e5,this.update(),window.addEventListener("resize",(t=>this.onResize())),setTimeout((()=>this.onResize()),0),this.canvas.addEventListener("contextmenu",(t=>t.preventDefault())),this.canvas.addEventListener("selectstart",(t=>t.preventDefault())),this.canvas.addEventListener("mousedown",(t=>{t.preventDefault(),this.mouse.buttons[t.button]=!0})),document.addEventListener("mouseup",(t=>{t.preventDefault(),this.mouse.buttons[t.button]=!1})),window.addEventListener("mousemove",(t=>{this.mouse.x2=this.mouse.x,this.mouse.y2=this.mouse.y,this.mouse.x=t.clientX,this.mouse.y=t.clientY;let e=this.mouse.x-this.mouse.x2,i=this.mouse.y-this.mouse.y2;this.mouse.buttons[0]&&this.rotate(e,i),this.mouse.buttons[2]&&this.move(-e,i)})),this.canvas.addEventListener("wheel",(t=>{t.preventDefault();let e=t.deltaY;1===t.deltaMode&&(e=e/3*100),this.zoom(e/100)})),this.canvas.addEventListener("touchstart",(t=>{t.preventDefault();let e=t.targetTouches;1===e.length?this.touchMode=0:2==e.length?this.touchMode=1:this.touchMode=-1,this.touches.length=0,this.touches.push(...e)})),this.canvas.addEventListener("touchend",(t=>{t.preventDefault(),this.touchMode=-1})),this.canvas.addEventListener("touchcancel",(t=>{t.preventDefault(),this.touchMode=-1})),this.canvas.addEventListener("touchmove",(t=>{t.preventDefault();let e=t.targetTouches;if(0===this.touchMode){let t=this.touches[0],i=e[0],r=i.clientX-t.clientX,n=i.clientY-t.clientY;this.rotate(r,n)}else if(1===this.touchMode){let t=gc(this.touches[0],this.touches[1]),i=gc(e[0],e[1]);this.zoom((t-i)/50)}this.touches.length=0,this.touches.push(...e)}))}update(){if(this.instance){let t=this.instance,e=t.model.cameras[0];e.getTranslation(dc,t.sequence,t.frame,t.counter),y(dc,dc,e.position),e.getTargetTranslation(uc,t.sequence,t.frame,t.counter),y(uc,uc,e.targetPosition),e.getRotation(mc,t.sequence,t.frame,t.counter),this.twist=mc[0],E(dc,dc,t.worldMatrix),E(uc,uc,t.worldMatrix),this.moveToAndFace(dc,uc)}else this.updateInternalCamera()}move(t,e){let i=this.camera.directionX,r=this.camera.directionY,n=this.canvas.width,s=this.canvas.height,a=n/s,o=t/n*this.distance*a,l=e/s*this.distance;y(this.target,this.target,_(dc,A(dc,b(dc,i[0],i[1],0)),o)),y(this.target,this.target,_(dc,A(dc,b(dc,r[0],r[1],0)),l)),this.manualChange()}rotate(t,e){this.horizontalAngle-=t*this.rotationSpeed,this.verticalAngle-=e*this.rotationSpeed,this.manualChange()}zoom(t){this.distance=Math.max(1,this.distance*(1+t*this.zoomFactor)),this.manualChange()}manualChange(){this.updateInternalCamera(),this.instance&&(this.instance=null,this.onManualChange&&this.onManualChange())}onResize(){let t=Math.max(this.canvas.clientWidth,1),e=Math.max(this.canvas.clientHeight,1);this.canvas.width=t,this.canvas.height=e,this.scene.viewport[2]=t,this.scene.viewport[3]=e,this.camera.perspective(this.fov,t/e,this.nearClipPlane,this.farClipPlane)}moveToAndFace(t,e){I(dc,t,e);let i=p(dc),r=Math.atan2(dc[1],dc[0]),n=Math.acos(dc[2]/i);v(this.target,e),this.verticalAngle=n,this.horizontalAngle=r+Math.PI/2,this.distance=i,this.updateInternalCamera()}updateInternalCamera(){this.verticalAngle=Math.min(Math.max(.01,this.verticalAngle),Math.PI-.01),k(fc),N(fc,fc,this.horizontalAngle),D(fc,fc,this.verticalAngle),b(this.position,0,0,1),S(this.position,this.position,fc),_(this.position,this.position,this.distance),y(this.position,this.position,this.target);let t=this.twist-Math.PI/2;b(dc,0,-Math.cos(t),-Math.sin(t)),this.camera.moveToAndFace(this.position,this.target,dc)}applyInstanceCamera(t){this.instance=t,this.fov=t.model.cameras[0].fieldOfView,this.onResize(),this.update()}}let wc=document.getElementById("status");wc.textContent="Initializing the viewer";let vc=document.getElementById("canvas"),bc=new class extends zt{constructor(t,e,i){super(t),this.terrainData=new s,this.cliffTypesData=new s,this.waterData=new s,this.doodadsData=new s,this.doodadMetaData=new s,this.destructableMetaData=new s,this.unitsData=new s,this.unitMetaData=new s,this.loadedBaseFiles=!1,this.map=null;const r=this.webgl;if(!r.ensureExtension("OES_texture_float"))throw new Error("War3MapViewer: No float texture support!");r.ensureExtension("OES_vertex_array_object")||console.warn("War3MapViewer: No vertex array object support! This might reduce performance."),this.on("error",(t=>console.log(t))),this.addHandler(gn,e,i),this.addHandler(Pn),this.addHandler(On),this.addHandler(rs),this.wc3PathSolver=e,this.isReforged=i,this.groundShader=this.webgl.createShader("\nuniform mat4 u_VP;\nuniform sampler2D u_heightMap;\nuniform vec2 u_size;\nuniform vec2 u_offset;\nuniform bool u_extended[14];\nuniform float u_baseTileset;\n\nattribute vec2 a_position;\nattribute float a_InstanceID;\nattribute vec4 a_textures;\nattribute vec4 a_variations;\n\nvarying vec4 v_tilesets;\nvarying vec2 v_uv[4];\nvarying vec3 v_normal;\n\nvec2 getCell(float variation) {\n  if (variation < 16.0) {\n    return vec2(mod(variation, 4.0), floor(variation / 4.0));\n  } else {\n    variation -= 16.0;\n\n    return vec2(4.0 + mod(variation, 4.0), floor(variation / 4.0));\n  }\n}\n\nvec2 getUV(vec2 position, bool extended, float variation) {\n  vec2 cell = getCell(variation);\n  vec2 cellSize = vec2(extended ? 0.125 : 0.25, 0.25);\n  vec2 uv = vec2(position.x, 1.0 - position.y);\n  vec2 pixelSize = vec2(1.0 / 512.0, 1.0 / 256.0); /// Note: hardcoded to 512x256 for now.\n\n  return clamp((cell + uv) * cellSize, cell * cellSize + pixelSize, (cell + 1.0) * cellSize - pixelSize); \n}\n\nvoid main() {\n  vec4 textures = a_textures - u_baseTileset;\n  \n  if (textures[0] > 0.0 || textures[1] > 0.0 || textures[2] > 0.0 || textures[3] > 0.0) {\n    v_tilesets = textures;\n\n    v_uv[0] = getUV(a_position, u_extended[int(textures[0]) - 1], a_variations[0]);\n    v_uv[1] = getUV(a_position, u_extended[int(textures[1]) - 1], a_variations[1]);\n    v_uv[2] = getUV(a_position, u_extended[int(textures[2]) - 1], a_variations[2]);\n    v_uv[3] = getUV(a_position, u_extended[int(textures[3]) - 1], a_variations[3]);\n\n    vec2 corner = vec2(mod(a_InstanceID, u_size.x), floor(a_InstanceID / u_size.x));\n    vec2 base = corner + a_position;\n    float height = texture2D(u_heightMap, base / u_size).a;\n\n    float hL = texture2D(u_heightMap, vec2(base - vec2(1.0, 0.0)) / (u_size)).a;\n    float hR = texture2D(u_heightMap, vec2(base + vec2(1.0, 0.0)) / (u_size)).a;\n    float hD = texture2D(u_heightMap, vec2(base - vec2(0.0, 1.0)) / (u_size)).a;\n    float hU = texture2D(u_heightMap, vec2(base + vec2(0.0, 1.0)) / (u_size)).a;\n\n    v_normal = normalize(vec3(hL - hR, hD - hU, 2.0));\n\n    gl_Position = u_VP * vec4(base * 128.0 + u_offset, height * 128.0, 1.0);\n  } else {\n    v_tilesets = vec4(0.0);\n\n    v_uv[0] = vec2(0.0);\n    v_uv[1] = vec2(0.0);\n    v_uv[2] = vec2(0.0);\n    v_uv[3] = vec2(0.0);\n\n    v_normal = vec3(0.0);\n\n    gl_Position = vec4(0.0);\n  }\n}\n",ns),this.waterShader=this.webgl.createShader("\nuniform mat4 u_VP;\nuniform sampler2D u_heightMap;\nuniform sampler2D u_waterHeightMap;\nuniform vec2 u_size;\nuniform vec2 u_offset;\nuniform float u_offsetHeight;\nuniform vec4 u_minDeepColor;\nuniform vec4 u_maxDeepColor;\nuniform vec4 u_minShallowColor;\nuniform vec4 u_maxShallowColor;\n\nattribute vec2 a_position;\nattribute float a_InstanceID;\nattribute float a_isWater;\n\nvarying vec2 v_uv;\nvarying vec4 v_color;\n\nconst float minDepth = 10.0 / 128.0;\nconst float deepLevel = 64.0 / 128.0;\nconst float maxDepth = 72.0 / 128.0;\n\nvoid main() {\n  if (a_isWater > 0.5) {\n    v_uv = a_position;\n\n    vec2 corner = vec2(mod(a_InstanceID, u_size.x), floor(a_InstanceID / u_size.x));\n    vec2 base = corner + a_position;\n    float height = texture2D(u_heightMap, base / u_size).a;\n    float waterHeight = texture2D(u_waterHeightMap, base / u_size).a + u_offsetHeight;\n    float value = clamp(waterHeight - height, 0.0, 1.0);\n\n    if (value <= deepLevel) {\n      value = max(0.0, value - minDepth) / (deepLevel - minDepth);\n      v_color = mix(u_minShallowColor, u_maxShallowColor, value) / 255.0;\n    } else {\n      value = clamp(value - deepLevel, 0.0, maxDepth - deepLevel) / (maxDepth - deepLevel);\n      v_color = mix(u_minDeepColor, u_maxDeepColor, value) / 255.0;\n    }\n\n    gl_Position = u_VP * vec4(base * 128.0 + u_offset, waterHeight * 128.0, 1.0);\n  } else {\n    v_uv = vec2(0.0);\n    v_color = vec4(0.0);\n\n    gl_Position = vec4(0.0);\n  }\n}\n",ss),this.cliffShader=this.webgl.createShader("\nuniform mat4 u_VP;\nuniform sampler2D u_heightMap;\nuniform vec2 u_pixel;\nuniform vec2 u_centerOffset;\n\nattribute vec3 a_position;\nattribute vec3 a_normal;\nattribute vec2 a_uv;\nattribute vec3 a_instancePosition;\nattribute float a_instanceTexture;\n\nvarying vec3 v_normal;\nvarying vec2 v_uv;\nvarying float v_texture;\nvarying vec3 v_position;\n\nvoid main() {\n  // Half of a pixel in the cliff height map.\n  vec2 halfPixel = u_pixel * 0.5;\n\n  // The bottom left corner of the map tile this vertex is on.\n  vec2 corner = floor((a_instancePosition.xy - vec2(1.0, 0.0) - u_centerOffset.xy) / 128.0);\n\n  // Get the 4 closest heights in the height map.\n  float bottomLeft = texture2D(u_heightMap, corner * u_pixel + halfPixel).a;\n  float bottomRight = texture2D(u_heightMap, (corner + vec2(1.0, 0.0)) * u_pixel + halfPixel).a;\n  float topLeft = texture2D(u_heightMap, (corner + vec2(0.0, 1.0)) * u_pixel + halfPixel).a;\n  float topRight = texture2D(u_heightMap, (corner + vec2(1.0, 1.0)) * u_pixel + halfPixel).a;\n  \n  // Do a bilinear interpolation between the heights to get the final value.\n  float bottom = mix(bottomRight, bottomLeft, -a_position.x / 128.0);\n  float top = mix(topRight, topLeft, -a_position.x / 128.0);\n  float height = mix(bottom, top, a_position.y / 128.0);\n\n  v_normal = a_normal;\n  v_uv = a_uv;\n  v_texture = a_instanceTexture;\n  v_position = a_position + vec3(a_instancePosition.xy, a_instancePosition.z + height * 128.0);\n\n  gl_Position = u_VP * vec4(v_position, 1.0);\n}\n",as),this.loadBaseFiles()}async loadBaseFiles(){const t=[this.loadBaseFile("TerrainArt\\Terrain.slk","text"),this.loadBaseFile("TerrainArt\\CliffTypes.slk","text"),this.loadBaseFile("TerrainArt\\Water.slk","text"),this.loadBaseFile("Doodads\\Doodads.slk","text"),this.loadBaseFile("Doodads\\DoodadMetaData.slk","text"),this.loadBaseFile("Units\\DestructableData.slk","text"),this.loadBaseFile("Units\\DestructableMetaData.slk","text"),this.loadBaseFile("Units\\UnitData.slk","text"),this.loadBaseFile("Units\\unitUI.slk","text"),this.loadBaseFile("Units\\ItemData.slk","text"),this.loadBaseFile("Units\\UnitMetaData.slk","text")];let e;this.isReforged&&(e=[this.loadBaseFile("Doodads\\doodadSkins.txt","text"),this.loadBaseFile("Units\\destructableSkin.txt","text"),this.loadBaseFile("Units\\unitSkin.txt","text"),this.loadBaseFile("Units\\itemSkin.txt","text")]);const[i,r,n,s,a,o,l,h,c,d,u]=await Promise.all(t);if(!(i&&r&&n&&s&&a&&o&&l&&h&&c&&d&&u))throw new Error("Failed to load the base files");if(this.terrainData.load(i.data),this.cliffTypesData.load(r.data),this.waterData.load(n.data),this.doodadsData.load(s.data),this.doodadMetaData.load(a.data),this.doodadsData.load(o.data),this.destructableMetaData.load(l.data),this.unitsData.load(h.data),this.unitsData.load(c.data),this.unitsData.load(d.data),this.unitMetaData.load(u.data),e){const[t,i,r,n]=await Promise.all(e);if(!(t&&i&&r&&n))throw new Error("Failed to load the base Reforged files");this.doodadsData.load(t.data),this.doodadsData.load(i.data),this.unitsData.load(r.data),this.unitsData.load(n.data)}this.loadedBaseFiles=!0,this.emit("loadedbasefiles")}loadBaseFile(t,e){return super.loadGeneric(this.wc3PathSolver(t),e)}loadMap(t){this.loadedBaseFiles&&(this.map&&this.map.die(),this.map=new cc(this,t))}update(){this.map&&(super.update(),this.map.update())}render(){this.map&&this.map.render()}}(vc,(function(t,e){return t=t.toLowerCase(),"127.0.0.1"===window.location.hostname?function(t,e){if(e){const i=Object.entries(e);if(i.length){const e=i.map((([t,e])=>`${t}=${e}`)).join("&");let r="&";return-1===t.indexOf("?")&&(r="?"),`${t}${r}${e}`}}return t}(`${window.location.origin}/assets?path=${t}`,e):`https://www.hiveworkshop.com/casc-contents?path=${t}`}),!0),yc=[];function _c(){yc.length?wc.textContent=`Loading ${yc.join(", ")}`:wc.textContent=""}for(let e of bc.promiseMap.keys())yc.push(t(e));_c(),bc.on("loadstart",(({fetchUrl:e})=>{yc.push(t(e)),_c()})),bc.on("loadend",(({fetchUrl:e})=>{let i=t(e),r=yc.indexOf(i);-1!==r&&(yc.splice(r,1),_c())}));let Ac=new FPSMeter({position:"absolute",right:"10px",top:"10px",left:"calc(100% - 130px)",theme:"transparent",heat:1,graph:1}),xc=document.getElementById("cells"),Tc=document.getElementById("instances"),Ec=document.getElementById("particles");!function t(){requestAnimationFrame(t),bc.updateAndRender(),Ac.tick(),xc.textContent=`Cells: ${bc.visibleCells}`,Tc.textContent=`Instances: ${bc.visibleInstances}`,Ec.textContent=`Particles: ${bc.updatedParticles}`}(),document.addEventListener("dragover",(t=>{t.preventDefault()})),document.addEventListener("dragend",(t=>{t.preventDefault()})),document.addEventListener("drop",(t=>{if(t.preventDefault(),bc.loadedBaseFiles){let i=t.dataTransfer.files[0],r=e(i.name);if(".w3m"===r||".w3x"===r){let t=new FileReader;t.addEventListener("loadend",(t=>{bc.loadMap(t.target.result),function(t,e={}){new pc(t,e)}(bc.map.worldScene,{distance:3e3})})),t.readAsArrayBuffer(i)}}}))})()})();