/*!
 * The MIT License (MIT)
 *
 * Copyright (c) 2013-2021 Chananya Freiman
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */(()=>{"use strict";var t={187:t=>{var e,i="object"==typeof Reflect?Reflect:null,n=i&&"function"==typeof i.apply?i.apply:function(t,e,i){return Function.prototype.apply.call(t,e,i)};e=i&&"function"==typeof i.ownKeys?i.ownKeys:Object.getOwnPropertySymbols?function(t){return Object.getOwnPropertyNames(t).concat(Object.getOwnPropertySymbols(t))}:function(t){return Object.getOwnPropertyNames(t)};var s=Number.isNaN||function(t){return t!=t};function r(){r.init.call(this)}t.exports=r,t.exports.once=function(t,e){return new Promise((function(i,n){function s(i){t.removeListener(e,r),n(i)}function r(){"function"==typeof t.removeListener&&t.removeListener("error",s),i([].slice.call(arguments))}g(t,e,r,{once:!0}),"error"!==e&&function(t,e,i){"function"==typeof t.on&&g(t,"error",e,i)}(t,s,{once:!0})}))},r.EventEmitter=r,r.prototype._events=void 0,r.prototype._eventsCount=0,r.prototype._maxListeners=void 0;var a=10;function o(t){if("function"!=typeof t)throw new TypeError('The "listener" argument must be of type Function. Received type '+typeof t)}function l(t){return void 0===t._maxListeners?r.defaultMaxListeners:t._maxListeners}function h(t,e,i,n){var s,r,a,h;if(o(i),void 0===(r=t._events)?(r=t._events=Object.create(null),t._eventsCount=0):(void 0!==r.newListener&&(t.emit("newListener",e,i.listener?i.listener:i),r=t._events),a=r[e]),void 0===a)a=r[e]=i,++t._eventsCount;else if("function"==typeof a?a=r[e]=n?[i,a]:[a,i]:n?a.unshift(i):a.push(i),(s=l(t))>0&&a.length>s&&!a.warned){a.warned=!0;var c=new Error("Possible EventEmitter memory leak detected. "+a.length+" "+String(e)+" listeners added. Use emitter.setMaxListeners() to increase limit");c.name="MaxListenersExceededWarning",c.emitter=t,c.type=e,c.count=a.length,h=c,console&&console.warn&&console.warn(h)}return t}function c(){if(!this.fired)return this.target.removeListener(this.type,this.wrapFn),this.fired=!0,0===arguments.length?this.listener.call(this.target):this.listener.apply(this.target,arguments)}function d(t,e,i){var n={fired:!1,wrapFn:void 0,target:t,type:e,listener:i},s=c.bind(n);return s.listener=i,n.wrapFn=s,s}function u(t,e,i){var n=t._events;if(void 0===n)return[];var s=n[e];return void 0===s?[]:"function"==typeof s?i?[s.listener||s]:[s]:i?function(t){for(var e=new Array(t.length),i=0;i<e.length;++i)e[i]=t[i].listener||t[i];return e}(s):m(s,s.length)}function f(t){var e=this._events;if(void 0!==e){var i=e[t];if("function"==typeof i)return 1;if(void 0!==i)return i.length}return 0}function m(t,e){for(var i=new Array(e),n=0;n<e;++n)i[n]=t[n];return i}function g(t,e,i,n){if("function"==typeof t.on)n.once?t.once(e,i):t.on(e,i);else{if("function"!=typeof t.addEventListener)throw new TypeError('The "emitter" argument must be of type EventEmitter. Received type '+typeof t);t.addEventListener(e,(function s(r){n.once&&t.removeEventListener(e,s),i(r)}))}}Object.defineProperty(r,"defaultMaxListeners",{enumerable:!0,get:function(){return a},set:function(t){if("number"!=typeof t||t<0||s(t))throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received '+t+".");a=t}}),r.init=function(){void 0!==this._events&&this._events!==Object.getPrototypeOf(this)._events||(this._events=Object.create(null),this._eventsCount=0),this._maxListeners=this._maxListeners||void 0},r.prototype.setMaxListeners=function(t){if("number"!=typeof t||t<0||s(t))throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received '+t+".");return this._maxListeners=t,this},r.prototype.getMaxListeners=function(){return l(this)},r.prototype.emit=function(t){for(var e=[],i=1;i<arguments.length;i++)e.push(arguments[i]);var s="error"===t,r=this._events;if(void 0!==r)s=s&&void 0===r.error;else if(!s)return!1;if(s){var a;if(e.length>0&&(a=e[0]),a instanceof Error)throw a;var o=new Error("Unhandled error."+(a?" ("+a.message+")":""));throw o.context=a,o}var l=r[t];if(void 0===l)return!1;if("function"==typeof l)n(l,this,e);else{var h=l.length,c=m(l,h);for(i=0;i<h;++i)n(c[i],this,e)}return!0},r.prototype.addListener=function(t,e){return h(this,t,e,!1)},r.prototype.on=r.prototype.addListener,r.prototype.prependListener=function(t,e){return h(this,t,e,!0)},r.prototype.once=function(t,e){return o(e),this.on(t,d(this,t,e)),this},r.prototype.prependOnceListener=function(t,e){return o(e),this.prependListener(t,d(this,t,e)),this},r.prototype.removeListener=function(t,e){var i,n,s,r,a;if(o(e),void 0===(n=this._events))return this;if(void 0===(i=n[t]))return this;if(i===e||i.listener===e)0==--this._eventsCount?this._events=Object.create(null):(delete n[t],n.removeListener&&this.emit("removeListener",t,i.listener||e));else if("function"!=typeof i){for(s=-1,r=i.length-1;r>=0;r--)if(i[r]===e||i[r].listener===e){a=i[r].listener,s=r;break}if(s<0)return this;0===s?i.shift():function(t,e){for(;e+1<t.length;e++)t[e]=t[e+1];t.pop()}(i,s),1===i.length&&(n[t]=i[0]),void 0!==n.removeListener&&this.emit("removeListener",t,a||e)}return this},r.prototype.off=r.prototype.removeListener,r.prototype.removeAllListeners=function(t){var e,i,n;if(void 0===(i=this._events))return this;if(void 0===i.removeListener)return 0===arguments.length?(this._events=Object.create(null),this._eventsCount=0):void 0!==i[t]&&(0==--this._eventsCount?this._events=Object.create(null):delete i[t]),this;if(0===arguments.length){var s,r=Object.keys(i);for(n=0;n<r.length;++n)"removeListener"!==(s=r[n])&&this.removeAllListeners(s);return this.removeAllListeners("removeListener"),this._events=Object.create(null),this._eventsCount=0,this}if("function"==typeof(e=i[t]))this.removeListener(t,e);else if(void 0!==e)for(n=e.length-1;n>=0;n--)this.removeListener(t,e[n]);return this},r.prototype.listeners=function(t){return u(this,t,!0)},r.prototype.rawListeners=function(t){return u(this,t,!1)},r.listenerCount=function(t,e){return"function"==typeof t.listenerCount?t.listenerCount(e):f.call(t,e)},r.prototype.listenerCount=f,r.prototype.eventNames=function(){return this._eventsCount>0?e(this._events):[]}}},e={};function i(n){var s=e[n];if(void 0!==s)return s.exports;var r=e[n]={exports:{}};return t[n](r,r.exports,i),r.exports}(()=>{function t(t){if(t&&t.length){let e=t.lastIndexOf("/");return-1!==e&&(t=t.slice(e+1)),e=t.lastIndexOf("\\"),-1!==e&&(t=t.slice(e+1)),t}return""}function e(t){if(t&&t.length){const e=t.lastIndexOf(".");return-1!==e&&(t=t.slice(e).toLowerCase()),t}return""}function n(e){const i=(e=t(e)).lastIndexOf(".");return-1!==i&&(e=e.slice(0,i)),e}const s=new TextDecoder,r=new TextEncoder;function a(t){return s.decode(t)}function o(t){return r.encode(t)}function l(t){let e=t.length;for(let i=t.length-1;i>=0;i--){const n=t.charCodeAt(i);n>127&&n<=2047?e++:n>2047&&n<=65535&&(e+=2),n>=56320&&n<=57343&&i--}return e}function h(t){return t instanceof Uint8Array?t:"string"==typeof t?o(t):new Uint8Array(t)}function c(t,e,i=0,n=1/0){const s=Math.max(i,0),r=Math.min(s+n,t.length);let a=0,o=e.charCodeAt(0);for(let i=s;i<r;i++){if(t[i]===o){if(a+=1,a===e.length)return!0;o=e.charCodeAt(a)}else a>0&&(a=0,o=e.charCodeAt(0))}return!1}const d=new ArrayBuffer(8),u=new Int8Array(d),f=new Int16Array(d),m=new Int32Array(d),g=new Uint8Array(d),p=new Uint16Array(d),w=new Uint32Array(d),b=new Float32Array(d),v=new Float64Array(d);function y(t){return g[0]=t,u[0]}function _(t,e){return g[0]=t,g[1]=e,f[0]}function x(t,e,i,n){return g[0]=t,g[1]=e,g[2]=i,g[3]=n,m[0]}function A(t,e){return g[0]=t,g[1]=e,p[0]}function T(t,e,i,n){return g[0]=t,g[1]=e,g[2]=i,g[3]=n,w[0]}function E(t,e,i,n){return g[0]=t,g[1]=e,g[2]=i,g[3]=n,b[0]}function S(t,e,i,n,s,r,a,o){return g[0]=t,g[1]=e,g[2]=i,g[3]=n,g[4]=s,g[5]=r,g[6]=a,g[7]=o,v[0]}function I(t){return g[0]=t,u[0]}function k(t,e){return f[0]=e,t[0]=g[0],t[1]=g[1],t}function L(t,e){return m[0]=e,t[0]=g[0],t[1]=g[1],t[2]=g[2],t[3]=g[3],t}function M(t,e){return p[0]=e,t[0]=g[0],t[1]=g[1],t}function C(t,e){return w[0]=e,t[0]=g[0],t[1]=g[1],t[2]=g[2],t[3]=g[3],t}function R(t,e){return b[0]=e,t[0]=g[0],t[1]=g[1],t[2]=g[2],t[3]=g[3],t}function B(t,e){return v[0]=e,t[0]=g[0],t[1]=g[1],t[2]=g[2],t[3]=g[3],t[4]=g[4],t[5]=g[5],t[6]=g[6],t[7]=g[7],t}function U(t){return w[0]=t,w[0]}const P=new Uint8Array(8);class F{constructor(t,e,i){this.index=0;const n=h(t);e=e||0,i=i||n.length,this.buffer=t,this.uint8array=n.subarray(e,e+i),this.byteLength=i,this.remaining=i}substream(t){if(this.remaining<t)throw new Error(`ByteStream: substream: want ${t} bytes but have ${this.remaining}`);const e=this.index;return this.index+=t,new F(this.uint8array.subarray(e,e+t))}skip(t){if(this.remaining<t)throw new Error(`ByteStream: skip: premature end - want ${t} bytes but have ${this.remaining}`);this.index+=t,this.remaining-=t}seek(t){this.index=t,this.remaining=this.byteLength-t}read(t){if(this.remaining<t)throw new Error(`ByteStream: read: premature end - want ${t} bytes but have ${this.remaining}`);const e=this.uint8array,i=this.index;let n=function(t,e,i=0,n=1/0){const s=Math.max(i,0),r=Math.min(s+n,t.length);for(let i=s;i<r;i++)if(t[i]===e)return i;return-1}(e,0,i,t);return-1===n&&(n=i+t),this.index+=t,this.remaining-=t,a(e.subarray(i,n))}readNull(){if(this.remaining<1)throw new Error("ByteStream: readNull: premature end - want at least 1 byte but have 0");const t=this.uint8array,e=this.index;let i=t.indexOf(0,e);-1===i&&(i=t.length-1);const n=i-e+1;return this.index+=n,this.remaining-=n,a(t.subarray(e,i))}readBinary(t){if(this.remaining<t)throw new Error(`ByteStream: readBinary: premature end - want ${t} bytes but have ${this.remaining}`);const e=this.uint8array,i=this.index;let n="";for(let s=0;s<t;s++)n+=String.fromCharCode(e[i+s]);return this.index+=t,this.remaining-=t,n}readInt8(){if(this.remaining<1)throw new Error(`ByteStream: readInt8: premature end - want 1 byte but have ${this.remaining}`);const t=this.index,e=y(this.uint8array[t]);return this.index+=1,this.remaining-=1,e}readInt16(){if(this.remaining<2)throw new Error(`ByteStream: readInt16: premature end - want 2 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=_(e[t],e[t+1]);return this.index+=2,this.remaining-=2,i}readInt32(){if(this.remaining<4)throw new Error(`ByteStream: readInt32: premature end - want 4 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=x(e[t],e[t+1],e[t+2],e[t+3]);return this.index+=4,this.remaining-=4,i}readUint8(){if(this.remaining<1)throw new Error(`ByteStream: readUint8: premature end - want 1 byte but have ${this.remaining}`);const t=this.uint8array[this.index];return this.index+=1,this.remaining-=1,t}readUint16(){if(this.remaining<2)throw new Error(`ByteStream: readUint16: premature end - want 2 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=A(e[t],e[t+1]);return this.index+=2,this.remaining-=2,i}readUint32(){if(this.remaining<4)throw new Error(`ByteStream: readUint32: premature end - want 4 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=T(e[t],e[t+1],e[t+2],e[t+3]);return this.index+=4,this.remaining-=4,i}readFloat32(){if(this.remaining<4)throw new Error(`ByteStream: readFloat32: premature end - want 4 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=E(e[t],e[t+1],e[t+2],e[t+3]);return this.index+=4,this.remaining-=4,i}readFloat64(){if(this.remaining<8)throw new Error(`ByteStream: readFloat64: premature end - want 8 bytes but have ${this.remaining}`);const t=this.index,e=this.uint8array,i=S(e[t],e[t+1],e[t+2],e[t+3],e[t+4],e[t+5],e[t+6],e[t+7]);return this.index+=8,this.remaining-=8,i}readInt8Array(t){if(ArrayBuffer.isView(t)||(t=new Int8Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readInt8Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++)t[n]=y(i[e+n]);return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readInt16Array(t){if(ArrayBuffer.isView(t)||(t=new Int16Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readInt16Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+2*n;t[n]=_(i[s],i[s+1])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readInt32Array(t){if(ArrayBuffer.isView(t)||(t=new Int32Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readInt32Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+4*n;t[n]=x(i[s],i[s+1],i[s+2],i[s+3])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readUint8Array(t){if(ArrayBuffer.isView(t)||(t=new Uint8Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readUint8Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++)t[n]=i[e+n];return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readUint16Array(t){if(ArrayBuffer.isView(t)||(t=new Uint16Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readUint16Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+2*n;t[n]=A(i[s],i[s+1])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readUint32Array(t){if(ArrayBuffer.isView(t)||(t=new Uint32Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readUint32Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+4*n;t[n]=T(i[s],i[s+1],i[s+2],i[s+3])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readFloat32Array(t){if(ArrayBuffer.isView(t)||(t=new Float32Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readFloat32Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+4*n;t[n]=E(i[s],i[s+1],i[s+2],i[s+3])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}readFloat64Array(t){if(ArrayBuffer.isView(t)||(t=new Float64Array(t)),this.remaining<t.byteLength)throw new Error(`ByteStream: readFloat64Array: premature end - want ${t.byteLength} bytes but have ${this.remaining}`);const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+8*n;t[n]=S(i[s],i[s+1],i[s+2],i[s+3],i[s+4],i[s+5],i[s+6],i[s+7])}return this.index+=t.byteLength,this.remaining-=t.byteLength,t}write(t){const e=o(t);return this.writeUint8Array(e),e.length}writeNull(t){const e=this.write(t);return this.index++,this.remaining--,e+1}writeBinary(t){const e=this.index,i=this.uint8array,n=t.length;for(let s=0;s<n;s++)i[e+s]=t.charCodeAt(s);this.index+=n}writeInt8(t){this.uint8array[this.index]=I(t),this.index+=1}writeInt16(t){const e=this.index,i=this.uint8array;k(P,t),i[e]=P[0],i[e+1]=P[1],this.index+=2}writeInt32(t){const e=this.index,i=this.uint8array;L(P,t),i[e]=P[0],i[e+1]=P[1],i[e+2]=P[2],i[e+3]=P[3],this.index+=4}writeUint8(t){this.uint8array[this.index]=t,this.index+=1}writeUint16(t){const e=this.index,i=this.uint8array;M(P,t),i[e]=P[0],i[e+1]=P[1],this.index+=2}writeUint32(t){const e=this.index,i=this.uint8array;C(P,t),i[e]=P[0],i[e+1]=P[1],i[e+2]=P[2],i[e+3]=P[3],this.index+=4}writeFloat32(t){const e=this.index,i=this.uint8array;R(P,t),i[e]=P[0],i[e+1]=P[1],i[e+2]=P[2],i[e+3]=P[3],this.index+=4}writeFloat64(t){const e=this.index,i=this.uint8array;B(P,t),i[e]=P[0],i[e+1]=P[1],i[e+2]=P[2],i[e+3]=P[3],i[e+4]=P[4],i[e+5]=P[5],i[e+6]=P[6],i[e+7]=P[7],this.index+=8}writeInt8Array(t){const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++)i[e+n]=I(t[n]);this.index+=t.byteLength}writeInt16Array(t){const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+2*n;k(P,t[n]),i[s]=P[0],i[s+1]=P[1]}this.index+=t.byteLength}writeInt32Array(t){const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+4*n;L(P,t[n]),i[s]=P[0],i[s+1]=P[1],i[s+2]=P[2],i[s+3]=P[3]}this.index+=t.byteLength}writeUint8Array(t){const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++)i[e+n]=t[n];this.index+=t.byteLength}writeUint16Array(t){const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+2*n;M(P,t[n]),i[s]=P[0],i[s+1]=P[1]}this.index+=t.byteLength}writeUint32Array(t){const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+4*n;C(P,t[n]),i[s]=P[0],i[s+1]=P[1],i[s+2]=P[2],i[s+3]=P[3]}this.index+=t.byteLength}writeFloat32Array(t){const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+4*n;R(P,t[n]),i[s]=P[0],i[s+1]=P[1],i[s+2]=P[2],i[s+3]=P[3]}this.index+=t.byteLength}writeFloat64Array(t){const e=this.index,i=this.uint8array;for(let n=0,s=t.length;n<s;n++){const s=e+8*n;B(P,t[n]),i[s]=P[0],i[s+1]=P[1],i[s+2]=P[2],i[s+3]=P[3],i[s+4]=P[4],i[s+5]=P[5],i[s+6]=P[6],i[s+7]=P[7]}this.index+=t.byteLength}}function N(t,e){return t+Math.random()*(e-t)}function D(t){return 0!==t&&0==(t&t-1)}class O{constructor(){this.offset=0,this.compressedSize=0,this.normalSize=0,this.flags=0}load(t){this.offset=t[0],this.compressedSize=t[1],this.normalSize=t[2],this.flags=t[3]}save(t){t[0]=this.offset,t[1]=this.compressedSize,t[2]=this.normalSize,t[3]=this.flags}}const V=3283040112,G=4294967294,j=4294967295,K=3968054179,$=65536,z=131072,q=16777216,H=2147483648;class X{constructor(t){this.c=t,this.entries=[]}add(t){const e=new O;return e.normalSize=t.byteLength,this.entries.push(e),e}clear(){this.entries.length=0}addEmpties(t){for(let e=0;e<t;e++)this.entries.push(new O)}load(t){const e=t.byteLength/16,i=new Uint32Array(this.c.decryptBlock(t,K).buffer);let n=0;this.clear(),this.addEmpties(e);for(const t of this.entries)t.load(i.subarray(n,n+4)),n+=4}save(t){const e=new Uint32Array(4*this.entries.length);let i=0;for(const t of this.entries)t.save(e.subarray(i,i+4)),i+=4;const n=new Uint8Array(e.buffer);this.c.encryptBlock(n,K),t.set(n)}}const W=new Uint8Array(4),Y=new Uint32Array(W.buffer);class Z{constructor(){this.cryptTable=new Uint32Array(1280);let t=1048577,e=0,i=0;for(let n=0;n<256;n++)for(let s=n,r=0;r<5;r+=1,s+=256)t=(125*t+3)%2796203,e=(65535&t)<<16,t=(125*t+3)%2796203,i=65535&t,this.cryptTable[s]=e|i}hash(t,e){const i=this.cryptTable;let n=2146271213,s=4008636142;t=t.toUpperCase();for(let r=0;r<t.length;r++){const a=t.charCodeAt(r);n=i[(e<<8)+a]^n+s,s=a+n+s+(s<<5)+3}return n>>>0}decryptBlock(t,e){const i=this.cryptTable;let n=4008636142;const s=new Uint8Array(t.buffer,t.byteOffset,t.byteLength);for(let r=0,a=t.byteLength>>>2;r<a;r++)n+=i[1024+(255&e)],W[0]=s[4*r],W[1]=s[4*r+1],W[2]=s[4*r+2],W[3]=s[4*r+3],Y[0]^=e+n,e=286331153+(~e<<21)|e>>>11,n=Y[0]+n+(n<<5)+3,s[4*r]=W[0],s[4*r+1]=W[1],s[4*r+2]=W[2],s[4*r+3]=W[3];return t}encryptBlock(t,e){const i=this.cryptTable;let n=4008636142;const s=new Uint8Array(t.buffer,t.byteOffset,t.byteLength);for(let r=0,a=t.byteLength>>>2;r<a;r++){n+=i[1024+(255&e)],W[0]=s[4*r],W[1]=s[4*r+1],W[2]=s[4*r+2],W[3]=s[4*r+3];const t=Y[0];Y[0]^=e+n,e=286331153+(~e<<21)|e>>>11,n=t+n+(n<<5)+3,s[4*r]=W[0],s[4*r+1]=W[1],s[4*r+2]=W[2],s[4*r+3]=W[3]}return t}computeFileKey(t,e){const i=t.lastIndexOf("\\"),n=t.substring(i+1);let s=this.hash(n,3);return e.flags&z&&(s=s+e.offset^e.normalSize),s}}function Q(t){let e=t.length;for(;--e>=0;)t[e]=0}const J=256,tt=286,et=30,it=15,nt=new Uint8Array([0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0]),st=new Uint8Array([0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13]),rt=new Uint8Array([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7]),at=new Uint8Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]),ot=new Array(576);Q(ot);const lt=new Array(60);Q(lt);const ht=new Array(512);Q(ht);const ct=new Array(256);Q(ct);const dt=new Array(29);Q(dt);const ut=new Array(et);function ft(t,e,i,n,s){this.static_tree=t,this.extra_bits=e,this.extra_base=i,this.elems=n,this.max_length=s,this.has_stree=t&&t.length}let mt,gt,pt;function wt(t,e){this.dyn_tree=t,this.max_code=0,this.stat_desc=e}Q(ut);const bt=t=>t<256?ht[t]:ht[256+(t>>>7)],vt=(t,e)=>{t.pending_buf[t.pending++]=255&e,t.pending_buf[t.pending++]=e>>>8&255},yt=(t,e,i)=>{t.bi_valid>16-i?(t.bi_buf|=e<<t.bi_valid&65535,vt(t,t.bi_buf),t.bi_buf=e>>16-t.bi_valid,t.bi_valid+=i-16):(t.bi_buf|=e<<t.bi_valid&65535,t.bi_valid+=i)},_t=(t,e,i)=>{yt(t,i[2*e],i[2*e+1])},xt=(t,e)=>{let i=0;do{i|=1&t,t>>>=1,i<<=1}while(--e>0);return i>>>1},At=(t,e,i)=>{const n=new Array(16);let s,r,a=0;for(s=1;s<=it;s++)n[s]=a=a+i[s-1]<<1;for(r=0;r<=e;r++){let e=t[2*r+1];0!==e&&(t[2*r]=xt(n[e]++,e))}},Tt=t=>{let e;for(e=0;e<tt;e++)t.dyn_ltree[2*e]=0;for(e=0;e<et;e++)t.dyn_dtree[2*e]=0;for(e=0;e<19;e++)t.bl_tree[2*e]=0;t.dyn_ltree[512]=1,t.opt_len=t.static_len=0,t.last_lit=t.matches=0},Et=t=>{t.bi_valid>8?vt(t,t.bi_buf):t.bi_valid>0&&(t.pending_buf[t.pending++]=t.bi_buf),t.bi_buf=0,t.bi_valid=0},St=(t,e,i,n)=>{const s=2*e,r=2*i;return t[s]<t[r]||t[s]===t[r]&&n[e]<=n[i]},It=(t,e,i)=>{const n=t.heap[i];let s=i<<1;for(;s<=t.heap_len&&(s<t.heap_len&&St(e,t.heap[s+1],t.heap[s],t.depth)&&s++,!St(e,n,t.heap[s],t.depth));)t.heap[i]=t.heap[s],i=s,s<<=1;t.heap[i]=n},kt=(t,e,i)=>{let n,s,r,a,o=0;if(0!==t.last_lit)do{n=t.pending_buf[t.d_buf+2*o]<<8|t.pending_buf[t.d_buf+2*o+1],s=t.pending_buf[t.l_buf+o],o++,0===n?_t(t,s,e):(r=ct[s],_t(t,r+J+1,e),a=nt[r],0!==a&&(s-=dt[r],yt(t,s,a)),n--,r=bt(n),_t(t,r,i),a=st[r],0!==a&&(n-=ut[r],yt(t,n,a)))}while(o<t.last_lit);_t(t,256,e)},Lt=(t,e)=>{const i=e.dyn_tree,n=e.stat_desc.static_tree,s=e.stat_desc.has_stree,r=e.stat_desc.elems;let a,o,l,h=-1;for(t.heap_len=0,t.heap_max=573,a=0;a<r;a++)0!==i[2*a]?(t.heap[++t.heap_len]=h=a,t.depth[a]=0):i[2*a+1]=0;for(;t.heap_len<2;)l=t.heap[++t.heap_len]=h<2?++h:0,i[2*l]=1,t.depth[l]=0,t.opt_len--,s&&(t.static_len-=n[2*l+1]);for(e.max_code=h,a=t.heap_len>>1;a>=1;a--)It(t,i,a);l=r;do{a=t.heap[1],t.heap[1]=t.heap[t.heap_len--],It(t,i,1),o=t.heap[1],t.heap[--t.heap_max]=a,t.heap[--t.heap_max]=o,i[2*l]=i[2*a]+i[2*o],t.depth[l]=(t.depth[a]>=t.depth[o]?t.depth[a]:t.depth[o])+1,i[2*a+1]=i[2*o+1]=l,t.heap[1]=l++,It(t,i,1)}while(t.heap_len>=2);t.heap[--t.heap_max]=t.heap[1],((t,e)=>{const i=e.dyn_tree,n=e.max_code,s=e.stat_desc.static_tree,r=e.stat_desc.has_stree,a=e.stat_desc.extra_bits,o=e.stat_desc.extra_base,l=e.stat_desc.max_length;let h,c,d,u,f,m,g=0;for(u=0;u<=it;u++)t.bl_count[u]=0;for(i[2*t.heap[t.heap_max]+1]=0,h=t.heap_max+1;h<573;h++)c=t.heap[h],u=i[2*i[2*c+1]+1]+1,u>l&&(u=l,g++),i[2*c+1]=u,c>n||(t.bl_count[u]++,f=0,c>=o&&(f=a[c-o]),m=i[2*c],t.opt_len+=m*(u+f),r&&(t.static_len+=m*(s[2*c+1]+f)));if(0!==g){do{for(u=l-1;0===t.bl_count[u];)u--;t.bl_count[u]--,t.bl_count[u+1]+=2,t.bl_count[l]--,g-=2}while(g>0);for(u=l;0!==u;u--)for(c=t.bl_count[u];0!==c;)d=t.heap[--h],d>n||(i[2*d+1]!==u&&(t.opt_len+=(u-i[2*d+1])*i[2*d],i[2*d+1]=u),c--)}})(t,e),At(i,h,t.bl_count)},Mt=(t,e,i)=>{let n,s,r=-1,a=e[1],o=0,l=7,h=4;for(0===a&&(l=138,h=3),e[2*(i+1)+1]=65535,n=0;n<=i;n++)s=a,a=e[2*(n+1)+1],++o<l&&s===a||(o<h?t.bl_tree[2*s]+=o:0!==s?(s!==r&&t.bl_tree[2*s]++,t.bl_tree[32]++):o<=10?t.bl_tree[34]++:t.bl_tree[36]++,o=0,r=s,0===a?(l=138,h=3):s===a?(l=6,h=3):(l=7,h=4))},Ct=(t,e,i)=>{let n,s,r=-1,a=e[1],o=0,l=7,h=4;for(0===a&&(l=138,h=3),n=0;n<=i;n++)if(s=a,a=e[2*(n+1)+1],!(++o<l&&s===a)){if(o<h)do{_t(t,s,t.bl_tree)}while(0!=--o);else 0!==s?(s!==r&&(_t(t,s,t.bl_tree),o--),_t(t,16,t.bl_tree),yt(t,o-3,2)):o<=10?(_t(t,17,t.bl_tree),yt(t,o-3,3)):(_t(t,18,t.bl_tree),yt(t,o-11,7));o=0,r=s,0===a?(l=138,h=3):s===a?(l=6,h=3):(l=7,h=4)}};let Rt=!1;const Bt=(t,e,i,n)=>{yt(t,0+(n?1:0),3),((t,e,i,n)=>{Et(t),n&&(vt(t,i),vt(t,~i)),t.pending_buf.set(t.window.subarray(e,e+i),t.pending),t.pending+=i})(t,e,i,!0)};var Ut=t=>{Rt||((()=>{let t,e,i,n,s;const r=new Array(16);for(i=0,n=0;n<28;n++)for(dt[n]=i,t=0;t<1<<nt[n];t++)ct[i++]=n;for(ct[i-1]=n,s=0,n=0;n<16;n++)for(ut[n]=s,t=0;t<1<<st[n];t++)ht[s++]=n;for(s>>=7;n<et;n++)for(ut[n]=s<<7,t=0;t<1<<st[n]-7;t++)ht[256+s++]=n;for(e=0;e<=it;e++)r[e]=0;for(t=0;t<=143;)ot[2*t+1]=8,t++,r[8]++;for(;t<=255;)ot[2*t+1]=9,t++,r[9]++;for(;t<=279;)ot[2*t+1]=7,t++,r[7]++;for(;t<=287;)ot[2*t+1]=8,t++,r[8]++;for(At(ot,287,r),t=0;t<et;t++)lt[2*t+1]=5,lt[2*t]=xt(t,5);mt=new ft(ot,nt,257,tt,it),gt=new ft(lt,st,0,et,it),pt=new ft(new Array(0),rt,0,19,7)})(),Rt=!0),t.l_desc=new wt(t.dyn_ltree,mt),t.d_desc=new wt(t.dyn_dtree,gt),t.bl_desc=new wt(t.bl_tree,pt),t.bi_buf=0,t.bi_valid=0,Tt(t)},Pt=(t,e,i,n)=>{let s,r,a=0;t.level>0?(2===t.strm.data_type&&(t.strm.data_type=(t=>{let e,i=4093624447;for(e=0;e<=31;e++,i>>>=1)if(1&i&&0!==t.dyn_ltree[2*e])return 0;if(0!==t.dyn_ltree[18]||0!==t.dyn_ltree[20]||0!==t.dyn_ltree[26])return 1;for(e=32;e<J;e++)if(0!==t.dyn_ltree[2*e])return 1;return 0})(t)),Lt(t,t.l_desc),Lt(t,t.d_desc),a=(t=>{let e;for(Mt(t,t.dyn_ltree,t.l_desc.max_code),Mt(t,t.dyn_dtree,t.d_desc.max_code),Lt(t,t.bl_desc),e=18;e>=3&&0===t.bl_tree[2*at[e]+1];e--);return t.opt_len+=3*(e+1)+5+5+4,e})(t),s=t.opt_len+3+7>>>3,r=t.static_len+3+7>>>3,r<=s&&(s=r)):s=r=i+5,i+4<=s&&-1!==e?Bt(t,e,i,n):4===t.strategy||r===s?(yt(t,2+(n?1:0),3),kt(t,ot,lt)):(yt(t,4+(n?1:0),3),((t,e,i,n)=>{let s;for(yt(t,e-257,5),yt(t,i-1,5),yt(t,n-4,4),s=0;s<n;s++)yt(t,t.bl_tree[2*at[s]+1],3);Ct(t,t.dyn_ltree,e-1),Ct(t,t.dyn_dtree,i-1)})(t,t.l_desc.max_code+1,t.d_desc.max_code+1,a+1),kt(t,t.dyn_ltree,t.dyn_dtree)),Tt(t),n&&Et(t)},Ft=(t,e,i)=>(t.pending_buf[t.d_buf+2*t.last_lit]=e>>>8&255,t.pending_buf[t.d_buf+2*t.last_lit+1]=255&e,t.pending_buf[t.l_buf+t.last_lit]=255&i,t.last_lit++,0===e?t.dyn_ltree[2*i]++:(t.matches++,e--,t.dyn_ltree[2*(ct[i]+J+1)]++,t.dyn_dtree[2*bt(e)]++),t.last_lit===t.lit_bufsize-1),Nt=t=>{yt(t,2,3),_t(t,256,ot),(t=>{16===t.bi_valid?(vt(t,t.bi_buf),t.bi_buf=0,t.bi_valid=0):t.bi_valid>=8&&(t.pending_buf[t.pending++]=255&t.bi_buf,t.bi_buf>>=8,t.bi_valid-=8)})(t)},Dt={_tr_init:Ut,_tr_stored_block:Bt,_tr_flush_block:Pt,_tr_tally:Ft,_tr_align:Nt};var Ot=(t,e,i,n)=>{let s=65535&t|0,r=t>>>16&65535|0,a=0;for(;0!==i;){a=i>2e3?2e3:i,i-=a;do{s=s+e[n++]|0,r=r+s|0}while(--a);s%=65521,r%=65521}return s|r<<16|0};const Vt=new Uint32Array((()=>{let t,e=[];for(var i=0;i<256;i++){t=i;for(var n=0;n<8;n++)t=1&t?3988292384^t>>>1:t>>>1;e[i]=t}return e})());var Gt=(t,e,i,n)=>{const s=Vt,r=n+i;t^=-1;for(let i=n;i<r;i++)t=t>>>8^s[255&(t^e[i])];return-1^t},jt={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"},Kt={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_MEM_ERROR:-4,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8};const{_tr_init:$t,_tr_stored_block:zt,_tr_flush_block:qt,_tr_tally:Ht,_tr_align:Xt}=Dt,{Z_NO_FLUSH:Wt,Z_PARTIAL_FLUSH:Yt,Z_FULL_FLUSH:Zt,Z_FINISH:Qt,Z_BLOCK:Jt,Z_OK:te,Z_STREAM_END:ee,Z_STREAM_ERROR:ie,Z_DATA_ERROR:ne,Z_BUF_ERROR:se,Z_DEFAULT_COMPRESSION:re,Z_FILTERED:ae,Z_HUFFMAN_ONLY:oe,Z_RLE:le,Z_FIXED:he,Z_DEFAULT_STRATEGY:ce,Z_UNKNOWN:de,Z_DEFLATED:ue}=Kt,fe=258,me=262,ge=103,pe=113,we=666,be=(t,e)=>(t.msg=jt[e],e),ve=t=>(t<<1)-(t>4?9:0),ye=t=>{let e=t.length;for(;--e>=0;)t[e]=0};let _e=(t,e,i)=>(e<<t.hash_shift^i)&t.hash_mask;const xe=t=>{const e=t.state;let i=e.pending;i>t.avail_out&&(i=t.avail_out),0!==i&&(t.output.set(e.pending_buf.subarray(e.pending_out,e.pending_out+i),t.next_out),t.next_out+=i,e.pending_out+=i,t.total_out+=i,t.avail_out-=i,e.pending-=i,0===e.pending&&(e.pending_out=0))},Ae=(t,e)=>{qt(t,t.block_start>=0?t.block_start:-1,t.strstart-t.block_start,e),t.block_start=t.strstart,xe(t.strm)},Te=(t,e)=>{t.pending_buf[t.pending++]=e},Ee=(t,e)=>{t.pending_buf[t.pending++]=e>>>8&255,t.pending_buf[t.pending++]=255&e},Se=(t,e,i,n)=>{let s=t.avail_in;return s>n&&(s=n),0===s?0:(t.avail_in-=s,e.set(t.input.subarray(t.next_in,t.next_in+s),i),1===t.state.wrap?t.adler=Ot(t.adler,e,s,i):2===t.state.wrap&&(t.adler=Gt(t.adler,e,s,i)),t.next_in+=s,t.total_in+=s,s)},Ie=(t,e)=>{let i,n,s=t.max_chain_length,r=t.strstart,a=t.prev_length,o=t.nice_match;const l=t.strstart>t.w_size-me?t.strstart-(t.w_size-me):0,h=t.window,c=t.w_mask,d=t.prev,u=t.strstart+fe;let f=h[r+a-1],m=h[r+a];t.prev_length>=t.good_match&&(s>>=2),o>t.lookahead&&(o=t.lookahead);do{if(i=e,h[i+a]===m&&h[i+a-1]===f&&h[i]===h[r]&&h[++i]===h[r+1]){r+=2,i++;do{}while(h[++r]===h[++i]&&h[++r]===h[++i]&&h[++r]===h[++i]&&h[++r]===h[++i]&&h[++r]===h[++i]&&h[++r]===h[++i]&&h[++r]===h[++i]&&h[++r]===h[++i]&&r<u);if(n=fe-(u-r),r=u-fe,n>a){if(t.match_start=e,a=n,n>=o)break;f=h[r+a-1],m=h[r+a]}}}while((e=d[e&c])>l&&0!=--s);return a<=t.lookahead?a:t.lookahead},ke=t=>{const e=t.w_size;let i,n,s,r,a;do{if(r=t.window_size-t.lookahead-t.strstart,t.strstart>=e+(e-me)){t.window.set(t.window.subarray(e,e+e),0),t.match_start-=e,t.strstart-=e,t.block_start-=e,n=t.hash_size,i=n;do{s=t.head[--i],t.head[i]=s>=e?s-e:0}while(--n);n=e,i=n;do{s=t.prev[--i],t.prev[i]=s>=e?s-e:0}while(--n);r+=e}if(0===t.strm.avail_in)break;if(n=Se(t.strm,t.window,t.strstart+t.lookahead,r),t.lookahead+=n,t.lookahead+t.insert>=3)for(a=t.strstart-t.insert,t.ins_h=t.window[a],t.ins_h=_e(t,t.ins_h,t.window[a+1]);t.insert&&(t.ins_h=_e(t,t.ins_h,t.window[a+3-1]),t.prev[a&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=a,a++,t.insert--,!(t.lookahead+t.insert<3)););}while(t.lookahead<me&&0!==t.strm.avail_in)},Le=(t,e)=>{let i,n;for(;;){if(t.lookahead<me){if(ke(t),t.lookahead<me&&e===Wt)return 1;if(0===t.lookahead)break}if(i=0,t.lookahead>=3&&(t.ins_h=_e(t,t.ins_h,t.window[t.strstart+3-1]),i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart),0!==i&&t.strstart-i<=t.w_size-me&&(t.match_length=Ie(t,i)),t.match_length>=3)if(n=Ht(t,t.strstart-t.match_start,t.match_length-3),t.lookahead-=t.match_length,t.match_length<=t.max_lazy_match&&t.lookahead>=3){t.match_length--;do{t.strstart++,t.ins_h=_e(t,t.ins_h,t.window[t.strstart+3-1]),i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart}while(0!=--t.match_length);t.strstart++}else t.strstart+=t.match_length,t.match_length=0,t.ins_h=t.window[t.strstart],t.ins_h=_e(t,t.ins_h,t.window[t.strstart+1]);else n=Ht(t,0,t.window[t.strstart]),t.lookahead--,t.strstart++;if(n&&(Ae(t,!1),0===t.strm.avail_out))return 1}return t.insert=t.strstart<2?t.strstart:2,e===Qt?(Ae(t,!0),0===t.strm.avail_out?3:4):t.last_lit&&(Ae(t,!1),0===t.strm.avail_out)?1:2},Me=(t,e)=>{let i,n,s;for(;;){if(t.lookahead<me){if(ke(t),t.lookahead<me&&e===Wt)return 1;if(0===t.lookahead)break}if(i=0,t.lookahead>=3&&(t.ins_h=_e(t,t.ins_h,t.window[t.strstart+3-1]),i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart),t.prev_length=t.match_length,t.prev_match=t.match_start,t.match_length=2,0!==i&&t.prev_length<t.max_lazy_match&&t.strstart-i<=t.w_size-me&&(t.match_length=Ie(t,i),t.match_length<=5&&(t.strategy===ae||3===t.match_length&&t.strstart-t.match_start>4096)&&(t.match_length=2)),t.prev_length>=3&&t.match_length<=t.prev_length){s=t.strstart+t.lookahead-3,n=Ht(t,t.strstart-1-t.prev_match,t.prev_length-3),t.lookahead-=t.prev_length-1,t.prev_length-=2;do{++t.strstart<=s&&(t.ins_h=_e(t,t.ins_h,t.window[t.strstart+3-1]),i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart)}while(0!=--t.prev_length);if(t.match_available=0,t.match_length=2,t.strstart++,n&&(Ae(t,!1),0===t.strm.avail_out))return 1}else if(t.match_available){if(n=Ht(t,0,t.window[t.strstart-1]),n&&Ae(t,!1),t.strstart++,t.lookahead--,0===t.strm.avail_out)return 1}else t.match_available=1,t.strstart++,t.lookahead--}return t.match_available&&(n=Ht(t,0,t.window[t.strstart-1]),t.match_available=0),t.insert=t.strstart<2?t.strstart:2,e===Qt?(Ae(t,!0),0===t.strm.avail_out?3:4):t.last_lit&&(Ae(t,!1),0===t.strm.avail_out)?1:2};function Ce(t,e,i,n,s){this.good_length=t,this.max_lazy=e,this.nice_length=i,this.max_chain=n,this.func=s}const Re=[new Ce(0,0,0,0,((t,e)=>{let i=65535;for(i>t.pending_buf_size-5&&(i=t.pending_buf_size-5);;){if(t.lookahead<=1){if(ke(t),0===t.lookahead&&e===Wt)return 1;if(0===t.lookahead)break}t.strstart+=t.lookahead,t.lookahead=0;const n=t.block_start+i;if((0===t.strstart||t.strstart>=n)&&(t.lookahead=t.strstart-n,t.strstart=n,Ae(t,!1),0===t.strm.avail_out))return 1;if(t.strstart-t.block_start>=t.w_size-me&&(Ae(t,!1),0===t.strm.avail_out))return 1}return t.insert=0,e===Qt?(Ae(t,!0),0===t.strm.avail_out?3:4):(t.strstart>t.block_start&&(Ae(t,!1),t.strm.avail_out),1)})),new Ce(4,4,8,4,Le),new Ce(4,5,16,8,Le),new Ce(4,6,32,32,Le),new Ce(4,4,16,16,Me),new Ce(8,16,32,32,Me),new Ce(8,16,128,128,Me),new Ce(8,32,128,256,Me),new Ce(32,128,258,1024,Me),new Ce(32,258,258,4096,Me)];function Be(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=ue,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new Uint16Array(1146),this.dyn_dtree=new Uint16Array(122),this.bl_tree=new Uint16Array(78),ye(this.dyn_ltree),ye(this.dyn_dtree),ye(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new Uint16Array(16),this.heap=new Uint16Array(573),ye(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new Uint16Array(573),ye(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0}const Ue=t=>{if(!t||!t.state)return be(t,ie);t.total_in=t.total_out=0,t.data_type=de;const e=t.state;return e.pending=0,e.pending_out=0,e.wrap<0&&(e.wrap=-e.wrap),e.status=e.wrap?42:pe,t.adler=2===e.wrap?0:1,e.last_flush=Wt,$t(e),te},Pe=t=>{const e=Ue(t);return e===te&&(t=>{t.window_size=2*t.w_size,ye(t.head),t.max_lazy_match=Re[t.level].max_lazy,t.good_match=Re[t.level].good_length,t.nice_match=Re[t.level].nice_length,t.max_chain_length=Re[t.level].max_chain,t.strstart=0,t.block_start=0,t.lookahead=0,t.insert=0,t.match_length=t.prev_length=2,t.match_available=0,t.ins_h=0})(t.state),e},Fe=(t,e,i,n,s,r)=>{if(!t)return ie;let a=1;if(e===re&&(e=6),n<0?(a=0,n=-n):n>15&&(a=2,n-=16),s<1||s>9||i!==ue||n<8||n>15||e<0||e>9||r<0||r>he)return be(t,ie);8===n&&(n=9);const o=new Be;return t.state=o,o.strm=t,o.wrap=a,o.gzhead=null,o.w_bits=n,o.w_size=1<<o.w_bits,o.w_mask=o.w_size-1,o.hash_bits=s+7,o.hash_size=1<<o.hash_bits,o.hash_mask=o.hash_size-1,o.hash_shift=~~((o.hash_bits+3-1)/3),o.window=new Uint8Array(2*o.w_size),o.head=new Uint16Array(o.hash_size),o.prev=new Uint16Array(o.w_size),o.lit_bufsize=1<<s+6,o.pending_buf_size=4*o.lit_bufsize,o.pending_buf=new Uint8Array(o.pending_buf_size),o.d_buf=1*o.lit_bufsize,o.l_buf=3*o.lit_bufsize,o.level=e,o.strategy=r,o.method=i,Pe(t)};var Ne=(t,e)=>{let i,n;if(!t||!t.state||e>Jt||e<0)return t?be(t,ie):ie;const s=t.state;if(!t.output||!t.input&&0!==t.avail_in||s.status===we&&e!==Qt)return be(t,0===t.avail_out?se:ie);s.strm=t;const r=s.last_flush;if(s.last_flush=e,42===s.status)if(2===s.wrap)t.adler=0,Te(s,31),Te(s,139),Te(s,8),s.gzhead?(Te(s,(s.gzhead.text?1:0)+(s.gzhead.hcrc?2:0)+(s.gzhead.extra?4:0)+(s.gzhead.name?8:0)+(s.gzhead.comment?16:0)),Te(s,255&s.gzhead.time),Te(s,s.gzhead.time>>8&255),Te(s,s.gzhead.time>>16&255),Te(s,s.gzhead.time>>24&255),Te(s,9===s.level?2:s.strategy>=oe||s.level<2?4:0),Te(s,255&s.gzhead.os),s.gzhead.extra&&s.gzhead.extra.length&&(Te(s,255&s.gzhead.extra.length),Te(s,s.gzhead.extra.length>>8&255)),s.gzhead.hcrc&&(t.adler=Gt(t.adler,s.pending_buf,s.pending,0)),s.gzindex=0,s.status=69):(Te(s,0),Te(s,0),Te(s,0),Te(s,0),Te(s,0),Te(s,9===s.level?2:s.strategy>=oe||s.level<2?4:0),Te(s,3),s.status=pe);else{let e=ue+(s.w_bits-8<<4)<<8,i=-1;i=s.strategy>=oe||s.level<2?0:s.level<6?1:6===s.level?2:3,e|=i<<6,0!==s.strstart&&(e|=32),e+=31-e%31,s.status=pe,Ee(s,e),0!==s.strstart&&(Ee(s,t.adler>>>16),Ee(s,65535&t.adler)),t.adler=1}if(69===s.status)if(s.gzhead.extra){for(i=s.pending;s.gzindex<(65535&s.gzhead.extra.length)&&(s.pending!==s.pending_buf_size||(s.gzhead.hcrc&&s.pending>i&&(t.adler=Gt(t.adler,s.pending_buf,s.pending-i,i)),xe(t),i=s.pending,s.pending!==s.pending_buf_size));)Te(s,255&s.gzhead.extra[s.gzindex]),s.gzindex++;s.gzhead.hcrc&&s.pending>i&&(t.adler=Gt(t.adler,s.pending_buf,s.pending-i,i)),s.gzindex===s.gzhead.extra.length&&(s.gzindex=0,s.status=73)}else s.status=73;if(73===s.status)if(s.gzhead.name){i=s.pending;do{if(s.pending===s.pending_buf_size&&(s.gzhead.hcrc&&s.pending>i&&(t.adler=Gt(t.adler,s.pending_buf,s.pending-i,i)),xe(t),i=s.pending,s.pending===s.pending_buf_size)){n=1;break}n=s.gzindex<s.gzhead.name.length?255&s.gzhead.name.charCodeAt(s.gzindex++):0,Te(s,n)}while(0!==n);s.gzhead.hcrc&&s.pending>i&&(t.adler=Gt(t.adler,s.pending_buf,s.pending-i,i)),0===n&&(s.gzindex=0,s.status=91)}else s.status=91;if(91===s.status)if(s.gzhead.comment){i=s.pending;do{if(s.pending===s.pending_buf_size&&(s.gzhead.hcrc&&s.pending>i&&(t.adler=Gt(t.adler,s.pending_buf,s.pending-i,i)),xe(t),i=s.pending,s.pending===s.pending_buf_size)){n=1;break}n=s.gzindex<s.gzhead.comment.length?255&s.gzhead.comment.charCodeAt(s.gzindex++):0,Te(s,n)}while(0!==n);s.gzhead.hcrc&&s.pending>i&&(t.adler=Gt(t.adler,s.pending_buf,s.pending-i,i)),0===n&&(s.status=ge)}else s.status=ge;if(s.status===ge&&(s.gzhead.hcrc?(s.pending+2>s.pending_buf_size&&xe(t),s.pending+2<=s.pending_buf_size&&(Te(s,255&t.adler),Te(s,t.adler>>8&255),t.adler=0,s.status=pe)):s.status=pe),0!==s.pending){if(xe(t),0===t.avail_out)return s.last_flush=-1,te}else if(0===t.avail_in&&ve(e)<=ve(r)&&e!==Qt)return be(t,se);if(s.status===we&&0!==t.avail_in)return be(t,se);if(0!==t.avail_in||0!==s.lookahead||e!==Wt&&s.status!==we){let i=s.strategy===oe?((t,e)=>{let i;for(;;){if(0===t.lookahead&&(ke(t),0===t.lookahead)){if(e===Wt)return 1;break}if(t.match_length=0,i=Ht(t,0,t.window[t.strstart]),t.lookahead--,t.strstart++,i&&(Ae(t,!1),0===t.strm.avail_out))return 1}return t.insert=0,e===Qt?(Ae(t,!0),0===t.strm.avail_out?3:4):t.last_lit&&(Ae(t,!1),0===t.strm.avail_out)?1:2})(s,e):s.strategy===le?((t,e)=>{let i,n,s,r;const a=t.window;for(;;){if(t.lookahead<=fe){if(ke(t),t.lookahead<=fe&&e===Wt)return 1;if(0===t.lookahead)break}if(t.match_length=0,t.lookahead>=3&&t.strstart>0&&(s=t.strstart-1,n=a[s],n===a[++s]&&n===a[++s]&&n===a[++s])){r=t.strstart+fe;do{}while(n===a[++s]&&n===a[++s]&&n===a[++s]&&n===a[++s]&&n===a[++s]&&n===a[++s]&&n===a[++s]&&n===a[++s]&&s<r);t.match_length=fe-(r-s),t.match_length>t.lookahead&&(t.match_length=t.lookahead)}if(t.match_length>=3?(i=Ht(t,1,t.match_length-3),t.lookahead-=t.match_length,t.strstart+=t.match_length,t.match_length=0):(i=Ht(t,0,t.window[t.strstart]),t.lookahead--,t.strstart++),i&&(Ae(t,!1),0===t.strm.avail_out))return 1}return t.insert=0,e===Qt?(Ae(t,!0),0===t.strm.avail_out?3:4):t.last_lit&&(Ae(t,!1),0===t.strm.avail_out)?1:2})(s,e):Re[s.level].func(s,e);if(3!==i&&4!==i||(s.status=we),1===i||3===i)return 0===t.avail_out&&(s.last_flush=-1),te;if(2===i&&(e===Yt?Xt(s):e!==Jt&&(zt(s,0,0,!1),e===Zt&&(ye(s.head),0===s.lookahead&&(s.strstart=0,s.block_start=0,s.insert=0))),xe(t),0===t.avail_out))return s.last_flush=-1,te}return e!==Qt?te:s.wrap<=0?ee:(2===s.wrap?(Te(s,255&t.adler),Te(s,t.adler>>8&255),Te(s,t.adler>>16&255),Te(s,t.adler>>24&255),Te(s,255&t.total_in),Te(s,t.total_in>>8&255),Te(s,t.total_in>>16&255),Te(s,t.total_in>>24&255)):(Ee(s,t.adler>>>16),Ee(s,65535&t.adler)),xe(t),s.wrap>0&&(s.wrap=-s.wrap),0!==s.pending?te:ee)},De=(t,e)=>{let i=e.length;if(!t||!t.state)return ie;const n=t.state,s=n.wrap;if(2===s||1===s&&42!==n.status||n.lookahead)return ie;if(1===s&&(t.adler=Ot(t.adler,e,i,0)),n.wrap=0,i>=n.w_size){0===s&&(ye(n.head),n.strstart=0,n.block_start=0,n.insert=0);let t=new Uint8Array(n.w_size);t.set(e.subarray(i-n.w_size,i),0),e=t,i=n.w_size}const r=t.avail_in,a=t.next_in,o=t.input;for(t.avail_in=i,t.next_in=0,t.input=e,ke(n);n.lookahead>=3;){let t=n.strstart,e=n.lookahead-2;do{n.ins_h=_e(n,n.ins_h,n.window[t+3-1]),n.prev[t&n.w_mask]=n.head[n.ins_h],n.head[n.ins_h]=t,t++}while(--e);n.strstart=t,n.lookahead=2,ke(n)}return n.strstart+=n.lookahead,n.block_start=n.strstart,n.insert=n.lookahead,n.lookahead=0,n.match_length=n.prev_length=2,n.match_available=0,t.next_in=a,t.input=o,t.avail_in=r,n.wrap=s,te},Oe={deflateInit:(t,e)=>Fe(t,e,ue,15,8,ce),deflateInit2:Fe,deflateReset:Pe,deflateResetKeep:Ue,deflateSetHeader:(t,e)=>t&&t.state?2!==t.state.wrap?ie:(t.state.gzhead=e,te):ie,deflate:Ne,deflateEnd:t=>{if(!t||!t.state)return ie;const e=t.state.status;return 42!==e&&69!==e&&73!==e&&91!==e&&e!==ge&&e!==pe&&e!==we?be(t,ie):(t.state=null,e===pe?be(t,ne):te)},deflateSetDictionary:De,deflateInfo:"pako deflate (from Nodeca project)"};const Ve=(t,e)=>Object.prototype.hasOwnProperty.call(t,e);var Ge=function(t){const e=Array.prototype.slice.call(arguments,1);for(;e.length;){const i=e.shift();if(i){if("object"!=typeof i)throw new TypeError(i+"must be non-object");for(const e in i)Ve(i,e)&&(t[e]=i[e])}}return t},je=t=>{let e=0;for(let i=0,n=t.length;i<n;i++)e+=t[i].length;const i=new Uint8Array(e);for(let e=0,n=0,s=t.length;e<s;e++){let s=t[e];i.set(s,n),n+=s.length}return i};let Ke=!0;try{String.fromCharCode.apply(null,new Uint8Array(1))}catch(t){Ke=!1}const $e=new Uint8Array(256);for(let t=0;t<256;t++)$e[t]=t>=252?6:t>=248?5:t>=240?4:t>=224?3:t>=192?2:1;$e[254]=$e[254]=1;var ze=t=>{if("function"==typeof TextEncoder&&TextEncoder.prototype.encode)return(new TextEncoder).encode(t);let e,i,n,s,r,a=t.length,o=0;for(s=0;s<a;s++)i=t.charCodeAt(s),55296==(64512&i)&&s+1<a&&(n=t.charCodeAt(s+1),56320==(64512&n)&&(i=65536+(i-55296<<10)+(n-56320),s++)),o+=i<128?1:i<2048?2:i<65536?3:4;for(e=new Uint8Array(o),r=0,s=0;r<o;s++)i=t.charCodeAt(s),55296==(64512&i)&&s+1<a&&(n=t.charCodeAt(s+1),56320==(64512&n)&&(i=65536+(i-55296<<10)+(n-56320),s++)),i<128?e[r++]=i:i<2048?(e[r++]=192|i>>>6,e[r++]=128|63&i):i<65536?(e[r++]=224|i>>>12,e[r++]=128|i>>>6&63,e[r++]=128|63&i):(e[r++]=240|i>>>18,e[r++]=128|i>>>12&63,e[r++]=128|i>>>6&63,e[r++]=128|63&i);return e},qe=(t,e)=>{const i=e||t.length;if("function"==typeof TextDecoder&&TextDecoder.prototype.decode)return(new TextDecoder).decode(t.subarray(0,e));let n,s;const r=new Array(2*i);for(s=0,n=0;n<i;){let e=t[n++];if(e<128){r[s++]=e;continue}let a=$e[e];if(a>4)r[s++]=65533,n+=a-1;else{for(e&=2===a?31:3===a?15:7;a>1&&n<i;)e=e<<6|63&t[n++],a--;a>1?r[s++]=65533:e<65536?r[s++]=e:(e-=65536,r[s++]=55296|e>>10&1023,r[s++]=56320|1023&e)}}return((t,e)=>{if(e<65534&&t.subarray&&Ke)return String.fromCharCode.apply(null,t.length===e?t:t.subarray(0,e));let i="";for(let n=0;n<e;n++)i+=String.fromCharCode(t[n]);return i})(r,s)},He=(t,e)=>{(e=e||t.length)>t.length&&(e=t.length);let i=e-1;for(;i>=0&&128==(192&t[i]);)i--;return i<0||0===i?e:i+$e[t[i]]>e?i:e};var Xe=function(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0};const We=Object.prototype.toString,{Z_NO_FLUSH:Ye,Z_SYNC_FLUSH:Ze,Z_FULL_FLUSH:Qe,Z_FINISH:Je,Z_OK:ti,Z_STREAM_END:ei,Z_DEFAULT_COMPRESSION:ii,Z_DEFAULT_STRATEGY:ni,Z_DEFLATED:si}=Kt;function ri(t){this.options=Ge({level:ii,method:si,chunkSize:16384,windowBits:15,memLevel:8,strategy:ni},t||{});let e=this.options;e.raw&&e.windowBits>0?e.windowBits=-e.windowBits:e.gzip&&e.windowBits>0&&e.windowBits<16&&(e.windowBits+=16),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new Xe,this.strm.avail_out=0;let i=Oe.deflateInit2(this.strm,e.level,e.method,e.windowBits,e.memLevel,e.strategy);if(i!==ti)throw new Error(jt[i]);if(e.header&&Oe.deflateSetHeader(this.strm,e.header),e.dictionary){let t;if(t="string"==typeof e.dictionary?ze(e.dictionary):"[object ArrayBuffer]"===We.call(e.dictionary)?new Uint8Array(e.dictionary):e.dictionary,i=Oe.deflateSetDictionary(this.strm,t),i!==ti)throw new Error(jt[i]);this._dict_set=!0}}function ai(t,e){const i=new ri(e);if(i.push(t,!0),i.err)throw i.msg||jt[i.err];return i.result}ri.prototype.push=function(t,e){const i=this.strm,n=this.options.chunkSize;let s,r;if(this.ended)return!1;for(r=e===~~e?e:!0===e?Je:Ye,"string"==typeof t?i.input=ze(t):"[object ArrayBuffer]"===We.call(t)?i.input=new Uint8Array(t):i.input=t,i.next_in=0,i.avail_in=i.input.length;;)if(0===i.avail_out&&(i.output=new Uint8Array(n),i.next_out=0,i.avail_out=n),(r===Ze||r===Qe)&&i.avail_out<=6)this.onData(i.output.subarray(0,i.next_out)),i.avail_out=0;else{if(s=Oe.deflate(i,r),s===ei)return i.next_out>0&&this.onData(i.output.subarray(0,i.next_out)),s=Oe.deflateEnd(this.strm),this.onEnd(s),this.ended=!0,s===ti;if(0!==i.avail_out){if(r>0&&i.next_out>0)this.onData(i.output.subarray(0,i.next_out)),i.avail_out=0;else if(0===i.avail_in)break}else this.onData(i.output)}return!0},ri.prototype.onData=function(t){this.chunks.push(t)},ri.prototype.onEnd=function(t){t===ti&&(this.result=je(this.chunks)),this.chunks=[],this.err=t,this.msg=this.strm.msg};var oi={Deflate:ri,deflate:ai,deflateRaw:function(t,e){return(e=e||{}).raw=!0,ai(t,e)},gzip:function(t,e){return(e=e||{}).gzip=!0,ai(t,e)},constants:Kt};var li=function(t,e){let i,n,s,r,a,o,l,h,c,d,u,f,m,g,p,w,b,v,y,_,x,A,T,E;const S=t.state;i=t.next_in,T=t.input,n=i+(t.avail_in-5),s=t.next_out,E=t.output,r=s-(e-t.avail_out),a=s+(t.avail_out-257),o=S.dmax,l=S.wsize,h=S.whave,c=S.wnext,d=S.window,u=S.hold,f=S.bits,m=S.lencode,g=S.distcode,p=(1<<S.lenbits)-1,w=(1<<S.distbits)-1;t:do{f<15&&(u+=T[i++]<<f,f+=8,u+=T[i++]<<f,f+=8),b=m[u&p];e:for(;;){if(v=b>>>24,u>>>=v,f-=v,v=b>>>16&255,0===v)E[s++]=65535&b;else{if(!(16&v)){if(0==(64&v)){b=m[(65535&b)+(u&(1<<v)-1)];continue e}if(32&v){S.mode=12;break t}t.msg="invalid literal/length code",S.mode=30;break t}y=65535&b,v&=15,v&&(f<v&&(u+=T[i++]<<f,f+=8),y+=u&(1<<v)-1,u>>>=v,f-=v),f<15&&(u+=T[i++]<<f,f+=8,u+=T[i++]<<f,f+=8),b=g[u&w];i:for(;;){if(v=b>>>24,u>>>=v,f-=v,v=b>>>16&255,!(16&v)){if(0==(64&v)){b=g[(65535&b)+(u&(1<<v)-1)];continue i}t.msg="invalid distance code",S.mode=30;break t}if(_=65535&b,v&=15,f<v&&(u+=T[i++]<<f,f+=8,f<v&&(u+=T[i++]<<f,f+=8)),_+=u&(1<<v)-1,_>o){t.msg="invalid distance too far back",S.mode=30;break t}if(u>>>=v,f-=v,v=s-r,_>v){if(v=_-v,v>h&&S.sane){t.msg="invalid distance too far back",S.mode=30;break t}if(x=0,A=d,0===c){if(x+=l-v,v<y){y-=v;do{E[s++]=d[x++]}while(--v);x=s-_,A=E}}else if(c<v){if(x+=l+c-v,v-=c,v<y){y-=v;do{E[s++]=d[x++]}while(--v);if(x=0,c<y){v=c,y-=v;do{E[s++]=d[x++]}while(--v);x=s-_,A=E}}}else if(x+=c-v,v<y){y-=v;do{E[s++]=d[x++]}while(--v);x=s-_,A=E}for(;y>2;)E[s++]=A[x++],E[s++]=A[x++],E[s++]=A[x++],y-=3;y&&(E[s++]=A[x++],y>1&&(E[s++]=A[x++]))}else{x=s-_;do{E[s++]=E[x++],E[s++]=E[x++],E[s++]=E[x++],y-=3}while(y>2);y&&(E[s++]=E[x++],y>1&&(E[s++]=E[x++]))}break}}break}}while(i<n&&s<a);y=f>>3,i-=y,f-=y<<3,u&=(1<<f)-1,t.next_in=i,t.next_out=s,t.avail_in=i<n?n-i+5:5-(i-n),t.avail_out=s<a?a-s+257:257-(s-a),S.hold=u,S.bits=f};const hi=15,ci=new Uint16Array([3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0]),di=new Uint8Array([16,16,16,16,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,16,72,78]),ui=new Uint16Array([1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577,0,0]),fi=new Uint8Array([16,16,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,64,64]);var mi=(t,e,i,n,s,r,a,o)=>{const l=o.bits;let h,c,d,u,f,m,g=0,p=0,w=0,b=0,v=0,y=0,_=0,x=0,A=0,T=0,E=null,S=0;const I=new Uint16Array(16),k=new Uint16Array(16);let L,M,C,R=null,B=0;for(g=0;g<=hi;g++)I[g]=0;for(p=0;p<n;p++)I[e[i+p]]++;for(v=l,b=hi;b>=1&&0===I[b];b--);if(v>b&&(v=b),0===b)return s[r++]=20971520,s[r++]=20971520,o.bits=1,0;for(w=1;w<b&&0===I[w];w++);for(v<w&&(v=w),x=1,g=1;g<=hi;g++)if(x<<=1,x-=I[g],x<0)return-1;if(x>0&&(0===t||1!==b))return-1;for(k[1]=0,g=1;g<hi;g++)k[g+1]=k[g]+I[g];for(p=0;p<n;p++)0!==e[i+p]&&(a[k[e[i+p]]++]=p);if(0===t?(E=R=a,m=19):1===t?(E=ci,S-=257,R=di,B-=257,m=256):(E=ui,R=fi,m=-1),T=0,p=0,g=w,f=r,y=v,_=0,d=-1,A=1<<v,u=A-1,1===t&&A>852||2===t&&A>592)return 1;for(;;){L=g-_,a[p]<m?(M=0,C=a[p]):a[p]>m?(M=R[B+a[p]],C=E[S+a[p]]):(M=96,C=0),h=1<<g-_,c=1<<y,w=c;do{c-=h,s[f+(T>>_)+c]=L<<24|M<<16|C|0}while(0!==c);for(h=1<<g-1;T&h;)h>>=1;if(0!==h?(T&=h-1,T+=h):T=0,p++,0==--I[g]){if(g===b)break;g=e[i+a[p]]}if(g>v&&(T&u)!==d){for(0===_&&(_=v),f+=w,y=g-_,x=1<<y;y+_<b&&(x-=I[y+_],!(x<=0));)y++,x<<=1;if(A+=1<<y,1===t&&A>852||2===t&&A>592)return 1;d=T&u,s[d]=v<<24|y<<16|f-r|0}}return 0!==T&&(s[f+T]=g-_<<24|64<<16|0),o.bits=v,0};const{Z_FINISH:gi,Z_BLOCK:pi,Z_TREES:wi,Z_OK:bi,Z_STREAM_END:vi,Z_NEED_DICT:yi,Z_STREAM_ERROR:_i,Z_DATA_ERROR:xi,Z_MEM_ERROR:Ai,Z_BUF_ERROR:Ti,Z_DEFLATED:Ei}=Kt,Si=12,Ii=30,ki=t=>(t>>>24&255)+(t>>>8&65280)+((65280&t)<<8)+((255&t)<<24);function Li(){this.mode=0,this.last=!1,this.wrap=0,this.havedict=!1,this.flags=0,this.dmax=0,this.check=0,this.total=0,this.head=null,this.wbits=0,this.wsize=0,this.whave=0,this.wnext=0,this.window=null,this.hold=0,this.bits=0,this.length=0,this.offset=0,this.extra=0,this.lencode=null,this.distcode=null,this.lenbits=0,this.distbits=0,this.ncode=0,this.nlen=0,this.ndist=0,this.have=0,this.next=null,this.lens=new Uint16Array(320),this.work=new Uint16Array(288),this.lendyn=null,this.distdyn=null,this.sane=0,this.back=0,this.was=0}const Mi=t=>{if(!t||!t.state)return _i;const e=t.state;return t.total_in=t.total_out=e.total=0,t.msg="",e.wrap&&(t.adler=1&e.wrap),e.mode=1,e.last=0,e.havedict=0,e.dmax=32768,e.head=null,e.hold=0,e.bits=0,e.lencode=e.lendyn=new Int32Array(852),e.distcode=e.distdyn=new Int32Array(592),e.sane=1,e.back=-1,bi},Ci=t=>{if(!t||!t.state)return _i;const e=t.state;return e.wsize=0,e.whave=0,e.wnext=0,Mi(t)},Ri=(t,e)=>{let i;if(!t||!t.state)return _i;const n=t.state;return e<0?(i=0,e=-e):(i=1+(e>>4),e<48&&(e&=15)),e&&(e<8||e>15)?_i:(null!==n.window&&n.wbits!==e&&(n.window=null),n.wrap=i,n.wbits=e,Ci(t))},Bi=(t,e)=>{if(!t)return _i;const i=new Li;t.state=i,i.window=null;const n=Ri(t,e);return n!==bi&&(t.state=null),n};let Ui,Pi,Fi=!0;const Ni=t=>{if(Fi){Ui=new Int32Array(512),Pi=new Int32Array(32);let e=0;for(;e<144;)t.lens[e++]=8;for(;e<256;)t.lens[e++]=9;for(;e<280;)t.lens[e++]=7;for(;e<288;)t.lens[e++]=8;for(mi(1,t.lens,0,288,Ui,0,t.work,{bits:9}),e=0;e<32;)t.lens[e++]=5;mi(2,t.lens,0,32,Pi,0,t.work,{bits:5}),Fi=!1}t.lencode=Ui,t.lenbits=9,t.distcode=Pi,t.distbits=5},Di=(t,e,i,n)=>{let s;const r=t.state;return null===r.window&&(r.wsize=1<<r.wbits,r.wnext=0,r.whave=0,r.window=new Uint8Array(r.wsize)),n>=r.wsize?(r.window.set(e.subarray(i-r.wsize,i),0),r.wnext=0,r.whave=r.wsize):(s=r.wsize-r.wnext,s>n&&(s=n),r.window.set(e.subarray(i-n,i-n+s),r.wnext),(n-=s)?(r.window.set(e.subarray(i-n,i),0),r.wnext=n,r.whave=r.wsize):(r.wnext+=s,r.wnext===r.wsize&&(r.wnext=0),r.whave<r.wsize&&(r.whave+=s))),0};var Oi=(t,e)=>{let i,n,s,r,a,o,l,h,c,d,u,f,m,g,p,w,b,v,y,_,x,A,T=0;const E=new Uint8Array(4);let S,I;const k=new Uint8Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]);if(!t||!t.state||!t.output||!t.input&&0!==t.avail_in)return _i;i=t.state,i.mode===Si&&(i.mode=13),a=t.next_out,s=t.output,l=t.avail_out,r=t.next_in,n=t.input,o=t.avail_in,h=i.hold,c=i.bits,d=o,u=l,A=bi;t:for(;;)switch(i.mode){case 1:if(0===i.wrap){i.mode=13;break}for(;c<16;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}if(2&i.wrap&&35615===h){i.check=0,E[0]=255&h,E[1]=h>>>8&255,i.check=Gt(i.check,E,2,0),h=0,c=0,i.mode=2;break}if(i.flags=0,i.head&&(i.head.done=!1),!(1&i.wrap)||(((255&h)<<8)+(h>>8))%31){t.msg="incorrect header check",i.mode=Ii;break}if((15&h)!==Ei){t.msg="unknown compression method",i.mode=Ii;break}if(h>>>=4,c-=4,x=8+(15&h),0===i.wbits)i.wbits=x;else if(x>i.wbits){t.msg="invalid window size",i.mode=Ii;break}i.dmax=1<<i.wbits,t.adler=i.check=1,i.mode=512&h?10:Si,h=0,c=0;break;case 2:for(;c<16;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}if(i.flags=h,(255&i.flags)!==Ei){t.msg="unknown compression method",i.mode=Ii;break}if(57344&i.flags){t.msg="unknown header flags set",i.mode=Ii;break}i.head&&(i.head.text=h>>8&1),512&i.flags&&(E[0]=255&h,E[1]=h>>>8&255,i.check=Gt(i.check,E,2,0)),h=0,c=0,i.mode=3;case 3:for(;c<32;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}i.head&&(i.head.time=h),512&i.flags&&(E[0]=255&h,E[1]=h>>>8&255,E[2]=h>>>16&255,E[3]=h>>>24&255,i.check=Gt(i.check,E,4,0)),h=0,c=0,i.mode=4;case 4:for(;c<16;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}i.head&&(i.head.xflags=255&h,i.head.os=h>>8),512&i.flags&&(E[0]=255&h,E[1]=h>>>8&255,i.check=Gt(i.check,E,2,0)),h=0,c=0,i.mode=5;case 5:if(1024&i.flags){for(;c<16;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}i.length=h,i.head&&(i.head.extra_len=h),512&i.flags&&(E[0]=255&h,E[1]=h>>>8&255,i.check=Gt(i.check,E,2,0)),h=0,c=0}else i.head&&(i.head.extra=null);i.mode=6;case 6:if(1024&i.flags&&(f=i.length,f>o&&(f=o),f&&(i.head&&(x=i.head.extra_len-i.length,i.head.extra||(i.head.extra=new Uint8Array(i.head.extra_len)),i.head.extra.set(n.subarray(r,r+f),x)),512&i.flags&&(i.check=Gt(i.check,n,f,r)),o-=f,r+=f,i.length-=f),i.length))break t;i.length=0,i.mode=7;case 7:if(2048&i.flags){if(0===o)break t;f=0;do{x=n[r+f++],i.head&&x&&i.length<65536&&(i.head.name+=String.fromCharCode(x))}while(x&&f<o);if(512&i.flags&&(i.check=Gt(i.check,n,f,r)),o-=f,r+=f,x)break t}else i.head&&(i.head.name=null);i.length=0,i.mode=8;case 8:if(4096&i.flags){if(0===o)break t;f=0;do{x=n[r+f++],i.head&&x&&i.length<65536&&(i.head.comment+=String.fromCharCode(x))}while(x&&f<o);if(512&i.flags&&(i.check=Gt(i.check,n,f,r)),o-=f,r+=f,x)break t}else i.head&&(i.head.comment=null);i.mode=9;case 9:if(512&i.flags){for(;c<16;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}if(h!==(65535&i.check)){t.msg="header crc mismatch",i.mode=Ii;break}h=0,c=0}i.head&&(i.head.hcrc=i.flags>>9&1,i.head.done=!0),t.adler=i.check=0,i.mode=Si;break;case 10:for(;c<32;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}t.adler=i.check=ki(h),h=0,c=0,i.mode=11;case 11:if(0===i.havedict)return t.next_out=a,t.avail_out=l,t.next_in=r,t.avail_in=o,i.hold=h,i.bits=c,yi;t.adler=i.check=1,i.mode=Si;case Si:if(e===pi||e===wi)break t;case 13:if(i.last){h>>>=7&c,c-=7&c,i.mode=27;break}for(;c<3;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}switch(i.last=1&h,h>>>=1,c-=1,3&h){case 0:i.mode=14;break;case 1:if(Ni(i),i.mode=20,e===wi){h>>>=2,c-=2;break t}break;case 2:i.mode=17;break;case 3:t.msg="invalid block type",i.mode=Ii}h>>>=2,c-=2;break;case 14:for(h>>>=7&c,c-=7&c;c<32;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}if((65535&h)!=(h>>>16^65535)){t.msg="invalid stored block lengths",i.mode=Ii;break}if(i.length=65535&h,h=0,c=0,i.mode=15,e===wi)break t;case 15:i.mode=16;case 16:if(f=i.length,f){if(f>o&&(f=o),f>l&&(f=l),0===f)break t;s.set(n.subarray(r,r+f),a),o-=f,r+=f,l-=f,a+=f,i.length-=f;break}i.mode=Si;break;case 17:for(;c<14;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}if(i.nlen=257+(31&h),h>>>=5,c-=5,i.ndist=1+(31&h),h>>>=5,c-=5,i.ncode=4+(15&h),h>>>=4,c-=4,i.nlen>286||i.ndist>30){t.msg="too many length or distance symbols",i.mode=Ii;break}i.have=0,i.mode=18;case 18:for(;i.have<i.ncode;){for(;c<3;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}i.lens[k[i.have++]]=7&h,h>>>=3,c-=3}for(;i.have<19;)i.lens[k[i.have++]]=0;if(i.lencode=i.lendyn,i.lenbits=7,S={bits:i.lenbits},A=mi(0,i.lens,0,19,i.lencode,0,i.work,S),i.lenbits=S.bits,A){t.msg="invalid code lengths set",i.mode=Ii;break}i.have=0,i.mode=19;case 19:for(;i.have<i.nlen+i.ndist;){for(;T=i.lencode[h&(1<<i.lenbits)-1],p=T>>>24,w=T>>>16&255,b=65535&T,!(p<=c);){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}if(b<16)h>>>=p,c-=p,i.lens[i.have++]=b;else{if(16===b){for(I=p+2;c<I;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}if(h>>>=p,c-=p,0===i.have){t.msg="invalid bit length repeat",i.mode=Ii;break}x=i.lens[i.have-1],f=3+(3&h),h>>>=2,c-=2}else if(17===b){for(I=p+3;c<I;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}h>>>=p,c-=p,x=0,f=3+(7&h),h>>>=3,c-=3}else{for(I=p+7;c<I;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}h>>>=p,c-=p,x=0,f=11+(127&h),h>>>=7,c-=7}if(i.have+f>i.nlen+i.ndist){t.msg="invalid bit length repeat",i.mode=Ii;break}for(;f--;)i.lens[i.have++]=x}}if(i.mode===Ii)break;if(0===i.lens[256]){t.msg="invalid code -- missing end-of-block",i.mode=Ii;break}if(i.lenbits=9,S={bits:i.lenbits},A=mi(1,i.lens,0,i.nlen,i.lencode,0,i.work,S),i.lenbits=S.bits,A){t.msg="invalid literal/lengths set",i.mode=Ii;break}if(i.distbits=6,i.distcode=i.distdyn,S={bits:i.distbits},A=mi(2,i.lens,i.nlen,i.ndist,i.distcode,0,i.work,S),i.distbits=S.bits,A){t.msg="invalid distances set",i.mode=Ii;break}if(i.mode=20,e===wi)break t;case 20:i.mode=21;case 21:if(o>=6&&l>=258){t.next_out=a,t.avail_out=l,t.next_in=r,t.avail_in=o,i.hold=h,i.bits=c,li(t,u),a=t.next_out,s=t.output,l=t.avail_out,r=t.next_in,n=t.input,o=t.avail_in,h=i.hold,c=i.bits,i.mode===Si&&(i.back=-1);break}for(i.back=0;T=i.lencode[h&(1<<i.lenbits)-1],p=T>>>24,w=T>>>16&255,b=65535&T,!(p<=c);){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}if(w&&0==(240&w)){for(v=p,y=w,_=b;T=i.lencode[_+((h&(1<<v+y)-1)>>v)],p=T>>>24,w=T>>>16&255,b=65535&T,!(v+p<=c);){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}h>>>=v,c-=v,i.back+=v}if(h>>>=p,c-=p,i.back+=p,i.length=b,0===w){i.mode=26;break}if(32&w){i.back=-1,i.mode=Si;break}if(64&w){t.msg="invalid literal/length code",i.mode=Ii;break}i.extra=15&w,i.mode=22;case 22:if(i.extra){for(I=i.extra;c<I;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}i.length+=h&(1<<i.extra)-1,h>>>=i.extra,c-=i.extra,i.back+=i.extra}i.was=i.length,i.mode=23;case 23:for(;T=i.distcode[h&(1<<i.distbits)-1],p=T>>>24,w=T>>>16&255,b=65535&T,!(p<=c);){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}if(0==(240&w)){for(v=p,y=w,_=b;T=i.distcode[_+((h&(1<<v+y)-1)>>v)],p=T>>>24,w=T>>>16&255,b=65535&T,!(v+p<=c);){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}h>>>=v,c-=v,i.back+=v}if(h>>>=p,c-=p,i.back+=p,64&w){t.msg="invalid distance code",i.mode=Ii;break}i.offset=b,i.extra=15&w,i.mode=24;case 24:if(i.extra){for(I=i.extra;c<I;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}i.offset+=h&(1<<i.extra)-1,h>>>=i.extra,c-=i.extra,i.back+=i.extra}if(i.offset>i.dmax){t.msg="invalid distance too far back",i.mode=Ii;break}i.mode=25;case 25:if(0===l)break t;if(f=u-l,i.offset>f){if(f=i.offset-f,f>i.whave&&i.sane){t.msg="invalid distance too far back",i.mode=Ii;break}f>i.wnext?(f-=i.wnext,m=i.wsize-f):m=i.wnext-f,f>i.length&&(f=i.length),g=i.window}else g=s,m=a-i.offset,f=i.length;f>l&&(f=l),l-=f,i.length-=f;do{s[a++]=g[m++]}while(--f);0===i.length&&(i.mode=21);break;case 26:if(0===l)break t;s[a++]=i.length,l--,i.mode=21;break;case 27:if(i.wrap){for(;c<32;){if(0===o)break t;o--,h|=n[r++]<<c,c+=8}if(u-=l,t.total_out+=u,i.total+=u,u&&(t.adler=i.check=i.flags?Gt(i.check,s,u,a-u):Ot(i.check,s,u,a-u)),u=l,(i.flags?h:ki(h))!==i.check){t.msg="incorrect data check",i.mode=Ii;break}h=0,c=0}i.mode=28;case 28:if(i.wrap&&i.flags){for(;c<32;){if(0===o)break t;o--,h+=n[r++]<<c,c+=8}if(h!==(4294967295&i.total)){t.msg="incorrect length check",i.mode=Ii;break}h=0,c=0}i.mode=29;case 29:A=vi;break t;case Ii:A=xi;break t;case 31:return Ai;default:return _i}return t.next_out=a,t.avail_out=l,t.next_in=r,t.avail_in=o,i.hold=h,i.bits=c,(i.wsize||u!==t.avail_out&&i.mode<Ii&&(i.mode<27||e!==gi))&&Di(t,t.output,t.next_out,u-t.avail_out),d-=t.avail_in,u-=t.avail_out,t.total_in+=d,t.total_out+=u,i.total+=u,i.wrap&&u&&(t.adler=i.check=i.flags?Gt(i.check,s,u,t.next_out-u):Ot(i.check,s,u,t.next_out-u)),t.data_type=i.bits+(i.last?64:0)+(i.mode===Si?128:0)+(20===i.mode||15===i.mode?256:0),(0===d&&0===u||e===gi)&&A===bi&&(A=Ti),A},Vi={inflateReset:Ci,inflateReset2:Ri,inflateResetKeep:Mi,inflateInit:t=>Bi(t,15),inflateInit2:Bi,inflate:Oi,inflateEnd:t=>{if(!t||!t.state)return _i;let e=t.state;return e.window&&(e.window=null),t.state=null,bi},inflateGetHeader:(t,e)=>{if(!t||!t.state)return _i;const i=t.state;return 0==(2&i.wrap)?_i:(i.head=e,e.done=!1,bi)},inflateSetDictionary:(t,e)=>{const i=e.length;let n,s,r;return t&&t.state?(n=t.state,0!==n.wrap&&11!==n.mode?_i:11===n.mode&&(s=1,s=Ot(s,e,i,0),s!==n.check)?xi:(r=Di(t,e,i,i),r?(n.mode=31,Ai):(n.havedict=1,bi))):_i},inflateInfo:"pako inflate (from Nodeca project)"};var Gi=function(){this.text=0,this.time=0,this.xflags=0,this.os=0,this.extra=null,this.extra_len=0,this.name="",this.comment="",this.hcrc=0,this.done=!1};const ji=Object.prototype.toString,{Z_NO_FLUSH:Ki,Z_FINISH:$i,Z_OK:zi,Z_STREAM_END:qi,Z_NEED_DICT:Hi,Z_STREAM_ERROR:Xi,Z_DATA_ERROR:Wi,Z_MEM_ERROR:Yi}=Kt;function Zi(t){this.options=Ge({chunkSize:65536,windowBits:15,to:""},t||{});const e=this.options;e.raw&&e.windowBits>=0&&e.windowBits<16&&(e.windowBits=-e.windowBits,0===e.windowBits&&(e.windowBits=-15)),!(e.windowBits>=0&&e.windowBits<16)||t&&t.windowBits||(e.windowBits+=32),e.windowBits>15&&e.windowBits<48&&0==(15&e.windowBits)&&(e.windowBits|=15),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new Xe,this.strm.avail_out=0;let i=Vi.inflateInit2(this.strm,e.windowBits);if(i!==zi)throw new Error(jt[i]);if(this.header=new Gi,Vi.inflateGetHeader(this.strm,this.header),e.dictionary&&("string"==typeof e.dictionary?e.dictionary=ze(e.dictionary):"[object ArrayBuffer]"===ji.call(e.dictionary)&&(e.dictionary=new Uint8Array(e.dictionary)),e.raw&&(i=Vi.inflateSetDictionary(this.strm,e.dictionary),i!==zi)))throw new Error(jt[i])}function Qi(t,e){const i=new Zi(e);if(i.push(t),i.err)throw i.msg||jt[i.err];return i.result}Zi.prototype.push=function(t,e){const i=this.strm,n=this.options.chunkSize,s=this.options.dictionary;let r,a,o;if(this.ended)return!1;for(a=e===~~e?e:!0===e?$i:Ki,"[object ArrayBuffer]"===ji.call(t)?i.input=new Uint8Array(t):i.input=t,i.next_in=0,i.avail_in=i.input.length;;){for(0===i.avail_out&&(i.output=new Uint8Array(n),i.next_out=0,i.avail_out=n),r=Vi.inflate(i,a),r===Hi&&s&&(r=Vi.inflateSetDictionary(i,s),r===zi?r=Vi.inflate(i,a):r===Wi&&(r=Hi));i.avail_in>0&&r===qi&&i.state.wrap>0&&0!==t[i.next_in];)Vi.inflateReset(i),r=Vi.inflate(i,a);switch(r){case Xi:case Wi:case Hi:case Yi:return this.onEnd(r),this.ended=!0,!1}if(o=i.avail_out,i.next_out&&(0===i.avail_out||r===qi))if("string"===this.options.to){let t=He(i.output,i.next_out),e=i.next_out-t,s=qe(i.output,t);i.next_out=e,i.avail_out=n-e,e&&i.output.set(i.output.subarray(t,t+e),0),this.onData(s)}else this.onData(i.output.length===i.next_out?i.output:i.output.subarray(0,i.next_out));if(r!==zi||0!==o){if(r===qi)return r=Vi.inflateEnd(this.strm),this.onEnd(r),this.ended=!0,!0;if(0===i.avail_in)break}}return!0},Zi.prototype.onData=function(t){this.chunks.push(t)},Zi.prototype.onEnd=function(t){t===zi&&("string"===this.options.to?this.result=this.chunks.join(""):this.result=je(this.chunks)),this.chunks=[],this.err=t,this.msg=this.strm.msg};var Ji={Inflate:Zi,inflate:Qi,inflateRaw:function(t,e){return(e=e||{}).raw=!0,Qi(t,e)},ungzip:Qi,constants:Kt};const{Deflate:tn,deflate:en,deflateRaw:nn,gzip:sn}=oi,{Inflate:rn,inflate:an,inflateRaw:on,ungzip:ln}=Ji;var hn=en,cn=an;class dn{constructor(t){this.ctype=0,this.outputPos=0,this.dsize_bits=0,this.dsize_mask=0,this.bit_buff=0,this.extra_bits=0,this.in_pos=0,this.out_buff=[],this.in_buff=t}}const un=new Uint8Array([2,4,4,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8]),fn=new Uint8Array([3,13,5,25,9,17,1,62,30,46,14,54,22,38,6,58,26,42,10,50,18,34,66,2,124,60,92,28,108,44,76,12,116,52,84,20,100,36,68,4,120,56,88,24,104,40,72,8,240,112,176,48,208,80,144,16,224,96,160,32,192,64,128,0]),mn=new Uint8Array([0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8]),gn=new Uint16Array([0,1,2,3,4,5,6,7,8,10,14,22,38,70,134,262]),pn=new Uint8Array([3,2,3,3,4,4,4,5,5,5,5,6,6,6,7,7]),wn=new Uint8Array([5,3,1,6,10,2,12,20,4,24,8,48,16,32,64,0]),bn=new Uint8Array([11,12,12,12,12,12,12,12,12,8,7,12,12,7,12,12,12,12,12,12,12,12,12,12,12,12,13,12,12,12,12,12,4,10,8,12,10,12,10,8,7,7,8,9,7,6,7,8,7,6,7,7,7,7,8,7,7,8,8,12,11,7,9,11,12,6,7,6,6,5,7,8,8,6,11,9,6,7,6,6,7,11,6,6,6,7,9,8,9,9,11,8,11,9,12,8,12,5,6,6,6,5,6,6,6,5,11,7,5,6,5,5,6,10,5,5,5,5,8,7,8,8,10,11,11,12,12,12,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,12,13,13,13,12,13,13,13,12,13,13,13,13,12,13,13,13,12,12,12,13,13,13,13,13,13,13,13,13,13,13]),vn=new Uint16Array([1168,4064,2016,3040,992,3552,1504,2528,480,184,98,3808,1760,34,2784,736,3296,1248,2272,224,3936,1888,2912,864,3424,1376,4672,2400,352,3680,1632,2656,15,592,56,608,80,3168,912,216,66,2,88,432,124,41,60,152,92,9,28,108,44,76,24,12,116,232,104,1120,144,52,176,1808,2144,49,84,17,33,23,20,168,40,1,784,304,62,100,30,46,36,1296,14,54,22,68,48,200,464,208,272,72,1552,336,96,136,4e3,7,38,6,58,27,26,42,10,11,528,4,19,50,3,29,18,400,13,21,5,25,8,120,240,112,656,1040,16,1952,2976,928,576,7232,3136,5184,1088,6208,2112,4160,64,8064,3968,6016,1920,7040,2944,4992,896,7552,3456,5504,1408,6528,2432,4480,384,7808,3712,5760,1664,6784,2688,4736,640,7296,3200,5248,1152,6272,2176,4224,128,7936,3840,5888,1792,6912,2816,4864,3488,1440,2464,416,3744,1696,2720,672,3232,1184,2208,160,3872,1824,2848,800,3360,1312,2336,288,3616,1568,2592,544,3104,1056,2080,32,4032,1984,3008,960,3520,1472,2496,448,3776,1728,2752,704,3264,1216,2240,192,3904,1856,2880,832,768,3392,7424,3328,5376,1344,1280,6400,2304,2368,4352,256,7680,3584,320,5632,1536,6656,3648,1600,2624,2560,4608,512,7168,3072,5120,1024,6144,2048,4096,0]);let yn=!1;const _n=new Uint8Array(256),xn=new Uint8Array(256);let An=!1;const Tn=new Uint8Array(256),En=new Uint8Array(256),Sn=new Uint8Array(128),In=new Uint8Array(256);function kn(t,e,i){for(let n=0,s=e.length;n<s;n++){const s=1<<i[n];for(let i=e[n];i<256;i+=s)t[i]=n}}function Ln(t,e){return e<=t.extra_bits?(t.extra_bits-=e,t.bit_buff>>=e,0):(t.bit_buff>>=t.extra_bits,t.in_pos===t.in_buff.byteLength?1:(t.bit_buff|=t.in_buff[t.in_pos++]<<8,t.bit_buff>>=e-t.extra_bits,t.extra_bits=t.extra_bits-e+8,0))}function Mn(t){if(1&t.bit_buff){if(Ln(t,1))return 774;let e,i=xn[255&t.bit_buff];if(Ln(t,pn[i]))return 774;if(0!=(e=mn[i])){const n=t.bit_buff&(1<<e)-1;if(Ln(t,e)&&i+n!=270)return 774;i=gn[i]+n}return i+256}if(Ln(t,1))return 774;if(0==t.ctype){const e=255&t.bit_buff;return Ln(t,8)?774:e}let e;if(255&t.bit_buff){if(e=Tn[255&t.bit_buff],255==e)if(63&t.bit_buff){if(Ln(t,4))return 774;e=En[255&t.bit_buff]}else{if(Ln(t,6))return 774;e=Sn[127&t.bit_buff]}}else{if(Ln(t,8))return 774;e=In[255&t.bit_buff]}return Ln(t,bn[e])?774:e}function Cn(t,e){const i=_n[255&t.bit_buff];if(Ln(t,un[i]))return 0;let n;if(2==e){if(n=i<<2|3&t.bit_buff,Ln(t,2))return 0}else if(n=i<<t.dsize_bits|t.bit_buff&t.dsize_mask,Ln(t,t.dsize_bits))return 0;return n+1}function Rn(t){const e=new dn(t);if(e.in_buff.byteLength<=4)throw new Error("Bad data");if(e.ctype=e.in_buff[0],e.dsize_bits=e.in_buff[1],e.bit_buff=e.in_buff[2],e.extra_bits=0,e.in_pos=3,4>e.dsize_bits||e.dsize_bits>6)throw new Error("Invalid dictionary size");if(e.dsize_mask=65535>>16-e.dsize_bits,0!==e.ctype){if(1!==e.ctype)throw new Error("Invalid mode");An||(!function(){let t,e,i=255;for(let n=255;i>=0;i--,n--){const s=n;let r=bn[s];if(r<=8){e=1<<r,t=vn[i];do{Tn[t]=n,t+=e}while(t<256)}else if(0!=(t=255&vn[i]))if(Tn[t]=255,63&vn[i]){r-=4,bn[s]=r,e=1<<r,t=vn[i]>>4;do{En[t]=n,t+=e}while(t<256)}else{r-=6,bn[s]=r,e=1<<r,t=vn[i]>>6;do{Sn[t]=n,t+=e}while(t<128)}else{r-=8,bn[s]=r,e=1<<r,t=vn[i]>>8;do{In[t]=n,t+=e}while(t<256)}}}(),An=!0)}if(yn||(kn(xn,wn,pn),kn(_n,fn,un),yn=!0),774===function(t){let e;for(;(e=Mn(t))<773;)if(e>=256){let i,n=e-254;if(0==(i=Cn(t,n)))return 774;let s=t.outputPos,r=s-i;for(t.outputPos+=n;n-- >0;)t.out_buff[s++]=t.out_buff[r++]}else t.out_buff[t.outputPos++]=e;return e}(e))throw new Error("Error while expanding");return new Uint8Array(e.out_buff)}function Bn(t){let e=-1;for(let i=0,n=Math.ceil(t.byteLength/512);i<n;i++){const n=512*i;77===t[n]&&80===t[n+1]&&81===t[n+2]&&26===t[n+3]&&(e=n)}return e}class Un{constructor(t,e,i,n,s){this.rawBuffer=null,this.buffer=null;const r=t.headerOffset;this.archive=t,this.c=t.c,this.name=`File${`${e.blockIndex}`.padStart(8,"0")}`,this.nameResolved=!1,this.hash=e,this.block=i,n&&(this.rawBuffer=n.slice(r+i.offset,r+i.offset+i.compressedSize)),s&&(this.buffer=s)}bytes(){return null===this.buffer&&this.decode(),this.buffer}arrayBuffer(){return this.bytes().buffer}text(){return a(this.bytes())}set(t){if(this.archive.readonly)return!1;const e=this.hash,i=this.block;return e.locale=0,e.platform=0,i.compressedSize=0,i.normalSize=t.byteLength,i.flags=0,this.buffer=t,this.rawBuffer=null,!0}delete(){if(this.archive.readonly)return!1;const t=this.archive,e=this.hash,i=e.blockIndex;e.delete();for(const e of t.hashTable.entries)e.blockIndex<G&&e.blockIndex>i&&(e.blockIndex-=1);return t.blockTable.entries.splice(i,1),t.files.splice(i,1),!0}rename(t){if(this.archive.readonly)return!1;const e=this.hash,i=e.locale,n=e.platform,s=e.blockIndex;e.delete();const r=this.archive.hashTable.add(t,s);return r.locale=i,r.platform=n,this.name=t,this.nameResolved=!0,this.hash=r,!0}decode(){if(!this.rawBuffer)throw new Error(`File ${this.name}: Nothing to decode`);const t=this.archive,e=this.block,i=t.c,n=i.computeFileKey(this.name,e),s=this.rawBuffer,r=e.flags;if(r===H)this.buffer=s.slice(0,e.normalSize);else if(r&q){let t;t=r&$?i.decryptBlock(s.slice(0,e.compressedSize),n):s.subarray(0,e.compressedSize),t=512&r?this.decompressSector(t,e.normalSize):t.slice(),this.buffer=t}else{const a=Math.ceil(e.normalSize/t.sectorSize),o=new Uint8Array(e.normalSize);let l=new Uint32Array(s.buffer,0,a+1);r&$&&(l=i.decryptBlock(l.slice(),n-1));let h=l[0],c=l[1],d=0;for(let u=0;u<a;u++){let f;if(f=r&$?i.decryptBlock(s.slice(h,c),n+u):s.subarray(h,c),512&r){let i=t.sectorSize;e.normalSize-d<i&&(i=e.normalSize-d),f=this.decompressSector(f,i)}256&r&&(f=Rn(f)),o.set(f,d),d+=f.byteLength,u<a&&(h=c,c=l[u+2])}this.buffer=o}t.readonly&&(this.rawBuffer=null)}decompressSector(t,e){if(t.byteLength===e)return t;{const e=t[0];if(16&e)throw new Error(`File ${this.name}: compression type 'bzip2' not supported`);if(8&e)try{t=Rn(t.subarray(1))}catch(t){throw new Error(`File ${this.name}: failed to decompress with 'explode': ${t}`)}if(2&e)try{t=cn(t.subarray(1))}catch(t){throw new Error(`File ${this.name}: failed to decompress with 'zlib': ${t}`)}if(1&e)throw new Error(`File ${this.name}: compression type 'huffman' not supported`);if(128&e)throw new Error(`File ${this.name}: compression type 'adpcm stereo' not supported`);if(64&e)throw new Error(`File ${this.name}: compression type 'adpcm mono' not supported`);return t}}encode(){if(null!==this.buffer&&null===this.rawBuffer){const e=this.buffer;if(72===(t=e)[0]&&77===t[1]&&51===t[2]&&87===t[3]||-1!==Bn(t))this.rawBuffer=this.buffer,this.block.compressedSize=this.buffer.byteLength,this.block.flags=H;else{const t=this.archive.sectorSize,i=Math.ceil(e.byteLength/t),n=new Uint32Array(i+1);let s=n.byteLength;const r=[],a=[];n[0]=s;for(let o=0;o<i;o++){const i=o*t;let l=e.subarray(i,i+t),h=l.byteLength;const c=hn(l);let d=!1;c.byteLength+1<h&&(l=c,h=c.byteLength+1,d=!0),s+=h,n[o+1]=s,r[o]=l,a[o]=d}if(s<e.byteLength){const t=new Uint8Array(s);t.set(new Uint8Array(n.buffer)),s=n.byteLength;for(let e=0;e<i;e++){a[e]&&(t[s]=2,s+=1);const i=r[e];t.set(i,s),s+=i.byteLength}this.rawBuffer=t,this.block.compressedSize=t.byteLength,this.block.flags=2147484160}else this.rawBuffer=this.buffer,this.block.compressedSize=this.buffer.byteLength,this.block.flags=H}}var t}reEncrypt(t){if(!this.rawBuffer)return!1;const e=this.archive,i=this.block,n=e.c,s=this.rawBuffer,r=i.flags,a=n.computeFileKey(this.name,i);i.offset=t;const o=n.computeFileKey(this.name,i);if(r&q)n.decryptBlock(s,a),n.encryptBlock(s,o);else{const t=Math.ceil(i.normalSize/e.sectorSize),r=new Uint32Array(s.buffer,0,t+1);n.decryptBlock(r,a-1);let l=r[0],h=r[1];for(let e=0;e<t;e++){const i=s.subarray(l,h);n.decryptBlock(i,a+e),n.encryptBlock(i,o+e),e<t&&(l=h,h=r[e+2])}n.encryptBlock(r,o-1)}return!0}offsetChanged(t){const e=this.block;return e.offset!==t&&e.flags&z?!!this.nameResolved&&this.reEncrypt(t):(e.offset=t,!0)}}class Pn{constructor(){this.nameA=4294967295,this.nameB=4294967295,this.locale=65535,this.platform=65535,this.blockIndex=j}load(t){const e=t[2];this.nameA=t[0],this.nameB=t[1],this.locale=65535&e,this.platform=e>>>16,this.blockIndex=t[3]}copy(t){this.nameA=t.nameA,this.nameB=t.nameB,this.locale=t.locale,this.platform=t.platform,this.blockIndex=t.blockIndex}save(t){t[0]=this.nameA,t[1]=this.nameB,t[2]=this.locale<<16|this.platform,t[3]=this.blockIndex}delete(){this.nameA=4294967295,this.nameB=4294967295,this.locale=65535,this.platform=65535,this.blockIndex=G}}class Fn{constructor(t){this.c=t,this.entries=[],this.addEmpties(4)}clear(){this.entries.length=0}addEmpties(t){for(let e=0;e<t;e++)this.entries.push(new Pn)}getInsertionIndex(t){const e=this.entries,i=this.c.hash(t,0)&e.length-1;for(let t=0,n=e.length;t<n;t++){const s=(t+i)%n;if(65535===e[s].platform)return s}return-1}add(t,e){const i=this.getInsertionIndex(t);if(-1!==i){const n=this.entries[i];return n.nameA=this.c.hash(t,1),n.nameB=this.c.hash(t,2),n.locale=0,n.platform=0,n.blockIndex=e,n}}load(t){const e=t.byteLength/16,i=new Uint32Array(this.c.decryptBlock(t,V).buffer);let n=0;this.clear(),this.addEmpties(e);for(const t of this.entries)t.load(i.subarray(n,n+4)),n+=4}save(t){const e=new Uint32Array(4*this.entries.length);let i=0;for(const t of this.entries)t.save(e.subarray(i,i+4)),i+=4;const n=new Uint8Array(e.buffer);this.c.encryptBlock(n,V),t.set(n)}get(t){const e=this.c,i=this.entries,n=e.hash(t,0)&i.length-1,s=e.hash(t,1),r=e.hash(t,2);for(let t=0,e=i.length;t<e;t++){const a=i[(t+n)%e];if(s===a.nameA&&r===a.nameB)return a;if(4294967295===a.blockIndex)return null}return null}}class Nn{constructor(){this.readonly=!1,this.headerOffset=0,this.sectorSize=4096,this.c=new Z,this.hashTable=new Fn(this.c),this.blockTable=new X(this.c),this.files=[]}load(t,e=!1){const i=h(t);this.readonly=e;const n=Bn(i);if(-1===n)throw new Error("No MPQ header");const s=new Uint32Array(i.buffer,n,8),r=s[3],a=U(s[4]+n),o=U(s[5]+n),l=s[6];let c=s[7];c>l&&(c=l),this.headerOffset=n,this.sectorSize=512*(1<<(r>>>16)),this.hashTable.load(i.slice(a,a+16*l)),this.blockTable.load(i.slice(o,o+16*c)),this.files.length=0;for(const t of this.hashTable.entries){const e=t.blockIndex;e<this.blockTable.entries.length&&(this.files[e]=new Un(this,t,this.blockTable.entries[e],i,null))}const d=this.get("(listfile)");if(d){const t=d.text();if(t)for(const e of t.split("\r\n"))this.get(e)}}save(){if(this.readonly)return null;const t=32;this.delete("(attributes)"),this.saveMemory(),this.set("(listfile)",this.getFileNames().join("\r\n"));let e=t;for(const t of this.files)if(t){if(!t.offsetChanged(e))return null;t.encode(),e+=t.block.compressedSize}const i=this.hashTable,n=this.blockTable,s=i.entries.length,r=n.entries.length,a=e-t,o=t+a+16*s+16*r,l=t+a,h=l+16*s,c=new Uint8Array(o),d=new Uint32Array(c.buffer,0,8);d[0]=441536589,d[1]=t,d[2]=o,d[3]=Math.log2(this.sectorSize/512)<<16,d[4]=l,d[5]=h,d[6]=s,d[7]=r,e=t;for(const t of this.files)t&&(t.rawBuffer&&c.set(t.rawBuffer,e),e+=t.block.compressedSize);return i.save(c.subarray(e,e+16*i.entries.length)),e+=16*i.entries.length,n.save(c.subarray(e,e+16*n.entries.length)),c}saveMemory(){if(this.readonly)return 0;const t=this.blockTable.entries,e=this.hashTable.entries;let i=t.length,n=0;for(;i--;){const s=t[i];if(0===s.normalSize)this.removeBlock(i),n+=s.compressedSize;else{let t=!1;for(const n of e)if(n.blockIndex===i){t=!0;break}t||(this.removeBlock(i),n+=s.compressedSize)}}return n}removeBlock(t){for(const e of this.hashTable.entries)e.blockIndex<G&&e.blockIndex>t&&(e.blockIndex-=1);this.blockTable.entries.splice(t,1)}getFileNames(){const t=[];for(const e of this.files)e&&""!==e.name&&t.push(e.name);return t}countUnresolved(){let t=0;for(const e of this.files)e.nameResolved||t++;return t}applyListfile(t){for(const e of t)this.get(e)}set(t,e){if(this.readonly)return!1;const i=h(e);let n=this.get(t);if(n)n.set(i);else{const e=this.blockTable.entries.length,s=this.hashTable.add(t,e);if(!s)return!1;const r=this.blockTable.add(i);n=new Un(this,s,r,null,i),n.name=t,n.nameResolved=!0,this.files[e]=n}return!0}get(t){const e=this.hashTable.get(t);if(e){const i=e.blockIndex;if(i<G){const e=this.files[i];if(e)return e.name=t,e.nameResolved=!0,e}}return null}has(t){return!!this.get(t)}delete(t){if(this.readonly)return!1;const e=this.get(t);return!!e&&(e.delete(),!0)}rename(t,e){if(this.readonly)return!1;const i=this.get(t);return!!i&&(i.rename(e),!0)}resizeHashtable(t){if(this.readonly)return!1;var e;t=Math.max(4,(e=t,e--,e|=e>>1,e|=e>>2,e|=e>>4,e|=e>>8,e|=e>>16,++e));const i=this.files;if(i.length>t)return!1;for(const t of i)if(!t.nameResolved)return!1;const n=this.hashTable,s=n.entries,r=s.slice();n.clear(),n.addEmpties(t);for(const t of r)if(t.blockIndex!==j){const e=i[t.blockIndex];s[n.getInsertionIndex(e.name)].copy(t)}return!0}}class Dn{constructor(){this.isCustom=0,this.path=""}load(t){this.isCustom=t.readUint8(),this.path=t.readNull()}save(t){t.writeUint8(this.isCustom),t.writeNull(this.path)}getByteLength(){return 2+l(this.path)}}class On{constructor(){this.version=1,this.entries=new Map}load(t){const e=new F(t);this.version=e.readUint32();for(let t=0,i=e.readUint32();t<i;t++){const t=new Dn;t.load(e),t.isCustom?this.entries.set(t.path,t):this.entries.set(`war3mapimported\\${t.path}`,t)}}save(){const t=new F(new ArrayBuffer(this.getByteLength()));t.writeUint32(this.version),t.writeUint32(this.entries.size);for(const e of this.entries.values())e.save(t);return t.uint8array}getByteLength(){let t=8;for(const e of this.entries.values())t+=e.getByteLength();return t}set(t){if(!this.entries.has(t)){const e=new Dn;return e.isCustom=10,e.path=t,this.entries.set(t,e),!0}return!1}has(t){return this.entries.has(t)}delete(t){return this.entries.delete(t)}rename(t,e){const i=this.entries.get(t);return!!i&&(i.isCustom=10,i.path=e,!0)}}class Vn{constructor(){this.id="\0\0\0\0",this.variableType=0,this.levelOrVariation=0,this.dataPointer=0,this.value=0,this.u1=0}load(t,e){if(this.id=t.readBinary(4),this.variableType=t.readInt32(),e&&(this.levelOrVariation=t.readInt32(),this.dataPointer=t.readInt32()),0===this.variableType)this.value=t.readInt32();else if(1===this.variableType||2===this.variableType)this.value=t.readFloat32();else{if(3!==this.variableType)throw new Error(`Modification: unknown variable type ${this.variableType}`);this.value=t.readNull()}this.u1=t.readInt32()}save(t,e){if(t.writeBinary(this.id),t.writeInt32(this.variableType),e&&(t.writeInt32(this.levelOrVariation),t.writeInt32(this.dataPointer)),0===this.variableType)t.writeInt32(this.value);else if(1===this.variableType||2===this.variableType)t.writeFloat32(this.value);else{if(3!==this.variableType)throw new Error(`Modification: unknown variable type ${this.variableType}`);t.writeNull(this.value)}t.writeInt32(this.u1)}getByteLength(t){let e=12;return t&&(e+=8),3===this.variableType?e+=l(this.value)+1:e+=4,e}}class Gn{constructor(){this.oldId="\0\0\0\0",this.newId="\0\0\0\0",this.modifications=[]}load(t,e){this.oldId=t.readBinary(4),this.newId=t.readBinary(4);for(let i=0,n=t.readUint32();i<n;i++){const n=new Vn;n.load(t,e),this.modifications[i]=n}}save(t,e){"\0\0\0\0"!==this.oldId?t.writeBinary(this.oldId):t.writeUint32(0),"\0\0\0\0"!==this.newId?t.writeBinary(this.newId):t.writeUint32(0),t.writeUint32(this.modifications.length);for(const i of this.modifications)i.save(t,e)}getByteLength(t){let e=12;for(const i of this.modifications)e+=i.getByteLength(t);return e}}class jn{constructor(){this.objects=[]}load(t,e){for(let i=0,n=t.readUint32();i<n;i++){const n=new Gn;n.load(t,e),this.objects[i]=n}}save(t,e){t.writeUint32(this.objects.length);for(const i of this.objects)i.save(t,e)}getByteLength(t){let e=4;for(const i of this.objects)e+=i.getByteLength(t);return e}}class Kn{constructor(){this.version=0,this.originalTable=new jn,this.customTable=new jn}load(t){let e;e=t instanceof F?t:new F(t),this.version=e.readInt32(),this.originalTable.load(e,!0),this.customTable.load(e,!0)}save(){const t=new F(new ArrayBuffer(this.getByteLength()));return t.writeInt32(this.version),this.originalTable.save(t,!0),this.customTable.save(t,!0),t.uint8array}getByteLength(){return 4+this.originalTable.getByteLength(!0)+this.customTable.getByteLength(!0)}}class $n{constructor(){this.version=0,this.originalTable=new jn,this.customTable=new jn}load(t){let e;e=t instanceof F?t:new F(t),this.version=e.readInt32(),this.originalTable.load(e,!1),this.customTable.load(e,!1)}save(){const t=new F(new ArrayBuffer(this.getByteLength()));return t.writeInt32(this.version),this.originalTable.save(t,!1),this.customTable.save(t,!1),t.uint8array}getByteLength(){return 4+this.originalTable.getByteLength(!1)+this.customTable.getByteLength(!1)}}class zn{constructor(){this.text=""}load(t){const e=t.readInt32();e&&(this.text=t.read(e-1),t.skip(1))}save(t){this.text.length?(t.writeInt32(l(this.text)+1),t.write(this.text),t.skip(1)):t.writeInt32(0)}getByteLength(){let t=4;return this.text.length&&(t+=l(this.text)+1),t}}class qn{constructor(){this.version=0,this.comment="",this.trigger=new zn,this.triggers=[]}load(t){const e=new F(t);this.version=e.readInt32(),1===this.version&&(this.comment=e.readNull(),this.trigger.load(e));for(let t=0,i=e.readUint32();t<i;t++){const i=new zn;i.load(e),this.triggers[t]=i}}save(){const t=new F(new ArrayBuffer(this.getByteLength()));t.writeInt32(this.version),1===this.version&&(t.writeNull(this.comment),this.trigger.save(t)),t.writeUint32(this.triggers.length);for(const e of this.triggers)e.save(t);return t.uint8array}getByteLength(){let t=8;1===this.version&&(t+=l(this.comment)+1+this.trigger.getByteLength());for(const e of this.triggers)t+=e.getByteLength();return t}}class Hn{constructor(){this.id=0,this.name="",this.isComment=0}load(t,e){this.id=t.readInt32(),this.name=t.readNull(),7===e&&(this.isComment=t.readInt32())}save(t,e){t.writeInt32(this.id),t.writeNull(this.name),7===e&&t.writeInt32(this.isComment)}getByteLength(t){let e=5+l(this.name);return 7===t&&(e+=4),e}}class Xn{constructor(){this.name="",this.type="",this.u1=0,this.isArray=0,this.arraySize=0,this.isInitialized=0,this.initialValue=""}load(t,e){this.name=t.readNull(),this.type=t.readNull(),this.u1=t.readInt32(),this.isArray=t.readInt32(),7===e&&(this.arraySize=t.readInt32()),this.isInitialized=t.readInt32(),this.initialValue=t.readNull()}save(t,e){t.writeNull(this.name),t.writeNull(this.type),t.writeInt32(this.u1),t.writeInt32(this.isArray),7===e&&t.writeInt32(this.arraySize),t.writeInt32(this.isInitialized),t.writeNull(this.initialValue)}getByteLength(t){let e=15+l(this.name)+l(this.type)+l(this.initialValue);return 7===t&&(e+=4),e}}class Wn{constructor(){this.type=0,this.name="",this.beginParameters=0,this.parameters=[]}load(t,e,i){if(this.type=t.readInt32(),this.type<0||this.type>3)throw new Error(`SubParameters: Bad type: ${this.type}`);if(this.name=t.readNull(),0===this.name.length)throw new Error("SubParameters: Empty name");if(this.beginParameters=t.readInt32(),this.beginParameters){const n=i.getFunction(this.type,this.name);if(!n)throw new Error(`SubParameters "${this.name}:${this.type}": Unknown signature`);for(let s=0,r=n.args.length;s<r;s++){const n=new Yn;try{n.load(t,e,i)}catch(t){throw new Error(`SubParameters "${this.name}": Parameter ${s}: ${t}`)}this.parameters[s]=n}}}save(t,e){t.writeInt32(this.type),t.writeNull(this.name),t.writeInt32(this.beginParameters);for(const i of this.parameters)i.save(t,e)}getByteLength(t){let e=9+l(this.name);if(this.parameters.length)for(const i of this.parameters)e+=i.getByteLength(t);return e}}class Yn{constructor(){this.type=0,this.value="",this.subParameters=null,this.u1=0,this.isArray=0,this.arrayIndex=null}load(t,e,i){if(this.type=t.readInt32(),this.type<-1||this.type>3)throw new Error(`Parameter: Bad type: ${this.type}`);if(this.value=t.readNull(),t.readInt32()){const n=new Wn;try{n.load(t,e,i)}catch(t){throw new Error(`Parameter "${this.value}": SubParameters ${t}`)}this.subParameters=n}if((4===e&&2===this.type||7===e&&this.subParameters)&&(this.u1=t.readInt32()),(4===e&&2!==this.type||7===e)&&(this.isArray=t.readInt32()),this.isArray){const n=new Yn;try{n.load(t,e,i)}catch(t){throw new Error(`Parameter "${this.value}": ArrayIndex: ${t}`)}this.arrayIndex=n}}save(t,e){t.writeInt32(this.type),t.writeNull(this.value),this.subParameters?(t.writeInt32(1),this.subParameters.save(t,e)):t.writeInt32(0),(4===e&&2===this.type||7===e&&this.subParameters)&&t.writeInt32(this.u1),(4===e&&2!==this.type||7===e)&&t.writeInt32(this.isArray),this.isArray&&this.arrayIndex&&this.arrayIndex.save(t,e)}getByteLength(t){let e=9+l(this.value);return this.subParameters&&(e+=this.subParameters.getByteLength(t)),(4===t&&2===this.type||7===t&&this.subParameters)&&(e+=4),(4===t&&2!==this.type||7===t)&&(e+=4),this.isArray&&this.arrayIndex&&(e+=this.arrayIndex.getByteLength(t)),e}}class Zn{constructor(){this.type=-1,this.group=-1,this.name="",this.isEnabled=0,this.parameters=[],this.ecas=[]}load(t,e,i,n){if(this.type=t.readInt32(),this.type<0||this.type>3)throw new Error(`ECA: Bad type: ${this.type}`);if(i&&(this.group=t.readUint32()),this.name=t.readNull(),0===this.name.length)throw new Error("ECA: Empty name");this.isEnabled=t.readInt32();const s=n.getFunction(this.type,this.name);if(!s)throw new Error(`ECA "${this.name}:${this.type}": Unknown signature`);for(let i=0,r=s.args.length;i<r;i++){const s=new Yn;try{s.load(t,e,n)}catch(t){throw new Error(`ECA "${this.name}": Parameter ${i}: ${t}`)}this.parameters[i]=s}if(7===e)for(let i=0,s=t.readUint32();i<s;i++){const s=new Zn;try{s.load(t,e,!0,n)}catch(t){throw new Error(`ECA "${this.name}": Child ECA ${i} ${t}`)}this.ecas[i]=s}}save(t,e){t.writeInt32(this.type),-1!==this.group&&t.writeInt32(this.group),t.writeNull(this.name),t.writeInt32(this.isEnabled);for(const i of this.parameters)i.save(t,e);if(7===e){t.writeUint32(this.ecas.length);for(const i of this.ecas)i.save(t,e)}}getByteLength(t){let e=9+l(this.name);-1!==this.group&&(e+=4);for(const i of this.parameters)e+=i.getByteLength(t);if(7===t){e+=4;for(const i of this.ecas)e+=i.getByteLength(t)}return e}}class Qn{constructor(){this.name="",this.description="",this.isComment=0,this.isEnabled=0,this.isCustom=0,this.isInitiallyOff=0,this.runOnInitialization=0,this.category=0,this.ecas=[]}load(t,e,i){this.name=t.readNull(),this.description=t.readNull(),7===e&&(this.isComment=t.readInt32()),this.isEnabled=t.readInt32(),this.isCustom=t.readInt32(),this.isInitiallyOff=t.readInt32(),this.runOnInitialization=t.readInt32(),this.category=t.readInt32();for(let n=0,s=t.readUint32();n<s;n++){const s=new Zn;try{s.load(t,e,!1,i)}catch(t){throw new Error(`Trigger "${this.name}": ECA ${n}: ${t}`)}this.ecas[n]=s}}save(t,e){t.writeNull(this.name),t.writeNull(this.description),7===e&&t.writeInt32(this.isComment),t.writeInt32(this.isEnabled),t.writeInt32(this.isCustom),t.writeInt32(this.isInitiallyOff),t.writeInt32(this.runOnInitialization),t.writeInt32(this.category),t.writeUint32(this.ecas.length);for(const i of this.ecas)i.save(t,e)}getByteLength(t){let e=26+l(this.name)+l(this.description);7===t&&(e+=4);for(const i of this.ecas)e+=i.getByteLength(t);return e}}class Jn{constructor(){this.version=0,this.categories=[],this.u1=0,this.variables=[],this.triggers=[]}load(t,e){const i=new F(t);if("WTG!"!==i.readBinary(4))throw new Error("Not a WTG file");this.version=i.readInt32();for(let t=0,e=i.readUint32();t<e;t++){const e=new Hn;e.load(i,this.version),this.categories[t]=e}this.u1=i.readInt32();for(let t=0,e=i.readUint32();t<e;t++){const e=new Xn;e.load(i,this.version),this.variables[t]=e}for(let t=0,n=i.readUint32();t<n;t++){const n=new Qn;try{n.load(i,this.version,e)}catch(e){throw new Error(`Trigger ${t}: ${e}`)}this.triggers[t]=n}}save(){const t=new F(new ArrayBuffer(this.getByteLength()));t.writeBinary("WTG!"),t.writeInt32(this.version),t.writeUint32(this.categories.length);for(const e of this.categories)e.save(t,this.version);t.writeInt32(this.u1),t.writeUint32(this.variables.length);for(const e of this.variables)e.save(t,this.version);t.writeUint32(this.triggers.length);for(const e of this.triggers)e.save(t,this.version);return t.uint8array}getByteLength(){let t=24;const e=this.version;for(const i of this.categories)t+=i.getByteLength(e);for(const i of this.variables)t+=i.getByteLength(e);for(const i of this.triggers)t+=i.getByteLength(e);return t}}class ts{constructor(t){this.index=0,this.ident=0,this.indentSpaces=4,this.precision=1e6,this.buffer=t||""}clear(){this.buffer="",this.index=0,this.ident=0}readToken(){const t=this.buffer,e=t.length;let i=!1,n=!1,s="";for(;this.index<e;){const e=t[this.index++];if(i)"\n"===e&&(i=!1);else if(n)if("\\"===e)s+=e+t[this.index++];else if("\n"===e)s+="\\n";else if("\r"===e)s+="\\r";else{if('"'===e)return s;s+=e}else if(" "===e||","===e||"\t"===e||"\n"===e||":"===e||"\r"===e){if(s.length)return s}else{if("{"===e||"}"===e)return s.length?(this.index--,s):e;if("/"===e&&"/"===t[this.index]){if(s.length)return this.index--,s;i=!0}else if('"'===e){if(s.length)return this.index--,s;n=!0}else s+=e}}}read(){const t=this.readToken();if(void 0===t)throw new Error("End of stream reached prematurely");return t}peek(){const t=this.index,e=this.read();return this.index=t,e}readInt(){return parseInt(this.read())}readFloat(){return parseFloat(this.read())}readVector(t){this.read();for(let e=0,i=t.length;e<i;e++)t[e]=this.readFloat();return this.read(),t}readVectorsBlock(t,e){this.read();for(let i=0,n=t.length;i<n;i+=e)this.readVector(t.subarray(i,i+e));return this.read(),t}readColor(t){return this.read(),t[2]=this.readFloat(),t[1]=this.readFloat(),t[0]=this.readFloat(),this.read(),t}*readBlock(){this.read();let t=this.read();for(;"}"!==t;)yield t,t=this.read()}writeLine(t){this.buffer+=`${" ".repeat(this.ident*this.indentSpaces)}${t}\n`}writeFlag(t){this.writeLine(`${t},`)}writeFlagAttrib(t,e){this.writeLine(`${t} ${e},`)}writeNumberAttrib(t,e){this.writeLine(`${t} ${this.floatDecimals(e)},`)}writeStringAttrib(t,e){this.writeLine(`${t} "${e}",`)}writeVectorAttrib(t,e){this.writeLine(`${t} { ${this.floatArrayDecimals(e)} },`)}writeColor(t,e){const i=this.floatDecimals(e[0]),n=this.floatDecimals(e[1]),s=this.floatDecimals(e[2]);this.writeLine(`${t} { ${s}, ${n}, ${i} },`)}writeVector(t){this.writeLine(`{ ${this.floatArrayDecimals(t)} },`)}writeVectorArrayBlock(t,e,i){this.startBlock(t,e.length/i);for(let t=0,n=e.length;t<n;t+=i)this.writeVector(e.subarray(t,t+i));this.endBlock()}startBlock(t,...e){e.length&&(t=`${t} ${e.join(" ")}`),this.writeLine(`${t} {`),this.ident+=1}startObjectBlock(t,e){this.writeLine(`${t} "${e.replace(/"/g,'\\"')}" {`),this.ident+=1}endBlock(){this.ident-=1,this.writeLine("}")}endBlockComma(){this.ident-=1,this.writeLine("},")}indent(){this.ident+=1}unindent(){this.ident-=1}floatDecimals(t){return""+Math.trunc(t*this.precision)/this.precision}floatArrayDecimals(t){if(t instanceof Float32Array){const e=[];for(let i=0,n=t.length;i<n;i++)e[i]=this.floatDecimals(t[i]);return e.join(", ")}return t.join(", ")}}class es{constructor(){this.stringMap=new Map}load(t){const e=new ts(t);let i;const n=t.indexOf("STRING");if(-1===n)throw new Error("Not a valid war3map.wts buffer");for(e.index=n;i=e.readToken();)if("STRING"===i){const i=e.readInt();e.read();const n=t.indexOf("}",e.index);if(-1===n)throw this.stringMap.set(i,t.slice(e.index,t.length).trim()),new Error(`WTS: missing data in string ${this.stringMap.size} (and maybe more)`);this.stringMap.set(i,t.slice(e.index,n).trim()),e.index=n}}save(){let t="";for(const[e,i]of this.stringMap)t+=`STRING ${e}\r\n{\r\n${i}\r\n}\r\n\r\n`;return t}getString(t){return"string"!=typeof t?this.stringMap.get(t):t.startsWith("TRIGSTR_")?this.stringMap.get(parseInt(t.slice(8))):void 0}setString(t,e){"string"==typeof t?t.startsWith("TRIGSTR_")&&this.stringMap.set(parseInt(t.slice(8)),e):this.stringMap.set(t,e)}}class is{constructor(){this.flags=0,this.playerMasks=0,this.name=""}load(t){this.flags=t.readUint32(),this.playerMasks=t.readUint32(),this.name=t.readNull()}save(t){t.writeUint32(this.flags),t.writeUint32(this.playerMasks),t.writeNull(this.name)}getByteLength(){return 9+l(this.name)}}class ns{constructor(){this.id=0,this.type=0,this.race=0,this.isFixedStartPosition=0,this.name="",this.startLocation=new Float32Array(2),this.allyLowPriorities=0,this.allyHighPriorities=0,this.unknown1=new Uint8Array(8)}load(t,e){this.id=t.readInt32(),this.type=t.readInt32(),this.race=t.readInt32(),this.isFixedStartPosition=t.readInt32(),this.name=t.readNull(),t.readFloat32Array(this.startLocation),this.allyLowPriorities=t.readUint32(),this.allyHighPriorities=t.readUint32(),e>30&&t.readUint8Array(this.unknown1)}save(t,e){t.writeInt32(this.id),t.writeInt32(this.type),t.writeInt32(this.race),t.writeInt32(this.isFixedStartPosition),t.writeNull(this.name),t.writeFloat32Array(this.startLocation),t.writeUint32(this.allyLowPriorities),t.writeUint32(this.allyHighPriorities),e>30&&t.writeUint8Array(this.unknown1)}getByteLength(t){return(t>30?41:33)+l(this.name)}}class ss{constructor(){this.chance=0,this.id="\0\0\0\0"}load(t){this.chance=t.readInt32(),this.id=t.readBinary(4)}save(t){t.writeInt32(this.chance),t.writeBinary(this.id)}}class rs{constructor(){this.items=[]}load(t){for(let e=0,i=t.readUint32();e<i;e++){const i=new ss;i.load(t),this.items[e]=i}}save(t){t.writeUint32(this.items.length);for(const e of this.items)e.save(t)}getByteLength(){return 4+8*this.items.length}}class as{constructor(){this.id=0,this.name="",this.sets=[]}load(t){this.id=t.readInt32(),this.name=t.readNull();for(let e=0,i=t.readUint32();e<i;e++){const i=new rs;i.load(t),this.sets[e]=i}}save(t){t.writeInt32(this.id),t.writeNull(this.name),t.writeUint32(this.sets.length);for(const e of this.sets)e.save(t)}getByteLength(){let t=9+l(this.name);for(const e of this.sets)t+=e.getByteLength();return t}}class os{constructor(){this.chance=0,this.ids=[]}load(t,e){this.chance=t.readInt32();for(let i=0;i<e;i++)this.ids[i]=t.readBinary(4)}save(t){t.writeInt32(this.chance);for(const e of this.ids)t.writeBinary(e)}}class ls{constructor(){this.id=0,this.name="",this.positions=0,this.columnTypes=new Int32Array(0),this.units=[]}load(t){this.id=t.readInt32(),this.name=t.readNull(),this.positions=t.readInt32(),this.columnTypes=t.readInt32Array(this.positions);for(let e=0,i=t.readUint32();e<i;e++){const i=new os;i.load(t,this.positions),this.units[e]=i}}save(t){t.writeInt32(this.id),t.writeNull(this.name),t.writeInt32(this.positions),t.writeInt32Array(this.columnTypes),t.writeUint32(this.units.length);for(const e of this.units)e.save(t)}getByteLength(){return 13+l(this.name)+this.columnTypes.byteLength+this.units.length*(4+4*this.positions)}}class hs{constructor(){this.playerFlags=0,this.id="\0\0\0\0"}load(t){this.playerFlags=t.readUint32(),this.id=t.readBinary(4)}save(t){t.writeUint32(this.playerFlags),t.writeBinary(this.id)}}class cs{constructor(){this.playerFlags=0,this.id="\0\0\0\0",this.levelAffected=0,this.availability=0}load(t){this.playerFlags=t.readUint32(),this.id=t.readBinary(4),this.levelAffected=t.readInt32(),this.availability=t.readInt32()}save(t){t.writeUint32(this.playerFlags),t.writeBinary(this.id),t.writeInt32(this.levelAffected),t.writeInt32(this.availability)}}class ds{constructor(){this.version=0,this.saves=0,this.editorVersion=0,this.buildVersion=new Uint32Array(4),this.name="",this.author="",this.description="",this.recommendedPlayers="",this.cameraBounds=new Float32Array(8),this.cameraBoundsComplements=new Int32Array(4),this.playableSize=new Int32Array(2),this.flags=0,this.tileset="A",this.campaignBackground=0,this.loadingScreenModel="",this.loadingScreenText="",this.loadingScreenTitle="",this.loadingScreenSubtitle="",this.loadingScreen=0,this.prologueScreenModel="",this.prologueScreenText="",this.prologueScreenTitle="",this.prologueScreenSubtitle="",this.useTerrainFog=0,this.fogHeight=new Float32Array(2),this.fogDensity=0,this.fogColor=new Uint8Array(4),this.globalWeather=0,this.soundEnvironment="",this.lightEnvironmentTileset="\0",this.waterVertexColor=new Uint8Array(4),this.scriptMode=0,this.graphicsMode=0,this.players=[],this.forces=[],this.upgradeAvailabilityChanges=[],this.techAvailabilityChanges=[],this.randomUnitTables=[],this.randomItemTables=[],this.unknown1=0}load(t){const e=new F(t);this.version=e.readInt32(),this.saves=e.readInt32(),this.editorVersion=e.readInt32(),this.version>27&&e.readUint32Array(this.buildVersion),this.name=e.readNull(),this.author=e.readNull(),this.description=e.readNull(),this.recommendedPlayers=e.readNull(),e.readFloat32Array(this.cameraBounds),e.readInt32Array(this.cameraBoundsComplements),e.readInt32Array(this.playableSize),this.flags=e.readUint32(),this.tileset=e.readBinary(1),this.campaignBackground=e.readInt32(),this.version>24&&(this.loadingScreenModel=e.readNull()),this.loadingScreenText=e.readNull(),this.loadingScreenTitle=e.readNull(),this.loadingScreenSubtitle=e.readNull(),this.loadingScreen=e.readInt32(),this.version>24&&(this.prologueScreenModel=e.readNull()),this.prologueScreenText=e.readNull(),this.prologueScreenTitle=e.readNull(),this.prologueScreenSubtitle=e.readNull(),this.version>24&&(this.useTerrainFog=e.readInt32(),e.readFloat32Array(this.fogHeight),this.fogDensity=e.readFloat32(),e.readUint8Array(this.fogColor),this.globalWeather=e.readInt32(),this.soundEnvironment=e.readNull(),this.lightEnvironmentTileset=e.readBinary(1),e.readUint8Array(this.waterVertexColor)),this.version>27&&(this.scriptMode=e.readUint32()),this.version>30&&(this.graphicsMode=e.readUint32(),this.unknown1=e.readUint32());for(let t=0,i=e.readInt32();t<i;t++){const i=new ns;i.load(e,this.version),this.players[t]=i}for(let t=0,i=e.readInt32();t<i;t++){const i=new is;i.load(e),this.forces[t]=i}for(let t=0,i=e.readInt32();t<i;t++){const i=new cs;i.load(e),this.upgradeAvailabilityChanges[t]=i}for(let t=0,i=e.readInt32();t<i;t++){const i=new hs;i.load(e),this.techAvailabilityChanges[t]=i}for(let t=0,i=e.readInt32();t<i;t++){const i=new ls;i.load(e),this.randomUnitTables[t]=i}if(this.version>24)for(let t=0,i=e.readInt32();t<i;t++){const i=new as;i.load(e),this.randomItemTables[t]=i}}save(){const t=new F(new ArrayBuffer(this.getByteLength()));t.writeInt32(this.version),t.writeInt32(this.saves),t.writeInt32(this.editorVersion),this.version>27&&t.writeUint32Array(this.buildVersion),t.writeNull(this.name),t.writeNull(this.author),t.writeNull(this.description),t.writeNull(this.recommendedPlayers),t.writeFloat32Array(this.cameraBounds),t.writeInt32Array(this.cameraBoundsComplements),t.writeInt32Array(this.playableSize),t.writeUint32(this.flags),t.writeBinary(this.tileset),t.writeInt32(this.campaignBackground),this.version>24&&t.writeNull(this.loadingScreenModel),t.writeNull(this.loadingScreenText),t.writeNull(this.loadingScreenTitle),t.writeNull(this.loadingScreenSubtitle),t.writeInt32(this.loadingScreen),this.version>24&&t.writeNull(this.prologueScreenModel),t.writeNull(this.prologueScreenText),t.writeNull(this.prologueScreenTitle),t.writeNull(this.prologueScreenSubtitle),this.version>24&&(t.writeInt32(this.useTerrainFog),t.writeFloat32Array(this.fogHeight),t.writeFloat32(this.fogDensity),t.writeUint8Array(this.fogColor),t.writeInt32(this.globalWeather),t.writeNull(this.soundEnvironment),t.writeBinary(this.lightEnvironmentTileset),t.writeUint8Array(this.waterVertexColor)),this.version>27&&t.writeUint32(this.scriptMode),this.version>30&&(t.writeUint32(this.graphicsMode),t.writeUint32(this.unknown1)),t.writeUint32(this.players.length);for(const e of this.players)e.save(t,this.version);t.writeUint32(this.forces.length);for(const e of this.forces)e.save(t);t.writeUint32(this.upgradeAvailabilityChanges.length);for(const e of this.upgradeAvailabilityChanges)e.save(t);t.writeUint32(this.techAvailabilityChanges.length);for(const e of this.techAvailabilityChanges)e.save(t);t.writeUint32(this.randomUnitTables.length);for(const e of this.randomUnitTables)e.save(t);if(this.version>24){t.writeUint32(this.randomItemTables.length);for(const e of this.randomItemTables)e.save(t)}return t.uint8array}getByteLength(){let t=111+l(this.name)+l(this.author)+l(this.description)+l(this.recommendedPlayers)+l(this.loadingScreenText)+l(this.loadingScreenTitle)+l(this.loadingScreenSubtitle)+l(this.prologueScreenText)+l(this.prologueScreenTitle)+l(this.prologueScreenSubtitle);for(const e of this.players)t+=e.getByteLength(this.version);for(const e of this.forces)t+=e.getByteLength();t+=16*this.upgradeAvailabilityChanges.length,t+=8*this.techAvailabilityChanges.length;for(const e of this.randomUnitTables)t+=e.getByteLength();if(this.version>24){t+=36+l(this.loadingScreenModel)+l(this.prologueScreenModel)+l(this.soundEnvironment);for(const e of this.randomItemTables)t+=e.getByteLength()}return this.version>27&&(t+=20),this.version>30&&(t+=8),t}getBuildVersion(){return 100*this.buildVersion[0]+this.buildVersion[1]}}class us{constructor(){this.u1=0,this.name="",this.flags=0,this.maxPlayers=0,this.archive=new Nn,this.imports=new On,this.readonly=!1}load(t,e=!1){const i=new F(t);"HM3W"===i.readBinary(4)&&(this.u1=i.readUint32(),this.name=i.readNull(),this.flags=i.readUint32(),this.maxPlayers=i.readUint32()),this.readonly=e,this.archive.load(t,e),this.readImports()}save(){if(this.readonly)return null;this.setImportsFile();const t=this.archive.save();if(!t)return null;const e=this.getMapInformation();if(!e||e.getBuildVersion()<131){const e=new Uint8Array(512+t.byteLength),i=new F(e);return i.writeBinary("HM3W"),i.writeUint32(this.u1),i.writeNull(this.name),i.writeUint32(this.flags),i.writeUint32(this.maxPlayers),e.set(t,512),e}return t}getFileNames(){return this.archive.getFileNames()}getImportNames(){const t=[];for(const e of this.imports.entries.values()){const i=e.isCustom;10===i||13===i?t.push(e.path):t.push(`war3mapImported\\${e.path}`)}return t}setImportsFile(){return!this.readonly&&(this.imports.entries.size>0&&this.set("war3map.imp",this.imports.save()))}import(t,e){return!this.readonly&&(!!this.archive.set(t,e)&&(this.imports.set(t),!0))}set(t,e){return!this.readonly&&this.archive.set(t,e)}get(t){return this.archive.get(t)}getScriptFile(){return this.get("war3map.j")||this.get("scripts\\war3map.j")||this.get("war3map.lua")||this.get("scripts\\war3map.lua")}has(t){return this.archive.has(t)}delete(t){return!this.readonly&&(this.imports.delete(t),this.archive.delete(t))}rename(t,e){return!this.readonly&&(!!this.archive.rename(t,e)&&(this.imports.rename(t,e),!0))}getMapInformation(){const t=this.archive.get("war3map.w3i");if(!t)throw new Error("File does not exist");const e=new ds;return e.load(t.bytes()),e}readImports(){const t=this.archive.get("war3map.imp");if(t){const e=t.arrayBuffer();e&&this.imports.load(e)}}readTriggers(t){const e=this.archive.get("war3map.wtg");if(e){const i=e.arrayBuffer();if(i){const e=new Jn;return e.load(i,t),e}}}readCustomTextTriggers(){const t=this.archive.get("war3map.wct");if(t){const e=t.arrayBuffer();if(e){const t=new qn;return t.load(e),t}}}readStringTable(){const t=this.archive.get("war3map.wts");if(t){const e=t.text();if(e){const t=new es;return t.load(e),t}}}readModifications(){const t={},e=["w3u","w3t","w3b","w3d","w3a","w3h","w3q"],i=[!1,!1,!1,!0,!0,!1,!0];for(let n=0,s=e.length;n<s;n++){const s=this.archive.get(`war3map.${e[n]}`);if(s){const r=s.arrayBuffer();if(r){let s;s=i[n]?new Kn:new $n,s.load(r),t[e[n]]=s}}}return t}}function fs(t){let e="div";t&&t.tagName&&(e=t.tagName);let i=document.createElement(e);return t&&(t.style&&(i.style=t.style),t.className&&(i.className=t.className),t.textContent&&(i.textContent=t.textContent),t.placeholder&&(i.placeholder=t.placeholder),t.readonly&&(i.readonly=!0),t.href&&(i.href=t.href),t.target&&(i.target=t.target),t.title&&(i.title=t.title),t.onclick&&i.addEventListener("click",(e=>t.onclick(e,t.component))),t.onchange&&i.addEventListener("change",(e=>t.onchange(e,t.component))),t.oninput&&i.addEventListener("input",(e=>t.oninput(e,t.component))),t.container&&t.container.appendChild(i)),i}function ms(t){t.classList.add("hidden")}function gs(t){t.classList.remove("hidden")}function ps(t){t.scrollTop=t.scrollHeight}function ws(t){return t.scrollHeight-t.clientHeight===t.scrollTop}function bs(t){for(let e=t.options.length-1;e>=0;e--)t.remove(e)}class vs{constructor(t){this.container=fs({...t,component:this})}hide(){ms(this.container)}show(){gs(this.container)}highlight(){this.container.classList.add("highlighted")}normal(){this.container.classList.remove("highlighted")}}class ys extends vs{constructor(t,e,i,n){super({...n,tagName:"button",textContent:t,onclick:()=>this.toggle()}),this.offName=t,this.onName=e,this.callback=i,this.clicked=!1}toggle(){this.clicked=!this.clicked,this.clicked?this.container.textContent=this.onName:this.container.textContent=this.offName,this.callback&&this.callback(this)}}function _s(t,e){return t=t.toLowerCase(),"127.0.0.1"===window.location.hostname?function(t,e){if(e){const i=Object.entries(e);if(i.length){const e=i.map((([t,e])=>`${t}=${e}`)).join("&");let n="&";return-1===t.indexOf("?")&&(n="?"),`${t}${n}${e}`}}return t}(`${window.location.origin}/assets?path=${t}`,e):`https://www.hiveworkshop.com/casc-contents?path=${t}`}async function xs(t){let e=[],i=await As(t);for(;i.length>0;)e.push(...i),i=await As(t);return e}async function As(t){try{return await new Promise(((e,i)=>{t.readEntries(e,i)}))}catch(t){console.log(t)}}async function Ts(t,e){return new Promise((i=>{let n=new FileReader;n.addEventListener("loadend",(t=>{i(t.target.result)})),e?n.readAsText(t):n.readAsArrayBuffer(t)}))}async function Es(t,e){return new Promise((i=>t.file((async t=>i(await Ts(t,e))))))}class Ss{constructor(){this.boundsRadius=0,this.min=new Float32Array(3),this.max=new Float32Array(3)}readMdx(t){this.boundsRadius=t.readFloat32(),t.readFloat32Array(this.min),t.readFloat32Array(this.max)}writeMdx(t){t.writeFloat32(this.boundsRadius),t.writeFloat32Array(this.min),t.writeFloat32Array(this.max)}writeMdl(t){0===this.min[0]&&0===this.min[1]&&0===this.min[2]||t.writeVectorAttrib("MinimumExtent",this.min),0===this.max[0]&&0===this.max[1]&&0===this.max[2]||t.writeVectorAttrib("MaximumExtent",this.max),0!==this.boundsRadius&&t.writeNumberAttrib("BoundsRadius",this.boundsRadius)}}class Is{constructor(){this.name="",this.interval=new Uint32Array(2),this.moveSpeed=0,this.nonLooping=0,this.rarity=0,this.syncPoint=0,this.extent=new Ss}readMdx(t){this.name=t.read(80),t.readUint32Array(this.interval),this.moveSpeed=t.readFloat32(),this.nonLooping=t.readUint32(),this.rarity=t.readFloat32(),this.syncPoint=t.readUint32(),this.extent.readMdx(t)}writeMdx(t){t.skip(80-t.write(this.name)),t.writeUint32Array(this.interval),t.writeFloat32(this.moveSpeed),t.writeUint32(this.nonLooping),t.writeFloat32(this.rarity),t.writeUint32(this.syncPoint),this.extent.writeMdx(t)}readMdl(t){this.name=t.read();for(const e of t.readBlock())if("Interval"===e)t.readVector(this.interval);else if("NonLooping"===e)this.nonLooping=1;else if("MoveSpeed"===e)this.moveSpeed=t.readFloat();else if("Rarity"===e)this.rarity=t.readFloat();else if("MinimumExtent"===e)t.readVector(this.extent.min);else if("MaximumExtent"===e)t.readVector(this.extent.max);else{if("BoundsRadius"!==e)throw new Error(`Unknown token in Sequence: "${e}"`);this.extent.boundsRadius=t.readFloat()}}writeMdl(t){t.startObjectBlock("Anim",this.name),t.writeVectorAttrib("Interval",this.interval),1===this.nonLooping&&t.writeFlag("NonLooping"),0!==this.moveSpeed&&t.writeNumberAttrib("MoveSpeed",this.moveSpeed),0!==this.rarity&&t.writeNumberAttrib("Rarity",this.rarity),this.extent.writeMdl(t),t.endBlock()}}class ks{constructor(){this.name="",this.interpolationType=0,this.globalSequenceId=-1,this.frames=[],this.values=[],this.inTans=[],this.outTans=[]}readMdx(t,e){const i=this.frames,n=this.values,s=this.inTans,r=this.outTans,a=t.readUint32(),o=t.readUint32();this.name=e,this.interpolationType=o,this.globalSequenceId=t.readInt32();for(let e=0;e<a;e++)i.push(t.readInt32()),n.push(this.readMdxValue(t)),o>1&&(s.push(this.readMdxValue(t)),r.push(this.readMdxValue(t)))}writeMdx(t){const e=this.interpolationType,i=this.frames,n=this.values,s=this.inTans,r=this.outTans,a=i.length;t.writeBinary(this.name),t.writeUint32(a),t.writeUint32(e),t.writeInt32(this.globalSequenceId);for(let o=0;o<a;o++)t.writeInt32(i[o]),this.writeMdxValue(t,n[o]),e>1&&(this.writeMdxValue(t,s[o]),this.writeMdxValue(t,r[o]))}readMdl(t,e){const i=this.frames,n=this.values,s=this.inTans,r=this.outTans;this.name=e;const a=t.readInt();t.read();let o=0;const l=t.read();"DontInterp"===l?o=0:"Linear"===l?o=1:"Hermite"===l?o=2:"Bezier"===l&&(o=3),this.interpolationType=o,"GlobalSeqId"===t.peek()&&(t.read(),this.globalSequenceId=t.readInt());for(let e=0;e<a;e++)i[e]=t.readInt(),n[e]=this.readMdlValue(t),o>1&&(t.read(),s[e]=this.readMdlValue(t),t.read(),r[e]=this.readMdlValue(t));t.read()}writeMdl(t,e){const i=this.interpolationType,n=this.frames,s=this.values,r=this.inTans,a=this.outTans,o=n.length;t.startBlock(e,this.frames.length);let l="";0===this.interpolationType?l="DontInterp":1===this.interpolationType?l="Linear":2===this.interpolationType?l="Hermite":3===this.interpolationType&&(l="Bezier"),t.writeFlag(l),-1!==this.globalSequenceId&&t.writeNumberAttrib("GlobalSeqId",this.globalSequenceId);for(let e=0;e<o;e++)this.writeMdlValue(t,`${n[e]}:`,s[e]),i>1&&(t.indent(),this.writeMdlValue(t,"InTan",r[e]),this.writeMdlValue(t,"OutTan",a[e]),t.unindent());t.endBlock()}getByteLength(){const t=this.frames.length;let e=16;if(t){const i=this.values[0].byteLength;let n=1;this.interpolationType>1&&(n=3),e+=(4+n*i)*t}return e}}class Ls extends ks{readMdxValue(t){return t.readUint32Array(1)}writeMdxValue(t,e){t.writeUint32(e[0])}readMdlValue(t){return new Uint32Array([t.readInt()])}writeMdlValue(t,e,i){t.writeNumberAttrib(e,i[0])}}class Ms extends ks{readMdxValue(t){return t.readFloat32Array(1)}writeMdxValue(t,e){t.writeFloat32(e[0])}readMdlValue(t){return new Float32Array([t.readFloat()])}writeMdlValue(t,e,i){t.writeNumberAttrib(e,i[0])}}class Cs extends ks{readMdxValue(t){return t.readFloat32Array(3)}writeMdxValue(t,e){t.writeFloat32Array(e)}readMdlValue(t){return t.readVector(new Float32Array(3))}writeMdlValue(t,e,i){t.writeVectorAttrib(e,i)}}class Rs extends ks{readMdxValue(t){return t.readFloat32Array(4)}writeMdxValue(t,e){t.writeFloat32Array(e)}readMdlValue(t){return t.readVector(new Float32Array(4))}writeMdlValue(t,e,i){t.writeVectorAttrib(e,i)}}const Bs={KMTF:["TextureID",Ls],KMTA:["Alpha",Ms],KMTE:["EmissiveGain",Ms],KFC3:["FresnelColor",Cs],KFCA:["FresnelOpacity",Ms],KFTC:["FresnelTeamColor",Ls],KTAT:["Translation",Cs],KTAR:["Rotation",Rs],KTAS:["Scaling",Cs],KGAO:["Alpha",Ms],KGAC:["Color",Cs],KGTR:["Translation",Cs],KGRT:["Rotation",Rs],KGSC:["Scaling",Cs],KLAS:["AttenuationStart",Ms],KLAE:["AttenuationEnd",Ms],KLAC:["Color",Cs],KLAI:["Intensity",Ms],KLBI:["AmbIntensity",Ms],KLBC:["AmbColor",Cs],KLAV:["Visibility",Ms],KATV:["Visibility",Ms],KPEE:["EmissionRate",Ms],KPEG:["Gravity",Ms],KPLN:["Longitude",Ms],KPLT:["Latitude",Ms],KPEL:["LifeSpan",Ms],KPES:["InitVelocity",Ms],KPEV:["Visibility",Ms],KP2S:["Speed",Ms],KP2R:["Variation",Ms],KP2L:["Latitude",Ms],KP2G:["Gravity",Ms],KP2E:["EmissionRate",Ms],KP2N:["Width",Ms],KP2W:["Length",Ms],KP2V:["Visibility",Ms],KPPA:["Alpha",Ms],KPPC:["Color",Cs],KPPE:["EmissionRate",Ms],KPPL:["LifeSpan",Ms],KPPS:["Speed",Ms],KPPV:["Visibility",Ms],KRHA:["HeightAbove",Ms],KRHB:["HeightBelow",Ms],KRAL:["Alpha",Ms],KRCO:["Color",Cs],KRTX:["TextureSlot",Ls],KRVS:["Visibility",Ms],KCTR:["Translation",Cs],KTTR:["Translation",Cs],KCRL:["Rotation",Ms]};class Us{constructor(){this.animations=[]}readAnimations(t,e){const i=t.index+e;for(;t.index<i;){const e=t.readBinary(4),i=new Bs[e][1];i.readMdx(t,e),this.animations.push(i)}}writeAnimations(t){for(const e of this.animations)e.writeMdx(t)}*readAnimatedBlock(t){for(const e of t.readBlock())"static"===e?yield`static ${t.read()}`:yield e}readAnimation(t,e){const i=new Bs[e][1];i.readMdl(t,e),this.animations.push(i)}writeAnimation(t,e){for(const i of this.animations)if(i.name===e)return i.writeMdl(t,Bs[e][0]),!0;return!1}getByteLength(t){let e=0;for(const t of this.animations)e+=t.getByteLength();return e}}function Ps(t){return"None"===t?0:"Transparent"===t?1:"Blend"===t?2:"Additive"===t?3:"AddAlpha"===t?4:"Modulate"===t?5:"Modulate2x"===t?6:0}class Fs extends Us{constructor(){super(...arguments),this.filterMode=0,this.flags=0,this.textureId=-1,this.textureAnimationId=-1,this.coordId=0,this.alpha=1,this.emissiveGain=1,this.fresnelColor=new Float32Array([1,1,1]),this.fresnelOpacity=0,this.fresnelTeamColor=0}readMdx(t,e){const i=t.index,n=t.readUint32();this.filterMode=t.readUint32(),this.flags=t.readUint32(),this.textureId=t.readInt32(),this.textureAnimationId=t.readInt32(),this.coordId=t.readUint32(),this.alpha=t.readFloat32(),e>800&&(this.emissiveGain=t.readFloat32(),t.readFloat32Array(this.fresnelColor),this.fresnelOpacity=t.readFloat32(),this.fresnelTeamColor=t.readFloat32()),this.readAnimations(t,n-(t.index-i))}writeMdx(t,e){t.writeUint32(this.getByteLength(e)),t.writeUint32(this.filterMode),t.writeUint32(this.flags),t.writeInt32(this.textureId),t.writeInt32(this.textureAnimationId),t.writeUint32(this.coordId),t.writeFloat32(this.alpha),e>800&&(t.writeFloat32(this.emissiveGain),t.writeFloat32Array(this.fresnelColor),t.writeFloat32(this.fresnelOpacity),t.writeFloat32(this.fresnelTeamColor)),this.writeAnimations(t)}readMdl(t){for(const e of super.readAnimatedBlock(t))if("FilterMode"===e)this.filterMode=Ps(t.read());else if("Unshaded"===e)this.flags|=1;else if("SphereEnvMap"===e)this.flags|=2;else if("TwoSided"===e)this.flags|=16;else if("Unfogged"===e)this.flags|=32;else if("NoDepthTest"===e)this.flags|=64;else if("NoDepthSet"===e)this.flags|=128;else if("Unlit"===e)this.flags|=256;else if("static TextureID"===e)this.textureId=t.readInt();else if("TextureID"===e)this.readAnimation(t,"KMTF");else if("TVertexAnimId"===e)this.textureAnimationId=t.readInt();else if("CoordId"===e)this.coordId=t.readInt();else if("static Alpha"===e)this.alpha=t.readFloat();else if("Alpha"===e)this.readAnimation(t,"KMTA");else if("static EmissiveGain"===e)this.emissiveGain=t.readFloat();else if("EmissiveGain"===e)this.readAnimation(t,"KMTE");else if("static FresnelColor"===e)t.readVector(this.fresnelColor);else if("FresnelColor"===e)this.readAnimation(t,"KFC3");else if("static FresnelOpacity"===e)this.fresnelOpacity=t.readFloat();else if("FresnelOpacity"===e)this.readAnimation(t,"KFCA");else if("static FresnelTeamColor"===e)this.fresnelTeamColor=t.readFloat();else{if("FresnelTeamColor"!==e)throw new Error(`Unknown token in Layer: "${e}"`);this.readAnimation(t,"KFTC")}}writeMdl(t,e){var i;t.startBlock("Layer"),t.writeFlagAttrib("FilterMode",0===(i=this.filterMode)?"None":1===i?"Transparent":2===i?"Blend":3===i?"Additive":4===i?"AddAlpha":5===i?"Modulate":6===i?"Modulate2x":"None"),1&this.flags&&t.writeFlag("Unshaded"),2&this.flags&&t.writeFlag("SphereEnvMap"),16&this.flags&&t.writeFlag("TwoSided"),32&this.flags&&t.writeFlag("Unfogged"),64&this.flags&&t.writeFlag("NoDepthTest"),128&this.flags&&t.writeFlag("NoDepthSet"),e>800&&256&this.flags&&t.writeFlag("Unlit"),this.writeAnimation(t,"KMTF")||t.writeNumberAttrib("static TextureID",this.textureId),-1!==this.textureAnimationId&&t.writeNumberAttrib("TVertexAnimId",this.textureAnimationId),0!==this.coordId&&t.writeNumberAttrib("CoordId",this.coordId),this.writeAnimation(t,"KMTA")||1===this.alpha||t.writeNumberAttrib("static Alpha",this.alpha),e>800&&(this.writeAnimation(t,"KMTE")||1===this.emissiveGain||t.writeNumberAttrib("static EmissiveGain",this.emissiveGain),this.writeAnimation(t,"KFC3")||1===this.fresnelColor[0]&&1===this.fresnelColor[1]&&1===this.fresnelColor[2]||t.writeVectorAttrib("static FresnelColor",this.fresnelColor),this.writeAnimation(t,"KFCA")||0===this.fresnelOpacity||t.writeNumberAttrib("static FresnelOpacity",this.fresnelOpacity),this.writeAnimation(t,"KFTC")||0===this.fresnelTeamColor||t.writeNumberAttrib("static FresnelTeamColor",this.fresnelTeamColor)),t.endBlock()}getByteLength(t){let e=28+super.getByteLength();return t>800&&(e+=24),e}}class Ns{constructor(){this.priorityPlane=0,this.flags=0,this.shader="",this.layers=[]}readMdx(t,e){t.readUint32(),this.priorityPlane=t.readInt32(),this.flags=t.readUint32(),e>800&&(this.shader=t.read(80)),t.skip(4);for(let i=0,n=t.readUint32();i<n;i++){const i=new Fs;i.readMdx(t,e),this.layers.push(i)}}writeMdx(t,e){t.writeUint32(this.getByteLength(e)),t.writeInt32(this.priorityPlane),t.writeUint32(this.flags),e>800&&t.skip(80-t.write(this.shader)),t.writeBinary("LAYS"),t.writeUint32(this.layers.length);for(const i of this.layers)i.writeMdx(t,e)}readMdl(t){for(const e of t.readBlock())if("ConstantColor"===e)this.flags|=1;else if("TwoSided"===e)this.flags|=2;else if("SortPrimsNearZ"===e)this.flags|=8;else if("SortPrimsFarZ"===e)this.flags|=16;else if("FullResolution"===e)this.flags|=32;else if("PriorityPlane"===e)this.priorityPlane=t.readInt();else if("Shader"===e)this.shader=t.read();else{if("Layer"!==e)throw new Error(`Unknown token in Material: "${e}"`);{const e=new Fs;e.readMdl(t),this.layers.push(e)}}}writeMdl(t,e){t.startBlock("Material"),1&this.flags&&t.writeFlag("ConstantColor"),e>800&&2&this.flags&&t.writeFlag("TwoSided"),8&this.flags&&t.writeFlag("SortPrimsNearZ"),16&this.flags&&t.writeFlag("SortPrimsFarZ"),32&this.flags&&t.writeFlag("FullResolution"),0!==this.priorityPlane&&t.writeNumberAttrib("PriorityPlane",this.priorityPlane),e>800&&t.writeStringAttrib("Shader",this.shader);for(const i of this.layers)i.writeMdl(t,e);t.endBlock()}getByteLength(t){let e=20;t>800&&(e+=80);for(const i of this.layers)e+=i.getByteLength(t);return e}}class Ds{constructor(){this.replaceableId=0,this.path="",this.wrapMode=0}readMdx(t){this.replaceableId=t.readUint32(),this.path=t.read(260),this.wrapMode=t.readUint32()}writeMdx(t){t.writeUint32(this.replaceableId),t.skip(260-t.write(this.path)),t.writeUint32(this.wrapMode)}readMdl(t){for(const e of t.readBlock())if("Image"===e)this.path=t.read();else if("ReplaceableId"===e)this.replaceableId=t.readInt();else if("WrapWidth"===e)this.wrapMode|=1;else{if("WrapHeight"!==e)throw new Error(`Unknown token in Texture: "${e}"`);this.wrapMode|=2}}writeMdl(t){t.startBlock("Bitmap"),this.path.length&&t.writeStringAttrib("Image",this.path),0!==this.replaceableId&&t.writeNumberAttrib("ReplaceableId",this.replaceableId),1&this.wrapMode&&t.writeFlag("WrapWidth"),2&this.wrapMode&&t.writeFlag("WrapHeight"),t.endBlock()}}class Os extends Us{readMdx(t){const e=t.readUint32();this.readAnimations(t,e-4)}writeMdx(t){t.writeUint32(this.getByteLength()),this.writeAnimations(t)}readMdl(t){for(const e of t.readBlock())if("Translation"===e)this.readAnimation(t,"KTAT");else if("Rotation"===e)this.readAnimation(t,"KTAR");else{if("Scaling"!==e)throw new Error(`Unknown token in TextureAnimation: "${e}"`);this.readAnimation(t,"KTAS")}}writeMdl(t){t.startBlock("TVertexAnim "),this.writeAnimation(t,"KTAT"),this.writeAnimation(t,"KTAR"),this.writeAnimation(t,"KTAS"),t.endBlock()}getByteLength(){return 4+super.getByteLength()}}class Vs{constructor(){this.vertices=new Float32Array(0),this.normals=new Float32Array(0),this.faceTypeGroups=new Uint32Array(0),this.faceGroups=new Uint32Array(0),this.faces=new Uint16Array(0),this.vertexGroups=new Uint8Array(0),this.matrixGroups=new Uint32Array(0),this.matrixIndices=new Uint32Array(0),this.materialId=0,this.selectionGroup=0,this.selectionFlags=0,this.lod=-1,this.lodName="",this.extent=new Ss,this.sequenceExtents=[],this.tangents=new Float32Array(0),this.skin=new Uint8Array(0),this.uvSets=[]}readMdx(t,e){t.readUint32(),t.skip(4),this.vertices=t.readFloat32Array(3*t.readUint32()),t.skip(4),this.normals=t.readFloat32Array(3*t.readUint32()),t.skip(4),this.faceTypeGroups=t.readUint32Array(t.readUint32()),t.skip(4),this.faceGroups=t.readUint32Array(t.readUint32()),t.skip(4),this.faces=t.readUint16Array(t.readUint32()),t.skip(4),this.vertexGroups=t.readUint8Array(t.readUint32()),t.skip(4),this.matrixGroups=t.readUint32Array(t.readUint32()),t.skip(4),this.matrixIndices=t.readUint32Array(t.readUint32()),this.materialId=t.readUint32(),this.selectionGroup=t.readUint32(),this.selectionFlags=t.readUint32(),e>800&&(this.lod=t.readInt32(),this.lodName=t.read(80)),this.extent.readMdx(t);for(let e=0,i=t.readUint32();e<i;e++){const e=new Ss;e.readMdx(t),this.sequenceExtents.push(e)}e>800&&("TANG"===t.readBinary(4)?this.tangents=t.readFloat32Array(4*t.readUint32()):t.skip(-4),"SKIN"===t.readBinary(4)?this.skin=t.readUint8Array(t.readUint32()):t.skip(-4)),t.skip(4);for(let e=0,i=t.readUint32();e<i;e++)t.skip(4),this.uvSets.push(t.readFloat32Array(2*t.readUint32()))}writeMdx(t,e){t.writeUint32(this.getByteLength(e)),t.writeBinary("VRTX"),t.writeUint32(this.vertices.length/3),t.writeFloat32Array(this.vertices),t.writeBinary("NRMS"),t.writeUint32(this.normals.length/3),t.writeFloat32Array(this.normals),t.writeBinary("PTYP"),t.writeUint32(this.faceTypeGroups.length),t.writeUint32Array(this.faceTypeGroups),t.writeBinary("PCNT"),t.writeUint32(this.faceGroups.length),t.writeUint32Array(this.faceGroups),t.writeBinary("PVTX"),t.writeUint32(this.faces.length),t.writeUint16Array(this.faces),t.writeBinary("GNDX"),t.writeUint32(this.vertexGroups.length),t.writeUint8Array(this.vertexGroups),t.writeBinary("MTGC"),t.writeUint32(this.matrixGroups.length),t.writeUint32Array(this.matrixGroups),t.writeBinary("MATS"),t.writeUint32(this.matrixIndices.length),t.writeUint32Array(this.matrixIndices),t.writeUint32(this.materialId),t.writeUint32(this.selectionGroup),t.writeUint32(this.selectionFlags),e>800&&(t.writeInt32(this.lod),t.skip(80-t.write(this.lodName))),this.extent.writeMdx(t),t.writeUint32(this.sequenceExtents.length);for(const e of this.sequenceExtents)e.writeMdx(t);e>800&&(this.tangents.length&&(t.writeBinary("TANG"),t.writeUint32(this.tangents.length/4),t.writeFloat32Array(this.tangents)),this.skin.length&&(t.writeBinary("SKIN"),t.writeUint32(this.skin.length),t.writeUint8Array(this.skin))),t.writeBinary("UVAS"),t.writeUint32(this.uvSets.length);for(const e of this.uvSets)t.writeBinary("UVBS"),t.writeUint32(e.length/2),t.writeFloat32Array(e)}readMdl(t){for(let e of t.readBlock())if("Vertices"===e)this.vertices=t.readVectorsBlock(new Float32Array(3*t.readInt()),3);else if("Normals"===e)this.normals=t.readVectorsBlock(new Float32Array(3*t.readInt()),3);else if("TVertices"===e)this.uvSets.push(t.readVectorsBlock(new Float32Array(2*t.readInt()),2));else if("VertexGroup"===e){const e=[];for(const i of t.readBlock())e.push(parseInt(i));this.vertexGroups=new Uint8Array(e)}else if("Tangents"===e)this.tangents=t.readVectorsBlock(new Float32Array(4*t.readInt()),4);else if("SkinWeights"===e)this.skin=t.readVector(new Uint8Array(8*t.readInt()));else if("Faces"===e){this.faceTypeGroups=new Uint32Array([4]);const e=t.readInt(),i=t.readInt();t.read(),t.read(),this.faces=t.readVectorsBlock(new Uint16Array(i),i/e),this.faceGroups=new Uint32Array([i]),t.read()}else if("Groups"===e){const e=[],i=[];t.readInt(),t.readInt();for(const n of t.readBlock()){let n=0;for(const i of t.readBlock())e.push(parseInt(i)),n+=1;i.push(n)}this.matrixIndices=new Uint32Array(e),this.matrixGroups=new Uint32Array(i)}else if("MinimumExtent"===e)t.readVector(this.extent.min);else if("MaximumExtent"===e)t.readVector(this.extent.max);else if("BoundsRadius"===e)this.extent.boundsRadius=t.readFloat();else if("Anim"===e){const i=new Ss;for(e of t.readBlock())"MinimumExtent"===e?t.readVector(i.min):"MaximumExtent"===e?t.readVector(i.max):"BoundsRadius"===e&&(i.boundsRadius=t.readFloat());this.sequenceExtents.push(i)}else if("MaterialID"===e)this.materialId=t.readInt();else if("SelectionGroup"===e)this.selectionGroup=t.readInt();else if("Unselectable"===e)this.selectionFlags=4;else if("LevelOfDetail"===e)this.lod=t.readInt();else{if("Name"!==e)throw new Error(`Unknown token in Geoset: "${e}"`);this.lodName=t.read()}}writeMdl(t,e){t.startBlock("Geoset"),t.writeVectorArrayBlock("Vertices",this.vertices,3),t.writeVectorArrayBlock("Normals",this.normals,3);for(const e of this.uvSets)t.writeVectorArrayBlock("TVertices",e,2);if(e>800&&this.tangents.length&&t.writeVectorArrayBlock("Tangents",this.tangents,4),this.vertexGroups.length){t.startBlock("VertexGroup");for(let e=0,i=this.vertexGroups.length;e<i;e++)t.writeLine(`${this.vertexGroups[e]},`);t.endBlock()}if(e>800&&this.skin.length){t.startBlock("SkinWeights",this.skin.length/8);for(let e=0,i=this.skin.length;e<i;e+=8)t.writeLine(`${this.skin.subarray(e,e+8).join(", ")},`);t.endBlock()}t.startBlock("Faces",1,this.faces.length),t.startBlock("Triangles"),t.writeVector(this.faces),t.endBlock(),t.endBlock(),t.startBlock("Groups",this.matrixGroups.length,this.matrixIndices.length);let i=0;for(const e of this.matrixGroups)t.writeVectorAttrib("Matrices",this.matrixIndices.subarray(i,i+e)),i+=e;t.endBlock(),this.extent.writeMdl(t);for(const e of this.sequenceExtents)t.startBlock("Anim"),e.writeMdl(t),t.endBlock();t.writeNumberAttrib("MaterialID",this.materialId),t.writeNumberAttrib("SelectionGroup",this.selectionGroup),4===this.selectionFlags&&t.writeFlag("Unselectable"),e>800&&(t.writeNumberAttrib("LevelOfDetail",this.lod),this.lodName.length&&t.writeStringAttrib("Name",this.lodName)),t.endBlock()}getByteLength(t){let e=120+this.vertices.byteLength+this.normals.byteLength+this.faceTypeGroups.byteLength+this.faceGroups.byteLength+this.faces.byteLength+this.vertexGroups.byteLength+this.matrixGroups.byteLength+this.matrixIndices.byteLength+28*this.sequenceExtents.length;t>800&&(e+=84,this.tangents.length&&(e+=8+this.tangents.byteLength),this.skin.length&&(e+=8+this.skin.byteLength));for(const t of this.uvSets)e+=8+t.byteLength;return e}}class Gs extends Us{constructor(){super(...arguments),this.alpha=1,this.flags=0,this.color=new Float32Array([1,1,1]),this.geosetId=-1}readMdx(t){const e=t.readUint32();this.alpha=t.readFloat32(),this.flags=t.readUint32(),t.readFloat32Array(this.color),this.geosetId=t.readInt32(),this.readAnimations(t,e-28)}writeMdx(t){t.writeUint32(this.getByteLength()),t.writeFloat32(this.alpha),t.writeUint32(this.flags),t.writeFloat32Array(this.color),t.writeInt32(this.geosetId),this.writeAnimations(t)}readMdl(t){for(const e of super.readAnimatedBlock(t))if("DropShadow"===e)this.flags|=1;else if("static Alpha"===e)this.alpha=t.readFloat();else if("Alpha"===e)this.readAnimation(t,"KGAO");else if("static Color"===e)this.flags|=2,t.readColor(this.color);else if("Color"===e)this.flags|=2,this.readAnimation(t,"KGAC");else{if("GeosetId"!==e)throw new Error(`Unknown token in GeosetAnimation: "${e}"`);this.geosetId=t.readInt()}}writeMdl(t){t.startBlock("GeosetAnim"),1&this.flags&&t.writeFlag("DropShadow"),this.writeAnimation(t,"KGAO")||t.writeNumberAttrib("static Alpha",this.alpha),2&this.flags&&(this.writeAnimation(t,"KGAC")||1===this.color[0]&&1===this.color[1]&&1===this.color[2]||t.writeColor("static Color ",this.color)),t.writeNumberAttrib("GeosetId",this.geosetId),t.endBlock()}getByteLength(){return 28+super.getByteLength()}}class js extends Us{constructor(t=0){super(),this.name="",this.objectId=-1,this.parentId=-1,this.flags=t}readMdx(t){const e=t.readUint32();this.name=t.read(80),this.objectId=t.readInt32(),this.parentId=t.readInt32(),this.flags=t.readUint32(),this.readAnimations(t,e-96)}writeMdx(t){t.writeUint32(this.getGenericByteLength()),t.skip(80-t.write(this.name)),t.writeInt32(this.objectId),t.writeInt32(this.parentId),t.writeUint32(this.flags);for(const e of this.eachAnimation(!0))e.writeMdx(t)}writeNonGenericAnimationChunks(t){for(const e of this.eachAnimation(!1))e.writeMdx(t)}*readGenericBlock(t){this.name=t.read();for(let e of this.readAnimatedBlock(t))if("ObjectId"===e)this.objectId=t.readInt();else if("Parent"===e)this.parentId=t.readInt();else if("BillboardedLockZ"===e)this.flags|=64;else if("BillboardedLockY"===e)this.flags|=32;else if("BillboardedLockX"===e)this.flags|=16;else if("Billboarded"===e)this.flags|=8;else if("CameraAnchored"===e)this.flags|=128;else if("DontInherit"===e)for(e of t.readBlock())"Rotation"===e?this.flags|=2:"Translation"===e?this.flags|=1:"Scaling"===e&&(this.flags|=4);else"Translation"===e?this.readAnimation(t,"KGTR"):"Rotation"===e?this.readAnimation(t,"KGRT"):"Scaling"===e?this.readAnimation(t,"KGSC"):yield e}writeGenericHeader(t){t.writeNumberAttrib("ObjectId",this.objectId),-1!==this.parentId&&t.writeNumberAttrib("Parent",this.parentId),64&this.flags&&t.writeFlag("BillboardedLockZ"),32&this.flags&&t.writeFlag("BillboardedLockY"),16&this.flags&&t.writeFlag("BillboardedLockX"),8&this.flags&&t.writeFlag("Billboarded"),128&this.flags&&t.writeFlag("CameraAnchored"),2&this.flags&&t.writeFlag("DontInherit { Rotation }"),1&this.flags&&t.writeFlag("DontInherit { Translation }"),4&this.flags&&t.writeFlag("DontInherit { Scaling }")}writeGenericAnimations(t){this.writeAnimation(t,"KGTR"),this.writeAnimation(t,"KGRT"),this.writeAnimation(t,"KGSC")}*eachAnimation(t){for(const e of this.animations){const i=e.name,n="KGTR"===i||"KGRT"===i||"KGSC"===i;(t&&n||!t&&!n)&&(yield e)}}getGenericByteLength(){let t=96;for(const e of this.eachAnimation(!0))t+=e.getByteLength();return t}getByteLength(){return 96+super.getByteLength()}}class Ks extends js{constructor(){super(256),this.geosetId=-1,this.geosetAnimationId=-1}readMdx(t){super.readMdx(t),this.geosetId=t.readInt32(),this.geosetAnimationId=t.readInt32()}writeMdx(t){super.writeMdx(t),t.writeInt32(this.geosetId),t.writeInt32(this.geosetAnimationId)}readMdl(t){for(let e of super.readGenericBlock(t))if("GeosetId"===e)e=t.read(),this.geosetId="Multiple"===e?-1:parseInt(e);else{if("GeosetAnimId"!==e)throw new Error(`Unknown token in Bone ${this.name}: "${e}"`);e=t.read(),this.geosetAnimationId="None"===e?-1:parseInt(e)}}writeMdl(t){t.startObjectBlock("Bone",this.name),this.writeGenericHeader(t),-1===this.geosetId?t.writeFlagAttrib("GeosetId","Multiple"):t.writeNumberAttrib("GeosetId",this.geosetId),-1===this.geosetAnimationId?t.writeFlagAttrib("GeosetAnimId","None"):t.writeNumberAttrib("GeosetAnimId",this.geosetAnimationId),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 8+super.getByteLength()}}class $s extends js{constructor(){super(512),this.type=-1,this.attenuation=new Float32Array(2),this.color=new Float32Array(3),this.intensity=0,this.ambientColor=new Float32Array(3),this.ambientIntensity=0}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.type=t.readUint32(),t.readFloat32Array(this.attenuation),t.readFloat32Array(this.color),this.intensity=t.readFloat32(),t.readFloat32Array(this.ambientColor),this.ambientIntensity=t.readFloat32(),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.writeUint32(this.type),t.writeFloat32Array(this.attenuation),t.writeFloat32Array(this.color),t.writeFloat32(this.intensity),t.writeFloat32Array(this.ambientColor),t.writeFloat32(this.ambientIntensity),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(const e of super.readGenericBlock(t))if("Omnidirectional"===e)this.type=0;else if("Directional"===e)this.type=1;else if("Ambient"===e)this.type=2;else if("static AttenuationStart"===e)this.attenuation[0]=t.readFloat();else if("AttenuationStart"===e)this.readAnimation(t,"KLAS");else if("static AttenuationEnd"===e)this.attenuation[1]=t.readFloat();else if("AttenuationEnd"===e)this.readAnimation(t,"KLAE");else if("static Intensity"===e)this.intensity=t.readFloat();else if("Intensity"===e)this.readAnimation(t,"KLAI");else if("static Color"===e)t.readColor(this.color);else if("Color"===e)this.readAnimation(t,"KLAC");else if("static AmbIntensity"===e)this.ambientIntensity=t.readFloat();else if("AmbIntensity"===e)this.readAnimation(t,"KLBI");else if("static AmbColor"===e)t.readColor(this.ambientColor);else if("AmbColor"===e)this.readAnimation(t,"KLBC");else{if("Visibility"!==e)throw new Error(`Unknown token in Light: "${e}"`);this.readAnimation(t,"KLAV")}}writeMdl(t){t.startObjectBlock("Light",this.name),this.writeGenericHeader(t),0===this.type?t.writeFlag("Omnidirectional"):1===this.type?t.writeFlag("Directional"):2===this.type&&t.writeFlag("Ambient"),this.writeAnimation(t,"KLAS")||t.writeNumberAttrib("static AttenuationStart",this.attenuation[0]),this.writeAnimation(t,"KLAE")||t.writeNumberAttrib("static AttenuationEnd",this.attenuation[1]),this.writeAnimation(t,"KLAI")||t.writeNumberAttrib("static Intensity",this.intensity),this.writeAnimation(t,"KLAC")||t.writeColor("static Color",this.color),this.writeAnimation(t,"KLBI")||t.writeNumberAttrib("static AmbIntensity",this.ambientIntensity),this.writeAnimation(t,"KLBC")||t.writeColor("static AmbColor",this.ambientColor),this.writeAnimation(t,"KLAV"),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 48+super.getByteLength()}}class zs extends js{readMdl(t){for(const e of super.readGenericBlock(t))throw new Error(`Unknown token in Helper: "${e}"`)}writeMdl(t){t.startObjectBlock("Helper",this.name),this.writeGenericHeader(t),this.writeGenericAnimations(t),t.endBlock()}}class qs extends js{constructor(){super(2048),this.path="",this.attachmentId=0}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.path=t.read(260),this.attachmentId=t.readInt32(),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.skip(260-t.write(this.path)),t.writeInt32(this.attachmentId),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(const e of super.readGenericBlock(t))if("AttachmentID"===e)this.attachmentId=t.readInt();else if("Path"===e)this.path=t.read();else{if("Visibility"!==e)throw new Error(`Unknown token in Attachment ${this.name}: "${e}"`);this.readAnimation(t,"KATV")}}writeMdl(t){t.startObjectBlock("Attachment",this.name),this.writeGenericHeader(t),t.writeNumberAttrib("AttachmentID",this.attachmentId),this.path.length&&t.writeStringAttrib("Path",this.path),this.writeAnimation(t,"KATV"),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 268+super.getByteLength()}}class Hs extends js{constructor(){super(4096),this.emissionRate=0,this.gravity=0,this.longitude=0,this.latitude=0,this.path="",this.lifeSpan=0,this.speed=0}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.emissionRate=t.readFloat32(),this.gravity=t.readFloat32(),this.longitude=t.readFloat32(),this.latitude=t.readFloat32(),this.path=t.read(260),this.lifeSpan=t.readFloat32(),this.speed=t.readFloat32(),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.writeFloat32(this.emissionRate),t.writeFloat32(this.gravity),t.writeFloat32(this.longitude),t.writeFloat32(this.latitude),t.skip(260-t.write(this.path)),t.writeFloat32(this.lifeSpan),t.writeFloat32(this.speed),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(let e of super.readGenericBlock(t))if("EmitterUsesMDL"===e)this.flags|=32768;else if("EmitterUsesTGA"===e)this.flags|=65536;else if("static EmissionRate"===e)this.emissionRate=t.readFloat();else if("EmissionRate"===e)this.readAnimation(t,"KPEE");else if("static Gravity"===e)this.gravity=t.readFloat();else if("Gravity"===e)this.readAnimation(t,"KPEG");else if("static Longitude"===e)this.longitude=t.readFloat();else if("Longitude"===e)this.readAnimation(t,"KPLN");else if("static Latitude"===e)this.latitude=t.readFloat();else if("Latitude"===e)this.readAnimation(t,"KPLT");else if("Visibility"===e)this.readAnimation(t,"KPEV");else{if("Particle"!==e)throw new Error(`Unknown token in ParticleEmitter: "${e}"`);for(e of this.readAnimatedBlock(t))"static LifeSpan"===e?this.lifeSpan=t.readFloat():"LifeSpan"===e?this.readAnimation(t,"KPEL"):"static InitVelocity"===e?this.speed=t.readFloat():"InitVelocity"===e?this.readAnimation(t,"KPES"):"Path"===e&&(this.path=t.read())}}writeMdl(t){t.startObjectBlock("ParticleEmitter",this.name),this.writeGenericHeader(t),32768&this.flags&&t.writeFlag("EmitterUsesMDL"),65536&this.flags&&t.writeFlag("EmitterUsesTGA"),this.writeAnimation(t,"KPEE")||t.writeNumberAttrib("static EmissionRate",this.emissionRate),this.writeAnimation(t,"KPEG")||t.writeNumberAttrib("static Gravity",this.gravity),this.writeAnimation(t,"KPLN")||t.writeNumberAttrib("static Longitude",this.longitude),this.writeAnimation(t,"KPLT")||t.writeNumberAttrib("static Latitude",this.latitude),this.writeAnimation(t,"KPEV"),t.startBlock("Particle"),this.writeAnimation(t,"KPEL")||t.writeNumberAttrib("static LifeSpan",this.lifeSpan),this.writeAnimation(t,"KPES")||t.writeNumberAttrib("static InitVelocity",this.speed),(32768&this.flags||65536&this.flags)&&t.writeStringAttrib("Path",this.path),t.endBlock(),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 288+super.getByteLength()}}class Xs extends js{constructor(){super(...arguments),this.speed=0,this.variation=0,this.latitude=0,this.gravity=0,this.lifeSpan=0,this.emissionRate=0,this.width=0,this.length=0,this.filterMode=0,this.rows=0,this.columns=0,this.headOrTail=0,this.tailLength=0,this.timeMiddle=0,this.segmentColors=[new Float32Array(3),new Float32Array(3),new Float32Array(3)],this.segmentAlphas=new Uint8Array(3),this.segmentScaling=new Float32Array(3),this.headIntervals=[new Uint32Array(3),new Uint32Array(3)],this.tailIntervals=[new Uint32Array(3),new Uint32Array(3)],this.textureId=-1,this.squirt=0,this.priorityPlane=0,this.replaceableId=0}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.speed=t.readFloat32(),this.variation=t.readFloat32(),this.latitude=t.readFloat32(),this.gravity=t.readFloat32(),this.lifeSpan=t.readFloat32(),this.emissionRate=t.readFloat32(),this.width=t.readFloat32(),this.length=t.readFloat32(),this.filterMode=t.readUint32(),this.rows=t.readUint32(),this.columns=t.readUint32(),this.headOrTail=t.readUint32(),this.tailLength=t.readFloat32(),this.timeMiddle=t.readFloat32(),t.readFloat32Array(this.segmentColors[0]),t.readFloat32Array(this.segmentColors[1]),t.readFloat32Array(this.segmentColors[2]),t.readUint8Array(this.segmentAlphas),t.readFloat32Array(this.segmentScaling),t.readUint32Array(this.headIntervals[0]),t.readUint32Array(this.headIntervals[1]),t.readUint32Array(this.tailIntervals[0]),t.readUint32Array(this.tailIntervals[1]),this.textureId=t.readInt32(),this.squirt=t.readUint32(),this.priorityPlane=t.readInt32(),this.replaceableId=t.readUint32(),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.writeFloat32(this.speed),t.writeFloat32(this.variation),t.writeFloat32(this.latitude),t.writeFloat32(this.gravity),t.writeFloat32(this.lifeSpan),t.writeFloat32(this.emissionRate),t.writeFloat32(this.width),t.writeFloat32(this.length),t.writeUint32(this.filterMode),t.writeUint32(this.rows),t.writeUint32(this.columns),t.writeUint32(this.headOrTail),t.writeFloat32(this.tailLength),t.writeFloat32(this.timeMiddle),t.writeFloat32Array(this.segmentColors[0]),t.writeFloat32Array(this.segmentColors[1]),t.writeFloat32Array(this.segmentColors[2]),t.writeUint8Array(this.segmentAlphas),t.writeFloat32Array(this.segmentScaling),t.writeUint32Array(this.headIntervals[0]),t.writeUint32Array(this.headIntervals[1]),t.writeUint32Array(this.tailIntervals[0]),t.writeUint32Array(this.tailIntervals[1]),t.writeInt32(this.textureId),t.writeUint32(this.squirt),t.writeInt32(this.priorityPlane),t.writeUint32(this.replaceableId),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(const e of super.readGenericBlock(t))if("SortPrimsFarZ"===e)this.flags|=65536;else if("Unshaded"===e)this.flags|=32768;else if("LineEmitter"===e)this.flags|=131072;else if("Unfogged"===e)this.flags|=262144;else if("ModelSpace"===e)this.flags|=524288;else if("XYQuad"===e)this.flags|=1048576;else if("static Speed"===e)this.speed=t.readFloat();else if("Speed"===e)this.readAnimation(t,"KP2S");else if("static Variation"===e)this.variation=t.readFloat();else if("Variation"===e)this.readAnimation(t,"KP2R");else if("static Latitude"===e)this.latitude=t.readFloat();else if("Latitude"===e)this.readAnimation(t,"KP2L");else if("static Gravity"===e)this.gravity=t.readFloat();else if("Gravity"===e)this.readAnimation(t,"KP2G");else if("Visibility"===e)this.readAnimation(t,"KP2V");else if("Squirt"===e)this.squirt=1;else if("LifeSpan"===e)this.lifeSpan=t.readFloat();else if("static EmissionRate"===e)this.emissionRate=t.readFloat();else if("EmissionRate"===e)this.readAnimation(t,"KP2E");else if("static Width"===e)this.width=t.readFloat();else if("Width"===e)this.readAnimation(t,"KP2N");else if("static Length"===e)this.length=t.readFloat();else if("Length"===e)this.readAnimation(t,"KP2W");else if("Blend"===e)this.filterMode=0;else if("Additive"===e)this.filterMode=1;else if("Modulate"===e)this.filterMode=2;else if("Modulate2x"===e)this.filterMode=3;else if("AlphaKey"===e)this.filterMode=4;else if("Rows"===e)this.rows=t.readInt();else if("Columns"===e)this.columns=t.readInt();else if("Head"===e)this.headOrTail=0;else if("Tail"===e)this.headOrTail=1;else if("Both"===e)this.headOrTail=2;else if("TailLength"===e)this.tailLength=t.readFloat();else if("Time"===e)this.timeMiddle=t.readFloat();else if("SegmentColor"===e){t.read();for(let e=0;e<3;e++)t.read(),t.readColor(this.segmentColors[e]);t.read()}else if("Alpha"===e)t.readVector(this.segmentAlphas);else if("ParticleScaling"===e)t.readVector(this.segmentScaling);else if("LifeSpanUVAnim"===e)t.readVector(this.headIntervals[0]);else if("DecayUVAnim"===e)t.readVector(this.headIntervals[1]);else if("TailUVAnim"===e)t.readVector(this.tailIntervals[0]);else if("TailDecayUVAnim"===e)t.readVector(this.tailIntervals[1]);else if("TextureID"===e)this.textureId=t.readInt();else if("ReplaceableId"===e)this.replaceableId=t.readInt();else{if("PriorityPlane"!==e)throw new Error(`Unknown token in ParticleEmitter2: "${e}"`);this.priorityPlane=t.readInt()}}writeMdl(t){t.startObjectBlock("ParticleEmitter2",this.name),this.writeGenericHeader(t),65536&this.flags&&t.writeFlag("SortPrimsFarZ"),32768&this.flags&&t.writeFlag("Unshaded"),131072&this.flags&&t.writeFlag("LineEmitter"),262144&this.flags&&t.writeFlag("Unfogged"),524288&this.flags&&t.writeFlag("ModelSpace"),1048576&this.flags&&t.writeFlag("XYQuad"),this.writeAnimation(t,"KP2S")||t.writeNumberAttrib("static Speed",this.speed),this.writeAnimation(t,"KP2R")||t.writeNumberAttrib("static Variation",this.variation),this.writeAnimation(t,"KP2L")||t.writeNumberAttrib("static Latitude",this.latitude),this.writeAnimation(t,"KP2G")||t.writeNumberAttrib("static Gravity",this.gravity),this.writeAnimation(t,"KP2V"),this.squirt&&t.writeFlag("Squirt"),t.writeNumberAttrib("LifeSpan",this.lifeSpan),this.writeAnimation(t,"KP2E")||t.writeNumberAttrib("static EmissionRate",this.emissionRate),this.writeAnimation(t,"KP2N")||t.writeNumberAttrib("static Width",this.width),this.writeAnimation(t,"KP2W")||t.writeNumberAttrib("static Length",this.length),0===this.filterMode?t.writeFlag("Blend"):1===this.filterMode?t.writeFlag("Additive"):2===this.filterMode?t.writeFlag("Modulate"):3===this.filterMode?t.writeFlag("Modulate2x"):4===this.filterMode&&t.writeFlag("AlphaKey"),t.writeNumberAttrib("Rows",this.rows),t.writeNumberAttrib("Columns",this.columns),0===this.headOrTail?t.writeFlag("Head"):1===this.headOrTail?t.writeFlag("Tail"):2===this.headOrTail&&t.writeFlag("Both"),t.writeNumberAttrib("TailLength",this.tailLength),t.writeNumberAttrib("Time",this.timeMiddle),t.startBlock("SegmentColor"),t.writeColor("Color",this.segmentColors[0]),t.writeColor("Color",this.segmentColors[1]),t.writeColor("Color",this.segmentColors[2]),t.endBlockComma(),t.writeVectorAttrib("Alpha",this.segmentAlphas),t.writeVectorAttrib("ParticleScaling",this.segmentScaling),t.writeVectorAttrib("LifeSpanUVAnim",this.headIntervals[0]),t.writeVectorAttrib("DecayUVAnim",this.headIntervals[1]),t.writeVectorAttrib("TailUVAnim",this.tailIntervals[0]),t.writeVectorAttrib("TailDecayUVAnim",this.tailIntervals[1]),t.writeNumberAttrib("TextureID",this.textureId),0!==this.replaceableId&&t.writeNumberAttrib("ReplaceableId",this.replaceableId),0!==this.priorityPlane&&t.writeNumberAttrib("PriorityPlane",this.priorityPlane),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 175+super.getByteLength()}}class Ws extends js{constructor(){super(...arguments),this.lifeSpan=0,this.emissionRate=0,this.speed=0,this.color=new Float32Array(3),this.alpha=1,this.replaceableId=0,this.path="",this.animationVisiblityGuide=""}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.lifeSpan=t.readFloat32(),this.emissionRate=t.readFloat32(),this.speed=t.readFloat32(),t.readFloat32Array(this.color),this.alpha=t.readFloat32(),this.replaceableId=t.readUint32(),this.path=t.read(260),this.animationVisiblityGuide=t.read(260),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.writeFloat32(this.lifeSpan),t.writeFloat32(this.emissionRate),t.writeFloat32(this.speed),t.writeFloat32Array(this.color),t.writeFloat32(this.alpha),t.writeUint32(this.replaceableId),t.skip(260-t.write(this.path)),t.skip(260-t.write(this.animationVisiblityGuide)),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(const e of super.readGenericBlock(t))if("SortPrimsFarZ"===e)this.flags|=65536;else if("Unshaded"===e)this.flags|=32768;else if("Unfogged"===e)this.flags|=262144;else if("static LifeSpan"===e)this.lifeSpan=t.readFloat();else if("LifeSpan"===e)this.readAnimation(t,"KPPL");else if("static EmissionRate"===e)this.emissionRate=t.readFloat();else if("EmissionRate"===e)this.readAnimation(t,"KPPE");else if("static Speed"===e)this.speed=t.readFloat();else if("Speed"===e)this.readAnimation(t,"KPPS");else if("static Color"===e)t.readVector(this.color);else if("Color"===e)this.readAnimation(t,"KPPC");else if("static Alpha"===e)this.alpha=t.readFloat();else if("Alpha"===e)this.readAnimation(t,"KPPA");else if("Visibility"===e)this.readAnimation(t,"KPPV");else if("ReplaceableId"===e)this.replaceableId=t.readInt();else if("Path"===e)this.path=t.read();else{if("AnimVisibilityGuide"!==e)throw new Error(`Unknown token in ParticleEmitterPopcorn: "${e}"`);this.animationVisiblityGuide=t.read()}}writeMdl(t){t.startObjectBlock("ParticleEmitterPopcorn",this.name),this.writeGenericHeader(t),65536&this.flags&&t.writeFlag("SortPrimsFarZ"),32768&this.flags&&t.writeFlag("Unshaded"),262144&this.flags&&t.writeFlag("Unfogged"),this.writeAnimation(t,"KPPL")||t.writeNumberAttrib("static LifeSpan",this.lifeSpan),this.writeAnimation(t,"KPPE")||t.writeNumberAttrib("static EmissionRate",this.emissionRate),this.writeAnimation(t,"KPPS")||t.writeNumberAttrib("static Speed",this.speed),this.writeAnimation(t,"KPPC")||t.writeVectorAttrib("static Color",this.color),this.writeAnimation(t,"KPPA")||t.writeNumberAttrib("static Alpha",this.alpha),this.writeAnimation(t,"KPPV"),0!==this.replaceableId&&t.writeNumberAttrib("ReplaceableId",this.replaceableId),this.path.length&&t.writeStringAttrib("Path",this.path),this.animationVisiblityGuide.length&&t.writeStringAttrib("AnimVisibilityGuide",this.animationVisiblityGuide),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 556+super.getByteLength()}}class Ys extends js{constructor(){super(16384),this.heightAbove=0,this.heightBelow=0,this.alpha=0,this.color=new Float32Array(3),this.lifeSpan=0,this.textureSlot=0,this.emissionRate=0,this.rows=0,this.columns=0,this.materialId=0,this.gravity=0}readMdx(t){const e=t.index,i=t.readUint32();super.readMdx(t),this.heightAbove=t.readFloat32(),this.heightBelow=t.readFloat32(),this.alpha=t.readFloat32(),t.readFloat32Array(this.color),this.lifeSpan=t.readFloat32(),this.textureSlot=t.readUint32(),this.emissionRate=t.readUint32(),this.rows=t.readUint32(),this.columns=t.readUint32(),this.materialId=t.readInt32(),this.gravity=t.readFloat32(),this.readAnimations(t,i-(t.index-e))}writeMdx(t){t.writeUint32(this.getByteLength()),super.writeMdx(t),t.writeFloat32(this.heightAbove),t.writeFloat32(this.heightBelow),t.writeFloat32(this.alpha),t.writeFloat32Array(this.color),t.writeFloat32(this.lifeSpan),t.writeUint32(this.textureSlot),t.writeUint32(this.emissionRate),t.writeUint32(this.rows),t.writeUint32(this.columns),t.writeInt32(this.materialId),t.writeFloat32(this.gravity),this.writeNonGenericAnimationChunks(t)}readMdl(t){for(const e of super.readGenericBlock(t))if("static HeightAbove"===e)this.heightAbove=t.readFloat();else if("HeightAbove"===e)this.readAnimation(t,"KRHA");else if("static HeightBelow"===e)this.heightBelow=t.readFloat();else if("HeightBelow"===e)this.readAnimation(t,"KRHB");else if("static Alpha"===e)this.alpha=t.readFloat();else if("Alpha"===e)this.readAnimation(t,"KRAL");else if("static Color"===e)t.readColor(this.color);else if("Color"===e)this.readAnimation(t,"KRCO");else if("static TextureSlot"===e)this.textureSlot=t.readInt();else if("TextureSlot"===e)this.readAnimation(t,"KRTX");else if("Visibility"===e)this.readAnimation(t,"KRVS");else if("EmissionRate"===e)this.emissionRate=t.readInt();else if("LifeSpan"===e)this.lifeSpan=t.readFloat();else if("Gravity"===e)this.gravity=t.readFloat();else if("Rows"===e)this.rows=t.readInt();else if("Columns"===e)this.columns=t.readInt();else{if("MaterialID"!==e)throw new Error(`Unknown token in RibbonEmitter: "${e}"`);this.materialId=t.readInt()}}writeMdl(t){t.startObjectBlock("RibbonEmitter",this.name),this.writeGenericHeader(t),this.writeAnimation(t,"KRHA")||t.writeNumberAttrib("static HeightAbove",this.heightAbove),this.writeAnimation(t,"KRHB")||t.writeNumberAttrib("static HeightBelow",this.heightBelow),this.writeAnimation(t,"KRAL")||t.writeNumberAttrib("static Alpha",this.alpha),this.writeAnimation(t,"KRCO")||t.writeColor("static Color",this.color),this.writeAnimation(t,"KRTX")||t.writeNumberAttrib("static TextureSlot",this.textureSlot),this.writeAnimation(t,"KRVS"),t.writeNumberAttrib("EmissionRate",this.emissionRate),t.writeNumberAttrib("LifeSpan",this.lifeSpan),0!==this.gravity&&t.writeNumberAttrib("Gravity",this.gravity),t.writeNumberAttrib("Rows",this.rows),t.writeNumberAttrib("Columns",this.columns),t.writeNumberAttrib("MaterialID",this.materialId),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 56+super.getByteLength()}}class Zs extends Us{constructor(){super(...arguments),this.name="",this.position=new Float32Array(3),this.fieldOfView=0,this.farClippingPlane=0,this.nearClippingPlane=0,this.targetPosition=new Float32Array(3)}readMdx(t){const e=t.readUint32();this.name=t.read(80),t.readFloat32Array(this.position),this.fieldOfView=t.readFloat32(),this.farClippingPlane=t.readFloat32(),this.nearClippingPlane=t.readFloat32(),t.readFloat32Array(this.targetPosition),this.readAnimations(t,e-120)}writeMdx(t){t.writeUint32(this.getByteLength()),t.skip(80-t.write(this.name)),t.writeFloat32Array(this.position),t.writeFloat32(this.fieldOfView),t.writeFloat32(this.farClippingPlane),t.writeFloat32(this.nearClippingPlane),t.writeFloat32Array(this.targetPosition),this.writeAnimations(t)}readMdl(t){this.name=t.read();for(let e of t.readBlock())if("Position"===e)t.readVector(this.position);else if("Translation"===e)this.readAnimation(t,"KCTR");else if("Rotation"===e)this.readAnimation(t,"KCRL");else if("FieldOfView"===e)this.fieldOfView=t.readFloat();else if("FarClip"===e)this.farClippingPlane=t.readFloat();else if("NearClip"===e)this.nearClippingPlane=t.readFloat();else{if("Target"!==e)throw new Error(`Unknown token in Camera ${this.name}: "${e}"`);for(e of t.readBlock())if("Position"===e)t.readVector(this.targetPosition);else{if("Translation"!==e)throw new Error(`Unknown token in Camera ${this.name}'s Target: "${e}"`);this.readAnimation(t,"KTTR")}}}writeMdl(t){t.startObjectBlock("Camera",this.name),t.writeVectorAttrib("Position",this.position),this.writeAnimation(t,"KCTR"),this.writeAnimation(t,"KCRL"),t.writeNumberAttrib("FieldOfView",this.fieldOfView),t.writeNumberAttrib("FarClip",this.farClippingPlane),t.writeNumberAttrib("NearClip",this.nearClippingPlane),t.startBlock("Target"),t.writeVectorAttrib("Position",this.targetPosition),this.writeAnimation(t,"KTTR"),t.endBlock(),t.endBlock()}getByteLength(){return 120+super.getByteLength()}}class Qs extends js{constructor(){super(1024),this.globalSequenceId=-1,this.tracks=new Uint32Array(0)}readMdx(t){super.readMdx(t),t.skip(4);const e=t.readUint32();this.globalSequenceId=t.readInt32(),this.tracks=t.readUint32Array(e)}writeMdx(t){super.writeMdx(t),t.writeBinary("KEVT"),t.writeUint32(this.tracks.length),t.writeInt32(this.globalSequenceId),t.writeUint32Array(this.tracks)}readMdl(t){for(const e of super.readGenericBlock(t)){if("EventTrack"!==e)throw new Error(`Unknown token in EventObject: "${e}"`);{const e=t.readInt();this.tracks=new Uint32Array(e),t.read(),"GlobalSeqId"===t.peek()&&(t.read(),this.globalSequenceId=t.readInt());for(let i=0;i<e;i++)this.tracks[i]=t.readInt();t.read()}}}writeMdl(t){t.startObjectBlock("EventObject",this.name),this.writeGenericHeader(t),t.startBlock("EventTrack",this.tracks.length),-1!==this.globalSequenceId&&t.writeNumberAttrib("GlobalSeqId",this.globalSequenceId);for(const e of this.tracks)t.writeFlag(`${e}`);t.endBlock(),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){return 12+this.tracks.byteLength+super.getByteLength()}}class Js extends js{constructor(){super(8192),this.type=0,this.vertices=[new Float32Array(3),new Float32Array(3)],this.boundsRadius=0}readMdx(t){super.readMdx(t),this.type=t.readUint32(),t.readFloat32Array(this.vertices[0]),2!==this.type&&t.readFloat32Array(this.vertices[1]),2!==this.type&&3!==this.type||(this.boundsRadius=t.readFloat32())}writeMdx(t){super.writeMdx(t),t.writeUint32(this.type),t.writeFloat32Array(this.vertices[0]),2!==this.type&&t.writeFloat32Array(this.vertices[1]),2!==this.type&&3!==this.type||t.writeFloat32(this.boundsRadius)}readMdl(t){for(const e of super.readGenericBlock(t))if("Box"===e)this.type=0;else if("Plane"===e)this.type=1;else if("Sphere"===e)this.type=2;else if("Cylinder"===e)this.type=3;else if("Vertices"===e){const e=t.readInt();t.read(),t.readVector(this.vertices[0]),2===e&&t.readVector(this.vertices[1]),t.read()}else{if("BoundsRadius"!==e)throw new Error(`Unknown token in CollisionShape: "${e}"`);this.boundsRadius=t.readFloat()}}writeMdl(t){t.startObjectBlock("CollisionShape",this.name),this.writeGenericHeader(t);let e="",i=2,n=!1;0===this.type?e="Box":1===this.type?e="Plane":2===this.type?(e="Sphere",i=1,n=!0):3===this.type&&(e="Cylinder",n=!0),t.writeFlag(e),t.startBlock("Vertices",i),t.writeVector(this.vertices[0]),2===i&&t.writeVector(this.vertices[1]),t.endBlock(),n&&t.writeNumberAttrib("BoundsRadius",this.boundsRadius),this.writeGenericAnimations(t),t.endBlock()}getByteLength(){let t=16+super.getByteLength();return 2!==this.type&&(t+=12),2!==this.type&&3!==this.type||(t+=4),t}}class tr{constructor(){this.type="",this.path=""}readMdx(t){this.type=t.read(80),this.path=t.read(260)}writeMdx(t){t.skip(80-t.write(this.type)),t.skip(260-t.write(this.path))}readMdl(t){this.type=t.read();for(const e of t.readBlock()){if("Path"!==e)throw new Error(`Unknown token in FaceEffect: "${e}"`);this.path=t.read()}}writeMdl(t){t.startObjectBlock("FaceFX",this.type),t.writeStringAttrib("Path",this.path),t.endBlock()}}class er{constructor(t,e,i){this.tag=i,this.chunk=t.readUint8Array(new Uint8Array(e))}writeMdx(t){t.writeBinary(this.tag),t.writeUint32(this.chunk.byteLength),t.writeUint8Array(this.chunk)}getByteLength(){return 8+this.chunk.byteLength}}function ir(t){return t instanceof ArrayBuffer&&(t=new Uint8Array(t)),t instanceof Uint8Array&&77===t[0]&&68===t[1]&&76===t[2]&&88===t[3]}function nr(t){return t instanceof ArrayBuffer&&(t=new Uint8Array(t)),!!(t instanceof Uint8Array&&c(t,"FormatVersion",0,4096))||!("string"!=typeof t||!function(t,e,i=0,n=1/0){const s=Math.max(i,0),r=Math.min(s+n,t.length);let a=0,o=e[0];for(let i=s;i<r;i++)if(t[i]===o){if(a+=1,a===e.length)return!0;o=e[a]}else a>0&&(a=0,o=e[0]);return!1}(t,"FormatVersion",0,4096))}class sr{constructor(){this.version=800,this.name="",this.animationFile="",this.extent=new Ss,this.blendTime=0,this.sequences=[],this.globalSequences=[],this.materials=[],this.textures=[],this.textureAnimations=[],this.geosets=[],this.geosetAnimations=[],this.bones=[],this.lights=[],this.helpers=[],this.attachments=[],this.pivotPoints=[],this.particleEmitters=[],this.particleEmitters2=[],this.particleEmittersPopcorn=[],this.ribbonEmitters=[],this.cameras=[],this.eventObjects=[],this.collisionShapes=[],this.faceEffects=[],this.bindPose=[],this.unknownChunks=[]}load(t){if(ir(t))this.loadMdx(t);else{if(!nr(t))throw new Error("Not a valid MDX/MDL buffer");"string"==typeof t?this.loadMdl(t):this.loadMdl(a(t))}}loadMdx(t){const e=new F(t);let i,n;for(e.skip(4);e.remaining>0;)i=e.readBinary(4),n=e.readUint32(),"VERS"===i?this.loadVersionChunk(e):"MODL"===i?this.loadModelChunk(e):"SEQS"===i?this.loadStaticObjects(this.sequences,Is,e,n/132):"GLBS"===i?this.loadGlobalSequenceChunk(e,n):"MTLS"===i?this.loadDynamicObjects(this.materials,Ns,e,n):"TEXS"===i?this.loadStaticObjects(this.textures,Ds,e,n/268):"TXAN"===i?this.loadDynamicObjects(this.textureAnimations,Os,e,n):"GEOS"===i?this.loadDynamicObjects(this.geosets,Vs,e,n):"GEOA"===i?this.loadDynamicObjects(this.geosetAnimations,Gs,e,n):"BONE"===i?this.loadDynamicObjects(this.bones,Ks,e,n):"LITE"===i?this.loadDynamicObjects(this.lights,$s,e,n):"HELP"===i?this.loadDynamicObjects(this.helpers,zs,e,n):"ATCH"===i?this.loadDynamicObjects(this.attachments,qs,e,n):"PIVT"===i?this.loadPivotPointChunk(e,n):"PREM"===i?this.loadDynamicObjects(this.particleEmitters,Hs,e,n):"PRE2"===i?this.loadDynamicObjects(this.particleEmitters2,Xs,e,n):"CORN"===i?this.loadDynamicObjects(this.particleEmittersPopcorn,Ws,e,n):"RIBB"===i?this.loadDynamicObjects(this.ribbonEmitters,Ys,e,n):"CAMS"===i?this.loadDynamicObjects(this.cameras,Zs,e,n):"EVTS"===i?this.loadDynamicObjects(this.eventObjects,Qs,e,n):"CLID"===i?this.loadDynamicObjects(this.collisionShapes,Js,e,n):"FAFX"===i?this.loadStaticObjects(this.faceEffects,tr,e,n/340):"BPOS"===i?this.loadBindPoseChunk(e,n):this.unknownChunks.push(new er(e,n,i))}loadVersionChunk(t){this.version=t.readUint32()}loadModelChunk(t){this.name=t.read(80),this.animationFile=t.read(260),this.extent.readMdx(t),this.blendTime=t.readUint32()}loadStaticObjects(t,e,i,n){for(let s=0;s<n;s++){const n=new e;n.readMdx(i),t.push(n)}}loadGlobalSequenceChunk(t,e){for(let i=0,n=e/4;i<n;i++)this.globalSequences.push(t.readUint32())}loadDynamicObjects(t,e,i,n){const s=i.index+n;for(;i.index<s;){const n=new e;n.readMdx(i,this.version),t.push(n)}}loadPivotPointChunk(t,e){for(let i=0,n=e/12;i<n;i++)this.pivotPoints.push(t.readFloat32Array(3))}loadBindPoseChunk(t,e){for(let e=0,i=t.readUint32();e<i;e++)this.bindPose[e]=t.readFloat32Array(12)}saveMdx(){const t=new F(new ArrayBuffer(this.getByteLength()));t.writeBinary("MDLX"),this.saveVersionChunk(t),this.saveModelChunk(t),this.saveStaticObjectChunk(t,"SEQS",this.sequences,132),this.saveGlobalSequenceChunk(t),this.saveDynamicObjectChunk(t,"MTLS",this.materials),this.saveStaticObjectChunk(t,"TEXS",this.textures,268),this.saveDynamicObjectChunk(t,"TXAN",this.textureAnimations),this.saveDynamicObjectChunk(t,"GEOS",this.geosets),this.saveDynamicObjectChunk(t,"GEOA",this.geosetAnimations),this.saveDynamicObjectChunk(t,"BONE",this.bones),this.saveDynamicObjectChunk(t,"LITE",this.lights),this.saveDynamicObjectChunk(t,"HELP",this.helpers),this.saveDynamicObjectChunk(t,"ATCH",this.attachments),this.savePivotPointChunk(t),this.saveDynamicObjectChunk(t,"PREM",this.particleEmitters),this.saveDynamicObjectChunk(t,"PRE2",this.particleEmitters2),this.version>800&&this.saveDynamicObjectChunk(t,"CORN",this.particleEmittersPopcorn),this.saveDynamicObjectChunk(t,"RIBB",this.ribbonEmitters),this.saveDynamicObjectChunk(t,"CAMS",this.cameras),this.saveDynamicObjectChunk(t,"EVTS",this.eventObjects),this.saveDynamicObjectChunk(t,"CLID",this.collisionShapes),this.version>800&&(this.saveStaticObjectChunk(t,"FAFX",this.faceEffects,340),this.saveBindPoseChunk(t));for(const e of this.unknownChunks)e.writeMdx(t);return t.uint8array}saveVersionChunk(t){t.writeBinary("VERS"),t.writeUint32(4),t.writeUint32(this.version)}saveModelChunk(t){t.writeBinary("MODL"),t.writeUint32(372),t.skip(80-t.write(this.name)),t.skip(260-t.write(this.animationFile)),this.extent.writeMdx(t),t.writeUint32(this.blendTime)}saveStaticObjectChunk(t,e,i,n){if(i.length){t.writeBinary(e),t.writeUint32(i.length*n);for(const e of i)e.writeMdx(t)}}saveGlobalSequenceChunk(t){if(this.globalSequences.length){t.writeBinary("GLBS"),t.writeUint32(4*this.globalSequences.length);for(const e of this.globalSequences)t.writeUint32(e)}}saveDynamicObjectChunk(t,e,i){if(i.length){t.writeBinary(e),t.writeUint32(this.getObjectsByteLength(i));for(const e of i)e.writeMdx(t,this.version)}}savePivotPointChunk(t){if(this.pivotPoints.length){t.writeBinary("PIVT"),t.writeUint32(12*this.pivotPoints.length);for(const e of this.pivotPoints)t.writeFloat32Array(e)}}saveBindPoseChunk(t){if(this.bindPose.length){t.writeBinary("BPOS"),t.writeUint32(4+48*this.bindPose.length),t.writeUint32(this.bindPose.length);for(const e of this.bindPose)t.writeFloat32Array(e)}}loadMdl(t){let e;const i=new ts(t);for(;e=i.readToken();)if("Version"===e)this.loadVersionBlock(i);else if("Model"===e)this.loadModelBlock(i);else if("Sequences"===e)this.loadNumberedObjectBlock(this.sequences,Is,"Anim",i);else if("GlobalSequences"===e)this.loadGlobalSequenceBlock(i);else if("Textures"===e)this.loadNumberedObjectBlock(this.textures,Ds,"Bitmap",i);else if("Materials"===e)this.loadNumberedObjectBlock(this.materials,Ns,"Material",i);else if("TextureAnims"===e)this.loadNumberedObjectBlock(this.textureAnimations,Os,"TVertexAnim",i);else if("Geoset"===e)this.loadObject(this.geosets,Vs,i);else if("GeosetAnim"===e)this.loadObject(this.geosetAnimations,Gs,i);else if("Bone"===e)this.loadObject(this.bones,Ks,i);else if("Light"===e)this.loadObject(this.lights,$s,i);else if("Helper"===e)this.loadObject(this.helpers,zs,i);else if("Attachment"===e)this.loadObject(this.attachments,qs,i);else if("PivotPoints"===e)this.loadPivotPointBlock(i);else if("ParticleEmitter"===e)this.loadObject(this.particleEmitters,Hs,i);else if("ParticleEmitter2"===e)this.loadObject(this.particleEmitters2,Xs,i);else if("ParticleEmitterPopcorn"===e)this.loadObject(this.particleEmittersPopcorn,Ws,i);else if("RibbonEmitter"===e)this.loadObject(this.ribbonEmitters,Ys,i);else if("Camera"===e)this.loadObject(this.cameras,Zs,i);else if("EventObject"===e)this.loadObject(this.eventObjects,Qs,i);else if("CollisionShape"===e)this.loadObject(this.collisionShapes,Js,i);else if("FaceFX"===e)this.loadObject(this.faceEffects,tr,i);else{if("BindPose"!==e)throw new Error(`Unsupported block: ${e}`);this.loadBindPoseBlock(i)}}loadVersionBlock(t){for(const e of t.readBlock()){if("FormatVersion"!==e)throw new Error(`Unknown token in Version: "${e}"`);this.version=t.readInt()}}loadModelBlock(t){this.name=t.read();for(const e of t.readBlock())if(e.startsWith("Num"))t.read();else if("BlendTime"===e)this.blendTime=t.readInt();else if("MinimumExtent"===e)t.readVector(this.extent.min);else if("MaximumExtent"===e)t.readVector(this.extent.max);else if("BoundsRadius"===e)this.extent.boundsRadius=t.readFloat();else{if("AnimationFile"!==e)throw new Error(`Unknown token in Model: "${e}"`);this.animationFile=t.read()}}loadNumberedObjectBlock(t,e,i,n){n.read();for(const s of n.readBlock()){if(s!==i)throw new Error(`Unknown token in ${i}: "${s}"`);{const i=new e;i.readMdl(n),t.push(i)}}}loadGlobalSequenceBlock(t){t.read();for(const e of t.readBlock()){if("Duration"!==e)throw new Error(`Unknown token in GlobalSequences: "${e}"`);this.globalSequences.push(t.readInt())}}loadObject(t,e,i){const n=new e;n.readMdl(i),t.push(n)}loadPivotPointBlock(t){const e=t.readInt();t.read();for(let i=0;i<e;i++)this.pivotPoints.push(t.readVector(new Float32Array(3)));t.read()}loadBindPoseBlock(t){for(const e of t.readBlock()){if("Matrices"!==e)throw new Error(`Unknown token in BindPose: "${e}"`);{const e=t.readInt();t.read();for(let i=0;i<e;i++)this.bindPose[i]=t.readVector(new Float32Array(12));t.read()}}}saveMdl(){const t=new ts;return this.saveVersionBlock(t),this.saveModelBlock(t),this.saveStaticObjectsBlock(t,"Sequences",this.sequences),this.saveGlobalSequenceBlock(t),this.saveStaticObjectsBlock(t,"Textures",this.textures),this.saveStaticObjectsBlock(t,"Materials",this.materials),this.saveStaticObjectsBlock(t,"TextureAnims",this.textureAnimations),this.saveObjects(t,this.geosets),this.saveObjects(t,this.geosetAnimations),this.saveObjects(t,this.bones),this.saveObjects(t,this.lights),this.saveObjects(t,this.helpers),this.saveObjects(t,this.attachments),this.savePivotPointBlock(t),this.saveObjects(t,this.particleEmitters),this.saveObjects(t,this.particleEmitters2),this.version>800&&this.saveObjects(t,this.particleEmittersPopcorn),this.saveObjects(t,this.ribbonEmitters),this.saveObjects(t,this.cameras),this.saveObjects(t,this.eventObjects),this.saveObjects(t,this.collisionShapes),this.version>800&&(this.saveObjects(t,this.faceEffects),this.saveBindPoseBlock(t)),t.buffer}saveVersionBlock(t){t.startBlock("Version"),t.writeNumberAttrib("FormatVersion",this.version),t.endBlock()}saveModelBlock(t){t.startObjectBlock("Model",this.name),t.writeNumberAttrib("BlendTime",this.blendTime),this.extent.writeMdl(t),this.animationFile.length&&t.writeStringAttrib("AnimationFile",this.animationFile),t.endBlock()}saveStaticObjectsBlock(t,e,i){if(i.length){t.startBlock(e,i.length);for(const e of i)e.writeMdl(t,this.version);t.endBlock()}}saveGlobalSequenceBlock(t){if(this.globalSequences.length){t.startBlock("GlobalSequences",this.globalSequences.length);for(const e of this.globalSequences)t.writeNumberAttrib("Duration",e);t.endBlock()}}saveObjects(t,e){for(const i of e)i.writeMdl(t,this.version)}savePivotPointBlock(t){if(this.pivotPoints.length){t.startBlock("PivotPoints",this.pivotPoints.length);for(const e of this.pivotPoints)t.writeVector(e);t.endBlock()}}saveBindPoseBlock(t){if(this.bindPose.length){t.startBlock("BindPose"),t.startBlock("Matrices",this.bindPose.length);for(const e of this.bindPose)t.writeVector(e);t.endBlock(),t.endBlock()}}getByteLength(){let t=396;return t+=this.getStaticObjectsChunkByteLength(this.sequences,132),t+=this.getStaticObjectsChunkByteLength(this.globalSequences,4),t+=this.getDynamicObjectsChunkByteLength(this.materials),t+=this.getStaticObjectsChunkByteLength(this.textures,268),t+=this.getDynamicObjectsChunkByteLength(this.textureAnimations),t+=this.getDynamicObjectsChunkByteLength(this.geosets),t+=this.getDynamicObjectsChunkByteLength(this.geosetAnimations),t+=this.getDynamicObjectsChunkByteLength(this.bones),t+=this.getDynamicObjectsChunkByteLength(this.lights),t+=this.getDynamicObjectsChunkByteLength(this.helpers),t+=this.getDynamicObjectsChunkByteLength(this.attachments),t+=this.getStaticObjectsChunkByteLength(this.pivotPoints,12),t+=this.getDynamicObjectsChunkByteLength(this.particleEmitters),t+=this.getDynamicObjectsChunkByteLength(this.particleEmitters2),this.version>800&&(t+=this.getDynamicObjectsChunkByteLength(this.particleEmittersPopcorn)),t+=this.getDynamicObjectsChunkByteLength(this.ribbonEmitters),t+=this.getDynamicObjectsChunkByteLength(this.cameras),t+=this.getDynamicObjectsChunkByteLength(this.eventObjects),t+=this.getDynamicObjectsChunkByteLength(this.collisionShapes),this.version>800&&(t+=this.getStaticObjectsChunkByteLength(this.faceEffects,340),t+=this.getBindPoseChunkByteLength()),t+=this.getObjectsByteLength(this.unknownChunks),t}getObjectsByteLength(t){let e=0;for(const i of t)e+=i.getByteLength(this.version);return e}getDynamicObjectsChunkByteLength(t){return t.length?8+this.getObjectsByteLength(t):0}getStaticObjectsChunkByteLength(t,e){return t.length?8+t.length*e:0}getBindPoseChunkByteLength(){return this.bindPose.length?12+48*this.bindPose.length:0}}class rr{constructor(t,e,i){this.index=0,this.bitBuffer=0,this.bits=0;const n=h(t);e=e||0,i=i||n.length,this.buffer=t,this.uint8array=n.subarray(e,e+i),this.byteLength=t.byteLength}peekBits(t){return this.loadBits(t),this.bitBuffer&(1<<t)-1}readBits(t){const e=this.peekBits(t);return this.bitBuffer>>>=t,this.bits-=t,e}skipBits(t){this.loadBits(t),this.bitBuffer>>>=t,this.bits-=t}loadBits(t){for(;this.bits<t;)this.bitBuffer+=this.uint8array[this.index]<<this.bits,this.bits+=8,this.index+=1}}function ar(t,e){return((1<<e)-1)/((1<<t)-1)}let or="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},lr=function(){function t(t){this.message="JPEG error: "+t}return t.prototype=new Error,t.prototype.name="JpegError",t.constructor=t,t}(),hr=new Uint8Array([0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5,12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28,35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63]),cr=4017,dr=799,ur=3406,fr=2276,mr=1567,gr=3784,pr=5793,wr=2896;function br(t,e){let i,n,s=0,r=[],a=16;for(;a>0&&!t[a-1];)a--;r.push({children:[],index:0});let o,l=r[0];for(i=0;i<a;i++){for(n=0;n<t[i];n++){for(l=r.pop(),l.children[l.index]=e[s];l.index>0;)l=r.pop();for(l.index++,r.push(l);r.length<=i;)r.push(o={children:[],index:0}),l.children[l.index]=o.children,l=o;s++}i+1<a&&(r.push(o={children:[],index:0}),l.children[l.index]=o.children,l=o)}return r[0].children}function vr(t,e,i){return 64*((t.blocksPerLine+1)*e+i)}function yr(t,e,i,n,s,r,a,o,l){let h=i.mcusPerLine,c=i.progressive,d=e,u=0,f=0;function m(){if(f>0)return f--,u>>f&1;if(u=t[e++],255===u){let i=t[e++];if(i)throw new lr("unexpected marker "+(u<<8|i).toString(16))}return f=7,u>>>7}function g(t){let e=t;for(;;){if(e=e[m()],"number"==typeof e)return e;if("object"!==(void 0===e?"undefined":or(e)))throw new lr("invalid huffman sequence")}}function p(t){let e=0;for(;t>0;)e=e<<1|m(),t--;return e}function w(t){if(1===t)return 1===m()?1:-1;let e=p(t);return e>=1<<t-1?e:e+(-1<<t)+1}let b=0;let v,y=0;function _(t,e,i,n,s){let r=i%h;e(t,vr(t,(i/h|0)*t.v+n,r*t.h+s))}function x(t,e,i){e(t,vr(t,i/t.blocksPerLine|0,i%t.blocksPerLine))}let A,T,E,S,I,k,L=n.length;k=c?0===r?0===o?function(t,e){let i=g(t.huffmanTableDC),n=0===i?0:w(i)<<l;t.blockData[e]=t.pred+=n}:function(t,e){t.blockData[e]|=m()<<l}:0===o?function(t,e){if(b>0)return void b--;let i=r,n=a;for(;i<=n;){let n=g(t.huffmanTableAC),s=15&n,r=n>>4;if(0===s){if(r<15){b=p(r)+(1<<r)-1;break}i+=16;continue}i+=r;let a=hr[i];t.blockData[e+a]=w(s)*(1<<l),i++}}:function(t,e){let i,n,s=r,o=a,h=0;for(;s<=o;){let r=hr[s];switch(y){case 0:if(n=g(t.huffmanTableAC),i=15&n,h=n>>4,0===i)h<15?(b=p(h)+(1<<h),y=4):(h=16,y=1);else{if(1!==i)throw new lr("invalid ACn encoding");v=w(i),y=h?2:3}continue;case 1:case 2:t.blockData[e+r]?t.blockData[e+r]+=m()<<l:(h--,0===h&&(y=2===y?3:0));break;case 3:t.blockData[e+r]?t.blockData[e+r]+=m()<<l:(t.blockData[e+r]=v<<l,y=0);break;case 4:t.blockData[e+r]&&(t.blockData[e+r]+=m()<<l)}s++}4===y&&(b--,0===b&&(y=0))}:function(t,e){let i=g(t.huffmanTableDC),n=0===i?0:w(i);t.blockData[e]=t.pred+=n;let s=1;for(;s<64;){let i=g(t.huffmanTableAC),n=15&i,r=i>>4;if(0===n){if(r<15)break;s+=16;continue}s+=r;let a=hr[s];t.blockData[e+a]=w(n),s++}};let M,C,R,B,U=0;for(C=1===L?n[0].blocksPerLine*n[0].blocksPerColumn:h*i.mcusPerColumn;U<C;){let i=s?Math.min(C-U,s):C;for(T=0;T<L;T++)n[T].pred=0;if(b=0,1===L)for(A=n[0],I=0;I<i;I++)x(A,k,U),U++;else for(I=0;I<i;I++){for(T=0;T<L;T++)for(A=n[T],R=A.h,B=A.v,E=0;E<B;E++)for(S=0;S<R;S++)_(A,k,U,E,S);U++}f=0,M=Ar(t,e),M&&M.invalid&&(e=M.offset);let r=M&&M.marker;if(!r||r<=65280)throw new lr("marker was not found");if(!(r>=65488&&r<=65495))break;e+=2}return M=Ar(t,e),M&&M.invalid&&(e=M.offset),e-d}function _r(t,e,i){let n,s,r,a,o,l,h,c,d,u,f,m,g,p,w,b,v,y=t.quantizationTable,_=t.blockData;if(!y)throw new lr("missing required Quantization Table.");for(let t=0;t<64;t+=8)d=_[e+t],u=_[e+t+1],f=_[e+t+2],m=_[e+t+3],g=_[e+t+4],p=_[e+t+5],w=_[e+t+6],b=_[e+t+7],d*=y[t],0!=(u|f|m|g|p|w|b)?(u*=y[t+1],f*=y[t+2],m*=y[t+3],g*=y[t+4],p*=y[t+5],w*=y[t+6],b*=y[t+7],n=pr*d+128>>8,s=pr*g+128>>8,r=f,a=w,o=wr*(u-b)+128>>8,c=wr*(u+b)+128>>8,l=m<<4,h=p<<4,n=n+s+1>>1,s=n-s,v=r*gr+a*mr+128>>8,r=r*mr-a*gr+128>>8,a=v,o=o+h+1>>1,h=o-h,c=c+l+1>>1,l=c-l,n=n+a+1>>1,a=n-a,s=s+r+1>>1,r=s-r,v=o*fr+c*ur+2048>>12,o=o*ur-c*fr+2048>>12,c=v,v=l*dr+h*cr+2048>>12,l=l*cr-h*dr+2048>>12,h=v,i[t]=n+c,i[t+7]=n-c,i[t+1]=s+h,i[t+6]=s-h,i[t+2]=r+l,i[t+5]=r-l,i[t+3]=a+o,i[t+4]=a-o):(v=pr*d+512>>10,i[t]=v,i[t+1]=v,i[t+2]=v,i[t+3]=v,i[t+4]=v,i[t+5]=v,i[t+6]=v,i[t+7]=v);for(let t=0;t<8;++t)d=i[t],u=i[t+8],f=i[t+16],m=i[t+24],g=i[t+32],p=i[t+40],w=i[t+48],b=i[t+56],0!=(u|f|m|g|p|w|b)?(n=pr*d+2048>>12,s=pr*g+2048>>12,r=f,a=w,o=wr*(u-b)+2048>>12,c=wr*(u+b)+2048>>12,l=m,h=p,n=4112+(n+s+1>>1),s=n-s,v=r*gr+a*mr+2048>>12,r=r*mr-a*gr+2048>>12,a=v,o=o+h+1>>1,h=o-h,c=c+l+1>>1,l=c-l,n=n+a+1>>1,a=n-a,s=s+r+1>>1,r=s-r,v=o*fr+c*ur+2048>>12,o=o*ur-c*fr+2048>>12,c=v,v=l*dr+h*cr+2048>>12,l=l*cr-h*dr+2048>>12,h=v,d=n+c,b=n-c,u=s+h,w=s-h,f=r+l,p=r-l,m=a+o,g=a-o,d=d<16?0:d>=4080?255:d>>4,u=u<16?0:u>=4080?255:u>>4,f=f<16?0:f>=4080?255:f>>4,m=m<16?0:m>=4080?255:m>>4,g=g<16?0:g>=4080?255:g>>4,p=p<16?0:p>=4080?255:p>>4,w=w<16?0:w>=4080?255:w>>4,b=b<16?0:b>=4080?255:b>>4,_[e+t]=d,_[e+t+8]=u,_[e+t+16]=f,_[e+t+24]=m,_[e+t+32]=g,_[e+t+40]=p,_[e+t+48]=w,_[e+t+56]=b):(v=pr*d+8192>>14,v=v<-2040?0:v>=2024?255:v+2056>>4,_[e+t]=v,_[e+t+8]=v,_[e+t+16]=v,_[e+t+24]=v,_[e+t+32]=v,_[e+t+40]=v,_[e+t+48]=v,_[e+t+56]=v)}function xr(t,e){let i=e.blocksPerLine,n=e.blocksPerColumn,s=new Int16Array(64);for(let t=0;t<n;t++)for(let n=0;n<i;n++){_r(e,vr(e,t,n),s)}return e.blockData}function Ar(t,e,i){function n(e){return t[e]<<8|t[e+1]}let s=t.length-1,r=i<e?i:e;if(e>=s)return null;let a=n(e);if(a>=65472&&a<=65534)return{invalid:null,marker:a,offset:e};let o=n(r);for(;!(o>=65472&&o<=65534);){if(++r>=s)return null;o=n(r)}return{invalid:a.toString(16),marker:o,offset:r}}class Tr{constructor(){this.decodeTransform=null,this.colorTransform=-1,this.width=0,this.height=0}parse(t){function e(){let e=t[s]<<8|t[s+1];return s+=2,e}function i(){let i=e(),n=s+i-2,r=Ar(t,n,s);r&&r.invalid&&(n=r.offset);let a=t.subarray(s,n);return s+=a.length,a}function n(t){let e=Math.ceil(t.samplesPerLine/8/t.maxH),i=Math.ceil(t.scanLines/8/t.maxV);for(let n=0;n<t.components.length;n++){A=t.components[n];let s=Math.ceil(Math.ceil(t.samplesPerLine/8)*A.h/t.maxH),r=Math.ceil(Math.ceil(t.scanLines/8)*A.v/t.maxV),a=e*A.h,o=64*(i*A.v)*(a+1);A.blockData=new Int16Array(o),A.blocksPerLine=s,A.blocksPerColumn=r}t.mcusPerLine=e,t.mcusPerColumn=i}var s=0;let r,a,o=null,l=null,h=[],c=[],d=[],u=e();if(65496!==u)throw new lr("SOI not found");for(u=e();65497!==u;){var f,m,g;switch(u){case 65504:case 65505:case 65506:case 65507:case 65508:case 65509:case 65510:case 65511:case 65512:case 65513:case 65514:case 65515:case 65516:case 65517:case 65518:case 65519:case 65534:var p=i();65504===u&&74===p[0]&&70===p[1]&&73===p[2]&&70===p[3]&&0===p[4]&&(o={version:{major:p[5],minor:p[6]},densityUnits:p[7],xDensity:p[8]<<8|p[9],yDensity:p[10]<<8|p[11],thumbWidth:p[12],thumbHeight:p[13],thumbData:p.subarray(14,14+3*p[12]*p[13])}),65518===u&&65===p[0]&&100===p[1]&&111===p[2]&&98===p[3]&&101===p[4]&&(l={version:p[5]<<8|p[6],flags0:p[7]<<8|p[8],flags1:p[9]<<8|p[10],transformCode:p[11]});break;case 65499:for(var w=e()+s-2;s<w;){let i=t[s++],n=new Uint16Array(64);if(i>>4==0)for(m=0;m<64;m++)n[hr[m]]=t[s++];else{if(i>>4!=1)throw new lr("DQT - invalid table spec");for(m=0;m<64;m++)n[hr[m]]=e()}h[15&i]=n}break;case 65472:case 65473:case 65474:if(r)throw new lr("Only single frame JPEGs supported");e(),r={},r.extended=65473===u,r.progressive=65474===u,r.precision=t[s++],r.scanLines=e(),r.samplesPerLine=e(),r.components=[],r.componentIds={};var b,v=t[s++],y=0,_=0;for(f=0;f<v;f++){b=t[s];let e=t[s+1]>>4,i=15&t[s+1];y<e&&(y=e),_<i&&(_=i);let n=t[s+2];g=r.components.push({h:e,v:i,quantizationId:n,quantizationTable:null}),r.componentIds[b]=g-1,s+=3}r.maxH=y,r.maxV=_,n(r);break;case 65476:var x=e();for(f=2;f<x;){let e=t[s++],i=new Uint8Array(16),n=0;for(m=0;m<16;m++,s++)n+=i[m]=t[s];let r=new Uint8Array(n);for(m=0;m<n;m++,s++)r[m]=t[s];f+=17+n,(e>>4==0?d:c)[15&e]=br(i,r)}break;case 65501:e(),a=e();break;case 65498:e();var A,T=t[s++],E=[];for(f=0;f<T;f++){let e=r.componentIds[t[s++]];A=r.components[e];let i=t[s++];A.huffmanTableDC=d[i>>4],A.huffmanTableAC=c[15&i],E.push(A)}var S=t[s++],I=t[s++],k=t[s++],L=yr(t,s,r,E,a,S,I,k>>4,15&k);s+=L;break;case 65535:255!==t[s]&&s--;break;default:if(255===t[s-3]&&t[s-2]>=192&&t[s-2]<=254){s-=3;break}throw new lr("unknown marker "+u.toString(16))}u=e()}for(this.width=r.samplesPerLine,this.height=r.scanLines,this.jfif=o,this.adobe=l,this.components=[],f=0;f<r.components.length;f++){let t=h[(A=r.components[f]).quantizationId];t&&(A.quantizationTable=t),this.components.push({output:xr(0,A),scaleX:A.h/r.maxH,scaleY:A.v/r.maxV,blocksPerLine:A.blocksPerLine,blocksPerColumn:A.blocksPerColumn})}this.numComponents=this.components.length}getData(t){let e=t.data,i=this.components,n=new Uint8Array((i[0].blocksPerLine<<3)*i[0].blocksPerColumn*8);[i[0],i[2]]=[i[2],i[0]];for(let t=0,o=i.length;t<o;t++){let l=i[t],h=l.blocksPerLine,c=l.blocksPerColumn,d=h<<3;var s,r,a=0;for(let t=0;t<c;t++){let e=t<<3;for(let i=0;i<h;i++){let o=vr(l,t,i),h=0,c=i<<3;for(s=0;s<8;s++){a=(e+s)*d;for(r=0;r<8;r++)n[a+c+r]=l.output[o+h++]}}}let u=t;for(let t=0;t<this.height;t++)for(let i=0;i<this.width;i++)e[u]=n[t*d+i],u+=o}return e}}class Er{constructor(){this.content=0,this.alphaBits=0,this.width=0,this.height=0,this.type=0,this.hasMipmaps=!1,this.mipmapOffsets=new Uint32Array(16),this.mipmapSizes=new Uint32Array(16),this.uint8array=null,this.jpgHeader=null,this.pallete=null}load(t){const e=h(t),i=new Int32Array(e.buffer,0,40);if(827345986!==i[0])throw new Error("WrongMagicNumber");this.content=i[1],this.alphaBits=i[2],this.width=i[3],this.height=i[4],this.type=i[5],this.hasMipmaps=0!==i[6];for(let t=0;t<16;t++)this.mipmapOffsets[t]=i[7+t],this.mipmapSizes[t]=i[23+t];this.uint8array=e,0===this.content?this.jpgHeader=e.subarray(160,160+i[39]):this.pallete=e.subarray(156,1180)}getMipmap(t){const e=this.uint8array,i=this.mipmapOffsets[t],n=this.mipmapSizes[t];let s;if(0===this.content){const t=this.jpgHeader,r=new Uint8Array(t.length+n),a=new Tr;r.set(t),r.set(e.subarray(i,i+n),t.length),a.parse(r),s=new ImageData(a.width,a.height),a.getData(s)}else{const n=this.pallete,r=Math.max(this.width/(1<<t),1),a=Math.max(this.height/(1<<t),1),o=r*a;let l,h=this.alphaBits,c=0;s=new ImageData(r,a),h>0&&(h>8&&(h=8),l=new rr(e.buffer,i+o,Math.ceil(o*h/8)),c=ar(h,8));const d=s.data;for(let t=0;t<o;t++){const s=4*t,r=4*e[i+t];d[s]=n[r+2],d[s+1]=n[r+1],d[s+2]=n[r],d[s+3]=h>0?l.readBits(h)*c:255}}return s}mipmaps(){let t=0;for(const e of this.mipmapSizes)e>0&&(t+=1);return t}fakeMipmaps(){const t=this.mipmapOffsets;let e=0;for(let i=0;i<16;i++){const n=t[i];if(n>0)for(let s=i+1;s<16;s++)if(n===t[s]){e+=1;break}}return e}}const Sr=ar(4,8),Ir=ar(5,8),kr=ar(6,8),Lr=new Uint8Array(16),Mr=new Uint8Array(12),Cr=new Uint8Array(8),Rr=new Uint8Array(8),Br=new Uint8Array(8);function Ur(t,e,i){const n=(e>>11&31)*Ir,s=(e>>5&63)*kr,r=(31&e)*Ir,a=(i>>11&31)*Ir,o=(i>>5&63)*kr,l=(31&i)*Ir;t[0]=n,t[1]=s,t[2]=r,t[3]=255,t[4]=a,t[5]=o,t[6]=l,t[7]=255,e>i?(t[8]=5*n+3*a>>3,t[9]=5*s+3*o>>3,t[10]=5*r+3*l>>3,t[11]=255,t[12]=5*a+3*n>>3,t[13]=5*o+3*s>>3,t[14]=5*l+3*r>>3,t[15]=255):(t[8]=n+a>>1,t[9]=s+o>>1,t[10]=r+l>>1,t[11]=255,t[12]=0,t[13]=0,t[14]=0,t[15]=0)}function Pr(t,e,i){const n=(e>>11&31)*Ir,s=(e>>5&63)*kr,r=(31&e)*Ir,a=(i>>11&31)*Ir,o=(i>>5&63)*kr,l=(31&i)*Ir;t[0]=n,t[1]=s,t[2]=r,t[3]=a,t[4]=o,t[5]=l,t[6]=5*n+3*a>>3,t[7]=5*s+3*o>>3,t[8]=5*r+3*l>>3,t[9]=5*a+3*n>>3,t[10]=5*o+3*s>>3,t[11]=5*l+3*r>>3}function Fr(t,e,i){t[0]=e,t[1]=i,e>i?(t[2]=(6*e+1*i)/7,t[3]=(5*e+2*i)/7,t[4]=(4*e+3*i)/7,t[5]=(3*e+4*i)/7,t[6]=(2*e+5*i)/7,t[7]=(1*e+6*i)/7):(t[2]=(4*e+1*i)/5,t[3]=(3*e+2*i)/5,t[4]=(2*e+3*i)/5,t[5]=(1*e+4*i)/5,t[6]=0,t[7]=1)}const Nr=827611204,Dr=861165636,Or=894720068,Vr=843666497;class Gr{constructor(){this.width=0,this.height=0,this.format=0,this.mipmapWidths=[],this.mipmapHeights=[],this.mipmapDatas=[]}load(t){const e=h(t),i=new Int32Array(e.buffer,0,31);let n=128;if(542327876!==i[0])throw new Error("Wrong magic number");if(!(4&i[20]))throw new Error("Not FourCC");let s=i[21];if(s!==Nr&&s!==Dr&&s!==Or&&s!==Vr){if(808540228!==s)throw new Error(`Unsupported FourCC: ${function(t){const e=[];for(;t>0;)e.push(String.fromCharCode(t%256)),t=Math.floor(t/256);return e.reverse().join("")}(s)}`);{n+=20;const t=new Int32Array(e.buffer,128,5),i=t[0];if(71===i)s=Nr;else if(74===i)s=Dr;else if(77===i)s=Or;else{if(83!==i)throw new Error(`Unsupported DXGI format: ${i}`);s=Vr}console.log(t)}}this.format=s;let r=1;131072&i[2]&&(r=Math.max(1,i[7]));let a=i[4],o=i[3],l=16;s===Nr&&(l=8),this.width=a,this.height=o;for(let t=0;t<r;t++){const i=Math.max(4,a)/4*Math.max(4,o)/4*l;this.mipmapWidths[t]=a,this.mipmapHeights[t]=o,this.mipmapDatas[t]=e.subarray(n,n+i),n+=i,a=Math.max(a/2,1),o=Math.max(o/2,1)}}mipmaps(){return this.mipmapDatas.length}getMipmap(t,e=!1){const i=this.mipmapWidths[t],n=this.mipmapHeights[t],s=this.mipmapDatas[t];let r;return r=e?s:this.format===Nr?function(t,e,i){const n=new Uint8Array(e*i*4);for(let s=0,r=i/4;s<r;s++)for(let i=0,r=e/4;i<r;i++){const a=8*(s*r+i);Ur(Lr,t[a]+256*t[a+1],t[a+2]+256*t[a+3]);const o=16*s*e+16*i,l=t[a+4]|t[a+5]<<8|t[a+6]<<16|t[a+7]<<24;for(let t=0;t<4;t++){const i=8*t,s=o+t*e*4;for(let t=0;t<4;t++){const e=s+4*t,r=4*(l>>i+2*t&3);n[e+0]=Lr[r+0],n[e+1]=Lr[r+1],n[e+2]=Lr[r+2],n[e+3]=Lr[r+3]}}}return n}(s,i,n):this.format===Dr?function(t,e,i){const n=new Uint8Array(e*i*4),s=4*e;for(let r=0,a=i/4;r<a;r++)for(let i=0,a=e/4;i<a;i++){const o=16*(r*a+i);Pr(Mr,t[o+8]+256*t[o+9],t[o+10]+256*t[o+11]);let l=16*r*e+16*i;for(let e=0;e<4;e++){const i=t[o+2*e]+256*t[o+1+2*e],r=t[o+12+e];for(let t=0;t<4;t++){const e=l+4*t,s=3*(r>>2*t&3);n[e+0]=Mr[s+0],n[e+1]=Mr[s+1],n[e+2]=Mr[s+2],n[e+3]=(i>>4*t&15)*Sr}l+=s}}return n}(s,i,n):this.format===Or?function(t,e,i){const n=new Uint8Array(e*i*4),s=4*e;for(let l=0,h=i/4;l<h;l++)for(let i=0,h=e/4;i<h;i++){const c=16*(l*h+i);r=Cr,a=t[c],o=t[c+1],r[0]=a,r[1]=o,a>o?(r[2]=54*a+9*o>>6,r[3]=45*a+18*o>>6,r[4]=36*a+27*o>>6,r[5]=27*a+36*o>>6,r[6]=18*a+45*o>>6,r[7]=9*a+54*o>>6):(r[2]=12*a+3*o>>4,r[3]=9*a+6*o>>4,r[4]=6*a+9*o>>4,r[5]=3*a+12*o>>4,r[6]=0,r[7]=255),Pr(Mr,t[c+8]+256*t[c+9],t[c+10]+256*t[c+11]);let d=16*l*e+16*i;for(let e=0;e<2;e++){const i=c+2+3*e,r=c+12+2*e,a=t[i]+256*(t[i+1]+256*t[i+2]);for(let e=0;e<2;e++){const i=t[r+e];for(let t=0;t<4;t++){const s=d+4*t,r=3*(i>>2*t&3),o=a>>12*e+3*t&7;n[s+0]=Mr[r+0],n[s+1]=Mr[r+1],n[s+2]=Mr[r+2],n[s+3]=Cr[o]}d+=s}}}var r,a,o;return n}(s,i,n):function(t,e,i){const n=new Uint8Array(e*i*2),s=2*e;for(let r=0,a=i/4;r<a;r++)for(let i=0,a=e/4;i<a;i++){const o=16*(r*a+i);Fr(Rr,t[o],t[o+1]),Fr(Br,t[o+8],t[o+9]);let l=8*r*e+8*i;for(let e=0;e<2;e++){const i=o+3*e,r=t[i+2]+256*(t[i+3]+256*t[i+4]),a=t[i+10]+256*(t[i+11]+256*t[i+12]);for(let t=0;t<2;t++){const e=4*t;for(let t=0;t<4;t++){const i=l+2*t,s=3*(e+t);n[i+1]=Rr[r>>s&7],n[i+2]=Br[a>>s&7]}l+=s}}}return n}(s,i,n),{width:i,height:n,data:r}}}class jr{constructor(){this.width=0,this.height=0,this.data=null}load(t){const e=h(t),i=new class{_checkHeader(){const t=this.header;if(0===t.imageType)throw Error("No data");if(t.hasColorMap){if(t.colorMapLength>256||24!==t.colorMapDepth||1!==t.colorMapType)throw Error("Invalid colormap for indexed type")}else if(t.colorMapType)throw Error("Why does the image contain a palette ?");if(!t.width||!t.height)throw Error("Invalid image size");if(8!==t.pixelDepth&&16!==t.pixelDepth&&24!==t.pixelDepth&&32!==t.pixelDepth)throw Error('Invalid pixel size "'+t.pixelDepth+'"')}_decodeRLE(t,e,i,n){const s=new Uint8Array(n),r=new Uint8Array(i);let a=0;for(;a<n;){const n=t[e++];let o=1+(127&n);if(128&n){for(let n=0;n<i;++n)r[n]=t[e+n];e+=i;for(let t=0;t<o;++t)s.set(r,a),a+=i}else{o*=i;for(let i=0;i<o;++i)s[a+i]=t[e+i];a+=o,e+=o}}return s}_getImageData8bits(t,e,i,n,s,r,a,o,l,h){for(let c=0,d=s;d!==a;d+=r)for(let s=o;s!==h;s+=l,c++){const r=e[c];t[4*(s+n*d)+3]=255,t[4*(s+n*d)+2]=i[3*r+0],t[4*(s+n*d)+1]=i[3*r+1],t[4*(s+n*d)+0]=i[3*r+2]}return t}_getImageData16bits(t,e,i,n,s,r,a,o,l,h){for(let i=0,c=s;c!==a;c+=r)for(let s=o;s!==h;s+=l,i+=2){const r=e[i+0]|e[i+1]<<8;t[4*(s+n*c)+0]=(31744&r)>>7,t[4*(s+n*c)+1]=(992&r)>>2,t[4*(s+n*c)+2]=(31&r)>>3,t[4*(s+n*c)+3]=32768&r?0:255}return t}_getImageData24bits(t,e,i,n,s,r,a,o,l,h){for(let i=0,c=s;c!==a;c+=r)for(let s=o;s!==h;s+=l,i+=3)t[4*(s+n*c)+3]=255,t[4*(s+n*c)+2]=e[i+0],t[4*(s+n*c)+1]=e[i+1],t[4*(s+n*c)+0]=e[i+2];return t}_getImageData32bits(t,e,i,n,s,r,a,o,l,h){for(let i=0,c=s;c!==a;c+=r)for(let s=o;s!==h;s+=l,i+=4)t[4*(s+n*c)+2]=e[i+0],t[4*(s+n*c)+1]=e[i+1],t[4*(s+n*c)+0]=e[i+2],t[4*(s+n*c)+3]=e[i+3];return t}_getImageDataGrey8bits(t,e,i,n,s,r,a,o,l,h){for(let i=0,c=s;c!==a;c+=r)for(let s=o;s!==h;s+=l,i++){const r=e[i];t[4*(s+n*c)+0]=r,t[4*(s+n*c)+1]=r,t[4*(s+n*c)+2]=r,t[4*(s+n*c)+3]=255}return t}_getImageDataGrey16bits(t,e,i,n,s,r,a,o,l,h){for(let i=0,c=s;c!==a;c+=r)for(let s=o;s!==h;s+=l,i+=2)t[4*(s+n*c)+0]=e[i+0],t[4*(s+n*c)+1]=e[i+0],t[4*(s+n*c)+2]=e[i+0],t[4*(s+n*c)+3]=e[i+1];return t}open(t,e){const i=new XMLHttpRequest;i.responseType="arraybuffer",i.open("GET",t,!0),i.onload=()=>{200===i.status&&(this.load(new Uint8Array(i.response)),e&&e())},i.send(null)}load(t){let e=0;if(t.length<18)throw Error("Not enough data to contain header");const i={idLength:t[e++],colorMapType:t[e++],imageType:t[e++],colorMapIndex:t[e++]|t[e++]<<8,colorMapLength:t[e++]|t[e++]<<8,colorMapDepth:t[e++],offsetX:t[e++]|t[e++]<<8,offsetY:t[e++]|t[e++]<<8,width:t[e++]|t[e++]<<8,height:t[e++]|t[e++]<<8,pixelDepth:t[e++],flags:t[e++]};if(i.hasEncoding=9===i.imageType||10===i.imageType||11===i.imageType,i.hasColorMap=9===i.imageType||1===i.imageType,i.isGreyColor=11===i.imageType||3===i.imageType,this.header=i,this._checkHeader(),(e+=i.idLength)>=t.length)throw Error("No data");if(i.hasColorMap){const n=i.colorMapLength*(i.colorMapDepth>>3);this.palette=t.subarray(e,e+n),e+=n}const n=i.pixelDepth>>3,s=i.width*i.height,r=s*n;i.hasEncoding?this.imageData=this._decodeRLE(t,e,n,r):this.imageData=t.subarray(e,e+(i.hasColorMap?s:r))}getImageData(t){const{width:e,height:i,flags:n,pixelDepth:s,isGreyColor:r}=this.header,a=(48&n)>>4;let o,l,h,c,d,u,f;switch(t||(t=document?document.createElement("canvas").getContext("2d").createImageData(e,i):{width:e,height:i,data:new Uint8ClampedArray(e*i*4)}),2===a||3===a?(c=0,d=1,u=i):(c=i-1,d=-1,u=-1),2===a||0===a?(o=0,l=1,h=e):(o=e-1,l=-1,h=-1),s){case 8:f=r?this._getImageDataGrey8bits:this._getImageData8bits;break;case 16:f=r?this._getImageDataGrey16bits:this._getImageData16bits;break;case 24:f=this._getImageData24bits;break;case 32:f=this._getImageData32bits}return f.call(this,t.data,this.imageData,this.palette,e,c,d,u,o,l,h),t}getCanvas(){const{width:t,height:e}=this.header,i=document.createElement("canvas"),n=i.getContext("2d"),s=n.createImageData(t,e);return i.width=t,i.height=e,n.putImageData(this.getImageData(s),0,0),i}getDataURL(t){return this.getCanvas().toDataURL(t||"image/png")}};i.load(e);const n=i.header;this.width=n.width,this.height=n.height,this.data=new ImageData(n.width,n.height),i.getImageData(this.data)}}let Kr,$r,zr,qr;function Hr(t){const e=new Image;return e.src=function(t){return Kr.width=t.width,Kr.height=t.height,$r.putImageData(t,0,0),Kr.toDataURL()}(t),e}function Xr(t){return t.reverse().filter(((t,e,i)=>-1===i.indexOf(t,e+1))).reverse()}function Wr(t,e,i){if(-1===i){const i=t.model.sequences;for(let t=0,n=i.length;t<n;t++){const n=i[t].interval;if(e>=n[0]&&e<=n[1])return t}}else{const n=t.model.globalSequences[i];if(e>=0&&e<=n)return i}return-1}"object"==typeof window&&(Kr=document.createElement("canvas"),$r=Kr.getContext("2d"),zr=document.createElement("canvas"),qr=zr.getContext("2d"));function Yr(t,e,i){let n=0;for(let s=0,r=t.length;s<r;s++){const r=t[s],a=Math.abs(r-e[s]),o=Math.abs(r-i[s]);a>n&&(n=a),o>n&&(n=o)}return n}function Zr(t,e,i,n,s){const{globalSequenceId:r,interpolationType:a,values:o}=n;let l;l=-1===r?t.model.sequences[i].interval[0]:0;const h=e[0],c=e[e.length-1],d=s[h];if(0!==a&&d!==l){(function(t,e){for(let i=0,n=t.length;i<n;i++)if(t[i]!==e[i])return!1;return!0})(o[h],o[c])||t.addSevere(`Missing opening track for ${function(t,e,i){return-1===i?`sequence "${t.model.sequences[e].name}"`:`global sequence ${i}`}(t,i,r)} at frame ${l} where it is needed`)}if(e.length>2){let i=o[e[0]],n=o[e[1]];for(let r=2,a=e.length;r<a;r++){const a=o[e[r]],l=e[r-1],h=Yr(i,n,a);0===h?t.addUnused(`Track ${l} at frame ${s[l]} has exactly the same value as tracks ${l-1} and ${l+1}`):h<.001&&t.addUnused(`Track ${l} at frame ${s[l]} has roughly the same value as tracks ${l-1} and ${l+1}`),i=n,n=a}}}function Qr(t,e){let i;e instanceof ks?(t.assertWarning(e.frames.length>0,"Zero tracks"),i=e.frames):(t.assertError(e.tracks.length>0,"Zero tracks"),i=e.tracks);const n=e.globalSequenceId,s=[];if(-1===n){t.assertWarning(t.model.sequences.length>0,"This animation exists, but the model has no sequences");for(let e=0,i=t.model.sequences.length;e<i;e++)s.push([])}else{if(!aa(t,t.model.globalSequences,n,"global sequence"))return;s[n]=[]}if(function(t,e,i,n){let s=-1/0;for(let r=0,a=e.length;r<a;r++){const a=e[r];t.assertWarning(a>=0,`Track ${r} has a negative frame ${a}`),a===s?t.addWarning(`Track ${r} has the same frame ${a} as track ${r-1}`):a<s&&t.addSevere(`Track ${r} at frame ${a} is lower than the track before it at ${s}`);const o=Wr(t,a,i);-1!==o?n[o].push(r):0!==a&&e.length>1&&(-1===i?t.addUnused(`Track ${r} at frame ${a} is not in any sequence`):t.addUnused(`Track ${r} at frame ${a} is not in global sequence ${i}`)),s=a}}(t,i,n,s),e instanceof ks)for(let n=0,r=s.length;n<r;n++){const r=s[n];r&&r.length>1&&Zr(t,r,n,e,i)}}const Jr=new Set(["attack","birth","cinematic","death","decay","dissipate","morph","portrait","sleep","spell","stand","walk","ready"]),ta=new Set([1,2,11,21,31,32,33,34,35,36,37]),ea=new Map([["KMTF","Texture ID"],["KMTA","Alpha"],["KMTE","Emissive Gain"],["KFC3","Fresnel Color"],["KFCA","Fresnel Opacity"],["KFTC","Fresnel Team Color"],["KTAT","Translation"],["KTAR","Rotation"],["KTAS","Scaling"],["KGAO","Alpha"],["KGAC","Color"],["KGTR","Translation"],["KGRT","Rotation"],["KGSC","Scaling"],["KLAS","Attenuation Start"],["KLAE","Attenuation End"],["KLAC","Color"],["KLAI","Intensity"],["KLBI","Ambient Intensity"],["KLBC","Ambient Color"],["KLAV","Visibility"],["KATV","Visibility"],["KPEE","Emission Rate"],["KPEG","Gravity"],["KPLN","Longitude"],["KPLT","Latitude"],["KPEL","Lifespan"],["KPES","Speed"],["KPEV","Visibility"],["KP2E","Emission Rate"],["KP2G","Gravity"],["KP2L","Latitude"],["KP2R","Variation"],["KP2N","Length"],["KP2W","Width"],["KP2S","Speed"],["KP2V","Visibility"],["KPPA","Alpha"],["KPPC","Color"],["KPPE","EmissionRate"],["KPPL","LifeSpan"],["KPPS","Speed"],["KPPV","Visibility"],["KRHA","Height Above"],["KRHB","Height Below"],["KRAL","Alpha"],["KRCO","Color"],["KRTX","Texture Slot"],["KRVS","Visibility"],["KCTR","Translation"],["KTTR","Rotation"],["KCRL","Target Translation"]]);function ia(t){return t instanceof Ss?"Extent":t instanceof Is?"Sequence":"number"==typeof t?"GlobalSequence":t instanceof Ds?"Texture":t instanceof Ns?"Material":t instanceof Fs?"Layer":t instanceof Os?"TextureAnimation":t instanceof Vs?"Geoset":t instanceof Gs?"GeosetAnimation":t instanceof Ks?"Bone":t instanceof $s?"Light":t instanceof zs?"Helper":t instanceof qs?"Attachment":t instanceof Hs?"ParticleEmitter":t instanceof Xs?"ParticleEmitter2":t instanceof Ws?"ParticleEmitterPopcorn":t instanceof Ys?"RibbonEmitter":t instanceof Qs?"EventObject":t instanceof Zs?"Camera":t instanceof Js?"CollisionShape":t instanceof tr?"FaceEffect":t instanceof ks?ea.get(t.name):(console.warn("Unknown object type",t),"Unknown")}function na(e,i){let n=ia(e);return e instanceof ks||e instanceof Ss||(n+=` ${i}`),(e instanceof Is||e instanceof js||e instanceof Zs)&&(n+=` - "${e.name}"`),(e instanceof Ds||e instanceof tr)&&(e.path.length&&(n+=` - "${t(e.path)}"`),e instanceof Ds&&(1===e.replaceableId?n+=" - Team color":2===e.replaceableId?n+=" - Team glow":e.replaceableId>0&&(n+=` - Replaceable ID ${e.replaceableId}`))),n}function sa(t,e,i){const n=e.length;if(n){const s=e[0]instanceof Us,r=e[0]instanceof js;for(let a=0;a<n;a++){const n=e[a];if(t.push(n,a),i&&i(t,n,a),s){sa(t,n.animations,ha)}if(r){const e=n,i=e.objectId,s=e.parentId;t.assertError(-1===s||la(t,s),`Invalid parent ${s}`),t.assertError(i!==s,"Same object and parent")}t.pop()}}}function ra(t,e,i,n){return i>=0&&i<e.length?(t.addReference(e[i]),e[i]):void t.addError(`Invalid ${n} ${i}`)}function aa(t,e,i,n){return void 0!==ra(t,e,i,n)}function oa(t,e,i,n){const s=t.objects[i];var r,a;if(n&&t.assertError((a=255,(r=i)>=0&&r<=a),`Vertex ${e}: References bone ${i} but there can only be 256 bones in an HD model`),s)if(s instanceof Ks){const e=t.boneUsageMap.get(i)||0;t.boneUsageMap.set(i,e+1)}else t.addSevere(`Vertex ${e}: Attached to "${s.name}" which is not a bone`);else t.addError(`Vertex ${e}: Attached to object ${i} which does not exist`)}function la(t,e){for(const i of t.objects)if(i.objectId===e)return!0;return!1}function ha(t,e){const i=e.name,n=e.interpolationType;t.assertWarning("KP2R"!==i,"Using a variation animation."),t.assertWarning("KP2G"!==i,"Using a gravity animation."),t.assertWarning("Visibility"!==ea.get(i)||0===n,"Interpolation type not set to None"),Qr(t,e)}function ca(t){const e=t.nodes;for(let t=e.length-1;t>=0;t--){const i=e[t];"node"===i.type&&(i.errors||i.severe||i.warnings||i.unused||void 0!==i.uses&&!i.uses?ca(i):e.splice(t,1))}}function da(t,e){t.push(e,0);const{max:i,min:n}=e;(i[0]-n[0]<0||i[1]-n[1]<0||i[2]-n[2]<0)&&t.addWarning("Negative extents"),t.pop()}class ua{constructor(t){this.objects=[],this.map=new Map,this.foundStand=!1,this.foundDeath=!1,this.boneUsageMap=new Map,this.model=t,this.current={type:"node",name:"",errors:0,severe:0,warnings:0,unused:0,nodes:[]},this.stack=[this.current],this.addObjects(t.sequences),this.addObjects(t.globalSequences),this.addObjects(t.textures),this.addObjects(t.materials),this.addObjects(t.textureAnimations),this.addObjects(t.geosets),this.addObjects(t.geosetAnimations),this.addObjects(t.bones),this.addObjects(t.lights),this.addObjects(t.helpers),this.addObjects(t.attachments),this.addObjects(t.particleEmitters),this.addObjects(t.particleEmitters2),this.addObjects(t.particleEmittersPopcorn),this.addObjects(t.ribbonEmitters),this.addObjects(t.cameras),this.addObjects(t.eventObjects),this.addObjects(t.collisionShapes),this.addObjects(t.faceEffects)}addObjects(t){if(t.length){const e=t[0]instanceof js;for(let i=0,n=t.length;i<n;i++){const n=t[i],s={type:"node",name:na(n,i),errors:0,severe:0,warnings:0,unused:0,nodes:[]};e||(s.uses=0),this.map.set(n,s)}e&&this.objects.push(...t)}}push(t,e){let i=this.map.get(t);if(!i){i={type:"node",name:na(t,e),errors:0,severe:0,warnings:0,unused:0,nodes:[]}}this.current.nodes.push(i),this.current=i,this.stack.unshift(i)}pop(){this.stack.shift(),this.current=this.stack[0]}addReference(t){const e=this.map.get(t);void 0!==e.uses&&(e.uses+=1)}addImplicitReference(){const t=this.current;void 0!==t.uses&&(t.uses+=1)}addError(t){this.current.nodes.push({type:"error",message:t});for(const t of this.stack)t.errors+=1}addSevere(t){this.current.nodes.push({type:"severe",message:t});for(const t of this.stack)t.severe+=1}addWarning(t){this.current.nodes.push({type:"warning",message:t});for(const t of this.stack)t.warnings+=1}addUnused(t){this.current.nodes.push({type:"unused",message:t});for(const t of this.stack)t.unused+=1}assertError(t,e){t||this.addError(e)}assertSevere(t,e){t||this.addSevere(e)}assertWarning(t,e){t||this.addWarning(e)}assertUnused(t,e){t||this.addUnused(e)}}function fa(t,e,i){const n=e.name.toLowerCase().trim().split("-")[0].split(/\s+/);let s=n[0];const r=e.interval,a=r[1]-r[0],o=t.model.sequences;for(let e=0;e<i;e++){const i=o[e],n=i.interval;800===t.model.version&&(r[0]===n[0]?t.addSevere(`This sequence starts at the same frame as sequence ${e} "${i.name}"`):r[0]<n[1]&&t.addSevere(`This sequence starts before sequence ${e} "${i.name}" ends`))}"alternate"===s&&(s=n[1]),"stand"===s&&(t.foundStand=!0),"death"===s&&(t.foundDeath=!0),t.addImplicitReference(),t.assertWarning(Jr.has(s),`"${s}" is not a standard name`),t.assertWarning(0!==a,"Zero length"),t.assertWarning(a>-1,`Negative length: ${a}`),da(t,e.extent)}function ma(t,e){t.assertWarning(0!==e,"Zero length"),t.assertWarning(e>=0,`Negative length: ${e}`)}function ga(t,i){const n=i.replaceableId,s=i.path.toLowerCase(),r=e(s);t.assertError(""===s||".blp"===r||".tga"===r||".tif"===r||".dds"===r,`Corrupted path: "${s}"`),t.assertError(0===n||ta.has(n),`Unknown replaceable ID: ${n}`),t.assertWarning(""===s||0===n,`Path "${s}" and replaceable ID ${n} used together`)}function pa(t,e){const i=e.layers,n=e.shader;t.model.version>800&&t.assertWarning(""===n||"Shader_SD_FixedFunction"===n||"Shader_HD_DefaultUnit"===n,`Unknown shader: "${n}"`),i.length?sa(t,i,wa):t.addWarning("No layers")}function wa(t,e){const i=t.model.textures,n=t.model.textureAnimations;for(const n of function(t){for(const e of t.animations)if("KMTF"===e.name)return Xr(e.values.map((t=>t[0])));return[t.textureId]}(e))aa(t,i,n,"texture");const s=e.textureAnimationId;-1!==s&&aa(t,n,s,"texture animation");const r=e.filterMode;t.assertWarning(r>=0&&r<=6,`Invalid filter mode: ${e.filterMode}`)}function ba(t,e,i){const n=t.model.geosetAnimations,s=ra(t,t.model.materials,e.materialId,"material");let r=!1;if(s&&"Shader_HD_DefaultUnit"===s.shader&&(r=!0),!r){const i=22299;t.assertSevere(e.vertices.length<i,"Too many vertices in one geoset: "+e.vertices.length/3)}if(function(t,e){if(t.model.version>800&&e.skin.length){t.assertWarning(0===e.vertexGroups.length,"This geoset has both skin/weights and vertex groups");const i=e.skin;for(let e=0,n=i.length/8;e<n;e++){const n=8*e,s=i[n],r=i[n+1],a=i[n+2],o=i[n+3],l=i[n+4],h=i[n+5],c=i[n+6],d=i[n+7];l>0&&oa(t,e,s,!0),h>0&&oa(t,e,r,!0),c>0&&oa(t,e,a,!0),d>0&&oa(t,e,o,!0);const u=l+h+c+d;0===u?t.addSevere(`Vertex ${e}: Not attached to anything`):255!==u&&t.addSevere(`Vertex ${e}: The weights are not normalized to 1`)}}else if(t.model.bones.length){const i=e.vertexGroups,n=e.matrixGroups,s=e.matrixIndices,r=[];for(let t=0,e=n.length,i=0;t<e;t++)r.push(s.subarray(i,i+n[t])),i+=n[t];for(let e=0,n=i.length;e<n;e++){const n=r[i[e]];if(n)for(const i of n)oa(t,e,i,!1);else{const n=i[e];255===n?t.addSevere(`Vertex ${e}: Not attached to anything`):t.addSevere(`Vertex ${e}: Attached to vertex group ${n} which does not exist`)}}}}(t,e),n.length){const e=[];for(let t=0,s=n.length;t<s;t++)n[t].geosetId===i&&e.push(t);t.assertWarning(e.length<=1,`Referenced by ${e.length} geoset animations: ${e.join(", ")}`)}e.faces.length?t.addImplicitReference():t.addWarning("Zero faces"),e.sequenceExtents.length!==t.model.sequences.length&&800===t.model.version&&t.addWarning(`Number of sequence extents (${e.sequenceExtents.length}) does not match the number of sequences (${t.model.sequences.length})`),da(t,e.extent);for(const i of e.sequenceExtents)da(t,i)}function va(t,e){const i=t.model.geosets,n=e.geosetId;t.addImplicitReference(),aa(t,i,n,"geoset")}function ya(t,e,i){const n=t.model.geosets,s=t.model.geosetAnimations,r=e.geosetId,a=e.geosetAnimationId;if(-1!==r&&aa(t,n,r,"geoset"),-1!==a&&aa(t,s,a,"geoset animation")){const e=s[a];-1!==r&&e.alpha<.1&&!function(t,e){for(const i of t.animations)if(i.name===e)return!0;return!1}(e,"KGAO")&&t.addSevere(`Referencing geoset ${r} and geoset animation ${a} with a 0 alpha, the geoset may be invisible`)}t.assertWarning(t.boneUsageMap.get(i)>0,"There are no vertices attached to this bone")}function _a(t,e){const i=e.attenuation;t.assertWarning(i[0]>=80,`Minimum attenuation should probably be bigger than or equal to 80, but is ${i[0]}`),t.assertWarning(i[1]<=200,`Maximum attenuation should probably be smaller than or equal to 200, but is ${i[1]}`),t.assertWarning(i[1]-i[0]>0,"The maximum attenuation should be bigger than the minimum, but isn't")}function xa(t,e){const i=e.path.toLowerCase();t.assertError(i.endsWith(".mdl")||i.endsWith(".mdx"),"Invalid path")}function Aa(t,e){const i=e.replaceableId;aa(t,t.model.textures,e.textureId,"texture");const n=e.filterMode;t.assertWarning(n>=0&&n<=4,`Invalid filter mode: ${e.filterMode}`),t.assertError(0===i||ta.has(i),`Invalid replaceable ID: ${i}`),1048576&e.flags&&t.assertSevere(0!==e.speed&&0!==e.latitude,"XY Quad emitters must have a non-zero speed and latitude"),t.assertSevere(e.timeMiddle>=0&&e.timeMiddle<=1,`Expected time middle to be between 0 and 1, got ${e.timeMiddle}`),e.squirt&&!function(t,e){for(const i of t.animations)if(i.name===e)return i}(e,"KP2E")&&t.addSevere("Using squirt without animating the emission rate")}function Ta(t,e){const i=e.path;i.length&&t.assertError(i.endsWith(".pkfx"),`Corrupted path: "${i}"`)}function Ea(t,e){aa(t,t.model.materials,e.materialId,"material")}function Sa(t,e){Qr(t,e)}function Ia(t,e){t.addImplicitReference()}function ka(t,e){const i=e.path;i.length&&t.assertError(i.endsWith(".facefx")||i.endsWith(".facefx_ingame"),`Corrupted face effect path: "${i}"`),t.addImplicitReference()}function La(t){const e=new ua(t);!function(t){const e=t.model.version;800!==e&&900!==e&&1e3!==e&&t.addWarning(`Unknown version: ${e}`),900===e&&t.addError("Version 900 is not supported by Warcrft 3"),""!==t.model.animationFile&&t.addWarning(`The animation file should probably be empty, currently set to: "${t.model.animationFile}"`),da(t,t.model.extent)}(e),function(t){const e=t.model.sequences;e.length?(sa(t,e,fa),t.assertSevere(t.foundStand,'Missing "Stand" sequence'),t.assertSevere(t.foundDeath,'Missing "Death" sequence')):t.addWarning("No sequences")}(e),sa(e,t.globalSequences,ma),function(t){const e=t.model.textures;e.length?sa(t,e,ga):t.addWarning("No textures")}(e),sa(e,t.materials,pa),sa(e,t.textureAnimations),sa(e,t.geosets,ba),sa(e,t.geosetAnimations,va),sa(e,t.bones,ya),sa(e,t.lights,_a),sa(e,t.helpers),function(t){const e=t.model.attachments;let i=!1;for(const n of e){const e=n.path;if(e.length){const i=e.toLowerCase();t.assertError(i.endsWith(".mdl")||i.endsWith(".mdx"),`Invalid path "${e}"`)}n.name.startsWith("Origin Ref")&&(i=!0)}i||t.addWarning("Missing the Origin attachment point")}(e),function(t){const e=t.model.pivotPoints,i=t.objects;t.assertWarning(e.length===i.length,`Expected ${i.length} pivot points, got ${e.length}`)}(e),sa(e,t.particleEmitters,xa),sa(e,t.particleEmitters2,Aa),t.version>800&&sa(e,t.particleEmittersPopcorn,Ta),sa(e,t.ribbonEmitters,Ea),sa(e,t.eventObjects,Sa),sa(e,t.cameras,Ia),sa(e,t.collisionShapes),t.version>800&&(sa(e,t.faceEffects,ka),function(t){const e=t.model.bindPose,i=t.objects;e.length&&i.length&&t.assertWarning(e.length===i.length+1,`Expected ${i.length+1} matrices, got ${e.length}`)}(e));const i=e.stack[0];ca(i);const{nodes:n,errors:s,severe:r,warnings:a}=i;let{unused:o}=i;for(const t of n)"node"===t.type&&0===t.uses&&(o+=1);return{type:"node",nodes:n,errors:s,severe:r,warnings:a,unused:o}}function Ma(t,e){const i=e[t];for(let n=0;n<t;n++)if(e[n]===i)return!0;return!1}class Ca extends vs{constructor(t){super(),this.nodes=[];const e=this.container,i=t instanceof sr,n=t instanceof Er,s=t instanceof Gr,r=t instanceof jr,a=n||s||r;let o;if((n||s||r)&&(fs({textContent:`Width: ${t.width}`,container:e}),fs({textContent:`Height: ${t.height}`,container:e}),n?(0===t.content?fs({textContent:"Content: JPG",container:e}):fs({textContent:"Content: Palette",container:e}),t.alphaBits>8?fs({textContent:`Alpha bits: ${t.alphaBits} (fake)`,container:e}):fs({textContent:`Alpha bits: ${t.alphaBits}`,container:e}),fs({textContent:`Mipmaps: ${t.mipmaps()} (fake: ${t.fakeMipmaps()})`,container:e})):s&&(t.format===Nr?fs({textContent:"Content: BC1 (DXT1)",container:e}):t.format===Dr?fs({textContent:"Content: BC2 (DXT3)",container:e}):t.format===Or?fs({textContent:"Content: BC3 (DXT5)",container:e}):t.format===Vr?fs({textContent:"Content: BC5 (ATI2)",container:e}):fs({textContent:"Content: Not supported",container:e}),fs({textContent:`Mipmaps: ${t.mipmaps()}`,container:e})),fs({tagName:"hr",container:e})),o=i?La(t):n?function(t){const e=[],i=t.content,n=t.alphaBits,s=t.mipmapOffsets,r=t.mipmapSizes;let a=t.width,o=t.height;if(0!==i&&1!==i&&e.push({type:"warning",message:"Unknown content type"}),0!==n&&1!==n&&4!==n&&8!==n&&e.push({type:"warning",message:`Expected alpha bits to be 0, 1, 4, or 8, but got ${n}`}),(a>512||o>512)&&e.push({type:"warning",message:`Expected width and height up to 512, but got ${a}x${o}`}),0===i){const i=t.jpgHeader;i.length>624&&e.push({type:"warning",message:`Expected the JPG header to be at most 624 bytes, but got ${i.length}`})}D(a)&&D(o)||e.push({type:"warning",message:`Expected the width and height to be powers of two, but got ${a}x${o}`});for(let l=0;l<16;l++){if(r[l]>0)if(a<1&&o<1)e.push({type:"warning",message:`Mipmap ${l}: this mipmap should not exist`});else if(Ma(l,s))e.push({type:"warning",message:`Mipmap ${l}: this mipmap is fake`});else{let s;a=Math.max(a,1),o=Math.max(o,1);try{s=t.getMipmap(l)}catch(t){e.push({type:"warning",message:`Mipmap ${l}: Decoding failed`})}if(s)if(0===i)s.width===a&&s.height===o||e.push({type:"warning",message:`Mipmap ${l}: the JPG width (${s.width}) and height (${s.height}) do not match the mipmap width (${a}) and height (${o})`});else if(1===i){const t=a*o,i=t+Math.ceil(t*n/8);i!==r[l]&&e.push({type:"warning",message:`Mipmap ${l}: the declared size is ${r[l]}, but the real size is ${i}`})}}a>>=1,o>>=1}return{warnings:e.length,nodes:e}}(t):s?function(t){const e=[],i=t.width,n=t.height,s=t.mipmaps(),r=Math.log2(Math.max(i,n));s<r&&e.push({type:"warning",message:`Expected ${r} mipmaps, but got ${s}`}),i%4==0&&n%4==0||e.push({type:"warning",message:`Expected the width and height to be multiples of four, but got ${i}x${n}`}),D(i)&&D(n)||e.push({type:"warning",message:`Expected the width and height to be powers of two, but got ${i}x${n}`});for(let i=0;i<s;i++)try{t.getMipmap(i)}catch(t){e.push({type:"warning",message:`Mipmap ${i}: Decoding failed`})}return{warnings:e.length,nodes:e}}(t):{},o.nodes&&o.nodes.length)for(let t of o.nodes)this.nodes.push(new Ra(t,e));else this.nodes.push(new Ra({type:"bold",message:"Passed"},e));if(this.results=o,a)if(fs({tagName:"hr",container:e}),n||s)for(let e=0,i=t.mipmaps();e<i;e++)try{let i;i=n?t.getMipmap(e):this.getDdsMipmap(t,e),this.addMipmap(i)}catch(t){void 0===this.results.errors?this.results.errors=1:this.results.errors+=1,this.nodes.push(new Ra({type:"error",message:`Mipmap ${e}: ${t}`},this.container))}else this.addMipmap(t.data)}getDdsMipmap(t,e){const i=t.getMipmap(e);if(t.format===Vr){const t=new ImageData(i.width,i.height),e=i.data,n=t.data;for(let t=0,s=i.width*i.height;t<s;t++){const i=2*t,s=4*t;n[s+0]=e[i+0],n[s+1]=e[i+1],n[s+2]=0,n[s+3]=255}return t}return new ImageData(new Uint8ClampedArray(i.data.buffer),i.width,i.height)}addMipmap(t){const e=Hr(t);e.className="padded",this.container.appendChild(e)}filter(t,e,i,n){for(let s of this.nodes)s.filter(t,e,i,n)}}class Ra extends vs{constructor(t,e){super();let i="",n="",s="";var r;if("node"===t.type?(i="bold",n=t.name):(i=t.type,n=t.message,s=(r=n).includes("does not match the number of sequences")?"Having the wrong amount of geoset extents can in some cases crash War 3 Model Editor (Magos).\n\nThis does not affect the game.":r.includes("has exactly the same value as tracks")?"A keyframe with the same value as the two keyframes sorrounding it is useless.":r.includes("has roughly the same value as tracks")?"A keyframe with roughly the same value as the two keyframes sorrounding it is many times useless.":r.includes("Missing opening track for sequence")?"When missing the opening keyframe for an animation, the game will wrap the animation and interpolate between the last and first keyframes.\n\nHowever there is a bug in the game which causes the animation values to reverse.\n\nTo fix it, add a keyframe at the beginning of the animation.\n":r.includes("has the same frame")?"Remove one of the keyframes.":"Missing the Origin attachment point"===r?"Missing the Origin attachment stops many in-game effects from attaching to models.\n\nNot relevant to portraits and special effects.":r.includes("is not in global sequence")?"This keyframe uses a global sequence, but its frame is outside of the global sequence's range.":'Missing "Stand" sequence'===r?"Missing the stand animation can cause issues for models that are used as units.\n\nNot relevant to portraits.":'Missing "Death" sequence'===r?"Missing the death animation makes particles and other effects linger for a short time after an object using this model dies.\n    \nNot relevant to portraits.":r.endsWith("is not in any sequence")?"A keyframe that is not in any animation is useless.":r.includes("is lower than the track before it at")?"A keyframe is not supposed to have a frame before the previous keyframe.":""),fs({className:i,textContent:n,title:s,container:this.container}),this.node=t,this.nodes=[],"node"===t.type&&(t.nodes.length||0===t.uses)){let e=fs({className:"indent",container:this.container});0===t.uses&&this.nodes.push(new Ra({type:"unused",message:"Not used"},e));for(let i of t.nodes)this.nodes.push(new Ra(i,e))}e.appendChild(this.container)}filter(t,e,i,n){if(this.matchFilters(t,e,i,n)){if("node"===this.node.type)for(let s of this.nodes)s.filter(t,e,i,n);this.show()}else this.hide()}matchFilters(t,e,i,n){let s=this.node;if("node"===s.type)return(s.unused||0===s.uses)&&!t||s.warnings&&!e||s.severe&&!i||s.errors&&!n;{let r=s.type;return"unused"===r&&!t||"warning"===r&&!e||"severe"===r&&!i||"error"===r&&!n||"bold"===r}}}function Ba(t,e){return 1===e?t:`${t}s`}class Ua extends vs{constructor(t,e,i,n){super({...n,className:"clickable highlightable padded"}),this.name=fs({className:"bold",textContent:t,container:this.container});let s=fs({className:"indent",container:this.container});e&&fs({className:"error",textContent:"Parsing failed",container:s}),i.errors||i.severe||i.warnings||i.unused?(i.errors&&fs({className:"error",textContent:`${i.errors} ${Ba("error",i.errors)}`,container:s}),i.severe&&fs({className:"severe",textContent:`${i.severe} ${Ba("severe warning",i.severe)}`,container:s}),i.warnings&&fs({className:"warning",textContent:`${i.warnings} ${Ba("warning",i.warnings)}`,container:s}),i.unused&&fs({className:"unused",textContent:`${i.unused} unused`,container:s})):fs({className:"bold",textContent:"Passed",container:s})}}function Pa(t,e,i,n){if(i.length)for(const[s,r]of i.entries())r.writeMdl(t,e.version),n.push({name:na(r,s),source:t.buffer}),t.clear()}function Fa(t,e,i,n){if(i.length){const s=ia(i[0])+"s",r=[];Pa(t,e,i,r),e.saveStaticObjectsBlock(t,s,i),n.push({name:s,source:t.buffer,nodes:r}),t.clear()}}class Na extends vs{constructor(t){super({className:"mdl-view"});const e=function(t){const e=new ts,i=[];if(t.saveVersionBlock(e),i.push({name:"Version",source:e.buffer}),e.clear(),t.saveModelBlock(e),i.push({name:"Model",source:e.buffer}),e.clear(),Fa(e,t,t.sequences,i),t.globalSequences.length&&(t.saveGlobalSequenceBlock(e),i.push({name:"GlobalSequences",source:e.buffer}),e.clear()),Fa(e,t,t.textures,i),t.materials.length){const n=[];for(const[i,s]of t.materials.entries()){const r=[];Pa(e,t,s.layers,r),s.writeMdl(e,t.version),n.push({name:`Material ${i}`,source:e.buffer,nodes:r}),e.clear()}t.saveStaticObjectsBlock(e,"Materials",t.materials),i.push({name:"Materials",source:e.buffer,nodes:n}),e.clear()}return Fa(e,t,t.textureAnimations,i),Pa(e,t,t.geosets,i),Pa(e,t,t.geosetAnimations,i),Pa(e,t,t.bones,i),Pa(e,t,t.lights,i),Pa(e,t,t.helpers,i),Pa(e,t,t.attachments,i),t.pivotPoints.length&&(t.savePivotPointBlock(e),i.push({name:"PivotPoints",source:e.buffer}),e.clear()),Pa(e,t,t.particleEmitters,i),Pa(e,t,t.particleEmitters2,i),Pa(e,t,t.particleEmittersPopcorn,i),Pa(e,t,t.ribbonEmitters,i),Pa(e,t,t.cameras,i),Pa(e,t,t.eventObjects,i),Pa(e,t,t.collisionShapes,i),Pa(e,t,t.faceEffects,i),t.bindPose.length&&(t.saveBindPoseBlock(e),i.push({name:"BindPose",source:e.buffer}),e.clear()),{nodes:i}}(t);this.structureElement=fs({className:"mdl-structure",container:this.container}),this.sourceElement=fs({tagName:"pre",className:"mdl-source",container:this.container}),this.nodes=[],this.visibleNode=null;for(let t of e.nodes)this.nodes.push(new Da(this,t,this.structureElement))}showNode(t){this.visibleNode&&this.visibleNode.normal(),this.visibleNode=t,t.highlight(),this.sourceElement.textContent=t.node.source}}class Da extends vs{constructor(t,e,i){if(super({className:"clickable highlightable",textContent:e.name,container:i}),this.container.addEventListener("click",(()=>t.showNode(this))),this.node=e,this.nodes=[],e.nodes&&e.nodes.length){let n=fs({className:"indent"});for(let i of e.nodes)this.nodes.push(new Da(t,i,n));i.appendChild(n)}}}class Oa{constructor(i,n,s,r){let a=e(n),o=".mdx"===a||".mdl"===a,l=".blp"===a,h=".dds"===a;this.name=n,this.shortName=t(n),this.parsingError=!1,this.results=null,this.mdl=null,this.pathSolver=r,this.resource=null,this.instance=null,this.boundingBox=null,this.boundingSphere=null,this.parser=o?new sr:l?new Er:h?new Gr:new jr;try{this.parser.load(s)}catch(t){this.parsingError=!0,i.logger.error(`Failed to parse ${n}: ${t}. The test will attempt to run on whatever data loaded`)}this.results=new Ca(this.parser),o&&(this.mdl=new Na(this.parser)),this.meta=new Ua(this.shortName,this.parsingError,this.results.results,{onclick:()=>i.render(this)})}show(){this.meta.highlight(),this.results&&this.results.show(),this.mdl&&this.mdl.show()}hide(){this.meta.normal(),this.results&&this.results.hide(),this.mdl&&this.mdl.hide()}}class Va extends vs{constructor(t){super({...t,className:"console"}),this.messages=[],this.tabs=fs({className:"tabs",container:this.container}),this.logsToggler=new ys("Hide Logs","Show Logs",(t=>this.filter()),{container:this.tabs}),this.infoToggler=new ys("Hide Info","Show Info",(t=>this.filter()),{container:this.tabs}),this.errorsToggler=new ys("Hide Errors","Show Errors",(t=>this.filter()),{container:this.tabs}),this.contents=fs({className:"tab-contents",container:this.container}),this.logsToggler.toggle()}message(t,e){let i=new Ga(t,e);i.filter(this.logsToggler.clicked,this.infoToggler.clicked,this.errorsToggler.clicked),this.messages.push(i);let n=ws(this.contents);this.contents.appendChild(i.container),n&&ps(this.contents)}log(t){this.message("log",t)}info(t){this.message("info",t)}error(t){this.message("error",t)}filter(){let t=ws(this.contents);for(let t of this.messages)t.filter(this.logsToggler.clicked,this.infoToggler.clicked,this.errorsToggler.clicked);t&&ps(this.contents)}}class Ga extends vs{constructor(t,e){super({className:t,textContent:e}),this.type=t}matchFilters(t,e,i){let n=this.type;return"log"===n&&!t||"info"===n&&!e||"error"===n&&!i}filter(t,e,i){this.matchFilters(t,e,i)?this.show():this.hide()}}var ja=i(187);async function Ka(t,e){if("image"===e)return new Promise((e=>{const i=new Image;i.onload=()=>{e({ok:!0,data:i})},i.onerror=t=>{e({ok:!1,error:"Image Error",data:t})},i.src=t}));{let i;try{i=await fetch(t)}catch(t){return{ok:!1,error:"Network Error",data:t}}if(!i.ok)return{ok:!1,error:"Http Error",data:i};try{let t=null;return"text"===e?t=await i.text():"arrayBuffer"===e||"bytes"===e?t=await i.arrayBuffer():"blob"===e&&(t=await i.blob()),"bytes"===e&&(t=new Uint8Array(t)),{ok:!0,data:t}}catch(t){return{ok:!1,error:"Data Error",data:t}}}}class $a{constructor(t,e=4){this.size=0,this.arrayBuffer=null,this.byteView=null,this.floatView=null,this.gl=t,this.buffer=t.createBuffer(),this.reserve(e)}reserve(t){if(this.size<t){const e=this.gl;this.size=4*Math.ceil(t/4),e.bindBuffer(e.ARRAY_BUFFER,this.buffer),e.bufferData(e.ARRAY_BUFFER,this.size,e.DYNAMIC_DRAW),this.arrayBuffer=new ArrayBuffer(this.size),this.byteView=new Uint8Array(this.arrayBuffer),this.floatView=new Float32Array(this.arrayBuffer)}}bindAndUpdate(t=this.size){const e=this.gl,i=this.byteView;e.bindBuffer(e.ARRAY_BUFFER,this.buffer),e.bufferSubData(e.ARRAY_BUFFER,0,i.subarray(0,t))}}class za{constructor(t,e=1,i=1){this.width=0,this.height=0,this.arrayBuffer=new ArrayBuffer(0),this.byteView=null,this.floatView=null,this.gl=t,this.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.NEAREST),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.NEAREST),this.reserve(e,i)}reserve(t,e){if(this.width<t||this.height<e){const i=this.gl;this.width=Math.max(this.width,t),this.height=Math.max(this.height,e),i.bindTexture(i.TEXTURE_2D,this.texture),i.texImage2D(i.TEXTURE_2D,0,i.RGBA,this.width,this.height,0,i.RGBA,i.FLOAT,null),this.arrayBuffer=new ArrayBuffer(this.width*this.height*16),this.byteView=new Uint8Array(this.arrayBuffer),this.floatView=new Float32Array(this.arrayBuffer)}}bindAndUpdate(t=this.width,e=this.height){const i=this.gl;i.bindTexture(i.TEXTURE_2D,this.texture),i.texSubImage2D(i.TEXTURE_2D,0,0,0,t,e,i.RGBA,i.FLOAT,this.byteView)}}class qa{constructor(t,e=4,i=1,n=1){this.width=0,this.height=0,this.gl=t,this.texture=t.createTexture(),this.format=3===e?t.RGB:t.RGBA,t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.NEAREST),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.NEAREST),this.reserve(i,n)}reserve(t,e){if(this.width<t||this.height<e){const i=this.gl;this.width=Math.max(this.width,t),this.height=Math.max(this.height,e),i.bindTexture(i.TEXTURE_2D,this.texture),i.texImage2D(i.TEXTURE_2D,0,this.format,this.width,this.height,0,this.format,i.FLOAT,null)}}bindAndUpdate(t,e=this.width,i=this.height){const n=this.gl;n.bindTexture(n.TEXTURE_2D,this.texture),n.texSubImage2D(n.TEXTURE_2D,0,0,0,e,i,this.format,n.FLOAT,t)}bind(t){const e=this.gl;e.activeTexture(e.TEXTURE0+t),e.bindTexture(e.TEXTURE_2D,this.texture)}}class Ha{constructor(t,e){this.uniforms={},this.attribs={},this.attribsCount=0,this.webgl=t,this.program=e;const i=t.gl;for(let t=0,n=i.getProgramParameter(e,i.ACTIVE_UNIFORMS);t<n;t++){const n=i.getActiveUniform(e,t);if(n)if(1===n.size)this.uniforms[n.name]=i.getUniformLocation(e,n.name);else{const t=n.name.substr(0,n.name.length-3);for(let s=0;s<n.size;s++){const n=t+"["+s+"]";this.uniforms[n]=i.getUniformLocation(e,n)}}}for(let t=0,n=i.getProgramParameter(e,i.ACTIVE_ATTRIBUTES);t<n;t++){const n=i.getActiveAttrib(e,t);if(n)if(this.attribsCount+=n.size,1===n.size)this.attribs[n.name]=i.getAttribLocation(e,n.name);else{const t=n.name.substr(0,n.name.length-3);for(let s=0;s<n.size;s++){const n=t+"["+s+"]";this.attribs[n]=i.getAttribLocation(e,n)}}}}use(){this.webgl.useShader(this)}}class Xa{constructor(t,e={alpha:!1}){this.currentShader=null,this.extensions={};let i=t.getContext("webgl",e);if(i||(i=t.getContext("experimental-webgl",e)),!i)throw new Error("WebGL: Failed to create a WebGL context!");const n=new Uint8ClampedArray(16).fill(255),s=i.createTexture();i.bindTexture(i.TEXTURE_2D,s),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_S,i.CLAMP_TO_EDGE),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_T,i.CLAMP_TO_EDGE),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MAG_FILTER,i.NEAREST),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.NEAREST),i.texImage2D(i.TEXTURE_2D,0,i.RGBA,2,2,0,i.RGBA,i.UNSIGNED_BYTE,n),this.gl=i,this.emptyTexture=s}ensureExtension(t){const e=this.gl.getExtension(t);return!!e&&(this.extensions[t]=e,!0)}createShader(t,e){const i=this.gl,n=i.createShader(i.VERTEX_SHADER);i.shaderSource(n,t),i.compileShader(n);const s=i.createShader(i.FRAGMENT_SHADER);i.shaderSource(s,e),i.compileShader(s);const r=i.createProgram();if(i.attachShader(r,n),i.attachShader(r,s),i.linkProgram(r),!i.getProgramParameter(r,i.LINK_STATUS)){let t="Shader failed to link:";const e=i.getShaderInfoLog(n);e&&e.length&&(t+=` Vertex shader: ${e}`);const r=i.getShaderInfoLog(s);throw r&&r.length&&(t+=` Fragment shader: ${r}`),new Error(t)}return new Ha(this,r)}enableVertexAttribs(t,e){const i=this.gl;for(let n=t;n<e;n++)i.enableVertexAttribArray(n)}disableVertexAttribs(t,e){const i=this.gl;for(let n=t;n<e;n++)i.disableVertexAttribArray(n)}useShader(t){if(t&&t!==this.currentShader){let e=0;const i=t.attribsCount;this.currentShader&&(e=this.currentShader.attribsCount),this.gl.useProgram(t.program),i>e?this.enableVertexAttribs(e,i):i<e&&this.disableVertexAttribs(i,e),this.currentShader=t}}bindTexture(t,e){const i=this.gl;i.activeTexture(i.TEXTURE0+e),t?i.bindTexture(i.TEXTURE_2D,t.webglResource):i.bindTexture(i.TEXTURE_2D,this.emptyTexture)}bindTextureAndWrap(t,e,i,n){const s=this.gl;s.activeTexture(s.TEXTURE0+e),t?s.bindTexture(s.TEXTURE_2D,t.webglResource):s.bindTexture(s.TEXTURE_2D,this.emptyTexture),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_WRAP_S,i),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_WRAP_T,n)}setTextureMode(t,e,i,n){const s=this.gl;s.texParameteri(s.TEXTURE_2D,s.TEXTURE_WRAP_S,t),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_WRAP_T,e),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MAG_FILTER,i),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MIN_FILTER,n)}createClientBuffer(t=4){return new $a(this.gl,t)}createDataTexture(t=4,e=1,i=1){return new qa(this.gl,t,e,i)}createClientDataTexture(t=1,e=1){return new za(this.gl,t,e)}}var Wa=1e-6,Ya="undefined"!=typeof Float32Array?Float32Array:Array;Math.random;Math.PI;function Za(){var t=new Ya(3);return Ya!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t}function Qa(t){var e=t[0],i=t[1],n=t[2];return Math.hypot(e,i,n)}function Ja(t,e,i){var n=new Ya(3);return n[0]=t,n[1]=e,n[2]=i,n}function to(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t}function eo(t,e,i,n){return t[0]=e,t[1]=i,t[2]=n,t}function io(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t}function no(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t}function so(t,e){var i=e[0],n=e[1],s=e[2],r=i*i+n*n+s*s;return r>0&&(r=1/Math.sqrt(r)),t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t}function ro(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]}function ao(t,e,i){var n=e[0],s=e[1],r=e[2],a=i[0],o=i[1],l=i[2];return t[0]=s*l-r*o,t[1]=r*a-n*l,t[2]=n*o-s*a,t}function oo(t,e,i){var n=e[0],s=e[1],r=e[2],a=i[3]*n+i[7]*s+i[11]*r+i[15];return a=a||1,t[0]=(i[0]*n+i[4]*s+i[8]*r+i[12])/a,t[1]=(i[1]*n+i[5]*s+i[9]*r+i[13])/a,t[2]=(i[2]*n+i[6]*s+i[10]*r+i[14])/a,t}function lo(t,e,i){var n=i[0],s=i[1],r=i[2],a=i[3],o=e[0],l=e[1],h=e[2],c=s*h-r*l,d=r*o-n*h,u=n*l-s*o,f=s*u-r*d,m=r*c-n*u,g=n*d-s*c,p=2*a;return c*=p,d*=p,u*=p,f*=2,m*=2,g*=2,t[0]=o+c+f,t[1]=l+d+m,t[2]=h+u+g,t}Math.hypot||(Math.hypot=function(){for(var t=0,e=arguments.length;e--;)t+=arguments[e]*arguments[e];return Math.sqrt(t)});var ho,co=function(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t[2]=e[2]-i[2],t},uo=function(t,e,i){return t[0]=e[0]*i[0],t[1]=e[1]*i[1],t[2]=e[2]*i[2],t},fo=Qa;ho=Za();function mo(){var t=new Ya(4);return Ya!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[3]=0),t}function go(t,e,i,n,s){return t[0]=e,t[1]=i,t[2]=n,t[3]=s,t}!function(){var t=mo()}();function po(){var t=new Ya(4);return Ya!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t[3]=1,t}function wo(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t}function bo(t,e,i){i*=.5;var n=Math.sin(i);return t[0]=n*e[0],t[1]=n*e[1],t[2]=n*e[2],t[3]=Math.cos(i),t}function vo(t,e,i){i*=.5;var n=e[0],s=e[1],r=e[2],a=e[3],o=Math.sin(i),l=Math.cos(i);return t[0]=n*l+a*o,t[1]=s*l+r*o,t[2]=r*l-s*o,t[3]=a*l-n*o,t}function yo(t,e,i){i*=.5;var n=e[0],s=e[1],r=e[2],a=e[3],o=Math.sin(i),l=Math.cos(i);return t[0]=n*l-r*o,t[1]=s*l+a*o,t[2]=r*l+n*o,t[3]=a*l-s*o,t}function _o(t,e,i){i*=.5;var n=e[0],s=e[1],r=e[2],a=e[3],o=Math.sin(i),l=Math.cos(i);return t[0]=n*l+s*o,t[1]=s*l-n*o,t[2]=r*l+a*o,t[3]=a*l-r*o,t}function xo(t,e,i,n){var s,r,a,o,l,h=e[0],c=e[1],d=e[2],u=e[3],f=i[0],m=i[1],g=i[2],p=i[3];return(r=h*f+c*m+d*g+u*p)<0&&(r=-r,f=-f,m=-m,g=-g,p=-p),1-r>Wa?(s=Math.acos(r),a=Math.sin(s),o=Math.sin((1-n)*s)/a,l=Math.sin(n*s)/a):(o=1-n,l=n),t[0]=o*h+l*f,t[1]=o*c+l*m,t[2]=o*d+l*g,t[3]=o*u+l*p,t}function Ao(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=e[3],t}var To,Eo,So,Io,ko,Lo,Mo,Co=function(t,e,i,n){var s=new Ya(4);return s[0]=t,s[1]=e,s[2]=i,s[3]=n,s},Ro=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},Bo=function(t,e,i){var n=e[0],s=e[1],r=e[2],a=e[3],o=i[0],l=i[1],h=i[2],c=i[3];return t[0]=n*c+a*o+s*h-r*l,t[1]=s*c+a*l+r*o-n*h,t[2]=r*c+a*h+n*l-s*o,t[3]=a*c-n*o-s*l-r*h,t},Uo=function(t,e){var i=e[0],n=e[1],s=e[2],r=e[3],a=i*i+n*n+s*s+r*r;return a>0&&(a=1/Math.sqrt(a)),t[0]=i*a,t[1]=n*a,t[2]=s*a,t[3]=r*a,t},Po=(To=Za(),Eo=Ja(1,0,0),So=Ja(0,1,0),Io=po(),ko=po(),function(t,e,i,n,s,r){return xo(Io,e,s,r),xo(ko,i,n,r),xo(t,Io,ko,2*r*(1-r)),t});Lo=new Ya(9),Ya!=Float32Array&&(Lo[1]=0,Lo[2]=0,Lo[3]=0,Lo[5]=0,Lo[6]=0,Lo[7]=0),Lo[0]=1,Lo[4]=1,Lo[8]=1,Mo=Lo;function Fo(){var t=new Ya(16);return Ya!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0),t[0]=1,t[5]=1,t[10]=1,t[15]=1,t}function No(t,e){var i=e[0],n=e[1],s=e[2],r=e[3],a=e[4],o=e[5],l=e[6],h=e[7],c=e[8],d=e[9],u=e[10],f=e[11],m=e[12],g=e[13],p=e[14],w=e[15],b=i*o-n*a,v=i*l-s*a,y=i*h-r*a,_=n*l-s*o,x=n*h-r*o,A=s*h-r*l,T=c*g-d*m,E=c*p-u*m,S=c*w-f*m,I=d*p-u*g,k=d*w-f*g,L=u*w-f*p,M=b*L-v*k+y*I+_*S-x*E+A*T;return M?(M=1/M,t[0]=(o*L-l*k+h*I)*M,t[1]=(s*k-n*L-r*I)*M,t[2]=(g*A-p*x+w*_)*M,t[3]=(u*x-d*A-f*_)*M,t[4]=(l*S-a*L-h*E)*M,t[5]=(i*L-s*S+r*E)*M,t[6]=(p*y-m*A-w*v)*M,t[7]=(c*A-u*y+f*v)*M,t[8]=(a*k-o*S+h*T)*M,t[9]=(n*S-i*k-r*T)*M,t[10]=(m*x-g*y+w*b)*M,t[11]=(d*y-c*x-f*b)*M,t[12]=(o*E-a*I-l*T)*M,t[13]=(i*I-n*E+s*T)*M,t[14]=(g*v-m*_-p*b)*M,t[15]=(c*_-d*v+u*b)*M,t):null}function Do(t,e,i,n){var s=e[0],r=e[1],a=e[2],o=e[3],l=s+s,h=r+r,c=a+a,d=s*l,u=s*h,f=s*c,m=r*h,g=r*c,p=a*c,w=o*l,b=o*h,v=o*c,y=n[0],_=n[1],x=n[2];return t[0]=(1-(m+p))*y,t[1]=(u+v)*y,t[2]=(f-b)*y,t[3]=0,t[4]=(u-v)*_,t[5]=(1-(d+p))*_,t[6]=(g+w)*_,t[7]=0,t[8]=(f+b)*x,t[9]=(g-w)*x,t[10]=(1-(d+m))*x,t[11]=0,t[12]=i[0],t[13]=i[1],t[14]=i[2],t[15]=1,t}var Oo=function(t,e,i){var n=e[0],s=e[1],r=e[2],a=e[3],o=e[4],l=e[5],h=e[6],c=e[7],d=e[8],u=e[9],f=e[10],m=e[11],g=e[12],p=e[13],w=e[14],b=e[15],v=i[0],y=i[1],_=i[2],x=i[3];return t[0]=v*n+y*o+_*d+x*g,t[1]=v*s+y*l+_*u+x*p,t[2]=v*r+y*h+_*f+x*w,t[3]=v*a+y*c+_*m+x*b,v=i[4],y=i[5],_=i[6],x=i[7],t[4]=v*n+y*o+_*d+x*g,t[5]=v*s+y*l+_*u+x*p,t[6]=v*r+y*h+_*f+x*w,t[7]=v*a+y*c+_*m+x*b,v=i[8],y=i[9],_=i[10],x=i[11],t[8]=v*n+y*o+_*d+x*g,t[9]=v*s+y*l+_*u+x*p,t[10]=v*r+y*h+_*f+x*w,t[11]=v*a+y*c+_*m+x*b,v=i[12],y=i[13],_=i[14],x=i[15],t[12]=v*n+y*o+_*d+x*g,t[13]=v*s+y*l+_*u+x*p,t[14]=v*r+y*h+_*f+x*w,t[15]=v*a+y*c+_*m+x*b,t};const Vo=Ja(1,0,0),Go=Ja(0,1,0),jo=Ja(0,0,1),Ko=Za(),$o=Ja(1,1,1),zo=(Co(0,0,0,0),po()),qo=mo();function Ho(t,e,i,n){const s=2*(e[0]-n[0])/n[2]-1,r=1-2*(e[1]-n[1])/n[3],a=2*e[2]-1;return go(qo,s,r,a,1),function(t,e,i){var n=e[0],s=e[1],r=e[2],a=e[3];t[0]=i[0]*n+i[4]*s+i[8]*r+i[12]*a,t[1]=i[1]*n+i[5]*s+i[9]*r+i[13]*a,t[2]=i[2]*n+i[6]*s+i[10]*r+i[14]*a,t[3]=i[3]*n+i[7]*s+i[11]*r+i[15]*a}(qo,qo,i),eo(t,qo[0]/qo[3],qo[1]/qo[3],qo[2]/qo[3]),t}function Xo(t,e,i){return t[0]*e+t[1]*i+t[3]}function Wo(t,e,i,n){return t[0]*e+t[1]*i+t[2]*n+t[3]}function Yo(t,e){const i=function(t){return Math.hypot(t[0],t[1],t[2])}(e);t[0]=e[0]/i,t[1]=e[1]/i,t[2]=e[2]/i,t[3]=e[3]/i}const Zo=Za(),Qo=Za(),Jo=Za();function tl(t,e,i,n){so(Zo,co(Zo,i,e)),so(Qo,ao(Qo,n,Zo)),ao(Jo,Qo,Zo);const s=Qo[0]+Jo[2]+Zo[1];if(s>0){const e=.5/Math.sqrt(s+1);t[3]=.25/e,t[0]=(Jo[1]-Zo[2])*e,t[2]=(Zo[0]-Qo[1])*e,t[1]=(Qo[2]-Jo[0])*e}else if(Qo[0]>Jo[2]&&Qo[0]>Zo[1]){const e=2*Math.sqrt(1+Qo[0]-Jo[2]-Zo[1]);t[3]=(Jo[1]-Zo[2])/e,t[0]=.25*e,t[2]=(Jo[0]+Qo[2])/e,t[1]=(Zo[0]+Qo[1])/e}else if(Jo[2]>Zo[1]){const e=2*Math.sqrt(1+Jo[2]-Qo[0]-Zo[1]);t[3]=(Zo[0]-Qo[1])/e,t[0]=(Jo[0]+Qo[2])/e,t[2]=.25*e,t[1]=(Zo[2]+Jo[1])/e}else{const e=2*Math.sqrt(1+Zo[1]-Qo[0]-Jo[2]);t[3]=(Qo[2]-Jo[0])/e,t[0]=(Zo[0]+Qo[1])/e,t[2]=(Zo[2]+Jo[1])/e,t[1]=.25*e}return t}const el=Za(),il=Za(),nl=Za(),sl=po(),rl=bo(po(),Vo,Math.PI/2);class al{constructor(){this.isPerspective=!0,this.fov=0,this.aspect=0,this.isOrtho=!1,this.leftClipPlane=0,this.rightClipPlane=0,this.bottomClipPlane=0,this.topClipPlane=0,this.nearClipPlane=0,this.farClipPlane=0,this.location=Za(),this.rotation=po(),this.inverseRotation=po(),this.viewMatrix=Fo(),this.projectionMatrix=Fo(),this.viewProjectionMatrix=Fo(),this.inverseViewMatrix=Fo(),this.inverseViewProjectionMatrix=Fo(),this.directionX=Za(),this.directionY=Za(),this.directionZ=Za(),this.vectors=[Ja(-1,-1,0),Ja(-1,1,0),Ja(1,1,0),Ja(1,-1,0),Ja(1,0,0),Ja(0,1,0),Ja(0,0,1)],this.billboardedVectors=[Za(),Za(),Za(),Za(),Za(),Za(),Za()],this.planes=[mo(),mo(),mo(),mo(),mo(),mo()]}perspective(t,e,i,n){this.isPerspective=!0,this.isOrtho=!1,this.fov=t,this.aspect=e,this.nearClipPlane=i,this.farClipPlane=n,this.update()}ortho(t,e,i,n,s,r){this.isPerspective=!1,this.isOrtho=!0,this.leftClipPlane=t,this.rightClipPlane=e,this.bottomClipPlane=i,this.topClipPlane=n,this.nearClipPlane=s,this.farClipPlane=r,this.update()}setLocation(t){to(this.location,t),this.update()}move(t){io(this.location,this.location,t),this.update()}setRotation(t){Ro(this.rotation,t),this.update()}rotate(t){Bo(this.rotation,this.rotation,t),this.update()}face(t,e){Bo(this.rotation,rl,tl(sl,t,this.location,e)),this.update()}moveToAndFace(t,e,i){to(this.location,t),this.face(e,i)}reset(){eo(this.location,0,0,0),wo(this.rotation),this.update()}update(){const t=this.location,e=this.rotation,i=this.inverseRotation,n=this.viewMatrix,s=this.projectionMatrix,r=this.viewProjectionMatrix,a=this.vectors,o=this.billboardedVectors;this.isPerspective?function(t,e,i,n,s){var r,a=1/Math.tan(e/2);t[0]=a/i,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=-1,t[12]=0,t[13]=0,t[15]=0,null!=s&&s!==1/0?(r=1/(n-s),t[10]=(s+n)*r,t[14]=2*s*n*r):(t[10]=-1,t[14]=-2*n)}(s,this.fov,this.aspect,this.nearClipPlane,this.farClipPlane):function(t,e,i,n,s,r,a){var o=1/(e-i),l=1/(n-s),h=1/(r-a);t[0]=-2*o,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*l,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*h,t[11]=0,t[12]=(e+i)*o,t[13]=(s+n)*l,t[14]=(a+r)*h,t[15]=1}(s,this.leftClipPlane,this.rightClipPlane,this.bottomClipPlane,this.topClipPlane,this.nearClipPlane,this.farClipPlane),function(t,e){var i=e[0],n=e[1],s=e[2],r=e[3],a=i+i,o=n+n,l=s+s,h=i*a,c=n*a,d=n*o,u=s*a,f=s*o,m=s*l,g=r*a,p=r*o,w=r*l;t[0]=1-d-m,t[1]=c+w,t[2]=u-p,t[3]=0,t[4]=c-w,t[5]=1-h-m,t[6]=f+g,t[7]=0,t[8]=u+p,t[9]=f-g,t[10]=1-h-d,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1}(n,e),function(t,e,i){var n,s,r,a,o,l,h,c,d,u,f,m,g=i[0],p=i[1],w=i[2];e===t?(t[12]=e[0]*g+e[4]*p+e[8]*w+e[12],t[13]=e[1]*g+e[5]*p+e[9]*w+e[13],t[14]=e[2]*g+e[6]*p+e[10]*w+e[14],t[15]=e[3]*g+e[7]*p+e[11]*w+e[15]):(n=e[0],s=e[1],r=e[2],a=e[3],o=e[4],l=e[5],h=e[6],c=e[7],d=e[8],u=e[9],f=e[10],m=e[11],t[0]=n,t[1]=s,t[2]=r,t[3]=a,t[4]=o,t[5]=l,t[6]=h,t[7]=c,t[8]=d,t[9]=u,t[10]=f,t[11]=m,t[12]=n*g+o*p+d*w+e[12],t[13]=s*g+l*p+u*w+e[13],t[14]=r*g+h*p+f*w+e[14],t[15]=a*g+c*p+m*w+e[15])}(n,n,function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t}(el,t)),Oo(r,s,n),No(this.inverseViewMatrix,n),No(this.inverseViewProjectionMatrix,r),function(t,e){const i=e[0],n=e[4],s=e[8],r=e[12],a=e[1],o=e[5],l=e[9],h=e[13],c=e[2],d=e[6],u=e[10],f=e[14],m=e[3],g=e[7],p=e[11],w=e[15];let b;b=t[0],b[0]=m+i,b[1]=g+n,b[2]=p+s,b[3]=w+r,b=t[1],b[0]=m-i,b[1]=g-n,b[2]=p-s,b[3]=w-r,b=t[2],b[0]=m-a,b[1]=g-o,b[2]=p-l,b[3]=w-h,b=t[3],b[0]=m+a,b[1]=g+o,b[2]=p+l,b[3]=w+h,b=t[4],b[0]=m+c,b[1]=g+d,b[2]=p+u,b[3]=w+f,b=t[5],b[0]=m-c,b[1]=g-d,b[2]=p-u,b[3]=w-f,Yo(t[0],t[0]),Yo(t[1],t[1]),Yo(t[2],t[2]),Yo(t[3],t[3]),Yo(t[4],t[4]),Yo(t[5],t[5])}(this.planes,r),Ao(i,e),lo(this.directionX,Vo,i),lo(this.directionY,Go,i),lo(this.directionZ,jo,i);for(let t=0;t<7;t++)lo(o[t],a[t],i)}cameraToWorld(t,e){return oo(t,e,this.inverseViewMatrix)}worldToCamera(t,e){return oo(t,e,this.viewMatrix)}worldToScreen(t,e,i){return oo(el,e,this.viewProjectionMatrix),t[0]=Math.round((el[0]+1)/2*i[2]),t[1]=Math.round((el[1]+1)/2*i[3]),t}screenToWorldRay(t,e,i){const n=el,s=il,r=nl,a=e[0],o=e[1],l=this.inverseViewProjectionMatrix;return Ho(n,eo(r,a,o,0),l,i),Ho(s,eo(r,a,o,1),l,i),t.set(n,0),t.set(s,3),t}}class ol{constructor(t,e,i,n){this.plane=-1,this.instances=[],this.visible=!1,this.left=t,this.right=e,this.bottom=i,this.top=n}add(t){this.instances.push(t)}remove(t){const e=this.instances.indexOf(t);this.instances.splice(e,1)}clear(){this.instances.length=0}isVisible(t){return this.plane=function(t,e,i,n,s,r){-1===r&&(r=0);for(let a=0;a<6;a++){const o=(r+a)%6,l=t[o];if(Xo(l,e,n)<0&&Xo(l,e,s)<0&&Xo(l,i,s)<0&&Xo(l,i,n)<0)return o}return-1}(t.planes,this.left,this.right,this.bottom,this.top,this.plane),-1===this.plane}}class ll{constructor(t,e,i,n,s,r){this.cells=[];const a=i/s,o=n/r;this.x=t,this.y=e,this.width=i,this.depth=n,this.cellWidth=s,this.cellDepth=r,this.columns=a,this.rows=o;for(let i=0;i<o;i++)for(let n=0;n<a;n++){const o=t+n*s,l=o+s,h=e+i*r,c=h+r;this.cells[i*a+n]=new ol(o,l,h,c)}}add(t){const e=this.cells,i=this.columns,n=t.left,s=t.right+1,r=t.bottom,a=t.top+1;if(-1!==n)for(let o=r;o<a;o++)for(let r=n;r<s;r++)e[o*i+r].add(t)}remove(t){const e=this.cells,i=this.columns,n=t.left,s=t.right+1,r=t.bottom,a=t.top+1;if(-1!==n){t.left=-1;for(let o=r;o<a;o++)for(let r=n;r<s;r++)e[o*i+r].remove(t)}}moved(t){const e=this.cellWidth,i=this.cellDepth,n=t.model.bounds,s=t.worldLocation[0]+n.x-this.x,r=t.worldLocation[1]+n.y-this.y,a=n.r,o=t.worldScale;let l=Math.floor((s-a*o[0])/e),h=Math.floor((s+a*o[0])/e),c=Math.floor((r-a*o[1])/i),d=Math.floor((r+a*o[1])/i);h<0||l>this.columns-1||d<0||c>this.rows-1?this.remove(t):(l=Math.max(l,0),h=Math.min(h,this.columns-1),c=Math.max(c,0),d=Math.min(d,this.rows-1),l===t.left&&h===t.right&&c===t.bottom&&d===t.top||(this.remove(t),t.left=l,t.right=h,t.bottom=c,t.top=d,this.add(t)))}clear(){for(const t of this.cells)t.clear()}}class hl{constructor(){this.objects=[],this.alive=0}add(t){this.objects[this.alive++]=t}update(t){const e=this.objects;for(let i=0;i<this.alive;i++){const n=e[i];n.update(t*n.emitter.instance.timeScale),n.health<=0&&(this.alive-=1,n.emitter.kill(n),i!==this.alive&&(e[i]=e[this.alive],i-=1))}}}class cl{constructor(t){this.camera=new al,this.grid=new ll(-1e5,-1e5,2e5,2e5,2e5,2e5),this.visibleCells=0,this.visibleInstances=0,this.updatedParticles=0,this.audioEnabled=!1,this.audioContext=null,this.instances=[],this.emittedObjectUpdater=new hl,this.alpha=!1,this.color=Za(),this.viewport=mo(),this.lightPosition=Ja(0,0,1e4),this.viewer=t;const e=t.canvas,i=e.width,n=e.height;this.viewport[2]=i,this.viewport[3]=n,this.camera.perspective(Math.PI/4,i/n,8,1e4)}async enableAudio(){return"function"==typeof AudioContext&&(this.audioContext||(this.audioContext=new AudioContext),"suspended"!==this.audioContext.state&&await this.audioContext.resume(),this.audioEnabled="running"===this.audioContext.state,this.audioEnabled)}disableAudio(){this.audioContext&&this.audioContext.suspend(),this.audioEnabled=!1}addInstance(t){return t.scene!==this&&(t.scene&&t.scene.removeInstance(t),t.scene=this,this.grid.moved(t),!0)}removeInstance(t){return t.scene===this&&(this.grid.remove(t),t.scene=null,!0)}clear(){for(const t of this.grid.cells)for(const e of t.instances)e.scene=null;this.grid.clear()}detach(){return!!this.viewer&&this.viewer.removeScene(this)}update(t){const e=this.camera;if(this.audioContext){const t=this.audioContext.listener,i=e.location,n=e.directionY,s=e.directionZ;t.positionX.value=-i[0],t.positionY.value=-i[1],t.positionZ.value=-i[2],t.forwardX.value=n[0],t.forwardY.value=n[1],t.forwardZ.value=n[2],t.upX.value=s[0],t.upY.value=s[1],t.upZ.value=s[2]}const i=this.viewer.frame,n=this.instances;this.visibleCells=0,this.visibleInstances=0;for(const n of this.grid.cells)if(n.isVisible(e)){this.visibleCells+=1;for(const e of n.instances)e.rendered&&e.updateFrame<i&&!e.parent&&(e.updateFrame=i,e.update(t))}n.length=this.visibleInstances,n.sort(((t,e)=>t.depth-e.depth)),this.emittedObjectUpdater.update(t),this.updatedParticles=this.emittedObjectUpdater.alive}renderInstance(t){this.instances[this.visibleInstances++]=t}startFrame(){const t=this.viewer.gl,e=this.viewport;if(t.viewport(e[0],e[1],e[2],e[3]),t.scissor(e[0],e[1],e[2],e[3]),!this.alpha){const e=this.color;t.depthMask(!0),t.clearColor(e[0],e[1],e[2],1),t.clear(t.COLOR_BUFFER_BIT|t.DEPTH_BUFFER_BIT)}}renderOpaque(){const t=this.instances;for(let e=0,i=t.length;e<i;e++)t[e].renderOpaque()}renderTranslucent(){const t=this.instances;for(let e=t.length-1;e>=0;e--)t[e].renderTranslucent()}render(){this.startFrame(),this.renderOpaque(),this.renderTranslucent()}clearEmittedObjects(){for(const t of this.emittedObjectUpdater.objects)t.health=0}}class dl{constructor(t){this.blockers=[],this.viewer=t.viewer,this.fetchUrl=t.fetchUrl}detach(){return this.viewer.unload(this)}}class ul extends dl{constructor(t,e){super(e),this.data=null,this.data=t}}class fl extends dl{constructor(t){super(t),this.pathSolver=t.pathSolver}}class ml extends fl{constructor(){super(...arguments),this.webglResource=null,this.width=0,this.height=0}}function gl(t){return(e=t)instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&137===e[0]&&80===e[1]&&78===e[2]&&71===e[3]&&13===e[4]&&10===e[5]&&26===e[6]&&10===e[7]?"image/png":function(t){return t instanceof ArrayBuffer&&(t=new Uint8Array(t)),t instanceof Uint8Array&&255===t[0]&&216===t[1]&&255===t[t.length-2]&&217===t[t.length-1]}(t)?"image/jpeg":function(t){return t instanceof ArrayBuffer&&(t=new Uint8Array(t)),t instanceof Uint8Array&&71===t[0]&&73===t[1]&&70===t[2]&&56===t[3]&&(55===t[4]||57===t[4])&&97===t[5]}(t)?"image/gif":function(t){return t instanceof ArrayBuffer&&(t=new Uint8Array(t)),t instanceof Uint8Array&&82===t[0]&&73===t[1]&&70===t[2]&&70===t[3]&&87===t[8]&&69===t[9]&&66===t[10]&&80===t[11]}(t)?"image/webp":"";var e}class pl extends ml{constructor(t,e){super(e);const i=this.viewer.gl;this.webglResource=i.createTexture(),i.bindTexture(i.TEXTURE_2D,this.webglResource),i.texImage2D(i.TEXTURE_2D,0,i.RGBA,i.RGBA,i.UNSIGNED_BYTE,t),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MAG_FILTER,i.LINEAR),D(t.width)&&D(t.height)?(i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.LINEAR_MIPMAP_LINEAR),i.generateMipmap(i.TEXTURE_2D)):(i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.LINEAR),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_S,i.CLAMP_TO_EDGE),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_T,i.CLAMP_TO_EDGE)),this.width=t.width,this.height=t.height}}var wl;!function(t){t[t.None=0]="None",t[t.Diffuse=1]="Diffuse",t[t.NormalMap=2]="NormalMap",t[t.Occlusion=3]="Occlusion",t[t.Roughness=4]="Roughness",t[t.Metallic=5]="Metallic",t[t.TCFactor=6]="TCFactor",t[t.Emissive=7]="Emissive",t[t.TexCoords=8]="TexCoords",t[t.Normals=9]="Normals",t[t.Tangents=10]="Tangents"}(wl||(wl={}));class bl extends ja.EventEmitter{constructor(t,e){super(),this.resources=[],this.resourceMap=new Map,this.promiseMap=new Map,this.handlers=new Set,this.scenes=[],this.frame=0,this.visibleCells=0,this.visibleInstances=0,this.updatedParticles=0,this.audioEnabled=!1,this.sharedCache=new Map,this.debugRenderMode=wl.None,this.directLoadId=0;const i=new Xa(t,e),n=i.gl;this.canvas=t,this.gl=n,this.webgl=i,this.buffer=i.createClientBuffer(),n.depthFunc(n.LEQUAL),n.enable(n.DEPTH_TEST),n.enable(n.SCISSOR_TEST)}enableAudio(){return"function"==typeof AudioContext&&(this.audioEnabled=!0,!0)}addHandler(t,...e){if(t){const i=this.handlers;if(!i.has(t)){if(!t.isValidSource)return this.emit("error",{viewer:this,error:"Handler missing the isValidSource function",handler:t}),!1;if(t.load)try{t.load(this,...e)}catch(e){return this.emit("error",{viewer:this,error:"Handler failed to load",handler:t,reason:e}),!1}return i.add(t),!0}}return!1}addScene(){const t=new cl(this);return this.scenes.push(t),t}removeScene(t){const e=this.scenes,i=e.indexOf(t);return-1!==i&&(e.splice(i,1),!0)}clear(){this.scenes.length=0}async load(t,e,i){let n,s,r="";if(e)try{n=e(t,i)}catch(n){return void this.emit("error",{viewer:this,error:"Path solver failed",src:t,reason:n,pathSolver:e,solverParams:i})}else n=t;if(n){if(n instanceof Promise&&(n=await n),n instanceof dl)return n;if("string"!=typeof n||this.detectFormat(n))r="__DIRECT_LOAD_"+this.directLoadId++,s=Promise.resolve(n);else{if(r=n,s=this.promiseMap.get(r),s)return s;const t=this.resourceMap.get(r);if(t)return t;s=Ka(r,"arrayBuffer").then((t=>t.ok?t.data:void this.emit("error",{viewer:this,error:`Failed to fetch a resource: ${t.error}`,fetchUrl:r,reason:t.data})))}return s=s.then((async i=>{if(i){if(i instanceof ArrayBuffer&&(i=new Uint8Array(i)),function(t){return t instanceof ImageData||t instanceof HTMLImageElement||t instanceof HTMLCanvasElement||t instanceof HTMLVideoElement}(i))return new pl(i,{viewer:this,fetchUrl:r,pathSolver:e});if(i instanceof Uint8Array){const t=gl(i);if(t.length)return new pl(await(n=new Blob([i.buffer],{type:t}),new Promise(((t,e)=>{const i=URL.createObjectURL(n),s=new Image;s.onload=()=>{t(s)},s.onerror=t=>{e(t)},s.src=i}))),{viewer:this,fetchUrl:r,pathSolver:e})}const s=this.detectFormat(i);if(s)try{const t=new s.resource(i,{viewer:this,fetchUrl:r,pathSolver:e});return await Promise.all(t.blockers),t.blockers.length=0,t}catch(e){this.emit("error",{viewer:this,error:"Failed to create a resource",fetchUrl:r,src:t,reason:e})}else this.emit("error",{viewer:this,error:"Source has no matching handler",fetchUrl:r,src:t})}var n})).then((t=>(this.promiseMap.delete(r),t&&(this.resourceMap.set(r,t),this.resources.push(t),this.emit("load",{viewer:this,fetchUrl:r,resource:t})),this.emit("loadend",{viewer:this,fetchUrl:r,resource:t}),this.checkLoadingStatus(),t))),this.promiseMap.set(r,s),this.emit("loadstart",{viewer:this,fetchUrl:r,promise:s}),s}}detectFormat(t){for(const e of this.handlers)if(e.isValidSource(t))return e}has(t){return this.resourceMap.has(t)}get(t){return this.resourceMap.get(t)}async loadGeneric(t,e,i){const n=this.promiseMap.get(t);if(n)return n;const s=this.resourceMap.get(t);if(s)return s;const r=Ka(t,e).then((async e=>{let n;if(this.promiseMap.delete(t),e.ok){let s=e.data;i&&(s=await i(s)),n=new ul(s,{viewer:this,fetchUrl:t}),this.resourceMap.set(t,n),this.resources.push(n),this.emit("load",{viewer:this,fetchUrl:t,resource:n})}else this.emit("error",{viewer:this,error:"Failed to fetch a generic resource",fetchUrl:t});return this.emit("loadend",{viewer:this,fetchUrl:t,resource:n}),this.checkLoadingStatus(),n}));return this.promiseMap.set(t,r),this.emit("loadstart",{viewer:this,fetchUrl:t}),r}unload(t){const e=t.fetchUrl;""!==e&&this.resourceMap.delete(e);const i=this.resources,n=i.indexOf(t);return-1!==n&&(i.splice(n,1),!0)}promise(){const t=Promise.resolve(void 0),e=`${performance.now()}`;return this.promiseMap.set(e,t),()=>{this.promiseMap.delete(e),this.checkLoadingStatus()}}checkLoadingStatus(){0===this.promiseMap.size&&setTimeout((()=>this.emit("idle")),0)}whenAllLoaded(t){const e=new Promise((t=>{0===this.promiseMap.size?t(this):this.once("idle",(()=>t(this)))}));if(!t)return e;e.then((()=>t(this)))}toBlob(t){const e=new Promise((t=>this.canvas.toBlob((e=>t(e)))));return t?void e.then((e=>t(e))):e}updateAndRender(t=1e3/60){this.update(t),this.startFrame(),this.render()}update(t=1e3/60){t*=.001,this.frame+=1,this.visibleCells=0,this.visibleInstances=0,this.updatedParticles=0;for(const e of this.scenes)e.update(t),this.visibleCells+=e.visibleCells,this.visibleInstances+=e.visibleInstances,this.updatedParticles+=e.updatedParticles}startFrame(){const t=this.gl;t.depthMask(!0),t.clearColor(0,0,0,1),t.clear(t.COLOR_BUFFER_BIT|t.DEPTH_BUFFER_BIT)}render(){for(const t of this.scenes)t.render()}clearEmittedObjects(){for(const t of this.scenes)t.clearEmittedObjects()}}let vl;"function"==typeof OfflineAudioContext&&(vl=new OfflineAudioContext(1,1,48e3));class yl{constructor(){this.rows=[]}load(t){if(!t.startsWith("ID"))throw new Error("WrongMagicNumber");const e=this.rows;let i=0,n=0;for(const s of t.split("\n"))if("B"!==s[0])for(const t of s.split(";")){const s=t[0],r=t.substring(1).trim();let a;"X"===s?i=parseInt(r,10)-1:"Y"===s?n=parseInt(r,10)-1:"K"===s&&(e[n]||(e[n]=[]),'"'===r[0]?a=r.substring(1,r.length-1):"TRUE"===r?a=!0:"FALSE"===r?a=!1:(a=parseFloat(r),isNaN(a)&&(a=r)),e[n][i]=a)}}save(){const t=this.rows,e=t.length,i=[];let n=0;for(let s=0;s<e;s++){const e=t[s],r=e.length;r>n&&(n=r);let a=!0;for(let t=0;t<r;t++){const n=e[t];if(void 0!==n){let e;e="string"==typeof n?`"${n}"`:"boolean"==typeof n?n?"TRUE":"FALSE":`${n}`,a?(a=!1,i.push(`C;X${t+1};Y${s+1};K${e}`)):i.push(`C;X${t+1};K${e}`)}}}return`ID;P\r\nB;X${n};Y${e}\r\n${i.join("\r\n")}\r\nE`}}class _l{constructor(){this.properties=new Map,this.sections=new Map}load(t){let e=this.properties;const i=this.sections;for(const n of t.split("\r\n"))if(n.length&&!n.startsWith("//")&&!n.startsWith(";")){let t=n.match(/^\[(.+?)\]/);if(t){const n=t[1].trim().toLowerCase();e=i.get(n),e||(e=new Map,i.set(n,e))}else t=n.match(/^(.+?)=(.*?)$/),t&&e.set(t[1],t[2])}}save(){const t=[];for(const[e,i]of this.properties)t.push(`${e}=${i}`);for(const[e,i]of this.sections){t.push(`[${e}]`);for(const[e,n]of i)t.push(`${e}=${n}`)}return t.join("\r\n")}getSection(t){return this.sections.get(t.toLowerCase())}}class xl{constructor(t){this.map={},t&&this.load(t)}load(t){if(t.startsWith("ID;")){const e=new yl;e.load(t);const i=e.rows,n=i[0],s=this.map;for(let t=1,e=i.length;t<e;t++){const e=i[t];if(e){let t=e[0];if(t&&"_"!==t){t=t.toLowerCase(),s[t]||(s[t]={});const i=s[t];for(let t=0,s=n.length;t<s;t++){let s=n[t];void 0===s&&(s=`column${t}`),i[`${s}`]=e[t]}}}}}else{const e=new _l;e.load(t);const i=e.sections,n=this.map;for(const[t,e]of i.entries()){n[t]||(n[t]={});const i=n[t];for(const[t,n]of e)i[t]=n}}}getRow(t){return this.map[t.toLowerCase()]}getProperty(t,e){return this.map[t.toLowerCase()][e]}setRow(t,e){this.map[t.toLowerCase()]=e}findRow(t,e){for(const i of Object.values(this.map))if(i[t]===e)return i}}class Al{constructor(){this.x=0,this.y=0,this.z=0,this.r=0}fromExtents(t,e){const i=t[0],n=t[1],s=t[2],r=e[0]-i,a=e[1]-n,o=e[2]-s;this.x=i+r/2,this.y=n+a/2,this.z=s+o/2,this.r=Math.max(0,Math.max(r,a,o)/2)}}class Tl{constructor(t){this.name=t.name,this.interval=t.interval,this.nonLooping=t.nonLooping,this.rarity=t.rarity,this.bounds=new Al;const e=t.extent;this.bounds.fromExtents(e.min,e.max)}}class El extends fl{constructor(){super(...arguments),this.bounds=new Al}}class Sl{constructor(t,e,i,n,s){this.frames=[],this.values=[],this.inTans=[],this.outTans=[],this.constant=!1,this.sd=t,this.start=e,this.end=i;const r=t.interpolationType,a=n.frames,o=n.values,l=n.inTans,h=n.outTans,c=t.defval;s&&a[0]>i&&(this.frames[0]=a[0],this.values[0]=o[0]);for(let t=0,n=a.length;t<n;t++){const n=a[t];n>=e&&n<=i&&(this.frames.push(n),this.values.push(o[t]),r>1&&(this.inTans.push(l[t]),this.outTans.push(h[t])))}const d=this.frames.length;if(0===d)this.constant=!0,this.frames[0]=e,this.values[0]=c;else if(1===d)this.constant=!0;else{const t=this.values[0];this.constant=this.values.every((e=>t.every(((t,i)=>t===e[i]))))}}getValue(t,e){const i=this.frames.length;if(this.constant||e<this.start)return this.sd.copy(t,this.values[0]),-1;{let n=-1,s=-1;const r=i-1;if(e<this.frames[0]||e>=this.frames[r])n=r,s=0;else for(let t=1;t<i;t++)if(this.frames[t]>e){n=t-1,s=t;break}let a=this.frames[n];const o=this.frames[s];let l=o-a;l<0&&(l+=this.end-this.start,e<a&&(a=o));const h=0==l?0:(e-a)/l;return this.sd.interpolate(t,this.values,this.inTans,this.outTans,n,s,h),n}}}const Il={KLAV:0,KATV:0,KPEV:0,KP2V:0,KRVS:0},kl=new Float32Array(1),Ll=new Uint32Array(1),Ml=new Float32Array([1]),Cl=Za(),Rl=po(),Bl=Ja(1,1,1),Ul=Cl,Pl={KMTF:kl,KMTA:Ml,KTAT:Cl,KTAR:Rl,KTAS:Bl,KGAO:Ml,KGAC:Ul,KLAS:kl,KLAE:kl,KLAC:Ul,KLAI:kl,KLBI:kl,KLBC:Ul,KLAV:Ml,KATV:Ml,KPEE:kl,KPEG:kl,KPLN:kl,KPLT:kl,KPEL:kl,KPES:kl,KPEV:Ml,KP2S:kl,KP2R:kl,KP2L:kl,KP2G:kl,KP2E:kl,KP2N:kl,KP2W:kl,KP2V:Ml,KRHA:kl,KRHB:kl,KRAL:new Float32Array([0]),KRCO:Ul,KRTX:kl,KRVS:Ml,KCTR:Cl,KTTR:Cl,KCRL:Ll,KGTR:Cl,KGRT:Rl,KGSC:Bl};class Fl{constructor(t,e){this.globalSequence=null,this.sequences=[];const i=t.globalSequences,n=e.globalSequenceId,s=Il[e.name];if(this.model=t,this.name=e.name,this.defval=Pl[e.name],this.interpolationType=void 0!==s?s:e.interpolationType,-1!==n&&i)this.globalSequence=new Sl(this,0,i[n],e,!0);else for(const i of t.sequences){const t=i.interval;this.sequences.push(new Sl(this,t[0],t[1],e,!1))}}getValue(t,e,i,n){return this.globalSequence?this.globalSequence.getValue(t,n%this.globalSequence.end):this.sequences[e].getValue(t,i)}isVariant(t){return this.globalSequence?!this.globalSequence.constant:!this.sequences[t].constant}}class Nl extends Fl{copy(t,e){t[0]=e[0]}interpolate(t,e,i,n,s,r,a){const o=this.interpolationType,l=e[s][0];0===o?t[0]=l:1===o?t[0]=function(t,e,i){return t+i*(e-t)}(l,e[r][0],a):2===o?t[0]=function(t,e,i,n,s){const r=s*s;return t*(r*(2*s-3)+1)+e*(r*(s-2)+s)+i*(r*(s-1))+n*(r*(3-2*s))}(l,n[s][0],i[r][0],e[r][0],a):3===o&&(t[0]=function(t,e,i,n,s){const r=1-s,a=s*s,o=r*r;return t*(o*r)+e*(3*s*o)+i*(3*a*r)+n*(a*s)}(l,n[s][0],i[r][0],e[r][0],a))}}class Dl extends Fl{copy(t,e){to(t,e)}interpolate(t,e,i,n,s,r,a){const o=this.interpolationType;0===o?to(t,e[s]):1===o?function(t,e,i,n){var s=e[0],r=e[1],a=e[2];t[0]=s+n*(i[0]-s),t[1]=r+n*(i[1]-r),t[2]=a+n*(i[2]-a)}(t,e[s],e[r],a):2===o?function(t,e,i,n,s,r){var a=r*r,o=a*(2*r-3)+1,l=a*(r-2)+r,h=a*(r-1),c=a*(3-2*r);t[0]=e[0]*o+i[0]*l+n[0]*h+s[0]*c,t[1]=e[1]*o+i[1]*l+n[1]*h+s[1]*c,t[2]=e[2]*o+i[2]*l+n[2]*h+s[2]*c}(t,e[s],n[s],i[r],e[r],a):3===o&&function(t,e,i,n,s,r){var a=1-r,o=a*a,l=r*r,h=o*a,c=3*r*o,d=3*l*a,u=l*r;t[0]=e[0]*h+i[0]*c+n[0]*d+s[0]*u,t[1]=e[1]*h+i[1]*c+n[1]*d+s[1]*u,t[2]=e[2]*h+i[2]*c+n[2]*d+s[2]*u}(t,e[s],n[s],i[r],e[r],a)}}class Ol extends Fl{copy(t,e){Ro(t,e)}interpolate(t,e,i,n,s,r,a){const o=this.interpolationType;0===o?Ro(t,e[s]):1===o?xo(t,e[s],e[r],a):2!==o&&3!==o||Po(t,e[s],n[s],i[r],e[r],a)}}function Vl(t,e){return e instanceof Ls||e instanceof Ms?new Nl(t,e):e instanceof Cs?new Dl(t,e):new Ol(t,e)}class Gl{constructor(t,e){this.animations=new Map,this.variants={},this.model=t;for(const i of e.animations)this.animations.set(i.name,Vl(t,i))}getScalarValue(t,e,i,n,s,r){if(-1!==i){const r=this.animations.get(e);if(r)return r.getValue(t,i,n,s)}return t[0]=r,-1}getVectorValue(t,e,i,n,s,r){if(-1!==i){const r=this.animations.get(e);if(r)return r.getValue(t,i,n,s)}return t[0]=r[0],t[1]=r[1],t[2]=r[2],-1}getQuatValue(t,e,i,n,s,r){if(-1!==i){const r=this.animations.get(e);if(r)return r.getValue(t,i,n,s)}return t[0]=r[0],t[1]=r[1],t[2]=r[2],t[3]=r[3],-1}addVariants(t,e){const i=this.animations.get(t),n=this.model.sequences.length,s=new Uint8Array(n);if(i)for(let t=0;t<n;t++)i.isVariant(t)&&(s[t]=1);this.variants[e]=s}addVariantIntersection(t,e){const i=this.model.sequences.length,n=new Uint8Array(i);for(let e=0;e<i;e++)for(const i of t)this.variants[i][e]&&(n[e]=1);this.variants[e]=n}}class jl extends Gl{constructor(t,e){super(t,e),this.addVariants("KTAT","translation"),this.addVariants("KTAR","rotation"),this.addVariants("KTAS","scale")}getTranslation(t,e,i,n){return this.getVectorValue(t,"KTAT",e,i,n,Ko)}getRotation(t,e,i,n){return this.getQuatValue(t,"KTAR",e,i,n,zo)}getScale(t,e,i,n){return this.getVectorValue(t,"KTAS",e,i,n,$o)}}function Kl(t,e){return 0===t?[e.SRC_ALPHA,e.ONE_MINUS_SRC_ALPHA]:1===t?[e.SRC_ALPHA,e.ONE]:2===t?[e.ZERO,e.SRC_COLOR]:3===t?[e.DST_COLOR,e.SRC_COLOR]:4===t?[e.SRC_ALPHA,e.ONE_MINUS_SRC_ALPHA]:[0,0]}class $l extends Gl{constructor(t,e,i,n){super(t,e),this.textureId=0,this.blendSrc=0,this.blendDst=0,this.blended=!1,this.textureAnimation=null;let s=e.filterMode;const r=e.textureAnimationId,a=t.viewer.gl;this.index=i,this.priorityPlane=n,s>6&&(s=2),this.filterMode=s,-1!==e.textureId&&(this.textureId=e.textureId),this.coordId=e.coordId,this.alpha=e.alpha;const o=e.flags;if(this.unshaded=1&o,this.sphereEnvironmentMap=2&o,this.twoSided=16&o,this.unfogged=32&o,this.noDepthTest=64&o,this.noDepthSet=128&o,this.depthMaskValue=0===s||1===s,s>1&&(this.blended=!0,[this.blendSrc,this.blendDst]=function(t,e){return 2===t?[e.SRC_ALPHA,e.ONE_MINUS_SRC_ALPHA]:3===t||4===t?[e.SRC_ALPHA,e.ONE]:5===t?[e.ZERO,e.SRC_COLOR]:6===t?[e.DST_COLOR,e.SRC_COLOR]:[0,0]}(s,a)),-1!==r){const e=t.textureAnimations[r];e&&(this.textureAnimation=e)}this.addVariants("KMTA","alpha"),this.addVariants("KMTF","textureId")}bind(t){const e=this.model.viewer.gl;e.uniform1f(t.uniforms.u_filterMode,this.filterMode),this.blended?(e.enable(e.BLEND),e.blendFunc(this.blendSrc,this.blendDst)):e.disable(e.BLEND),this.twoSided?e.disable(e.CULL_FACE):e.enable(e.CULL_FACE),this.noDepthTest?e.disable(e.DEPTH_TEST):e.enable(e.DEPTH_TEST),this.noDepthSet?e.depthMask(!1):e.depthMask(this.depthMaskValue)}getAlpha(t,e,i,n){return this.getScalarValue(t,"KMTA",e,i,n,this.alpha)}getTextureId(t,e,i,n){return this.getScalarValue(t,"KMTF",e,i,n,this.textureId)}}class zl{constructor(t,e,i){this.model=t,this.shader=e,this.layers=i}}class ql extends Gl{constructor(t,e){super(t,e);const i=e.color;this.alpha=e.alpha,this.color=Ja(i[2],i[1],i[0]),this.geosetId=e.geosetId,this.addVariants("KGAO","alpha"),this.addVariants("KGAC","color")}getAlpha(t,e,i,n){return this.getScalarValue(t,"KGAO",e,i,n,this.alpha)}getColor(t,e,i,n){return this.getVectorValue(t,"KGAC",e,i,n,this.color)}}const Hl={1:"TeamColor/TeamColor00",2:"TeamGlow/TeamGlow00",11:"Cliff/Cliff0",21:"",31:"LordaeronTree/LordaeronSummerTree",32:"AshenvaleTree/AshenTree",33:"BarrensTree/BarrensTree",34:"NorthrendTree/NorthTree",35:"Mushroom/MushroomTree",36:"RuinsTree/RuinsTree",37:"OutlandMushroomTree/MushroomTree"};class Xl extends Gl{constructor(t,e,i){super(t,e),this.index=i,this.name=e.name,this.objectId=e.objectId,this.parentId=e.parentId,this.pivot=t.pivotPoints[e.objectId]||Za();const n=e.flags;this.dontInheritTranslation=1&n,this.dontInheritRotation=2&n,this.dontInheritScaling=4&n,this.billboarded=8&n,this.billboardedX=16&n,this.billboardedY=32&n,this.billboardedZ=64&n,this.cameraAnchored=128&n,this.anyBillboarding=0!==(this.billboarded||this.billboardedX||this.billboardedY||this.billboardedZ),e.objectId===e.parentId&&(this.parentId=-1),this.addVariants("KGTR","translation"),this.addVariants("KGRT","rotation"),this.addVariants("KGSC","scale"),this.addVariantIntersection(["translation","rotation","scale"],"generic")}getVisibility(t,e,i,n){return t[0]=1,-1}getTranslation(t,e,i,n){return this.getVectorValue(t,"KGTR",e,i,n,Ko)}getRotation(t,e,i,n){return this.getQuatValue(t,"KGRT",e,i,n,zo)}getScale(t,e,i,n){return this.getVectorValue(t,"KGSC",e,i,n,$o)}}class Wl extends Xl{constructor(t,e,i){super(t,e,i),this.geosetAnimation=t.geosetAnimations[e.geosetAnimationId]}getVisibility(t,e,i,n){return this.geosetAnimation?this.geosetAnimation.getAlpha(t,e,i,n):(t[0]=1,-1)}}class Yl extends Xl{constructor(t,e,i){super(t,e,i),this.type=e.type,this.attenuation=e.attenuation,this.color=e.color,this.intensity=e.intensity,this.ambientColor=e.ambientColor,this.ambientIntensity=e.ambientIntensity}getAttenuationStart(t,e,i,n){return this.getScalarValue(t,"KLAS",e,i,n,this.attenuation[0])}getAttenuationEnd(t,e,i,n){return this.getScalarValue(t,"KLAE",e,i,n,this.attenuation[1])}getIntensity(t,e,i,n){return this.getScalarValue(t,"KLAI",e,i,n,this.intensity)}getColor(t,e,i,n){return this.getVectorValue(t,"KLAC",e,i,n,this.color)}getAmbientIntensity(t,e,i,n){return this.getScalarValue(t,"KLBI",e,i,n,this.ambientIntensity)}getAmbientColor(t,e,i,n){return this.getVectorValue(t,"KLBC",e,i,n,this.ambientColor)}}class Zl extends Xl{}class Ql extends Xl{constructor(t,e,i){super(t,e,i),this.internalModel=null;const n=e.path.replace(/\\/g,"/").toLowerCase().replace(".mdl",".mdx");if(this.path=n,this.attachmentId=e.attachmentId,""!==n&&-1!=n.indexOf(".mdx")){const e=t.viewer.load(n,t.pathSolver,t.solverParams);e.then((t=>{t&&(this.internalModel=t)})),t.blockers.push(e)}}getVisibility(t,e,i,n){return this.getScalarValue(t,"KATV",e,i,n,1)}}class Jl extends Xl{constructor(t,e,i){super(t,e,i),this.internalModel=null,this.ok=!1,this.speed=e.speed,this.latitude=e.latitude,this.longitude=e.longitude,this.lifeSpan=e.lifeSpan,this.gravity=e.gravity,this.emissionRate=e.emissionRate,t.viewer.load(e.path.replace(/\\/g,"/").toLowerCase().replace(".mdl",".mdx"),t.pathSolver,t.solverParams).then((t=>{t&&(this.internalModel=t,this.ok=!0)}))}getSpeed(t,e,i,n){return this.getScalarValue(t,"KPES",e,i,n,this.speed)}getLatitude(t,e,i,n){return this.getScalarValue(t,"KPLTV",e,i,n,this.latitude)}getLongitude(t,e,i,n){return this.getScalarValue(t,"KPLN",e,i,n,this.longitude)}getLifeSpan(t,e,i,n){return this.getScalarValue(t,"KPEL",e,i,n,this.lifeSpan)}getGravity(t,e,i,n){return this.getScalarValue(t,"KPEG",e,i,n,this.gravity)}getEmissionRate(t,e,i,n){return this.getScalarValue(t,"KPEE",e,i,n,this.emissionRate)}getVisibility(t,e,i,n){return this.getScalarValue(t,"KPEV",e,i,n,1)}}const th=Za(),eh=Za(),ih=Za(),nh=60,sh=1e4;function rh(t,e){const i=t.objects,n=e.floatView;let s=0;for(const t of i){const e=15*s,i=e+0,r=t.vertices;n[i+0]=r[0],n[i+1]=r[1],n[i+2]=r[2],n[i+3]=r[3],n[i+4]=r[4],n[i+5]=r[5],n[i+6]=r[6],n[i+7]=r[7],n[i+8]=r[8],n[i+9]=r[9],n[i+10]=r[10],n[i+11]=r[11],n[e+12]=t.health,s+=1}}function ah(t,e){let i=t.alive;const n=t.emitterObject.geometryEmitterType;if(1===n&&(i-=1),i>0){const s=t.instance.model.viewer,r=s.buffer,a=s.gl,o=s.webgl.extensions.ANGLE_instanced_arrays,l=i*nh,h=e.attribs;r.reserve(l),0===n?(function(t,e){const i=t.instance,n=t.objects,s=e.byteView,r=e.floatView,a=t.emitterObject,o=a.modelSpace,l=a.tailLength,h=t.node,c=i.teamColor;let d=0;for(const t of n){const e=d*nh,i=15*d,n=i+0;let a=t.location;const u=t.scale,f=t.tail;if(0===f)o&&(a=oo(th,a,h.worldMatrix)),r[n+0]=a[0],r[n+1]=a[1],r[n+2]=a[2],r[n+3]=t.facing;else{const e=t.velocity;let i=eh,s=a;i[0]=s[0]-l*e[0],i[1]=s[1]-l*e[1],i[2]=s[2]-l*e[2],o&&(i=oo(i,i,h.worldMatrix),s=oo(ih,s,h.worldMatrix)),r[n+0]=i[0],r[n+1]=i[1],r[n+2]=i[2],r[n+3]=s[0],r[n+4]=s[1],r[n+5]=s[2]}r[n+6]=u[0],r[n+7]=u[0],r[n+8]=u[0],r[i+12]=t.health,s[e+56]=f,s[e+57]=c,d+=1}}(t,r),function(t,e){const i=t.instance,n=i.textureOverrides,s=i.scene.camera,r=t.emitterObject,a=r.model,o=a.viewer,l=o.gl,h=o.sharedCache.get("mdx"),c=e.uniforms,d=r.colors,u=r.intervals,f=r.replaceableId;let m,g=r.internalTexture;l.blendFunc(r.blendSrc,r.blendDst),l.uniform1f(c.u_filterMode,r.filterMode),g=r.internalTexture?r.internalTexture:1===f?h.teamColors[i.teamColor]:2===f?h.teamGlows[i.teamColor]:a.textures[r.textureId];let p=n.get(1e3+r.index);p||(0===f&&(p=n.get(r.textureId)),p||(p=g.texture)),o.webgl.bindTextureAndWrap(p,0,g.wrapS,g.wrapT),m=r.xYQuad?s.vectors:s.billboardedVectors,l.uniform1f(c.u_lifeSpan,r.lifeSpan),l.uniform1f(c.u_timeMiddle,r.timeMiddle),l.uniform1f(c.u_columns,r.columns),l.uniform1f(c.u_rows,r.rows),l.uniform1f(c.u_teamColored,r.teamColored),l.uniform3fv(c["u_intervals[0]"],u[0]),l.uniform3fv(c["u_intervals[1]"],u[1]),l.uniform3fv(c["u_intervals[2]"],u[2]),l.uniform3fv(c["u_intervals[3]"],u[3]),l.uniform4fv(c["u_colors[0]"],d[0]),l.uniform4fv(c["u_colors[1]"],d[1]),l.uniform4fv(c["u_colors[2]"],d[2]),l.uniform3fv(c.u_scaling,r.scaling),r.head&&(l.uniform3fv(c["u_vertices[0]"],m[0]),l.uniform3fv(c["u_vertices[1]"],m[1]),l.uniform3fv(c["u_vertices[2]"],m[2]),l.uniform3fv(c["u_vertices[3]"],m[3])),r.tail&&l.uniform3fv(c.u_cameraZ,s.directionZ)}(t,e)):1===n?(function(t,e){let i=t.first;const n=e.byteView,s=e.floatView,r=t.emitterObject.columns,a=1/(t.alive-1);let o=0;for(;i.next;){const t=i.next.vertices,e=o*nh,l=15*o+0,h=e+52,c=e+57,d=(i.slot%r+(1-o*a-a))/r,u=i.slot/r,f=d+a,m=i.vertices,g=i.color;s[l+0]=m[0],s[l+1]=m[1],s[l+2]=m[2],s[l+3]=m[3],s[l+4]=m[4],s[l+5]=m[5],s[l+6]=t[3],s[l+7]=t[4],s[l+8]=t[5],s[l+9]=t[0],s[l+10]=t[1],s[l+11]=t[2],n[h+0]=g[0],n[h+1]=g[1],n[h+2]=g[2],n[h+3]=g[3],n[c+0]=255*d,n[c+1]=255*f,n[c+2]=255*u,i=i.next,o+=1}}(t,r),function(t,e){const i=t.instance.textureOverrides,n=t.emitterObject,s=n.layer,r=n.model,a=r.viewer.gl,o=e.uniforms,l=r.textures[s.textureId],h=i.get(s.textureId)||l.texture;s.bind(e),a.uniform1f(o.u_filterMode,s.filterMode),r.viewer.webgl.bindTextureAndWrap(h,0,l.wrapS,l.wrapT),a.uniform1f(o.u_columns,n.columns),a.uniform1f(o.u_rows,n.rows)}(t,e)):2===n?(rh(t,r),function(t,e){const i=t.instance.textureOverrides,n=t.emitterObject,s=n.intervalTimes,r=n.intervals,a=n.colors,o=n.model,l=o.viewer.gl,h=e.uniforms,c=n.internalTexture,d=i.get(sh+n.index)||c.texture;l.blendFunc(n.blendSrc,n.blendDst),o.viewer.webgl.bindTextureAndWrap(d,0,c.wrapS,c.wrapT),l.uniform1f(h.u_lifeSpan,n.lifeSpan),l.uniform1f(h.u_columns,n.columns),l.uniform1f(h.u_rows,n.rows),l.uniform3f(h.u_intervalTimes,s[0],s[1],0),l.uniform3fv(h["u_intervals[0]"],r[0]),l.uniform3fv(h["u_intervals[1]"],r[1]),l.uniform4fv(h["u_colors[0]"],a[0]),l.uniform4fv(h["u_colors[1]"],a[1]),l.uniform4fv(h["u_colors[2]"],a[2])}(t,e)):(rh(t,r),function(t,e){const i=t.instance.textureOverrides,n=t.emitterObject,s=n.intervalTimes,r=n.colors,a=n.model,o=a.viewer.gl,l=e.uniforms,h=n.internalTexture,c=i.get(sh+n.index)||h.texture;o.blendFunc(n.blendSrc,n.blendDst),a.viewer.webgl.bindTextureAndWrap(c,0,h.wrapS,h.wrapT),o.uniform1f(l.u_lifeSpan,n.lifeSpan),o.uniform1f(l.u_columns,n.columns),o.uniform1f(l.u_rows,n.rows),o.uniform3fv(l.u_intervalTimes,s),o.uniform4fv(l["u_colors[0]"],r[0]),o.uniform4fv(l["u_colors[1]"],r[1]),o.uniform4fv(l["u_colors[2]"],r[2])}(t,e)),r.bindAndUpdate(l),a.uniform1i(e.uniforms.u_emitter,n),a.vertexAttribPointer(h.a_p0,3,a.FLOAT,!1,nh,0),a.vertexAttribPointer(h.a_p1,3,a.FLOAT,!1,nh,12),a.vertexAttribPointer(h.a_p2,3,a.FLOAT,!1,nh,24),a.vertexAttribPointer(h.a_p3,3,a.FLOAT,!1,nh,36),a.vertexAttribPointer(h.a_health,1,a.FLOAT,!1,nh,48),a.vertexAttribPointer(h.a_color,4,a.UNSIGNED_BYTE,!0,nh,52),a.vertexAttribPointer(h.a_tail,1,a.UNSIGNED_BYTE,!1,nh,56),a.vertexAttribPointer(h.a_leftRightTop,3,a.UNSIGNED_BYTE,!1,nh,57),o.drawArraysInstancedANGLE(a.TRIANGLES,0,6,i)}}class oh{constructor(t,e){this.texture=null,this.wrapS=33071,this.wrapT=33071,this.replaceableId=t,1&e&&(this.wrapS=10497),2&e&&(this.wrapT=10497)}}class lh extends Xl{constructor(t,e,i){super(t,e,i),this.geometryEmitterType=0,this.teamColored=0,this.internalTexture=null,this.colors=[],this.ok=!0,this.width=e.width,this.length=e.length,this.speed=e.speed,this.latitude=e.latitude,this.gravity=e.gravity,this.emissionRate=2*e.emissionRate,this.squirt=e.squirt,this.lifeSpan=e.lifeSpan,this.variation=e.variation,this.tailLength=e.tailLength,this.timeMiddle=e.timeMiddle;const n=e.flags;this.lineEmitter=131072&n,this.unfogged=262144&n,this.modelSpace=524288&n,this.xYQuad=1048576&n;const s=e.replaceableId;if(this.columns=e.columns,this.rows=e.rows,1===s||2===s)this.teamColored=1;else if(s>2){const e=t.reforged?".dds":".blp";this.internalTexture=new oh(s,0),t.viewer.load(`ReplaceableTextures\\${Hl[s]}${e}`,t.pathSolver,t.solverParams).then((t=>{t&&(this.internalTexture.texture=t)}))}this.replaceableId=e.replaceableId,this.textureId=e.textureId;const r=e.headOrTail;this.head=0===r||2===r,this.tail=1===r||2===r,this.cellWidth=1/e.columns,this.cellHeight=1/e.rows;const a=e.segmentColors,o=e.segmentAlphas;for(let t=0;t<3;t++){const e=a[t];this.colors[t]=new Float32Array([e[0],e[1],e[2],o[t]/255])}this.scaling=e.segmentScaling;const l=e.headIntervals,h=e.tailIntervals;this.intervals=[new Float32Array(l[0]),new Float32Array(l[1]),new Float32Array(h[0]),new Float32Array(h[1])];const c=Kl(e.filterMode,this.model.viewer.gl);this.filterMode=e.filterMode,this.blendSrc=c[0],this.blendDst=c[1],this.priorityPlane=e.priorityPlane}getWidth(t,e,i,n){return this.getScalarValue(t,"KP2N",e,i,n,this.width)}getLength(t,e,i,n){return this.getScalarValue(t,"KP2W",e,i,n,this.length)}getSpeed(t,e,i,n){return this.getScalarValue(t,"KP2S",e,i,n,this.speed)}getLatitude(t,e,i,n){return this.getScalarValue(t,"KP2L",e,i,n,this.latitude)}getGravity(t,e,i,n){return this.getScalarValue(t,"KP2G",e,i,n,this.gravity)}getEmissionRate(t,e,i,n){return this.getScalarValue(t,"KP2E",e,i,n,this.emissionRate)}getVariation(t,e,i,n){return this.getScalarValue(t,"KP2R",e,i,n,this.variation)}getVisibility(t,e,i,n){return this.getScalarValue(t,"KP2V",e,i,n,1)}}class hh extends Xl{constructor(t,e,i){super(t,e,i),this.geometryEmitterType=1,this.ok=!0,this.layer=t.materials[e.materialId].layers[0],this.heightAbove=e.heightAbove,this.heightBelow=e.heightBelow,this.alpha=e.alpha,this.color=e.color,this.lifeSpan=e.lifeSpan,this.textureSlot=e.textureSlot,this.emissionRate=2*e.emissionRate,this.gravity=e.gravity,this.columns=e.columns,this.rows=e.rows}getHeightBelow(t,e,i,n){return this.getScalarValue(t,"KRHB",e,i,n,this.heightBelow)}getHeightAbove(t,e,i,n){return this.getScalarValue(t,"KRHA",e,i,n,this.heightAbove)}getTextureSlot(t,e,i,n){return this.getScalarValue(t,"KRTX",e,i,n,0)}getColor(t,e,i,n){return this.getVectorValue(t,"KRCO",e,i,n,this.color)}getAlpha(t,e,i,n){return this.getScalarValue(t,"KRAL",e,i,n,this.alpha)}getVisibility(t,e,i,n){const s=this.getAlpha(t,e,i,n);return 0===t[0]?s:this.getScalarValue(t,"KRVS",e,i,n,1)}}class ch extends Gl{constructor(t,e){super(t,e),this.name=e.name,this.position=e.position,this.fieldOfView=e.fieldOfView,this.farClippingPlane=e.farClippingPlane,this.nearClippingPlane=e.nearClippingPlane,this.targetPosition=e.targetPosition}getTranslation(t,e,i,n){return this.getVectorValue(t,"KCTR",e,i,n,Ko)}getTargetTranslation(t,e,i,n){return this.getVectorValue(t,"KTTR",e,i,n,Ko)}getRotation(t,e,i,n){return this.getScalarValue(t,"KCRL",e,i,n,0)}}class dh extends Xl{constructor(t,e,i){super(t,e,i),this.geometryEmitterType=-1,this.globalSequence=-1,this.defval=new Uint32Array(1),this.internalModel=null,this.internalTexture=null,this.colors=[],this.intervalTimes=new Float32Array(3),this.scale=0,this.columns=0,this.rows=0,this.lifeSpan=0,this.blendSrc=0,this.blendDst=0,this.intervals=[],this.distanceCutoff=0,this.maxDistance=0,this.minDistance=0,this.pitch=0,this.pitchVariance=0,this.volume=0,this.decodedBuffers=[],this.ok=!1;const n=t.viewer,s=e.name;let r=s.substring(0,3);const a=s.substring(4);"FPT"===r&&(r="SPL"),"SPL"===r?this.geometryEmitterType=2:"UBR"===r&&(this.geometryEmitterType=3),this.type=r,this.id=a,this.tracks=e.tracks;const o=e.globalSequenceId;if(-1!==o&&(this.globalSequence=t.globalSequences[o]),"SND"===r&&!n.audioEnabled)return;const l=n.promise();Uc.getEventObjectData(n,r,a,t.hd).then((t=>{if(l(),t){const{row:e,resources:i}=t;if(this.ok=!0,"SPN"===r)this.internalModel=i[0];else if("SPL"===r||"UBR"===r){this.internalTexture=new oh(0,3),this.internalTexture.texture=i[0],this.scale=e.Scale,this.colors[0]=new Float32Array([e.StartR,e.StartG,e.StartB,e.StartA]),this.colors[1]=new Float32Array([e.MiddleR,e.MiddleG,e.MiddleB,e.MiddleA]),this.colors[2]=new Float32Array([e.EndR,e.EndG,e.EndB,e.EndA]),"SPL"===r?(this.columns=e.Columns,this.rows=e.Rows,this.lifeSpan=e.Lifespan+e.Decay,this.intervalTimes[0]=e.Lifespan,this.intervalTimes[1]=e.Decay,this.intervals[0]=new Float32Array([e.UVLifespanStart,e.UVLifespanEnd,e.LifespanRepeat]),this.intervals[1]=new Float32Array([e.UVDecayStart,e.UVDecayEnd,e.DecayRepeat])):(this.columns=1,this.rows=1,this.lifeSpan=e.BirthTime+e.PauseTime+e.Decay,this.intervalTimes[0]=e.BirthTime,this.intervalTimes[1]=e.PauseTime,this.intervalTimes[2]=e.Decay);const t=Kl(e.BlendMode,n.gl);this.blendSrc=t[0],this.blendDst=t[1]}else{this.distanceCutoff=e.DistanceCutoff,this.maxDistance=e.MaxDistance,this.minDistance=e.MinDistance,this.pitch=e.Pitch,this.pitchVariance=e.PitchVariance,this.volume=e.Volume;for(const t of i)this.decodedBuffers.push(t.data)}}}))}getValue(t,e){if(-1!==this.globalSequence){const i=this.globalSequence;return this.getValueAtTime(t,e.counter%i,0,i)}if(-1!==e.sequence){const i=this.model.sequences[e.sequence].interval;return this.getValueAtTime(t,e.frame,i[0],i[1])}return t[0]=this.defval[0],-1}getValueAtTime(t,e,i,n){const s=this.tracks;if(e>=i&&e<=n)for(let n=s.length-1;n>-1;n--){if(s[n]<i)return t[0]=0,n;if(s[n]<=e)return t[0]=1,n}return t[0]=0,-1}}class uh extends Xl{}var fh;!function(t){t[t.VertexGroups=0]="VertexGroups",t[t.ExtendedVertexGroups=1]="ExtendedVertexGroups",t[t.Skin=2]="Skin"}(fh||(fh={}));class mh{constructor(t,e,i,n,s){let r,a;s?(r=i,a=r.layers[0]):(r=null,a=i),this.index=t,this.geoset=e,this.skinningType=n,this.isHd=s,this.layer=a,this.material=r}}class gh{constructor(t,e,i,n,s,r,a,o,l,h,c){this.geosetAnimation=null,this.model=t,this.index=e,this.positionOffset=i,this.normalOffset=n,this.uvOffset=s,this.tangentOffset=r,this.skinOffset=a,this.faceOffset=o,this.vertices=l,this.elements=h,this.faceType=c;for(const i of t.geosetAnimations)i.geosetId===e&&(this.geosetAnimation=i)}bindShared(t,e,i){t.vertexAttribPointer(e.a_position,3,t.FLOAT,!1,0,this.positionOffset),t.vertexAttribPointer(e.a_normal,3,t.FLOAT,!1,0,this.normalOffset),t.vertexAttribPointer(e.a_uv,2,t.FLOAT,!1,0,this.uvOffset+i*this.vertices*8)}bindVertexGroups(t,e){const i=this.model,n=i.skinDataType,s=i.bytesPerSkinElement;t.vertexAttribPointer(e.a_bones,4,n,!1,5*s,this.skinOffset),t.vertexAttribPointer(e.a_boneNumber,1,n,!1,5*s,this.skinOffset+4*s)}bindVertexGroupsExtended(t,e){const i=this.model,n=i.skinDataType,s=i.bytesPerSkinElement;t.vertexAttribPointer(e.a_bones,4,n,!1,9*s,this.skinOffset),t.vertexAttribPointer(e.a_extendedBones,4,n,!1,9*s,this.skinOffset+4*s),t.vertexAttribPointer(e.a_boneNumber,1,n,!1,9*s,this.skinOffset+8*s)}bindSkin(t,e){t.vertexAttribPointer(e.a_bones,4,t.UNSIGNED_BYTE,!1,8,this.skinOffset),t.vertexAttribPointer(e.a_weights,4,t.UNSIGNED_BYTE,!0,8,this.skinOffset+4)}bind(t,e){const i=this.model.viewer.gl,n=t.attribs;this.bindShared(i,n,e),this.bindVertexGroups(i,n)}bindExtended(t,e){const i=this.model.viewer.gl,n=t.attribs;this.bindShared(i,n,e),this.bindVertexGroupsExtended(i,n)}bindHd(t,e,i){const n=this.model.viewer.gl,s=t.attribs;this.bindShared(n,s,i),n.vertexAttribPointer(s.a_tangent,4,n.FLOAT,!1,0,this.tangentOffset),e===fh.Skin?this.bindSkin(n,s):e===fh.VertexGroups?this.bindVertexGroupsExtended(n,s):this.bindVertexGroups(n,s)}render(){const t=this.model.viewer.gl;t.drawElements(this.faceType,this.elements,t.UNSIGNED_SHORT,this.faceOffset)}}class ph{constructor(t,e,i){this.objects=[],this.model=t,this.skinningType=e,this.isHd=i}render(t){const e=t.scene,i=e.camera,n=t.textureOverrides,s=t.layerAlphas,r=this.model,a=r.textures,o=r.batches,l=r.viewer,h=l.sharedCache.get("mdx"),c=l.gl,d=l.webgl,u=this.skinningType,f=this.isHd,m=h.teamColors,g=h.teamGlows,p=Uc.getBatchShader(l,u,f);p.use();const w=p.uniforms;c.uniformMatrix4fv(w.u_VP,!1,i.viewProjectionMatrix);const b=t.boneTexture;if(b?(b.bind(15),c.uniform1f(w.u_hasBones,1),c.uniform1i(w.u_boneMap,15),c.uniform1f(w.u_vectorSize,1/b.width),c.uniform1f(w.u_rowSize,1)):c.uniform1f(w.u_hasBones,0),c.uniform3fv(w.u_lightPos,e.lightPosition),c.bindBuffer(c.ARRAY_BUFFER,r.arrayBuffer),c.bindBuffer(c.ELEMENT_ARRAY_BUFFER,r.elementBuffer),f){c.uniform1i(w.u_diffuseMap,0),c.uniform1i(w.u_normalsMap,1),c.uniform1i(w.u_ormMap,2),c.uniform1i(w.u_emissiveMap,3),c.uniform1i(w.u_teamColorMap,4),c.uniform1i(w.u_environmentMap,5),c.disable(c.BLEND),c.enable(c.DEPTH_TEST),c.depthMask(!0),c.uniformMatrix4fv(w.u_MV,!1,i.viewMatrix),c.uniform3fv(w.u_eyePos,i.location);for(const e of this.objects){const i=o[e],r=i.geoset,l=i.material,[h,u,f,g,b,v]=l.layers,y=s[h.index];if(y>0){c.uniform1f(w.u_layerAlpha,y),c.uniform1f(w.u_filterMode,h.filterMode);const e=h.textureId,s=u.textureId,o=f.textureId,l=g.textureId,_=b.textureId,x=v.textureId,A=a[e],T=a[s],E=a[o],S=a[l];let I=a[_];const k=a[x];0!==I.replaceableId&&1!==I.replaceableId||(I=m[t.teamColor]);const L=n.get(e)||A.texture,M=n.get(s)||T.texture,C=n.get(o)||E.texture,R=n.get(l)||S.texture,B=n.get(_)||I.texture,U=n.get(x)||k.texture;d.bindTextureAndWrap(L,0,A.wrapS,A.wrapT),d.bindTextureAndWrap(M,1,T.wrapS,T.wrapT),d.bindTextureAndWrap(C,2,E.wrapS,E.wrapT),d.bindTextureAndWrap(R,3,S.wrapS,S.wrapT),d.bindTextureAndWrap(B,4,I.wrapS,I.wrapT),d.bindTextureAndWrap(U,5,k.wrapS,k.wrapT),r.bindHd(p,i.skinningType,h.coordId),r.render()}}}else{const e=t.geosetColors,i=t.layerTextures,r=t.uvAnims;c.uniform4fv(w.u_vertexColor,t.vertexColor),c.uniform1i(w.u_texture,0);for(const l of this.objects){const h=o[l],f=h.geoset,b=h.layer,v=f.index,y=b.index,_=e[v],x=s[y];if(_[3]>.01&&x>.01){const e=i[y],s=a[e],o=r[y];c.uniform4fv(w.u_geosetColor,_),c.uniform1f(w.u_layerAlpha,x),c.uniform1f(w.u_unshaded,b.unshaded),c.uniform2f(w.u_uvTrans,o[0],o[1]),c.uniform2f(w.u_uvRot,o[2],o[3]),c.uniform1f(w.u_uvScale,o[4]),b.bind(p);let l=n.get(e);if(!l){const e=s.replaceableId;let i;i=1===e?m[t.teamColor]:2===e?g[t.teamColor]:s,i&&(l=i.texture)}d.bindTextureAndWrap(l,0,s.wrapS,s.wrapT),u===fh.ExtendedVertexGroups?f.bindExtended(p,b.coordId):f.bind(p,b.coordId),f.render()}}}}}class wh{constructor(t){this.objects=[],this.model=t}render(t){const e=t.scene,i=t.nodes,n=t.model.viewer,s=n.gl,r=n.webgl.extensions.ANGLE_instanced_arrays,a=n.sharedCache.get("mdx"),o=a.particlesShader,l=o.uniforms,h=o.attribs,c=a.rectBuffer;s.depthMask(!1),s.enable(s.BLEND),s.disable(s.CULL_FACE),s.enable(s.DEPTH_TEST),o.use(),s.uniformMatrix4fv(l.u_VP,!1,e.camera.viewProjectionMatrix),s.uniform1i(l.u_texture,0),r.vertexAttribDivisorANGLE(h.a_position,0),s.bindBuffer(s.ARRAY_BUFFER,c),s.vertexAttribPointer(h.a_position,1,s.UNSIGNED_BYTE,!1,0,0),r.vertexAttribDivisorANGLE(h.a_p0,1),r.vertexAttribDivisorANGLE(h.a_p1,1),r.vertexAttribDivisorANGLE(h.a_p2,1),r.vertexAttribDivisorANGLE(h.a_p3,1),r.vertexAttribDivisorANGLE(h.a_health,1),r.vertexAttribDivisorANGLE(h.a_color,1),r.vertexAttribDivisorANGLE(h.a_tail,1),r.vertexAttribDivisorANGLE(h.a_leftRightTop,1);for(const t of this.objects)ah(i[t].object,o);r.vertexAttribDivisorANGLE(h.a_leftRightTop,0),r.vertexAttribDivisorANGLE(h.a_tail,0),r.vertexAttribDivisorANGLE(h.a_color,0),r.vertexAttribDivisorANGLE(h.a_health,0),r.vertexAttribDivisorANGLE(h.a_p3,0),r.vertexAttribDivisorANGLE(h.a_p2,0),r.vertexAttribDivisorANGLE(h.a_p1,0),r.vertexAttribDivisorANGLE(h.a_p0,0)}}function bh(t){return t instanceof mh||t instanceof hh?t.layer.priorityPlane:t instanceof lh?t.priorityPlane:0}function vh(t,e){return t instanceof ph?e instanceof mh&&e.skinningType===t.skinningType&&e.isHd===t.isHd:e instanceof Xl}function yh(t,e){return e instanceof mh?new ph(t,e.skinningType,e.isHd):new wh(t)}const _h=Za(),xh=po(),Ah=Za();const Th=po(),Eh=Za(),Sh=Za(),Ih=po();class kh{constructor(t,e,i,n,s,r,a,o,l,h,c,d){this.dontInheritTranslation=!1,this.dontInheritRotation=!1,this.dontInheritScaling=!1,this.billboarded=!1,this.billboardedX=!1,this.billboardedY=!1,this.billboardedZ=!1,this.dirty=!0,this.wasDirty=!1,this.parent=null,this.children=[],this.object=null,this.pivot=t,this.localLocation=e,this.localRotation=i,this.localScale=n,this.worldLocation=s,this.worldRotation=r,this.worldScale=a,this.inverseWorldLocation=o,this.inverseWorldRotation=l,this.inverseWorldScale=h,this.localMatrix=c,this.worldMatrix=d,this.localRotation[3]=1,this.localScale.fill(1),this.localMatrix[0]=1,this.localMatrix[5]=1,this.localMatrix[10]=1,this.localMatrix[15]=1}recalculateTransformation(t){const e=this.localMatrix,i=this.localRotation,n=this.localScale,s=this.worldMatrix,r=this.worldLocation,a=this.worldRotation,o=this.worldScale,l=this.pivot,h=this.inverseWorldLocation,c=this.inverseWorldRotation,d=this.inverseWorldScale,u=this.parent;let f,m;if(this.dontInheritScaling){m=Eh;const t=u.inverseWorldScale;m[0]=t[0]*n[0],m[1]=t[1]*n[1],m[2]=t[2]*n[2],o[0]=n[0],o[1]=n[1],o[2]=n[2]}else{m=n;const t=u.worldScale;o[0]=t[0]*n[0],o[1]=t[1]*n[1],o[2]=t[2]*n[2]}if(this.billboarded)f=Th,Ro(f,u.inverseWorldRotation),Bo(f,f,t.camera.inverseRotation),this.convertBasis(f),Bo(f,f,i);else{const{billboardedX:e,billboardedY:s,billboardedZ:r}=this;e||s||r?(e&&(m===n&&(m=Eh,to(m,n)),m[2]*=-1),Ih[0]=-i[0],Ih[1]=-i[1],Ih[2]=-i[2],Bo(Ih,Ih,u.inverseWorldRotation),lo(Sh,t.camera.billboardedVectors[6],Ih),e?bo(Ih,Vo,Math.atan2(Sh[2],Sh[1])):s?bo(Ih,Go,Math.atan2(-Sh[2],Sh[0])):bo(Ih,jo,Math.atan2(Sh[1],Sh[0])),f=Th,Bo(f,i,Ih)):f=i}!function(t,e,i,n,s){var r=e[0],a=e[1],o=e[2],l=e[3],h=r+r,c=a+a,d=o+o,u=r*h,f=r*c,m=r*d,g=a*c,p=a*d,w=o*d,b=l*h,v=l*c,y=l*d,_=n[0],x=n[1],A=n[2],T=s[0],E=s[1],S=s[2],I=(1-(g+w))*_,k=(f+y)*_,L=(m-v)*_,M=(f-y)*x,C=(1-(u+w))*x,R=(p+b)*x,B=(m+v)*A,U=(p-b)*A,P=(1-(u+g))*A;t[0]=I,t[1]=k,t[2]=L,t[3]=0,t[4]=M,t[5]=C,t[6]=R,t[7]=0,t[8]=B,t[9]=U,t[10]=P,t[11]=0,t[12]=i[0]+T-(I*T+M*E+B*S),t[13]=i[1]+E-(k*T+C*E+U*S),t[14]=i[2]+S-(L*T+R*E+P*S),t[15]=1}(e,f,this.localLocation,m,l),Oo(s,u.worldMatrix,e),Bo(a,u.worldRotation,f),c[0]=-a[0],c[1]=-a[1],c[2]=-a[2],c[3]=a[3],d[0]=1/o[0],d[1]=1/o[1],d[2]=1/o[2];const g=l[0],p=l[1],w=l[2];r[0]=s[0]*g+s[4]*p+s[8]*w+s[12],r[1]=s[1]*g+s[5]*p+s[9]*w+s[13],r[2]=s[2]*g+s[6]*p+s[10]*w+s[14],h[0]=-r[0],h[1]=-r[1],h[2]=-r[2]}convertBasis(t){}}class Lh extends kh{convertBasis(t){yo(t,t,-Math.PI/2),vo(t,t,-Math.PI/2)}}const Mh=new Float32Array(1);class Ch{constructor(t,e){const i=e.internalModel.addInstance();i.setSequenceLoopMode(2),i.dontInheritScaling=!1,i.hide(),i.setParent(t.nodes[e.objectId]),this.instance=t,this.attachment=e,this.internalInstance=i}update(){const t=this.instance,e=this.internalInstance;t.scene&&-1!==t.sequence&&(this.attachment.getVisibility(Mh,t.sequence,t.frame,t.counter),Mh[0]>.1?(t.scene.addInstance(e),e.hidden()&&(e.show(),e.setSequence(0))):e.hide())}}class Rh extends class{constructor(t){this.objects=[],this.alive=0,this.currentEmission=0,this.instance=t}update(t){this.updateEmission(t);const e=this.currentEmission;if(e>=1)for(let t=0;t<e;t+=1)this.emit()}clear(){const t=this.objects;for(let e=0,i=this.alive;e<i;e++){t[e].health=0}this.currentEmission=0}emitObject(t){const e=this.objects;this.alive===e.length&&e.push(this.createObject());const i=e[this.alive];i.index=this.alive,i.bind(t),this.alive+=1,this.currentEmission-=1;return this.instance.scene.emittedObjectUpdater.add(i),i}kill(t){const e=this.objects;this.alive-=1;const i=e[this.alive];e[t.index]=i,e[this.alive]=t,i.index=t.index,t.index=-1}}{constructor(t,e){super(t),this.emitterObject=e}update(t){this.emitterObject.ok&&super.update(t)}}class Bh{constructor(t){this.index=-1,this.health=0,this.emitter=t}}const Uh=po(),Ph=Za(),Fh=new Float32Array(1),Nh=new Float32Array(1),Dh=new Float32Array(1),Oh=new Float32Array(1);class Vh extends Bh{constructor(t){super(t),this.velocity=Za(),this.gravity=0;const e=t.emitterObject.internalModel;this.internalInstance=e.addInstance()}bind(){const t=this.emitter,e=t.instance,i=e.sequence,n=e.frame,s=e.counter,r=e.scene,a=t.emitterObject,o=e.nodes[a.index],l=this.internalInstance,h=o.worldScale,c=this.velocity;a.getLatitude(Fh,i,n,s),a.getLifeSpan(Nh,i,n,s),a.getGravity(Dh,i,n,s),a.getSpeed(Oh,i,n,s),this.health=Nh[0],this.gravity=Dh[0]*h[2],wo(Uh),_o(Uh,Uh,N(-Math.PI,Math.PI)),yo(Uh,Uh,N(-Fh[0],Fh[0])),lo(c,jo,Uh),lo(c,c,o.worldRotation),no(c,c,Oh[0]),uo(c,c,h),l.setScene(r),l.setSequence(0),l.setTransformation(o.worldLocation,bo(Uh,jo,N(0,2*Math.PI)),o.worldScale),l.show()}update(t){const e=this.internalInstance;if(this.health-=t,this.health>0){const i=this.velocity;i[2]-=this.gravity*t,e.move(no(Ph,i,t))}else e.hide()}}const Gh=new Float32Array(1);class jh extends Rh{updateEmission(t){const e=this.instance;if(e.allowParticleSpawn){this.emitterObject.getEmissionRate(Gh,e.sequence,e.frame,e.counter),this.currentEmission+=Gh[0]*t}}emit(){this.emitObject()}createObject(){return new Vh(this)}}const Kh=po(),$h=new Float32Array(1),zh=new Float32Array(1),qh=new Float32Array(1),Hh=new Float32Array(1),Xh=new Float32Array(1),Wh=new Float32Array(1);class Yh extends Bh{constructor(){super(...arguments),this.tail=0,this.gravity=0,this.location=Za(),this.velocity=Za(),this.scale=Za(),this.facing=0}bind(t){const e=this.emitter,i=e.instance,n=i.sequence,s=i.frame,r=i.counter,a=e.emitterObject;a.getWidth($h,n,s,r),a.getLength(zh,n,s,r),a.getLatitude(qh,n,s,r),a.getVariation(Hh,n,s,r),a.getSpeed(Xh,n,s,r),a.getGravity(Wh,n,s,r);const o=e.node,l=o.pivot,h=o.worldScale,c=.5*$h[0],d=.5*zh[0],u=qh[0]*(Math.PI/180);const f=Hh[0],m=Xh[0],g=this.location,p=this.velocity;this.health=a.lifeSpan,this.tail=t,this.gravity=Wh[0]*h[2],to(this.scale,h),g[0]=l[0]+N(-c,c),g[1]=l[1]+N(-d,d),g[2]=l[2],a.modelSpace||oo(g,g,o.worldMatrix),wo(Kh),_o(Kh,Kh,Math.PI/2),yo(Kh,Kh,N(-u,u)),a.lineEmitter||vo(Kh,Kh,N(-u,u)),a.modelSpace||Bo(Kh,o.worldRotation,Kh),lo(p,jo,Kh),no(p,p,m*(1+N(-f,f))),a.modelSpace||uo(p,p,h),a.xYQuad&&(this.facing=Math.atan2(p[1],p[0])-Math.PI+Math.PI/8)}update(t){if(this.health-=t,this.health>0){const e=this.location,i=this.velocity;i[2]-=this.gravity*t,e[0]+=i[0]*t,e[1]+=i[1]*t,e[2]+=i[2]*t}}}const Zh=new Float32Array(1);class Qh extends Rh{constructor(t,e){super(t,e),this.lastEmissionKey=-1,this.node=t.nodes[e.index]}updateEmission(t){const e=this.instance;if(e.allowParticleSpawn){const i=this.emitterObject,n=i.getEmissionRate(Zh,e.sequence,e.frame,e.counter);i.squirt?(n!==this.lastEmissionKey&&(this.currentEmission+=Zh[0]),this.lastEmissionKey=n):this.currentEmission+=Zh[0]*t}}emit(){const t=this.emitterObject;t.head&&this.emitObject(0),t.tail&&this.emitObject(1)}createObject(){return new Yh(this)}}const Jh=Za(),tc=Za(),ec=new Float32Array(3),ic=new Float32Array(1),nc=new Uint32Array(1);class sc extends Bh{constructor(){super(...arguments),this.vertices=new Float32Array(6),this.color=new Uint8Array(4),this.slot=0,this.prev=null,this.next=null}bind(){const t=this.emitter,e=t.instance,i=e.sequence,n=e.frame,s=e.counter,r=t.emitterObject,a=e.nodes[r.index],[o,l,h]=a.pivot,c=a.worldMatrix,d=this.vertices;this.health=t.emitterObject.lifeSpan,r.getHeightBelow(Jh,i,n,s),r.getHeightAbove(tc,i,n,s),Jh[1]=l-Jh[0],Jh[0]=o,Jh[2]=h,tc[1]=l+tc[0],tc[0]=o,tc[2]=h,oo(Jh,Jh,c),oo(tc,tc,c),d[0]=tc[0],d[1]=tc[1],d[2]=tc[2],d[3]=Jh[0],d[4]=Jh[1],d[5]=Jh[2]}update(t){if(this.health-=t,this.health>0){const e=this.emitter,i=e.instance,n=i.sequence,s=i.frame,r=i.counter,a=e.emitterObject,o=this.color,l=this.vertices,h=a.gravity*t*t;a.getColor(ec,n,s,r),a.getAlpha(ic,n,s,r),a.getTextureSlot(nc,n,s,r),l[1]-=h,l[4]-=h,o[0]=255*ec[0],o[1]=255*ec[1],o[2]=255*ec[2],o[3]=255*ic[0],this.slot=nc[0]}}}class rc extends Rh{constructor(){super(...arguments),this.first=null,this.last=null}updateEmission(t){if(this.instance.allowParticleSpawn){const e=this.emitterObject;this.currentEmission+=e.emissionRate*t}}emit(){const t=this.emitObject(),e=this.last;e?(e.next=t,t.prev=e):this.first=t,this.last=t}kill(t){super.kill(t);const e=t.prev,i=t.next;t===this.first&&(this.first=i),t===this.last&&(this.first=null,this.last=null),e&&(e.next=i),i&&(i.prev=e),t.prev=null,t.next=null}createObject(){return new sc(this)}}const ac=new Uint32Array(1);class oc extends Rh{constructor(){super(...arguments),this.lastValue=0}updateEmission(t){const e=this.instance;if(e.allowParticleSpawn){this.emitterObject.getValue(ac,e);const t=ac[0];1===t&&t!==this.lastValue&&(this.currentEmission+=1),this.lastValue=t}}emit(){this.emitObject()}}class lc extends Bh{constructor(t){super(t);const e=t.emitterObject.internalModel;this.internalInstance=e.addInstance()}bind(){const t=this.emitter,e=t.instance,i=e.scene,n=e.nodes[t.emitterObject.index],s=this.internalInstance;s.setScene(i),s.setSequence(0),s.setTransformation(n.worldLocation,n.worldRotation,n.worldScale),s.show(),this.health=1}update(t){const e=this.internalInstance,i=e.model;e.frame>=i.sequences[0].interval[1]&&(this.health=0,e.hide())}}class hc extends oc{createObject(){return new lc(this)}}const cc=Za();class dc extends Bh{constructor(){super(...arguments),this.vertices=new Float32Array(12)}bind(){const t=this.emitter,e=t.instance,i=t.emitterObject,n=this.vertices,s=i.scale,{worldLocation:r,worldRotation:a}=e.nodes[i.index];this.health=i.lifeSpan,eo(cc,s,s,0),lo(cc,cc,a),io(n.subarray(0,2),cc,r),eo(cc,-s,s,0),lo(cc,cc,a),io(n.subarray(3,5),cc,r),eo(cc,-s,-s,0),lo(cc,cc,a),io(n.subarray(6,8),cc,r),eo(cc,s,-s,0),lo(cc,cc,a),io(n.subarray(9,11),cc,r)}update(t){this.health-=t}}class uc extends oc{createObject(){return new dc(this)}}class fc extends oc{createObject(){return new dc(this)}}class mc extends Bh{bind(){const t=this.emitter,e=t.instance,i=e.model.viewer,n=e.scene;if(i.audioEnabled&&n.audioEnabled){const i=t.emitterObject,s=e.nodes[i.index],r=n.audioContext,a=i.decodedBuffers,o=r.createPanner(),l=r.createBufferSource(),h=s.worldLocation;o.positionX.value=h[0],o.positionY.value=h[1],o.positionZ.value=h[2],o.maxDistance=i.distanceCutoff,o.refDistance=i.minDistance,o.connect(r.destination),l.buffer=a[Math.random()*a.length|0],l.connect(o),l.start(0)}}update(t){}}class gc extends oc{createObject(){return new mc(this)}}const pc=new Float32Array(1),wc=Za(),bc=po(),vc=Za(),yc=new Float32Array(3),_c=new Float32Array(1),xc=new Uint32Array(1);class Ac extends class extends class{constructor(){this.pivot=Za(),this.localLocation=Za(),this.localRotation=po(),this.localScale=Ja(1,1,1),this.worldLocation=Za(),this.worldRotation=po(),this.worldScale=Ja(1,1,1),this.inverseWorldLocation=Za(),this.inverseWorldRotation=po(),this.inverseWorldScale=Ja(1,1,1),this.localMatrix=Fo(),this.worldMatrix=Fo(),this.dontInheritTranslation=!1,this.dontInheritRotation=!1,this.dontInheritScaling=!0,this.parent=null,this.children=[]}setPivot(t){return to(this.pivot,t),this.recalculateTransformation(),this}setLocation(t){return to(this.localLocation,t),this.recalculateTransformation(),this}setRotation(t){return Ro(this.localRotation,t),this.recalculateTransformation(),this}setScale(t){return to(this.localScale,t),this.recalculateTransformation(),this}setUniformScale(t){return eo(this.localScale,t,t,t),this.recalculateTransformation(),this}setTransformation(t,e,i){const n=this.localLocation,s=this.localRotation,r=this.localScale;return n[0]=t[0],n[1]=t[1],n[2]=t[2],s[0]=e[0],s[1]=e[1],s[2]=e[2],s[3]=e[3],r[0]=i[0],r[1]=i[1],r[2]=i[2],this.recalculateTransformation(),this}resetTransformation(){return to(this.pivot,Ko),to(this.localLocation,Ko),Ro(this.localRotation,zo),to(this.localScale,$o),this.recalculateTransformation(),this}movePivot(t){return io(this.pivot,this.pivot,t),this.recalculateTransformation(),this}move(t){return io(this.localLocation,this.localLocation,t),this.recalculateTransformation(),this}rotate(t){return Bo(this.localRotation,this.localRotation,t),this.recalculateTransformation(),this}rotateLocal(t){return Bo(this.localRotation,t,this.localRotation),this.recalculateTransformation(),this}scale(t){return uo(this.localScale,this.localScale,t),this.recalculateTransformation(),this}uniformScale(t){return no(this.localScale,this.localScale,t),this.recalculateTransformation(),this}face(t,e){return Ao(this.localRotation,tl(this.localRotation,this.localLocation,t,e)),this.recalculateTransformation(),this}setParent(t){if(this.parent){const t=this.parent.children,e=t.indexOf(this);-1!==e&&t.splice(e,1)}return this.parent=t||null,t&&t.children.push(this),this.recalculateTransformation(),this}recalculateTransformation(){const t=this.parent,e=this.localMatrix,i=this.localLocation,n=this.localRotation,s=this.localScale,r=this.worldMatrix,a=this.worldLocation,o=this.worldRotation,l=this.worldScale,h=this.inverseWorldLocation,c=this.inverseWorldRotation,d=this.inverseWorldScale;if(t){const a=_h,h=t.pivot;let c,d;if(a[0]=i[0]+h[0],a[1]=i[1]+h[1],a[2]=i[2]+h[2],this.dontInheritRotation?(c=xh,Bo(c,n,t.inverseWorldRotation)):c=n,this.dontInheritScaling){d=Ah;const e=t.inverseWorldScale;d[0]=e[0]*s[0],d[1]=e[1]*s[1],d[2]=e[2]*s[2],l[0]=s[0],l[1]=s[1],l[2]=s[2]}else{d=s;const e=t.worldScale;l[0]=e[0]*s[0],l[1]=e[1]*s[1],l[2]=e[2]*s[2]}Do(e,c,a,d),Oo(r,t.worldMatrix,e),Bo(o,t.worldRotation,c)}else Do(e,n,i,s),r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=e[3],r[4]=e[4],r[5]=e[5],r[6]=e[6],r[7]=e[7],r[8]=e[8],r[9]=e[9],r[10]=e[10],r[11]=e[11],r[12]=e[12],r[13]=e[13],r[14]=e[14],r[15]=e[15],o[0]=n[0],o[1]=n[1],o[2]=n[2],o[3]=n[3],l[0]=s[0],l[1]=s[1],l[2]=s[2];c[0]=-o[0],c[1]=-o[1],c[2]=-o[2],c[3]=o[3],d[0]=1/l[0],d[1]=1/l[1],d[2]=1/l[2],a[0]=r[12],a[1]=r[13],a[2]=r[14],h[0]=-a[0],h[1]=-a[1],h[2]=-a[2];for(const t of this.children)t.recalculateTransformation()}update(t){for(const e of this.children)e.update(t)}}{constructor(t){super(),this.scene=null,this.left=-1,this.right=-1,this.bottom=-1,this.top=-1,this.plane=-1,this.depth=0,this.updateFrame=0,this.timeScale=1,this.rendered=!0,this.textureOverrides=new Map,this.model=t}show(){this.rendered=!0}hide(){this.rendered=!1}shown(){return this.rendered}hidden(){return!this.rendered}detach(){return!!this.scene&&this.scene.removeInstance(this)}overrideTexture(t,e){e?this.textureOverrides.set(t,e):this.textureOverrides.delete(t)}getBounds(){return this.model.bounds}clearEmittedObjects(){}setScene(t){return t.addInstance(this)}recalculateTransformation(){super.recalculateTransformation(),this.scene&&this.scene.grid.moved(this)}update(t){const e=this.scene;e&&this.rendered&&this.isVisible(e.camera)&&(e.renderInstance(this),this.updateAnimations(t*this.timeScale),super.update(t))}updateAnimations(t){}renderOpaque(){}renderTranslucent(){}isVisible(t){const[e,i,n]=this.worldLocation,[s,r,a]=this.worldScale,o=this.getBounds(),l=t.planes;let h=s;return r>h&&(h=r),a>h&&(h=a),this.plane=function(t,e,i,n,s,r){-1===r&&(r=0);for(let a=0;a<6;a++){const o=(r+a)%6;if(Wo(t[o],e,i,n)<=-s)return o}return-1}(l,e+o.x,i+o.y,n+o.z,o.r*h,this.plane),-1===this.plane&&(this.depth=Wo(l[4],e,i,n),!0)}}{constructor(t){super(t),this.attachments=[],this.particleEmitters=[],this.particleEmitters2=[],this.ribbonEmitters=[],this.eventObjectEmitters=[],this.nodes=[],this.sortedNodes=[],this.frame=0,this.counter=0,this.sequence=-1,this.sequenceLoopMode=0,this.sequenceEnded=!1,this.teamColor=0,this.vertexColor=new Float32Array([1,1,1,1]),this.allowParticleSpawn=!1,this.forced=!0,this.geosetColors=[],this.layerAlphas=[],this.layerTextures=[],this.uvAnims=[],this.worldMatrices=null,this.boneTexture=null;for(let e=0,i=t.geosets.length;e<i;e++)this.geosetColors[e]=new Float32Array(4);for(let e=0,i=t.layers.length;e<i;e++)this.layerAlphas[e]=0,this.layerTextures[e]=0,this.uvAnims[e]=new Float32Array(5);const e=function(t,e=kh){const i=new Float32Array(65*t),n=[];let s=0;const r=3*t,a=4*t,o=16*t,l=i.subarray(s,s+r);s+=r;const h=i.subarray(s,s+r);s+=r;const c=i.subarray(s,s+a);s+=a;const d=i.subarray(s,s+r);s+=r;const u=i.subarray(s,s+r);s+=r;const f=i.subarray(s,s+a);s+=a;const m=i.subarray(s,s+r);s+=r;const g=i.subarray(s,s+r);s+=r;const p=i.subarray(s,s+a);s+=a;const w=i.subarray(s,s+r);s+=r;const b=i.subarray(s,s+o);s+=o;const v=i.subarray(s,s+o);for(let i=0;i<t;i++){const t=3*i,s=t+3,r=4*i,a=r+4,o=16*i,y=o+16;n[i]=new e(l.subarray(t,s),h.subarray(t,s),c.subarray(r,a),d.subarray(t,s),u.subarray(t,s),f.subarray(r,a),m.subarray(t,s),g.subarray(t,s),p.subarray(r,a),w.subarray(t,s),b.subarray(o,y),v.subarray(o,y))}return{data:i,nodes:n,pivots:l,localLocations:h,localRotations:c,localScales:d,worldLocations:u,worldRotations:f,worldScales:m,inverseWorldLocations:g,invereseWorldRotations:p,inverseWorldScales:w,localMatrices:b,worldMatrices:v}}(t.genericObjects.length,Lh),i=e.nodes;let n=0;this.nodes.push(...i),this.worldMatrices=e.worldMatrices;for(const e of t.bones)this.initNode(i,i[n++],e);for(const e of t.lights)this.initNode(i,i[n++],e);for(const e of t.helpers)this.initNode(i,i[n++],e);for(const e of t.attachments){let t;e.internalModel&&(t=new Ch(this,e),this.attachments.push(t)),this.initNode(i,i[n++],e,t)}for(const e of t.particleEmitters){const t=new jh(this,e);this.particleEmitters.push(t),this.initNode(i,i[n++],e,t)}for(const e of t.particleEmitters2){const t=new Qh(this,e);this.particleEmitters2.push(t),this.initNode(i,i[n++],e,t)}for(const e of t.ribbonEmitters){const t=new rc(this,e);this.ribbonEmitters.push(t),this.initNode(i,i[n++],e,t)}for(const e of t.eventObjects){const t=e.type;let s;s="SPN"===t?new hc(this,e):"SPL"===t?new uc(this,e):"UBR"===t?new fc(this,e):new gc(this,e),this.eventObjectEmitters.push(s),this.initNode(i,i[n++],e,s)}for(const e of t.collisionShapes)this.initNode(i,i[n++],e);const s=t.hierarchy;for(let t=0,e=i.length;t<e;t++)this.sortedNodes[t]=i[s[t]];t.bones.length&&(this.boneTexture=new qa(t.viewer.gl,4,4*t.bones.length,1))}setTexture(t,e){this.overrideTexture(t,e)}setParticle2Texture(t,e){this.overrideTexture(1e3+t,e)}setEventTexture(t,e){this.overrideTexture(sh+t,e)}clearEmittedObjects(){for(const t of this.particleEmitters)t.clear();for(const t of this.particleEmitters2)t.clear();for(const t of this.ribbonEmitters)t.clear();for(const t of this.eventObjectEmitters)t.clear()}initNode(t,e,i,n){to(e.pivot,i.pivot),-1===i.parentId?e.parent=this:e.parent=t[i.parentId],i.billboarded?e.billboarded=!0:i.billboardedX?e.billboardedX=!0:i.billboardedY?e.billboardedY=!0:i.billboardedZ&&(e.billboardedZ=!0),n&&(e.object=n)}hide(){super.hide(),this.resetAttachments()}updateNodes(t,e){const i=this.sequence,n=this.frame,s=this.counter,r=this.sortedNodes,a=this.model.sortedGenericObjects,o=this.scene;for(let l=0,h=r.length;l<h;l++){const h=a[l],c=r[l],d=c.parent;let u=e||d.wasDirty||h.anyBillboarding;const f=h.variants;(e||f.generic[i])&&(u=!0,(e||f.translation[i])&&h.getTranslation(c.localLocation,i,n,s),(e||f.rotation[i])&&h.getRotation(c.localRotation,i,n,s),(e||f.scale[i])&&h.getScale(c.localScale,i,n,s)),c.wasDirty=u,u&&c.recalculateTransformation(o),c.object&&(h.getVisibility(pc,i,n,s),pc[0]>0&&c.object.update(t));for(const e of c.children)u&&e.recalculateTransformation(),e.update(t)}}recalculateTransformation(){super.recalculateTransformation(),this.forced=!0}updateBatches(t){const e=this.sequence,i=this.frame,n=this.counter,s=this.model,r=s.geosets,a=s.layers,o=this.geosetColors,l=this.layerAlphas,h=this.layerTextures,c=this.uvAnims;for(let s=0,a=r.length;s<a;s++){const a=r[s].geosetAnimation,l=o[s];a?((t||a.variants.color[e])&&(a.getColor(yc,e,i,n),l[0]=yc[0],l[1]=yc[1],l[2]=yc[2]),(t||a.variants.alpha[e])&&(a.getAlpha(_c,e,i,n),l[3]=_c[0])):t&&(l[0]=1,l[1]=1,l[2]=1,l[3]=1)}for(let s=0,r=a.length;s<r;s++){const r=a[s],o=r.textureAnimation,d=c[s];(t||r.variants.alpha[e])&&(r.getAlpha(_c,e,i,n),l[s]=_c[0]),(t||r.variants.textureId[e])&&(r.getTextureId(xc,e,i,n),h[s]=xc[0]),o?((t||o.variants.translation[e])&&(o.getTranslation(wc,e,i,n),d[0]=wc[0],d[1]=wc[1]),(t||o.variants.rotation[e])&&(o.getRotation(bc,e,i,n),d[2]=bc[2],d[3]=bc[3]),(t||o.variants.scale[e])&&(o.getScale(vc,e,i,n),d[4]=vc[0])):t&&(d[0]=0,d[1]=0,d[2]=0,d[3]=1,d[4]=1)}}updateBoneTexture(){this.boneTexture&&this.boneTexture.bindAndUpdate(this.worldMatrices)}renderOpaque(){const t=this.model;for(const e of t.opaqueGroups)e.render(this)}renderTranslucent(){const t=this.model;for(const e of t.translucentGroups)e.render(this)}updateAnimations(t){const e=this.model,i=this.sequence;if(-1!==i){const n=e.sequences[i],s=n.interval,r=1e3*t;this.frame+=r,this.counter+=r,this.allowParticleSpawn=!0,this.frame>=s[1]?(2===this.sequenceLoopMode||0===this.sequenceLoopMode&&0===n.nonLooping?(this.frame=s[0],this.resetEventEmitters()):(this.frame=s[1],this.counter-=r,this.allowParticleSpawn=!1),this.sequenceEnded=!0):this.sequenceEnded=!1}const n=this.forced;(-1!==i||n)&&(this.updateNodes(t,n),this.updateBoneTexture(),this.updateBatches(n)),this.forced=!1}setTeamColor(t){return this.teamColor=t,this}setVertexColor(t){return this.vertexColor.set(t),this}setSequence(t){const e=this.model.sequences;return this.sequence=t,t<0||t>e.length-1?(this.sequence=-1,this.frame=0,this.allowParticleSpawn=!1):this.frame=e[t].interval[0],this.resetEventEmitters(),this.resetAttachments(),this.forced=!0,this}getBounds(){const t=this.model;if(-1===this.sequence)return t.bounds;const e=t.sequences[this.sequence].bounds;return 0===e.r?t.bounds:e}setSequenceLoopMode(t){return this.sequenceLoopMode=t,this}getAttachment(t){const e=this.model.attachments[t];if(e)return this.nodes[e.index]}resetEventEmitters(){for(const t of this.eventObjectEmitters)t.lastValue=0}resetAttachments(){for(const t of this.attachments)t.internalInstance.hide()}}const Tc="\nuniform sampler2D u_boneMap;\nuniform float u_vectorSize;\nuniform float u_rowSize;\n\nmat4 fetchMatrix(float column, float row) {\n  column *= u_vectorSize * 4.0;\n  row *= u_rowSize;\n  // Add in half a texel, to sample in the middle of the texel.\n  // Otherwise, since the sample is directly on the boundary, floating point errors can cause the sample to get the wrong pixel.\n  // This is most noticeable with NPOT textures, which the bone maps are.\n  column += 0.5 * u_vectorSize;\n  row += 0.5 * u_rowSize;\n\n  return mat4(texture2D(u_boneMap, vec2(column, row)),\n              texture2D(u_boneMap, vec2(column + u_vectorSize, row)),\n              texture2D(u_boneMap, vec2(column + u_vectorSize * 2.0, row)),\n              texture2D(u_boneMap, vec2(column + u_vectorSize * 3.0, row)));\n}\n",Ec="\n#ifdef SKIN\nattribute vec4 a_bones;\nattribute vec4 a_weights;\n\nvoid transformSkin(inout vec3 position, inout vec3 normal, inout vec3 tangent, inout vec3 binormal) {\n  mat4 bone;\n\n  bone += fetchMatrix(a_bones[0], 0.0) * a_weights[0];\n  bone += fetchMatrix(a_bones[1], 0.0) * a_weights[1];\n  bone += fetchMatrix(a_bones[2], 0.0) * a_weights[2];\n  bone += fetchMatrix(a_bones[3], 0.0) * a_weights[3];\n\n  mat3 rotation = mat3(bone);\n\n  position = vec3(bone * vec4(position, 1.0));\n  normal = rotation * normal;\n  tangent = rotation * tangent;\n  binormal = rotation * binormal;\n}\n#else\nattribute vec4 a_bones;\n#ifdef EXTENDED_BONES\nattribute vec4 a_extendedBones;\n#endif\nattribute float a_boneNumber;\n\nmat4 getVertexGroupMatrix() {\n  mat4 bone;\n\n  // For the broken models out there, since the game supports this.\n  if (a_boneNumber > 0.0) {\n    for (int i = 0; i < 4; i++) {\n      if (a_bones[i] > 0.0) {\n        bone += fetchMatrix(a_bones[i] - 1.0, 0.0);\n      }\n    }\n\n    #ifdef EXTENDED_BONES\n      for (int i = 0; i < 4; i++) {\n        if (a_extendedBones[i] > 0.0) {\n          bone += fetchMatrix(a_extendedBones[i] - 1.0, 0.0);\n        }\n      }\n    #endif\n  }\n\n  return bone / a_boneNumber;\n}\n\nvoid transformVertexGroups(inout vec3 position, inout vec3 normal) {\n  mat4 bone = getVertexGroupMatrix();\n  mat3 rotation = mat3(bone);\n\n  position = vec3(bone * vec4(position, 1.0));\n  normal = normalize(rotation * normal);\n}\n\nvoid transformVertexGroupsHD(inout vec3 position, inout vec3 normal, inout vec3 tangent, inout vec3 binormal) {\n  mat4 bone = getVertexGroupMatrix();\n  mat3 rotation = mat3(bone);\n\n  position = vec3(bone * vec4(position, 1.0));\n  normal = normalize(rotation * normal);\n  tangent = normalize(rotation * tangent);\n  binormal = normalize(rotation * binormal);\n}\n#endif\n",Sc=`\nuniform mat4 u_VP;\nuniform vec3 u_lightPos;\nuniform vec4 u_vertexColor;\nuniform vec4 u_geosetColor;\nuniform float u_layerAlpha;\nuniform vec2 u_uvTrans;\nuniform vec2 u_uvRot;\nuniform float u_uvScale;\nuniform bool u_hasBones;\n\nattribute vec3 a_position;\nattribute vec3 a_normal;\nattribute vec2 a_uv;\n\nvarying vec2 v_uv;\nvarying vec3 v_normal;\nvarying vec4 v_color;\nvarying vec4 v_uvTransRot;\nvarying float v_uvScale;\nvarying vec3 v_lightDir;\n\n${Tc}\n${Ec}\n\nvoid main() {\n  vec3 position = a_position;\n  vec3 normal = a_normal;\n\n  if (u_hasBones) {\n    transformVertexGroups(position, normal);\n  }\n\n  v_uv = a_uv;\n  v_normal = normal;\n  v_color = u_vertexColor * u_geosetColor.bgra * vec4(1.0, 1.0, 1.0, u_layerAlpha);\n  v_uvTransRot = vec4(u_uvTrans, u_uvRot);\n  v_uvScale = u_uvScale;\n  v_lightDir = normalize(u_lightPos - position);\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n`,Ic="\n#ifdef GL_FRAGMENT_PRECISION_HIGH\nprecision highp float;\n#else\nprecision mediump float;\n#endif\n",kc=`\n${Ic}\n\n\n// A 2D quaternion*vector.\n// q is the zw components of the original quaternion.\nvec2 quat_transform(vec2 q, vec2 v) {\n  vec2 uv = vec2(-q.x * v.y, q.x * v.x);\n  vec2 uuv = vec2(-q.x * uv.y, q.x * uv.x);\n\n  return v + 2.0 * (uv * q.y + uuv);\n}\n\n\nuniform sampler2D u_texture;\nuniform float u_filterMode;\nuniform bool u_unshaded;\n\nvarying vec2 v_uv;\nvarying vec3 v_normal;\nvarying vec4 v_color;\nvarying vec4 v_uvTransRot;\nvarying float v_uvScale;\nvarying vec3 v_lightDir;\n\nvec4 getDiffuseColor() {\n  vec2 uv = v_uv;\n\n  // Translation animation\n  uv += v_uvTransRot.xy;\n\n  // Rotation animation\n  uv = quat_transform(v_uvTransRot.zw, uv - 0.5) + 0.5;\n\n  // Scale animation\n  uv = v_uvScale * (uv - 0.5) + 0.5;\n\n  vec4 texel = texture2D(u_texture, uv);\n  vec4 color = texel * v_color;\n\n  // 1bit Alpha\n  if (u_filterMode == 1.0 && color.a < 0.75) {\n    discard;\n  }\n\n  // "Close to 0 alpha"\n  if (u_filterMode >= 5.0 && color.a < 0.02) {\n    discard;\n  }\n\n  return color;\n}\n\nvoid onlyTexCoords() {\n  gl_FragColor = vec4(v_uv, 0.0, 1.0);\n}\n\nvoid onlyNormals() {\n  gl_FragColor = vec4(v_normal, 1.0);\n}\n\nvoid onlyDiffuse() {\n  gl_FragColor = getDiffuseColor();\n}\n\nvoid lambert() {\n  vec4 color = getDiffuseColor();\n\n  if (!u_unshaded) {\n    float lambertFactor = clamp(dot(v_normal, v_lightDir), 0.0, 1.0);\n    lambertFactor = clamp(lambertFactor + 0.7, 0.0, 1.0);\n\n    color.rgb *= lambertFactor;\n  }\n\n  gl_FragColor = color;\n}\n\nvoid main() {\n  #if defined(ONLY_DIFFUSE)\n  onlyDiffuse();\n  #elif defined(ONLY_TEXCOORDS)\n  onlyTexCoords();\n  #elif defined(ONLY_NORMALS)\n  onlyNormals();\n  #else\n  lambert();\n  #endif\n}\n`,Lc=`\nuniform mat4 u_VP;\nuniform mat4 u_MV;\nuniform vec3 u_eyePos;\nuniform vec3 u_lightPos;\nuniform float u_layerAlpha;\nuniform bool u_hasBones;\n\nattribute vec3 a_position;\nattribute vec3 a_normal;\nattribute vec2 a_uv;\nattribute vec4 a_tangent;\n\nvarying vec2 v_uv;\nvarying float v_layerAlpha;\nvarying vec3 v_lightDir;\nvarying vec3 v_eyeVec;\nvarying vec3 v_normal;\n// varying vec3 v_lightDirWorld;\n\n#if defined(ONLY_TANGENTS)\nvarying vec3 v_tangent;\n#endif\n\n${Tc}\n${Ec}\n\nvec3 TBN(vec3 vector, vec3 tangent, vec3 binormal, vec3 normal) {\n  return vec3(dot(vector, tangent), dot(vector, binormal), dot(vector, normal));\n}\n\nvoid main() {\n  vec3 position = a_position;\n  vec3 normal = a_normal;\n  vec3 tangent = a_tangent.xyz;\n\n  // Re-orthogonalize the tangent in case it wasnt normalized.\n  // See "One last thing" at https://learnopengl.com/Advanced-Lighting/Normal-Mapping\n  tangent = normalize(tangent - dot(tangent, normal) * normal);\n\n  vec3 binormal = cross(normal, tangent) * a_tangent.w;\n\n  if (u_hasBones) {\n    #ifdef SKIN\n      transformSkin(position, normal, tangent, binormal);\n    #else\n      transformVertexGroupsHD(position, normal, tangent, binormal);\n    #endif\n  }\n\n  vec3 position_mv = vec3(u_MV * vec4(position, 1));\n\n  mat3 mv = mat3(u_MV);\n  vec3 t = normalize(mv * tangent);\n  vec3 b = normalize(mv * binormal);\n  vec3 n = normalize(mv * normal);\n\n  v_eyeVec = normalize(u_eyePos - position_mv);\n\n  vec3 lightDir = normalize(u_lightPos - position_mv);\n  v_lightDir = normalize(TBN(lightDir, t, b, n));\n  \n  v_uv = a_uv;\n  v_layerAlpha = u_layerAlpha;\n\n  v_normal = normal;\n  // v_lightDirWorld = normalize(lightDir);\n\n  #if defined(ONLY_TANGENTS)\n  v_tangent = tangent;\n  #endif\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n`,Mc=`\n${Ic}\n\nuniform sampler2D u_diffuseMap;\nuniform sampler2D u_normalsMap;\nuniform sampler2D u_ormMap;\nuniform sampler2D u_emissiveMap;\nuniform sampler2D u_teamColorMap;\nuniform sampler2D u_environmentMap;\nuniform float u_filterMode;\n\n// uniform sampler2D u_lutMap;\n// uniform sampler2D u_envDiffuseMap;\n// uniform sampler2D u_envSpecularMap;\n\nvarying vec2 v_uv;\nvarying float v_layerAlpha;\nvarying vec3 v_lightDir;\nvarying vec3 v_eyeVec;\nvarying vec3 v_normal;\n// varying vec3 v_lightDirWorld;\n\n#if defined(ONLY_TANGENTS)\nvarying vec3 v_tangent;\n#endif\n\nvec3 decodeNormal() {\n  vec2 xy = texture2D(u_normalsMap, v_uv).xy * 2.0 - 1.0;\n  \n  return vec3(xy, sqrt(1.0 - dot(xy, xy)));\n}\n\nconst vec2 invAtan = vec2(0.1591, 0.3183);\nvec2 sampleEnvironmentMap(vec3 normal) {\n  vec2 uv = vec2(atan(normal.x, normal.y), -asin(normal.z));\n  uv *= invAtan;\n  uv += 0.5;\n  return uv;\n}\n\nvec4 getDiffuseColor() {\n  vec4 color = texture2D(u_diffuseMap, v_uv);\n\n  // 1bit Alpha\n  if (u_filterMode == 1.0 && color.a < 0.75) {\n    discard;\n  }\n\n  return color;\n}\n\nvec4 getOrmColor() {\n  return texture2D(u_ormMap, v_uv);\n}\n\nvec3 getEmissiveColor() {\n  return texture2D(u_emissiveMap, v_uv).rgb;\n}\n\nvec3 getTeamColor() {\n  return texture2D(u_teamColorMap, v_uv).rgb;\n}\n\n// const float PI = 3.14159265359;\n// const float RECIPROCAL_PI = 0.31830988618;\n// const float RECIPROCAL_PI2 = 0.15915494;\n// const float LN2 = 0.6931472;\n// const float ENV_LODS = 6.0;\n// vec4 SRGBtoLinear(vec4 srgb) {\n//     vec3 linOut = pow(srgb.xyz, vec3(2.2));\n//     return vec4(linOut, srgb.w);;\n// }\n// vec4 RGBMToLinear(in vec4 value) {\n//     float maxRange = 6.0;\n//     return vec4(value.xyz * value.w * maxRange, 1.0);\n// }\n// vec3 linearToSRGB(vec3 color) {\n//     return pow(color, vec3(1.0 / 2.2));\n// }\n// // vec3 getNormal() {\n// //     vec3 pos_dx = dFdx(vMPos.xyz);\n// //     vec3 pos_dy = dFdy(vMPos.xyz);\n// //     vec2 tex_dx = dFdx(vUv);\n// //     vec2 tex_dy = dFdy(vUv);\n// //     vec3 t = normalize(pos_dx * tex_dy.t - pos_dy * tex_dx.t);\n// //     vec3 b = normalize(-pos_dx * tex_dy.s + pos_dy * tex_dx.s);\n// //     mat3 tbn = mat3(t, b, normalize(vNormal));\n// //     vec3 n = texture2D(tNormal, vUv * uNormalUVScale).rgb * 2.0 - 1.0;\n// //     n.xy *= uNormalScale;\n// //     vec3 normal = normalize(tbn * n);\n// //     // Get world normal from view normal (normalMatrix * normal)\n// //     return normalize((vec4(normal, 0.0) * viewMatrix).xyz);\n// // }\n// vec3 specularReflection(vec3 specularEnvR0, vec3 specularEnvR90, float VdH) {\n//     return specularEnvR0 + (specularEnvR90 - specularEnvR0) * pow(clamp(1.0 - VdH, 0.0, 1.0), 5.0);\n// }\n// float geometricOcclusion(float NdL, float NdV, float roughness) {\n//     float r = roughness;\n//     float attenuationL = 2.0 * NdL / (NdL + sqrt(r * r + (1.0 - r * r) * (NdL * NdL)));\n//     float attenuationV = 2.0 * NdV / (NdV + sqrt(r * r + (1.0 - r * r) * (NdV * NdV)));\n//     return attenuationL * attenuationV;\n// }\n// float microfacetDistribution(float roughness, float NdH) {\n//     float roughnessSq = roughness * roughness;\n//     float f = (NdH * roughnessSq - NdH) * NdH + 1.0;\n//     return roughnessSq / (PI * f * f);\n// }\n// vec2 cartesianToPolar(vec3 n) {\n//     vec2 uv;\n//     uv.x = atan(n.z, n.x) * RECIPROCAL_PI2 + 0.5;\n//     uv.y = asin(n.y) * RECIPROCAL_PI + 0.5;\n//     return uv;\n// }\n// void getIBLContribution(inout vec3 diffuse, inout vec3 specular, float NdV, float roughness, vec3 n, vec3 reflection, vec3 diffuseColor, vec3 specularColor) {\n//   vec3 brdf = SRGBtoLinear(texture2D(u_lutMap, vec2(NdV, roughness))).rgb;\n//   vec3 diffuseLight = RGBMToLinear(texture2D(u_envDiffuseMap, sampleEnvironmentMap(n))).rgb;\n//   // Sample 2 levels and mix between to get smoother degradation\n//   float blend = roughness * ENV_LODS;\n//   float level0 = floor(blend);\n//   float level1 = min(ENV_LODS, level0 + 1.0);\n//   blend -= level0;\n  \n//   // Sample the specular env map atlas depending on the roughness value\n//   vec2 uvSpec = sampleEnvironmentMap(reflection);\n//   uvSpec.y /= 2.0;\n//   vec2 uv0 = uvSpec;\n//   vec2 uv1 = uvSpec;\n//   uv0 /= pow(2.0, level0);\n//   uv0.y += 1.0 - exp(-LN2 * level0);\n//   uv1 /= pow(2.0, level1);\n//   uv1.y += 1.0 - exp(-LN2 * level1);\n//   vec3 specular0 = RGBMToLinear(texture2D(u_envSpecularMap, uv0)).rgb;\n//   vec3 specular1 = RGBMToLinear(texture2D(u_envSpecularMap, uv1)).rgb;\n//   vec3 specularLight = mix(specular0, specular1, blend);\n//   diffuse = diffuseLight * diffuseColor;\n  \n//   // Bit of extra reflection for smooth materials\n//   float reflectivity = pow((1.0 - roughness), 2.0) * 0.05;\n//   specular = specularLight * (specularColor * brdf.x + brdf.y + reflectivity);\n//   // specular *= uEnvSpecular;\n// }\n\n// void PBR() {\n//   vec4 baseDiffuseColor = getDiffuseColor();\n//   vec3 baseColor = baseDiffuseColor.rgb;\n//   vec4 orm = getOrmColor();\n//   vec3 tc = getTeamColor();\n//   float tcFactor = getOrmColor().a;\n\n//   if (tcFactor > 0.1) {\n//     baseColor *= tc * tcFactor;\n//   }\n\n//   float roughness = clamp(orm.g, 0.04, 1.0);\n//   float metallic = clamp(orm.b, 0.04, 1.0);\n\n//   vec3 f0 = vec3(0.04);\n//   vec3 diffuseColor = baseColor * (vec3(1.0) - f0) * (1.0 - metallic);\n//   vec3 specularColor = mix(f0, baseColor, metallic);\n//   vec3 specularEnvR0 = specularColor;\n//   vec3 specularEnvR90 = vec3(clamp(max(max(specularColor.r, specularColor.g), specularColor.b) * 25.0, 0.0, 1.0));\n\n//   vec3 N = v_normal;\n//   vec3 V = normalize(v_eyeVec);\n//   vec3 L = normalize(v_lightDirWorld);\n//   vec3 H = normalize(L + V);\n//   vec3 reflection = normalize(reflect(-V, N));\n\n//   float NdL = clamp(dot(N, L), 0.001, 1.0);\n//   float NdV = clamp(abs(dot(N, V)), 0.001, 1.0);\n//   float NdH = clamp(dot(N, H), 0.0, 1.0);\n//   float LdH = clamp(dot(L, H), 0.0, 1.0);\n//   float VdH = clamp(dot(V, H), 0.0, 1.0);\n\n//   vec3 F = specularReflection(specularEnvR0, specularEnvR90, VdH);\n//   float G = geometricOcclusion(NdL, NdV, roughness);\n//   float D = microfacetDistribution(roughness, NdH);\n\n//   vec3 diffuseContrib = (1.0 - F) * (diffuseColor / PI);\n//   vec3 specContrib = F * G * D / (4.0 * NdL * NdV);\n  \n//   // Shading based off lights\n//   // vec3 color = NdL * uLightColor * (diffuseContrib + specContrib);\n//   vec3 color = NdL * (diffuseContrib + specContrib);\n\n//   // Calculate IBL lighting\n//   vec3 diffuseIBL;\n//   vec3 specularIBL;\n//   getIBLContribution(diffuseIBL, specularIBL, NdV, roughness, N, reflection, diffuseColor, specularColor);\n\n//   // Add IBL on top of color\n//   color +=  specularIBL;\n\n//   color *= orm.r;\n\n//   color += getEmissiveColor();\n\n//   // Convert to sRGB to display\n//   gl_FragColor.rgb = color;\n//   gl_FragColor.a = baseDiffuseColor.a;\n// }\n\nvoid onlyDiffuse() {\n  vec4 baseColor = getDiffuseColor();\n  vec3 tc = getTeamColor();\n  float tcFactor = getOrmColor().a;\n\n  if (tcFactor > 0.1) {\n    baseColor.rgb *= tc * tcFactor;\n  }\n\n  gl_FragColor = baseColor;\n}\n\nvoid onlyNormalMap() {\n  gl_FragColor = vec4(decodeNormal(), 1.0);\n}\n\nvoid onlyOcclusion() {\n  gl_FragColor = vec4(getOrmColor().rrr, 1.0);\n}\n\nvoid onlyRoughness() {\n  gl_FragColor = vec4(getOrmColor().ggg, 1.0);\n}\n\nvoid onlyMetallic() {\n  gl_FragColor = vec4(getOrmColor().bbb, 1.0);\n}\n\nvoid onlyTeamColorFactor() {\n  gl_FragColor = vec4(getOrmColor().aaa, 1.0);\n}\n\nvoid onlyEmissiveMap() {\n  gl_FragColor = vec4(getEmissiveColor(), 1.0);\n}\n\nvoid onlyTexCoords() {\n  gl_FragColor = vec4(v_uv, 0.0, 1.0);\n}\n\nvoid onlyNormals() {\n  gl_FragColor = vec4(v_normal, 1.0);\n}\n\n#if defined(ONLY_TANGENTS)\nvoid onlyTangents() {\n  gl_FragColor = vec4(v_tangent, 1.0);\n}\n#endif\n\nvoid lambert() {\n  vec4 baseColor = getDiffuseColor();\n  vec3 normal = decodeNormal();\n  vec4 orm = getOrmColor();\n  vec3 emissive = getEmissiveColor();\n  vec3 tc = getTeamColor();\n  float aoFactor = orm.r;\n  float tcFactor = orm.a;\n  float lambertFactor = clamp(dot(normal, v_lightDir), 0.0, 1.0);\n  vec3 color = baseColor.rgb;\n\n  if (tcFactor > 0.1) {\n    color *= tc * tcFactor;\n  }\n  \n  color *= clamp(lambertFactor * aoFactor + 0.1, 0.0, 1.0);\n  color += emissive;\n\n  gl_FragColor = vec4(color, baseColor.a);\n}\n\nvoid main() {\n  #if defined(ONLY_DIFFUSE)\n  onlyDiffuse();\n  #elif defined(ONLY_NORMAL_MAP)\n  onlyNormalMap();\n  #elif defined(ONLY_OCCLUSION)\n  onlyOcclusion();\n  #elif defined(ONLY_ROUGHNESS)\n  onlyRoughness();\n  #elif defined(ONLY_METALLIC)\n  onlyMetallic();\n  #elif defined(ONLY_TC_FACTOR)\n  onlyTeamColorFactor();\n  #elif defined(ONLY_EMISSIVE)\n  onlyEmissiveMap();\n  #elif defined(ONLY_TEXCOORDS)\n  onlyTexCoords();\n  #elif defined(ONLY_NORMALS)\n  onlyNormals();\n  #elif defined(ONLY_TANGENTS)\n  onlyTangents();\n  #else\n  lambert();\n  #endif\n}\n`,Cc=`\n${Ic}\n\n#define EMITTER_PARTICLE2 0\n#define EMITTER_RIBBON 1\n\nuniform sampler2D u_texture;\nuniform highp int u_emitter;\nuniform float u_filterMode;\n\nvarying vec2 v_texcoord;\nvarying vec4 v_color;\n\nvoid main() {\n  vec4 texel = texture2D(u_texture, v_texcoord);\n  vec4 color = texel * v_color;\n\n  // 1bit Alpha, used by ribbon emitters.\n  if (u_emitter == EMITTER_RIBBON && u_filterMode == 1.0 && color.a < 0.75) {\n    discard;\n  }\n\n  // "Close to 0 alpha"\n  if (u_emitter == EMITTER_PARTICLE2 && (u_filterMode == 2.0 || u_filterMode == 3.0) && color.a < 0.02) {\n    discard;\n  }\n\n  // Alpha key.\n  if (u_emitter == EMITTER_PARTICLE2 && (u_filterMode == 4.0) && color.a < 0.75) {\n    discard;\n  }\n\n  gl_FragColor = color;\n}\n`,Rc=t=>new xl(t),Bc=t=>function(t){if(vl)return vl.decodeAudioData(t)}(t),Uc={load(t,e,i=!1){const n=t.gl,s=t.webgl;if(!s.ensureExtension("OES_texture_float"))throw new Error("MDX: No float texture support!");if(!s.ensureExtension("ANGLE_instanced_arrays"))throw new Error("MDX: No instanced rendering support!");const r="#define EXTENDED_BONES\n"+Sc,a="#define ONLY_DIFFUSE\n"+kc,o="#define ONLY_TEXCOORDS\n"+kc,l="#define ONLY_NORMALS\n"+kc,h="#define EXTENDED_BONES\n"+Lc,c="#define SKIN\n"+Lc,d="#define ONLY_DIFFUSE\n"+Mc,u="#define ONLY_NORMAL_MAP\n"+Mc,f="#define ONLY_OCCLUSION\n"+Mc,m="#define ONLY_ROUGHNESS\n"+Mc,g="#define ONLY_METALLIC\n"+Mc,p="#define ONLY_TC_FACTOR\n"+Mc,w="#define ONLY_EMISSIVE\n"+Mc,b="#define ONLY_TEXCOORDS\n"+Mc,v="#define ONLY_NORMALS\n"+Mc,y="#define ONLY_TANGENTS\n"+Mc,_=s.createShader(Sc,kc),x=s.createShader(r,kc),A=s.createShader(Lc,Mc),T=s.createShader(h,Mc),E=s.createShader(c,Mc),S=s.createShader("\n#define EMITTER_PARTICLE2 0\n#define EMITTER_RIBBON 1\n#define EMITTER_SPLAT 2\n#define EMITTER_UBERSPLAT 3\n#define HEAD 0.0\n\nuniform mat4 u_VP;\nuniform int u_emitter;\n\n// Shared\nuniform vec4 u_colors[3];\nuniform vec3 u_vertices[4];\nuniform vec3 u_intervals[4];\nuniform float u_lifeSpan;\nuniform float u_columns;\nuniform float u_rows;\n\n// Particle2\nuniform vec3 u_scaling;\nuniform vec3 u_cameraZ;\nuniform float u_timeMiddle;\nuniform bool u_teamColored;\n\n// Splat and Uber.\nuniform vec3 u_intervalTimes;\n\n// Vertices\nattribute float a_position;\n\n// Instances\nattribute vec3 a_p0;\nattribute vec3 a_p1;\nattribute vec3 a_p2;\nattribute vec3 a_p3;\nattribute float a_health;\nattribute vec4 a_color;\nattribute float a_tail;\nattribute vec3 a_leftRightTop;\n\nvarying vec2 v_texcoord;\nvarying vec4 v_color;\n\nfloat getCell(vec3 interval, float factor) {\n  float start = interval[0];\n  float end = interval[1];\n  float repeat = interval[2];\n  float spriteCount = end - start;\n\n  if (spriteCount > 0.0) {\n    // Repeating speeds up the sprite animation, which makes it effectively run N times in its interval.\n    // E.g. if repeat is 4, the sprite animation will be seen 4 times, and thus also run 4 times as fast.\n    // The sprite index is limited to the number of actual sprites.\n    return min(start + mod(floor(spriteCount * repeat * factor), spriteCount), u_columns * u_rows - 1.0);\n  }\n\n  return start;\n}\n\nvoid particle2() {\n  float factor = (u_lifeSpan - a_health) / u_lifeSpan;\n  int index = 0;\n\n  if (factor < u_timeMiddle) {\n    factor = factor / u_timeMiddle;\n    index = 0;\n  } else {\n    factor = (factor - u_timeMiddle) / (1.0 - u_timeMiddle);\n    index = 1;\n  }\n\n  factor = min(factor, 1.0);\n\n  float scale = mix(u_scaling[index], u_scaling[index + 1], factor);\n  vec4 color = mix(u_colors[index], u_colors[index + 1], factor);\n\n  float cell = 0.0;\n\n  if (u_teamColored) {\n    cell = a_leftRightTop[0];\n  } else {\n    vec3 interval;\n\n    if (a_tail == HEAD) {\n      interval = u_intervals[index];\n    } else {\n      interval = u_intervals[index + 2];\n    }\n\n    cell = getCell(interval, factor);\n  }\n\n  float left = floor(mod(cell, u_columns));\n  float top = floor(cell / u_columns);\n  float right = left + 1.0;\n  float bottom = top + 1.0;\n\n  left /= u_columns;\n  right /= u_columns;\n  top /= u_rows;\n  bottom /= u_rows;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(right, top);\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(left, top);\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(left, bottom);\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(right, bottom);\n  }\n\n  v_color = color;\n  \n  if (a_tail == HEAD) {\n    vec3 v = u_vertices[int(a_position)];\n    float cs = cos(a_p1.x);\n    float sn = sin(a_p1.x);\n\n    float x = v.x * cs - v.y * sn;\n    float y = v.x * sn + v.y * cs;\n\n    vec3 fv = vec3(\n      v.x * cs - v.y * sn,\n      v.x * sn + v.y * cs,\n      v.z);\n\n    gl_Position = u_VP * vec4(a_p0 + fv * scale, 1.0);\n  } else {\n    // Get the normal to the tail in camera space.\n    // This allows to build a 2D rectangle around the 3D tail.\n    vec3 normal = cross(u_cameraZ, normalize(a_p1 - a_p0));\n    vec3 boundary = normal * scale * a_p2[0];\n    vec3 position;\n\n    if (a_position == 0.0) {\n      position = a_p0 - boundary;\n    } else if (a_position == 1.0) {\n      position = a_p1 - boundary;\n    } else if (a_position == 2.0) {\n      position = a_p1 + boundary;\n    } else if (a_position == 3.0) {\n      position = a_p0 + boundary;\n    }\n\n    gl_Position = u_VP * vec4(position, 1.0);\n  }\n}\n\nvoid ribbon() {\n  vec3 position;\n  float left = a_leftRightTop[0] / 255.0;\n  float right = a_leftRightTop[1] / 255.0;\n  float top = a_leftRightTop[2] / 255.0;\n  float bottom = top + 1.0;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(right, top);\n    position = a_p0;\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(right, bottom);\n    position = a_p1;\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(left, bottom);\n    position = a_p2;\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(left, top);\n    position = a_p3;\n  }\n\n  v_texcoord[0] /= u_columns;\n  v_texcoord[1] /= u_rows;\n\n  v_color = a_color;\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n\nvoid splat() {\n  float factor = u_lifeSpan - a_health;\n  int index;\n\n  if (factor < u_intervalTimes[0]) {\n    factor = factor / u_intervalTimes[0];\n    index = 0;\n  } else {\n    factor = (factor - u_intervalTimes[0]) / u_intervalTimes[1];\n    index = 1;\n  }\n\n  float cell = getCell(u_intervals[index], factor);\n  float left = floor(mod(cell, u_columns));\n  float top = floor(cell / u_columns);\n  float right = left + 1.0;\n  float bottom = top + 1.0;\n  vec3 position;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(left, top);\n    position = a_p0;\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(left, bottom);\n    position = a_p1;\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(right, bottom);\n    position = a_p2;\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(right, top);\n    position = a_p3;\n  }\n\n  v_texcoord[0] /= u_columns;\n  v_texcoord[1] /= u_rows;\n\n  v_color = mix(u_colors[index], u_colors[index + 1], factor) / 255.0;\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n\nvoid ubersplat() {\n  float factor = u_lifeSpan - a_health;\n  vec4 color;\n\n  if (factor < u_intervalTimes[0]) {\n    color = mix(u_colors[0], u_colors[1], factor / u_intervalTimes[0]);\n  } else if (factor < u_intervalTimes[0] + u_intervalTimes[1]) {\n    color = u_colors[1];\n  } else {\n    color = mix(u_colors[1], u_colors[2], (factor - u_intervalTimes[0] - u_intervalTimes[1]) / u_intervalTimes[2]);\n  }\n\n  vec3 position;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(0.0, 0.0);\n    position = a_p0;\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(0.0, 1.0);\n    position = a_p1;\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(1.0, 1.0);\n    position = a_p2;\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(1.0, 0.0);\n    position = a_p3;\n  }\n\n  v_color = color / 255.0;\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n\nvoid main() {\n  if (u_emitter == EMITTER_PARTICLE2) {\n    particle2();\n  } else if (u_emitter == EMITTER_RIBBON) {\n    ribbon();\n  } else if (u_emitter == EMITTER_SPLAT) {\n    splat();\n  } else if (u_emitter == EMITTER_UBERSPLAT) {\n    ubersplat();\n  }\n}\n",Cc),I=[],k=[];let L=[];L[wl.Diffuse]=s.createShader(Sc,a),L[wl.TexCoords]=s.createShader(Sc,o),L[wl.Normals]=s.createShader(Sc,l),I[fh.VertexGroups]=L,L=[],L[wl.Diffuse]=s.createShader(r,a),L[wl.TexCoords]=s.createShader(r,o),L[wl.Normals]=s.createShader(r,l),I[fh.ExtendedVertexGroups]=L,L=[],L[wl.Diffuse]=s.createShader(Lc,d),L[wl.NormalMap]=s.createShader(Lc,u),L[wl.Occlusion]=s.createShader(Lc,f),L[wl.Roughness]=s.createShader(Lc,m),L[wl.Metallic]=s.createShader(Lc,g),L[wl.TCFactor]=s.createShader(Lc,p),L[wl.Emissive]=s.createShader(Lc,w),L[wl.TexCoords]=s.createShader(Lc,b),L[wl.Normals]=s.createShader(Lc,v),L[wl.Tangents]=s.createShader("#define ONLY_TANGENTS\n"+Lc,y),k[fh.VertexGroups]=L,L=[],L[wl.Diffuse]=s.createShader(h,d),L[wl.NormalMap]=s.createShader(h,u),L[wl.Occlusion]=s.createShader(h,f),L[wl.Roughness]=s.createShader(h,m),L[wl.Metallic]=s.createShader(h,g),L[wl.TCFactor]=s.createShader(h,p),L[wl.Emissive]=s.createShader(h,w),L[wl.TexCoords]=s.createShader(h,b),L[wl.Normals]=s.createShader(h,v),L[wl.Tangents]=s.createShader("#define ONLY_TANGENTS\n"+h,y),k[fh.ExtendedVertexGroups]=L,L=[],L[wl.Diffuse]=s.createShader(c,d),L[wl.NormalMap]=s.createShader(c,u),L[wl.Occlusion]=s.createShader(c,f),L[wl.Roughness]=s.createShader(c,m),L[wl.Metallic]=s.createShader(c,g),L[wl.TCFactor]=s.createShader(c,p),L[wl.Emissive]=s.createShader(c,w),L[wl.TexCoords]=s.createShader(c,b),L[wl.Normals]=s.createShader(c,v),L[wl.Tangents]=s.createShader("#define ONLY_TANGENTS\n"+c,y),k[fh.Skin]=L;const M=n.createBuffer();n.bindBuffer(n.ARRAY_BUFFER,M),n.bufferData(n.ARRAY_BUFFER,new Uint8Array([0,1,2,0,2,3]),n.STATIC_DRAW);const C={pathSolver:e,reforged:i,sdShader:_,sdExtendedShader:x,hdShader:A,hdExtendedShader:T,hdSkinShader:E,particlesShader:S,sdDebugShaders:I,hdDebugShaders:k,rectBuffer:M,teamColors:[],teamGlows:[],eventObjectTables:{}};t.sharedCache.set("mdx",C)},isValidSource:t=>t instanceof sr||(ir(t)||nr(t)),resource:class extends El{constructor(t,e){let i;if(super(e),this.reforged=!1,this.hd=!1,this.solverParams={},this.name="",this.sequences=[],this.globalSequences=[],this.materials=[],this.layers=[],this.textures=[],this.textureAnimations=[],this.geosets=[],this.geosetAnimations=[],this.bones=[],this.lights=[],this.helpers=[],this.attachments=[],this.pivotPoints=[],this.particleEmitters=[],this.particleEmitters2=[],this.ribbonEmitters=[],this.cameras=[],this.eventObjects=[],this.collisionShapes=[],this.hasLayerAnims=!1,this.hasGeosetAnims=!1,this.batches=[],this.genericObjects=[],this.sortedGenericObjects=[],this.hierarchy=[],this.opaqueGroups=[],this.translucentGroups=[],this.arrayBuffer=null,this.elementBuffer=null,this.skinDataType=0,this.bytesPerSkinElement=1,t instanceof sr)i=t;else{i=new sr;try{i.load(t)}catch(t){}}const n=this.viewer,s=this.pathSolver,r=this.solverParams,a=i.version>800,o=a?".dds":".blp";let l=!1;this.reforged=a,this.name=i.name;const h=i.extent;this.bounds.fromExtents(h.min,h.max);for(const t of i.sequences)this.sequences.push(new Tl(t));for(const t of i.globalSequences)this.globalSequences.push(t);for(const t of i.textureAnimations)this.textureAnimations.push(new jl(this,t));let c=0;for(const t of i.materials){const e=[];for(const i of t.layers){const n=new $l(this,i,c++,t.priorityPlane);e.push(n),this.layers.push(n)}this.materials.push(new zl(this,t.shader,e)),""!==t.shader&&(this.hd=!0)}a&&(r.reforged=!0),this.hd&&(r.hd=!0);const d=i.textures;for(let t=0,e=d.length;t<e;t++){const e=d[t];let i=e.path;const a=e.replaceableId,h=e.wrapMode;""===i&&0!==a&&(i=`ReplaceableTextures\\${Hl[a]}${o}`,1!==a&&2!==a||(l=!0));const c=new oh(a,h);n.load(i,s,r).then((t=>{t&&(c.texture=t)})),this.textures[t]=c}for(const t of i.geosetAnimations)this.geosetAnimations.push(new ql(this,t));this.pivotPoints=i.pivotPoints;let u=0;for(const t of i.bones)this.bones.push(new Wl(this,t,u++));for(const t of i.lights)this.lights.push(new Yl(this,t,u++));for(const t of i.helpers)this.helpers.push(new Zl(this,t,u++));for(const t of i.attachments)this.attachments.push(new Ql(this,t,u++));for(const t of i.particleEmitters)this.particleEmitters.push(new Jl(this,t,u++));for(const t of i.particleEmitters2){const e=new lh(this,t,u++);this.particleEmitters2.push(e),e.teamColored&&(l=!0)}for(const t of i.ribbonEmitters)this.ribbonEmitters.push(new hh(this,t,u++));for(const t of i.cameras)this.cameras.push(new ch(this,t));for(const t of i.eventObjects)this.eventObjects.push(new dh(this,t,u++));for(const t of i.collisionShapes)this.collisionShapes.push(new uh(this,t,u++));this.genericObjects.push(...this.bones,...this.lights,...this.helpers,...this.attachments,...this.particleEmitters,...this.particleEmitters2,...this.ribbonEmitters,...this.eventObjects,...this.collisionShapes),function(t,e){if(e.length>0){const i=t.viewer.gl;let n=0,s=0,r=0,a=0,o=0,l=0;const h=[];for(let t=0,i=e.length;t<i;t++){const i=e[t];if(0===i.lod||-1===i.lod){const e=i.vertices.length/3;if(n+=12*e,s+=12*e,r+=i.uvSets.length*e*8,i.tangents.length&&(a+=16*e),i.skin.length)o+=8*e,h[t]=fh.Skin;else{let n=0;for(const t of i.matrixGroups)t>n&&(n=t);n>4?(o+=9*e,h[t]=fh.ExtendedVertexGroups):(o+=5*e,h[t]=fh.VertexGroups)}l+=i.faces.byteLength}}let c=0,d=c+n,u=d+s,f=u+r,m=f+a,g=0,p=Uint8Array,w=i.UNSIGNED_BYTE;t.bones.length>255&&(o*=2,p=Uint16Array,w=i.UNSIGNED_SHORT),t.skinDataType=w,t.bytesPerSkinElement=p.BYTES_PER_ELEMENT,t.arrayBuffer=i.createBuffer(),i.bindBuffer(i.ARRAY_BUFFER,t.arrayBuffer),i.bufferData(i.ARRAY_BUFFER,m+o,i.STATIC_DRAW),t.elementBuffer=i.createBuffer(),i.bindBuffer(i.ELEMENT_ARRAY_BUFFER,t.elementBuffer),i.bufferData(i.ELEMENT_ARRAY_BUFFER,l,i.STATIC_DRAW);for(let n=0,s=e.length;n<s;n++){const s=e[n];if(0===s.lod||-1===s.lod){const e=s.vertices,r=s.normals,a=s.uvSets,o=s.tangents,l=s.faces;let w;const b=s.vertices.length/3,v=h[n];if(v===fh.Skin)w=s.skin;else{const t=s.matrixIndices,e=s.vertexGroups,i=[];let n=0,r=4;v===fh.ExtendedVertexGroups&&(r=8),w=new p(b*(r+1));for(const e of s.matrixGroups)i.push(t.subarray(n,n+e)),n+=e;for(let t=0;t<b;t++){const s=i[e[t]];if(n=t*(r+1),s){const t=Math.min(s.length,r);for(let e=0;e<t;e++)w[n+e]=s[e]+1;w[n+r]=t}}}const y=new gh(t,t.geosets.length,c,d,u,f,m,g,b,l.length,s.faceTypeGroups[0]);t.geosets.push(y);const _=t.materials[s.materialId];if("Shader_HD_DefaultUnit"===_.shader)t.batches.push(new mh(t.batches.length,y,_,v,!0));else for(const e of _.layers)t.batches.push(new mh(t.batches.length,y,e,v,!1));i.bufferSubData(i.ARRAY_BUFFER,c,e),c+=e.byteLength,i.bufferSubData(i.ARRAY_BUFFER,d,r),d+=r.byteLength;for(const t of a)i.bufferSubData(i.ARRAY_BUFFER,u,t),u+=t.byteLength;o.length&&(i.bufferSubData(i.ARRAY_BUFFER,f,o),f+=o.byteLength),i.bufferSubData(i.ARRAY_BUFFER,m,w),m+=w.byteLength,i.bufferSubData(i.ELEMENT_ARRAY_BUFFER,g,l),g+=l.byteLength}}}}(this,i.geosets),function(t){const e=[];let i=[];for(const n of t.batches)n.layer.filterMode<2?e.push(n):i.push(n);const n=t.opaqueGroups,s=t.translucentGroups;let r=null;for(const i of e)r&&vh(r,i)||(r=yh(t,i),n.push(r)),r.objects.push(i.index);i=i.sort(((t,e)=>t.layer.filterMode-e.layer.filterMode));const a=[...i,...t.eventObjects,...t.particleEmitters2,...t.ribbonEmitters].sort(((t,e)=>bh(t)-bh(e)));r=null;for(const e of a)(e instanceof mh||-1!==e.geometryEmitterType)&&(r&&vh(r,e)||(r=yh(t,e),s.push(r)),r.objects.push(e.index))}(this),this.setupHierarchy(-1);for(let t=0,e=this.genericObjects.length;t<e;t++)this.sortedGenericObjects[t]=this.genericObjects[this.hierarchy[t]];l&&Uc.loadTeamTextures(n)}addInstance(){return new Ac(this)}setupHierarchy(t){for(let e=0,i=this.genericObjects.length;e<i;e++){const i=this.genericObjects[e];i.parentId===t&&(this.hierarchy.push(e),this.setupHierarchy(i.objectId))}}},loadTeamTextures(t){const{pathSolver:e,reforged:i,teamColors:n,teamGlows:s}=t.sharedCache.get("mdx");if(0===n.length){const r=i?28:16,a=i?"dds":"blp",o=i?{reforged:!0}:void 0;for(let i=0;i<r;i++){const r=`${`${i}`.padStart(2,"0")}.${a}`,l=new oh(1,3),h=new oh(2,3);t.load(`ReplaceableTextures\\TeamColor\\TeamColor${r}`,e,o).then((t=>l.texture=t)),t.load(`ReplaceableTextures\\TeamGlow\\TeamGlow${r}`,e,o).then((t=>h.texture=t)),n[i]=l,s[i]=h}}},getEventObjectSoundFile(t,i,n,s){if(!i||".flac"===e(t))return t;for(let e=1,i=s.length;e<i;e++){const i=s[e].data.getRow(t);if(i){const t=i.Flags,e=i.Filepath;if("SD_ONLY"===t){if(!n)return e}else{if("HD_ONLY"!==t)return e;if(n)return e}}}},async getEventObjectData(t,e,i,n){if("SPN"!==e&&"SPL"!==e&&"UBR"!==e&&"SND"!==e)return;const{pathSolver:s,reforged:r,eventObjectTables:a}=t.sharedCache.get("mdx"),o=r?{reforged:!0}:void 0,l=(t,e)=>s?s(t,e):t;if(!a[e]){const i=[];"SPN"===e?i.push("Splats\\SpawnData.slk"):"SPL"===e?i.push("Splats\\SplatData.slk"):"UBR"===e?i.push("Splats\\UberSplatData.slk"):"SND"===e&&(i.push("UI\\SoundInfo\\AnimSounds.slk"),r?i.push("UI\\SoundInfo\\DialogueHumanBase.slk","UI\\SoundInfo\\DialogueOrcBase.slk","UI\\SoundInfo\\DialogueUndeadBase.slk","UI\\SoundInfo\\DialogueNightElfBase.slk","UI\\SoundInfo\\DialogueNagaBase.slk","UI\\SoundInfo\\DialogueDemonBase.slk","UI\\SoundInfo\\DialogueCreepsBase.slk"):i.push("UI\\SoundInfo\\AnimLookups.slk"));const n=i.map((e=>t.loadGeneric(l(e,o),"text",Rc))),s=await Promise.all(n);for(const t of s)if(!t)return;a[e]=s}const h=a[e],c=h[0].data;let d;const u=[];if("SND"===e){if(r)d=c.findRow("AnimationEventCode",i);else{const t=h[1].data.getRow(i);t&&(d=c.getRow(t.SoundLabel))}if(d)for(const e of d.FileNames.split(",")){const i=this.getEventObjectSoundFile(e,r,n,h);i&&u.push(t.loadGeneric(l(i,o),"arrayBuffer",Bc))}}else d=c.getRow(i),d&&("SPN"===e?u.push(t.load(d.Model.replace(".mdl",".mdx"),l,o)):"SPL"!==e&&"UBR"!==e||u.push(t.load(`ReplaceableTextures\\Splats\\${d.file}${r?".dds":".blp"}`,l,o)));if(d&&u.length){const t=(await Promise.all(u)).filter((t=>t));if(t.length)return{row:d,resources:t}}},getBatchShader(t,e,i){const n=t.sharedCache.get("mdx"),s=t.debugRenderMode;if(i){if(s!==wl.None){const t=n.hdDebugShaders[e];if(t){const e=t[s];if(e)return e}}return e===fh.Skin?n.hdSkinShader:e===fh.VertexGroups?n.hdShader:n.hdExtendedShader}if(s!==wl.None){const t=n.sdDebugShaders[e];if(t){const e=t[s];if(e)return e}}return e===fh.VertexGroups?n.sdShader:n.sdExtendedShader}};const Pc={isValidSource(t){return t instanceof Er||((e=t)instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&66===e[0]&&76===e[1]&&80===e[2]&&49===e[3]);var e},resource:class extends ml{constructor(t,e){let i;super(e),t instanceof Er?i=t:(i=new Er,i.load(t));const n=this.viewer.gl,s=n.createTexture();n.bindTexture(n.TEXTURE_2D,s),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MAG_FILTER,n.LINEAR);const r=D(i.width)&&D(i.height);r||(n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_S,n.CLAMP_TO_EDGE),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_T,n.CLAMP_TO_EDGE));const a=i.mipmaps();if(1===a||i.fakeMipmaps()||!r){const t=i.getMipmap(0);n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MIN_FILTER,n.LINEAR),n.texImage2D(n.TEXTURE_2D,0,n.RGBA,n.RGBA,n.UNSIGNED_BYTE,t)}else{n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MIN_FILTER,n.LINEAR_MIPMAP_LINEAR);let t=i.width,e=i.height;for(let s=0;s<a;s++){const r=i.getMipmap(s);n.texImage2D(n.TEXTURE_2D,s,n.RGBA,t,e,0,n.RGBA,n.UNSIGNED_BYTE,r.data),t=Math.ceil(t/2),e=Math.ceil(e/2)}}this.width=i.width,this.height=i.height,this.webglResource=s}}};const Fc={load(t){t.webgl.ensureExtension("WEBGL_compressed_texture_s3tc")||console.warn("DDS: No compressed textures support! This might reduce performance.")},isValidSource(t){return t instanceof Gr||((e=t)instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&68===e[0]&&68===e[1]&&83===e[2]&&32===e[3]);var e},resource:class extends ml{constructor(t,e){let i;super(e),t instanceof Gr?i=t:(i=new Gr,i.load(t));const n=this.viewer,s=n.gl,r=n.webgl.extensions.WEBGL_compressed_texture_s3tc,a=i.format;let o=0;r&&(a===Nr?o=r.COMPRESSED_RGB_S3TC_DXT1_EXT:a===Dr?o=r.COMPRESSED_RGBA_S3TC_DXT3_EXT:a===Or&&(o=r.COMPRESSED_RGBA_S3TC_DXT5_EXT));const l=s.createTexture();this.width=i.width,this.height=i.height,this.webglResource=l,s.bindTexture(s.TEXTURE_2D,l);const h=i.mipmaps();a!==Nr&&a!==Vr||s.pixelStorei(s.UNPACK_ALIGNMENT,2);for(let t=0;t<h;t++){const{width:e,height:n,data:r}=i.getMipmap(t,0!==o);o?s.compressedTexImage2D(s.TEXTURE_2D,t,o,e,n,0,r):a===Nr||a===Dr||a===Or?s.texImage2D(s.TEXTURE_2D,t,s.RGBA,e,n,0,s.RGBA,s.UNSIGNED_BYTE,r):s.texImage2D(s.TEXTURE_2D,t,s.LUMINANCE_ALPHA,e,n,0,s.LUMINANCE_ALPHA,s.UNSIGNED_BYTE,r)}s.pixelStorei(s.UNPACK_ALIGNMENT,4),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MAG_FILTER,s.LINEAR),h>1?s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MIN_FILTER,s.LINEAR_MIPMAP_LINEAR):s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MIN_FILTER,s.LINEAR)}}};const Nc={isValidSource(t){return t instanceof jr||((e=t)instanceof ArrayBuffer&&(e=new Uint8Array(e)),!!(e instanceof Uint8Array&&c(e,"TRUEVISION-XFILE.\0",e.length-18)));var e},resource:class extends ml{constructor(t,e){let i;super(e),t instanceof jr?i=t:(i=new jr,i.load(t));const n=i.width,s=i.height,r=this.viewer.gl,a=r.createTexture();r.bindTexture(r.TEXTURE_2D,a),r.texImage2D(r.TEXTURE_2D,0,r.RGBA,r.RGBA,r.UNSIGNED_BYTE,i.data),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.LINEAR),D(n)&&D(s)?(r.generateMipmap(r.TEXTURE_2D),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.LINEAR_MIPMAP_LINEAR)):r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.LINEAR),this.webglResource=a,this.width=n,this.height=s}}};const Dc=Za(),Oc=Za(),Vc=po(),Gc=new Float32Array(1);function jc(t,e){let i=e.clientX-t.clientX,n=e.clientY-t.clientY;return Math.sqrt(i*i+n*n)}class Kc{constructor(t,e={}){this.scene=t,this.canvas=t.viewer.canvas,this.camera=t.camera,this.moveSpeed=e.moveSpeed||2,this.rotationSpeed=e.rotationSpeed||Math.PI/180,this.zoomFactor=e.zoomFactor||.1,this.horizontalAngle=e.horizontalAngle||Math.PI/2,this.verticalAngle=e.verticalAngle||Math.PI/4,this.distance=e.distance||500,this.position=e.position||Za(),this.target=e.target||Za(),this.twist=e.twist||0,this.mouse={buttons:[!1,!1,!1],x:0,y:0,x2:0,y2:0},this.touchMode=-1,this.touches=[],this.instance=null,this.onManualChange=e.onManualChange||null,this.fov=e.fov||Math.PI/4,this.nearClipPlane=e.nearClipPlane||1,this.farClipPlane=e.farClipPlane||2e5,this.update(),window.addEventListener("resize",(t=>this.onResize())),setTimeout((()=>this.onResize()),0),this.canvas.addEventListener("contextmenu",(t=>t.preventDefault())),this.canvas.addEventListener("selectstart",(t=>t.preventDefault())),this.canvas.addEventListener("mousedown",(t=>{t.preventDefault(),this.mouse.buttons[t.button]=!0})),document.addEventListener("mouseup",(t=>{t.preventDefault(),this.mouse.buttons[t.button]=!1})),window.addEventListener("mousemove",(t=>{this.mouse.x2=this.mouse.x,this.mouse.y2=this.mouse.y,this.mouse.x=t.clientX,this.mouse.y=t.clientY;let e=this.mouse.x-this.mouse.x2,i=this.mouse.y-this.mouse.y2;this.mouse.buttons[0]&&this.rotate(e,i),this.mouse.buttons[2]&&this.move(-e,i)})),this.canvas.addEventListener("wheel",(t=>{t.preventDefault();let e=t.deltaY;1===t.deltaMode&&(e=e/3*100),this.zoom(e/100)})),this.canvas.addEventListener("touchstart",(t=>{t.preventDefault();let e=t.targetTouches;1===e.length?this.touchMode=0:2==e.length?this.touchMode=1:this.touchMode=-1,this.touches.length=0,this.touches.push(...e)})),this.canvas.addEventListener("touchend",(t=>{t.preventDefault(),this.touchMode=-1})),this.canvas.addEventListener("touchcancel",(t=>{t.preventDefault(),this.touchMode=-1})),this.canvas.addEventListener("touchmove",(t=>{t.preventDefault();let e=t.targetTouches;if(0===this.touchMode){let t=this.touches[0],i=e[0],n=i.clientX-t.clientX,s=i.clientY-t.clientY;this.rotate(n,s)}else if(1===this.touchMode){let t=jc(this.touches[0],this.touches[1]),i=jc(e[0],e[1]);this.zoom((t-i)/50)}this.touches.length=0,this.touches.push(...e)}))}update(){if(this.instance){let t=this.instance,e=t.model.cameras[0];e.getTranslation(Dc,t.sequence,t.frame,t.counter),io(Dc,Dc,e.position),e.getTargetTranslation(Oc,t.sequence,t.frame,t.counter),io(Oc,Oc,e.targetPosition),e.getRotation(Gc,t.sequence,t.frame,t.counter),this.twist=Gc[0],oo(Dc,Dc,t.worldMatrix),oo(Oc,Oc,t.worldMatrix),this.moveToAndFace(Dc,Oc)}else this.updateInternalCamera()}move(t,e){let i=this.camera.directionX,n=this.camera.directionY,s=this.canvas.width,r=this.canvas.height,a=s/r,o=t/s*this.distance*a,l=e/r*this.distance;io(this.target,this.target,no(Dc,so(Dc,eo(Dc,i[0],i[1],0)),o)),io(this.target,this.target,no(Dc,so(Dc,eo(Dc,n[0],n[1],0)),l)),this.manualChange()}rotate(t,e){this.horizontalAngle-=t*this.rotationSpeed,this.verticalAngle-=e*this.rotationSpeed,this.manualChange()}zoom(t){this.distance=Math.max(1,this.distance*(1+t*this.zoomFactor)),this.manualChange()}manualChange(){this.updateInternalCamera(),this.instance&&(this.instance=null,this.onManualChange&&this.onManualChange())}onResize(){let t=Math.max(this.canvas.clientWidth,1),e=Math.max(this.canvas.clientHeight,1);this.canvas.width=t,this.canvas.height=e,this.scene.viewport[2]=t,this.scene.viewport[3]=e,this.camera.perspective(this.fov,t/e,this.nearClipPlane,this.farClipPlane)}moveToAndFace(t,e){co(Dc,t,e);let i=Qa(Dc),n=Math.atan2(Dc[1],Dc[0]),s=Math.acos(Dc[2]/i);to(this.target,e),this.verticalAngle=s,this.horizontalAngle=n+Math.PI/2,this.distance=i,this.updateInternalCamera()}updateInternalCamera(){this.verticalAngle=Math.min(Math.max(.01,this.verticalAngle),Math.PI-.01),wo(Vc),_o(Vc,Vc,this.horizontalAngle),vo(Vc,Vc,this.verticalAngle),eo(this.position,0,0,1),lo(this.position,this.position,Vc),no(this.position,this.position,this.distance),io(this.position,this.position,this.target);let t=this.twist-Math.PI/2;eo(Dc,0,-Math.cos(t),-Math.sin(t)),this.camera.moveToAndFace(this.position,this.target,Dc)}applyInstanceCamera(t){this.instance=t,this.fov=t.model.cameras[0].fieldOfView,this.onResize(),this.update()}}const $c=[{name:"Red",color:"#ff0402"},{name:"Blue",color:"#0042ff"},{name:"Teal",color:"#1be6ba"},{name:"Purple",color:"#540081"},{name:"Yellow",color:"#fffc00"},{name:"Orange",color:"#ff8a0d"},{name:"Green",color:"#20c000"},{name:"Pink",color:"#e45bb0"},{name:"Gray",color:"#949697"},{name:"Light Blue",color:"#7ebff1"},{name:"Dark Green",color:"#106247"},{name:"Brown",color:"#4f2a05"},{name:"Maroon",color:"#9c0000"},{name:"Navy",color:"#0000c3"},{name:"Turquoise",color:"#00ebff"},{name:"Violet",color:"#bd00ff"},{name:"Wheat",color:"#eccd86"},{name:"Peach",color:"#f7a48b"},{name:"Mint",color:"#c0ff80"},{name:"Lavender",color:"#dcb9ec"},{name:"Coal",color:"#4f4f55"},{name:"Snow",color:"#ecf0ff"},{name:"Emerald",color:"#00781e"},{name:"Peanut",color:"#a46f33"},{name:"Neutral",color:"#2e2d2e"}];class zc extends vs{constructor(t,e){super({...e,className:"viewer-controls"}),this.viewer=t;let i=fs({container:this.container});fs({textContent:"Team color:",container:i}),this.teamColorElement=fs({tagName:"div",className:"controls teamcolor",style:"background-color:red",container:i}),this.teamColorsElement=fs({tagName:"select",className:"controls",onchange:()=>{this.viewer.setTeamColor(this.teamColorsElement.selectedIndex),this.teamColorElement.style.backgroundColor=$c[this.teamColorsElement.selectedIndex].color},container:i});for(let t of $c)this.teamColorsElement.add(fs({tagName:"option",textContent:t.name}));i=fs({container:this.container}),fs({textContent:"Show extents:",container:i}),this.extentElement=fs({tagName:"select",className:"controls",onchange:()=>this.viewer.updateExtents(),container:i}),this.extentElement.add(fs({tagName:"option",textContent:"No"})),this.extentElement.add(fs({tagName:"option",textContent:"Box"})),this.extentElement.add(fs({tagName:"option",textContent:"Sphere"})),this.extentElement.add(fs({tagName:"option",textContent:"Both"})),this.extentElement.selectedIndex=1,i=fs({container:this.container}),fs({textContent:"Run Animations:",container:i}),this.animationToggle=new ys("Yes","No",(t=>{t.clicked?this.viewer.viewer.frameTime=0:this.viewer.viewer.frameTime=1e3/60}),{className:"controls",container:i}),i=fs({container:this.container}),fs({textContent:"Cycle Animations:",container:i}),this.cycleToggle=new ys("Yes","No",null,{className:"controls",container:i}),i=fs({container:this.container}),fs({textContent:"Animations:",container:i}),this.sequencesElement=fs({tagName:"select",className:"controls",onchange:()=>{this.cycleToggle.clicked||this.cycleToggle.toggle(),this.viewer.viewer.clearEmittedObjects(),this.viewer.setSequence(this.sequencesElement.selectedIndex-1)},container:i}),i=fs({container:this.container}),fs({textContent:"Frame:",container:i}),this.frameElement=fs({container:i}),i=fs({container:this.container}),fs({textContent:"Camera:",container:i}),this.camerasElement=fs({tagName:"select",className:"controls",onchange:()=>this.viewer.setCamera(this.camerasElement.selectedIndex-1),container:i}),i=fs({container:this.container}),fs({textContent:"Debug Mode:",container:i}),this.debugRenderSelect=fs({tagName:"select",className:"controls",onchange:()=>{this.viewer.viewer.debugRenderMode=this.debugRenderSelect.selectedIndex},container:i}),this.debugRenderSelect.add(fs({tagName:"option",textContent:"None"})),this.debugRenderSelect.add(fs({tagName:"option",textContent:"Diffuse"})),this.debugRenderSelect.add(fs({tagName:"option",textContent:"Normal map"})),this.debugRenderSelect.add(fs({tagName:"option",textContent:"Occlusion"})),this.debugRenderSelect.add(fs({tagName:"option",textContent:"Roughness"})),this.debugRenderSelect.add(fs({tagName:"option",textContent:"Metallic"})),this.debugRenderSelect.add(fs({tagName:"option",textContent:"TC Factor"})),this.debugRenderSelect.add(fs({tagName:"option",textContent:"Emissive"})),this.debugRenderSelect.add(fs({tagName:"option",textContent:"TexCoords"})),this.debugRenderSelect.add(fs({tagName:"option",textContent:"Normals"})),this.debugRenderSelect.add(fs({tagName:"option",textContent:"Tangents"}))}frame(t){this.frameElement.textContent=`${Math.floor(t)}`}updateInstance(t){bs(this.sequencesElement),this.sequencesElement.add(fs({tagName:"option",textContent:"None"}));for(let e of t.model.sequences)this.sequencesElement.add(fs({tagName:"option",textContent:e.name}));bs(this.camerasElement),this.camerasElement.add(fs({tagName:"option",textContent:"None"}));for(let e of t.model.cameras)this.camerasElement.add(fs({tagName:"option",textContent:e.name}))}setSequence(t){1===this.sequencesElement.options.length&&(t=-1),this.sequencesElement.selectedIndex=t+1}setCamera(t){this.camerasElement.selectedIndex=t+1}}function qc(t,e,i){let n,s,r,a=1;i&&(n=i.lines,s=i.color,r=i.texture,i.twoSided&&(a|=16));const o=new sr,l=o.extent,h=e.boundingRadius;l.min.fill(-h),l.max.fill(h),l.boundsRadius=h;const c=new Ds;c.path="PLACEHOLDER",o.textures[0]=c;const d=new Ns,u=new Fs;u.textureId=0,u.flags=a,d.layers[0]=u,o.materials[0]=d;const f=new Vs;f.vertices=e.vertices,f.uvSets[0]=e.uvs,f.matrixGroups=new Uint32Array([1]),f.matrixIndices=new Uint32Array([0]),f.vertexGroups=new Uint8Array(e.vertices.length/3);let m=4,g=e.faces;if(n&&(m=1,g=e.edges),f.faceTypeGroups=new Uint32Array([m]),f.faceGroups=new Uint32Array([g.length]),f.faces=g,o.geosets[0]=f,s){const t=new Gs;t.geosetId=0,t.color=s,o.geosetAnimations[0]=t}const p=new Ks;return p.objectId=0,o.bones[0]=p,t.load(o,(t=>t===o?o:r))}function Hc(){return t=1,e=1,{vertices:new Float32Array([-t,e,0,-t,-e,0,t,-e,0,t,e,0]),uvs:new Float32Array([0,0,0,1,1,1,1,0]),faces:new Uint16Array([0,1,2,0,2,3]),edges:new Uint16Array([0,1,1,2,2,3,3,0]),boundingRadius:Math.hypot(t,e)};var t,e}function Xc(){return function(t,e,i){return{vertices:new Float32Array([-t,-e,-i,-t,-e,i,-t,e,-i,-t,e,i,t,e,-i,t,e,i,t,-e,-i,t,-e,i]),uvs:new Float32Array([0,0,0,1,.25,0,.25,1,.5,0,.5,1,.75,0,.75,1]),faces:new Uint16Array([0,1,2,1,3,2,2,3,4,3,5,4,4,5,6,5,7,6,6,7,0,7,1,0,0,2,4,0,4,6,1,5,3,1,7,5]),edges:new Uint16Array([0,1,2,3,4,5,6,7,0,2,2,4,4,6,6,0,1,3,3,5,5,7,7,1]),boundingRadius:Math.hypot(t,e,i)}}(1,1,1)}function Wc(t,e){return function(t,e,i){const n=(e+1)*(i+1),s=new Float32Array(3*n),r=new Float32Array(2*n),a=new Uint16Array(e*i*6),o=new Uint16Array(e*i*6);for(let n=0,a=0,o=0;n<=e;n++){const l=n*Math.PI/e,h=Math.sin(l),c=Math.cos(l);for(let l=0;l<=i;l+=1,a+=3,o+=2){const d=2*l*Math.PI/i,u=Math.sin(d),f=Math.cos(d);s[a+0]=f*h*t,s[a+1]=u*h*t,s[a+2]=c*t,r[o+0]=l/i,r[o+1]=1-n/e}}for(let t=0,n=0;t<e;t++)for(let e=0;e<i;e+=1,n+=6){const s=t*(i+1)+e,r=s+i+1;a[n+0]=s,a[n+1]=r,a[n+2]=s+1,a[n+3]=r,a[n+4]=r+1,a[n+5]=s+1,o[n+0]=s,o[n+1]=r,o[n+2]=s,o[n+3]=s+1,o[n+4]=r,o[n+5]=r+1}return{vertices:s,uvs:r,faces:a,edges:o,boundingRadius:t}}(1,t,e)}class Yc extends vs{constructor(t,e){super({...e,className:"viewer"}),this.tester=t,this.messages=[],this.canvas=fs({tagName:"canvas",style:"width:100%;height:100%",container:this.container}),this.controls=new zc(this,{container:this.container});let i=new bl(this.canvas),n=i.addScene();this.viewer=i,this.scene=n,this.visibleTest=null,this.teamColor=0,n.color.fill(.2),this.orbitCamera=function(t,e={}){return new Kc(t,e)}(n,{onManualChange:()=>{this.setCamera(-1),this.controls.setCamera(-1)}}),i.on("loadstart",(e=>{t.logger.log(`[Viewer] Loading ${e.fetchUrl}`)})),i.on("loadend",(e=>{t.logger.log(`[Viewer] Loaded ${e.fetchUrl}`)})),i.on("error",(e=>{e.fetchUrl?t.logger.error(`[Viewer] ${e.error}: ${e.fetchUrl}`):t.logger.error(`[Viewer] ${e.error}: ${e.reason}`)})),i.addHandler(Uc,_s,!0),i.addHandler(Pc),i.addHandler(Fc),i.addHandler(Nc),this.textureModel=null,this.boxModel=null,this.sphereModel=null,qc(i,Hc(),{twoSided:!0}).then((t=>{this.textureModel=t})),qc(i,Xc(),{lines:!0}).then((t=>{this.boxModel=t})),qc(i,Wc(12,12),{lines:!0}).then((t=>{this.sphereModel=t}));let s=performance.now(),r=()=>{requestAnimationFrame(r);let t=performance.now(),e=t-s;if(s=t,this.controls.animationToggle.clicked?i.updateAndRender(0):i.updateAndRender(e),this.visibleTest){let t=this.visibleTest.instance;if(t.sequenceEnded){let e=t.sequence;this.controls.cycleToggle.clicked||(e+=1,e===t.model.sequences.length&&(e=0),this.setSequence(e))}this.controls.frame(t.frame)}};r()}async load(t){const e=await this.viewer.load(t.parser,((e,i)=>e===t.parser?e:t.pathSolver?t.pathSolver(e,i):_s(e,i)));if(!e)return;let i;if(e instanceof El){i=e.addInstance(),i.setTeamColor(this.teamColor);let n=this.boxModel.addInstance();n.hide(),n.setScene(this.scene),n.setParent(i);let s=this.sphereModel.addInstance();s.hide(),s.setScene(this.scene),s.setParent(i),t.boundingBox=n,t.boundingSphere=s}else i=this.textureModel.addInstance(),i.scale([e.width,e.height,1]),i.setTexture(0,e);i.hide(),i.setSequenceLoopMode(2),i.setScene(this.scene),t.resource=e,t.instance=i,this.tryToInjectCustomTextures(t),t===this.tester.visibleTest&&this.render(t)}render(t){t.instance&&(this.visibleTest&&(this.visibleTest.instance.hide(),this.visibleTest.boundingBox&&(this.visibleTest.boundingBox.hide(),this.visibleTest.boundingSphere.hide())),this.visibleTest=t,t.instance.model.sequences.length?(this.controls.updateInstance(t.instance),this.viewer.clearEmittedObjects(),-1===t.instance.sequence?this.setSequence(0):this.setSequence(t.instance.sequence),this.controls.show()):this.controls.hide(),t.instance.show(),this.updateExtents())}updateExtents(){if(this.visibleTest&&this.visibleTest.boundingBox){let t=this.controls.extentElement.selectedIndex;0===t||2===t?this.visibleTest.boundingBox.hide():this.visibleTest.boundingBox.show(),0===t||1===t?this.visibleTest.boundingSphere.hide():this.visibleTest.boundingSphere.show()}}setSequence(t){if(this.visibleTest.instance.setSequence(t),this.visibleTest.boundingBox){let e;if(-1===t)e=this.visibleTest.parser.extent;else{e=this.visibleTest.parser.sequences[t].extent;let{max:i,min:n}=e;0===i[0]&&0===i[1]&&0===i[2]&&0===n[0]&&0===n[1]&&0===n[2]&&(e=this.visibleTest.parser.extent)}let{max:i,min:n}=e,s=(i[0]+n[0])/2,r=(i[1]+n[1])/2,a=(i[2]+n[2])/2,o=(i[0]-n[0])/2,l=(i[1]-n[1])/2,h=(i[2]-n[2])/2;this.visibleTest.boundingBox.setLocation([s,r,a]),this.visibleTest.boundingBox.setScale([o,l,h]),this.visibleTest.boundingSphere.setLocation([s,r,a]),this.visibleTest.boundingSphere.setUniformScale(e.boundsRadius)}this.controls.setSequence(t)}setCamera(t){-1===t?this.orbitCamera.instance=null:this.orbitCamera.applyInstanceCamera(this.visibleTest.instance)}setTeamColor(t){this.teamColor=t,this.visibleTest&&this.visibleTest.instance.setTeamColor(this.teamColor)}tryToInjectCustomTextures(t){if(t.resource instanceof ml){for(let e of this.tester.tests)if(e!==t&&e.instance&&e.resource instanceof El){let i=e.parser.textures;for(let s=0,r=i.length;s<r;s++){n(i[s].path).toLowerCase()===n(t.name).toLowerCase()&&(e.instance.setTexture(s,t.resource),this.tester.logger.info(`Injected ${t.name} as a custom texture for ${e.name}`))}}}else for(let e of this.tester.tests)if(e!==t&&e.instance)if(e.resource instanceof ml){let i=t.parser.textures;for(let s=0,r=i.length;s<r;s++){n(i[s].path).toLowerCase()===n(e.name).toLowerCase()&&(t.instance.setTexture(s,e.resource),this.tester.logger.info(`Injected ${e.name} as a custom texture for ${t.name}`))}}else{let i=e.parser.particleEmitters,s=n(t.name).toLowerCase();for(let t=0,e=i.length;t<e;t++){let e=n(i[t].path).toLowerCase();console.log("inject into other",s,e)}i=t.parser.particleEmitters,s=n(t.name).toLowerCase();for(let t=0,e=i.length;t<e;t++){let e=n(i[t].path).toLowerCase();console.log("inject from other",s,e)}}}}const Zc=new class extends vs{constructor(t){super({className:"client"}),this.tests=[],this.visibleTest=null;let e=fs({className:"tests-header",container:this.container});fs({tagName:"h1",textContent:"Tests",container:e,container:e});let i=fs({className:"tests-body",container:this.container});this.searchTests=fs({tagName:"input",placeholder:"Search tests",oninput:()=>this.filterTests(),container:i}),this.testsElement=fs({className:"tests",container:i});let n=fs({className:"results-header",container:this.container});fs({tagName:"h1",textContent:"Test Results",container:n,container:n}),this.unusedToggle=new ys("Hide Unused","Show Unused",(()=>this.filterResults()),{container:n}),this.warningToggle=new ys("Hide Warnings","Show Warnings",(()=>this.filterResults()),{container:n}),this.severeToggler=new ys("Hide Severe","Show Severe",(()=>this.filterResults()),{container:n}),this.errorToggler=new ys("Hide Errors","Show Errors",(()=>this.filterResults()),{container:n}),this.resultsBody=fs({className:"results-body",container:this.container});let s=fs({className:"viewer-and-mdl-header",container:this.container}),r=fs({tagName:"h1",textContent:"3D View",container:s}),a=fs({className:"viewer-and-mdl-body",container:this.container}),o=fs({className:"viewer-and-console",container:a});this.mdl=fs({className:"mdl hidden",container:a}),new ys("View in MDL","View in 3D",(t=>{t.clicked?(r.textContent="MDL View",ms(o),gs(this.mdl),this.viewer.controls.animationToggle.clicked||this.viewer.controls.animationToggle.toggle()):(r.textContent="3D View",gs(o),this.viewer.orbitCamera.onResize(),ms(this.mdl))}),{container:s}),this.logger=new Va({container:o}),this.viewer=new Yc(this,{container:o}),t.appendChild(this.container)}filterTests(){let t=this.searchTests.value.toLowerCase();for(let e of this.tests)e.name.toLowerCase().includes(t)?e.meta.show():e.meta.hide()}filterResults(){this.visibleTest&&this.visibleTest.results&&this.visibleTest.results.filter(this.unusedToggle.clicked,this.warningToggle.clicked,this.severeToggler.clicked,this.errorToggler.clicked)}test(t,e,i,n){let s;this.logger.info(`Parsing ${t}`);try{s=new Oa(this,t,e,n)}catch(t){this.logger.error(`An error occured before the test could finish: ${t.stack}`)}this.tests.push(s),this.testsElement.appendChild(s.meta.container),s.meta.container.scrollIntoView(),s.results&&this.resultsBody.appendChild(s.results.container),s.mdl&&this.mdl.appendChild(s.mdl.container),this.viewer.load(s),i?this.render(s):s.hide()}render(t){t!==this.visibleTest&&(this.visibleTest&&this.visibleTest.hide(),this.visibleTest=t,this.filterResults(),t.show(),this.viewer.render(t))}loadMap(t,i){this.logger.info(`Parsing ${t}`);let n=new us;try{n.load(i)}catch(e){return void this.logger.error(`Failed to parse ${t}: ${e}`)}let s=(t,e)=>{let i=n.get(t);return i?i.bytes():_s(t,e)},r=!0;for(let i of n.getImportNames()){let a=e(i);if(".mdx"===a||".mdl"===a||".blp"===a||".dds"===a||".tga"===a){let e=n.get(i);e?(".mdx"===a?this.test(`${t}:${i}`,e.arrayBuffer(),r,s):".mdl"===a?this.test(`${t}:${i}`,e.text(),r,s):".blp"!==a&&".dds"!==a&&".tga"!==a||this.test(`${t}:${i}`,e.arrayBuffer(),r),r=!1):this.logger.error(`The map says it imports ${i} but it couldn't be found`)}}}async loadFile(t){let i=t.name,n=e(i);if(".mdx"===n||".mdl"===n||".blp"===n||".dds"===n||".tga"===n||".w3x"===n||".w3m"===n){this.logger.info(`Reading ${i}`);let e=await Ts(t,".mdl"===n);".w3m"===n||".w3x"===n?this.loadMap(i,e):this.test(i,e,!0)}else this.logger.info(`${i} is not a supported file, skipping it`)}async loadDataTransfer(i){let n=await async function(t){const e=t.items;let i=[],n=[];for(let t=0;t<e.length;t++)n.push(e[t].webkitGetAsEntry());for(;n.length>0;){let t=n.shift();t.isFile?i.push(t):t.isDirectory&&n.push(...await xs(t.createReader()))}return i}(i),s=[],r=[];for(let t of n){let i=t.name,n=e(i);".mdx"===n||".mdl"===n||".blp"===n||".dds"===n||".tga"===n||".w3x"===n||".w3m"===n?(this.logger.info(`Reading ${i}`),s.push(i.toLowerCase()),r.push(Es(t,".mdl"===n))):this.logger.info(`${i} is not a supported file, skipping it`)}let a=await Promise.all(r),o=new Map;for(let t=0,e=s.length;t<e;t++)o.set(s[t],a[t]);let l=(e,i)=>{let n=o.get(t(e).toLowerCase());return n||_s(e,i)},h=!0;for(let[t,e]of o.entries())t.endsWith(".w3m")||t.endsWith(".w3x")?this.loadMap(t,e):this.test(t,e,h,l),h=!1}loadAPI(e){if(""!==e){let i=[],n=new Map;for(let t of e.slice(1).split("&")){let[e,s]=t.split("=");void 0!==s&&(i.push(s),e.startsWith("override")&&n.set(e.slice(9,-1).replace(/\//g,"\\"),s))}if(i.length){let e=(e,i)=>{let s=n.get(t(e).toLowerCase());return s||_s(e,i)},s=!0;for(let t of i)fetch(t).then((async i=>{let n;n=t.endsWith(".mdl")?await i.text():await i.arrayBuffer(),this.test(t,n,s,e),s=!1}))}}}}(document.body);document.addEventListener("dragover",(t=>{t.preventDefault()})),document.addEventListener("dragend",(t=>{t.preventDefault()})),document.addEventListener("drop",(t=>{t.preventDefault(),Zc.loadDataTransfer(t.dataTransfer)})),Zc.loadAPI(window.location.search),window.tester=Zc})()})();