/*!
 * The MIT License (MIT)
 *
 * Copyright (c) 2013-2021 Chananya Freiman
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */
var ModelViewer;(()=>{var e={187:e=>{"use strict";var t,n="object"==typeof Reflect?Reflect:null,a=n&&"function"==typeof n.apply?n.apply:function(e,t,n){return Function.prototype.apply.call(e,t,n)};t=n&&"function"==typeof n.ownKeys?n.ownKeys:Object.getOwnPropertySymbols?function(e){return Object.getOwnPropertyNames(e).concat(Object.getOwnPropertySymbols(e))}:function(e){return Object.getOwnPropertyNames(e)};var r=Number.isNaN||function(e){return e!=e};function i(){i.init.call(this)}e.exports=i,e.exports.once=function(e,t){return new Promise((function(n,a){function r(n){e.removeListener(t,i),a(n)}function i(){"function"==typeof e.removeListener&&e.removeListener("error",r),n([].slice.call(arguments))}p(e,t,i,{once:!0}),"error"!==t&&function(e,t,n){"function"==typeof e.on&&p(e,"error",t,n)}(e,r,{once:!0})}))},i.EventEmitter=i,i.prototype._events=void 0,i.prototype._eventsCount=0,i.prototype._maxListeners=void 0;var s=10;function l(e){if("function"!=typeof e)throw new TypeError('The "listener" argument must be of type Function. Received type '+typeof e)}function o(e){return void 0===e._maxListeners?i.defaultMaxListeners:e._maxListeners}function u(e,t,n,a){var r,i,s,u;if(l(n),void 0===(i=e._events)?(i=e._events=Object.create(null),e._eventsCount=0):(void 0!==i.newListener&&(e.emit("newListener",t,n.listener?n.listener:n),i=e._events),s=i[t]),void 0===s)s=i[t]=n,++e._eventsCount;else if("function"==typeof s?s=i[t]=a?[n,s]:[s,n]:a?s.unshift(n):s.push(n),(r=o(e))>0&&s.length>r&&!s.warned){s.warned=!0;var c=new Error("Possible EventEmitter memory leak detected. "+s.length+" "+String(t)+" listeners added. Use emitter.setMaxListeners() to increase limit");c.name="MaxListenersExceededWarning",c.emitter=e,c.type=t,c.count=s.length,u=c,console&&console.warn&&console.warn(u)}return e}function c(){if(!this.fired)return this.target.removeListener(this.type,this.wrapFn),this.fired=!0,0===arguments.length?this.listener.call(this.target):this.listener.apply(this.target,arguments)}function d(e,t,n){var a={fired:!1,wrapFn:void 0,target:e,type:t,listener:n},r=c.bind(a);return r.listener=n,a.wrapFn=r,r}function h(e,t,n){var a=e._events;if(void 0===a)return[];var r=a[t];return void 0===r?[]:"function"==typeof r?n?[r.listener||r]:[r]:n?function(e){for(var t=new Array(e.length),n=0;n<t.length;++n)t[n]=e[n].listener||e[n];return t}(r):m(r,r.length)}function f(e){var t=this._events;if(void 0!==t){var n=t[e];if("function"==typeof n)return 1;if(void 0!==n)return n.length}return 0}function m(e,t){for(var n=new Array(t),a=0;a<t;++a)n[a]=e[a];return n}function p(e,t,n,a){if("function"==typeof e.on)a.once?e.once(t,n):e.on(t,n);else{if("function"!=typeof e.addEventListener)throw new TypeError('The "emitter" argument must be of type EventEmitter. Received type '+typeof e);e.addEventListener(t,(function r(i){a.once&&e.removeEventListener(t,r),n(i)}))}}Object.defineProperty(i,"defaultMaxListeners",{enumerable:!0,get:function(){return s},set:function(e){if("number"!=typeof e||e<0||r(e))throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received '+e+".");s=e}}),i.init=function(){void 0!==this._events&&this._events!==Object.getPrototypeOf(this)._events||(this._events=Object.create(null),this._eventsCount=0),this._maxListeners=this._maxListeners||void 0},i.prototype.setMaxListeners=function(e){if("number"!=typeof e||e<0||r(e))throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received '+e+".");return this._maxListeners=e,this},i.prototype.getMaxListeners=function(){return o(this)},i.prototype.emit=function(e){for(var t=[],n=1;n<arguments.length;n++)t.push(arguments[n]);var r="error"===e,i=this._events;if(void 0!==i)r=r&&void 0===i.error;else if(!r)return!1;if(r){var s;if(t.length>0&&(s=t[0]),s instanceof Error)throw s;var l=new Error("Unhandled error."+(s?" ("+s.message+")":""));throw l.context=s,l}var o=i[e];if(void 0===o)return!1;if("function"==typeof o)a(o,this,t);else{var u=o.length,c=m(o,u);for(n=0;n<u;++n)a(c[n],this,t)}return!0},i.prototype.addListener=function(e,t){return u(this,e,t,!1)},i.prototype.on=i.prototype.addListener,i.prototype.prependListener=function(e,t){return u(this,e,t,!0)},i.prototype.once=function(e,t){return l(t),this.on(e,d(this,e,t)),this},i.prototype.prependOnceListener=function(e,t){return l(t),this.prependListener(e,d(this,e,t)),this},i.prototype.removeListener=function(e,t){var n,a,r,i,s;if(l(t),void 0===(a=this._events))return this;if(void 0===(n=a[e]))return this;if(n===t||n.listener===t)0==--this._eventsCount?this._events=Object.create(null):(delete a[e],a.removeListener&&this.emit("removeListener",e,n.listener||t));else if("function"!=typeof n){for(r=-1,i=n.length-1;i>=0;i--)if(n[i]===t||n[i].listener===t){s=n[i].listener,r=i;break}if(r<0)return this;0===r?n.shift():function(e,t){for(;t+1<e.length;t++)e[t]=e[t+1];e.pop()}(n,r),1===n.length&&(a[e]=n[0]),void 0!==a.removeListener&&this.emit("removeListener",e,s||t)}return this},i.prototype.off=i.prototype.removeListener,i.prototype.removeAllListeners=function(e){var t,n,a;if(void 0===(n=this._events))return this;if(void 0===n.removeListener)return 0===arguments.length?(this._events=Object.create(null),this._eventsCount=0):void 0!==n[e]&&(0==--this._eventsCount?this._events=Object.create(null):delete n[e]),this;if(0===arguments.length){var r,i=Object.keys(n);for(a=0;a<i.length;++a)"removeListener"!==(r=i[a])&&this.removeAllListeners(r);return this.removeAllListeners("removeListener"),this._events=Object.create(null),this._eventsCount=0,this}if("function"==typeof(t=n[e]))this.removeListener(e,t);else if(void 0!==t)for(a=t.length-1;a>=0;a--)this.removeListener(e,t[a]);return this},i.prototype.listeners=function(e){return h(this,e,!0)},i.prototype.rawListeners=function(e){return h(this,e,!1)},i.listenerCount=function(e,t){return"function"==typeof e.listenerCount?e.listenerCount(t):f.call(e,t)},i.prototype.listenerCount=f,i.prototype.eventNames=function(){return this._eventsCount>0?t(this._events):[]}},775:(e,t,n)=>{"use strict";let a,r,i;if(a="function"==typeof Uint8Array.from?Uint8Array.from.bind(Uint8Array):function(e){let t=0,n=e.length,a=new Uint8Array(n);for(;n>t;)a[t]=e[t++];return a},"function"==typeof(new Uint8Array).indexOf)r=function(e,t,n){return e.indexOf(t,n)};else{let e=[].indexOf;if(0!==e.call(new Uint8Array(1),0))throw Error("missing .indexOf");r=function(t,n,a){return e.call(t,n,a)}}i="function"==typeof Uint8Array.of?Uint8Array.of.bind(Uint8Array):function(){return a(arguments)};const s=function(e){return e instanceof Uint8Array},l="cannot convert invalid utf8 to javascript string",o=";,/?:@&=+$abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789,-_.!~*'()#".split("").reduce((function(e,t){return e[t.charCodeAt(0)]=!0,e}),{}),u={},c=function(e,t){if("string"!=typeof e)throw new TypeError("to_luastring expects a javascript string");if(t){let t=u[e];if(s(t))return t}let n=e.length,r=Array(n),i=0;for(let t=0;t<n;++t){let a=e.charCodeAt(t);if(a<=127)r[i++]=a;else if(a<=2047)r[i++]=192|a>>6,r[i++]=128|63&a;else{if(a>=55296&&a<=56319&&t+1<n){let n=e.charCodeAt(t+1);n>=56320&&n<=57343&&(t++,a=1024*(a-55296)+n+9216)}a<=65535?(r[i++]=224|a>>12,r[i++]=128|a>>6&63,r[i++]=128|63&a):(r[i++]=240|a>>18,r[i++]=128|a>>12&63,r[i++]=128|a>>6&63,r[i++]=128|63&a)}}return r=a(r),t&&(u[e]=r),r};e.exports.luastring_from=a,e.exports.luastring_indexOf=r,e.exports.luastring_of=i,e.exports.is_luastring=s,e.exports.luastring_eq=function(e,t){if(e!==t){let n=e.length;if(n!==t.length)return!1;for(let a=0;a<n;a++)if(e[a]!==t[a])return!1}return!0},e.exports.to_jsstring=function(e,t,n,a){if(!s(e))throw new TypeError("to_jsstring expects a Uint8Array");n=void 0===n?e.length:Math.min(e.length,n);let r="";for(let i=void 0!==t?t:0;i<n;){let t=e[i++];if(t<128)r+=String.fromCharCode(t);else if(t<194||t>244){if(!a)throw RangeError(l);r+="�"}else if(t<=223){if(i>=n){if(!a)throw RangeError(l);r+="�";continue}let s=e[i++];if(128!=(192&s)){if(!a)throw RangeError(l);r+="�";continue}r+=String.fromCharCode(((31&t)<<6)+(63&s))}else if(t<=239){if(i+1>=n){if(!a)throw RangeError(l);r+="�";continue}let s=e[i++];if(128!=(192&s)){if(!a)throw RangeError(l);r+="�";continue}let o=e[i++];if(128!=(192&o)){if(!a)throw RangeError(l);r+="�";continue}let u=((15&t)<<12)+((63&s)<<6)+(63&o);if(u<=65535)r+=String.fromCharCode(u);else{u-=65536;let e=55296+(u>>10),t=u%1024+56320;r+=String.fromCharCode(e,t)}}else{if(i+2>=n){if(!a)throw RangeError(l);r+="�";continue}let s=e[i++];if(128!=(192&s)){if(!a)throw RangeError(l);r+="�";continue}let o=e[i++];if(128!=(192&o)){if(!a)throw RangeError(l);r+="�";continue}let u=e[i++];if(128!=(192&u)){if(!a)throw RangeError(l);r+="�";continue}let c=((7&t)<<18)+((63&s)<<12)+((63&o)<<6)+(63&u);c-=65536;let d=55296+(c>>10),h=c%1024+56320;r+=String.fromCharCode(d,h)}}return r},e.exports.to_uristring=function(e){if(!s(e))throw new TypeError("to_uristring expects a Uint8Array");let t="";for(let n=0;n<e.length;n++){let a=e[n];o[a]?t+=String.fromCharCode(a):t+="%"+(a<16?"0":"")+a.toString(16)}return t},e.exports.to_luastring=c,e.exports.from_userstring=function(e){if(!s(e)){if("string"!=typeof e)throw new TypeError("expects an array of bytes or javascript string");e=c(e)}return e};const d=c("Lua"),h="Lua 5.3",f="Lua 5.3.4";e.exports.LUA_SIGNATURE=d,e.exports.LUA_VERSION_MAJOR="5",e.exports.LUA_VERSION_MINOR="3",e.exports.LUA_VERSION_NUM=503,e.exports.LUA_VERSION_RELEASE="4",e.exports.LUA_VERSION=h,e.exports.LUA_RELEASE=f,e.exports.LUA_COPYRIGHT="Lua 5.3.4  Copyright (C) 1994-2017 Lua.org, PUC-Rio",e.exports.LUA_AUTHORS="R. Ierusalimschy, L. H. de Figueiredo, W. Celes";const m={LUA_TNONE:-1,LUA_TNIL:0,LUA_TBOOLEAN:1,LUA_TLIGHTUSERDATA:2,LUA_TNUMBER:3,LUA_TSTRING:4,LUA_TTABLE:5,LUA_TFUNCTION:6,LUA_TUSERDATA:7,LUA_TTHREAD:8,LUA_NUMTAGS:9};m.LUA_TSHRSTR=0|m.LUA_TSTRING,m.LUA_TLNGSTR=16|m.LUA_TSTRING,m.LUA_TNUMFLT=0|m.LUA_TNUMBER,m.LUA_TNUMINT=16|m.LUA_TNUMBER,m.LUA_TLCL=0|m.LUA_TFUNCTION,m.LUA_TLCF=16|m.LUA_TFUNCTION,m.LUA_TCCL=32|m.LUA_TFUNCTION;const{LUAI_MAXSTACK:p}=n(947),_=-p-1e3;e.exports.LUA_HOOKCALL=0,e.exports.LUA_HOOKCOUNT=3,e.exports.LUA_HOOKLINE=2,e.exports.LUA_HOOKRET=1,e.exports.LUA_HOOKTAILCALL=4,e.exports.LUA_MASKCALL=1,e.exports.LUA_MASKCOUNT=8,e.exports.LUA_MASKLINE=4,e.exports.LUA_MASKRET=2,e.exports.LUA_MINSTACK=20,e.exports.LUA_MULTRET=-1,e.exports.LUA_OPADD=0,e.exports.LUA_OPBAND=7,e.exports.LUA_OPBNOT=13,e.exports.LUA_OPBOR=8,e.exports.LUA_OPBXOR=9,e.exports.LUA_OPDIV=5,e.exports.LUA_OPEQ=0,e.exports.LUA_OPIDIV=6,e.exports.LUA_OPLE=2,e.exports.LUA_OPLT=1,e.exports.LUA_OPMOD=3,e.exports.LUA_OPMUL=2,e.exports.LUA_OPPOW=4,e.exports.LUA_OPSHL=10,e.exports.LUA_OPSHR=11,e.exports.LUA_OPSUB=1,e.exports.LUA_OPUNM=12,e.exports.LUA_REGISTRYINDEX=_,e.exports.LUA_RIDX_GLOBALS=2,e.exports.LUA_RIDX_LAST=2,e.exports.LUA_RIDX_MAINTHREAD=1,e.exports.constant_types=m,e.exports.lua_Debug=class{constructor(){this.event=NaN,this.name=null,this.namewhat=null,this.what=null,this.source=null,this.currentline=NaN,this.linedefined=NaN,this.lastlinedefined=NaN,this.nups=NaN,this.nparams=NaN,this.isvararg=NaN,this.istailcall=NaN,this.short_src=null,this.i_ci=null}},e.exports.lua_upvalueindex=function(e){return _-e},e.exports.thread_status={LUA_OK:0,LUA_YIELD:1,LUA_ERRRUN:2,LUA_ERRSYNTAX:3,LUA_ERRMEM:4,LUA_ERRGCMM:5,LUA_ERRERR:6}},745:(e,t,n)=>{const a=n(775),r="Fengari 0.1",i="Fengari 0.1.4",s="B. Giannangeli, Daurnimator",l="Fengari 0.1.4  Copyright (C) 2017-2018 "+s+"\nBased on: "+a.LUA_COPYRIGHT;e.exports.FENGARI_AUTHORS=s,e.exports.FENGARI_COPYRIGHT=l,e.exports.FENGARI_RELEASE=i,e.exports.FENGARI_VERSION=r,e.exports.FENGARI_VERSION_MAJOR="0",e.exports.FENGARI_VERSION_MINOR="1",e.exports.FENGARI_VERSION_NUM=1,e.exports.FENGARI_VERSION_RELEASE="4",e.exports.is_luastring=a.is_luastring,e.exports.luastring_eq=a.luastring_eq,e.exports.luastring_from=a.luastring_from,e.exports.luastring_indexOf=a.luastring_indexOf,e.exports.luastring_of=a.luastring_of,e.exports.to_jsstring=a.to_jsstring,e.exports.to_luastring=a.to_luastring,e.exports.to_uristring=a.to_uristring,e.exports.from_userstring=a.from_userstring},973:(e,t,n)=>{"use strict";const{LUA_MULTRET:a,LUA_OPBNOT:r,LUA_OPEQ:i,LUA_OPLE:s,LUA_OPLT:l,LUA_OPUNM:o,LUA_REGISTRYINDEX:u,LUA_RIDX_GLOBALS:c,LUA_VERSION_NUM:d,constant_types:{LUA_NUMTAGS:h,LUA_TBOOLEAN:f,LUA_TCCL:m,LUA_TFUNCTION:p,LUA_TLCF:_,LUA_TLCL:g,LUA_TLIGHTUSERDATA:b,LUA_TLNGSTR:w,LUA_TNIL:v,LUA_TNONE:A,LUA_TNUMFLT:y,LUA_TNUMINT:S,LUA_TSHRSTR:T,LUA_TTABLE:x,LUA_TTHREAD:E,LUA_TUSERDATA:L},thread_status:{LUA_OK:I},from_userstring:U,to_luastring:R}=n(775),{api_check:M}=n(568),C=n(821),B=n(983),{luaU_dump:P}=n(957),k=n(897),O=n(435),D=n(137),{luaS_bless:F,luaS_new:G,luaS_newliteral:N}=n(878),V=n(964),{LUAI_MAXSTACK:H}=n(947),Y=n(427),K=n(718),{ZIO:z}=n(161),q=O.TValue,Z=O.CClosure,j=function(e){e.top++,M(e,e.top<=e.ci.top,"stack overflow")},X=function(e,t){M(e,t<e.top-e.ci.funcOff,"not enough elements in the stack")},$=function(e){if(!e)throw TypeError("invalid argument")},J=function(e){$("number"==typeof e&&(0|e)===e)},W=function(e){return e!==O.luaO_nilobject},Q=function(e,t){let n=e.ci;if(t>0){let a=n.funcOff+t;return M(e,t<=n.top-(n.funcOff+1),"unacceptable index"),a>=e.top?O.luaO_nilobject:e.stack[a]}return t>u?(M(e,0!==t&&-t<=e.top,"invalid index"),e.stack[e.top+t]):t===u?e.l_G.l_registry:(M(e,(t=u-t)<=k.MAXUPVAL+1,"upvalue index too large"),n.func.ttislcf()?O.luaO_nilobject:t<=n.func.value.nupvalues?n.func.value.upvalue[t-1]:O.luaO_nilobject)},ee=function(e,t){let n=e.ci;if(t>0){let a=n.funcOff+t;return M(e,t<=n.top-(n.funcOff+1),"unacceptable index"),a>=e.top?null:a}if(t>u)return M(e,0!==t&&-t<=e.top,"invalid index"),e.top+t;throw Error("attempt to use pseudo-index")},te=function(e,t){let n,a=e.ci.funcOff;t>=0?(M(e,t<=e.stack_last-(a+1),"new top too large"),n=a+1+t):(M(e,-(t+1)<=e.top-(a+1),"invalid new top"),n=e.top+t+1),B.adjust_top(e,n)},ne=function(e,t){te(e,-t-1)},ae=function(e,t,n){for(;t<n;t++,n--){let a=e.stack[t],r=new q(a.type,a.value);O.setobjs2s(e,t,n),O.setobj2s(e,n,r)}},re=function(e,t,n){let a=e.top-1,r=ee(e,t),i=e.stack[r];M(e,W(i)&&t>u,"index not in the stack"),M(e,(n>=0?n:-n)<=a-r+1,"invalid 'n'");let s=n>=0?a-n:r-n-1;ae(e,r,s),ae(e,s+1,e.top-1),ae(e,r,e.top-1)},ie=function(e,t,n){let a=Q(e,t);Q(e,n).setfrom(a)},se=function(e,t,n){if($("function"==typeof t),J(n),0===n)e.stack[e.top]=new q(_,t);else{X(e,n),M(e,n<=k.MAXUPVAL,"upvalue index too large");let a=new Z(e,t,n);for(let t=0;t<n;t++)a.upvalue[t].setfrom(e.stack[e.top-n+t]);for(let t=1;t<n;t++)delete e.stack[--e.top];n>0&&--e.top,e.stack[e.top].setclCvalue(a)}j(e)},le=se,oe=function(e,t){se(e,t,0)},ue=oe,ce=function(e,t,n){let a=G(e,U(n));X(e,1),O.pushsvalue2s(e,a),M(e,e.top<=e.ci.top,"stack overflow"),Y.settable(e,t,e.stack[e.top-1],e.stack[e.top-2]),delete e.stack[--e.top],delete e.stack[--e.top]},de=function(e,t){ce(e,K.luaH_getint(e.l_G.l_registry.value,c),t)},he=function(e,t,n){let a=G(e,U(n));return O.pushsvalue2s(e,a),M(e,e.top<=e.ci.top,"stack overflow"),Y.luaV_gettable(e,t,e.stack[e.top-1],e.top-1),e.stack[e.top-1].ttnov()},fe=function(e,t,n){let a=Q(e,t);return J(n),M(e,a.ttistable(),"table expected"),O.pushobj2s(e,K.luaH_getint(a.value,n)),M(e,e.top<=e.ci.top,"stack overflow"),e.stack[e.top-1].ttnov()},me=function(e,t,n){let a=new O.TValue(x,K.luaH_new(e));e.stack[e.top]=a,j(e)},pe=function(e,t,n){switch(J(n),t.ttype()){case m:{let e=t.value;return 1<=n&&n<=e.nupvalues?{name:R("",!0),val:e.upvalue[n-1]}:null}case g:{let e=t.value,a=e.p;if(!(1<=n&&n<=a.upvalues.length))return null;let r=a.upvalues[n-1].name;return{name:r?r.getstr():R("(*no name)",!0),val:e.upvals[n-1]}}default:return null}},_e=function(e,t){let n=Q(e,t);if(!n.ttisstring()){if(!Y.cvt2str(n))return null;O.luaO_tostring(e,n)}return n.svalue()},ge=_e,be=function(e,t){return Y.tointeger(Q(e,t))},we=function(e,t){return Y.tonumber(Q(e,t))},ve=new WeakMap,Ae=function(e,t){B.luaD_callnoyield(e,t.funcOff,t.nresults)},ye=function(e,t){let n=Q(e,t);return W(n)?n.ttnov():A},Se=R("?"),Te=function(e,t,n){M(e,n===a||e.ci.top-e.top>=n-t,"results from function overflow current stack size")},xe=function(e,t,n,r,i){M(e,null===i||!(e.ci.callstatus&D.CIST_LUA),"cannot use continuations inside hooks"),X(e,t+1),M(e,e.status===I,"cannot do calls on non-normal thread"),Te(e,t,n);let s=e.top-(t+1);null!==i&&0===e.nny?(e.ci.c_k=i,e.ci.c_ctx=r,B.luaD_call(e,s,n)):B.luaD_callnoyield(e,s,n),n===a&&e.ci.top<e.top&&(e.ci.top=e.top)},Ee=function(e,t,n,r,i,s){let l,o;M(e,null===s||!(e.ci.callstatus&D.CIST_LUA),"cannot use continuations inside hooks"),X(e,t+1),M(e,e.status===I,"cannot do calls on non-normal thread"),Te(e,t,n),o=0===r?0:ee(e,r);let u=e.top-(t+1);if(null===s||e.nny>0){let t={funcOff:u,nresults:n};l=B.luaD_pcall(e,Ae,t,u,o)}else{let t=e.ci;t.c_k=s,t.c_ctx=i,t.extra=u,t.c_old_errfunc=e.errfunc,e.errfunc=o,t.callstatus&=~D.CIST_OAH|e.allowhook,t.callstatus|=D.CIST_YPCALL,B.luaD_call(e,u,n),t.callstatus&=~D.CIST_YPCALL,e.errfunc=t.c_old_errfunc,l=I}return n===a&&e.ci.top<e.top&&(e.ci.top=e.top),l},Le=function(e,t,n){let a=Q(e,t);M(e,a.ttisLclosure(),"Lua function expected");let r=a.value;return J(n),M(e,1<=n&&n<=r.p.upvalues.length,"invalid upvalue index"),{f:r,i:n-1}};e.exports.api_incr_top=j,e.exports.api_checknelems=X,e.exports.lua_absindex=function(e,t){return t>0||t<=u?t:e.top-e.ci.funcOff+t},e.exports.lua_arith=function(e,t){t!==o&&t!==r?X(e,2):(X(e,1),O.pushobj2s(e,e.stack[e.top-1]),M(e,e.top<=e.ci.top,"stack overflow")),O.luaO_arith(e,t,e.stack[e.top-2],e.stack[e.top-1],e.stack[e.top-2]),delete e.stack[--e.top]},e.exports.lua_atpanic=function(e,t){let n=e.l_G.panic;return e.l_G.panic=t,n},e.exports.lua_atnativeerror=function(e,t){let n=e.l_G.atnativeerror;return e.l_G.atnativeerror=t,n},e.exports.lua_call=function(e,t,n){xe(e,t,n,0,null)},e.exports.lua_callk=xe,e.exports.lua_checkstack=function(e,t){let n,a=e.ci;if(M(e,t>=0,"negative 'n'"),e.stack_last-e.top>t)n=!0;else{e.top+D.EXTRA_STACK>H-t?n=!1:(B.luaD_growstack(e,t),n=!0)}return n&&a.top<e.top+t&&(a.top=e.top+t),n},e.exports.lua_compare=function(e,t,n,a){let r=Q(e,t),o=Q(e,n),u=0;if(W(r)&&W(o))switch(a){case i:u=Y.luaV_equalobj(e,r,o);break;case l:u=Y.luaV_lessthan(e,r,o);break;case s:u=Y.luaV_lessequal(e,r,o);break;default:M(e,!1,"invalid option")}return u},e.exports.lua_concat=function(e,t){X(e,t),t>=2?Y.luaV_concat(e,t):0===t&&(O.pushsvalue2s(e,F(e,R("",!0))),M(e,e.top<=e.ci.top,"stack overflow"))},e.exports.lua_copy=ie,e.exports.lua_createtable=me,e.exports.lua_dump=function(e,t,n,a){X(e,1);let r=e.stack[e.top-1];return r.ttisLclosure()?P(e,r.value.p,t,n,a):1},e.exports.lua_error=function(e){X(e,1),C.luaG_errormsg(e)},e.exports.lua_gc=function(){},e.exports.lua_getallocf=function(){return console.warn("lua_getallocf is not available"),0},e.exports.lua_getextraspace=function(){return console.warn("lua_getextraspace is not available"),0},e.exports.lua_getfield=function(e,t,n){return he(e,Q(e,t),n)},e.exports.lua_getglobal=function(e,t){return he(e,K.luaH_getint(e.l_G.l_registry.value,c),t)},e.exports.lua_geti=function(e,t,n){let a=Q(e,t);return J(n),e.stack[e.top]=new q(S,n),j(e),Y.luaV_gettable(e,a,e.stack[e.top-1],e.top-1),e.stack[e.top-1].ttnov()},e.exports.lua_getmetatable=function(e,t){let n,a=Q(e,t),r=!1;switch(a.ttnov()){case x:case L:n=a.value.metatable;break;default:n=e.l_G.mt[a.ttnov()]}return null!=n&&(e.stack[e.top]=new q(x,n),j(e),r=!0),r},e.exports.lua_gettable=function(e,t){let n=Q(e,t);return Y.luaV_gettable(e,n,e.stack[e.top-1],e.top-1),e.stack[e.top-1].ttnov()},e.exports.lua_gettop=function(e){return e.top-(e.ci.funcOff+1)},e.exports.lua_getupvalue=function(e,t,n){let a=pe(0,Q(e,t),n);if(a){let t=a.name,n=a.val;return O.pushobj2s(e,n),M(e,e.top<=e.ci.top,"stack overflow"),t}return null},e.exports.lua_getuservalue=function(e,t){let n=Q(e,t);M(e,n.ttisfulluserdata(),"full userdata expected");let a=n.value.uservalue;return e.stack[e.top]=new q(a.type,a.value),j(e),e.stack[e.top-1].ttnov()},e.exports.lua_insert=function(e,t){re(e,t,1)},e.exports.lua_isboolean=function(e,t){return ye(e,t)===f},e.exports.lua_iscfunction=function(e,t){let n=Q(e,t);return n.ttislcf(n)||n.ttisCclosure()},e.exports.lua_isfunction=function(e,t){return ye(e,t)===p},e.exports.lua_isinteger=function(e,t){return Q(e,t).ttisinteger()},e.exports.lua_islightuserdata=function(e,t){return ye(e,t)===b},e.exports.lua_isnil=function(e,t){return ye(e,t)===v},e.exports.lua_isnone=function(e,t){return ye(e,t)===A},e.exports.lua_isnoneornil=function(e,t){return ye(e,t)<=0},e.exports.lua_isnumber=function(e,t){return!1!==Y.tonumber(Q(e,t))},e.exports.lua_isproxy=function(e,t){let n=ve.get(e);return!!n&&(null===t||t.l_G===n)},e.exports.lua_isstring=function(e,t){let n=Q(e,t);return n.ttisstring()||Y.cvt2str(n)},e.exports.lua_istable=function(e,t){return Q(e,t).ttistable()},e.exports.lua_isthread=function(e,t){return ye(e,t)===E},e.exports.lua_isuserdata=function(e,t){let n=Q(e,t);return n.ttisfulluserdata(n)||n.ttislightuserdata()},e.exports.lua_len=function(e,t){let n=Q(e,t),a=new q;Y.luaV_objlen(e,a,n),e.stack[e.top]=a,j(e)},e.exports.lua_load=function(e,t,n,a,r){a=a?U(a):Se,null!==r&&(r=U(r));let i=new z(e,t,n),s=B.luaD_protectedparser(e,i,a,r);if(s===I){let t=e.stack[e.top-1].value;if(t.nupvalues>=1){let n=K.luaH_getint(e.l_G.l_registry.value,c);t.upvals[0].setfrom(n)}}return s},e.exports.lua_newtable=function(e){me(e)},e.exports.lua_newuserdata=function(e,t){let n=function(e,t){return new O.Udata(e,t)}(e,t);return e.stack[e.top]=new O.TValue(L,n),j(e),n.data},e.exports.lua_next=function(e,t){let n=Q(e,t);return M(e,n.ttistable(),"table expected"),e.stack[e.top]=new q,K.luaH_next(e,n.value,e.top-1)?(j(e),1):(delete e.stack[e.top],delete e.stack[--e.top],0)},e.exports.lua_pcall=function(e,t,n,a){return Ee(e,t,n,a,0,null)},e.exports.lua_pcallk=Ee,e.exports.lua_pop=ne,e.exports.lua_pushboolean=function(e,t){e.stack[e.top]=new q(f,!!t),j(e)},e.exports.lua_pushcclosure=se,e.exports.lua_pushcfunction=oe,e.exports.lua_pushfstring=function(e,t,...n){return t=U(t),O.luaO_pushvfstring(e,t,n)},e.exports.lua_pushglobaltable=function(e){fe(e,u,c)},e.exports.lua_pushinteger=function(e,t){J(t),e.stack[e.top]=new q(S,t),j(e)},e.exports.lua_pushjsclosure=le,e.exports.lua_pushjsfunction=ue,e.exports.lua_pushlightuserdata=function(e,t){e.stack[e.top]=new q(b,t),j(e)},e.exports.lua_pushliteral=function(e,t){if(null==t)e.stack[e.top]=new q(v,null),e.top++;else{$("string"==typeof t);let n=N(e,t);O.pushsvalue2s(e,n),t=n.getstr()}return M(e,e.top<=e.ci.top,"stack overflow"),t},e.exports.lua_pushlstring=function(e,t,n){let a;return J(n),0===n?(t=R("",!0),a=F(e,t)):(t=U(t),M(e,t.length>=n,"invalid length to lua_pushlstring"),a=G(e,t.subarray(0,n))),O.pushsvalue2s(e,a),M(e,e.top<=e.ci.top,"stack overflow"),a.value},e.exports.lua_pushnil=function(e){e.stack[e.top]=new q(v,null),j(e)},e.exports.lua_pushnumber=function(e,t){$("number"==typeof t),e.stack[e.top]=new q(y,t),j(e)},e.exports.lua_pushstring=function(e,t){if(null==t)e.stack[e.top]=new q(v,null),e.top++;else{let n=G(e,U(t));O.pushsvalue2s(e,n),t=n.getstr()}return M(e,e.top<=e.ci.top,"stack overflow"),t},e.exports.lua_pushthread=function(e){return e.stack[e.top]=new q(E,e),j(e),e.l_G.mainthread===e},e.exports.lua_pushvalue=function(e,t){O.pushobj2s(e,Q(e,t)),M(e,e.top<=e.ci.top,"stack overflow")},e.exports.lua_pushvfstring=function(e,t,n){return t=U(t),O.luaO_pushvfstring(e,t,n)},e.exports.lua_rawequal=function(e,t,n){let a=Q(e,t),r=Q(e,n);return W(a)&&W(r)?Y.luaV_equalobj(null,a,r):0},e.exports.lua_rawget=function(e,t){let n=Q(e,t);return M(e,n.ttistable(n),"table expected"),O.setobj2s(e,e.top-1,K.luaH_get(e,n.value,e.stack[e.top-1])),e.stack[e.top-1].ttnov()},e.exports.lua_rawgeti=fe,e.exports.lua_rawgetp=function(e,t,n){let a=Q(e,t);M(e,a.ttistable(),"table expected");let r=new q(b,n);return O.pushobj2s(e,K.luaH_get(e,a.value,r)),M(e,e.top<=e.ci.top,"stack overflow"),e.stack[e.top-1].ttnov()},e.exports.lua_rawlen=function(e,t){let n=Q(e,t);switch(n.ttype()){case T:case w:return n.vslen();case L:return n.value.len;case x:return K.luaH_getn(n.value);default:return 0}},e.exports.lua_rawset=function(e,t){X(e,2);let n=Q(e,t);M(e,n.ttistable(),"table expected");let a=e.stack[e.top-2],r=e.stack[e.top-1];K.luaH_setfrom(e,n.value,a,r),K.invalidateTMcache(n.value),delete e.stack[--e.top],delete e.stack[--e.top]},e.exports.lua_rawseti=function(e,t,n){J(n),X(e,1);let a=Q(e,t);M(e,a.ttistable(),"table expected"),K.luaH_setint(a.value,n,e.stack[e.top-1]),delete e.stack[--e.top]},e.exports.lua_rawsetp=function(e,t,n){X(e,1);let a=Q(e,t);M(e,a.ttistable(),"table expected");let r=new q(b,n),i=e.stack[e.top-1];K.luaH_setfrom(e,a.value,r,i),delete e.stack[--e.top]},e.exports.lua_register=function(e,t,n){oe(e,n),de(e,t)},e.exports.lua_remove=function(e,t){re(e,t,-1),ne(e,1)},e.exports.lua_replace=function(e,t){ie(e,-1,t),ne(e,1)},e.exports.lua_rotate=re,e.exports.lua_setallocf=function(){return console.warn("lua_setallocf is not available"),0},e.exports.lua_setfield=function(e,t,n){ce(e,Q(e,t),n)},e.exports.lua_setglobal=de,e.exports.lua_seti=function(e,t,n){J(n),X(e,1);let a=Q(e,t);e.stack[e.top]=new q(S,n),j(e),Y.settable(e,a,e.stack[e.top-1],e.stack[e.top-2]),delete e.stack[--e.top],delete e.stack[--e.top]},e.exports.lua_setmetatable=function(e,t){let n;X(e,1);let a=Q(e,t);switch(e.stack[e.top-1].ttisnil()?n=null:(M(e,e.stack[e.top-1].ttistable(),"table expected"),n=e.stack[e.top-1].value),a.ttnov()){case L:case x:a.value.metatable=n;break;default:e.l_G.mt[a.ttnov()]=n}return delete e.stack[--e.top],!0},e.exports.lua_settable=function(e,t){X(e,2);let n=Q(e,t);Y.settable(e,n,e.stack[e.top-2],e.stack[e.top-1]),delete e.stack[--e.top],delete e.stack[--e.top]},e.exports.lua_settop=te,e.exports.lua_setupvalue=function(e,t,n){let a=Q(e,t);X(e,1);let r=pe(0,a,n);if(r){let t=r.name;return r.val.setfrom(e.stack[e.top-1]),delete e.stack[--e.top],t}return null},e.exports.lua_setuservalue=function(e,t){X(e,1);let n=Q(e,t);M(e,n.ttisfulluserdata(),"full userdata expected"),n.value.uservalue.setfrom(e.stack[e.top-1]),delete e.stack[--e.top]},e.exports.lua_status=function(e){return e.status},e.exports.lua_stringtonumber=function(e,t){let n=new q,a=O.luaO_str2num(t,n);return 0!==a&&(e.stack[e.top]=n,j(e)),a},e.exports.lua_toboolean=function(e,t){return!Q(e,t).l_isfalse()},e.exports.lua_tocfunction=function(e,t){let n=Q(e,t);return n.ttislcf()||n.ttisCclosure()?n.value:null},e.exports.lua_todataview=function(e,t){let n=_e(e,t);return new DataView(n.buffer,n.byteOffset,n.byteLength)},e.exports.lua_tointeger=function(e,t){let n=be(e,t);return!1===n?0:n},e.exports.lua_tointegerx=be,e.exports.lua_tojsstring=function(e,t){let n=Q(e,t);if(!n.ttisstring()){if(!Y.cvt2str(n))return null;O.luaO_tostring(e,n)}return n.jsstring()},e.exports.lua_tolstring=_e,e.exports.lua_tonumber=function(e,t){let n=we(e,t);return!1===n?0:n},e.exports.lua_tonumberx=we,e.exports.lua_topointer=function(e,t){let n=Q(e,t);switch(n.ttype()){case x:case g:case m:case _:case E:case L:case b:return n.value;default:return null}},e.exports.lua_toproxy=function(e,t){let n=Q(e,t);return function(e,t,n){let a=function(a){M(a,a instanceof D.lua_State&&e===a.l_G,"must be from same global state"),a.stack[a.top]=new q(t,n),j(a)};return ve.set(a,e),a}(e.l_G,n.type,n.value)},e.exports.lua_tostring=ge,e.exports.lua_tothread=function(e,t){let n=Q(e,t);return n.ttisthread()?n.value:null},e.exports.lua_touserdata=function(e,t){let n=Q(e,t);switch(n.ttnov()){case L:return n.value.data;case b:return n.value;default:return null}},e.exports.lua_type=ye,e.exports.lua_typename=function(e,t){return M(e,A<=t&&t<h,"invalid tag"),V.ttypename(t)},e.exports.lua_upvalueid=function(e,t,n){let a=Q(e,t);switch(a.ttype()){case g:{let a=Le(e,t,n);return a.f.upvals[a.i]}case m:{let t=a.value;return M(e,(0|n)===n&&n>0&&n<=t.nupvalues,"invalid upvalue index"),t.upvalue[n-1]}default:return M(e,!1,"closure expected"),null}},e.exports.lua_upvaluejoin=function(e,t,n,a,r){let i=Le(e,t,n),s=Le(e,a,r),l=s.f.upvals[s.i];i.f.upvals[i.i]=l},e.exports.lua_version=function(e){return null===e?d:e.l_G.version},e.exports.lua_xmove=function(e,t,n){if(e!==t){X(e,n),M(e,e.l_G===t.l_G,"moving among independent states"),M(e,t.ci.top-t.top>=n,"stack overflow"),e.top-=n;for(let a=0;a<n;a++)t.stack[t.top]=new O.TValue,O.setobj2s(t,t.top,e.stack[e.top+a]),delete e.stack[e.top+a],t.top++}}},670:(e,t,n)=>{"use strict";const{LUAL_BUFFERSIZE:a}=n(947),{LUA_ERRERR:r,LUA_MULTRET:i,LUA_REGISTRYINDEX:s,LUA_SIGNATURE:l,LUA_TBOOLEAN:o,LUA_TLIGHTUSERDATA:u,LUA_TNIL:c,LUA_TNONE:d,LUA_TNUMBER:h,LUA_TSTRING:f,LUA_TTABLE:m,LUA_VERSION_NUM:p,lua_Debug:_,lua_absindex:g,lua_atpanic:b,lua_call:w,lua_checkstack:v,lua_concat:A,lua_copy:y,lua_createtable:S,lua_error:T,lua_getfield:x,lua_getinfo:E,lua_getmetatable:L,lua_getstack:I,lua_gettop:U,lua_insert:R,lua_isinteger:M,lua_isnil:C,lua_isnumber:B,lua_isstring:P,lua_istable:k,lua_len:O,lua_load:D,lua_newstate:F,lua_newtable:G,lua_next:N,lua_pcall:V,lua_pop:H,lua_pushboolean:Y,lua_pushcclosure:K,lua_pushcfunction:z,lua_pushfstring:q,lua_pushinteger:Z,lua_pushliteral:j,lua_pushlstring:X,lua_pushnil:$,lua_pushstring:J,lua_pushvalue:W,lua_pushvfstring:Q,lua_rawequal:ee,lua_rawget:te,lua_rawgeti:ne,lua_rawlen:ae,lua_rawseti:re,lua_remove:ie,lua_setfield:se,lua_setglobal:le,lua_setmetatable:oe,lua_settop:ue,lua_toboolean:ce,lua_tointeger:de,lua_tointegerx:he,lua_tojsstring:fe,lua_tolstring:me,lua_tonumber:pe,lua_tonumberx:_e,lua_topointer:ge,lua_tostring:be,lua_touserdata:we,lua_type:ve,lua_typename:Ae,lua_version:ye}=n(870),{from_userstring:Se,luastring_eq:Te,to_luastring:xe,to_uristring:Ee}=n(745),Le=r+1,Ie=xe("_LOADED"),Ue=xe("_PRELOAD"),Re=xe("FILE*"),Me=xe("__name"),Ce=xe("__tostring"),Be=new Uint8Array(0);class Pe{constructor(){this.L=null,this.b=Be,this.n=0}}const ke=function(e,t,n){if(0===n||!k(e,-1))return 0;for($(e);N(e,-2);){if(ve(e,-2)===f){if(ee(e,t,-1))return H(e,1),1;if(ke(e,t,n-1))return ie(e,-2),j(e,"."),R(e,-2),A(e,3),1}H(e,1)}return 0},Oe=function(e,t){let n=U(e);if(E(e,xe("f"),t),x(e,s,Ie),ke(e,n+1,2)){let t=be(e,-1);return 95===t[0]&&71===t[1]&&46===t[2]&&(J(e,t.subarray(3)),ie(e,-2)),y(e,-1,n+1),H(e,2),1}return ue(e,n),0},De=function(e,t){Oe(e,t)?(q(e,xe("function '%s'"),be(e,-1)),ie(e,-2)):0!==t.namewhat.length?q(e,xe("%s '%s'"),t.namewhat,t.name):t.what&&109===t.what[0]?j(e,"main chunk"):t.what&&76===t.what[0]?q(e,xe("function <%s:%d>"),t.short_src,t.linedefined):j(e,"?")},Fe=function(e){let t="PANIC: unprotected error in call to Lua API ("+fe(e,-1)+")";throw new Error(t)},Ge=function(e,t,n){let a=new _;return I(e,0,a)?(E(e,xe("n"),a),Te(a.namewhat,xe("method"))&&0===--t?He(e,xe("calling '%s' on bad self (%s)"),a.name,n):(null===a.name&&(a.name=Oe(e,a)?be(e,-1):xe("?")),He(e,xe("bad argument #%d to '%s' (%s)"),t,a.name,n))):He(e,xe("bad argument #%d (%s)"),t,n)},Ne=function(e,t,n){let a;a=dt(e,t,Me)===f?be(e,-1):ve(e,t)===u?xe("light userdata",!0):Ze(e,t);let r=q(e,xe("%s expected, got %s"),n,a);return Ge(e,t,r)},Ve=function(e,t){let n=new _;I(e,t,n)&&(E(e,xe("Sl",!0),n),n.currentline>0)?q(e,xe("%s:%d: "),n.short_src,n.currentline):J(e,xe(""))},He=function(e,t,...n){return Ve(e,1),Q(e,t,n),A(e,2),T(e)},Ye=function(e,t,n,a){if(t)return Y(e,1),1;{let t,r;return $(e),a?(t=a.message,r=-a.errno):(t="Success",r=0),n?q(e,xe("%s: %s"),n,xe(t)):J(e,xe(t)),Z(e,r),3}},Ke=function(e,t){return x(e,s,t)},ze=function(e,t,n){let a=we(e,t);return null!==a&&L(e,t)?(Ke(e,n),ee(e,-1,-2)||(a=null),H(e,2),a):null},qe=function(e,t,n){Ne(e,t,Ae(e,n))},Ze=function(e,t){return Ae(e,ve(e,t))},je=function(e,t){let n=me(e,t);return null==n&&qe(e,t,f),n},Xe=je,$e=function(e,t,n){return ve(e,t)<=0?null===n?null:Se(n):je(e,t)},Je=$e,We=function(e,t){let n=_e(e,t);return!1===n&&qe(e,t,h),n},Qe=function(e,t){let n=he(e,t);return!1===n&&function(e,t){B(e,t)?Ge(e,t,xe("number has no integer representation",!0)):qe(e,t,h)}(e,t),n},et=function(e,t){let n=e.n+t;if(e.b.length<n){let t=Math.max(2*e.b.length,n),a=new Uint8Array(t);a.set(e.b),e.b=a}return e.b.subarray(e.n,n)},tt=function(e,t){t.L=e,t.b=Be},nt=function(e,t,n){if(n>0){t=Se(t),et(e,n).set(t.subarray(0,n)),it(e,n)}},at=function(e,t){t=Se(t),nt(e,t,t.length)},rt=function(e){X(e.L,e.b,e.n),e.n=0,e.b=Be},it=function(e,t){e.n+=t},st=function(e,t,n,a){return ve(e,n)<=0?a:t(e,n)},lt=function(e,t){let n=t.string;return t.string=null,n},ot=function(e,t,n,a,r){return D(e,lt,{string:t},a,r)},ut=function(e,t,n,a){return ot(e,t,0,a,null)},ct=function(e,t){return ut(e,t,t.length,t)},dt=function(e,t,n){if(L(e,t)){J(e,n);let t=te(e,-2);return t===c?H(e,2):ie(e,-2),t}return c},ht=function(e,t,n){return t=g(e,t),dt(e,t,n)!==c&&(W(e,t),w(e,1,1),!0)},ft=xe("%I"),mt=xe("%f"),pt=function(e,t,n){var a=n>>>0,r=t.length,i=e.length+1-r;e:for(;a<i;a++){for(let n=0;n<r;n++)if(e[a+n]!==t[n])continue e;return a}return-1},_t=function(e,t,n){return x(e,t,n)===m||(H(e,1),t=g(e,t),G(e),W(e,-1),se(e,t,n),!1)},gt=function(e,t,n){bt(e,n,xe("too many upvalues",!0));for(let a in t){for(let t=0;t<n;t++)W(e,-n);K(e,t[a],n),se(e,-(n+2),xe(a))}H(e,n)},bt=function(e,t,n){v(e,t)||(n?He(e,xe("stack overflow (%s)"),n):He(e,xe("stack overflow",!0)))},wt=function(e,t,n,a){let r=a.message,i=be(e,n).subarray(1);return q(e,xe("cannot %s %s: %s"),xe(t),i,xe(r)),ie(e,n),Le};let vt;const At=[239,187,191],yt=function(e){let t=function(e){let t;e.n=0;let n=0;do{if(t=vt(e),null===t||t!==At[n])return t;n++,e.buff[e.n++]=t}while(n<At.length);return e.n=0,vt(e)}(e);if(35===t){do{t=vt(e)}while(t&&10!==t);return{skipped:!0,c:vt(e)}}return{skipped:!1,c:t}};let St;{class e{constructor(){this.n=NaN,this.f=null,this.buff=new Uint8Array(1024),this.pos=0,this.err=void 0}}const t=function(e,t){let n=t;if(null!==n.f&&n.n>0){let e=n.n;return n.n=0,n.f=n.f.subarray(n.pos),n.buff.subarray(0,e)}let a=n.f;return n.f=null,a};vt=function(e){return e.pos<e.f.length?e.f[e.pos++]:null},St=function(n,a,r){let i=new e,s=U(n)+1;if(null===a)throw new Error("Can't read stdin in the browser");{q(n,xe("@%s"),a);let e=Ee(a),t=new XMLHttpRequest;if(t.open("GET",e,!1),"undefined"==typeof window&&(t.responseType="arraybuffer"),t.send(),!(t.status>=200&&t.status<=299))return i.err=t.status,wt(n,"open",s,{message:`${t.status}: ${t.statusText}`});"string"==typeof t.response?i.f=xe(t.response):i.f=new Uint8Array(t.response)}let o=yt(i);o.c===l[0]&&a||o.skipped&&(i.buff[i.n++]=10),null!==o.c&&(i.buff[i.n++]=o.c);let u=D(n,t,i,be(n,-1),r),c=i.err;return c?(ue(n,s),wt(n,"read",s,c)):(ie(n,s),u)}}const Tt=function(e,t){return St(e,t,null)},xt=function(e,t,n){let a=ye(e);72!=n&&He(e,xe("core and library have incompatible numeric types")),a!=ye(null)?He(e,xe("multiple Lua VMs detected")):a!==t&&He(e,xe("version mismatch: app. needs %f, Lua core provides %f"),t,a)};e.exports.Ye=Qe,e.exports.qZ=We,e.exports.zH=Xe,e.exports.Tl=ct,e.exports.AH=function(){let e=F();return e&&b(e,Fe),e},e.exports.b6=function(e,t){let n;return C(e,-1)?(H(e,1),-1):(t=g(e,t),ne(e,t,0),n=de(e,-1),H(e,1),0!==n?(ne(e,t,n),re(e,t,0)):n=ae(e,t)+1,re(e,t,n),n)},e.exports.bm=function(e,t){if(ht(e,t,Ce))P(e,-1)||He(e,xe("'__tostring' must return a string"));else{switch(ve(e,t)){case h:M(e,t)?q(e,ft,de(e,t)):q(e,mt,pe(e,t));break;case f:W(e,t);break;case o:j(e,ce(e,t)?"true":"false");break;case c:j(e,"nil");break;default:{let n=dt(e,t,Me),a=n===f?be(e,-1):Ze(e,t);q(e,xe("%s: %p"),a,ge(e,t)),n!==c&&ie(e,-2);break}}}return me(e,-1)},e.exports.i$=function(e,t,n){n>=0&&(t=g(e,t),ne(e,t,0),re(e,t,n),Z(e,n),re(e,t,0))}},807:(e,t,n)=>{"use strict";const{LUA_MULTRET:a,LUA_OPADD:r,LUA_OPBAND:i,LUA_OPBNOT:s,LUA_OPBOR:l,LUA_OPBXOR:o,LUA_OPDIV:u,LUA_OPIDIV:c,LUA_OPMOD:d,LUA_OPSHL:h,LUA_OPSHR:f,LUA_OPUNM:m,constant_types:{LUA_TBOOLEAN:p,LUA_TLIGHTUSERDATA:_,LUA_TLNGSTR:g,LUA_TNIL:b,LUA_TNUMFLT:w,LUA_TNUMINT:v,LUA_TTABLE:A},to_luastring:y}=n(775),{lua_assert:S}=n(568),T=n(278),x=n(435),E=n(159),L=n(391),I=n(718),U=n(427),R=E.OpCodesI,M=x.TValue,C=-1,B={OPR_ADD:0,OPR_SUB:1,OPR_MUL:2,OPR_MOD:3,OPR_POW:4,OPR_DIV:5,OPR_IDIV:6,OPR_BAND:7,OPR_BOR:8,OPR_BXOR:9,OPR_SHL:10,OPR_SHR:11,OPR_CONCAT:12,OPR_EQ:13,OPR_LT:14,OPR_LE:15,OPR_NE:16,OPR_GT:17,OPR_GE:18,OPR_AND:19,OPR_OR:20,OPR_NOBINOPR:21},P={OPR_MINUS:0,OPR_BNOT:1,OPR_NOT:2,OPR_LEN:3,OPR_NOUNOPR:4},k=function(e){return e.t!==e.f},O=function(e,t){let n=L.expkind;if(k(e))return!1;switch(e.k){case n.VKINT:return!t||new M(v,e.u.ival);case n.VKFLT:return!t||new M(w,e.u.nval);default:return!1}},D=function(e,t,n){let a,r=t+n-1;if(e.pc>e.lasttarget&&(a=e.f.code[e.pc-1],a.opcode===R.OP_LOADNIL)){let e=a.A,n=e+a.B;if(e<=t&&t<=n+1||t<=e&&e<=r+1)return e<t&&(t=e),n>r&&(r=n),E.SETARG_A(a,t),void E.SETARG_B(a,r-t)}Q(e,R.OP_LOADNIL,t,n-1,0)},F=function(e,t){return e.f.code[t.u.info]},G=function(e,t){let n=e.f.code[t].sBx;return n===C?C:t+1+n},N=function(e,t,n){let a=e.f.code[t],r=n-(t+1);S(n!==C),Math.abs(r)>E.MAXARG_sBx&&T.luaX_syntaxerror(e.ls,y("control structure too long",!0)),E.SETARG_sBx(a,r)},V=function(e,t,n){if(n===C)return t;if(t===C)t=n;else{let a=t,r=G(e,a);for(;r!==C;)a=r,r=G(e,a);N(e,a,n)}return t},H=function(e){let t=e.jpc;e.jpc=C;let n=te(e,R.OP_JMP,0,C);return n=V(e,n,t),n},Y=function(e,t,n,a,r){return Q(e,t,n,a,r),H(e)},K=function(e){return e.lasttarget=e.pc,e.pc},z=function(e,t){return t>=1&&E.testTMode(e.f.code[t-1].opcode)?t-1:t},q=function(e,t){return e.f.code[z(e,t)]},Z=function(e,t,n){let a=z(e,t),r=e.f.code[a];return r.opcode===R.OP_TESTSET&&(n!==E.NO_REG&&n!==r.B?E.SETARG_A(r,n):e.f.code[a]=E.CREATE_ABC(R.OP_TEST,r.B,0,r.C),!0)},j=function(e,t){for(;t!==C;t=G(e,t))Z(e,t,E.NO_REG)},X=function(e,t,n,a,r){for(;t!==C;){let i=G(e,t);Z(e,t,a)?N(e,t,n):N(e,t,r),t=i}},$=function(e,t){K(e),e.jpc=V(e,e.jpc,t)},J=function(e,t,n){n===e.pc?$(e,t):(S(n<e.pc),X(e,t,n,E.NO_REG,n))},W=function(e,t){let n=e.f;return function(e){X(e,e.jpc,e.pc,E.NO_REG,e.pc),e.jpc=C}(e),n.code[e.pc]=t,n.lineinfo[e.pc]=e.ls.lastline,e.pc++},Q=function(e,t,n,a,r){return S(E.getOpMode(t)===E.iABC),S(E.getBMode(t)!==E.OpArgN||0===a),S(E.getCMode(t)!==E.OpArgN||0===r),S(n<=E.MAXARG_A&&a<=E.MAXARG_B&&r<=E.MAXARG_C),W(e,E.CREATE_ABC(t,n,a,r))},ee=function(e,t,n,a){return S(E.getOpMode(t)===E.iABx||E.getOpMode(t)===E.iAsBx),S(E.getCMode(t)===E.OpArgN),S(n<=E.MAXARG_A&&a<=E.MAXARG_Bx),W(e,E.CREATE_ABx(t,n,a))},te=function(e,t,n,a){return ee(e,t,n,a+E.MAXARG_sBx)},ne=function(e,t){return S(t<=E.MAXARG_Ax),W(e,E.CREATE_Ax(R.OP_EXTRAARG,t))},ae=function(e,t,n){if(n<=E.MAXARG_Bx)return ee(e,R.OP_LOADK,t,n);{let a=ee(e,R.OP_LOADKX,t,0);return ne(e,n),a}},re=function(e,t){let n=e.freereg+t;n>e.f.maxstacksize&&(n>=255&&T.luaX_syntaxerror(e.ls,y("function or expression needs too many registers",!0)),e.f.maxstacksize=n)},ie=function(e,t){re(e,t),e.freereg+=t},se=function(e,t){!E.ISK(t)&&t>=e.nactvar&&(e.freereg--,S(t===e.freereg))},le=function(e,t){t.k===L.expkind.VNONRELOC&&se(e,t.u.info)},oe=function(e,t,n){let a=t.k===L.expkind.VNONRELOC?t.u.info:-1,r=n.k===L.expkind.VNONRELOC?n.u.info:-1;a>r?(se(e,a),se(e,r)):(se(e,r),se(e,a))},ue=function(e,t,n){let a=e.f,r=I.luaH_get(e.L,e.ls.h,t);if(r.ttisinteger()){let t=r.value;if(t<e.nk&&a.k[t].ttype()===n.ttype()&&a.k[t].value===n.value)return t}let i=e.nk;return I.luaH_setfrom(e.L,e.ls.h,t,new x.TValue(v,i)),a.k[i]=n,e.nk++,i},ce=function(e,t){let n=new M(_,t),a=new M(v,t);return ue(e,n,a)},de=function(e,t){let n=new M(w,t);return ue(e,n,n)},he=function(e,t){let n=new M(p,t);return ue(e,n,n)},fe=function(e,t,n){let r=L.expkind;if(t.k===r.VCALL)E.SETARG_C(F(e,t),n+1);else if(t.k===r.VVARARG){let a=F(e,t);E.SETARG_B(a,n+1),E.SETARG_A(a,e.freereg),ie(e,1)}else S(n===a)},me=function(e,t){let n=L.expkind;t.k===n.VCALL?(S(2===F(e,t).C),t.k=n.VNONRELOC,t.u.info=F(e,t).A):t.k===n.VVARARG&&(E.SETARG_B(F(e,t),2),t.k=n.VRELOCABLE)},pe=function(e,t){let n=L.expkind;switch(t.k){case n.VLOCAL:t.k=n.VNONRELOC;break;case n.VUPVAL:t.u.info=Q(e,R.OP_GETUPVAL,0,t.u.info,0),t.k=n.VRELOCABLE;break;case n.VINDEXED:{let a;se(e,t.u.ind.idx),t.u.ind.vt===n.VLOCAL?(se(e,t.u.ind.t),a=R.OP_GETTABLE):(S(t.u.ind.vt===n.VUPVAL),a=R.OP_GETTABUP),t.u.info=Q(e,a,0,t.u.ind.t,t.u.ind.idx),t.k=n.VRELOCABLE;break}case n.VVARARG:case n.VCALL:me(e,t)}},_e=function(e,t,n,a){return K(e),Q(e,R.OP_LOADBOOL,t,n,a)},ge=function(e,t,n){let a=L.expkind;switch(pe(e,t),t.k){case a.VNIL:D(e,n,1);break;case a.VFALSE:case a.VTRUE:Q(e,R.OP_LOADBOOL,n,t.k===a.VTRUE,0);break;case a.VK:ae(e,n,t.u.info);break;case a.VKFLT:ae(e,n,de(e,t.u.nval));break;case a.VKINT:ae(e,n,ce(e,t.u.ival));break;case a.VRELOCABLE:{let a=F(e,t);E.SETARG_A(a,n);break}case a.VNONRELOC:n!==t.u.info&&Q(e,R.OP_MOVE,n,t.u.info,0);break;default:return void S(t.k===a.VJMP)}t.u.info=n,t.k=a.VNONRELOC},be=function(e,t){t.k!==L.expkind.VNONRELOC&&(ie(e,1),ge(e,t,e.freereg-1))},we=function(e,t){for(;t!==C;t=G(e,t)){if(q(e,t).opcode!==R.OP_TESTSET)return!0}return!1},ve=function(e,t,n){let a=L.expkind;if(ge(e,t,n),t.k===a.VJMP&&(t.t=V(e,t.t,t.u.info)),k(t)){let r,i=C,s=C;if(we(e,t.t)||we(e,t.f)){let r=t.k===a.VJMP?C:H(e);i=_e(e,n,0,1),s=_e(e,n,1,0),$(e,r)}r=K(e),X(e,t.f,r,n,i),X(e,t.t,r,n,s)}t.f=t.t=C,t.u.info=n,t.k=a.VNONRELOC},Ae=function(e,t){pe(e,t),le(e,t),ie(e,1),ve(e,t,e.freereg-1)},ye=function(e,t){if(pe(e,t),t.k===L.expkind.VNONRELOC){if(!k(t))return t.u.info;if(t.u.info>=e.nactvar)return ve(e,t,t.u.info),t.u.info}return Ae(e,t),t.u.info},Se=function(e,t){k(t)?ye(e,t):pe(e,t)},Te=function(e,t){let n=L.expkind,a=!1;switch(Se(e,t),t.k){case n.VTRUE:t.u.info=he(e,!0),a=!0;break;case n.VFALSE:t.u.info=he(e,!1),a=!0;break;case n.VNIL:t.u.info=function(e){let t=new M(b,null),n=new M(A,e.ls.h);return ue(e,n,t)}(e),a=!0;break;case n.VKINT:t.u.info=ce(e,t.u.ival),a=!0;break;case n.VKFLT:t.u.info=de(e,t.u.nval),a=!0;break;case n.VK:a=!0}return a&&(t.k=n.VK,t.u.info<=E.MAXINDEXRK)?E.RKASK(t.u.info):ye(e,t)},xe=function(e,t){let n=q(e,t.u.info);S(E.testTMode(n.opcode)&&n.opcode!==R.OP_TESTSET&&n.opcode!==R.OP_TEST),E.SETARG_A(n,!n.A)},Ee=function(e,t,n){if(t.k===L.expkind.VRELOCABLE){let a=F(e,t);if(a.opcode===R.OP_NOT)return e.pc--,Y(e,R.OP_TEST,a.B,0,!n)}return be(e,t),le(e,t),Y(e,R.OP_TESTSET,E.NO_REG,t.u.info,n)},Le=function(e,t){let n,a=L.expkind;switch(pe(e,t),t.k){case a.VJMP:xe(e,t),n=t.u.info;break;case a.VK:case a.VKFLT:case a.VKINT:case a.VTRUE:n=C;break;default:n=Ee(e,t,0)}t.f=V(e,t.f,n),$(e,t.t),t.t=C},Ie=function(e,t){let n,a=L.expkind;switch(pe(e,t),t.k){case a.VJMP:n=t.u.info;break;case a.VNIL:case a.VFALSE:n=C;break;default:n=Ee(e,t,1)}t.t=V(e,t.t,n),$(e,t.f),t.f=C},Ue=function(e,t,n){let a,r,m=L.expkind;if(!(a=O(t,!0))||!(r=O(n,!0))||!function(e,t,n){switch(e){case i:case l:case o:case h:case f:case s:return!1!==U.tointeger(t)&&!1!==U.tointeger(n);case u:case c:case d:return 0!==n.value;default:return 1}}(e,a,r))return 0;let p=new M;if(x.luaO_arith(null,e,a,r,p),p.ttisinteger())t.k=m.VKINT,t.u.ival=p.value;else{let e=p.value;if(isNaN(e)||0===e)return!1;t.k=m.VKFLT,t.u.nval=e}return!0},Re=function(e,t,n,a,r){let i=Te(e,a),s=Te(e,n);oe(e,n,a),n.u.info=Q(e,t,0,s,i),n.k=L.expkind.VRELOCABLE,Me(e,r)},Me=function(e,t){e.f.lineinfo[e.pc-1]=t};e.exports.BinOpr=B,e.exports.NO_JUMP=C,e.exports.UnOpr=P,e.exports.getinstruction=F,e.exports.luaK_checkstack=re,e.exports.luaK_code=W,e.exports.luaK_codeABC=Q,e.exports.luaK_codeABx=ee,e.exports.luaK_codeAsBx=te,e.exports.luaK_codek=ae,e.exports.luaK_concat=V,e.exports.luaK_dischargevars=pe,e.exports.luaK_exp2RK=Te,e.exports.luaK_exp2anyreg=ye,e.exports.luaK_exp2anyregup=function(e,t){(t.k!==L.expkind.VUPVAL||k(t))&&ye(e,t)},e.exports.luaK_exp2nextreg=Ae,e.exports.luaK_exp2val=Se,e.exports.luaK_fixline=Me,e.exports.luaK_getlabel=K,e.exports.luaK_goiffalse=Ie,e.exports.luaK_goiftrue=Le,e.exports.luaK_indexed=function(e,t,n){let a=L.expkind;S(!k(t)&&(L.vkisinreg(t.k)||t.k===a.VUPVAL)),t.u.ind.t=t.u.info,t.u.ind.idx=Te(e,n),t.u.ind.vt=t.k===a.VUPVAL?a.VUPVAL:a.VLOCAL,t.k=a.VINDEXED},e.exports.luaK_infix=function(e,t,n){switch(t){case B.OPR_AND:Le(e,n);break;case B.OPR_OR:Ie(e,n);break;case B.OPR_CONCAT:Ae(e,n);break;case B.OPR_ADD:case B.OPR_SUB:case B.OPR_MUL:case B.OPR_DIV:case B.OPR_IDIV:case B.OPR_MOD:case B.OPR_POW:case B.OPR_BAND:case B.OPR_BOR:case B.OPR_BXOR:case B.OPR_SHL:case B.OPR_SHR:O(n,!1)||Te(e,n);break;default:Te(e,n)}},e.exports.luaK_intK=ce,e.exports.luaK_jump=H,e.exports.luaK_jumpto=function(e,t){return J(e,H(e),t)},e.exports.luaK_nil=D,e.exports.luaK_numberK=de,e.exports.luaK_patchclose=function(e,t,n){for(n++;t!==C;t=G(e,t)){let a=e.f.code[t];S(a.opcode===R.OP_JMP&&(0===a.A||a.A>=n)),E.SETARG_A(a,n)}},e.exports.luaK_patchlist=J,e.exports.luaK_patchtohere=$,e.exports.luaK_posfix=function(e,t,n,a,i){let s=L.expkind;switch(t){case B.OPR_AND:S(n.t===C),pe(e,a),a.f=V(e,a.f,n.f),n.to(a);break;case B.OPR_OR:S(n.f===C),pe(e,a),a.t=V(e,a.t,n.t),n.to(a);break;case B.OPR_CONCAT:{Se(e,a);let t=F(e,a);a.k===s.VRELOCABLE&&t.opcode===R.OP_CONCAT?(S(n.u.info===t.B-1),le(e,n),E.SETARG_B(t,n.u.info),n.k=s.VRELOCABLE,n.u.info=a.u.info):(Ae(e,a),Re(e,R.OP_CONCAT,n,a,i));break}case B.OPR_ADD:case B.OPR_SUB:case B.OPR_MUL:case B.OPR_DIV:case B.OPR_IDIV:case B.OPR_MOD:case B.OPR_POW:case B.OPR_BAND:case B.OPR_BOR:case B.OPR_BXOR:case B.OPR_SHL:case B.OPR_SHR:Ue(t+r,n,a)||Re(e,t+R.OP_ADD,n,a,i);break;case B.OPR_EQ:case B.OPR_LT:case B.OPR_LE:case B.OPR_NE:case B.OPR_GT:case B.OPR_GE:!function(e,t,n,a){let r,i=L.expkind;n.k===i.VK?r=E.RKASK(n.u.info):(S(n.k===i.VNONRELOC),r=n.u.info);let s=Te(e,a);switch(oe(e,n,a),t){case B.OPR_NE:n.u.info=Y(e,R.OP_EQ,0,r,s);break;case B.OPR_GT:case B.OPR_GE:{let a=t-B.OPR_NE+R.OP_EQ;n.u.info=Y(e,a,1,s,r);break}default:{let a=t-B.OPR_EQ+R.OP_EQ;n.u.info=Y(e,a,1,r,s);break}}n.k=i.VJMP}(e,t,n,a)}return n},e.exports.luaK_prefix=function(e,t,n,a){let r=new L.expdesc;switch(r.k=L.expkind.VKINT,r.u.ival=r.u.nval=r.u.info=0,r.t=C,r.f=C,t){case P.OPR_MINUS:case P.OPR_BNOT:if(Ue(t+m,n,r))break;case P.OPR_LEN:!function(e,t,n,a){let r=ye(e,n);le(e,n),n.u.info=Q(e,t,0,r,0),n.k=L.expkind.VRELOCABLE,Me(e,a)}(e,t+R.OP_UNM,n,a);break;case P.OPR_NOT:!function(e,t){let n=L.expkind;switch(pe(e,t),t.k){case n.VNIL:case n.VFALSE:t.k=n.VTRUE;break;case n.VK:case n.VKFLT:case n.VKINT:case n.VTRUE:t.k=n.VFALSE;break;case n.VJMP:xe(e,t);break;case n.VRELOCABLE:case n.VNONRELOC:be(e,t),le(e,t),t.u.info=Q(e,R.OP_NOT,0,t.u.info,0),t.k=n.VRELOCABLE}{let e=t.f;t.f=t.t,t.t=e}j(e,t.f),j(e,t.t)}(e,n)}},e.exports.luaK_reserveregs=ie,e.exports.luaK_ret=function(e,t,n){Q(e,R.OP_RETURN,t,n+1,0)},e.exports.luaK_self=function(e,t,n){ye(e,t);let a=t.u.info;le(e,t),t.u.info=e.freereg,t.k=L.expkind.VNONRELOC,ie(e,2),Q(e,R.OP_SELF,t.u.info,a,Te(e,n)),le(e,n)},e.exports.luaK_setlist=function(e,t,n,r){let i=(n-1)/E.LFIELDS_PER_FLUSH+1,s=r===a?0:r;S(0!==r&&r<=E.LFIELDS_PER_FLUSH),i<=E.MAXARG_C?Q(e,R.OP_SETLIST,t,s,i):i<=E.MAXARG_Ax?(Q(e,R.OP_SETLIST,t,s,0),ne(e,i)):T.luaX_syntaxerror(e.ls,y("constructor too long",!0)),e.freereg=t+1},e.exports.luaK_setmultret=function(e,t){fe(e,t,a)},e.exports.luaK_setoneret=me,e.exports.luaK_setreturns=fe,e.exports.luaK_storevar=function(e,t,n){let a=L.expkind;switch(t.k){case a.VLOCAL:return le(e,n),void ve(e,n,t.u.info);case a.VUPVAL:{let a=ye(e,n);Q(e,R.OP_SETUPVAL,a,t.u.info,0);break}case a.VINDEXED:{let r=t.u.ind.vt===a.VLOCAL?R.OP_SETTABLE:R.OP_SETTABUP,i=Te(e,n);Q(e,r,t.u.ind.t,t.u.ind.idx,i);break}}le(e,n)},e.exports.luaK_stringK=function(e,t){let n=new M(g,t);return ue(e,n,n)}},821:(e,t,n)=>{"use strict";const{LUA_HOOKCOUNT:a,LUA_HOOKLINE:r,LUA_MASKCOUNT:i,LUA_MASKLINE:s,constant_types:{LUA_TBOOLEAN:l,LUA_TNIL:o,LUA_TTABLE:u},thread_status:{LUA_ERRRUN:c,LUA_YIELD:d},from_userstring:h,luastring_eq:f,luastring_indexOf:m,to_luastring:p}=n(775),{api_check:_,lua_assert:g}=n(568),{LUA_IDSIZE:b}=n(947),w=n(973),v=n(983),A=n(897),y=n(278),S=n(435),T=n(159),x=n(137),E=n(718),L=n(964),I=n(427),U=function(e){return g(e.callstatus&x.CIST_LUA),e.l_savedpc-1},R=function(e){return 0!==e.func.value.p.lineinfo.length?e.func.value.p.lineinfo[U(e)]:-1},M=function(e){if(e.status===d){let t=e.ci,n=t.funcOff;t.func=e.stack[t.extra],t.funcOff=t.extra,t.extra=n}},C=function(e,t){g(t<e.upvalues.length);let n=e.upvalues[t].name;return null===n?p("?",!0):n.getstr()},B=function(e,t,n){let a,r=null;if(t.callstatus&x.CIST_LUA){if(n<0)return function(e,t){let n=e.func.value.p.numparams;return t>=e.l_base-e.funcOff-n?null:{pos:e.funcOff+n+t,name:p("(*vararg)",!0)}}(t,-n);a=t.l_base,r=A.luaF_getlocalname(t.func.value.p,n,U(t))}else a=t.funcOff+1;if(null===r){if(!((t===e.ci?e.top:t.next.funcOff)-a>=n&&n>0))return null;r=p("(*temporary)",!0)}return{pos:a+(n-1),name:r}},P=function(e,t){if(null===t||t instanceof S.CClosure)e.source=p("=[JS]",!0),e.linedefined=-1,e.lastlinedefined=-1,e.what=p("J",!0);else{let n=t.p;e.source=n.source?n.source.getstr():p("=?",!0),e.linedefined=n.linedefined,e.lastlinedefined=n.lastlinedefined,e.what=0===e.linedefined?p("main",!0):p("Lua",!0)}e.short_src=S.luaO_chunkid(e.source,b)},k=function(e,t){let n={name:null,funcname:null};return null===t?null:t.callstatus&x.CIST_FIN?(n.name=p("__gc",!0),n.funcname=p("metamethod",!0),n):!(t.callstatus&x.CIST_TAIL)&&t.previous.callstatus&x.CIST_LUA?G(e,t.previous):null},O=function(e,t,n){let a={name:null,funcname:null};if(T.ISK(n)){let t=e.k[T.INDEXK(n)];if(t.ttisstring())return a.name=t.svalue(),a}else{let a=F(e,t,n);if(a&&99===a.funcname[0])return a}return a.name=p("?",!0),a},D=function(e,t){return e<t?-1:e},F=function(e,t,n){let a={name:A.luaF_getlocalname(e,n+1,t),funcname:null};if(a.name)return a.funcname=p("local",!0),a;let r=function(e,t,n){let a=-1,r=0,i=T.OpCodesI;for(let s=0;s<t;s++){let l=e.code[s],o=l.A;switch(l.opcode){case i.OP_LOADNIL:{let e=l.B;o<=n&&n<=o+e&&(a=D(s,r));break}case i.OP_TFORCALL:n>=o+2&&(a=D(s,r));break;case i.OP_CALL:case i.OP_TAILCALL:n>=o&&(a=D(s,r));break;case i.OP_JMP:{let e=s+1+l.sBx;s<e&&e<=t&&e>r&&(r=e);break}default:T.testAMode(l.opcode)&&n===o&&(a=D(s,r))}}return a}(e,t,n),i=T.OpCodesI;if(-1!==r){let t=e.code[r];switch(t.opcode){case i.OP_MOVE:{let n=t.B;if(n<t.A)return F(e,r,n);break}case i.OP_GETTABUP:case i.OP_GETTABLE:{let n=t.C,s=t.B,l=t.opcode===i.OP_GETTABLE?A.luaF_getlocalname(e,s+1,r):C(e,s);return a.name=O(e,r,n).name,a.funcname=l&&f(l,y.LUA_ENV)?p("global",!0):p("field",!0),a}case i.OP_GETUPVAL:return a.name=C(e,t.B),a.funcname=p("upvalue",!0),a;case i.OP_LOADK:case i.OP_LOADKX:{let n=t.opcode===i.OP_LOADK?t.Bx:e.code[r+1].Ax;if(e.k[n].ttisstring())return a.name=e.k[n].svalue(),a.funcname=p("constant",!0),a;break}case i.OP_SELF:{let n=t.C;return a.name=O(e,r,n).name,a.funcname=p("method",!0),a}}}return null},G=function(e,t){let n={name:null,funcname:null},a=0,r=t.func.value.p,i=U(t),s=r.code[i],l=T.OpCodesI;if(t.callstatus&x.CIST_HOOKED)return n.name=p("?",!0),n.funcname=p("hook",!0),n;switch(s.opcode){case l.OP_CALL:case l.OP_TAILCALL:return F(r,i,s.A);case l.OP_TFORCALL:return n.name=p("for iterator",!0),n.funcname=p("for iterator",!0),n;case l.OP_SELF:case l.OP_GETTABUP:case l.OP_GETTABLE:a=L.TMS.TM_INDEX;break;case l.OP_SETTABUP:case l.OP_SETTABLE:a=L.TMS.TM_NEWINDEX;break;case l.OP_ADD:a=L.TMS.TM_ADD;break;case l.OP_SUB:a=L.TMS.TM_SUB;break;case l.OP_MUL:a=L.TMS.TM_MUL;break;case l.OP_MOD:a=L.TMS.TM_MOD;break;case l.OP_POW:a=L.TMS.TM_POW;break;case l.OP_DIV:a=L.TMS.TM_DIV;break;case l.OP_IDIV:a=L.TMS.TM_IDIV;break;case l.OP_BAND:a=L.TMS.TM_BAND;break;case l.OP_BOR:a=L.TMS.TM_BOR;break;case l.OP_BXOR:a=L.TMS.TM_BXOR;break;case l.OP_SHL:a=L.TMS.TM_SHL;break;case l.OP_SHR:a=L.TMS.TM_SHR;break;case l.OP_UNM:a=L.TMS.TM_UNM;break;case l.OP_BNOT:a=L.TMS.TM_BNOT;break;case l.OP_LEN:a=L.TMS.TM_LEN;break;case l.OP_CONCAT:a=L.TMS.TM_CONCAT;break;case l.OP_EQ:a=L.TMS.TM_EQ;break;case l.OP_LT:a=L.TMS.TM_LT;break;case l.OP_LE:a=L.TMS.TM_LE;break;default:return null}return n.name=e.l_G.tmname[a].getstr(),n.funcname=p("metamethod",!0),n},N=function(e,t){let n=e.ci,a=null;if(n.callstatus&x.CIST_LUA){a=function(e,t,n){let a=t.func.value;for(let e=0;e<a.nupvalues;e++)if(a.upvals[e]===n)return{name:C(a.p,e),funcname:p("upvalue",!0)};return null}(0,n,t);let r=function(e,t,n){for(let a=t.l_base;a<t.top;a++)if(e.stack[a]===n)return a;return!1}(e,n,t);!a&&r&&(a=F(n.func.value.p,U(n),r-n.l_base))}return a?S.luaO_pushfstring(e,p(" (%s '%s')",!0),a.funcname,a.name):p("",!0)},V=function(e,t,n){let a=L.luaT_objtypename(e,t);Y(e,p("attempt to %s a %s value%s",!0),n,a,N(e,t))},H=function(e,t,n,a){let r;return r=n?S.luaO_chunkid(n.getstr(),b):p("?",!0),S.luaO_pushfstring(e,p("%s:%d: %s",!0),r,a,t)},Y=function(e,t,...n){let a=e.ci,r=S.luaO_pushvfstring(e,t,n);a.callstatus&x.CIST_LUA&&H(e,r,a.func.value.p.source,R(a)),K(e)},K=function(e){if(0!==e.errfunc){let t=e.errfunc;S.pushobj2s(e,e.stack[e.top-1]),S.setobjs2s(e,e.top-2,t),v.luaD_callnoyield(e,e.top-2,1)}v.luaD_throw(e,c)};e.exports.luaG_addinfo=H,e.exports.luaG_concaterror=function(e,t,n){(t.ttisstring()||I.cvt2str(t))&&(t=n),V(e,t,p("concatenate",!0))},e.exports.luaG_errormsg=K,e.exports.luaG_opinterror=function(e,t,n,a){!1===I.tonumber(t)&&(n=t),V(e,n,a)},e.exports.luaG_ordererror=function(e,t,n){let a=L.luaT_objtypename(e,t),r=L.luaT_objtypename(e,n);f(a,r)?Y(e,p("attempt to compare two %s values",!0),a):Y(e,p("attempt to compare %s with %s",!0),a,r)},e.exports.luaG_runerror=Y,e.exports.luaG_tointerror=function(e,t,n){!1===I.tointeger(t)&&(n=t),Y(e,p("number%s has no integer representation",!0),N(e,n))},e.exports.luaG_traceexec=function(e){let t=e.ci,n=e.hookmask,l=0==--e.hookcount&&n&i;if(l)e.hookcount=e.basehookcount;else if(!(n&s))return;if(t.callstatus&x.CIST_HOOKYIELD)t.callstatus&=~x.CIST_HOOKYIELD;else{if(l&&v.luaD_hook(e,a,-1),n&s){let n=t.func.value.p,a=t.l_savedpc-1,i=0!==n.lineinfo.length?n.lineinfo[a]:-1;(0===a||t.l_savedpc<=e.oldpc||i!==(0!==n.lineinfo.length?n.lineinfo[e.oldpc-1]:-1))&&v.luaD_hook(e,r,i)}e.oldpc=t.l_savedpc,e.status===d&&(l&&(e.hookcount=1),t.l_savedpc--,t.callstatus|=x.CIST_HOOKYIELD,t.funcOff=e.top-1,t.func=e.stack[t.funcOff],v.luaD_throw(e,d))}},e.exports.luaG_typeerror=V,e.exports.lua_gethook=function(e){return e.hook},e.exports.lua_gethookcount=function(e){return e.basehookcount},e.exports.lua_gethookmask=function(e){return e.hookmask},e.exports.lua_getinfo=function(e,t,n){let a,r,i,s;return t=h(t),M(e),62===t[0]?(i=null,s=e.stack[e.top-1],_(e,s.ttisfunction(),"function expected"),t=t.subarray(1),e.top--):(i=n.i_ci,s=i.func,g(i.func.ttisfunction())),r=s.ttisclosure()?s.value:null,a=function(e,t,n,a,r){let i=1;for(;t.length>0;t=t.subarray(1))switch(t[0]){case 83:P(n,a);break;case 108:n.currentline=r&&r.callstatus&x.CIST_LUA?R(r):-1;break;case 117:n.nups=null===a?0:a.nupvalues,null===a||a instanceof S.CClosure?(n.isvararg=!0,n.nparams=0):(n.isvararg=a.p.is_vararg,n.nparams=a.p.numparams);break;case 116:n.istailcall=r?r.callstatus&x.CIST_TAIL:0;break;case 110:{let t=k(e,r);null===t?(n.namewhat=p("",!0),n.name=null):(n.namewhat=t.funcname,n.name=t.name);break}case 76:case 102:break;default:i=0}return i}(e,t,n,r,i),m(t,102)>=0&&(S.pushobj2s(e,s),_(e,e.top<=e.ci.top,"stack overflow")),M(e),m(t,76)>=0&&function(e,t){if(null===t||t instanceof S.CClosure)e.stack[e.top]=new S.TValue(o,null),w.api_incr_top(e);else{let n=t.p.lineinfo,a=E.luaH_new(e);e.stack[e.top]=new S.TValue(u,a),w.api_incr_top(e);let r=new S.TValue(l,!0);for(let e=0;e<n.length;e++)E.luaH_setint(a,n[e],r)}}(e,r),a},e.exports.lua_getlocal=function(e,t,n){let a;if(M(e),null===t)a=e.stack[e.top-1].ttisLclosure()?A.luaF_getlocalname(e.stack[e.top-1].value.p,n,0):null;else{let r=B(e,t.i_ci,n);r?(a=r.name,S.pushobj2s(e,e.stack[r.pos]),_(e,e.top<=e.ci.top,"stack overflow")):a=null}return M(e),a},e.exports.lua_getstack=function(e,t,n){let a,r;if(t<0)return 0;for(a=e.ci;t>0&&a!==e.base_ci;a=a.previous)t--;return 0===t&&a!==e.base_ci?(r=1,n.i_ci=a):r=0,r},e.exports.lua_sethook=function(e,t,n,a){null!==t&&0!==n||(n=0,t=null),e.ci.callstatus&x.CIST_LUA&&(e.oldpc=e.ci.l_savedpc),e.hook=t,e.basehookcount=a,e.hookcount=e.basehookcount,e.hookmask=n},e.exports.lua_setlocal=function(e,t,n){let a;M(e);let r=B(e,t.i_ci,n);return r?(a=r.name,S.setobjs2s(e,r.pos,e.top-1),delete e.stack[--e.top]):a=null,M(e),a}},983:(e,t,n)=>{"use strict";const{LUA_HOOKCALL:a,LUA_HOOKRET:r,LUA_HOOKTAILCALL:i,LUA_MASKCALL:s,LUA_MASKLINE:l,LUA_MASKRET:o,LUA_MINSTACK:u,LUA_MULTRET:c,LUA_SIGNATURE:d,constant_types:{LUA_TCCL:h,LUA_TLCF:f,LUA_TLCL:m,LUA_TNIL:p},thread_status:{LUA_ERRMEM:_,LUA_ERRERR:g,LUA_ERRRUN:b,LUA_ERRSYNTAX:w,LUA_OK:v,LUA_YIELD:A},lua_Debug:y,luastring_indexOf:S,to_luastring:T}=n(775),x=n(973),E=n(821),L=n(897),{api_check:I,lua_assert:U,LUAI_MAXCCALLS:R}=n(568),M=n(435),C=n(159),B=n(391),P=n(137),{luaS_newliteral:k}=n(878),O=n(964),{LUAI_MAXSTACK:D}=n(947),F=n(866),G=n(427),{MBuffer:N}=n(161),V=function(e,t){if(e.top<t)for(;e.top<t;)e.stack[e.top++]=new M.TValue(p,null);else for(;e.top>t;)delete e.stack[--e.top]},H=function(e,t,n){let a=e.top;for(;e.top<n+1;)e.stack[e.top++]=new M.TValue(p,null);switch(t){case _:M.setsvalue2s(e,n,k(e,"not enough memory"));break;case g:M.setsvalue2s(e,n,k(e,"error in error handling"));break;default:M.setobjs2s(e,n,a-1)}for(;e.top>n+1;)delete e.stack[--e.top]},Y=D+200,K=function(e,t){U(t<=D||t==Y),U(e.stack_last==e.stack.length-P.EXTRA_STACK),e.stack.length=t,e.stack_last=t-P.EXTRA_STACK},z=function(e,t){let n=e.stack.length;if(n>D)ne(e,g);else{let a=e.top+t+P.EXTRA_STACK,r=2*n;r>D&&(r=D),r<a&&(r=a),r>D?(K(e,Y),E.luaG_runerror(e,T("stack overflow",!0))):K(e,r)}},q=function(e,t){e.stack_last-e.top<=t&&z(e,t)},Z=function(e){let t=function(e){let t=e.top;for(let n=e.ci;null!==n;n=n.previous)t<n.top&&(t=n.top);return U(t<=e.stack_last),t+1}(e),n=t+Math.floor(t/8)+2*P.EXTRA_STACK;n>D&&(n=D),e.stack.length>D&&P.luaE_freeCI(e),t<=D-P.EXTRA_STACK&&n<e.stack.length&&K(e,n)},j=function(e,t,n){let r=e.stack[t];switch(r.type){case h:case f:{let i=r.type===h?r.value.f:r.value;q(e,u);let l=P.luaE_extendCI(e);l.funcOff=t,l.nresults=n,l.func=r,l.top=e.top+u,U(l.top<=e.stack_last),l.callstatus=0,e.hookmask&s&&J(e,a,-1);let o=i(e);if("number"!=typeof o||o<0||(0|o)!==o)throw Error("invalid return value from JS function (expected integer)");return x.api_checknelems(e,o),X(e,l,e.top-o,o),!0}case m:{let a,i=r.value.p,l=e.top-t-1,o=i.maxstacksize;if(q(e,o),i.is_vararg)a=Q(e,i,l);else{for(;l<i.numparams;l++)e.stack[e.top++]=new M.TValue(p,null);a=t+1}let u=P.luaE_extendCI(e);return u.funcOff=t,u.nresults=n,u.func=r,u.l_base=a,u.top=a+o,V(e,u.top),u.l_code=i.code,u.l_savedpc=0,u.callstatus=P.CIST_LUA,e.hookmask&s&&W(e,u),!1}default:return q(e,1),ee(e,t,r),j(e,t,n)}},X=function(e,t,n,a){let i=t.nresults;e.hookmask&(o|l)&&(e.hookmask&o&&J(e,r,-1),e.oldpc=t.previous.l_savedpc);let s=t.funcOff;return e.ci=t.previous,e.ci.next=null,$(e,n,s,a,i)},$=function(e,t,n,a,r){switch(r){case 0:break;case 1:0===a?e.stack[n].setnilvalue():M.setobjs2s(e,n,t);break;case c:for(let r=0;r<a;r++)M.setobjs2s(e,n+r,t+r);for(let t=e.top;t>=n+a;t--)delete e.stack[t];return e.top=n+a,!1;default:{let i;if(r<=a)for(i=0;i<r;i++)M.setobjs2s(e,n+i,t+i);else{for(i=0;i<a;i++)M.setobjs2s(e,n+i,t+i);for(;i<r;i++)n+i>=e.top?e.stack[n+i]=new M.TValue(p,null):e.stack[n+i].setnilvalue()}break}}let i=n+r;for(let t=e.top;t>=i;t--)delete e.stack[t];return e.top=i,!0},J=function(e,t,n){let a=e.hook;if(a&&e.allowhook){let r=e.ci,i=e.top,s=r.top,l=new y;l.event=t,l.currentline=n,l.i_ci=r,q(e,u),r.top=e.top+u,U(r.top<=e.stack_last),e.allowhook=0,r.callstatus|=P.CIST_HOOKED,a(e,l),U(!e.allowhook),e.allowhook=1,r.top=s,V(e,i),r.callstatus&=~P.CIST_HOOKED}},W=function(e,t){let n=a;t.l_savedpc++,t.previous.callstatus&P.CIST_LUA&&t.previous.l_code[t.previous.l_savedpc-1].opcode==C.OpCodesI.OP_TAILCALL&&(t.callstatus|=P.CIST_TAIL,n=i),J(e,n,-1),t.l_savedpc--},Q=function(e,t,n){let a,r=t.numparams,i=e.top-n,s=e.top;for(a=0;a<r&&a<n;a++)M.pushobj2s(e,e.stack[i+a]),e.stack[i+a].setnilvalue();for(;a<r;a++)e.stack[e.top++]=new M.TValue(p,null);return s},ee=function(e,t,n){let a=O.luaT_gettmbyobj(e,n,O.TMS.TM_CALL);a.ttisfunction(a)||E.luaG_typeerror(e,n,T("call",!0)),M.pushobj2s(e,e.stack[e.top-1]);for(let n=e.top-2;n>t;n--)M.setobjs2s(e,n,n-1);M.setobj2s(e,t,a)},te=function(e,t,n){++e.nCcalls>=R&&function(e){e.nCcalls===R?E.luaG_runerror(e,T("JS stack overflow",!0)):e.nCcalls>=R+(R>>3)&&ne(e,g)}(e),j(e,t,n)||G.luaV_execute(e),e.nCcalls--},ne=function(e,t){if(e.errorJmp)throw e.errorJmp.status=t,e.errorJmp;{let n=e.l_G;if(e.status=t,!n.mainthread.errorJmp){let a=n.panic;throw a&&(H(e,t,e.top),e.ci.top<e.top&&(e.ci.top=e.top),a(e)),new Error(`Aborted ${t}`)}n.mainthread.stack[n.mainthread.top++]=e.stack[e.top-1],ne(n.mainthread,t)}},ae=function(e,t,n){let a=e.nCcalls,r={status:v,previous:e.errorJmp};e.errorJmp=r;try{t(e,n)}catch(t){if(r.status===v){let n=e.l_G.atnativeerror;if(n)try{if(r.status=v,x.lua_pushcfunction(e,n),x.lua_pushlightuserdata(e,t),de(e,e.top-2,1),0!==e.errfunc){let t=e.errfunc;M.pushobj2s(e,e.stack[e.top-1]),M.setobjs2s(e,e.top-2,t),de(e,e.top-2,1)}r.status=b}catch(e){r.status===v&&(r.status=-1)}else r.status=-1}}return e.errorJmp=r.previous,e.nCcalls=a,r.status},re=function(e,t){let n=e.ci;U(null!==n.c_k&&0===e.nny),U(n.callstatus&P.CIST_YPCALL||t===A),n.callstatus&P.CIST_YPCALL&&(n.callstatus&=~P.CIST_YPCALL,e.errfunc=n.c_old_errfunc),n.nresults===c&&e.ci.top<e.top&&(e.ci.top=e.top);let a=(0,n.c_k)(e,t,n.c_ctx);x.api_checknelems(e,a),X(e,n,e.top-a,a)},ie=function(e,t){for(null!==t&&re(e,t);e.ci!==e.base_ci;)e.ci.callstatus&P.CIST_LUA?(G.luaV_finishOp(e),G.luaV_execute(e)):re(e,A)},se=function(e,t){let n=function(e){for(let t=e.ci;null!==t;t=t.previous)if(t.callstatus&P.CIST_YPCALL)return t;return null}(e);if(null===n)return 0;let a=n.extra;return L.luaF_close(e,a),H(e,t,a),e.ci=n,e.allowhook=n.callstatus&P.CIST_OAH,e.nny=0,Z(e),e.errfunc=n.c_old_errfunc,1},le=function(e,t,n){let a=k(e,t);if(0===n)M.pushsvalue2s(e,a),I(e,e.top<=e.ci.top,"stack overflow");else{for(let t=1;t<n;t++)delete e.stack[--e.top];M.setsvalue2s(e,e.top-1,a)}return b},oe=function(e,t){let n=e.top-t,a=e.ci;e.status===v?j(e,n-1,c)||G.luaV_execute(e):(U(e.status===A),e.status=v,a.funcOff=a.extra,a.func=e.stack[a.funcOff],a.callstatus&P.CIST_LUA?G.luaV_execute(e):(null!==a.c_k&&(t=a.c_k(e,A,a.c_ctx),x.api_checknelems(e,t),n=e.top-t),X(e,a,n,t)),ie(e,null))},ue=function(e,t,n,a){let r=e.ci;return x.api_checknelems(e,t),e.nny>0&&(e!==e.l_G.mainthread?E.luaG_runerror(e,T("attempt to yield across a JS-call boundary",!0)):E.luaG_runerror(e,T("attempt to yield from outside a coroutine",!0))),e.status=A,r.extra=r.funcOff,r.callstatus&P.CIST_LUA?I(e,null===a,"hooks cannot continue after yielding"):(r.c_k=a,null!==a&&(r.c_ctx=n),r.funcOff=e.top-t-1,r.func=e.stack[r.funcOff],ne(e,A)),U(r.callstatus&P.CIST_HOOKED),0},ce=function(e,t,n,a,r){let i=e.ci,s=e.allowhook,l=e.nny,o=e.errfunc;e.errfunc=r;let u=ae(e,t,n);return u!==v&&(L.luaF_close(e,a),H(e,u,a),e.ci=i,e.allowhook=s,e.nny=l,Z(e)),e.errfunc=o,u},de=function(e,t,n){e.nny++,te(e,t,n),e.nny--};class he{constructor(e,t,n){this.z=e,this.buff=new N,this.dyd=new B.Dyndata,this.mode=n,this.name=t}}const fe=function(e,t,n){t&&-1===S(t,n[0])&&(M.luaO_pushfstring(e,T("attempt to load a %s chunk (mode is '%s')"),n,t),ne(e,w))},me=function(e,t){let n,a=t.z.zgetc();a===d[0]?(fe(e,t.mode,T("binary",!0)),n=F.luaU_undump(e,t.z,t.name)):(fe(e,t.mode,T("text",!0)),n=B.luaY_parser(e,t.z,t.buff,t.dyd,t.name,a)),U(n.nupvalues===n.p.upvalues.length),L.luaF_initupvals(e,n)};e.exports.adjust_top=V,e.exports.luaD_call=te,e.exports.luaD_callnoyield=de,e.exports.luaD_checkstack=q,e.exports.luaD_growstack=z,e.exports.luaD_hook=J,e.exports.luaD_inctop=function(e){q(e,1),e.stack[e.top++]=new M.TValue(p,null)},e.exports.luaD_pcall=ce,e.exports.luaD_poscall=X,e.exports.luaD_precall=j,e.exports.luaD_protectedparser=function(e,t,n,a){let r=new he(t,n,a);e.nny++;let i=ce(e,me,r,e.top,e.errfunc);return e.nny--,i},e.exports.luaD_rawrunprotected=ae,e.exports.luaD_reallocstack=K,e.exports.luaD_throw=ne,e.exports.lua_isyieldable=function(e){return 0===e.nny},e.exports.lua_resume=function(e,t,n){let a=e.nny;if(e.status===v){if(e.ci!==e.base_ci)return le(e,"cannot resume non-suspended coroutine",n)}else if(e.status!==A)return le(e,"cannot resume dead coroutine",n);if(e.nCcalls=t?t.nCcalls+1:1,e.nCcalls>=R)return le(e,"JS stack overflow",n);e.nny=0,x.api_checknelems(e,e.status===v?n+1:n);let r=ae(e,oe,n);if(-1===r)r=b;else{for(;r>A&&se(e,r);)r=ae(e,ie,r);r>A?(e.status=r,H(e,r,e.top),e.ci.top=e.top):U(r===e.status)}return e.nny=a,e.nCcalls--,U(e.nCcalls===(t?t.nCcalls:0)),r},e.exports.lua_yield=function(e,t){ue(e,t,0,null)},e.exports.lua_yieldk=ue},957:(e,t,n)=>{"use strict";const{LUA_SIGNATURE:a,LUA_VERSION_MAJOR:r,LUA_VERSION_MINOR:i,constant_types:{LUA_TBOOLEAN:s,LUA_TLNGSTR:l,LUA_TNIL:o,LUA_TNUMFLT:u,LUA_TNUMINT:c,LUA_TSHRSTR:d},luastring_of:h}=n(775),f=h(25,147,13,10,26,10),m=16*Number(r)+Number(i);class p{constructor(){this.L=null,this.write=null,this.data=null,this.strip=NaN,this.status=NaN}}const _=function(e,t,n){0===n.status&&t>0&&(n.status=n.writer(n.L,e,t,n.data))},g=function(e,t){_(h(e),1,t)},b=function(e,t){let n=new ArrayBuffer(4);new DataView(n).setInt32(0,e,!0);let a=new Uint8Array(n);_(a,4,t)},w=function(e,t){let n=new ArrayBuffer(4);new DataView(n).setInt32(0,e,!0);let a=new Uint8Array(n);_(a,4,t)},v=function(e,t){let n=new ArrayBuffer(8);new DataView(n).setFloat64(0,e,!0);let a=new Uint8Array(n);_(a,8,t)},A=function(e,t){if(null===e)g(0,t);else{let n=e.tsslen()+1,a=e.getstr();n<255?g(n,t):(g(255,t),w(n,t)),_(a,n-1,t)}},y=function(e,t,n){n.strip||e.source===t?A(null,n):A(e.source,n),b(e.linedefined,n),b(e.lastlinedefined,n),g(e.numparams,n),g(e.is_vararg?1:0,n),g(e.maxstacksize,n),function(e,t){let n=e.code.map((e=>e.code));b(n.length,t);for(let e=0;e<n.length;e++)b(n[e],t)}(e,n),function(e,t){let n=e.k.length;b(n,t);for(let a=0;a<n;a++){let n=e.k[a];switch(g(n.ttype(),t),n.ttype()){case o:break;case s:g(n.value?1:0,t);break;case u:v(n.value,t);break;case c:w(n.value,t);break;case d:case l:A(n.tsvalue(),t)}}}(e,n),function(e,t){let n=e.upvalues.length;b(n,t);for(let a=0;a<n;a++)g(e.upvalues[a].instack?1:0,t),g(e.upvalues[a].idx,t)}(e,n),function(e,t){let n=e.p.length;b(n,t);for(let a=0;a<n;a++)y(e.p[a],e.source,t)}(e,n),function(e,t){let n=t.strip?0:e.lineinfo.length;b(n,t);for(let a=0;a<n;a++)b(e.lineinfo[a],t);n=t.strip?0:e.locvars.length,b(n,t);for(let a=0;a<n;a++)A(e.locvars[a].varname,t),b(e.locvars[a].startpc,t),b(e.locvars[a].endpc,t);n=t.strip?0:e.upvalues.length,b(n,t);for(let a=0;a<n;a++)A(e.upvalues[a].name,t)}(e,n)};e.exports.luaU_dump=function(e,t,n,r,i){let s=new p;return s.L=e,s.writer=n,s.data=r,s.strip=i,s.status=0,function(e){_(a,a.length,e),g(m,e),g(0,e),_(f,f.length,e),g(4,e),g(4,e),g(4,e),g(4,e),g(8,e),w(22136,e),v(370.5,e)}(s),g(t.upvalues.length,s),y(t,null,s),s.status}},897:(e,t,n)=>{"use strict";const{constant_types:{LUA_TNIL:a}}=n(775),r=n(435);e.exports.MAXUPVAL=255,e.exports.Proto=class{constructor(e){this.id=e.l_G.id_counter++,this.k=[],this.p=[],this.code=[],this.cache=null,this.lineinfo=[],this.upvalues=[],this.numparams=0,this.is_vararg=!1,this.maxstacksize=0,this.locvars=[],this.linedefined=0,this.lastlinedefined=0,this.source=null}},e.exports.luaF_findupval=function(e,t){return e.stack[t]},e.exports.luaF_close=function(e,t){for(let n=t;n<e.top;n++){let t=e.stack[n];e.stack[n]=new r.TValue(t.type,t.value)}},e.exports.luaF_getlocalname=function(e,t,n){for(let a=0;a<e.locvars.length&&e.locvars[a].startpc<=n;a++)if(n<e.locvars[a].endpc&&0===--t)return e.locvars[a].varname.getstr();return null},e.exports.luaF_initupvals=function(e,t){for(let e=0;e<t.nupvalues;e++)t.upvals[e]=new r.TValue(a,null)},e.exports.luaF_newLclosure=function(e,t){return new r.LClosure(e,t)}},122:(e,t,n)=>{"use strict";const{luastring_of:a}=n(775),r=a(0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,22,22,22,22,22,22,22,22,22,22,4,4,4,4,4,4,4,21,21,21,21,21,21,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,4,4,4,4,5,4,21,21,21,21,21,21,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);e.exports.lisdigit=function(e){return 0!=(2&r[e+1])},e.exports.lislalnum=function(e){return 0!=(3&r[e+1])},e.exports.lislalpha=function(e){return 0!=(1&r[e+1])},e.exports.lisprint=function(e){return 0!=(4&r[e+1])},e.exports.lisspace=function(e){return 0!=(8&r[e+1])},e.exports.lisxdigit=function(e){return 0!=(16&r[e+1])}},278:(e,t,n)=>{"use strict";const{constant_types:{LUA_TBOOLEAN:a,LUA_TLNGSTR:r},thread_status:{LUA_ERRSYNTAX:i},to_luastring:s}=n(775),{LUA_MINBUFFER:l,MAX_INT:o,lua_assert:u}=n(568),c=n(821),d=n(983),{lisdigit:h,lislalnum:f,lislalpha:m,lisspace:p,lisxdigit:_}=n(122),g=n(435),{luaS_bless:b,luaS_hash:w,luaS_hashlongstr:v,luaS_new:A}=n(878),y=n(718),{EOZ:S,luaZ_buffer:T,luaZ_buffremove:x,luaZ_resetbuffer:E,luaZ_resizebuffer:L}=n(161),I=257,U=s("_ENV",!0),R=289,M=290,C=293,B={TK_AND:257,TK_BREAK:258,TK_DO:259,TK_ELSE:260,TK_ELSEIF:261,TK_END:262,TK_FALSE:263,TK_FOR:264,TK_FUNCTION:265,TK_GOTO:266,TK_IF:267,TK_IN:268,TK_LOCAL:269,TK_NIL:270,TK_NOT:271,TK_OR:272,TK_REPEAT:273,TK_RETURN:274,TK_THEN:275,TK_TRUE:276,TK_UNTIL:277,TK_WHILE:278,TK_IDIV:279,TK_CONCAT:280,TK_DOTS:281,TK_EQ:282,TK_GE:283,TK_LE:284,TK_NE:285,TK_SHL:286,TK_SHR:287,TK_DBCOLON:288,TK_EOS:R,TK_FLT:M,TK_INT:291,TK_NAME:292,TK_STRING:C},P=["and","break","do","else","elseif","end","false","for","function","goto","if","in","local","nil","not","or","repeat","return","then","true","until","while","//","..","...","==",">=","<=","~=","<<",">>","::","<eof>","<number>","<integer>","<name>","<string>"].map(((e,t)=>s(e)));class k{constructor(){this.r=NaN,this.i=NaN,this.ts=null}}class O{constructor(){this.token=NaN,this.seminfo=new k}}const D=function(e,t){let n=e.buff;if(n.n+1>n.buffer.length){n.buffer.length>=o/2&&j(e,s("lexical element too long",!0),0);let t=2*n.buffer.length;L(e.L,n,t)}n.buffer[n.n++]=t<0?255+t+1:t},F=function(e,t){if(t<I)return g.luaO_pushfstring(e.L,s("'%c'",!0),t);{let n=P[t-I];return t<R?g.luaO_pushfstring(e.L,s("'%s'",!0),n):n}},G=function(e){return 10===e.current||13===e.current},N=function(e){e.current=e.z.zgetc()},V=function(e){D(e,e.current),N(e)},H=new g.TValue(a,!0),Y=function(e,t){let n=e.L,a=A(n,t),i=e.h.strong.get(v(a));if(i)a=i.key.tsvalue();else{let t=new g.TValue(r,a);y.luaH_setfrom(n,e.h,t,H)}return a},K=function(e){let t=e.current;u(G(e)),N(e),G(e)&&e.current!==t&&N(e),++e.linenumber>=o&&j(e,s("chunk has too many lines",!0),0)},z=function(e,t){return e.current===t&&(N(e),!0)},q=function(e,t){return(e.current===t[0].charCodeAt(0)||e.current===t[1].charCodeAt(0))&&(V(e),!0)},Z=function(e,t){let n="Ee",a=e.current;for(u(h(e.current)),V(e),48===a&&q(e,"xX")&&(n="Pp");;)if(q(e,n)&&q(e,"-+"),_(e.current))V(e);else{if(46!==e.current)break;V(e)}let r=new g.TValue;return 0===g.luaO_str2num(T(e.buff),r)&&j(e,s("malformed number",!0),M),r.ttisinteger()?(t.i=r.value,291):(u(r.ttisfloat()),t.r=r.value,M)},j=function(e,t,n){t=c.luaG_addinfo(e.L,t,e.source,e.linenumber),n&&g.luaO_pushfstring(e.L,s("%s near %s"),t,function(e,t){switch(t){case 292:case C:case M:case 291:return g.luaO_pushfstring(e.L,s("'%s'",!0),T(e.buff));default:return F(e,t)}}(e,n)),d.luaD_throw(e.L,i)},X=function(e){let t=0,n=e.current;for(u(91===n||93===n),V(e);61===e.current;)V(e),t++;return e.current===n?t:-t-1},$=function(e,t,n){let a=e.linenumber;V(e),G(e)&&K(e);let r=!1;for(;!r;)switch(e.current){case S:j(e,s(`unfinished long ${t?"string":"comment"} (starting at line ${a})`),R);break;case 93:X(e)===n&&(V(e),r=!0);break;case 10:case 13:D(e,10),K(e),t||E(e.buff);break;default:t?V(e):N(e)}t&&(t.ts=Y(e,e.buff.buffer.subarray(2+n,e.buff.n-(2+n))))},J=function(e,t,n){t||(e.current!==S&&V(e),j(e,n,C))},W=function(e){return V(e),J(e,_(e.current),s("hexadecimal digit expected",!0)),g.luaO_hexavalue(e.current)},Q=function(e){let t=W(e);return t=(t<<4)+W(e),x(e.buff,2),t},ee=function(e){let t=new Uint8Array(g.UTF8BUFFSZ),n=g.luaO_utf8esc(t,function(e){let t=4;V(e),J(e,123===e.current,s("missing '{'",!0));let n=W(e);for(V(e);_(e.current);)t++,n=(n<<4)+g.luaO_hexavalue(e.current),J(e,n<=1114111,s("UTF-8 value too large",!0)),V(e);return J(e,125===e.current,s("missing '}'",!0)),N(e),x(e.buff,t),n}(e));for(;n>0;n--)D(e,t[g.UTF8BUFFSZ-n])},te=function(e){let t,n=0;for(t=0;t<3&&h(e.current);t++)n=10*n+e.current-48,V(e);return J(e,n<=255,s("decimal escape too large",!0)),x(e.buff,t),n},ne=function(e,t,n){for(V(e);e.current!==t;)switch(e.current){case S:j(e,s("unfinished string",!0),R);break;case 10:case 13:j(e,s("unfinished string",!0),C);break;case 92:{let t,n;switch(V(e),e.current){case 97:n=7,t="read_save";break;case 98:n=8,t="read_save";break;case 102:n=12,t="read_save";break;case 110:n=10,t="read_save";break;case 114:n=13,t="read_save";break;case 116:n=9,t="read_save";break;case 118:n=11,t="read_save";break;case 120:n=Q(e),t="read_save";break;case 117:ee(e),t="no_save";break;case 10:case 13:K(e),n=10,t="only_save";break;case 92:case 34:case 39:n=e.current,t="read_save";break;case S:t="no_save";break;case 122:for(x(e.buff,1),N(e);p(e.current);)G(e)?K(e):N(e);t="no_save";break;default:J(e,h(e.current),s("invalid escape sequence",!0)),n=te(e),t="only_save"}"read_save"===t&&N(e),"read_save"!==t&&"only_save"!==t||(x(e.buff,1),D(e,n));break}default:V(e)}V(e),n.ts=Y(e,e.buff.buffer.subarray(1,e.buff.n-1))},ae=Object.create(null);P.forEach(((e,t)=>ae[w(e)]=t));const re=function(e,t){for(E(e.buff);;)switch(u("number"==typeof e.current),e.current){case 10:case 13:K(e);break;case 32:case 12:case 9:case 11:N(e);break;case 45:if(N(e),45!==e.current)return 45;if(N(e),91===e.current){let t=X(e);if(E(e.buff),t>=0){$(e,null,t),E(e.buff);break}}for(;!G(e)&&e.current!==S;)N(e);break;case 91:{let n=X(e);return n>=0?($(e,t,n),C):(-1!==n&&j(e,s("invalid long string delimiter",!0),C),91)}case 61:return N(e),z(e,61)?282:61;case 60:return N(e),z(e,61)?284:z(e,60)?286:60;case 62:return N(e),z(e,61)?283:z(e,62)?287:62;case 47:return N(e),z(e,47)?279:47;case 126:return N(e),z(e,61)?285:126;case 58:return N(e),z(e,58)?288:58;case 34:case 39:return ne(e,e.current,t),C;case 46:return V(e),z(e,46)?z(e,46)?281:280:h(e.current)?Z(e,t):46;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return Z(e,t);case S:return R;default:if(m(e.current)){do{V(e)}while(f(e.current));let n=Y(e,T(e.buff));t.ts=n;let a=ae[v(n)];return void 0!==a&&a<=22?a+I:292}{let t=e.current;return N(e),t}}};e.exports.FIRST_RESERVED=I,e.exports.LUA_ENV=U,e.exports.LexState=class{constructor(){this.current=NaN,this.linenumber=NaN,this.lastline=NaN,this.t=new O,this.lookahead=new O,this.fs=null,this.L=null,this.z=null,this.buff=null,this.h=null,this.dyd=null,this.source=null,this.envn=null}},e.exports.RESERVED=B,e.exports.isreserved=function(e){let t=ae[v(e)];return void 0!==t&&t<=22},e.exports.luaX_lookahead=function(e){return u(e.lookahead.token===R),e.lookahead.token=re(e,e.lookahead.seminfo),e.lookahead.token},e.exports.luaX_newstring=Y,e.exports.luaX_next=function(e){e.lastline=e.linenumber,e.lookahead.token!==R?(e.t.token=e.lookahead.token,e.t.seminfo.i=e.lookahead.seminfo.i,e.t.seminfo.r=e.lookahead.seminfo.r,e.t.seminfo.ts=e.lookahead.seminfo.ts,e.lookahead.token=R):e.t.token=re(e,e.t.seminfo)},e.exports.luaX_setinput=function(e,t,n,a,r){t.t={token:0,seminfo:new k},t.L=e,t.current=r,t.lookahead={token:R,seminfo:new k},t.z=n,t.fs=null,t.linenumber=1,t.lastline=1,t.source=a,t.envn=b(e,U),L(e,t.buff,l)},e.exports.luaX_syntaxerror=function(e,t){j(e,t,e.t.token)},e.exports.luaX_token2str=F,e.exports.luaX_tokens=P},568:(e,t,n)=>{"use strict";const{luai_apicheck:a}=n(947),r=function(e){if(!e)throw Error("assertion failed")};e.exports.lua_assert=r,e.exports.luai_apicheck=a||function(e,t){return r(t)};e.exports.api_check=function(e,t,n){return a(e,t&&n)};e.exports.LUAI_MAXCCALLS=200;e.exports.LUA_MINBUFFER=32;e.exports.luai_nummod=function(e,t,n){let a=t%n;return a*n<0&&(a+=n),a};e.exports.MAX_INT=2147483647;e.exports.MIN_INT=-2147483648},435:(e,t,n)=>{"use strict";const{LUA_OPADD:a,LUA_OPBAND:r,LUA_OPBNOT:i,LUA_OPBOR:s,LUA_OPBXOR:l,LUA_OPDIV:o,LUA_OPIDIV:u,LUA_OPMOD:c,LUA_OPMUL:d,LUA_OPPOW:h,LUA_OPSHL:f,LUA_OPSHR:m,LUA_OPSUB:p,LUA_OPUNM:_,constant_types:{LUA_NUMTAGS:g,LUA_TBOOLEAN:b,LUA_TCCL:w,LUA_TFUNCTION:v,LUA_TLCF:A,LUA_TLCL:y,LUA_TLIGHTUSERDATA:S,LUA_TLNGSTR:T,LUA_TNIL:x,LUA_TNUMBER:E,LUA_TNUMFLT:L,LUA_TNUMINT:I,LUA_TSHRSTR:U,LUA_TSTRING:R,LUA_TTABLE:M,LUA_TTHREAD:C,LUA_TUSERDATA:B},from_userstring:P,luastring_indexOf:k,luastring_of:O,to_jsstring:D,to_luastring:F}=n(775),{lisdigit:G,lisprint:N,lisspace:V,lisxdigit:H}=n(122),Y=n(821),K=n(983),z=n(137),{luaS_bless:q,luaS_new:Z}=n(878),j=n(718),{LUA_COMPAT_FLOATSTRING:X,ldexp:$,lua_integer2str:J,lua_number2str:W}=n(947),Q=n(427),{MAX_INT:ee,luai_nummod:te,lua_assert:ne}=n(568),ae=n(964),re=g,ie=g+1;class se{constructor(e,t){this.type=e,this.value=t}ttype(){return 63&this.type}ttnov(){return 15&this.type}checktag(e){return this.type===e}checktype(e){return this.ttnov()===e}ttisnumber(){return this.checktype(E)}ttisfloat(){return this.checktag(L)}ttisinteger(){return this.checktag(I)}ttisnil(){return this.checktag(x)}ttisboolean(){return this.checktag(b)}ttislightuserdata(){return this.checktag(S)}ttisstring(){return this.checktype(R)}ttisshrstring(){return this.checktag(U)}ttislngstring(){return this.checktag(T)}ttistable(){return this.checktag(M)}ttisfunction(){return this.checktype(v)}ttisclosure(){return(31&this.type)===v}ttisCclosure(){return this.checktag(w)}ttisLclosure(){return this.checktag(y)}ttislcf(){return this.checktag(A)}ttisfulluserdata(){return this.checktag(B)}ttisthread(){return this.checktag(C)}ttisdeadkey(){return this.checktag(ie)}l_isfalse(){return this.ttisnil()||this.ttisboolean()&&!1===this.value}setfltvalue(e){this.type=L,this.value=e}chgfltvalue(e){ne(this.type==L),this.value=e}setivalue(e){this.type=I,this.value=e}chgivalue(e){ne(this.type==I),this.value=e}setnilvalue(){this.type=x,this.value=null}setfvalue(e){this.type=A,this.value=e}setpvalue(e){this.type=S,this.value=e}setbvalue(e){this.type=b,this.value=e}setsvalue(e){this.type=T,this.value=e}setuvalue(e){this.type=B,this.value=e}setthvalue(e){this.type=C,this.value=e}setclLvalue(e){this.type=y,this.value=e}setclCvalue(e){this.type=w,this.value=e}sethvalue(e){this.type=M,this.value=e}setdeadvalue(){this.type=ie,this.value=null}setfrom(e){this.type=e.type,this.value=e.value}tsvalue(){return ne(this.ttisstring()),this.value}svalue(){return this.tsvalue().getstr()}vslen(){return this.tsvalue().tsslen()}jsstring(e,t){return D(this.svalue(),e,t,!0)}}const le=function(e,t,n){e.stack[t].setsvalue(n)},oe=new se(x,null);Object.freeze(oe),e.exports.luaO_nilobject=oe;class ue{constructor(e,t){this.id=e.l_G.id_counter++,this.p=null,this.nupvalues=t,this.upvals=new Array(t)}}class ce{constructor(e,t,n){for(this.id=e.l_G.id_counter++,this.f=t,this.nupvalues=n,this.upvalue=new Array(n);n--;)this.upvalue[n]=new se(x,null)}}class de{constructor(e,t){this.id=e.l_G.id_counter++,this.metatable=null,this.uservalue=new se(x,null),this.len=t,this.data=Object.create(null)}}const he=F("..."),fe=F('[string "'),me=F('"]'),pe=function(e){return G(e)?e-48:(223&e)-55},_e=function(e,t){let n=1;if(ne(t<=1114111),t<128)e[7]=t;else{let a=63;do{e[8-n++]=128|63&t,t>>=6,a>>=1}while(t>a);e[8-n]=~a<<1|t}return n},ge=function(e,t){let n="x"===t?function(e){let t,n=0,a=0,r=0,i=0,s=0,l=!1;for(;V(e[n]);)n++;if(((t=45===e[n])||43===e[n])&&n++,48!==e[n]||120!==e[n+1]&&88!==e[n+1])return null;for(n+=2;;n++)if(46===e[n]){if(l)break;l=!0}else{if(!H(e[n]))break;0===r&&48===e[n]?i++:++r<=30?a=16*a+pe(e[n]):s++,l&&s--}if(i+r===0)return null;if(s*=4,112===e[n]||80===e[n]){let t,a=0;if(n++,((t=45===e[n])||43===e[n])&&n++,!G(e[n]))return null;for(;G(e[n]);)a=10*a+e[n++]-48;t&&(a=-a),s+=a}return t&&(a=-a),{n:$(a,s),i:n}}(e):function(e){try{e=D(e)}catch(e){return null}let t=/^[\t\v\f \n\r]*[+-]?(?:[0-9]+\.?[0-9]*|\.[0-9]*)(?:[eE][+-]?[0-9]+)?/.exec(e);if(!t)return null;let n=parseFloat(t[0]);return isNaN(n)?null:{n,i:t[0].length}}(e);if(null===n)return null;for(;V(e[n.i]);)n.i++;return n.i===e.length||0===e[n.i]?n:null},be=[46,120,88,110,78],we={46:".",120:"x",88:"x",110:"n",78:"n"},ve=Math.floor(ee/10),Ae=ee%10,ye=function(e,t){let n;if(t.ttisinteger())n=F(J(t.value));else{let e=W(t.value);!X&&/^[-0123456789]+$/.test(e)&&(e+=".0"),n=F(e)}t.setsvalue(q(e,n))},Se=function(e,t){K.luaD_inctop(e),le(e,e.top-1,Z(e,t))},Te=function(e,t,n){let a,r=0,i=0,s=0;for(;a=k(t,37,i),-1!=a;){switch(Se(e,t.subarray(i,a)),t[a+1]){case 115:{let t=n[s++];if(null===t)t=F("(null)",!0);else{t=P(t);let e=k(t,0);-1!==e&&(t=t.subarray(0,e))}Se(e,t);break}case 99:{let t=n[s++];N(t)?Se(e,O(t)):xe(e,F("<\\%d>",!0),t);break}case 100:case 73:K.luaD_inctop(e),e.stack[e.top-1].setivalue(n[s++]),ye(e,e.stack[e.top-1]);break;case 102:K.luaD_inctop(e),e.stack[e.top-1].setfltvalue(n[s++]),ye(e,e.stack[e.top-1]);break;case 112:{let t=n[s++];if(t instanceof z.lua_State||t instanceof j.Table||t instanceof de||t instanceof ue||t instanceof ce)Se(e,F("0x"+t.id.toString(16)));else switch(typeof t){case"undefined":Se(e,F("undefined"));break;case"number":Se(e,F("Number("+t+")"));break;case"string":Se(e,F("String("+JSON.stringify(t)+")"));break;case"boolean":Se(e,F(t?"Boolean(true)":"Boolean(false)"));break;case"object":if(null===t){Se(e,F("null"));break}case"function":{let n=e.l_G.ids.get(t);n||(n=e.l_G.id_counter++,e.l_G.ids.set(t,n)),Se(e,F("0x"+n.toString(16)));break}default:Se(e,F("<id NYI>"))}break}case 85:{let t=new Uint8Array(8),a=_e(t,n[s++]);Se(e,t.subarray(8-a));break}case 37:Se(e,F("%",!0));break;default:Y.luaG_runerror(e,F("invalid option '%%%c' to 'lua_pushfstring'"),t[a+1])}r+=2,i=a+2}return K.luaD_checkstack(e,1),Se(e,t.subarray(i)),r>0&&Q.luaV_concat(e,r+1),e.stack[e.top-1].svalue()},xe=function(e,t,...n){return Te(e,t,n)},Ee=function(e,t,n,o){switch(t){case a:return n+o|0;case p:return n-o|0;case d:return Q.luaV_imul(n,o);case c:return Q.luaV_mod(e,n,o);case u:return Q.luaV_div(e,n,o);case r:return n&o;case s:return n|o;case l:return n^o;case f:return Q.luaV_shiftl(n,o);case m:return Q.luaV_shiftl(n,-o);case _:return 0-n|0;case i:return-1^n;default:ne(0)}},Le=function(e,t,n,r){switch(t){case a:return n+r;case p:return n-r;case d:return n*r;case o:return n/r;case h:return Math.pow(n,r);case u:return Math.floor(n/r);case _:return-n;case c:return te(e,n,r);default:ne(0)}};e.exports.CClosure=ce,e.exports.LClosure=ue,e.exports.LUA_TDEADKEY=ie,e.exports.LUA_TPROTO=re,e.exports.LocVar=class{constructor(){this.varname=null,this.startpc=NaN,this.endpc=NaN}},e.exports.TValue=se,e.exports.Udata=de,e.exports.UTF8BUFFSZ=8,e.exports.luaO_arith=function(e,t,n,u,c){let d="number"==typeof c?e.stack[c]:c;switch(t){case r:case s:case l:case f:case m:case i:{let a,r;if(!1!==(a=Q.tointeger(n))&&!1!==(r=Q.tointeger(u)))return void d.setivalue(Ee(e,t,a,r));break}case o:case h:{let a,r;if(!1!==(a=Q.tonumber(n))&&!1!==(r=Q.tonumber(u)))return void d.setfltvalue(Le(e,t,a,r));break}default:{let a,r;if(n.ttisinteger()&&u.ttisinteger())return void d.setivalue(Ee(e,t,n.value,u.value));if(!1!==(a=Q.tonumber(n))&&!1!==(r=Q.tonumber(u)))return void d.setfltvalue(Le(e,t,a,r));break}}ne(null!==e),ae.luaT_trybinTM(e,n,u,c,t-a+ae.TMS.TM_ADD)},e.exports.luaO_chunkid=function(e,t){let n,a=e.length;if(61===e[0])a<t?(n=new Uint8Array(a-1),n.set(e.subarray(1))):(n=new Uint8Array(t),n.set(e.subarray(1,t+1)));else if(64===e[0])a<=t?(n=new Uint8Array(a-1),n.set(e.subarray(1))):(n=new Uint8Array(t),n.set(he),t-=he.length,n.set(e.subarray(a-t),he.length));else{n=new Uint8Array(t);let r=k(e,10);n.set(fe);let i=fe.length;a<(t-=fe.length+he.length+me.length)&&-1===r?(n.set(e,i),i+=e.length):(-1!==r&&(a=r),a>t&&(a=t),n.set(e.subarray(0,a),i),i+=a,n.set(he,i),i+=he.length),n.set(me,i),i+=me.length,n=n.subarray(0,i)}return n},e.exports.luaO_hexavalue=pe,e.exports.luaO_int2fb=function(e){let t=0;if(e<8)return e;for(;e>=128;)e=e+15>>4,t+=4;for(;e>=16;)e=e+1>>1,t++;return t+1<<3|e-8},e.exports.luaO_pushfstring=xe,e.exports.luaO_pushvfstring=Te,e.exports.luaO_str2num=function(e,t){let n=function(e){let t,n=0,a=0,r=!0;for(;V(e[n]);)n++;if(((t=45===e[n])||43===e[n])&&n++,48!==e[n]||120!==e[n+1]&&88!==e[n+1])for(;n<e.length&&G(e[n]);n++){let i=e[n]-48;if(a>=ve&&(a>ve||i>Ae+t))return null;a=10*a+i|0,r=!1}else for(n+=2;n<e.length&&H(e[n]);n++)a=16*a+pe(e[n])|0,r=!1;for(;n<e.length&&V(e[n]);)n++;return r||n!==e.length&&0!==e[n]?null:{n:0|(t?-a:a),i:n}}(e);return null!==n?(t.setivalue(n.n),n.i+1):(n=function(e){let t=e.length,n=0;for(let a=0;a<t;a++){let t=e[a];if(-1!==be.indexOf(t)){n=t;break}}let a=we[n];return"n"===a?null:ge(e,a)}(e),null!==n?(t.setfltvalue(n.n),n.i+1):0)},e.exports.luaO_tostring=ye,e.exports.luaO_utf8esc=_e,e.exports.numarith=Le,e.exports.pushobj2s=function(e,t){e.stack[e.top++]=new se(t.type,t.value)},e.exports.pushsvalue2s=function(e,t){e.stack[e.top++]=new se(T,t)},e.exports.setobjs2s=function(e,t,n){e.stack[t].setfrom(e.stack[n])},e.exports.setobj2s=function(e,t,n){e.stack[t].setfrom(n)},e.exports.setsvalue2s=le},159:e=>{"use strict";const t=[96,113,65,84,80,80,92,108,60,16,60,84,108,124,124,124,124,124,124,124,124,124,124,124,124,96,96,96,96,104,34,188,188,188,132,228,84,84,16,98,98,4,98,20,81,80,23],n=18,a=14,r=a,i=262143,s=131071,l=256,o=function(e,t){return~(-1<<e)<<t},u=function(e,t){return~o(e,t)},c=function(e,t,n,a){return e.code=e.code&u(a,n)|t<<n&o(a,n),h(e)},d=function(e,t){return c(e,t,r,n)},h=function(e){if("number"==typeof e)return{code:e,opcode:e>>0&o(6,0),A:e>>6&o(8,0),B:e>>23&o(9,0),C:e>>a&o(9,0),Bx:e>>r&o(n,0),Ax:e>>6&o(26,0),sBx:(e>>r&o(n,0))-s};{let t=e.code;return e.opcode=t>>0&o(6,0),e.A=t>>6&o(8,0),e.B=t>>23&o(9,0),e.C=t>>a&o(9,0),e.Bx=t>>r&o(n,0),e.Ax=t>>6&o(26,0),e.sBx=(t>>r&o(n,0))-s,e}};e.exports.BITRK=l,e.exports.CREATE_ABC=function(e,t,n,r){return h(e<<0|t<<6|n<<23|r<<a)},e.exports.CREATE_ABx=function(e,t,n){return h(e<<0|t<<6|n<<r)},e.exports.CREATE_Ax=function(e,t){return h(e<<0|t<<6)},e.exports.GET_OPCODE=function(e){return e.opcode},e.exports.GETARG_A=function(e){return e.A},e.exports.GETARG_B=function(e){return e.B},e.exports.GETARG_C=function(e){return e.C},e.exports.GETARG_Bx=function(e){return e.Bx},e.exports.GETARG_Ax=function(e){return e.Ax},e.exports.GETARG_sBx=function(e){return e.sBx},e.exports.INDEXK=function(e){return-257&e},e.exports.ISK=function(e){return e&l},e.exports.LFIELDS_PER_FLUSH=50,e.exports.MAXARG_A=255,e.exports.MAXARG_Ax=67108863,e.exports.MAXARG_B=511,e.exports.MAXARG_Bx=i,e.exports.MAXARG_C=511,e.exports.MAXARG_sBx=s,e.exports.MAXINDEXRK=255,e.exports.NO_REG=255,e.exports.OpArgK=3,e.exports.OpArgN=0,e.exports.OpArgR=2,e.exports.OpArgU=1,e.exports.OpCodes=["MOVE","LOADK","LOADKX","LOADBOOL","LOADNIL","GETUPVAL","GETTABUP","GETTABLE","SETTABUP","SETUPVAL","SETTABLE","NEWTABLE","SELF","ADD","SUB","MUL","MOD","POW","DIV","IDIV","BAND","BOR","BXOR","SHL","SHR","UNM","BNOT","NOT","LEN","CONCAT","JMP","EQ","LT","LE","TEST","TESTSET","CALL","TAILCALL","RETURN","FORLOOP","FORPREP","TFORCALL","TFORLOOP","SETLIST","CLOSURE","VARARG","EXTRAARG"],e.exports.OpCodesI={OP_MOVE:0,OP_LOADK:1,OP_LOADKX:2,OP_LOADBOOL:3,OP_LOADNIL:4,OP_GETUPVAL:5,OP_GETTABUP:6,OP_GETTABLE:7,OP_SETTABUP:8,OP_SETUPVAL:9,OP_SETTABLE:10,OP_NEWTABLE:11,OP_SELF:12,OP_ADD:13,OP_SUB:14,OP_MUL:15,OP_MOD:16,OP_POW:17,OP_DIV:18,OP_IDIV:19,OP_BAND:20,OP_BOR:21,OP_BXOR:22,OP_SHL:23,OP_SHR:24,OP_UNM:25,OP_BNOT:26,OP_NOT:27,OP_LEN:28,OP_CONCAT:29,OP_JMP:30,OP_EQ:31,OP_LT:32,OP_LE:33,OP_TEST:34,OP_TESTSET:35,OP_CALL:36,OP_TAILCALL:37,OP_RETURN:38,OP_FORLOOP:39,OP_FORPREP:40,OP_TFORCALL:41,OP_TFORLOOP:42,OP_SETLIST:43,OP_CLOSURE:44,OP_VARARG:45,OP_EXTRAARG:46},e.exports.POS_A=6,e.exports.POS_Ax=6,e.exports.POS_B=23,e.exports.POS_Bx=r,e.exports.POS_C=a,e.exports.POS_OP=0,e.exports.RKASK=function(e){return e|l},e.exports.SETARG_A=function(e,t){return c(e,t,6,8)},e.exports.SETARG_Ax=function(e,t){return c(e,t,6,26)},e.exports.SETARG_B=function(e,t){return c(e,t,23,9)},e.exports.SETARG_Bx=d,e.exports.SETARG_C=function(e,t){return c(e,t,a,9)},e.exports.SETARG_sBx=function(e,t){return d(e,t+s)},e.exports.SET_OPCODE=function(e,t){return e.code=e.code&u(6,0)|t<<0&o(6,0),h(e)},e.exports.SIZE_A=8,e.exports.SIZE_Ax=26,e.exports.SIZE_B=9,e.exports.SIZE_Bx=n,e.exports.SIZE_C=9,e.exports.SIZE_OP=6,e.exports.fullins=h,e.exports.getBMode=function(e){return t[e]>>4&3},e.exports.getCMode=function(e){return t[e]>>2&3},e.exports.getOpMode=function(e){return 3&t[e]},e.exports.iABC=0,e.exports.iABx=1,e.exports.iAsBx=2,e.exports.iAx=3,e.exports.testAMode=function(e){return 64&t[e]},e.exports.testTMode=function(e){return 128&t[e]}},391:(e,t,n)=>{"use strict";const{LUA_MULTRET:a,to_luastring:r}=n(775),{BinOpr:{OPR_ADD:i,OPR_AND:s,OPR_BAND:l,OPR_BOR:o,OPR_BXOR:u,OPR_CONCAT:c,OPR_DIV:d,OPR_EQ:h,OPR_GE:f,OPR_GT:m,OPR_IDIV:p,OPR_LE:_,OPR_LT:g,OPR_MOD:b,OPR_MUL:w,OPR_NE:v,OPR_NOBINOPR:A,OPR_OR:y,OPR_POW:S,OPR_SHL:T,OPR_SHR:x,OPR_SUB:E},UnOpr:{OPR_BNOT:L,OPR_LEN:I,OPR_MINUS:U,OPR_NOT:R,OPR_NOUNOPR:M},NO_JUMP:C,getinstruction:B,luaK_checkstack:P,luaK_codeABC:k,luaK_codeABx:O,luaK_codeAsBx:D,luaK_codek:F,luaK_concat:G,luaK_dischargevars:N,luaK_exp2RK:V,luaK_exp2anyreg:H,luaK_exp2anyregup:Y,luaK_exp2nextreg:K,luaK_exp2val:z,luaK_fixline:q,luaK_getlabel:Z,luaK_goiffalse:j,luaK_goiftrue:X,luaK_indexed:$,luaK_infix:J,luaK_intK:W,luaK_jump:Q,luaK_jumpto:ee,luaK_nil:te,luaK_patchclose:ne,luaK_patchlist:ae,luaK_patchtohere:re,luaK_posfix:ie,luaK_prefix:se,luaK_reserveregs:le,luaK_ret:oe,luaK_self:ue,luaK_setlist:ce,luaK_setmultret:de,luaK_setoneret:he,luaK_setreturns:fe,luaK_storevar:me,luaK_stringK:pe}=n(807),_e=n(983),ge=n(897),be=n(278),{LUAI_MAXCCALLS:we,MAX_INT:ve,lua_assert:Ae}=n(568),ye=n(435),{OpCodesI:{OP_CALL:Se,OP_CLOSURE:Te,OP_FORLOOP:xe,OP_FORPREP:Ee,OP_GETUPVAL:Le,OP_MOVE:Ie,OP_NEWTABLE:Ue,OP_SETTABLE:Re,OP_TAILCALL:Me,OP_TFORCALL:Ce,OP_TFORLOOP:Be,OP_VARARG:Pe},LFIELDS_PER_FLUSH:ke,SETARG_B:Oe,SETARG_C:De,SET_OPCODE:Fe}=n(159),{luaS_eqlngstr:Ge,luaS_new:Ne,luaS_newliteral:Ve}=n(878),He=n(718),Ye=ge.Proto,Ke=be.RESERVED,ze=function(e){return e===je.VCALL||e===je.VVARARG},qe=function(e,t){return Ge(e,t)};class Ze{constructor(){this.previous=null,this.firstlabel=NaN,this.firstgoto=NaN,this.nactvar=NaN,this.upval=NaN,this.isloop=NaN}}const je={VVOID:0,VNIL:1,VTRUE:2,VFALSE:3,VK:4,VKFLT:5,VKINT:6,VNONRELOC:7,VLOCAL:8,VUPVAL:9,VINDEXED:10,VJMP:11,VRELOCABLE:12,VCALL:13,VVARARG:14};class Xe{constructor(){this.k=NaN,this.u={ival:NaN,nval:NaN,info:NaN,ind:{idx:NaN,t:NaN,vt:NaN}},this.t=NaN,this.f=NaN}to(e){this.k=e.k,this.u=e.u,this.t=e.t,this.f=e.f}}class $e{constructor(){this.f=null,this.prev=null,this.ls=null,this.bl=null,this.pc=NaN,this.lasttarget=NaN,this.jpc=NaN,this.nk=NaN,this.np=NaN,this.firstlocal=NaN,this.nlocvars=NaN,this.nactvar=NaN,this.nups=NaN,this.freereg=NaN}}class Je{constructor(){this.idx=NaN}}class We{constructor(){this.name=null,this.pc=NaN,this.line=NaN,this.nactvar=NaN}}class Qe{constructor(){this.arr=[],this.n=NaN,this.size=NaN}}const et=function(e,t){e.t.token=0,be.luaX_syntaxerror(e,t)},tt=function(e,t){be.luaX_syntaxerror(e,ye.luaO_pushfstring(e.L,r("%s expected",!0),be.luaX_token2str(e,t)))},nt=function(e,t,n,a){t>n&&function(e,t,n){let a=e.ls.L,i=e.f.linedefined,s=0===i?r("main function",!0):ye.luaO_pushfstring(a,r("function at line %d",!0),i),l=ye.luaO_pushfstring(a,r("too many %s (limit is %d) in %s",!0),n,t,s);be.luaX_syntaxerror(e.ls,l)}(e,n,a)},at=function(e,t){return e.t.token===t&&(be.luaX_next(e),!0)},rt=function(e,t){e.t.token!==t&&tt(e,t)},it=function(e,t){rt(e,t),be.luaX_next(e)},st=function(e,t,n){t||be.luaX_syntaxerror(e,n)},lt=function(e,t,n,a){at(e,t)||(a===e.linenumber?tt(e,t):be.luaX_syntaxerror(e,ye.luaO_pushfstring(e.L,r("%s expected (to close %s at line %d)"),be.luaX_token2str(e,t),be.luaX_token2str(e,n),a)))},ot=function(e){rt(e,Ke.TK_NAME);let t=e.t.seminfo.ts;return be.luaX_next(e),t},ut=function(e,t,n){e.f=e.t=C,e.k=t,e.u.info=n},ct=function(e,t,n){ut(t,je.VK,pe(e.fs,n))},dt=function(e,t){ct(e,t,ot(e))},ht=function(e,t){let n=e.fs,a=e.dyd,i=function(e,t){let n=e.fs,a=n.f;return a.locvars[n.nlocvars]=new ye.LocVar,a.locvars[n.nlocvars].varname=t,n.nlocvars++}(e,t);nt(n,a.actvar.n+1-n.firstlocal,200,r("local variables",!0)),a.actvar.arr[a.actvar.n]=new Je,a.actvar.arr[a.actvar.n].idx=i,a.actvar.n++},ft=function(e,t){ht(e,be.luaX_newstring(e,r(t,!0)))},mt=function(e,t){let n=e.ls.dyd.actvar.arr[e.firstlocal+t].idx;return Ae(n<e.nlocvars),e.f.locvars[n]},pt=function(e,t){let n=e.fs;for(n.nactvar=n.nactvar+t;t;t--)mt(n,n.nactvar-t).startpc=n.pc},_t=function(e,t,n){let a=e.f;return nt(e,e.nups+1,ge.MAXUPVAL,r("upvalues",!0)),a.upvalues[e.nups]={instack:n.k===je.VLOCAL,idx:n.u.info,name:t},e.nups++},gt=function(e,t,n,a){if(null===e)ut(n,je.VVOID,0);else{let r=function(e,t){for(let n=e.nactvar-1;n>=0;n--)if(qe(t,mt(e,n).varname))return n;return-1}(e,t);if(r>=0)ut(n,je.VLOCAL,r),a||function(e,t){let n=e.bl;for(;n.nactvar>t;)n=n.previous;n.upval=1}(e,r);else{let a=function(e,t){let n=e.f.upvalues;for(let a=0;a<e.nups;a++)if(qe(n[a].name,t))return a;return-1}(e,t);if(a<0){if(gt(e.prev,t,n,0),n.k===je.VVOID)return;a=_t(e,t,n)}ut(n,je.VUPVAL,a)}}},bt=function(e,t){let n=ot(e),a=e.fs;if(gt(a,n,t,1),t.k===je.VVOID){let r=new Xe;gt(a,e.envn,t,1),Ae(t.k!==je.VVOID),ct(e,r,n),$(a,t,r)}},wt=function(e,t,n,a){let r=e.fs,i=t-n;if(ze(a.k))i++,i<0&&(i=0),fe(r,a,i),i>1&&le(r,i-1);else if(a.k!==je.VVOID&&K(r,a),i>0){let e=r.freereg;le(r,i),te(r,e,i)}n>t&&(e.fs.freereg-=n-t)},vt=function(e){let t=e.L;++t.nCcalls,nt(e.fs,t.nCcalls,we,r("JS levels",!0))},At=function(e){return e.L.nCcalls--},yt=function(e,t,n){let a=e.fs,i=e.dyd.gt,s=i.arr[t];if(Ae(qe(s.name,n.name)),s.nactvar<n.nactvar){let t=mt(a,s.nactvar).varname,n=ye.luaO_pushfstring(e.L,r("<goto %s> at line %d jumps into the scope of local '%s'"),s.name.getstr(),s.line,t.getstr());et(e,n)}ae(a,s.pc,n.pc);for(let e=t;e<i.n-1;e++)i.arr[e]=i.arr[e+1];i.n--},St=function(e,t){let n=e.fs.bl,a=e.dyd,r=a.gt.arr[t];for(let i=n.firstlabel;i<a.label.n;i++){let s=a.label.arr[i];if(qe(s.name,r.name))return r.nactvar>s.nactvar&&(n.upval||a.label.n>n.firstlabel)&&ne(e.fs,r.pc,s.nactvar),yt(e,t,s),!0}return!1},Tt=function(e,t,n,a,r){let i=t.n;return t.arr[i]=new We,t.arr[i].name=n,t.arr[i].line=a,t.arr[i].nactvar=e.fs.nactvar,t.arr[i].pc=r,t.n=i+1,i},xt=function(e,t){let n=e.dyd.gt,a=e.fs.bl.firstgoto;for(;a<n.n;)qe(n.arr[a].name,t.name)?yt(e,a,t):a++},Et=function(e,t,n){t.isloop=n,t.nactvar=e.nactvar,t.firstlabel=e.ls.dyd.label.n,t.firstgoto=e.ls.dyd.gt.n,t.upval=0,t.previous=e.bl,e.bl=t,Ae(e.freereg===e.nactvar)},Lt=function(e,t,n){t.prev=e.fs,t.ls=e,e.fs=t,t.pc=0,t.lasttarget=0,t.jpc=C,t.freereg=0,t.nk=0,t.np=0,t.nups=0,t.nlocvars=0,t.nactvar=0,t.firstlocal=e.dyd.actvar.n,t.bl=null;let a=t.f;a.source=e.source,a.maxstacksize=2,Et(t,n,!1)},It=function(e){let t=e.bl,n=e.ls;if(t.previous&&t.upval){let n=Q(e);ne(e,n,t.nactvar),re(e,n)}t.isloop&&function(e){let t=Ve(e.L,"break"),n=Tt(e,e.dyd.label,t,0,e.fs.pc);xt(e,e.dyd.label.arr[n])}(n),e.bl=t.previous,function(e,t){for(e.ls.dyd.actvar.n-=e.nactvar-t;e.nactvar>t;)mt(e,--e.nactvar).endpc=e.pc}(e,t.nactvar),Ae(t.nactvar===e.nactvar),e.freereg=e.nactvar,n.dyd.label.n=t.firstlabel,t.previous?function(e,t){let n=t.firstgoto,a=e.ls.dyd.gt;for(;n<a.n;){let r=a.arr[n];r.nactvar>t.nactvar&&(t.upval&&ne(e,r.pc,t.nactvar),r.nactvar=t.nactvar),St(e.ls,n)||n++}}(e,t):t.firstgoto<n.dyd.gt.n&&function(e,t){let n=be.isreserved(t.name)?"<%s> at line %d not inside a loop":"no visible label '%s' for <goto> at line %d";n=ye.luaO_pushfstring(e.L,r(n),t.name.getstr(),t.line),et(e,n)}(n,n.dyd.gt.arr[t.firstgoto])},Ut=function(e){let t=e.fs;oe(t,0,0),It(t),Ae(null===t.bl),e.fs=t.prev},Rt=function(e,t){switch(e.t.token){case Ke.TK_ELSE:case Ke.TK_ELSEIF:case Ke.TK_END:case Ke.TK_EOS:return!0;case Ke.TK_UNTIL:return t;default:return!1}},Mt=function(e){for(;!Rt(e,1);){if(e.t.token===Ke.TK_RETURN)return void rn(e);rn(e)}},Ct=function(e,t){let n=e.fs,a=new Xe;Y(n,t),be.luaX_next(e),dt(e,a),$(n,t,a)},Bt=function(e,t){be.luaX_next(e),qt(e,t),z(e.fs,t),it(e,93)};class Pt{constructor(){this.v=new Xe,this.t=new Xe,this.nh=NaN,this.na=NaN,this.tostore=NaN}}const kt=function(e,t){let n=e.fs,a=e.fs.freereg,i=new Xe,s=new Xe;e.t.token===Ke.TK_NAME?(nt(n,t.nh,ve,r("items in a constructor",!0)),dt(e,i)):Bt(e,i),t.nh++,it(e,61);let l=V(n,i);qt(e,s),k(n,Re,t.t.u.info,l,V(n,s)),n.freereg=a},Ot=function(e,t){t.v.k!==je.VVOID&&(K(e,t.v),t.v.k=je.VVOID,t.tostore===ke&&(ce(e,t.t.u.info,t.na,t.tostore),t.tostore=0))},Dt=function(e,t){qt(e,t.v),nt(e.fs,t.na,ve,r("items in a constructor",!0)),t.na++,t.tostore++},Ft=function(e,t){switch(e.t.token){case Ke.TK_NAME:61!==be.luaX_lookahead(e)?Dt(e,t):kt(e,t);break;case 91:kt(e,t);break;default:Dt(e,t)}},Gt=function(e,t){let n=e.fs,r=e.linenumber,i=k(n,Ue,0,0,0),s=new Pt;s.na=s.nh=s.tostore=0,s.t=t,ut(t,je.VRELOCABLE,i),ut(s.v,je.VVOID,0),K(e.fs,t),it(e,123);do{if(Ae(s.v.k===je.VVOID||s.tostore>0),125===e.t.token)break;Ot(n,s),Ft(e,s)}while(at(e,44)||at(e,59));lt(e,125,123,r),function(e,t){0!==t.tostore&&(ze(t.v.k)?(de(e,t.v),ce(e,t.t.u.info,t.na,a),t.na--):(t.v.k!==je.VVOID&&K(e,t.v),ce(e,t.t.u.info,t.na,t.tostore)))}(n,s),Oe(n.f.code[i],ye.luaO_int2fb(s.na)),De(n.f.code[i],ye.luaO_int2fb(s.nh))},Nt=function(e,t,n,a){let i=new $e,s=new Ze;i.f=function(e){let t=e.L,n=new Ye(t),a=e.fs;return a.f.p[a.np++]=n,n}(e),i.f.linedefined=a,Lt(e,i,s),it(e,40),n&&(ft(e,"self"),pt(e,1)),function(e){let t=e.fs,n=t.f,a=0;if(n.is_vararg=!1,41!==e.t.token)do{switch(e.t.token){case Ke.TK_NAME:ht(e,ot(e)),a++;break;case Ke.TK_DOTS:be.luaX_next(e),n.is_vararg=!0;break;default:be.luaX_syntaxerror(e,r("<name> or '...' expected",!0))}}while(!n.is_vararg&&at(e,44));pt(e,a),n.numparams=t.nactvar,le(t,t.nactvar)}(e),it(e,41),Mt(e),i.f.lastlinedefined=e.linenumber,lt(e,Ke.TK_END,Ke.TK_FUNCTION,a),function(e,t){let n=e.fs.prev;ut(t,je.VRELOCABLE,O(n,Te,0,n.np-1)),K(n,t)}(e,t),Ut(e)},Vt=function(e,t){let n=1;for(qt(e,t);at(e,44);)K(e.fs,t),qt(e,t),n++;return n},Ht=function(e,t,n){let i,s=e.fs,l=new Xe;switch(e.t.token){case 40:be.luaX_next(e),41===e.t.token?l.k=je.VVOID:(Vt(e,l),de(s,l)),lt(e,41,40,n);break;case 123:Gt(e,l);break;case Ke.TK_STRING:ct(e,l,e.t.seminfo.ts),be.luaX_next(e);break;default:be.luaX_syntaxerror(e,r("function arguments expected",!0))}Ae(t.k===je.VNONRELOC);let o=t.u.info;ze(l.k)?i=a:(l.k!==je.VVOID&&K(s,l),i=s.freereg-(o+1)),ut(t,je.VCALL,k(s,Se,o,i+1,2)),q(s,n),s.freereg=o+1},Yt=function(e,t){let n=e.fs,a=e.linenumber;for(!function(e,t){switch(e.t.token){case 40:{let n=e.linenumber;return be.luaX_next(e),qt(e,t),lt(e,41,40,n),void N(e.fs,t)}case Ke.TK_NAME:return void bt(e,t);default:be.luaX_syntaxerror(e,r("unexpected symbol",!0))}}(e,t);;)switch(e.t.token){case 46:Ct(e,t);break;case 91:{let a=new Xe;Y(n,t),Bt(e,a),$(n,t,a);break}case 58:{let r=new Xe;be.luaX_next(e),dt(e,r),ue(n,t,r),Ht(e,t,a);break}case 40:case Ke.TK_STRING:case 123:K(n,t),Ht(e,t,a);break;default:return}},Kt=[{left:10,right:10},{left:10,right:10},{left:11,right:11},{left:11,right:11},{left:14,right:13},{left:11,right:11},{left:11,right:11},{left:6,right:6},{left:4,right:4},{left:5,right:5},{left:7,right:7},{left:7,right:7},{left:9,right:8},{left:3,right:3},{left:3,right:3},{left:3,right:3},{left:3,right:3},{left:3,right:3},{left:3,right:3},{left:2,right:2},{left:1,right:1}],zt=function(e,t,n){vt(e);let a=function(e){switch(e){case Ke.TK_NOT:return R;case 45:return U;case 126:return L;case 35:return I;default:return M}}(e.t.token);if(a!==M){let n=e.linenumber;be.luaX_next(e),zt(e,t,12),se(e.fs,a,t,n)}else!function(e,t){switch(e.t.token){case Ke.TK_FLT:ut(t,je.VKFLT,0),t.u.nval=e.t.seminfo.r;break;case Ke.TK_INT:ut(t,je.VKINT,0),t.u.ival=e.t.seminfo.i;break;case Ke.TK_STRING:ct(e,t,e.t.seminfo.ts);break;case Ke.TK_NIL:ut(t,je.VNIL,0);break;case Ke.TK_TRUE:ut(t,je.VTRUE,0);break;case Ke.TK_FALSE:ut(t,je.VFALSE,0);break;case Ke.TK_DOTS:{let n=e.fs;st(e,n.f.is_vararg,r("cannot use '...' outside a vararg function",!0)),ut(t,je.VVARARG,k(n,Pe,0,1,0));break}case 123:return void Gt(e,t);case Ke.TK_FUNCTION:return be.luaX_next(e),void Nt(e,t,0,e.linenumber);default:return void Yt(e,t)}be.luaX_next(e)}(e,t);let C=function(e){switch(e){case 43:return i;case 45:return E;case 42:return w;case 37:return b;case 94:return S;case 47:return d;case Ke.TK_IDIV:return p;case 38:return l;case 124:return o;case 126:return u;case Ke.TK_SHL:return T;case Ke.TK_SHR:return x;case Ke.TK_CONCAT:return c;case Ke.TK_NE:return v;case Ke.TK_EQ:return h;case 60:return g;case Ke.TK_LE:return _;case 62:return m;case Ke.TK_GE:return f;case Ke.TK_AND:return s;case Ke.TK_OR:return y;default:return A}}(e.t.token);for(;C!==A&&Kt[C].left>n;){let n=new Xe,a=e.linenumber;be.luaX_next(e),J(e.fs,C,t);let r=zt(e,n,Kt[C].right);ie(e.fs,C,t,n,a),C=r}return At(e),C},qt=function(e,t){zt(e,t,0)},Zt=function(e){let t=e.fs,n=new Ze;Et(t,n,0),Mt(e),It(t)};class jt{constructor(){this.prev=null,this.v=new Xe}}const Xt=function(e,t,n){let a=new Xe;var i;if(st(e,(i=t.v.k,je.VLOCAL<=i&&i<=je.VINDEXED),r("syntax error",!0)),at(e,44)){let a=new jt;a.prev=t,Yt(e,a.v),a.v.k!==je.VINDEXED&&function(e,t,n){let a=e.fs,r=a.freereg,i=!1;for(;t;t=t.prev)t.v.k===je.VINDEXED&&(t.v.u.ind.vt===n.k&&t.v.u.ind.t===n.u.info&&(i=!0,t.v.u.ind.vt=je.VLOCAL,t.v.u.ind.t=r),n.k===je.VLOCAL&&t.v.u.ind.idx===n.u.info&&(i=!0,t.v.u.ind.idx=r));if(i){let e=n.k===je.VLOCAL?Ie:Le;k(a,e,r,n.u.info,0),le(a,1)}}(e,t,a.v),nt(e.fs,n+e.L.nCcalls,we,r("JS levels",!0)),Xt(e,a,n+1)}else{it(e,61);let r=Vt(e,a);if(r===n)return he(e.fs,a),void me(e.fs,t.v,a);wt(e,n,r,a)}ut(a,je.VNONRELOC,e.fs.freereg-1),me(e.fs,t.v,a)},$t=function(e){let t=new Xe;return qt(e,t),t.k===je.VNIL&&(t.k=je.VFALSE),X(e.fs,t),t.f},Jt=function(e,t){let n,a=e.linenumber;at(e,Ke.TK_GOTO)?n=ot(e):(be.luaX_next(e),n=Ve(e.L,"break"));let r=Tt(e,e.dyd.gt,n,a,t);St(e,r)},Wt=function(e,t,n){let a,i=e.fs,s=e.dyd.label;!function(e,t,n){for(let a=e.bl.firstlabel;a<t.n;a++)if(qe(n,t.arr[a].name)){let i=ye.luaO_pushfstring(e.ls.L,r("label '%s' already defined on line %d",!0),n.getstr(),t.arr[a].line);et(e.ls,i)}}(i,s,t),it(e,Ke.TK_DBCOLON),a=Tt(e,s,t,n,Z(i)),function(e){for(;59===e.t.token||e.t.token===Ke.TK_DBCOLON;)rn(e)}(e),Rt(e,0)&&(s.arr[a].nactvar=i.bl.nactvar),xt(e,s.arr[a])},Qt=function(e){let t=new Xe;return qt(e,t),K(e.fs,t),Ae(t.k===je.VNONRELOC),t.u.info},en=function(e,t,n,a,r){let i,s=new Ze,l=e.fs;pt(e,3),it(e,Ke.TK_DO);let o=r?D(l,Ee,t,C):Q(l);Et(l,s,0),pt(e,a),le(l,a),Zt(e),It(l),re(l,o),r?i=D(l,xe,t,C):(k(l,Ce,t,0,a),q(l,n),i=D(l,Be,t+2,C)),ae(l,i,o+1),q(l,n)},tn=function(e,t){let n=e.fs,a=new Ze;Et(n,a,1),be.luaX_next(e);let i=ot(e);switch(e.t.token){case 61:!function(e,t,n){let a=e.fs,r=a.freereg;ft(e,"(for index)"),ft(e,"(for limit)"),ft(e,"(for step)"),ht(e,t),it(e,61),Qt(e),it(e,44),Qt(e),at(e,44)?Qt(e):(F(a,a.freereg,W(a,1)),le(a,1)),en(e,r,n,1,1)}(e,i,t);break;case 44:case Ke.TK_IN:!function(e,t){let n=e.fs,a=new Xe,r=4,i=n.freereg;for(ft(e,"(for generator)"),ft(e,"(for state)"),ft(e,"(for control)"),ht(e,t);at(e,44);)ht(e,ot(e)),r++;it(e,Ke.TK_IN);let s=e.linenumber;wt(e,3,Vt(e,a),a),P(n,3),en(e,i,s,r-3,0)}(e,i);break;default:be.luaX_syntaxerror(e,r("'=' or 'in' expected",!0))}lt(e,Ke.TK_END,Ke.TK_FOR,t),It(n)},nn=function(e,t){let n,a=new Ze,r=e.fs,i=new Xe;if(be.luaX_next(e),qt(e,i),it(e,Ke.TK_THEN),e.t.token===Ke.TK_GOTO||e.t.token===Ke.TK_BREAK){for(j(e.fs,i),Et(r,a,!1),Jt(e,i.t);at(e,59););if(Rt(e,0))return It(r),t;n=Q(r)}else X(e.fs,i),Et(r,a,!1),n=i.f;return Mt(e),It(r),e.t.token!==Ke.TK_ELSE&&e.t.token!==Ke.TK_ELSEIF||(t=G(r,t,Q(r))),re(r,n),t},an=function(e,t){let n=new Xe,a=new Xe;be.luaX_next(e);let r=function(e,t){let n=0;for(bt(e,t);46===e.t.token;)Ct(e,t);return 58===e.t.token&&(n=1,Ct(e,t)),n}(e,n);Nt(e,a,r,t),me(e.fs,n,a),q(e.fs,t)},rn=function(e){let t=e.linenumber;switch(vt(e),e.t.token){case 59:be.luaX_next(e);break;case Ke.TK_IF:!function(e,t){let n=e.fs,a=C;for(a=nn(e,a);e.t.token===Ke.TK_ELSEIF;)a=nn(e,a);at(e,Ke.TK_ELSE)&&Zt(e),lt(e,Ke.TK_END,Ke.TK_IF,t),re(n,a)}(e,t);break;case Ke.TK_WHILE:!function(e,t){let n=e.fs,a=new Ze;be.luaX_next(e);let r=Z(n),i=$t(e);Et(n,a,1),it(e,Ke.TK_DO),Zt(e),ee(n,r),lt(e,Ke.TK_END,Ke.TK_WHILE,t),It(n),re(n,i)}(e,t);break;case Ke.TK_DO:be.luaX_next(e),Zt(e),lt(e,Ke.TK_END,Ke.TK_DO,t);break;case Ke.TK_FOR:tn(e,t);break;case Ke.TK_REPEAT:!function(e,t){let n=e.fs,a=Z(n),r=new Ze,i=new Ze;Et(n,r,1),Et(n,i,0),be.luaX_next(e),Mt(e),lt(e,Ke.TK_UNTIL,Ke.TK_REPEAT,t);let s=$t(e);i.upval&&ne(n,s,i.nactvar),It(n),ae(n,s,a),It(n)}(e,t);break;case Ke.TK_FUNCTION:an(e,t);break;case Ke.TK_LOCAL:be.luaX_next(e),at(e,Ke.TK_FUNCTION)?function(e){let t=new Xe,n=e.fs;ht(e,ot(e)),pt(e,1),Nt(e,t,0,e.linenumber),mt(n,t.u.info).startpc=n.pc}(e):function(e){let t,n=0,a=new Xe;do{ht(e,ot(e)),n++}while(at(e,44));at(e,61)?t=Vt(e,a):(a.k=je.VVOID,t=0),wt(e,n,t,a),pt(e,n)}(e);break;case Ke.TK_DBCOLON:be.luaX_next(e),Wt(e,ot(e),t);break;case Ke.TK_RETURN:be.luaX_next(e),function(e){let t,n,r=e.fs,i=new Xe;Rt(e,1)||59===e.t.token?t=n=0:(n=Vt(e,i),ze(i.k)?(de(r,i),i.k===je.VCALL&&1===n&&(Fe(B(r,i),Me),Ae(B(r,i).A===r.nactvar)),t=r.nactvar,n=a):1===n?t=H(r,i):(K(r,i),t=r.nactvar,Ae(n===r.freereg-t))),oe(r,t,n),at(e,59)}(e);break;case Ke.TK_BREAK:case Ke.TK_GOTO:Jt(e,Q(e.fs));break;default:!function(e){let t=e.fs,n=new jt;Yt(e,n.v),61===e.t.token||44===e.t.token?(n.prev=null,Xt(e,n,1)):(st(e,n.v.k===je.VCALL,r("syntax error",!0)),De(B(t,n.v),1))}(e)}Ae(e.fs.f.maxstacksize>=e.fs.freereg&&e.fs.freereg>=e.fs.nactvar),e.fs.freereg=e.fs.nactvar,At(e)};e.exports.Dyndata=class{constructor(){this.actvar={arr:[],n:NaN,size:NaN},this.gt=new Qe,this.label=new Qe}},e.exports.expkind=je,e.exports.expdesc=Xe,e.exports.luaY_parser=function(e,t,n,a,r,i){let s=new be.LexState,l=new $e,o=ge.luaF_newLclosure(e,1);return _e.luaD_inctop(e),e.stack[e.top-1].setclLvalue(o),s.h=He.luaH_new(e),_e.luaD_inctop(e),e.stack[e.top-1].sethvalue(s.h),l.f=o.p=new Ye(e),l.f.source=Ne(e,r),s.buff=n,s.dyd=a,a.actvar.n=a.gt.n=a.label.n=0,be.luaX_setinput(e,s,t,l.f.source,i),function(e,t){let n=new Ze,a=new Xe;Lt(e,t,n),t.f.is_vararg=!0,ut(a,je.VLOCAL,0),_t(t,e.envn,a),be.luaX_next(e),Mt(e),rt(e,Ke.TK_EOS),Ut(e)}(s,l),Ae(!l.prev&&1===l.nups&&!s.fs),Ae(0===a.actvar.n&&0===a.gt.n&&0===a.label.n),delete e.stack[--e.top],o},e.exports.vkisinreg=function(e){return e===je.VNONRELOC||e===je.VLOCAL}},137:(e,t,n)=>{"use strict";const{LUA_MINSTACK:a,LUA_RIDX_GLOBALS:r,LUA_RIDX_MAINTHREAD:i,constant_types:{LUA_NUMTAGS:s,LUA_TNIL:l,LUA_TTABLE:o,LUA_TTHREAD:u},thread_status:{LUA_OK:c}}=n(775),d=n(435),h=n(983),f=n(973),m=n(718),p=n(964),_=2*a;class g{constructor(){this.func=null,this.funcOff=NaN,this.top=NaN,this.previous=null,this.next=null,this.l_base=NaN,this.l_code=null,this.l_savedpc=NaN,this.c_k=null,this.c_old_errfunc=null,this.c_ctx=null,this.nresults=NaN,this.callstatus=NaN}}class b{constructor(e){this.id=e.id_counter++,this.base_ci=new g,this.top=NaN,this.stack_last=NaN,this.oldpc=NaN,this.l_G=e,this.stack=null,this.ci=null,this.errorJmp=null,this.nCcalls=0,this.hook=null,this.hookmask=0,this.basehookcount=0,this.allowhook=1,this.hookcount=this.basehookcount,this.nny=1,this.status=c,this.errfunc=0}}class w{constructor(){this.id_counter=1,this.ids=new WeakMap,this.mainthread=null,this.l_registry=new d.TValue(l,null),this.panic=null,this.atnativeerror=null,this.version=null,this.tmname=new Array(p.TMS.TM_N),this.mt=new Array(s)}}const v=function(e){e.ci.next=null},A=function(e,t){e.stack=new Array(_),e.top=0,e.stack_last=_-5;let n=e.base_ci;n.next=n.previous=null,n.callstatus=0,n.funcOff=e.top,n.func=e.stack[e.top],e.stack[e.top++]=new d.TValue(l,null),n.top=e.top+a,e.ci=n},y=function(e){e.ci=e.base_ci,v(e),e.stack=null},S=function(e){let t=e.l_G;A(e),function(e,t){let n=m.luaH_new(e);t.l_registry.sethvalue(n),m.luaH_setint(n,i,new d.TValue(u,e)),m.luaH_setint(n,r,new d.TValue(o,m.luaH_new(e)))}(e,t),p.luaT_init(e),t.version=f.lua_version(null)};e.exports.lua_State=b,e.exports.CallInfo=g,e.exports.CIST_OAH=1,e.exports.CIST_LUA=2,e.exports.CIST_HOOKED=4,e.exports.CIST_FRESH=8,e.exports.CIST_YPCALL=16,e.exports.CIST_TAIL=32,e.exports.CIST_HOOKYIELD=64,e.exports.CIST_LEQ=128,e.exports.CIST_FIN=256,e.exports.EXTRA_STACK=5,e.exports.lua_close=function(e){!function(e){y(e)}(e=e.l_G.mainthread)},e.exports.lua_newstate=function(){let e=new w,t=new b(e);return e.mainthread=t,h.luaD_rawrunprotected(t,S,null)!==c&&(t=null),t},e.exports.lua_newthread=function(e){let t=e.l_G,n=new b(t);return e.stack[e.top]=new d.TValue(u,n),f.api_incr_top(e),n.hookmask=e.hookmask,n.basehookcount=e.basehookcount,n.hook=e.hook,n.hookcount=n.basehookcount,A(n),n},e.exports.luaE_extendCI=function(e){let t=new g;return e.ci.next=t,t.previous=e.ci,t.next=null,e.ci=t,t},e.exports.luaE_freeCI=v,e.exports.luaE_freethread=function(e,t){y(t)}},878:(e,t,n)=>{"use strict";const{is_luastring:a,luastring_eq:r,luastring_from:i,to_luastring:s}=n(775),{lua_assert:l}=n(568);class o{constructor(e,t){this.hash=null,this.realstring=t}getstr(){return this.realstring}tsslen(){return this.realstring.length}}const u=function(e){l(a(e));let t=e.length,n="|";for(let a=0;a<t;a++)n+=e[a].toString(16);return n},c=function(e,t){return l(t instanceof Uint8Array),new o(e,t)};e.exports.luaS_eqlngstr=function(e,t){return l(e instanceof o),l(t instanceof o),e==t||r(e.realstring,t.realstring)},e.exports.luaS_hash=u,e.exports.luaS_hashlongstr=function(e){return l(e instanceof o),null===e.hash&&(e.hash=u(e.getstr())),e.hash},e.exports.luaS_bless=c,e.exports.luaS_new=function(e,t){return c(e,i(t))},e.exports.luaS_newliteral=function(e,t){return c(e,s(t))},e.exports.TString=o},718:(e,t,n)=>{"use strict";const{constant_types:{LUA_TBOOLEAN:a,LUA_TCCL:r,LUA_TLCF:i,LUA_TLCL:s,LUA_TLIGHTUSERDATA:l,LUA_TLNGSTR:o,LUA_TNIL:u,LUA_TNUMFLT:c,LUA_TNUMINT:d,LUA_TSHRSTR:h,LUA_TTABLE:f,LUA_TTHREAD:m,LUA_TUSERDATA:p},to_luastring:_}=n(775),{lua_assert:g}=n(568),b=n(821),w=n(435),{luaS_hashlongstr:v,TString:A}=n(878),y=n(137);let S=new WeakMap;const T=function(e){let t=S.get(e);return t||(t={},S.set(e,t)),t},x=function(e,t){switch(t.type){case u:return b.luaG_runerror(e,_("table index is nil",!0));case c:if(isNaN(t.value))return b.luaG_runerror(e,_("table index is NaN",!0));case d:case a:case f:case s:case i:case r:case p:case m:return t.value;case h:case o:return v(t.tsvalue());case l:{let n=t.value;switch(typeof n){case"string":return"*"+n;case"number":return"#"+n;case"boolean":return n?"?true":"?false";case"function":return T(n);case"object":if(n instanceof y.lua_State&&n.l_G===e.l_G||n instanceof E||n instanceof w.Udata||n instanceof w.LClosure||n instanceof w.CClosure)return T(n);default:return n}}default:throw new Error("unknown key type: "+t.type)}};class E{constructor(e){this.id=e.l_G.id_counter++,this.strong=new Map,this.dead_strong=new Map,this.dead_weak=void 0,this.f=void 0,this.l=void 0,this.metatable=null,this.flags=-1}}const L=function(e,t,n,a){e.dead_strong.clear(),e.dead_weak=void 0;let r=null,i={key:n,value:a,p:r=e.l,n:void 0};e.f||(e.f=i),r&&(r.n=i),e.strong.set(t,i),e.l=i},I=function(e,t){let n=e.strong.get(t);if(n){n.key.setdeadvalue(),n.value=void 0;let r=n.n,i=n.p;n.p=void 0,i&&(i.n=r),r&&(r.p=i),e.f===n&&(e.f=r),e.l===n&&(e.l=i),e.strong.delete(t),("object"==typeof(a=t)?null!==a:"function"==typeof a)?(e.dead_weak||(e.dead_weak=new WeakMap),e.dead_weak.set(t,n)):e.dead_strong.set(t,n)}var a},U=function(e,t){let n=e.strong.get(t);return n?n.value:w.luaO_nilobject},R=function(e,t){return g("number"==typeof t&&(0|t)===t),U(e,t)};e.exports.invalidateTMcache=function(e){e.flags=0},e.exports.luaH_get=function(e,t,n){return g(n instanceof w.TValue),n.ttisnil()||n.ttisfloat()&&isNaN(n.value)?w.luaO_nilobject:U(t,x(e,n))},e.exports.luaH_getint=R,e.exports.luaH_getn=function(e){let t=0,n=e.strong.size+1;for(;n-t>1;){let a=Math.floor((t+n)/2);R(e,a).ttisnil()?n=a:t=a}return t},e.exports.luaH_getstr=function(e,t){return g(t instanceof A),U(e,v(t))},e.exports.luaH_setfrom=function(e,t,n,a){g(n instanceof w.TValue);let r=x(e,n);if(a.ttisnil())return void I(t,r);let i=t.strong.get(r);if(i)i.value.setfrom(a);else{let e,i=n.value;e=n.ttisfloat()&&(0|i)===i?new w.TValue(d,i):new w.TValue(n.type,i);let s=new w.TValue(a.type,a.value);L(t,r,e,s)}},e.exports.luaH_setint=function(e,t,n){g("number"==typeof t&&(0|t)===t&&n instanceof w.TValue);let a=t;if(n.ttisnil())return void I(e,a);let r=e.strong.get(a);if(r){r.value.setfrom(n)}else{let r=new w.TValue(d,t),i=new w.TValue(n.type,n.value);L(e,a,r,i)}},e.exports.luaH_new=function(e){return new E(e)},e.exports.luaH_next=function(e,t,n){let a,r=e.stack[n];if(r.type===u){if(a=t.f,!a)return!1}else{let n=x(e,r);if(a=t.strong.get(n),a){if(a=a.n,!a)return!1}else{if(a=t.dead_weak&&t.dead_weak.get(n)||t.dead_strong.get(n),!a)return b.luaG_runerror(e,_("invalid key to 'next'"));do{if(a=a.n,!a)return!1}while(a.key.ttisdeadkey())}}return w.setobj2s(e,n,a.key),w.setobj2s(e,n+1,a.value),!0},e.exports.Table=E},964:(e,t,n)=>{"use strict";const{constant_types:{LUA_TTABLE:a,LUA_TUSERDATA:r},to_luastring:i}=n(775),{lua_assert:s}=n(568),l=n(435),o=n(983),u=n(137),{luaS_bless:c,luaS_new:d}=n(878),h=n(718),f=n(821),m=n(427),p=["no value","nil","boolean","userdata","number","string","table","function","userdata","thread","proto"].map((e=>i(e))),_=function(e){return p[e+1]},g={TM_INDEX:0,TM_NEWINDEX:1,TM_GC:2,TM_MODE:3,TM_LEN:4,TM_EQ:5,TM_ADD:6,TM_SUB:7,TM_MUL:8,TM_MOD:9,TM_POW:10,TM_DIV:11,TM_IDIV:12,TM_BAND:13,TM_BOR:14,TM_BXOR:15,TM_SHL:16,TM_SHR:17,TM_UNM:18,TM_BNOT:19,TM_LT:20,TM_LE:21,TM_CONCAT:22,TM_CALL:23,TM_N:24},b=i("__name",!0),w=function(e,t,n,a,r,i){let s=e.top;if(l.pushobj2s(e,t),l.pushobj2s(e,n),l.pushobj2s(e,a),i||l.pushobj2s(e,r),e.ci.callstatus&u.CIST_LUA?o.luaD_call(e,s,i):o.luaD_callnoyield(e,s,i),i){let t=e.stack[e.top-1];delete e.stack[--e.top],r.setfrom(t)}},v=function(e,t,n,a,r){let i=y(e,t,r);return i.ttisnil()&&(i=y(e,n,r)),!i.ttisnil()&&(w(e,i,t,n,a,1),!0)},A=function(e,t,n){const a=h.luaH_getstr(e,n);return s(t<=g.TM_EQ),a.ttisnil()?(e.flags|=1<<t,null):a},y=function(e,t,n){let i;switch(t.ttnov()){case a:case r:i=t.value.metatable;break;default:i=e.l_G.mt[t.ttnov()]}return i?h.luaH_getstr(i,e.l_G.tmname[n]):l.luaO_nilobject};e.exports.fasttm=function(e,t,n){return null===t||t.flags&1<<n?null:A(t,n,e.l_G.tmname[n])},e.exports.TMS=g,e.exports.luaT_callTM=w,e.exports.luaT_callbinTM=v,e.exports.luaT_trybinTM=function(e,t,n,a,r){if(!v(e,t,n,a,r))switch(r){case g.TM_CONCAT:return f.luaG_concaterror(e,t,n);case g.TM_BAND:case g.TM_BOR:case g.TM_BXOR:case g.TM_SHL:case g.TM_SHR:case g.TM_BNOT:{let a=m.tonumber(t),r=m.tonumber(n);return!1!==a&&!1!==r?f.luaG_tointerror(e,t,n):f.luaG_opinterror(e,t,n,i("perform bitwise operation on",!0))}default:return f.luaG_opinterror(e,t,n,i("perform arithmetic on",!0))}},e.exports.luaT_callorderTM=function(e,t,n,a){let r=new l.TValue;return v(e,t,n,r,a)?!r.l_isfalse():null},e.exports.luaT_gettm=A,e.exports.luaT_gettmbyobj=y,e.exports.luaT_init=function(e){e.l_G.tmname[g.TM_INDEX]=new d(e,i("__index",!0)),e.l_G.tmname[g.TM_NEWINDEX]=new d(e,i("__newindex",!0)),e.l_G.tmname[g.TM_GC]=new d(e,i("__gc",!0)),e.l_G.tmname[g.TM_MODE]=new d(e,i("__mode",!0)),e.l_G.tmname[g.TM_LEN]=new d(e,i("__len",!0)),e.l_G.tmname[g.TM_EQ]=new d(e,i("__eq",!0)),e.l_G.tmname[g.TM_ADD]=new d(e,i("__add",!0)),e.l_G.tmname[g.TM_SUB]=new d(e,i("__sub",!0)),e.l_G.tmname[g.TM_MUL]=new d(e,i("__mul",!0)),e.l_G.tmname[g.TM_MOD]=new d(e,i("__mod",!0)),e.l_G.tmname[g.TM_POW]=new d(e,i("__pow",!0)),e.l_G.tmname[g.TM_DIV]=new d(e,i("__div",!0)),e.l_G.tmname[g.TM_IDIV]=new d(e,i("__idiv",!0)),e.l_G.tmname[g.TM_BAND]=new d(e,i("__band",!0)),e.l_G.tmname[g.TM_BOR]=new d(e,i("__bor",!0)),e.l_G.tmname[g.TM_BXOR]=new d(e,i("__bxor",!0)),e.l_G.tmname[g.TM_SHL]=new d(e,i("__shl",!0)),e.l_G.tmname[g.TM_SHR]=new d(e,i("__shr",!0)),e.l_G.tmname[g.TM_UNM]=new d(e,i("__unm",!0)),e.l_G.tmname[g.TM_BNOT]=new d(e,i("__bnot",!0)),e.l_G.tmname[g.TM_LT]=new d(e,i("__lt",!0)),e.l_G.tmname[g.TM_LE]=new d(e,i("__le",!0)),e.l_G.tmname[g.TM_CONCAT]=new d(e,i("__concat",!0)),e.l_G.tmname[g.TM_CALL]=new d(e,i("__call",!0))},e.exports.luaT_objtypename=function(e,t){let n;if(t.ttistable()&&null!==(n=t.value.metatable)||t.ttisfulluserdata()&&null!==(n=t.value.metatable)){let t=h.luaH_getstr(n,c(e,b));if(t.ttisstring())return t.svalue()}return _(t.ttnov())},e.exports.ttypename=_},870:(e,t,n)=>{"use strict";const a=n(775),r=n(973),i=n(821),s=n(983),l=n(137);e.exports.LUA_AUTHORS=a.LUA_AUTHORS,e.exports.LUA_COPYRIGHT=a.LUA_COPYRIGHT,e.exports.LUA_ERRERR=a.thread_status.LUA_ERRERR,e.exports.LUA_ERRGCMM=a.thread_status.LUA_ERRGCMM,e.exports.LUA_ERRMEM=a.thread_status.LUA_ERRMEM,e.exports.LUA_ERRRUN=a.thread_status.LUA_ERRRUN,e.exports.LUA_ERRSYNTAX=a.thread_status.LUA_ERRSYNTAX,e.exports.LUA_HOOKCALL=a.LUA_HOOKCALL,e.exports.LUA_HOOKCOUNT=a.LUA_HOOKCOUNT,e.exports.LUA_HOOKLINE=a.LUA_HOOKLINE,e.exports.LUA_HOOKRET=a.LUA_HOOKRET,e.exports.LUA_HOOKTAILCALL=a.LUA_HOOKTAILCALL,e.exports.LUA_MASKCALL=a.LUA_MASKCALL,e.exports.LUA_MASKCOUNT=a.LUA_MASKCOUNT,e.exports.LUA_MASKLINE=a.LUA_MASKLINE,e.exports.LUA_MASKRET=a.LUA_MASKRET,e.exports.LUA_MINSTACK=a.LUA_MINSTACK,e.exports.LUA_MULTRET=a.LUA_MULTRET,e.exports.LUA_NUMTAGS=a.constant_types.LUA_NUMTAGS,e.exports.LUA_OK=a.thread_status.LUA_OK,e.exports.LUA_OPADD=a.LUA_OPADD,e.exports.LUA_OPBAND=a.LUA_OPBAND,e.exports.LUA_OPBNOT=a.LUA_OPBNOT,e.exports.LUA_OPBOR=a.LUA_OPBOR,e.exports.LUA_OPBXOR=a.LUA_OPBXOR,e.exports.LUA_OPDIV=a.LUA_OPDIV,e.exports.LUA_OPEQ=a.LUA_OPEQ,e.exports.LUA_OPIDIV=a.LUA_OPIDIV,e.exports.LUA_OPLE=a.LUA_OPLE,e.exports.LUA_OPLT=a.LUA_OPLT,e.exports.LUA_OPMOD=a.LUA_OPMOD,e.exports.LUA_OPMUL=a.LUA_OPMUL,e.exports.LUA_OPPOW=a.LUA_OPPOW,e.exports.LUA_OPSHL=a.LUA_OPSHL,e.exports.LUA_OPSHR=a.LUA_OPSHR,e.exports.LUA_OPSUB=a.LUA_OPSUB,e.exports.LUA_OPUNM=a.LUA_OPUNM,e.exports.LUA_REGISTRYINDEX=a.LUA_REGISTRYINDEX,e.exports.LUA_RELEASE=a.LUA_RELEASE,e.exports.LUA_RIDX_GLOBALS=a.LUA_RIDX_GLOBALS,e.exports.LUA_RIDX_LAST=a.LUA_RIDX_LAST,e.exports.LUA_RIDX_MAINTHREAD=a.LUA_RIDX_MAINTHREAD,e.exports.LUA_SIGNATURE=a.LUA_SIGNATURE,e.exports.LUA_TNONE=a.constant_types.LUA_TNONE,e.exports.LUA_TNIL=a.constant_types.LUA_TNIL,e.exports.LUA_TBOOLEAN=a.constant_types.LUA_TBOOLEAN,e.exports.LUA_TLIGHTUSERDATA=a.constant_types.LUA_TLIGHTUSERDATA,e.exports.LUA_TNUMBER=a.constant_types.LUA_TNUMBER,e.exports.LUA_TSTRING=a.constant_types.LUA_TSTRING,e.exports.LUA_TTABLE=a.constant_types.LUA_TTABLE,e.exports.LUA_TFUNCTION=a.constant_types.LUA_TFUNCTION,e.exports.LUA_TUSERDATA=a.constant_types.LUA_TUSERDATA,e.exports.LUA_TTHREAD=a.constant_types.LUA_TTHREAD,e.exports.LUA_VERSION=a.LUA_VERSION,e.exports.LUA_VERSION_MAJOR=a.LUA_VERSION_MAJOR,e.exports.LUA_VERSION_MINOR=a.LUA_VERSION_MINOR,e.exports.LUA_VERSION_NUM=a.LUA_VERSION_NUM,e.exports.LUA_VERSION_RELEASE=a.LUA_VERSION_RELEASE,e.exports.LUA_YIELD=a.thread_status.LUA_YIELD,e.exports.lua_Debug=a.lua_Debug,e.exports.lua_upvalueindex=a.lua_upvalueindex,e.exports.lua_absindex=r.lua_absindex,e.exports.lua_arith=r.lua_arith,e.exports.lua_atpanic=r.lua_atpanic,e.exports.lua_atnativeerror=r.lua_atnativeerror,e.exports.lua_call=r.lua_call,e.exports.lua_callk=r.lua_callk,e.exports.lua_checkstack=r.lua_checkstack,e.exports.lua_close=l.lua_close,e.exports.lua_compare=r.lua_compare,e.exports.lua_concat=r.lua_concat,e.exports.lua_copy=r.lua_copy,e.exports.lua_createtable=r.lua_createtable,e.exports.lua_dump=r.lua_dump,e.exports.lua_error=r.lua_error,e.exports.lua_gc=r.lua_gc,e.exports.lua_getallocf=r.lua_getallocf,e.exports.lua_getextraspace=r.lua_getextraspace,e.exports.lua_getfield=r.lua_getfield,e.exports.lua_getglobal=r.lua_getglobal,e.exports.lua_gethook=i.lua_gethook,e.exports.lua_gethookcount=i.lua_gethookcount,e.exports.lua_gethookmask=i.lua_gethookmask,e.exports.lua_geti=r.lua_geti,e.exports.lua_getinfo=i.lua_getinfo,e.exports.lua_getlocal=i.lua_getlocal,e.exports.lua_getmetatable=r.lua_getmetatable,e.exports.lua_getstack=i.lua_getstack,e.exports.lua_gettable=r.lua_gettable,e.exports.lua_gettop=r.lua_gettop,e.exports.lua_getupvalue=r.lua_getupvalue,e.exports.lua_getuservalue=r.lua_getuservalue,e.exports.lua_insert=r.lua_insert,e.exports.lua_isboolean=r.lua_isboolean,e.exports.lua_iscfunction=r.lua_iscfunction,e.exports.lua_isfunction=r.lua_isfunction,e.exports.lua_isinteger=r.lua_isinteger,e.exports.lua_islightuserdata=r.lua_islightuserdata,e.exports.lua_isnil=r.lua_isnil,e.exports.lua_isnone=r.lua_isnone,e.exports.lua_isnoneornil=r.lua_isnoneornil,e.exports.lua_isnumber=r.lua_isnumber,e.exports.lua_isproxy=r.lua_isproxy,e.exports.lua_isstring=r.lua_isstring,e.exports.lua_istable=r.lua_istable,e.exports.lua_isthread=r.lua_isthread,e.exports.lua_isuserdata=r.lua_isuserdata,e.exports.lua_isyieldable=s.lua_isyieldable,e.exports.lua_len=r.lua_len,e.exports.lua_load=r.lua_load,e.exports.lua_newstate=l.lua_newstate,e.exports.lua_newtable=r.lua_newtable,e.exports.lua_newthread=l.lua_newthread,e.exports.lua_newuserdata=r.lua_newuserdata,e.exports.lua_next=r.lua_next,e.exports.lua_pcall=r.lua_pcall,e.exports.lua_pcallk=r.lua_pcallk,e.exports.lua_pop=r.lua_pop,e.exports.lua_pushboolean=r.lua_pushboolean,e.exports.lua_pushcclosure=r.lua_pushcclosure,e.exports.lua_pushcfunction=r.lua_pushcfunction,e.exports.lua_pushfstring=r.lua_pushfstring,e.exports.lua_pushglobaltable=r.lua_pushglobaltable,e.exports.lua_pushinteger=r.lua_pushinteger,e.exports.lua_pushjsclosure=r.lua_pushjsclosure,e.exports.lua_pushjsfunction=r.lua_pushjsfunction,e.exports.lua_pushlightuserdata=r.lua_pushlightuserdata,e.exports.lua_pushliteral=r.lua_pushliteral,e.exports.lua_pushlstring=r.lua_pushlstring,e.exports.lua_pushnil=r.lua_pushnil,e.exports.lua_pushnumber=r.lua_pushnumber,e.exports.lua_pushstring=r.lua_pushstring,e.exports.lua_pushthread=r.lua_pushthread,e.exports.lua_pushvalue=r.lua_pushvalue,e.exports.lua_pushvfstring=r.lua_pushvfstring,e.exports.lua_rawequal=r.lua_rawequal,e.exports.lua_rawget=r.lua_rawget,e.exports.lua_rawgeti=r.lua_rawgeti,e.exports.lua_rawgetp=r.lua_rawgetp,e.exports.lua_rawlen=r.lua_rawlen,e.exports.lua_rawset=r.lua_rawset,e.exports.lua_rawseti=r.lua_rawseti,e.exports.lua_rawsetp=r.lua_rawsetp,e.exports.lua_register=r.lua_register,e.exports.lua_remove=r.lua_remove,e.exports.lua_replace=r.lua_replace,e.exports.lua_resume=s.lua_resume,e.exports.lua_rotate=r.lua_rotate,e.exports.lua_setallof=s.lua_setallof,e.exports.lua_setfield=r.lua_setfield,e.exports.lua_setglobal=r.lua_setglobal,e.exports.lua_sethook=i.lua_sethook,e.exports.lua_seti=r.lua_seti,e.exports.lua_setlocal=i.lua_setlocal,e.exports.lua_setmetatable=r.lua_setmetatable,e.exports.lua_settable=r.lua_settable,e.exports.lua_settop=r.lua_settop,e.exports.lua_setupvalue=r.lua_setupvalue,e.exports.lua_setuservalue=r.lua_setuservalue,e.exports.lua_status=r.lua_status,e.exports.lua_stringtonumber=r.lua_stringtonumber,e.exports.lua_toboolean=r.lua_toboolean,e.exports.lua_todataview=r.lua_todataview,e.exports.lua_tointeger=r.lua_tointeger,e.exports.lua_tointegerx=r.lua_tointegerx,e.exports.lua_tojsstring=r.lua_tojsstring,e.exports.lua_tolstring=r.lua_tolstring,e.exports.lua_tonumber=r.lua_tonumber,e.exports.lua_tonumberx=r.lua_tonumberx,e.exports.lua_topointer=r.lua_topointer,e.exports.lua_toproxy=r.lua_toproxy,e.exports.lua_tostring=r.lua_tostring,e.exports.lua_tothread=r.lua_tothread,e.exports.lua_touserdata=r.lua_touserdata,e.exports.lua_type=r.lua_type,e.exports.lua_typename=r.lua_typename,e.exports.lua_upvalueid=r.lua_upvalueid,e.exports.lua_upvaluejoin=r.lua_upvaluejoin,e.exports.lua_version=r.lua_version,e.exports.lua_xmove=r.lua_xmove,e.exports.lua_yield=s.lua_yield,e.exports.lua_yieldk=s.lua_yieldk,e.exports.lua_tocfunction=r.lua_tocfunction},947:(e,t,n)=>{"use strict";const a={},{LUA_VERSION_MAJOR:r,LUA_VERSION_MINOR:i,to_luastring:s}=n(775);e.exports.LUA_PATH_SEP=";";e.exports.LUA_PATH_MARK="?";e.exports.LUA_EXEC_DIR="!";const l=r+"."+i;e.exports.LUA_VDIR=l;{const t="/";e.exports.LUA_DIRSEP=t;const n="./lua/"+l+"/";e.exports.LUA_LDIR=n;const a=n;e.exports.LUA_JSDIR=a;const r=s(n+"?.lua;"+n+"?/init.lua;./?.lua;./?/init.lua");e.exports.LUA_PATH_DEFAULT=r;const i=s(a+"?.js;"+a+"loadall.js;./?.js");e.exports.LUA_JSPATH_DEFAULT=i}const o=a.LUA_COMPAT_FLOATSTRING||!1,u=-2147483648,c=a.LUAI_MAXSTACK||1e6,d=a.LUA_IDSIZE||59,h=a.LUAL_BUFFERSIZE||8192,f=function(e,t){for(var n=Math.min(3,Math.ceil(Math.abs(t)/1023)),a=e,r=0;r<n;r++)a*=Math.pow(2,Math.floor((t+r)/n));return a};e.exports.LUAI_MAXSTACK=c,e.exports.LUA_COMPAT_FLOATSTRING=o,e.exports.LUA_IDSIZE=d,e.exports.LUA_INTEGER_FMT="%d",e.exports.LUA_INTEGER_FRMLEN="",e.exports.LUA_MAXINTEGER=2147483647,e.exports.LUA_MININTEGER=u,e.exports.LUA_NUMBER_FMT="%.14g",e.exports.LUA_NUMBER_FRMLEN="",e.exports.LUAL_BUFFERSIZE=h,e.exports.frexp=function(e){if(0===e)return[e,0];var t=new DataView(new ArrayBuffer(8));t.setFloat64(0,e);var n=t.getUint32(0)>>>20&2047;0===n&&(t.setFloat64(0,e*Math.pow(2,64)),n=(t.getUint32(0)>>>20&2047)-64);var a=n-1022;return[f(e,-a),a]},e.exports.ldexp=f,e.exports.lua_getlocaledecpoint=function(){return 46},e.exports.lua_integer2str=function(e){return String(e)},e.exports.lua_number2str=function(e){return String(Number(e.toPrecision(14)))},e.exports.lua_numbertointeger=function(e){return e>=u&&e<2147483648&&e},e.exports.luai_apicheck=function(e,t){if(!t)throw Error(t)}},866:(e,t,n)=>{"use strict";const{LUA_SIGNATURE:a,constant_types:{LUA_TBOOLEAN:r,LUA_TLNGSTR:i,LUA_TNIL:s,LUA_TNUMFLT:l,LUA_TNUMINT:o,LUA_TSHRSTR:u},thread_status:{LUA_ERRSYNTAX:c},is_luastring:d,luastring_eq:h,to_luastring:f}=n(775),m=n(983),p=n(897),_=n(435),{MAXARG_sBx:g,POS_A:b,POS_Ax:w,POS_B:v,POS_Bx:A,POS_C:y,POS_OP:S,SIZE_A:T,SIZE_Ax:x,SIZE_B:E,SIZE_Bx:L,SIZE_C:I,SIZE_OP:U}=n(159),{lua_assert:R}=n(568),{luaS_bless:M}=n(878),{luaZ_read:C,ZIO:B}=n(161);let P=[25,147,13,10,26,10];class k{constructor(e,t,n){this.intSize=4,this.size_tSize=4,this.instructionSize=4,this.integerSize=4,this.numberSize=8,R(t instanceof B,"BytecodeParser only operates on a ZIO"),R(d(n)),64===n[0]||61===n[0]?this.name=n.subarray(1):n[0]==a[0]?this.name=f("binary string",!0):this.name=n,this.L=e,this.Z=t,this.arraybuffer=new ArrayBuffer(Math.max(this.intSize,this.size_tSize,this.instructionSize,this.integerSize,this.numberSize)),this.dv=new DataView(this.arraybuffer),this.u8=new Uint8Array(this.arraybuffer)}read(e){let t=new Uint8Array(e);return 0!==C(this.Z,t,0,e)&&this.error("truncated"),t}LoadByte(){return 0!==C(this.Z,this.u8,0,1)&&this.error("truncated"),this.u8[0]}LoadInt(){return 0!==C(this.Z,this.u8,0,this.intSize)&&this.error("truncated"),this.dv.getInt32(0,!0)}LoadNumber(){return 0!==C(this.Z,this.u8,0,this.numberSize)&&this.error("truncated"),this.dv.getFloat64(0,!0)}LoadInteger(){return 0!==C(this.Z,this.u8,0,this.integerSize)&&this.error("truncated"),this.dv.getInt32(0,!0)}LoadSize_t(){return this.LoadInteger()}LoadString(){let e=this.LoadByte();return 255===e&&(e=this.LoadSize_t()),0===e?null:M(this.L,this.read(e-1))}static MASK1(e,t){return~(-1<<e)<<t}LoadCode(e){let t=this.LoadInt(),n=k;for(let a=0;a<t;a++){0!==C(this.Z,this.u8,0,this.instructionSize)&&this.error("truncated");let t=this.dv.getUint32(0,!0);e.code[a]={code:t,opcode:t>>S&n.MASK1(U,0),A:t>>b&n.MASK1(T,0),B:t>>v&n.MASK1(E,0),C:t>>y&n.MASK1(I,0),Bx:t>>A&n.MASK1(L,0),Ax:t>>w&n.MASK1(x,0),sBx:(t>>A&n.MASK1(L,0))-g}}}LoadConstants(e){let t=this.LoadInt();for(let n=0;n<t;n++){let t=this.LoadByte();switch(t){case s:e.k.push(new _.TValue(s,null));break;case r:e.k.push(new _.TValue(r,0!==this.LoadByte()));break;case l:e.k.push(new _.TValue(l,this.LoadNumber()));break;case o:e.k.push(new _.TValue(o,this.LoadInteger()));break;case u:case i:e.k.push(new _.TValue(i,this.LoadString()));break;default:this.error(`unrecognized constant '${t}'`)}}}LoadProtos(e){let t=this.LoadInt();for(let n=0;n<t;n++)e.p[n]=new p.Proto(this.L),this.LoadFunction(e.p[n],e.source)}LoadUpvalues(e){let t=this.LoadInt();for(let n=0;n<t;n++)e.upvalues[n]={name:null,instack:this.LoadByte(),idx:this.LoadByte()}}LoadDebug(e){let t=this.LoadInt();for(let n=0;n<t;n++)e.lineinfo[n]=this.LoadInt();t=this.LoadInt();for(let n=0;n<t;n++)e.locvars[n]={varname:this.LoadString(),startpc:this.LoadInt(),endpc:this.LoadInt()};t=this.LoadInt();for(let n=0;n<t;n++)e.upvalues[n].name=this.LoadString()}LoadFunction(e,t){e.source=this.LoadString(),null===e.source&&(e.source=t),e.linedefined=this.LoadInt(),e.lastlinedefined=this.LoadInt(),e.numparams=this.LoadByte(),e.is_vararg=0!==this.LoadByte(),e.maxstacksize=this.LoadByte(),this.LoadCode(e),this.LoadConstants(e),this.LoadUpvalues(e),this.LoadProtos(e),this.LoadDebug(e)}checkliteral(e,t){let n=this.read(e.length);h(n,e)||this.error(t)}checkHeader(){this.checkliteral(a.subarray(1),"not a"),83!==this.LoadByte()&&this.error("version mismatch in"),0!==this.LoadByte()&&this.error("format mismatch in"),this.checkliteral(P,"corrupted"),this.intSize=this.LoadByte(),this.size_tSize=this.LoadByte(),this.instructionSize=this.LoadByte(),this.integerSize=this.LoadByte(),this.numberSize=this.LoadByte(),this.checksize(this.intSize,4,"int"),this.checksize(this.size_tSize,4,"size_t"),this.checksize(this.instructionSize,4,"instruction"),this.checksize(this.integerSize,4,"integer"),this.checksize(this.numberSize,8,"number"),22136!==this.LoadInteger()&&this.error("endianness mismatch in"),370.5!==this.LoadNumber()&&this.error("float format mismatch in")}error(e){_.luaO_pushfstring(this.L,f("%s: %s precompiled chunk"),this.name,f(e)),m.luaD_throw(this.L,c)}checksize(e,t,n){e!==t&&this.error(`${n} size mismatch in`)}}e.exports.luaU_undump=function(e,t,n){let a=new k(e,t,n);a.checkHeader();let r=p.luaF_newLclosure(e,a.LoadByte());return m.luaD_inctop(e),e.stack[e.top-1].setclLvalue(r),r.p=new p.Proto(e),a.LoadFunction(r.p,null),R(r.nupvalues===r.p.upvalues.length),r}},427:(e,t,n)=>{"use strict";const{LUA_MASKLINE:a,LUA_MASKCOUNT:r,LUA_MULTRET:i,constant_types:{LUA_TBOOLEAN:s,LUA_TLCF:l,LUA_TLIGHTUSERDATA:o,LUA_TLNGSTR:u,LUA_TNIL:c,LUA_TNUMBER:d,LUA_TNUMFLT:h,LUA_TNUMINT:f,LUA_TSHRSTR:m,LUA_TTABLE:p,LUA_TUSERDATA:_},to_luastring:g}=n(775),{INDEXK:b,ISK:w,LFIELDS_PER_FLUSH:v,OpCodesI:{OP_ADD:A,OP_BAND:y,OP_BNOT:S,OP_BOR:T,OP_BXOR:x,OP_CALL:E,OP_CLOSURE:L,OP_CONCAT:I,OP_DIV:U,OP_EQ:R,OP_EXTRAARG:M,OP_FORLOOP:C,OP_FORPREP:B,OP_GETTABLE:P,OP_GETTABUP:k,OP_GETUPVAL:O,OP_IDIV:D,OP_JMP:F,OP_LE:G,OP_LEN:N,OP_LOADBOOL:V,OP_LOADK:H,OP_LOADKX:Y,OP_LOADNIL:K,OP_LT:z,OP_MOD:q,OP_MOVE:Z,OP_MUL:j,OP_NEWTABLE:X,OP_NOT:$,OP_POW:J,OP_RETURN:W,OP_SELF:Q,OP_SETLIST:ee,OP_SETTABLE:te,OP_SETTABUP:ne,OP_SETUPVAL:ae,OP_SHL:re,OP_SHR:ie,OP_SUB:se,OP_TAILCALL:le,OP_TEST:oe,OP_TESTSET:ue,OP_TFORCALL:ce,OP_TFORLOOP:de,OP_UNM:he,OP_VARARG:fe}}=n(159),{LUA_MAXINTEGER:me,LUA_MININTEGER:pe,lua_numbertointeger:_e}=n(947),{lua_assert:ge,luai_nummod:be}=n(568),we=n(435),ve=n(897),Ae=n(137),{luaS_bless:ye,luaS_eqlngstr:Se,luaS_hashlongstr:Te}=n(878),xe=n(983),Ee=n(964),Le=n(718),Ie=n(821),Ue=function(e,t,n){return t+n.A},Re=function(e,t,n){return t+n.B},Me=function(e,t,n,a){return w(a.B)?n[b(a.B)]:e.stack[t+a.B]},Ce=function(e,t,n,a){return w(a.C)?n[b(a.C)]:e.stack[t+a.C]},Be=function(e,t,n,a){let r=n.A;0!==r&&ve.luaF_close(e,t.l_base+r-1),t.l_savedpc+=n.sBx+a},Pe=function(e,t){Be(e,t,t.l_code[t.l_savedpc],1)},ke=function(e,t,n){if(t.ttisnumber()&&n.ttisnumber())return He(t,n)?1:0;if(t.ttisstring()&&n.ttisstring())return Ke(t.tsvalue(),n.tsvalue())<0?1:0;{let a=Ee.luaT_callorderTM(e,t,n,Ee.TMS.TM_LT);return null===a&&Ie.luaG_ordererror(e,t,n),a?1:0}},Oe=function(e,t,n){let a;return t.ttisnumber()&&n.ttisnumber()?Ye(t,n)?1:0:t.ttisstring()&&n.ttisstring()?Ke(t.tsvalue(),n.tsvalue())<=0?1:0:(a=Ee.luaT_callorderTM(e,t,n,Ee.TMS.TM_LE),null!==a?a?1:0:(e.ci.callstatus|=Ae.CIST_LEQ,a=Ee.luaT_callorderTM(e,n,t,Ee.TMS.TM_LT),e.ci.callstatus^=Ae.CIST_LEQ,null===a&&Ie.luaG_ordererror(e,t,n),a?0:1))},De=function(e,t,n){if(t.ttype()!==n.ttype())return t.ttnov()!==n.ttnov()||t.ttnov()!==d?0:t.value===n.value?1:0;let a;switch(t.ttype()){case c:return 1;case s:return t.value==n.value?1:0;default:return t.value===n.value?1:0;case m:case u:return Se(t.tsvalue(),n.tsvalue())?1:0;case _:case p:if(t.value===n.value)return 1;if(null===e)return 0;a=Ee.fasttm(e,t.value.metatable,Ee.TMS.TM_EQ),null===a&&(a=Ee.fasttm(e,n.value.metatable,Ee.TMS.TM_EQ))}if(null===a)return 0;let r=new we.TValue;return Ee.luaT_callTM(e,a,t,n,r,1),r.l_isfalse()?0:1},Fe=function(e,t){let n=!1,a=Ge(e,t<0?2:1);if(!1===a){let r=Ve(e);if(!1===r)return!1;0<r?(a=me,t<0&&(n=!0)):(a=pe,t>=0&&(n=!0))}return{stopnow:n,ilimit:a}},Ge=function(e,t){if(e.ttisfloat()){let n=e.value,a=Math.floor(n);if(n!==a){if(0===t)return!1;t>1&&(a+=1)}return _e(a)}if(e.ttisinteger())return e.value;if(Qe(e)){let n=new we.TValue;if(we.luaO_str2num(e.svalue(),n)===e.vslen()+1)return Ge(n,t)}return!1},Ne=function(e){return e.ttisinteger()?e.value:Ge(e,0)},Ve=function(e){if(e.ttnov()===d)return e.value;if(Qe(e)){let t=new we.TValue;if(we.luaO_str2num(e.svalue(),t)===e.vslen()+1)return t.value}return!1},He=function(e,t){return e.value<t.value},Ye=function(e,t){return e.value<=t.value},Ke=function(e,t){let n=Te(e),a=Te(t);return n===a?0:n<a?-1:1},ze=function(e,t,n){let a;switch(n.ttype()){case p:{let r=n.value;if(a=Ee.fasttm(e,r.metatable,Ee.TMS.TM_LEN),null!==a)break;return void t.setivalue(Le.luaH_getn(r))}case m:case u:return void t.setivalue(n.vslen());default:a=Ee.luaT_gettmbyobj(e,n,Ee.TMS.TM_LEN),a.ttisnil()&&Ie.luaG_typeerror(e,n,g("get length of",!0))}Ee.luaT_callTM(e,a,n,n,t,1)},qe=Math.imul||function(e,t){let n=65535&e,a=65535&t;return n*a+((e>>>16&65535)*a+n*(t>>>16&65535)<<16>>>0)|0},Ze=function(e,t,n){return 0===n&&Ie.luaG_runerror(e,g("attempt to divide by zero")),0|Math.floor(t/n)},je=function(e,t,n){return 0===n&&Ie.luaG_runerror(e,g("attempt to perform 'n%%0'")),t-Math.floor(t/n)*n|0},Xe=function(e,t){return t<0?t<=-32?0:e>>>-t:t>=32?0:e<<t},$e=function(e,t,n,a){let r=e.cache;if(null!==r){let i=e.upvalues,s=i.length;for(let e=0;e<s;e++){let s=i[e].instack?n[a+i[e].idx]:t[i[e].idx];if(r.upvals[e]!==s)return null}}return r},Je=function(e,t,n,a,r){let i=t.upvalues.length,s=t.upvalues,l=new we.LClosure(e,i);l.p=t,e.stack[r].setclLvalue(l);for(let t=0;t<i;t++)s[t].instack?l.upvals[t]=ve.luaF_findupval(e,a+s[t].idx):l.upvals[t]=n[s[t].idx];t.cache=l},We=function(e){return e.ttisnumber()},Qe=function(e){return e.ttisstring()},et=function(e,t){let n=e.stack[t];return!!n.ttisstring()||!!We(n)&&(we.luaO_tostring(e,n),!0)},tt=function(e){return e.ttisstring()&&0===e.vslen()},nt=function(e,t,n,a){let r=0;do{let i=e.stack[t-n],s=i.vslen(),l=i.svalue();a.set(l,r),r+=s}while(--n>0)},at=function(e,t){ge(t>=2);do{let n=e.top,a=2;if((e.stack[n-2].ttisstring()||We(e.stack[n-2]))&&et(e,n-1))if(tt(e.stack[n-1]))et(e,n-2);else if(tt(e.stack[n-2]))we.setobjs2s(e,n-2,n-1);else{let r=e.stack[n-1].vslen();for(a=1;a<t&&et(e,n-a-1);a++){r+=e.stack[n-a-1].vslen()}let i=new Uint8Array(r);nt(e,n,a,i);let s=ye(e,i);we.setsvalue2s(e,n-a,s)}else Ee.luaT_trybinTM(e,e.stack[n-2],e.stack[n-1],e.stack[n-2],Ee.TMS.TM_CONCAT);for(t-=a-1;e.top>n-(a-1);)delete e.stack[--e.top]}while(t>1)},rt=function(e,t,n,a){for(let r=0;r<2e3;r++){let r;if(t.ttistable()){let i=Le.luaH_get(e,t.value,n);if(!i.ttisnil())return void we.setobj2s(e,a,i);if(r=Ee.fasttm(e,t.value.metatable,Ee.TMS.TM_INDEX),null===r)return void e.stack[a].setnilvalue()}else r=Ee.luaT_gettmbyobj(e,t,Ee.TMS.TM_INDEX),r.ttisnil()&&Ie.luaG_typeerror(e,t,g("index",!0));if(r.ttisfunction())return void Ee.luaT_callTM(e,r,t,n,e.stack[a],1);t=r}Ie.luaG_runerror(e,g("'__index' chain too long; possible loop",!0))},it=function(e,t,n,a){for(let r=0;r<2e3;r++){let r;if(t.ttistable()){let i=t.value;if(!Le.luaH_get(e,i,n).ttisnil()||null===(r=Ee.fasttm(e,i.metatable,Ee.TMS.TM_NEWINDEX)))return Le.luaH_setfrom(e,i,n,a),void Le.invalidateTMcache(i)}else(r=Ee.luaT_gettmbyobj(e,t,Ee.TMS.TM_NEWINDEX)).ttisnil()&&Ie.luaG_typeerror(e,t,g("index",!0));if(r.ttisfunction())return void Ee.luaT_callTM(e,r,t,n,a,0);t=r}Ie.luaG_runerror(e,g("'__newindex' chain too long; possible loop",!0))};e.exports.cvt2str=We,e.exports.cvt2num=Qe,e.exports.luaV_gettable=rt,e.exports.luaV_concat=at,e.exports.luaV_div=Ze,e.exports.luaV_equalobj=De,e.exports.luaV_execute=function(e){let t=e.ci;t.callstatus|=Ae.CIST_FRESH;e:for(;;){ge(t===e.ci);let n=t.func.value,s=n.p.k,l=t.l_base,o=t.l_code[t.l_savedpc++];e.hookmask&(a|r)&&Ie.luaG_traceexec(e);let u=Ue(0,l,o);switch(o.opcode){case Z:we.setobjs2s(e,u,Re(0,l,o));break;case H:{let t=s[o.Bx];we.setobj2s(e,u,t);break}case Y:{ge(t.l_code[t.l_savedpc].opcode===M);let n=s[t.l_code[t.l_savedpc++].Ax];we.setobj2s(e,u,n);break}case V:e.stack[u].setbvalue(0!==o.B),0!==o.C&&t.l_savedpc++;break;case K:for(let t=0;t<=o.B;t++)e.stack[u+t].setnilvalue();break;case O:{let t=o.B;we.setobj2s(e,u,n.upvals[t]);break}case k:{let t=n.upvals[o.B],a=Ce(e,l,s,o);rt(e,t,a,u);break}case P:{let t=e.stack[Re(0,l,o)],n=Ce(e,l,s,o);rt(e,t,n,u);break}case ne:{let t=n.upvals[o.A],a=Me(e,l,s,o),r=Ce(e,l,s,o);it(e,t,a,r);break}case ae:n.upvals[o.B].setfrom(e.stack[u]);break;case te:{let t=e.stack[u],n=Me(e,l,s,o),a=Ce(e,l,s,o);it(e,t,n,a);break}case X:e.stack[u].sethvalue(Le.luaH_new(e));break;case Q:{let t=Re(0,l,o),n=Ce(e,l,s,o);we.setobjs2s(e,u+1,t),rt(e,e.stack[t],n,u);break}case A:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);a.ttisinteger()&&r.ttisinteger()?e.stack[u].setivalue(a.value+r.value|0):!1!==(t=Ve(a))&&!1!==(n=Ve(r))?e.stack[u].setfltvalue(t+n):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_ADD);break}case se:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);a.ttisinteger()&&r.ttisinteger()?e.stack[u].setivalue(a.value-r.value|0):!1!==(t=Ve(a))&&!1!==(n=Ve(r))?e.stack[u].setfltvalue(t-n):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_SUB);break}case j:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);a.ttisinteger()&&r.ttisinteger()?e.stack[u].setivalue(qe(a.value,r.value)):!1!==(t=Ve(a))&&!1!==(n=Ve(r))?e.stack[u].setfltvalue(t*n):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_MUL);break}case q:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);a.ttisinteger()&&r.ttisinteger()?e.stack[u].setivalue(je(e,a.value,r.value)):!1!==(t=Ve(a))&&!1!==(n=Ve(r))?e.stack[u].setfltvalue(be(e,t,n)):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_MOD);break}case J:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);!1!==(t=Ve(a))&&!1!==(n=Ve(r))?e.stack[u].setfltvalue(Math.pow(t,n)):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_POW);break}case U:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);!1!==(t=Ve(a))&&!1!==(n=Ve(r))?e.stack[u].setfltvalue(t/n):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_DIV);break}case D:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);a.ttisinteger()&&r.ttisinteger()?e.stack[u].setivalue(Ze(e,a.value,r.value)):!1!==(t=Ve(a))&&!1!==(n=Ve(r))?e.stack[u].setfltvalue(Math.floor(t/n)):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_IDIV);break}case y:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);!1!==(t=Ne(a))&&!1!==(n=Ne(r))?e.stack[u].setivalue(t&n):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_BAND);break}case T:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);!1!==(t=Ne(a))&&!1!==(n=Ne(r))?e.stack[u].setivalue(t|n):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_BOR);break}case x:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);!1!==(t=Ne(a))&&!1!==(n=Ne(r))?e.stack[u].setivalue(t^n):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_BXOR);break}case re:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);!1!==(t=Ne(a))&&!1!==(n=Ne(r))?e.stack[u].setivalue(Xe(t,n)):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_SHL);break}case ie:{let t,n,a=Me(e,l,s,o),r=Ce(e,l,s,o);!1!==(t=Ne(a))&&!1!==(n=Ne(r))?e.stack[u].setivalue(Xe(t,-n)):Ee.luaT_trybinTM(e,a,r,e.stack[u],Ee.TMS.TM_SHR);break}case he:{let t,n=e.stack[Re(0,l,o)];n.ttisinteger()?e.stack[u].setivalue(0|-n.value):!1!==(t=Ve(n))?e.stack[u].setfltvalue(-t):Ee.luaT_trybinTM(e,n,n,e.stack[u],Ee.TMS.TM_UNM);break}case S:{let t=e.stack[Re(0,l,o)];t.ttisinteger()?e.stack[u].setivalue(~t.value):Ee.luaT_trybinTM(e,t,t,e.stack[u],Ee.TMS.TM_BNOT);break}case $:{let t=e.stack[Re(0,l,o)];e.stack[u].setbvalue(t.l_isfalse());break}case N:ze(e,e.stack[u],e.stack[Re(0,l,o)]);break;case I:{let n=o.B,a=o.C;e.top=l+a+1,at(e,a-n+1);let r=l+n;we.setobjs2s(e,u,r),xe.adjust_top(e,t.top);break}case F:Be(e,t,o,0);break;case R:De(e,Me(e,l,s,o),Ce(e,l,s,o))!==o.A?t.l_savedpc++:Pe(e,t);break;case z:ke(e,Me(e,l,s,o),Ce(e,l,s,o))!==o.A?t.l_savedpc++:Pe(e,t);break;case G:Oe(e,Me(e,l,s,o),Ce(e,l,s,o))!==o.A?t.l_savedpc++:Pe(e,t);break;case oe:(o.C?e.stack[u].l_isfalse():!e.stack[u].l_isfalse())?t.l_savedpc++:Pe(e,t);break;case ue:{let n=Re(0,l,o),a=e.stack[n];(o.C?a.l_isfalse():!a.l_isfalse())?t.l_savedpc++:(we.setobjs2s(e,u,n),Pe(e,t));break}case E:{let n=o.B,a=o.C-1;if(0!==n&&xe.adjust_top(e,u+n),!xe.luaD_precall(e,u,a)){t=e.ci;continue e}a>=0&&xe.adjust_top(e,t.top);break}case le:{let a=o.B;if(0!==a&&xe.adjust_top(e,u+a),!xe.luaD_precall(e,u,i)){let a=e.ci,r=a.previous,i=a.func,s=a.funcOff,l=r.funcOff,o=a.l_base+i.value.p.numparams;n.p.p.length>0&&ve.luaF_close(e,r.l_base);for(let t=0;s+t<o;t++)we.setobjs2s(e,l+t,s+t);r.l_base=l+(a.l_base-s),r.top=l+(e.top-s),xe.adjust_top(e,r.top),r.l_code=a.l_code,r.l_savedpc=a.l_savedpc,r.callstatus|=Ae.CIST_TAIL,r.next=null,t=e.ci=r,ge(e.top===r.l_base+e.stack[l].value.p.maxstacksize);continue e}break}case W:{n.p.p.length>0&&ve.luaF_close(e,l);let a=xe.luaD_poscall(e,t,u,0!==o.B?o.B-1:e.top-u);if(t.callstatus&Ae.CIST_FRESH)return;t=e.ci,a&&xe.adjust_top(e,t.top),ge(t.callstatus&Ae.CIST_LUA),ge(t.l_code[t.l_savedpc-1].opcode===E);continue e}case C:if(e.stack[u].ttisinteger()){let n=e.stack[u+2].value,a=e.stack[u].value+n|0,r=e.stack[u+1].value;(0<n?a<=r:r<=a)&&(t.l_savedpc+=o.sBx,e.stack[u].chgivalue(a),e.stack[u+3].setivalue(a))}else{let n=e.stack[u+2].value,a=e.stack[u].value+n,r=e.stack[u+1].value;(0<n?a<=r:r<=a)&&(t.l_savedpc+=o.sBx,e.stack[u].chgfltvalue(a),e.stack[u+3].setfltvalue(a))}break;case B:{let n,a=e.stack[u],r=e.stack[u+1],i=e.stack[u+2];if(a.ttisinteger()&&i.ttisinteger()&&(n=Fe(r,i.value))){let e=n.stopnow?0:a.value;r.value=n.ilimit,a.value=e-i.value|0}else{let t,n,s;!1===(t=Ve(r))&&Ie.luaG_runerror(e,g("'for' limit must be a number",!0)),e.stack[u+1].setfltvalue(t),!1===(n=Ve(i))&&Ie.luaG_runerror(e,g("'for' step must be a number",!0)),e.stack[u+2].setfltvalue(n),!1===(s=Ve(a))&&Ie.luaG_runerror(e,g("'for' initial value must be a number",!0)),e.stack[u].setfltvalue(s-n)}t.l_savedpc+=o.sBx;break}case ce:{let n=u+3;we.setobjs2s(e,n+2,u+2),we.setobjs2s(e,n+1,u+1),we.setobjs2s(e,n,u),xe.adjust_top(e,n+3),xe.luaD_call(e,n,o.C),xe.adjust_top(e,t.top),o=t.l_code[t.l_savedpc++],u=Ue(0,l,o),ge(o.opcode===de)}case de:e.stack[u+1].ttisnil()||(we.setobjs2s(e,u,u+1),t.l_savedpc+=o.sBx);break;case ee:{let n=o.B,a=o.C;0===n&&(n=e.top-u-1),0===a&&(ge(t.l_code[t.l_savedpc].opcode===M),a=t.l_code[t.l_savedpc++].Ax);let r=e.stack[u].value,i=(a-1)*v+n;for(;n>0;n--)Le.luaH_setint(r,i--,e.stack[u+n]);xe.adjust_top(e,t.top);break}case L:{let t=n.p.p[o.Bx],a=$e(t,n.upvals,e.stack,l);null===a?Je(e,t,n.upvals,l,u):e.stack[u].setclLvalue(a);break}case fe:{let a,r=o.B-1,i=l-t.funcOff-n.p.numparams-1;for(i<0&&(i=0),r<0&&(r=i,xe.luaD_checkstack(e,i),xe.adjust_top(e,u+i)),a=0;a<r&&a<i;a++)we.setobjs2s(e,u+a,l-i+a);for(;a<r;a++)e.stack[u+a].setnilvalue();break}case M:throw Error("invalid opcode")}}},e.exports.luaV_finishOp=function(e){let t=e.ci,n=t.l_base,a=t.l_code[t.l_savedpc-1],r=a.opcode;switch(r){case A:case se:case j:case U:case D:case y:case T:case x:case re:case ie:case q:case J:case he:case S:case N:case k:case P:case Q:we.setobjs2s(e,n+a.A,e.top-1),delete e.stack[--e.top];break;case G:case z:case R:{let n=!e.stack[e.top-1].l_isfalse();delete e.stack[--e.top],t.callstatus&Ae.CIST_LEQ&&(ge(r===G),t.callstatus^=Ae.CIST_LEQ,n=!n),ge(t.l_code[t.l_savedpc].opcode===F),n!==!!a.A&&t.l_savedpc++;break}case I:{let r=e.top-1,i=r-1-(n+a.B);we.setobjs2s(e,r-2,r),i>1&&(e.top=r-1,at(e,i)),we.setobjs2s(e,t.l_base+a.A,e.top-1),xe.adjust_top(e,t.top);break}case ce:ge(t.l_code[t.l_savedpc].opcode===de),xe.adjust_top(e,t.top);break;case E:a.C-1>=0&&xe.adjust_top(e,t.top)}},e.exports.luaV_imul=qe,e.exports.luaV_lessequal=Oe,e.exports.luaV_lessthan=ke,e.exports.luaV_mod=je,e.exports.luaV_objlen=ze,e.exports.luaV_rawequalobj=function(e,t){return De(null,e,t)},e.exports.luaV_shiftl=Xe,e.exports.luaV_tointeger=Ge,e.exports.settable=it,e.exports.tointeger=Ne,e.exports.tonumber=Ve},161:(e,t,n)=>{"use strict";const{lua_assert:a}=n(568);const r=function(e){let t=e.reader(e.L,e.data);if(null===t)return-1;a(t instanceof Uint8Array,"Should only load binary of array of bytes");let n=t.length;return 0===n?-1:(e.buffer=t,e.off=0,e.n=n-1,e.buffer[e.off++])};e.exports.EOZ=-1,e.exports.luaZ_buffer=function(e){return e.buffer.subarray(0,e.n)},e.exports.luaZ_buffremove=function(e,t){e.n-=t},e.exports.luaZ_fill=r,e.exports.luaZ_read=function(e,t,n,a){for(;a;){if(0===e.n){if(-1===r(e))return a;e.n++,e.off--}let i=a<=e.n?a:e.n;for(let a=0;a<i;a++)t[n++]=e.buffer[e.off++];e.n-=i,0===e.n&&(e.buffer=null),a-=i}return 0},e.exports.luaZ_resetbuffer=function(e){e.n=0},e.exports.luaZ_resizebuffer=function(e,t,n){let a=new Uint8Array(n);t.buffer&&a.set(t.buffer),t.buffer=a},e.exports.MBuffer=class{constructor(){this.buffer=null,this.n=0}},e.exports.ZIO=class{constructor(e,t,n){this.L=e,a("function"==typeof t,"ZIO requires a reader"),this.reader=t,this.data=n,this.n=0,this.buffer=null,this.off=0}zgetc(){return this.n-- >0?this.buffer[this.off++]:r(this)}}},685:(e,t,n)=>{"use strict";n.r(t),n.d(t,{EPSILON:()=>a,ARRAY_TYPE:()=>r,RANDOM:()=>i,setMatrixArrayType:()=>s,toRadian:()=>o,equals:()=>u});var a=1e-6,r="undefined"!=typeof Float32Array?Float32Array:Array,i=Math.random;function s(e){r=e}var l=Math.PI/180;function o(e){return e*l}function u(e,t){return Math.abs(e-t)<=a*Math.max(1,Math.abs(e),Math.abs(t))}Math.hypot||(Math.hypot=function(){for(var e=0,t=arguments.length;t--;)e+=arguments[t]*arguments[t];return Math.sqrt(e)})},600:(e,t,n)=>{"use strict";n.r(t),n.d(t,{create:()=>r,fromMat4:()=>i,clone:()=>s,copy:()=>l,fromValues:()=>o,set:()=>u,identity:()=>c,transpose:()=>d,invert:()=>h,adjoint:()=>f,determinant:()=>m,multiply:()=>p,translate:()=>_,rotate:()=>g,scale:()=>b,fromTranslation:()=>w,fromRotation:()=>v,fromScaling:()=>A,fromMat2d:()=>y,fromQuat:()=>S,normalFromMat4:()=>T,projection:()=>x,str:()=>E,frob:()=>L,add:()=>I,subtract:()=>U,multiplyScalar:()=>R,multiplyScalarAndAdd:()=>M,exactEquals:()=>C,equals:()=>B,mul:()=>P,sub:()=>k});var a=n(685);function r(){var e=new a.ARRAY_TYPE(9);return a.ARRAY_TYPE!=Float32Array&&(e[1]=0,e[2]=0,e[3]=0,e[5]=0,e[6]=0,e[7]=0),e[0]=1,e[4]=1,e[8]=1,e}function i(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[4],e[4]=t[5],e[5]=t[6],e[6]=t[8],e[7]=t[9],e[8]=t[10],e}function s(e){var t=new a.ARRAY_TYPE(9);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t}function l(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e}function o(e,t,n,r,i,s,l,o,u){var c=new a.ARRAY_TYPE(9);return c[0]=e,c[1]=t,c[2]=n,c[3]=r,c[4]=i,c[5]=s,c[6]=l,c[7]=o,c[8]=u,c}function u(e,t,n,a,r,i,s,l,o,u){return e[0]=t,e[1]=n,e[2]=a,e[3]=r,e[4]=i,e[5]=s,e[6]=l,e[7]=o,e[8]=u,e}function c(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=1,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e}function d(e,t){if(e===t){var n=t[1],a=t[2],r=t[5];e[1]=t[3],e[2]=t[6],e[3]=n,e[5]=t[7],e[6]=a,e[7]=r}else e[0]=t[0],e[1]=t[3],e[2]=t[6],e[3]=t[1],e[4]=t[4],e[5]=t[7],e[6]=t[2],e[7]=t[5],e[8]=t[8];return e}function h(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=t[4],l=t[5],o=t[6],u=t[7],c=t[8],d=c*s-l*u,h=-c*i+l*o,f=u*i-s*o,m=n*d+a*h+r*f;return m?(m=1/m,e[0]=d*m,e[1]=(-c*a+r*u)*m,e[2]=(l*a-r*s)*m,e[3]=h*m,e[4]=(c*n-r*o)*m,e[5]=(-l*n+r*i)*m,e[6]=f*m,e[7]=(-u*n+a*o)*m,e[8]=(s*n-a*i)*m,e):null}function f(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=t[4],l=t[5],o=t[6],u=t[7],c=t[8];return e[0]=s*c-l*u,e[1]=r*u-a*c,e[2]=a*l-r*s,e[3]=l*o-i*c,e[4]=n*c-r*o,e[5]=r*i-n*l,e[6]=i*u-s*o,e[7]=a*o-n*u,e[8]=n*s-a*i,e}function m(e){var t=e[0],n=e[1],a=e[2],r=e[3],i=e[4],s=e[5],l=e[6],o=e[7],u=e[8];return t*(u*i-s*o)+n*(-u*r+s*l)+a*(o*r-i*l)}function p(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=t[4],o=t[5],u=t[6],c=t[7],d=t[8],h=n[0],f=n[1],m=n[2],p=n[3],_=n[4],g=n[5],b=n[6],w=n[7],v=n[8];return e[0]=h*a+f*s+m*u,e[1]=h*r+f*l+m*c,e[2]=h*i+f*o+m*d,e[3]=p*a+_*s+g*u,e[4]=p*r+_*l+g*c,e[5]=p*i+_*o+g*d,e[6]=b*a+w*s+v*u,e[7]=b*r+w*l+v*c,e[8]=b*i+w*o+v*d,e}function _(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=t[4],o=t[5],u=t[6],c=t[7],d=t[8],h=n[0],f=n[1];return e[0]=a,e[1]=r,e[2]=i,e[3]=s,e[4]=l,e[5]=o,e[6]=h*a+f*s+u,e[7]=h*r+f*l+c,e[8]=h*i+f*o+d,e}function g(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=t[4],o=t[5],u=t[6],c=t[7],d=t[8],h=Math.sin(n),f=Math.cos(n);return e[0]=f*a+h*s,e[1]=f*r+h*l,e[2]=f*i+h*o,e[3]=f*s-h*a,e[4]=f*l-h*r,e[5]=f*o-h*i,e[6]=u,e[7]=c,e[8]=d,e}function b(e,t,n){var a=n[0],r=n[1];return e[0]=a*t[0],e[1]=a*t[1],e[2]=a*t[2],e[3]=r*t[3],e[4]=r*t[4],e[5]=r*t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e}function w(e,t){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=1,e[5]=0,e[6]=t[0],e[7]=t[1],e[8]=1,e}function v(e,t){var n=Math.sin(t),a=Math.cos(t);return e[0]=a,e[1]=n,e[2]=0,e[3]=-n,e[4]=a,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e}function A(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=0,e[4]=t[1],e[5]=0,e[6]=0,e[7]=0,e[8]=1,e}function y(e,t){return e[0]=t[0],e[1]=t[1],e[2]=0,e[3]=t[2],e[4]=t[3],e[5]=0,e[6]=t[4],e[7]=t[5],e[8]=1,e}function S(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=n+n,l=a+a,o=r+r,u=n*s,c=a*s,d=a*l,h=r*s,f=r*l,m=r*o,p=i*s,_=i*l,g=i*o;return e[0]=1-d-m,e[3]=c-g,e[6]=h+_,e[1]=c+g,e[4]=1-u-m,e[7]=f-p,e[2]=h-_,e[5]=f+p,e[8]=1-u-d,e}function T(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=t[4],l=t[5],o=t[6],u=t[7],c=t[8],d=t[9],h=t[10],f=t[11],m=t[12],p=t[13],_=t[14],g=t[15],b=n*l-a*s,w=n*o-r*s,v=n*u-i*s,A=a*o-r*l,y=a*u-i*l,S=r*u-i*o,T=c*p-d*m,x=c*_-h*m,E=c*g-f*m,L=d*_-h*p,I=d*g-f*p,U=h*g-f*_,R=b*U-w*I+v*L+A*E-y*x+S*T;return R?(R=1/R,e[0]=(l*U-o*I+u*L)*R,e[1]=(o*E-s*U-u*x)*R,e[2]=(s*I-l*E+u*T)*R,e[3]=(r*I-a*U-i*L)*R,e[4]=(n*U-r*E+i*x)*R,e[5]=(a*E-n*I-i*T)*R,e[6]=(p*S-_*y+g*A)*R,e[7]=(_*v-m*S-g*w)*R,e[8]=(m*y-p*v+g*b)*R,e):null}function x(e,t,n){return e[0]=2/t,e[1]=0,e[2]=0,e[3]=0,e[4]=-2/n,e[5]=0,e[6]=-1,e[7]=1,e[8]=1,e}function E(e){return"mat3("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+", "+e[6]+", "+e[7]+", "+e[8]+")"}function L(e){return Math.hypot(e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8])}function I(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e[4]=t[4]+n[4],e[5]=t[5]+n[5],e[6]=t[6]+n[6],e[7]=t[7]+n[7],e[8]=t[8]+n[8],e}function U(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e[4]=t[4]-n[4],e[5]=t[5]-n[5],e[6]=t[6]-n[6],e[7]=t[7]-n[7],e[8]=t[8]-n[8],e}function R(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*n,e[5]=t[5]*n,e[6]=t[6]*n,e[7]=t[7]*n,e[8]=t[8]*n,e}function M(e,t,n,a){return e[0]=t[0]+n[0]*a,e[1]=t[1]+n[1]*a,e[2]=t[2]+n[2]*a,e[3]=t[3]+n[3]*a,e[4]=t[4]+n[4]*a,e[5]=t[5]+n[5]*a,e[6]=t[6]+n[6]*a,e[7]=t[7]+n[7]*a,e[8]=t[8]+n[8]*a,e}function C(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]&&e[8]===t[8]}function B(e,t){var n=e[0],r=e[1],i=e[2],s=e[3],l=e[4],o=e[5],u=e[6],c=e[7],d=e[8],h=t[0],f=t[1],m=t[2],p=t[3],_=t[4],g=t[5],b=t[6],w=t[7],v=t[8];return Math.abs(n-h)<=a.EPSILON*Math.max(1,Math.abs(n),Math.abs(h))&&Math.abs(r-f)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(f))&&Math.abs(i-m)<=a.EPSILON*Math.max(1,Math.abs(i),Math.abs(m))&&Math.abs(s-p)<=a.EPSILON*Math.max(1,Math.abs(s),Math.abs(p))&&Math.abs(l-_)<=a.EPSILON*Math.max(1,Math.abs(l),Math.abs(_))&&Math.abs(o-g)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(g))&&Math.abs(u-b)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(b))&&Math.abs(c-w)<=a.EPSILON*Math.max(1,Math.abs(c),Math.abs(w))&&Math.abs(d-v)<=a.EPSILON*Math.max(1,Math.abs(d),Math.abs(v))}var P=p,k=U},945:(e,t,n)=>{"use strict";n.r(t),n.d(t,{create:()=>l,identity:()=>o,setAxisAngle:()=>u,getAxisAngle:()=>c,getAngle:()=>d,multiply:()=>h,rotateX:()=>f,rotateY:()=>m,rotateZ:()=>p,calculateW:()=>_,exp:()=>g,ln:()=>b,pow:()=>w,slerp:()=>v,random:()=>A,invert:()=>y,conjugate:()=>S,fromMat3:()=>T,fromEuler:()=>x,str:()=>E,clone:()=>B,fromValues:()=>P,copy:()=>k,set:()=>O,add:()=>D,mul:()=>F,scale:()=>G,dot:()=>N,lerp:()=>V,length:()=>H,len:()=>Y,squaredLength:()=>K,sqrLen:()=>z,normalize:()=>q,exactEquals:()=>Z,equals:()=>j,rotationTo:()=>X,sqlerp:()=>$,setAxes:()=>J});var a=n(685),r=n(600),i=n(160),s=n(333);function l(){var e=new a.ARRAY_TYPE(4);return a.ARRAY_TYPE!=Float32Array&&(e[0]=0,e[1]=0,e[2]=0),e[3]=1,e}function o(e){return e[0]=0,e[1]=0,e[2]=0,e[3]=1,e}function u(e,t,n){n*=.5;var a=Math.sin(n);return e[0]=a*t[0],e[1]=a*t[1],e[2]=a*t[2],e[3]=Math.cos(n),e}function c(e,t){var n=2*Math.acos(t[3]),r=Math.sin(n/2);return r>a.EPSILON?(e[0]=t[0]/r,e[1]=t[1]/r,e[2]=t[2]/r):(e[0]=1,e[1]=0,e[2]=0),n}function d(e,t){var n=N(e,t);return Math.acos(2*n*n-1)}function h(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=n[0],o=n[1],u=n[2],c=n[3];return e[0]=a*c+s*l+r*u-i*o,e[1]=r*c+s*o+i*l-a*u,e[2]=i*c+s*u+a*o-r*l,e[3]=s*c-a*l-r*o-i*u,e}function f(e,t,n){n*=.5;var a=t[0],r=t[1],i=t[2],s=t[3],l=Math.sin(n),o=Math.cos(n);return e[0]=a*o+s*l,e[1]=r*o+i*l,e[2]=i*o-r*l,e[3]=s*o-a*l,e}function m(e,t,n){n*=.5;var a=t[0],r=t[1],i=t[2],s=t[3],l=Math.sin(n),o=Math.cos(n);return e[0]=a*o-i*l,e[1]=r*o+s*l,e[2]=i*o+a*l,e[3]=s*o-r*l,e}function p(e,t,n){n*=.5;var a=t[0],r=t[1],i=t[2],s=t[3],l=Math.sin(n),o=Math.cos(n);return e[0]=a*o+r*l,e[1]=r*o-a*l,e[2]=i*o+s*l,e[3]=s*o-i*l,e}function _(e,t){var n=t[0],a=t[1],r=t[2];return e[0]=n,e[1]=a,e[2]=r,e[3]=Math.sqrt(Math.abs(1-n*n-a*a-r*r)),e}function g(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=Math.sqrt(n*n+a*a+r*r),l=Math.exp(i),o=s>0?l*Math.sin(s)/s:0;return e[0]=n*o,e[1]=a*o,e[2]=r*o,e[3]=l*Math.cos(s),e}function b(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=Math.sqrt(n*n+a*a+r*r),l=s>0?Math.atan2(s,i)/s:0;return e[0]=n*l,e[1]=a*l,e[2]=r*l,e[3]=.5*Math.log(n*n+a*a+r*r+i*i),e}function w(e,t,n){return b(e,t),G(e,e,n),g(e,e),e}function v(e,t,n,r){var i,s,l,o,u,c=t[0],d=t[1],h=t[2],f=t[3],m=n[0],p=n[1],_=n[2],g=n[3];return(s=c*m+d*p+h*_+f*g)<0&&(s=-s,m=-m,p=-p,_=-_,g=-g),1-s>a.EPSILON?(i=Math.acos(s),l=Math.sin(i),o=Math.sin((1-r)*i)/l,u=Math.sin(r*i)/l):(o=1-r,u=r),e[0]=o*c+u*m,e[1]=o*d+u*p,e[2]=o*h+u*_,e[3]=o*f+u*g,e}function A(e){var t=a.RANDOM(),n=a.RANDOM(),r=a.RANDOM(),i=Math.sqrt(1-t),s=Math.sqrt(t);return e[0]=i*Math.sin(2*Math.PI*n),e[1]=i*Math.cos(2*Math.PI*n),e[2]=s*Math.sin(2*Math.PI*r),e[3]=s*Math.cos(2*Math.PI*r),e}function y(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=n*n+a*a+r*r+i*i,l=s?1/s:0;return e[0]=-n*l,e[1]=-a*l,e[2]=-r*l,e[3]=i*l,e}function S(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=t[3],e}function T(e,t){var n,a=t[0]+t[4]+t[8];if(a>0)n=Math.sqrt(a+1),e[3]=.5*n,n=.5/n,e[0]=(t[5]-t[7])*n,e[1]=(t[6]-t[2])*n,e[2]=(t[1]-t[3])*n;else{var r=0;t[4]>t[0]&&(r=1),t[8]>t[3*r+r]&&(r=2);var i=(r+1)%3,s=(r+2)%3;n=Math.sqrt(t[3*r+r]-t[3*i+i]-t[3*s+s]+1),e[r]=.5*n,n=.5/n,e[3]=(t[3*i+s]-t[3*s+i])*n,e[i]=(t[3*i+r]+t[3*r+i])*n,e[s]=(t[3*s+r]+t[3*r+s])*n}return e}function x(e,t,n,a){var r=.5*Math.PI/180;t*=r,n*=r,a*=r;var i=Math.sin(t),s=Math.cos(t),l=Math.sin(n),o=Math.cos(n),u=Math.sin(a),c=Math.cos(a);return e[0]=i*o*c-s*l*u,e[1]=s*l*c+i*o*u,e[2]=s*o*u-i*l*c,e[3]=s*o*c+i*l*u,e}function E(e){return"quat("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"}var L,I,U,R,M,C,B=s.clone,P=s.fromValues,k=s.copy,O=s.set,D=s.add,F=h,G=s.scale,N=s.dot,V=s.lerp,H=s.length,Y=H,K=s.squaredLength,z=K,q=s.normalize,Z=s.exactEquals,j=s.equals,X=(L=i.create(),I=i.fromValues(1,0,0),U=i.fromValues(0,1,0),function(e,t,n){var a=i.dot(t,n);return a<-.999999?(i.cross(L,I,t),i.len(L)<1e-6&&i.cross(L,U,t),i.normalize(L,L),u(e,L,Math.PI),e):a>.999999?(e[0]=0,e[1]=0,e[2]=0,e[3]=1,e):(i.cross(L,t,n),e[0]=L[0],e[1]=L[1],e[2]=L[2],e[3]=1+a,q(e,e))}),$=(R=l(),M=l(),function(e,t,n,a,r,i){return v(R,t,r,i),v(M,n,a,i),v(e,R,M,2*i*(1-i)),e}),J=(C=r.create(),function(e,t,n,a){return C[0]=n[0],C[3]=n[1],C[6]=n[2],C[1]=a[0],C[4]=a[1],C[7]=a[2],C[2]=-t[0],C[5]=-t[1],C[8]=-t[2],q(e,T(e,C))})},160:(e,t,n)=>{"use strict";n.r(t),n.d(t,{create:()=>r,clone:()=>i,length:()=>s,fromValues:()=>l,copy:()=>o,set:()=>u,add:()=>c,subtract:()=>d,multiply:()=>h,divide:()=>f,ceil:()=>m,floor:()=>p,min:()=>_,max:()=>g,round:()=>b,scale:()=>w,scaleAndAdd:()=>v,distance:()=>A,squaredDistance:()=>y,squaredLength:()=>S,negate:()=>T,inverse:()=>x,normalize:()=>E,dot:()=>L,cross:()=>I,lerp:()=>U,hermite:()=>R,bezier:()=>M,random:()=>C,transformMat4:()=>B,transformMat3:()=>P,transformQuat:()=>k,rotateX:()=>O,rotateY:()=>D,rotateZ:()=>F,angle:()=>G,zero:()=>N,str:()=>V,exactEquals:()=>H,equals:()=>Y,sub:()=>z,mul:()=>q,div:()=>Z,dist:()=>j,sqrDist:()=>X,len:()=>$,sqrLen:()=>J,forEach:()=>W});var a=n(685);function r(){var e=new a.ARRAY_TYPE(3);return a.ARRAY_TYPE!=Float32Array&&(e[0]=0,e[1]=0,e[2]=0),e}function i(e){var t=new a.ARRAY_TYPE(3);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t}function s(e){var t=e[0],n=e[1],a=e[2];return Math.hypot(t,n,a)}function l(e,t,n){var r=new a.ARRAY_TYPE(3);return r[0]=e,r[1]=t,r[2]=n,r}function o(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e}function u(e,t,n,a){return e[0]=t,e[1]=n,e[2]=a,e}function c(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e}function d(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e}function h(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e[2]=t[2]*n[2],e}function f(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e[2]=t[2]/n[2],e}function m(e,t){return e[0]=Math.ceil(t[0]),e[1]=Math.ceil(t[1]),e[2]=Math.ceil(t[2]),e}function p(e,t){return e[0]=Math.floor(t[0]),e[1]=Math.floor(t[1]),e[2]=Math.floor(t[2]),e}function _(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e[2]=Math.min(t[2],n[2]),e}function g(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e[2]=Math.max(t[2],n[2]),e}function b(e,t){return e[0]=Math.round(t[0]),e[1]=Math.round(t[1]),e[2]=Math.round(t[2]),e}function w(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e}function v(e,t,n,a){return e[0]=t[0]+n[0]*a,e[1]=t[1]+n[1]*a,e[2]=t[2]+n[2]*a,e}function A(e,t){var n=t[0]-e[0],a=t[1]-e[1],r=t[2]-e[2];return Math.hypot(n,a,r)}function y(e,t){var n=t[0]-e[0],a=t[1]-e[1],r=t[2]-e[2];return n*n+a*a+r*r}function S(e){var t=e[0],n=e[1],a=e[2];return t*t+n*n+a*a}function T(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e}function x(e,t){return e[0]=1/t[0],e[1]=1/t[1],e[2]=1/t[2],e}function E(e,t){var n=t[0],a=t[1],r=t[2],i=n*n+a*a+r*r;return i>0&&(i=1/Math.sqrt(i)),e[0]=t[0]*i,e[1]=t[1]*i,e[2]=t[2]*i,e}function L(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]}function I(e,t,n){var a=t[0],r=t[1],i=t[2],s=n[0],l=n[1],o=n[2];return e[0]=r*o-i*l,e[1]=i*s-a*o,e[2]=a*l-r*s,e}function U(e,t,n,a){var r=t[0],i=t[1],s=t[2];return e[0]=r+a*(n[0]-r),e[1]=i+a*(n[1]-i),e[2]=s+a*(n[2]-s),e}function R(e,t,n,a,r,i){var s=i*i,l=s*(2*i-3)+1,o=s*(i-2)+i,u=s*(i-1),c=s*(3-2*i);return e[0]=t[0]*l+n[0]*o+a[0]*u+r[0]*c,e[1]=t[1]*l+n[1]*o+a[1]*u+r[1]*c,e[2]=t[2]*l+n[2]*o+a[2]*u+r[2]*c,e}function M(e,t,n,a,r,i){var s=1-i,l=s*s,o=i*i,u=l*s,c=3*i*l,d=3*o*s,h=o*i;return e[0]=t[0]*u+n[0]*c+a[0]*d+r[0]*h,e[1]=t[1]*u+n[1]*c+a[1]*d+r[1]*h,e[2]=t[2]*u+n[2]*c+a[2]*d+r[2]*h,e}function C(e,t){t=t||1;var n=2*a.RANDOM()*Math.PI,r=2*a.RANDOM()-1,i=Math.sqrt(1-r*r)*t;return e[0]=Math.cos(n)*i,e[1]=Math.sin(n)*i,e[2]=r*t,e}function B(e,t,n){var a=t[0],r=t[1],i=t[2],s=n[3]*a+n[7]*r+n[11]*i+n[15];return s=s||1,e[0]=(n[0]*a+n[4]*r+n[8]*i+n[12])/s,e[1]=(n[1]*a+n[5]*r+n[9]*i+n[13])/s,e[2]=(n[2]*a+n[6]*r+n[10]*i+n[14])/s,e}function P(e,t,n){var a=t[0],r=t[1],i=t[2];return e[0]=a*n[0]+r*n[3]+i*n[6],e[1]=a*n[1]+r*n[4]+i*n[7],e[2]=a*n[2]+r*n[5]+i*n[8],e}function k(e,t,n){var a=n[0],r=n[1],i=n[2],s=n[3],l=t[0],o=t[1],u=t[2],c=r*u-i*o,d=i*l-a*u,h=a*o-r*l,f=r*h-i*d,m=i*c-a*h,p=a*d-r*c,_=2*s;return c*=_,d*=_,h*=_,f*=2,m*=2,p*=2,e[0]=l+c+f,e[1]=o+d+m,e[2]=u+h+p,e}function O(e,t,n,a){var r=[],i=[];return r[0]=t[0]-n[0],r[1]=t[1]-n[1],r[2]=t[2]-n[2],i[0]=r[0],i[1]=r[1]*Math.cos(a)-r[2]*Math.sin(a),i[2]=r[1]*Math.sin(a)+r[2]*Math.cos(a),e[0]=i[0]+n[0],e[1]=i[1]+n[1],e[2]=i[2]+n[2],e}function D(e,t,n,a){var r=[],i=[];return r[0]=t[0]-n[0],r[1]=t[1]-n[1],r[2]=t[2]-n[2],i[0]=r[2]*Math.sin(a)+r[0]*Math.cos(a),i[1]=r[1],i[2]=r[2]*Math.cos(a)-r[0]*Math.sin(a),e[0]=i[0]+n[0],e[1]=i[1]+n[1],e[2]=i[2]+n[2],e}function F(e,t,n,a){var r=[],i=[];return r[0]=t[0]-n[0],r[1]=t[1]-n[1],r[2]=t[2]-n[2],i[0]=r[0]*Math.cos(a)-r[1]*Math.sin(a),i[1]=r[0]*Math.sin(a)+r[1]*Math.cos(a),i[2]=r[2],e[0]=i[0]+n[0],e[1]=i[1]+n[1],e[2]=i[2]+n[2],e}function G(e,t){var n=e[0],a=e[1],r=e[2],i=t[0],s=t[1],l=t[2],o=Math.sqrt(n*n+a*a+r*r)*Math.sqrt(i*i+s*s+l*l),u=o&&L(e,t)/o;return Math.acos(Math.min(Math.max(u,-1),1))}function N(e){return e[0]=0,e[1]=0,e[2]=0,e}function V(e){return"vec3("+e[0]+", "+e[1]+", "+e[2]+")"}function H(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]}function Y(e,t){var n=e[0],r=e[1],i=e[2],s=t[0],l=t[1],o=t[2];return Math.abs(n-s)<=a.EPSILON*Math.max(1,Math.abs(n),Math.abs(s))&&Math.abs(r-l)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(l))&&Math.abs(i-o)<=a.EPSILON*Math.max(1,Math.abs(i),Math.abs(o))}var K,z=d,q=h,Z=f,j=A,X=y,$=s,J=S,W=(K=r(),function(e,t,n,a,r,i){var s,l;for(t||(t=3),n||(n=0),l=a?Math.min(a*t+n,e.length):e.length,s=n;s<l;s+=t)K[0]=e[s],K[1]=e[s+1],K[2]=e[s+2],r(K,K,i),e[s]=K[0],e[s+1]=K[1],e[s+2]=K[2];return e})},333:(e,t,n)=>{"use strict";n.r(t),n.d(t,{create:()=>r,clone:()=>i,fromValues:()=>s,copy:()=>l,set:()=>o,add:()=>u,subtract:()=>c,multiply:()=>d,divide:()=>h,ceil:()=>f,floor:()=>m,min:()=>p,max:()=>_,round:()=>g,scale:()=>b,scaleAndAdd:()=>w,distance:()=>v,squaredDistance:()=>A,length:()=>y,squaredLength:()=>S,negate:()=>T,inverse:()=>x,normalize:()=>E,dot:()=>L,cross:()=>I,lerp:()=>U,random:()=>R,transformMat4:()=>M,transformQuat:()=>C,zero:()=>B,str:()=>P,exactEquals:()=>k,equals:()=>O,sub:()=>F,mul:()=>G,div:()=>N,dist:()=>V,sqrDist:()=>H,len:()=>Y,sqrLen:()=>K,forEach:()=>z});var a=n(685);function r(){var e=new a.ARRAY_TYPE(4);return a.ARRAY_TYPE!=Float32Array&&(e[0]=0,e[1]=0,e[2]=0,e[3]=0),e}function i(e){var t=new a.ARRAY_TYPE(4);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t}function s(e,t,n,r){var i=new a.ARRAY_TYPE(4);return i[0]=e,i[1]=t,i[2]=n,i[3]=r,i}function l(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e}function o(e,t,n,a,r){return e[0]=t,e[1]=n,e[2]=a,e[3]=r,e}function u(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e}function c(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e}function d(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e[2]=t[2]*n[2],e[3]=t[3]*n[3],e}function h(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e[2]=t[2]/n[2],e[3]=t[3]/n[3],e}function f(e,t){return e[0]=Math.ceil(t[0]),e[1]=Math.ceil(t[1]),e[2]=Math.ceil(t[2]),e[3]=Math.ceil(t[3]),e}function m(e,t){return e[0]=Math.floor(t[0]),e[1]=Math.floor(t[1]),e[2]=Math.floor(t[2]),e[3]=Math.floor(t[3]),e}function p(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e[2]=Math.min(t[2],n[2]),e[3]=Math.min(t[3],n[3]),e}function _(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e[2]=Math.max(t[2],n[2]),e[3]=Math.max(t[3],n[3]),e}function g(e,t){return e[0]=Math.round(t[0]),e[1]=Math.round(t[1]),e[2]=Math.round(t[2]),e[3]=Math.round(t[3]),e}function b(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e}function w(e,t,n,a){return e[0]=t[0]+n[0]*a,e[1]=t[1]+n[1]*a,e[2]=t[2]+n[2]*a,e[3]=t[3]+n[3]*a,e}function v(e,t){var n=t[0]-e[0],a=t[1]-e[1],r=t[2]-e[2],i=t[3]-e[3];return Math.hypot(n,a,r,i)}function A(e,t){var n=t[0]-e[0],a=t[1]-e[1],r=t[2]-e[2],i=t[3]-e[3];return n*n+a*a+r*r+i*i}function y(e){var t=e[0],n=e[1],a=e[2],r=e[3];return Math.hypot(t,n,a,r)}function S(e){var t=e[0],n=e[1],a=e[2],r=e[3];return t*t+n*n+a*a+r*r}function T(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=-t[3],e}function x(e,t){return e[0]=1/t[0],e[1]=1/t[1],e[2]=1/t[2],e[3]=1/t[3],e}function E(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=n*n+a*a+r*r+i*i;return s>0&&(s=1/Math.sqrt(s)),e[0]=n*s,e[1]=a*s,e[2]=r*s,e[3]=i*s,e}function L(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]+e[3]*t[3]}function I(e,t,n,a){var r=n[0]*a[1]-n[1]*a[0],i=n[0]*a[2]-n[2]*a[0],s=n[0]*a[3]-n[3]*a[0],l=n[1]*a[2]-n[2]*a[1],o=n[1]*a[3]-n[3]*a[1],u=n[2]*a[3]-n[3]*a[2],c=t[0],d=t[1],h=t[2],f=t[3];return e[0]=d*u-h*o+f*l,e[1]=-c*u+h*s-f*i,e[2]=c*o-d*s+f*r,e[3]=-c*l+d*i-h*r,e}function U(e,t,n,a){var r=t[0],i=t[1],s=t[2],l=t[3];return e[0]=r+a*(n[0]-r),e[1]=i+a*(n[1]-i),e[2]=s+a*(n[2]-s),e[3]=l+a*(n[3]-l),e}function R(e,t){var n,r,i,s,l,o;t=t||1;do{l=(n=2*a.RANDOM()-1)*n+(r=2*a.RANDOM()-1)*r}while(l>=1);do{o=(i=2*a.RANDOM()-1)*i+(s=2*a.RANDOM()-1)*s}while(o>=1);var u=Math.sqrt((1-l)/o);return e[0]=t*n,e[1]=t*r,e[2]=t*i*u,e[3]=t*s*u,e}function M(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3];return e[0]=n[0]*a+n[4]*r+n[8]*i+n[12]*s,e[1]=n[1]*a+n[5]*r+n[9]*i+n[13]*s,e[2]=n[2]*a+n[6]*r+n[10]*i+n[14]*s,e[3]=n[3]*a+n[7]*r+n[11]*i+n[15]*s,e}function C(e,t,n){var a=t[0],r=t[1],i=t[2],s=n[0],l=n[1],o=n[2],u=n[3],c=u*a+l*i-o*r,d=u*r+o*a-s*i,h=u*i+s*r-l*a,f=-s*a-l*r-o*i;return e[0]=c*u+f*-s+d*-o-h*-l,e[1]=d*u+f*-l+h*-s-c*-o,e[2]=h*u+f*-o+c*-l-d*-s,e[3]=t[3],e}function B(e){return e[0]=0,e[1]=0,e[2]=0,e[3]=0,e}function P(e){return"vec4("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"}function k(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]}function O(e,t){var n=e[0],r=e[1],i=e[2],s=e[3],l=t[0],o=t[1],u=t[2],c=t[3];return Math.abs(n-l)<=a.EPSILON*Math.max(1,Math.abs(n),Math.abs(l))&&Math.abs(r-o)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(o))&&Math.abs(i-u)<=a.EPSILON*Math.max(1,Math.abs(i),Math.abs(u))&&Math.abs(s-c)<=a.EPSILON*Math.max(1,Math.abs(s),Math.abs(c))}var D,F=c,G=d,N=h,V=v,H=A,Y=y,K=S,z=(D=r(),function(e,t,n,a,r,i){var s,l;for(t||(t=4),n||(n=0),l=a?Math.min(a*t+n,e.length):e.length,s=n;s<l;s+=t)D[0]=e[s],D[1]=e[s+1],D[2]=e[s+2],D[3]=e[s+3],r(D,D,i),e[s]=D[0],e[s+1]=D[1],e[s+2]=D[2],e[s+3]=D[3];return e})}},t={};function n(a){var r=t[a];if(void 0!==r)return r.exports;var i=t[a]={exports:{}};return e[a](i,i.exports,n),i.exports}n.d=(e,t)=>{for(var a in t)n.o(t,a)&&!n.o(e,a)&&Object.defineProperty(e,a,{enumerable:!0,get:t[a]})},n.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),n.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})};var a={};(()=>{"use strict";n.r(a),n.d(a,{default:()=>CV});var e={};n.r(e),n.d(e,{LDU:()=>C,add:()=>B,adjoint:()=>S,clone:()=>_,copy:()=>g,create:()=>p,determinant:()=>T,equals:()=>O,exactEquals:()=>k,frob:()=>M,fromRotation:()=>I,fromScaling:()=>U,fromValues:()=>w,identity:()=>b,invert:()=>y,mul:()=>G,multiply:()=>x,multiplyScalar:()=>D,multiplyScalarAndAdd:()=>F,rotate:()=>E,scale:()=>L,set:()=>v,str:()=>R,sub:()=>N,subtract:()=>P,transpose:()=>A});var t={};n.r(t),n.d(t,{add:()=>re,clone:()=>H,copy:()=>Y,create:()=>V,determinant:()=>j,equals:()=>ue,exactEquals:()=>oe,frob:()=>ae,fromRotation:()=>Q,fromScaling:()=>ee,fromTranslation:()=>te,fromValues:()=>z,identity:()=>K,invert:()=>Z,mul:()=>ce,multiply:()=>X,multiplyScalar:()=>se,multiplyScalarAndAdd:()=>le,rotate:()=>$,scale:()=>J,set:()=>q,str:()=>ne,sub:()=>de,subtract:()=>ie,translate:()=>W});var r={};n.r(r),n.d(r,{add:()=>We,adjoint:()=>Ae,clone:()=>me,copy:()=>pe,create:()=>fe,determinant:()=>ye,equals:()=>at,exactEquals:()=>nt,frob:()=>Je,fromQuat:()=>Ye,fromQuat2:()=>De,fromRotation:()=>Ce,fromRotationTranslation:()=>Oe,fromRotationTranslationScale:()=>Ve,fromRotationTranslationScaleOrigin:()=>He,fromScaling:()=>Me,fromTranslation:()=>Re,fromValues:()=>_e,fromXRotation:()=>Be,fromYRotation:()=>Pe,fromZRotation:()=>ke,frustum:()=>Ke,getRotation:()=>Ne,getScaling:()=>Ge,getTranslation:()=>Fe,identity:()=>be,invert:()=>ve,lookAt:()=>je,mul:()=>rt,multiply:()=>Se,multiplyScalar:()=>et,multiplyScalarAndAdd:()=>tt,ortho:()=>Ze,perspective:()=>ze,perspectiveFromFieldOfView:()=>qe,rotate:()=>Ee,rotateX:()=>Le,rotateY:()=>Ie,rotateZ:()=>Ue,scale:()=>xe,set:()=>ge,str:()=>$e,sub:()=>it,subtract:()=>Qe,targetTo:()=>Xe,translate:()=>Te,transpose:()=>we});var i={};n.r(i),n.d(i,{add:()=>Rt,clone:()=>ot,conjugate:()=>Dt,copy:()=>pt,create:()=>lt,dot:()=>Pt,equals:()=>zt,exactEquals:()=>Kt,fromMat4:()=>mt,fromRotation:()=>ft,fromRotationTranslation:()=>dt,fromRotationTranslationValues:()=>ct,fromTranslation:()=>ht,fromValues:()=>ut,getDual:()=>wt,getReal:()=>bt,getTranslation:()=>yt,identity:()=>_t,invert:()=>Ot,len:()=>Gt,length:()=>Ft,lerp:()=>kt,mul:()=>Ct,multiply:()=>Mt,normalize:()=>Ht,rotateAroundAxis:()=>Ut,rotateByQuatAppend:()=>Lt,rotateByQuatPrepend:()=>It,rotateX:()=>Tt,rotateY:()=>xt,rotateZ:()=>Et,scale:()=>Bt,set:()=>gt,setDual:()=>At,setReal:()=>vt,sqrLen:()=>Vt,squaredLength:()=>Nt,str:()=>Yt,translate:()=>St});var s={};n.r(s),n.d(s,{add:()=>Jt,angle:()=>xn,ceil:()=>tn,clone:()=>Zt,copy:()=>Xt,create:()=>qt,cross:()=>gn,dist:()=>kn,distance:()=>un,div:()=>Pn,divide:()=>en,dot:()=>_n,equals:()=>Un,exactEquals:()=>In,floor:()=>nn,forEach:()=>Fn,fromValues:()=>jt,inverse:()=>mn,len:()=>Mn,length:()=>dn,lerp:()=>bn,max:()=>rn,min:()=>an,mul:()=>Bn,multiply:()=>Qt,negate:()=>fn,normalize:()=>pn,random:()=>wn,rotate:()=>Tn,round:()=>sn,scale:()=>ln,scaleAndAdd:()=>on,set:()=>$t,sqrDist:()=>On,sqrLen:()=>Dn,squaredDistance:()=>cn,squaredLength:()=>hn,str:()=>Ln,sub:()=>Cn,subtract:()=>Wt,transformMat2:()=>vn,transformMat2d:()=>An,transformMat3:()=>yn,transformMat4:()=>Sn,zero:()=>En});var l={};n.r(l),n.d(l,{glMatrix:()=>m,mat2:()=>e,mat2d:()=>t,mat3:()=>he,mat4:()=>r,quat:()=>st,quat2:()=>i,vec2:()=>s,vec3:()=>Gn,vec4:()=>Nn});var o={};n.r(o),n.d(o,{QUAT_DEFAULT:()=>Zn,QUAT_ZERO:()=>qn,VEC3_ONE:()=>zn,VEC3_UNIT_X:()=>Vn,VEC3_UNIT_Y:()=>Hn,VEC3_UNIT_Z:()=>Yn,VEC3_ZERO:()=>Kn,distanceToPlane:()=>$n,distanceToPlane2:()=>Jn,distanceToPlane3:()=>Wn,normalizePlane:()=>na,planeLength:()=>ta,quatLookAt:()=>la,testCell:()=>ea,testSphere:()=>Qn,unpackPlanes:()=>aa,unproject:()=>Xn});var u={};n.r(u),n.d(u,{bezier:()=>ma,clamp:()=>da,copysign:()=>pa,degToRad:()=>oa,hermite:()=>fa,isPowerOfTwo:()=>ga,lerp:()=>ha,powerOfTwo:()=>_a,radToDeg:()=>ua,randomInRange:()=>ca});var c={};n.r(c),n.d(c,{blobToImage:()=>ya,blobToImageData:()=>Sa,imageDataToBlob:()=>Ta,imageDataToDataUrl:()=>xa,imageDataToImage:()=>Ea,imageToImageData:()=>La,resizeImageData:()=>Ia});var d={};n.r(d),n.d(d,{basename:()=>dr,extname:()=>hr,filename:()=>fr});var h={};n.r(h),n.d(h,{JassAgent:()=>yp,JassAiDifficulty:()=>Kp,JassAllianceType:()=>kp,JassAttackType:()=>S_,JassBlendMode:()=>__,JassCameraField:()=>c_,JassCameraSetup:()=>d_,JassDamageType:()=>T_,JassDialogEvent:()=>Wp,JassEffectType:()=>b_,JassEventId:()=>zp,JassFGameState:()=>Gp,JassFogState:()=>v_,JassForce:()=>Ep,JassGameDifficulty:()=>t_,JassGameEvent:()=>qp,JassGameSpeed:()=>e_,JassGameState:()=>Dp,JassGameType:()=>n_,JassGroup:()=>Lp,JassHandle:()=>Ap,JassHashtable:()=>I_,JassIGameState:()=>Fp,JassItemType:()=>y_,JassLimitOp:()=>$p,JassLocation:()=>Rp,JassMapControl:()=>l_,JassMapDensity:()=>s_,JassMapFlag:()=>a_,JassMapSetting:()=>i_,JassMapVisibility:()=>r_,JassPathingType:()=>L_,JassPlacement:()=>f_,JassPlayer:()=>Sp,JassPlayerColor:()=>h_,JassPlayerEvent:()=>Zp,JassPlayerGameResult:()=>Hp,JassPlayerScore:()=>Vp,JassPlayerSlotState:()=>o_,JassPlayerState:()=>Np,JassPlayerUnitEvent:()=>jp,JassRace:()=>Pp,JassRacePreference:()=>Op,JassRarityControl:()=>p_,JassRect:()=>Cp,JassRegion:()=>Mp,JassSoundType:()=>E_,JassStartLocPrio:()=>m_,JassTexMapFlags:()=>g_,JassTimer:()=>Up,JassTrigger:()=>Ip,JassUnit:()=>xp,JassUnitEvent:()=>Xp,JassUnitState:()=>Yp,JassUnitType:()=>Qp,JassVersion:()=>A_,JassVolumeGroup:()=>u_,JassWeaponType:()=>x_,JassWeatherEffect:()=>w_,JassWidget:()=>Tp,JassWidgetEvent:()=>Jp});var f={};n.r(f),n.d(f,{createCube:()=>NN,createCylinder:()=>KN,createFrustum:()=>qN,createRectangle:()=>FN,createSphere:()=>HN,createUnitCube:()=>VN,createUnitCylinder:()=>zN,createUnitRectangle:()=>GN,createUnitSphere:()=>YN});var m=n(685);function p(){var e=new m.ARRAY_TYPE(4);return m.ARRAY_TYPE!=Float32Array&&(e[1]=0,e[2]=0),e[0]=1,e[3]=1,e}function _(e){var t=new m.ARRAY_TYPE(4);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t}function g(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e}function b(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e}function w(e,t,n,a){var r=new m.ARRAY_TYPE(4);return r[0]=e,r[1]=t,r[2]=n,r[3]=a,r}function v(e,t,n,a,r){return e[0]=t,e[1]=n,e[2]=a,e[3]=r,e}function A(e,t){if(e===t){var n=t[1];e[1]=t[2],e[2]=n}else e[0]=t[0],e[1]=t[2],e[2]=t[1],e[3]=t[3];return e}function y(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=n*i-r*a;return s?(s=1/s,e[0]=i*s,e[1]=-a*s,e[2]=-r*s,e[3]=n*s,e):null}function S(e,t){var n=t[0];return e[0]=t[3],e[1]=-t[1],e[2]=-t[2],e[3]=n,e}function T(e){return e[0]*e[3]-e[2]*e[1]}function x(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=n[0],o=n[1],u=n[2],c=n[3];return e[0]=a*l+i*o,e[1]=r*l+s*o,e[2]=a*u+i*c,e[3]=r*u+s*c,e}function E(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=Math.sin(n),o=Math.cos(n);return e[0]=a*o+i*l,e[1]=r*o+s*l,e[2]=a*-l+i*o,e[3]=r*-l+s*o,e}function L(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=n[0],o=n[1];return e[0]=a*l,e[1]=r*l,e[2]=i*o,e[3]=s*o,e}function I(e,t){var n=Math.sin(t),a=Math.cos(t);return e[0]=a,e[1]=n,e[2]=-n,e[3]=a,e}function U(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=t[1],e}function R(e){return"mat2("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"}function M(e){return Math.hypot(e[0],e[1],e[2],e[3])}function C(e,t,n,a){return e[2]=a[2]/a[0],n[0]=a[0],n[1]=a[1],n[3]=a[3]-e[2]*n[1],[e,t,n]}function B(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e}function P(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e}function k(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]}function O(e,t){var n=e[0],a=e[1],r=e[2],i=e[3],s=t[0],l=t[1],o=t[2],u=t[3];return Math.abs(n-s)<=m.EPSILON*Math.max(1,Math.abs(n),Math.abs(s))&&Math.abs(a-l)<=m.EPSILON*Math.max(1,Math.abs(a),Math.abs(l))&&Math.abs(r-o)<=m.EPSILON*Math.max(1,Math.abs(r),Math.abs(o))&&Math.abs(i-u)<=m.EPSILON*Math.max(1,Math.abs(i),Math.abs(u))}function D(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e}function F(e,t,n,a){return e[0]=t[0]+n[0]*a,e[1]=t[1]+n[1]*a,e[2]=t[2]+n[2]*a,e[3]=t[3]+n[3]*a,e}var G=x,N=P;function V(){var e=new m.ARRAY_TYPE(6);return m.ARRAY_TYPE!=Float32Array&&(e[1]=0,e[2]=0,e[4]=0,e[5]=0),e[0]=1,e[3]=1,e}function H(e){var t=new m.ARRAY_TYPE(6);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t}function Y(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e}function K(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e[4]=0,e[5]=0,e}function z(e,t,n,a,r,i){var s=new m.ARRAY_TYPE(6);return s[0]=e,s[1]=t,s[2]=n,s[3]=a,s[4]=r,s[5]=i,s}function q(e,t,n,a,r,i,s){return e[0]=t,e[1]=n,e[2]=a,e[3]=r,e[4]=i,e[5]=s,e}function Z(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=t[4],l=t[5],o=n*i-a*r;return o?(o=1/o,e[0]=i*o,e[1]=-a*o,e[2]=-r*o,e[3]=n*o,e[4]=(r*l-i*s)*o,e[5]=(a*s-n*l)*o,e):null}function j(e){return e[0]*e[3]-e[1]*e[2]}function X(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=t[4],o=t[5],u=n[0],c=n[1],d=n[2],h=n[3],f=n[4],m=n[5];return e[0]=a*u+i*c,e[1]=r*u+s*c,e[2]=a*d+i*h,e[3]=r*d+s*h,e[4]=a*f+i*m+l,e[5]=r*f+s*m+o,e}function $(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=t[4],o=t[5],u=Math.sin(n),c=Math.cos(n);return e[0]=a*c+i*u,e[1]=r*c+s*u,e[2]=a*-u+i*c,e[3]=r*-u+s*c,e[4]=l,e[5]=o,e}function J(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=t[4],o=t[5],u=n[0],c=n[1];return e[0]=a*u,e[1]=r*u,e[2]=i*c,e[3]=s*c,e[4]=l,e[5]=o,e}function W(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=t[4],o=t[5],u=n[0],c=n[1];return e[0]=a,e[1]=r,e[2]=i,e[3]=s,e[4]=a*u+i*c+l,e[5]=r*u+s*c+o,e}function Q(e,t){var n=Math.sin(t),a=Math.cos(t);return e[0]=a,e[1]=n,e[2]=-n,e[3]=a,e[4]=0,e[5]=0,e}function ee(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=t[1],e[4]=0,e[5]=0,e}function te(e,t){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e[4]=t[0],e[5]=t[1],e}function ne(e){return"mat2d("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+")"}function ae(e){return Math.hypot(e[0],e[1],e[2],e[3],e[4],e[5],1)}function re(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e[4]=t[4]+n[4],e[5]=t[5]+n[5],e}function ie(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e[4]=t[4]-n[4],e[5]=t[5]-n[5],e}function se(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*n,e[5]=t[5]*n,e}function le(e,t,n,a){return e[0]=t[0]+n[0]*a,e[1]=t[1]+n[1]*a,e[2]=t[2]+n[2]*a,e[3]=t[3]+n[3]*a,e[4]=t[4]+n[4]*a,e[5]=t[5]+n[5]*a,e}function oe(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]}function ue(e,t){var n=e[0],a=e[1],r=e[2],i=e[3],s=e[4],l=e[5],o=t[0],u=t[1],c=t[2],d=t[3],h=t[4],f=t[5];return Math.abs(n-o)<=m.EPSILON*Math.max(1,Math.abs(n),Math.abs(o))&&Math.abs(a-u)<=m.EPSILON*Math.max(1,Math.abs(a),Math.abs(u))&&Math.abs(r-c)<=m.EPSILON*Math.max(1,Math.abs(r),Math.abs(c))&&Math.abs(i-d)<=m.EPSILON*Math.max(1,Math.abs(i),Math.abs(d))&&Math.abs(s-h)<=m.EPSILON*Math.max(1,Math.abs(s),Math.abs(h))&&Math.abs(l-f)<=m.EPSILON*Math.max(1,Math.abs(l),Math.abs(f))}var ce=X,de=ie,he=n(600);function fe(){var e=new m.ARRAY_TYPE(16);return m.ARRAY_TYPE!=Float32Array&&(e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[11]=0,e[12]=0,e[13]=0,e[14]=0),e[0]=1,e[5]=1,e[10]=1,e[15]=1,e}function me(e){var t=new m.ARRAY_TYPE(16);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t}function pe(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e}function _e(e,t,n,a,r,i,s,l,o,u,c,d,h,f,p,_){var g=new m.ARRAY_TYPE(16);return g[0]=e,g[1]=t,g[2]=n,g[3]=a,g[4]=r,g[5]=i,g[6]=s,g[7]=l,g[8]=o,g[9]=u,g[10]=c,g[11]=d,g[12]=h,g[13]=f,g[14]=p,g[15]=_,g}function ge(e,t,n,a,r,i,s,l,o,u,c,d,h,f,m,p,_){return e[0]=t,e[1]=n,e[2]=a,e[3]=r,e[4]=i,e[5]=s,e[6]=l,e[7]=o,e[8]=u,e[9]=c,e[10]=d,e[11]=h,e[12]=f,e[13]=m,e[14]=p,e[15]=_,e}function be(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e}function we(e,t){if(e===t){var n=t[1],a=t[2],r=t[3],i=t[6],s=t[7],l=t[11];e[1]=t[4],e[2]=t[8],e[3]=t[12],e[4]=n,e[6]=t[9],e[7]=t[13],e[8]=a,e[9]=i,e[11]=t[14],e[12]=r,e[13]=s,e[14]=l}else e[0]=t[0],e[1]=t[4],e[2]=t[8],e[3]=t[12],e[4]=t[1],e[5]=t[5],e[6]=t[9],e[7]=t[13],e[8]=t[2],e[9]=t[6],e[10]=t[10],e[11]=t[14],e[12]=t[3],e[13]=t[7],e[14]=t[11],e[15]=t[15];return e}function ve(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=t[4],l=t[5],o=t[6],u=t[7],c=t[8],d=t[9],h=t[10],f=t[11],m=t[12],p=t[13],_=t[14],g=t[15],b=n*l-a*s,w=n*o-r*s,v=n*u-i*s,A=a*o-r*l,y=a*u-i*l,S=r*u-i*o,T=c*p-d*m,x=c*_-h*m,E=c*g-f*m,L=d*_-h*p,I=d*g-f*p,U=h*g-f*_,R=b*U-w*I+v*L+A*E-y*x+S*T;return R?(R=1/R,e[0]=(l*U-o*I+u*L)*R,e[1]=(r*I-a*U-i*L)*R,e[2]=(p*S-_*y+g*A)*R,e[3]=(h*y-d*S-f*A)*R,e[4]=(o*E-s*U-u*x)*R,e[5]=(n*U-r*E+i*x)*R,e[6]=(_*v-m*S-g*w)*R,e[7]=(c*S-h*v+f*w)*R,e[8]=(s*I-l*E+u*T)*R,e[9]=(a*E-n*I-i*T)*R,e[10]=(m*y-p*v+g*b)*R,e[11]=(d*v-c*y-f*b)*R,e[12]=(l*x-s*L-o*T)*R,e[13]=(n*L-a*x+r*T)*R,e[14]=(p*w-m*A-_*b)*R,e[15]=(c*A-d*w+h*b)*R,e):null}function Ae(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=t[4],l=t[5],o=t[6],u=t[7],c=t[8],d=t[9],h=t[10],f=t[11],m=t[12],p=t[13],_=t[14],g=t[15];return e[0]=l*(h*g-f*_)-d*(o*g-u*_)+p*(o*f-u*h),e[1]=-(a*(h*g-f*_)-d*(r*g-i*_)+p*(r*f-i*h)),e[2]=a*(o*g-u*_)-l*(r*g-i*_)+p*(r*u-i*o),e[3]=-(a*(o*f-u*h)-l*(r*f-i*h)+d*(r*u-i*o)),e[4]=-(s*(h*g-f*_)-c*(o*g-u*_)+m*(o*f-u*h)),e[5]=n*(h*g-f*_)-c*(r*g-i*_)+m*(r*f-i*h),e[6]=-(n*(o*g-u*_)-s*(r*g-i*_)+m*(r*u-i*o)),e[7]=n*(o*f-u*h)-s*(r*f-i*h)+c*(r*u-i*o),e[8]=s*(d*g-f*p)-c*(l*g-u*p)+m*(l*f-u*d),e[9]=-(n*(d*g-f*p)-c*(a*g-i*p)+m*(a*f-i*d)),e[10]=n*(l*g-u*p)-s*(a*g-i*p)+m*(a*u-i*l),e[11]=-(n*(l*f-u*d)-s*(a*f-i*d)+c*(a*u-i*l)),e[12]=-(s*(d*_-h*p)-c*(l*_-o*p)+m*(l*h-o*d)),e[13]=n*(d*_-h*p)-c*(a*_-r*p)+m*(a*h-r*d),e[14]=-(n*(l*_-o*p)-s*(a*_-r*p)+m*(a*o-r*l)),e[15]=n*(l*h-o*d)-s*(a*h-r*d)+c*(a*o-r*l),e}function ye(e){var t=e[0],n=e[1],a=e[2],r=e[3],i=e[4],s=e[5],l=e[6],o=e[7],u=e[8],c=e[9],d=e[10],h=e[11],f=e[12],m=e[13],p=e[14],_=e[15];return(t*s-n*i)*(d*_-h*p)-(t*l-a*i)*(c*_-h*m)+(t*o-r*i)*(c*p-d*m)+(n*l-a*s)*(u*_-h*f)-(n*o-r*s)*(u*p-d*f)+(a*o-r*l)*(u*m-c*f)}function Se(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=t[4],o=t[5],u=t[6],c=t[7],d=t[8],h=t[9],f=t[10],m=t[11],p=t[12],_=t[13],g=t[14],b=t[15],w=n[0],v=n[1],A=n[2],y=n[3];return e[0]=w*a+v*l+A*d+y*p,e[1]=w*r+v*o+A*h+y*_,e[2]=w*i+v*u+A*f+y*g,e[3]=w*s+v*c+A*m+y*b,w=n[4],v=n[5],A=n[6],y=n[7],e[4]=w*a+v*l+A*d+y*p,e[5]=w*r+v*o+A*h+y*_,e[6]=w*i+v*u+A*f+y*g,e[7]=w*s+v*c+A*m+y*b,w=n[8],v=n[9],A=n[10],y=n[11],e[8]=w*a+v*l+A*d+y*p,e[9]=w*r+v*o+A*h+y*_,e[10]=w*i+v*u+A*f+y*g,e[11]=w*s+v*c+A*m+y*b,w=n[12],v=n[13],A=n[14],y=n[15],e[12]=w*a+v*l+A*d+y*p,e[13]=w*r+v*o+A*h+y*_,e[14]=w*i+v*u+A*f+y*g,e[15]=w*s+v*c+A*m+y*b,e}function Te(e,t,n){var a,r,i,s,l,o,u,c,d,h,f,m,p=n[0],_=n[1],g=n[2];return t===e?(e[12]=t[0]*p+t[4]*_+t[8]*g+t[12],e[13]=t[1]*p+t[5]*_+t[9]*g+t[13],e[14]=t[2]*p+t[6]*_+t[10]*g+t[14],e[15]=t[3]*p+t[7]*_+t[11]*g+t[15]):(a=t[0],r=t[1],i=t[2],s=t[3],l=t[4],o=t[5],u=t[6],c=t[7],d=t[8],h=t[9],f=t[10],m=t[11],e[0]=a,e[1]=r,e[2]=i,e[3]=s,e[4]=l,e[5]=o,e[6]=u,e[7]=c,e[8]=d,e[9]=h,e[10]=f,e[11]=m,e[12]=a*p+l*_+d*g+t[12],e[13]=r*p+o*_+h*g+t[13],e[14]=i*p+u*_+f*g+t[14],e[15]=s*p+c*_+m*g+t[15]),e}function xe(e,t,n){var a=n[0],r=n[1],i=n[2];return e[0]=t[0]*a,e[1]=t[1]*a,e[2]=t[2]*a,e[3]=t[3]*a,e[4]=t[4]*r,e[5]=t[5]*r,e[6]=t[6]*r,e[7]=t[7]*r,e[8]=t[8]*i,e[9]=t[9]*i,e[10]=t[10]*i,e[11]=t[11]*i,e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e}function Ee(e,t,n,a){var r,i,s,l,o,u,c,d,h,f,p,_,g,b,w,v,A,y,S,T,x,E,L,I,U=a[0],R=a[1],M=a[2],C=Math.hypot(U,R,M);return C<m.EPSILON?null:(U*=C=1/C,R*=C,M*=C,r=Math.sin(n),s=1-(i=Math.cos(n)),l=t[0],o=t[1],u=t[2],c=t[3],d=t[4],h=t[5],f=t[6],p=t[7],_=t[8],g=t[9],b=t[10],w=t[11],v=U*U*s+i,A=R*U*s+M*r,y=M*U*s-R*r,S=U*R*s-M*r,T=R*R*s+i,x=M*R*s+U*r,E=U*M*s+R*r,L=R*M*s-U*r,I=M*M*s+i,e[0]=l*v+d*A+_*y,e[1]=o*v+h*A+g*y,e[2]=u*v+f*A+b*y,e[3]=c*v+p*A+w*y,e[4]=l*S+d*T+_*x,e[5]=o*S+h*T+g*x,e[6]=u*S+f*T+b*x,e[7]=c*S+p*T+w*x,e[8]=l*E+d*L+_*I,e[9]=o*E+h*L+g*I,e[10]=u*E+f*L+b*I,e[11]=c*E+p*L+w*I,t!==e&&(e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e)}function Le(e,t,n){var a=Math.sin(n),r=Math.cos(n),i=t[4],s=t[5],l=t[6],o=t[7],u=t[8],c=t[9],d=t[10],h=t[11];return t!==e&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[4]=i*r+u*a,e[5]=s*r+c*a,e[6]=l*r+d*a,e[7]=o*r+h*a,e[8]=u*r-i*a,e[9]=c*r-s*a,e[10]=d*r-l*a,e[11]=h*r-o*a,e}function Ie(e,t,n){var a=Math.sin(n),r=Math.cos(n),i=t[0],s=t[1],l=t[2],o=t[3],u=t[8],c=t[9],d=t[10],h=t[11];return t!==e&&(e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[0]=i*r-u*a,e[1]=s*r-c*a,e[2]=l*r-d*a,e[3]=o*r-h*a,e[8]=i*a+u*r,e[9]=s*a+c*r,e[10]=l*a+d*r,e[11]=o*a+h*r,e}function Ue(e,t,n){var a=Math.sin(n),r=Math.cos(n),i=t[0],s=t[1],l=t[2],o=t[3],u=t[4],c=t[5],d=t[6],h=t[7];return t!==e&&(e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[0]=i*r+u*a,e[1]=s*r+c*a,e[2]=l*r+d*a,e[3]=o*r+h*a,e[4]=u*r-i*a,e[5]=c*r-s*a,e[6]=d*r-l*a,e[7]=h*r-o*a,e}function Re(e,t){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=t[0],e[13]=t[1],e[14]=t[2],e[15]=1,e}function Me(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=t[1],e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=t[2],e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e}function Ce(e,t,n){var a,r,i,s=n[0],l=n[1],o=n[2],u=Math.hypot(s,l,o);return u<m.EPSILON?null:(s*=u=1/u,l*=u,o*=u,a=Math.sin(t),i=1-(r=Math.cos(t)),e[0]=s*s*i+r,e[1]=l*s*i+o*a,e[2]=o*s*i-l*a,e[3]=0,e[4]=s*l*i-o*a,e[5]=l*l*i+r,e[6]=o*l*i+s*a,e[7]=0,e[8]=s*o*i+l*a,e[9]=l*o*i-s*a,e[10]=o*o*i+r,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e)}function Be(e,t){var n=Math.sin(t),a=Math.cos(t);return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=a,e[6]=n,e[7]=0,e[8]=0,e[9]=-n,e[10]=a,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e}function Pe(e,t){var n=Math.sin(t),a=Math.cos(t);return e[0]=a,e[1]=0,e[2]=-n,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=n,e[9]=0,e[10]=a,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e}function ke(e,t){var n=Math.sin(t),a=Math.cos(t);return e[0]=a,e[1]=n,e[2]=0,e[3]=0,e[4]=-n,e[5]=a,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e}function Oe(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=a+a,o=r+r,u=i+i,c=a*l,d=a*o,h=a*u,f=r*o,m=r*u,p=i*u,_=s*l,g=s*o,b=s*u;return e[0]=1-(f+p),e[1]=d+b,e[2]=h-g,e[3]=0,e[4]=d-b,e[5]=1-(c+p),e[6]=m+_,e[7]=0,e[8]=h+g,e[9]=m-_,e[10]=1-(c+f),e[11]=0,e[12]=n[0],e[13]=n[1],e[14]=n[2],e[15]=1,e}function De(e,t){var n=new m.ARRAY_TYPE(3),a=-t[0],r=-t[1],i=-t[2],s=t[3],l=t[4],o=t[5],u=t[6],c=t[7],d=a*a+r*r+i*i+s*s;return d>0?(n[0]=2*(l*s+c*a+o*i-u*r)/d,n[1]=2*(o*s+c*r+u*a-l*i)/d,n[2]=2*(u*s+c*i+l*r-o*a)/d):(n[0]=2*(l*s+c*a+o*i-u*r),n[1]=2*(o*s+c*r+u*a-l*i),n[2]=2*(u*s+c*i+l*r-o*a)),Oe(e,t,n),e}function Fe(e,t){return e[0]=t[12],e[1]=t[13],e[2]=t[14],e}function Ge(e,t){var n=t[0],a=t[1],r=t[2],i=t[4],s=t[5],l=t[6],o=t[8],u=t[9],c=t[10];return e[0]=Math.hypot(n,a,r),e[1]=Math.hypot(i,s,l),e[2]=Math.hypot(o,u,c),e}function Ne(e,t){var n=new m.ARRAY_TYPE(3);Ge(n,t);var a=1/n[0],r=1/n[1],i=1/n[2],s=t[0]*a,l=t[1]*r,o=t[2]*i,u=t[4]*a,c=t[5]*r,d=t[6]*i,h=t[8]*a,f=t[9]*r,p=t[10]*i,_=s+c+p,g=0;return _>0?(g=2*Math.sqrt(_+1),e[3]=.25*g,e[0]=(d-f)/g,e[1]=(h-o)/g,e[2]=(l-u)/g):s>c&&s>p?(g=2*Math.sqrt(1+s-c-p),e[3]=(d-f)/g,e[0]=.25*g,e[1]=(l+u)/g,e[2]=(h+o)/g):c>p?(g=2*Math.sqrt(1+c-s-p),e[3]=(h-o)/g,e[0]=(l+u)/g,e[1]=.25*g,e[2]=(d+f)/g):(g=2*Math.sqrt(1+p-s-c),e[3]=(l-u)/g,e[0]=(h+o)/g,e[1]=(d+f)/g,e[2]=.25*g),e}function Ve(e,t,n,a){var r=t[0],i=t[1],s=t[2],l=t[3],o=r+r,u=i+i,c=s+s,d=r*o,h=r*u,f=r*c,m=i*u,p=i*c,_=s*c,g=l*o,b=l*u,w=l*c,v=a[0],A=a[1],y=a[2];return e[0]=(1-(m+_))*v,e[1]=(h+w)*v,e[2]=(f-b)*v,e[3]=0,e[4]=(h-w)*A,e[5]=(1-(d+_))*A,e[6]=(p+g)*A,e[7]=0,e[8]=(f+b)*y,e[9]=(p-g)*y,e[10]=(1-(d+m))*y,e[11]=0,e[12]=n[0],e[13]=n[1],e[14]=n[2],e[15]=1,e}function He(e,t,n,a,r){var i=t[0],s=t[1],l=t[2],o=t[3],u=i+i,c=s+s,d=l+l,h=i*u,f=i*c,m=i*d,p=s*c,_=s*d,g=l*d,b=o*u,w=o*c,v=o*d,A=a[0],y=a[1],S=a[2],T=r[0],x=r[1],E=r[2],L=(1-(p+g))*A,I=(f+v)*A,U=(m-w)*A,R=(f-v)*y,M=(1-(h+g))*y,C=(_+b)*y,B=(m+w)*S,P=(_-b)*S,k=(1-(h+p))*S;return e[0]=L,e[1]=I,e[2]=U,e[3]=0,e[4]=R,e[5]=M,e[6]=C,e[7]=0,e[8]=B,e[9]=P,e[10]=k,e[11]=0,e[12]=n[0]+T-(L*T+R*x+B*E),e[13]=n[1]+x-(I*T+M*x+P*E),e[14]=n[2]+E-(U*T+C*x+k*E),e[15]=1,e}function Ye(e,t){var n=t[0],a=t[1],r=t[2],i=t[3],s=n+n,l=a+a,o=r+r,u=n*s,c=a*s,d=a*l,h=r*s,f=r*l,m=r*o,p=i*s,_=i*l,g=i*o;return e[0]=1-d-m,e[1]=c+g,e[2]=h-_,e[3]=0,e[4]=c-g,e[5]=1-u-m,e[6]=f+p,e[7]=0,e[8]=h+_,e[9]=f-p,e[10]=1-u-d,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e}function Ke(e,t,n,a,r,i,s){var l=1/(n-t),o=1/(r-a),u=1/(i-s);return e[0]=2*i*l,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=2*i*o,e[6]=0,e[7]=0,e[8]=(n+t)*l,e[9]=(r+a)*o,e[10]=(s+i)*u,e[11]=-1,e[12]=0,e[13]=0,e[14]=s*i*2*u,e[15]=0,e}function ze(e,t,n,a,r){var i,s=1/Math.tan(t/2);return e[0]=s/n,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=s,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[11]=-1,e[12]=0,e[13]=0,e[15]=0,null!=r&&r!==1/0?(i=1/(a-r),e[10]=(r+a)*i,e[14]=2*r*a*i):(e[10]=-1,e[14]=-2*a),e}function qe(e,t,n,a){var r=Math.tan(t.upDegrees*Math.PI/180),i=Math.tan(t.downDegrees*Math.PI/180),s=Math.tan(t.leftDegrees*Math.PI/180),l=Math.tan(t.rightDegrees*Math.PI/180),o=2/(s+l),u=2/(r+i);return e[0]=o,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=u,e[6]=0,e[7]=0,e[8]=-(s-l)*o*.5,e[9]=(r-i)*u*.5,e[10]=a/(n-a),e[11]=-1,e[12]=0,e[13]=0,e[14]=a*n/(n-a),e[15]=0,e}function Ze(e,t,n,a,r,i,s){var l=1/(t-n),o=1/(a-r),u=1/(i-s);return e[0]=-2*l,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=-2*o,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=2*u,e[11]=0,e[12]=(t+n)*l,e[13]=(r+a)*o,e[14]=(s+i)*u,e[15]=1,e}function je(e,t,n,a){var r,i,s,l,o,u,c,d,h,f,p=t[0],_=t[1],g=t[2],b=a[0],w=a[1],v=a[2],A=n[0],y=n[1],S=n[2];return Math.abs(p-A)<m.EPSILON&&Math.abs(_-y)<m.EPSILON&&Math.abs(g-S)<m.EPSILON?be(e):(c=p-A,d=_-y,h=g-S,r=w*(h*=f=1/Math.hypot(c,d,h))-v*(d*=f),i=v*(c*=f)-b*h,s=b*d-w*c,(f=Math.hypot(r,i,s))?(r*=f=1/f,i*=f,s*=f):(r=0,i=0,s=0),l=d*s-h*i,o=h*r-c*s,u=c*i-d*r,(f=Math.hypot(l,o,u))?(l*=f=1/f,o*=f,u*=f):(l=0,o=0,u=0),e[0]=r,e[1]=l,e[2]=c,e[3]=0,e[4]=i,e[5]=o,e[6]=d,e[7]=0,e[8]=s,e[9]=u,e[10]=h,e[11]=0,e[12]=-(r*p+i*_+s*g),e[13]=-(l*p+o*_+u*g),e[14]=-(c*p+d*_+h*g),e[15]=1,e)}function Xe(e,t,n,a){var r=t[0],i=t[1],s=t[2],l=a[0],o=a[1],u=a[2],c=r-n[0],d=i-n[1],h=s-n[2],f=c*c+d*d+h*h;f>0&&(c*=f=1/Math.sqrt(f),d*=f,h*=f);var m=o*h-u*d,p=u*c-l*h,_=l*d-o*c;return(f=m*m+p*p+_*_)>0&&(m*=f=1/Math.sqrt(f),p*=f,_*=f),e[0]=m,e[1]=p,e[2]=_,e[3]=0,e[4]=d*_-h*p,e[5]=h*m-c*_,e[6]=c*p-d*m,e[7]=0,e[8]=c,e[9]=d,e[10]=h,e[11]=0,e[12]=r,e[13]=i,e[14]=s,e[15]=1,e}function $e(e){return"mat4("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+", "+e[6]+", "+e[7]+", "+e[8]+", "+e[9]+", "+e[10]+", "+e[11]+", "+e[12]+", "+e[13]+", "+e[14]+", "+e[15]+")"}function Je(e){return Math.hypot(e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14],e[15])}function We(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e[4]=t[4]+n[4],e[5]=t[5]+n[5],e[6]=t[6]+n[6],e[7]=t[7]+n[7],e[8]=t[8]+n[8],e[9]=t[9]+n[9],e[10]=t[10]+n[10],e[11]=t[11]+n[11],e[12]=t[12]+n[12],e[13]=t[13]+n[13],e[14]=t[14]+n[14],e[15]=t[15]+n[15],e}function Qe(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e[4]=t[4]-n[4],e[5]=t[5]-n[5],e[6]=t[6]-n[6],e[7]=t[7]-n[7],e[8]=t[8]-n[8],e[9]=t[9]-n[9],e[10]=t[10]-n[10],e[11]=t[11]-n[11],e[12]=t[12]-n[12],e[13]=t[13]-n[13],e[14]=t[14]-n[14],e[15]=t[15]-n[15],e}function et(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*n,e[5]=t[5]*n,e[6]=t[6]*n,e[7]=t[7]*n,e[8]=t[8]*n,e[9]=t[9]*n,e[10]=t[10]*n,e[11]=t[11]*n,e[12]=t[12]*n,e[13]=t[13]*n,e[14]=t[14]*n,e[15]=t[15]*n,e}function tt(e,t,n,a){return e[0]=t[0]+n[0]*a,e[1]=t[1]+n[1]*a,e[2]=t[2]+n[2]*a,e[3]=t[3]+n[3]*a,e[4]=t[4]+n[4]*a,e[5]=t[5]+n[5]*a,e[6]=t[6]+n[6]*a,e[7]=t[7]+n[7]*a,e[8]=t[8]+n[8]*a,e[9]=t[9]+n[9]*a,e[10]=t[10]+n[10]*a,e[11]=t[11]+n[11]*a,e[12]=t[12]+n[12]*a,e[13]=t[13]+n[13]*a,e[14]=t[14]+n[14]*a,e[15]=t[15]+n[15]*a,e}function nt(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]&&e[8]===t[8]&&e[9]===t[9]&&e[10]===t[10]&&e[11]===t[11]&&e[12]===t[12]&&e[13]===t[13]&&e[14]===t[14]&&e[15]===t[15]}function at(e,t){var n=e[0],a=e[1],r=e[2],i=e[3],s=e[4],l=e[5],o=e[6],u=e[7],c=e[8],d=e[9],h=e[10],f=e[11],p=e[12],_=e[13],g=e[14],b=e[15],w=t[0],v=t[1],A=t[2],y=t[3],S=t[4],T=t[5],x=t[6],E=t[7],L=t[8],I=t[9],U=t[10],R=t[11],M=t[12],C=t[13],B=t[14],P=t[15];return Math.abs(n-w)<=m.EPSILON*Math.max(1,Math.abs(n),Math.abs(w))&&Math.abs(a-v)<=m.EPSILON*Math.max(1,Math.abs(a),Math.abs(v))&&Math.abs(r-A)<=m.EPSILON*Math.max(1,Math.abs(r),Math.abs(A))&&Math.abs(i-y)<=m.EPSILON*Math.max(1,Math.abs(i),Math.abs(y))&&Math.abs(s-S)<=m.EPSILON*Math.max(1,Math.abs(s),Math.abs(S))&&Math.abs(l-T)<=m.EPSILON*Math.max(1,Math.abs(l),Math.abs(T))&&Math.abs(o-x)<=m.EPSILON*Math.max(1,Math.abs(o),Math.abs(x))&&Math.abs(u-E)<=m.EPSILON*Math.max(1,Math.abs(u),Math.abs(E))&&Math.abs(c-L)<=m.EPSILON*Math.max(1,Math.abs(c),Math.abs(L))&&Math.abs(d-I)<=m.EPSILON*Math.max(1,Math.abs(d),Math.abs(I))&&Math.abs(h-U)<=m.EPSILON*Math.max(1,Math.abs(h),Math.abs(U))&&Math.abs(f-R)<=m.EPSILON*Math.max(1,Math.abs(f),Math.abs(R))&&Math.abs(p-M)<=m.EPSILON*Math.max(1,Math.abs(p),Math.abs(M))&&Math.abs(_-C)<=m.EPSILON*Math.max(1,Math.abs(_),Math.abs(C))&&Math.abs(g-B)<=m.EPSILON*Math.max(1,Math.abs(g),Math.abs(B))&&Math.abs(b-P)<=m.EPSILON*Math.max(1,Math.abs(b),Math.abs(P))}var rt=Se,it=Qe,st=n(945);function lt(){var e=new m.ARRAY_TYPE(8);return m.ARRAY_TYPE!=Float32Array&&(e[0]=0,e[1]=0,e[2]=0,e[4]=0,e[5]=0,e[6]=0,e[7]=0),e[3]=1,e}function ot(e){var t=new m.ARRAY_TYPE(8);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t}function ut(e,t,n,a,r,i,s,l){var o=new m.ARRAY_TYPE(8);return o[0]=e,o[1]=t,o[2]=n,o[3]=a,o[4]=r,o[5]=i,o[6]=s,o[7]=l,o}function ct(e,t,n,a,r,i,s){var l=new m.ARRAY_TYPE(8);l[0]=e,l[1]=t,l[2]=n,l[3]=a;var o=.5*r,u=.5*i,c=.5*s;return l[4]=o*a+u*n-c*t,l[5]=u*a+c*e-o*n,l[6]=c*a+o*t-u*e,l[7]=-o*e-u*t-c*n,l}function dt(e,t,n){var a=.5*n[0],r=.5*n[1],i=.5*n[2],s=t[0],l=t[1],o=t[2],u=t[3];return e[0]=s,e[1]=l,e[2]=o,e[3]=u,e[4]=a*u+r*o-i*l,e[5]=r*u+i*s-a*o,e[6]=i*u+a*l-r*s,e[7]=-a*s-r*l-i*o,e}function ht(e,t){return e[0]=0,e[1]=0,e[2]=0,e[3]=1,e[4]=.5*t[0],e[5]=.5*t[1],e[6]=.5*t[2],e[7]=0,e}function ft(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=0,e[5]=0,e[6]=0,e[7]=0,e}function mt(e,t){var n=st.create();Ne(n,t);var a=new m.ARRAY_TYPE(3);return Fe(a,t),dt(e,n,a),e}function pt(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e}function _t(e){return e[0]=0,e[1]=0,e[2]=0,e[3]=1,e[4]=0,e[5]=0,e[6]=0,e[7]=0,e}function gt(e,t,n,a,r,i,s,l,o){return e[0]=t,e[1]=n,e[2]=a,e[3]=r,e[4]=i,e[5]=s,e[6]=l,e[7]=o,e}var bt=st.copy;function wt(e,t){return e[0]=t[4],e[1]=t[5],e[2]=t[6],e[3]=t[7],e}var vt=st.copy;function At(e,t){return e[4]=t[0],e[5]=t[1],e[6]=t[2],e[7]=t[3],e}function yt(e,t){var n=t[4],a=t[5],r=t[6],i=t[7],s=-t[0],l=-t[1],o=-t[2],u=t[3];return e[0]=2*(n*u+i*s+a*o-r*l),e[1]=2*(a*u+i*l+r*s-n*o),e[2]=2*(r*u+i*o+n*l-a*s),e}function St(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=.5*n[0],o=.5*n[1],u=.5*n[2],c=t[4],d=t[5],h=t[6],f=t[7];return e[0]=a,e[1]=r,e[2]=i,e[3]=s,e[4]=s*l+r*u-i*o+c,e[5]=s*o+i*l-a*u+d,e[6]=s*u+a*o-r*l+h,e[7]=-a*l-r*o-i*u+f,e}function Tt(e,t,n){var a=-t[0],r=-t[1],i=-t[2],s=t[3],l=t[4],o=t[5],u=t[6],c=t[7],d=l*s+c*a+o*i-u*r,h=o*s+c*r+u*a-l*i,f=u*s+c*i+l*r-o*a,m=c*s-l*a-o*r-u*i;return st.rotateX(e,t,n),a=e[0],r=e[1],i=e[2],s=e[3],e[4]=d*s+m*a+h*i-f*r,e[5]=h*s+m*r+f*a-d*i,e[6]=f*s+m*i+d*r-h*a,e[7]=m*s-d*a-h*r-f*i,e}function xt(e,t,n){var a=-t[0],r=-t[1],i=-t[2],s=t[3],l=t[4],o=t[5],u=t[6],c=t[7],d=l*s+c*a+o*i-u*r,h=o*s+c*r+u*a-l*i,f=u*s+c*i+l*r-o*a,m=c*s-l*a-o*r-u*i;return st.rotateY(e,t,n),a=e[0],r=e[1],i=e[2],s=e[3],e[4]=d*s+m*a+h*i-f*r,e[5]=h*s+m*r+f*a-d*i,e[6]=f*s+m*i+d*r-h*a,e[7]=m*s-d*a-h*r-f*i,e}function Et(e,t,n){var a=-t[0],r=-t[1],i=-t[2],s=t[3],l=t[4],o=t[5],u=t[6],c=t[7],d=l*s+c*a+o*i-u*r,h=o*s+c*r+u*a-l*i,f=u*s+c*i+l*r-o*a,m=c*s-l*a-o*r-u*i;return st.rotateZ(e,t,n),a=e[0],r=e[1],i=e[2],s=e[3],e[4]=d*s+m*a+h*i-f*r,e[5]=h*s+m*r+f*a-d*i,e[6]=f*s+m*i+d*r-h*a,e[7]=m*s-d*a-h*r-f*i,e}function Lt(e,t,n){var a=n[0],r=n[1],i=n[2],s=n[3],l=t[0],o=t[1],u=t[2],c=t[3];return e[0]=l*s+c*a+o*i-u*r,e[1]=o*s+c*r+u*a-l*i,e[2]=u*s+c*i+l*r-o*a,e[3]=c*s-l*a-o*r-u*i,l=t[4],o=t[5],u=t[6],c=t[7],e[4]=l*s+c*a+o*i-u*r,e[5]=o*s+c*r+u*a-l*i,e[6]=u*s+c*i+l*r-o*a,e[7]=c*s-l*a-o*r-u*i,e}function It(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=n[0],o=n[1],u=n[2],c=n[3];return e[0]=a*c+s*l+r*u-i*o,e[1]=r*c+s*o+i*l-a*u,e[2]=i*c+s*u+a*o-r*l,e[3]=s*c-a*l-r*o-i*u,l=n[4],o=n[5],u=n[6],c=n[7],e[4]=a*c+s*l+r*u-i*o,e[5]=r*c+s*o+i*l-a*u,e[6]=i*c+s*u+a*o-r*l,e[7]=s*c-a*l-r*o-i*u,e}function Ut(e,t,n,a){if(Math.abs(a)<m.EPSILON)return pt(e,t);var r=Math.hypot(n[0],n[1],n[2]);a*=.5;var i=Math.sin(a),s=i*n[0]/r,l=i*n[1]/r,o=i*n[2]/r,u=Math.cos(a),c=t[0],d=t[1],h=t[2],f=t[3];e[0]=c*u+f*s+d*o-h*l,e[1]=d*u+f*l+h*s-c*o,e[2]=h*u+f*o+c*l-d*s,e[3]=f*u-c*s-d*l-h*o;var p=t[4],_=t[5],g=t[6],b=t[7];return e[4]=p*u+b*s+_*o-g*l,e[5]=_*u+b*l+g*s-p*o,e[6]=g*u+b*o+p*l-_*s,e[7]=b*u-p*s-_*l-g*o,e}function Rt(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e[4]=t[4]+n[4],e[5]=t[5]+n[5],e[6]=t[6]+n[6],e[7]=t[7]+n[7],e}function Mt(e,t,n){var a=t[0],r=t[1],i=t[2],s=t[3],l=n[4],o=n[5],u=n[6],c=n[7],d=t[4],h=t[5],f=t[6],m=t[7],p=n[0],_=n[1],g=n[2],b=n[3];return e[0]=a*b+s*p+r*g-i*_,e[1]=r*b+s*_+i*p-a*g,e[2]=i*b+s*g+a*_-r*p,e[3]=s*b-a*p-r*_-i*g,e[4]=a*c+s*l+r*u-i*o+d*b+m*p+h*g-f*_,e[5]=r*c+s*o+i*l-a*u+h*b+m*_+f*p-d*g,e[6]=i*c+s*u+a*o-r*l+f*b+m*g+d*_-h*p,e[7]=s*c-a*l-r*o-i*u+m*b-d*p-h*_-f*g,e}var Ct=Mt;function Bt(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*n,e[5]=t[5]*n,e[6]=t[6]*n,e[7]=t[7]*n,e}var Pt=st.dot;function kt(e,t,n,a){var r=1-a;return Pt(t,n)<0&&(a=-a),e[0]=t[0]*r+n[0]*a,e[1]=t[1]*r+n[1]*a,e[2]=t[2]*r+n[2]*a,e[3]=t[3]*r+n[3]*a,e[4]=t[4]*r+n[4]*a,e[5]=t[5]*r+n[5]*a,e[6]=t[6]*r+n[6]*a,e[7]=t[7]*r+n[7]*a,e}function Ot(e,t){var n=Nt(t);return e[0]=-t[0]/n,e[1]=-t[1]/n,e[2]=-t[2]/n,e[3]=t[3]/n,e[4]=-t[4]/n,e[5]=-t[5]/n,e[6]=-t[6]/n,e[7]=t[7]/n,e}function Dt(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=t[3],e[4]=-t[4],e[5]=-t[5],e[6]=-t[6],e[7]=t[7],e}var Ft=st.length,Gt=Ft,Nt=st.squaredLength,Vt=Nt;function Ht(e,t){var n=Nt(t);if(n>0){n=Math.sqrt(n);var a=t[0]/n,r=t[1]/n,i=t[2]/n,s=t[3]/n,l=t[4],o=t[5],u=t[6],c=t[7],d=a*l+r*o+i*u+s*c;e[0]=a,e[1]=r,e[2]=i,e[3]=s,e[4]=(l-a*d)/n,e[5]=(o-r*d)/n,e[6]=(u-i*d)/n,e[7]=(c-s*d)/n}return e}function Yt(e){return"quat2("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+", "+e[6]+", "+e[7]+")"}function Kt(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]}function zt(e,t){var n=e[0],a=e[1],r=e[2],i=e[3],s=e[4],l=e[5],o=e[6],u=e[7],c=t[0],d=t[1],h=t[2],f=t[3],p=t[4],_=t[5],g=t[6],b=t[7];return Math.abs(n-c)<=m.EPSILON*Math.max(1,Math.abs(n),Math.abs(c))&&Math.abs(a-d)<=m.EPSILON*Math.max(1,Math.abs(a),Math.abs(d))&&Math.abs(r-h)<=m.EPSILON*Math.max(1,Math.abs(r),Math.abs(h))&&Math.abs(i-f)<=m.EPSILON*Math.max(1,Math.abs(i),Math.abs(f))&&Math.abs(s-p)<=m.EPSILON*Math.max(1,Math.abs(s),Math.abs(p))&&Math.abs(l-_)<=m.EPSILON*Math.max(1,Math.abs(l),Math.abs(_))&&Math.abs(o-g)<=m.EPSILON*Math.max(1,Math.abs(o),Math.abs(g))&&Math.abs(u-b)<=m.EPSILON*Math.max(1,Math.abs(u),Math.abs(b))}function qt(){var e=new m.ARRAY_TYPE(2);return m.ARRAY_TYPE!=Float32Array&&(e[0]=0,e[1]=0),e}function Zt(e){var t=new m.ARRAY_TYPE(2);return t[0]=e[0],t[1]=e[1],t}function jt(e,t){var n=new m.ARRAY_TYPE(2);return n[0]=e,n[1]=t,n}function Xt(e,t){return e[0]=t[0],e[1]=t[1],e}function $t(e,t,n){return e[0]=t,e[1]=n,e}function Jt(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e}function Wt(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e}function Qt(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e}function en(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e}function tn(e,t){return e[0]=Math.ceil(t[0]),e[1]=Math.ceil(t[1]),e}function nn(e,t){return e[0]=Math.floor(t[0]),e[1]=Math.floor(t[1]),e}function an(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e}function rn(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e}function sn(e,t){return e[0]=Math.round(t[0]),e[1]=Math.round(t[1]),e}function ln(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e}function on(e,t,n,a){return e[0]=t[0]+n[0]*a,e[1]=t[1]+n[1]*a,e}function un(e,t){var n=t[0]-e[0],a=t[1]-e[1];return Math.hypot(n,a)}function cn(e,t){var n=t[0]-e[0],a=t[1]-e[1];return n*n+a*a}function dn(e){var t=e[0],n=e[1];return Math.hypot(t,n)}function hn(e){var t=e[0],n=e[1];return t*t+n*n}function fn(e,t){return e[0]=-t[0],e[1]=-t[1],e}function mn(e,t){return e[0]=1/t[0],e[1]=1/t[1],e}function pn(e,t){var n=t[0],a=t[1],r=n*n+a*a;return r>0&&(r=1/Math.sqrt(r)),e[0]=t[0]*r,e[1]=t[1]*r,e}function _n(e,t){return e[0]*t[0]+e[1]*t[1]}function gn(e,t,n){var a=t[0]*n[1]-t[1]*n[0];return e[0]=e[1]=0,e[2]=a,e}function bn(e,t,n,a){var r=t[0],i=t[1];return e[0]=r+a*(n[0]-r),e[1]=i+a*(n[1]-i),e}function wn(e,t){t=t||1;var n=2*m.RANDOM()*Math.PI;return e[0]=Math.cos(n)*t,e[1]=Math.sin(n)*t,e}function vn(e,t,n){var a=t[0],r=t[1];return e[0]=n[0]*a+n[2]*r,e[1]=n[1]*a+n[3]*r,e}function An(e,t,n){var a=t[0],r=t[1];return e[0]=n[0]*a+n[2]*r+n[4],e[1]=n[1]*a+n[3]*r+n[5],e}function yn(e,t,n){var a=t[0],r=t[1];return e[0]=n[0]*a+n[3]*r+n[6],e[1]=n[1]*a+n[4]*r+n[7],e}function Sn(e,t,n){var a=t[0],r=t[1];return e[0]=n[0]*a+n[4]*r+n[12],e[1]=n[1]*a+n[5]*r+n[13],e}function Tn(e,t,n,a){var r=t[0]-n[0],i=t[1]-n[1],s=Math.sin(a),l=Math.cos(a);return e[0]=r*l-i*s+n[0],e[1]=r*s+i*l+n[1],e}function xn(e,t){var n=e[0],a=e[1],r=t[0],i=t[1],s=Math.sqrt(n*n+a*a)*Math.sqrt(r*r+i*i),l=s&&(n*r+a*i)/s;return Math.acos(Math.min(Math.max(l,-1),1))}function En(e){return e[0]=0,e[1]=0,e}function Ln(e){return"vec2("+e[0]+", "+e[1]+")"}function In(e,t){return e[0]===t[0]&&e[1]===t[1]}function Un(e,t){var n=e[0],a=e[1],r=t[0],i=t[1];return Math.abs(n-r)<=m.EPSILON*Math.max(1,Math.abs(n),Math.abs(r))&&Math.abs(a-i)<=m.EPSILON*Math.max(1,Math.abs(a),Math.abs(i))}var Rn,Mn=dn,Cn=Wt,Bn=Qt,Pn=en,kn=un,On=cn,Dn=hn,Fn=(Rn=qt(),function(e,t,n,a,r,i){var s,l;for(t||(t=2),n||(n=0),l=a?Math.min(a*t+n,e.length):e.length,s=n;s<l;s+=t)Rn[0]=e[s],Rn[1]=e[s+1],r(Rn,Rn,i),e[s]=Rn[0],e[s+1]=Rn[1];return e}),Gn=n(160),Nn=n(333);const Vn=Gn.fromValues(1,0,0),Hn=Gn.fromValues(0,1,0),Yn=Gn.fromValues(0,0,1),Kn=Gn.create(),zn=Gn.fromValues(1,1,1),qn=st.fromValues(0,0,0,0),Zn=st.create(),jn=Nn.create();function Xn(e,t,n,a){const r=2*(t[0]-a[0])/a[2]-1,i=1-2*(t[1]-a[1])/a[3],s=2*t[2]-1;return Nn.set(jn,r,i,s,1),Nn.transformMat4(jn,jn,n),Gn.set(e,jn[0]/jn[3],jn[1]/jn[3],jn[2]/jn[3]),e}function $n(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]+e[3]}function Jn(e,t,n){return e[0]*t+e[1]*n+e[3]}function Wn(e,t,n,a){return e[0]*t+e[1]*n+e[2]*a+e[3]}function Qn(e,t,n,a,r,i){-1===i&&(i=0);for(let s=0;s<6;s++){const l=(i+s)%6;if(Wn(e[l],t,n,a)<=-r)return l}return-1}function ea(e,t,n,a,r,i){-1===i&&(i=0);for(let s=0;s<6;s++){const l=(i+s)%6,o=e[l];if(Jn(o,t,a)<0&&Jn(o,t,r)<0&&Jn(o,n,r)<0&&Jn(o,n,a)<0)return l}return-1}function ta(e){return Math.hypot(e[0],e[1],e[2])}function na(e,t){const n=ta(t);e[0]=t[0]/n,e[1]=t[1]/n,e[2]=t[2]/n,e[3]=t[3]/n}function aa(e,t){const n=t[0],a=t[4],r=t[8],i=t[12],s=t[1],l=t[5],o=t[9],u=t[13],c=t[2],d=t[6],h=t[10],f=t[14],m=t[3],p=t[7],_=t[11],g=t[15];let b;b=e[0],b[0]=m+n,b[1]=p+a,b[2]=_+r,b[3]=g+i,b=e[1],b[0]=m-n,b[1]=p-a,b[2]=_-r,b[3]=g-i,b=e[2],b[0]=m-s,b[1]=p-l,b[2]=_-o,b[3]=g-u,b=e[3],b[0]=m+s,b[1]=p+l,b[2]=_+o,b[3]=g+u,b=e[4],b[0]=m+c,b[1]=p+d,b[2]=_+h,b[3]=g+f,b=e[5],b[0]=m-c,b[1]=p-d,b[2]=_-h,b[3]=g-f,na(e[0],e[0]),na(e[1],e[1]),na(e[2],e[2]),na(e[3],e[3]),na(e[4],e[4]),na(e[5],e[5])}const ra=Gn.create(),ia=Gn.create(),sa=Gn.create();function la(e,t,n,a){Gn.normalize(ra,Gn.sub(ra,n,t)),Gn.normalize(ia,Gn.cross(ia,a,ra)),Gn.cross(sa,ia,ra);const r=ia[0]+sa[2]+ra[1];if(r>0){const t=.5/Math.sqrt(r+1);e[3]=.25/t,e[0]=(sa[1]-ra[2])*t,e[2]=(ra[0]-ia[1])*t,e[1]=(ia[2]-sa[0])*t}else if(ia[0]>sa[2]&&ia[0]>ra[1]){const t=2*Math.sqrt(1+ia[0]-sa[2]-ra[1]);e[3]=(sa[1]-ra[2])/t,e[0]=.25*t,e[2]=(sa[0]+ia[2])/t,e[1]=(ra[0]+ia[1])/t}else if(sa[2]>ra[1]){const t=2*Math.sqrt(1+sa[2]-ia[0]-ra[1]);e[3]=(ra[0]-ia[1])/t,e[0]=(sa[0]+ia[2])/t,e[2]=.25*t,e[1]=(ra[2]+sa[1])/t}else{const t=2*Math.sqrt(1+ra[1]-ia[0]-sa[2]);e[3]=(ia[2]-sa[0])/t,e[0]=(ra[0]+ia[1])/t,e[2]=(ra[2]+sa[1])/t,e[1]=.25*t}return e}function oa(e){return e*(Math.PI/180)}function ua(e){return e*(180/Math.PI)}function ca(e,t){return e+Math.random()*(t-e)}function da(e,t,n){return Math.min(Math.max(e,t),n)}function ha(e,t,n){return e+n*(t-e)}function fa(e,t,n,a,r){const i=r*r;return e*(i*(2*r-3)+1)+t*(i*(r-2)+r)+n*(i*(r-1))+a*(i*(3-2*r))}function ma(e,t,n,a,r){const i=1-r,s=r*r,l=i*i;return e*(l*i)+t*(3*r*l)+n*(3*s*i)+a*(s*r)}function pa(e,t){const n=Math.sign(t);if(0===n)return 0;return Math.sign(e)!==n?-e:e}function _a(e){return e--,e|=e>>1,e|=e>>2,e|=e>>4,e|=e>>8,e|=e>>16,++e}function ga(e){return 0!==e&&0==(e&e-1)}let ba,wa,va,Aa;function ya(e){return new Promise(((t,n)=>{const a=URL.createObjectURL(e),r=new Image;r.onload=()=>{t(r)},r.onerror=e=>{n(e)},r.src=a}))}function Sa(e){return new Promise(((t,n)=>{const a=URL.createObjectURL(e),r=new Image;r.onload=()=>{URL.revokeObjectURL(a),ba.width=r.width,ba.height=r.height,wa.drawImage(r,0,0),t(wa.getImageData(0,0,r.width,r.height))},r.onerror=e=>{n(e)},r.src=a}))}function Ta(e){return new Promise((t=>{ba.width=e.width,ba.height=e.height,wa.putImageData(e,0,0),ba.toBlob((e=>{t(e)}))}))}function xa(e){return ba.width=e.width,ba.height=e.height,wa.putImageData(e,0,0),ba.toDataURL()}function Ea(e){const t=new Image;return t.src=xa(e),t}function La(e){const t=e.width,n=e.height;return ba.width=t,ba.height=n,wa.drawImage(e,0,0),wa.getImageData(0,0,t,n)}function Ia(e,t,n){return e instanceof ImageData?(ba.width=e.width,ba.height=e.height,wa.putImageData(e,0,0),va.width=t,va.height=n,Aa.drawImage(ba,0,0,t,n),Aa.getImageData(0,0,t,n)):(ba.width=t,ba.height=n,wa.drawImage(e,0,0,t,n),wa.getImageData(0,0,t,n))}"object"==typeof window&&(ba=document.createElement("canvas"),wa=ba.getContext("2d"),va=document.createElement("canvas"),Aa=va.getContext("2d"));const Ua=new TextDecoder,Ra=new TextEncoder;function Ma(e){return Ua.decode(e)}function Ca(e){return Ra.encode(e)}function Ba(e){let t=e.length;for(let n=e.length-1;n>=0;n--){const a=e.charCodeAt(n);a>127&&a<=2047?t++:a>2047&&a<=65535&&(t+=2),a>=56320&&a<=57343&&n--}return t}function Pa(e,t){const n=[];let a=0,r=0;for(let i=0,s=e.length;i<s;i++){const s=e.charCodeAt(i);s<128?r+=1:s<2048?r+=2:s<55296||s>=57344?r+=3:(i++,r+=4),r>=t-3&&(n.push(e.substr(a,i)),a+=i,r=0)}return r>0&&n.push(e.substr(a)),n}function ka(e){return e instanceof Uint8Array?e:"string"==typeof e?Ca(e):new Uint8Array(e)}function Oa(e,t,n=0,a=1/0){const r=Math.max(n,0),i=Math.min(r+a,e.length);let s=0,l=t.charCodeAt(0);for(let n=r;n<i;n++){if(e[n]===l){if(s+=1,s===t.length)return!0;l=t.charCodeAt(s)}else s>0&&(s=0,l=t.charCodeAt(0))}return!1}const Da=new ArrayBuffer(8),Fa=new Int8Array(Da),Ga=new Int16Array(Da),Na=new Int32Array(Da),Va=new Uint8Array(Da),Ha=new Uint16Array(Da),Ya=new Uint32Array(Da),Ka=new Float32Array(Da),za=new Float64Array(Da);function qa(e){return Va[0]=e,Fa[0]}function Za(e,t){return Va[0]=e,Va[1]=t,Ga[0]}function ja(e,t,n,a){return Va[0]=e,Va[1]=t,Va[2]=n,Va[3]=a,Na[0]}function Xa(e,t){return Va[0]=e,Va[1]=t,Ha[0]}function $a(e,t,n,a){return Va[0]=e,Va[1]=t,Va[2]=n,Va[3]=a,Ya[0]}function Ja(e,t,n,a){return Va[0]=e,Va[1]=t,Va[2]=n,Va[3]=a,Ka[0]}function Wa(e,t,n,a,r,i,s,l){return Va[0]=e,Va[1]=t,Va[2]=n,Va[3]=a,Va[4]=r,Va[5]=i,Va[6]=s,Va[7]=l,za[0]}function Qa(e){return Va[0]=e,Fa[0]}function er(e,t){return Ga[0]=t,e[0]=Va[0],e[1]=Va[1],e}function tr(e,t){return Na[0]=t,e[0]=Va[0],e[1]=Va[1],e[2]=Va[2],e[3]=Va[3],e}function nr(e,t){return Ha[0]=t,e[0]=Va[0],e[1]=Va[1],e}function ar(e,t){return Ya[0]=t,e[0]=Va[0],e[1]=Va[1],e[2]=Va[2],e[3]=Va[3],e}function rr(e,t){return Ka[0]=t,e[0]=Va[0],e[1]=Va[1],e[2]=Va[2],e[3]=Va[3],e}function ir(e,t){return za[0]=t,e[0]=Va[0],e[1]=Va[1],e[2]=Va[2],e[3]=Va[3],e[4]=Va[4],e[5]=Va[5],e[6]=Va[6],e[7]=Va[7],e}function sr(e){return Ya[0]=e,Ya[0]}function lr(e){const t=[];for(;e>0;)t.push(String.fromCharCode(e%256)),e=Math.floor(e/256);return t.reverse().join("")}const or=new Uint8Array(8);class ur{constructor(e,t,n){this.index=0;const a=ka(e);t=t||0,n=n||a.length,this.buffer=e,this.uint8array=a.subarray(t,t+n),this.byteLength=n,this.remaining=n}substream(e){if(this.remaining<e)throw new Error(`ByteStream: substream: want ${e} bytes but have ${this.remaining}`);const t=this.index;return this.index+=e,new ur(this.uint8array.subarray(t,t+e))}skip(e){if(this.remaining<e)throw new Error(`ByteStream: skip: premature end - want ${e} bytes but have ${this.remaining}`);this.index+=e,this.remaining-=e}seek(e){this.index=e,this.remaining=this.byteLength-e}read(e){if(this.remaining<e)throw new Error(`ByteStream: read: premature end - want ${e} bytes but have ${this.remaining}`);const t=this.uint8array,n=this.index;let a=function(e,t,n=0,a=1/0){const r=Math.max(n,0),i=Math.min(r+a,e.length);for(let n=r;n<i;n++)if(e[n]===t)return n;return-1}(t,0,n,e);return-1===a&&(a=n+e),this.index+=e,this.remaining-=e,Ma(t.subarray(n,a))}readNull(){if(this.remaining<1)throw new Error("ByteStream: readNull: premature end - want at least 1 byte but have 0");const e=this.uint8array,t=this.index;let n=e.indexOf(0,t);-1===n&&(n=e.length-1);const a=n-t+1;return this.index+=a,this.remaining-=a,Ma(e.subarray(t,n))}readBinary(e){if(this.remaining<e)throw new Error(`ByteStream: readBinary: premature end - want ${e} bytes but have ${this.remaining}`);const t=this.uint8array,n=this.index;let a="";for(let r=0;r<e;r++)a+=String.fromCharCode(t[n+r]);return this.index+=e,this.remaining-=e,a}readInt8(){if(this.remaining<1)throw new Error(`ByteStream: readInt8: premature end - want 1 byte but have ${this.remaining}`);const e=this.index,t=qa(this.uint8array[e]);return this.index+=1,this.remaining-=1,t}readInt16(){if(this.remaining<2)throw new Error(`ByteStream: readInt16: premature end - want 2 bytes but have ${this.remaining}`);const e=this.index,t=this.uint8array,n=Za(t[e],t[e+1]);return this.index+=2,this.remaining-=2,n}readInt32(){if(this.remaining<4)throw new Error(`ByteStream: readInt32: premature end - want 4 bytes but have ${this.remaining}`);const e=this.index,t=this.uint8array,n=ja(t[e],t[e+1],t[e+2],t[e+3]);return this.index+=4,this.remaining-=4,n}readUint8(){if(this.remaining<1)throw new Error(`ByteStream: readUint8: premature end - want 1 byte but have ${this.remaining}`);const e=this.uint8array[this.index];return this.index+=1,this.remaining-=1,e}readUint16(){if(this.remaining<2)throw new Error(`ByteStream: readUint16: premature end - want 2 bytes but have ${this.remaining}`);const e=this.index,t=this.uint8array,n=Xa(t[e],t[e+1]);return this.index+=2,this.remaining-=2,n}readUint32(){if(this.remaining<4)throw new Error(`ByteStream: readUint32: premature end - want 4 bytes but have ${this.remaining}`);const e=this.index,t=this.uint8array,n=$a(t[e],t[e+1],t[e+2],t[e+3]);return this.index+=4,this.remaining-=4,n}readFloat32(){if(this.remaining<4)throw new Error(`ByteStream: readFloat32: premature end - want 4 bytes but have ${this.remaining}`);const e=this.index,t=this.uint8array,n=Ja(t[e],t[e+1],t[e+2],t[e+3]);return this.index+=4,this.remaining-=4,n}readFloat64(){if(this.remaining<8)throw new Error(`ByteStream: readFloat64: premature end - want 8 bytes but have ${this.remaining}`);const e=this.index,t=this.uint8array,n=Wa(t[e],t[e+1],t[e+2],t[e+3],t[e+4],t[e+5],t[e+6],t[e+7]);return this.index+=8,this.remaining-=8,n}readInt8Array(e){if(ArrayBuffer.isView(e)||(e=new Int8Array(e)),this.remaining<e.byteLength)throw new Error(`ByteStream: readInt8Array: premature end - want ${e.byteLength} bytes but have ${this.remaining}`);const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++)e[a]=qa(n[t+a]);return this.index+=e.byteLength,this.remaining-=e.byteLength,e}readInt16Array(e){if(ArrayBuffer.isView(e)||(e=new Int16Array(e)),this.remaining<e.byteLength)throw new Error(`ByteStream: readInt16Array: premature end - want ${e.byteLength} bytes but have ${this.remaining}`);const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+2*a;e[a]=Za(n[r],n[r+1])}return this.index+=e.byteLength,this.remaining-=e.byteLength,e}readInt32Array(e){if(ArrayBuffer.isView(e)||(e=new Int32Array(e)),this.remaining<e.byteLength)throw new Error(`ByteStream: readInt32Array: premature end - want ${e.byteLength} bytes but have ${this.remaining}`);const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+4*a;e[a]=ja(n[r],n[r+1],n[r+2],n[r+3])}return this.index+=e.byteLength,this.remaining-=e.byteLength,e}readUint8Array(e){if(ArrayBuffer.isView(e)||(e=new Uint8Array(e)),this.remaining<e.byteLength)throw new Error(`ByteStream: readUint8Array: premature end - want ${e.byteLength} bytes but have ${this.remaining}`);const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++)e[a]=n[t+a];return this.index+=e.byteLength,this.remaining-=e.byteLength,e}readUint16Array(e){if(ArrayBuffer.isView(e)||(e=new Uint16Array(e)),this.remaining<e.byteLength)throw new Error(`ByteStream: readUint16Array: premature end - want ${e.byteLength} bytes but have ${this.remaining}`);const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+2*a;e[a]=Xa(n[r],n[r+1])}return this.index+=e.byteLength,this.remaining-=e.byteLength,e}readUint32Array(e){if(ArrayBuffer.isView(e)||(e=new Uint32Array(e)),this.remaining<e.byteLength)throw new Error(`ByteStream: readUint32Array: premature end - want ${e.byteLength} bytes but have ${this.remaining}`);const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+4*a;e[a]=$a(n[r],n[r+1],n[r+2],n[r+3])}return this.index+=e.byteLength,this.remaining-=e.byteLength,e}readFloat32Array(e){if(ArrayBuffer.isView(e)||(e=new Float32Array(e)),this.remaining<e.byteLength)throw new Error(`ByteStream: readFloat32Array: premature end - want ${e.byteLength} bytes but have ${this.remaining}`);const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+4*a;e[a]=Ja(n[r],n[r+1],n[r+2],n[r+3])}return this.index+=e.byteLength,this.remaining-=e.byteLength,e}readFloat64Array(e){if(ArrayBuffer.isView(e)||(e=new Float64Array(e)),this.remaining<e.byteLength)throw new Error(`ByteStream: readFloat64Array: premature end - want ${e.byteLength} bytes but have ${this.remaining}`);const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+8*a;e[a]=Wa(n[r],n[r+1],n[r+2],n[r+3],n[r+4],n[r+5],n[r+6],n[r+7])}return this.index+=e.byteLength,this.remaining-=e.byteLength,e}write(e){const t=Ca(e);return this.writeUint8Array(t),t.length}writeNull(e){const t=this.write(e);return this.index++,this.remaining--,t+1}writeBinary(e){const t=this.index,n=this.uint8array,a=e.length;for(let r=0;r<a;r++)n[t+r]=e.charCodeAt(r);this.index+=a}writeInt8(e){this.uint8array[this.index]=Qa(e),this.index+=1}writeInt16(e){const t=this.index,n=this.uint8array;er(or,e),n[t]=or[0],n[t+1]=or[1],this.index+=2}writeInt32(e){const t=this.index,n=this.uint8array;tr(or,e),n[t]=or[0],n[t+1]=or[1],n[t+2]=or[2],n[t+3]=or[3],this.index+=4}writeUint8(e){this.uint8array[this.index]=e,this.index+=1}writeUint16(e){const t=this.index,n=this.uint8array;nr(or,e),n[t]=or[0],n[t+1]=or[1],this.index+=2}writeUint32(e){const t=this.index,n=this.uint8array;ar(or,e),n[t]=or[0],n[t+1]=or[1],n[t+2]=or[2],n[t+3]=or[3],this.index+=4}writeFloat32(e){const t=this.index,n=this.uint8array;rr(or,e),n[t]=or[0],n[t+1]=or[1],n[t+2]=or[2],n[t+3]=or[3],this.index+=4}writeFloat64(e){const t=this.index,n=this.uint8array;ir(or,e),n[t]=or[0],n[t+1]=or[1],n[t+2]=or[2],n[t+3]=or[3],n[t+4]=or[4],n[t+5]=or[5],n[t+6]=or[6],n[t+7]=or[7],this.index+=8}writeInt8Array(e){const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++)n[t+a]=Qa(e[a]);this.index+=e.byteLength}writeInt16Array(e){const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+2*a;er(or,e[a]),n[r]=or[0],n[r+1]=or[1]}this.index+=e.byteLength}writeInt32Array(e){const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+4*a;tr(or,e[a]),n[r]=or[0],n[r+1]=or[1],n[r+2]=or[2],n[r+3]=or[3]}this.index+=e.byteLength}writeUint8Array(e){const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++)n[t+a]=e[a];this.index+=e.byteLength}writeUint16Array(e){const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+2*a;nr(or,e[a]),n[r]=or[0],n[r+1]=or[1]}this.index+=e.byteLength}writeUint32Array(e){const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+4*a;ar(or,e[a]),n[r]=or[0],n[r+1]=or[1],n[r+2]=or[2],n[r+3]=or[3]}this.index+=e.byteLength}writeFloat32Array(e){const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+4*a;rr(or,e[a]),n[r]=or[0],n[r+1]=or[1],n[r+2]=or[2],n[r+3]=or[3]}this.index+=e.byteLength}writeFloat64Array(e){const t=this.index,n=this.uint8array;for(let a=0,r=e.length;a<r;a++){const r=t+8*a;ir(or,e[a]),n[r]=or[0],n[r+1]=or[1],n[r+2]=or[2],n[r+3]=or[3],n[r+4]=or[4],n[r+5]=or[5],n[r+6]=or[6],n[r+7]=or[7]}this.index+=e.byteLength}}class cr{constructor(e,t,n){this.index=0,this.bitBuffer=0,this.bits=0;const a=ka(e);t=t||0,n=n||a.length,this.buffer=e,this.uint8array=a.subarray(t,t+n),this.byteLength=e.byteLength}peekBits(e){return this.loadBits(e),this.bitBuffer&(1<<e)-1}readBits(e){const t=this.peekBits(e);return this.bitBuffer>>>=e,this.bits-=e,t}skipBits(e){this.loadBits(e),this.bitBuffer>>>=e,this.bits-=e}loadBits(e){for(;this.bits<e;)this.bitBuffer+=this.uint8array[this.index]<<this.bits,this.bits+=8,this.index+=1}}function dr(e){if(e&&e.length){let t=e.lastIndexOf("/");return-1!==t&&(e=e.slice(t+1)),t=e.lastIndexOf("\\"),-1!==t&&(e=e.slice(t+1)),e}return""}function hr(e){if(e&&e.length){const t=e.lastIndexOf(".");return-1!==t&&(e=e.slice(t).toLowerCase()),e}return""}function fr(e){const t=(e=dr(e)).lastIndexOf(".");return-1!==t&&(e=e.slice(0,t)),e}function mr(e){return e instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&137===e[0]&&80===e[1]&&78===e[2]&&71===e[3]&&13===e[4]&&10===e[5]&&26===e[6]&&10===e[7]}function pr(e){return e instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&255===e[0]&&216===e[1]&&255===e[e.length-2]&&217===e[e.length-1]}function _r(e){return e instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&71===e[0]&&73===e[1]&&70===e[2]&&56===e[3]&&(55===e[4]||57===e[4])&&97===e[5]}function gr(e){return e instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&82===e[0]&&73===e[1]&&70===e[2]&&70===e[3]&&87===e[8]&&69===e[9]&&66===e[10]&&80===e[11]}const br={glMatrix:l,glMatrixAddon:o,math:u,canvas:c,BinaryStream:ur,BitStream:cr,urlWithParams:function(e,t){if(t){const n=Object.entries(t);if(n.length){const t=n.map((([e,t])=>`${e}=${t}`)).join("&");let a="&";return-1===e.indexOf("?")&&(a="?"),`${e}${a}${t}`}}return e},path:d,isPng:mr,isJpeg:pr,isGif:_r,isWebP:gr};class wr{constructor(){this.properties=new Map,this.sections=new Map}load(e){let t=this.properties;const n=this.sections;for(const a of e.split("\r\n"))if(a.length&&!a.startsWith("//")&&!a.startsWith(";")){let e=a.match(/^\[(.+?)\]/);if(e){const a=e[1].trim().toLowerCase();t=n.get(a),t||(t=new Map,n.set(a,t))}else e=a.match(/^(.+?)=(.*?)$/),e&&t.set(e[1],e[2])}}save(){const e=[];for(const[t,n]of this.properties)e.push(`${t}=${n}`);for(const[t,n]of this.sections){e.push(`[${t}]`);for(const[t,a]of n)e.push(`${t}=${a}`)}return e.join("\r\n")}getSection(e){return this.sections.get(e.toLowerCase())}}const vr={File:wr};class Ar{constructor(){this.rows=[]}load(e){if(!e.startsWith("ID"))throw new Error("WrongMagicNumber");const t=this.rows;let n=0,a=0;for(const r of e.split("\n"))if("B"!==r[0])for(const e of r.split(";")){const r=e[0],i=e.substring(1).trim();let s;"X"===r?n=parseInt(i,10)-1:"Y"===r?a=parseInt(i,10)-1:"K"===r&&(t[a]||(t[a]=[]),'"'===i[0]?s=i.substring(1,i.length-1):"TRUE"===i?s=!0:"FALSE"===i?s=!1:(s=parseFloat(i),isNaN(s)&&(s=i)),t[a][n]=s)}}save(){const e=this.rows,t=e.length,n=[];let a=0;for(let r=0;r<t;r++){const t=e[r],i=t.length;i>a&&(a=i);let s=!0;for(let e=0;e<i;e++){const a=t[e];if(void 0!==a){let t;t="string"==typeof a?`"${a}"`:"boolean"==typeof a?a?"TRUE":"FALSE":`${a}`,s?(s=!1,n.push(`C;X${e+1};Y${r+1};K${t}`)):n.push(`C;X${e+1};K${t}`)}}}return`ID;P\r\nB;X${a};Y${t}\r\n${n.join("\r\n")}\r\nE`}}const yr={File:Ar};function Sr(e){return[...e].reverse().join("")}class Tr{constructor(){this.index=null,this.entries=0,this.id=0,this.flags=0}load(e,t){this.index=t,this.entries=e.readUint32(),this.id=e.readUint32(),this.flags=e.readUint32()}get(){if(this.index&&0!==this.id&&0!==this.entries)return this.index[this.id].entries}first(){const e=this.get();if(e)return e[0]}}class xr{constructor(){this.version=-1,this.tag="",this.offset=0,this.entries=0,this.model=new Tr}load(e,t,n){this.version=t,this.tag=Sr(e.readBinary(4)),this.offset=e.readUint32(),this.entries=e.readUint32(),this.model.load(e,n)}}class Er{constructor(){this.min=new Float32Array(3),this.max=new Float32Array(3),this.radius=0}load(e){e.readFloat32Array(this.min),e.readFloat32Array(this.max),this.radius=e.readFloat32()}}class Lr{constructor(){this.shape=-1,this.bone=-1,this.unknown0=0,this.matrix=new Float32Array(16),this.unknown1=0,this.unknown2=0,this.unknown3=0,this.unknown4=0,this.unknown5=0,this.unknown6=0,this.size=new Float32Array(3)}load(e){this.shape=e.readUint32(),this.bone=e.readInt16(),this.unknown0=e.readUint16(),e.readFloat32Array(this.matrix),this.unknown1=e.readUint32(),this.unknown2=e.readUint32(),this.unknown3=e.readUint32(),this.unknown4=e.readUint32(),this.unknown5=e.readUint32(),this.unknown6=e.readUint32(),e.readFloat32Array(this.size)}}class Ir{constructor(){this.interpolationType=0,this.animFlags=0,this.animId=-1,this.initValue=null,this.nullValue=null}load(e){this.interpolationType=e.readUint16(),this.animFlags=e.readUint16(),this.animId=e.readUint32(),this.readInitNullValues(e),e.skip(4)}}class Ur extends Ir{readInitNullValues(e){this.initValue=e.readUint8Array(4),this.nullValue=e.readUint8Array(4)}}class Rr extends Ir{readInitNullValues(e){this.initValue=e.readUint16(),this.nullValue=e.readUint16()}}class Mr extends Ir{readInitNullValues(e){this.initValue=e.readUint32(),this.nullValue=e.readUint32()}}class Cr extends Ir{readInitNullValues(e){this.initValue=e.readFloat32(),this.nullValue=e.readFloat32()}}class Br extends Ir{readInitNullValues(e){this.initValue=e.readFloat32Array(2),this.nullValue=e.readFloat32Array(2)}}class Pr extends Ir{readInitNullValues(e){this.initValue=e.readFloat32Array(3),this.nullValue=e.readFloat32Array(3)}}class kr extends Ir{readInitNullValues(e){this.initValue=e.readFloat32Array(4),this.nullValue=e.readFloat32Array(4)}}class Or{constructor(){this.version=-1,this.keys=new Tr,this.flags=0,this.biggestKey=-1,this.values=new Tr}load(e,t,n){this.version=t,this.keys.load(e,n),this.flags=e.readUint32(),this.biggestKey=e.readUint32(),this.values.load(e,n)}}class Dr{constructor(e,t,n){this.stream=e,this.version=t,this.index=n}}const Fr={MD34:[xr,{11:24}],MODL:[class{constructor(){this.version=-1,this.modelName=new Tr,this.flags=0,this.sequences=new Tr,this.stc=new Tr,this.stg=new Tr,this.unknown0=0,this.unknown1=0,this.unknown2=0,this.unknown3=0,this.sts=new Tr,this.bones=new Tr,this.numberOfBonesToCheckForSkin=0,this.vertexFlags=0,this.vertices=new Tr,this.divisions=new Tr,this.boneLookup=new Tr,this.boundings=new Er,this.unknown4To20=new Uint32Array(16),this.attachmentPoints=new Tr,this.attachmentPointAddons=new Tr,this.ligts=new Tr,this.shbxData=new Tr,this.cameras=new Tr,this.unknown21=new Tr,this.materialReferences=new Tr,this.materials=[],this.particleEmitters=new Tr,this.particleEmitterCopies=new Tr,this.ribbonEmitters=new Tr,this.projections=new Tr,this.forces=new Tr,this.warps=new Tr,this.unknown22=new Tr,this.rigidBodies=new Tr,this.unknown23=new Tr,this.physicsJoints=new Tr,this.clothBehavior=new Tr,this.unknown24=new Tr,this.ikjtData=new Tr,this.unknown25=new Tr,this.unknown26=new Tr,this.partsOfTurrentBehaviors=new Tr,this.turrentBehaviors=new Tr,this.absoluteInverseBoneRestPositions=new Tr,this.tightHitTest=new Lr,this.fuzzyHitTestObjects=new Tr,this.attachmentVolumes=new Tr,this.attachmentVolumesAddon0=new Tr,this.attachmentVolumesAddon1=new Tr,this.billboardBehaviors=new Tr,this.tmdData=new Tr,this.unknown27=0,this.unknown28=new Tr;for(let e=0;e<11;e++)this.materials[e]=new Tr}load(e,t,n){this.version=t,this.modelName.load(e,n),this.flags=e.readUint32(),this.sequences.load(e,n),this.stc.load(e,n),this.stg.load(e,n),this.unknown0=e.readFloat32(),this.unknown1=e.readFloat32(),this.unknown2=e.readFloat32(),this.unknown3=e.readFloat32(),this.sts.load(e,n),this.bones.load(e,n),this.numberOfBonesToCheckForSkin=e.readUint32(),this.vertexFlags=e.readUint32(),this.vertices.load(e,n),this.divisions.load(e,n),this.boneLookup.load(e,n),this.boundings.load(e),e.readUint32Array(this.unknown4To20),this.attachmentPoints.load(e,n),this.attachmentPointAddons.load(e,n),this.ligts.load(e,n),this.shbxData.load(e,n),this.cameras.load(e,n),this.unknown21.load(e,n),this.materialReferences.load(e,n);for(let t=0;t<7;t++)this.materials[t].load(e,n);t>24&&this.materials[7].load(e,n),t>25&&this.materials[8].load(e,n),t>27&&this.materials[9].load(e,n),t>28&&this.materials[10].load(e,n),this.particleEmitters.load(e,n),this.particleEmitterCopies.load(e,n),this.ribbonEmitters.load(e,n),this.projections.load(e,n),this.forces.load(e,n),this.warps.load(e,n),this.unknown22.load(e,n),this.rigidBodies.load(e,n),this.unknown23.load(e,n),this.physicsJoints.load(e,n),t>27&&this.clothBehavior.load(e,n),this.unknown24.load(e,n),this.ikjtData.load(e,n),this.unknown25.load(e,n),t>24&&this.unknown26.load(e,n),this.partsOfTurrentBehaviors.load(e,n),this.turrentBehaviors.load(e,n),this.absoluteInverseBoneRestPositions.load(e,n),this.tightHitTest.load(e),this.fuzzyHitTestObjects.load(e,n),this.attachmentVolumes.load(e,n),this.attachmentVolumesAddon0.load(e,n),this.attachmentVolumesAddon1.load(e,n),this.billboardBehaviors.load(e,n),this.tmdData.load(e,n),this.unknown27=e.readUint32(),this.unknown28.load(e,n)}},{23:784,25:808,26:820,28:844,29:856}],SEQS:[class{constructor(){this.version=-1,this.name=new Tr,this.interval=new Uint32Array(2),this.movementSpeed=0,this.flags=0,this.frequency=0,this.boundingSphere=new Er}load(e,t,n){this.version=t,e.skip(8),this.name.load(e,n),e.readUint32Array(this.interval),this.movementSpeed=e.readFloat32(),this.flags=e.readUint32(),this.frequency=e.readUint32(),e.skip(12),t<2&&e.skip(4),this.boundingSphere.load(e),e.skip(12)}},{1:96,2:92}],STC_:[class{constructor(){this.version=-1,this.name=new Tr,this.runsConcurrent=0,this.priority=0,this.stsIndex=-1,this.stsIndexCopy=-1,this.animIds=new Tr,this.animRefs=new Tr,this.sd=[];for(let e=0;e<13;e++)this.sd[e]=new Tr}load(e,t,n){this.version=t,this.name.load(e,n),this.runsConcurrent=e.readUint16(),this.priority=e.readUint16(),this.stsIndex=e.readUint16(),this.stsIndexCopy=e.readUint16(),this.animIds.load(e,n),this.animRefs.load(e,n),e.skip(4);for(let t=0;t<13;t++)this.sd[t].load(e,n)}},{4:204}],STG_:[class{constructor(){this.version=-1,this.name=new Tr,this.stcIndices=new Tr}load(e,t,n){this.version=t,this.name.load(e,n),this.stcIndices.load(e,n)}},{0:24}],STS_:[class{constructor(){this.version=-1,this.animIds=new Tr}load(e,t,n){this.version=t,this.animIds.load(e,n),e.skip(16)}},{0:28}],BONE:[class{constructor(){this.version=-1,this.unknown0=0,this.name=new Tr,this.flags=0,this.parent=-1,this.unknown1=0,this.location=new Pr,this.rotation=new kr,this.scale=new Pr,this.visibility=new Mr}load(e,t,n){this.version=t,this.unknown0=e.readInt32(),this.name.load(e,n),this.flags=e.readUint32(),this.parent=e.readInt16(),this.unknown1=e.readUint16(),this.location.load(e),this.rotation.load(e),this.scale.load(e),this.visibility.load(e)}},{1:160}],DIV_:[class{constructor(){this.version=-1,this.triangles=new Tr,this.regions=new Tr,this.batches=new Tr,this.MSEC=new Tr,this.unknown0=0}load(e,t,n){this.version=t,this.triangles.load(e,n),this.regions.load(e,n),this.batches.load(e,n),this.MSEC.load(e,n),this.unknown0=e.readUint32()}},{2:52}],REGN:[class{constructor(){this.version=-1,this.unknown0=0,this.unknown1=0,this.firstVertexIndex=-1,this.verticesCount=0,this.firstTriangleIndex=-1,this.triangleIndicesCount=0,this.bonesCount=0,this.firstBoneLookupIndex=-1,this.boneLookupIndicesCount=0,this.unknown2=0,this.boneWeightPairsCount=0,this.unknown3=0,this.rootBoneIndex=-1,this.unknown4=0,this.unknown5=new Uint8Array(8)}load(e,t,n){this.version=t,this.unknown0=e.readUint32(),this.unknown1=e.readUint32(),this.firstVertexIndex=e.readUint32(),this.verticesCount=e.readUint32(),this.firstTriangleIndex=e.readUint32(),this.triangleIndicesCount=e.readUint32(),this.bonesCount=e.readUint16(),this.firstBoneLookupIndex=e.readUint16(),this.boneLookupIndicesCount=e.readUint16(),this.unknown2=e.readUint16(),this.boneWeightPairsCount=e.readUint8(),this.unknown3=e.readUint8(),this.rootBoneIndex=e.readUint16(),t>3&&(this.unknown4=e.readUint32()),t>4&&e.readUint8Array(this.unknown5)}},{3:36,4:40,5:48}],BAT_:[class{constructor(){this.version=-1,this.unknown0=0,this.regionIndex=-1,this.unknown1=0,this.materialReferenceIndex=-1,this.unknown2=0}load(e,t,n){this.version=t,this.unknown0=e.readUint32(),this.regionIndex=e.readUint16(),this.unknown1=e.readUint32(),this.materialReferenceIndex=e.readUint16(),this.unknown2=e.readUint16()}},{1:14}],MATM:[class{constructor(){this.version=-1,this.materialType=0,this.materialIndex=-1}load(e,t,n){this.version=t,this.materialType=e.readUint32(),this.materialIndex=e.readUint32()}},{0:8}],MAT_:[class{constructor(){this.version=-1,this.name=new Tr,this.additionalFlags=0,this.flags=0,this.blendMode=0,this.priority=0,this.usedRTTChannels=0,this.specularity=0,this.depthBlendFalloff=0,this.cutoutThreshold=0,this.unknown1=0,this.unknown2=0,this.unknown3=0,this.specMult=0,this.emisMult=0,this.diffuseLayer=new Tr,this.decalLayer=new Tr,this.specularLayer=new Tr,this.glossLayer=new Tr,this.emissiveLayer=new Tr,this.emissive2Layer=new Tr,this.evioLayer=new Tr,this.evioMaskLayer=new Tr,this.alphaMaskLayer=new Tr,this.alphaMask2Layer=new Tr,this.normalLayer=new Tr,this.heightLayer=new Tr,this.lightMapLayer=new Tr,this.ambientOcclusionLayer=new Tr,this.unknown4=new Tr,this.unknown5=new Tr,this.unknown6=new Tr,this.unknown7=new Tr,this.unknown8=0,this.layerBlendType=0,this.emisBlendType=0,this.emisMode=0,this.specType=0,this.unknown9=new Cr,this.unknown10=new Mr,this.unknown11=new Uint8Array(12)}load(e,t,n){this.version=t,this.name.load(e,n),this.additionalFlags=e.readUint32(),this.flags=e.readUint32(),this.blendMode=e.readUint32(),this.priority=e.readInt32(),this.usedRTTChannels=e.readUint32(),this.specularity=e.readFloat32(),this.depthBlendFalloff=e.readFloat32(),this.cutoutThreshold=e.readUint8(),this.unknown1=e.readUint8(),this.unknown2=e.readUint8(),this.unknown3=e.readUint8(),this.specMult=e.readFloat32(),this.emisMult=e.readFloat32(),this.diffuseLayer.load(e,n),this.decalLayer.load(e,n),this.specularLayer.load(e,n),t>15&&this.glossLayer.load(e,n),this.emissiveLayer.load(e,n),this.emissive2Layer.load(e,n),this.evioLayer.load(e,n),this.evioMaskLayer.load(e,n),this.alphaMaskLayer.load(e,n),this.alphaMask2Layer.load(e,n),this.normalLayer.load(e,n),this.heightLayer.load(e,n),this.lightMapLayer.load(e,n),this.ambientOcclusionLayer.load(e,n),t>18&&(this.unknown4.load(e,n),this.unknown5.load(e,n),this.unknown6.load(e,n),this.unknown7.load(e,n)),this.unknown8=e.readUint32(),this.layerBlendType=e.readUint32(),this.emisBlendType=e.readUint32(),this.emisMode=e.readUint32(),this.specType=e.readUint32(),this.unknown9.load(e),this.unknown10.load(e),t>18&&(this.unknown11=e.readUint8Array(this.unknown11))}},{15:268,16:280,17:280,18:280,19:340}],LAYR:[class{constructor(){this.version=-1,this.unknown0=0,this.imagePath=new Tr,this.color=new Ur,this.flags=0,this.uvSource=-1,this.colorChannelSetting=0,this.brightMult=new Cr,this.midtoneOffset=new Cr,this.unknown1=0,this.noiseAmp=0,this.noiseFreq=0,this.rttChannel=0,this.videoFrameRate=0,this.videoStartFrame=0,this.videoEndFrame=0,this.videoMode=0,this.videoSyncTiming=0,this.videoPlay=new Mr,this.videoRestart=new Mr,this.flipBookRows=0,this.flipBookColumns=0,this.flipBookFrame=new Rr,this.uvOffset=new Br,this.uvAngle=new Pr,this.uvTiling=new Br,this.unknown2=new Mr,this.unknown3=new Cr,this.brightness=new Cr,this.triPlanarOffset=new Pr,this.triPlanarScale=new Pr,this.unknown4=0,this.fresnelType=0,this.fresnelExponent=0,this.fresnelMin=0,this.fresnelMaxOffset=0,this.unknown5=0,this.unknown6=new Uint8Array(8),this.fresnelInvertedMaskX=0,this.fresnelInvertedMaskY=0,this.fresnelInvertedMaskZ=0,this.fresnelRotationYaw=0,this.fresnelRotationPitch=0,this.unknown7=0}load(e,t,n){this.version=t,this.unknown0=e.readUint32(),this.imagePath.load(e,n),this.color.load(e),this.flags=e.readUint32(),this.uvSource=e.readUint32(),this.colorChannelSetting=e.readUint32(),this.brightMult.load(e),this.midtoneOffset.load(e),this.unknown1=e.readUint32(),t>23&&(this.noiseAmp=e.readFloat32(),this.noiseFreq=e.readFloat32()),this.rttChannel=e.readInt32(),this.videoFrameRate=e.readUint32(),this.videoStartFrame=e.readUint32(),this.videoEndFrame=e.readInt32(),this.videoMode=e.readUint32(),this.videoSyncTiming=e.readUint32(),this.videoPlay.load(e),this.videoRestart.load(e),this.flipBookRows=e.readUint32(),this.flipBookColumns=e.readUint32(),this.flipBookFrame.load(e),this.uvOffset.load(e),this.uvAngle.load(e),this.uvTiling.load(e),this.unknown2.load(e),this.unknown3.load(e),this.brightness.load(e),t>23&&(this.triPlanarOffset.load(e),this.triPlanarScale.load(e)),this.unknown4=e.readInt32(),this.fresnelType=e.readUint32(),this.fresnelExponent=e.readFloat32(),this.fresnelMin=e.readFloat32(),this.fresnelMaxOffset=e.readFloat32(),this.unknown5=e.readFloat32(),t>24&&(this.unknown6=e.readUint8Array(8),this.fresnelInvertedMaskX=e.readFloat32(),this.fresnelInvertedMaskY=e.readFloat32(),this.fresnelInvertedMaskZ=e.readFloat32(),this.fresnelRotationYaw=e.readFloat32(),this.fresnelRotationPitch=e.readFloat32(),this.unknown7=e.readUint32())}},{22:356,24:436,25:468,26:464}],EVNT:[class{constructor(){this.version=-1,this.name=new Tr,this.unknown0=0,this.unknown1=0,this.unknown2=0,this.matrix=new Float32Array(16),this.unknown3=0,this.unknown4=0,this.unknown5=0,this.unknown6=0,this.unknown7=0,this.unknown8=0}load(e,t,n){this.version=t,this.name.load(e,n),this.unknown0=e.readInt32(),this.unknown1=e.readInt16(),this.unknown2=e.readUint16(),e.readFloat32Array(this.matrix),this.unknown3=e.readInt32(),this.unknown4=e.readInt32(),this.unknown5=e.readInt32(),t>0&&(this.unknown6=e.readInt32(),this.unknown7=e.readInt32()),t>1&&(this.unknown8=e.readInt32())}},{0:96,1:104,2:108}],BNDS:[Er,{0:28}],ATT_:[class{constructor(){this.version=-1,this.unknown=0,this.name=new Tr,this.bone=-1}load(e,t,n){this.version=t,this.unknown=e.readInt32(),this.name.load(e,n),this.bone=e.readUint32()}},{1:20}],CAM_:[class{constructor(){this.version=-1,this.bone=-1,this.name=new Tr,this.fieldOfView=new Cr,this.unknown0=0,this.farClip=new Cr,this.nearClip=new Cr,this.clip2=new Cr,this.focalDepth=new Cr,this.falloffStart=new Cr,this.falloffEnd=new Cr,this.depthOfField=new Cr}load(e,t,n){this.version=t,this.bone=e.readUint32(),this.name.load(e,n),this.fieldOfView.load(e),this.unknown0=e.readUint32(),this.farClip.load(e),this.nearClip.load(e),this.clip2.load(e),this.focalDepth.load(e),this.falloffStart.load(e),this.falloffEnd.load(e),this.depthOfField.load(e)}},{3:180,5:264}],SDEV:[Or,{0:32}],SDU6:[Or,{0:32}],SDFG:[Or,{0:32}],SDS6:[Or,{0:32}],SDR3:[Or,{0:32}],SD2V:[Or,{0:32}],SD3V:[Or,{0:32}],SD4Q:[Or,{0:32}],SDCC:[Or,{0:32}],SDMB:[Or,{0:32}],FLAG:[Or,{0:32}],MSEC:[Dr,{1:72}],LITE:[Dr,{7:212}],ATVL:[Dr,{0:116}],PATU:[Dr,{4:152}],TRGD:[Dr,{0:24}],DIS_:[Dr,{4:68}],CMS_:[Dr,{0:24}],CMP_:[Dr,{2:28}],TER_:[Dr,{0:24,1:28}],VOL_:[Dr,{0:84}],VON_:[Dr,{0:268}],CREP:[Dr,{0:24,1:28}],STBM:[Dr,{0:48}],LFSB:[Dr,{2:56}],LFLR:[Dr,{2:80,3:152}],PAR_:[Dr,{12:1316,17:1460,18:1464,19:1464,21:1464,22:1484,23:1492,24:1496}],PARC:[Dr,{0:40}],PROJ:[Dr,{4:388,5:382}],PHYJ:[Dr,{0:180}],PHCC:[Dr,{0:76}],PHAC:[Dr,{0:32}],PHCL:[Dr,{2:128}],FOR_:[Dr,{1:104,2:104}],DMSE:[Dr,{0:4}],PHSH:[Dr,{1:132,3:300}],PHRB:[Dr,{2:104,4:80}],SSGS:[Dr,{1:108}],BBSC:[Dr,{0:48}],SRIB:[Dr,{0:272}],RIB_:[Dr,{6:748,8:756,9:760}],IKJT:[Dr,{0:32}],SHBX:[Dr,{0:64}],WRP_:[Dr,{1:132}]};class Gr{constructor(e,t){const n=Sr(e.readBinary(4)),a=e.readUint32(),r=e.readUint32(),i=e.readUint32();this.index=t,this.tag=n,this.offset=a,this.version=i;const s=Fr[n],l=e.index;if(e.seek(a),s){const a=s[0],l=s[1][i];if(!l)throw new Error(": Unsupported object version - tag "+n+" and version "+i);this.entries=[];for(let n=0,s=r;n<s;n++)if(a===Dr)this.entries[n]=new Dr(e.substream(l),i,t);else{const r=new a;r.load(e.substream(l),i,t),this.entries[n]=r}}else if("CHAR"===n||"SCHR"===n)this.entries=e.read(r);else if("U8__"===n)this.entries=e.readUint8Array(r);else if("U16_"===n)this.entries=e.readUint16Array(r);else if("U32_"===n)this.entries=e.readUint32Array(r);else if("I16_"===n)this.entries=e.readInt16Array(r);else if("I32_"===n)this.entries=e.readInt32Array(r);else if("REAL"===n)this.entries=e.readFloat32Array(r);else if("VEC2"===n){this.entries=[];for(let t=0;t<r;t++)this.entries[t]=e.readFloat32Array(2)}else if("VEC3"===n||"SVC3"===n){this.entries=[];for(let t=0;t<r;t++)this.entries[t]=e.readFloat32Array(3)}else if("VEC4"===n||"QUAT"===n){this.entries=[];for(let t=0;t<r;t++)this.entries[t]=e.readFloat32Array(4)}else{if("IREF"!==n)throw this.entries=[],new Error(": Unsupported object tag - tag "+n+" and version "+i);this.entries=[];for(let t=0;t<r;t++)this.entries[t]=e.readFloat32Array(16)}e.seek(l)}}class Nr{constructor(){this.index=[],this.model=null}load(e){const t=new ur(e),n=new xr;if(n.load(t,11,this.index),"MD34"!==n.tag)throw new Error("WrongMagicNumber");t.seek(n.offset);for(let e=0,a=n.entries;e<a;e++)this.index[e]=new Gr(t,this.index);const a=this.index[n.model.id].entries;a&&(this.model=a[0])}}function Vr(e){return e instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&52===e[0]&&51===e[1]&&68===e[2]&&77===e[3]}const Hr={Model:Nr,isM3:Vr};class Yr{constructor(e){this.index=0,this.ident=0,this.indentSpaces=4,this.precision=1e6,this.buffer=e||""}clear(){this.buffer="",this.index=0,this.ident=0}readToken(){const e=this.buffer,t=e.length;let n=!1,a=!1,r="";for(;this.index<t;){const t=e[this.index++];if(n)"\n"===t&&(n=!1);else if(a)if("\\"===t)r+=t+e[this.index++];else if("\n"===t)r+="\\n";else if("\r"===t)r+="\\r";else{if('"'===t)return r;r+=t}else if(" "===t||","===t||"\t"===t||"\n"===t||":"===t||"\r"===t){if(r.length)return r}else{if("{"===t||"}"===t)return r.length?(this.index--,r):t;if("/"===t&&"/"===e[this.index]){if(r.length)return this.index--,r;n=!0}else if('"'===t){if(r.length)return this.index--,r;a=!0}else r+=t}}}read(){const e=this.readToken();if(void 0===e)throw new Error("End of stream reached prematurely");return e}peek(){const e=this.index,t=this.read();return this.index=e,t}readInt(){return parseInt(this.read())}readFloat(){return parseFloat(this.read())}readVector(e){this.read();for(let t=0,n=e.length;t<n;t++)e[t]=this.readFloat();return this.read(),e}readVectorsBlock(e,t){this.read();for(let n=0,a=e.length;n<a;n+=t)this.readVector(e.subarray(n,n+t));return this.read(),e}readColor(e){return this.read(),e[2]=this.readFloat(),e[1]=this.readFloat(),e[0]=this.readFloat(),this.read(),e}*readBlock(){this.read();let e=this.read();for(;"}"!==e;)yield e,e=this.read()}writeLine(e){this.buffer+=`${" ".repeat(this.ident*this.indentSpaces)}${e}\n`}writeFlag(e){this.writeLine(`${e},`)}writeFlagAttrib(e,t){this.writeLine(`${e} ${t},`)}writeNumberAttrib(e,t){this.writeLine(`${e} ${this.floatDecimals(t)},`)}writeStringAttrib(e,t){this.writeLine(`${e} "${t}",`)}writeVectorAttrib(e,t){this.writeLine(`${e} { ${this.floatArrayDecimals(t)} },`)}writeColor(e,t){const n=this.floatDecimals(t[0]),a=this.floatDecimals(t[1]),r=this.floatDecimals(t[2]);this.writeLine(`${e} { ${r}, ${a}, ${n} },`)}writeVector(e){this.writeLine(`{ ${this.floatArrayDecimals(e)} },`)}writeVectorArrayBlock(e,t,n){this.startBlock(e,t.length/n);for(let e=0,a=t.length;e<a;e+=n)this.writeVector(t.subarray(e,e+n));this.endBlock()}startBlock(e,...t){t.length&&(e=`${e} ${t.join(" ")}`),this.writeLine(`${e} {`),this.ident+=1}startObjectBlock(e,t){this.writeLine(`${e} "${t.replace(/"/g,'\\"')}" {`),this.ident+=1}endBlock(){this.ident-=1,this.writeLine("}")}endBlockComma(){this.ident-=1,this.writeLine("},")}indent(){this.ident+=1}unindent(){this.ident-=1}floatDecimals(e){return""+Math.trunc(e*this.precision)/this.precision}floatArrayDecimals(e){if(e instanceof Float32Array){const t=[];for(let n=0,a=e.length;n<a;n++)t[n]=this.floatDecimals(e[n]);return t.join(", ")}return e.join(", ")}}class Kr{constructor(){this.boundsRadius=0,this.min=new Float32Array(3),this.max=new Float32Array(3)}readMdx(e){this.boundsRadius=e.readFloat32(),e.readFloat32Array(this.min),e.readFloat32Array(this.max)}writeMdx(e){e.writeFloat32(this.boundsRadius),e.writeFloat32Array(this.min),e.writeFloat32Array(this.max)}writeMdl(e){0===this.min[0]&&0===this.min[1]&&0===this.min[2]||e.writeVectorAttrib("MinimumExtent",this.min),0===this.max[0]&&0===this.max[1]&&0===this.max[2]||e.writeVectorAttrib("MaximumExtent",this.max),0!==this.boundsRadius&&e.writeNumberAttrib("BoundsRadius",this.boundsRadius)}}class zr{constructor(){this.name="",this.interval=new Uint32Array(2),this.moveSpeed=0,this.nonLooping=0,this.rarity=0,this.syncPoint=0,this.extent=new Kr}readMdx(e){this.name=e.read(80),e.readUint32Array(this.interval),this.moveSpeed=e.readFloat32(),this.nonLooping=e.readUint32(),this.rarity=e.readFloat32(),this.syncPoint=e.readUint32(),this.extent.readMdx(e)}writeMdx(e){e.skip(80-e.write(this.name)),e.writeUint32Array(this.interval),e.writeFloat32(this.moveSpeed),e.writeUint32(this.nonLooping),e.writeFloat32(this.rarity),e.writeUint32(this.syncPoint),this.extent.writeMdx(e)}readMdl(e){this.name=e.read();for(const t of e.readBlock())if("Interval"===t)e.readVector(this.interval);else if("NonLooping"===t)this.nonLooping=1;else if("MoveSpeed"===t)this.moveSpeed=e.readFloat();else if("Rarity"===t)this.rarity=e.readFloat();else if("MinimumExtent"===t)e.readVector(this.extent.min);else if("MaximumExtent"===t)e.readVector(this.extent.max);else{if("BoundsRadius"!==t)throw new Error(`Unknown token in Sequence: "${t}"`);this.extent.boundsRadius=e.readFloat()}}writeMdl(e){e.startObjectBlock("Anim",this.name),e.writeVectorAttrib("Interval",this.interval),1===this.nonLooping&&e.writeFlag("NonLooping"),0!==this.moveSpeed&&e.writeNumberAttrib("MoveSpeed",this.moveSpeed),0!==this.rarity&&e.writeNumberAttrib("Rarity",this.rarity),this.extent.writeMdl(e),e.endBlock()}}class qr{constructor(){this.name="",this.interpolationType=0,this.globalSequenceId=-1,this.frames=[],this.values=[],this.inTans=[],this.outTans=[]}readMdx(e,t){const n=this.frames,a=this.values,r=this.inTans,i=this.outTans,s=e.readUint32(),l=e.readUint32();this.name=t,this.interpolationType=l,this.globalSequenceId=e.readInt32();for(let t=0;t<s;t++)n.push(e.readInt32()),a.push(this.readMdxValue(e)),l>1&&(r.push(this.readMdxValue(e)),i.push(this.readMdxValue(e)))}writeMdx(e){const t=this.interpolationType,n=this.frames,a=this.values,r=this.inTans,i=this.outTans,s=n.length;e.writeBinary(this.name),e.writeUint32(s),e.writeUint32(t),e.writeInt32(this.globalSequenceId);for(let l=0;l<s;l++)e.writeInt32(n[l]),this.writeMdxValue(e,a[l]),t>1&&(this.writeMdxValue(e,r[l]),this.writeMdxValue(e,i[l]))}readMdl(e,t){const n=this.frames,a=this.values,r=this.inTans,i=this.outTans;this.name=t;const s=e.readInt();e.read();let l=0;const o=e.read();"DontInterp"===o?l=0:"Linear"===o?l=1:"Hermite"===o?l=2:"Bezier"===o&&(l=3),this.interpolationType=l,"GlobalSeqId"===e.peek()&&(e.read(),this.globalSequenceId=e.readInt());for(let t=0;t<s;t++)n[t]=e.readInt(),a[t]=this.readMdlValue(e),l>1&&(e.read(),r[t]=this.readMdlValue(e),e.read(),i[t]=this.readMdlValue(e));e.read()}writeMdl(e,t){const n=this.interpolationType,a=this.frames,r=this.values,i=this.inTans,s=this.outTans,l=a.length;e.startBlock(t,this.frames.length);let o="";0===this.interpolationType?o="DontInterp":1===this.interpolationType?o="Linear":2===this.interpolationType?o="Hermite":3===this.interpolationType&&(o="Bezier"),e.writeFlag(o),-1!==this.globalSequenceId&&e.writeNumberAttrib("GlobalSeqId",this.globalSequenceId);for(let t=0;t<l;t++)this.writeMdlValue(e,`${a[t]}:`,r[t]),n>1&&(e.indent(),this.writeMdlValue(e,"InTan",i[t]),this.writeMdlValue(e,"OutTan",s[t]),e.unindent());e.endBlock()}getByteLength(){const e=this.frames.length;let t=16;if(e){const n=this.values[0].byteLength;let a=1;this.interpolationType>1&&(a=3),t+=(4+a*n)*e}return t}}class Zr extends qr{readMdxValue(e){return e.readUint32Array(1)}writeMdxValue(e,t){e.writeUint32(t[0])}readMdlValue(e){return new Uint32Array([e.readInt()])}writeMdlValue(e,t,n){e.writeNumberAttrib(t,n[0])}}class jr extends qr{readMdxValue(e){return e.readFloat32Array(1)}writeMdxValue(e,t){e.writeFloat32(t[0])}readMdlValue(e){return new Float32Array([e.readFloat()])}writeMdlValue(e,t,n){e.writeNumberAttrib(t,n[0])}}class Xr extends qr{readMdxValue(e){return e.readFloat32Array(3)}writeMdxValue(e,t){e.writeFloat32Array(t)}readMdlValue(e){return e.readVector(new Float32Array(3))}writeMdlValue(e,t,n){e.writeVectorAttrib(t,n)}}class $r extends qr{readMdxValue(e){return e.readFloat32Array(4)}writeMdxValue(e,t){e.writeFloat32Array(t)}readMdlValue(e){return e.readVector(new Float32Array(4))}writeMdlValue(e,t,n){e.writeVectorAttrib(t,n)}}const Jr={KMTF:["TextureID",Zr],KMTA:["Alpha",jr],KMTE:["EmissiveGain",jr],KFC3:["FresnelColor",Xr],KFCA:["FresnelOpacity",jr],KFTC:["FresnelTeamColor",Zr],KTAT:["Translation",Xr],KTAR:["Rotation",$r],KTAS:["Scaling",Xr],KGAO:["Alpha",jr],KGAC:["Color",Xr],KGTR:["Translation",Xr],KGRT:["Rotation",$r],KGSC:["Scaling",Xr],KLAS:["AttenuationStart",jr],KLAE:["AttenuationEnd",jr],KLAC:["Color",Xr],KLAI:["Intensity",jr],KLBI:["AmbIntensity",jr],KLBC:["AmbColor",Xr],KLAV:["Visibility",jr],KATV:["Visibility",jr],KPEE:["EmissionRate",jr],KPEG:["Gravity",jr],KPLN:["Longitude",jr],KPLT:["Latitude",jr],KPEL:["LifeSpan",jr],KPES:["InitVelocity",jr],KPEV:["Visibility",jr],KP2S:["Speed",jr],KP2R:["Variation",jr],KP2L:["Latitude",jr],KP2G:["Gravity",jr],KP2E:["EmissionRate",jr],KP2N:["Width",jr],KP2W:["Length",jr],KP2V:["Visibility",jr],KPPA:["Alpha",jr],KPPC:["Color",Xr],KPPE:["EmissionRate",jr],KPPL:["LifeSpan",jr],KPPS:["Speed",jr],KPPV:["Visibility",jr],KRHA:["HeightAbove",jr],KRHB:["HeightBelow",jr],KRAL:["Alpha",jr],KRCO:["Color",Xr],KRTX:["TextureSlot",Zr],KRVS:["Visibility",jr],KCTR:["Translation",Xr],KTTR:["Translation",Xr],KCRL:["Rotation",jr]};class Wr{constructor(){this.animations=[]}readAnimations(e,t){const n=e.index+t;for(;e.index<n;){const t=e.readBinary(4),n=new Jr[t][1];n.readMdx(e,t),this.animations.push(n)}}writeAnimations(e){for(const t of this.animations)t.writeMdx(e)}*readAnimatedBlock(e){for(const t of e.readBlock())"static"===t?yield`static ${e.read()}`:yield t}readAnimation(e,t){const n=new Jr[t][1];n.readMdl(e,t),this.animations.push(n)}writeAnimation(e,t){for(const n of this.animations)if(n.name===t)return n.writeMdl(e,Jr[t][0]),!0;return!1}getByteLength(e){let t=0;for(const e of this.animations)t+=e.getByteLength();return t}}function Qr(e){return"None"===e?0:"Transparent"===e?1:"Blend"===e?2:"Additive"===e?3:"AddAlpha"===e?4:"Modulate"===e?5:"Modulate2x"===e?6:0}class ei extends Wr{constructor(){super(...arguments),this.filterMode=0,this.flags=0,this.textureId=-1,this.textureAnimationId=-1,this.coordId=0,this.alpha=1,this.emissiveGain=1,this.fresnelColor=new Float32Array([1,1,1]),this.fresnelOpacity=0,this.fresnelTeamColor=0}readMdx(e,t){const n=e.index,a=e.readUint32();this.filterMode=e.readUint32(),this.flags=e.readUint32(),this.textureId=e.readInt32(),this.textureAnimationId=e.readInt32(),this.coordId=e.readUint32(),this.alpha=e.readFloat32(),t>800&&(this.emissiveGain=e.readFloat32(),e.readFloat32Array(this.fresnelColor),this.fresnelOpacity=e.readFloat32(),this.fresnelTeamColor=e.readFloat32()),this.readAnimations(e,a-(e.index-n))}writeMdx(e,t){e.writeUint32(this.getByteLength(t)),e.writeUint32(this.filterMode),e.writeUint32(this.flags),e.writeInt32(this.textureId),e.writeInt32(this.textureAnimationId),e.writeUint32(this.coordId),e.writeFloat32(this.alpha),t>800&&(e.writeFloat32(this.emissiveGain),e.writeFloat32Array(this.fresnelColor),e.writeFloat32(this.fresnelOpacity),e.writeFloat32(this.fresnelTeamColor)),this.writeAnimations(e)}readMdl(e){for(const t of super.readAnimatedBlock(e))if("FilterMode"===t)this.filterMode=Qr(e.read());else if("Unshaded"===t)this.flags|=1;else if("SphereEnvMap"===t)this.flags|=2;else if("TwoSided"===t)this.flags|=16;else if("Unfogged"===t)this.flags|=32;else if("NoDepthTest"===t)this.flags|=64;else if("NoDepthSet"===t)this.flags|=128;else if("Unlit"===t)this.flags|=256;else if("static TextureID"===t)this.textureId=e.readInt();else if("TextureID"===t)this.readAnimation(e,"KMTF");else if("TVertexAnimId"===t)this.textureAnimationId=e.readInt();else if("CoordId"===t)this.coordId=e.readInt();else if("static Alpha"===t)this.alpha=e.readFloat();else if("Alpha"===t)this.readAnimation(e,"KMTA");else if("static EmissiveGain"===t)this.emissiveGain=e.readFloat();else if("EmissiveGain"===t)this.readAnimation(e,"KMTE");else if("static FresnelColor"===t)e.readVector(this.fresnelColor);else if("FresnelColor"===t)this.readAnimation(e,"KFC3");else if("static FresnelOpacity"===t)this.fresnelOpacity=e.readFloat();else if("FresnelOpacity"===t)this.readAnimation(e,"KFCA");else if("static FresnelTeamColor"===t)this.fresnelTeamColor=e.readFloat();else{if("FresnelTeamColor"!==t)throw new Error(`Unknown token in Layer: "${t}"`);this.readAnimation(e,"KFTC")}}writeMdl(e,t){var n;e.startBlock("Layer"),e.writeFlagAttrib("FilterMode",0===(n=this.filterMode)?"None":1===n?"Transparent":2===n?"Blend":3===n?"Additive":4===n?"AddAlpha":5===n?"Modulate":6===n?"Modulate2x":"None"),1&this.flags&&e.writeFlag("Unshaded"),2&this.flags&&e.writeFlag("SphereEnvMap"),16&this.flags&&e.writeFlag("TwoSided"),32&this.flags&&e.writeFlag("Unfogged"),64&this.flags&&e.writeFlag("NoDepthTest"),128&this.flags&&e.writeFlag("NoDepthSet"),t>800&&256&this.flags&&e.writeFlag("Unlit"),this.writeAnimation(e,"KMTF")||e.writeNumberAttrib("static TextureID",this.textureId),-1!==this.textureAnimationId&&e.writeNumberAttrib("TVertexAnimId",this.textureAnimationId),0!==this.coordId&&e.writeNumberAttrib("CoordId",this.coordId),this.writeAnimation(e,"KMTA")||1===this.alpha||e.writeNumberAttrib("static Alpha",this.alpha),t>800&&(this.writeAnimation(e,"KMTE")||1===this.emissiveGain||e.writeNumberAttrib("static EmissiveGain",this.emissiveGain),this.writeAnimation(e,"KFC3")||1===this.fresnelColor[0]&&1===this.fresnelColor[1]&&1===this.fresnelColor[2]||e.writeVectorAttrib("static FresnelColor",this.fresnelColor),this.writeAnimation(e,"KFCA")||0===this.fresnelOpacity||e.writeNumberAttrib("static FresnelOpacity",this.fresnelOpacity),this.writeAnimation(e,"KFTC")||0===this.fresnelTeamColor||e.writeNumberAttrib("static FresnelTeamColor",this.fresnelTeamColor)),e.endBlock()}getByteLength(e){let t=28+super.getByteLength();return e>800&&(t+=24),t}}class ti{constructor(){this.priorityPlane=0,this.flags=0,this.shader="",this.layers=[]}readMdx(e,t){e.readUint32(),this.priorityPlane=e.readInt32(),this.flags=e.readUint32(),t>800&&(this.shader=e.read(80)),e.skip(4);for(let n=0,a=e.readUint32();n<a;n++){const n=new ei;n.readMdx(e,t),this.layers.push(n)}}writeMdx(e,t){e.writeUint32(this.getByteLength(t)),e.writeInt32(this.priorityPlane),e.writeUint32(this.flags),t>800&&e.skip(80-e.write(this.shader)),e.writeBinary("LAYS"),e.writeUint32(this.layers.length);for(const n of this.layers)n.writeMdx(e,t)}readMdl(e){for(const t of e.readBlock())if("ConstantColor"===t)this.flags|=1;else if("TwoSided"===t)this.flags|=2;else if("SortPrimsNearZ"===t)this.flags|=8;else if("SortPrimsFarZ"===t)this.flags|=16;else if("FullResolution"===t)this.flags|=32;else if("PriorityPlane"===t)this.priorityPlane=e.readInt();else if("Shader"===t)this.shader=e.read();else{if("Layer"!==t)throw new Error(`Unknown token in Material: "${t}"`);{const t=new ei;t.readMdl(e),this.layers.push(t)}}}writeMdl(e,t){e.startBlock("Material"),1&this.flags&&e.writeFlag("ConstantColor"),t>800&&2&this.flags&&e.writeFlag("TwoSided"),8&this.flags&&e.writeFlag("SortPrimsNearZ"),16&this.flags&&e.writeFlag("SortPrimsFarZ"),32&this.flags&&e.writeFlag("FullResolution"),0!==this.priorityPlane&&e.writeNumberAttrib("PriorityPlane",this.priorityPlane),t>800&&e.writeStringAttrib("Shader",this.shader);for(const n of this.layers)n.writeMdl(e,t);e.endBlock()}getByteLength(e){let t=20;e>800&&(t+=80);for(const n of this.layers)t+=n.getByteLength(e);return t}}class ni{constructor(){this.replaceableId=0,this.path="",this.wrapMode=0}readMdx(e){this.replaceableId=e.readUint32(),this.path=e.read(260),this.wrapMode=e.readUint32()}writeMdx(e){e.writeUint32(this.replaceableId),e.skip(260-e.write(this.path)),e.writeUint32(this.wrapMode)}readMdl(e){for(const t of e.readBlock())if("Image"===t)this.path=e.read();else if("ReplaceableId"===t)this.replaceableId=e.readInt();else if("WrapWidth"===t)this.wrapMode|=1;else{if("WrapHeight"!==t)throw new Error(`Unknown token in Texture: "${t}"`);this.wrapMode|=2}}writeMdl(e){e.startBlock("Bitmap"),this.path.length&&e.writeStringAttrib("Image",this.path),0!==this.replaceableId&&e.writeNumberAttrib("ReplaceableId",this.replaceableId),1&this.wrapMode&&e.writeFlag("WrapWidth"),2&this.wrapMode&&e.writeFlag("WrapHeight"),e.endBlock()}}class ai extends Wr{readMdx(e){const t=e.readUint32();this.readAnimations(e,t-4)}writeMdx(e){e.writeUint32(this.getByteLength()),this.writeAnimations(e)}readMdl(e){for(const t of e.readBlock())if("Translation"===t)this.readAnimation(e,"KTAT");else if("Rotation"===t)this.readAnimation(e,"KTAR");else{if("Scaling"!==t)throw new Error(`Unknown token in TextureAnimation: "${t}"`);this.readAnimation(e,"KTAS")}}writeMdl(e){e.startBlock("TVertexAnim "),this.writeAnimation(e,"KTAT"),this.writeAnimation(e,"KTAR"),this.writeAnimation(e,"KTAS"),e.endBlock()}getByteLength(){return 4+super.getByteLength()}}class ri{constructor(){this.vertices=new Float32Array(0),this.normals=new Float32Array(0),this.faceTypeGroups=new Uint32Array(0),this.faceGroups=new Uint32Array(0),this.faces=new Uint16Array(0),this.vertexGroups=new Uint8Array(0),this.matrixGroups=new Uint32Array(0),this.matrixIndices=new Uint32Array(0),this.materialId=0,this.selectionGroup=0,this.selectionFlags=0,this.lod=-1,this.lodName="",this.extent=new Kr,this.sequenceExtents=[],this.tangents=new Float32Array(0),this.skin=new Uint8Array(0),this.uvSets=[]}readMdx(e,t){e.readUint32(),e.skip(4),this.vertices=e.readFloat32Array(3*e.readUint32()),e.skip(4),this.normals=e.readFloat32Array(3*e.readUint32()),e.skip(4),this.faceTypeGroups=e.readUint32Array(e.readUint32()),e.skip(4),this.faceGroups=e.readUint32Array(e.readUint32()),e.skip(4),this.faces=e.readUint16Array(e.readUint32()),e.skip(4),this.vertexGroups=e.readUint8Array(e.readUint32()),e.skip(4),this.matrixGroups=e.readUint32Array(e.readUint32()),e.skip(4),this.matrixIndices=e.readUint32Array(e.readUint32()),this.materialId=e.readUint32(),this.selectionGroup=e.readUint32(),this.selectionFlags=e.readUint32(),t>800&&(this.lod=e.readInt32(),this.lodName=e.read(80)),this.extent.readMdx(e);for(let t=0,n=e.readUint32();t<n;t++){const t=new Kr;t.readMdx(e),this.sequenceExtents.push(t)}t>800&&("TANG"===e.readBinary(4)?this.tangents=e.readFloat32Array(4*e.readUint32()):e.skip(-4),"SKIN"===e.readBinary(4)?this.skin=e.readUint8Array(e.readUint32()):e.skip(-4)),e.skip(4);for(let t=0,n=e.readUint32();t<n;t++)e.skip(4),this.uvSets.push(e.readFloat32Array(2*e.readUint32()))}writeMdx(e,t){e.writeUint32(this.getByteLength(t)),e.writeBinary("VRTX"),e.writeUint32(this.vertices.length/3),e.writeFloat32Array(this.vertices),e.writeBinary("NRMS"),e.writeUint32(this.normals.length/3),e.writeFloat32Array(this.normals),e.writeBinary("PTYP"),e.writeUint32(this.faceTypeGroups.length),e.writeUint32Array(this.faceTypeGroups),e.writeBinary("PCNT"),e.writeUint32(this.faceGroups.length),e.writeUint32Array(this.faceGroups),e.writeBinary("PVTX"),e.writeUint32(this.faces.length),e.writeUint16Array(this.faces),e.writeBinary("GNDX"),e.writeUint32(this.vertexGroups.length),e.writeUint8Array(this.vertexGroups),e.writeBinary("MTGC"),e.writeUint32(this.matrixGroups.length),e.writeUint32Array(this.matrixGroups),e.writeBinary("MATS"),e.writeUint32(this.matrixIndices.length),e.writeUint32Array(this.matrixIndices),e.writeUint32(this.materialId),e.writeUint32(this.selectionGroup),e.writeUint32(this.selectionFlags),t>800&&(e.writeInt32(this.lod),e.skip(80-e.write(this.lodName))),this.extent.writeMdx(e),e.writeUint32(this.sequenceExtents.length);for(const t of this.sequenceExtents)t.writeMdx(e);t>800&&(this.tangents.length&&(e.writeBinary("TANG"),e.writeUint32(this.tangents.length/4),e.writeFloat32Array(this.tangents)),this.skin.length&&(e.writeBinary("SKIN"),e.writeUint32(this.skin.length),e.writeUint8Array(this.skin))),e.writeBinary("UVAS"),e.writeUint32(this.uvSets.length);for(const t of this.uvSets)e.writeBinary("UVBS"),e.writeUint32(t.length/2),e.writeFloat32Array(t)}readMdl(e){for(let t of e.readBlock())if("Vertices"===t)this.vertices=e.readVectorsBlock(new Float32Array(3*e.readInt()),3);else if("Normals"===t)this.normals=e.readVectorsBlock(new Float32Array(3*e.readInt()),3);else if("TVertices"===t)this.uvSets.push(e.readVectorsBlock(new Float32Array(2*e.readInt()),2));else if("VertexGroup"===t){const t=[];for(const n of e.readBlock())t.push(parseInt(n));this.vertexGroups=new Uint8Array(t)}else if("Tangents"===t)this.tangents=e.readVectorsBlock(new Float32Array(4*e.readInt()),4);else if("SkinWeights"===t)this.skin=e.readVector(new Uint8Array(8*e.readInt()));else if("Faces"===t){this.faceTypeGroups=new Uint32Array([4]);const t=e.readInt(),n=e.readInt();e.read(),e.read(),this.faces=e.readVectorsBlock(new Uint16Array(n),n/t),this.faceGroups=new Uint32Array([n]),e.read()}else if("Groups"===t){const t=[],n=[];e.readInt(),e.readInt();for(const a of e.readBlock()){let a=0;for(const n of e.readBlock())t.push(parseInt(n)),a+=1;n.push(a)}this.matrixIndices=new Uint32Array(t),this.matrixGroups=new Uint32Array(n)}else if("MinimumExtent"===t)e.readVector(this.extent.min);else if("MaximumExtent"===t)e.readVector(this.extent.max);else if("BoundsRadius"===t)this.extent.boundsRadius=e.readFloat();else if("Anim"===t){const n=new Kr;for(t of e.readBlock())"MinimumExtent"===t?e.readVector(n.min):"MaximumExtent"===t?e.readVector(n.max):"BoundsRadius"===t&&(n.boundsRadius=e.readFloat());this.sequenceExtents.push(n)}else if("MaterialID"===t)this.materialId=e.readInt();else if("SelectionGroup"===t)this.selectionGroup=e.readInt();else if("Unselectable"===t)this.selectionFlags=4;else if("LevelOfDetail"===t)this.lod=e.readInt();else{if("Name"!==t)throw new Error(`Unknown token in Geoset: "${t}"`);this.lodName=e.read()}}writeMdl(e,t){e.startBlock("Geoset"),e.writeVectorArrayBlock("Vertices",this.vertices,3),e.writeVectorArrayBlock("Normals",this.normals,3);for(const t of this.uvSets)e.writeVectorArrayBlock("TVertices",t,2);if(t>800&&this.tangents.length&&e.writeVectorArrayBlock("Tangents",this.tangents,4),this.vertexGroups.length){e.startBlock("VertexGroup");for(let t=0,n=this.vertexGroups.length;t<n;t++)e.writeLine(`${this.vertexGroups[t]},`);e.endBlock()}if(t>800&&this.skin.length){e.startBlock("SkinWeights",this.skin.length/8);for(let t=0,n=this.skin.length;t<n;t+=8)e.writeLine(`${this.skin.subarray(t,t+8).join(", ")},`);e.endBlock()}e.startBlock("Faces",1,this.faces.length),e.startBlock("Triangles"),e.writeVector(this.faces),e.endBlock(),e.endBlock(),e.startBlock("Groups",this.matrixGroups.length,this.matrixIndices.length);let n=0;for(const t of this.matrixGroups)e.writeVectorAttrib("Matrices",this.matrixIndices.subarray(n,n+t)),n+=t;e.endBlock(),this.extent.writeMdl(e);for(const t of this.sequenceExtents)e.startBlock("Anim"),t.writeMdl(e),e.endBlock();e.writeNumberAttrib("MaterialID",this.materialId),e.writeNumberAttrib("SelectionGroup",this.selectionGroup),4===this.selectionFlags&&e.writeFlag("Unselectable"),t>800&&(e.writeNumberAttrib("LevelOfDetail",this.lod),this.lodName.length&&e.writeStringAttrib("Name",this.lodName)),e.endBlock()}getByteLength(e){let t=120+this.vertices.byteLength+this.normals.byteLength+this.faceTypeGroups.byteLength+this.faceGroups.byteLength+this.faces.byteLength+this.vertexGroups.byteLength+this.matrixGroups.byteLength+this.matrixIndices.byteLength+28*this.sequenceExtents.length;e>800&&(t+=84,this.tangents.length&&(t+=8+this.tangents.byteLength),this.skin.length&&(t+=8+this.skin.byteLength));for(const e of this.uvSets)t+=8+e.byteLength;return t}}class ii extends Wr{constructor(){super(...arguments),this.alpha=1,this.flags=0,this.color=new Float32Array([1,1,1]),this.geosetId=-1}readMdx(e){const t=e.readUint32();this.alpha=e.readFloat32(),this.flags=e.readUint32(),e.readFloat32Array(this.color),this.geosetId=e.readInt32(),this.readAnimations(e,t-28)}writeMdx(e){e.writeUint32(this.getByteLength()),e.writeFloat32(this.alpha),e.writeUint32(this.flags),e.writeFloat32Array(this.color),e.writeInt32(this.geosetId),this.writeAnimations(e)}readMdl(e){for(const t of super.readAnimatedBlock(e))if("DropShadow"===t)this.flags|=1;else if("static Alpha"===t)this.alpha=e.readFloat();else if("Alpha"===t)this.readAnimation(e,"KGAO");else if("static Color"===t)this.flags|=2,e.readColor(this.color);else if("Color"===t)this.flags|=2,this.readAnimation(e,"KGAC");else{if("GeosetId"!==t)throw new Error(`Unknown token in GeosetAnimation: "${t}"`);this.geosetId=e.readInt()}}writeMdl(e){e.startBlock("GeosetAnim"),1&this.flags&&e.writeFlag("DropShadow"),this.writeAnimation(e,"KGAO")||e.writeNumberAttrib("static Alpha",this.alpha),2&this.flags&&(this.writeAnimation(e,"KGAC")||1===this.color[0]&&1===this.color[1]&&1===this.color[2]||e.writeColor("static Color ",this.color)),e.writeNumberAttrib("GeosetId",this.geosetId),e.endBlock()}getByteLength(){return 28+super.getByteLength()}}class si extends Wr{constructor(e=0){super(),this.name="",this.objectId=-1,this.parentId=-1,this.flags=e}readMdx(e){const t=e.readUint32();this.name=e.read(80),this.objectId=e.readInt32(),this.parentId=e.readInt32(),this.flags=e.readUint32(),this.readAnimations(e,t-96)}writeMdx(e){e.writeUint32(this.getGenericByteLength()),e.skip(80-e.write(this.name)),e.writeInt32(this.objectId),e.writeInt32(this.parentId),e.writeUint32(this.flags);for(const t of this.eachAnimation(!0))t.writeMdx(e)}writeNonGenericAnimationChunks(e){for(const t of this.eachAnimation(!1))t.writeMdx(e)}*readGenericBlock(e){this.name=e.read();for(let t of this.readAnimatedBlock(e))if("ObjectId"===t)this.objectId=e.readInt();else if("Parent"===t)this.parentId=e.readInt();else if("BillboardedLockZ"===t)this.flags|=64;else if("BillboardedLockY"===t)this.flags|=32;else if("BillboardedLockX"===t)this.flags|=16;else if("Billboarded"===t)this.flags|=8;else if("CameraAnchored"===t)this.flags|=128;else if("DontInherit"===t)for(t of e.readBlock())"Rotation"===t?this.flags|=2:"Translation"===t?this.flags|=1:"Scaling"===t&&(this.flags|=4);else"Translation"===t?this.readAnimation(e,"KGTR"):"Rotation"===t?this.readAnimation(e,"KGRT"):"Scaling"===t?this.readAnimation(e,"KGSC"):yield t}writeGenericHeader(e){e.writeNumberAttrib("ObjectId",this.objectId),-1!==this.parentId&&e.writeNumberAttrib("Parent",this.parentId),64&this.flags&&e.writeFlag("BillboardedLockZ"),32&this.flags&&e.writeFlag("BillboardedLockY"),16&this.flags&&e.writeFlag("BillboardedLockX"),8&this.flags&&e.writeFlag("Billboarded"),128&this.flags&&e.writeFlag("CameraAnchored"),2&this.flags&&e.writeFlag("DontInherit { Rotation }"),1&this.flags&&e.writeFlag("DontInherit { Translation }"),4&this.flags&&e.writeFlag("DontInherit { Scaling }")}writeGenericAnimations(e){this.writeAnimation(e,"KGTR"),this.writeAnimation(e,"KGRT"),this.writeAnimation(e,"KGSC")}*eachAnimation(e){for(const t of this.animations){const n=t.name,a="KGTR"===n||"KGRT"===n||"KGSC"===n;(e&&a||!e&&!a)&&(yield t)}}getGenericByteLength(){let e=96;for(const t of this.eachAnimation(!0))e+=t.getByteLength();return e}getByteLength(){return 96+super.getByteLength()}}class li extends si{constructor(){super(256),this.geosetId=-1,this.geosetAnimationId=-1}readMdx(e){super.readMdx(e),this.geosetId=e.readInt32(),this.geosetAnimationId=e.readInt32()}writeMdx(e){super.writeMdx(e),e.writeInt32(this.geosetId),e.writeInt32(this.geosetAnimationId)}readMdl(e){for(let t of super.readGenericBlock(e))if("GeosetId"===t)t=e.read(),this.geosetId="Multiple"===t?-1:parseInt(t);else{if("GeosetAnimId"!==t)throw new Error(`Unknown token in Bone ${this.name}: "${t}"`);t=e.read(),this.geosetAnimationId="None"===t?-1:parseInt(t)}}writeMdl(e){e.startObjectBlock("Bone",this.name),this.writeGenericHeader(e),-1===this.geosetId?e.writeFlagAttrib("GeosetId","Multiple"):e.writeNumberAttrib("GeosetId",this.geosetId),-1===this.geosetAnimationId?e.writeFlagAttrib("GeosetAnimId","None"):e.writeNumberAttrib("GeosetAnimId",this.geosetAnimationId),this.writeGenericAnimations(e),e.endBlock()}getByteLength(){return 8+super.getByteLength()}}class oi extends si{constructor(){super(512),this.type=-1,this.attenuation=new Float32Array(2),this.color=new Float32Array(3),this.intensity=0,this.ambientColor=new Float32Array(3),this.ambientIntensity=0}readMdx(e){const t=e.index,n=e.readUint32();super.readMdx(e),this.type=e.readUint32(),e.readFloat32Array(this.attenuation),e.readFloat32Array(this.color),this.intensity=e.readFloat32(),e.readFloat32Array(this.ambientColor),this.ambientIntensity=e.readFloat32(),this.readAnimations(e,n-(e.index-t))}writeMdx(e){e.writeUint32(this.getByteLength()),super.writeMdx(e),e.writeUint32(this.type),e.writeFloat32Array(this.attenuation),e.writeFloat32Array(this.color),e.writeFloat32(this.intensity),e.writeFloat32Array(this.ambientColor),e.writeFloat32(this.ambientIntensity),this.writeNonGenericAnimationChunks(e)}readMdl(e){for(const t of super.readGenericBlock(e))if("Omnidirectional"===t)this.type=0;else if("Directional"===t)this.type=1;else if("Ambient"===t)this.type=2;else if("static AttenuationStart"===t)this.attenuation[0]=e.readFloat();else if("AttenuationStart"===t)this.readAnimation(e,"KLAS");else if("static AttenuationEnd"===t)this.attenuation[1]=e.readFloat();else if("AttenuationEnd"===t)this.readAnimation(e,"KLAE");else if("static Intensity"===t)this.intensity=e.readFloat();else if("Intensity"===t)this.readAnimation(e,"KLAI");else if("static Color"===t)e.readColor(this.color);else if("Color"===t)this.readAnimation(e,"KLAC");else if("static AmbIntensity"===t)this.ambientIntensity=e.readFloat();else if("AmbIntensity"===t)this.readAnimation(e,"KLBI");else if("static AmbColor"===t)e.readColor(this.ambientColor);else if("AmbColor"===t)this.readAnimation(e,"KLBC");else{if("Visibility"!==t)throw new Error(`Unknown token in Light: "${t}"`);this.readAnimation(e,"KLAV")}}writeMdl(e){e.startObjectBlock("Light",this.name),this.writeGenericHeader(e),0===this.type?e.writeFlag("Omnidirectional"):1===this.type?e.writeFlag("Directional"):2===this.type&&e.writeFlag("Ambient"),this.writeAnimation(e,"KLAS")||e.writeNumberAttrib("static AttenuationStart",this.attenuation[0]),this.writeAnimation(e,"KLAE")||e.writeNumberAttrib("static AttenuationEnd",this.attenuation[1]),this.writeAnimation(e,"KLAI")||e.writeNumberAttrib("static Intensity",this.intensity),this.writeAnimation(e,"KLAC")||e.writeColor("static Color",this.color),this.writeAnimation(e,"KLBI")||e.writeNumberAttrib("static AmbIntensity",this.ambientIntensity),this.writeAnimation(e,"KLBC")||e.writeColor("static AmbColor",this.ambientColor),this.writeAnimation(e,"KLAV"),this.writeGenericAnimations(e),e.endBlock()}getByteLength(){return 48+super.getByteLength()}}class ui extends si{readMdl(e){for(const t of super.readGenericBlock(e))throw new Error(`Unknown token in Helper: "${t}"`)}writeMdl(e){e.startObjectBlock("Helper",this.name),this.writeGenericHeader(e),this.writeGenericAnimations(e),e.endBlock()}}class ci extends si{constructor(){super(2048),this.path="",this.attachmentId=0}readMdx(e){const t=e.index,n=e.readUint32();super.readMdx(e),this.path=e.read(260),this.attachmentId=e.readInt32(),this.readAnimations(e,n-(e.index-t))}writeMdx(e){e.writeUint32(this.getByteLength()),super.writeMdx(e),e.skip(260-e.write(this.path)),e.writeInt32(this.attachmentId),this.writeNonGenericAnimationChunks(e)}readMdl(e){for(const t of super.readGenericBlock(e))if("AttachmentID"===t)this.attachmentId=e.readInt();else if("Path"===t)this.path=e.read();else{if("Visibility"!==t)throw new Error(`Unknown token in Attachment ${this.name}: "${t}"`);this.readAnimation(e,"KATV")}}writeMdl(e){e.startObjectBlock("Attachment",this.name),this.writeGenericHeader(e),e.writeNumberAttrib("AttachmentID",this.attachmentId),this.path.length&&e.writeStringAttrib("Path",this.path),this.writeAnimation(e,"KATV"),this.writeGenericAnimations(e),e.endBlock()}getByteLength(){return 268+super.getByteLength()}}class di extends si{constructor(){super(4096),this.emissionRate=0,this.gravity=0,this.longitude=0,this.latitude=0,this.path="",this.lifeSpan=0,this.speed=0}readMdx(e){const t=e.index,n=e.readUint32();super.readMdx(e),this.emissionRate=e.readFloat32(),this.gravity=e.readFloat32(),this.longitude=e.readFloat32(),this.latitude=e.readFloat32(),this.path=e.read(260),this.lifeSpan=e.readFloat32(),this.speed=e.readFloat32(),this.readAnimations(e,n-(e.index-t))}writeMdx(e){e.writeUint32(this.getByteLength()),super.writeMdx(e),e.writeFloat32(this.emissionRate),e.writeFloat32(this.gravity),e.writeFloat32(this.longitude),e.writeFloat32(this.latitude),e.skip(260-e.write(this.path)),e.writeFloat32(this.lifeSpan),e.writeFloat32(this.speed),this.writeNonGenericAnimationChunks(e)}readMdl(e){for(let t of super.readGenericBlock(e))if("EmitterUsesMDL"===t)this.flags|=32768;else if("EmitterUsesTGA"===t)this.flags|=65536;else if("static EmissionRate"===t)this.emissionRate=e.readFloat();else if("EmissionRate"===t)this.readAnimation(e,"KPEE");else if("static Gravity"===t)this.gravity=e.readFloat();else if("Gravity"===t)this.readAnimation(e,"KPEG");else if("static Longitude"===t)this.longitude=e.readFloat();else if("Longitude"===t)this.readAnimation(e,"KPLN");else if("static Latitude"===t)this.latitude=e.readFloat();else if("Latitude"===t)this.readAnimation(e,"KPLT");else if("Visibility"===t)this.readAnimation(e,"KPEV");else{if("Particle"!==t)throw new Error(`Unknown token in ParticleEmitter: "${t}"`);for(t of this.readAnimatedBlock(e))"static LifeSpan"===t?this.lifeSpan=e.readFloat():"LifeSpan"===t?this.readAnimation(e,"KPEL"):"static InitVelocity"===t?this.speed=e.readFloat():"InitVelocity"===t?this.readAnimation(e,"KPES"):"Path"===t&&(this.path=e.read())}}writeMdl(e){e.startObjectBlock("ParticleEmitter",this.name),this.writeGenericHeader(e),32768&this.flags&&e.writeFlag("EmitterUsesMDL"),65536&this.flags&&e.writeFlag("EmitterUsesTGA"),this.writeAnimation(e,"KPEE")||e.writeNumberAttrib("static EmissionRate",this.emissionRate),this.writeAnimation(e,"KPEG")||e.writeNumberAttrib("static Gravity",this.gravity),this.writeAnimation(e,"KPLN")||e.writeNumberAttrib("static Longitude",this.longitude),this.writeAnimation(e,"KPLT")||e.writeNumberAttrib("static Latitude",this.latitude),this.writeAnimation(e,"KPEV"),e.startBlock("Particle"),this.writeAnimation(e,"KPEL")||e.writeNumberAttrib("static LifeSpan",this.lifeSpan),this.writeAnimation(e,"KPES")||e.writeNumberAttrib("static InitVelocity",this.speed),(32768&this.flags||65536&this.flags)&&e.writeStringAttrib("Path",this.path),e.endBlock(),this.writeGenericAnimations(e),e.endBlock()}getByteLength(){return 288+super.getByteLength()}}class hi extends si{constructor(){super(...arguments),this.speed=0,this.variation=0,this.latitude=0,this.gravity=0,this.lifeSpan=0,this.emissionRate=0,this.width=0,this.length=0,this.filterMode=0,this.rows=0,this.columns=0,this.headOrTail=0,this.tailLength=0,this.timeMiddle=0,this.segmentColors=[new Float32Array(3),new Float32Array(3),new Float32Array(3)],this.segmentAlphas=new Uint8Array(3),this.segmentScaling=new Float32Array(3),this.headIntervals=[new Uint32Array(3),new Uint32Array(3)],this.tailIntervals=[new Uint32Array(3),new Uint32Array(3)],this.textureId=-1,this.squirt=0,this.priorityPlane=0,this.replaceableId=0}readMdx(e){const t=e.index,n=e.readUint32();super.readMdx(e),this.speed=e.readFloat32(),this.variation=e.readFloat32(),this.latitude=e.readFloat32(),this.gravity=e.readFloat32(),this.lifeSpan=e.readFloat32(),this.emissionRate=e.readFloat32(),this.width=e.readFloat32(),this.length=e.readFloat32(),this.filterMode=e.readUint32(),this.rows=e.readUint32(),this.columns=e.readUint32(),this.headOrTail=e.readUint32(),this.tailLength=e.readFloat32(),this.timeMiddle=e.readFloat32(),e.readFloat32Array(this.segmentColors[0]),e.readFloat32Array(this.segmentColors[1]),e.readFloat32Array(this.segmentColors[2]),e.readUint8Array(this.segmentAlphas),e.readFloat32Array(this.segmentScaling),e.readUint32Array(this.headIntervals[0]),e.readUint32Array(this.headIntervals[1]),e.readUint32Array(this.tailIntervals[0]),e.readUint32Array(this.tailIntervals[1]),this.textureId=e.readInt32(),this.squirt=e.readUint32(),this.priorityPlane=e.readInt32(),this.replaceableId=e.readUint32(),this.readAnimations(e,n-(e.index-t))}writeMdx(e){e.writeUint32(this.getByteLength()),super.writeMdx(e),e.writeFloat32(this.speed),e.writeFloat32(this.variation),e.writeFloat32(this.latitude),e.writeFloat32(this.gravity),e.writeFloat32(this.lifeSpan),e.writeFloat32(this.emissionRate),e.writeFloat32(this.width),e.writeFloat32(this.length),e.writeUint32(this.filterMode),e.writeUint32(this.rows),e.writeUint32(this.columns),e.writeUint32(this.headOrTail),e.writeFloat32(this.tailLength),e.writeFloat32(this.timeMiddle),e.writeFloat32Array(this.segmentColors[0]),e.writeFloat32Array(this.segmentColors[1]),e.writeFloat32Array(this.segmentColors[2]),e.writeUint8Array(this.segmentAlphas),e.writeFloat32Array(this.segmentScaling),e.writeUint32Array(this.headIntervals[0]),e.writeUint32Array(this.headIntervals[1]),e.writeUint32Array(this.tailIntervals[0]),e.writeUint32Array(this.tailIntervals[1]),e.writeInt32(this.textureId),e.writeUint32(this.squirt),e.writeInt32(this.priorityPlane),e.writeUint32(this.replaceableId),this.writeNonGenericAnimationChunks(e)}readMdl(e){for(const t of super.readGenericBlock(e))if("SortPrimsFarZ"===t)this.flags|=65536;else if("Unshaded"===t)this.flags|=32768;else if("LineEmitter"===t)this.flags|=131072;else if("Unfogged"===t)this.flags|=262144;else if("ModelSpace"===t)this.flags|=524288;else if("XYQuad"===t)this.flags|=1048576;else if("static Speed"===t)this.speed=e.readFloat();else if("Speed"===t)this.readAnimation(e,"KP2S");else if("static Variation"===t)this.variation=e.readFloat();else if("Variation"===t)this.readAnimation(e,"KP2R");else if("static Latitude"===t)this.latitude=e.readFloat();else if("Latitude"===t)this.readAnimation(e,"KP2L");else if("static Gravity"===t)this.gravity=e.readFloat();else if("Gravity"===t)this.readAnimation(e,"KP2G");else if("Visibility"===t)this.readAnimation(e,"KP2V");else if("Squirt"===t)this.squirt=1;else if("LifeSpan"===t)this.lifeSpan=e.readFloat();else if("static EmissionRate"===t)this.emissionRate=e.readFloat();else if("EmissionRate"===t)this.readAnimation(e,"KP2E");else if("static Width"===t)this.width=e.readFloat();else if("Width"===t)this.readAnimation(e,"KP2N");else if("static Length"===t)this.length=e.readFloat();else if("Length"===t)this.readAnimation(e,"KP2W");else if("Blend"===t)this.filterMode=0;else if("Additive"===t)this.filterMode=1;else if("Modulate"===t)this.filterMode=2;else if("Modulate2x"===t)this.filterMode=3;else if("AlphaKey"===t)this.filterMode=4;else if("Rows"===t)this.rows=e.readInt();else if("Columns"===t)this.columns=e.readInt();else if("Head"===t)this.headOrTail=0;else if("Tail"===t)this.headOrTail=1;else if("Both"===t)this.headOrTail=2;else if("TailLength"===t)this.tailLength=e.readFloat();else if("Time"===t)this.timeMiddle=e.readFloat();else if("SegmentColor"===t){e.read();for(let t=0;t<3;t++)e.read(),e.readColor(this.segmentColors[t]);e.read()}else if("Alpha"===t)e.readVector(this.segmentAlphas);else if("ParticleScaling"===t)e.readVector(this.segmentScaling);else if("LifeSpanUVAnim"===t)e.readVector(this.headIntervals[0]);else if("DecayUVAnim"===t)e.readVector(this.headIntervals[1]);else if("TailUVAnim"===t)e.readVector(this.tailIntervals[0]);else if("TailDecayUVAnim"===t)e.readVector(this.tailIntervals[1]);else if("TextureID"===t)this.textureId=e.readInt();else if("ReplaceableId"===t)this.replaceableId=e.readInt();else{if("PriorityPlane"!==t)throw new Error(`Unknown token in ParticleEmitter2: "${t}"`);this.priorityPlane=e.readInt()}}writeMdl(e){e.startObjectBlock("ParticleEmitter2",this.name),this.writeGenericHeader(e),65536&this.flags&&e.writeFlag("SortPrimsFarZ"),32768&this.flags&&e.writeFlag("Unshaded"),131072&this.flags&&e.writeFlag("LineEmitter"),262144&this.flags&&e.writeFlag("Unfogged"),524288&this.flags&&e.writeFlag("ModelSpace"),1048576&this.flags&&e.writeFlag("XYQuad"),this.writeAnimation(e,"KP2S")||e.writeNumberAttrib("static Speed",this.speed),this.writeAnimation(e,"KP2R")||e.writeNumberAttrib("static Variation",this.variation),this.writeAnimation(e,"KP2L")||e.writeNumberAttrib("static Latitude",this.latitude),this.writeAnimation(e,"KP2G")||e.writeNumberAttrib("static Gravity",this.gravity),this.writeAnimation(e,"KP2V"),this.squirt&&e.writeFlag("Squirt"),e.writeNumberAttrib("LifeSpan",this.lifeSpan),this.writeAnimation(e,"KP2E")||e.writeNumberAttrib("static EmissionRate",this.emissionRate),this.writeAnimation(e,"KP2N")||e.writeNumberAttrib("static Width",this.width),this.writeAnimation(e,"KP2W")||e.writeNumberAttrib("static Length",this.length),0===this.filterMode?e.writeFlag("Blend"):1===this.filterMode?e.writeFlag("Additive"):2===this.filterMode?e.writeFlag("Modulate"):3===this.filterMode?e.writeFlag("Modulate2x"):4===this.filterMode&&e.writeFlag("AlphaKey"),e.writeNumberAttrib("Rows",this.rows),e.writeNumberAttrib("Columns",this.columns),0===this.headOrTail?e.writeFlag("Head"):1===this.headOrTail?e.writeFlag("Tail"):2===this.headOrTail&&e.writeFlag("Both"),e.writeNumberAttrib("TailLength",this.tailLength),e.writeNumberAttrib("Time",this.timeMiddle),e.startBlock("SegmentColor"),e.writeColor("Color",this.segmentColors[0]),e.writeColor("Color",this.segmentColors[1]),e.writeColor("Color",this.segmentColors[2]),e.endBlockComma(),e.writeVectorAttrib("Alpha",this.segmentAlphas),e.writeVectorAttrib("ParticleScaling",this.segmentScaling),e.writeVectorAttrib("LifeSpanUVAnim",this.headIntervals[0]),e.writeVectorAttrib("DecayUVAnim",this.headIntervals[1]),e.writeVectorAttrib("TailUVAnim",this.tailIntervals[0]),e.writeVectorAttrib("TailDecayUVAnim",this.tailIntervals[1]),e.writeNumberAttrib("TextureID",this.textureId),0!==this.replaceableId&&e.writeNumberAttrib("ReplaceableId",this.replaceableId),0!==this.priorityPlane&&e.writeNumberAttrib("PriorityPlane",this.priorityPlane),this.writeGenericAnimations(e),e.endBlock()}getByteLength(){return 175+super.getByteLength()}}class fi extends si{constructor(){super(...arguments),this.lifeSpan=0,this.emissionRate=0,this.speed=0,this.color=new Float32Array(3),this.alpha=1,this.replaceableId=0,this.path="",this.animationVisiblityGuide=""}readMdx(e){const t=e.index,n=e.readUint32();super.readMdx(e),this.lifeSpan=e.readFloat32(),this.emissionRate=e.readFloat32(),this.speed=e.readFloat32(),e.readFloat32Array(this.color),this.alpha=e.readFloat32(),this.replaceableId=e.readUint32(),this.path=e.read(260),this.animationVisiblityGuide=e.read(260),this.readAnimations(e,n-(e.index-t))}writeMdx(e){e.writeUint32(this.getByteLength()),super.writeMdx(e),e.writeFloat32(this.lifeSpan),e.writeFloat32(this.emissionRate),e.writeFloat32(this.speed),e.writeFloat32Array(this.color),e.writeFloat32(this.alpha),e.writeUint32(this.replaceableId),e.skip(260-e.write(this.path)),e.skip(260-e.write(this.animationVisiblityGuide)),this.writeNonGenericAnimationChunks(e)}readMdl(e){for(const t of super.readGenericBlock(e))if("SortPrimsFarZ"===t)this.flags|=65536;else if("Unshaded"===t)this.flags|=32768;else if("Unfogged"===t)this.flags|=262144;else if("static LifeSpan"===t)this.lifeSpan=e.readFloat();else if("LifeSpan"===t)this.readAnimation(e,"KPPL");else if("static EmissionRate"===t)this.emissionRate=e.readFloat();else if("EmissionRate"===t)this.readAnimation(e,"KPPE");else if("static Speed"===t)this.speed=e.readFloat();else if("Speed"===t)this.readAnimation(e,"KPPS");else if("static Color"===t)e.readVector(this.color);else if("Color"===t)this.readAnimation(e,"KPPC");else if("static Alpha"===t)this.alpha=e.readFloat();else if("Alpha"===t)this.readAnimation(e,"KPPA");else if("Visibility"===t)this.readAnimation(e,"KPPV");else if("ReplaceableId"===t)this.replaceableId=e.readInt();else if("Path"===t)this.path=e.read();else{if("AnimVisibilityGuide"!==t)throw new Error(`Unknown token in ParticleEmitterPopcorn: "${t}"`);this.animationVisiblityGuide=e.read()}}writeMdl(e){e.startObjectBlock("ParticleEmitterPopcorn",this.name),this.writeGenericHeader(e),65536&this.flags&&e.writeFlag("SortPrimsFarZ"),32768&this.flags&&e.writeFlag("Unshaded"),262144&this.flags&&e.writeFlag("Unfogged"),this.writeAnimation(e,"KPPL")||e.writeNumberAttrib("static LifeSpan",this.lifeSpan),this.writeAnimation(e,"KPPE")||e.writeNumberAttrib("static EmissionRate",this.emissionRate),this.writeAnimation(e,"KPPS")||e.writeNumberAttrib("static Speed",this.speed),this.writeAnimation(e,"KPPC")||e.writeVectorAttrib("static Color",this.color),this.writeAnimation(e,"KPPA")||e.writeNumberAttrib("static Alpha",this.alpha),this.writeAnimation(e,"KPPV"),0!==this.replaceableId&&e.writeNumberAttrib("ReplaceableId",this.replaceableId),this.path.length&&e.writeStringAttrib("Path",this.path),this.animationVisiblityGuide.length&&e.writeStringAttrib("AnimVisibilityGuide",this.animationVisiblityGuide),this.writeGenericAnimations(e),e.endBlock()}getByteLength(){return 556+super.getByteLength()}}class mi extends si{constructor(){super(16384),this.heightAbove=0,this.heightBelow=0,this.alpha=0,this.color=new Float32Array(3),this.lifeSpan=0,this.textureSlot=0,this.emissionRate=0,this.rows=0,this.columns=0,this.materialId=0,this.gravity=0}readMdx(e){const t=e.index,n=e.readUint32();super.readMdx(e),this.heightAbove=e.readFloat32(),this.heightBelow=e.readFloat32(),this.alpha=e.readFloat32(),e.readFloat32Array(this.color),this.lifeSpan=e.readFloat32(),this.textureSlot=e.readUint32(),this.emissionRate=e.readUint32(),this.rows=e.readUint32(),this.columns=e.readUint32(),this.materialId=e.readInt32(),this.gravity=e.readFloat32(),this.readAnimations(e,n-(e.index-t))}writeMdx(e){e.writeUint32(this.getByteLength()),super.writeMdx(e),e.writeFloat32(this.heightAbove),e.writeFloat32(this.heightBelow),e.writeFloat32(this.alpha),e.writeFloat32Array(this.color),e.writeFloat32(this.lifeSpan),e.writeUint32(this.textureSlot),e.writeUint32(this.emissionRate),e.writeUint32(this.rows),e.writeUint32(this.columns),e.writeInt32(this.materialId),e.writeFloat32(this.gravity),this.writeNonGenericAnimationChunks(e)}readMdl(e){for(const t of super.readGenericBlock(e))if("static HeightAbove"===t)this.heightAbove=e.readFloat();else if("HeightAbove"===t)this.readAnimation(e,"KRHA");else if("static HeightBelow"===t)this.heightBelow=e.readFloat();else if("HeightBelow"===t)this.readAnimation(e,"KRHB");else if("static Alpha"===t)this.alpha=e.readFloat();else if("Alpha"===t)this.readAnimation(e,"KRAL");else if("static Color"===t)e.readColor(this.color);else if("Color"===t)this.readAnimation(e,"KRCO");else if("static TextureSlot"===t)this.textureSlot=e.readInt();else if("TextureSlot"===t)this.readAnimation(e,"KRTX");else if("Visibility"===t)this.readAnimation(e,"KRVS");else if("EmissionRate"===t)this.emissionRate=e.readInt();else if("LifeSpan"===t)this.lifeSpan=e.readFloat();else if("Gravity"===t)this.gravity=e.readFloat();else if("Rows"===t)this.rows=e.readInt();else if("Columns"===t)this.columns=e.readInt();else{if("MaterialID"!==t)throw new Error(`Unknown token in RibbonEmitter: "${t}"`);this.materialId=e.readInt()}}writeMdl(e){e.startObjectBlock("RibbonEmitter",this.name),this.writeGenericHeader(e),this.writeAnimation(e,"KRHA")||e.writeNumberAttrib("static HeightAbove",this.heightAbove),this.writeAnimation(e,"KRHB")||e.writeNumberAttrib("static HeightBelow",this.heightBelow),this.writeAnimation(e,"KRAL")||e.writeNumberAttrib("static Alpha",this.alpha),this.writeAnimation(e,"KRCO")||e.writeColor("static Color",this.color),this.writeAnimation(e,"KRTX")||e.writeNumberAttrib("static TextureSlot",this.textureSlot),this.writeAnimation(e,"KRVS"),e.writeNumberAttrib("EmissionRate",this.emissionRate),e.writeNumberAttrib("LifeSpan",this.lifeSpan),0!==this.gravity&&e.writeNumberAttrib("Gravity",this.gravity),e.writeNumberAttrib("Rows",this.rows),e.writeNumberAttrib("Columns",this.columns),e.writeNumberAttrib("MaterialID",this.materialId),this.writeGenericAnimations(e),e.endBlock()}getByteLength(){return 56+super.getByteLength()}}class pi extends Wr{constructor(){super(...arguments),this.name="",this.position=new Float32Array(3),this.fieldOfView=0,this.farClippingPlane=0,this.nearClippingPlane=0,this.targetPosition=new Float32Array(3)}readMdx(e){const t=e.readUint32();this.name=e.read(80),e.readFloat32Array(this.position),this.fieldOfView=e.readFloat32(),this.farClippingPlane=e.readFloat32(),this.nearClippingPlane=e.readFloat32(),e.readFloat32Array(this.targetPosition),this.readAnimations(e,t-120)}writeMdx(e){e.writeUint32(this.getByteLength()),e.skip(80-e.write(this.name)),e.writeFloat32Array(this.position),e.writeFloat32(this.fieldOfView),e.writeFloat32(this.farClippingPlane),e.writeFloat32(this.nearClippingPlane),e.writeFloat32Array(this.targetPosition),this.writeAnimations(e)}readMdl(e){this.name=e.read();for(let t of e.readBlock())if("Position"===t)e.readVector(this.position);else if("Translation"===t)this.readAnimation(e,"KCTR");else if("Rotation"===t)this.readAnimation(e,"KCRL");else if("FieldOfView"===t)this.fieldOfView=e.readFloat();else if("FarClip"===t)this.farClippingPlane=e.readFloat();else if("NearClip"===t)this.nearClippingPlane=e.readFloat();else{if("Target"!==t)throw new Error(`Unknown token in Camera ${this.name}: "${t}"`);for(t of e.readBlock())if("Position"===t)e.readVector(this.targetPosition);else{if("Translation"!==t)throw new Error(`Unknown token in Camera ${this.name}'s Target: "${t}"`);this.readAnimation(e,"KTTR")}}}writeMdl(e){e.startObjectBlock("Camera",this.name),e.writeVectorAttrib("Position",this.position),this.writeAnimation(e,"KCTR"),this.writeAnimation(e,"KCRL"),e.writeNumberAttrib("FieldOfView",this.fieldOfView),e.writeNumberAttrib("FarClip",this.farClippingPlane),e.writeNumberAttrib("NearClip",this.nearClippingPlane),e.startBlock("Target"),e.writeVectorAttrib("Position",this.targetPosition),this.writeAnimation(e,"KTTR"),e.endBlock(),e.endBlock()}getByteLength(){return 120+super.getByteLength()}}class _i extends si{constructor(){super(1024),this.globalSequenceId=-1,this.tracks=new Uint32Array(0)}readMdx(e){super.readMdx(e),e.skip(4);const t=e.readUint32();this.globalSequenceId=e.readInt32(),this.tracks=e.readUint32Array(t)}writeMdx(e){super.writeMdx(e),e.writeBinary("KEVT"),e.writeUint32(this.tracks.length),e.writeInt32(this.globalSequenceId),e.writeUint32Array(this.tracks)}readMdl(e){for(const t of super.readGenericBlock(e)){if("EventTrack"!==t)throw new Error(`Unknown token in EventObject: "${t}"`);{const t=e.readInt();this.tracks=new Uint32Array(t),e.read(),"GlobalSeqId"===e.peek()&&(e.read(),this.globalSequenceId=e.readInt());for(let n=0;n<t;n++)this.tracks[n]=e.readInt();e.read()}}}writeMdl(e){e.startObjectBlock("EventObject",this.name),this.writeGenericHeader(e),e.startBlock("EventTrack",this.tracks.length),-1!==this.globalSequenceId&&e.writeNumberAttrib("GlobalSeqId",this.globalSequenceId);for(const t of this.tracks)e.writeFlag(`${t}`);e.endBlock(),this.writeGenericAnimations(e),e.endBlock()}getByteLength(){return 12+this.tracks.byteLength+super.getByteLength()}}class gi extends si{constructor(){super(8192),this.type=0,this.vertices=[new Float32Array(3),new Float32Array(3)],this.boundsRadius=0}readMdx(e){super.readMdx(e),this.type=e.readUint32(),e.readFloat32Array(this.vertices[0]),2!==this.type&&e.readFloat32Array(this.vertices[1]),2!==this.type&&3!==this.type||(this.boundsRadius=e.readFloat32())}writeMdx(e){super.writeMdx(e),e.writeUint32(this.type),e.writeFloat32Array(this.vertices[0]),2!==this.type&&e.writeFloat32Array(this.vertices[1]),2!==this.type&&3!==this.type||e.writeFloat32(this.boundsRadius)}readMdl(e){for(const t of super.readGenericBlock(e))if("Box"===t)this.type=0;else if("Plane"===t)this.type=1;else if("Sphere"===t)this.type=2;else if("Cylinder"===t)this.type=3;else if("Vertices"===t){const t=e.readInt();e.read(),e.readVector(this.vertices[0]),2===t&&e.readVector(this.vertices[1]),e.read()}else{if("BoundsRadius"!==t)throw new Error(`Unknown token in CollisionShape: "${t}"`);this.boundsRadius=e.readFloat()}}writeMdl(e){e.startObjectBlock("CollisionShape",this.name),this.writeGenericHeader(e);let t="",n=2,a=!1;0===this.type?t="Box":1===this.type?t="Plane":2===this.type?(t="Sphere",n=1,a=!0):3===this.type&&(t="Cylinder",a=!0),e.writeFlag(t),e.startBlock("Vertices",n),e.writeVector(this.vertices[0]),2===n&&e.writeVector(this.vertices[1]),e.endBlock(),a&&e.writeNumberAttrib("BoundsRadius",this.boundsRadius),this.writeGenericAnimations(e),e.endBlock()}getByteLength(){let e=16+super.getByteLength();return 2!==this.type&&(e+=12),2!==this.type&&3!==this.type||(e+=4),e}}class bi{constructor(){this.type="",this.path=""}readMdx(e){this.type=e.read(80),this.path=e.read(260)}writeMdx(e){e.skip(80-e.write(this.type)),e.skip(260-e.write(this.path))}readMdl(e){this.type=e.read();for(const t of e.readBlock()){if("Path"!==t)throw new Error(`Unknown token in FaceEffect: "${t}"`);this.path=e.read()}}writeMdl(e){e.startObjectBlock("FaceFX",this.type),e.writeStringAttrib("Path",this.path),e.endBlock()}}class wi{constructor(e,t,n){this.tag=n,this.chunk=e.readUint8Array(new Uint8Array(t))}writeMdx(e){e.writeBinary(this.tag),e.writeUint32(this.chunk.byteLength),e.writeUint8Array(this.chunk)}getByteLength(){return 8+this.chunk.byteLength}}function vi(e){return e instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&77===e[0]&&68===e[1]&&76===e[2]&&88===e[3]}function Ai(e){return e instanceof ArrayBuffer&&(e=new Uint8Array(e)),!!(e instanceof Uint8Array&&Oa(e,"FormatVersion",0,4096))||!("string"!=typeof e||!function(e,t,n=0,a=1/0){const r=Math.max(n,0),i=Math.min(r+a,e.length);let s=0,l=t[0];for(let n=r;n<i;n++)if(e[n]===l){if(s+=1,s===t.length)return!0;l=t[s]}else s>0&&(s=0,l=t[0]);return!1}(e,"FormatVersion",0,4096))}class yi{constructor(){this.version=800,this.name="",this.animationFile="",this.extent=new Kr,this.blendTime=0,this.sequences=[],this.globalSequences=[],this.materials=[],this.textures=[],this.textureAnimations=[],this.geosets=[],this.geosetAnimations=[],this.bones=[],this.lights=[],this.helpers=[],this.attachments=[],this.pivotPoints=[],this.particleEmitters=[],this.particleEmitters2=[],this.particleEmittersPopcorn=[],this.ribbonEmitters=[],this.cameras=[],this.eventObjects=[],this.collisionShapes=[],this.faceEffects=[],this.bindPose=[],this.unknownChunks=[]}load(e){if(vi(e))this.loadMdx(e);else{if(!Ai(e))throw new Error("Not a valid MDX/MDL buffer");"string"==typeof e?this.loadMdl(e):this.loadMdl(Ma(e))}}loadMdx(e){const t=new ur(e);let n,a;for(t.skip(4);t.remaining>0;)n=t.readBinary(4),a=t.readUint32(),"VERS"===n?this.loadVersionChunk(t):"MODL"===n?this.loadModelChunk(t):"SEQS"===n?this.loadStaticObjects(this.sequences,zr,t,a/132):"GLBS"===n?this.loadGlobalSequenceChunk(t,a):"MTLS"===n?this.loadDynamicObjects(this.materials,ti,t,a):"TEXS"===n?this.loadStaticObjects(this.textures,ni,t,a/268):"TXAN"===n?this.loadDynamicObjects(this.textureAnimations,ai,t,a):"GEOS"===n?this.loadDynamicObjects(this.geosets,ri,t,a):"GEOA"===n?this.loadDynamicObjects(this.geosetAnimations,ii,t,a):"BONE"===n?this.loadDynamicObjects(this.bones,li,t,a):"LITE"===n?this.loadDynamicObjects(this.lights,oi,t,a):"HELP"===n?this.loadDynamicObjects(this.helpers,ui,t,a):"ATCH"===n?this.loadDynamicObjects(this.attachments,ci,t,a):"PIVT"===n?this.loadPivotPointChunk(t,a):"PREM"===n?this.loadDynamicObjects(this.particleEmitters,di,t,a):"PRE2"===n?this.loadDynamicObjects(this.particleEmitters2,hi,t,a):"CORN"===n?this.loadDynamicObjects(this.particleEmittersPopcorn,fi,t,a):"RIBB"===n?this.loadDynamicObjects(this.ribbonEmitters,mi,t,a):"CAMS"===n?this.loadDynamicObjects(this.cameras,pi,t,a):"EVTS"===n?this.loadDynamicObjects(this.eventObjects,_i,t,a):"CLID"===n?this.loadDynamicObjects(this.collisionShapes,gi,t,a):"FAFX"===n?this.loadStaticObjects(this.faceEffects,bi,t,a/340):"BPOS"===n?this.loadBindPoseChunk(t,a):this.unknownChunks.push(new wi(t,a,n))}loadVersionChunk(e){this.version=e.readUint32()}loadModelChunk(e){this.name=e.read(80),this.animationFile=e.read(260),this.extent.readMdx(e),this.blendTime=e.readUint32()}loadStaticObjects(e,t,n,a){for(let r=0;r<a;r++){const a=new t;a.readMdx(n),e.push(a)}}loadGlobalSequenceChunk(e,t){for(let n=0,a=t/4;n<a;n++)this.globalSequences.push(e.readUint32())}loadDynamicObjects(e,t,n,a){const r=n.index+a;for(;n.index<r;){const a=new t;a.readMdx(n,this.version),e.push(a)}}loadPivotPointChunk(e,t){for(let n=0,a=t/12;n<a;n++)this.pivotPoints.push(e.readFloat32Array(3))}loadBindPoseChunk(e,t){for(let t=0,n=e.readUint32();t<n;t++)this.bindPose[t]=e.readFloat32Array(12)}saveMdx(){const e=new ur(new ArrayBuffer(this.getByteLength()));e.writeBinary("MDLX"),this.saveVersionChunk(e),this.saveModelChunk(e),this.saveStaticObjectChunk(e,"SEQS",this.sequences,132),this.saveGlobalSequenceChunk(e),this.saveDynamicObjectChunk(e,"MTLS",this.materials),this.saveStaticObjectChunk(e,"TEXS",this.textures,268),this.saveDynamicObjectChunk(e,"TXAN",this.textureAnimations),this.saveDynamicObjectChunk(e,"GEOS",this.geosets),this.saveDynamicObjectChunk(e,"GEOA",this.geosetAnimations),this.saveDynamicObjectChunk(e,"BONE",this.bones),this.saveDynamicObjectChunk(e,"LITE",this.lights),this.saveDynamicObjectChunk(e,"HELP",this.helpers),this.saveDynamicObjectChunk(e,"ATCH",this.attachments),this.savePivotPointChunk(e),this.saveDynamicObjectChunk(e,"PREM",this.particleEmitters),this.saveDynamicObjectChunk(e,"PRE2",this.particleEmitters2),this.version>800&&this.saveDynamicObjectChunk(e,"CORN",this.particleEmittersPopcorn),this.saveDynamicObjectChunk(e,"RIBB",this.ribbonEmitters),this.saveDynamicObjectChunk(e,"CAMS",this.cameras),this.saveDynamicObjectChunk(e,"EVTS",this.eventObjects),this.saveDynamicObjectChunk(e,"CLID",this.collisionShapes),this.version>800&&(this.saveStaticObjectChunk(e,"FAFX",this.faceEffects,340),this.saveBindPoseChunk(e));for(const t of this.unknownChunks)t.writeMdx(e);return e.uint8array}saveVersionChunk(e){e.writeBinary("VERS"),e.writeUint32(4),e.writeUint32(this.version)}saveModelChunk(e){e.writeBinary("MODL"),e.writeUint32(372),e.skip(80-e.write(this.name)),e.skip(260-e.write(this.animationFile)),this.extent.writeMdx(e),e.writeUint32(this.blendTime)}saveStaticObjectChunk(e,t,n,a){if(n.length){e.writeBinary(t),e.writeUint32(n.length*a);for(const t of n)t.writeMdx(e)}}saveGlobalSequenceChunk(e){if(this.globalSequences.length){e.writeBinary("GLBS"),e.writeUint32(4*this.globalSequences.length);for(const t of this.globalSequences)e.writeUint32(t)}}saveDynamicObjectChunk(e,t,n){if(n.length){e.writeBinary(t),e.writeUint32(this.getObjectsByteLength(n));for(const t of n)t.writeMdx(e,this.version)}}savePivotPointChunk(e){if(this.pivotPoints.length){e.writeBinary("PIVT"),e.writeUint32(12*this.pivotPoints.length);for(const t of this.pivotPoints)e.writeFloat32Array(t)}}saveBindPoseChunk(e){if(this.bindPose.length){e.writeBinary("BPOS"),e.writeUint32(4+48*this.bindPose.length),e.writeUint32(this.bindPose.length);for(const t of this.bindPose)e.writeFloat32Array(t)}}loadMdl(e){let t;const n=new Yr(e);for(;t=n.readToken();)if("Version"===t)this.loadVersionBlock(n);else if("Model"===t)this.loadModelBlock(n);else if("Sequences"===t)this.loadNumberedObjectBlock(this.sequences,zr,"Anim",n);else if("GlobalSequences"===t)this.loadGlobalSequenceBlock(n);else if("Textures"===t)this.loadNumberedObjectBlock(this.textures,ni,"Bitmap",n);else if("Materials"===t)this.loadNumberedObjectBlock(this.materials,ti,"Material",n);else if("TextureAnims"===t)this.loadNumberedObjectBlock(this.textureAnimations,ai,"TVertexAnim",n);else if("Geoset"===t)this.loadObject(this.geosets,ri,n);else if("GeosetAnim"===t)this.loadObject(this.geosetAnimations,ii,n);else if("Bone"===t)this.loadObject(this.bones,li,n);else if("Light"===t)this.loadObject(this.lights,oi,n);else if("Helper"===t)this.loadObject(this.helpers,ui,n);else if("Attachment"===t)this.loadObject(this.attachments,ci,n);else if("PivotPoints"===t)this.loadPivotPointBlock(n);else if("ParticleEmitter"===t)this.loadObject(this.particleEmitters,di,n);else if("ParticleEmitter2"===t)this.loadObject(this.particleEmitters2,hi,n);else if("ParticleEmitterPopcorn"===t)this.loadObject(this.particleEmittersPopcorn,fi,n);else if("RibbonEmitter"===t)this.loadObject(this.ribbonEmitters,mi,n);else if("Camera"===t)this.loadObject(this.cameras,pi,n);else if("EventObject"===t)this.loadObject(this.eventObjects,_i,n);else if("CollisionShape"===t)this.loadObject(this.collisionShapes,gi,n);else if("FaceFX"===t)this.loadObject(this.faceEffects,bi,n);else{if("BindPose"!==t)throw new Error(`Unsupported block: ${t}`);this.loadBindPoseBlock(n)}}loadVersionBlock(e){for(const t of e.readBlock()){if("FormatVersion"!==t)throw new Error(`Unknown token in Version: "${t}"`);this.version=e.readInt()}}loadModelBlock(e){this.name=e.read();for(const t of e.readBlock())if(t.startsWith("Num"))e.read();else if("BlendTime"===t)this.blendTime=e.readInt();else if("MinimumExtent"===t)e.readVector(this.extent.min);else if("MaximumExtent"===t)e.readVector(this.extent.max);else if("BoundsRadius"===t)this.extent.boundsRadius=e.readFloat();else{if("AnimationFile"!==t)throw new Error(`Unknown token in Model: "${t}"`);this.animationFile=e.read()}}loadNumberedObjectBlock(e,t,n,a){a.read();for(const r of a.readBlock()){if(r!==n)throw new Error(`Unknown token in ${n}: "${r}"`);{const n=new t;n.readMdl(a),e.push(n)}}}loadGlobalSequenceBlock(e){e.read();for(const t of e.readBlock()){if("Duration"!==t)throw new Error(`Unknown token in GlobalSequences: "${t}"`);this.globalSequences.push(e.readInt())}}loadObject(e,t,n){const a=new t;a.readMdl(n),e.push(a)}loadPivotPointBlock(e){const t=e.readInt();e.read();for(let n=0;n<t;n++)this.pivotPoints.push(e.readVector(new Float32Array(3)));e.read()}loadBindPoseBlock(e){for(const t of e.readBlock()){if("Matrices"!==t)throw new Error(`Unknown token in BindPose: "${t}"`);{const t=e.readInt();e.read();for(let n=0;n<t;n++)this.bindPose[n]=e.readVector(new Float32Array(12));e.read()}}}saveMdl(){const e=new Yr;return this.saveVersionBlock(e),this.saveModelBlock(e),this.saveStaticObjectsBlock(e,"Sequences",this.sequences),this.saveGlobalSequenceBlock(e),this.saveStaticObjectsBlock(e,"Textures",this.textures),this.saveStaticObjectsBlock(e,"Materials",this.materials),this.saveStaticObjectsBlock(e,"TextureAnims",this.textureAnimations),this.saveObjects(e,this.geosets),this.saveObjects(e,this.geosetAnimations),this.saveObjects(e,this.bones),this.saveObjects(e,this.lights),this.saveObjects(e,this.helpers),this.saveObjects(e,this.attachments),this.savePivotPointBlock(e),this.saveObjects(e,this.particleEmitters),this.saveObjects(e,this.particleEmitters2),this.version>800&&this.saveObjects(e,this.particleEmittersPopcorn),this.saveObjects(e,this.ribbonEmitters),this.saveObjects(e,this.cameras),this.saveObjects(e,this.eventObjects),this.saveObjects(e,this.collisionShapes),this.version>800&&(this.saveObjects(e,this.faceEffects),this.saveBindPoseBlock(e)),e.buffer}saveVersionBlock(e){e.startBlock("Version"),e.writeNumberAttrib("FormatVersion",this.version),e.endBlock()}saveModelBlock(e){e.startObjectBlock("Model",this.name),e.writeNumberAttrib("BlendTime",this.blendTime),this.extent.writeMdl(e),this.animationFile.length&&e.writeStringAttrib("AnimationFile",this.animationFile),e.endBlock()}saveStaticObjectsBlock(e,t,n){if(n.length){e.startBlock(t,n.length);for(const t of n)t.writeMdl(e,this.version);e.endBlock()}}saveGlobalSequenceBlock(e){if(this.globalSequences.length){e.startBlock("GlobalSequences",this.globalSequences.length);for(const t of this.globalSequences)e.writeNumberAttrib("Duration",t);e.endBlock()}}saveObjects(e,t){for(const n of t)n.writeMdl(e,this.version)}savePivotPointBlock(e){if(this.pivotPoints.length){e.startBlock("PivotPoints",this.pivotPoints.length);for(const t of this.pivotPoints)e.writeVector(t);e.endBlock()}}saveBindPoseBlock(e){if(this.bindPose.length){e.startBlock("BindPose"),e.startBlock("Matrices",this.bindPose.length);for(const t of this.bindPose)e.writeVector(t);e.endBlock(),e.endBlock()}}getByteLength(){let e=396;return e+=this.getStaticObjectsChunkByteLength(this.sequences,132),e+=this.getStaticObjectsChunkByteLength(this.globalSequences,4),e+=this.getDynamicObjectsChunkByteLength(this.materials),e+=this.getStaticObjectsChunkByteLength(this.textures,268),e+=this.getDynamicObjectsChunkByteLength(this.textureAnimations),e+=this.getDynamicObjectsChunkByteLength(this.geosets),e+=this.getDynamicObjectsChunkByteLength(this.geosetAnimations),e+=this.getDynamicObjectsChunkByteLength(this.bones),e+=this.getDynamicObjectsChunkByteLength(this.lights),e+=this.getDynamicObjectsChunkByteLength(this.helpers),e+=this.getDynamicObjectsChunkByteLength(this.attachments),e+=this.getStaticObjectsChunkByteLength(this.pivotPoints,12),e+=this.getDynamicObjectsChunkByteLength(this.particleEmitters),e+=this.getDynamicObjectsChunkByteLength(this.particleEmitters2),this.version>800&&(e+=this.getDynamicObjectsChunkByteLength(this.particleEmittersPopcorn)),e+=this.getDynamicObjectsChunkByteLength(this.ribbonEmitters),e+=this.getDynamicObjectsChunkByteLength(this.cameras),e+=this.getDynamicObjectsChunkByteLength(this.eventObjects),e+=this.getDynamicObjectsChunkByteLength(this.collisionShapes),this.version>800&&(e+=this.getStaticObjectsChunkByteLength(this.faceEffects,340),e+=this.getBindPoseChunkByteLength()),e+=this.getObjectsByteLength(this.unknownChunks),e}getObjectsByteLength(e){let t=0;for(const n of e)t+=n.getByteLength(this.version);return t}getDynamicObjectsChunkByteLength(e){return e.length?8+this.getObjectsByteLength(e):0}getStaticObjectsChunkByteLength(e,t){return e.length?8+e.length*t:0}getBindPoseChunkByteLength(){return this.bindPose.length?12+48*this.bindPose.length:0}}const Si={Model:yi,Sequence:zr,Material:ti,Layer:ei,Texture:ni,TextureAnimation:ai,Geoset:ri,GeosetAnimation:ii,Bone:li,Light:oi,Helper:ui,Attachment:ci,ParticleEmitter:di,ParticleEmitter2:hi,ParticleEmitterPopcorn:fi,RibbonEmitter:mi,Camera:pi,EventObject:_i,CollisionShape:gi,UnknownChunk:wi,TokenStream:Yr,isMdx:vi,isMdl:Ai};class Ti{constructor(){this.offset=0,this.compressedSize=0,this.normalSize=0,this.flags=0}load(e){this.offset=e[0],this.compressedSize=e[1],this.normalSize=e[2],this.flags=e[3]}save(e){e[0]=this.offset,e[1]=this.compressedSize,e[2]=this.normalSize,e[3]=this.flags}}const xi=3283040112,Ei=4294967294,Li=4294967295,Ii=3968054179,Ui=65536,Ri=131072,Mi=16777216,Ci=2147483648;class Bi{constructor(e){this.c=e,this.entries=[]}add(e){const t=new Ti;return t.normalSize=e.byteLength,this.entries.push(t),t}clear(){this.entries.length=0}addEmpties(e){for(let t=0;t<e;t++)this.entries.push(new Ti)}load(e){const t=e.byteLength/16,n=new Uint32Array(this.c.decryptBlock(e,Ii).buffer);let a=0;this.clear(),this.addEmpties(t);for(const e of this.entries)e.load(n.subarray(a,a+4)),a+=4}save(e){const t=new Uint32Array(4*this.entries.length);let n=0;for(const e of this.entries)e.save(t.subarray(n,n+4)),n+=4;const a=new Uint8Array(t.buffer);this.c.encryptBlock(a,Ii),e.set(a)}}const Pi=new Uint8Array(4),ki=new Uint32Array(Pi.buffer);class Oi{constructor(){this.cryptTable=new Uint32Array(1280);let e=1048577,t=0,n=0;for(let a=0;a<256;a++)for(let r=a,i=0;i<5;i+=1,r+=256)e=(125*e+3)%2796203,t=(65535&e)<<16,e=(125*e+3)%2796203,n=65535&e,this.cryptTable[r]=t|n}hash(e,t){const n=this.cryptTable;let a=2146271213,r=4008636142;e=e.toUpperCase();for(let i=0;i<e.length;i++){const s=e.charCodeAt(i);a=n[(t<<8)+s]^a+r,r=s+a+r+(r<<5)+3}return a>>>0}decryptBlock(e,t){const n=this.cryptTable;let a=4008636142;const r=new Uint8Array(e.buffer,e.byteOffset,e.byteLength);for(let i=0,s=e.byteLength>>>2;i<s;i++)a+=n[1024+(255&t)],Pi[0]=r[4*i],Pi[1]=r[4*i+1],Pi[2]=r[4*i+2],Pi[3]=r[4*i+3],ki[0]^=t+a,t=286331153+(~t<<21)|t>>>11,a=ki[0]+a+(a<<5)+3,r[4*i]=Pi[0],r[4*i+1]=Pi[1],r[4*i+2]=Pi[2],r[4*i+3]=Pi[3];return e}encryptBlock(e,t){const n=this.cryptTable;let a=4008636142;const r=new Uint8Array(e.buffer,e.byteOffset,e.byteLength);for(let i=0,s=e.byteLength>>>2;i<s;i++){a+=n[1024+(255&t)],Pi[0]=r[4*i],Pi[1]=r[4*i+1],Pi[2]=r[4*i+2],Pi[3]=r[4*i+3];const e=ki[0];ki[0]^=t+a,t=286331153+(~t<<21)|t>>>11,a=e+a+(a<<5)+3,r[4*i]=Pi[0],r[4*i+1]=Pi[1],r[4*i+2]=Pi[2],r[4*i+3]=Pi[3]}return e}computeFileKey(e,t){const n=e.lastIndexOf("\\"),a=e.substring(n+1);let r=this.hash(a,3);return t.flags&Ri&&(r=r+t.offset^t.normalSize),r}}function Di(e){let t=e.length;for(;--t>=0;)e[t]=0}const Fi=256,Gi=286,Ni=30,Vi=15,Hi=new Uint8Array([0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0]),Yi=new Uint8Array([0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13]),Ki=new Uint8Array([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7]),zi=new Uint8Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]),qi=new Array(576);Di(qi);const Zi=new Array(60);Di(Zi);const ji=new Array(512);Di(ji);const Xi=new Array(256);Di(Xi);const $i=new Array(29);Di($i);const Ji=new Array(Ni);function Wi(e,t,n,a,r){this.static_tree=e,this.extra_bits=t,this.extra_base=n,this.elems=a,this.max_length=r,this.has_stree=e&&e.length}let Qi,es,ts;function ns(e,t){this.dyn_tree=e,this.max_code=0,this.stat_desc=t}Di(Ji);const as=e=>e<256?ji[e]:ji[256+(e>>>7)],rs=(e,t)=>{e.pending_buf[e.pending++]=255&t,e.pending_buf[e.pending++]=t>>>8&255},is=(e,t,n)=>{e.bi_valid>16-n?(e.bi_buf|=t<<e.bi_valid&65535,rs(e,e.bi_buf),e.bi_buf=t>>16-e.bi_valid,e.bi_valid+=n-16):(e.bi_buf|=t<<e.bi_valid&65535,e.bi_valid+=n)},ss=(e,t,n)=>{is(e,n[2*t],n[2*t+1])},ls=(e,t)=>{let n=0;do{n|=1&e,e>>>=1,n<<=1}while(--t>0);return n>>>1},os=(e,t,n)=>{const a=new Array(16);let r,i,s=0;for(r=1;r<=Vi;r++)a[r]=s=s+n[r-1]<<1;for(i=0;i<=t;i++){let t=e[2*i+1];0!==t&&(e[2*i]=ls(a[t]++,t))}},us=e=>{let t;for(t=0;t<Gi;t++)e.dyn_ltree[2*t]=0;for(t=0;t<Ni;t++)e.dyn_dtree[2*t]=0;for(t=0;t<19;t++)e.bl_tree[2*t]=0;e.dyn_ltree[512]=1,e.opt_len=e.static_len=0,e.last_lit=e.matches=0},cs=e=>{e.bi_valid>8?rs(e,e.bi_buf):e.bi_valid>0&&(e.pending_buf[e.pending++]=e.bi_buf),e.bi_buf=0,e.bi_valid=0},ds=(e,t,n,a)=>{const r=2*t,i=2*n;return e[r]<e[i]||e[r]===e[i]&&a[t]<=a[n]},hs=(e,t,n)=>{const a=e.heap[n];let r=n<<1;for(;r<=e.heap_len&&(r<e.heap_len&&ds(t,e.heap[r+1],e.heap[r],e.depth)&&r++,!ds(t,a,e.heap[r],e.depth));)e.heap[n]=e.heap[r],n=r,r<<=1;e.heap[n]=a},fs=(e,t,n)=>{let a,r,i,s,l=0;if(0!==e.last_lit)do{a=e.pending_buf[e.d_buf+2*l]<<8|e.pending_buf[e.d_buf+2*l+1],r=e.pending_buf[e.l_buf+l],l++,0===a?ss(e,r,t):(i=Xi[r],ss(e,i+Fi+1,t),s=Hi[i],0!==s&&(r-=$i[i],is(e,r,s)),a--,i=as(a),ss(e,i,n),s=Yi[i],0!==s&&(a-=Ji[i],is(e,a,s)))}while(l<e.last_lit);ss(e,256,t)},ms=(e,t)=>{const n=t.dyn_tree,a=t.stat_desc.static_tree,r=t.stat_desc.has_stree,i=t.stat_desc.elems;let s,l,o,u=-1;for(e.heap_len=0,e.heap_max=573,s=0;s<i;s++)0!==n[2*s]?(e.heap[++e.heap_len]=u=s,e.depth[s]=0):n[2*s+1]=0;for(;e.heap_len<2;)o=e.heap[++e.heap_len]=u<2?++u:0,n[2*o]=1,e.depth[o]=0,e.opt_len--,r&&(e.static_len-=a[2*o+1]);for(t.max_code=u,s=e.heap_len>>1;s>=1;s--)hs(e,n,s);o=i;do{s=e.heap[1],e.heap[1]=e.heap[e.heap_len--],hs(e,n,1),l=e.heap[1],e.heap[--e.heap_max]=s,e.heap[--e.heap_max]=l,n[2*o]=n[2*s]+n[2*l],e.depth[o]=(e.depth[s]>=e.depth[l]?e.depth[s]:e.depth[l])+1,n[2*s+1]=n[2*l+1]=o,e.heap[1]=o++,hs(e,n,1)}while(e.heap_len>=2);e.heap[--e.heap_max]=e.heap[1],((e,t)=>{const n=t.dyn_tree,a=t.max_code,r=t.stat_desc.static_tree,i=t.stat_desc.has_stree,s=t.stat_desc.extra_bits,l=t.stat_desc.extra_base,o=t.stat_desc.max_length;let u,c,d,h,f,m,p=0;for(h=0;h<=Vi;h++)e.bl_count[h]=0;for(n[2*e.heap[e.heap_max]+1]=0,u=e.heap_max+1;u<573;u++)c=e.heap[u],h=n[2*n[2*c+1]+1]+1,h>o&&(h=o,p++),n[2*c+1]=h,c>a||(e.bl_count[h]++,f=0,c>=l&&(f=s[c-l]),m=n[2*c],e.opt_len+=m*(h+f),i&&(e.static_len+=m*(r[2*c+1]+f)));if(0!==p){do{for(h=o-1;0===e.bl_count[h];)h--;e.bl_count[h]--,e.bl_count[h+1]+=2,e.bl_count[o]--,p-=2}while(p>0);for(h=o;0!==h;h--)for(c=e.bl_count[h];0!==c;)d=e.heap[--u],d>a||(n[2*d+1]!==h&&(e.opt_len+=(h-n[2*d+1])*n[2*d],n[2*d+1]=h),c--)}})(e,t),os(n,u,e.bl_count)},ps=(e,t,n)=>{let a,r,i=-1,s=t[1],l=0,o=7,u=4;for(0===s&&(o=138,u=3),t[2*(n+1)+1]=65535,a=0;a<=n;a++)r=s,s=t[2*(a+1)+1],++l<o&&r===s||(l<u?e.bl_tree[2*r]+=l:0!==r?(r!==i&&e.bl_tree[2*r]++,e.bl_tree[32]++):l<=10?e.bl_tree[34]++:e.bl_tree[36]++,l=0,i=r,0===s?(o=138,u=3):r===s?(o=6,u=3):(o=7,u=4))},_s=(e,t,n)=>{let a,r,i=-1,s=t[1],l=0,o=7,u=4;for(0===s&&(o=138,u=3),a=0;a<=n;a++)if(r=s,s=t[2*(a+1)+1],!(++l<o&&r===s)){if(l<u)do{ss(e,r,e.bl_tree)}while(0!=--l);else 0!==r?(r!==i&&(ss(e,r,e.bl_tree),l--),ss(e,16,e.bl_tree),is(e,l-3,2)):l<=10?(ss(e,17,e.bl_tree),is(e,l-3,3)):(ss(e,18,e.bl_tree),is(e,l-11,7));l=0,i=r,0===s?(o=138,u=3):r===s?(o=6,u=3):(o=7,u=4)}};let gs=!1;const bs=(e,t,n,a)=>{is(e,0+(a?1:0),3),((e,t,n,a)=>{cs(e),a&&(rs(e,n),rs(e,~n)),e.pending_buf.set(e.window.subarray(t,t+n),e.pending),e.pending+=n})(e,t,n,!0)};var ws=e=>{gs||((()=>{let e,t,n,a,r;const i=new Array(16);for(n=0,a=0;a<28;a++)for($i[a]=n,e=0;e<1<<Hi[a];e++)Xi[n++]=a;for(Xi[n-1]=a,r=0,a=0;a<16;a++)for(Ji[a]=r,e=0;e<1<<Yi[a];e++)ji[r++]=a;for(r>>=7;a<Ni;a++)for(Ji[a]=r<<7,e=0;e<1<<Yi[a]-7;e++)ji[256+r++]=a;for(t=0;t<=Vi;t++)i[t]=0;for(e=0;e<=143;)qi[2*e+1]=8,e++,i[8]++;for(;e<=255;)qi[2*e+1]=9,e++,i[9]++;for(;e<=279;)qi[2*e+1]=7,e++,i[7]++;for(;e<=287;)qi[2*e+1]=8,e++,i[8]++;for(os(qi,287,i),e=0;e<Ni;e++)Zi[2*e+1]=5,Zi[2*e]=ls(e,5);Qi=new Wi(qi,Hi,257,Gi,Vi),es=new Wi(Zi,Yi,0,Ni,Vi),ts=new Wi(new Array(0),Ki,0,19,7)})(),gs=!0),e.l_desc=new ns(e.dyn_ltree,Qi),e.d_desc=new ns(e.dyn_dtree,es),e.bl_desc=new ns(e.bl_tree,ts),e.bi_buf=0,e.bi_valid=0,us(e)},vs=(e,t,n,a)=>{let r,i,s=0;e.level>0?(2===e.strm.data_type&&(e.strm.data_type=(e=>{let t,n=4093624447;for(t=0;t<=31;t++,n>>>=1)if(1&n&&0!==e.dyn_ltree[2*t])return 0;if(0!==e.dyn_ltree[18]||0!==e.dyn_ltree[20]||0!==e.dyn_ltree[26])return 1;for(t=32;t<Fi;t++)if(0!==e.dyn_ltree[2*t])return 1;return 0})(e)),ms(e,e.l_desc),ms(e,e.d_desc),s=(e=>{let t;for(ps(e,e.dyn_ltree,e.l_desc.max_code),ps(e,e.dyn_dtree,e.d_desc.max_code),ms(e,e.bl_desc),t=18;t>=3&&0===e.bl_tree[2*zi[t]+1];t--);return e.opt_len+=3*(t+1)+5+5+4,t})(e),r=e.opt_len+3+7>>>3,i=e.static_len+3+7>>>3,i<=r&&(r=i)):r=i=n+5,n+4<=r&&-1!==t?bs(e,t,n,a):4===e.strategy||i===r?(is(e,2+(a?1:0),3),fs(e,qi,Zi)):(is(e,4+(a?1:0),3),((e,t,n,a)=>{let r;for(is(e,t-257,5),is(e,n-1,5),is(e,a-4,4),r=0;r<a;r++)is(e,e.bl_tree[2*zi[r]+1],3);_s(e,e.dyn_ltree,t-1),_s(e,e.dyn_dtree,n-1)})(e,e.l_desc.max_code+1,e.d_desc.max_code+1,s+1),fs(e,e.dyn_ltree,e.dyn_dtree)),us(e),a&&cs(e)},As=(e,t,n)=>(e.pending_buf[e.d_buf+2*e.last_lit]=t>>>8&255,e.pending_buf[e.d_buf+2*e.last_lit+1]=255&t,e.pending_buf[e.l_buf+e.last_lit]=255&n,e.last_lit++,0===t?e.dyn_ltree[2*n]++:(e.matches++,t--,e.dyn_ltree[2*(Xi[n]+Fi+1)]++,e.dyn_dtree[2*as(t)]++),e.last_lit===e.lit_bufsize-1),ys=e=>{is(e,2,3),ss(e,256,qi),(e=>{16===e.bi_valid?(rs(e,e.bi_buf),e.bi_buf=0,e.bi_valid=0):e.bi_valid>=8&&(e.pending_buf[e.pending++]=255&e.bi_buf,e.bi_buf>>=8,e.bi_valid-=8)})(e)},Ss={_tr_init:ws,_tr_stored_block:bs,_tr_flush_block:vs,_tr_tally:As,_tr_align:ys};var Ts=(e,t,n,a)=>{let r=65535&e|0,i=e>>>16&65535|0,s=0;for(;0!==n;){s=n>2e3?2e3:n,n-=s;do{r=r+t[a++]|0,i=i+r|0}while(--s);r%=65521,i%=65521}return r|i<<16|0};const xs=new Uint32Array((()=>{let e,t=[];for(var n=0;n<256;n++){e=n;for(var a=0;a<8;a++)e=1&e?3988292384^e>>>1:e>>>1;t[n]=e}return t})());var Es=(e,t,n,a)=>{const r=xs,i=a+n;e^=-1;for(let n=a;n<i;n++)e=e>>>8^r[255&(e^t[n])];return-1^e},Ls={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"},Is={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_MEM_ERROR:-4,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8};const{_tr_init:Us,_tr_stored_block:Rs,_tr_flush_block:Ms,_tr_tally:Cs,_tr_align:Bs}=Ss,{Z_NO_FLUSH:Ps,Z_PARTIAL_FLUSH:ks,Z_FULL_FLUSH:Os,Z_FINISH:Ds,Z_BLOCK:Fs,Z_OK:Gs,Z_STREAM_END:Ns,Z_STREAM_ERROR:Vs,Z_DATA_ERROR:Hs,Z_BUF_ERROR:Ys,Z_DEFAULT_COMPRESSION:Ks,Z_FILTERED:zs,Z_HUFFMAN_ONLY:qs,Z_RLE:Zs,Z_FIXED:js,Z_DEFAULT_STRATEGY:Xs,Z_UNKNOWN:$s,Z_DEFLATED:Js}=Is,Ws=258,Qs=262,el=103,tl=113,nl=666,al=(e,t)=>(e.msg=Ls[t],t),rl=e=>(e<<1)-(e>4?9:0),il=e=>{let t=e.length;for(;--t>=0;)e[t]=0};let sl=(e,t,n)=>(t<<e.hash_shift^n)&e.hash_mask;const ll=e=>{const t=e.state;let n=t.pending;n>e.avail_out&&(n=e.avail_out),0!==n&&(e.output.set(t.pending_buf.subarray(t.pending_out,t.pending_out+n),e.next_out),e.next_out+=n,t.pending_out+=n,e.total_out+=n,e.avail_out-=n,t.pending-=n,0===t.pending&&(t.pending_out=0))},ol=(e,t)=>{Ms(e,e.block_start>=0?e.block_start:-1,e.strstart-e.block_start,t),e.block_start=e.strstart,ll(e.strm)},ul=(e,t)=>{e.pending_buf[e.pending++]=t},cl=(e,t)=>{e.pending_buf[e.pending++]=t>>>8&255,e.pending_buf[e.pending++]=255&t},dl=(e,t,n,a)=>{let r=e.avail_in;return r>a&&(r=a),0===r?0:(e.avail_in-=r,t.set(e.input.subarray(e.next_in,e.next_in+r),n),1===e.state.wrap?e.adler=Ts(e.adler,t,r,n):2===e.state.wrap&&(e.adler=Es(e.adler,t,r,n)),e.next_in+=r,e.total_in+=r,r)},hl=(e,t)=>{let n,a,r=e.max_chain_length,i=e.strstart,s=e.prev_length,l=e.nice_match;const o=e.strstart>e.w_size-Qs?e.strstart-(e.w_size-Qs):0,u=e.window,c=e.w_mask,d=e.prev,h=e.strstart+Ws;let f=u[i+s-1],m=u[i+s];e.prev_length>=e.good_match&&(r>>=2),l>e.lookahead&&(l=e.lookahead);do{if(n=t,u[n+s]===m&&u[n+s-1]===f&&u[n]===u[i]&&u[++n]===u[i+1]){i+=2,n++;do{}while(u[++i]===u[++n]&&u[++i]===u[++n]&&u[++i]===u[++n]&&u[++i]===u[++n]&&u[++i]===u[++n]&&u[++i]===u[++n]&&u[++i]===u[++n]&&u[++i]===u[++n]&&i<h);if(a=Ws-(h-i),i=h-Ws,a>s){if(e.match_start=t,s=a,a>=l)break;f=u[i+s-1],m=u[i+s]}}}while((t=d[t&c])>o&&0!=--r);return s<=e.lookahead?s:e.lookahead},fl=e=>{const t=e.w_size;let n,a,r,i,s;do{if(i=e.window_size-e.lookahead-e.strstart,e.strstart>=t+(t-Qs)){e.window.set(e.window.subarray(t,t+t),0),e.match_start-=t,e.strstart-=t,e.block_start-=t,a=e.hash_size,n=a;do{r=e.head[--n],e.head[n]=r>=t?r-t:0}while(--a);a=t,n=a;do{r=e.prev[--n],e.prev[n]=r>=t?r-t:0}while(--a);i+=t}if(0===e.strm.avail_in)break;if(a=dl(e.strm,e.window,e.strstart+e.lookahead,i),e.lookahead+=a,e.lookahead+e.insert>=3)for(s=e.strstart-e.insert,e.ins_h=e.window[s],e.ins_h=sl(e,e.ins_h,e.window[s+1]);e.insert&&(e.ins_h=sl(e,e.ins_h,e.window[s+3-1]),e.prev[s&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=s,s++,e.insert--,!(e.lookahead+e.insert<3)););}while(e.lookahead<Qs&&0!==e.strm.avail_in)},ml=(e,t)=>{let n,a;for(;;){if(e.lookahead<Qs){if(fl(e),e.lookahead<Qs&&t===Ps)return 1;if(0===e.lookahead)break}if(n=0,e.lookahead>=3&&(e.ins_h=sl(e,e.ins_h,e.window[e.strstart+3-1]),n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),0!==n&&e.strstart-n<=e.w_size-Qs&&(e.match_length=hl(e,n)),e.match_length>=3)if(a=Cs(e,e.strstart-e.match_start,e.match_length-3),e.lookahead-=e.match_length,e.match_length<=e.max_lazy_match&&e.lookahead>=3){e.match_length--;do{e.strstart++,e.ins_h=sl(e,e.ins_h,e.window[e.strstart+3-1]),n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart}while(0!=--e.match_length);e.strstart++}else e.strstart+=e.match_length,e.match_length=0,e.ins_h=e.window[e.strstart],e.ins_h=sl(e,e.ins_h,e.window[e.strstart+1]);else a=Cs(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++;if(a&&(ol(e,!1),0===e.strm.avail_out))return 1}return e.insert=e.strstart<2?e.strstart:2,t===Ds?(ol(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(ol(e,!1),0===e.strm.avail_out)?1:2},pl=(e,t)=>{let n,a,r;for(;;){if(e.lookahead<Qs){if(fl(e),e.lookahead<Qs&&t===Ps)return 1;if(0===e.lookahead)break}if(n=0,e.lookahead>=3&&(e.ins_h=sl(e,e.ins_h,e.window[e.strstart+3-1]),n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),e.prev_length=e.match_length,e.prev_match=e.match_start,e.match_length=2,0!==n&&e.prev_length<e.max_lazy_match&&e.strstart-n<=e.w_size-Qs&&(e.match_length=hl(e,n),e.match_length<=5&&(e.strategy===zs||3===e.match_length&&e.strstart-e.match_start>4096)&&(e.match_length=2)),e.prev_length>=3&&e.match_length<=e.prev_length){r=e.strstart+e.lookahead-3,a=Cs(e,e.strstart-1-e.prev_match,e.prev_length-3),e.lookahead-=e.prev_length-1,e.prev_length-=2;do{++e.strstart<=r&&(e.ins_h=sl(e,e.ins_h,e.window[e.strstart+3-1]),n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart)}while(0!=--e.prev_length);if(e.match_available=0,e.match_length=2,e.strstart++,a&&(ol(e,!1),0===e.strm.avail_out))return 1}else if(e.match_available){if(a=Cs(e,0,e.window[e.strstart-1]),a&&ol(e,!1),e.strstart++,e.lookahead--,0===e.strm.avail_out)return 1}else e.match_available=1,e.strstart++,e.lookahead--}return e.match_available&&(a=Cs(e,0,e.window[e.strstart-1]),e.match_available=0),e.insert=e.strstart<2?e.strstart:2,t===Ds?(ol(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(ol(e,!1),0===e.strm.avail_out)?1:2};function _l(e,t,n,a,r){this.good_length=e,this.max_lazy=t,this.nice_length=n,this.max_chain=a,this.func=r}const gl=[new _l(0,0,0,0,((e,t)=>{let n=65535;for(n>e.pending_buf_size-5&&(n=e.pending_buf_size-5);;){if(e.lookahead<=1){if(fl(e),0===e.lookahead&&t===Ps)return 1;if(0===e.lookahead)break}e.strstart+=e.lookahead,e.lookahead=0;const a=e.block_start+n;if((0===e.strstart||e.strstart>=a)&&(e.lookahead=e.strstart-a,e.strstart=a,ol(e,!1),0===e.strm.avail_out))return 1;if(e.strstart-e.block_start>=e.w_size-Qs&&(ol(e,!1),0===e.strm.avail_out))return 1}return e.insert=0,t===Ds?(ol(e,!0),0===e.strm.avail_out?3:4):(e.strstart>e.block_start&&(ol(e,!1),e.strm.avail_out),1)})),new _l(4,4,8,4,ml),new _l(4,5,16,8,ml),new _l(4,6,32,32,ml),new _l(4,4,16,16,pl),new _l(8,16,32,32,pl),new _l(8,16,128,128,pl),new _l(8,32,128,256,pl),new _l(32,128,258,1024,pl),new _l(32,258,258,4096,pl)];function bl(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=Js,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new Uint16Array(1146),this.dyn_dtree=new Uint16Array(122),this.bl_tree=new Uint16Array(78),il(this.dyn_ltree),il(this.dyn_dtree),il(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new Uint16Array(16),this.heap=new Uint16Array(573),il(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new Uint16Array(573),il(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0}const wl=e=>{if(!e||!e.state)return al(e,Vs);e.total_in=e.total_out=0,e.data_type=$s;const t=e.state;return t.pending=0,t.pending_out=0,t.wrap<0&&(t.wrap=-t.wrap),t.status=t.wrap?42:tl,e.adler=2===t.wrap?0:1,t.last_flush=Ps,Us(t),Gs},vl=e=>{const t=wl(e);return t===Gs&&(e=>{e.window_size=2*e.w_size,il(e.head),e.max_lazy_match=gl[e.level].max_lazy,e.good_match=gl[e.level].good_length,e.nice_match=gl[e.level].nice_length,e.max_chain_length=gl[e.level].max_chain,e.strstart=0,e.block_start=0,e.lookahead=0,e.insert=0,e.match_length=e.prev_length=2,e.match_available=0,e.ins_h=0})(e.state),t},Al=(e,t,n,a,r,i)=>{if(!e)return Vs;let s=1;if(t===Ks&&(t=6),a<0?(s=0,a=-a):a>15&&(s=2,a-=16),r<1||r>9||n!==Js||a<8||a>15||t<0||t>9||i<0||i>js)return al(e,Vs);8===a&&(a=9);const l=new bl;return e.state=l,l.strm=e,l.wrap=s,l.gzhead=null,l.w_bits=a,l.w_size=1<<l.w_bits,l.w_mask=l.w_size-1,l.hash_bits=r+7,l.hash_size=1<<l.hash_bits,l.hash_mask=l.hash_size-1,l.hash_shift=~~((l.hash_bits+3-1)/3),l.window=new Uint8Array(2*l.w_size),l.head=new Uint16Array(l.hash_size),l.prev=new Uint16Array(l.w_size),l.lit_bufsize=1<<r+6,l.pending_buf_size=4*l.lit_bufsize,l.pending_buf=new Uint8Array(l.pending_buf_size),l.d_buf=1*l.lit_bufsize,l.l_buf=3*l.lit_bufsize,l.level=t,l.strategy=i,l.method=n,vl(e)};var yl=(e,t)=>{let n,a;if(!e||!e.state||t>Fs||t<0)return e?al(e,Vs):Vs;const r=e.state;if(!e.output||!e.input&&0!==e.avail_in||r.status===nl&&t!==Ds)return al(e,0===e.avail_out?Ys:Vs);r.strm=e;const i=r.last_flush;if(r.last_flush=t,42===r.status)if(2===r.wrap)e.adler=0,ul(r,31),ul(r,139),ul(r,8),r.gzhead?(ul(r,(r.gzhead.text?1:0)+(r.gzhead.hcrc?2:0)+(r.gzhead.extra?4:0)+(r.gzhead.name?8:0)+(r.gzhead.comment?16:0)),ul(r,255&r.gzhead.time),ul(r,r.gzhead.time>>8&255),ul(r,r.gzhead.time>>16&255),ul(r,r.gzhead.time>>24&255),ul(r,9===r.level?2:r.strategy>=qs||r.level<2?4:0),ul(r,255&r.gzhead.os),r.gzhead.extra&&r.gzhead.extra.length&&(ul(r,255&r.gzhead.extra.length),ul(r,r.gzhead.extra.length>>8&255)),r.gzhead.hcrc&&(e.adler=Es(e.adler,r.pending_buf,r.pending,0)),r.gzindex=0,r.status=69):(ul(r,0),ul(r,0),ul(r,0),ul(r,0),ul(r,0),ul(r,9===r.level?2:r.strategy>=qs||r.level<2?4:0),ul(r,3),r.status=tl);else{let t=Js+(r.w_bits-8<<4)<<8,n=-1;n=r.strategy>=qs||r.level<2?0:r.level<6?1:6===r.level?2:3,t|=n<<6,0!==r.strstart&&(t|=32),t+=31-t%31,r.status=tl,cl(r,t),0!==r.strstart&&(cl(r,e.adler>>>16),cl(r,65535&e.adler)),e.adler=1}if(69===r.status)if(r.gzhead.extra){for(n=r.pending;r.gzindex<(65535&r.gzhead.extra.length)&&(r.pending!==r.pending_buf_size||(r.gzhead.hcrc&&r.pending>n&&(e.adler=Es(e.adler,r.pending_buf,r.pending-n,n)),ll(e),n=r.pending,r.pending!==r.pending_buf_size));)ul(r,255&r.gzhead.extra[r.gzindex]),r.gzindex++;r.gzhead.hcrc&&r.pending>n&&(e.adler=Es(e.adler,r.pending_buf,r.pending-n,n)),r.gzindex===r.gzhead.extra.length&&(r.gzindex=0,r.status=73)}else r.status=73;if(73===r.status)if(r.gzhead.name){n=r.pending;do{if(r.pending===r.pending_buf_size&&(r.gzhead.hcrc&&r.pending>n&&(e.adler=Es(e.adler,r.pending_buf,r.pending-n,n)),ll(e),n=r.pending,r.pending===r.pending_buf_size)){a=1;break}a=r.gzindex<r.gzhead.name.length?255&r.gzhead.name.charCodeAt(r.gzindex++):0,ul(r,a)}while(0!==a);r.gzhead.hcrc&&r.pending>n&&(e.adler=Es(e.adler,r.pending_buf,r.pending-n,n)),0===a&&(r.gzindex=0,r.status=91)}else r.status=91;if(91===r.status)if(r.gzhead.comment){n=r.pending;do{if(r.pending===r.pending_buf_size&&(r.gzhead.hcrc&&r.pending>n&&(e.adler=Es(e.adler,r.pending_buf,r.pending-n,n)),ll(e),n=r.pending,r.pending===r.pending_buf_size)){a=1;break}a=r.gzindex<r.gzhead.comment.length?255&r.gzhead.comment.charCodeAt(r.gzindex++):0,ul(r,a)}while(0!==a);r.gzhead.hcrc&&r.pending>n&&(e.adler=Es(e.adler,r.pending_buf,r.pending-n,n)),0===a&&(r.status=el)}else r.status=el;if(r.status===el&&(r.gzhead.hcrc?(r.pending+2>r.pending_buf_size&&ll(e),r.pending+2<=r.pending_buf_size&&(ul(r,255&e.adler),ul(r,e.adler>>8&255),e.adler=0,r.status=tl)):r.status=tl),0!==r.pending){if(ll(e),0===e.avail_out)return r.last_flush=-1,Gs}else if(0===e.avail_in&&rl(t)<=rl(i)&&t!==Ds)return al(e,Ys);if(r.status===nl&&0!==e.avail_in)return al(e,Ys);if(0!==e.avail_in||0!==r.lookahead||t!==Ps&&r.status!==nl){let n=r.strategy===qs?((e,t)=>{let n;for(;;){if(0===e.lookahead&&(fl(e),0===e.lookahead)){if(t===Ps)return 1;break}if(e.match_length=0,n=Cs(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++,n&&(ol(e,!1),0===e.strm.avail_out))return 1}return e.insert=0,t===Ds?(ol(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(ol(e,!1),0===e.strm.avail_out)?1:2})(r,t):r.strategy===Zs?((e,t)=>{let n,a,r,i;const s=e.window;for(;;){if(e.lookahead<=Ws){if(fl(e),e.lookahead<=Ws&&t===Ps)return 1;if(0===e.lookahead)break}if(e.match_length=0,e.lookahead>=3&&e.strstart>0&&(r=e.strstart-1,a=s[r],a===s[++r]&&a===s[++r]&&a===s[++r])){i=e.strstart+Ws;do{}while(a===s[++r]&&a===s[++r]&&a===s[++r]&&a===s[++r]&&a===s[++r]&&a===s[++r]&&a===s[++r]&&a===s[++r]&&r<i);e.match_length=Ws-(i-r),e.match_length>e.lookahead&&(e.match_length=e.lookahead)}if(e.match_length>=3?(n=Cs(e,1,e.match_length-3),e.lookahead-=e.match_length,e.strstart+=e.match_length,e.match_length=0):(n=Cs(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++),n&&(ol(e,!1),0===e.strm.avail_out))return 1}return e.insert=0,t===Ds?(ol(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(ol(e,!1),0===e.strm.avail_out)?1:2})(r,t):gl[r.level].func(r,t);if(3!==n&&4!==n||(r.status=nl),1===n||3===n)return 0===e.avail_out&&(r.last_flush=-1),Gs;if(2===n&&(t===ks?Bs(r):t!==Fs&&(Rs(r,0,0,!1),t===Os&&(il(r.head),0===r.lookahead&&(r.strstart=0,r.block_start=0,r.insert=0))),ll(e),0===e.avail_out))return r.last_flush=-1,Gs}return t!==Ds?Gs:r.wrap<=0?Ns:(2===r.wrap?(ul(r,255&e.adler),ul(r,e.adler>>8&255),ul(r,e.adler>>16&255),ul(r,e.adler>>24&255),ul(r,255&e.total_in),ul(r,e.total_in>>8&255),ul(r,e.total_in>>16&255),ul(r,e.total_in>>24&255)):(cl(r,e.adler>>>16),cl(r,65535&e.adler)),ll(e),r.wrap>0&&(r.wrap=-r.wrap),0!==r.pending?Gs:Ns)},Sl=(e,t)=>{let n=t.length;if(!e||!e.state)return Vs;const a=e.state,r=a.wrap;if(2===r||1===r&&42!==a.status||a.lookahead)return Vs;if(1===r&&(e.adler=Ts(e.adler,t,n,0)),a.wrap=0,n>=a.w_size){0===r&&(il(a.head),a.strstart=0,a.block_start=0,a.insert=0);let e=new Uint8Array(a.w_size);e.set(t.subarray(n-a.w_size,n),0),t=e,n=a.w_size}const i=e.avail_in,s=e.next_in,l=e.input;for(e.avail_in=n,e.next_in=0,e.input=t,fl(a);a.lookahead>=3;){let e=a.strstart,t=a.lookahead-2;do{a.ins_h=sl(a,a.ins_h,a.window[e+3-1]),a.prev[e&a.w_mask]=a.head[a.ins_h],a.head[a.ins_h]=e,e++}while(--t);a.strstart=e,a.lookahead=2,fl(a)}return a.strstart+=a.lookahead,a.block_start=a.strstart,a.insert=a.lookahead,a.lookahead=0,a.match_length=a.prev_length=2,a.match_available=0,e.next_in=s,e.input=l,e.avail_in=i,a.wrap=r,Gs},Tl={deflateInit:(e,t)=>Al(e,t,Js,15,8,Xs),deflateInit2:Al,deflateReset:vl,deflateResetKeep:wl,deflateSetHeader:(e,t)=>e&&e.state?2!==e.state.wrap?Vs:(e.state.gzhead=t,Gs):Vs,deflate:yl,deflateEnd:e=>{if(!e||!e.state)return Vs;const t=e.state.status;return 42!==t&&69!==t&&73!==t&&91!==t&&t!==el&&t!==tl&&t!==nl?al(e,Vs):(e.state=null,t===tl?al(e,Hs):Gs)},deflateSetDictionary:Sl,deflateInfo:"pako deflate (from Nodeca project)"};const xl=(e,t)=>Object.prototype.hasOwnProperty.call(e,t);var El=function(e){const t=Array.prototype.slice.call(arguments,1);for(;t.length;){const n=t.shift();if(n){if("object"!=typeof n)throw new TypeError(n+"must be non-object");for(const t in n)xl(n,t)&&(e[t]=n[t])}}return e},Ll=e=>{let t=0;for(let n=0,a=e.length;n<a;n++)t+=e[n].length;const n=new Uint8Array(t);for(let t=0,a=0,r=e.length;t<r;t++){let r=e[t];n.set(r,a),a+=r.length}return n};let Il=!0;try{String.fromCharCode.apply(null,new Uint8Array(1))}catch(e){Il=!1}const Ul=new Uint8Array(256);for(let e=0;e<256;e++)Ul[e]=e>=252?6:e>=248?5:e>=240?4:e>=224?3:e>=192?2:1;Ul[254]=Ul[254]=1;var Rl=e=>{if("function"==typeof TextEncoder&&TextEncoder.prototype.encode)return(new TextEncoder).encode(e);let t,n,a,r,i,s=e.length,l=0;for(r=0;r<s;r++)n=e.charCodeAt(r),55296==(64512&n)&&r+1<s&&(a=e.charCodeAt(r+1),56320==(64512&a)&&(n=65536+(n-55296<<10)+(a-56320),r++)),l+=n<128?1:n<2048?2:n<65536?3:4;for(t=new Uint8Array(l),i=0,r=0;i<l;r++)n=e.charCodeAt(r),55296==(64512&n)&&r+1<s&&(a=e.charCodeAt(r+1),56320==(64512&a)&&(n=65536+(n-55296<<10)+(a-56320),r++)),n<128?t[i++]=n:n<2048?(t[i++]=192|n>>>6,t[i++]=128|63&n):n<65536?(t[i++]=224|n>>>12,t[i++]=128|n>>>6&63,t[i++]=128|63&n):(t[i++]=240|n>>>18,t[i++]=128|n>>>12&63,t[i++]=128|n>>>6&63,t[i++]=128|63&n);return t},Ml=(e,t)=>{const n=t||e.length;if("function"==typeof TextDecoder&&TextDecoder.prototype.decode)return(new TextDecoder).decode(e.subarray(0,t));let a,r;const i=new Array(2*n);for(r=0,a=0;a<n;){let t=e[a++];if(t<128){i[r++]=t;continue}let s=Ul[t];if(s>4)i[r++]=65533,a+=s-1;else{for(t&=2===s?31:3===s?15:7;s>1&&a<n;)t=t<<6|63&e[a++],s--;s>1?i[r++]=65533:t<65536?i[r++]=t:(t-=65536,i[r++]=55296|t>>10&1023,i[r++]=56320|1023&t)}}return((e,t)=>{if(t<65534&&e.subarray&&Il)return String.fromCharCode.apply(null,e.length===t?e:e.subarray(0,t));let n="";for(let a=0;a<t;a++)n+=String.fromCharCode(e[a]);return n})(i,r)},Cl=(e,t)=>{(t=t||e.length)>e.length&&(t=e.length);let n=t-1;for(;n>=0&&128==(192&e[n]);)n--;return n<0||0===n?t:n+Ul[e[n]]>t?n:t};var Bl=function(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0};const Pl=Object.prototype.toString,{Z_NO_FLUSH:kl,Z_SYNC_FLUSH:Ol,Z_FULL_FLUSH:Dl,Z_FINISH:Fl,Z_OK:Gl,Z_STREAM_END:Nl,Z_DEFAULT_COMPRESSION:Vl,Z_DEFAULT_STRATEGY:Hl,Z_DEFLATED:Yl}=Is;function Kl(e){this.options=El({level:Vl,method:Yl,chunkSize:16384,windowBits:15,memLevel:8,strategy:Hl},e||{});let t=this.options;t.raw&&t.windowBits>0?t.windowBits=-t.windowBits:t.gzip&&t.windowBits>0&&t.windowBits<16&&(t.windowBits+=16),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new Bl,this.strm.avail_out=0;let n=Tl.deflateInit2(this.strm,t.level,t.method,t.windowBits,t.memLevel,t.strategy);if(n!==Gl)throw new Error(Ls[n]);if(t.header&&Tl.deflateSetHeader(this.strm,t.header),t.dictionary){let e;if(e="string"==typeof t.dictionary?Rl(t.dictionary):"[object ArrayBuffer]"===Pl.call(t.dictionary)?new Uint8Array(t.dictionary):t.dictionary,n=Tl.deflateSetDictionary(this.strm,e),n!==Gl)throw new Error(Ls[n]);this._dict_set=!0}}function zl(e,t){const n=new Kl(t);if(n.push(e,!0),n.err)throw n.msg||Ls[n.err];return n.result}Kl.prototype.push=function(e,t){const n=this.strm,a=this.options.chunkSize;let r,i;if(this.ended)return!1;for(i=t===~~t?t:!0===t?Fl:kl,"string"==typeof e?n.input=Rl(e):"[object ArrayBuffer]"===Pl.call(e)?n.input=new Uint8Array(e):n.input=e,n.next_in=0,n.avail_in=n.input.length;;)if(0===n.avail_out&&(n.output=new Uint8Array(a),n.next_out=0,n.avail_out=a),(i===Ol||i===Dl)&&n.avail_out<=6)this.onData(n.output.subarray(0,n.next_out)),n.avail_out=0;else{if(r=Tl.deflate(n,i),r===Nl)return n.next_out>0&&this.onData(n.output.subarray(0,n.next_out)),r=Tl.deflateEnd(this.strm),this.onEnd(r),this.ended=!0,r===Gl;if(0!==n.avail_out){if(i>0&&n.next_out>0)this.onData(n.output.subarray(0,n.next_out)),n.avail_out=0;else if(0===n.avail_in)break}else this.onData(n.output)}return!0},Kl.prototype.onData=function(e){this.chunks.push(e)},Kl.prototype.onEnd=function(e){e===Gl&&(this.result=Ll(this.chunks)),this.chunks=[],this.err=e,this.msg=this.strm.msg};var ql={Deflate:Kl,deflate:zl,deflateRaw:function(e,t){return(t=t||{}).raw=!0,zl(e,t)},gzip:function(e,t){return(t=t||{}).gzip=!0,zl(e,t)},constants:Is};var Zl=function(e,t){let n,a,r,i,s,l,o,u,c,d,h,f,m,p,_,g,b,w,v,A,y,S,T,x;const E=e.state;n=e.next_in,T=e.input,a=n+(e.avail_in-5),r=e.next_out,x=e.output,i=r-(t-e.avail_out),s=r+(e.avail_out-257),l=E.dmax,o=E.wsize,u=E.whave,c=E.wnext,d=E.window,h=E.hold,f=E.bits,m=E.lencode,p=E.distcode,_=(1<<E.lenbits)-1,g=(1<<E.distbits)-1;e:do{f<15&&(h+=T[n++]<<f,f+=8,h+=T[n++]<<f,f+=8),b=m[h&_];t:for(;;){if(w=b>>>24,h>>>=w,f-=w,w=b>>>16&255,0===w)x[r++]=65535&b;else{if(!(16&w)){if(0==(64&w)){b=m[(65535&b)+(h&(1<<w)-1)];continue t}if(32&w){E.mode=12;break e}e.msg="invalid literal/length code",E.mode=30;break e}v=65535&b,w&=15,w&&(f<w&&(h+=T[n++]<<f,f+=8),v+=h&(1<<w)-1,h>>>=w,f-=w),f<15&&(h+=T[n++]<<f,f+=8,h+=T[n++]<<f,f+=8),b=p[h&g];n:for(;;){if(w=b>>>24,h>>>=w,f-=w,w=b>>>16&255,!(16&w)){if(0==(64&w)){b=p[(65535&b)+(h&(1<<w)-1)];continue n}e.msg="invalid distance code",E.mode=30;break e}if(A=65535&b,w&=15,f<w&&(h+=T[n++]<<f,f+=8,f<w&&(h+=T[n++]<<f,f+=8)),A+=h&(1<<w)-1,A>l){e.msg="invalid distance too far back",E.mode=30;break e}if(h>>>=w,f-=w,w=r-i,A>w){if(w=A-w,w>u&&E.sane){e.msg="invalid distance too far back",E.mode=30;break e}if(y=0,S=d,0===c){if(y+=o-w,w<v){v-=w;do{x[r++]=d[y++]}while(--w);y=r-A,S=x}}else if(c<w){if(y+=o+c-w,w-=c,w<v){v-=w;do{x[r++]=d[y++]}while(--w);if(y=0,c<v){w=c,v-=w;do{x[r++]=d[y++]}while(--w);y=r-A,S=x}}}else if(y+=c-w,w<v){v-=w;do{x[r++]=d[y++]}while(--w);y=r-A,S=x}for(;v>2;)x[r++]=S[y++],x[r++]=S[y++],x[r++]=S[y++],v-=3;v&&(x[r++]=S[y++],v>1&&(x[r++]=S[y++]))}else{y=r-A;do{x[r++]=x[y++],x[r++]=x[y++],x[r++]=x[y++],v-=3}while(v>2);v&&(x[r++]=x[y++],v>1&&(x[r++]=x[y++]))}break}}break}}while(n<a&&r<s);v=f>>3,n-=v,f-=v<<3,h&=(1<<f)-1,e.next_in=n,e.next_out=r,e.avail_in=n<a?a-n+5:5-(n-a),e.avail_out=r<s?s-r+257:257-(r-s),E.hold=h,E.bits=f};const jl=15,Xl=new Uint16Array([3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0]),$l=new Uint8Array([16,16,16,16,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,16,72,78]),Jl=new Uint16Array([1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577,0,0]),Wl=new Uint8Array([16,16,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,64,64]);var Ql=(e,t,n,a,r,i,s,l)=>{const o=l.bits;let u,c,d,h,f,m,p=0,_=0,g=0,b=0,w=0,v=0,A=0,y=0,S=0,T=0,x=null,E=0;const L=new Uint16Array(16),I=new Uint16Array(16);let U,R,M,C=null,B=0;for(p=0;p<=jl;p++)L[p]=0;for(_=0;_<a;_++)L[t[n+_]]++;for(w=o,b=jl;b>=1&&0===L[b];b--);if(w>b&&(w=b),0===b)return r[i++]=20971520,r[i++]=20971520,l.bits=1,0;for(g=1;g<b&&0===L[g];g++);for(w<g&&(w=g),y=1,p=1;p<=jl;p++)if(y<<=1,y-=L[p],y<0)return-1;if(y>0&&(0===e||1!==b))return-1;for(I[1]=0,p=1;p<jl;p++)I[p+1]=I[p]+L[p];for(_=0;_<a;_++)0!==t[n+_]&&(s[I[t[n+_]]++]=_);if(0===e?(x=C=s,m=19):1===e?(x=Xl,E-=257,C=$l,B-=257,m=256):(x=Jl,C=Wl,m=-1),T=0,_=0,p=g,f=i,v=w,A=0,d=-1,S=1<<w,h=S-1,1===e&&S>852||2===e&&S>592)return 1;for(;;){U=p-A,s[_]<m?(R=0,M=s[_]):s[_]>m?(R=C[B+s[_]],M=x[E+s[_]]):(R=96,M=0),u=1<<p-A,c=1<<v,g=c;do{c-=u,r[f+(T>>A)+c]=U<<24|R<<16|M|0}while(0!==c);for(u=1<<p-1;T&u;)u>>=1;if(0!==u?(T&=u-1,T+=u):T=0,_++,0==--L[p]){if(p===b)break;p=t[n+s[_]]}if(p>w&&(T&h)!==d){for(0===A&&(A=w),f+=g,v=p-A,y=1<<v;v+A<b&&(y-=L[v+A],!(y<=0));)v++,y<<=1;if(S+=1<<v,1===e&&S>852||2===e&&S>592)return 1;d=T&h,r[d]=w<<24|v<<16|f-i|0}}return 0!==T&&(r[f+T]=p-A<<24|64<<16|0),l.bits=w,0};const{Z_FINISH:eo,Z_BLOCK:to,Z_TREES:no,Z_OK:ao,Z_STREAM_END:ro,Z_NEED_DICT:io,Z_STREAM_ERROR:so,Z_DATA_ERROR:lo,Z_MEM_ERROR:oo,Z_BUF_ERROR:uo,Z_DEFLATED:co}=Is,ho=12,fo=30,mo=e=>(e>>>24&255)+(e>>>8&65280)+((65280&e)<<8)+((255&e)<<24);function po(){this.mode=0,this.last=!1,this.wrap=0,this.havedict=!1,this.flags=0,this.dmax=0,this.check=0,this.total=0,this.head=null,this.wbits=0,this.wsize=0,this.whave=0,this.wnext=0,this.window=null,this.hold=0,this.bits=0,this.length=0,this.offset=0,this.extra=0,this.lencode=null,this.distcode=null,this.lenbits=0,this.distbits=0,this.ncode=0,this.nlen=0,this.ndist=0,this.have=0,this.next=null,this.lens=new Uint16Array(320),this.work=new Uint16Array(288),this.lendyn=null,this.distdyn=null,this.sane=0,this.back=0,this.was=0}const _o=e=>{if(!e||!e.state)return so;const t=e.state;return e.total_in=e.total_out=t.total=0,e.msg="",t.wrap&&(e.adler=1&t.wrap),t.mode=1,t.last=0,t.havedict=0,t.dmax=32768,t.head=null,t.hold=0,t.bits=0,t.lencode=t.lendyn=new Int32Array(852),t.distcode=t.distdyn=new Int32Array(592),t.sane=1,t.back=-1,ao},go=e=>{if(!e||!e.state)return so;const t=e.state;return t.wsize=0,t.whave=0,t.wnext=0,_o(e)},bo=(e,t)=>{let n;if(!e||!e.state)return so;const a=e.state;return t<0?(n=0,t=-t):(n=1+(t>>4),t<48&&(t&=15)),t&&(t<8||t>15)?so:(null!==a.window&&a.wbits!==t&&(a.window=null),a.wrap=n,a.wbits=t,go(e))},wo=(e,t)=>{if(!e)return so;const n=new po;e.state=n,n.window=null;const a=bo(e,t);return a!==ao&&(e.state=null),a};let vo,Ao,yo=!0;const So=e=>{if(yo){vo=new Int32Array(512),Ao=new Int32Array(32);let t=0;for(;t<144;)e.lens[t++]=8;for(;t<256;)e.lens[t++]=9;for(;t<280;)e.lens[t++]=7;for(;t<288;)e.lens[t++]=8;for(Ql(1,e.lens,0,288,vo,0,e.work,{bits:9}),t=0;t<32;)e.lens[t++]=5;Ql(2,e.lens,0,32,Ao,0,e.work,{bits:5}),yo=!1}e.lencode=vo,e.lenbits=9,e.distcode=Ao,e.distbits=5},To=(e,t,n,a)=>{let r;const i=e.state;return null===i.window&&(i.wsize=1<<i.wbits,i.wnext=0,i.whave=0,i.window=new Uint8Array(i.wsize)),a>=i.wsize?(i.window.set(t.subarray(n-i.wsize,n),0),i.wnext=0,i.whave=i.wsize):(r=i.wsize-i.wnext,r>a&&(r=a),i.window.set(t.subarray(n-a,n-a+r),i.wnext),(a-=r)?(i.window.set(t.subarray(n-a,n),0),i.wnext=a,i.whave=i.wsize):(i.wnext+=r,i.wnext===i.wsize&&(i.wnext=0),i.whave<i.wsize&&(i.whave+=r))),0};var xo=(e,t)=>{let n,a,r,i,s,l,o,u,c,d,h,f,m,p,_,g,b,w,v,A,y,S,T=0;const x=new Uint8Array(4);let E,L;const I=new Uint8Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]);if(!e||!e.state||!e.output||!e.input&&0!==e.avail_in)return so;n=e.state,n.mode===ho&&(n.mode=13),s=e.next_out,r=e.output,o=e.avail_out,i=e.next_in,a=e.input,l=e.avail_in,u=n.hold,c=n.bits,d=l,h=o,S=ao;e:for(;;)switch(n.mode){case 1:if(0===n.wrap){n.mode=13;break}for(;c<16;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}if(2&n.wrap&&35615===u){n.check=0,x[0]=255&u,x[1]=u>>>8&255,n.check=Es(n.check,x,2,0),u=0,c=0,n.mode=2;break}if(n.flags=0,n.head&&(n.head.done=!1),!(1&n.wrap)||(((255&u)<<8)+(u>>8))%31){e.msg="incorrect header check",n.mode=fo;break}if((15&u)!==co){e.msg="unknown compression method",n.mode=fo;break}if(u>>>=4,c-=4,y=8+(15&u),0===n.wbits)n.wbits=y;else if(y>n.wbits){e.msg="invalid window size",n.mode=fo;break}n.dmax=1<<n.wbits,e.adler=n.check=1,n.mode=512&u?10:ho,u=0,c=0;break;case 2:for(;c<16;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}if(n.flags=u,(255&n.flags)!==co){e.msg="unknown compression method",n.mode=fo;break}if(57344&n.flags){e.msg="unknown header flags set",n.mode=fo;break}n.head&&(n.head.text=u>>8&1),512&n.flags&&(x[0]=255&u,x[1]=u>>>8&255,n.check=Es(n.check,x,2,0)),u=0,c=0,n.mode=3;case 3:for(;c<32;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}n.head&&(n.head.time=u),512&n.flags&&(x[0]=255&u,x[1]=u>>>8&255,x[2]=u>>>16&255,x[3]=u>>>24&255,n.check=Es(n.check,x,4,0)),u=0,c=0,n.mode=4;case 4:for(;c<16;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}n.head&&(n.head.xflags=255&u,n.head.os=u>>8),512&n.flags&&(x[0]=255&u,x[1]=u>>>8&255,n.check=Es(n.check,x,2,0)),u=0,c=0,n.mode=5;case 5:if(1024&n.flags){for(;c<16;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}n.length=u,n.head&&(n.head.extra_len=u),512&n.flags&&(x[0]=255&u,x[1]=u>>>8&255,n.check=Es(n.check,x,2,0)),u=0,c=0}else n.head&&(n.head.extra=null);n.mode=6;case 6:if(1024&n.flags&&(f=n.length,f>l&&(f=l),f&&(n.head&&(y=n.head.extra_len-n.length,n.head.extra||(n.head.extra=new Uint8Array(n.head.extra_len)),n.head.extra.set(a.subarray(i,i+f),y)),512&n.flags&&(n.check=Es(n.check,a,f,i)),l-=f,i+=f,n.length-=f),n.length))break e;n.length=0,n.mode=7;case 7:if(2048&n.flags){if(0===l)break e;f=0;do{y=a[i+f++],n.head&&y&&n.length<65536&&(n.head.name+=String.fromCharCode(y))}while(y&&f<l);if(512&n.flags&&(n.check=Es(n.check,a,f,i)),l-=f,i+=f,y)break e}else n.head&&(n.head.name=null);n.length=0,n.mode=8;case 8:if(4096&n.flags){if(0===l)break e;f=0;do{y=a[i+f++],n.head&&y&&n.length<65536&&(n.head.comment+=String.fromCharCode(y))}while(y&&f<l);if(512&n.flags&&(n.check=Es(n.check,a,f,i)),l-=f,i+=f,y)break e}else n.head&&(n.head.comment=null);n.mode=9;case 9:if(512&n.flags){for(;c<16;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}if(u!==(65535&n.check)){e.msg="header crc mismatch",n.mode=fo;break}u=0,c=0}n.head&&(n.head.hcrc=n.flags>>9&1,n.head.done=!0),e.adler=n.check=0,n.mode=ho;break;case 10:for(;c<32;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}e.adler=n.check=mo(u),u=0,c=0,n.mode=11;case 11:if(0===n.havedict)return e.next_out=s,e.avail_out=o,e.next_in=i,e.avail_in=l,n.hold=u,n.bits=c,io;e.adler=n.check=1,n.mode=ho;case ho:if(t===to||t===no)break e;case 13:if(n.last){u>>>=7&c,c-=7&c,n.mode=27;break}for(;c<3;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}switch(n.last=1&u,u>>>=1,c-=1,3&u){case 0:n.mode=14;break;case 1:if(So(n),n.mode=20,t===no){u>>>=2,c-=2;break e}break;case 2:n.mode=17;break;case 3:e.msg="invalid block type",n.mode=fo}u>>>=2,c-=2;break;case 14:for(u>>>=7&c,c-=7&c;c<32;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}if((65535&u)!=(u>>>16^65535)){e.msg="invalid stored block lengths",n.mode=fo;break}if(n.length=65535&u,u=0,c=0,n.mode=15,t===no)break e;case 15:n.mode=16;case 16:if(f=n.length,f){if(f>l&&(f=l),f>o&&(f=o),0===f)break e;r.set(a.subarray(i,i+f),s),l-=f,i+=f,o-=f,s+=f,n.length-=f;break}n.mode=ho;break;case 17:for(;c<14;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}if(n.nlen=257+(31&u),u>>>=5,c-=5,n.ndist=1+(31&u),u>>>=5,c-=5,n.ncode=4+(15&u),u>>>=4,c-=4,n.nlen>286||n.ndist>30){e.msg="too many length or distance symbols",n.mode=fo;break}n.have=0,n.mode=18;case 18:for(;n.have<n.ncode;){for(;c<3;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}n.lens[I[n.have++]]=7&u,u>>>=3,c-=3}for(;n.have<19;)n.lens[I[n.have++]]=0;if(n.lencode=n.lendyn,n.lenbits=7,E={bits:n.lenbits},S=Ql(0,n.lens,0,19,n.lencode,0,n.work,E),n.lenbits=E.bits,S){e.msg="invalid code lengths set",n.mode=fo;break}n.have=0,n.mode=19;case 19:for(;n.have<n.nlen+n.ndist;){for(;T=n.lencode[u&(1<<n.lenbits)-1],_=T>>>24,g=T>>>16&255,b=65535&T,!(_<=c);){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}if(b<16)u>>>=_,c-=_,n.lens[n.have++]=b;else{if(16===b){for(L=_+2;c<L;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}if(u>>>=_,c-=_,0===n.have){e.msg="invalid bit length repeat",n.mode=fo;break}y=n.lens[n.have-1],f=3+(3&u),u>>>=2,c-=2}else if(17===b){for(L=_+3;c<L;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}u>>>=_,c-=_,y=0,f=3+(7&u),u>>>=3,c-=3}else{for(L=_+7;c<L;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}u>>>=_,c-=_,y=0,f=11+(127&u),u>>>=7,c-=7}if(n.have+f>n.nlen+n.ndist){e.msg="invalid bit length repeat",n.mode=fo;break}for(;f--;)n.lens[n.have++]=y}}if(n.mode===fo)break;if(0===n.lens[256]){e.msg="invalid code -- missing end-of-block",n.mode=fo;break}if(n.lenbits=9,E={bits:n.lenbits},S=Ql(1,n.lens,0,n.nlen,n.lencode,0,n.work,E),n.lenbits=E.bits,S){e.msg="invalid literal/lengths set",n.mode=fo;break}if(n.distbits=6,n.distcode=n.distdyn,E={bits:n.distbits},S=Ql(2,n.lens,n.nlen,n.ndist,n.distcode,0,n.work,E),n.distbits=E.bits,S){e.msg="invalid distances set",n.mode=fo;break}if(n.mode=20,t===no)break e;case 20:n.mode=21;case 21:if(l>=6&&o>=258){e.next_out=s,e.avail_out=o,e.next_in=i,e.avail_in=l,n.hold=u,n.bits=c,Zl(e,h),s=e.next_out,r=e.output,o=e.avail_out,i=e.next_in,a=e.input,l=e.avail_in,u=n.hold,c=n.bits,n.mode===ho&&(n.back=-1);break}for(n.back=0;T=n.lencode[u&(1<<n.lenbits)-1],_=T>>>24,g=T>>>16&255,b=65535&T,!(_<=c);){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}if(g&&0==(240&g)){for(w=_,v=g,A=b;T=n.lencode[A+((u&(1<<w+v)-1)>>w)],_=T>>>24,g=T>>>16&255,b=65535&T,!(w+_<=c);){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}u>>>=w,c-=w,n.back+=w}if(u>>>=_,c-=_,n.back+=_,n.length=b,0===g){n.mode=26;break}if(32&g){n.back=-1,n.mode=ho;break}if(64&g){e.msg="invalid literal/length code",n.mode=fo;break}n.extra=15&g,n.mode=22;case 22:if(n.extra){for(L=n.extra;c<L;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}n.length+=u&(1<<n.extra)-1,u>>>=n.extra,c-=n.extra,n.back+=n.extra}n.was=n.length,n.mode=23;case 23:for(;T=n.distcode[u&(1<<n.distbits)-1],_=T>>>24,g=T>>>16&255,b=65535&T,!(_<=c);){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}if(0==(240&g)){for(w=_,v=g,A=b;T=n.distcode[A+((u&(1<<w+v)-1)>>w)],_=T>>>24,g=T>>>16&255,b=65535&T,!(w+_<=c);){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}u>>>=w,c-=w,n.back+=w}if(u>>>=_,c-=_,n.back+=_,64&g){e.msg="invalid distance code",n.mode=fo;break}n.offset=b,n.extra=15&g,n.mode=24;case 24:if(n.extra){for(L=n.extra;c<L;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}n.offset+=u&(1<<n.extra)-1,u>>>=n.extra,c-=n.extra,n.back+=n.extra}if(n.offset>n.dmax){e.msg="invalid distance too far back",n.mode=fo;break}n.mode=25;case 25:if(0===o)break e;if(f=h-o,n.offset>f){if(f=n.offset-f,f>n.whave&&n.sane){e.msg="invalid distance too far back",n.mode=fo;break}f>n.wnext?(f-=n.wnext,m=n.wsize-f):m=n.wnext-f,f>n.length&&(f=n.length),p=n.window}else p=r,m=s-n.offset,f=n.length;f>o&&(f=o),o-=f,n.length-=f;do{r[s++]=p[m++]}while(--f);0===n.length&&(n.mode=21);break;case 26:if(0===o)break e;r[s++]=n.length,o--,n.mode=21;break;case 27:if(n.wrap){for(;c<32;){if(0===l)break e;l--,u|=a[i++]<<c,c+=8}if(h-=o,e.total_out+=h,n.total+=h,h&&(e.adler=n.check=n.flags?Es(n.check,r,h,s-h):Ts(n.check,r,h,s-h)),h=o,(n.flags?u:mo(u))!==n.check){e.msg="incorrect data check",n.mode=fo;break}u=0,c=0}n.mode=28;case 28:if(n.wrap&&n.flags){for(;c<32;){if(0===l)break e;l--,u+=a[i++]<<c,c+=8}if(u!==(4294967295&n.total)){e.msg="incorrect length check",n.mode=fo;break}u=0,c=0}n.mode=29;case 29:S=ro;break e;case fo:S=lo;break e;case 31:return oo;default:return so}return e.next_out=s,e.avail_out=o,e.next_in=i,e.avail_in=l,n.hold=u,n.bits=c,(n.wsize||h!==e.avail_out&&n.mode<fo&&(n.mode<27||t!==eo))&&To(e,e.output,e.next_out,h-e.avail_out),d-=e.avail_in,h-=e.avail_out,e.total_in+=d,e.total_out+=h,n.total+=h,n.wrap&&h&&(e.adler=n.check=n.flags?Es(n.check,r,h,e.next_out-h):Ts(n.check,r,h,e.next_out-h)),e.data_type=n.bits+(n.last?64:0)+(n.mode===ho?128:0)+(20===n.mode||15===n.mode?256:0),(0===d&&0===h||t===eo)&&S===ao&&(S=uo),S},Eo={inflateReset:go,inflateReset2:bo,inflateResetKeep:_o,inflateInit:e=>wo(e,15),inflateInit2:wo,inflate:xo,inflateEnd:e=>{if(!e||!e.state)return so;let t=e.state;return t.window&&(t.window=null),e.state=null,ao},inflateGetHeader:(e,t)=>{if(!e||!e.state)return so;const n=e.state;return 0==(2&n.wrap)?so:(n.head=t,t.done=!1,ao)},inflateSetDictionary:(e,t)=>{const n=t.length;let a,r,i;return e&&e.state?(a=e.state,0!==a.wrap&&11!==a.mode?so:11===a.mode&&(r=1,r=Ts(r,t,n,0),r!==a.check)?lo:(i=To(e,t,n,n),i?(a.mode=31,oo):(a.havedict=1,ao))):so},inflateInfo:"pako inflate (from Nodeca project)"};var Lo=function(){this.text=0,this.time=0,this.xflags=0,this.os=0,this.extra=null,this.extra_len=0,this.name="",this.comment="",this.hcrc=0,this.done=!1};const Io=Object.prototype.toString,{Z_NO_FLUSH:Uo,Z_FINISH:Ro,Z_OK:Mo,Z_STREAM_END:Co,Z_NEED_DICT:Bo,Z_STREAM_ERROR:Po,Z_DATA_ERROR:ko,Z_MEM_ERROR:Oo}=Is;function Do(e){this.options=El({chunkSize:65536,windowBits:15,to:""},e||{});const t=this.options;t.raw&&t.windowBits>=0&&t.windowBits<16&&(t.windowBits=-t.windowBits,0===t.windowBits&&(t.windowBits=-15)),!(t.windowBits>=0&&t.windowBits<16)||e&&e.windowBits||(t.windowBits+=32),t.windowBits>15&&t.windowBits<48&&0==(15&t.windowBits)&&(t.windowBits|=15),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new Bl,this.strm.avail_out=0;let n=Eo.inflateInit2(this.strm,t.windowBits);if(n!==Mo)throw new Error(Ls[n]);if(this.header=new Lo,Eo.inflateGetHeader(this.strm,this.header),t.dictionary&&("string"==typeof t.dictionary?t.dictionary=Rl(t.dictionary):"[object ArrayBuffer]"===Io.call(t.dictionary)&&(t.dictionary=new Uint8Array(t.dictionary)),t.raw&&(n=Eo.inflateSetDictionary(this.strm,t.dictionary),n!==Mo)))throw new Error(Ls[n])}function Fo(e,t){const n=new Do(t);if(n.push(e),n.err)throw n.msg||Ls[n.err];return n.result}Do.prototype.push=function(e,t){const n=this.strm,a=this.options.chunkSize,r=this.options.dictionary;let i,s,l;if(this.ended)return!1;for(s=t===~~t?t:!0===t?Ro:Uo,"[object ArrayBuffer]"===Io.call(e)?n.input=new Uint8Array(e):n.input=e,n.next_in=0,n.avail_in=n.input.length;;){for(0===n.avail_out&&(n.output=new Uint8Array(a),n.next_out=0,n.avail_out=a),i=Eo.inflate(n,s),i===Bo&&r&&(i=Eo.inflateSetDictionary(n,r),i===Mo?i=Eo.inflate(n,s):i===ko&&(i=Bo));n.avail_in>0&&i===Co&&n.state.wrap>0&&0!==e[n.next_in];)Eo.inflateReset(n),i=Eo.inflate(n,s);switch(i){case Po:case ko:case Bo:case Oo:return this.onEnd(i),this.ended=!0,!1}if(l=n.avail_out,n.next_out&&(0===n.avail_out||i===Co))if("string"===this.options.to){let e=Cl(n.output,n.next_out),t=n.next_out-e,r=Ml(n.output,e);n.next_out=t,n.avail_out=a-t,t&&n.output.set(n.output.subarray(e,e+t),0),this.onData(r)}else this.onData(n.output.length===n.next_out?n.output:n.output.subarray(0,n.next_out));if(i!==Mo||0!==l){if(i===Co)return i=Eo.inflateEnd(this.strm),this.onEnd(i),this.ended=!0,!0;if(0===n.avail_in)break}}return!0},Do.prototype.onData=function(e){this.chunks.push(e)},Do.prototype.onEnd=function(e){e===Mo&&("string"===this.options.to?this.result=this.chunks.join(""):this.result=Ll(this.chunks)),this.chunks=[],this.err=e,this.msg=this.strm.msg};var Go={Inflate:Do,inflate:Fo,inflateRaw:function(e,t){return(t=t||{}).raw=!0,Fo(e,t)},ungzip:Fo,constants:Is};const{Deflate:No,deflate:Vo,deflateRaw:Ho,gzip:Yo}=ql,{Inflate:Ko,inflate:zo,inflateRaw:qo,ungzip:Zo}=Go;var jo=Vo,Xo=zo;class $o{constructor(e){this.ctype=0,this.outputPos=0,this.dsize_bits=0,this.dsize_mask=0,this.bit_buff=0,this.extra_bits=0,this.in_pos=0,this.out_buff=[],this.in_buff=e}}const Jo=new Uint8Array([2,4,4,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8]),Wo=new Uint8Array([3,13,5,25,9,17,1,62,30,46,14,54,22,38,6,58,26,42,10,50,18,34,66,2,124,60,92,28,108,44,76,12,116,52,84,20,100,36,68,4,120,56,88,24,104,40,72,8,240,112,176,48,208,80,144,16,224,96,160,32,192,64,128,0]),Qo=new Uint8Array([0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8]),eu=new Uint16Array([0,1,2,3,4,5,6,7,8,10,14,22,38,70,134,262]),tu=new Uint8Array([3,2,3,3,4,4,4,5,5,5,5,6,6,6,7,7]),nu=new Uint8Array([5,3,1,6,10,2,12,20,4,24,8,48,16,32,64,0]),au=new Uint8Array([11,12,12,12,12,12,12,12,12,8,7,12,12,7,12,12,12,12,12,12,12,12,12,12,12,12,13,12,12,12,12,12,4,10,8,12,10,12,10,8,7,7,8,9,7,6,7,8,7,6,7,7,7,7,8,7,7,8,8,12,11,7,9,11,12,6,7,6,6,5,7,8,8,6,11,9,6,7,6,6,7,11,6,6,6,7,9,8,9,9,11,8,11,9,12,8,12,5,6,6,6,5,6,6,6,5,11,7,5,6,5,5,6,10,5,5,5,5,8,7,8,8,10,11,11,12,12,12,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,12,13,13,13,12,13,13,13,12,13,13,13,13,12,13,13,13,12,12,12,13,13,13,13,13,13,13,13,13,13,13]),ru=new Uint16Array([1168,4064,2016,3040,992,3552,1504,2528,480,184,98,3808,1760,34,2784,736,3296,1248,2272,224,3936,1888,2912,864,3424,1376,4672,2400,352,3680,1632,2656,15,592,56,608,80,3168,912,216,66,2,88,432,124,41,60,152,92,9,28,108,44,76,24,12,116,232,104,1120,144,52,176,1808,2144,49,84,17,33,23,20,168,40,1,784,304,62,100,30,46,36,1296,14,54,22,68,48,200,464,208,272,72,1552,336,96,136,4e3,7,38,6,58,27,26,42,10,11,528,4,19,50,3,29,18,400,13,21,5,25,8,120,240,112,656,1040,16,1952,2976,928,576,7232,3136,5184,1088,6208,2112,4160,64,8064,3968,6016,1920,7040,2944,4992,896,7552,3456,5504,1408,6528,2432,4480,384,7808,3712,5760,1664,6784,2688,4736,640,7296,3200,5248,1152,6272,2176,4224,128,7936,3840,5888,1792,6912,2816,4864,3488,1440,2464,416,3744,1696,2720,672,3232,1184,2208,160,3872,1824,2848,800,3360,1312,2336,288,3616,1568,2592,544,3104,1056,2080,32,4032,1984,3008,960,3520,1472,2496,448,3776,1728,2752,704,3264,1216,2240,192,3904,1856,2880,832,768,3392,7424,3328,5376,1344,1280,6400,2304,2368,4352,256,7680,3584,320,5632,1536,6656,3648,1600,2624,2560,4608,512,7168,3072,5120,1024,6144,2048,4096,0]);let iu=!1;const su=new Uint8Array(256),lu=new Uint8Array(256);let ou=!1;const uu=new Uint8Array(256),cu=new Uint8Array(256),du=new Uint8Array(128),hu=new Uint8Array(256);function fu(e,t,n){for(let a=0,r=t.length;a<r;a++){const r=1<<n[a];for(let n=t[a];n<256;n+=r)e[n]=a}}function mu(e,t){return t<=e.extra_bits?(e.extra_bits-=t,e.bit_buff>>=t,0):(e.bit_buff>>=e.extra_bits,e.in_pos===e.in_buff.byteLength?1:(e.bit_buff|=e.in_buff[e.in_pos++]<<8,e.bit_buff>>=t-e.extra_bits,e.extra_bits=e.extra_bits-t+8,0))}function pu(e){if(1&e.bit_buff){if(mu(e,1))return 774;let t,n=lu[255&e.bit_buff];if(mu(e,tu[n]))return 774;if(0!=(t=Qo[n])){const a=e.bit_buff&(1<<t)-1;if(mu(e,t)&&n+a!=270)return 774;n=eu[n]+a}return n+256}if(mu(e,1))return 774;if(0==e.ctype){const t=255&e.bit_buff;return mu(e,8)?774:t}let t;if(255&e.bit_buff){if(t=uu[255&e.bit_buff],255==t)if(63&e.bit_buff){if(mu(e,4))return 774;t=cu[255&e.bit_buff]}else{if(mu(e,6))return 774;t=du[127&e.bit_buff]}}else{if(mu(e,8))return 774;t=hu[255&e.bit_buff]}return mu(e,au[t])?774:t}function _u(e,t){const n=su[255&e.bit_buff];if(mu(e,Jo[n]))return 0;let a;if(2==t){if(a=n<<2|3&e.bit_buff,mu(e,2))return 0}else if(a=n<<e.dsize_bits|e.bit_buff&e.dsize_mask,mu(e,e.dsize_bits))return 0;return a+1}function gu(e){const t=new $o(e);if(t.in_buff.byteLength<=4)throw new Error("Bad data");if(t.ctype=t.in_buff[0],t.dsize_bits=t.in_buff[1],t.bit_buff=t.in_buff[2],t.extra_bits=0,t.in_pos=3,4>t.dsize_bits||t.dsize_bits>6)throw new Error("Invalid dictionary size");if(t.dsize_mask=65535>>16-t.dsize_bits,0!==t.ctype){if(1!==t.ctype)throw new Error("Invalid mode");ou||(!function(){let e,t,n=255;for(let a=255;n>=0;n--,a--){const r=a;let i=au[r];if(i<=8){t=1<<i,e=ru[n];do{uu[e]=a,e+=t}while(e<256)}else if(0!=(e=255&ru[n]))if(uu[e]=255,63&ru[n]){i-=4,au[r]=i,t=1<<i,e=ru[n]>>4;do{cu[e]=a,e+=t}while(e<256)}else{i-=6,au[r]=i,t=1<<i,e=ru[n]>>6;do{du[e]=a,e+=t}while(e<128)}else{i-=8,au[r]=i,t=1<<i,e=ru[n]>>8;do{hu[e]=a,e+=t}while(e<256)}}}(),ou=!0)}if(iu||(fu(lu,nu,tu),fu(su,Wo,Jo),iu=!0),774===function(e){let t;for(;(t=pu(e))<773;)if(t>=256){let n,a=t-254;if(0==(n=_u(e,a)))return 774;let r=e.outputPos,i=r-n;for(e.outputPos+=a;a-- >0;)e.out_buff[r++]=e.out_buff[i++]}else e.out_buff[e.outputPos++]=t;return t}(t))throw new Error("Error while expanding");return new Uint8Array(t.out_buff)}function bu(e){let t=-1;for(let n=0,a=Math.ceil(e.byteLength/512);n<a;n++){const a=512*n;77===e[a]&&80===e[a+1]&&81===e[a+2]&&26===e[a+3]&&(t=a)}return t}function wu(e){return 72===e[0]&&77===e[1]&&51===e[2]&&87===e[3]||-1!==bu(e)}class vu{constructor(e,t,n,a,r){this.rawBuffer=null,this.buffer=null;const i=e.headerOffset;this.archive=e,this.c=e.c,this.name=`File${`${t.blockIndex}`.padStart(8,"0")}`,this.nameResolved=!1,this.hash=t,this.block=n,a&&(this.rawBuffer=a.slice(i+n.offset,i+n.offset+n.compressedSize)),r&&(this.buffer=r)}bytes(){return null===this.buffer&&this.decode(),this.buffer}arrayBuffer(){return this.bytes().buffer}text(){return Ma(this.bytes())}set(e){if(this.archive.readonly)return!1;const t=this.hash,n=this.block;return t.locale=0,t.platform=0,n.compressedSize=0,n.normalSize=e.byteLength,n.flags=0,this.buffer=e,this.rawBuffer=null,!0}delete(){if(this.archive.readonly)return!1;const e=this.archive,t=this.hash,n=t.blockIndex;t.delete();for(const t of e.hashTable.entries)t.blockIndex<Ei&&t.blockIndex>n&&(t.blockIndex-=1);return e.blockTable.entries.splice(n,1),e.files.splice(n,1),!0}rename(e){if(this.archive.readonly)return!1;const t=this.hash,n=t.locale,a=t.platform,r=t.blockIndex;t.delete();const i=this.archive.hashTable.add(e,r);return i.locale=n,i.platform=a,this.name=e,this.nameResolved=!0,this.hash=i,!0}decode(){if(!this.rawBuffer)throw new Error(`File ${this.name}: Nothing to decode`);const e=this.archive,t=this.block,n=e.c,a=n.computeFileKey(this.name,t),r=this.rawBuffer,i=t.flags;if(i===Ci)this.buffer=r.slice(0,t.normalSize);else if(i&Mi){let e;e=i&Ui?n.decryptBlock(r.slice(0,t.compressedSize),a):r.subarray(0,t.compressedSize),e=512&i?this.decompressSector(e,t.normalSize):e.slice(),this.buffer=e}else{const s=Math.ceil(t.normalSize/e.sectorSize),l=new Uint8Array(t.normalSize);let o=new Uint32Array(r.buffer,0,s+1);i&Ui&&(o=n.decryptBlock(o.slice(),a-1));let u=o[0],c=o[1],d=0;for(let h=0;h<s;h++){let f;if(f=i&Ui?n.decryptBlock(r.slice(u,c),a+h):r.subarray(u,c),512&i){let n=e.sectorSize;t.normalSize-d<n&&(n=t.normalSize-d),f=this.decompressSector(f,n)}256&i&&(f=gu(f)),l.set(f,d),d+=f.byteLength,h<s&&(u=c,c=o[h+2])}this.buffer=l}e.readonly&&(this.rawBuffer=null)}decompressSector(e,t){if(e.byteLength===t)return e;{const t=e[0];if(16&t)throw new Error(`File ${this.name}: compression type 'bzip2' not supported`);if(8&t)try{e=gu(e.subarray(1))}catch(e){throw new Error(`File ${this.name}: failed to decompress with 'explode': ${e}`)}if(2&t)try{e=Xo(e.subarray(1))}catch(e){throw new Error(`File ${this.name}: failed to decompress with 'zlib': ${e}`)}if(1&t)throw new Error(`File ${this.name}: compression type 'huffman' not supported`);if(128&t)throw new Error(`File ${this.name}: compression type 'adpcm stereo' not supported`);if(64&t)throw new Error(`File ${this.name}: compression type 'adpcm mono' not supported`);return e}}encode(){if(null!==this.buffer&&null===this.rawBuffer){const e=this.buffer;if(wu(e))this.rawBuffer=this.buffer,this.block.compressedSize=this.buffer.byteLength,this.block.flags=Ci;else{const t=this.archive.sectorSize,n=Math.ceil(e.byteLength/t),a=new Uint32Array(n+1);let r=a.byteLength;const i=[],s=[];a[0]=r;for(let l=0;l<n;l++){const n=l*t;let o=e.subarray(n,n+t),u=o.byteLength;const c=jo(o);let d=!1;c.byteLength+1<u&&(o=c,u=c.byteLength+1,d=!0),r+=u,a[l+1]=r,i[l]=o,s[l]=d}if(r<e.byteLength){const e=new Uint8Array(r);e.set(new Uint8Array(a.buffer)),r=a.byteLength;for(let t=0;t<n;t++){s[t]&&(e[r]=2,r+=1);const n=i[t];e.set(n,r),r+=n.byteLength}this.rawBuffer=e,this.block.compressedSize=e.byteLength,this.block.flags=2147484160}else this.rawBuffer=this.buffer,this.block.compressedSize=this.buffer.byteLength,this.block.flags=Ci}}}reEncrypt(e){if(!this.rawBuffer)return!1;const t=this.archive,n=this.block,a=t.c,r=this.rawBuffer,i=n.flags,s=a.computeFileKey(this.name,n);n.offset=e;const l=a.computeFileKey(this.name,n);if(i&Mi)a.decryptBlock(r,s),a.encryptBlock(r,l);else{const e=Math.ceil(n.normalSize/t.sectorSize),i=new Uint32Array(r.buffer,0,e+1);a.decryptBlock(i,s-1);let o=i[0],u=i[1];for(let t=0;t<e;t++){const n=r.subarray(o,u);a.decryptBlock(n,s+t),a.encryptBlock(n,l+t),t<e&&(o=u,u=i[t+2])}a.encryptBlock(i,l-1)}return!0}offsetChanged(e){const t=this.block;return t.offset!==e&&t.flags&Ri?!!this.nameResolved&&this.reEncrypt(e):(t.offset=e,!0)}}class Au{constructor(){this.nameA=4294967295,this.nameB=4294967295,this.locale=65535,this.platform=65535,this.blockIndex=Li}load(e){const t=e[2];this.nameA=e[0],this.nameB=e[1],this.locale=65535&t,this.platform=t>>>16,this.blockIndex=e[3]}copy(e){this.nameA=e.nameA,this.nameB=e.nameB,this.locale=e.locale,this.platform=e.platform,this.blockIndex=e.blockIndex}save(e){e[0]=this.nameA,e[1]=this.nameB,e[2]=this.locale<<16|this.platform,e[3]=this.blockIndex}delete(){this.nameA=4294967295,this.nameB=4294967295,this.locale=65535,this.platform=65535,this.blockIndex=Ei}}class yu{constructor(e){this.c=e,this.entries=[],this.addEmpties(4)}clear(){this.entries.length=0}addEmpties(e){for(let t=0;t<e;t++)this.entries.push(new Au)}getInsertionIndex(e){const t=this.entries,n=this.c.hash(e,0)&t.length-1;for(let e=0,a=t.length;e<a;e++){const r=(e+n)%a;if(65535===t[r].platform)return r}return-1}add(e,t){const n=this.getInsertionIndex(e);if(-1!==n){const a=this.entries[n];return a.nameA=this.c.hash(e,1),a.nameB=this.c.hash(e,2),a.locale=0,a.platform=0,a.blockIndex=t,a}}load(e){const t=e.byteLength/16,n=new Uint32Array(this.c.decryptBlock(e,xi).buffer);let a=0;this.clear(),this.addEmpties(t);for(const e of this.entries)e.load(n.subarray(a,a+4)),a+=4}save(e){const t=new Uint32Array(4*this.entries.length);let n=0;for(const e of this.entries)e.save(t.subarray(n,n+4)),n+=4;const a=new Uint8Array(t.buffer);this.c.encryptBlock(a,xi),e.set(a)}get(e){const t=this.c,n=this.entries,a=t.hash(e,0)&n.length-1,r=t.hash(e,1),i=t.hash(e,2);for(let e=0,t=n.length;e<t;e++){const s=n[(e+a)%t];if(r===s.nameA&&i===s.nameB)return s;if(4294967295===s.blockIndex)return null}return null}}class Su{constructor(){this.readonly=!1,this.headerOffset=0,this.sectorSize=4096,this.c=new Oi,this.hashTable=new yu(this.c),this.blockTable=new Bi(this.c),this.files=[]}load(e,t=!1){const n=ka(e);this.readonly=t;const a=bu(n);if(-1===a)throw new Error("No MPQ header");const r=new Uint32Array(n.buffer,a,8),i=r[3],s=sr(r[4]+a),l=sr(r[5]+a),o=r[6];let u=r[7];u>o&&(u=o),this.headerOffset=a,this.sectorSize=512*(1<<(i>>>16)),this.hashTable.load(n.slice(s,s+16*o)),this.blockTable.load(n.slice(l,l+16*u)),this.files.length=0;for(const e of this.hashTable.entries){const t=e.blockIndex;t<this.blockTable.entries.length&&(this.files[t]=new vu(this,e,this.blockTable.entries[t],n,null))}const c=this.get("(listfile)");if(c){const e=c.text();if(e)for(const t of e.split("\r\n"))this.get(t)}}save(){if(this.readonly)return null;const e=32;this.delete("(attributes)"),this.saveMemory(),this.set("(listfile)",this.getFileNames().join("\r\n"));let t=e;for(const e of this.files)if(e){if(!e.offsetChanged(t))return null;e.encode(),t+=e.block.compressedSize}const n=this.hashTable,a=this.blockTable,r=n.entries.length,i=a.entries.length,s=t-e,l=e+s+16*r+16*i,o=e+s,u=o+16*r,c=new Uint8Array(l),d=new Uint32Array(c.buffer,0,8);d[0]=441536589,d[1]=e,d[2]=l,d[3]=Math.log2(this.sectorSize/512)<<16,d[4]=o,d[5]=u,d[6]=r,d[7]=i,t=e;for(const e of this.files)e&&(e.rawBuffer&&c.set(e.rawBuffer,t),t+=e.block.compressedSize);return n.save(c.subarray(t,t+16*n.entries.length)),t+=16*n.entries.length,a.save(c.subarray(t,t+16*a.entries.length)),c}saveMemory(){if(this.readonly)return 0;const e=this.blockTable.entries,t=this.hashTable.entries;let n=e.length,a=0;for(;n--;){const r=e[n];if(0===r.normalSize)this.removeBlock(n),a+=r.compressedSize;else{let e=!1;for(const a of t)if(a.blockIndex===n){e=!0;break}e||(this.removeBlock(n),a+=r.compressedSize)}}return a}removeBlock(e){for(const t of this.hashTable.entries)t.blockIndex<Ei&&t.blockIndex>e&&(t.blockIndex-=1);this.blockTable.entries.splice(e,1)}getFileNames(){const e=[];for(const t of this.files)t&&""!==t.name&&e.push(t.name);return e}countUnresolved(){let e=0;for(const t of this.files)t.nameResolved||e++;return e}applyListfile(e){for(const t of e)this.get(t)}set(e,t){if(this.readonly)return!1;const n=ka(t);let a=this.get(e);if(a)a.set(n);else{const t=this.blockTable.entries.length,r=this.hashTable.add(e,t);if(!r)return!1;const i=this.blockTable.add(n);a=new vu(this,r,i,null,n),a.name=e,a.nameResolved=!0,this.files[t]=a}return!0}get(e){const t=this.hashTable.get(e);if(t){const n=t.blockIndex;if(n<Ei){const t=this.files[n];if(t)return t.name=e,t.nameResolved=!0,t}}return null}has(e){return!!this.get(e)}delete(e){if(this.readonly)return!1;const t=this.get(e);return!!t&&(t.delete(),!0)}rename(e,t){if(this.readonly)return!1;const n=this.get(e);return!!n&&(n.rename(t),!0)}resizeHashtable(e){if(this.readonly)return!1;e=Math.max(4,_a(e));const t=this.files;if(t.length>e)return!1;for(const e of t)if(!e.nameResolved)return!1;const n=this.hashTable,a=n.entries,r=a.slice();n.clear(),n.addEmpties(e);for(const e of r)if(e.blockIndex!==Li){const r=t[e.blockIndex];a[n.getInsertionIndex(r.name)].copy(e)}return!0}}const Tu={Archive:Su,Crypto:Oi,HashTable:yu,Hash:Au,BlockTable:Bi,Block:Ti,File:vu,isArchive:wu};class xu{constructor(){this.isCustom=0,this.path=""}load(e){this.isCustom=e.readUint8(),this.path=e.readNull()}save(e){e.writeUint8(this.isCustom),e.writeNull(this.path)}getByteLength(){return 2+Ba(this.path)}}class Eu{constructor(){this.version=1,this.entries=new Map}load(e){const t=new ur(e);this.version=t.readUint32();for(let e=0,n=t.readUint32();e<n;e++){const e=new xu;e.load(t),e.isCustom?this.entries.set(e.path,e):this.entries.set(`war3mapimported\\${e.path}`,e)}}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));e.writeUint32(this.version),e.writeUint32(this.entries.size);for(const t of this.entries.values())t.save(e);return e.uint8array}getByteLength(){let e=8;for(const t of this.entries.values())e+=t.getByteLength();return e}set(e){if(!this.entries.has(e)){const t=new xu;return t.isCustom=10,t.path=e,this.entries.set(e,t),!0}return!1}has(e){return this.entries.has(e)}delete(e){return this.entries.delete(e)}rename(e,t){const n=this.entries.get(e);return!!n&&(n.isCustom=10,n.path=t,!0)}}class Lu{constructor(){this.id="\0\0\0\0",this.variableType=0,this.levelOrVariation=0,this.dataPointer=0,this.value=0,this.u1=0}load(e,t){if(this.id=e.readBinary(4),this.variableType=e.readInt32(),t&&(this.levelOrVariation=e.readInt32(),this.dataPointer=e.readInt32()),0===this.variableType)this.value=e.readInt32();else if(1===this.variableType||2===this.variableType)this.value=e.readFloat32();else{if(3!==this.variableType)throw new Error(`Modification: unknown variable type ${this.variableType}`);this.value=e.readNull()}this.u1=e.readInt32()}save(e,t){if(e.writeBinary(this.id),e.writeInt32(this.variableType),t&&(e.writeInt32(this.levelOrVariation),e.writeInt32(this.dataPointer)),0===this.variableType)e.writeInt32(this.value);else if(1===this.variableType||2===this.variableType)e.writeFloat32(this.value);else{if(3!==this.variableType)throw new Error(`Modification: unknown variable type ${this.variableType}`);e.writeNull(this.value)}e.writeInt32(this.u1)}getByteLength(e){let t=12;return e&&(t+=8),3===this.variableType?t+=Ba(this.value)+1:t+=4,t}}class Iu{constructor(){this.oldId="\0\0\0\0",this.newId="\0\0\0\0",this.modifications=[]}load(e,t){this.oldId=e.readBinary(4),this.newId=e.readBinary(4);for(let n=0,a=e.readUint32();n<a;n++){const a=new Lu;a.load(e,t),this.modifications[n]=a}}save(e,t){"\0\0\0\0"!==this.oldId?e.writeBinary(this.oldId):e.writeUint32(0),"\0\0\0\0"!==this.newId?e.writeBinary(this.newId):e.writeUint32(0),e.writeUint32(this.modifications.length);for(const n of this.modifications)n.save(e,t)}getByteLength(e){let t=12;for(const n of this.modifications)t+=n.getByteLength(e);return t}}class Uu{constructor(){this.objects=[]}load(e,t){for(let n=0,a=e.readUint32();n<a;n++){const a=new Iu;a.load(e,t),this.objects[n]=a}}save(e,t){e.writeUint32(this.objects.length);for(const n of this.objects)n.save(e,t)}getByteLength(e){let t=4;for(const n of this.objects)t+=n.getByteLength(e);return t}}class Ru{constructor(){this.version=0,this.originalTable=new Uu,this.customTable=new Uu}load(e){let t;t=e instanceof ur?e:new ur(e),this.version=t.readInt32(),this.originalTable.load(t,!0),this.customTable.load(t,!0)}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));return e.writeInt32(this.version),this.originalTable.save(e,!0),this.customTable.save(e,!0),e.uint8array}getByteLength(){return 4+this.originalTable.getByteLength(!0)+this.customTable.getByteLength(!0)}}class Mu{constructor(){this.version=0,this.originalTable=new Uu,this.customTable=new Uu}load(e){let t;t=e instanceof ur?e:new ur(e),this.version=t.readInt32(),this.originalTable.load(t,!1),this.customTable.load(t,!1)}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));return e.writeInt32(this.version),this.originalTable.save(e,!1),this.customTable.save(e,!1),e.uint8array}getByteLength(){return 4+this.originalTable.getByteLength(!1)+this.customTable.getByteLength(!1)}}class Cu{constructor(){this.text=""}load(e){const t=e.readInt32();t&&(this.text=e.read(t-1),e.skip(1))}save(e){this.text.length?(e.writeInt32(Ba(this.text)+1),e.write(this.text),e.skip(1)):e.writeInt32(0)}getByteLength(){let e=4;return this.text.length&&(e+=Ba(this.text)+1),e}}class Bu{constructor(){this.version=0,this.comment="",this.trigger=new Cu,this.triggers=[]}load(e){const t=new ur(e);this.version=t.readInt32(),1===this.version&&(this.comment=t.readNull(),this.trigger.load(t));for(let e=0,n=t.readUint32();e<n;e++){const n=new Cu;n.load(t),this.triggers[e]=n}}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));e.writeInt32(this.version),1===this.version&&(e.writeNull(this.comment),this.trigger.save(e)),e.writeUint32(this.triggers.length);for(const t of this.triggers)t.save(e);return e.uint8array}getByteLength(){let e=8;1===this.version&&(e+=Ba(this.comment)+1+this.trigger.getByteLength());for(const t of this.triggers)e+=t.getByteLength();return e}}class Pu{constructor(){this.id=0,this.name="",this.isComment=0}load(e,t){this.id=e.readInt32(),this.name=e.readNull(),7===t&&(this.isComment=e.readInt32())}save(e,t){e.writeInt32(this.id),e.writeNull(this.name),7===t&&e.writeInt32(this.isComment)}getByteLength(e){let t=5+Ba(this.name);return 7===e&&(t+=4),t}}class ku{constructor(){this.name="",this.type="",this.u1=0,this.isArray=0,this.arraySize=0,this.isInitialized=0,this.initialValue=""}load(e,t){this.name=e.readNull(),this.type=e.readNull(),this.u1=e.readInt32(),this.isArray=e.readInt32(),7===t&&(this.arraySize=e.readInt32()),this.isInitialized=e.readInt32(),this.initialValue=e.readNull()}save(e,t){e.writeNull(this.name),e.writeNull(this.type),e.writeInt32(this.u1),e.writeInt32(this.isArray),7===t&&e.writeInt32(this.arraySize),e.writeInt32(this.isInitialized),e.writeNull(this.initialValue)}getByteLength(e){let t=15+Ba(this.name)+Ba(this.type)+Ba(this.initialValue);return 7===e&&(t+=4),t}}class Ou{constructor(){this.type=0,this.name="",this.beginParameters=0,this.parameters=[]}load(e,t,n){if(this.type=e.readInt32(),this.type<0||this.type>3)throw new Error(`SubParameters: Bad type: ${this.type}`);if(this.name=e.readNull(),0===this.name.length)throw new Error("SubParameters: Empty name");if(this.beginParameters=e.readInt32(),this.beginParameters){const a=n.getFunction(this.type,this.name);if(!a)throw new Error(`SubParameters "${this.name}:${this.type}": Unknown signature`);for(let r=0,i=a.args.length;r<i;r++){const a=new Du;try{a.load(e,t,n)}catch(e){throw new Error(`SubParameters "${this.name}": Parameter ${r}: ${e}`)}this.parameters[r]=a}}}save(e,t){e.writeInt32(this.type),e.writeNull(this.name),e.writeInt32(this.beginParameters);for(const n of this.parameters)n.save(e,t)}getByteLength(e){let t=9+Ba(this.name);if(this.parameters.length)for(const n of this.parameters)t+=n.getByteLength(e);return t}}class Du{constructor(){this.type=0,this.value="",this.subParameters=null,this.u1=0,this.isArray=0,this.arrayIndex=null}load(e,t,n){if(this.type=e.readInt32(),this.type<-1||this.type>3)throw new Error(`Parameter: Bad type: ${this.type}`);if(this.value=e.readNull(),e.readInt32()){const a=new Ou;try{a.load(e,t,n)}catch(e){throw new Error(`Parameter "${this.value}": SubParameters ${e}`)}this.subParameters=a}if((4===t&&2===this.type||7===t&&this.subParameters)&&(this.u1=e.readInt32()),(4===t&&2!==this.type||7===t)&&(this.isArray=e.readInt32()),this.isArray){const a=new Du;try{a.load(e,t,n)}catch(e){throw new Error(`Parameter "${this.value}": ArrayIndex: ${e}`)}this.arrayIndex=a}}save(e,t){e.writeInt32(this.type),e.writeNull(this.value),this.subParameters?(e.writeInt32(1),this.subParameters.save(e,t)):e.writeInt32(0),(4===t&&2===this.type||7===t&&this.subParameters)&&e.writeInt32(this.u1),(4===t&&2!==this.type||7===t)&&e.writeInt32(this.isArray),this.isArray&&this.arrayIndex&&this.arrayIndex.save(e,t)}getByteLength(e){let t=9+Ba(this.value);return this.subParameters&&(t+=this.subParameters.getByteLength(e)),(4===e&&2===this.type||7===e&&this.subParameters)&&(t+=4),(4===e&&2!==this.type||7===e)&&(t+=4),this.isArray&&this.arrayIndex&&(t+=this.arrayIndex.getByteLength(e)),t}}class Fu{constructor(){this.type=-1,this.group=-1,this.name="",this.isEnabled=0,this.parameters=[],this.ecas=[]}load(e,t,n,a){if(this.type=e.readInt32(),this.type<0||this.type>3)throw new Error(`ECA: Bad type: ${this.type}`);if(n&&(this.group=e.readUint32()),this.name=e.readNull(),0===this.name.length)throw new Error("ECA: Empty name");this.isEnabled=e.readInt32();const r=a.getFunction(this.type,this.name);if(!r)throw new Error(`ECA "${this.name}:${this.type}": Unknown signature`);for(let n=0,i=r.args.length;n<i;n++){const r=new Du;try{r.load(e,t,a)}catch(e){throw new Error(`ECA "${this.name}": Parameter ${n}: ${e}`)}this.parameters[n]=r}if(7===t)for(let n=0,r=e.readUint32();n<r;n++){const r=new Fu;try{r.load(e,t,!0,a)}catch(e){throw new Error(`ECA "${this.name}": Child ECA ${n} ${e}`)}this.ecas[n]=r}}save(e,t){e.writeInt32(this.type),-1!==this.group&&e.writeInt32(this.group),e.writeNull(this.name),e.writeInt32(this.isEnabled);for(const n of this.parameters)n.save(e,t);if(7===t){e.writeUint32(this.ecas.length);for(const n of this.ecas)n.save(e,t)}}getByteLength(e){let t=9+Ba(this.name);-1!==this.group&&(t+=4);for(const n of this.parameters)t+=n.getByteLength(e);if(7===e){t+=4;for(const n of this.ecas)t+=n.getByteLength(e)}return t}}class Gu{constructor(){this.name="",this.description="",this.isComment=0,this.isEnabled=0,this.isCustom=0,this.isInitiallyOff=0,this.runOnInitialization=0,this.category=0,this.ecas=[]}load(e,t,n){this.name=e.readNull(),this.description=e.readNull(),7===t&&(this.isComment=e.readInt32()),this.isEnabled=e.readInt32(),this.isCustom=e.readInt32(),this.isInitiallyOff=e.readInt32(),this.runOnInitialization=e.readInt32(),this.category=e.readInt32();for(let a=0,r=e.readUint32();a<r;a++){const r=new Fu;try{r.load(e,t,!1,n)}catch(e){throw new Error(`Trigger "${this.name}": ECA ${a}: ${e}`)}this.ecas[a]=r}}save(e,t){e.writeNull(this.name),e.writeNull(this.description),7===t&&e.writeInt32(this.isComment),e.writeInt32(this.isEnabled),e.writeInt32(this.isCustom),e.writeInt32(this.isInitiallyOff),e.writeInt32(this.runOnInitialization),e.writeInt32(this.category),e.writeUint32(this.ecas.length);for(const n of this.ecas)n.save(e,t)}getByteLength(e){let t=26+Ba(this.name)+Ba(this.description);7===e&&(t+=4);for(const n of this.ecas)t+=n.getByteLength(e);return t}}class Nu{constructor(){this.version=0,this.categories=[],this.u1=0,this.variables=[],this.triggers=[]}load(e,t){const n=new ur(e);if("WTG!"!==n.readBinary(4))throw new Error("Not a WTG file");this.version=n.readInt32();for(let e=0,t=n.readUint32();e<t;e++){const t=new Pu;t.load(n,this.version),this.categories[e]=t}this.u1=n.readInt32();for(let e=0,t=n.readUint32();e<t;e++){const t=new ku;t.load(n,this.version),this.variables[e]=t}for(let e=0,a=n.readUint32();e<a;e++){const a=new Gu;try{a.load(n,this.version,t)}catch(t){throw new Error(`Trigger ${e}: ${t}`)}this.triggers[e]=a}}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));e.writeBinary("WTG!"),e.writeInt32(this.version),e.writeUint32(this.categories.length);for(const t of this.categories)t.save(e,this.version);e.writeInt32(this.u1),e.writeUint32(this.variables.length);for(const t of this.variables)t.save(e,this.version);e.writeUint32(this.triggers.length);for(const t of this.triggers)t.save(e,this.version);return e.uint8array}getByteLength(){let e=24;const t=this.version;for(const n of this.categories)e+=n.getByteLength(t);for(const n of this.variables)e+=n.getByteLength(t);for(const n of this.triggers)e+=n.getByteLength(t);return e}}class Vu{constructor(){this.stringMap=new Map}load(e){const t=new Yr(e);let n;const a=e.indexOf("STRING");if(-1===a)throw new Error("Not a valid war3map.wts buffer");for(t.index=a;n=t.readToken();)if("STRING"===n){const n=t.readInt();t.read();const a=e.indexOf("}",t.index);if(-1===a)throw this.stringMap.set(n,e.slice(t.index,e.length).trim()),new Error(`WTS: missing data in string ${this.stringMap.size} (and maybe more)`);this.stringMap.set(n,e.slice(t.index,a).trim()),t.index=a}}save(){let e="";for(const[t,n]of this.stringMap)e+=`STRING ${t}\r\n{\r\n${n}\r\n}\r\n\r\n`;return e}getString(e){return"string"!=typeof e?this.stringMap.get(e):e.startsWith("TRIGSTR_")?this.stringMap.get(parseInt(e.slice(8))):void 0}setString(e,t){"string"==typeof e?e.startsWith("TRIGSTR_")&&this.stringMap.set(parseInt(e.slice(8)),t):this.stringMap.set(e,t)}}class Hu{constructor(){this.flags=0,this.playerMasks=0,this.name=""}load(e){this.flags=e.readUint32(),this.playerMasks=e.readUint32(),this.name=e.readNull()}save(e){e.writeUint32(this.flags),e.writeUint32(this.playerMasks),e.writeNull(this.name)}getByteLength(){return 9+Ba(this.name)}}class Yu{constructor(){this.id=0,this.type=0,this.race=0,this.isFixedStartPosition=0,this.name="",this.startLocation=new Float32Array(2),this.allyLowPriorities=0,this.allyHighPriorities=0,this.unknown1=new Uint8Array(8)}load(e,t){this.id=e.readInt32(),this.type=e.readInt32(),this.race=e.readInt32(),this.isFixedStartPosition=e.readInt32(),this.name=e.readNull(),e.readFloat32Array(this.startLocation),this.allyLowPriorities=e.readUint32(),this.allyHighPriorities=e.readUint32(),t>30&&e.readUint8Array(this.unknown1)}save(e,t){e.writeInt32(this.id),e.writeInt32(this.type),e.writeInt32(this.race),e.writeInt32(this.isFixedStartPosition),e.writeNull(this.name),e.writeFloat32Array(this.startLocation),e.writeUint32(this.allyLowPriorities),e.writeUint32(this.allyHighPriorities),t>30&&e.writeUint8Array(this.unknown1)}getByteLength(e){return(e>30?41:33)+Ba(this.name)}}class Ku{constructor(){this.chance=0,this.id="\0\0\0\0"}load(e){this.chance=e.readInt32(),this.id=e.readBinary(4)}save(e){e.writeInt32(this.chance),e.writeBinary(this.id)}}class zu{constructor(){this.items=[]}load(e){for(let t=0,n=e.readUint32();t<n;t++){const n=new Ku;n.load(e),this.items[t]=n}}save(e){e.writeUint32(this.items.length);for(const t of this.items)t.save(e)}getByteLength(){return 4+8*this.items.length}}class qu{constructor(){this.id=0,this.name="",this.sets=[]}load(e){this.id=e.readInt32(),this.name=e.readNull();for(let t=0,n=e.readUint32();t<n;t++){const n=new zu;n.load(e),this.sets[t]=n}}save(e){e.writeInt32(this.id),e.writeNull(this.name),e.writeUint32(this.sets.length);for(const t of this.sets)t.save(e)}getByteLength(){let e=9+Ba(this.name);for(const t of this.sets)e+=t.getByteLength();return e}}class Zu{constructor(){this.chance=0,this.ids=[]}load(e,t){this.chance=e.readInt32();for(let n=0;n<t;n++)this.ids[n]=e.readBinary(4)}save(e){e.writeInt32(this.chance);for(const t of this.ids)e.writeBinary(t)}}class ju{constructor(){this.id=0,this.name="",this.positions=0,this.columnTypes=new Int32Array(0),this.units=[]}load(e){this.id=e.readInt32(),this.name=e.readNull(),this.positions=e.readInt32(),this.columnTypes=e.readInt32Array(this.positions);for(let t=0,n=e.readUint32();t<n;t++){const n=new Zu;n.load(e,this.positions),this.units[t]=n}}save(e){e.writeInt32(this.id),e.writeNull(this.name),e.writeInt32(this.positions),e.writeInt32Array(this.columnTypes),e.writeUint32(this.units.length);for(const t of this.units)t.save(e)}getByteLength(){return 13+Ba(this.name)+this.columnTypes.byteLength+this.units.length*(4+4*this.positions)}}class Xu{constructor(){this.playerFlags=0,this.id="\0\0\0\0"}load(e){this.playerFlags=e.readUint32(),this.id=e.readBinary(4)}save(e){e.writeUint32(this.playerFlags),e.writeBinary(this.id)}}class $u{constructor(){this.playerFlags=0,this.id="\0\0\0\0",this.levelAffected=0,this.availability=0}load(e){this.playerFlags=e.readUint32(),this.id=e.readBinary(4),this.levelAffected=e.readInt32(),this.availability=e.readInt32()}save(e){e.writeUint32(this.playerFlags),e.writeBinary(this.id),e.writeInt32(this.levelAffected),e.writeInt32(this.availability)}}class Ju{constructor(){this.version=0,this.saves=0,this.editorVersion=0,this.buildVersion=new Uint32Array(4),this.name="",this.author="",this.description="",this.recommendedPlayers="",this.cameraBounds=new Float32Array(8),this.cameraBoundsComplements=new Int32Array(4),this.playableSize=new Int32Array(2),this.flags=0,this.tileset="A",this.campaignBackground=0,this.loadingScreenModel="",this.loadingScreenText="",this.loadingScreenTitle="",this.loadingScreenSubtitle="",this.loadingScreen=0,this.prologueScreenModel="",this.prologueScreenText="",this.prologueScreenTitle="",this.prologueScreenSubtitle="",this.useTerrainFog=0,this.fogHeight=new Float32Array(2),this.fogDensity=0,this.fogColor=new Uint8Array(4),this.globalWeather=0,this.soundEnvironment="",this.lightEnvironmentTileset="\0",this.waterVertexColor=new Uint8Array(4),this.scriptMode=0,this.graphicsMode=0,this.players=[],this.forces=[],this.upgradeAvailabilityChanges=[],this.techAvailabilityChanges=[],this.randomUnitTables=[],this.randomItemTables=[],this.unknown1=0}load(e){const t=new ur(e);this.version=t.readInt32(),this.saves=t.readInt32(),this.editorVersion=t.readInt32(),this.version>27&&t.readUint32Array(this.buildVersion),this.name=t.readNull(),this.author=t.readNull(),this.description=t.readNull(),this.recommendedPlayers=t.readNull(),t.readFloat32Array(this.cameraBounds),t.readInt32Array(this.cameraBoundsComplements),t.readInt32Array(this.playableSize),this.flags=t.readUint32(),this.tileset=t.readBinary(1),this.campaignBackground=t.readInt32(),this.version>24&&(this.loadingScreenModel=t.readNull()),this.loadingScreenText=t.readNull(),this.loadingScreenTitle=t.readNull(),this.loadingScreenSubtitle=t.readNull(),this.loadingScreen=t.readInt32(),this.version>24&&(this.prologueScreenModel=t.readNull()),this.prologueScreenText=t.readNull(),this.prologueScreenTitle=t.readNull(),this.prologueScreenSubtitle=t.readNull(),this.version>24&&(this.useTerrainFog=t.readInt32(),t.readFloat32Array(this.fogHeight),this.fogDensity=t.readFloat32(),t.readUint8Array(this.fogColor),this.globalWeather=t.readInt32(),this.soundEnvironment=t.readNull(),this.lightEnvironmentTileset=t.readBinary(1),t.readUint8Array(this.waterVertexColor)),this.version>27&&(this.scriptMode=t.readUint32()),this.version>30&&(this.graphicsMode=t.readUint32(),this.unknown1=t.readUint32());for(let e=0,n=t.readInt32();e<n;e++){const n=new Yu;n.load(t,this.version),this.players[e]=n}for(let e=0,n=t.readInt32();e<n;e++){const n=new Hu;n.load(t),this.forces[e]=n}for(let e=0,n=t.readInt32();e<n;e++){const n=new $u;n.load(t),this.upgradeAvailabilityChanges[e]=n}for(let e=0,n=t.readInt32();e<n;e++){const n=new Xu;n.load(t),this.techAvailabilityChanges[e]=n}for(let e=0,n=t.readInt32();e<n;e++){const n=new ju;n.load(t),this.randomUnitTables[e]=n}if(this.version>24)for(let e=0,n=t.readInt32();e<n;e++){const n=new qu;n.load(t),this.randomItemTables[e]=n}}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));e.writeInt32(this.version),e.writeInt32(this.saves),e.writeInt32(this.editorVersion),this.version>27&&e.writeUint32Array(this.buildVersion),e.writeNull(this.name),e.writeNull(this.author),e.writeNull(this.description),e.writeNull(this.recommendedPlayers),e.writeFloat32Array(this.cameraBounds),e.writeInt32Array(this.cameraBoundsComplements),e.writeInt32Array(this.playableSize),e.writeUint32(this.flags),e.writeBinary(this.tileset),e.writeInt32(this.campaignBackground),this.version>24&&e.writeNull(this.loadingScreenModel),e.writeNull(this.loadingScreenText),e.writeNull(this.loadingScreenTitle),e.writeNull(this.loadingScreenSubtitle),e.writeInt32(this.loadingScreen),this.version>24&&e.writeNull(this.prologueScreenModel),e.writeNull(this.prologueScreenText),e.writeNull(this.prologueScreenTitle),e.writeNull(this.prologueScreenSubtitle),this.version>24&&(e.writeInt32(this.useTerrainFog),e.writeFloat32Array(this.fogHeight),e.writeFloat32(this.fogDensity),e.writeUint8Array(this.fogColor),e.writeInt32(this.globalWeather),e.writeNull(this.soundEnvironment),e.writeBinary(this.lightEnvironmentTileset),e.writeUint8Array(this.waterVertexColor)),this.version>27&&e.writeUint32(this.scriptMode),this.version>30&&(e.writeUint32(this.graphicsMode),e.writeUint32(this.unknown1)),e.writeUint32(this.players.length);for(const t of this.players)t.save(e,this.version);e.writeUint32(this.forces.length);for(const t of this.forces)t.save(e);e.writeUint32(this.upgradeAvailabilityChanges.length);for(const t of this.upgradeAvailabilityChanges)t.save(e);e.writeUint32(this.techAvailabilityChanges.length);for(const t of this.techAvailabilityChanges)t.save(e);e.writeUint32(this.randomUnitTables.length);for(const t of this.randomUnitTables)t.save(e);if(this.version>24){e.writeUint32(this.randomItemTables.length);for(const t of this.randomItemTables)t.save(e)}return e.uint8array}getByteLength(){let e=111+Ba(this.name)+Ba(this.author)+Ba(this.description)+Ba(this.recommendedPlayers)+Ba(this.loadingScreenText)+Ba(this.loadingScreenTitle)+Ba(this.loadingScreenSubtitle)+Ba(this.prologueScreenText)+Ba(this.prologueScreenTitle)+Ba(this.prologueScreenSubtitle);for(const t of this.players)e+=t.getByteLength(this.version);for(const t of this.forces)e+=t.getByteLength();e+=16*this.upgradeAvailabilityChanges.length,e+=8*this.techAvailabilityChanges.length;for(const t of this.randomUnitTables)e+=t.getByteLength();if(this.version>24){e+=36+Ba(this.loadingScreenModel)+Ba(this.prologueScreenModel)+Ba(this.soundEnvironment);for(const t of this.randomItemTables)e+=t.getByteLength()}return this.version>27&&(e+=20),this.version>30&&(e+=8),e}getBuildVersion(){return 100*this.buildVersion[0]+this.buildVersion[1]}}class Wu{constructor(){this.u1=0,this.name="",this.flags=0,this.maxPlayers=0,this.archive=new Su,this.imports=new Eu,this.readonly=!1}load(e,t=!1){const n=new ur(e);"HM3W"===n.readBinary(4)&&(this.u1=n.readUint32(),this.name=n.readNull(),this.flags=n.readUint32(),this.maxPlayers=n.readUint32()),this.readonly=t,this.archive.load(e,t),this.readImports()}save(){if(this.readonly)return null;this.setImportsFile();const e=this.archive.save();if(!e)return null;const t=this.getMapInformation();if(!t||t.getBuildVersion()<131){const t=new Uint8Array(512+e.byteLength),n=new ur(t);return n.writeBinary("HM3W"),n.writeUint32(this.u1),n.writeNull(this.name),n.writeUint32(this.flags),n.writeUint32(this.maxPlayers),t.set(e,512),t}return e}getFileNames(){return this.archive.getFileNames()}getImportNames(){const e=[];for(const t of this.imports.entries.values()){const n=t.isCustom;10===n||13===n?e.push(t.path):e.push(`war3mapImported\\${t.path}`)}return e}setImportsFile(){return!this.readonly&&(this.imports.entries.size>0&&this.set("war3map.imp",this.imports.save()))}import(e,t){return!this.readonly&&(!!this.archive.set(e,t)&&(this.imports.set(e),!0))}set(e,t){return!this.readonly&&this.archive.set(e,t)}get(e){return this.archive.get(e)}getScriptFile(){return this.get("war3map.j")||this.get("scripts\\war3map.j")||this.get("war3map.lua")||this.get("scripts\\war3map.lua")}has(e){return this.archive.has(e)}delete(e){return!this.readonly&&(this.imports.delete(e),this.archive.delete(e))}rename(e,t){return!this.readonly&&(!!this.archive.rename(e,t)&&(this.imports.rename(e,t),!0))}getMapInformation(){const e=this.archive.get("war3map.w3i");if(!e)throw new Error("File does not exist");const t=new Ju;return t.load(e.bytes()),t}readImports(){const e=this.archive.get("war3map.imp");if(e){const t=e.arrayBuffer();t&&this.imports.load(t)}}readTriggers(e){const t=this.archive.get("war3map.wtg");if(t){const n=t.arrayBuffer();if(n){const t=new Nu;return t.load(n,e),t}}}readCustomTextTriggers(){const e=this.archive.get("war3map.wct");if(e){const t=e.arrayBuffer();if(t){const e=new Bu;return e.load(t),e}}}readStringTable(){const e=this.archive.get("war3map.wts");if(e){const t=e.text();if(t){const e=new Vu;return e.load(t),e}}}readModifications(){const e={},t=["w3u","w3t","w3b","w3d","w3a","w3h","w3q"],n=[!1,!1,!1,!0,!0,!1,!0];for(let a=0,r=t.length;a<r;a++){const r=this.archive.get(`war3map.${t[a]}`);if(r){const i=r.arrayBuffer();if(i){let r;r=n[a]?new Ru:new Mu,r.load(i),e[t[a]]=r}}}return e}}class Qu{constructor(){this.id="\0\0\0\0",this.chance=0}load(e){this.id=e.readBinary(4),this.chance=e.readInt32()}save(e){e.writeBinary(this.id),e.writeInt32(this.chance)}}class ec{constructor(){this.items=[]}load(e){for(let t=0,n=e.readUint32();t<n;t++){const t=new Qu;t.load(e),this.items.push(t)}}save(e){e.writeUint32(this.items.length);for(const t of this.items)t.save(e)}getByteLength(){return 4+8*this.items.length}}class tc{constructor(){this.id="\0\0\0\0",this.variation=0,this.location=new Float32Array(3),this.angle=0,this.scale=new Float32Array([1,1,1]),this.skin="\0\0\0\0",this.flags=0,this.life=0,this.itemTable=-1,this.itemSets=[],this.editorId=0,this.u1=new Uint8Array(8)}load(e,t,n){if(this.id=e.readBinary(4),this.variation=e.readInt32(),e.readFloat32Array(this.location),this.angle=e.readFloat32(),e.readFloat32Array(this.scale),n>131&&(this.skin=e.readBinary(4)),this.flags=e.readUint8(),this.life=e.readUint8(),t>7){this.itemTable=e.readUint32();for(let t=0,n=e.readUint32();t<n;t++){const t=new ec;t.load(e),this.itemSets.push(t)}}this.editorId=e.readInt32()}save(e,t,n){if(e.writeBinary(this.id),e.writeInt32(this.variation),e.writeFloat32Array(this.location),e.writeFloat32(this.angle),e.writeFloat32Array(this.scale),n>131&&e.writeBinary(this.skin),e.writeUint8(this.flags),e.writeUint8(this.life),t>7){e.writeUint32(this.itemTable),e.writeUint32(this.itemSets.length);for(const t of this.itemSets)t.save(e)}e.writeInt32(this.editorId)}getByteLength(e,t){let n=42;if(t>131&&(n+=4),e>7){n+=8;for(const e of this.itemSets)n+=e.getByteLength()}return n}}class nc{constructor(){this.id="\0\0\0\0",this.u1=0,this.location=new Uint32Array(2)}load(e,t){this.id=e.readBinary(4),this.u1=e.readUint32(),e.readUint32Array(this.location)}save(e,t){e.writeBinary(this.id),e.writeUint32(this.u1),e.writeUint32Array(this.location)}}class ac{constructor(){this.version=0,this.u1=new Uint8Array(4),this.doodads=[],this.u2=new Uint8Array(4),this.terrainDoodads=[]}load(e,t){const n=new ur(e);if("W3do"!==n.readBinary(4))throw new Error("Not a valid war3map.doo buffer");this.version=n.readInt32(),n.readUint8Array(this.u1);for(let e=0,a=n.readInt32();e<a;e++){const e=new tc;e.load(n,this.version,t),this.doodads.push(e)}n.readUint8Array(this.u2);for(let e=0,t=n.readInt32();e<t;e++){const e=new nc;e.load(n,this.version),this.terrainDoodads.push(e)}}save(e){const t=new ur(new ArrayBuffer(this.getByteLength(e)));t.writeBinary("W3do"),t.writeInt32(this.version),t.writeUint8Array(this.u1),t.writeUint32(this.doodads.length);for(const n of this.doodads)n.save(t,this.version,e);t.writeUint8Array(this.u2),t.writeUint32(this.terrainDoodads.length);for(const e of this.terrainDoodads)e.save(t,this.version);return t.uint8array}getByteLength(e){let t=24+16*this.terrainDoodads.length;for(const n of this.doodads)t+=n.getByteLength(this.version,e);return t}}const rc={File:ac,Doodad:tc,RandomItemSet:ec,RandomItem:Qu,TerrainDoodad:nc},ic={File:Eu,Import:xu};class sc{constructor(){this.type=0,this.location=new Int32Array(2),this.color=new Uint8Array(4)}load(e){this.type=e.readInt32(),e.readInt32Array(this.location),e.readUint8Array(this.color)}save(e){e.writeInt32(this.type),e.writeInt32Array(this.location),e.writeUint8Array(this.color)}}const lc={File:class{constructor(){this.u1=0,this.icons=[]}load(e){const t=new ur(e);this.u1=t.readInt32();for(let e=0,n=t.readInt32();e<n;e++){const n=new sc;n.load(t),this.icons[e]=n}}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));e.writeInt32(this.u1),e.writeUint32(this.icons.length);for(const t of this.icons)t.save(e);return e.uint8array}getByteLength(){return 8+16*this.icons.length}},MinimapIcon:sc};const oc={File:class{constructor(){this.shadows=new Uint8Array(0)}load(e,t,n){this.shadows=new Uint8Array(e.slice(0,t*n*16))}save(){return this.shadows.slice()}getByteLength(){return this.shadows.length}}};class uc{constructor(){this.targetLocation=new Float32Array(3),this.rotation=0,this.angleOfAttack=0,this.distance=0,this.roll=0,this.fieldOfView=0,this.farClippingPlane=0,this.nearClippingPlane=0,this.cinematicName="",this.localPitch=0,this.localYaw=0,this.localRoll=0}load(e,t){e.readFloat32Array(this.targetLocation),this.rotation=e.readFloat32(),this.angleOfAttack=e.readFloat32(),this.distance=e.readFloat32(),this.roll=e.readFloat32(),this.fieldOfView=e.readFloat32(),this.farClippingPlane=e.readFloat32(),this.nearClippingPlane=e.readFloat32(),this.cinematicName=e.readNull(),t>131&&(this.localPitch=e.readFloat32(),this.localYaw=e.readFloat32(),this.localRoll=e.readFloat32())}save(e,t){e.writeFloat32Array(this.targetLocation),e.writeFloat32(this.rotation),e.writeFloat32(this.angleOfAttack),e.writeFloat32(this.distance),e.writeFloat32(this.roll),e.writeFloat32(this.fieldOfView),e.writeFloat32(this.farClippingPlane),e.writeFloat32(this.nearClippingPlane),e.writeNull(this.cinematicName),t>131&&(e.writeFloat32(this.localPitch),e.writeFloat32(this.localYaw),e.writeFloat32(this.localRoll))}getByteLength(e){let t=41+Ba(this.cinematicName);return e>131&&(t+=12),t}}const cc={File:class{constructor(){this.version=0,this.cameras=[]}load(e,t){const n=new ur(e);this.version=n.readInt32();for(let e=0,a=n.readUint32();e<a;e++){const a=new uc;a.load(n,t),this.cameras[e]=a}}save(e){const t=new ur(new ArrayBuffer(this.getByteLength(e)));t.writeInt32(this.version),t.writeUint32(this.cameras.length);for(const n of this.cameras)n.save(t,e);return t.uint8array}getByteLength(e){let t=8;for(const n of this.cameras)t+=n.getByteLength(e);return t}},Camera:uc},dc={File:Ru};class hc{constructor(){this.groundHeight=0,this.waterHeight=0,this.mapEdge=0,this.ramp=0,this.blight=0,this.water=0,this.boundary=0,this.groundTexture=0,this.cliffVariation=0,this.groundVariation=0,this.cliffTexture=0,this.layerHeight=0}load(e){this.groundHeight=(e.readInt16()-8192)/512;const t=e.readInt16();this.waterHeight=((16383&t)-8192)/512,this.mapEdge=16384&t;const n=e.readUint8();this.ramp=16&n,this.blight=32&n,this.water=64&n,this.boundary=128&n,this.groundTexture=15&n;const a=e.readUint8();this.cliffVariation=(224&a)>>>5,this.groundVariation=31&a;const r=e.readUint8();this.cliffTexture=(240&r)>>>4,this.layerHeight=15&r}save(e){e.writeInt16(512*this.groundHeight+8192),e.writeInt16(512*this.waterHeight+8192+this.mapEdge<<14),e.writeUint8(this.ramp<<4|this.blight<<5|this.water<<6|this.boundary<<7|this.groundTexture),e.writeUint8(this.cliffVariation<<5|this.groundVariation),e.writeUint8((this.cliffTexture<<4)+this.layerHeight)}}class fc{constructor(){this.version=0,this.tileset="A",this.haveCustomTileset=0,this.groundTilesets=[],this.cliffTilesets=[],this.mapSize=new Int32Array(2),this.centerOffset=new Float32Array(2),this.corners=[]}load(e){const t=new ur(e);if("W3E!"===t.readBinary(4)){this.version=t.readInt32(),this.tileset=t.readBinary(1),this.haveCustomTileset=t.readInt32();for(let e=0,n=t.readInt32();e<n;e++)this.groundTilesets[e]=t.readBinary(4);for(let e=0,n=t.readInt32();e<n;e++)this.cliffTilesets[e]=t.readBinary(4);t.readInt32Array(this.mapSize),t.readFloat32Array(this.centerOffset);for(let e=0,n=this.mapSize[1];e<n;e++){this.corners[e]=[];for(let n=0,a=this.mapSize[0];n<a;n++){const a=new hc;a.load(t),this.corners[e][n]=a}}}}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));e.writeBinary("W3E!"),e.writeInt32(this.version),e.writeBinary(this.tileset),e.writeInt32(this.haveCustomTileset),e.writeUint32(this.groundTilesets.length);for(const t of this.groundTilesets)e.writeBinary(t);e.writeUint32(this.cliffTilesets.length);for(const t of this.cliffTilesets)e.writeBinary(t);e.writeInt32Array(this.mapSize),e.writeFloat32Array(this.centerOffset);for(const t of this.corners)for(const n of t)n.save(e);return e.uint8array}getByteLength(){return 37+4*this.groundTilesets.length+4*this.cliffTilesets.length+this.mapSize[0]*this.mapSize[1]*7}}const mc={File:fc,Corner:hc},pc={File:Ju,Player:Yu,Force:Hu,UpgradeAvailabilityChange:$u,TechAvailabilityChange:Xu,RandomUnitTable:ju,RandomUnit:Zu,RandomItemTable:qu,RandomItemSet:zu,RandomItem:Ku};const _c={File:class{constructor(){this.version=0,this.units=null,this.items=null,this.destructables=null,this.doodads=null,this.abilities=null,this.buffs=null,this.upgrades=null}load(e){const t=new ur(e);this.version=t.readInt32(),t.readInt32()&&(this.units=new Mu,this.units.load(t)),t.readInt32()&&(this.items=new Mu,this.items.load(t)),t.readInt32()&&(this.destructables=new Mu,this.destructables.load(t)),t.readInt32()&&(this.doodads=new Ru,this.doodads.load(t)),t.readInt32()&&(this.abilities=new Ru,this.abilities.load(t)),t.readInt32()&&(this.buffs=new Mu,this.buffs.load(t)),t.readInt32()&&(this.upgrades=new Ru,this.upgrades.load(t))}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));return e.writeInt32(this.version),this.units?(e.writeInt32(1),e.writeUint8Array(this.units.save())):e.writeInt32(0),this.items?(e.writeInt32(1),e.writeUint8Array(this.items.save())):e.writeInt32(0),this.destructables?(e.writeInt32(1),e.writeUint8Array(this.destructables.save())):e.writeInt32(0),this.doodads?(e.writeInt32(1),e.writeUint8Array(this.doodads.save())):e.writeInt32(0),this.abilities?(e.writeInt32(1),e.writeUint8Array(this.abilities.save())):e.writeInt32(0),this.buffs?(e.writeInt32(1),e.writeUint8Array(this.buffs.save())):e.writeInt32(0),this.upgrades?(e.writeInt32(1),e.writeUint8Array(this.upgrades.save())):e.writeInt32(0),e.uint8array}getByteLength(){let e=32;return this.units&&(e+=this.units.getByteLength()),this.items&&(e+=this.items.getByteLength()),this.destructables&&(e+=this.destructables.getByteLength()),this.doodads&&(e+=this.doodads.getByteLength()),this.abilities&&(e+=this.abilities.getByteLength()),this.buffs&&(e+=this.buffs.getByteLength()),this.upgrades&&(e+=this.upgrades.getByteLength()),e}}};class gc{constructor(){this.left=0,this.right=0,this.bottom=0,this.top=0,this.name="",this.creationNumber=0,this.weatherEffectId="\0\0\0\0",this.ambientSound="",this.color=new Uint8Array(4)}load(e){this.left=e.readFloat32(),this.right=e.readFloat32(),this.bottom=e.readFloat32(),this.top=e.readFloat32(),this.name=e.readNull(),this.creationNumber=e.readUint32(),this.weatherEffectId=e.readBinary(4),this.ambientSound=e.readNull(),e.readUint8Array(this.color)}save(e){e.writeFloat32(this.left),e.writeFloat32(this.right),e.writeFloat32(this.bottom),e.writeFloat32(this.top),e.writeNull(this.name),e.writeUint32(this.creationNumber),this.weatherEffectId?e.writeBinary(this.weatherEffectId):e.writeUint32(0),e.writeNull(this.ambientSound),e.writeUint8Array(this.color)}getByteLength(){return 30+Ba(this.name)+Ba(this.ambientSound)}}const bc={File:class{constructor(){this.version=0,this.regions=[]}load(e){const t=new ur(e);this.version=t.readInt32();for(let e=0,n=t.readUint32();e<n;e++){const n=new gc;n.load(t),this.regions[e]=n}}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));e.writeInt32(this.version),e.writeUint32(this.regions.length);for(const t of this.regions)t.save(e);return e.uint8array}getByteLength(){let e=8;for(const t of this.regions)e+=t.getByteLength();return e}},Region:gc};class wc{constructor(){this.name="",this.file="",this.eaxEffect="",this.flags=0,this.fadeInRate=0,this.fadeOutRate=0,this.volume=0,this.pitch=0,this.pitchVariance=0,this.priority=0,this.channel=0,this.minDistance=0,this.maxDistance=0,this.distanceCutoff=0,this.coneInside=0,this.coneOutside=0,this.coneOutsideVolume=0,this.coneOrientationX=0,this.coneOrientationY=0,this.coneOrientationZ=0}load(e,t){this.name=e.readNull(),this.file=e.readNull(),this.eaxEffect=e.readNull(),this.flags=e.readUint32(),this.fadeInRate=e.readInt32(),this.fadeOutRate=e.readInt32(),this.volume=e.readInt32(),this.pitch=e.readFloat32(),this.pitchVariance=e.readFloat32(),this.priority=e.readInt32(),this.channel=e.readInt32(),this.minDistance=e.readFloat32(),this.maxDistance=e.readFloat32(),this.distanceCutoff=e.readFloat32(),this.coneInside=e.readFloat32(),this.coneOutside=e.readFloat32(),this.coneOutsideVolume=e.readInt32(),this.coneOrientationX=e.readFloat32(),this.coneOrientationY=e.readFloat32(),this.coneOrientationZ=e.readFloat32()}save(e,t){e.writeNull(this.name),e.writeNull(this.file),e.writeNull(this.eaxEffect),e.writeUint32(this.flags),e.writeUint32(this.fadeInRate),e.writeUint32(this.fadeOutRate),e.writeUint32(this.volume),e.writeFloat32(this.pitch),e.writeFloat32(this.pitchVariance),e.writeInt32(this.priority),e.writeInt32(this.channel),e.writeFloat32(this.minDistance),e.writeFloat32(this.maxDistance),e.writeFloat32(this.distanceCutoff),e.writeFloat32(this.coneInside),e.writeFloat32(this.coneOutside),e.writeInt32(this.coneOutsideVolume),e.writeFloat32(this.coneOrientationX),e.writeFloat32(this.coneOrientationY),e.writeFloat32(this.coneOrientationZ)}getByteLength(e){return 71+Ba(this.name)+Ba(this.file)+Ba(this.eaxEffect)}}class vc{constructor(){this.version=0,this.sounds=[]}load(e){const t=new ur(e);this.version=t.readInt32();for(let e=0,n=t.readUint32();e<n;e++){const n=new wc;n.load(t,this.version),this.sounds[e]=n}}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));e.writeInt32(this.version),e.writeUint32(this.sounds.length);for(const t of this.sounds)t.save(e,this.version);return e.uint8array}getByteLength(){let e=8;for(const t of this.sounds)e+=t.getByteLength(this.version);return e}}const Ac={File:vc,Sound:wc},yc={File:Mu,ModificationTable:Uu,ModificationObject:Iu,Modification:Lu},Sc={File:Bu,CustomTextTrigger:Cu};const Tc={File:class{constructor(){this.version=0,this.size=new Int32Array(2),this.pathing=new Uint8Array(0)}load(e){const t=new ur(e);"MP3W"===t.readBinary(4)&&(this.version=t.readInt32(),t.readInt32Array(this.size),this.pathing=t.readUint8Array(this.size[0]*this.size[1]))}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));return e.writeBinary("MP3W"),e.writeInt32(this.version),e.writeInt32Array(this.size),e.writeUint8Array(this.pathing),e.uint8array}getByteLength(){return 16+this.size[0]*this.size[1]}}};class xc{constructor(e){this.buffer=e,this.index=0}read(){const e=this.buffer,t=e.length;let n=!1,a=!1,r=!1,i="";for(;this.index<t;){const s=e[this.index++];if(n)"\n"===s&&(n=!1,this.index--);else if(a){if(i+="\\"===s?s+e[this.index++]:"\n"===s?"\\n":"\r"===s?"\\r":s,'"'===s)return i}else if(r){if(i+=s,"'"===s)return i}else if(" "===s||"\t"===s){if(i.length)return i}else if("("===s||")"===s||"["===s||"]"===s||"="===s||"\r"===s||"\n"===s||","===s||"!"===s||"-"===s||"<"===s||">"===s||"+"===s||"*"===s||"/"===s){if(i.length)return this.index--,i;{const t=e[this.index];if("="===s&&"="===t)return this.index++,"==";if("\r"===s)return"\n"===t&&this.index++,"\n";if("!"===s&&"="===t)return this.index++,"!=";if("/"!==s||"/"!==t)return s;if(i.length)return this.index--,i;n=!0}}else if('"'===s){if(i.length)return this.index--,i;i+=s,a=!0}else if("'"===s){if(i.length)return this.index--,i;i+=s,r=!0}else i+=s;if(this.index===t)return i}}peek(){const e=this.index,t=this.read();return this.index=e,t}readSafe(){const e=this.read();if(void 0===e)throw new Error("Premature end of stream reached");return"null"===e?"nil":"!="===e?"~=":"'"===e[0]?`${function(e){let t=0;for(const n of e)t=256*t+n.charCodeAt(0);return t}(e.slice(1,e.indexOf("'",1)))}`:"break"===e||"do"===e||"end"===e||"for"===e||"goto"===e||"in"===e||"nil"===e||"repeat"===e||"until"===e||"while"===e?e+"_":"and"===e||"or"===e?" "+e+" ":"$"===e[0]?"0x"+e.slice(1):e}readUntil(e){let t,n="";for(;(t=this.readSafe())!==e;)n+=t;return n}}const Ec={File:Nu,TriggerCategory:Pu,Variable:ku,Trigger:Gu,ECA:Fu,Parameter:Du,SubParameters:Ou,TriggerData:class{constructor(){this.types={},this.functions=[{},{},{},{}],this.presets={},this.externalTypes={},this.externalFunctions=[{},{},{},{}],this.externalPresets={}}addTriggerData(e,t){let n=this.types,a=this.functions,r=this.presets;t&&(n=this.externalTypes,a=this.externalFunctions,r=this.externalPresets);const i=new wr;i.load(e);let s=i.getSection("TriggerTypes");s&&this.addTriggerTypes(n,s),s=i.getSection("TriggerEvents"),s&&this.addTriggerDataFunctions(a[0],s,1),s=i.getSection("TriggerConditions"),s&&this.addTriggerDataFunctions(a[1],s,1),s=i.getSection("TriggerActions"),s&&this.addTriggerDataFunctions(a[2],s,1),s=i.getSection("TriggerCalls"),s&&this.addTriggerDataFunctions(a[3],s,3),s=i.getSection("TriggerParams"),s&&this.addTriggerDataPresets(r,s)}addTriggerTypes(e,t){for(const[n,a]of t){const t=a.split(",");e[n.toLowerCase()]=t[4]||""}}addTriggerDataFunctions(e,t,n){for(const[a,r]of t)if("_"!==a[0]){const i=r.split(","),s=[],l=t.get(`_${a}_scriptname`)||null;let o=null;3===n&&(o=i[2]);for(let e=n,t=i.length;e<t;e++){const t=i[e];Number.isNaN(parseFloat(t))&&"nothing"!==t&&""!==t&&s.push(t)}e[a.toLowerCase()]={args:s,scriptName:l,returnType:o}}}addTriggerDataPresets(e,t){for(const[n,a]of t){const t=a.split(",");e[n.toLowerCase()]=t[2].replace(/"/g,"").replace(/`/g,'"')}}addJassFunctions(e){const t=new xc(e);let n;for(;void 0!==(n=t.read());)if("native"===n||"function"===n){const e=t.read();if(e&&(n=t.read(),"takes"===n)){const n=[],a=t.readSafe();if("nothing"!==a)for(n.push(a),t.readSafe();","===t.read();)n.push(t.readSafe()),t.readSafe();else t.read();let r=t.readSafe();"nothing"===r&&(r=null);const i=e.toLowerCase(),s={args:n,scriptName:e,returnType:r};this.externalFunctions[2][i]=s,"nothing"!==r&&(this.externalFunctions[3][i]=s)}}}getBaseType(e){e=e.toLowerCase();let t=this.types[e];return void 0===t&&(t=this.externalTypes[e]),""===t||void 0===t?e:t}isBaseFunction(e,t){return t=t.toLowerCase(),!!this.functions[e][t]}getFunction(e,t){t=t.toLowerCase();let n=this.functions[e][t];return n||(n=this.externalFunctions[e][t]),n}getFunctionType(e){e=e.toLowerCase();const t=this.functions;for(let n=0;n<4;n++)if(t[n][e])return n;return-1}getPreset(e){e=e.toLowerCase();let t=this.presets[e];return void 0===t&&(t=this.externalPresets[e]),t}isCustomPreset(e){if(e=e.toLowerCase(),void 0!==this.presets[e])return!1;if(void 0!==this.externalPresets[e])return!0;throw new Error(`Failed to find a preset: ${e}`)}}},Lc={File:Vu};class Ic{constructor(){this.id="\0\0\0\0",this.chance=0}load(e){this.id=e.readBinary(4),this.chance=e.readInt32()}save(e){e.writeBinary(this.id),e.writeInt32(this.chance)}}class Uc{constructor(){this.items=[]}load(e){for(let t=0,n=e.readInt32();t<n;t++){const n=new Ic;n.load(e),this.items[t]=n}}save(e){e.writeInt32(this.items.length);for(const t of this.items)t.save(e)}getByteLength(){return 4+8*this.items.length}}class Rc{constructor(){this.slot=0,this.id="\0\0\0\0"}load(e){this.slot=e.readInt32(),this.id=e.readBinary(4)}save(e){e.writeInt32(this.slot),e.writeBinary(this.id)}}class Mc{constructor(){this.id="\0\0\0\0",this.activeForAutocast=0,this.heroLevel=1}load(e){this.id=e.readBinary(4),this.activeForAutocast=e.readInt32(),this.heroLevel=e.readInt32()}save(e){e.writeBinary(this.id),e.writeInt32(this.activeForAutocast),e.writeInt32(this.heroLevel)}}class Cc{constructor(){this.id="\0\0\0\0",this.chance=0}load(e){this.id=e.readBinary(4),this.chance=e.readInt32()}save(e){e.writeBinary(this.id),e.writeInt32(this.chance)}}class Bc{constructor(){this.id="\0\0\0\0",this.variation=0,this.location=new Float32Array(3),this.angle=0,this.scale=new Float32Array([1,1,1]),this.skin="\0\0\0\0",this.flags=0,this.player=0,this.unknown=0,this.hitpoints=-1,this.mana=-1,this.droppedItemTable=0,this.droppedItemSets=[],this.goldAmount=0,this.targetAcquisition=0,this.heroLevel=0,this.heroStrength=0,this.heroAgility=0,this.heroIntelligence=0,this.itemsInInventory=[],this.modifiedAbilities=[],this.randomFlag=0,this.level=new Uint8Array(3),this.itemClass=0,this.unitGroup=0,this.positionInGroup=0,this.randomUnitTables=[],this.customTeamColor=0,this.waygate=0,this.creationNumber=0}load(e,t,n,a){this.id=e.readBinary(4),this.variation=e.readInt32(),e.readFloat32Array(this.location),this.angle=e.readFloat32(),e.readFloat32Array(this.scale),a>131&&(this.skin=e.readBinary(4)),this.flags=e.readUint8(),this.player=e.readInt32(),this.unknown=e.readUint16(),this.hitpoints=e.readInt32(),this.mana=e.readInt32(),n>10&&(this.droppedItemTable=e.readInt32());for(let t=0,n=e.readInt32();t<n;t++){const n=new Uc;n.load(e),this.droppedItemSets[t]=n}this.goldAmount=e.readInt32(),this.targetAcquisition=e.readFloat32(),this.heroLevel=e.readInt32(),n>10&&(this.heroStrength=e.readInt32(),this.heroAgility=e.readInt32(),this.heroIntelligence=e.readInt32());for(let t=0,n=e.readInt32();t<n;t++){const n=new Rc;n.load(e),this.itemsInInventory[t]=n}for(let t=0,n=e.readInt32();t<n;t++){const n=new Mc;n.load(e),this.modifiedAbilities[t]=n}if(this.randomFlag=e.readInt32(),0===this.randomFlag)e.readUint8Array(this.level),this.itemClass=e.readUint8();else if(1===this.randomFlag)this.unitGroup=e.readUint32(),this.positionInGroup=e.readUint32();else if(2===this.randomFlag)for(let t=0,n=e.readInt32();t<n;t++){const n=new Cc;n.load(e),this.randomUnitTables[t]=n}this.customTeamColor=e.readInt32(),this.waygate=e.readInt32(),this.creationNumber=e.readInt32()}save(e,t,n,a){e.writeBinary(this.id),e.writeInt32(this.variation),e.writeFloat32Array(this.location),e.writeFloat32(this.angle),e.writeFloat32Array(this.scale),a>131&&e.writeBinary(this.skin),e.writeUint8(this.flags),e.writeInt32(this.player),e.writeUint16(this.unknown),e.writeInt32(this.hitpoints),e.writeInt32(this.mana),n>10&&e.writeInt32(this.droppedItemTable),e.writeInt32(this.droppedItemSets.length);for(const t of this.droppedItemSets)t.save(e);e.writeInt32(this.goldAmount),e.writeFloat32(this.targetAcquisition),e.writeInt32(this.heroLevel),n>10&&(e.writeInt32(this.heroStrength),e.writeInt32(this.heroAgility),e.writeInt32(this.heroIntelligence)),e.writeInt32(this.itemsInInventory.length);for(const t of this.itemsInInventory)t.save(e);e.writeInt32(this.modifiedAbilities.length);for(const t of this.modifiedAbilities)t.save(e);if(e.writeInt32(this.randomFlag),0===this.randomFlag)e.writeUint8Array(this.level),e.writeUint8(this.itemClass);else if(1===this.randomFlag)e.writeUint32(this.unitGroup),e.writeUint32(this.positionInGroup);else if(2===this.randomFlag){e.writeInt32(this.randomUnitTables.length);for(const t of this.randomUnitTables)t.save(e)}e.writeInt32(this.customTeamColor),e.writeInt32(this.waygate),e.writeInt32(this.creationNumber)}getByteLength(e,t,n){let a=91;n>131&&(a+=4),t>10&&(a+=16);for(const e of this.droppedItemSets)a+=e.getByteLength();return a+=8*this.itemsInInventory.length,a+=12*this.modifiedAbilities.length,0===this.randomFlag?a+=4:1===this.randomFlag?a+=8:2===this.randomFlag&&(a+=4+8*this.randomUnitTables.length),a}}class Pc{constructor(){this.version=8,this.subversion=11,this.units=[]}load(e,t){const n=new ur(e);if("W3do"!==n.readBinary(4))throw new Error("Not a valid war3mapUnits.doo buffer");this.version=n.readInt32(),this.subversion=n.readUint32();for(let e=0,a=n.readInt32();e<a;e++){const a=new Bc;a.load(n,this.version,this.subversion,t),this.units[e]=a}}save(e){const t=new ur(new ArrayBuffer(this.getByteLength(e)));t.writeBinary("W3do"),t.writeInt32(this.version),t.writeUint32(this.subversion),t.writeInt32(this.units.length);for(const n of this.units)n.save(t,this.version,this.subversion,e);return t.uint8array}getByteLength(e){let t=16;for(const n of this.units)t+=n.getByteLength(this.version,this.subversion,e);return t}}const kc={File:Pc,Unit:Bc,DroppedItemSet:Uc,DroppedItem:Ic,InventoryItem:Rc,ModifiedAbility:Mc,RandomUnit:Cc};class Oc{constructor(){this.visible=0,this.chapterTitle="",this.mapTitle="",this.path=""}load(e){this.visible=e.readInt32(),this.chapterTitle=e.readNull(),this.mapTitle=e.readNull(),this.path=e.readNull()}save(e){e.writeInt32(this.visible),e.writeNull(this.chapterTitle),e.writeNull(this.mapTitle),e.writeNull(this.path)}getByteLength(){return 7+Ba(this.chapterTitle)+Ba(this.mapTitle)+Ba(this.path)}}class Dc{constructor(){this.u1=0,this.path=""}load(e){this.u1=e.readInt8(),this.path=e.readNull()}save(e){e.writeInt8(this.u1),e.writeNull(this.path)}getByteLength(){return 2+Ba(this.path)}}const Fc={File:class{constructor(){this.version=0,this.campaignVersion=0,this.editorVersion=0,this.name="",this.difficulty="",this.author="",this.description="",this.mode=-1,this.backgroundScreen=-1,this.backgroundScreenPath="",this.minimapImagePath="",this.ambientSound=0,this.ambientSoundPath="",this.terrainFog=0,this.fogStartZ=0,this.fogEndZ=0,this.fogDensity=0,this.fogColor=new Uint8Array(4),this.userInterface=-1,this.mapTitles=[],this.mapOrders=[]}load(e){const t=new ur(e);this.version=t.readInt32(),this.campaignVersion=t.readInt32(),this.editorVersion=t.readInt32(),this.name=t.readNull(),this.difficulty=t.readNull(),this.author=t.readNull(),this.description=t.readNull(),this.mode=t.readInt32(),this.backgroundScreen=t.readInt32(),this.backgroundScreenPath=t.readNull(),this.minimapImagePath=t.readNull(),this.ambientSound=t.readInt32(),this.ambientSoundPath=t.readNull(),this.terrainFog=t.readInt32(),this.fogStartZ=t.readFloat32(),this.fogEndZ=t.readFloat32(),this.fogDensity=t.readFloat32(),t.readUint8Array(this.fogColor),this.userInterface=t.readInt32();for(let e=0,n=t.readUint32();e<n;e++){const n=new Oc;n.load(t),this.mapTitles[e]=n}for(let e=0,n=t.readUint32();e<n;e++){const n=new Dc;n.load(t),this.mapOrders[e]=n}}save(){const e=new ur(new ArrayBuffer(this.getByteLength()));e.writeInt32(this.version),e.writeInt32(this.campaignVersion),e.writeInt32(this.editorVersion),e.writeNull(this.name),e.writeNull(this.difficulty),e.writeNull(this.author),e.writeNull(this.description),e.writeInt32(this.mode),e.writeInt32(this.backgroundScreen),e.writeNull(this.backgroundScreenPath),e.writeNull(this.minimapImagePath),e.writeInt32(this.ambientSound),e.writeNull(this.ambientSoundPath),e.writeInt32(this.terrainFog),e.writeFloat32(this.fogStartZ),e.writeFloat32(this.fogEndZ),e.writeFloat32(this.fogDensity),e.writeUint8Array(this.fogColor),e.writeInt32(this.userInterface),e.writeUint32(this.mapTitles.length);for(const t of this.mapTitles)t.save(e);e.writeUint32(this.mapOrders.length);for(const t of this.mapOrders)t.save(e);return e.uint8array}getByteLength(){let e=63+Ba(this.name)+Ba(this.difficulty)+Ba(this.author)+Ba(this.description)+Ba(this.backgroundScreenPath)+Ba(this.minimapImagePath)+Ba(this.ambientSoundPath);for(const t of this.mapTitles)e+=t.getByteLength();for(const t of this.mapOrders)e+=t.getByteLength();return e}},MapTitle:Oc,MapOrder:Dc},Gc={Map:Wu,doo:rc,imp:ic,mmp:lc,shd:oc,w3c:cc,w3d:dc,w3e:mc,w3i:pc,w3o:_c,w3r:bc,w3s:Ac,w3u:yc,wct:Sc,wpm:Tc,wtg:Ec,wts:Lc,unitsdoo:kc,w3f:Fc};function Nc(e,t){return((1<<t)-1)/((1<<e)-1)}let Vc="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},Hc=function(){function e(e){this.message="JPEG error: "+e}return e.prototype=new Error,e.prototype.name="JpegError",e.constructor=e,e}(),Yc=new Uint8Array([0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5,12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28,35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63]),Kc=4017,zc=799,qc=3406,Zc=2276,jc=1567,Xc=3784,$c=5793,Jc=2896;function Wc(e,t){let n,a,r=0,i=[],s=16;for(;s>0&&!e[s-1];)s--;i.push({children:[],index:0});let l,o=i[0];for(n=0;n<s;n++){for(a=0;a<e[n];a++){for(o=i.pop(),o.children[o.index]=t[r];o.index>0;)o=i.pop();for(o.index++,i.push(o);i.length<=n;)i.push(l={children:[],index:0}),o.children[o.index]=l.children,o=l;r++}n+1<s&&(i.push(l={children:[],index:0}),o.children[o.index]=l.children,o=l)}return i[0].children}function Qc(e,t,n){return 64*((e.blocksPerLine+1)*t+n)}function ed(e,t,n,a,r,i,s,l,o){let u=n.mcusPerLine,c=n.progressive,d=t,h=0,f=0;function m(){if(f>0)return f--,h>>f&1;if(h=e[t++],255===h){let n=e[t++];if(n)throw new Hc("unexpected marker "+(h<<8|n).toString(16))}return f=7,h>>>7}function p(e){let t=e;for(;;){if(t=t[m()],"number"==typeof t)return t;if("object"!==(void 0===t?"undefined":Vc(t)))throw new Hc("invalid huffman sequence")}}function _(e){let t=0;for(;e>0;)t=t<<1|m(),e--;return t}function g(e){if(1===e)return 1===m()?1:-1;let t=_(e);return t>=1<<e-1?t:t+(-1<<e)+1}let b=0;let w,v=0;function A(e,t,n,a,r){let i=n%u;t(e,Qc(e,(n/u|0)*e.v+a,i*e.h+r))}function y(e,t,n){t(e,Qc(e,n/e.blocksPerLine|0,n%e.blocksPerLine))}let S,T,x,E,L,I,U=a.length;I=c?0===i?0===l?function(e,t){let n=p(e.huffmanTableDC),a=0===n?0:g(n)<<o;e.blockData[t]=e.pred+=a}:function(e,t){e.blockData[t]|=m()<<o}:0===l?function(e,t){if(b>0)return void b--;let n=i,a=s;for(;n<=a;){let a=p(e.huffmanTableAC),r=15&a,i=a>>4;if(0===r){if(i<15){b=_(i)+(1<<i)-1;break}n+=16;continue}n+=i;let s=Yc[n];e.blockData[t+s]=g(r)*(1<<o),n++}}:function(e,t){let n,a,r=i,l=s,u=0;for(;r<=l;){let i=Yc[r];switch(v){case 0:if(a=p(e.huffmanTableAC),n=15&a,u=a>>4,0===n)u<15?(b=_(u)+(1<<u),v=4):(u=16,v=1);else{if(1!==n)throw new Hc("invalid ACn encoding");w=g(n),v=u?2:3}continue;case 1:case 2:e.blockData[t+i]?e.blockData[t+i]+=m()<<o:(u--,0===u&&(v=2===v?3:0));break;case 3:e.blockData[t+i]?e.blockData[t+i]+=m()<<o:(e.blockData[t+i]=w<<o,v=0);break;case 4:e.blockData[t+i]&&(e.blockData[t+i]+=m()<<o)}r++}4===v&&(b--,0===b&&(v=0))}:function(e,t){let n=p(e.huffmanTableDC),a=0===n?0:g(n);e.blockData[t]=e.pred+=a;let r=1;for(;r<64;){let n=p(e.huffmanTableAC),a=15&n,i=n>>4;if(0===a){if(i<15)break;r+=16;continue}r+=i;let s=Yc[r];e.blockData[t+s]=g(a),r++}};let R,M,C,B,P=0;for(M=1===U?a[0].blocksPerLine*a[0].blocksPerColumn:u*n.mcusPerColumn;P<M;){let n=r?Math.min(M-P,r):M;for(T=0;T<U;T++)a[T].pred=0;if(b=0,1===U)for(S=a[0],L=0;L<n;L++)y(S,I,P),P++;else for(L=0;L<n;L++){for(T=0;T<U;T++)for(S=a[T],C=S.h,B=S.v,x=0;x<B;x++)for(E=0;E<C;E++)A(S,I,P,x,E);P++}f=0,R=ad(e,t),R&&R.invalid&&(t=R.offset);let i=R&&R.marker;if(!i||i<=65280)throw new Hc("marker was not found");if(!(i>=65488&&i<=65495))break;t+=2}return R=ad(e,t),R&&R.invalid&&(t=R.offset),t-d}function td(e,t,n){let a,r,i,s,l,o,u,c,d,h,f,m,p,_,g,b,w,v=e.quantizationTable,A=e.blockData;if(!v)throw new Hc("missing required Quantization Table.");for(let e=0;e<64;e+=8)d=A[t+e],h=A[t+e+1],f=A[t+e+2],m=A[t+e+3],p=A[t+e+4],_=A[t+e+5],g=A[t+e+6],b=A[t+e+7],d*=v[e],0!=(h|f|m|p|_|g|b)?(h*=v[e+1],f*=v[e+2],m*=v[e+3],p*=v[e+4],_*=v[e+5],g*=v[e+6],b*=v[e+7],a=$c*d+128>>8,r=$c*p+128>>8,i=f,s=g,l=Jc*(h-b)+128>>8,c=Jc*(h+b)+128>>8,o=m<<4,u=_<<4,a=a+r+1>>1,r=a-r,w=i*Xc+s*jc+128>>8,i=i*jc-s*Xc+128>>8,s=w,l=l+u+1>>1,u=l-u,c=c+o+1>>1,o=c-o,a=a+s+1>>1,s=a-s,r=r+i+1>>1,i=r-i,w=l*Zc+c*qc+2048>>12,l=l*qc-c*Zc+2048>>12,c=w,w=o*zc+u*Kc+2048>>12,o=o*Kc-u*zc+2048>>12,u=w,n[e]=a+c,n[e+7]=a-c,n[e+1]=r+u,n[e+6]=r-u,n[e+2]=i+o,n[e+5]=i-o,n[e+3]=s+l,n[e+4]=s-l):(w=$c*d+512>>10,n[e]=w,n[e+1]=w,n[e+2]=w,n[e+3]=w,n[e+4]=w,n[e+5]=w,n[e+6]=w,n[e+7]=w);for(let e=0;e<8;++e)d=n[e],h=n[e+8],f=n[e+16],m=n[e+24],p=n[e+32],_=n[e+40],g=n[e+48],b=n[e+56],0!=(h|f|m|p|_|g|b)?(a=$c*d+2048>>12,r=$c*p+2048>>12,i=f,s=g,l=Jc*(h-b)+2048>>12,c=Jc*(h+b)+2048>>12,o=m,u=_,a=4112+(a+r+1>>1),r=a-r,w=i*Xc+s*jc+2048>>12,i=i*jc-s*Xc+2048>>12,s=w,l=l+u+1>>1,u=l-u,c=c+o+1>>1,o=c-o,a=a+s+1>>1,s=a-s,r=r+i+1>>1,i=r-i,w=l*Zc+c*qc+2048>>12,l=l*qc-c*Zc+2048>>12,c=w,w=o*zc+u*Kc+2048>>12,o=o*Kc-u*zc+2048>>12,u=w,d=a+c,b=a-c,h=r+u,g=r-u,f=i+o,_=i-o,m=s+l,p=s-l,d=d<16?0:d>=4080?255:d>>4,h=h<16?0:h>=4080?255:h>>4,f=f<16?0:f>=4080?255:f>>4,m=m<16?0:m>=4080?255:m>>4,p=p<16?0:p>=4080?255:p>>4,_=_<16?0:_>=4080?255:_>>4,g=g<16?0:g>=4080?255:g>>4,b=b<16?0:b>=4080?255:b>>4,A[t+e]=d,A[t+e+8]=h,A[t+e+16]=f,A[t+e+24]=m,A[t+e+32]=p,A[t+e+40]=_,A[t+e+48]=g,A[t+e+56]=b):(w=$c*d+8192>>14,w=w<-2040?0:w>=2024?255:w+2056>>4,A[t+e]=w,A[t+e+8]=w,A[t+e+16]=w,A[t+e+24]=w,A[t+e+32]=w,A[t+e+40]=w,A[t+e+48]=w,A[t+e+56]=w)}function nd(e,t){let n=t.blocksPerLine,a=t.blocksPerColumn,r=new Int16Array(64);for(let e=0;e<a;e++)for(let a=0;a<n;a++){td(t,Qc(t,e,a),r)}return t.blockData}function ad(e,t,n){function a(t){return e[t]<<8|e[t+1]}let r=e.length-1,i=n<t?n:t;if(t>=r)return null;let s=a(t);if(s>=65472&&s<=65534)return{invalid:null,marker:s,offset:t};let l=a(i);for(;!(l>=65472&&l<=65534);){if(++i>=r)return null;l=a(i)}return{invalid:s.toString(16),marker:l,offset:i}}class rd{constructor(){this.decodeTransform=null,this.colorTransform=-1,this.width=0,this.height=0}parse(e){function t(){let t=e[r]<<8|e[r+1];return r+=2,t}function n(){let n=t(),a=r+n-2,i=ad(e,a,r);i&&i.invalid&&(a=i.offset);let s=e.subarray(r,a);return r+=s.length,s}function a(e){let t=Math.ceil(e.samplesPerLine/8/e.maxH),n=Math.ceil(e.scanLines/8/e.maxV);for(let a=0;a<e.components.length;a++){S=e.components[a];let r=Math.ceil(Math.ceil(e.samplesPerLine/8)*S.h/e.maxH),i=Math.ceil(Math.ceil(e.scanLines/8)*S.v/e.maxV),s=t*S.h,l=64*(n*S.v)*(s+1);S.blockData=new Int16Array(l),S.blocksPerLine=r,S.blocksPerColumn=i}e.mcusPerLine=t,e.mcusPerColumn=n}var r=0;let i,s,l=null,o=null,u=[],c=[],d=[],h=t();if(65496!==h)throw new Hc("SOI not found");for(h=t();65497!==h;){var f,m,p;switch(h){case 65504:case 65505:case 65506:case 65507:case 65508:case 65509:case 65510:case 65511:case 65512:case 65513:case 65514:case 65515:case 65516:case 65517:case 65518:case 65519:case 65534:var _=n();65504===h&&74===_[0]&&70===_[1]&&73===_[2]&&70===_[3]&&0===_[4]&&(l={version:{major:_[5],minor:_[6]},densityUnits:_[7],xDensity:_[8]<<8|_[9],yDensity:_[10]<<8|_[11],thumbWidth:_[12],thumbHeight:_[13],thumbData:_.subarray(14,14+3*_[12]*_[13])}),65518===h&&65===_[0]&&100===_[1]&&111===_[2]&&98===_[3]&&101===_[4]&&(o={version:_[5]<<8|_[6],flags0:_[7]<<8|_[8],flags1:_[9]<<8|_[10],transformCode:_[11]});break;case 65499:for(var g=t()+r-2;r<g;){let n=e[r++],a=new Uint16Array(64);if(n>>4==0)for(m=0;m<64;m++)a[Yc[m]]=e[r++];else{if(n>>4!=1)throw new Hc("DQT - invalid table spec");for(m=0;m<64;m++)a[Yc[m]]=t()}u[15&n]=a}break;case 65472:case 65473:case 65474:if(i)throw new Hc("Only single frame JPEGs supported");t(),i={},i.extended=65473===h,i.progressive=65474===h,i.precision=e[r++],i.scanLines=t(),i.samplesPerLine=t(),i.components=[],i.componentIds={};var b,w=e[r++],v=0,A=0;for(f=0;f<w;f++){b=e[r];let t=e[r+1]>>4,n=15&e[r+1];v<t&&(v=t),A<n&&(A=n);let a=e[r+2];p=i.components.push({h:t,v:n,quantizationId:a,quantizationTable:null}),i.componentIds[b]=p-1,r+=3}i.maxH=v,i.maxV=A,a(i);break;case 65476:var y=t();for(f=2;f<y;){let t=e[r++],n=new Uint8Array(16),a=0;for(m=0;m<16;m++,r++)a+=n[m]=e[r];let i=new Uint8Array(a);for(m=0;m<a;m++,r++)i[m]=e[r];f+=17+a,(t>>4==0?d:c)[15&t]=Wc(n,i)}break;case 65501:t(),s=t();break;case 65498:t();var S,T=e[r++],x=[];for(f=0;f<T;f++){let t=i.componentIds[e[r++]];S=i.components[t];let n=e[r++];S.huffmanTableDC=d[n>>4],S.huffmanTableAC=c[15&n],x.push(S)}var E=e[r++],L=e[r++],I=e[r++],U=ed(e,r,i,x,s,E,L,I>>4,15&I);r+=U;break;case 65535:255!==e[r]&&r--;break;default:if(255===e[r-3]&&e[r-2]>=192&&e[r-2]<=254){r-=3;break}throw new Hc("unknown marker "+h.toString(16))}h=t()}for(this.width=i.samplesPerLine,this.height=i.scanLines,this.jfif=l,this.adobe=o,this.components=[],f=0;f<i.components.length;f++){let e=u[(S=i.components[f]).quantizationId];e&&(S.quantizationTable=e),this.components.push({output:nd(0,S),scaleX:S.h/i.maxH,scaleY:S.v/i.maxV,blocksPerLine:S.blocksPerLine,blocksPerColumn:S.blocksPerColumn})}this.numComponents=this.components.length}getData(e){let t=e.data,n=this.components,a=new Uint8Array((n[0].blocksPerLine<<3)*n[0].blocksPerColumn*8);[n[0],n[2]]=[n[2],n[0]];for(let e=0,l=n.length;e<l;e++){let o=n[e],u=o.blocksPerLine,c=o.blocksPerColumn,d=u<<3;var r,i,s=0;for(let e=0;e<c;e++){let t=e<<3;for(let n=0;n<u;n++){let l=Qc(o,e,n),u=0,c=n<<3;for(r=0;r<8;r++){s=(t+r)*d;for(i=0;i<8;i++)a[s+c+i]=o.output[l+u++]}}}let h=e;for(let e=0;e<this.height;e++)for(let n=0;n<this.width;n++)t[h]=a[e*d+n],h+=l}return t}}class id{constructor(){this.content=0,this.alphaBits=0,this.width=0,this.height=0,this.type=0,this.hasMipmaps=!1,this.mipmapOffsets=new Uint32Array(16),this.mipmapSizes=new Uint32Array(16),this.uint8array=null,this.jpgHeader=null,this.pallete=null}load(e){const t=ka(e),n=new Int32Array(t.buffer,0,40);if(827345986!==n[0])throw new Error("WrongMagicNumber");this.content=n[1],this.alphaBits=n[2],this.width=n[3],this.height=n[4],this.type=n[5],this.hasMipmaps=0!==n[6];for(let e=0;e<16;e++)this.mipmapOffsets[e]=n[7+e],this.mipmapSizes[e]=n[23+e];this.uint8array=t,0===this.content?this.jpgHeader=t.subarray(160,160+n[39]):this.pallete=t.subarray(156,1180)}getMipmap(e){const t=this.uint8array,n=this.mipmapOffsets[e],a=this.mipmapSizes[e];let r;if(0===this.content){const e=this.jpgHeader,i=new Uint8Array(e.length+a),s=new rd;i.set(e),i.set(t.subarray(n,n+a),e.length),s.parse(i),r=new ImageData(s.width,s.height),s.getData(r)}else{const a=this.pallete,i=Math.max(this.width/(1<<e),1),s=Math.max(this.height/(1<<e),1),l=i*s;let o,u=this.alphaBits,c=0;r=new ImageData(i,s),u>0&&(u>8&&(u=8),o=new cr(t.buffer,n+l,Math.ceil(l*u/8)),c=Nc(u,8));const d=r.data;for(let e=0;e<l;e++){const r=4*e,i=4*t[n+e];d[r]=a[i+2],d[r+1]=a[i+1],d[r+2]=a[i],d[r+3]=u>0?o.readBits(u)*c:255}}return r}mipmaps(){let e=0;for(const t of this.mipmapSizes)t>0&&(e+=1);return e}fakeMipmaps(){const e=this.mipmapOffsets;let t=0;for(let n=0;n<16;n++){const a=e[n];if(a>0)for(let r=n+1;r<16;r++)if(a===e[r]){t+=1;break}}return t}}const sd={Image:id},ld=Nc(4,8),od=Nc(5,8),ud=Nc(6,8),cd=new Uint8Array(16),dd=new Uint8Array(12),hd=new Uint8Array(8),fd=new Uint8Array(8),md=new Uint8Array(8);function pd(e,t,n){const a=(t>>11&31)*od,r=(t>>5&63)*ud,i=(31&t)*od,s=(n>>11&31)*od,l=(n>>5&63)*ud,o=(31&n)*od;e[0]=a,e[1]=r,e[2]=i,e[3]=255,e[4]=s,e[5]=l,e[6]=o,e[7]=255,t>n?(e[8]=5*a+3*s>>3,e[9]=5*r+3*l>>3,e[10]=5*i+3*o>>3,e[11]=255,e[12]=5*s+3*a>>3,e[13]=5*l+3*r>>3,e[14]=5*o+3*i>>3,e[15]=255):(e[8]=a+s>>1,e[9]=r+l>>1,e[10]=i+o>>1,e[11]=255,e[12]=0,e[13]=0,e[14]=0,e[15]=0)}function _d(e,t,n){const a=(t>>11&31)*od,r=(t>>5&63)*ud,i=(31&t)*od,s=(n>>11&31)*od,l=(n>>5&63)*ud,o=(31&n)*od;e[0]=a,e[1]=r,e[2]=i,e[3]=s,e[4]=l,e[5]=o,e[6]=5*a+3*s>>3,e[7]=5*r+3*l>>3,e[8]=5*i+3*o>>3,e[9]=5*s+3*a>>3,e[10]=5*l+3*r>>3,e[11]=5*o+3*i>>3}function gd(e,t,n){e[0]=t,e[1]=n,t>n?(e[2]=(6*t+1*n)/7,e[3]=(5*t+2*n)/7,e[4]=(4*t+3*n)/7,e[5]=(3*t+4*n)/7,e[6]=(2*t+5*n)/7,e[7]=(1*t+6*n)/7):(e[2]=(4*t+1*n)/5,e[3]=(3*t+2*n)/5,e[4]=(2*t+3*n)/5,e[5]=(1*t+4*n)/5,e[6]=0,e[7]=1)}const bd=827611204,wd=861165636,vd=894720068,Ad=843666497;class yd{constructor(){this.width=0,this.height=0,this.format=0,this.mipmapWidths=[],this.mipmapHeights=[],this.mipmapDatas=[]}load(e){const t=ka(e),n=new Int32Array(t.buffer,0,31);let a=128;if(542327876!==n[0])throw new Error("Wrong magic number");if(!(4&n[20]))throw new Error("Not FourCC");let r=n[21];if(r!==bd&&r!==wd&&r!==vd&&r!==Ad){if(808540228!==r)throw new Error(`Unsupported FourCC: ${lr(r)}`);{a+=20;const e=new Int32Array(t.buffer,128,5),n=e[0];if(71===n)r=bd;else if(74===n)r=wd;else if(77===n)r=vd;else{if(83!==n)throw new Error(`Unsupported DXGI format: ${n}`);r=Ad}console.log(e)}}this.format=r;let i=1;131072&n[2]&&(i=Math.max(1,n[7]));let s=n[4],l=n[3],o=16;r===bd&&(o=8),this.width=s,this.height=l;for(let e=0;e<i;e++){const n=Math.max(4,s)/4*Math.max(4,l)/4*o;this.mipmapWidths[e]=s,this.mipmapHeights[e]=l,this.mipmapDatas[e]=t.subarray(a,a+n),a+=n,s=Math.max(s/2,1),l=Math.max(l/2,1)}}mipmaps(){return this.mipmapDatas.length}getMipmap(e,t=!1){const n=this.mipmapWidths[e],a=this.mipmapHeights[e],r=this.mipmapDatas[e];let i;return i=t?r:this.format===bd?function(e,t,n){const a=new Uint8Array(t*n*4);for(let r=0,i=n/4;r<i;r++)for(let n=0,i=t/4;n<i;n++){const s=8*(r*i+n);pd(cd,e[s]+256*e[s+1],e[s+2]+256*e[s+3]);const l=16*r*t+16*n,o=e[s+4]|e[s+5]<<8|e[s+6]<<16|e[s+7]<<24;for(let e=0;e<4;e++){const n=8*e,r=l+e*t*4;for(let e=0;e<4;e++){const t=r+4*e,i=4*(o>>n+2*e&3);a[t+0]=cd[i+0],a[t+1]=cd[i+1],a[t+2]=cd[i+2],a[t+3]=cd[i+3]}}}return a}(r,n,a):this.format===wd?function(e,t,n){const a=new Uint8Array(t*n*4),r=4*t;for(let i=0,s=n/4;i<s;i++)for(let n=0,s=t/4;n<s;n++){const l=16*(i*s+n);_d(dd,e[l+8]+256*e[l+9],e[l+10]+256*e[l+11]);let o=16*i*t+16*n;for(let t=0;t<4;t++){const n=e[l+2*t]+256*e[l+1+2*t],i=e[l+12+t];for(let e=0;e<4;e++){const t=o+4*e,r=3*(i>>2*e&3);a[t+0]=dd[r+0],a[t+1]=dd[r+1],a[t+2]=dd[r+2],a[t+3]=(n>>4*e&15)*ld}o+=r}}return a}(r,n,a):this.format===vd?function(e,t,n){const a=new Uint8Array(t*n*4),r=4*t;for(let o=0,u=n/4;o<u;o++)for(let n=0,u=t/4;n<u;n++){const c=16*(o*u+n);i=hd,s=e[c],l=e[c+1],i[0]=s,i[1]=l,s>l?(i[2]=54*s+9*l>>6,i[3]=45*s+18*l>>6,i[4]=36*s+27*l>>6,i[5]=27*s+36*l>>6,i[6]=18*s+45*l>>6,i[7]=9*s+54*l>>6):(i[2]=12*s+3*l>>4,i[3]=9*s+6*l>>4,i[4]=6*s+9*l>>4,i[5]=3*s+12*l>>4,i[6]=0,i[7]=255),_d(dd,e[c+8]+256*e[c+9],e[c+10]+256*e[c+11]);let d=16*o*t+16*n;for(let t=0;t<2;t++){const n=c+2+3*t,i=c+12+2*t,s=e[n]+256*(e[n+1]+256*e[n+2]);for(let t=0;t<2;t++){const n=e[i+t];for(let e=0;e<4;e++){const r=d+4*e,i=3*(n>>2*e&3),l=s>>12*t+3*e&7;a[r+0]=dd[i+0],a[r+1]=dd[i+1],a[r+2]=dd[i+2],a[r+3]=hd[l]}d+=r}}}var i,s,l;return a}(r,n,a):function(e,t,n){const a=new Uint8Array(t*n*2),r=2*t;for(let i=0,s=n/4;i<s;i++)for(let n=0,s=t/4;n<s;n++){const l=16*(i*s+n);gd(fd,e[l],e[l+1]),gd(md,e[l+8],e[l+9]);let o=8*i*t+8*n;for(let t=0;t<2;t++){const n=l+3*t,i=e[n+2]+256*(e[n+3]+256*e[n+4]),s=e[n+10]+256*(e[n+11]+256*e[n+12]);for(let e=0;e<2;e++){const t=4*e;for(let e=0;e<4;e++){const n=o+2*e,r=3*(t+e);a[n+1]=fd[i>>r&7],a[n+2]=md[s>>r&7]}o+=r}}}return a}(r,n,a),{width:n,height:a,data:i}}}function Sd(e){return e instanceof ArrayBuffer&&(e=new Uint8Array(e)),e instanceof Uint8Array&&68===e[0]&&68===e[1]&&83===e[2]&&32===e[3]}const Td={Image:yd,FOURCC_DXT1:bd,FOURCC_DXT3:wd,FOURCC_DXT5:vd,FOURCC_ATI2:Ad,isDds:Sd};class xd{constructor(){this.width=0,this.height=0,this.data=null}load(e){const t=ka(e),n=new class{_checkHeader(){const e=this.header;if(0===e.imageType)throw Error("No data");if(e.hasColorMap){if(e.colorMapLength>256||24!==e.colorMapDepth||1!==e.colorMapType)throw Error("Invalid colormap for indexed type")}else if(e.colorMapType)throw Error("Why does the image contain a palette ?");if(!e.width||!e.height)throw Error("Invalid image size");if(8!==e.pixelDepth&&16!==e.pixelDepth&&24!==e.pixelDepth&&32!==e.pixelDepth)throw Error('Invalid pixel size "'+e.pixelDepth+'"')}_decodeRLE(e,t,n,a){const r=new Uint8Array(a),i=new Uint8Array(n);let s=0;for(;s<a;){const a=e[t++];let l=1+(127&a);if(128&a){for(let a=0;a<n;++a)i[a]=e[t+a];t+=n;for(let e=0;e<l;++e)r.set(i,s),s+=n}else{l*=n;for(let n=0;n<l;++n)r[s+n]=e[t+n];s+=l,t+=l}}return r}_getImageData8bits(e,t,n,a,r,i,s,l,o,u){for(let c=0,d=r;d!==s;d+=i)for(let r=l;r!==u;r+=o,c++){const i=t[c];e[4*(r+a*d)+3]=255,e[4*(r+a*d)+2]=n[3*i+0],e[4*(r+a*d)+1]=n[3*i+1],e[4*(r+a*d)+0]=n[3*i+2]}return e}_getImageData16bits(e,t,n,a,r,i,s,l,o,u){for(let n=0,c=r;c!==s;c+=i)for(let r=l;r!==u;r+=o,n+=2){const i=t[n+0]|t[n+1]<<8;e[4*(r+a*c)+0]=(31744&i)>>7,e[4*(r+a*c)+1]=(992&i)>>2,e[4*(r+a*c)+2]=(31&i)>>3,e[4*(r+a*c)+3]=32768&i?0:255}return e}_getImageData24bits(e,t,n,a,r,i,s,l,o,u){for(let n=0,c=r;c!==s;c+=i)for(let r=l;r!==u;r+=o,n+=3)e[4*(r+a*c)+3]=255,e[4*(r+a*c)+2]=t[n+0],e[4*(r+a*c)+1]=t[n+1],e[4*(r+a*c)+0]=t[n+2];return e}_getImageData32bits(e,t,n,a,r,i,s,l,o,u){for(let n=0,c=r;c!==s;c+=i)for(let r=l;r!==u;r+=o,n+=4)e[4*(r+a*c)+2]=t[n+0],e[4*(r+a*c)+1]=t[n+1],e[4*(r+a*c)+0]=t[n+2],e[4*(r+a*c)+3]=t[n+3];return e}_getImageDataGrey8bits(e,t,n,a,r,i,s,l,o,u){for(let n=0,c=r;c!==s;c+=i)for(let r=l;r!==u;r+=o,n++){const i=t[n];e[4*(r+a*c)+0]=i,e[4*(r+a*c)+1]=i,e[4*(r+a*c)+2]=i,e[4*(r+a*c)+3]=255}return e}_getImageDataGrey16bits(e,t,n,a,r,i,s,l,o,u){for(let n=0,c=r;c!==s;c+=i)for(let r=l;r!==u;r+=o,n+=2)e[4*(r+a*c)+0]=t[n+0],e[4*(r+a*c)+1]=t[n+0],e[4*(r+a*c)+2]=t[n+0],e[4*(r+a*c)+3]=t[n+1];return e}open(e,t){const n=new XMLHttpRequest;n.responseType="arraybuffer",n.open("GET",e,!0),n.onload=()=>{200===n.status&&(this.load(new Uint8Array(n.response)),t&&t())},n.send(null)}load(e){let t=0;if(e.length<18)throw Error("Not enough data to contain header");const n={idLength:e[t++],colorMapType:e[t++],imageType:e[t++],colorMapIndex:e[t++]|e[t++]<<8,colorMapLength:e[t++]|e[t++]<<8,colorMapDepth:e[t++],offsetX:e[t++]|e[t++]<<8,offsetY:e[t++]|e[t++]<<8,width:e[t++]|e[t++]<<8,height:e[t++]|e[t++]<<8,pixelDepth:e[t++],flags:e[t++]};if(n.hasEncoding=9===n.imageType||10===n.imageType||11===n.imageType,n.hasColorMap=9===n.imageType||1===n.imageType,n.isGreyColor=11===n.imageType||3===n.imageType,this.header=n,this._checkHeader(),(t+=n.idLength)>=e.length)throw Error("No data");if(n.hasColorMap){const a=n.colorMapLength*(n.colorMapDepth>>3);this.palette=e.subarray(t,t+a),t+=a}const a=n.pixelDepth>>3,r=n.width*n.height,i=r*a;n.hasEncoding?this.imageData=this._decodeRLE(e,t,a,i):this.imageData=e.subarray(t,t+(n.hasColorMap?r:i))}getImageData(e){const{width:t,height:n,flags:a,pixelDepth:r,isGreyColor:i}=this.header,s=(48&a)>>4;let l,o,u,c,d,h,f;switch(e||(e=document?document.createElement("canvas").getContext("2d").createImageData(t,n):{width:t,height:n,data:new Uint8ClampedArray(t*n*4)}),2===s||3===s?(c=0,d=1,h=n):(c=n-1,d=-1,h=-1),2===s||0===s?(l=0,o=1,u=t):(l=t-1,o=-1,u=-1),r){case 8:f=i?this._getImageDataGrey8bits:this._getImageData8bits;break;case 16:f=i?this._getImageDataGrey16bits:this._getImageData16bits;break;case 24:f=this._getImageData24bits;break;case 32:f=this._getImageData32bits}return f.call(this,e.data,this.imageData,this.palette,t,c,d,h,l,o,u),e}getCanvas(){const{width:e,height:t}=this.header,n=document.createElement("canvas"),a=n.getContext("2d"),r=a.createImageData(e,t);return n.width=e,n.height=t,a.putImageData(this.getImageData(r),0,0),n}getDataURL(e){return this.getCanvas().toDataURL(e||"image/png")}};n.load(t);const a=n.header;this.width=a.width,this.height=a.height,this.data=new ImageData(a.width,a.height),n.getImageData(this.data)}}function Ed(e){return e instanceof ArrayBuffer&&(e=new Uint8Array(e)),!!(e instanceof Uint8Array&&Oa(e,"TRUEVISION-XFILE.\0",e.length-18))}const Ld={ini:vr,slk:yr,m3:Hr,mdlx:Si,mpq:Tu,w3x:Gc,blp:sd,dds:Td,tga:{Image:xd,isTga:Ed}};var Id=n(187);async function Ud(e,t){if("image"===t)return new Promise((t=>{const n=new Image;n.onload=()=>{t({ok:!0,data:n})},n.onerror=e=>{t({ok:!1,error:"Image Error",data:e})},n.src=e}));{let n;try{n=await fetch(e)}catch(e){return{ok:!1,error:"Network Error",data:e}}if(!n.ok)return{ok:!1,error:"Http Error",data:n};try{let e=null;return"text"===t?e=await n.text():"arrayBuffer"===t||"bytes"===t?e=await n.arrayBuffer():"blob"===t&&(e=await n.blob()),"bytes"===t&&(e=new Uint8Array(e)),{ok:!0,data:e}}catch(e){return{ok:!1,error:"Data Error",data:e}}}}class Rd{constructor(e,t=4){this.size=0,this.arrayBuffer=null,this.byteView=null,this.floatView=null,this.gl=e,this.buffer=e.createBuffer(),this.reserve(t)}reserve(e){if(this.size<e){const t=this.gl;this.size=4*Math.ceil(e/4),t.bindBuffer(t.ARRAY_BUFFER,this.buffer),t.bufferData(t.ARRAY_BUFFER,this.size,t.DYNAMIC_DRAW),this.arrayBuffer=new ArrayBuffer(this.size),this.byteView=new Uint8Array(this.arrayBuffer),this.floatView=new Float32Array(this.arrayBuffer)}}bindAndUpdate(e=this.size){const t=this.gl,n=this.byteView;t.bindBuffer(t.ARRAY_BUFFER,this.buffer),t.bufferSubData(t.ARRAY_BUFFER,0,n.subarray(0,e))}}class Md{constructor(e,t=1,n=1){this.width=0,this.height=0,this.arrayBuffer=new ArrayBuffer(0),this.byteView=null,this.floatView=null,this.gl=e,this.texture=e.createTexture(),e.bindTexture(e.TEXTURE_2D,this.texture),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.NEAREST),this.reserve(t,n)}reserve(e,t){if(this.width<e||this.height<t){const n=this.gl;this.width=Math.max(this.width,e),this.height=Math.max(this.height,t),n.bindTexture(n.TEXTURE_2D,this.texture),n.texImage2D(n.TEXTURE_2D,0,n.RGBA,this.width,this.height,0,n.RGBA,n.FLOAT,null),this.arrayBuffer=new ArrayBuffer(this.width*this.height*16),this.byteView=new Uint8Array(this.arrayBuffer),this.floatView=new Float32Array(this.arrayBuffer)}}bindAndUpdate(e=this.width,t=this.height){const n=this.gl;n.bindTexture(n.TEXTURE_2D,this.texture),n.texSubImage2D(n.TEXTURE_2D,0,0,0,e,t,n.RGBA,n.FLOAT,this.byteView)}}class Cd{constructor(e,t=4,n=1,a=1){this.width=0,this.height=0,this.gl=e,this.texture=e.createTexture(),this.format=3===t?e.RGB:e.RGBA,e.bindTexture(e.TEXTURE_2D,this.texture),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.NEAREST),this.reserve(n,a)}reserve(e,t){if(this.width<e||this.height<t){const n=this.gl;this.width=Math.max(this.width,e),this.height=Math.max(this.height,t),n.bindTexture(n.TEXTURE_2D,this.texture),n.texImage2D(n.TEXTURE_2D,0,this.format,this.width,this.height,0,this.format,n.FLOAT,null)}}bindAndUpdate(e,t=this.width,n=this.height){const a=this.gl;a.bindTexture(a.TEXTURE_2D,this.texture),a.texSubImage2D(a.TEXTURE_2D,0,0,0,t,n,this.format,a.FLOAT,e)}bind(e){const t=this.gl;t.activeTexture(t.TEXTURE0+e),t.bindTexture(t.TEXTURE_2D,this.texture)}}class Bd{constructor(e,t){this.uniforms={},this.attribs={},this.attribsCount=0,this.webgl=e,this.program=t;const n=e.gl;for(let e=0,a=n.getProgramParameter(t,n.ACTIVE_UNIFORMS);e<a;e++){const a=n.getActiveUniform(t,e);if(a)if(1===a.size)this.uniforms[a.name]=n.getUniformLocation(t,a.name);else{const e=a.name.substr(0,a.name.length-3);for(let r=0;r<a.size;r++){const a=e+"["+r+"]";this.uniforms[a]=n.getUniformLocation(t,a)}}}for(let e=0,a=n.getProgramParameter(t,n.ACTIVE_ATTRIBUTES);e<a;e++){const a=n.getActiveAttrib(t,e);if(a)if(this.attribsCount+=a.size,1===a.size)this.attribs[a.name]=n.getAttribLocation(t,a.name);else{const e=a.name.substr(0,a.name.length-3);for(let r=0;r<a.size;r++){const a=e+"["+r+"]";this.attribs[a]=n.getAttribLocation(t,a)}}}}use(){this.webgl.useShader(this)}}class Pd{constructor(e,t={alpha:!1}){this.currentShader=null,this.extensions={};let n=e.getContext("webgl",t);if(n||(n=e.getContext("experimental-webgl",t)),!n)throw new Error("WebGL: Failed to create a WebGL context!");const a=new Uint8ClampedArray(16).fill(255),r=n.createTexture();n.bindTexture(n.TEXTURE_2D,r),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_S,n.CLAMP_TO_EDGE),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_T,n.CLAMP_TO_EDGE),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MAG_FILTER,n.NEAREST),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MIN_FILTER,n.NEAREST),n.texImage2D(n.TEXTURE_2D,0,n.RGBA,2,2,0,n.RGBA,n.UNSIGNED_BYTE,a),this.gl=n,this.emptyTexture=r}ensureExtension(e){const t=this.gl.getExtension(e);return!!t&&(this.extensions[e]=t,!0)}createShader(e,t){const n=this.gl,a=n.createShader(n.VERTEX_SHADER);n.shaderSource(a,e),n.compileShader(a);const r=n.createShader(n.FRAGMENT_SHADER);n.shaderSource(r,t),n.compileShader(r);const i=n.createProgram();if(n.attachShader(i,a),n.attachShader(i,r),n.linkProgram(i),!n.getProgramParameter(i,n.LINK_STATUS)){let e="Shader failed to link:";const t=n.getShaderInfoLog(a);t&&t.length&&(e+=` Vertex shader: ${t}`);const i=n.getShaderInfoLog(r);throw i&&i.length&&(e+=` Fragment shader: ${i}`),new Error(e)}return new Bd(this,i)}enableVertexAttribs(e,t){const n=this.gl;for(let a=e;a<t;a++)n.enableVertexAttribArray(a)}disableVertexAttribs(e,t){const n=this.gl;for(let a=e;a<t;a++)n.disableVertexAttribArray(a)}useShader(e){if(e&&e!==this.currentShader){let t=0;const n=e.attribsCount;this.currentShader&&(t=this.currentShader.attribsCount),this.gl.useProgram(e.program),n>t?this.enableVertexAttribs(t,n):n<t&&this.disableVertexAttribs(n,t),this.currentShader=e}}bindTexture(e,t){const n=this.gl;n.activeTexture(n.TEXTURE0+t),e?n.bindTexture(n.TEXTURE_2D,e.webglResource):n.bindTexture(n.TEXTURE_2D,this.emptyTexture)}bindTextureAndWrap(e,t,n,a){const r=this.gl;r.activeTexture(r.TEXTURE0+t),e?r.bindTexture(r.TEXTURE_2D,e.webglResource):r.bindTexture(r.TEXTURE_2D,this.emptyTexture),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,n),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,a)}setTextureMode(e,t,n,a){const r=this.gl;r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,e),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,t),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,n),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,a)}createClientBuffer(e=4){return new Rd(this.gl,e)}createDataTexture(e=4,t=1,n=1){return new Cd(this.gl,e,t,n)}createClientDataTexture(e=1,t=1){return new Md(this.gl,e,t)}}const kd=Gn.create(),Od=Gn.create(),Dd=Gn.create(),Fd=st.create(),Gd=st.setAxisAngle(st.create(),Vn,Math.PI/2);class Nd{constructor(){this.isPerspective=!0,this.fov=0,this.aspect=0,this.isOrtho=!1,this.leftClipPlane=0,this.rightClipPlane=0,this.bottomClipPlane=0,this.topClipPlane=0,this.nearClipPlane=0,this.farClipPlane=0,this.location=Gn.create(),this.rotation=st.create(),this.inverseRotation=st.create(),this.viewMatrix=fe(),this.projectionMatrix=fe(),this.viewProjectionMatrix=fe(),this.inverseViewMatrix=fe(),this.inverseViewProjectionMatrix=fe(),this.directionX=Gn.create(),this.directionY=Gn.create(),this.directionZ=Gn.create(),this.vectors=[Gn.fromValues(-1,-1,0),Gn.fromValues(-1,1,0),Gn.fromValues(1,1,0),Gn.fromValues(1,-1,0),Gn.fromValues(1,0,0),Gn.fromValues(0,1,0),Gn.fromValues(0,0,1)],this.billboardedVectors=[Gn.create(),Gn.create(),Gn.create(),Gn.create(),Gn.create(),Gn.create(),Gn.create()],this.planes=[Nn.create(),Nn.create(),Nn.create(),Nn.create(),Nn.create(),Nn.create()]}perspective(e,t,n,a){this.isPerspective=!0,this.isOrtho=!1,this.fov=e,this.aspect=t,this.nearClipPlane=n,this.farClipPlane=a,this.update()}ortho(e,t,n,a,r,i){this.isPerspective=!1,this.isOrtho=!0,this.leftClipPlane=e,this.rightClipPlane=t,this.bottomClipPlane=n,this.topClipPlane=a,this.nearClipPlane=r,this.farClipPlane=i,this.update()}setLocation(e){Gn.copy(this.location,e),this.update()}move(e){Gn.add(this.location,this.location,e),this.update()}setRotation(e){st.copy(this.rotation,e),this.update()}rotate(e){st.mul(this.rotation,this.rotation,e),this.update()}face(e,t){st.mul(this.rotation,Gd,la(Fd,e,this.location,t)),this.update()}moveToAndFace(e,t,n){Gn.copy(this.location,e),this.face(t,n)}reset(){Gn.set(this.location,0,0,0),st.identity(this.rotation),this.update()}update(){const e=this.location,t=this.rotation,n=this.inverseRotation,a=this.viewMatrix,r=this.projectionMatrix,i=this.viewProjectionMatrix,s=this.vectors,l=this.billboardedVectors;this.isPerspective?ze(r,this.fov,this.aspect,this.nearClipPlane,this.farClipPlane):Ze(r,this.leftClipPlane,this.rightClipPlane,this.bottomClipPlane,this.topClipPlane,this.nearClipPlane,this.farClipPlane),Ye(a,t),Te(a,a,Gn.negate(kd,e)),rt(i,r,a),ve(this.inverseViewMatrix,a),ve(this.inverseViewProjectionMatrix,i),aa(this.planes,i),st.conjugate(n,t),Gn.transformQuat(this.directionX,Vn,n),Gn.transformQuat(this.directionY,Hn,n),Gn.transformQuat(this.directionZ,Yn,n);for(let e=0;e<7;e++)Gn.transformQuat(l[e],s[e],n)}cameraToWorld(e,t){return Gn.transformMat4(e,t,this.inverseViewMatrix)}worldToCamera(e,t){return Gn.transformMat4(e,t,this.viewMatrix)}worldToScreen(e,t,n){return Gn.transformMat4(kd,t,this.viewProjectionMatrix),e[0]=Math.round((kd[0]+1)/2*n[2]),e[1]=Math.round((kd[1]+1)/2*n[3]),e}screenToWorldRay(e,t,n){const a=kd,r=Od,i=Dd,s=t[0],l=t[1],o=this.inverseViewProjectionMatrix;return Xn(a,Gn.set(i,s,l,0),o,n),Xn(r,Gn.set(i,s,l,1),o,n),e.set(a,0),e.set(r,3),e}}class Vd{constructor(e,t,n,a){this.plane=-1,this.instances=[],this.visible=!1,this.left=e,this.right=t,this.bottom=n,this.top=a}add(e){this.instances.push(e)}remove(e){const t=this.instances.indexOf(e);this.instances.splice(t,1)}clear(){this.instances.length=0}isVisible(e){return this.plane=ea(e.planes,this.left,this.right,this.bottom,this.top,this.plane),-1===this.plane}}class Hd{constructor(e,t,n,a,r,i){this.cells=[];const s=n/r,l=a/i;this.x=e,this.y=t,this.width=n,this.depth=a,this.cellWidth=r,this.cellDepth=i,this.columns=s,this.rows=l;for(let n=0;n<l;n++)for(let a=0;a<s;a++){const l=e+a*r,o=l+r,u=t+n*i,c=u+i;this.cells[n*s+a]=new Vd(l,o,u,c)}}add(e){const t=this.cells,n=this.columns,a=e.left,r=e.right+1,i=e.bottom,s=e.top+1;if(-1!==a)for(let l=i;l<s;l++)for(let i=a;i<r;i++)t[l*n+i].add(e)}remove(e){const t=this.cells,n=this.columns,a=e.left,r=e.right+1,i=e.bottom,s=e.top+1;if(-1!==a){e.left=-1;for(let l=i;l<s;l++)for(let i=a;i<r;i++)t[l*n+i].remove(e)}}moved(e){const t=this.cellWidth,n=this.cellDepth,a=e.model.bounds,r=e.worldLocation[0]+a.x-this.x,i=e.worldLocation[1]+a.y-this.y,s=a.r,l=e.worldScale;let o=Math.floor((r-s*l[0])/t),u=Math.floor((r+s*l[0])/t),c=Math.floor((i-s*l[1])/n),d=Math.floor((i+s*l[1])/n);u<0||o>this.columns-1||d<0||c>this.rows-1?this.remove(e):(o=Math.max(o,0),u=Math.min(u,this.columns-1),c=Math.max(c,0),d=Math.min(d,this.rows-1),o===e.left&&u===e.right&&c===e.bottom&&d===e.top||(this.remove(e),e.left=o,e.right=u,e.bottom=c,e.top=d,this.add(e)))}clear(){for(const e of this.cells)e.clear()}}class Yd{constructor(){this.objects=[],this.alive=0}add(e){this.objects[this.alive++]=e}update(e){const t=this.objects;for(let n=0;n<this.alive;n++){const a=t[n];a.update(e*a.emitter.instance.timeScale),a.health<=0&&(this.alive-=1,a.emitter.kill(a),n!==this.alive&&(t[n]=t[this.alive],n-=1))}}}class Kd{constructor(e){this.camera=new Nd,this.grid=new Hd(-1e5,-1e5,2e5,2e5,2e5,2e5),this.visibleCells=0,this.visibleInstances=0,this.updatedParticles=0,this.audioEnabled=!1,this.audioContext=null,this.instances=[],this.emittedObjectUpdater=new Yd,this.alpha=!1,this.color=Gn.create(),this.viewport=Nn.create(),this.lightPosition=Gn.fromValues(0,0,1e4),this.viewer=e;const t=e.canvas,n=t.width,a=t.height;this.viewport[2]=n,this.viewport[3]=a,this.camera.perspective(Math.PI/4,n/a,8,1e4)}async enableAudio(){return"function"==typeof AudioContext&&(this.audioContext||(this.audioContext=new AudioContext),"suspended"!==this.audioContext.state&&await this.audioContext.resume(),this.audioEnabled="running"===this.audioContext.state,this.audioEnabled)}disableAudio(){this.audioContext&&this.audioContext.suspend(),this.audioEnabled=!1}addInstance(e){return e.scene!==this&&(e.scene&&e.scene.removeInstance(e),e.scene=this,this.grid.moved(e),!0)}removeInstance(e){return e.scene===this&&(this.grid.remove(e),e.scene=null,!0)}clear(){for(const e of this.grid.cells)for(const t of e.instances)t.scene=null;this.grid.clear()}detach(){return!!this.viewer&&this.viewer.removeScene(this)}update(e){const t=this.camera;if(this.audioContext){const e=this.audioContext.listener,n=t.location,a=t.directionY,r=t.directionZ;e.positionX.value=-n[0],e.positionY.value=-n[1],e.positionZ.value=-n[2],e.forwardX.value=a[0],e.forwardY.value=a[1],e.forwardZ.value=a[2],e.upX.value=r[0],e.upY.value=r[1],e.upZ.value=r[2]}const n=this.viewer.frame,a=this.instances;this.visibleCells=0,this.visibleInstances=0;for(const a of this.grid.cells)if(a.isVisible(t)){this.visibleCells+=1;for(const t of a.instances)t.rendered&&t.updateFrame<n&&!t.parent&&(t.updateFrame=n,t.update(e))}a.length=this.visibleInstances,a.sort(((e,t)=>e.depth-t.depth)),this.emittedObjectUpdater.update(e),this.updatedParticles=this.emittedObjectUpdater.alive}renderInstance(e){this.instances[this.visibleInstances++]=e}startFrame(){const e=this.viewer.gl,t=this.viewport;if(e.viewport(t[0],t[1],t[2],t[3]),e.scissor(t[0],t[1],t[2],t[3]),!this.alpha){const t=this.color;e.depthMask(!0),e.clearColor(t[0],t[1],t[2],1),e.clear(e.COLOR_BUFFER_BIT|e.DEPTH_BUFFER_BIT)}}renderOpaque(){const e=this.instances;for(let t=0,n=e.length;t<n;t++)e[t].renderOpaque()}renderTranslucent(){const e=this.instances;for(let t=e.length-1;t>=0;t--)e[t].renderTranslucent()}render(){this.startFrame(),this.renderOpaque(),this.renderTranslucent()}clearEmittedObjects(){for(const e of this.emittedObjectUpdater.objects)e.health=0}}class zd{constructor(e){this.blockers=[],this.viewer=e.viewer,this.fetchUrl=e.fetchUrl}detach(){return this.viewer.unload(this)}}class qd extends zd{constructor(e,t){super(t),this.data=null,this.data=e}}class Zd extends zd{constructor(e){super(e),this.pathSolver=e.pathSolver}}class jd extends Zd{constructor(){super(...arguments),this.webglResource=null,this.width=0,this.height=0}}class Xd extends jd{constructor(e,t){super(t);const n=this.viewer.gl;this.webglResource=n.createTexture(),n.bindTexture(n.TEXTURE_2D,this.webglResource),n.texImage2D(n.TEXTURE_2D,0,n.RGBA,n.RGBA,n.UNSIGNED_BYTE,e),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MAG_FILTER,n.LINEAR),ga(e.width)&&ga(e.height)?(n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MIN_FILTER,n.LINEAR_MIPMAP_LINEAR),n.generateMipmap(n.TEXTURE_2D)):(n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MIN_FILTER,n.LINEAR),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_S,n.CLAMP_TO_EDGE),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_T,n.CLAMP_TO_EDGE)),this.width=e.width,this.height=e.height}}var $d;!function(e){e[e.None=0]="None",e[e.Diffuse=1]="Diffuse",e[e.NormalMap=2]="NormalMap",e[e.Occlusion=3]="Occlusion",e[e.Roughness=4]="Roughness",e[e.Metallic=5]="Metallic",e[e.TCFactor=6]="TCFactor",e[e.Emissive=7]="Emissive",e[e.TexCoords=8]="TexCoords",e[e.Normals=9]="Normals",e[e.Tangents=10]="Tangents"}($d||($d={}));class Jd extends Id.EventEmitter{constructor(e,t){super(),this.resources=[],this.resourceMap=new Map,this.promiseMap=new Map,this.handlers=new Set,this.scenes=[],this.frame=0,this.visibleCells=0,this.visibleInstances=0,this.updatedParticles=0,this.audioEnabled=!1,this.sharedCache=new Map,this.debugRenderMode=$d.None,this.directLoadId=0;const n=new Pd(e,t),a=n.gl;this.canvas=e,this.gl=a,this.webgl=n,this.buffer=n.createClientBuffer(),a.depthFunc(a.LEQUAL),a.enable(a.DEPTH_TEST),a.enable(a.SCISSOR_TEST)}enableAudio(){return"function"==typeof AudioContext&&(this.audioEnabled=!0,!0)}addHandler(e,...t){if(e){const n=this.handlers;if(!n.has(e)){if(!e.isValidSource)return this.emit("error",{viewer:this,error:"Handler missing the isValidSource function",handler:e}),!1;if(e.load)try{e.load(this,...t)}catch(t){return this.emit("error",{viewer:this,error:"Handler failed to load",handler:e,reason:t}),!1}return n.add(e),!0}}return!1}addScene(){const e=new Kd(this);return this.scenes.push(e),e}removeScene(e){const t=this.scenes,n=t.indexOf(e);return-1!==n&&(t.splice(n,1),!0)}clear(){this.scenes.length=0}async load(e,t,n){let a,r,i="";if(t)try{a=t(e,n)}catch(a){return void this.emit("error",{viewer:this,error:"Path solver failed",src:e,reason:a,pathSolver:t,solverParams:n})}else a=e;if(a){if(a instanceof Promise&&(a=await a),a instanceof zd)return a;if("string"!=typeof a||this.detectFormat(a))i="__DIRECT_LOAD_"+this.directLoadId++,r=Promise.resolve(a);else{if(i=a,r=this.promiseMap.get(i),r)return r;const e=this.resourceMap.get(i);if(e)return e;r=Ud(i,"arrayBuffer").then((e=>e.ok?e.data:void this.emit("error",{viewer:this,error:`Failed to fetch a resource: ${e.error}`,fetchUrl:i,reason:e.data})))}return r=r.then((async n=>{if(n){if(n instanceof ArrayBuffer&&(n=new Uint8Array(n)),function(e){return e instanceof ImageData||e instanceof HTMLImageElement||e instanceof HTMLCanvasElement||e instanceof HTMLVideoElement}(n))return new Xd(n,{viewer:this,fetchUrl:i,pathSolver:t});if(n instanceof Uint8Array){const e=function(e){return mr(e)?"image/png":pr(e)?"image/jpeg":_r(e)?"image/gif":gr(e)?"image/webp":""}(n);if(e.length)return new Xd(await ya(new Blob([n.buffer],{type:e})),{viewer:this,fetchUrl:i,pathSolver:t})}const a=this.detectFormat(n);if(a)try{const e=new a.resource(n,{viewer:this,fetchUrl:i,pathSolver:t});return await Promise.all(e.blockers),e.blockers.length=0,e}catch(t){this.emit("error",{viewer:this,error:"Failed to create a resource",fetchUrl:i,src:e,reason:t})}else this.emit("error",{viewer:this,error:"Source has no matching handler",fetchUrl:i,src:e})}})).then((e=>(this.promiseMap.delete(i),e&&(this.resourceMap.set(i,e),this.resources.push(e),this.emit("load",{viewer:this,fetchUrl:i,resource:e})),this.emit("loadend",{viewer:this,fetchUrl:i,resource:e}),this.checkLoadingStatus(),e))),this.promiseMap.set(i,r),this.emit("loadstart",{viewer:this,fetchUrl:i,promise:r}),r}}detectFormat(e){for(const t of this.handlers)if(t.isValidSource(e))return t}has(e){return this.resourceMap.has(e)}get(e){return this.resourceMap.get(e)}async loadGeneric(e,t,n){const a=this.promiseMap.get(e);if(a)return a;const r=this.resourceMap.get(e);if(r)return r;const i=Ud(e,t).then((async t=>{let a;if(this.promiseMap.delete(e),t.ok){let r=t.data;n&&(r=await n(r)),a=new qd(r,{viewer:this,fetchUrl:e}),this.resourceMap.set(e,a),this.resources.push(a),this.emit("load",{viewer:this,fetchUrl:e,resource:a})}else this.emit("error",{viewer:this,error:"Failed to fetch a generic resource",fetchUrl:e});return this.emit("loadend",{viewer:this,fetchUrl:e,resource:a}),this.checkLoadingStatus(),a}));return this.promiseMap.set(e,i),this.emit("loadstart",{viewer:this,fetchUrl:e}),i}unload(e){const t=e.fetchUrl;""!==t&&this.resourceMap.delete(t);const n=this.resources,a=n.indexOf(e);return-1!==a&&(n.splice(a,1),!0)}promise(){const e=Promise.resolve(void 0),t=`${performance.now()}`;return this.promiseMap.set(t,e),()=>{this.promiseMap.delete(t),this.checkLoadingStatus()}}checkLoadingStatus(){0===this.promiseMap.size&&setTimeout((()=>this.emit("idle")),0)}whenAllLoaded(e){const t=new Promise((e=>{0===this.promiseMap.size?e(this):this.once("idle",(()=>e(this)))}));if(!e)return t;t.then((()=>e(this)))}toBlob(e){const t=new Promise((e=>this.canvas.toBlob((t=>e(t)))));return e?void t.then((t=>e(t))):t}updateAndRender(e=1e3/60){this.update(e),this.startFrame(),this.render()}update(e=1e3/60){e*=.001,this.frame+=1,this.visibleCells=0,this.visibleInstances=0,this.updatedParticles=0;for(const t of this.scenes)t.update(e),this.visibleCells+=t.visibleCells,this.visibleInstances+=t.visibleInstances,this.updatedParticles+=t.updatedParticles}startFrame(){const e=this.gl;e.depthMask(!0),e.clearColor(0,0,0,1),e.clear(e.COLOR_BUFFER_BIT|e.DEPTH_BUFFER_BIT)}render(){for(const e of this.scenes)e.render()}clearEmittedObjects(){for(const e of this.scenes)e.clearEmittedObjects()}}const Wd=Gn.create(),Qd=st.create(),eh=Gn.create();class th{constructor(){this.pivot=Gn.create(),this.localLocation=Gn.create(),this.localRotation=st.create(),this.localScale=Gn.fromValues(1,1,1),this.worldLocation=Gn.create(),this.worldRotation=st.create(),this.worldScale=Gn.fromValues(1,1,1),this.inverseWorldLocation=Gn.create(),this.inverseWorldRotation=st.create(),this.inverseWorldScale=Gn.fromValues(1,1,1),this.localMatrix=fe(),this.worldMatrix=fe(),this.dontInheritTranslation=!1,this.dontInheritRotation=!1,this.dontInheritScaling=!0,this.parent=null,this.children=[]}setPivot(e){return Gn.copy(this.pivot,e),this.recalculateTransformation(),this}setLocation(e){return Gn.copy(this.localLocation,e),this.recalculateTransformation(),this}setRotation(e){return st.copy(this.localRotation,e),this.recalculateTransformation(),this}setScale(e){return Gn.copy(this.localScale,e),this.recalculateTransformation(),this}setUniformScale(e){return Gn.set(this.localScale,e,e,e),this.recalculateTransformation(),this}setTransformation(e,t,n){const a=this.localLocation,r=this.localRotation,i=this.localScale;return a[0]=e[0],a[1]=e[1],a[2]=e[2],r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[3],i[0]=n[0],i[1]=n[1],i[2]=n[2],this.recalculateTransformation(),this}resetTransformation(){return Gn.copy(this.pivot,Kn),Gn.copy(this.localLocation,Kn),st.copy(this.localRotation,Zn),Gn.copy(this.localScale,zn),this.recalculateTransformation(),this}movePivot(e){return Gn.add(this.pivot,this.pivot,e),this.recalculateTransformation(),this}move(e){return Gn.add(this.localLocation,this.localLocation,e),this.recalculateTransformation(),this}rotate(e){return st.mul(this.localRotation,this.localRotation,e),this.recalculateTransformation(),this}rotateLocal(e){return st.mul(this.localRotation,e,this.localRotation),this.recalculateTransformation(),this}scale(e){return Gn.mul(this.localScale,this.localScale,e),this.recalculateTransformation(),this}uniformScale(e){return Gn.scale(this.localScale,this.localScale,e),this.recalculateTransformation(),this}face(e,t){return st.conjugate(this.localRotation,la(this.localRotation,this.localLocation,e,t)),this.recalculateTransformation(),this}setParent(e){if(this.parent){const e=this.parent.children,t=e.indexOf(this);-1!==t&&e.splice(t,1)}return this.parent=e||null,e&&e.children.push(this),this.recalculateTransformation(),this}recalculateTransformation(){const e=this.parent,t=this.localMatrix,n=this.localLocation,a=this.localRotation,r=this.localScale,i=this.worldMatrix,s=this.worldLocation,l=this.worldRotation,o=this.worldScale,u=this.inverseWorldLocation,c=this.inverseWorldRotation,d=this.inverseWorldScale;if(e){const s=Wd,u=e.pivot;let c,d;if(s[0]=n[0]+u[0],s[1]=n[1]+u[1],s[2]=n[2]+u[2],this.dontInheritRotation?(c=Qd,st.mul(c,a,e.inverseWorldRotation)):c=a,this.dontInheritScaling){d=eh;const t=e.inverseWorldScale;d[0]=t[0]*r[0],d[1]=t[1]*r[1],d[2]=t[2]*r[2],o[0]=r[0],o[1]=r[1],o[2]=r[2]}else{d=r;const t=e.worldScale;o[0]=t[0]*r[0],o[1]=t[1]*r[1],o[2]=t[2]*r[2]}Ve(t,c,s,d),rt(i,e.worldMatrix,t),st.mul(l,e.worldRotation,c)}else Ve(t,a,n,r),i[0]=t[0],i[1]=t[1],i[2]=t[2],i[3]=t[3],i[4]=t[4],i[5]=t[5],i[6]=t[6],i[7]=t[7],i[8]=t[8],i[9]=t[9],i[10]=t[10],i[11]=t[11],i[12]=t[12],i[13]=t[13],i[14]=t[14],i[15]=t[15],l[0]=a[0],l[1]=a[1],l[2]=a[2],l[3]=a[3],o[0]=r[0],o[1]=r[1],o[2]=r[2];c[0]=-l[0],c[1]=-l[1],c[2]=-l[2],c[3]=l[3],d[0]=1/o[0],d[1]=1/o[1],d[2]=1/o[2],s[0]=i[12],s[1]=i[13],s[2]=i[14],u[0]=-s[0],u[1]=-s[1],u[2]=-s[2];for(const e of this.children)e.recalculateTransformation()}update(e){for(const t of this.children)t.update(e)}}class nh{constructor(){this.x=0,this.y=0,this.z=0,this.r=0}fromExtents(e,t){const n=e[0],a=e[1],r=e[2],i=t[0]-n,s=t[1]-a,l=t[2]-r;this.x=n+i/2,this.y=a+s/2,this.z=r+l/2,this.r=Math.max(0,Math.max(i,s,l)/2)}}class ah extends Zd{constructor(){super(...arguments),this.bounds=new nh}}class rh extends th{constructor(e){super(),this.scene=null,this.left=-1,this.right=-1,this.bottom=-1,this.top=-1,this.plane=-1,this.depth=0,this.updateFrame=0,this.timeScale=1,this.rendered=!0,this.textureOverrides=new Map,this.model=e}show(){this.rendered=!0}hide(){this.rendered=!1}shown(){return this.rendered}hidden(){return!this.rendered}detach(){return!!this.scene&&this.scene.removeInstance(this)}overrideTexture(e,t){t?this.textureOverrides.set(e,t):this.textureOverrides.delete(e)}getBounds(){return this.model.bounds}clearEmittedObjects(){}setScene(e){return e.addInstance(this)}recalculateTransformation(){super.recalculateTransformation(),this.scene&&this.scene.grid.moved(this)}update(e){const t=this.scene;t&&this.rendered&&this.isVisible(t.camera)&&(t.renderInstance(this),this.updateAnimations(e*this.timeScale),super.update(e))}updateAnimations(e){}renderOpaque(){}renderTranslucent(){}isVisible(e){const[t,n,a]=this.worldLocation,[r,i,s]=this.worldScale,l=this.getBounds(),o=e.planes;let u=r;return i>u&&(u=i),s>u&&(u=s),this.plane=Qn(o,t+l.x,n+l.y,a+l.z,l.r*u,this.plane),-1===this.plane&&(this.depth=Wn(o[4],t,n,a),!0)}}const ih={WebGL:Pd,Shader:Bd,ClientBuffer:Rd,DataTexture:Cd,ClientDataTexture:Md};const sh={isValidSource(e){return e instanceof id||((t=e)instanceof ArrayBuffer&&(t=new Uint8Array(t)),t instanceof Uint8Array&&66===t[0]&&76===t[1]&&80===t[2]&&49===t[3]);var t},resource:class extends jd{constructor(e,t){let n;super(t),e instanceof id?n=e:(n=new id,n.load(e));const a=this.viewer.gl,r=a.createTexture();a.bindTexture(a.TEXTURE_2D,r),a.texParameteri(a.TEXTURE_2D,a.TEXTURE_MAG_FILTER,a.LINEAR);const i=ga(n.width)&&ga(n.height);i||(a.texParameteri(a.TEXTURE_2D,a.TEXTURE_WRAP_S,a.CLAMP_TO_EDGE),a.texParameteri(a.TEXTURE_2D,a.TEXTURE_WRAP_T,a.CLAMP_TO_EDGE));const s=n.mipmaps();if(1===s||n.fakeMipmaps()||!i){const e=n.getMipmap(0);a.texParameteri(a.TEXTURE_2D,a.TEXTURE_MIN_FILTER,a.LINEAR),a.texImage2D(a.TEXTURE_2D,0,a.RGBA,a.RGBA,a.UNSIGNED_BYTE,e)}else{a.texParameteri(a.TEXTURE_2D,a.TEXTURE_MIN_FILTER,a.LINEAR_MIPMAP_LINEAR);let e=n.width,t=n.height;for(let r=0;r<s;r++){const i=n.getMipmap(r);a.texImage2D(a.TEXTURE_2D,r,a.RGBA,e,t,0,a.RGBA,a.UNSIGNED_BYTE,i.data),e=Math.ceil(e/2),t=Math.ceil(t/2)}}this.width=n.width,this.height=n.height,this.webglResource=r}}};const lh={load(e){e.webgl.ensureExtension("WEBGL_compressed_texture_s3tc")||console.warn("DDS: No compressed textures support! This might reduce performance.")},isValidSource:e=>e instanceof yd||Sd(e),resource:class extends jd{constructor(e,t){let n;super(t),e instanceof yd?n=e:(n=new yd,n.load(e));const a=this.viewer,r=a.gl,i=a.webgl.extensions.WEBGL_compressed_texture_s3tc,s=n.format;let l=0;i&&(s===bd?l=i.COMPRESSED_RGB_S3TC_DXT1_EXT:s===wd?l=i.COMPRESSED_RGBA_S3TC_DXT3_EXT:s===vd&&(l=i.COMPRESSED_RGBA_S3TC_DXT5_EXT));const o=r.createTexture();this.width=n.width,this.height=n.height,this.webglResource=o,r.bindTexture(r.TEXTURE_2D,o);const u=n.mipmaps();s!==bd&&s!==Ad||r.pixelStorei(r.UNPACK_ALIGNMENT,2);for(let e=0;e<u;e++){const{width:t,height:a,data:i}=n.getMipmap(e,0!==l);l?r.compressedTexImage2D(r.TEXTURE_2D,e,l,t,a,0,i):s===bd||s===wd||s===vd?r.texImage2D(r.TEXTURE_2D,e,r.RGBA,t,a,0,r.RGBA,r.UNSIGNED_BYTE,i):r.texImage2D(r.TEXTURE_2D,e,r.LUMINANCE_ALPHA,t,a,0,r.LUMINANCE_ALPHA,r.UNSIGNED_BYTE,i)}r.pixelStorei(r.UNPACK_ALIGNMENT,4),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.LINEAR),u>1?r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.LINEAR_MIPMAP_LINEAR):r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.LINEAR)}}};class oh{constructor(e,t){this.texture=null,this.wrapS=33071,this.wrapT=33071,e&&(this.wrapS=10497),t&&(this.wrapT=10497)}}const uh={diffuse:1,decal:2,specular:3,gloss:4,emissive:5,emissive2:6,evio:7,evioMask:8,alphaMask:9,alphaMask2:10,normal:11,heightMap:12,lightMap:13,ao:14};class ch{constructor(e,t,n,a,r){this.active=0,this.layer=null,this.source="",this.texture=null,this.flags=0,this.colorChannels=0,this.type="",this.op=0,this.uvCoordinate=0,this.textureUnit=0,this.invert=0,this.clampResult=0,this.teamColorMode=0;const i=e.model;this.model=i,this.material=e,this.gl=e.gl,this.index=t;const s="u_"+a,l=s+"LayerSettings.";if(this.uniformMap={map:s+"Map",enabled:l+"enabled",op:l+"op",channels:l+"channels",teamColorMode:l+"teamColorMode",invert:l+"invert",clampResult:l+"clampResult",uvCoordinate:l+"uvCoordinate"},n.entries){const e=n.first();this.layer=e;const t=i.pathSolver,s=e.imagePath.get();if(s){const n=s.toLowerCase();if(n.length){this.source=n,this.active=1;const s=e.uvSource,l=e.flags;this.flags=l,this.colorChannels=e.colorChannelSetting,this.model=i,this.type=a,this.op=r;let o=0;1===s?o=1:9===s?o=2:10===s&&(o=3),this.uvCoordinate=o,this.textureUnit=uh[a],this.invert=16&l,this.clampResult=32&l,"diffuse"===a&&(this.teamColorMode=1);const u=new oh(!!(4&l),!!(8&l));i.viewer.load(n,t).then((e=>{e&&(u.texture=e)})),this.texture=u}}}}bind(e,t){const n=this.gl,a=this.uniformMap,r=e.uniforms,i=this.active;if(n.uniform1f(r[a.enabled],i),i){const e=this.texture,i=t.get(this.material.index*dh+this.index)||e.texture,s=this.textureUnit;n.uniform1i(r[a.map],s),this.model.viewer.webgl.bindTextureAndWrap(i,s,e.wrapS,e.wrapT),n.uniform1f(r[a.op],this.op),n.uniform1f(r[a.channels],this.colorChannels),n.uniform1f(r[a.teamColorMode],this.teamColorMode),n.uniform1f(r[a.invert],this.invert),n.uniform1f(r[a.clampResult],this.clampResult),n.uniform1f(r[a.uvCoordinate],this.uvCoordinate)}}unbind(e){this.active&&this.gl.uniform1f(e.uniforms[this.uniformMap.enabled],0)}}const dh=100;class hh{constructor(e,t,n){this.model=e,this.gl=e.viewer.gl,this.index=t,this.name=n.name.get(),this.flags=n.flags,this.blendMode=n.blendMode,this.priority=n.priority,this.specularity=n.specularity,this.specMult=n.specMult,this.emisMult=n.emisMult,this.layerBlendType=n.layerBlendType,this.emisBlendType=n.emisBlendType,this.emisMode=n.emisMode,this.doubleSided=8&n.flags,this.layers=[new ch(this,0,n.diffuseLayer,"diffuse",2),new ch(this,1,n.decalLayer,"decal",2),new ch(this,2,n.specularLayer,"specular",2),new ch(this,3,n.glossLayer,"gloss",2),new ch(this,4,n.emissiveLayer,"emissive",n.emisBlendType),new ch(this,5,n.emissive2Layer,"emissive2",n.emisMode),new ch(this,6,n.evioLayer,"evio",2),new ch(this,7,n.evioMaskLayer,"evioMask",2),new ch(this,8,n.alphaMaskLayer,"alphaMask",2),new ch(this,9,n.alphaMask2Layer,"alphaMask2",2),new ch(this,10,n.normalLayer,"normal",2),new ch(this,11,n.heightLayer,"heightMap",2),new ch(this,12,n.lightMapLayer,"lightMap",2),new ch(this,13,n.ambientOcclusionLayer,"ao",2)]}bindCommon(){const e=this.gl;1===this.blendMode||2===this.blendMode?(e.enable(e.BLEND),e.blendFunc(e.ONE,e.ONE)):e.disable(e.BLEND),this.doubleSided?e.disable(e.CULL_FACE):e.enable(e.CULL_FACE),e.enable(e.DEPTH_TEST),e.depthMask(!0)}bind(e,t){const n=this.gl;this.bindCommon(),n.uniform1f(e.uniforms.u_specularity,this.specularity),n.uniform1f(e.uniforms.u_specMult,this.specMult),n.uniform1f(e.uniforms.u_emisMult,this.emisMult),n.uniform4f(e.uniforms.u_lightAmbient,.02,.02,.02,0);const a=this.layers;a[0].bind(e,t),a[1].bind(e,t),a[2].bind(e,t),a[4].bind(e,t),a[5].bind(e,t),a[10].bind(e,t),a[12].bind(e,t)}unbind(e){const t=this.gl;t.disable(t.BLEND),t.enable(t.CULL_FACE);const n=this.layers;n[0].unbind(e),n[1].unbind(e),n[2].unbind(e),n[4].unbind(e),n[5].unbind(e),n[10].unbind(e),n[12].unbind(e)}}class fh{constructor(e){const t=e.flags;this.name=e.name.get(),this.parent=e.parent,this.location=e.location,this.rotation=e.rotation,this.scale=e.scale,this.visibility=e.visibility,this.inhertTranslation=1&t,this.inheritScale=2&t,this.inheritRotation=4&t,this.billboard1=16&t,this.billboard2=64&t,this.twoDProjection=256&t,this.animated=512&t,this.inverseKinematics=1024&t,this.skinned=2048&t,this.real=8192&t}}class mh{constructor(e){this.name=e.name.get(),this.interval=e.interval,this.movementSpeed=e.movementSpeed,this.frequency=e.frequency,this.boundingSphere=e.boundingSphere,this.flags=e.flags}}class ph{constructor(e){this.animIds=new Map;const t=e.animIds.get();for(let e=0,n=t.length;e<n;e++)this.animIds.set(t[e],e)}hasData(e){return this.animIds.has(e.animId)}}const _h=Gn.create(),gh=st.create();class bh{constructor(e){this.keys=e.keys.get(),this.values=e.values.get(),this.biggestKey=e.biggestKey}}class wh{constructor(){this.sd=[]}addSds(e){for(const t of e)this.sd.push(new bh(t))}getValueUnsafe(e,t,n,a){const r=this.sd[e];a&&(n%=r.biggestKey);const i=r.keys,s=r.values;let l=i.length,o=0;for(;o!==i.length&&n>i[o];)l=o,o++;const u=i.length;if(l===u)return o===u?t.initValue:s[o];if(o===u||l>=o)return s[l];const c=da((n-i[l])/(i[o]-i[l]),0,1),d=s[l],h=s[o],f=t.interpolationType,m=d;return 4===m.length?0===f?st.copy(gh,d):st.slerp(gh,d,h,c):3===m.length?0===f?Gn.copy(_h,d):Gn.lerp(_h,d,h,c):0===f?d:ha(d,h,c)}}class vh{constructor(e){this.animRefs=[],this.sd=[];const t=e.animIds.get();this.name=e.name.get(),this.runsConcurrent=e.runsConcurrent,this.priority=e.priority,this.stsIndex=e.stsIndex;const n=e.animRefs.get(),a=new Uint16Array(n.buffer);for(let e=0,n=t.length;e<n;e++)this.animRefs[t[e]]=[a[2*e+1],a[2*e]];for(const t of e.sd){const e=new wh,n=t.get();n&&e.addSds(n),this.sd.push(e)}}getValueUnsafe(e,t){const n=this.animRefs[e.animId];return n?this.sd[n[0]].getValueUnsafe(n[1],e,t.frame,this.runsConcurrent):e.initValue}}class Ah{constructor(e,t,n){this.name=e.name.get(),this.stcIndices=e.stcIndices.get(),this.sts=t,this.stc=n}getValueUnsafe(e,t){const n=this.stcIndices,a=this.stc,r=this.sts;for(let i=0,s=n.length;i<s;i++){const s=a[n[i]];if(r[s.stsIndex].hasData(e))return s.getValueUnsafe(e,t)}return e.initValue}}class yh{constructor(e){this.name=e.name.get(),this.bone=e.bone}}class Sh{constructor(e){this.bone=e.bone,this.name=e.name.get()}}class Th{constructor(e,t,n,a,r){const i=t.firstVertexIndex,s=t.triangleIndicesCount,l=t.firstTriangleIndex;for(let e=0;e<s;e++)a[r+e]=n[l+e]+i;this.gl=e.viewer.gl,this.firstBoneLookupIndex=t.firstBoneLookupIndex,this.boneWeightPairsCount=t.boneWeightPairsCount,this.offset=2*r,this.verticesCount=t.verticesCount,this.elements=s}render(e){const t=this.gl;t.uniform1f(e.uniforms.u_firstBoneLookupIndex,this.firstBoneLookupIndex),t.uniform1f(e.uniforms.u_boneWeightPairsCount,this.boneWeightPairsCount),t.drawElements(t.TRIANGLES,this.elements,t.UNSIGNED_SHORT,this.offset)}}const xh=st.create(),Eh=Gn.create(),Lh=Gn.create(),Ih=st.create();class Uh{constructor(e,t,n,a,r,i,s,l,o,u,c,d){this.dontInheritTranslation=!1,this.dontInheritRotation=!1,this.dontInheritScaling=!1,this.billboarded=!1,this.billboardedX=!1,this.billboardedY=!1,this.billboardedZ=!1,this.dirty=!0,this.wasDirty=!1,this.parent=null,this.children=[],this.object=null,this.pivot=e,this.localLocation=t,this.localRotation=n,this.localScale=a,this.worldLocation=r,this.worldRotation=i,this.worldScale=s,this.inverseWorldLocation=l,this.inverseWorldRotation=o,this.inverseWorldScale=u,this.localMatrix=c,this.worldMatrix=d,this.localRotation[3]=1,this.localScale.fill(1),this.localMatrix[0]=1,this.localMatrix[5]=1,this.localMatrix[10]=1,this.localMatrix[15]=1}recalculateTransformation(e){const t=this.localMatrix,n=this.localRotation,a=this.localScale,r=this.worldMatrix,i=this.worldLocation,s=this.worldRotation,l=this.worldScale,o=this.pivot,u=this.inverseWorldLocation,c=this.inverseWorldRotation,d=this.inverseWorldScale,h=this.parent;let f,m;if(this.dontInheritScaling){m=Eh;const e=h.inverseWorldScale;m[0]=e[0]*a[0],m[1]=e[1]*a[1],m[2]=e[2]*a[2],l[0]=a[0],l[1]=a[1],l[2]=a[2]}else{m=a;const e=h.worldScale;l[0]=e[0]*a[0],l[1]=e[1]*a[1],l[2]=e[2]*a[2]}if(this.billboarded)f=xh,st.copy(f,h.inverseWorldRotation),st.mul(f,f,e.camera.inverseRotation),this.convertBasis(f),st.mul(f,f,n);else{const{billboardedX:t,billboardedY:r,billboardedZ:i}=this;t||r||i?(t&&(m===a&&(m=Eh,Gn.copy(m,a)),m[2]*=-1),Ih[0]=-n[0],Ih[1]=-n[1],Ih[2]=-n[2],st.mul(Ih,Ih,h.inverseWorldRotation),Gn.transformQuat(Lh,e.camera.billboardedVectors[6],Ih),t?st.setAxisAngle(Ih,Vn,Math.atan2(Lh[2],Lh[1])):r?st.setAxisAngle(Ih,Hn,Math.atan2(-Lh[2],Lh[0])):st.setAxisAngle(Ih,Yn,Math.atan2(Lh[1],Lh[0])),f=xh,st.mul(f,n,Ih)):f=n}He(t,f,this.localLocation,m,o),rt(r,h.worldMatrix,t),st.mul(s,h.worldRotation,f),c[0]=-s[0],c[1]=-s[1],c[2]=-s[2],c[3]=s[3],d[0]=1/l[0],d[1]=1/l[1],d[2]=1/l[2];const p=o[0],_=o[1],g=o[2];i[0]=r[0]*p+r[4]*_+r[8]*g+r[12],i[1]=r[1]*p+r[5]*_+r[9]*g+r[13],i[2]=r[2]*p+r[6]*_+r[10]*g+r[14],u[0]=-i[0],u[1]=-i[1],u[2]=-i[2]}convertBasis(e){}}function Rh(e,t=Uh){const n=new Float32Array(65*e),a=[];let r=0;const i=3*e,s=4*e,l=16*e,o=n.subarray(r,r+i);r+=i;const u=n.subarray(r,r+i);r+=i;const c=n.subarray(r,r+s);r+=s;const d=n.subarray(r,r+i);r+=i;const h=n.subarray(r,r+i);r+=i;const f=n.subarray(r,r+s);r+=s;const m=n.subarray(r,r+i);r+=i;const p=n.subarray(r,r+i);r+=i;const _=n.subarray(r,r+s);r+=s;const g=n.subarray(r,r+i);r+=i;const b=n.subarray(r,r+l);r+=l;const w=n.subarray(r,r+l);for(let n=0;n<e;n++){const e=3*n,r=e+3,i=4*n,s=i+4,l=16*n,v=l+16;a[n]=new t(o.subarray(e,r),u.subarray(e,r),c.subarray(i,s),d.subarray(e,r),h.subarray(e,r),f.subarray(i,s),m.subarray(e,r),p.subarray(e,r),_.subarray(i,s),g.subarray(e,r),b.subarray(l,v),w.subarray(l,v))}return{data:n,nodes:a,pivots:o,localLocations:u,localRotations:c,localScales:d,worldLocations:h,worldRotations:f,worldScales:m,inverseWorldLocations:p,invereseWorldRotations:_,inverseWorldScales:g,localMatrices:b,worldMatrices:w}}class Mh extends Uh{convertBasis(e){const t=Math.PI/2;st.rotateZ(e,e,t),st.rotateY(e,e,-t)}}class Ch{constructor(e){const t=e.model,n=t.bones,a=t.boneLookup,r=Rh(n.length,Mh),i=r.nodes;this.nodes=i,this.worldMatrices=r.worldMatrices,this.instance=e,this.modelNodes=n,this.initialReference=t.initialReference,this.sts=t.sts,this.stc=t.stc,this.stg=t.stg,this.boneLookup=a;for(let t=0,a=n.length;t<a;t++){const a=n[t];-1===a.parent?i[t].parent=e:i[t].parent=i[a.parent],a.billboard1&&(i[t].billboarded=!0)}}update(e){const t=this.instance,n=t.scene,a=this.nodes,r=this.modelNodes;for(let i=0,s=a.length;i<s;i++){const s=a[i],l=r[i];this.getValue4(s.localRotation,l.rotation,t),this.getValue3(s.localLocation,l.location,t),this.getValue3(s.localScale,l.scale,t),s.recalculateTransformation(n);for(const t of s.children)t.recalculateTransformation(),t.update(e)}}getValueUnsafe(e,t){const n=t.sequence;return-1!==n?this.stg[n].getValueUnsafe(e,t):e.initValue}getValue(e,t){return this.getValueUnsafe(e,t)}getValue2(e,t,n){const a=this.getValueUnsafe(t,n);return e[0]=a[0],e[1]=a[1],e}getValue3(e,t,n){const a=this.getValueUnsafe(t,n);return e[0]=a[0],e[1]=a[1],e[2]=a[2],e}getValue4(e,t,n){const a=this.getValueUnsafe(t,n);return e[0]=a[0],e[1]=a[1],e[2]=a[2],e[3]=a[3],e}}const Bh=fe();class Ph extends rh{constructor(e){super(e),this.skeleton=null,this.teamColor=0,this.vertexColor=new Float32Array([1,1,1,1]),this.sequence=-1,this.frame=0,this.sequenceLoopMode=0,this.sequenceEnded=!1,this.forced=!0,this.boneTexture=null,this.skeleton=new Ch(this),-1!==this.sequence&&this.setSequence(this.sequence),this.boneTexture=new Cd(e.viewer.gl,3,4*e.boneLookup.length,1)}setTexture(e,t,n){this.overrideTexture(e*dh+t,n)}updateSkeletonAndBoneTexture(e){const t=this.model,n=t.viewer.buffer,a=t.boneLookup,r=this.skeleton,i=r.nodes,s=t.initialReference,l=a.length,o=-1!==this.sequence,u=this.boneTexture;r.update(e),n.reserve(48*l);const c=n.floatView;let d;d=o?Bh:this.worldMatrix;for(let e=0;e<l;e++){const t=12*e;if(o){const t=a[e];d=rt(Bh,i[t].worldMatrix,s[t])}c[t+0]=d[0],c[t+1]=d[1],c[t+2]=d[2],c[t+3]=d[4],c[t+4]=d[5],c[t+5]=d[6],c[t+6]=d[8],c[t+7]=d[9],c[t+8]=d[10],c[t+9]=d[12],c[t+10]=d[13],c[t+11]=d[14]}u.bindAndUpdate(c,u.width,1)}renderOpaque(){const e=this.model,t=e.batches;if(t.length){const n=e.viewer,a=n.sharedCache.get("m3"),r=n.gl,i=e.vertexSize,s=e.uvSetCount,l=a.standardShaders[s-1],o=l.attribs,u=l.uniforms,c=this.scene,d=c.camera,h=this.textureOverrides,f=this.boneTexture;l.use(),r.uniform1f(u.u_teamColor,this.teamColor),r.uniform4fv(u.u_vertexColor,this.vertexColor),r.uniformMatrix4fv(u.u_VP,!1,d.viewProjectionMatrix),r.uniformMatrix4fv(u.u_MV,!1,d.viewMatrix),r.uniform3fv(u.u_eyePos,d.location),r.uniform3fv(u.u_lightPos,c.lightPosition),f.bind(15),r.uniform1i(u.u_boneMap,15),r.uniform1f(u.u_vectorSize,1/f.width),r.uniform1f(u.u_rowSize,1),r.bindBuffer(r.ARRAY_BUFFER,e.arrayBuffer),r.vertexAttribPointer(o.a_position,3,r.FLOAT,!1,i,0),r.vertexAttribPointer(o.a_weights,4,r.UNSIGNED_BYTE,!1,i,12),r.vertexAttribPointer(o.a_bones,4,r.UNSIGNED_BYTE,!1,i,16),r.vertexAttribPointer(o.a_normal,4,r.UNSIGNED_BYTE,!1,i,20);for(let e=0;e<s;e++)r.vertexAttribPointer(o[`a_uv${e}`],2,r.SHORT,!1,i,24+4*e);r.vertexAttribPointer(o.a_tangent,4,r.UNSIGNED_BYTE,!1,i,24+4*s),r.bindBuffer(r.ELEMENT_ARRAY_BUFFER,e.elementBuffer);for(const e of t){const t=e.material,n=e.region;t.bind(l,h),n.render(l),t.unbind(l)}}}updateAnimations(e){const t=this.sequence;if(-1!==t){const n=this.model.sequences[t],a=n.interval;this.frame+=1e3*e,this.frame>a[1]?((0!==this.sequenceLoopMode||1&n.flags)&&2!==this.sequenceLoopMode?this.frame=a[1]:this.frame=a[0],this.sequenceEnded=!0):this.sequenceEnded=!1}(this.forced||-1!==t)&&(this.forced=!1,this.updateSkeletonAndBoneTexture(e))}setTeamColor(e){return this.teamColor=e,this}setVertexColor(e){return this.vertexColor.set(e),this}setSequence(e){const t=this.model;return this.sequence=e,this.frame=0,(e<-1||e>t.sequences.length-1)&&(e=-1,this.sequence=e),this.forced=!0,this}setSequenceLoopMode(e){return this.sequenceLoopMode=e,this}getAttachment(e){const t=this.model.attachments[e];if(t)return this.skeleton.nodes[t.bone]}}class kh{constructor(e,t){this.region=e,this.material=t}}const Oh="\nuniform sampler2D u_boneMap;\nuniform float u_vectorSize;\nuniform float u_rowSize;\n\nmat4 fetchMatrix(float column, float row) {\n  column *= u_vectorSize * 4.0;\n  row *= u_rowSize;\n  // Add in half a texel, to sample in the middle of the texel.\n  // Otherwise, since the sample is directly on the boundary, floating point errors can cause the sample to get the wrong pixel.\n  // This is most noticeable with NPOT textures, which the bone maps are.\n  column += 0.5 * u_vectorSize;\n  row += 0.5 * u_rowSize;\n\n  return mat4(texture2D(u_boneMap, vec2(column, row)),\n              texture2D(u_boneMap, vec2(column + u_vectorSize, row)),\n              texture2D(u_boneMap, vec2(column + u_vectorSize * 2.0, row)),\n              texture2D(u_boneMap, vec2(column + u_vectorSize * 3.0, row)));\n}\n",Dh=`\nuniform mat4 u_VP;\nuniform mat4 u_MV;\nuniform vec3 u_eyePos;\nuniform vec3 u_lightPos;\nuniform float u_firstBoneLookupIndex;\nuniform float u_boneWeightPairsCount;\nuniform vec3 u_teamColors[14];\nuniform float u_teamColor;\nuniform vec4 u_vertexColor;\n\nattribute vec3 a_position;\nattribute vec4 a_normal;\nattribute vec2 a_uv0;\n\n#ifdef EXPLICITUV1\nattribute vec2 a_uv1;\n#endif\n#ifdef EXPLICITUV2\nattribute vec2 a_uv1, a_uv2;\n#endif\n#ifdef EXPLICITUV3\nattribute vec2 a_uv1, a_uv2, a_uv3;\n#endif\n\nattribute vec4 a_tangent;\nattribute vec4 a_bones;\nattribute vec4 a_weights;\n\nvarying vec3 v_normal;\nvarying vec4 v_uv[2]; // Pack 4 vec2 in 2 vec4, to reduce the varyings count\nvarying vec3 v_lightDir;\n// varying vec3 v_eyeVec;\nvarying vec3 v_halfVec;\nvarying vec3 v_teamColor;\nvarying vec4 v_vertexColor;\n\n${Oh}\n\nvec3 TBN(vec3 vector, vec3 tangent, vec3 binormal, vec3 normal) {\n  return vec3(dot(vector, tangent), dot(vector, binormal), dot(vector, normal));\n}\n\nvec4 decodeVector(vec4 v) {\n  return ((v / 255.0) * 2.0) - 1.0;\n}\n\nvoid transform(inout vec3 position, inout vec3 normal, inout vec3 tangent, inout vec3 binormal, vec4 bones, vec4 weights) {\n  if (u_boneWeightPairsCount > 0.0) {\n    mat4 bone;\n\n    if (u_boneWeightPairsCount == 1.0) {\n      bone = fetchMatrix(bones[0], 0.0);\n    } else {\n      bone += fetchMatrix(bones[0], 0.0) * weights[0];\n      bone += fetchMatrix(bones[1], 0.0) * weights[1];\n      bone += fetchMatrix(bones[2], 0.0) * weights[2];\n      bone += fetchMatrix(bones[3], 0.0) * weights[3];\n    }\n\n    position = vec3(bone * vec4(position, 1.0));\n    normal = mat3(bone) * normal;\n    tangent = vec3(bone * vec4(tangent, 0.0));\n    binormal = vec3(bone * vec4(binormal, 0.0));\n  }\n}\n\nvoid main() {\n  vec4 decodedNormal = decodeVector(a_normal);\n\n  vec3 position = a_position;\n  vec3 normal = decodedNormal.xyz;\n  vec3 tangent = vec3(decodeVector(a_tangent));\n  vec3 binormal = cross(normal, tangent) * decodedNormal.w;\n\n  transform(position, normal, tangent, binormal, a_bones + u_firstBoneLookupIndex, a_weights / 255.0);\n\n  vec3 position_mv = vec3(u_MV * vec4(position, 1));\n\n  mat3 mv = mat3(u_MV);\n  vec3 t = normalize(mv * tangent);\n  vec3 b = normalize(mv * binormal);\n  vec3 n = normalize(mv * normal);\n\n  vec3 lightDir = normalize(u_lightPos - position_mv);\n\n  v_lightDir = normalize(TBN(lightDir, t, b, n));\n\n  vec3 eyeVec = normalize(u_eyePos - position_mv);\n  vec3 halfVec = normalize(eyeVec - u_lightPos);\n\n  // v_eyeVec = TBN(eyeVec, t, b, n);\n  v_halfVec = TBN(halfVec, t, b, n);\n\n  v_normal = n;\n\n  vec4 uv0, uv1;\n\n  uv0.xy = a_uv0 / 2048.0;\n\n  #ifdef EXPLICITUV1\n  uv0.zw = a_uv1 / 2048.0;\n  #endif\n\n  #ifdef EXPLICITUV2\n  uv0.zw = a_uv1 / 2048.0;\n  uv1.xy = a_uv2 / 2048.0;\n  #endif\n\n  #ifdef EXPLICITUV3\n  uv0.zw = a_uv1 / 2048.0;\n  uv1.xy = a_uv2 / 2048.0;\n  uv1.zw = a_uv3 / 2048.0;\n  #endif\n\n  v_uv[0] = uv0;\n  v_uv[1] = uv1;\n\n  v_teamColor = u_teamColors[int(u_teamColor)];\n  v_vertexColor = u_vertexColor;\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n`,Fh="\n#ifdef GL_FRAGMENT_PRECISION_HIGH\nprecision highp float;\n#else\nprecision mediump float;\n#endif\n",Gh=`\n${Fh}\n\n\nvarying vec3 v_normal;\nvarying vec4 v_uv[2];\nvarying vec3 v_lightDir;\n// varying vec3 v_eyeVec;\nvarying vec3 v_halfVec;\nvarying vec3 v_teamColor;\nvarying vec4 v_vertexColor;\n\nstruct LayerSettings {\n  bool enabled;\n  float op;\n  float channels;\n  float teamColorMode;\n  // vec3 multAddAlpha;\n  // bool useAlphaFactor;\n  bool invert;\n  // bool multColor;\n  // bool addColor;\n  bool clampResult;\n  // bool useConstantColor;\n  // vec4 constantColor;\n  // float uvSource;\n  float uvCoordinate;\n  // float fresnelMode;\n  // float fresnelTransformMode;\n  // mat4 fresnelTransform;\n  // bool fresnelClamp;\n  // vec3 fresnelExponentBiasScale;\n};\n\nuniform float u_specularity;\nuniform float u_specMult;\nuniform float u_emisMult;\nuniform vec4 u_lightAmbient;\n\nuniform LayerSettings u_diffuseLayerSettings;\nuniform sampler2D u_diffuseMap;\nuniform LayerSettings u_decalLayerSettings;\nuniform sampler2D u_decalMap;\nuniform LayerSettings u_specularLayerSettings;\nuniform sampler2D u_specularMap;\nuniform LayerSettings u_glossLayerSettings;\nuniform sampler2D u_glossMap;\nuniform LayerSettings u_emissiveLayerSettings;\nuniform sampler2D u_emissiveMap;\nuniform LayerSettings u_emissive2LayerSettings;\nuniform sampler2D u_emissive2Map;\nuniform LayerSettings u_evioLayerSettings;\nuniform sampler2D u_evioMap;\nuniform LayerSettings u_evioMaskLayerSettings;\nuniform sampler2D u_evioMaskMap;\nuniform LayerSettings u_alphaLayerSettings;\nuniform sampler2D u_alphaMap;\nuniform LayerSettings u_alphaMaskLayerSettings;\nuniform sampler2D u_alphaMaskMap;\nuniform LayerSettings u_normalLayerSettings;\nuniform sampler2D u_normalMap;\nuniform LayerSettings u_heightLayerSettings;\nuniform sampler2D u_heightMap;\nuniform LayerSettings u_lightMapLayerSettings;\nuniform sampler2D u_lightMapMap;\nuniform LayerSettings u_aoLayerSettings;\nuniform sampler2D u_aoMap;\n\n#define SPECULAR_RGB 0.0\n#define SPECULAR_A_ONLY 1.0\n\n#define FRESNELMODE_NONE 0.0\n#define FRESNELMODE_STANDARD 1.0\n#define FRESNELMODE_INVERTED 2.0\n\n#define FRESNELTRANSFORM_NONE 0.0\n#define FRESNELTRANSFORM_SIMPLE 1.0\n#define FRESNELTRANSFORM_NORMALIZED 2.0\n\n#define UVMAP_EXPLICITUV0 0.0\n#define UVMAP_EXPLICITUV1 1.0\n#define UVMAP_REFLECT_CUBICENVIO 2.0\n#define UVMAP_REFLECT_SPHERICALENVIO 3.0\n#define UVMAP_PLANARLOCALZ 4.0\n#define UVMAP_PLANARWORLDZ 5.0\n#define UVMAP_PARTICLE_FLIPBOOK 6.0\n#define UVMAP_CUBICENVIO 7.0\n#define UVMAP_SPHERICALENVIO 8.0\n#define UVMAP_EXPLICITUV2 9.0\n#define UVMAP_EXPLICITUV3 10.0\n#define UVMAP_PLANARLOCALX 11.0\n#define UVMAP_PLANARLOCALY 12.0\n#define UVMAP_PLANARWORLDX 13.0\n#define UVMAP_PLANARWORLDY 14.0\n#define UVMAP_SCREENSPACE 15.0\n#define UVMAP_TRIPLANAR_LOCAL 16.0\n#define UVMAP_TRIPLANAR_WORLD 17.0\n#define UVMAP_TRIPLANAR_WORLD_LOCAL_Z 18.0\n\n#define CHANNELSELECT_RGB 0.0\n#define CHANNELSELECT_RGBA 1.0\n#define CHANNELSELECT_A 2.0\n#define CHANNELSELECT_R 3.0\n#define CHANNELSELECT_G 4.0\n#define CHANNELSELECT_B 5.0\n\n#define TEAMCOLOR_NONE 0.0\n#define TEAMCOLOR_DIFFUSE 1.0\n#define TEAMCOLOR_EMISSIVE 2.0\n\n#define LAYEROP_MOD 0.0\n#define LAYEROP_MOD2X 1.0\n#define LAYEROP_ADD 2.0\n#define LAYEROP_LERP 3.0\n#define LAYEROP_TEAMCOLOR_EMISSIVE_ADD 4.0\n#define LAYEROP_TEAMCOLOR_DIFFUSE_ADD 5.0\n#define LAYEROP_ADD_NO_ALPHA 6.0\n\n// float calculateFresnelTerm(vec3 normal, vec3 eyeToVertex, float exponent, mat4 fresnelTransform, float fresnelTransformMode, bool fresnelClamp) {\n//   vec3 fresnelDir = eyeToVertex;\n//   float result;\n\n//   if (fresnelTransformMode != FRESNELTRANSFORM_NONE) {\n//     fresnelDir = (fresnelTransform * vec4(fresnelDir, 1.0)).xyz;\n\n//     if (fresnelTransformMode == FRESNELTRANSFORM_NORMALIZED) {\n//       fresnelDir = normalize(fresnelDir);\n//     }\n//   }\n\n//   if (fresnelClamp) {\n//     result = 1.0 - clamp(-dot(normal, fresnelDir), 0.0, 1.0);\n//   } else {\n//     result = 1.0 - abs(dot(normal, fresnelDir));\n//   }\n\n//   result = max(result, 0.0000001);\n\n//   return pow(result, exponent);\n// }\n\nvec3 combineLayerColor(vec4 color, vec3 result, LayerSettings layerSettings) {\n  if (layerSettings.op == LAYEROP_MOD) {\n    result *= color.rgb;\n  } else if (layerSettings.op == LAYEROP_MOD2X) {\n    result *= color.rgb * 2.0;\n  } else if (layerSettings.op == LAYEROP_ADD) {\n    result += color.rgb * color.a;\n  } else if (layerSettings.op == LAYEROP_ADD_NO_ALPHA) {\n    result += color.rgb;\n  } else if (layerSettings.op == LAYEROP_LERP) {\n    result = mix(result, color.rgb, color.a);\n  } else if (layerSettings.op == LAYEROP_TEAMCOLOR_EMISSIVE_ADD) {\n    result += color.a * v_teamColor;\n  } else if (layerSettings.op == LAYEROP_TEAMCOLOR_DIFFUSE_ADD) {\n    result += color.a * v_teamColor;\n  }\n\n  return result;\n}\n\nvec4 chooseChannel(float channel, vec4 texel) {\n  if (channel == CHANNELSELECT_R) {\n    texel = texel.rrrr;\n  } else if (channel == CHANNELSELECT_G) {\n    texel = texel.gggg;\n  } else if (channel == CHANNELSELECT_B) {\n    texel = texel.bbbb;\n  } else if (channel == CHANNELSELECT_A) {\n    texel = texel.aaaa;\n  } else if (channel == CHANNELSELECT_RGB) {\n    texel.a = 1.0;\n  }\n\n  return texel;\n}\n\nvec2 getUV(LayerSettings layerSettings) {\n  if (layerSettings.uvCoordinate == 1.0) {\n    return v_uv[0].zw;\n  } else if (layerSettings.uvCoordinate == 2.0) {\n    return v_uv[1].xy;\n  } else if (layerSettings.uvCoordinate == 3.0) {\n    return v_uv[1].zw;\n  }\n\n  return v_uv[0].xy;\n}\n\nvec4 sampleLayer(sampler2D layer, LayerSettings layerSettings) {\n  // if (layerSettings.useConstantColor) {\n  //   return layerSettings.constantColor;\n  // }\n\n  return texture2D(layer, getUV(layerSettings));\n}\n\nvec4 computeLayerColor(sampler2D layer, LayerSettings layerSettings) {\n  vec4 color = sampleLayer(layer, layerSettings);\n\n  // if (layerSettings.useMask) {\n  //   result *= mask;\n  // }\n\n  vec4 result = chooseChannel(layerSettings.channels, color);\n\n  // if (layerSettings.useAlphaFactor) {\n  //   result.a *= layerSettings.multiplyAddAlpha.z;\n  // }\n\n  if (layerSettings.teamColorMode == TEAMCOLOR_DIFFUSE) {\n    result = vec4(mix(v_teamColor, result.rgb, color.a), 1.0);\n  } else if (layerSettings.teamColorMode == TEAMCOLOR_EMISSIVE) {\n    result = vec4(mix(v_teamColor, result.rgb, color.a), 1.0);\n  }\n\n  if (layerSettings.invert) {\n    result = vec4(1.0) - result;\n  }\n\n  // if (layerSettings.multiplyEnable) {\n  //   result *= layerSettings.multiplyAddAlpha.x;\n  // }\n\n  // if (layerSettings.addEnable) {\n  //   result += layerSettings.multiplyAddAlpha.y;\n  // }\n\n  if (layerSettings.clampResult) {\n    result = clamp(result, 0.0, 1.0);\n  }\n\n  // if (layerSettings.fresnelMode != FRESNELMODE_NONE) {\n  //   float fresnelTerm = calculateFresnelTerm(v_normal, v_eyeVec, layerSettings.fresnelExponentBiasScale.x, layerSettings.fresnelTransform, layerSettings.fresnelTransformMode, layerSettings.fresnelClamp);\n    \n  //   if (layerSettings.fresnelMode == FRESNELMODE_INVERTED) {\n  //     fresnelTerm = 1.0 - fresnelTerm;\n  //   }\n    \n  //   fresnelTerm = clamp(fresnelTerm * layerSettings.fresnelExponentBiasScale.z + layerSettings.fresnelExponentBiasScale.y, 0.0, 1.0);\n    \n  //   result *= fresnelTerm;\n  // }\n\n  return result;\n}\n\nvec3 decodeNormal(sampler2D map) {\n  vec4 texel = texture2D(map, v_uv[0].xy);\n  vec3 normal;\n\n  normal.xy = 2.0 * texel.wy - 1.0;\n  normal.z = sqrt(max(0.0, 1.0 - dot(normal.xy, normal.xy)));\n\n  return normal;\n}\n\nvec4 computeSpecular(sampler2D specularMap, LayerSettings layerSettings, float specularity, float specMult, vec3 normal) {\n  vec4 color;\n\n  if (layerSettings.enabled) {\n    color = computeLayerColor(specularMap, layerSettings);\n  } else {\n    color = vec4(0);\n  }\n\n  float factor = pow(max(-dot(v_halfVec, normal), 0.0), specularity) * specMult;\n\n  return color * factor;\n}\n\n\nvoid main() {\n  vec3 color;\n  vec4 final = u_lightAmbient;\n  vec3 normal;\n  vec3 lightMapDiffuse;\n\n  if (u_normalLayerSettings.enabled) {\n    normal = decodeNormal(u_normalMap);\n  } else {\n    normal = v_normal;\n  }\n\n  float lambertFactor = max(dot(normal, v_lightDir), 0.0);\n\n  if (lambertFactor > 0.0) {\n    if (u_diffuseLayerSettings.enabled) {\n      vec4 diffuseColor = computeLayerColor(u_diffuseMap, u_diffuseLayerSettings);\n\n      color = combineLayerColor(diffuseColor, color, u_diffuseLayerSettings);\n    }\n\n    if (u_decalLayerSettings.enabled) {\n      vec4 decalColor = computeLayerColor(u_decalMap, u_decalLayerSettings);\n\n      color = combineLayerColor(decalColor, color, u_decalLayerSettings);\n    }\n\n    vec4 specularColor = computeSpecular(u_specularMap, u_specularLayerSettings, u_specularity, u_specMult, normal);\n\n    if (u_lightMapLayerSettings.enabled) {\n      vec4 lightMapColor = computeLayerColor(u_lightMapMap, u_lightMapLayerSettings) * 2.0;\n\n      lightMapDiffuse = lightMapColor.rgb;\n    }\n\n    // final.rgb = color * lightMapDiffuse + specularColor.rgb;\n    final.rgb = (color + specularColor.rgb) * lambertFactor;\n\n    bool addEmissive = false;\n    vec3 emissiveColor;\n    vec4 tempColor;\n\n    if (u_emissiveLayerSettings.enabled) {\n      tempColor = computeLayerColor(u_emissiveMap, u_emissiveLayerSettings);\n\n      if (u_emissiveLayerSettings.op == LAYEROP_MOD || u_emissiveLayerSettings.op == LAYEROP_MOD2X || u_emissiveLayerSettings.op == LAYEROP_LERP) {\n        final.rgb = combineLayerColor(tempColor, final.rgb, u_emissiveLayerSettings);\n      } else {\n        emissiveColor = combineLayerColor(tempColor, emissiveColor, u_emissiveLayerSettings);\n        addEmissive = true;\n      }\n    }\n\n    if (u_emissive2LayerSettings.enabled) {\n      tempColor = computeLayerColor(u_emissive2Map, u_emissive2LayerSettings);\n\n      if (!addEmissive && (u_emissive2LayerSettings.op == LAYEROP_MOD || u_emissive2LayerSettings.op == LAYEROP_MOD2X || u_emissive2LayerSettings.op == LAYEROP_LERP)) {\n        final.rgb = combineLayerColor(tempColor, final.rgb, u_emissive2LayerSettings);\n      } else {\n        emissiveColor = combineLayerColor(tempColor, emissiveColor, u_emissive2LayerSettings);\n        addEmissive = true;\n      }\n    }\n\n    if (addEmissive) {\n      final.rgb += emissiveColor * u_emisMult;\n    }\n  }\n\n  gl_FragColor = final * v_vertexColor;\n}\n`,Nh={load(e){const t=e.gl,n=e.webgl,a=[[255,3,3],[0,66,255],[28,230,185],[84,0,129],[255,252,1],[254,138,14],[32,192,0],[229,91,176],[149,150,151],[126,191,241],[16,98,70],[78,42,4],[40,40,40],[0,0,0]];if(!n.ensureExtension("OES_texture_float"))throw new Error("M3: No float texture support!");const r=[];for(let e=0;e<4;e++){const i=n.createShader(`#define EXPLICITUV${e}\n${Dh}`,Gh);i.use();for(let e=0;e<14;e++){const n=a[e];t.uniform3f(i.uniforms["u_teamColors["+e+"]"],n[0]/255,n[1]/255,n[2]/255)}r[e]=i}const i={standardShaders:r};e.sharedCache.set("m3",i)},isValidSource:e=>e instanceof Nr||Vr(e),resource:class extends ah{constructor(e,t){let n;super(t),this.name="",this.batches=[],this.materials=[[],[]],this.materialMaps=[],this.bones=[],this.sequences=[],this.sts=[],this.stc=[],this.stg=[],this.attachments=[],this.cameras=[],this.regions=[],this.initialReference=[],this.elementBuffer=null,this.arrayBuffer=null,this.vertexSize=0,this.uvSetCount=0,e instanceof Nr?n=e:(n=new Nr,n.load(e));const a=n.model,r=a.divisions.first();this.name=a.modelName.get(),this.setupGeometry(a,r);const i=a.materialReferences.get();this.materialMaps=i;const s=a.materials[0].get();for(let e=0,t=s.length;e<t;e++)this.materials[1].push(new hh(this,e,s[e]));for(const e of r.batches.get()){const t=e.regionIndex,n=i[e.materialReferenceIndex];1===n.materialType&&this.batches.push(new kh(this.regions[t],this.materials[1][n.materialIndex]))}this.initialReference=a.absoluteInverseBoneRestPositions.get();for(const e of a.bones.get())this.bones.push(new fh(e));this.boneLookup=a.boneLookup.get();const l=a.sequences.get();if(l)for(const e of l)this.sequences.push(new mh(e));const o=a.sts.get();if(o)for(const e of o)this.sts.push(new ph(e));const u=a.stc.get();if(u)for(const e of u)this.stc.push(new vh(e));const c=a.stg.get();if(c)for(const e of c)this.stg.push(new Ah(e,this.sts,this.stc));this.addGlobalAnims();const d=a.attachmentPoints.get();if(d)for(const e of d)this.attachments.push(new yh(e));const h=a.cameras.get();if(h)for(const e of h)this.cameras.push(new Sh(e))}addInstance(){return new Ph(this)}setupGeometry(e,t){const n=this.viewer.gl;let a=1;const r=e.vertexFlags;262144&r?a=2:524288&r?a=3:1048576&r&&(a=4);const i=t.regions.get();let s=0;const l=[];for(let e=0,t=i.length;e<t;e++)l[e]=s,s+=i[e].triangleIndicesCount;const o=new Uint16Array(s),u=t.triangles.get();for(let e=0,t=i.length;e<t;e++)this.regions.push(new Th(this,i[e],u,o,l[e]));const c=e.vertices.get();this.elementBuffer=n.createBuffer(),n.bindBuffer(n.ELEMENT_ARRAY_BUFFER,this.elementBuffer),n.bufferData(n.ELEMENT_ARRAY_BUFFER,o,n.STATIC_DRAW);const d=n.createBuffer();n.bindBuffer(n.ARRAY_BUFFER,d),n.bufferData(n.ARRAY_BUFFER,c,n.STATIC_DRAW),this.arrayBuffer=d,this.vertexSize=4*(7+a),this.uvSetCount=a}mapMaterial(e){const t=this.materialMaps[e];return this.materials[t.materialType][t.materialIndex]}addGlobalAnims(){}}};let Vh;"function"==typeof OfflineAudioContext&&(Vh=new OfflineAudioContext(1,1,48e3));class Hh{constructor(e){this.map={},e&&this.load(e)}load(e){if(e.startsWith("ID;")){const t=new Ar;t.load(e);const n=t.rows,a=n[0],r=this.map;for(let e=1,t=n.length;e<t;e++){const t=n[e];if(t){let e=t[0];if(e&&"_"!==e){e=e.toLowerCase(),r[e]||(r[e]={});const n=r[e];for(let e=0,r=a.length;e<r;e++){let r=a[e];void 0===r&&(r=`column${e}`),n[`${r}`]=t[e]}}}}}else{const t=new wr;t.load(e);const n=t.sections,a=this.map;for(const[e,t]of n.entries()){a[e]||(a[e]={});const n=a[e];for(const[e,a]of t)n[e]=a}}}getRow(e){return this.map[e.toLowerCase()]}getProperty(e,t){return this.map[e.toLowerCase()][t]}setRow(e,t){this.map[e.toLowerCase()]=t}findRow(e,t){for(const n of Object.values(this.map))if(n[e]===t)return n}}class Yh{constructor(e){this.name=e.name,this.interval=e.interval,this.nonLooping=e.nonLooping,this.rarity=e.rarity,this.bounds=new nh;const t=e.extent;this.bounds.fromExtents(t.min,t.max)}}class Kh{constructor(e,t,n,a,r){this.frames=[],this.values=[],this.inTans=[],this.outTans=[],this.constant=!1,this.sd=e,this.start=t,this.end=n;const i=e.interpolationType,s=a.frames,l=a.values,o=a.inTans,u=a.outTans,c=e.defval;r&&s[0]>n&&(this.frames[0]=s[0],this.values[0]=l[0]);for(let e=0,a=s.length;e<a;e++){const a=s[e];a>=t&&a<=n&&(this.frames.push(a),this.values.push(l[e]),i>1&&(this.inTans.push(o[e]),this.outTans.push(u[e])))}const d=this.frames.length;if(0===d)this.constant=!0,this.frames[0]=t,this.values[0]=c;else if(1===d)this.constant=!0;else{const e=this.values[0];this.constant=this.values.every((t=>e.every(((e,n)=>e===t[n]))))}}getValue(e,t){const n=this.frames.length;if(this.constant||t<this.start)return this.sd.copy(e,this.values[0]),-1;{let a=-1,r=-1;const i=n-1;if(t<this.frames[0]||t>=this.frames[i])a=i,r=0;else for(let e=1;e<n;e++)if(this.frames[e]>t){a=e-1,r=e;break}let s=this.frames[a];const l=this.frames[r];let o=l-s;o<0&&(o+=this.end-this.start,t<s&&(s=l));const u=0==o?0:(t-s)/o;return this.sd.interpolate(e,this.values,this.inTans,this.outTans,a,r,u),a}}}const zh={KLAV:0,KATV:0,KPEV:0,KP2V:0,KRVS:0},qh=new Float32Array(1),Zh=new Uint32Array(1),jh=new Float32Array([1]),Xh=Gn.create(),$h=st.create(),Jh=Gn.fromValues(1,1,1),Wh=Xh,Qh={KMTF:qh,KMTA:jh,KTAT:Xh,KTAR:$h,KTAS:Jh,KGAO:jh,KGAC:Wh,KLAS:qh,KLAE:qh,KLAC:Wh,KLAI:qh,KLBI:qh,KLBC:Wh,KLAV:jh,KATV:jh,KPEE:qh,KPEG:qh,KPLN:qh,KPLT:qh,KPEL:qh,KPES:qh,KPEV:jh,KP2S:qh,KP2R:qh,KP2L:qh,KP2G:qh,KP2E:qh,KP2N:qh,KP2W:qh,KP2V:jh,KRHA:qh,KRHB:qh,KRAL:new Float32Array([0]),KRCO:Wh,KRTX:qh,KRVS:jh,KCTR:Xh,KTTR:Xh,KCRL:Zh,KGTR:Xh,KGRT:$h,KGSC:Jh};class ef{constructor(e,t){this.globalSequence=null,this.sequences=[];const n=e.globalSequences,a=t.globalSequenceId,r=zh[t.name];if(this.model=e,this.name=t.name,this.defval=Qh[t.name],this.interpolationType=void 0!==r?r:t.interpolationType,-1!==a&&n)this.globalSequence=new Kh(this,0,n[a],t,!0);else for(const n of e.sequences){const e=n.interval;this.sequences.push(new Kh(this,e[0],e[1],t,!1))}}getValue(e,t,n,a){return this.globalSequence?this.globalSequence.getValue(e,a%this.globalSequence.end):this.sequences[t].getValue(e,n)}isVariant(e){return this.globalSequence?!this.globalSequence.constant:!this.sequences[e].constant}}class tf extends ef{copy(e,t){e[0]=t[0]}interpolate(e,t,n,a,r,i,s){const l=this.interpolationType,o=t[r][0];0===l?e[0]=o:1===l?e[0]=ha(o,t[i][0],s):2===l?e[0]=fa(o,a[r][0],n[i][0],t[i][0],s):3===l&&(e[0]=ma(o,a[r][0],n[i][0],t[i][0],s))}}class nf extends ef{copy(e,t){Gn.copy(e,t)}interpolate(e,t,n,a,r,i,s){const l=this.interpolationType;0===l?Gn.copy(e,t[r]):1===l?Gn.lerp(e,t[r],t[i],s):2===l?Gn.hermite(e,t[r],a[r],n[i],t[i],s):3===l&&Gn.bezier(e,t[r],a[r],n[i],t[i],s)}}class af extends ef{copy(e,t){st.copy(e,t)}interpolate(e,t,n,a,r,i,s){const l=this.interpolationType;0===l?st.copy(e,t[r]):1===l?st.slerp(e,t[r],t[i],s):2!==l&&3!==l||st.sqlerp(e,t[r],a[r],n[i],t[i],s)}}function rf(e,t){return t instanceof Zr||t instanceof jr?new tf(e,t):t instanceof Xr?new nf(e,t):new af(e,t)}class sf{constructor(e,t){this.animations=new Map,this.variants={},this.model=e;for(const n of t.animations)this.animations.set(n.name,rf(e,n))}getScalarValue(e,t,n,a,r,i){if(-1!==n){const i=this.animations.get(t);if(i)return i.getValue(e,n,a,r)}return e[0]=i,-1}getVectorValue(e,t,n,a,r,i){if(-1!==n){const i=this.animations.get(t);if(i)return i.getValue(e,n,a,r)}return e[0]=i[0],e[1]=i[1],e[2]=i[2],-1}getQuatValue(e,t,n,a,r,i){if(-1!==n){const i=this.animations.get(t);if(i)return i.getValue(e,n,a,r)}return e[0]=i[0],e[1]=i[1],e[2]=i[2],e[3]=i[3],-1}addVariants(e,t){const n=this.animations.get(e),a=this.model.sequences.length,r=new Uint8Array(a);if(n)for(let e=0;e<a;e++)n.isVariant(e)&&(r[e]=1);this.variants[t]=r}addVariantIntersection(e,t){const n=this.model.sequences.length,a=new Uint8Array(n);for(let t=0;t<n;t++)for(const n of e)this.variants[n][t]&&(a[t]=1);this.variants[t]=a}}class lf extends sf{constructor(e,t){super(e,t),this.addVariants("KTAT","translation"),this.addVariants("KTAR","rotation"),this.addVariants("KTAS","scale")}getTranslation(e,t,n,a){return this.getVectorValue(e,"KTAT",t,n,a,Kn)}getRotation(e,t,n,a){return this.getQuatValue(e,"KTAR",t,n,a,Zn)}getScale(e,t,n,a){return this.getVectorValue(e,"KTAS",t,n,a,zn)}}function of(e,t){return 0===e?[t.SRC_ALPHA,t.ONE_MINUS_SRC_ALPHA]:1===e?[t.SRC_ALPHA,t.ONE]:2===e?[t.ZERO,t.SRC_COLOR]:3===e?[t.DST_COLOR,t.SRC_COLOR]:4===e?[t.SRC_ALPHA,t.ONE_MINUS_SRC_ALPHA]:[0,0]}class uf extends sf{constructor(e,t,n,a){super(e,t),this.textureId=0,this.blendSrc=0,this.blendDst=0,this.blended=!1,this.textureAnimation=null;let r=t.filterMode;const i=t.textureAnimationId,s=e.viewer.gl;this.index=n,this.priorityPlane=a,r>6&&(r=2),this.filterMode=r,-1!==t.textureId&&(this.textureId=t.textureId),this.coordId=t.coordId,this.alpha=t.alpha;const l=t.flags;if(this.unshaded=1&l,this.sphereEnvironmentMap=2&l,this.twoSided=16&l,this.unfogged=32&l,this.noDepthTest=64&l,this.noDepthSet=128&l,this.depthMaskValue=0===r||1===r,r>1&&(this.blended=!0,[this.blendSrc,this.blendDst]=function(e,t){return 2===e?[t.SRC_ALPHA,t.ONE_MINUS_SRC_ALPHA]:3===e||4===e?[t.SRC_ALPHA,t.ONE]:5===e?[t.ZERO,t.SRC_COLOR]:6===e?[t.DST_COLOR,t.SRC_COLOR]:[0,0]}(r,s)),-1!==i){const t=e.textureAnimations[i];t&&(this.textureAnimation=t)}this.addVariants("KMTA","alpha"),this.addVariants("KMTF","textureId")}bind(e){const t=this.model.viewer.gl;t.uniform1f(e.uniforms.u_filterMode,this.filterMode),this.blended?(t.enable(t.BLEND),t.blendFunc(this.blendSrc,this.blendDst)):t.disable(t.BLEND),this.twoSided?t.disable(t.CULL_FACE):t.enable(t.CULL_FACE),this.noDepthTest?t.disable(t.DEPTH_TEST):t.enable(t.DEPTH_TEST),this.noDepthSet?t.depthMask(!1):t.depthMask(this.depthMaskValue)}getAlpha(e,t,n,a){return this.getScalarValue(e,"KMTA",t,n,a,this.alpha)}getTextureId(e,t,n,a){return this.getScalarValue(e,"KMTF",t,n,a,this.textureId)}}class cf{constructor(e,t,n){this.model=e,this.shader=t,this.layers=n}}class df extends sf{constructor(e,t){super(e,t);const n=t.color;this.alpha=t.alpha,this.color=Gn.fromValues(n[2],n[1],n[0]),this.geosetId=t.geosetId,this.addVariants("KGAO","alpha"),this.addVariants("KGAC","color")}getAlpha(e,t,n,a){return this.getScalarValue(e,"KGAO",t,n,a,this.alpha)}getColor(e,t,n,a){return this.getVectorValue(e,"KGAC",t,n,a,this.color)}}const hf={1:"TeamColor/TeamColor00",2:"TeamGlow/TeamGlow00",11:"Cliff/Cliff0",21:"",31:"LordaeronTree/LordaeronSummerTree",32:"AshenvaleTree/AshenTree",33:"BarrensTree/BarrensTree",34:"NorthrendTree/NorthTree",35:"Mushroom/MushroomTree",36:"RuinsTree/RuinsTree",37:"OutlandMushroomTree/MushroomTree"};class ff extends sf{constructor(e,t,n){super(e,t),this.index=n,this.name=t.name,this.objectId=t.objectId,this.parentId=t.parentId,this.pivot=e.pivotPoints[t.objectId]||Gn.create();const a=t.flags;this.dontInheritTranslation=1&a,this.dontInheritRotation=2&a,this.dontInheritScaling=4&a,this.billboarded=8&a,this.billboardedX=16&a,this.billboardedY=32&a,this.billboardedZ=64&a,this.cameraAnchored=128&a,this.anyBillboarding=0!==(this.billboarded||this.billboardedX||this.billboardedY||this.billboardedZ),t.objectId===t.parentId&&(this.parentId=-1),this.addVariants("KGTR","translation"),this.addVariants("KGRT","rotation"),this.addVariants("KGSC","scale"),this.addVariantIntersection(["translation","rotation","scale"],"generic")}getVisibility(e,t,n,a){return e[0]=1,-1}getTranslation(e,t,n,a){return this.getVectorValue(e,"KGTR",t,n,a,Kn)}getRotation(e,t,n,a){return this.getQuatValue(e,"KGRT",t,n,a,Zn)}getScale(e,t,n,a){return this.getVectorValue(e,"KGSC",t,n,a,zn)}}class mf extends ff{constructor(e,t,n){super(e,t,n),this.geosetAnimation=e.geosetAnimations[t.geosetAnimationId]}getVisibility(e,t,n,a){return this.geosetAnimation?this.geosetAnimation.getAlpha(e,t,n,a):(e[0]=1,-1)}}class pf extends ff{constructor(e,t,n){super(e,t,n),this.type=t.type,this.attenuation=t.attenuation,this.color=t.color,this.intensity=t.intensity,this.ambientColor=t.ambientColor,this.ambientIntensity=t.ambientIntensity}getAttenuationStart(e,t,n,a){return this.getScalarValue(e,"KLAS",t,n,a,this.attenuation[0])}getAttenuationEnd(e,t,n,a){return this.getScalarValue(e,"KLAE",t,n,a,this.attenuation[1])}getIntensity(e,t,n,a){return this.getScalarValue(e,"KLAI",t,n,a,this.intensity)}getColor(e,t,n,a){return this.getVectorValue(e,"KLAC",t,n,a,this.color)}getAmbientIntensity(e,t,n,a){return this.getScalarValue(e,"KLBI",t,n,a,this.ambientIntensity)}getAmbientColor(e,t,n,a){return this.getVectorValue(e,"KLBC",t,n,a,this.ambientColor)}}class _f extends ff{}class gf extends ff{constructor(e,t,n){super(e,t,n),this.internalModel=null;const a=t.path.replace(/\\/g,"/").toLowerCase().replace(".mdl",".mdx");if(this.path=a,this.attachmentId=t.attachmentId,""!==a&&-1!=a.indexOf(".mdx")){const t=e.viewer.load(a,e.pathSolver,e.solverParams);t.then((e=>{e&&(this.internalModel=e)})),e.blockers.push(t)}}getVisibility(e,t,n,a){return this.getScalarValue(e,"KATV",t,n,a,1)}}class bf extends ff{constructor(e,t,n){super(e,t,n),this.internalModel=null,this.ok=!1,this.speed=t.speed,this.latitude=t.latitude,this.longitude=t.longitude,this.lifeSpan=t.lifeSpan,this.gravity=t.gravity,this.emissionRate=t.emissionRate,e.viewer.load(t.path.replace(/\\/g,"/").toLowerCase().replace(".mdl",".mdx"),e.pathSolver,e.solverParams).then((e=>{e&&(this.internalModel=e,this.ok=!0)}))}getSpeed(e,t,n,a){return this.getScalarValue(e,"KPES",t,n,a,this.speed)}getLatitude(e,t,n,a){return this.getScalarValue(e,"KPLTV",t,n,a,this.latitude)}getLongitude(e,t,n,a){return this.getScalarValue(e,"KPLN",t,n,a,this.longitude)}getLifeSpan(e,t,n,a){return this.getScalarValue(e,"KPEL",t,n,a,this.lifeSpan)}getGravity(e,t,n,a){return this.getScalarValue(e,"KPEG",t,n,a,this.gravity)}getEmissionRate(e,t,n,a){return this.getScalarValue(e,"KPEE",t,n,a,this.emissionRate)}getVisibility(e,t,n,a){return this.getScalarValue(e,"KPEV",t,n,a,1)}}const wf=Gn.create(),vf=Gn.create(),Af=Gn.create(),yf=60,Sf=1e4;function Tf(e,t){const n=e.objects,a=t.floatView;let r=0;for(const e of n){const t=15*r,n=t+0,i=e.vertices;a[n+0]=i[0],a[n+1]=i[1],a[n+2]=i[2],a[n+3]=i[3],a[n+4]=i[4],a[n+5]=i[5],a[n+6]=i[6],a[n+7]=i[7],a[n+8]=i[8],a[n+9]=i[9],a[n+10]=i[10],a[n+11]=i[11],a[t+12]=e.health,r+=1}}function xf(e,t){let n=e.alive;const a=e.emitterObject.geometryEmitterType;if(1===a&&(n-=1),n>0){const r=e.instance.model.viewer,i=r.buffer,s=r.gl,l=r.webgl.extensions.ANGLE_instanced_arrays,o=n*yf,u=t.attribs;i.reserve(o),0===a?(function(e,t){const n=e.instance,a=e.objects,r=t.byteView,i=t.floatView,s=e.emitterObject,l=s.modelSpace,o=s.tailLength,u=e.node,c=n.teamColor;let d=0;for(const e of a){const t=d*yf,n=15*d,a=n+0;let s=e.location;const h=e.scale,f=e.tail;if(0===f)l&&(s=Gn.transformMat4(wf,s,u.worldMatrix)),i[a+0]=s[0],i[a+1]=s[1],i[a+2]=s[2],i[a+3]=e.facing;else{const t=e.velocity;let n=vf,r=s;n[0]=r[0]-o*t[0],n[1]=r[1]-o*t[1],n[2]=r[2]-o*t[2],l&&(n=Gn.transformMat4(n,n,u.worldMatrix),r=Gn.transformMat4(Af,r,u.worldMatrix)),i[a+0]=n[0],i[a+1]=n[1],i[a+2]=n[2],i[a+3]=r[0],i[a+4]=r[1],i[a+5]=r[2]}i[a+6]=h[0],i[a+7]=h[0],i[a+8]=h[0],i[n+12]=e.health,r[t+56]=f,r[t+57]=c,d+=1}}(e,i),function(e,t){const n=e.instance,a=n.textureOverrides,r=n.scene.camera,i=e.emitterObject,s=i.model,l=s.viewer,o=l.gl,u=l.sharedCache.get("mdx"),c=t.uniforms,d=i.colors,h=i.intervals,f=i.replaceableId;let m,p=i.internalTexture;o.blendFunc(i.blendSrc,i.blendDst),o.uniform1f(c.u_filterMode,i.filterMode),p=i.internalTexture?i.internalTexture:1===f?u.teamColors[n.teamColor]:2===f?u.teamGlows[n.teamColor]:s.textures[i.textureId];let _=a.get(1e3+i.index);_||(0===f&&(_=a.get(i.textureId)),_||(_=p.texture)),l.webgl.bindTextureAndWrap(_,0,p.wrapS,p.wrapT),m=i.xYQuad?r.vectors:r.billboardedVectors,o.uniform1f(c.u_lifeSpan,i.lifeSpan),o.uniform1f(c.u_timeMiddle,i.timeMiddle),o.uniform1f(c.u_columns,i.columns),o.uniform1f(c.u_rows,i.rows),o.uniform1f(c.u_teamColored,i.teamColored),o.uniform3fv(c["u_intervals[0]"],h[0]),o.uniform3fv(c["u_intervals[1]"],h[1]),o.uniform3fv(c["u_intervals[2]"],h[2]),o.uniform3fv(c["u_intervals[3]"],h[3]),o.uniform4fv(c["u_colors[0]"],d[0]),o.uniform4fv(c["u_colors[1]"],d[1]),o.uniform4fv(c["u_colors[2]"],d[2]),o.uniform3fv(c.u_scaling,i.scaling),i.head&&(o.uniform3fv(c["u_vertices[0]"],m[0]),o.uniform3fv(c["u_vertices[1]"],m[1]),o.uniform3fv(c["u_vertices[2]"],m[2]),o.uniform3fv(c["u_vertices[3]"],m[3])),i.tail&&o.uniform3fv(c.u_cameraZ,r.directionZ)}(e,t)):1===a?(function(e,t){let n=e.first;const a=t.byteView,r=t.floatView,i=e.emitterObject.columns,s=1/(e.alive-1);let l=0;for(;n.next;){const e=n.next.vertices,t=l*yf,o=15*l+0,u=t+52,c=t+57,d=(n.slot%i+(1-l*s-s))/i,h=n.slot/i,f=d+s,m=n.vertices,p=n.color;r[o+0]=m[0],r[o+1]=m[1],r[o+2]=m[2],r[o+3]=m[3],r[o+4]=m[4],r[o+5]=m[5],r[o+6]=e[3],r[o+7]=e[4],r[o+8]=e[5],r[o+9]=e[0],r[o+10]=e[1],r[o+11]=e[2],a[u+0]=p[0],a[u+1]=p[1],a[u+2]=p[2],a[u+3]=p[3],a[c+0]=255*d,a[c+1]=255*f,a[c+2]=255*h,n=n.next,l+=1}}(e,i),function(e,t){const n=e.instance.textureOverrides,a=e.emitterObject,r=a.layer,i=a.model,s=i.viewer.gl,l=t.uniforms,o=i.textures[r.textureId],u=n.get(r.textureId)||o.texture;r.bind(t),s.uniform1f(l.u_filterMode,r.filterMode),i.viewer.webgl.bindTextureAndWrap(u,0,o.wrapS,o.wrapT),s.uniform1f(l.u_columns,a.columns),s.uniform1f(l.u_rows,a.rows)}(e,t)):2===a?(Tf(e,i),function(e,t){const n=e.instance.textureOverrides,a=e.emitterObject,r=a.intervalTimes,i=a.intervals,s=a.colors,l=a.model,o=l.viewer.gl,u=t.uniforms,c=a.internalTexture,d=n.get(Sf+a.index)||c.texture;o.blendFunc(a.blendSrc,a.blendDst),l.viewer.webgl.bindTextureAndWrap(d,0,c.wrapS,c.wrapT),o.uniform1f(u.u_lifeSpan,a.lifeSpan),o.uniform1f(u.u_columns,a.columns),o.uniform1f(u.u_rows,a.rows),o.uniform3f(u.u_intervalTimes,r[0],r[1],0),o.uniform3fv(u["u_intervals[0]"],i[0]),o.uniform3fv(u["u_intervals[1]"],i[1]),o.uniform4fv(u["u_colors[0]"],s[0]),o.uniform4fv(u["u_colors[1]"],s[1]),o.uniform4fv(u["u_colors[2]"],s[2])}(e,t)):(Tf(e,i),function(e,t){const n=e.instance.textureOverrides,a=e.emitterObject,r=a.intervalTimes,i=a.colors,s=a.model,l=s.viewer.gl,o=t.uniforms,u=a.internalTexture,c=n.get(Sf+a.index)||u.texture;l.blendFunc(a.blendSrc,a.blendDst),s.viewer.webgl.bindTextureAndWrap(c,0,u.wrapS,u.wrapT),l.uniform1f(o.u_lifeSpan,a.lifeSpan),l.uniform1f(o.u_columns,a.columns),l.uniform1f(o.u_rows,a.rows),l.uniform3fv(o.u_intervalTimes,r),l.uniform4fv(o["u_colors[0]"],i[0]),l.uniform4fv(o["u_colors[1]"],i[1]),l.uniform4fv(o["u_colors[2]"],i[2])}(e,t)),i.bindAndUpdate(o),s.uniform1i(t.uniforms.u_emitter,a),s.vertexAttribPointer(u.a_p0,3,s.FLOAT,!1,yf,0),s.vertexAttribPointer(u.a_p1,3,s.FLOAT,!1,yf,12),s.vertexAttribPointer(u.a_p2,3,s.FLOAT,!1,yf,24),s.vertexAttribPointer(u.a_p3,3,s.FLOAT,!1,yf,36),s.vertexAttribPointer(u.a_health,1,s.FLOAT,!1,yf,48),s.vertexAttribPointer(u.a_color,4,s.UNSIGNED_BYTE,!0,yf,52),s.vertexAttribPointer(u.a_tail,1,s.UNSIGNED_BYTE,!1,yf,56),s.vertexAttribPointer(u.a_leftRightTop,3,s.UNSIGNED_BYTE,!1,yf,57),l.drawArraysInstancedANGLE(s.TRIANGLES,0,6,n)}}class Ef{constructor(e,t){this.texture=null,this.wrapS=33071,this.wrapT=33071,this.replaceableId=e,1&t&&(this.wrapS=10497),2&t&&(this.wrapT=10497)}}class Lf extends ff{constructor(e,t,n){super(e,t,n),this.geometryEmitterType=0,this.teamColored=0,this.internalTexture=null,this.colors=[],this.ok=!0,this.width=t.width,this.length=t.length,this.speed=t.speed,this.latitude=t.latitude,this.gravity=t.gravity,this.emissionRate=2*t.emissionRate,this.squirt=t.squirt,this.lifeSpan=t.lifeSpan,this.variation=t.variation,this.tailLength=t.tailLength,this.timeMiddle=t.timeMiddle;const a=t.flags;this.lineEmitter=131072&a,this.unfogged=262144&a,this.modelSpace=524288&a,this.xYQuad=1048576&a;const r=t.replaceableId;if(this.columns=t.columns,this.rows=t.rows,1===r||2===r)this.teamColored=1;else if(r>2){const t=e.reforged?".dds":".blp";this.internalTexture=new Ef(r,0),e.viewer.load(`ReplaceableTextures\\${hf[r]}${t}`,e.pathSolver,e.solverParams).then((e=>{e&&(this.internalTexture.texture=e)}))}this.replaceableId=t.replaceableId,this.textureId=t.textureId;const i=t.headOrTail;this.head=0===i||2===i,this.tail=1===i||2===i,this.cellWidth=1/t.columns,this.cellHeight=1/t.rows;const s=t.segmentColors,l=t.segmentAlphas;for(let e=0;e<3;e++){const t=s[e];this.colors[e]=new Float32Array([t[0],t[1],t[2],l[e]/255])}this.scaling=t.segmentScaling;const o=t.headIntervals,u=t.tailIntervals;this.intervals=[new Float32Array(o[0]),new Float32Array(o[1]),new Float32Array(u[0]),new Float32Array(u[1])];const c=of(t.filterMode,this.model.viewer.gl);this.filterMode=t.filterMode,this.blendSrc=c[0],this.blendDst=c[1],this.priorityPlane=t.priorityPlane}getWidth(e,t,n,a){return this.getScalarValue(e,"KP2N",t,n,a,this.width)}getLength(e,t,n,a){return this.getScalarValue(e,"KP2W",t,n,a,this.length)}getSpeed(e,t,n,a){return this.getScalarValue(e,"KP2S",t,n,a,this.speed)}getLatitude(e,t,n,a){return this.getScalarValue(e,"KP2L",t,n,a,this.latitude)}getGravity(e,t,n,a){return this.getScalarValue(e,"KP2G",t,n,a,this.gravity)}getEmissionRate(e,t,n,a){return this.getScalarValue(e,"KP2E",t,n,a,this.emissionRate)}getVariation(e,t,n,a){return this.getScalarValue(e,"KP2R",t,n,a,this.variation)}getVisibility(e,t,n,a){return this.getScalarValue(e,"KP2V",t,n,a,1)}}class If extends ff{constructor(e,t,n){super(e,t,n),this.geometryEmitterType=1,this.ok=!0,this.layer=e.materials[t.materialId].layers[0],this.heightAbove=t.heightAbove,this.heightBelow=t.heightBelow,this.alpha=t.alpha,this.color=t.color,this.lifeSpan=t.lifeSpan,this.textureSlot=t.textureSlot,this.emissionRate=2*t.emissionRate,this.gravity=t.gravity,this.columns=t.columns,this.rows=t.rows}getHeightBelow(e,t,n,a){return this.getScalarValue(e,"KRHB",t,n,a,this.heightBelow)}getHeightAbove(e,t,n,a){return this.getScalarValue(e,"KRHA",t,n,a,this.heightAbove)}getTextureSlot(e,t,n,a){return this.getScalarValue(e,"KRTX",t,n,a,0)}getColor(e,t,n,a){return this.getVectorValue(e,"KRCO",t,n,a,this.color)}getAlpha(e,t,n,a){return this.getScalarValue(e,"KRAL",t,n,a,this.alpha)}getVisibility(e,t,n,a){const r=this.getAlpha(e,t,n,a);return 0===e[0]?r:this.getScalarValue(e,"KRVS",t,n,a,1)}}class Uf extends sf{constructor(e,t){super(e,t),this.name=t.name,this.position=t.position,this.fieldOfView=t.fieldOfView,this.farClippingPlane=t.farClippingPlane,this.nearClippingPlane=t.nearClippingPlane,this.targetPosition=t.targetPosition}getTranslation(e,t,n,a){return this.getVectorValue(e,"KCTR",t,n,a,Kn)}getTargetTranslation(e,t,n,a){return this.getVectorValue(e,"KTTR",t,n,a,Kn)}getRotation(e,t,n,a){return this.getScalarValue(e,"KCRL",t,n,a,0)}}class Rf extends ff{constructor(e,t,n){super(e,t,n),this.geometryEmitterType=-1,this.globalSequence=-1,this.defval=new Uint32Array(1),this.internalModel=null,this.internalTexture=null,this.colors=[],this.intervalTimes=new Float32Array(3),this.scale=0,this.columns=0,this.rows=0,this.lifeSpan=0,this.blendSrc=0,this.blendDst=0,this.intervals=[],this.distanceCutoff=0,this.maxDistance=0,this.minDistance=0,this.pitch=0,this.pitchVariance=0,this.volume=0,this.decodedBuffers=[],this.ok=!1;const a=e.viewer,r=t.name;let i=r.substring(0,3);const s=r.substring(4);"FPT"===i&&(i="SPL"),"SPL"===i?this.geometryEmitterType=2:"UBR"===i&&(this.geometryEmitterType=3),this.type=i,this.id=s,this.tracks=t.tracks;const l=t.globalSequenceId;if(-1!==l&&(this.globalSequence=e.globalSequences[l]),"SND"===i&&!a.audioEnabled)return;const o=a.promise();Ym.getEventObjectData(a,i,s,e.hd).then((e=>{if(o(),e){const{row:t,resources:n}=e;if(this.ok=!0,"SPN"===i)this.internalModel=n[0];else if("SPL"===i||"UBR"===i){this.internalTexture=new Ef(0,3),this.internalTexture.texture=n[0],this.scale=t.Scale,this.colors[0]=new Float32Array([t.StartR,t.StartG,t.StartB,t.StartA]),this.colors[1]=new Float32Array([t.MiddleR,t.MiddleG,t.MiddleB,t.MiddleA]),this.colors[2]=new Float32Array([t.EndR,t.EndG,t.EndB,t.EndA]),"SPL"===i?(this.columns=t.Columns,this.rows=t.Rows,this.lifeSpan=t.Lifespan+t.Decay,this.intervalTimes[0]=t.Lifespan,this.intervalTimes[1]=t.Decay,this.intervals[0]=new Float32Array([t.UVLifespanStart,t.UVLifespanEnd,t.LifespanRepeat]),this.intervals[1]=new Float32Array([t.UVDecayStart,t.UVDecayEnd,t.DecayRepeat])):(this.columns=1,this.rows=1,this.lifeSpan=t.BirthTime+t.PauseTime+t.Decay,this.intervalTimes[0]=t.BirthTime,this.intervalTimes[1]=t.PauseTime,this.intervalTimes[2]=t.Decay);const e=of(t.BlendMode,a.gl);this.blendSrc=e[0],this.blendDst=e[1]}else{this.distanceCutoff=t.DistanceCutoff,this.maxDistance=t.MaxDistance,this.minDistance=t.MinDistance,this.pitch=t.Pitch,this.pitchVariance=t.PitchVariance,this.volume=t.Volume;for(const e of n)this.decodedBuffers.push(e.data)}}}))}getValue(e,t){if(-1!==this.globalSequence){const n=this.globalSequence;return this.getValueAtTime(e,t.counter%n,0,n)}if(-1!==t.sequence){const n=this.model.sequences[t.sequence].interval;return this.getValueAtTime(e,t.frame,n[0],n[1])}return e[0]=this.defval[0],-1}getValueAtTime(e,t,n,a){const r=this.tracks;if(t>=n&&t<=a)for(let a=r.length-1;a>-1;a--){if(r[a]<n)return e[0]=0,a;if(r[a]<=t)return e[0]=1,a}return e[0]=0,-1}}class Mf extends ff{}var Cf;!function(e){e[e.VertexGroups=0]="VertexGroups",e[e.ExtendedVertexGroups=1]="ExtendedVertexGroups",e[e.Skin=2]="Skin"}(Cf||(Cf={}));class Bf{constructor(e,t,n,a,r){let i,s;r?(i=n,s=i.layers[0]):(i=null,s=n),this.index=e,this.geoset=t,this.skinningType=a,this.isHd=r,this.layer=s,this.material=i}}class Pf{constructor(e,t,n,a,r,i,s,l,o,u,c){this.geosetAnimation=null,this.model=e,this.index=t,this.positionOffset=n,this.normalOffset=a,this.uvOffset=r,this.tangentOffset=i,this.skinOffset=s,this.faceOffset=l,this.vertices=o,this.elements=u,this.faceType=c;for(const n of e.geosetAnimations)n.geosetId===t&&(this.geosetAnimation=n)}bindShared(e,t,n){e.vertexAttribPointer(t.a_position,3,e.FLOAT,!1,0,this.positionOffset),e.vertexAttribPointer(t.a_normal,3,e.FLOAT,!1,0,this.normalOffset),e.vertexAttribPointer(t.a_uv,2,e.FLOAT,!1,0,this.uvOffset+n*this.vertices*8)}bindVertexGroups(e,t){const n=this.model,a=n.skinDataType,r=n.bytesPerSkinElement;e.vertexAttribPointer(t.a_bones,4,a,!1,5*r,this.skinOffset),e.vertexAttribPointer(t.a_boneNumber,1,a,!1,5*r,this.skinOffset+4*r)}bindVertexGroupsExtended(e,t){const n=this.model,a=n.skinDataType,r=n.bytesPerSkinElement;e.vertexAttribPointer(t.a_bones,4,a,!1,9*r,this.skinOffset),e.vertexAttribPointer(t.a_extendedBones,4,a,!1,9*r,this.skinOffset+4*r),e.vertexAttribPointer(t.a_boneNumber,1,a,!1,9*r,this.skinOffset+8*r)}bindSkin(e,t){e.vertexAttribPointer(t.a_bones,4,e.UNSIGNED_BYTE,!1,8,this.skinOffset),e.vertexAttribPointer(t.a_weights,4,e.UNSIGNED_BYTE,!0,8,this.skinOffset+4)}bind(e,t){const n=this.model.viewer.gl,a=e.attribs;this.bindShared(n,a,t),this.bindVertexGroups(n,a)}bindExtended(e,t){const n=this.model.viewer.gl,a=e.attribs;this.bindShared(n,a,t),this.bindVertexGroupsExtended(n,a)}bindHd(e,t,n){const a=this.model.viewer.gl,r=e.attribs;this.bindShared(a,r,n),a.vertexAttribPointer(r.a_tangent,4,a.FLOAT,!1,0,this.tangentOffset),t===Cf.Skin?this.bindSkin(a,r):t===Cf.VertexGroups?this.bindVertexGroupsExtended(a,r):this.bindVertexGroups(a,r)}render(){const e=this.model.viewer.gl;e.drawElements(this.faceType,this.elements,e.UNSIGNED_SHORT,this.faceOffset)}}class kf{constructor(e,t,n){this.objects=[],this.model=e,this.skinningType=t,this.isHd=n}render(e){const t=e.scene,n=t.camera,a=e.textureOverrides,r=e.layerAlphas,i=this.model,s=i.textures,l=i.batches,o=i.viewer,u=o.sharedCache.get("mdx"),c=o.gl,d=o.webgl,h=this.skinningType,f=this.isHd,m=u.teamColors,p=u.teamGlows,_=Ym.getBatchShader(o,h,f);_.use();const g=_.uniforms;c.uniformMatrix4fv(g.u_VP,!1,n.viewProjectionMatrix);const b=e.boneTexture;if(b?(b.bind(15),c.uniform1f(g.u_hasBones,1),c.uniform1i(g.u_boneMap,15),c.uniform1f(g.u_vectorSize,1/b.width),c.uniform1f(g.u_rowSize,1)):c.uniform1f(g.u_hasBones,0),c.uniform3fv(g.u_lightPos,t.lightPosition),c.bindBuffer(c.ARRAY_BUFFER,i.arrayBuffer),c.bindBuffer(c.ELEMENT_ARRAY_BUFFER,i.elementBuffer),f){c.uniform1i(g.u_diffuseMap,0),c.uniform1i(g.u_normalsMap,1),c.uniform1i(g.u_ormMap,2),c.uniform1i(g.u_emissiveMap,3),c.uniform1i(g.u_teamColorMap,4),c.uniform1i(g.u_environmentMap,5),c.disable(c.BLEND),c.enable(c.DEPTH_TEST),c.depthMask(!0),c.uniformMatrix4fv(g.u_MV,!1,n.viewMatrix),c.uniform3fv(g.u_eyePos,n.location);for(const t of this.objects){const n=l[t],i=n.geoset,o=n.material,[u,h,f,p,b,w]=o.layers,v=r[u.index];if(v>0){c.uniform1f(g.u_layerAlpha,v),c.uniform1f(g.u_filterMode,u.filterMode);const t=u.textureId,r=h.textureId,l=f.textureId,o=p.textureId,A=b.textureId,y=w.textureId,S=s[t],T=s[r],x=s[l],E=s[o];let L=s[A];const I=s[y];0!==L.replaceableId&&1!==L.replaceableId||(L=m[e.teamColor]);const U=a.get(t)||S.texture,R=a.get(r)||T.texture,M=a.get(l)||x.texture,C=a.get(o)||E.texture,B=a.get(A)||L.texture,P=a.get(y)||I.texture;d.bindTextureAndWrap(U,0,S.wrapS,S.wrapT),d.bindTextureAndWrap(R,1,T.wrapS,T.wrapT),d.bindTextureAndWrap(M,2,x.wrapS,x.wrapT),d.bindTextureAndWrap(C,3,E.wrapS,E.wrapT),d.bindTextureAndWrap(B,4,L.wrapS,L.wrapT),d.bindTextureAndWrap(P,5,I.wrapS,I.wrapT),i.bindHd(_,n.skinningType,u.coordId),i.render()}}}else{const t=e.geosetColors,n=e.layerTextures,i=e.uvAnims;c.uniform4fv(g.u_vertexColor,e.vertexColor),c.uniform1i(g.u_texture,0);for(const o of this.objects){const u=l[o],f=u.geoset,b=u.layer,w=f.index,v=b.index,A=t[w],y=r[v];if(A[3]>.01&&y>.01){const t=n[v],r=s[t],l=i[v];c.uniform4fv(g.u_geosetColor,A),c.uniform1f(g.u_layerAlpha,y),c.uniform1f(g.u_unshaded,b.unshaded),c.uniform2f(g.u_uvTrans,l[0],l[1]),c.uniform2f(g.u_uvRot,l[2],l[3]),c.uniform1f(g.u_uvScale,l[4]),b.bind(_);let o=a.get(t);if(!o){const t=r.replaceableId;let n;n=1===t?m[e.teamColor]:2===t?p[e.teamColor]:r,n&&(o=n.texture)}d.bindTextureAndWrap(o,0,r.wrapS,r.wrapT),h===Cf.ExtendedVertexGroups?f.bindExtended(_,b.coordId):f.bind(_,b.coordId),f.render()}}}}}class Of{constructor(e){this.objects=[],this.model=e}render(e){const t=e.scene,n=e.nodes,a=e.model.viewer,r=a.gl,i=a.webgl.extensions.ANGLE_instanced_arrays,s=a.sharedCache.get("mdx"),l=s.particlesShader,o=l.uniforms,u=l.attribs,c=s.rectBuffer;r.depthMask(!1),r.enable(r.BLEND),r.disable(r.CULL_FACE),r.enable(r.DEPTH_TEST),l.use(),r.uniformMatrix4fv(o.u_VP,!1,t.camera.viewProjectionMatrix),r.uniform1i(o.u_texture,0),i.vertexAttribDivisorANGLE(u.a_position,0),r.bindBuffer(r.ARRAY_BUFFER,c),r.vertexAttribPointer(u.a_position,1,r.UNSIGNED_BYTE,!1,0,0),i.vertexAttribDivisorANGLE(u.a_p0,1),i.vertexAttribDivisorANGLE(u.a_p1,1),i.vertexAttribDivisorANGLE(u.a_p2,1),i.vertexAttribDivisorANGLE(u.a_p3,1),i.vertexAttribDivisorANGLE(u.a_health,1),i.vertexAttribDivisorANGLE(u.a_color,1),i.vertexAttribDivisorANGLE(u.a_tail,1),i.vertexAttribDivisorANGLE(u.a_leftRightTop,1);for(const e of this.objects)xf(n[e].object,l);i.vertexAttribDivisorANGLE(u.a_leftRightTop,0),i.vertexAttribDivisorANGLE(u.a_tail,0),i.vertexAttribDivisorANGLE(u.a_color,0),i.vertexAttribDivisorANGLE(u.a_health,0),i.vertexAttribDivisorANGLE(u.a_p3,0),i.vertexAttribDivisorANGLE(u.a_p2,0),i.vertexAttribDivisorANGLE(u.a_p1,0),i.vertexAttribDivisorANGLE(u.a_p0,0)}}function Df(e){return e instanceof Bf||e instanceof If?e.layer.priorityPlane:e instanceof Lf?e.priorityPlane:0}function Ff(e,t){return e instanceof kf?t instanceof Bf&&t.skinningType===e.skinningType&&t.isHd===e.isHd:t instanceof ff}function Gf(e,t){return t instanceof Bf?new kf(e,t.skinningType,t.isHd):new Of(e)}class Nf extends Uh{convertBasis(e){st.rotateY(e,e,-Math.PI/2),st.rotateX(e,e,-Math.PI/2)}}const Vf=new Float32Array(1);class Hf{constructor(e,t){const n=t.internalModel.addInstance();n.setSequenceLoopMode(2),n.dontInheritScaling=!1,n.hide(),n.setParent(e.nodes[t.objectId]),this.instance=e,this.attachment=t,this.internalInstance=n}update(){const e=this.instance,t=this.internalInstance;e.scene&&-1!==e.sequence&&(this.attachment.getVisibility(Vf,e.sequence,e.frame,e.counter),Vf[0]>.1?(e.scene.addInstance(t),t.hidden()&&(t.show(),t.setSequence(0))):t.hide())}}class Yf extends class{constructor(e){this.objects=[],this.alive=0,this.currentEmission=0,this.instance=e}update(e){this.updateEmission(e);const t=this.currentEmission;if(t>=1)for(let e=0;e<t;e+=1)this.emit()}clear(){const e=this.objects;for(let t=0,n=this.alive;t<n;t++){e[t].health=0}this.currentEmission=0}emitObject(e){const t=this.objects;this.alive===t.length&&t.push(this.createObject());const n=t[this.alive];n.index=this.alive,n.bind(e),this.alive+=1,this.currentEmission-=1;return this.instance.scene.emittedObjectUpdater.add(n),n}kill(e){const t=this.objects;this.alive-=1;const n=t[this.alive];t[e.index]=n,t[this.alive]=e,n.index=e.index,e.index=-1}}{constructor(e,t){super(e),this.emitterObject=t}update(e){this.emitterObject.ok&&super.update(e)}}class Kf{constructor(e){this.index=-1,this.health=0,this.emitter=e}}const zf=st.create(),qf=Gn.create(),Zf=new Float32Array(1),jf=new Float32Array(1),Xf=new Float32Array(1),$f=new Float32Array(1);class Jf extends Kf{constructor(e){super(e),this.velocity=Gn.create(),this.gravity=0;const t=e.emitterObject.internalModel;this.internalInstance=t.addInstance()}bind(){const e=this.emitter,t=e.instance,n=t.sequence,a=t.frame,r=t.counter,i=t.scene,s=e.emitterObject,l=t.nodes[s.index],o=this.internalInstance,u=l.worldScale,c=this.velocity;s.getLatitude(Zf,n,a,r),s.getLifeSpan(jf,n,a,r),s.getGravity(Xf,n,a,r),s.getSpeed($f,n,a,r),this.health=jf[0],this.gravity=Xf[0]*u[2],st.identity(zf),st.rotateZ(zf,zf,ca(-Math.PI,Math.PI)),st.rotateY(zf,zf,ca(-Zf[0],Zf[0])),Gn.transformQuat(c,Yn,zf),Gn.transformQuat(c,c,l.worldRotation),Gn.scale(c,c,$f[0]),Gn.mul(c,c,u),o.setScene(i),o.setSequence(0),o.setTransformation(l.worldLocation,st.setAxisAngle(zf,Yn,ca(0,2*Math.PI)),l.worldScale),o.show()}update(e){const t=this.internalInstance;if(this.health-=e,this.health>0){const n=this.velocity;n[2]-=this.gravity*e,t.move(Gn.scale(qf,n,e))}else t.hide()}}const Wf=new Float32Array(1);class Qf extends Yf{updateEmission(e){const t=this.instance;if(t.allowParticleSpawn){this.emitterObject.getEmissionRate(Wf,t.sequence,t.frame,t.counter),this.currentEmission+=Wf[0]*e}}emit(){this.emitObject()}createObject(){return new Jf(this)}}const em=st.create(),tm=new Float32Array(1),nm=new Float32Array(1),am=new Float32Array(1),rm=new Float32Array(1),im=new Float32Array(1),sm=new Float32Array(1);class lm extends Kf{constructor(){super(...arguments),this.tail=0,this.gravity=0,this.location=Gn.create(),this.velocity=Gn.create(),this.scale=Gn.create(),this.facing=0}bind(e){const t=this.emitter,n=t.instance,a=n.sequence,r=n.frame,i=n.counter,s=t.emitterObject;s.getWidth(tm,a,r,i),s.getLength(nm,a,r,i),s.getLatitude(am,a,r,i),s.getVariation(rm,a,r,i),s.getSpeed(im,a,r,i),s.getGravity(sm,a,r,i);const l=t.node,o=l.pivot,u=l.worldScale,c=.5*tm[0],d=.5*nm[0],h=oa(am[0]),f=rm[0],m=im[0],p=this.location,_=this.velocity;this.health=s.lifeSpan,this.tail=e,this.gravity=sm[0]*u[2],Gn.copy(this.scale,u),p[0]=o[0]+ca(-c,c),p[1]=o[1]+ca(-d,d),p[2]=o[2],s.modelSpace||Gn.transformMat4(p,p,l.worldMatrix),st.identity(em),st.rotateZ(em,em,Math.PI/2),st.rotateY(em,em,ca(-h,h)),s.lineEmitter||st.rotateX(em,em,ca(-h,h)),s.modelSpace||st.mul(em,l.worldRotation,em),Gn.transformQuat(_,Yn,em),Gn.scale(_,_,m*(1+ca(-f,f))),s.modelSpace||Gn.mul(_,_,u),s.xYQuad&&(this.facing=Math.atan2(_[1],_[0])-Math.PI+Math.PI/8)}update(e){if(this.health-=e,this.health>0){const t=this.location,n=this.velocity;n[2]-=this.gravity*e,t[0]+=n[0]*e,t[1]+=n[1]*e,t[2]+=n[2]*e}}}const om=new Float32Array(1);class um extends Yf{constructor(e,t){super(e,t),this.lastEmissionKey=-1,this.node=e.nodes[t.index]}updateEmission(e){const t=this.instance;if(t.allowParticleSpawn){const n=this.emitterObject,a=n.getEmissionRate(om,t.sequence,t.frame,t.counter);n.squirt?(a!==this.lastEmissionKey&&(this.currentEmission+=om[0]),this.lastEmissionKey=a):this.currentEmission+=om[0]*e}}emit(){const e=this.emitterObject;e.head&&this.emitObject(0),e.tail&&this.emitObject(1)}createObject(){return new lm(this)}}const cm=Gn.create(),dm=Gn.create(),hm=new Float32Array(3),fm=new Float32Array(1),mm=new Uint32Array(1);class pm extends Kf{constructor(){super(...arguments),this.vertices=new Float32Array(6),this.color=new Uint8Array(4),this.slot=0,this.prev=null,this.next=null}bind(){const e=this.emitter,t=e.instance,n=t.sequence,a=t.frame,r=t.counter,i=e.emitterObject,s=t.nodes[i.index],[l,o,u]=s.pivot,c=s.worldMatrix,d=this.vertices;this.health=e.emitterObject.lifeSpan,i.getHeightBelow(cm,n,a,r),i.getHeightAbove(dm,n,a,r),cm[1]=o-cm[0],cm[0]=l,cm[2]=u,dm[1]=o+dm[0],dm[0]=l,dm[2]=u,Gn.transformMat4(cm,cm,c),Gn.transformMat4(dm,dm,c),d[0]=dm[0],d[1]=dm[1],d[2]=dm[2],d[3]=cm[0],d[4]=cm[1],d[5]=cm[2]}update(e){if(this.health-=e,this.health>0){const t=this.emitter,n=t.instance,a=n.sequence,r=n.frame,i=n.counter,s=t.emitterObject,l=this.color,o=this.vertices,u=s.gravity*e*e;s.getColor(hm,a,r,i),s.getAlpha(fm,a,r,i),s.getTextureSlot(mm,a,r,i),o[1]-=u,o[4]-=u,l[0]=255*hm[0],l[1]=255*hm[1],l[2]=255*hm[2],l[3]=255*fm[0],this.slot=mm[0]}}}class _m extends Yf{constructor(){super(...arguments),this.first=null,this.last=null}updateEmission(e){if(this.instance.allowParticleSpawn){const t=this.emitterObject;this.currentEmission+=t.emissionRate*e}}emit(){const e=this.emitObject(),t=this.last;t?(t.next=e,e.prev=t):this.first=e,this.last=e}kill(e){super.kill(e);const t=e.prev,n=e.next;e===this.first&&(this.first=n),e===this.last&&(this.first=null,this.last=null),t&&(t.next=n),n&&(n.prev=t),e.prev=null,e.next=null}createObject(){return new pm(this)}}const gm=new Uint32Array(1);class bm extends Yf{constructor(){super(...arguments),this.lastValue=0}updateEmission(e){const t=this.instance;if(t.allowParticleSpawn){this.emitterObject.getValue(gm,t);const e=gm[0];1===e&&e!==this.lastValue&&(this.currentEmission+=1),this.lastValue=e}}emit(){this.emitObject()}}class wm extends Kf{constructor(e){super(e);const t=e.emitterObject.internalModel;this.internalInstance=t.addInstance()}bind(){const e=this.emitter,t=e.instance,n=t.scene,a=t.nodes[e.emitterObject.index],r=this.internalInstance;r.setScene(n),r.setSequence(0),r.setTransformation(a.worldLocation,a.worldRotation,a.worldScale),r.show(),this.health=1}update(e){const t=this.internalInstance,n=t.model;t.frame>=n.sequences[0].interval[1]&&(this.health=0,t.hide())}}class vm extends bm{createObject(){return new wm(this)}}const Am=Gn.create();class ym extends Kf{constructor(){super(...arguments),this.vertices=new Float32Array(12)}bind(){const e=this.emitter,t=e.instance,n=e.emitterObject,a=this.vertices,r=n.scale,{worldLocation:i,worldRotation:s}=t.nodes[n.index];this.health=n.lifeSpan,Gn.set(Am,r,r,0),Gn.transformQuat(Am,Am,s),Gn.add(a.subarray(0,2),Am,i),Gn.set(Am,-r,r,0),Gn.transformQuat(Am,Am,s),Gn.add(a.subarray(3,5),Am,i),Gn.set(Am,-r,-r,0),Gn.transformQuat(Am,Am,s),Gn.add(a.subarray(6,8),Am,i),Gn.set(Am,r,-r,0),Gn.transformQuat(Am,Am,s),Gn.add(a.subarray(9,11),Am,i)}update(e){this.health-=e}}class Sm extends bm{createObject(){return new ym(this)}}class Tm extends bm{createObject(){return new ym(this)}}class xm extends Kf{bind(){const e=this.emitter,t=e.instance,n=t.model.viewer,a=t.scene;if(n.audioEnabled&&a.audioEnabled){const n=e.emitterObject,r=t.nodes[n.index],i=a.audioContext,s=n.decodedBuffers,l=i.createPanner(),o=i.createBufferSource(),u=r.worldLocation;l.positionX.value=u[0],l.positionY.value=u[1],l.positionZ.value=u[2],l.maxDistance=n.distanceCutoff,l.refDistance=n.minDistance,l.connect(i.destination),o.buffer=s[Math.random()*s.length|0],o.connect(l),o.start(0)}}update(e){}}class Em extends bm{createObject(){return new xm(this)}}const Lm=new Float32Array(1),Im=Gn.create(),Um=st.create(),Rm=Gn.create(),Mm=new Float32Array(3),Cm=new Float32Array(1),Bm=new Uint32Array(1);class Pm extends rh{constructor(e){super(e),this.attachments=[],this.particleEmitters=[],this.particleEmitters2=[],this.ribbonEmitters=[],this.eventObjectEmitters=[],this.nodes=[],this.sortedNodes=[],this.frame=0,this.counter=0,this.sequence=-1,this.sequenceLoopMode=0,this.sequenceEnded=!1,this.teamColor=0,this.vertexColor=new Float32Array([1,1,1,1]),this.allowParticleSpawn=!1,this.forced=!0,this.geosetColors=[],this.layerAlphas=[],this.layerTextures=[],this.uvAnims=[],this.worldMatrices=null,this.boneTexture=null;for(let t=0,n=e.geosets.length;t<n;t++)this.geosetColors[t]=new Float32Array(4);for(let t=0,n=e.layers.length;t<n;t++)this.layerAlphas[t]=0,this.layerTextures[t]=0,this.uvAnims[t]=new Float32Array(5);const t=Rh(e.genericObjects.length,Nf),n=t.nodes;let a=0;this.nodes.push(...n),this.worldMatrices=t.worldMatrices;for(const t of e.bones)this.initNode(n,n[a++],t);for(const t of e.lights)this.initNode(n,n[a++],t);for(const t of e.helpers)this.initNode(n,n[a++],t);for(const t of e.attachments){let e;t.internalModel&&(e=new Hf(this,t),this.attachments.push(e)),this.initNode(n,n[a++],t,e)}for(const t of e.particleEmitters){const e=new Qf(this,t);this.particleEmitters.push(e),this.initNode(n,n[a++],t,e)}for(const t of e.particleEmitters2){const e=new um(this,t);this.particleEmitters2.push(e),this.initNode(n,n[a++],t,e)}for(const t of e.ribbonEmitters){const e=new _m(this,t);this.ribbonEmitters.push(e),this.initNode(n,n[a++],t,e)}for(const t of e.eventObjects){const e=t.type;let r;r="SPN"===e?new vm(this,t):"SPL"===e?new Sm(this,t):"UBR"===e?new Tm(this,t):new Em(this,t),this.eventObjectEmitters.push(r),this.initNode(n,n[a++],t,r)}for(const t of e.collisionShapes)this.initNode(n,n[a++],t);const r=e.hierarchy;for(let e=0,t=n.length;e<t;e++)this.sortedNodes[e]=n[r[e]];e.bones.length&&(this.boneTexture=new Cd(e.viewer.gl,4,4*e.bones.length,1))}setTexture(e,t){this.overrideTexture(e,t)}setParticle2Texture(e,t){this.overrideTexture(1e3+e,t)}setEventTexture(e,t){this.overrideTexture(Sf+e,t)}clearEmittedObjects(){for(const e of this.particleEmitters)e.clear();for(const e of this.particleEmitters2)e.clear();for(const e of this.ribbonEmitters)e.clear();for(const e of this.eventObjectEmitters)e.clear()}initNode(e,t,n,a){Gn.copy(t.pivot,n.pivot),-1===n.parentId?t.parent=this:t.parent=e[n.parentId],n.billboarded?t.billboarded=!0:n.billboardedX?t.billboardedX=!0:n.billboardedY?t.billboardedY=!0:n.billboardedZ&&(t.billboardedZ=!0),a&&(t.object=a)}hide(){super.hide(),this.resetAttachments()}updateNodes(e,t){const n=this.sequence,a=this.frame,r=this.counter,i=this.sortedNodes,s=this.model.sortedGenericObjects,l=this.scene;for(let o=0,u=i.length;o<u;o++){const u=s[o],c=i[o],d=c.parent;let h=t||d.wasDirty||u.anyBillboarding;const f=u.variants;(t||f.generic[n])&&(h=!0,(t||f.translation[n])&&u.getTranslation(c.localLocation,n,a,r),(t||f.rotation[n])&&u.getRotation(c.localRotation,n,a,r),(t||f.scale[n])&&u.getScale(c.localScale,n,a,r)),c.wasDirty=h,h&&c.recalculateTransformation(l),c.object&&(u.getVisibility(Lm,n,a,r),Lm[0]>0&&c.object.update(e));for(const t of c.children)h&&t.recalculateTransformation(),t.update(e)}}recalculateTransformation(){super.recalculateTransformation(),this.forced=!0}updateBatches(e){const t=this.sequence,n=this.frame,a=this.counter,r=this.model,i=r.geosets,s=r.layers,l=this.geosetColors,o=this.layerAlphas,u=this.layerTextures,c=this.uvAnims;for(let r=0,s=i.length;r<s;r++){const s=i[r].geosetAnimation,o=l[r];s?((e||s.variants.color[t])&&(s.getColor(Mm,t,n,a),o[0]=Mm[0],o[1]=Mm[1],o[2]=Mm[2]),(e||s.variants.alpha[t])&&(s.getAlpha(Cm,t,n,a),o[3]=Cm[0])):e&&(o[0]=1,o[1]=1,o[2]=1,o[3]=1)}for(let r=0,i=s.length;r<i;r++){const i=s[r],l=i.textureAnimation,d=c[r];(e||i.variants.alpha[t])&&(i.getAlpha(Cm,t,n,a),o[r]=Cm[0]),(e||i.variants.textureId[t])&&(i.getTextureId(Bm,t,n,a),u[r]=Bm[0]),l?((e||l.variants.translation[t])&&(l.getTranslation(Im,t,n,a),d[0]=Im[0],d[1]=Im[1]),(e||l.variants.rotation[t])&&(l.getRotation(Um,t,n,a),d[2]=Um[2],d[3]=Um[3]),(e||l.variants.scale[t])&&(l.getScale(Rm,t,n,a),d[4]=Rm[0])):e&&(d[0]=0,d[1]=0,d[2]=0,d[3]=1,d[4]=1)}}updateBoneTexture(){this.boneTexture&&this.boneTexture.bindAndUpdate(this.worldMatrices)}renderOpaque(){const e=this.model;for(const t of e.opaqueGroups)t.render(this)}renderTranslucent(){const e=this.model;for(const t of e.translucentGroups)t.render(this)}updateAnimations(e){const t=this.model,n=this.sequence;if(-1!==n){const a=t.sequences[n],r=a.interval,i=1e3*e;this.frame+=i,this.counter+=i,this.allowParticleSpawn=!0,this.frame>=r[1]?(2===this.sequenceLoopMode||0===this.sequenceLoopMode&&0===a.nonLooping?(this.frame=r[0],this.resetEventEmitters()):(this.frame=r[1],this.counter-=i,this.allowParticleSpawn=!1),this.sequenceEnded=!0):this.sequenceEnded=!1}const a=this.forced;(-1!==n||a)&&(this.updateNodes(e,a),this.updateBoneTexture(),this.updateBatches(a)),this.forced=!1}setTeamColor(e){return this.teamColor=e,this}setVertexColor(e){return this.vertexColor.set(e),this}setSequence(e){const t=this.model.sequences;return this.sequence=e,e<0||e>t.length-1?(this.sequence=-1,this.frame=0,this.allowParticleSpawn=!1):this.frame=t[e].interval[0],this.resetEventEmitters(),this.resetAttachments(),this.forced=!0,this}getBounds(){const e=this.model;if(-1===this.sequence)return e.bounds;const t=e.sequences[this.sequence].bounds;return 0===t.r?e.bounds:t}setSequenceLoopMode(e){return this.sequenceLoopMode=e,this}getAttachment(e){const t=this.model.attachments[e];if(t)return this.nodes[t.index]}resetEventEmitters(){for(const e of this.eventObjectEmitters)e.lastValue=0}resetAttachments(){for(const e of this.attachments)e.internalInstance.hide()}}const km="\n#ifdef SKIN\nattribute vec4 a_bones;\nattribute vec4 a_weights;\n\nvoid transformSkin(inout vec3 position, inout vec3 normal, inout vec3 tangent, inout vec3 binormal) {\n  mat4 bone;\n\n  bone += fetchMatrix(a_bones[0], 0.0) * a_weights[0];\n  bone += fetchMatrix(a_bones[1], 0.0) * a_weights[1];\n  bone += fetchMatrix(a_bones[2], 0.0) * a_weights[2];\n  bone += fetchMatrix(a_bones[3], 0.0) * a_weights[3];\n\n  mat3 rotation = mat3(bone);\n\n  position = vec3(bone * vec4(position, 1.0));\n  normal = rotation * normal;\n  tangent = rotation * tangent;\n  binormal = rotation * binormal;\n}\n#else\nattribute vec4 a_bones;\n#ifdef EXTENDED_BONES\nattribute vec4 a_extendedBones;\n#endif\nattribute float a_boneNumber;\n\nmat4 getVertexGroupMatrix() {\n  mat4 bone;\n\n  // For the broken models out there, since the game supports this.\n  if (a_boneNumber > 0.0) {\n    for (int i = 0; i < 4; i++) {\n      if (a_bones[i] > 0.0) {\n        bone += fetchMatrix(a_bones[i] - 1.0, 0.0);\n      }\n    }\n\n    #ifdef EXTENDED_BONES\n      for (int i = 0; i < 4; i++) {\n        if (a_extendedBones[i] > 0.0) {\n          bone += fetchMatrix(a_extendedBones[i] - 1.0, 0.0);\n        }\n      }\n    #endif\n  }\n\n  return bone / a_boneNumber;\n}\n\nvoid transformVertexGroups(inout vec3 position, inout vec3 normal) {\n  mat4 bone = getVertexGroupMatrix();\n  mat3 rotation = mat3(bone);\n\n  position = vec3(bone * vec4(position, 1.0));\n  normal = normalize(rotation * normal);\n}\n\nvoid transformVertexGroupsHD(inout vec3 position, inout vec3 normal, inout vec3 tangent, inout vec3 binormal) {\n  mat4 bone = getVertexGroupMatrix();\n  mat3 rotation = mat3(bone);\n\n  position = vec3(bone * vec4(position, 1.0));\n  normal = normalize(rotation * normal);\n  tangent = normalize(rotation * tangent);\n  binormal = normalize(rotation * binormal);\n}\n#endif\n",Om=`\nuniform mat4 u_VP;\nuniform vec3 u_lightPos;\nuniform vec4 u_vertexColor;\nuniform vec4 u_geosetColor;\nuniform float u_layerAlpha;\nuniform vec2 u_uvTrans;\nuniform vec2 u_uvRot;\nuniform float u_uvScale;\nuniform bool u_hasBones;\n\nattribute vec3 a_position;\nattribute vec3 a_normal;\nattribute vec2 a_uv;\n\nvarying vec2 v_uv;\nvarying vec3 v_normal;\nvarying vec4 v_color;\nvarying vec4 v_uvTransRot;\nvarying float v_uvScale;\nvarying vec3 v_lightDir;\n\n${Oh}\n${km}\n\nvoid main() {\n  vec3 position = a_position;\n  vec3 normal = a_normal;\n\n  if (u_hasBones) {\n    transformVertexGroups(position, normal);\n  }\n\n  v_uv = a_uv;\n  v_normal = normal;\n  v_color = u_vertexColor * u_geosetColor.bgra * vec4(1.0, 1.0, 1.0, u_layerAlpha);\n  v_uvTransRot = vec4(u_uvTrans, u_uvRot);\n  v_uvScale = u_uvScale;\n  v_lightDir = normalize(u_lightPos - position);\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n`,Dm=`\n${Fh}\n\n\n// A 2D quaternion*vector.\n// q is the zw components of the original quaternion.\nvec2 quat_transform(vec2 q, vec2 v) {\n  vec2 uv = vec2(-q.x * v.y, q.x * v.x);\n  vec2 uuv = vec2(-q.x * uv.y, q.x * uv.x);\n\n  return v + 2.0 * (uv * q.y + uuv);\n}\n\n\nuniform sampler2D u_texture;\nuniform float u_filterMode;\nuniform bool u_unshaded;\n\nvarying vec2 v_uv;\nvarying vec3 v_normal;\nvarying vec4 v_color;\nvarying vec4 v_uvTransRot;\nvarying float v_uvScale;\nvarying vec3 v_lightDir;\n\nvec4 getDiffuseColor() {\n  vec2 uv = v_uv;\n\n  // Translation animation\n  uv += v_uvTransRot.xy;\n\n  // Rotation animation\n  uv = quat_transform(v_uvTransRot.zw, uv - 0.5) + 0.5;\n\n  // Scale animation\n  uv = v_uvScale * (uv - 0.5) + 0.5;\n\n  vec4 texel = texture2D(u_texture, uv);\n  vec4 color = texel * v_color;\n\n  // 1bit Alpha\n  if (u_filterMode == 1.0 && color.a < 0.75) {\n    discard;\n  }\n\n  // "Close to 0 alpha"\n  if (u_filterMode >= 5.0 && color.a < 0.02) {\n    discard;\n  }\n\n  return color;\n}\n\nvoid onlyTexCoords() {\n  gl_FragColor = vec4(v_uv, 0.0, 1.0);\n}\n\nvoid onlyNormals() {\n  gl_FragColor = vec4(v_normal, 1.0);\n}\n\nvoid onlyDiffuse() {\n  gl_FragColor = getDiffuseColor();\n}\n\nvoid lambert() {\n  vec4 color = getDiffuseColor();\n\n  if (!u_unshaded) {\n    float lambertFactor = clamp(dot(v_normal, v_lightDir), 0.0, 1.0);\n    lambertFactor = clamp(lambertFactor + 0.7, 0.0, 1.0);\n\n    color.rgb *= lambertFactor;\n  }\n\n  gl_FragColor = color;\n}\n\nvoid main() {\n  #if defined(ONLY_DIFFUSE)\n  onlyDiffuse();\n  #elif defined(ONLY_TEXCOORDS)\n  onlyTexCoords();\n  #elif defined(ONLY_NORMALS)\n  onlyNormals();\n  #else\n  lambert();\n  #endif\n}\n`,Fm=`\nuniform mat4 u_VP;\nuniform mat4 u_MV;\nuniform vec3 u_eyePos;\nuniform vec3 u_lightPos;\nuniform float u_layerAlpha;\nuniform bool u_hasBones;\n\nattribute vec3 a_position;\nattribute vec3 a_normal;\nattribute vec2 a_uv;\nattribute vec4 a_tangent;\n\nvarying vec2 v_uv;\nvarying float v_layerAlpha;\nvarying vec3 v_lightDir;\nvarying vec3 v_eyeVec;\nvarying vec3 v_normal;\n// varying vec3 v_lightDirWorld;\n\n#if defined(ONLY_TANGENTS)\nvarying vec3 v_tangent;\n#endif\n\n${Oh}\n${km}\n\nvec3 TBN(vec3 vector, vec3 tangent, vec3 binormal, vec3 normal) {\n  return vec3(dot(vector, tangent), dot(vector, binormal), dot(vector, normal));\n}\n\nvoid main() {\n  vec3 position = a_position;\n  vec3 normal = a_normal;\n  vec3 tangent = a_tangent.xyz;\n\n  // Re-orthogonalize the tangent in case it wasnt normalized.\n  // See "One last thing" at https://learnopengl.com/Advanced-Lighting/Normal-Mapping\n  tangent = normalize(tangent - dot(tangent, normal) * normal);\n\n  vec3 binormal = cross(normal, tangent) * a_tangent.w;\n\n  if (u_hasBones) {\n    #ifdef SKIN\n      transformSkin(position, normal, tangent, binormal);\n    #else\n      transformVertexGroupsHD(position, normal, tangent, binormal);\n    #endif\n  }\n\n  vec3 position_mv = vec3(u_MV * vec4(position, 1));\n\n  mat3 mv = mat3(u_MV);\n  vec3 t = normalize(mv * tangent);\n  vec3 b = normalize(mv * binormal);\n  vec3 n = normalize(mv * normal);\n\n  v_eyeVec = normalize(u_eyePos - position_mv);\n\n  vec3 lightDir = normalize(u_lightPos - position_mv);\n  v_lightDir = normalize(TBN(lightDir, t, b, n));\n  \n  v_uv = a_uv;\n  v_layerAlpha = u_layerAlpha;\n\n  v_normal = normal;\n  // v_lightDirWorld = normalize(lightDir);\n\n  #if defined(ONLY_TANGENTS)\n  v_tangent = tangent;\n  #endif\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n`,Gm=`\n${Fh}\n\nuniform sampler2D u_diffuseMap;\nuniform sampler2D u_normalsMap;\nuniform sampler2D u_ormMap;\nuniform sampler2D u_emissiveMap;\nuniform sampler2D u_teamColorMap;\nuniform sampler2D u_environmentMap;\nuniform float u_filterMode;\n\n// uniform sampler2D u_lutMap;\n// uniform sampler2D u_envDiffuseMap;\n// uniform sampler2D u_envSpecularMap;\n\nvarying vec2 v_uv;\nvarying float v_layerAlpha;\nvarying vec3 v_lightDir;\nvarying vec3 v_eyeVec;\nvarying vec3 v_normal;\n// varying vec3 v_lightDirWorld;\n\n#if defined(ONLY_TANGENTS)\nvarying vec3 v_tangent;\n#endif\n\nvec3 decodeNormal() {\n  vec2 xy = texture2D(u_normalsMap, v_uv).xy * 2.0 - 1.0;\n  \n  return vec3(xy, sqrt(1.0 - dot(xy, xy)));\n}\n\nconst vec2 invAtan = vec2(0.1591, 0.3183);\nvec2 sampleEnvironmentMap(vec3 normal) {\n  vec2 uv = vec2(atan(normal.x, normal.y), -asin(normal.z));\n  uv *= invAtan;\n  uv += 0.5;\n  return uv;\n}\n\nvec4 getDiffuseColor() {\n  vec4 color = texture2D(u_diffuseMap, v_uv);\n\n  // 1bit Alpha\n  if (u_filterMode == 1.0 && color.a < 0.75) {\n    discard;\n  }\n\n  return color;\n}\n\nvec4 getOrmColor() {\n  return texture2D(u_ormMap, v_uv);\n}\n\nvec3 getEmissiveColor() {\n  return texture2D(u_emissiveMap, v_uv).rgb;\n}\n\nvec3 getTeamColor() {\n  return texture2D(u_teamColorMap, v_uv).rgb;\n}\n\n// const float PI = 3.14159265359;\n// const float RECIPROCAL_PI = 0.31830988618;\n// const float RECIPROCAL_PI2 = 0.15915494;\n// const float LN2 = 0.6931472;\n// const float ENV_LODS = 6.0;\n// vec4 SRGBtoLinear(vec4 srgb) {\n//     vec3 linOut = pow(srgb.xyz, vec3(2.2));\n//     return vec4(linOut, srgb.w);;\n// }\n// vec4 RGBMToLinear(in vec4 value) {\n//     float maxRange = 6.0;\n//     return vec4(value.xyz * value.w * maxRange, 1.0);\n// }\n// vec3 linearToSRGB(vec3 color) {\n//     return pow(color, vec3(1.0 / 2.2));\n// }\n// // vec3 getNormal() {\n// //     vec3 pos_dx = dFdx(vMPos.xyz);\n// //     vec3 pos_dy = dFdy(vMPos.xyz);\n// //     vec2 tex_dx = dFdx(vUv);\n// //     vec2 tex_dy = dFdy(vUv);\n// //     vec3 t = normalize(pos_dx * tex_dy.t - pos_dy * tex_dx.t);\n// //     vec3 b = normalize(-pos_dx * tex_dy.s + pos_dy * tex_dx.s);\n// //     mat3 tbn = mat3(t, b, normalize(vNormal));\n// //     vec3 n = texture2D(tNormal, vUv * uNormalUVScale).rgb * 2.0 - 1.0;\n// //     n.xy *= uNormalScale;\n// //     vec3 normal = normalize(tbn * n);\n// //     // Get world normal from view normal (normalMatrix * normal)\n// //     return normalize((vec4(normal, 0.0) * viewMatrix).xyz);\n// // }\n// vec3 specularReflection(vec3 specularEnvR0, vec3 specularEnvR90, float VdH) {\n//     return specularEnvR0 + (specularEnvR90 - specularEnvR0) * pow(clamp(1.0 - VdH, 0.0, 1.0), 5.0);\n// }\n// float geometricOcclusion(float NdL, float NdV, float roughness) {\n//     float r = roughness;\n//     float attenuationL = 2.0 * NdL / (NdL + sqrt(r * r + (1.0 - r * r) * (NdL * NdL)));\n//     float attenuationV = 2.0 * NdV / (NdV + sqrt(r * r + (1.0 - r * r) * (NdV * NdV)));\n//     return attenuationL * attenuationV;\n// }\n// float microfacetDistribution(float roughness, float NdH) {\n//     float roughnessSq = roughness * roughness;\n//     float f = (NdH * roughnessSq - NdH) * NdH + 1.0;\n//     return roughnessSq / (PI * f * f);\n// }\n// vec2 cartesianToPolar(vec3 n) {\n//     vec2 uv;\n//     uv.x = atan(n.z, n.x) * RECIPROCAL_PI2 + 0.5;\n//     uv.y = asin(n.y) * RECIPROCAL_PI + 0.5;\n//     return uv;\n// }\n// void getIBLContribution(inout vec3 diffuse, inout vec3 specular, float NdV, float roughness, vec3 n, vec3 reflection, vec3 diffuseColor, vec3 specularColor) {\n//   vec3 brdf = SRGBtoLinear(texture2D(u_lutMap, vec2(NdV, roughness))).rgb;\n//   vec3 diffuseLight = RGBMToLinear(texture2D(u_envDiffuseMap, sampleEnvironmentMap(n))).rgb;\n//   // Sample 2 levels and mix between to get smoother degradation\n//   float blend = roughness * ENV_LODS;\n//   float level0 = floor(blend);\n//   float level1 = min(ENV_LODS, level0 + 1.0);\n//   blend -= level0;\n  \n//   // Sample the specular env map atlas depending on the roughness value\n//   vec2 uvSpec = sampleEnvironmentMap(reflection);\n//   uvSpec.y /= 2.0;\n//   vec2 uv0 = uvSpec;\n//   vec2 uv1 = uvSpec;\n//   uv0 /= pow(2.0, level0);\n//   uv0.y += 1.0 - exp(-LN2 * level0);\n//   uv1 /= pow(2.0, level1);\n//   uv1.y += 1.0 - exp(-LN2 * level1);\n//   vec3 specular0 = RGBMToLinear(texture2D(u_envSpecularMap, uv0)).rgb;\n//   vec3 specular1 = RGBMToLinear(texture2D(u_envSpecularMap, uv1)).rgb;\n//   vec3 specularLight = mix(specular0, specular1, blend);\n//   diffuse = diffuseLight * diffuseColor;\n  \n//   // Bit of extra reflection for smooth materials\n//   float reflectivity = pow((1.0 - roughness), 2.0) * 0.05;\n//   specular = specularLight * (specularColor * brdf.x + brdf.y + reflectivity);\n//   // specular *= uEnvSpecular;\n// }\n\n// void PBR() {\n//   vec4 baseDiffuseColor = getDiffuseColor();\n//   vec3 baseColor = baseDiffuseColor.rgb;\n//   vec4 orm = getOrmColor();\n//   vec3 tc = getTeamColor();\n//   float tcFactor = getOrmColor().a;\n\n//   if (tcFactor > 0.1) {\n//     baseColor *= tc * tcFactor;\n//   }\n\n//   float roughness = clamp(orm.g, 0.04, 1.0);\n//   float metallic = clamp(orm.b, 0.04, 1.0);\n\n//   vec3 f0 = vec3(0.04);\n//   vec3 diffuseColor = baseColor * (vec3(1.0) - f0) * (1.0 - metallic);\n//   vec3 specularColor = mix(f0, baseColor, metallic);\n//   vec3 specularEnvR0 = specularColor;\n//   vec3 specularEnvR90 = vec3(clamp(max(max(specularColor.r, specularColor.g), specularColor.b) * 25.0, 0.0, 1.0));\n\n//   vec3 N = v_normal;\n//   vec3 V = normalize(v_eyeVec);\n//   vec3 L = normalize(v_lightDirWorld);\n//   vec3 H = normalize(L + V);\n//   vec3 reflection = normalize(reflect(-V, N));\n\n//   float NdL = clamp(dot(N, L), 0.001, 1.0);\n//   float NdV = clamp(abs(dot(N, V)), 0.001, 1.0);\n//   float NdH = clamp(dot(N, H), 0.0, 1.0);\n//   float LdH = clamp(dot(L, H), 0.0, 1.0);\n//   float VdH = clamp(dot(V, H), 0.0, 1.0);\n\n//   vec3 F = specularReflection(specularEnvR0, specularEnvR90, VdH);\n//   float G = geometricOcclusion(NdL, NdV, roughness);\n//   float D = microfacetDistribution(roughness, NdH);\n\n//   vec3 diffuseContrib = (1.0 - F) * (diffuseColor / PI);\n//   vec3 specContrib = F * G * D / (4.0 * NdL * NdV);\n  \n//   // Shading based off lights\n//   // vec3 color = NdL * uLightColor * (diffuseContrib + specContrib);\n//   vec3 color = NdL * (diffuseContrib + specContrib);\n\n//   // Calculate IBL lighting\n//   vec3 diffuseIBL;\n//   vec3 specularIBL;\n//   getIBLContribution(diffuseIBL, specularIBL, NdV, roughness, N, reflection, diffuseColor, specularColor);\n\n//   // Add IBL on top of color\n//   color +=  specularIBL;\n\n//   color *= orm.r;\n\n//   color += getEmissiveColor();\n\n//   // Convert to sRGB to display\n//   gl_FragColor.rgb = color;\n//   gl_FragColor.a = baseDiffuseColor.a;\n// }\n\nvoid onlyDiffuse() {\n  vec4 baseColor = getDiffuseColor();\n  vec3 tc = getTeamColor();\n  float tcFactor = getOrmColor().a;\n\n  if (tcFactor > 0.1) {\n    baseColor.rgb *= tc * tcFactor;\n  }\n\n  gl_FragColor = baseColor;\n}\n\nvoid onlyNormalMap() {\n  gl_FragColor = vec4(decodeNormal(), 1.0);\n}\n\nvoid onlyOcclusion() {\n  gl_FragColor = vec4(getOrmColor().rrr, 1.0);\n}\n\nvoid onlyRoughness() {\n  gl_FragColor = vec4(getOrmColor().ggg, 1.0);\n}\n\nvoid onlyMetallic() {\n  gl_FragColor = vec4(getOrmColor().bbb, 1.0);\n}\n\nvoid onlyTeamColorFactor() {\n  gl_FragColor = vec4(getOrmColor().aaa, 1.0);\n}\n\nvoid onlyEmissiveMap() {\n  gl_FragColor = vec4(getEmissiveColor(), 1.0);\n}\n\nvoid onlyTexCoords() {\n  gl_FragColor = vec4(v_uv, 0.0, 1.0);\n}\n\nvoid onlyNormals() {\n  gl_FragColor = vec4(v_normal, 1.0);\n}\n\n#if defined(ONLY_TANGENTS)\nvoid onlyTangents() {\n  gl_FragColor = vec4(v_tangent, 1.0);\n}\n#endif\n\nvoid lambert() {\n  vec4 baseColor = getDiffuseColor();\n  vec3 normal = decodeNormal();\n  vec4 orm = getOrmColor();\n  vec3 emissive = getEmissiveColor();\n  vec3 tc = getTeamColor();\n  float aoFactor = orm.r;\n  float tcFactor = orm.a;\n  float lambertFactor = clamp(dot(normal, v_lightDir), 0.0, 1.0);\n  vec3 color = baseColor.rgb;\n\n  if (tcFactor > 0.1) {\n    color *= tc * tcFactor;\n  }\n  \n  color *= clamp(lambertFactor * aoFactor + 0.1, 0.0, 1.0);\n  color += emissive;\n\n  gl_FragColor = vec4(color, baseColor.a);\n}\n\nvoid main() {\n  #if defined(ONLY_DIFFUSE)\n  onlyDiffuse();\n  #elif defined(ONLY_NORMAL_MAP)\n  onlyNormalMap();\n  #elif defined(ONLY_OCCLUSION)\n  onlyOcclusion();\n  #elif defined(ONLY_ROUGHNESS)\n  onlyRoughness();\n  #elif defined(ONLY_METALLIC)\n  onlyMetallic();\n  #elif defined(ONLY_TC_FACTOR)\n  onlyTeamColorFactor();\n  #elif defined(ONLY_EMISSIVE)\n  onlyEmissiveMap();\n  #elif defined(ONLY_TEXCOORDS)\n  onlyTexCoords();\n  #elif defined(ONLY_NORMALS)\n  onlyNormals();\n  #elif defined(ONLY_TANGENTS)\n  onlyTangents();\n  #else\n  lambert();\n  #endif\n}\n`,Nm=`\n${Fh}\n\n#define EMITTER_PARTICLE2 0\n#define EMITTER_RIBBON 1\n\nuniform sampler2D u_texture;\nuniform highp int u_emitter;\nuniform float u_filterMode;\n\nvarying vec2 v_texcoord;\nvarying vec4 v_color;\n\nvoid main() {\n  vec4 texel = texture2D(u_texture, v_texcoord);\n  vec4 color = texel * v_color;\n\n  // 1bit Alpha, used by ribbon emitters.\n  if (u_emitter == EMITTER_RIBBON && u_filterMode == 1.0 && color.a < 0.75) {\n    discard;\n  }\n\n  // "Close to 0 alpha"\n  if (u_emitter == EMITTER_PARTICLE2 && (u_filterMode == 2.0 || u_filterMode == 3.0) && color.a < 0.02) {\n    discard;\n  }\n\n  // Alpha key.\n  if (u_emitter == EMITTER_PARTICLE2 && (u_filterMode == 4.0) && color.a < 0.75) {\n    discard;\n  }\n\n  gl_FragColor = color;\n}\n`,Vm=e=>new Hh(e),Hm=e=>function(e){if(Vh)return Vh.decodeAudioData(e)}(e),Ym={load(e,t,n=!1){const a=e.gl,r=e.webgl;if(!r.ensureExtension("OES_texture_float"))throw new Error("MDX: No float texture support!");if(!r.ensureExtension("ANGLE_instanced_arrays"))throw new Error("MDX: No instanced rendering support!");const i="#define EXTENDED_BONES\n"+Om,s="#define ONLY_DIFFUSE\n"+Dm,l="#define ONLY_TEXCOORDS\n"+Dm,o="#define ONLY_NORMALS\n"+Dm,u="#define EXTENDED_BONES\n"+Fm,c="#define SKIN\n"+Fm,d="#define ONLY_DIFFUSE\n"+Gm,h="#define ONLY_NORMAL_MAP\n"+Gm,f="#define ONLY_OCCLUSION\n"+Gm,m="#define ONLY_ROUGHNESS\n"+Gm,p="#define ONLY_METALLIC\n"+Gm,_="#define ONLY_TC_FACTOR\n"+Gm,g="#define ONLY_EMISSIVE\n"+Gm,b="#define ONLY_TEXCOORDS\n"+Gm,w="#define ONLY_NORMALS\n"+Gm,v="#define ONLY_TANGENTS\n"+Gm,A=r.createShader(Om,Dm),y=r.createShader(i,Dm),S=r.createShader(Fm,Gm),T=r.createShader(u,Gm),x=r.createShader(c,Gm),E=r.createShader("\n#define EMITTER_PARTICLE2 0\n#define EMITTER_RIBBON 1\n#define EMITTER_SPLAT 2\n#define EMITTER_UBERSPLAT 3\n#define HEAD 0.0\n\nuniform mat4 u_VP;\nuniform int u_emitter;\n\n// Shared\nuniform vec4 u_colors[3];\nuniform vec3 u_vertices[4];\nuniform vec3 u_intervals[4];\nuniform float u_lifeSpan;\nuniform float u_columns;\nuniform float u_rows;\n\n// Particle2\nuniform vec3 u_scaling;\nuniform vec3 u_cameraZ;\nuniform float u_timeMiddle;\nuniform bool u_teamColored;\n\n// Splat and Uber.\nuniform vec3 u_intervalTimes;\n\n// Vertices\nattribute float a_position;\n\n// Instances\nattribute vec3 a_p0;\nattribute vec3 a_p1;\nattribute vec3 a_p2;\nattribute vec3 a_p3;\nattribute float a_health;\nattribute vec4 a_color;\nattribute float a_tail;\nattribute vec3 a_leftRightTop;\n\nvarying vec2 v_texcoord;\nvarying vec4 v_color;\n\nfloat getCell(vec3 interval, float factor) {\n  float start = interval[0];\n  float end = interval[1];\n  float repeat = interval[2];\n  float spriteCount = end - start;\n\n  if (spriteCount > 0.0) {\n    // Repeating speeds up the sprite animation, which makes it effectively run N times in its interval.\n    // E.g. if repeat is 4, the sprite animation will be seen 4 times, and thus also run 4 times as fast.\n    // The sprite index is limited to the number of actual sprites.\n    return min(start + mod(floor(spriteCount * repeat * factor), spriteCount), u_columns * u_rows - 1.0);\n  }\n\n  return start;\n}\n\nvoid particle2() {\n  float factor = (u_lifeSpan - a_health) / u_lifeSpan;\n  int index = 0;\n\n  if (factor < u_timeMiddle) {\n    factor = factor / u_timeMiddle;\n    index = 0;\n  } else {\n    factor = (factor - u_timeMiddle) / (1.0 - u_timeMiddle);\n    index = 1;\n  }\n\n  factor = min(factor, 1.0);\n\n  float scale = mix(u_scaling[index], u_scaling[index + 1], factor);\n  vec4 color = mix(u_colors[index], u_colors[index + 1], factor);\n\n  float cell = 0.0;\n\n  if (u_teamColored) {\n    cell = a_leftRightTop[0];\n  } else {\n    vec3 interval;\n\n    if (a_tail == HEAD) {\n      interval = u_intervals[index];\n    } else {\n      interval = u_intervals[index + 2];\n    }\n\n    cell = getCell(interval, factor);\n  }\n\n  float left = floor(mod(cell, u_columns));\n  float top = floor(cell / u_columns);\n  float right = left + 1.0;\n  float bottom = top + 1.0;\n\n  left /= u_columns;\n  right /= u_columns;\n  top /= u_rows;\n  bottom /= u_rows;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(right, top);\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(left, top);\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(left, bottom);\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(right, bottom);\n  }\n\n  v_color = color;\n  \n  if (a_tail == HEAD) {\n    vec3 v = u_vertices[int(a_position)];\n    float cs = cos(a_p1.x);\n    float sn = sin(a_p1.x);\n\n    float x = v.x * cs - v.y * sn;\n    float y = v.x * sn + v.y * cs;\n\n    vec3 fv = vec3(\n      v.x * cs - v.y * sn,\n      v.x * sn + v.y * cs,\n      v.z);\n\n    gl_Position = u_VP * vec4(a_p0 + fv * scale, 1.0);\n  } else {\n    // Get the normal to the tail in camera space.\n    // This allows to build a 2D rectangle around the 3D tail.\n    vec3 normal = cross(u_cameraZ, normalize(a_p1 - a_p0));\n    vec3 boundary = normal * scale * a_p2[0];\n    vec3 position;\n\n    if (a_position == 0.0) {\n      position = a_p0 - boundary;\n    } else if (a_position == 1.0) {\n      position = a_p1 - boundary;\n    } else if (a_position == 2.0) {\n      position = a_p1 + boundary;\n    } else if (a_position == 3.0) {\n      position = a_p0 + boundary;\n    }\n\n    gl_Position = u_VP * vec4(position, 1.0);\n  }\n}\n\nvoid ribbon() {\n  vec3 position;\n  float left = a_leftRightTop[0] / 255.0;\n  float right = a_leftRightTop[1] / 255.0;\n  float top = a_leftRightTop[2] / 255.0;\n  float bottom = top + 1.0;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(right, top);\n    position = a_p0;\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(right, bottom);\n    position = a_p1;\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(left, bottom);\n    position = a_p2;\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(left, top);\n    position = a_p3;\n  }\n\n  v_texcoord[0] /= u_columns;\n  v_texcoord[1] /= u_rows;\n\n  v_color = a_color;\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n\nvoid splat() {\n  float factor = u_lifeSpan - a_health;\n  int index;\n\n  if (factor < u_intervalTimes[0]) {\n    factor = factor / u_intervalTimes[0];\n    index = 0;\n  } else {\n    factor = (factor - u_intervalTimes[0]) / u_intervalTimes[1];\n    index = 1;\n  }\n\n  float cell = getCell(u_intervals[index], factor);\n  float left = floor(mod(cell, u_columns));\n  float top = floor(cell / u_columns);\n  float right = left + 1.0;\n  float bottom = top + 1.0;\n  vec3 position;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(left, top);\n    position = a_p0;\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(left, bottom);\n    position = a_p1;\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(right, bottom);\n    position = a_p2;\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(right, top);\n    position = a_p3;\n  }\n\n  v_texcoord[0] /= u_columns;\n  v_texcoord[1] /= u_rows;\n\n  v_color = mix(u_colors[index], u_colors[index + 1], factor) / 255.0;\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n\nvoid ubersplat() {\n  float factor = u_lifeSpan - a_health;\n  vec4 color;\n\n  if (factor < u_intervalTimes[0]) {\n    color = mix(u_colors[0], u_colors[1], factor / u_intervalTimes[0]);\n  } else if (factor < u_intervalTimes[0] + u_intervalTimes[1]) {\n    color = u_colors[1];\n  } else {\n    color = mix(u_colors[1], u_colors[2], (factor - u_intervalTimes[0] - u_intervalTimes[1]) / u_intervalTimes[2]);\n  }\n\n  vec3 position;\n\n  if (a_position == 0.0) {\n    v_texcoord = vec2(0.0, 0.0);\n    position = a_p0;\n  } else if (a_position == 1.0) {\n    v_texcoord = vec2(0.0, 1.0);\n    position = a_p1;\n  } else if (a_position == 2.0) {\n    v_texcoord = vec2(1.0, 1.0);\n    position = a_p2;\n  } else if (a_position == 3.0) {\n    v_texcoord = vec2(1.0, 0.0);\n    position = a_p3;\n  }\n\n  v_color = color / 255.0;\n\n  gl_Position = u_VP * vec4(position, 1.0);\n}\n\nvoid main() {\n  if (u_emitter == EMITTER_PARTICLE2) {\n    particle2();\n  } else if (u_emitter == EMITTER_RIBBON) {\n    ribbon();\n  } else if (u_emitter == EMITTER_SPLAT) {\n    splat();\n  } else if (u_emitter == EMITTER_UBERSPLAT) {\n    ubersplat();\n  }\n}\n",Nm),L=[],I=[];let U=[];U[$d.Diffuse]=r.createShader(Om,s),U[$d.TexCoords]=r.createShader(Om,l),U[$d.Normals]=r.createShader(Om,o),L[Cf.VertexGroups]=U,U=[],U[$d.Diffuse]=r.createShader(i,s),U[$d.TexCoords]=r.createShader(i,l),U[$d.Normals]=r.createShader(i,o),L[Cf.ExtendedVertexGroups]=U,U=[],U[$d.Diffuse]=r.createShader(Fm,d),U[$d.NormalMap]=r.createShader(Fm,h),U[$d.Occlusion]=r.createShader(Fm,f),U[$d.Roughness]=r.createShader(Fm,m),U[$d.Metallic]=r.createShader(Fm,p),U[$d.TCFactor]=r.createShader(Fm,_),U[$d.Emissive]=r.createShader(Fm,g),U[$d.TexCoords]=r.createShader(Fm,b),U[$d.Normals]=r.createShader(Fm,w),U[$d.Tangents]=r.createShader("#define ONLY_TANGENTS\n"+Fm,v),I[Cf.VertexGroups]=U,U=[],U[$d.Diffuse]=r.createShader(u,d),U[$d.NormalMap]=r.createShader(u,h),U[$d.Occlusion]=r.createShader(u,f),U[$d.Roughness]=r.createShader(u,m),U[$d.Metallic]=r.createShader(u,p),U[$d.TCFactor]=r.createShader(u,_),U[$d.Emissive]=r.createShader(u,g),U[$d.TexCoords]=r.createShader(u,b),U[$d.Normals]=r.createShader(u,w),U[$d.Tangents]=r.createShader("#define ONLY_TANGENTS\n"+u,v),I[Cf.ExtendedVertexGroups]=U,U=[],U[$d.Diffuse]=r.createShader(c,d),U[$d.NormalMap]=r.createShader(c,h),U[$d.Occlusion]=r.createShader(c,f),U[$d.Roughness]=r.createShader(c,m),U[$d.Metallic]=r.createShader(c,p),U[$d.TCFactor]=r.createShader(c,_),U[$d.Emissive]=r.createShader(c,g),U[$d.TexCoords]=r.createShader(c,b),U[$d.Normals]=r.createShader(c,w),U[$d.Tangents]=r.createShader("#define ONLY_TANGENTS\n"+c,v),I[Cf.Skin]=U;const R=a.createBuffer();a.bindBuffer(a.ARRAY_BUFFER,R),a.bufferData(a.ARRAY_BUFFER,new Uint8Array([0,1,2,0,2,3]),a.STATIC_DRAW);const M={pathSolver:t,reforged:n,sdShader:A,sdExtendedShader:y,hdShader:S,hdExtendedShader:T,hdSkinShader:x,particlesShader:E,sdDebugShaders:L,hdDebugShaders:I,rectBuffer:R,teamColors:[],teamGlows:[],eventObjectTables:{}};e.sharedCache.set("mdx",M)},isValidSource:e=>e instanceof yi||(vi(e)||Ai(e)),resource:class extends ah{constructor(e,t){let n;if(super(t),this.reforged=!1,this.hd=!1,this.solverParams={},this.name="",this.sequences=[],this.globalSequences=[],this.materials=[],this.layers=[],this.textures=[],this.textureAnimations=[],this.geosets=[],this.geosetAnimations=[],this.bones=[],this.lights=[],this.helpers=[],this.attachments=[],this.pivotPoints=[],this.particleEmitters=[],this.particleEmitters2=[],this.ribbonEmitters=[],this.cameras=[],this.eventObjects=[],this.collisionShapes=[],this.hasLayerAnims=!1,this.hasGeosetAnims=!1,this.batches=[],this.genericObjects=[],this.sortedGenericObjects=[],this.hierarchy=[],this.opaqueGroups=[],this.translucentGroups=[],this.arrayBuffer=null,this.elementBuffer=null,this.skinDataType=0,this.bytesPerSkinElement=1,e instanceof yi)n=e;else{n=new yi;try{n.load(e)}catch(e){}}const a=this.viewer,r=this.pathSolver,i=this.solverParams,s=n.version>800,l=s?".dds":".blp";let o=!1;this.reforged=s,this.name=n.name;const u=n.extent;this.bounds.fromExtents(u.min,u.max);for(const e of n.sequences)this.sequences.push(new Yh(e));for(const e of n.globalSequences)this.globalSequences.push(e);for(const e of n.textureAnimations)this.textureAnimations.push(new lf(this,e));let c=0;for(const e of n.materials){const t=[];for(const n of e.layers){const a=new uf(this,n,c++,e.priorityPlane);t.push(a),this.layers.push(a)}this.materials.push(new cf(this,e.shader,t)),""!==e.shader&&(this.hd=!0)}s&&(i.reforged=!0),this.hd&&(i.hd=!0);const d=n.textures;for(let e=0,t=d.length;e<t;e++){const t=d[e];let n=t.path;const s=t.replaceableId,u=t.wrapMode;""===n&&0!==s&&(n=`ReplaceableTextures\\${hf[s]}${l}`,1!==s&&2!==s||(o=!0));const c=new Ef(s,u);a.load(n,r,i).then((e=>{e&&(c.texture=e)})),this.textures[e]=c}for(const e of n.geosetAnimations)this.geosetAnimations.push(new df(this,e));this.pivotPoints=n.pivotPoints;let h=0;for(const e of n.bones)this.bones.push(new mf(this,e,h++));for(const e of n.lights)this.lights.push(new pf(this,e,h++));for(const e of n.helpers)this.helpers.push(new _f(this,e,h++));for(const e of n.attachments)this.attachments.push(new gf(this,e,h++));for(const e of n.particleEmitters)this.particleEmitters.push(new bf(this,e,h++));for(const e of n.particleEmitters2){const t=new Lf(this,e,h++);this.particleEmitters2.push(t),t.teamColored&&(o=!0)}for(const e of n.ribbonEmitters)this.ribbonEmitters.push(new If(this,e,h++));for(const e of n.cameras)this.cameras.push(new Uf(this,e));for(const e of n.eventObjects)this.eventObjects.push(new Rf(this,e,h++));for(const e of n.collisionShapes)this.collisionShapes.push(new Mf(this,e,h++));this.genericObjects.push(...this.bones,...this.lights,...this.helpers,...this.attachments,...this.particleEmitters,...this.particleEmitters2,...this.ribbonEmitters,...this.eventObjects,...this.collisionShapes),function(e,t){if(t.length>0){const n=e.viewer.gl;let a=0,r=0,i=0,s=0,l=0,o=0;const u=[];for(let e=0,n=t.length;e<n;e++){const n=t[e];if(0===n.lod||-1===n.lod){const t=n.vertices.length/3;if(a+=12*t,r+=12*t,i+=n.uvSets.length*t*8,n.tangents.length&&(s+=16*t),n.skin.length)l+=8*t,u[e]=Cf.Skin;else{let a=0;for(const e of n.matrixGroups)e>a&&(a=e);a>4?(l+=9*t,u[e]=Cf.ExtendedVertexGroups):(l+=5*t,u[e]=Cf.VertexGroups)}o+=n.faces.byteLength}}let c=0,d=c+a,h=d+r,f=h+i,m=f+s,p=0,_=Uint8Array,g=n.UNSIGNED_BYTE;e.bones.length>255&&(l*=2,_=Uint16Array,g=n.UNSIGNED_SHORT),e.skinDataType=g,e.bytesPerSkinElement=_.BYTES_PER_ELEMENT,e.arrayBuffer=n.createBuffer(),n.bindBuffer(n.ARRAY_BUFFER,e.arrayBuffer),n.bufferData(n.ARRAY_BUFFER,m+l,n.STATIC_DRAW),e.elementBuffer=n.createBuffer(),n.bindBuffer(n.ELEMENT_ARRAY_BUFFER,e.elementBuffer),n.bufferData(n.ELEMENT_ARRAY_BUFFER,o,n.STATIC_DRAW);for(let a=0,r=t.length;a<r;a++){const r=t[a];if(0===r.lod||-1===r.lod){const t=r.vertices,i=r.normals,s=r.uvSets,l=r.tangents,o=r.faces;let g;const b=r.vertices.length/3,w=u[a];if(w===Cf.Skin)g=r.skin;else{const e=r.matrixIndices,t=r.vertexGroups,n=[];let a=0,i=4;w===Cf.ExtendedVertexGroups&&(i=8),g=new _(b*(i+1));for(const t of r.matrixGroups)n.push(e.subarray(a,a+t)),a+=t;for(let e=0;e<b;e++){const r=n[t[e]];if(a=e*(i+1),r){const e=Math.min(r.length,i);for(let t=0;t<e;t++)g[a+t]=r[t]+1;g[a+i]=e}}}const v=new Pf(e,e.geosets.length,c,d,h,f,m,p,b,o.length,r.faceTypeGroups[0]);e.geosets.push(v);const A=e.materials[r.materialId];if("Shader_HD_DefaultUnit"===A.shader)e.batches.push(new Bf(e.batches.length,v,A,w,!0));else for(const t of A.layers)e.batches.push(new Bf(e.batches.length,v,t,w,!1));n.bufferSubData(n.ARRAY_BUFFER,c,t),c+=t.byteLength,n.bufferSubData(n.ARRAY_BUFFER,d,i),d+=i.byteLength;for(const e of s)n.bufferSubData(n.ARRAY_BUFFER,h,e),h+=e.byteLength;l.length&&(n.bufferSubData(n.ARRAY_BUFFER,f,l),f+=l.byteLength),n.bufferSubData(n.ARRAY_BUFFER,m,g),m+=g.byteLength,n.bufferSubData(n.ELEMENT_ARRAY_BUFFER,p,o),p+=o.byteLength}}}}(this,n.geosets),function(e){const t=[];let n=[];for(const a of e.batches)a.layer.filterMode<2?t.push(a):n.push(a);const a=e.opaqueGroups,r=e.translucentGroups;let i=null;for(const n of t)i&&Ff(i,n)||(i=Gf(e,n),a.push(i)),i.objects.push(n.index);n=n.sort(((e,t)=>e.layer.filterMode-t.layer.filterMode));const s=[...n,...e.eventObjects,...e.particleEmitters2,...e.ribbonEmitters].sort(((e,t)=>Df(e)-Df(t)));i=null;for(const t of s)(t instanceof Bf||-1!==t.geometryEmitterType)&&(i&&Ff(i,t)||(i=Gf(e,t),r.push(i)),i.objects.push(t.index))}(this),this.setupHierarchy(-1);for(let e=0,t=this.genericObjects.length;e<t;e++)this.sortedGenericObjects[e]=this.genericObjects[this.hierarchy[e]];o&&Ym.loadTeamTextures(a)}addInstance(){return new Pm(this)}setupHierarchy(e){for(let t=0,n=this.genericObjects.length;t<n;t++){const n=this.genericObjects[t];n.parentId===e&&(this.hierarchy.push(t),this.setupHierarchy(n.objectId))}}},loadTeamTextures(e){const{pathSolver:t,reforged:n,teamColors:a,teamGlows:r}=e.sharedCache.get("mdx");if(0===a.length){const i=n?28:16,s=n?"dds":"blp",l=n?{reforged:!0}:void 0;for(let n=0;n<i;n++){const i=`${`${n}`.padStart(2,"0")}.${s}`,o=new Ef(1,3),u=new Ef(2,3);e.load(`ReplaceableTextures\\TeamColor\\TeamColor${i}`,t,l).then((e=>o.texture=e)),e.load(`ReplaceableTextures\\TeamGlow\\TeamGlow${i}`,t,l).then((e=>u.texture=e)),a[n]=o,r[n]=u}}},getEventObjectSoundFile(e,t,n,a){if(!t||".flac"===hr(e))return e;for(let t=1,r=a.length;t<r;t++){const r=a[t].data.getRow(e);if(r){const e=r.Flags,t=r.Filepath;if("SD_ONLY"===e){if(!n)return t}else{if("HD_ONLY"!==e)return t;if(n)return t}}}},async getEventObjectData(e,t,n,a){if("SPN"!==t&&"SPL"!==t&&"UBR"!==t&&"SND"!==t)return;const{pathSolver:r,reforged:i,eventObjectTables:s}=e.sharedCache.get("mdx"),l=i?{reforged:!0}:void 0,o=(e,t)=>r?r(e,t):e;if(!s[t]){const n=[];"SPN"===t?n.push("Splats\\SpawnData.slk"):"SPL"===t?n.push("Splats\\SplatData.slk"):"UBR"===t?n.push("Splats\\UberSplatData.slk"):"SND"===t&&(n.push("UI\\SoundInfo\\AnimSounds.slk"),i?n.push("UI\\SoundInfo\\DialogueHumanBase.slk","UI\\SoundInfo\\DialogueOrcBase.slk","UI\\SoundInfo\\DialogueUndeadBase.slk","UI\\SoundInfo\\DialogueNightElfBase.slk","UI\\SoundInfo\\DialogueNagaBase.slk","UI\\SoundInfo\\DialogueDemonBase.slk","UI\\SoundInfo\\DialogueCreepsBase.slk"):n.push("UI\\SoundInfo\\AnimLookups.slk"));const a=n.map((t=>e.loadGeneric(o(t,l),"text",Vm))),r=await Promise.all(a);for(const e of r)if(!e)return;s[t]=r}const u=s[t],c=u[0].data;let d;const h=[];if("SND"===t){if(i)d=c.findRow("AnimationEventCode",n);else{const e=u[1].data.getRow(n);e&&(d=c.getRow(e.SoundLabel))}if(d)for(const t of d.FileNames.split(",")){const n=this.getEventObjectSoundFile(t,i,a,u);n&&h.push(e.loadGeneric(o(n,l),"arrayBuffer",Hm))}}else d=c.getRow(n),d&&("SPN"===t?h.push(e.load(d.Model.replace(".mdl",".mdx"),o,l)):"SPL"!==t&&"UBR"!==t||h.push(e.load(`ReplaceableTextures\\Splats\\${d.file}${i?".dds":".blp"}`,o,l)));if(d&&h.length){const e=(await Promise.all(h)).filter((e=>e));if(e.length)return{row:d,resources:e}}},getBatchShader(e,t,n){const a=e.sharedCache.get("mdx"),r=e.debugRenderMode;if(n){if(r!==$d.None){const e=a.hdDebugShaders[t];if(e){const t=e[r];if(t)return t}}return t===Cf.Skin?a.hdSkinShader:t===Cf.VertexGroups?a.hdShader:a.hdExtendedShader}if(r!==$d.None){const e=a.sdDebugShaders[t];if(e){const t=e[r];if(t)return t}}return t===Cf.VertexGroups?a.sdShader:a.sdExtendedShader}};const Km={isValidSource:e=>e instanceof xd||Ed(e),resource:class extends jd{constructor(e,t){let n;super(t),e instanceof xd?n=e:(n=new xd,n.load(e));const a=n.width,r=n.height,i=this.viewer.gl,s=i.createTexture();i.bindTexture(i.TEXTURE_2D,s),i.texImage2D(i.TEXTURE_2D,0,i.RGBA,i.RGBA,i.UNSIGNED_BYTE,n.data),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MAG_FILTER,i.LINEAR),ga(a)&&ga(r)?(i.generateMipmap(i.TEXTURE_2D),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.LINEAR_MIPMAP_LINEAR)):i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.LINEAR),this.webglResource=s,this.width=a,this.height=r}}},zm=`\n${Fh}\n\nuniform sampler2D u_tilesets[15];\n\nvarying vec4 v_tilesets;\nvarying vec2 v_uv[4];\nvarying vec3 v_normal;\n\nconst vec3 lightDirection = normalize(vec3(-0.3, -0.3, 0.25));\n\nvec4 sample(float tileset, vec2 uv) {\n  // 1.0 - 1.0 == 0.0 is not always true.\n  int i = int(tileset - 0.6);\n\n  if (i == 0) {\n    return texture2D(u_tilesets[0], uv);\n  } else if (i == 1) {\n    return texture2D(u_tilesets[1], uv);\n  } else if (i == 2) {\n    return texture2D(u_tilesets[2], uv);\n  } else if (i == 3) {\n    return texture2D(u_tilesets[3], uv);\n  } else if (i == 4) {\n    return texture2D(u_tilesets[4], uv);\n  } else if (i == 5) {\n    return texture2D(u_tilesets[5], uv);\n  } else if (i == 6) {\n    return texture2D(u_tilesets[6], uv);\n  } else if (i == 7) {\n    return texture2D(u_tilesets[7], uv);\n  } else if (i == 8) {\n    return texture2D(u_tilesets[8], uv);\n  } else if (i == 9) {\n    return texture2D(u_tilesets[9], uv);\n  } else if (i == 10) {\n    return texture2D(u_tilesets[10], uv);\n  } else if (i == 11) {\n    return texture2D(u_tilesets[11], uv);\n  } else if (i == 12) {\n    return texture2D(u_tilesets[12], uv);\n  } else if (i == 13) {\n    return texture2D(u_tilesets[13], uv);\n  } else if (i == 14) {\n    return texture2D(u_tilesets[14], uv);\n  }\n}\n\nvec4 blend(vec4 color, float tileset, vec2 uv) {\n  vec4 texel = sample(tileset, uv);\n\n  return mix(color, texel, texel.a);\n}\n\nvoid main() {\n  vec4 color = sample(v_tilesets[0], v_uv[0]);\n\n  if (v_tilesets[1] > 0.5) {\n    color = blend(color, v_tilesets[1], v_uv[1]);\n  }\n\n  if (v_tilesets[2] > 0.5) {\n    color = blend(color, v_tilesets[2], v_uv[2]);\n  }\n\n  if (v_tilesets[3] > 0.5) {\n    color = blend(color, v_tilesets[3], v_uv[3]);\n  }\n\n  //color *= clamp(dot(v_normal, lightDirection) + 0.45, 0.0, 1.0);\n\n  gl_FragColor = vec4(color.rgb, 1.0);\n}\n`,qm=`\n${Fh}\n\nuniform sampler2D u_waterTexture;\n\nvarying vec2 v_uv;\nvarying vec4 v_color;\n\nvoid main() {\n  gl_FragColor = texture2D(u_waterTexture, v_uv) * v_color;\n}\n`,Zm=`\n// #extension GL_OES_standard_derivatives : enable\n\n${Fh}\n\nuniform sampler2D u_texture1;\nuniform sampler2D u_texture2;\n\nvarying vec3 v_normal;\nvarying vec2 v_uv;\nvarying float v_texture;\nvarying vec3 v_position;\n\n// const vec3 lightDirection = normalize(vec3(-0.3, -0.3, 0.25));\n\nvec4 sample(float texture, vec2 uv) {\n  // int(0.0) == 0 is not always true.\n  int i = int(texture + 0.1);\n\n  if (i == 0) {\n    return texture2D(u_texture1, uv);\n  } else {\n    return texture2D(u_texture2, uv);\n  }\n}\n\nvoid main() {\n  vec4 color = sample(v_texture, v_uv);\n\n  // vec3 faceNormal = cross(dFdx(v_position), dFdy(v_position));\n  // vec3 normal = normalize((faceNormal + v_normal) * 0.5);\n\n  // color *= clamp(dot(normal, lightDirection) + 0.45, 0.1, 1.0);\n\n  gl_FragColor = color;\n}\n`;function jm(e){return e.reverse().filter(((e,t,n)=>-1===n.indexOf(e,t+1))).reverse()}const Xm={AAAB:1,AAAC:1,AABA:1,AABB:2,AABC:0,AACA:1,AACB:0,AACC:1,ABAA:1,ABAB:1,ABAC:0,ABBA:2,ABBB:1,ABBC:0,ABCA:0,ABCB:0,ABCC:0,ACAA:1,ACAB:0,ACAC:1,ACBA:0,ACBB:0,ACBC:0,ACCA:1,ACCB:0,ACCC:1,BAAA:1,BAAB:1,BAAC:0,BABA:1,BABB:1,BABC:0,BACA:0,BACB:0,BACC:0,BBAA:1,BBAB:1,BBAC:0,BBBA:1,BBCA:0,BCAA:0,BCAB:0,BCAC:0,BCBA:0,BCCA:0,CAAA:1,CAAB:0,CAAC:1,CABA:0,CABB:0,CABC:0,CACA:1,CACB:0,CACC:1,CBAA:0,CBAB:0,CBAC:0,CBBA:0,CBCA:0,CCAA:1,CCAB:0,CCAC:1,CCBA:0,CCCA:1},$m={AAAB:2,AAAC:1,AABA:1,AABB:3,AABC:0,AACA:1,AACB:0,AACC:3,ABAA:1,ABAB:2,ABAC:0,ABBA:3,ABBB:0,ABBC:0,ABCA:0,ABCB:0,ABCC:0,ACAA:1,ACAB:0,ACAC:2,ACBA:0,ACBB:0,ACBC:0,ACCA:3,ACCB:0,ACCC:1,BAAA:1,BAAB:3,BAAC:0,BABA:2,BABB:0,BABC:0,BACA:0,BACB:0,BACC:0,BBAA:3,BBAB:1,BBAC:0,BBBA:1,BBCA:0,BCAA:0,BCAB:0,BCAC:0,BCBA:0,BCCA:0,CAAA:1,CAAB:0,CAAC:3,CABA:0,CABB:0,CABC:0,CACA:2,CACB:0,CACC:1,CBAA:0,CBAB:0,CBAC:0,CBBA:0,CBCA:0,CCAA:3,CCAB:0,CCAC:1,CCBA:0,CCCA:1};function Jm(e,t,n){return"Cliffs"===e?Math.min(n,Xm[t]):Math.min(n,$m[t])}class Wm{constructor(e,t,n,a,r){const i=e.viewer.gl,s=e.viewer.webgl,l=s.extensions.ANGLE_instanced_arrays,o=s.extensions.OES_vertex_array_object,u=new yi;u.load(t);const c=u.geosets[0],d=c.vertices,h=c.normals,f=c.uvSets[0],m=c.faces,p=d.byteLength,_=p+h.byteLength;let g=null;const b=r.attribs;o&&(g=o.createVertexArrayOES(),o.bindVertexArrayOES(g));const w=i.createBuffer();i.bindBuffer(i.ARRAY_BUFFER,w),i.bufferData(i.ARRAY_BUFFER,_+f.byteLength,i.STATIC_DRAW),i.bufferSubData(i.ARRAY_BUFFER,0,d),i.bufferSubData(i.ARRAY_BUFFER,p,h),i.bufferSubData(i.ARRAY_BUFFER,_,f),o&&(i.vertexAttribPointer(b.a_position,3,i.FLOAT,!1,0,0),i.enableVertexAttribArray(b.a_position),i.vertexAttribPointer(b.a_normal,3,i.FLOAT,!1,0,p),i.enableVertexAttribArray(b.a_normal),i.vertexAttribPointer(b.a_uv,2,i.FLOAT,!1,0,_),i.enableVertexAttribArray(b.a_uv));const v=4*n.length,A=i.createBuffer();i.bindBuffer(i.ARRAY_BUFFER,A),i.bufferData(i.ARRAY_BUFFER,v+a.length,i.STATIC_DRAW),i.bufferSubData(i.ARRAY_BUFFER,0,new Float32Array(n)),i.bufferSubData(i.ARRAY_BUFFER,v,new Uint8Array(a)),o&&(i.vertexAttribPointer(b.a_instancePosition,3,i.FLOAT,!1,0,0),i.enableVertexAttribArray(b.a_instancePosition),l.vertexAttribDivisorANGLE(b.a_instancePosition,1),i.vertexAttribPointer(b.a_instanceTexture,1,i.UNSIGNED_BYTE,!1,0,v),i.enableVertexAttribArray(b.a_instanceTexture),l.vertexAttribDivisorANGLE(b.a_instanceTexture,1));const y=i.createBuffer();i.bindBuffer(i.ELEMENT_ARRAY_BUFFER,y),i.bufferData(i.ELEMENT_ARRAY_BUFFER,m,i.STATIC_DRAW),o&&o.bindVertexArrayOES(null),this.map=e,this.vertexBuffer=w,this.faceBuffer=y,this.normalsOffset=p,this.uvsOffset=_,this.elements=m.length,this.locationAndTextureBuffer=A,this.texturesOffset=v,this.instances=n.length/3,this.vao=g}render(e){const t=this.map.viewer,n=t.gl,a=t.webgl,r=a.extensions.ANGLE_instanced_arrays,i=a.extensions.OES_vertex_array_object,s=e.attribs;i?i.bindVertexArrayOES(this.vao):(n.bindBuffer(n.ARRAY_BUFFER,this.locationAndTextureBuffer),n.vertexAttribPointer(s.a_instancePosition,3,n.FLOAT,!1,0,0),n.vertexAttribPointer(s.a_instanceTexture,1,n.UNSIGNED_BYTE,!1,0,this.texturesOffset),n.bindBuffer(n.ARRAY_BUFFER,this.vertexBuffer),n.vertexAttribPointer(s.a_position,3,n.FLOAT,!1,0,0),n.vertexAttribPointer(s.a_normal,3,n.FLOAT,!1,0,this.normalsOffset),n.vertexAttribPointer(s.a_uv,2,n.FLOAT,!1,0,this.uvsOffset),n.bindBuffer(n.ELEMENT_ARRAY_BUFFER,this.faceBuffer)),r.drawElementsInstancedANGLE(n.TRIANGLES,this.elements,n.UNSIGNED_SHORT,0,this.instances),i&&i.bindVertexArrayOES(null)}}function Qm(e,t){return e.sequence.rarity-t.sequence.rarity}function ep(e){const t=function(e,t){const n=function(e,t){const n=[];for(let a=0,r=t.length;a<r;a++){const r=t[a];r.name.split("-")[0].replace(/\d/g,"").trim().toLowerCase()===e&&n.push({sequence:r,index:a})}return n}(e,t);let a,r;for(n.sort(Qm),a=0,r=n.length;a<r;a++){const e=n[a].sequence.rarity;if(0===e)break;if(10*Math.random()>e)return n[a]}const i=n.length-a;return n[a+Math.floor(Math.random()*i)]}("stand",e.model.sequences);t&&e.setSequence(t.index)}var tp;!function(e){e[e.IDLE=0]="IDLE",e[e.WALK=1]="WALK"}(tp||(tp={}));class np{constructor(e,t){this.state=tp.IDLE,this.instance=t.addInstance(),this.instance.setScene(e.worldScene)}update(){(this.instance.sequenceEnded||-1===this.instance.sequence)&&this.state===tp.IDLE&&ep(this.instance)}}const ap=Gn.create();class rp extends np{constructor(e,t,n,a){super(e,t);const r=this.instance;r.move(a.location),r.rotateLocal(st.setAxisAngle(st.create(),Yn,a.angle)),r.scale(a.scale),r.setTeamColor(a.player),r.setScene(e.worldScene),n&&(ap[2]=n.moveHeight,r.move(ap),r.setVertexColor([n.red/255,n.green/255,n.blue/255,1]),r.uniformScale(n.modelScale)),this.instance=r,this.row=n}}class ip extends np{constructor(e,t,n,a){super(e,t);const r=this.instance;r.move(a.location),r.rotateLocal(st.setAxisAngle(st.create(),Yn,a.angle)),r.scale(a.scale),r.setScene(e.worldScene),this.instance=r,this.row=n}}const sp=Gn.create();class lp{constructor(e,t,n,a){const r=e.centerOffset,i=t.addInstance();sp[0]=128*a.location[0]+r[0]+128,sp[1]=128*a.location[1]+r[1]+128,i.move(sp),i.rotateLocal(st.setAxisAngle(st.create(),Yn,oa(n.fixedRot))),i.setScene(e.worldScene),this.instance=i,this.row=n}}const op=Gn.create(),up=Gn.create();class cp{constructor(e,t){this.buildVersion=0,this.solverParams={tileset:"a"},this.waterIndex=0,this.waterIncreasePerFrame=0,this.waterHeightOffset=0,this.waterTextures=[],this.maxDeepColor=new Float32Array(4),this.minDeepColor=new Float32Array(4),this.maxShallowColor=new Float32Array(4),this.minShallowColor=new Float32Array(4),this.anyReady=!1,this.terrainReady=!1,this.cliffsReady=!1,this.doodads=[],this.terrainDoodads=[],this.doodadsReady=!1,this.units=[],this.unitsReady=!1,this.tilesetTextures=[],this.cliffTextures=[],this.cliffModels=[],this.corners=[],this.centerOffset=new Float32Array(2),this.mapSize=new Int32Array(2),this.tilesets=[],this.blightTextureIndex=-1,this.cliffTilesets=[],this.columns=0,this.rows=0,this.vertexBuffer=null,this.faceBuffer=null,this.instanceBuffer=null,this.textureBuffer=null,this.variationBuffer=null,this.waterBuffer=null,this.heightMap=null,this.waterHeightMap=null,this.cliffHeightMap=null,this.viewer=e,this.worldScene=e.addScene(),this.map=new Wu,this.map.load(t,!0),this.loadMapInformation(),this.pathSolver=(t,n)=>{if("string"==typeof t){const a=t.replace(/\//g,"\\"),r=this.map.get(a);return r?r.arrayBuffer():e.wc3PathSolver(t,n)}return t},this.loadTerrainCliffsAndWater();const n=this.map.readModifications();this.applyModificationFile(e.doodadsData,e.doodadMetaData,n.w3d),this.applyModificationFile(e.doodadsData,e.destructableMetaData,n.w3b),this.applyModificationFile(e.unitsData,e.unitMetaData,n.w3u),this.applyModificationFile(e.unitsData,e.unitMetaData,n.w3t),this.loadDoodadsAndDestructibles(),this.loadUnitsAndItems()}die(){this.worldScene.detach()}load(e){return this.viewer.load(e,this.pathSolver,this.solverParams)}loadMapInformation(){const e=this.map.get("war3map.w3i");if(!e)return void console.warn("Attempted to load war3map.w3i but it is not there. Using default tileset A.");const t=new Ju;try{t.load(e.bytes())}catch(e){console.warn("Failed to correctly parse the map information file")}this.solverParams.tileset=t.tileset.toLowerCase(),this.buildVersion=t.getBuildVersion(),this.buildVersion>131&&(this.solverParams.reforged=!0)}async loadTerrainCliffsAndWater(){const e=this.map.get("war3map.w3e");if(!e)return void console.warn("Attempted to load war3map.w3e, but it is not there.");const t=new fc;try{t.load(e.bytes())}catch(e){return void console.warn(`Failed to load war3map.w3e: ${e}`)}const n=this.viewer,a=t.centerOffset,r=t.mapSize;this.corners=t.corners,this.centerOffset.set(a),this.mapSize.set(r),this.worldScene.grid=new Hd(a[0],a[1],128*r[0]-128,128*r[1]-128,2048,2048);const i=this.solverParams.reforged?".dds":".blp",s=t.tileset,l=[],o=[],u=[];for(const e of t.groundTilesets){const t=n.terrainData.getRow(e);this.tilesets.push(t),l.push(this.load(`${t.dir}\\${t.file}${i}`))}this.blightTextureIndex=this.tilesetTextures.length,l.push(this.load(`TerrainArt\\Blight\\${{A:"Ashen",B:"Barrens",C:"Felwood",D:"Cave",F:"Lordf",G:"Dungeon",I:"Ice",J:"DRuins",K:"Citadel",L:"Lords",N:"North",O:"Outland",Q:"VillageFall",V:"Village",W:"Lordw",X:"Village",Y:"Village",Z:"Ruins"}[s]}_Blight${i}`));for(const e of t.cliffTilesets){const t=n.cliffTypesData.getRow(e);this.cliffTilesets.push(t),o.push(this.load(`${t.texDir}\\${t.texFile}${i}`))}const c=n.waterData.getRow(`${s}Sha`);this.waterHeightOffset=c.height,this.waterIncreasePerFrame=c.texRate/60,this.waterTextures.length=0,this.maxDeepColor.set([c.Dmax_R,c.Dmax_G,c.Dmax_B,c.Dmax_A]),this.minDeepColor.set([c.Dmin_R,c.Dmin_G,c.Dmin_B,c.Dmin_A]),this.maxShallowColor.set([c.Smax_R,c.Smax_G,c.Smax_B,c.Smax_A]),this.minShallowColor.set([c.Smin_R,c.Smin_G,c.Smin_B,c.Smin_A]);for(let e=0,t=c.numTex;e<t;e++)u.push(this.load(`${c.texFile}${e<10?"0":""}${e}${i}`));this.tilesetTextures=await Promise.all(l),this.cliffTextures=await Promise.all(o),this.waterTextures=await Promise.all(u);const d=t.corners,[h,f]=this.mapSize,m=(h-1)*(f-1),p=new Float32Array(h*f),_=new Float32Array(h*f),g=new Float32Array(h*f),b=new Uint8Array(4*m),w=new Uint8Array(4*m),v=new Uint8Array(m);let A=0;const y={};this.columns=h-1,this.rows=f-1;for(let e=0;e<f;e++)for(let t=0;t<h;t++){const n=d[e][t],r=e*h+t;if(p[r]=n.groundHeight,_[r]=n.groundHeight+n.layerHeight-2,g[r]=n.waterHeight,e<f-1&&t<h-1){if(v[A]=this.isWater(t,e),this.isCliff(t,e)){const r=n.layerHeight,i=d[e][t+1].layerHeight,s=d[e+1][t].layerHeight,l=d[e+1][t+1].layerHeight,o=Math.min(r,i,s,l),u=this.cliffFileName(r,i,s,l,o);if("AAAA"!==u){let r=n.cliffTexture;15===r&&(r=1);const i=this.cliffTilesets[r].cliffModelDir,s=`Doodads\\Terrain\\${i}\\${i}${u}${Jm(i,u,n.cliffVariation)}.mdx`;y[s]||(y[s]={locations:[],textures:[]}),y[s].locations.push(128*(t+1)+a[0],128*e+a[1],128*(o-2)),y[s].textures.push(r)}}else{const a=this.cornerTexture(t,e),r=this.cornerTexture(t+1,e),i=this.cornerTexture(t,e+1),s=this.cornerTexture(t+1,e+1),l=jm([a,r,i,s]).sort();let o=l[0];b[4*A]=o+1,w[4*A]=this.getVariation(o,n.groundVariation),l.shift();for(let e=0,t=l.length;e<t;e++){let t=0;o=l[e],r===o&&(t|=1),a===o&&(t|=2),s===o&&(t|=4),i===o&&(t|=8),b[4*A+1+e]=o+1,w[4*A+1+e]=t}}A+=1}}const S=this.viewer.gl,T=this.viewer.webgl;this.vertexBuffer=S.createBuffer(),S.bindBuffer(S.ARRAY_BUFFER,this.vertexBuffer),S.bufferData(S.ARRAY_BUFFER,new Float32Array([0,0,1,0,0,1,1,1]),S.STATIC_DRAW),this.faceBuffer=S.createBuffer(),S.bindBuffer(S.ELEMENT_ARRAY_BUFFER,this.faceBuffer),S.bufferData(S.ELEMENT_ARRAY_BUFFER,new Uint8Array([0,1,2,1,3,2]),S.STATIC_DRAW),this.cliffHeightMap=S.createTexture(),S.bindTexture(S.TEXTURE_2D,this.cliffHeightMap),T.setTextureMode(S.CLAMP_TO_EDGE,S.CLAMP_TO_EDGE,S.NEAREST,S.NEAREST),S.texImage2D(S.TEXTURE_2D,0,S.ALPHA,h,f,0,S.ALPHA,S.FLOAT,p),this.heightMap=S.createTexture(),S.bindTexture(S.TEXTURE_2D,this.heightMap),T.setTextureMode(S.CLAMP_TO_EDGE,S.CLAMP_TO_EDGE,S.NEAREST,S.NEAREST),S.texImage2D(S.TEXTURE_2D,0,S.ALPHA,h,f,0,S.ALPHA,S.FLOAT,_),this.waterHeightMap=S.createTexture(),S.bindTexture(S.TEXTURE_2D,this.waterHeightMap),T.setTextureMode(S.CLAMP_TO_EDGE,S.CLAMP_TO_EDGE,S.NEAREST,S.NEAREST),S.texImage2D(S.TEXTURE_2D,0,S.ALPHA,h,f,0,S.ALPHA,S.FLOAT,g),this.instanceBuffer=S.createBuffer(),S.bindBuffer(S.ARRAY_BUFFER,this.instanceBuffer),S.bufferData(S.ARRAY_BUFFER,new Float32Array(m).map(((e,t)=>t)),S.STATIC_DRAW),this.textureBuffer=S.createBuffer(),S.bindBuffer(S.ARRAY_BUFFER,this.textureBuffer),S.bufferData(S.ARRAY_BUFFER,b,S.STATIC_DRAW),this.variationBuffer=S.createBuffer(),S.bindBuffer(S.ARRAY_BUFFER,this.variationBuffer),S.bufferData(S.ARRAY_BUFFER,w,S.STATIC_DRAW),this.waterBuffer=S.createBuffer(),S.bindBuffer(S.ARRAY_BUFFER,this.waterBuffer),S.bufferData(S.ARRAY_BUFFER,v,S.STATIC_DRAW),this.terrainReady=!0,this.anyReady=!0;const x=n.cliffShader,E=Object.entries(y).map((async e=>{const t=e[0],{locations:a,textures:r}=e[1],i=await n.loadBaseFile(t,"arrayBuffer");if(i)return new Wm(this,i.data,a,r,x)})).filter((e=>e));this.cliffModels=await Promise.all(E),this.cliffsReady=!0}loadDoodadsAndDestructibles(){const e=this.map.get("war3map.doo");if(!e)return void console.warn("Attempted to load war3map.doo but it is not there");const t=new ac;try{t.load(e.bytes(),this.buildVersion)}catch(e){return void console.warn(`Failed to load war3map.doo: ${e}`)}for(const e of t.doodads)try{const t=this.viewer.doodadsData.getRow(e.id);let n=t.file;if(n){const a=t.numVar;n.endsWith(".mdl")&&(n=n.slice(0,-4));let r=n;n+=".mdx",a>1&&(r+=Math.min(e.variation,a-1)),r+=".mdx";const i=this.map.get(r)||this.map.get(n);let s;s=i?this.load(i.name):this.load(r),s.then((n=>{n&&this.doodads.push(new ip(this,n,t,e))}))}else console.log("Unknown doodad ID",e.id,e)}catch(t){console.warn(`Failed to load doodad/destructible ID ${e.id}: ${t}`)}for(const e of t.terrainDoodads)try{const t=this.viewer.doodadsData.getRow(e.id);this.load(`${t.file}.mdx`).then((n=>{n&&this.terrainDoodads.push(new lp(this,n,t,e))}))}catch(t){console.warn(`Failed to load cliff/terrain doodad ID ${e.id}: ${t}`)}this.doodadsReady=!0,this.anyReady=!0}loadUnitsAndItems(){const e=this.map.get("war3mapUnits.doo");if(!e)return void console.warn("Attempted to load war3mapUnits.doo but it is not there");const t=new Pc;try{t.load(e.bytes(),this.buildVersion)}catch(e){return void console.warn(`Failed to load war3mapUnits.doo: ${e}`)}for(const e of t.units)try{let t,n;"sloc"===e.id?n="Objects\\StartLocation\\StartLocation.mdx":(t=this.viewer.unitsData.getRow(e.id),n=t.file,n&&(n.endsWith(".mdl")&&(n=n.slice(0,-4)),n+=".mdx")),n?this.load(n).then((n=>{n&&this.units.push(new rp(this,n,t,e))})):console.log("Unknown unit ID",e.id,e)}catch(t){console.warn(`Failed to load unit/item ID ${e.id}: ${t}`)}this.unitsReady=!0,this.anyReady=!0}update(){if(this.anyReady){this.waterIndex+=this.waterIncreasePerFrame,this.waterIndex>=this.waterTextures.length&&(this.waterIndex=0);for(const e of this.doodads)e.update();for(const e of this.units)e.update()}}render(){if(this.anyReady){const e=this.worldScene;e.startFrame(),this.renderGround(),this.renderCliffs(),e.renderOpaque(),this.renderWater(),e.renderTranslucent()}}renderGround(){if(this.terrainReady){const e=this.viewer.gl,t=this.viewer.webgl,n=t.extensions.ANGLE_instanced_arrays,a=this.viewer.groundShader,r=a.uniforms,i=a.attribs,s=this.tilesetTextures,l=i.a_InstanceID,o=i.a_position,u=i.a_textures,c=i.a_variations,d=s.length;e.enable(e.BLEND),e.blendFunc(e.SRC_ALPHA,e.ONE_MINUS_SRC_ALPHA),t.useShader(a),e.uniformMatrix4fv(r.u_VP,!1,this.worldScene.camera.viewProjectionMatrix),e.uniform2fv(r.u_offset,this.centerOffset),e.uniform2f(r.u_size,this.columns,this.rows),e.uniform1i(r.u_heightMap,15),e.activeTexture(e.TEXTURE15),e.bindTexture(e.TEXTURE_2D,this.heightMap),e.bindBuffer(e.ARRAY_BUFFER,this.vertexBuffer),e.vertexAttribPointer(o,2,e.FLOAT,!1,0,0),e.bindBuffer(e.ARRAY_BUFFER,this.instanceBuffer),e.vertexAttribPointer(l,1,e.FLOAT,!1,0,0),n.vertexAttribDivisorANGLE(l,1),e.bindBuffer(e.ARRAY_BUFFER,this.textureBuffer),e.vertexAttribPointer(u,4,e.UNSIGNED_BYTE,!1,0,0),n.vertexAttribDivisorANGLE(u,1),e.bindBuffer(e.ARRAY_BUFFER,this.variationBuffer),e.vertexAttribPointer(c,4,e.UNSIGNED_BYTE,!1,0,0),n.vertexAttribDivisorANGLE(c,1),e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,this.faceBuffer),e.uniform1f(r.u_baseTileset,0);for(let n=0,a=Math.min(d,15);n<a;n++){const a=s[n].width>s[n].height?1:0;e.uniform1f(r[`u_extended[${n}]`],a),e.uniform1i(r[`u_tilesets[${n}]`],n),t.bindTexture(s[n],n)}if(n.drawElementsInstancedANGLE(e.TRIANGLES,6,e.UNSIGNED_BYTE,0,this.rows*this.columns),d>15){e.uniform1f(r.u_baseTileset,15);for(let n=0,a=d-15;n<a;n++){const a=s[n+15].width>s[n+15].height?1:0;e.uniform1f(r[`u_extended[${n}]`],a),t.bindTexture(s[n+15],n)}n.drawElementsInstancedANGLE(e.TRIANGLES,6,e.UNSIGNED_BYTE,0,this.rows*this.columns)}n.vertexAttribDivisorANGLE(u,0),n.vertexAttribDivisorANGLE(c,0),n.vertexAttribDivisorANGLE(l,0)}}renderWater(){if(this.terrainReady){const e=this.viewer.gl,t=this.viewer.webgl,n=t.extensions.ANGLE_instanced_arrays,a=this.viewer.waterShader,r=a.uniforms,i=a.attribs,s=i.a_InstanceID,l=i.a_position,o=i.a_isWater;e.depthMask(!1),e.enable(e.BLEND),e.blendFunc(e.SRC_ALPHA,e.ONE_MINUS_SRC_ALPHA),t.useShader(a),e.uniformMatrix4fv(r.u_VP,!1,this.worldScene.camera.viewProjectionMatrix),e.uniform2fv(r.u_offset,this.centerOffset),e.uniform2f(r.u_size,this.columns,this.rows),e.uniform1i(r.u_heightMap,0),e.uniform1i(r.u_waterHeightMap,1),e.uniform1i(r.u_waterTexture,2),e.uniform1f(r.u_offsetHeight,this.waterHeightOffset),e.uniform4fv(r.u_maxDeepColor,this.maxDeepColor),e.uniform4fv(r.u_minDeepColor,this.minDeepColor),e.uniform4fv(r.u_maxShallowColor,this.maxShallowColor),e.uniform4fv(r.u_minShallowColor,this.minShallowColor),e.activeTexture(e.TEXTURE0),e.bindTexture(e.TEXTURE_2D,this.heightMap),e.activeTexture(e.TEXTURE1),e.bindTexture(e.TEXTURE_2D,this.waterHeightMap),t.bindTexture(this.waterTextures[0|this.waterIndex],2),e.bindBuffer(e.ARRAY_BUFFER,this.vertexBuffer),e.vertexAttribPointer(l,2,e.FLOAT,!1,8,0),e.bindBuffer(e.ARRAY_BUFFER,this.instanceBuffer),e.vertexAttribPointer(s,1,e.FLOAT,!1,4,0),n.vertexAttribDivisorANGLE(s,1),e.bindBuffer(e.ARRAY_BUFFER,this.waterBuffer),e.vertexAttribPointer(o,1,e.UNSIGNED_BYTE,!1,1,0),n.vertexAttribDivisorANGLE(o,1),e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,this.faceBuffer),n.drawElementsInstancedANGLE(e.TRIANGLES,6,e.UNSIGNED_BYTE,0,this.rows*this.columns),n.vertexAttribDivisorANGLE(o,0),n.vertexAttribDivisorANGLE(s,0)}}renderCliffs(){if(this.cliffsReady){const e=this.viewer.gl,t=this.viewer.webgl,n=t.extensions.ANGLE_instanced_arrays,a=t.extensions.OES_vertex_array_object,r=this.viewer.cliffShader,i=r.attribs,s=r.uniforms;e.disable(e.BLEND),r.use(),e.uniformMatrix4fv(s.u_VP,!1,this.worldScene.camera.viewProjectionMatrix),e.uniform1i(s.u_heightMap,0),e.uniform2f(s.u_pixel,1/(this.columns+1),1/(this.rows+1)),e.uniform2fv(s.u_centerOffset,this.centerOffset),e.uniform1i(s.u_texture1,1),e.uniform1i(s.u_texture2,2),e.activeTexture(e.TEXTURE0),e.bindTexture(e.TEXTURE_2D,this.cliffHeightMap),e.activeTexture(e.TEXTURE1),e.bindTexture(e.TEXTURE_2D,this.cliffTextures[0].webglResource),this.cliffTextures.length>1&&(e.activeTexture(e.TEXTURE2),e.bindTexture(e.TEXTURE_2D,this.cliffTextures[1].webglResource)),a||(n.vertexAttribDivisorANGLE(i.a_instancePosition,1),n.vertexAttribDivisorANGLE(i.a_instanceTexture,1));for(const e of this.cliffModels)e.render(r);a||(n.vertexAttribDivisorANGLE(i.a_instancePosition,0),n.vertexAttribDivisorANGLE(i.a_instanceTexture,0))}}cliffFileName(e,t,n,a,r){return String.fromCharCode(65+e-r)+String.fromCharCode(65+n-r)+String.fromCharCode(65+a-r)+String.fromCharCode(65+t-r)}getVariation(e,t){const n=this.tilesetTextures[e];return n.width>n.height?t<16?16+t:16===t?15:0:0===t?0:15}isCliff(e,t){if(e<1||e>this.columns-1||t<1||t>this.rows-1)return!1;const n=this.corners,a=n[t][e].layerHeight,r=n[t][e+1].layerHeight,i=n[t+1][e].layerHeight,s=n[t+1][e+1].layerHeight;return a!==r||a!==i||a!==s}isWater(e,t){const n=this.corners;return n[t][e].water||n[t][e+1].water||n[t+1][e].water||n[t+1][e+1].water}cliffGroundIndex(e){const t=this.cliffTilesets[e].groundTile,n=this.tilesets;for(let e=0,a=n.length;e<a;e++)if(n[e].tileID===t)return e;return 0}cornerTexture(e,t){const n=this.corners,a=this.columns,r=this.rows;for(let i=-1;i<1;i++)for(let s=-1;s<1;s++)if(e+s>0&&e+s<a-1&&t+i>0&&t+i<r-1&&this.isCliff(e+s,t+i)){let a=n[t+i][e+s].cliffTexture;return 15===a&&(a=1),this.cliffGroundIndex(a)}const i=n[t][e];return i.blight?this.blightTextureIndex:i.groundTexture}applyModificationFile(e,t,n){n&&(this.applyModificationTable(e,t,n.originalTable),this.applyModificationTable(e,t,n.customTable))}applyModificationTable(e,t,n){for(const a of n.objects){let n;""!==a.newId?(n=e.getRow(a.newId),n||(n=Object.assign({},e.getRow(a.oldId)),e.setRow(a.newId,n))):n=e.getRow(a.oldId);for(const e of a.modifications){const a=t.getRow(e.id);a?n[a.field]=e.value:console.warn("Unknown modification ID",e)}}}groundNormal(e,t,n){const a=this.centerOffset,r=this.mapSize,i=0|(t=(t-a[0])/128),s=0|(n=(n-a[1])/128);if(i>=0&&i<r[0]-1&&s>=0&&s<r[1]-1){const a=this.corners,r=a[s][i].groundHeight,l=a[s][i+1].groundHeight,o=a[s+1][i].groundHeight,u=a[s+1][i+1].groundHeight;t-i+(n-s)<1?(Gn.set(op,1,0,l-r),Gn.set(up,0,1,o-r)):(Gn.set(op,-1,0,u-o),Gn.set(up,0,1,u-l)),Gn.normalize(e,Gn.cross(e,op,up))}else Gn.set(e,0,0,1);return e}}const dp={blp:sh,dds:lh,m3:Nh,mdx:Ym,tga:Km,War3MapViewer:class extends Jd{constructor(e,t,n){super(e),this.terrainData=new Hh,this.cliffTypesData=new Hh,this.waterData=new Hh,this.doodadsData=new Hh,this.doodadMetaData=new Hh,this.destructableMetaData=new Hh,this.unitsData=new Hh,this.unitMetaData=new Hh,this.loadedBaseFiles=!1,this.map=null;const a=this.webgl;if(!a.ensureExtension("OES_texture_float"))throw new Error("War3MapViewer: No float texture support!");a.ensureExtension("OES_vertex_array_object")||console.warn("War3MapViewer: No vertex array object support! This might reduce performance."),this.on("error",(e=>console.log(e))),this.addHandler(Ym,t,n),this.addHandler(sh),this.addHandler(Km),this.addHandler(lh),this.wc3PathSolver=t,this.isReforged=n,this.groundShader=this.webgl.createShader("\nuniform mat4 u_VP;\nuniform sampler2D u_heightMap;\nuniform vec2 u_size;\nuniform vec2 u_offset;\nuniform bool u_extended[14];\nuniform float u_baseTileset;\n\nattribute vec2 a_position;\nattribute float a_InstanceID;\nattribute vec4 a_textures;\nattribute vec4 a_variations;\n\nvarying vec4 v_tilesets;\nvarying vec2 v_uv[4];\nvarying vec3 v_normal;\n\nvec2 getCell(float variation) {\n  if (variation < 16.0) {\n    return vec2(mod(variation, 4.0), floor(variation / 4.0));\n  } else {\n    variation -= 16.0;\n\n    return vec2(4.0 + mod(variation, 4.0), floor(variation / 4.0));\n  }\n}\n\nvec2 getUV(vec2 position, bool extended, float variation) {\n  vec2 cell = getCell(variation);\n  vec2 cellSize = vec2(extended ? 0.125 : 0.25, 0.25);\n  vec2 uv = vec2(position.x, 1.0 - position.y);\n  vec2 pixelSize = vec2(1.0 / 512.0, 1.0 / 256.0); /// Note: hardcoded to 512x256 for now.\n\n  return clamp((cell + uv) * cellSize, cell * cellSize + pixelSize, (cell + 1.0) * cellSize - pixelSize); \n}\n\nvoid main() {\n  vec4 textures = a_textures - u_baseTileset;\n  \n  if (textures[0] > 0.0 || textures[1] > 0.0 || textures[2] > 0.0 || textures[3] > 0.0) {\n    v_tilesets = textures;\n\n    v_uv[0] = getUV(a_position, u_extended[int(textures[0]) - 1], a_variations[0]);\n    v_uv[1] = getUV(a_position, u_extended[int(textures[1]) - 1], a_variations[1]);\n    v_uv[2] = getUV(a_position, u_extended[int(textures[2]) - 1], a_variations[2]);\n    v_uv[3] = getUV(a_position, u_extended[int(textures[3]) - 1], a_variations[3]);\n\n    vec2 corner = vec2(mod(a_InstanceID, u_size.x), floor(a_InstanceID / u_size.x));\n    vec2 base = corner + a_position;\n    float height = texture2D(u_heightMap, base / u_size).a;\n\n    float hL = texture2D(u_heightMap, vec2(base - vec2(1.0, 0.0)) / (u_size)).a;\n    float hR = texture2D(u_heightMap, vec2(base + vec2(1.0, 0.0)) / (u_size)).a;\n    float hD = texture2D(u_heightMap, vec2(base - vec2(0.0, 1.0)) / (u_size)).a;\n    float hU = texture2D(u_heightMap, vec2(base + vec2(0.0, 1.0)) / (u_size)).a;\n\n    v_normal = normalize(vec3(hL - hR, hD - hU, 2.0));\n\n    gl_Position = u_VP * vec4(base * 128.0 + u_offset, height * 128.0, 1.0);\n  } else {\n    v_tilesets = vec4(0.0);\n\n    v_uv[0] = vec2(0.0);\n    v_uv[1] = vec2(0.0);\n    v_uv[2] = vec2(0.0);\n    v_uv[3] = vec2(0.0);\n\n    v_normal = vec3(0.0);\n\n    gl_Position = vec4(0.0);\n  }\n}\n",zm),this.waterShader=this.webgl.createShader("\nuniform mat4 u_VP;\nuniform sampler2D u_heightMap;\nuniform sampler2D u_waterHeightMap;\nuniform vec2 u_size;\nuniform vec2 u_offset;\nuniform float u_offsetHeight;\nuniform vec4 u_minDeepColor;\nuniform vec4 u_maxDeepColor;\nuniform vec4 u_minShallowColor;\nuniform vec4 u_maxShallowColor;\n\nattribute vec2 a_position;\nattribute float a_InstanceID;\nattribute float a_isWater;\n\nvarying vec2 v_uv;\nvarying vec4 v_color;\n\nconst float minDepth = 10.0 / 128.0;\nconst float deepLevel = 64.0 / 128.0;\nconst float maxDepth = 72.0 / 128.0;\n\nvoid main() {\n  if (a_isWater > 0.5) {\n    v_uv = a_position;\n\n    vec2 corner = vec2(mod(a_InstanceID, u_size.x), floor(a_InstanceID / u_size.x));\n    vec2 base = corner + a_position;\n    float height = texture2D(u_heightMap, base / u_size).a;\n    float waterHeight = texture2D(u_waterHeightMap, base / u_size).a + u_offsetHeight;\n    float value = clamp(waterHeight - height, 0.0, 1.0);\n\n    if (value <= deepLevel) {\n      value = max(0.0, value - minDepth) / (deepLevel - minDepth);\n      v_color = mix(u_minShallowColor, u_maxShallowColor, value) / 255.0;\n    } else {\n      value = clamp(value - deepLevel, 0.0, maxDepth - deepLevel) / (maxDepth - deepLevel);\n      v_color = mix(u_minDeepColor, u_maxDeepColor, value) / 255.0;\n    }\n\n    gl_Position = u_VP * vec4(base * 128.0 + u_offset, waterHeight * 128.0, 1.0);\n  } else {\n    v_uv = vec2(0.0);\n    v_color = vec4(0.0);\n\n    gl_Position = vec4(0.0);\n  }\n}\n",qm),this.cliffShader=this.webgl.createShader("\nuniform mat4 u_VP;\nuniform sampler2D u_heightMap;\nuniform vec2 u_pixel;\nuniform vec2 u_centerOffset;\n\nattribute vec3 a_position;\nattribute vec3 a_normal;\nattribute vec2 a_uv;\nattribute vec3 a_instancePosition;\nattribute float a_instanceTexture;\n\nvarying vec3 v_normal;\nvarying vec2 v_uv;\nvarying float v_texture;\nvarying vec3 v_position;\n\nvoid main() {\n  // Half of a pixel in the cliff height map.\n  vec2 halfPixel = u_pixel * 0.5;\n\n  // The bottom left corner of the map tile this vertex is on.\n  vec2 corner = floor((a_instancePosition.xy - vec2(1.0, 0.0) - u_centerOffset.xy) / 128.0);\n\n  // Get the 4 closest heights in the height map.\n  float bottomLeft = texture2D(u_heightMap, corner * u_pixel + halfPixel).a;\n  float bottomRight = texture2D(u_heightMap, (corner + vec2(1.0, 0.0)) * u_pixel + halfPixel).a;\n  float topLeft = texture2D(u_heightMap, (corner + vec2(0.0, 1.0)) * u_pixel + halfPixel).a;\n  float topRight = texture2D(u_heightMap, (corner + vec2(1.0, 1.0)) * u_pixel + halfPixel).a;\n  \n  // Do a bilinear interpolation between the heights to get the final value.\n  float bottom = mix(bottomRight, bottomLeft, -a_position.x / 128.0);\n  float top = mix(topRight, topLeft, -a_position.x / 128.0);\n  float height = mix(bottom, top, a_position.y / 128.0);\n\n  v_normal = a_normal;\n  v_uv = a_uv;\n  v_texture = a_instanceTexture;\n  v_position = a_position + vec3(a_instancePosition.xy, a_instancePosition.z + height * 128.0);\n\n  gl_Position = u_VP * vec4(v_position, 1.0);\n}\n",Zm),this.loadBaseFiles()}async loadBaseFiles(){const e=[this.loadBaseFile("TerrainArt\\Terrain.slk","text"),this.loadBaseFile("TerrainArt\\CliffTypes.slk","text"),this.loadBaseFile("TerrainArt\\Water.slk","text"),this.loadBaseFile("Doodads\\Doodads.slk","text"),this.loadBaseFile("Doodads\\DoodadMetaData.slk","text"),this.loadBaseFile("Units\\DestructableData.slk","text"),this.loadBaseFile("Units\\DestructableMetaData.slk","text"),this.loadBaseFile("Units\\UnitData.slk","text"),this.loadBaseFile("Units\\unitUI.slk","text"),this.loadBaseFile("Units\\ItemData.slk","text"),this.loadBaseFile("Units\\UnitMetaData.slk","text")];let t;this.isReforged&&(t=[this.loadBaseFile("Doodads\\doodadSkins.txt","text"),this.loadBaseFile("Units\\destructableSkin.txt","text"),this.loadBaseFile("Units\\unitSkin.txt","text"),this.loadBaseFile("Units\\itemSkin.txt","text")]);const[n,a,r,i,s,l,o,u,c,d,h]=await Promise.all(e);if(!(n&&a&&r&&i&&s&&l&&o&&u&&c&&d&&h))throw new Error("Failed to load the base files");if(this.terrainData.load(n.data),this.cliffTypesData.load(a.data),this.waterData.load(r.data),this.doodadsData.load(i.data),this.doodadMetaData.load(s.data),this.doodadsData.load(l.data),this.destructableMetaData.load(o.data),this.unitsData.load(u.data),this.unitsData.load(c.data),this.unitsData.load(d.data),this.unitMetaData.load(h.data),t){const[e,n,a,r]=await Promise.all(t);if(!(e&&n&&a&&r))throw new Error("Failed to load the base Reforged files");this.doodadsData.load(e.data),this.doodadsData.load(n.data),this.unitsData.load(a.data),this.unitsData.load(r.data)}this.loadedBaseFiles=!0,this.emit("loadedbasefiles")}loadBaseFile(e,t){return super.loadGeneric(this.wc3PathSolver(e),t)}loadMap(e){this.loadedBaseFiles&&(this.map&&this.map.die(),this.map=new cp(this,e))}update(){this.map&&(super.update(),this.map.update())}render(){this.map&&this.map.render()}}},hp={ModelViewer:Jd,DebugRenderMode:$d,Scene:Kd,Camera:Nd,Node:th,Model:ah,ModelInstance:rh,Texture:jd,GenericResource:qd,gl:ih,handlers:dp};function fp(e,t){const n=t[e];for(let a=0;a<e;a++)if(t[a]===n)return!0;return!1}const mp={sanityTest:function(e){const t=[],n=e.content,a=e.alphaBits,r=e.mipmapOffsets,i=e.mipmapSizes;let s=e.width,l=e.height;if(0!==n&&1!==n&&t.push({type:"warning",message:"Unknown content type"}),0!==a&&1!==a&&4!==a&&8!==a&&t.push({type:"warning",message:`Expected alpha bits to be 0, 1, 4, or 8, but got ${a}`}),(s>512||l>512)&&t.push({type:"warning",message:`Expected width and height up to 512, but got ${s}x${l}`}),0===n){const n=e.jpgHeader;n.length>624&&t.push({type:"warning",message:`Expected the JPG header to be at most 624 bytes, but got ${n.length}`})}ga(s)&&ga(l)||t.push({type:"warning",message:`Expected the width and height to be powers of two, but got ${s}x${l}`});for(let o=0;o<16;o++){if(i[o]>0)if(s<1&&l<1)t.push({type:"warning",message:`Mipmap ${o}: this mipmap should not exist`});else if(fp(o,r))t.push({type:"warning",message:`Mipmap ${o}: this mipmap is fake`});else{let r;s=Math.max(s,1),l=Math.max(l,1);try{r=e.getMipmap(o)}catch(e){t.push({type:"warning",message:`Mipmap ${o}: Decoding failed`})}if(r)if(0===n)r.width===s&&r.height===l||t.push({type:"warning",message:`Mipmap ${o}: the JPG width (${r.width}) and height (${r.height}) do not match the mipmap width (${s}) and height (${l})`});else if(1===n){const e=s*l,n=e+Math.ceil(e*a/8);n!==i[o]&&t.push({type:"warning",message:`Mipmap ${o}: the declared size is ${i[o]}, but the real size is ${n}`})}}s>>=1,l>>=1}return{warnings:t.length,nodes:t}}};const pp={sanityTest:function(e){const t=[],n=e.width,a=e.height,r=e.mipmaps(),i=Math.log2(Math.max(n,a));r<i&&t.push({type:"warning",message:`Expected ${i} mipmaps, but got ${r}`}),n%4==0&&a%4==0||t.push({type:"warning",message:`Expected the width and height to be multiples of four, but got ${n}x${a}`}),ga(n)&&ga(a)||t.push({type:"warning",message:`Expected the width and height to be powers of two, but got ${n}x${a}`});for(let n=0;n<r;n++)try{e.getMipmap(n)}catch(e){t.push({type:"warning",message:`Mipmap ${n}: Decoding failed`})}return{warnings:t.length,nodes:t}}};var _p=n(973),gp=n(775),bp=n(670),wp=n(983);function vp(e){const t=new xc(e),n=[];let a;for(;void 0!==(a=t.read());)if("function"===a){const e=t.readSafe();t.read(),a=t.read();let r="";if("nothing"!==a)for(r+=t.readSafe();","===t.read();)t.read(),r+=","+t.readSafe();else t.read();t.read();const i=`function ${e}(${r})`,s=[];for(;"endfunction"!==(a=t.readSafe());)if("local"===a){t.read();const e=t.readSafe();"array"===e?s.push(`local ${t.readSafe()}={}`):s.push(`local ${e}${t.readUntil("\n")}\n`)}else if("if"===a||"elseif"===a||"not"===a)s.push(a+" ");else if("then"===a)s.push(" "+a);else if("loop"===a)s.push("while 1 do");else if("endloop"===a||"endif"===a)s.push("end");else if("exitwhen"===a)s.push(`if ${t.readUntil("\n")} then break end\n`);else if("return"===a){const e=t.readUntil("\n");a=t.peek(),"endif"===a||"endloop"===a||"endfunction"===a?s.push(`return ${e}\n`):s.push(`if 1 then return ${e} end\n`)}else if("\n"===a){const e=s[s.length-1];e&&"\n"!==e[e.length-1]&&s.push("\n")}else"set"!==a&&"call"!==a&&"function"!==a&&s.push(a);n.push(`${i}\n${s.join("")}end`)}else if("globals"===a)for(;"endglobals"!==(a=t.read());)if("\n"!==a){"constant"===a&&(a=t.read());const e=t.read();if("array"===e)n.push(`${t.readSafe()}={}`);else{let a="nil";"="===t.peek()&&(t.read(),a=t.readUntil("\n")),"nil"!==a&&n.push(`${e}=${a}`)}}return n.join("\n")}class Ap{constructor(){this.handleId=-1}}class yp extends Ap{}class Sp extends yp{constructor(e,t){super(),this.team=-1,this.startLocation=-1,this.forcedStartLocation=-1,this.color=-1,this.racePreference=-1,this.raceSelectable=!1,this.controller=-1,this.alliances=new Map,this.index=e,this.name=`Player ${e}`;for(let n=0;n<t;n++)n!==e&&this.alliances.set(n,{passive:!1,helpRequest:!1,helpResponse:!1,sharedXp:!1,sharedSpells:!1,sharedVision:!1,sharedControl:!1,sharedAdvancedControl:!1,rescuable:!1,sharedVisionForced:!1})}}class Tp extends yp{constructor(){super(...arguments),this.health=0,this.maxHealth=0}}class xp extends Tp{constructor(e,t,n,a,r){super(),this.acquireRange=500,this.player=e,this.unitId=lr(t),this.x=n,this.y=a,this.face=r}}class Ep extends yp{constructor(){super(...arguments),this.players=new Set}}class Lp extends yp{constructor(){super(...arguments),this.units=new Set}}class Ip extends yp{constructor(){super(...arguments),this.events=[],this.conditions=[],this.actions=[],this.enabled=!0}}class Up extends yp{constructor(){super(...arguments),this.elapsed=0,this.timeout=0,this.periodic=!1,this.handlerFunc=-1}}class Rp extends yp{constructor(e,t){super(),this.z=0,this.x=e,this.y=t}}class Mp extends yp{constructor(){super(...arguments),this.rects=new Set}}class Cp extends yp{constructor(e,t,n,a){super(),this.center=new Float32Array([n-e,a-t]),this.min=new Float32Array([e,t]),this.max=new Float32Array([n,a])}}class Bp extends Ap{constructor(e){super(),this.id=e}}class Pp extends Bp{}class kp extends Bp{}class Op extends Bp{}class Dp extends Bp{}class Fp extends Dp{}class Gp extends Dp{}class Np extends Bp{}class Vp extends Bp{}class Hp extends Bp{}class Yp extends Bp{}class Kp extends Bp{}class zp extends Bp{}class qp extends zp{}class Zp extends zp{}class jp extends zp{}class Xp extends zp{}class $p extends zp{}class Jp extends zp{}class Wp extends zp{}class Qp extends Bp{}class e_ extends Bp{}class t_ extends Bp{}class n_ extends Bp{}class a_ extends Bp{}class r_ extends Bp{}class i_ extends Bp{}class s_ extends Bp{}class l_ extends Bp{}class o_ extends Bp{}class u_ extends Bp{}class c_ extends Bp{}class d_ extends Ap{constructor(){super(...arguments),this.targetDistance=0,this.farZ=0,this.angleOfAttack=0,this.fieldOfView=0,this.roll=0,this.rotation=0,this.zOffset=0,this.destPosition=new Rp(0,0)}}class h_ extends Bp{}class f_ extends Bp{}class m_ extends Bp{}class p_ extends Bp{}class __ extends Bp{}class g_ extends Bp{}class b_ extends Bp{}class w_ extends Ap{constructor(e,t){super(),this.enabled=!1,this.whichRect=e,this.effectId=t}}class v_ extends Bp{}class A_ extends Bp{}class y_ extends Bp{}class S_ extends Bp{}class T_ extends Bp{}class x_ extends Bp{}class E_ extends Bp{}class L_ extends Bp{}class I_ extends yp{constructor(){super(...arguments),this.table=new Map}save(e,t,n){const a=this.table;let r=a.get(e);r||(r=new Map,a.set(e,r)),r.set(t,n)}load(e,t,n){const a=this.table.get(e);if(a){const e=a.get(t);if(void 0!==e)return e}return n}have(e,t){const n=this.table.get(e);return!!n&&n.has(t)}remove(e,t){const n=this.table,a=n.get(e);a&&(a.delete(t),a.size||n.delete(e))}flush(){this.table.clear()}flushChild(e){const t=this.table.get(e);t&&t.clear()}}function U_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.races[n]),1}function R_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.allianceTypes[n]),1}function M_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.racePrefs[n]),1}function C_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.gameStates[n]),1}function B_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.gameStates[n]),1}function P_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.playerStates[n]),1}function k_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.playerScores[n]),1}function O_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.playerGameResults[n]),1}function D_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.unitStates[n]),1}function F_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.aiDifficulties[n]),1}function G_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.events[n]),1}function N_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.events[n]),1}function V_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.events[n]),1}function H_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.events[n]),1}function Y_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.events[n]),1}function K_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.events[n]),1}function z_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.limitOps[n]),1}function q_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.unitTypes[n]),1}function Z_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.gameSpeeds[n]),1}function j_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.placements[n]),1}function X_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.startLocPrios[n]),1}function $_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.gameDifficulties[n]),1}function J_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.gameTypes[n]),1}function W_(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.mapFlags[n]),1}function Q_(e,t){(0,bp.Ye)(t,1);return console.warn("ConvertMapVisibility used, but the implementation is unknown"),(0,_p.lua_pushnil)(t),1}function eg(e,t){(0,bp.Ye)(t,1);return console.warn("ConvertMapSetting used, but the implementation is unknown"),(0,_p.lua_pushnil)(t),1}function tg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.mapDensities[n]),1}function ng(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.mapControls[n]),1}function ag(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.playerColors[n]),1}function rg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.playerSlotStates[n]),1}function ig(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.volumeGroups[n]),1}function sg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.cameraFields[n]),1}function lg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.blendModes[n]),1}function og(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.rarityControls[n]),1}function ug(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.texMapFlags[n]),1}function cg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.fogStates[n]),1}function dg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.effectTypes[n]),1}function hg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.versions[n]),1}function fg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.itemTypes[n]),1}function mg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.attackTypes[n]),1}function pg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.damageTypes[n]),1}function _g(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.weaponTypes[n]),1}function gg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.soundTypes[n]),1}function bg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.pathingTypes[n]),1}function wg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.mouseButtonTypes[n]),1}function vg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.animTypes[n]),1}function Ag(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.constantHandles.subAnimTypes[n]),1}function yg(e,t){(0,bp.zH)(t,1);return console.warn("OrderId was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function Sg(e,t){(0,bp.Ye)(t,1);return console.warn("OrderId2String was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function Tg(e,t){(0,bp.zH)(t,1);return console.warn("UnitId was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function xg(e,t){(0,bp.Ye)(t,1);return console.warn("UnitId2String was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function Eg(e,t){(0,bp.zH)(t,1);return console.warn("AbilityId was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function Lg(e,t){(0,bp.Ye)(t,1);return console.warn("AbilityId2String was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function Ig(e,t){(0,bp.Ye)(t,1);return console.warn("GetObjectName was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function Ug(e,t){return(0,_p.lua_pushinteger)(t,24),1}function Rg(e,t){return(0,_p.lua_pushinteger)(t,24),1}function Mg(e,t){return(0,_p.lua_pushinteger)(t,25),1}function Cg(e,t){return(0,_p.lua_pushinteger)(t,28),1}function Bg(e,t){return(0,_p.lua_pushinteger)(t,26),1}function Pg(e,t){return(0,_p.lua_pushinteger)(t,27),1}function kg(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushnumber)(t,n*(Math.PI/180)),1}function Og(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushnumber)(t,n*(180/Math.PI)),1}function Dg(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushnumber)(t,Math.sin(n)),1}function Fg(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushnumber)(t,Math.cos(n)),1}function Gg(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushnumber)(t,Math.tan(n)),1}function Ng(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushnumber)(t,Math.asin(n)),1}function Vg(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushnumber)(t,Math.acos(n)),1}function Hg(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushnumber)(t,Math.atan(n)),1}function Yg(e,t){const n=(0,bp.qZ)(t,1),a=(0,bp.qZ)(t,2);return(0,_p.lua_pushnumber)(t,Math.atan2(n,a)),1}function Kg(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushnumber)(t,Math.sqrt(n)),1}function zg(e,t){const n=(0,bp.qZ)(t,1),a=(0,bp.qZ)(t,2);return(0,_p.lua_pushnumber)(t,Math.pow(n,a)),1}function qg(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushnumber)(t,n),1}function Zg(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushinteger)(t,0|n),1}function jg(e,t){(0,bp.Ye)(t,1);return console.warn("I2S was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function Xg(e,t){(0,bp.qZ)(t,1);return console.warn("R2S was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function $g(e,t){(0,bp.qZ)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("R2SW was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function Jg(e,t){(0,bp.zH)(t,1);return console.warn("S2I was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function Wg(e,t){(0,bp.zH)(t,1);return console.warn("S2R was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Qg(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushinteger)(t,n.handleId),1}function eb(e,t){(0,bp.zH)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("SubString was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function tb(e,t){(0,bp.zH)(t,1);return console.warn("StringLength was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function nb(e,t){(0,bp.zH)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("StringCase was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function ab(e,t){(0,bp.zH)(t,1);return console.warn("StringHash was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function rb(e,t){(0,bp.zH)(t,1);return console.warn("GetLocalizedString was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function ib(e,t){(0,bp.zH)(t,1);return console.warn("GetLocalizedHotkey was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function sb(e,t){(0,bp.zH)(t,1);return console.warn("SetMapName was called but is not implemented :("),0}function lb(e,t){(0,bp.zH)(t,1);return console.warn("SetMapDescription was called but is not implemented :("),0}function ob(e,t){(0,bp.Ye)(t,1);return console.warn("SetTeams was called but is not implemented :("),0}function ub(e,t){(0,bp.Ye)(t,1);return console.warn("SetPlayers was called but is not implemented :("),0}function cb(e,t){const n=(0,bp.Ye)(t,1),a=(0,bp.qZ)(t,2),r=(0,bp.qZ)(t,3);return e.startLocations[n]=e.addHandle(new Rp(a,r)),0}function db(e,t){(0,bp.Ye)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("DefineStartLocationLoc was called but is not implemented :("),0}function hb(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("SetStartLocPrioCount was called but is not implemented :("),0}function fb(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SetStartLocPrio was called but is not implemented :("),0}function mb(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("GetStartLocPrioSlot was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function pb(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("GetStartLocPrio was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function _b(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetGameTypeSupported was called but is not implemented :("),0}function gb(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetMapFlag was called but is not implemented :("),0}function bb(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("SetGamePlacement was called but is not implemented :("),0}function wb(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("SetGameSpeed was called but is not implemented :("),0}function vb(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("SetGameDifficulty was called but is not implemented :("),0}function Ab(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("SetResourceDensity was called but is not implemented :("),0}function yb(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("SetCreatureDensity was called but is not implemented :("),0}function Sb(e,t){return console.warn("GetTeams was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function Tb(e,t){return console.warn("GetPlayers was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function xb(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsGameTypeSupported was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Eb(e,t){return console.warn("GetGameTypeSelected was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Lb(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsMapFlagSet was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Ib(e,t){return console.warn("GetGamePlacement was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Ub(e,t){return console.warn("GetGameSpeed was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Rb(e,t){return console.warn("GetGameDifficulty was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Mb(e,t){return console.warn("GetResourceDensity was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Cb(e,t){return console.warn("GetCreatureDensity was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Bb(e,t){(0,bp.Ye)(t,1);return console.warn("GetStartLocationX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Pb(e,t){(0,bp.Ye)(t,1);return console.warn("GetStartLocationY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function kb(e,t){(0,bp.Ye)(t,1);return console.warn("GetStartLocationLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Ob(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetPlayerTeam was called but is not implemented :("),0}function Db(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,bp.Ye)(t,2);return n.startLocation=a,0}function Fb(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("ForcePlayerStartLocation was called but is not implemented :("),0}function Gb(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,_p.lua_touserdata)(t,2);return n.color=a,0}function Nb(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("SetPlayerAlliance was called but is not implemented :("),0}function Vb(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.Ye)(t,4);return console.warn("SetPlayerTaxRate was called but is not implemented :("),0}function Hb(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("SetPlayerRacePreference was called but is not implemented :("),0}function Yb(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,_p.lua_toboolean)(t,2);return n.raceSelectable=a,0}function Kb(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,_p.lua_touserdata)(t,2);return n.controller=a,0}function zb(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,bp.zH)(t,2);return n.name=a,0}function qb(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetPlayerOnScoreScreen was called but is not implemented :("),0}function Zb(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetPlayerTeam was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function jb(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushinteger)(t,n.startLocation),1}function Xb(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushlightuserdata)(t,n.color),1}function $b(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetPlayerSelectable was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Jb(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushlightuserdata)(t,n.controller),1}function Wb(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetPlayerSlotState was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Qb(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("GetPlayerTaxRate was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function ew(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsPlayerRacePrefSet was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function tw(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushstring)(t,n.name),1}function nw(e,t){return(0,_p.lua_pushlightuserdata)(t,e.addHandle(new Up)),1}function aw(e,t){const n=(0,_p.lua_touserdata)(t,1);return e.timers.delete(n),e.freeHandle(n),0}function rw(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,bp.qZ)(t,2),r=(0,_p.lua_toboolean)(t,3),i=(0,bp.b6)(t,gp.LUA_REGISTRYINDEX);return n.elapsed=0,n.timeout=a,n.periodic=r,n.handlerFunc=i,e.timers.add(n),0}function iw(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushnumber)(t,n.elapsed),1}function sw(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushnumber)(t,n.timeout-n.elapsed),1}function lw(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushnumber)(t,n.timeout),1}function ow(e,t){const n=(0,_p.lua_touserdata)(t,1);return e.timers.delete(n),0}function uw(e,t){const n=(0,_p.lua_touserdata)(t,1);return e.timers.add(n),0}function cw(e,t){const n=e.currentThread;return n&&n.expiredTimer?(0,_p.lua_pushlightuserdata)(t,n.expiredTimer):(0,_p.lua_pushnil)(t),1}function dw(e,t){return(0,_p.lua_pushlightuserdata)(t,e.addHandle(new Lp)),1}function hw(e,t){const n=(0,_p.lua_touserdata)(t,1);return e.freeHandle(n),0}function fw(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,_p.lua_touserdata)(t,2);return n.units.add(a),0}function mw(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,_p.lua_touserdata)(t,2);return n.units.delete(a),0}function pw(e,t){return(0,_p.lua_touserdata)(t,1).units.clear(),0}function _w(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("GroupEnumUnitsOfType was called but is not implemented :("),0}function gw(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("GroupEnumUnitsOfPlayer was called but is not implemented :("),0}function bw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.Ye)(t,4);return console.warn("GroupEnumUnitsOfTypeCounted was called but is not implemented :("),0}function ww(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("GroupEnumUnitsInRect was called but is not implemented :("),0}function vw(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.Ye)(t,4);return console.warn("GroupEnumUnitsInRectCounted was called but is not implemented :("),0}function Aw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,_p.lua_touserdata)(t,5);return console.warn("GroupEnumUnitsInRange was called but is not implemented :("),0}function yw(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("GroupEnumUnitsInRangeOfLoc was called but is not implemented :("),0}function Sw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,_p.lua_touserdata)(t,5),(0,bp.Ye)(t,6);return console.warn("GroupEnumUnitsInRangeCounted was called but is not implemented :("),0}function Tw(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,_p.lua_touserdata)(t,4),(0,bp.Ye)(t,5);return console.warn("GroupEnumUnitsInRangeOfLocCounted was called but is not implemented :("),0}function xw(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("GroupEnumUnitsSelected was called but is not implemented :("),0}function Ew(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("GroupImmediateOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Lw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("GroupImmediateOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Iw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("GroupPointOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Uw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("GroupPointOrderLoc was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Rw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("GroupPointOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Mw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("GroupPointOrderByIdLoc was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Cw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("GroupTargetOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Bw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("GroupTargetOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Pw(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,bp.b6)(t,gp.LUA_REGISTRYINDEX);for(const t of n.units)e.enumUnit=t,e.call(a);return e.enumUnit=null,(0,bp.i$)(t,a),0}function kw(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("FirstOfGroup was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Ow(e,t){return(0,_p.lua_pushlightuserdata)(t,e.addHandle(new Ep)),1}function Dw(e,t){const n=(0,_p.lua_touserdata)(t,1);return e.freeHandle(n),0}function Fw(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,_p.lua_touserdata)(t,2);return n.players.add(a),0}function Gw(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,_p.lua_touserdata)(t,2);return n.players.delete(a),0}function Nw(e,t){return(0,_p.lua_touserdata)(t,1).players.clear(),0}function Vw(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("ForceEnumPlayers was called but is not implemented :("),0}function Hw(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.Ye)(t,3);return console.warn("ForceEnumPlayersCounted was called but is not implemented :("),0}function Yw(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("ForceEnumAllies was called but is not implemented :("),0}function Kw(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("ForceEnumEnemies was called but is not implemented :("),0}function zw(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,bp.b6)(t,gp.LUA_REGISTRYINDEX);for(const t of n.players)e.enumPlayer=t,e.call(a);return e.enumPlayer=null,(0,bp.i$)(t,a),0}function qw(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("Rect was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Zw(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("RectFromLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function jw(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("RemoveRect was called but is not implemented :("),0}function Xw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5);return console.warn("SetRect was called but is not implemented :("),0}function $w(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("SetRectFromLoc was called but is not implemented :("),0}function Jw(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("MoveRectTo was called but is not implemented :("),0}function Ww(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("MoveRectToLoc was called but is not implemented :("),0}function Qw(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetRectCenterX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function ev(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetRectCenterY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function tv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetRectMinX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function nv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetRectMinY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function av(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetRectMaxX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function rv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetRectMaxY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function iv(e,t){return console.warn("CreateRegion was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function sv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("RemoveRegion was called but is not implemented :("),0}function lv(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("RegionAddRect was called but is not implemented :("),0}function ov(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("RegionClearRect was called but is not implemented :("),0}function uv(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("RegionAddCell was called but is not implemented :("),0}function cv(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("RegionAddCellAtLoc was called but is not implemented :("),0}function dv(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("RegionClearCell was called but is not implemented :("),0}function hv(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("RegionClearCellAtLoc was called but is not implemented :("),0}function fv(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("Location was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function mv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("RemoveLocation was called but is not implemented :("),0}function pv(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("MoveLocation was called but is not implemented :("),0}function _v(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetLocationX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function gv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetLocationY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function bv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetLocationZ was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function wv(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitInRegion was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function vv(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("IsPointInRegion was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Av(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsLocationInRegion was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function yv(e,t){return console.warn("GetWorldBounds was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Sv(e,t){return(0,_p.lua_pushlightuserdata)(t,e.addHandle(new Ip)),1}function Tv(e,t){const n=(0,_p.lua_touserdata)(t,1);return e.triggers.delete(n),e.freeHandle(n),0}function xv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("ResetTrigger was called but is not implemented :("),0}function Ev(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("EnableTrigger was called but is not implemented :("),0}function Lv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DisableTrigger was called but is not implemented :("),0}function Iv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsTriggerEnabled was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Uv(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("TriggerWaitOnSleeps was called but is not implemented :("),0}function Rv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsTriggerWaitOnSleeps was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Mv(e,t){return(0,_p.lua_pushlightuserdata)(t,e.filterUnit),1}function Cv(e,t){return(0,_p.lua_pushlightuserdata)(t,e.enumUnit),1}function Bv(e,t){return console.warn("GetFilterDestructable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Pv(e,t){return console.warn("GetEnumDestructable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function kv(e,t){return console.warn("GetFilterItem was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Ov(e,t){return console.warn("GetEnumItem was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Dv(e,t){return console.warn("GetFilterPlayer was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Fv(e,t){return(0,_p.lua_pushlightuserdata)(t,e.enumPlayer),1}function Gv(e,t){const n=e.currentThread;return n&&n.triggeringTrigger?(0,_p.lua_pushlightuserdata)(t,n.triggeringTrigger):(0,_p.lua_pushnil)(t),1}function Nv(e,t){return console.warn("GetTriggerEventId was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Vv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetTriggerEvalCount was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function Hv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetTriggerExecCount was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function Yv(e,t){(0,bp.zH)(t,1);return console.warn("ExecuteFunc was called but is not implemented :("),0}function Kv(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("And was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function zv(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("Or was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function qv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("Not was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Zv(e,t){(0,bp.b6)(t,gp.LUA_REGISTRYINDEX);return console.warn("Condition was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function jv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyCondition was called but is not implemented :("),0}function Xv(e,t){(0,bp.b6)(t,gp.LUA_REGISTRYINDEX);return console.warn("Filter was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function $v(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyFilter was called but is not implemented :("),0}function Jv(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyBoolExpr was called but is not implemented :("),0}function Wv(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.qZ)(t,4);return console.warn("TriggerRegisterVariableEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Qv(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("TriggerRegisterTimerEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function eA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("TriggerRegisterTimerExpireEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function tA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.qZ)(t,4);return console.warn("TriggerRegisterGameStateEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function nA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("TriggerRegisterDialogEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function aA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("TriggerRegisterDialogButtonEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function rA(e,t){return console.warn("GetEventGameState was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function iA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("TriggerRegisterGameEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function sA(e,t){return console.warn("GetWinningPlayer was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function lA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("TriggerRegisterEnterRegion was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function oA(e,t){return console.warn("GetTriggeringRegion was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function uA(e,t){return console.warn("GetEnteringUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function cA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("TriggerRegisterLeaveRegion was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function dA(e,t){return console.warn("GetLeavingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function hA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("TriggerRegisterTrackableHitEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function fA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("TriggerRegisterTrackableTrackEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function mA(e,t){return console.warn("GetTriggeringTrackable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function pA(e,t){return console.warn("GetClickedButton was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function _A(e,t){return console.warn("GetClickedDialog was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function gA(e,t){return console.warn("GetTournamentFinishSoonTimeRemaining was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function bA(e,t){return console.warn("GetTournamentFinishNowRule was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function wA(e,t){return console.warn("GetTournamentFinishNowPlayer was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function vA(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetTournamentScore was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function AA(e,t){return console.warn("GetSaveBasicFilename was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function yA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("TriggerRegisterPlayerEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function SA(e,t){return console.warn("GetTriggerPlayer was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function TA(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("TriggerRegisterPlayerUnitEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function xA(e,t){return console.warn("GetLevelingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function EA(e,t){return console.warn("GetLearningUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function LA(e,t){return console.warn("GetLearnedSkill was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function IA(e,t){return console.warn("GetLearnedSkillLevel was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function UA(e,t){return console.warn("GetRevivableUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function RA(e,t){return console.warn("GetRevivingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function MA(e,t){return console.warn("GetAttacker was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function CA(e,t){return console.warn("GetRescuer was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function BA(e,t){return console.warn("GetDyingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function PA(e,t){return console.warn("GetKillingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function kA(e,t){return console.warn("GetDecayingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function OA(e,t){return console.warn("GetConstructingStructure was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function DA(e,t){return console.warn("GetCancelledStructure was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function FA(e,t){return console.warn("GetConstructedStructure was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function GA(e,t){return console.warn("GetResearchingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function NA(e,t){return console.warn("GetResearched was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function VA(e,t){return console.warn("GetTrainedUnitType was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function HA(e,t){return console.warn("GetTrainedUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function YA(e,t){return console.warn("GetDetectedUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function KA(e,t){return console.warn("GetSummoningUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function zA(e,t){return console.warn("GetSummonedUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function qA(e,t){return console.warn("GetTransportUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ZA(e,t){return console.warn("GetLoadedUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function jA(e,t){return console.warn("GetSellingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function XA(e,t){return console.warn("GetSoldUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function $A(e,t){return console.warn("GetBuyingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function JA(e,t){return console.warn("GetSoldItem was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function WA(e,t){return console.warn("GetChangingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function QA(e,t){return console.warn("GetChangingUnitPrevOwner was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ey(e,t){return console.warn("GetManipulatingUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ty(e,t){return console.warn("GetManipulatedItem was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ny(e,t){return console.warn("GetOrderedUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ay(e,t){return console.warn("GetIssuedOrderId was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function ry(e,t){return console.warn("GetOrderPointX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function iy(e,t){return console.warn("GetOrderPointY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function sy(e,t){return console.warn("GetOrderPointLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ly(e,t){return console.warn("GetOrderTarget was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function oy(e,t){return console.warn("GetOrderTargetDestructable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function uy(e,t){return console.warn("GetOrderTargetItem was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function cy(e,t){return console.warn("GetOrderTargetUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function dy(e,t){return console.warn("GetSpellAbilityUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function hy(e,t){return console.warn("GetSpellAbilityId was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function fy(e,t){return console.warn("GetSpellAbility was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function my(e,t){return console.warn("GetSpellTargetLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function py(e,t){return console.warn("GetSpellTargetX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function _y(e,t){return console.warn("GetSpellTargetY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function gy(e,t){return console.warn("GetSpellTargetDestructable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function by(e,t){return console.warn("GetSpellTargetItem was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function wy(e,t){return console.warn("GetSpellTargetUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function vy(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("TriggerRegisterPlayerAllianceChange was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Ay(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,_p.lua_touserdata)(t,4),(0,bp.qZ)(t,5);return console.warn("TriggerRegisterPlayerStateEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function yy(e,t){return console.warn("GetEventPlayerState was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Sy(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.zH)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("TriggerRegisterPlayerChatEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Ty(e,t){return console.warn("GetEventPlayerChatString was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function xy(e,t){return console.warn("GetEventPlayerChatStringMatched was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function Ey(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("TriggerRegisterDeathEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Ly(e,t){const n=e.currentThread;return n&&n.triggerUnit?(0,_p.lua_pushlightuserdata)(t,n.triggerUnit):(0,_p.lua_pushnil)(t),1}function Iy(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,_p.lua_touserdata)(t,4),(0,bp.qZ)(t,5);return console.warn("TriggerRegisterUnitStateEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Uy(e,t){return console.warn("GetEventUnitState was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Ry(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("TriggerRegisterUnitEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function My(e,t){return console.warn("GetEventDamage was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Cy(e,t){return console.warn("GetEventDamageSource was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function By(e,t){return console.warn("GetEventDetectingPlayer was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Py(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("TriggerRegisterFilterUnitEvent was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ky(e,t){return console.warn("GetEventTargetUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Oy(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("TriggerRegisterUnitInRange was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Dy(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("TriggerAddCondition was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Fy(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("TriggerRemoveCondition was called but is not implemented :("),0}function Gy(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("TriggerClearConditions was called but is not implemented :("),0}function Ny(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.b6)(t,gp.LUA_REGISTRYINDEX);return console.warn("TriggerAddAction was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Vy(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("TriggerRemoveAction was called but is not implemented :("),0}function Hy(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("TriggerClearActions was called but is not implemented :("),0}function Yy(e,t){const n=(0,bp.qZ)(t,1);return(0,_p.lua_pushnumber)(t,n),(0,wp.lua_yield)(t,1),0}function Ky(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("TriggerWaitForSound was called but is not implemented :("),0}function zy(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("TriggerEvaluate was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function qy(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("TriggerExecute was called but is not implemented :("),0}function Zy(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("TriggerExecuteWait was called but is not implemented :("),0}function jy(e,t){return console.warn("TriggerSyncStart was called but is not implemented :("),0}function Xy(e,t){return console.warn("TriggerSyncReady was called but is not implemented :("),0}function $y(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetWidgetLife was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Jy(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetWidgetLife was called but is not implemented :("),0}function Wy(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetWidgetX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Qy(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetWidgetY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function eS(e,t){return console.warn("GetTriggerWidget was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function tS(e,t){(0,bp.Ye)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.Ye)(t,6);return console.warn("CreateDestructable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function nS(e,t){(0,bp.Ye)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6),(0,bp.Ye)(t,7);return console.warn("CreateDestructableZ was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function aS(e,t){(0,bp.Ye)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.Ye)(t,6);return console.warn("CreateDeadDestructable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function rS(e,t){(0,bp.Ye)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6),(0,bp.Ye)(t,7);return console.warn("CreateDeadDestructableZ was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function iS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("RemoveDestructable was called but is not implemented :("),0}function sS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("KillDestructable was called but is not implemented :("),0}function lS(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetDestructableInvulnerable was called but is not implemented :("),0}function oS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsDestructableInvulnerable was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function uS(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.b6)(t,gp.LUA_REGISTRYINDEX);return console.warn("EnumDestructablesInRect was called but is not implemented :("),0}function cS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetDestructableTypeId was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function dS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetDestructableX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function hS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetDestructableY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function fS(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetDestructableLife was called but is not implemented :("),0}function mS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetDestructableLife was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function pS(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetDestructableMaxLife was called but is not implemented :("),0}function _S(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetDestructableMaxLife was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function gS(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("DestructableRestoreLife was called but is not implemented :("),0}function bS(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("QueueDestructableAnimation was called but is not implemented :("),0}function wS(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("SetDestructableAnimation was called but is not implemented :("),0}function vS(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetDestructableAnimationSpeed was called but is not implemented :("),0}function AS(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("ShowDestructable was called but is not implemented :("),0}function yS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetDestructableOccluderHeight was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function SS(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetDestructableOccluderHeight was called but is not implemented :("),0}function TS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetDestructableName was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function xS(e,t){return console.warn("GetTriggerDestructable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ES(e,t){(0,bp.Ye)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("CreateItem was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function LS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("RemoveItem was called but is not implemented :("),0}function IS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetItemPlayer was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function US(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetItemTypeId was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function RS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetItemX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function MS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetItemY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function CS(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("SetItemPosition was called but is not implemented :("),0}function BS(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetItemDropOnDeath was called but is not implemented :("),0}function PS(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetItemDroppable was called but is not implemented :("),0}function kS(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetItemPawnable was called but is not implemented :("),0}function OS(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetItemPlayer was called but is not implemented :("),0}function DS(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetItemInvulnerable was called but is not implemented :("),0}function FS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsItemInvulnerable was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function GS(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetItemVisible was called but is not implemented :("),0}function NS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsItemVisible was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function VS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsItemOwned was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function HS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsItemPowerup was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function YS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsItemSellable was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function KS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsItemPawnable was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function zS(e,t){(0,bp.Ye)(t,1);return console.warn("IsItemIdPowerup was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function qS(e,t){(0,bp.Ye)(t,1);return console.warn("IsItemIdSellable was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function ZS(e,t){(0,bp.Ye)(t,1);return console.warn("IsItemIdPawnable was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function jS(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.b6)(t,gp.LUA_REGISTRYINDEX);return console.warn("EnumItemsInRect was called but is not implemented :("),0}function XS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetItemLevel was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function $S(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetItemType was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function JS(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetItemDropID was called but is not implemented :("),0}function WS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetItemName was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function QS(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetItemCharges was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function eT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetItemCharges was called but is not implemented :("),0}function tT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetItemUserData was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function nT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetItemUserData was called but is not implemented :("),0}function aT(e,t){const n=(0,_p.lua_touserdata)(t,1),a=(0,bp.Ye)(t,2),r=(0,bp.qZ)(t,3),i=(0,bp.qZ)(t,4),s=(0,bp.qZ)(t,5);return(0,_p.lua_pushlightuserdata)(t,e.addHandle(new xp(n,a,r,i,s))),1}function rT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5);return console.warn("CreateUnitByName was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function iT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.qZ)(t,4);return console.warn("CreateUnitAtLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function sT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.qZ)(t,4);return console.warn("CreateUnitAtLocByName was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function lT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5);return console.warn("CreateCorpse was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function oT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("KillUnit was called but is not implemented :("),0}function uT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("RemoveUnit was called but is not implemented :("),0}function cT(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("ShowUnit was called but is not implemented :("),0}function dT(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3);return console.warn("SetUnitState was called but is not implemented :("),0}function hT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetUnitX was called but is not implemented :("),0}function fT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetUnitY was called but is not implemented :("),0}function mT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("SetUnitPosition was called but is not implemented :("),0}function pT(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("SetUnitPositionLoc was called but is not implemented :("),0}function _T(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetUnitFacing was called but is not implemented :("),0}function gT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("SetUnitFacingTimed was called but is not implemented :("),0}function bT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetUnitMoveSpeed was called but is not implemented :("),0}function wT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("SetUnitFlyHeight was called but is not implemented :("),0}function vT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetUnitTurnSpeed was called but is not implemented :("),0}function AT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetUnitPropWindow was called but is not implemented :("),0}function yT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetUnitAcquireRange was called but is not implemented :("),0}function ST(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetUnitCreepGuard was called but is not implemented :("),0}function TT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitAcquireRange was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function xT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitTurnSpeed was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function ET(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitPropWindow was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function LT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitFlyHeight was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function IT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitDefaultAcquireRange was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function UT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitDefaultTurnSpeed was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function RT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitDefaultPropWindow was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function MT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitDefaultFlyHeight was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function CT(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetUnitOwner was called but is not implemented :("),0}function BT(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("SetUnitColor was called but is not implemented :("),0}function PT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("SetUnitScale was called but is not implemented :("),0}function kT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetUnitTimeScale was called but is not implemented :("),0}function OT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetUnitBlendTime was called but is not implemented :("),0}function DT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("SetUnitVertexColor was called but is not implemented :("),0}function FT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("QueueUnitAnimation was called but is not implemented :("),0}function GT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("SetUnitAnimation was called but is not implemented :("),0}function NT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetUnitAnimationByIndex was called but is not implemented :("),0}function VT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("SetUnitAnimationWithRarity was called but is not implemented :("),0}function HT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("AddUnitAnimationProperties was called but is not implemented :("),0}function YT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6);return console.warn("SetUnitLookAt was called but is not implemented :("),0}function KT(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("ResetUnitLookAt was called but is not implemented :("),0}function zT(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetUnitRescuable was called but is not implemented :("),0}function qT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetUnitRescueRange was called but is not implemented :("),0}function ZT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetHeroStr was called but is not implemented :("),0}function jT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetHeroAgi was called but is not implemented :("),0}function XT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetHeroInt was called but is not implemented :("),0}function $T(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("GetHeroStr was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function JT(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("GetHeroAgi was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function WT(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("GetHeroInt was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function QT(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("UnitStripHeroLevel was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function ex(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetHeroXP was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function tx(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetHeroXP was called but is not implemented :("),0}function nx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetHeroSkillPoints was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function ax(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("UnitModifySkillPoints was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function rx(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("AddHeroXP was called but is not implemented :("),0}function ix(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetHeroLevel was called but is not implemented :("),0}function sx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetHeroLevel was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function lx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitLevel was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function ox(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetHeroProperName was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function ux(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SuspendHeroXP was called but is not implemented :("),0}function cx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsSuspendedXP was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function dx(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SelectHeroSkill was called but is not implemented :("),0}function hx(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("GetUnitAbilityLevel was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function fx(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("DecUnitAbilityLevel was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function mx(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("IncUnitAbilityLevel was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function px(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("SetUnitAbilityLevel was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function _x(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("ReviveHero was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function gx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("ReviveHeroLoc was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function bx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetUnitExploded was called but is not implemented :("),0}function wx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetUnitInvulnerable was called but is not implemented :("),0}function vx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("PauseUnit was called but is not implemented :("),0}function Ax(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsUnitPaused was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function yx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetUnitPathing was called but is not implemented :("),0}function Sx(e,t){return console.warn("ClearSelection was called but is not implemented :("),0}function Tx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SelectUnit was called but is not implemented :("),0}function xx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitPointValue was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function Ex(e,t){(0,bp.Ye)(t,1);return console.warn("GetUnitPointValueByType was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function Lx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("UnitAddItem was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Ix(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("UnitAddItemById was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Ux(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("UnitAddItemToSlotById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Rx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("UnitRemoveItem was called but is not implemented :("),0}function Mx(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("UnitRemoveItemFromSlot was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Cx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("UnitHasItem was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Bx(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("UnitItemInSlot was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Px(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("UnitInventorySize was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function kx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("UnitDropItemPoint was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Ox(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.Ye)(t,3);return console.warn("UnitDropItemSlot was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Dx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("UnitDropItemTarget was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Fx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("UnitUseItem was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Gx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("UnitUseItemPoint was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Nx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("UnitUseItemTarget was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Vx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Hx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Yx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Kx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitFacing was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function zx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitMoveSpeed was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function qx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitDefaultMoveSpeed was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Zx(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("GetUnitState was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function jx(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushlightuserdata)(t,n.player),1}function Xx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitTypeId was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function $x(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitRace was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Jx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitName was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function Wx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitFoodUsed was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function Qx(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitFoodMade was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function eE(e,t){(0,bp.Ye)(t,1);return console.warn("GetFoodMade was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function tE(e,t){(0,bp.Ye)(t,1);return console.warn("GetFoodUsed was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function nE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetUnitUseFood was called but is not implemented :("),0}function aE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitRallyPoint was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function rE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitRallyUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function iE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitRallyDestructable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function sE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitInGroup was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function lE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitInForce was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function oE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitOwnedByPlayer was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function uE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitAlly was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function cE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitEnemy was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function dE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitVisible was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function hE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitDetected was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function fE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitInvisible was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function mE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitFogged was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function pE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitMasked was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function _E(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitSelected was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function gE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitRace was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function bE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitType was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function wE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnit was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function vE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3);return console.warn("IsUnitInRange was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function AE(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("IsUnitInRangeXY was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function yE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3);return console.warn("IsUnitInRangeLoc was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function SE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsUnitHidden was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function TE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsUnitIllusion was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function xE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitInTransport was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function EE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsUnitLoaded was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function LE(e,t){(0,bp.Ye)(t,1);return console.warn("IsHeroUnitId was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function IE(e,t){(0,bp.Ye)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsUnitIdType was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function UE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("UnitShareVision was called but is not implemented :("),0}function RE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("UnitSuspendDecay was called but is not implemented :("),0}function ME(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("UnitAddType was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function CE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("UnitRemoveType was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function BE(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("UnitAddAbility was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function PE(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("UnitRemoveAbility was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function kE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.Ye)(t,3);return console.warn("UnitMakeAbilityPermanent was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function OE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("UnitRemoveBuffs was called but is not implemented :("),0}function DE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3),(0,_p.lua_toboolean)(t,4),(0,_p.lua_toboolean)(t,5),(0,_p.lua_toboolean)(t,6),(0,_p.lua_toboolean)(t,7),(0,_p.lua_toboolean)(t,8);return console.warn("UnitRemoveBuffsEx was called but is not implemented :("),0}function FE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3),(0,_p.lua_toboolean)(t,4),(0,_p.lua_toboolean)(t,5),(0,_p.lua_toboolean)(t,6),(0,_p.lua_toboolean)(t,7),(0,_p.lua_toboolean)(t,8);return console.warn("UnitHasBuffsEx was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function GE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3),(0,_p.lua_toboolean)(t,4),(0,_p.lua_toboolean)(t,5),(0,_p.lua_toboolean)(t,6),(0,_p.lua_toboolean)(t,7),(0,_p.lua_toboolean)(t,8);return console.warn("UnitCountBuffsEx was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function NE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("UnitAddSleep was called but is not implemented :("),0}function VE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("UnitCanSleep was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function HE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("UnitAddSleepPerm was called but is not implemented :("),0}function YE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("UnitCanSleepPerm was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function KE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("UnitIsSleeping was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function zE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("UnitWakeUp was called but is not implemented :("),0}function qE(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.qZ)(t,3);return console.warn("UnitApplyTimedLife was called but is not implemented :("),0}function ZE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("UnitIgnoreAlarm was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function jE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("UnitIgnoreAlarmToggled was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function XE(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("UnitResetCooldown was called but is not implemented :("),0}function $E(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("UnitSetConstructionProgress was called but is not implemented :("),0}function JE(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("UnitSetUpgradeProgress was called but is not implemented :("),0}function WE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("UnitPauseTimedLife was called but is not implemented :("),0}function QE(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("UnitSetUsesAltIcon was called but is not implemented :("),0}function eL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6),(0,_p.lua_toboolean)(t,7),(0,_p.lua_toboolean)(t,8),(0,_p.lua_touserdata)(t,9),(0,_p.lua_touserdata)(t,10),(0,_p.lua_touserdata)(t,11);return console.warn("UnitDamagePoint was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function tL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,_p.lua_toboolean)(t,4),(0,_p.lua_toboolean)(t,5),(0,_p.lua_touserdata)(t,6),(0,_p.lua_touserdata)(t,7),(0,_p.lua_touserdata)(t,8);return console.warn("UnitDamageTarget was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function nL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("IssueImmediateOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function aL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("IssueImmediateOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function rL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("IssuePointOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function iL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("IssuePointOrderLoc was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function sL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("IssuePointOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function lL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("IssuePointOrderByIdLoc was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function oL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("IssueTargetOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function uL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("IssueTargetOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function cL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,_p.lua_touserdata)(t,5);return console.warn("IssueInstantPointOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function dL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,_p.lua_touserdata)(t,5);return console.warn("IssueInstantPointOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function hL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_touserdata)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("IssueInstantTargetOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function fL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_touserdata)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("IssueInstantTargetOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function mL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("IssueBuildOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function pL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("IssueBuildOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function _L(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.zH)(t,3);return console.warn("IssueNeutralImmediateOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function gL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.Ye)(t,3);return console.warn("IssueNeutralImmediateOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function bL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.zH)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5);return console.warn("IssueNeutralPointOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function wL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.Ye)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5);return console.warn("IssueNeutralPointOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function vL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.zH)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("IssueNeutralTargetOrder was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function AL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("IssueNeutralTargetOrderById was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function yL(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitCurrentOrder was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function SL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetResourceAmount was called but is not implemented :("),0}function TL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("AddResourceAmount was called but is not implemented :("),0}function xL(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetResourceAmount was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function EL(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("WaygateGetDestinationX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function LL(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("WaygateGetDestinationY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function IL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("WaygateSetDestination was called but is not implemented :("),0}function UL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("WaygateActivate was called but is not implemented :("),0}function RL(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("WaygateIsActive was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function ML(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("AddItemToAllStock was called but is not implemented :("),0}function CL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4);return console.warn("AddItemToStock was called but is not implemented :("),0}function BL(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("AddUnitToAllStock was called but is not implemented :("),0}function PL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4);return console.warn("AddUnitToStock was called but is not implemented :("),0}function kL(e,t){(0,bp.Ye)(t,1);return console.warn("RemoveItemFromAllStock was called but is not implemented :("),0}function OL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("RemoveItemFromStock was called but is not implemented :("),0}function DL(e,t){(0,bp.Ye)(t,1);return console.warn("RemoveUnitFromAllStock was called but is not implemented :("),0}function FL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("RemoveUnitFromStock was called but is not implemented :("),0}function GL(e,t){(0,bp.Ye)(t,1);return console.warn("SetAllItemTypeSlots was called but is not implemented :("),0}function NL(e,t){(0,bp.Ye)(t,1);return console.warn("SetAllUnitTypeSlots was called but is not implemented :("),0}function VL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetItemTypeSlots was called but is not implemented :("),0}function HL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetUnitTypeSlots was called but is not implemented :("),0}function YL(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetUnitUserData was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function KL(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetUnitUserData was called but is not implemented :("),0}function zL(e,t){const n=(0,bp.Ye)(t,1);return(0,_p.lua_pushlightuserdata)(t,e.players[n]),1}function qL(e,t){return console.warn("GetLocalPlayer was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ZL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsPlayerAlly was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function jL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsPlayerEnemy was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function XL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsPlayerInForce was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function $L(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsPlayerObserver was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function JL(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("IsVisibleToPlayer was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function WL(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsLocationVisibleToPlayer was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function QL(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("IsFoggedToPlayer was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function eI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsLocationFoggedToPlayer was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function tI(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("IsMaskedToPlayer was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function nI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("IsLocationMaskedToPlayer was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function aI(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushlightuserdata)(t,n.race),1}function rI(e,t){const n=(0,_p.lua_touserdata)(t,1);return(0,_p.lua_pushinteger)(t,n.index),1}function iI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("GetPlayerUnitCount was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function sI(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,_p.lua_toboolean)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("GetPlayerTypedUnitCount was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function lI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("GetPlayerStructureCount was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function oI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("GetPlayerState was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function uI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("GetPlayerScore was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function cI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("GetPlayerAlliance was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function dI(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetPlayerHandicap was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function hI(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetPlayerHandicapXP was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function fI(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetPlayerHandicap was called but is not implemented :("),0}function mI(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetPlayerHandicapXP was called but is not implemented :("),0}function pI(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("SetPlayerTechMaxAllowed was called but is not implemented :("),0}function _I(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("GetPlayerTechMaxAllowed was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function gI(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("AddPlayerTechResearched was called but is not implemented :("),0}function bI(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("SetPlayerTechResearched was called but is not implemented :("),0}function wI(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("GetPlayerTechResearched was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function vI(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("GetPlayerTechCount was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function AI(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetPlayerUnitsOwner was called but is not implemented :("),0}function yI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("CripplePlayer was called but is not implemented :("),0}function SI(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetPlayerAbilityAvailable was called but is not implemented :("),0}function TI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.Ye)(t,3);return console.warn("SetPlayerState was called but is not implemented :("),0}function xI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("RemovePlayer was called but is not implemented :("),0}function EI(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("CachePlayerHeroData was called but is not implemented :("),0}function LI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("SetFogStateRect was called but is not implemented :("),0}function II(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,_p.lua_toboolean)(t,6);return console.warn("SetFogStateRadius was called but is not implemented :("),0}function UI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.qZ)(t,4),(0,_p.lua_toboolean)(t,5);return console.warn("SetFogStateRadiusLoc was called but is not implemented :("),0}function RI(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("FogMaskEnable was called but is not implemented :("),0}function MI(e,t){return console.warn("IsFogMaskEnabled was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function CI(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("FogEnable was called but is not implemented :("),0}function BI(e,t){return console.warn("IsFogEnabled was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function PI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,_p.lua_toboolean)(t,4),(0,_p.lua_toboolean)(t,5);return console.warn("CreateFogModifierRect was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function kI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,_p.lua_toboolean)(t,6),(0,_p.lua_toboolean)(t,7);return console.warn("CreateFogModifierRadius was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function OI(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.qZ)(t,4),(0,_p.lua_toboolean)(t,5),(0,_p.lua_toboolean)(t,6);return console.warn("CreateFogModifierRadiusLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function DI(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyFogModifier was called but is not implemented :("),0}function FI(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("FogModifierStart was called but is not implemented :("),0}function GI(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("FogModifierStop was called but is not implemented :("),0}function NI(e,t){return console.warn("VersionGet was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function VI(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("VersionCompatible was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function HI(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("VersionSupported was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function YI(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("EndGame was called but is not implemented :("),0}function KI(e,t){(0,bp.zH)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("ChangeLevel was called but is not implemented :("),0}function zI(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("RestartGame was called but is not implemented :("),0}function qI(e,t){return console.warn("ReloadGame was called but is not implemented :("),0}function ZI(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("SetCampaignMenuRace was called but is not implemented :("),0}function jI(e,t){(0,bp.Ye)(t,1);return console.warn("SetCampaignMenuRaceEx was called but is not implemented :("),0}function XI(e,t){return console.warn("ForceCampaignSelectScreen was called but is not implemented :("),0}function $I(e,t){(0,bp.zH)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("LoadGame was called but is not implemented :("),0}function JI(e,t){(0,bp.zH)(t,1);return console.warn("SaveGame was called but is not implemented :("),0}function WI(e,t){(0,bp.zH)(t,1),(0,bp.zH)(t,2);return console.warn("RenameSaveDirectory was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function QI(e,t){(0,bp.zH)(t,1);return console.warn("RemoveSaveDirectory was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function eU(e,t){(0,bp.zH)(t,1),(0,bp.zH)(t,2);return console.warn("CopySaveGame was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function tU(e,t){(0,bp.zH)(t,1);return console.warn("SaveGameExists was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function nU(e,t){return console.warn("SyncSelections was called but is not implemented :("),0}function aU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetFloatGameState was called but is not implemented :("),0}function rU(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetFloatGameState was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function iU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetIntegerGameState was called but is not implemented :("),0}function sU(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetIntegerGameState was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function lU(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("SetTutorialCleared was called but is not implemented :("),0}function oU(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetMissionAvailable was called but is not implemented :("),0}function uU(e,t){(0,bp.Ye)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetCampaignAvailable was called but is not implemented :("),0}function cU(e,t){(0,bp.Ye)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetOpCinematicAvailable was called but is not implemented :("),0}function dU(e,t){(0,bp.Ye)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetEdCinematicAvailable was called but is not implemented :("),0}function hU(e,t){return console.warn("GetDefaultDifficulty was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function fU(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("SetDefaultDifficulty was called but is not implemented :("),0}function mU(e,t){(0,bp.Ye)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetCustomCampaignButtonVisible was called but is not implemented :("),0}function pU(e,t){(0,bp.Ye)(t,1);return console.warn("GetCustomCampaignButtonVisible was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function _U(e,t){return console.warn("DoNotSaveReplay was called but is not implemented :("),0}function gU(e,t){return console.warn("DialogCreate was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function bU(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DialogDestroy was called but is not implemented :("),0}function wU(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DialogClear was called but is not implemented :("),0}function vU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("DialogSetMessage was called but is not implemented :("),0}function AU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.Ye)(t,3);return console.warn("DialogAddButton was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function yU(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.zH)(t,3),(0,bp.Ye)(t,4);return console.warn("DialogAddQuitButton was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function SU(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("DialogDisplay was called but is not implemented :("),0}function TU(e,t){return console.warn("ReloadGameCachesFromDisk was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function xU(e,t){(0,bp.zH)(t,1);return console.warn("InitGameCache was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function EU(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("SaveGameCache was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function LU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3),(0,bp.Ye)(t,4);return console.warn("StoreInteger was called but is not implemented :("),0}function IU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3),(0,bp.qZ)(t,4);return console.warn("StoreReal was called but is not implemented :("),0}function UU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("StoreBoolean was called but is not implemented :("),0}function RU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("StoreUnit was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function MU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3),(0,bp.zH)(t,4);return console.warn("StoreString was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function CU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("SyncStoredInteger was called but is not implemented :("),0}function BU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("SyncStoredReal was called but is not implemented :("),0}function PU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("SyncStoredBoolean was called but is not implemented :("),0}function kU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("SyncStoredUnit was called but is not implemented :("),0}function OU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("SyncStoredString was called but is not implemented :("),0}function DU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("HaveStoredInteger was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function FU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("HaveStoredReal was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function GU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("HaveStoredBoolean was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function NU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("HaveStoredUnit was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function VU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("HaveStoredString was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function HU(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("FlushGameCache was called but is not implemented :("),0}function YU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("FlushStoredMission was called but is not implemented :("),0}function KU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("FlushStoredInteger was called but is not implemented :("),0}function zU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("FlushStoredReal was called but is not implemented :("),0}function qU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("FlushStoredBoolean was called but is not implemented :("),0}function ZU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("FlushStoredUnit was called but is not implemented :("),0}function jU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("FlushStoredString was called but is not implemented :("),0}function XU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("GetStoredInteger was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function $U(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("GetStoredReal was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function JU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("GetStoredBoolean was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function WU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3);return console.warn("GetStoredString was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function QU(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.zH)(t,3),(0,_p.lua_touserdata)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6),(0,bp.qZ)(t,7);return console.warn("RestoreUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function eR(e,t){return console.warn("InitHashtable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function tR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4);return console.warn("SaveInteger was called but is not implemented :("),0}function nR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.qZ)(t,4);return console.warn("SaveReal was called but is not implemented :("),0}function aR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("SaveBoolean was called but is not implemented :("),0}function rR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.zH)(t,4);return console.warn("SaveStr was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function iR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SavePlayerHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function sR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveWidgetHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function lR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveDestructableHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function oR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveItemHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function uR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveUnitHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function cR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveAbilityHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function dR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveTimerHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function hR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveTriggerHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function fR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveTriggerConditionHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function mR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveTriggerActionHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function pR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveTriggerEventHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function _R(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveForceHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function gR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveGroupHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function bR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveLocationHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function wR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveRectHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function vR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveBooleanExprHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function AR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveSoundHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function yR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveEffectHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function SR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveUnitPoolHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function TR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveItemPoolHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function xR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveQuestHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function ER(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveQuestItemHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function LR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveDefeatConditionHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function IR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveTimerDialogHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function UR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveLeaderboardHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function RR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveMultiboardHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function MR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveMultiboardItemHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function CR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveTrackableHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function BR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveDialogHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function PR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveButtonHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function kR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveTextTagHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function OR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveLightningHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function DR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveImageHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function FR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveUbersplatHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function GR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveRegionHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function NR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveFogStateHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function VR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveFogModifierHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function HR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveAgentHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function YR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("SaveHashtableHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function KR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadInteger was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function zR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadReal was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function qR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadBoolean was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function ZR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadStr was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function jR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadPlayerHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function XR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadWidgetHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function $R(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadDestructableHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function JR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadItemHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function WR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadUnitHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function QR(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadAbilityHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function eM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadTimerHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function tM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadTriggerHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function nM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadTriggerConditionHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function aM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadTriggerActionHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function rM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadTriggerEventHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function iM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadForceHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function sM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadGroupHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function lM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadLocationHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function oM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadRectHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function uM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadBooleanExprHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function cM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadSoundHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function dM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadEffectHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function hM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadUnitPoolHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function fM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadItemPoolHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function mM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadQuestHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function pM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadQuestItemHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function _M(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadDefeatConditionHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function gM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadTimerDialogHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function bM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadLeaderboardHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function wM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadMultiboardHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function vM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadMultiboardItemHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function AM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadTrackableHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function yM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadDialogHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function SM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadButtonHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function TM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadTextTagHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function xM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadLightningHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function EM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadImageHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function LM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadUbersplatHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function IM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadRegionHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function UM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadFogStateHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function RM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadFogModifierHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function MM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LoadHashtableHandle was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function CM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("HaveSavedInteger was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function BM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("HaveSavedReal was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function PM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("HaveSavedBoolean was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function kM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("HaveSavedString was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function OM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("HaveSavedHandle was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function DM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("RemoveSavedInteger was called but is not implemented :("),0}function FM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("RemoveSavedReal was called but is not implemented :("),0}function GM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("RemoveSavedBoolean was called but is not implemented :("),0}function NM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("RemoveSavedString was called but is not implemented :("),0}function VM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("RemoveSavedHandle was called but is not implemented :("),0}function HM(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("FlushParentHashtable was called but is not implemented :("),0}function YM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("FlushChildHashtable was called but is not implemented :("),0}function KM(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("GetRandomInt was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function zM(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("GetRandomReal was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function qM(e,t){return console.warn("CreateUnitPool was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ZM(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyUnitPool was called but is not implemented :("),0}function jM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.qZ)(t,3);return console.warn("UnitPoolAddUnitType was called but is not implemented :("),0}function XM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("UnitPoolRemoveUnitType was called but is not implemented :("),0}function $M(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5);return console.warn("PlaceRandomUnit was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function JM(e,t){return console.warn("CreateItemPool was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function WM(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyItemPool was called but is not implemented :("),0}function QM(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.qZ)(t,3);return console.warn("ItemPoolAddItemType was called but is not implemented :("),0}function eC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("ItemPoolRemoveItemType was called but is not implemented :("),0}function tC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("PlaceRandomItem was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function nC(e,t){(0,bp.Ye)(t,1);return console.warn("ChooseRandomCreep was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function aC(e,t){return console.warn("ChooseRandomNPBuilding was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function rC(e,t){(0,bp.Ye)(t,1);return console.warn("ChooseRandomItem was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function iC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("ChooseRandomItemEx was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function sC(e,t){(0,bp.Ye)(t,1);return console.warn("SetRandomSeed was called but is not implemented :("),0}function lC(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5);return console.warn("SetTerrainFog was called but is not implemented :("),0}function oC(e,t){return console.warn("ResetTerrainFog was called but is not implemented :("),0}function uC(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5);return console.warn("SetUnitFog was called but is not implemented :("),0}function cC(e,t){(0,bp.Ye)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6),(0,bp.qZ)(t,7);return console.warn("SetTerrainFogEx was called but is not implemented :("),0}function dC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.zH)(t,4);return console.warn("DisplayTextToPlayer was called but is not implemented :("),0}function hC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.zH)(t,5);return console.warn("DisplayTimedTextToPlayer was called but is not implemented :("),0}function fC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.zH)(t,5);return console.warn("DisplayTimedTextFromPlayer was called but is not implemented :("),0}function mC(e,t){return console.warn("ClearTextMessages was called but is not implemented :("),0}function pC(e,t){(0,bp.zH)(t,1),(0,bp.zH)(t,2);return console.warn("SetDayNightModels was called but is not implemented :("),0}function _C(e,t){(0,bp.zH)(t,1);return console.warn("SetSkyModel was called but is not implemented :("),0}function gC(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("EnableUserControl was called but is not implemented :("),0}function bC(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("EnableUserUI was called but is not implemented :("),0}function wC(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("SuspendTimeOfDay was called but is not implemented :("),0}function vC(e,t){(0,bp.qZ)(t,1);return console.warn("SetTimeOfDayScale was called but is not implemented :("),0}function AC(e,t){return console.warn("GetTimeOfDayScale was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function yC(e,t){(0,_p.lua_toboolean)(t,1),(0,bp.qZ)(t,2);return console.warn("ShowInterface was called but is not implemented :("),0}function SC(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("PauseGame was called but is not implemented :("),0}function TC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("UnitAddIndicator was called but is not implemented :("),0}function xC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("AddIndicator was called but is not implemented :("),0}function EC(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("PingMinimap was called but is not implemented :("),0}function LC(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5),(0,bp.Ye)(t,6),(0,_p.lua_toboolean)(t,7);return console.warn("PingMinimapEx was called but is not implemented :("),0}function IC(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("EnableOcclusion was called but is not implemented :("),0}function UC(e,t){(0,bp.zH)(t,1);return console.warn("SetIntroShotText was called but is not implemented :("),0}function RC(e,t){(0,bp.zH)(t,1);return console.warn("SetIntroShotModel was called but is not implemented :("),0}function MC(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("EnableWorldFogBoundary was called but is not implemented :("),0}function CC(e,t){(0,bp.zH)(t,1);return console.warn("PlayModelCinematic was called but is not implemented :("),0}function BC(e,t){(0,bp.zH)(t,1);return console.warn("PlayCinematic was called but is not implemented :("),0}function PC(e,t){(0,bp.zH)(t,1);return console.warn("ForceUIKey was called but is not implemented :("),0}function kC(e,t){return console.warn("ForceUICancel was called but is not implemented :("),0}function OC(e,t){return console.warn("DisplayLoadDialog was called but is not implemented :("),0}function DC(e,t){(0,bp.zH)(t,1);return console.warn("SetAltMinimapIcon was called but is not implemented :("),0}function FC(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("DisableRestartMission was called but is not implemented :("),0}function GC(e,t){return console.warn("CreateTextTag was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function NC(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyTextTag was called but is not implemented :("),0}function VC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.qZ)(t,3);return console.warn("SetTextTagText was called but is not implemented :("),0}function HC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("SetTextTagPos was called but is not implemented :("),0}function YC(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3);return console.warn("SetTextTagPosUnit was called but is not implemented :("),0}function KC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("SetTextTagColor was called but is not implemented :("),0}function zC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("SetTextTagVelocity was called but is not implemented :("),0}function qC(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetTextTagVisibility was called but is not implemented :("),0}function ZC(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetTextTagSuspended was called but is not implemented :("),0}function jC(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetTextTagPermanent was called but is not implemented :("),0}function XC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetTextTagAge was called but is not implemented :("),0}function $C(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetTextTagLifespan was called but is not implemented :("),0}function JC(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetTextTagFadepoint was called but is not implemented :("),0}function WC(e,t){(0,bp.Ye)(t,1);return console.warn("SetReservedLocalHeroButtons was called but is not implemented :("),0}function QC(e,t){return console.warn("GetAllyColorFilterState was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function eB(e,t){(0,bp.Ye)(t,1);return console.warn("SetAllyColorFilterState was called but is not implemented :("),0}function tB(e,t){return console.warn("GetCreepCampFilterState was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function nB(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("SetCreepCampFilterState was called but is not implemented :("),0}function aB(e,t){(0,_p.lua_toboolean)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("EnableMinimapFilterButtons was called but is not implemented :("),0}function rB(e,t){(0,_p.lua_toboolean)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("EnableDragSelect was called but is not implemented :("),0}function iB(e,t){(0,_p.lua_toboolean)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("EnablePreSelect was called but is not implemented :("),0}function sB(e,t){(0,_p.lua_toboolean)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("EnableSelect was called but is not implemented :("),0}function lB(e,t){(0,bp.zH)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("CreateTrackable was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function oB(e,t){return console.warn("CreateQuest was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function uB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyQuest was called but is not implemented :("),0}function cB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("QuestSetTitle was called but is not implemented :("),0}function dB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("QuestSetDescription was called but is not implemented :("),0}function hB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("QuestSetIconPath was called but is not implemented :("),0}function fB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("QuestSetRequired was called but is not implemented :("),0}function mB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("QuestSetCompleted was called but is not implemented :("),0}function pB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("QuestSetDiscovered was called but is not implemented :("),0}function _B(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("QuestSetFailed was called but is not implemented :("),0}function gB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("QuestSetEnabled was called but is not implemented :("),0}function bB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsQuestRequired was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function wB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsQuestCompleted was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function vB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsQuestDiscovered was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function AB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsQuestFailed was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function yB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsQuestEnabled was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function SB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("QuestCreateItem was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function TB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("QuestItemSetDescription was called but is not implemented :("),0}function xB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("QuestItemSetCompleted was called but is not implemented :("),0}function EB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsQuestItemCompleted was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function LB(e,t){return console.warn("CreateDefeatCondition was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function IB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyDefeatCondition was called but is not implemented :("),0}function UB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("DefeatConditionSetDescription was called but is not implemented :("),0}function RB(e,t){return console.warn("FlashQuestDialogButton was called but is not implemented :("),0}function MB(e,t){return console.warn("ForceQuestDialogUpdate was called but is not implemented :("),0}function CB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("CreateTimerDialog was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function BB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyTimerDialog was called but is not implemented :("),0}function PB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("TimerDialogSetTitle was called but is not implemented :("),0}function kB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("TimerDialogSetTitleColor was called but is not implemented :("),0}function OB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("TimerDialogSetTimeColor was called but is not implemented :("),0}function DB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("TimerDialogSetSpeed was called but is not implemented :("),0}function FB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("TimerDialogDisplay was called but is not implemented :("),0}function GB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsTimerDialogDisplayed was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function NB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("TimerDialogSetRealTimeRemaining was called but is not implemented :("),0}function VB(e,t){return console.warn("CreateLeaderboard was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function HB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyLeaderboard was called but is not implemented :("),0}function YB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("LeaderboardDisplay was called but is not implemented :("),0}function KB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsLeaderboardDisplayed was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function zB(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("LeaderboardGetItemCount was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function qB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("LeaderboardSetSizeByItemCount was called but is not implemented :("),0}function ZB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2),(0,bp.Ye)(t,3),(0,_p.lua_touserdata)(t,4);return console.warn("LeaderboardAddItem was called but is not implemented :("),0}function jB(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("LeaderboardRemoveItem was called but is not implemented :("),0}function XB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("LeaderboardRemovePlayerItem was called but is not implemented :("),0}function $B(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("LeaderboardClear was called but is not implemented :("),0}function JB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("LeaderboardSortItemsByValue was called but is not implemented :("),0}function WB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("LeaderboardSortItemsByPlayer was called but is not implemented :("),0}function QB(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("LeaderboardSortItemsByLabel was called but is not implemented :("),0}function eP(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("LeaderboardHasPlayerItem was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function tP(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("LeaderboardGetPlayerIndex was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function nP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("LeaderboardSetLabel was called but is not implemented :("),0}function aP(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("LeaderboardGetLabelText was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function rP(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("PlayerSetLeaderboard was called but is not implemented :("),0}function iP(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("PlayerGetLeaderboard was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function sP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("LeaderboardSetLabelColor was called but is not implemented :("),0}function lP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("LeaderboardSetValueColor was called but is not implemented :("),0}function oP(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3),(0,_p.lua_toboolean)(t,4),(0,_p.lua_toboolean)(t,5);return console.warn("LeaderboardSetStyle was called but is not implemented :("),0}function uP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("LeaderboardSetItemValue was called but is not implemented :("),0}function cP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.zH)(t,3);return console.warn("LeaderboardSetItemLabel was called but is not implemented :("),0}function dP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3),(0,_p.lua_toboolean)(t,4),(0,_p.lua_toboolean)(t,5);return console.warn("LeaderboardSetItemStyle was called but is not implemented :("),0}function hP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5),(0,bp.Ye)(t,6);return console.warn("LeaderboardSetItemLabelColor was called but is not implemented :("),0}function fP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5),(0,bp.Ye)(t,6);return console.warn("LeaderboardSetItemValueColor was called but is not implemented :("),0}function mP(e,t){return console.warn("CreateMultiboard was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function pP(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyMultiboard was called but is not implemented :("),0}function _P(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("MultiboardDisplay was called but is not implemented :("),0}function gP(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsMultiboardDisplayed was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function bP(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("MultiboardMinimize was called but is not implemented :("),0}function wP(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("IsMultiboardMinimized was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function vP(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("MultiboardClear was called but is not implemented :("),0}function AP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("MultiboardSetTitleText was called but is not implemented :("),0}function yP(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("MultiboardGetTitleText was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function SP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("MultiboardSetTitleTextColor was called but is not implemented :("),0}function TP(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("MultiboardGetRowCount was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function xP(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("MultiboardGetColumnCount was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function EP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("MultiboardSetColumnCount was called but is not implemented :("),0}function LP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("MultiboardSetRowCount was called but is not implemented :("),0}function IP(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("MultiboardSetItemsStyle was called but is not implemented :("),0}function UP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("MultiboardSetItemsValue was called but is not implemented :("),0}function RP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("MultiboardSetItemsValueColor was called but is not implemented :("),0}function MP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("MultiboardSetItemsWidth was called but is not implemented :("),0}function CP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("MultiboardSetItemsIcon was called but is not implemented :("),0}function BP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("MultiboardGetItem was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function PP(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("MultiboardReleaseItem was called but is not implemented :("),0}function kP(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("MultiboardSetItemStyle was called but is not implemented :("),0}function OP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("MultiboardSetItemValue was called but is not implemented :("),0}function DP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("MultiboardSetItemValueColor was called but is not implemented :("),0}function FP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("MultiboardSetItemWidth was called but is not implemented :("),0}function GP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("MultiboardSetItemIcon was called but is not implemented :("),0}function NP(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("MultiboardSuppressDisplay was called but is not implemented :("),0}function VP(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("SetCameraPosition was called but is not implemented :("),0}function HP(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("SetCameraQuickPosition was called but is not implemented :("),0}function YP(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6),(0,bp.qZ)(t,7),(0,bp.qZ)(t,8);return console.warn("SetCameraBounds was called but is not implemented :("),0}function KP(e,t){return console.warn("StopCamera was called but is not implemented :("),0}function zP(e,t){(0,bp.qZ)(t,1);return console.warn("ResetToGameCamera was called but is not implemented :("),0}function qP(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("PanCameraTo was called but is not implemented :("),0}function ZP(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("PanCameraToTimed was called but is not implemented :("),0}function jP(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("PanCameraToWithZ was called but is not implemented :("),0}function XP(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("PanCameraToTimedWithZ was called but is not implemented :("),0}function $P(e,t){(0,bp.zH)(t,1);return console.warn("SetCinematicCamera was called but is not implemented :("),0}function JP(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("SetCameraRotateMode was called but is not implemented :("),0}function WP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("SetCameraField was called but is not implemented :("),0}function QP(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("AdjustCameraField was called but is not implemented :("),0}function ek(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("SetCameraTargetController was called but is not implemented :("),0}function tk(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("SetCameraOrientController was called but is not implemented :("),0}function nk(e,t){return console.warn("CreateCameraSetup was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ak(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("CameraSetupSetField was called but is not implemented :("),0}function rk(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("CameraSetupGetField was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function ik(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("CameraSetupSetDestPosition was called but is not implemented :("),0}function sk(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("CameraSetupGetDestPositionLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function lk(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("CameraSetupGetDestPositionX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function ok(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("CameraSetupGetDestPositionY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function uk(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("CameraSetupApply was called but is not implemented :("),0}function ck(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("CameraSetupApplyWithZ was called but is not implemented :("),0}function dk(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.qZ)(t,3);return console.warn("CameraSetupApplyForceDuration was called but is not implemented :("),0}function hk(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("CameraSetupApplyForceDurationWithZ was called but is not implemented :("),0}function fk(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("CameraSetTargetNoise was called but is not implemented :("),0}function mk(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("CameraSetSourceNoise was called but is not implemented :("),0}function pk(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("CameraSetTargetNoiseEx was called but is not implemented :("),0}function _k(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("CameraSetSourceNoiseEx was called but is not implemented :("),0}function gk(e,t){(0,bp.qZ)(t,1);return console.warn("CameraSetSmoothingFactor was called but is not implemented :("),0}function bk(e,t){(0,bp.zH)(t,1);return console.warn("SetCineFilterTexture was called but is not implemented :("),0}function wk(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("SetCineFilterBlendMode was called but is not implemented :("),0}function vk(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("SetCineFilterTexMapFlags was called but is not implemented :("),0}function Ak(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("SetCineFilterStartUV was called but is not implemented :("),0}function yk(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("SetCineFilterEndUV was called but is not implemented :("),0}function Sk(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4);return console.warn("SetCineFilterStartColor was called but is not implemented :("),0}function Tk(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4);return console.warn("SetCineFilterEndColor was called but is not implemented :("),0}function xk(e,t){(0,bp.qZ)(t,1);return console.warn("SetCineFilterDuration was called but is not implemented :("),0}function Ek(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("DisplayCineFilter was called but is not implemented :("),0}function Lk(e,t){return console.warn("IsCineFilterDisplayed was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function Ik(e,t){(0,bp.Ye)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.zH)(t,3),(0,bp.zH)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6);return console.warn("SetCinematicScene was called but is not implemented :("),0}function Uk(e,t){return console.warn("EndCinematicScene was called but is not implemented :("),0}function Rk(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("ForceCinematicSubtitles was called but is not implemented :("),0}function Mk(e,t){(0,bp.Ye)(t,1);return console.warn("GetCameraMargin was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Ck(e,t){return console.warn("GetCameraBoundMinX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Bk(e,t){return console.warn("GetCameraBoundMinY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Pk(e,t){return console.warn("GetCameraBoundMaxX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function kk(e,t){return console.warn("GetCameraBoundMaxY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Ok(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetCameraField was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Dk(e,t){return console.warn("GetCameraTargetPositionX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Fk(e,t){return console.warn("GetCameraTargetPositionY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Gk(e,t){return console.warn("GetCameraTargetPositionZ was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Nk(e,t){return console.warn("GetCameraTargetPositionLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Vk(e,t){return console.warn("GetCameraEyePositionX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Hk(e,t){return console.warn("GetCameraEyePositionY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Yk(e,t){return console.warn("GetCameraEyePositionZ was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function Kk(e,t){return console.warn("GetCameraEyePositionLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function zk(e,t){(0,bp.zH)(t,1);return console.warn("NewSoundEnvironment was called but is not implemented :("),0}function qk(e,t){(0,bp.zH)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3),(0,_p.lua_toboolean)(t,4),(0,bp.Ye)(t,5),(0,bp.Ye)(t,6),(0,bp.zH)(t,7);return console.warn("CreateSound was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Zk(e,t){(0,bp.zH)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3),(0,_p.lua_toboolean)(t,4),(0,bp.Ye)(t,5),(0,bp.Ye)(t,6),(0,bp.zH)(t,7);return console.warn("CreateSoundFilenameWithLabel was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function jk(e,t){(0,bp.zH)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3),(0,_p.lua_toboolean)(t,4),(0,bp.Ye)(t,5),(0,bp.Ye)(t,6);return console.warn("CreateSoundFromLabel was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function Xk(e,t){(0,bp.zH)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("CreateMIDISound was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function $k(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("SetSoundParamsFromLabel was called but is not implemented :("),0}function Jk(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetSoundDistanceCutoff was called but is not implemented :("),0}function Wk(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetSoundChannel was called but is not implemented :("),0}function Qk(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetSoundVolume was called but is not implemented :("),0}function eO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("SetSoundPitch was called but is not implemented :("),0}function tO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetSoundPlayPosition was called but is not implemented :("),0}function nO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("SetSoundDistances was called but is not implemented :("),0}function aO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.Ye)(t,4);return console.warn("SetSoundConeAngles was called but is not implemented :("),0}function rO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("SetSoundConeOrientation was called but is not implemented :("),0}function iO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("SetSoundPosition was called but is not implemented :("),0}function sO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("SetSoundVelocity was called but is not implemented :("),0}function lO(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("AttachSoundToUnit was called but is not implemented :("),0}function oO(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("StartSound was called but is not implemented :("),0}function uO(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("StopSound was called but is not implemented :("),0}function cO(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("KillSoundWhenDone was called but is not implemented :("),0}function dO(e,t){(0,bp.zH)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.Ye)(t,3);return console.warn("SetMapMusic was called but is not implemented :("),0}function hO(e,t){return console.warn("ClearMapMusic was called but is not implemented :("),0}function fO(e,t){(0,bp.zH)(t,1);return console.warn("PlayMusic was called but is not implemented :("),0}function mO(e,t){(0,bp.zH)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("PlayMusicEx was called but is not implemented :("),0}function pO(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("StopMusic was called but is not implemented :("),0}function _O(e,t){return console.warn("ResumeMusic was called but is not implemented :("),0}function gO(e,t){(0,bp.zH)(t,1);return console.warn("PlayThematicMusic was called but is not implemented :("),0}function bO(e,t){(0,bp.zH)(t,1),(0,bp.Ye)(t,2);return console.warn("PlayThematicMusicEx was called but is not implemented :("),0}function wO(e,t){return console.warn("EndThematicMusic was called but is not implemented :("),0}function vO(e,t){(0,bp.Ye)(t,1);return console.warn("SetMusicVolume was called but is not implemented :("),0}function AO(e,t){(0,bp.Ye)(t,1);return console.warn("SetMusicPlayPosition was called but is not implemented :("),0}function yO(e,t){(0,bp.Ye)(t,1);return console.warn("SetThematicMusicPlayPosition was called but is not implemented :("),0}function SO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetSoundDuration was called but is not implemented :("),0}function TO(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetSoundDuration was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function xO(e,t){(0,bp.zH)(t,1);return console.warn("GetSoundFileDuration was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function EO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("VolumeGroupSetVolume was called but is not implemented :("),0}function LO(e,t){return console.warn("VolumeGroupReset was called but is not implemented :("),0}function IO(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetSoundIsPlaying was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function UO(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetSoundIsLoading was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function RO(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("RegisterStackedSound was called but is not implemented :("),0}function MO(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("UnregisterStackedSound was called but is not implemented :("),0}function CO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("AddWeatherEffect was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function BO(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("RemoveWeatherEffect was called but is not implemented :("),0}function PO(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("EnableWeatherEffect was called but is not implemented :("),0}function kO(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.Ye)(t,5),(0,_p.lua_toboolean)(t,6);return console.warn("TerrainDeformCrater was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function OO(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.Ye)(t,5),(0,bp.Ye)(t,6),(0,bp.qZ)(t,7),(0,bp.qZ)(t,8),(0,bp.qZ)(t,9),(0,_p.lua_toboolean)(t,10);return console.warn("TerrainDeformRipple was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function DO(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6),(0,bp.qZ)(t,7),(0,bp.qZ)(t,8),(0,bp.Ye)(t,9),(0,bp.Ye)(t,10);return console.warn("TerrainDeformWave was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function FO(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.Ye)(t,6),(0,bp.Ye)(t,7);return console.warn("TerrainDeformRandom was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function GO(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("TerrainDeformStop was called but is not implemented :("),0}function NO(e,t){return console.warn("TerrainDeformStopAll was called but is not implemented :("),0}function VO(e,t){(0,bp.zH)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3);return console.warn("AddSpecialEffect was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function HO(e,t){(0,bp.zH)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("AddSpecialEffectLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function YO(e,t){(0,bp.zH)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.zH)(t,3);return console.warn("AddSpecialEffectTarget was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function KO(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyEffect was called but is not implemented :("),0}function zO(e,t){(0,bp.zH)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("AddSpellEffect was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function qO(e,t){(0,bp.zH)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("AddSpellEffectLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function ZO(e,t){(0,bp.Ye)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("AddSpellEffectById was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function jO(e,t){(0,bp.Ye)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("AddSpellEffectByIdLoc was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function XO(e,t){(0,bp.zH)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.zH)(t,4);return console.warn("AddSpellEffectTarget was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function $O(e,t){(0,bp.Ye)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_touserdata)(t,3),(0,bp.zH)(t,4);return console.warn("AddSpellEffectTargetById was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function JO(e,t){(0,bp.zH)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6);return console.warn("AddLightning was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function WO(e,t){(0,bp.zH)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6),(0,bp.qZ)(t,7),(0,bp.qZ)(t,8);return console.warn("AddLightningEx was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function QO(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyLightning was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function eD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6);return console.warn("MoveLightning was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function tD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6),(0,bp.qZ)(t,7),(0,bp.qZ)(t,8);return console.warn("MoveLightningEx was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function nD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetLightningColorA was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function aD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetLightningColorR was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function rD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetLightningColorG was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function iD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetLightningColorB was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function sD(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5);return console.warn("SetLightningColor was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function lD(e,t){(0,bp.zH)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.Ye)(t,3);return console.warn("GetAbilityEffect was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function oD(e,t){(0,bp.Ye)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.Ye)(t,3);return console.warn("GetAbilityEffectById was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function uD(e,t){(0,bp.zH)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("GetAbilitySound was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function cD(e,t){(0,bp.Ye)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("GetAbilitySoundById was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function dD(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("GetTerrainCliffLevel was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function hD(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4);return console.warn("SetWaterBaseColor was called but is not implemented :("),0}function fD(e,t){(0,_p.lua_toboolean)(t,1);return console.warn("SetWaterDeforms was called but is not implemented :("),0}function mD(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("GetTerrainType was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function pD(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("GetTerrainVariance was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function _D(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5),(0,bp.Ye)(t,6);return console.warn("SetTerrainType was called but is not implemented :("),0}function gD(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,_p.lua_touserdata)(t,3);return console.warn("IsTerrainPathable was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function bD(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,_p.lua_touserdata)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("SetTerrainPathable was called but is not implemented :("),0}function wD(e,t){(0,bp.zH)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,bp.qZ)(t,5),(0,bp.qZ)(t,6),(0,bp.qZ)(t,7),(0,bp.qZ)(t,8),(0,bp.qZ)(t,9),(0,bp.qZ)(t,10),(0,bp.Ye)(t,11);return console.warn("CreateImage was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function vD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyImage was called but is not implemented :("),0}function AD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("ShowImage was called but is not implemented :("),0}function yD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,bp.qZ)(t,3);return console.warn("SetImageConstantHeight was called but is not implemented :("),0}function SD(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("SetImagePosition was called but is not implemented :("),0}function TD(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5);return console.warn("SetImageColor was called but is not implemented :("),0}function xD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetImageRender was called but is not implemented :("),0}function ED(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetImageRenderAlways was called but is not implemented :("),0}function LD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetImageAboveWater was called but is not implemented :("),0}function ID(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("SetImageType was called but is not implemented :("),0}function UD(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.zH)(t,3),(0,bp.Ye)(t,4),(0,bp.Ye)(t,5),(0,bp.Ye)(t,6),(0,bp.Ye)(t,7),(0,_p.lua_toboolean)(t,8),(0,_p.lua_toboolean)(t,9);return console.warn("CreateUbersplat was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function RD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("DestroyUbersplat was called but is not implemented :("),0}function MD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("ResetUbersplat was called but is not implemented :("),0}function CD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("FinishUbersplat was called but is not implemented :("),0}function BD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("ShowUbersplat was called but is not implemented :("),0}function PD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetUbersplatRender was called but is not implemented :("),0}function kD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("SetUbersplatRenderAlways was called but is not implemented :("),0}function OD(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4),(0,_p.lua_toboolean)(t,5);return console.warn("SetBlight was called but is not implemented :("),0}function DD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("SetBlightRect was called but is not implemented :("),0}function FD(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("SetBlightPoint was called but is not implemented :("),0}function GD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2),(0,bp.qZ)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("SetBlightLoc was called but is not implemented :("),0}function ND(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("CreateBlightedGoldmine was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function VD(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2);return console.warn("IsPointBlighted was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function HD(e,t){(0,bp.qZ)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.Ye)(t,4),(0,_p.lua_toboolean)(t,5),(0,bp.zH)(t,6),(0,_p.lua_toboolean)(t,7);return console.warn("SetDoodadAnimation was called but is not implemented :("),0}function YD(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.zH)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("SetDoodadAnimationRect was called but is not implemented :("),0}function KD(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("StartMeleeAI was called but is not implemented :("),0}function zD(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("StartCampaignAI was called but is not implemented :("),0}function qD(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("CommandAI was called but is not implemented :("),0}function ZD(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_toboolean)(t,2);return console.warn("PauseCompAI was called but is not implemented :("),0}function jD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("GetAIDifficulty was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function XD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("RemoveGuardPosition was called but is not implemented :("),0}function $D(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("RecycleGuardPosition was called but is not implemented :("),0}function JD(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("RemoveAllGuardPositions was called but is not implemented :("),0}function WD(e,t){(0,bp.zH)(t,1);return console.warn("Cheat was called but is not implemented :("),0}function QD(e,t){return console.warn("IsNoVictoryCheat was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function eF(e,t){return console.warn("IsNoDefeatCheat was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function tF(e,t){(0,bp.zH)(t,1);return console.warn("Preload was called but is not implemented :("),0}function nF(e,t){(0,bp.qZ)(t,1);return console.warn("PreloadEnd was called but is not implemented :("),0}function aF(e,t){return console.warn("PreloadStart was called but is not implemented :("),0}function rF(e,t){return console.warn("PreloadRefresh was called but is not implemented :("),0}function iF(e,t){return console.warn("PreloadEndEx was called but is not implemented :("),0}function sF(e,t){return console.warn("PreloadGenClear was called but is not implemented :("),0}function lF(e,t){return console.warn("PreloadGenStart was called but is not implemented :("),0}function oF(e,t){(0,bp.zH)(t,1);return console.warn("PreloadGenEnd was called but is not implemented :("),0}function uF(e,t){(0,bp.zH)(t,1);return console.warn("Preloader was called but is not implemented :("),0}function cF(e,t){(0,bp.zH)(t,1);return console.warn("AutomationTestStart was called but is not implemented :("),0}function dF(e,t){(0,bp.zH)(t,1);return console.warn("AutomationTestEnd was called but is not implemented :("),0}function hF(e,t){return console.warn("BlzGetTriggerPlayerMouseX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function fF(e,t){return console.warn("BlzGetTriggerPlayerMouseY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function mF(e,t){return console.warn("BlzGetTriggerPlayerMousePosition was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function pF(e,t){return console.warn("BlzGetTriggerPlayerMouseButton was called but is not implemented :("),(0,_p.lua_pushlightuserdata)(t,{name:"FAKE"}),1}function _F(e,t){(0,bp.Ye)(t,1),(0,bp.zH)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzSetAbilityTooltip was called but is not implemented :("),0}function gF(e,t){(0,bp.Ye)(t,1),(0,bp.zH)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzSetAbilityActivatedTooltip was called but is not implemented :("),0}function bF(e,t){(0,bp.Ye)(t,1),(0,bp.zH)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzSetAbilityExtendedTooltip was called but is not implemented :("),0}function wF(e,t){(0,bp.Ye)(t,1),(0,bp.zH)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzSetAbilityActivatedExtendedTooltip was called but is not implemented :("),0}function vF(e,t){(0,bp.Ye)(t,1),(0,bp.zH)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzSetAbilityResearchTooltip was called but is not implemented :("),0}function AF(e,t){(0,bp.Ye)(t,1),(0,bp.zH)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzSetAbilityResearchExtendedTooltip was called but is not implemented :("),0}function yF(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetAbilityTooltip was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function SF(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetAbilityActivatedTooltip was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function TF(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetAbilityExtendedTooltip was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function xF(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetAbilityActivatedExtendedTooltip was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function EF(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetAbilityResearchTooltip was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function LF(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetAbilityResearchExtendedTooltip was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function IF(e,t){(0,bp.Ye)(t,1),(0,bp.zH)(t,2);return console.warn("BlzSetAbilityIcon was called but is not implemented :("),0}function UF(e,t){(0,bp.Ye)(t,1);return console.warn("BlzGetAbilityIcon was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function RF(e,t){(0,bp.Ye)(t,1),(0,bp.zH)(t,2);return console.warn("BlzSetAbilityActivatedIcon was called but is not implemented :("),0}function MF(e,t){(0,bp.Ye)(t,1);return console.warn("BlzGetAbilityActivatedIcon was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function CF(e,t){(0,bp.Ye)(t,1);return console.warn("BlzGetAbilityPosX was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function BF(e,t){(0,bp.Ye)(t,1);return console.warn("BlzGetAbilityPosY was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function PF(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzSetAbilityPosX was called but is not implemented :("),0}function kF(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzSetAbilityPosY was called but is not implemented :("),0}function OF(e,t){(0,bp.Ye)(t,1);return console.warn("BlzGetAbilityActivatedPosX was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function DF(e,t){(0,bp.Ye)(t,1);return console.warn("BlzGetAbilityActivatedPosY was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function FF(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzSetAbilityActivatedPosX was called but is not implemented :("),0}function GF(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzSetAbilityActivatedPosY was called but is not implemented :("),0}function NF(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetUnitMaxHP was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function VF(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzSetUnitMaxHP was called but is not implemented :("),0}function HF(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetUnitMaxMana was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function YF(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzSetUnitMaxMana was called but is not implemented :("),0}function KF(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzDeleteHeroAbility was called but is not implemented :("),0}function zF(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("BlzSetItemName was called but is not implemented :("),0}function qF(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("BlzSetItemDescription was called but is not implemented :("),0}function ZF(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetItemDescription was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function jF(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("BlzSetItemTooltip was called but is not implemented :("),0}function XF(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetItemTooltip was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function $F(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("BlzSetItemExtendedTooltip was called but is not implemented :("),0}function JF(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetItemExtendedTooltip was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function WF(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("BlzSetItemIconPath was called but is not implemented :("),0}function QF(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetItemIconPath was called but is not implemented :("),(0,_p.lua_pushstring)(t,""),1}function eG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("BlzSetUnitName was called but is not implemented :("),0}function tG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.zH)(t,2);return console.warn("BlzSetHeroProperName was called but is not implemented :("),0}function nG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetUnitBaseDamage was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function aG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzSetUnitBaseDamage was called but is not implemented :("),0}function rG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetUnitDiceNumber was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function iG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzSetUnitDiceNumber was called but is not implemented :("),0}function sG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetUnitDiceSides was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function lG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzSetUnitDiceSides was called but is not implemented :("),0}function oG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetUnitAttackCooldown was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function uG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzSetUnitAttackCooldown was called but is not implemented :("),0}function cG(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("BlzSetSpecialEffectColorByPlayer was called but is not implemented :("),0}function dG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4);return console.warn("BlzSetSpecialEffectColor was called but is not implemented :("),0}function hG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzSetSpecialEffectAlpha was called but is not implemented :("),0}function fG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetSpecialEffectScale was called but is not implemented :("),0}function mG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("BlzSetSpecialEffectPosition was called but is not implemented :("),0}function pG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetSpecialEffectHeight was called but is not implemented :("),0}function _G(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetSpecialEffectTimeScale was called but is not implemented :("),0}function gG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetSpecialEffectTime was called but is not implemented :("),0}function bG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2),(0,bp.qZ)(t,3),(0,bp.qZ)(t,4);return console.warn("BlzSetSpecialEffectOrientation was called but is not implemented :("),0}function wG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetSpecialEffectYaw was called but is not implemented :("),0}function vG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetSpecialEffectPitch was called but is not implemented :("),0}function AG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetSpecialEffectRoll was called but is not implemented :("),0}function yG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetSpecialEffectX was called but is not implemented :("),0}function SG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetSpecialEffectY was called but is not implemented :("),0}function TG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetSpecialEffectZ was called but is not implemented :("),0}function xG(e,t){(0,_p.lua_touserdata)(t,1),(0,_p.lua_touserdata)(t,2);return console.warn("BlzSetSpecialEffectPositionLoc was called but is not implemented :("),0}function EG(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetLocalSpecialEffectX was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function LG(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetLocalSpecialEffectY was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function IG(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetLocalSpecialEffectZ was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function UG(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetUnitArmor was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function RG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.qZ)(t,2);return console.warn("BlzSetUnitArmor was called but is not implemented :("),0}function MG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3);return console.warn("BlzUnitHideAbility was called but is not implemented :("),0}function CG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,_p.lua_toboolean)(t,3),(0,_p.lua_toboolean)(t,4);return console.warn("BlzUnitDisableAbility was called but is not implemented :("),0}function BG(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzUnitCancelTimedLife was called but is not implemented :("),0}function PG(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzIsUnitSelectable was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function kG(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzIsUnitInvulnerable was called but is not implemented :("),(0,_p.lua_pushboolean)(t,!1),1}function OG(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzUnitInterruptAttack was called but is not implemented :("),0}function DG(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetUnitCollisionSize was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function FG(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetAbilityManaCost was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function GG(e,t){(0,bp.Ye)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetAbilityCooldown was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function NG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.qZ)(t,4);return console.warn("BlzSetUnitAbilityCooldown was called but is not implemented :("),0}function VG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzGetUnitAbilityCooldown was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function HG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzGetUnitAbilityCooldownRemaining was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function YG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2);return console.warn("BlzEndUnitAbilityCooldown was called but is not implemented :("),0}function KG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzGetUnitAbilityManaCost was called but is not implemented :("),(0,_p.lua_pushinteger)(t,0),1}function zG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3),(0,bp.Ye)(t,4);return console.warn("BlzSetUnitAbilityManaCost was called but is not implemented :("),0}function qG(e,t){(0,_p.lua_touserdata)(t,1);return console.warn("BlzGetLocalUnitZ was called but is not implemented :("),(0,_p.lua_pushnumber)(t,0),1}function ZG(e,t){(0,_p.lua_touserdata)(t,1),(0,bp.Ye)(t,2),(0,bp.Ye)(t,3);return console.warn("BlzDecPlayerTechResearched was called but is not implemented :("),0}function jG(e,t){(0,bp.qZ)(t,1);return console.warn("BlzSetEventDamage was called but is not implemented :("),0}function XG(e){const t=e.L;(0,_p.lua_register)(t,"ConvertRace",U_.bind(null,e)),(0,_p.lua_register)(t,"ConvertAllianceType",R_.bind(null,e)),(0,_p.lua_register)(t,"ConvertRacePref",M_.bind(null,e)),(0,_p.lua_register)(t,"ConvertIGameState",C_.bind(null,e)),(0,_p.lua_register)(t,"ConvertFGameState",B_.bind(null,e)),(0,_p.lua_register)(t,"ConvertPlayerState",P_.bind(null,e)),(0,_p.lua_register)(t,"ConvertPlayerScore",k_.bind(null,e)),(0,_p.lua_register)(t,"ConvertPlayerGameResult",O_.bind(null,e)),(0,_p.lua_register)(t,"ConvertUnitState",D_.bind(null,e)),(0,_p.lua_register)(t,"ConvertAIDifficulty",F_.bind(null,e)),(0,_p.lua_register)(t,"ConvertGameEvent",G_.bind(null,e)),(0,_p.lua_register)(t,"ConvertPlayerEvent",N_.bind(null,e)),(0,_p.lua_register)(t,"ConvertPlayerUnitEvent",V_.bind(null,e)),(0,_p.lua_register)(t,"ConvertWidgetEvent",H_.bind(null,e)),(0,_p.lua_register)(t,"ConvertDialogEvent",Y_.bind(null,e)),(0,_p.lua_register)(t,"ConvertUnitEvent",K_.bind(null,e)),(0,_p.lua_register)(t,"ConvertLimitOp",z_.bind(null,e)),(0,_p.lua_register)(t,"ConvertUnitType",q_.bind(null,e)),(0,_p.lua_register)(t,"ConvertGameSpeed",Z_.bind(null,e)),(0,_p.lua_register)(t,"ConvertPlacement",j_.bind(null,e)),(0,_p.lua_register)(t,"ConvertStartLocPrio",X_.bind(null,e)),(0,_p.lua_register)(t,"ConvertGameDifficulty",$_.bind(null,e)),(0,_p.lua_register)(t,"ConvertGameType",J_.bind(null,e)),(0,_p.lua_register)(t,"ConvertMapFlag",W_.bind(null,e)),(0,_p.lua_register)(t,"ConvertMapVisibility",Q_.bind(null,e)),(0,_p.lua_register)(t,"ConvertMapSetting",eg.bind(null,e)),(0,_p.lua_register)(t,"ConvertMapDensity",tg.bind(null,e)),(0,_p.lua_register)(t,"ConvertMapControl",ng.bind(null,e)),(0,_p.lua_register)(t,"ConvertPlayerColor",ag.bind(null,e)),(0,_p.lua_register)(t,"ConvertPlayerSlotState",rg.bind(null,e)),(0,_p.lua_register)(t,"ConvertVolumeGroup",ig.bind(null,e)),(0,_p.lua_register)(t,"ConvertCameraField",sg.bind(null,e)),(0,_p.lua_register)(t,"ConvertBlendMode",lg.bind(null,e)),(0,_p.lua_register)(t,"ConvertRarityControl",og.bind(null,e)),(0,_p.lua_register)(t,"ConvertTexMapFlags",ug.bind(null,e)),(0,_p.lua_register)(t,"ConvertFogState",cg.bind(null,e)),(0,_p.lua_register)(t,"ConvertEffectType",dg.bind(null,e)),(0,_p.lua_register)(t,"ConvertVersion",hg.bind(null,e)),(0,_p.lua_register)(t,"ConvertItemType",fg.bind(null,e)),(0,_p.lua_register)(t,"ConvertAttackType",mg.bind(null,e)),(0,_p.lua_register)(t,"ConvertDamageType",pg.bind(null,e)),(0,_p.lua_register)(t,"ConvertWeaponType",_g.bind(null,e)),(0,_p.lua_register)(t,"ConvertSoundType",gg.bind(null,e)),(0,_p.lua_register)(t,"ConvertPathingType",bg.bind(null,e)),(0,_p.lua_register)(t,"ConvertMouseButtonType",wg.bind(null,e)),(0,_p.lua_register)(t,"ConvertAnimType",vg.bind(null,e)),(0,_p.lua_register)(t,"ConvertSubAnimType",Ag.bind(null,e)),(0,_p.lua_register)(t,"OrderId",yg.bind(null,e)),(0,_p.lua_register)(t,"OrderId2String",Sg.bind(null,e)),(0,_p.lua_register)(t,"UnitId",Tg.bind(null,e)),(0,_p.lua_register)(t,"UnitId2String",xg.bind(null,e)),(0,_p.lua_register)(t,"AbilityId",Eg.bind(null,e)),(0,_p.lua_register)(t,"AbilityId2String",Lg.bind(null,e)),(0,_p.lua_register)(t,"GetObjectName",Ig.bind(null,e)),(0,_p.lua_register)(t,"GetBJMaxPlayers",Ug.bind(null,e)),(0,_p.lua_register)(t,"GetBJPlayerNeutralVictim",Rg.bind(null,e)),(0,_p.lua_register)(t,"GetBJPlayerNeutralExtra",Mg.bind(null,e)),(0,_p.lua_register)(t,"GetBJMaxPlayerSlots",Cg.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerNeutralPassive",Bg.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerNeutralAggressive",Pg.bind(null,e)),(0,_p.lua_register)(t,"Deg2Rad",kg.bind(null,e)),(0,_p.lua_register)(t,"Rad2Deg",Og.bind(null,e)),(0,_p.lua_register)(t,"Sin",Dg.bind(null,e)),(0,_p.lua_register)(t,"Cos",Fg.bind(null,e)),(0,_p.lua_register)(t,"Tan",Gg.bind(null,e)),(0,_p.lua_register)(t,"Asin",Ng.bind(null,e)),(0,_p.lua_register)(t,"Acos",Vg.bind(null,e)),(0,_p.lua_register)(t,"Atan",Hg.bind(null,e)),(0,_p.lua_register)(t,"Atan2",Yg.bind(null,e)),(0,_p.lua_register)(t,"SquareRoot",Kg.bind(null,e)),(0,_p.lua_register)(t,"Pow",zg.bind(null,e)),(0,_p.lua_register)(t,"I2R",qg.bind(null,e)),(0,_p.lua_register)(t,"R2I",Zg.bind(null,e)),(0,_p.lua_register)(t,"I2S",jg.bind(null,e)),(0,_p.lua_register)(t,"R2S",Xg.bind(null,e)),(0,_p.lua_register)(t,"R2SW",$g.bind(null,e)),(0,_p.lua_register)(t,"S2I",Jg.bind(null,e)),(0,_p.lua_register)(t,"S2R",Wg.bind(null,e)),(0,_p.lua_register)(t,"GetHandleId",Qg.bind(null,e)),(0,_p.lua_register)(t,"SubString",eb.bind(null,e)),(0,_p.lua_register)(t,"StringLength",tb.bind(null,e)),(0,_p.lua_register)(t,"StringCase",nb.bind(null,e)),(0,_p.lua_register)(t,"StringHash",ab.bind(null,e)),(0,_p.lua_register)(t,"GetLocalizedString",rb.bind(null,e)),(0,_p.lua_register)(t,"GetLocalizedHotkey",ib.bind(null,e)),(0,_p.lua_register)(t,"SetMapName",sb.bind(null,e)),(0,_p.lua_register)(t,"SetMapDescription",lb.bind(null,e)),(0,_p.lua_register)(t,"SetTeams",ob.bind(null,e)),(0,_p.lua_register)(t,"SetPlayers",ub.bind(null,e)),(0,_p.lua_register)(t,"DefineStartLocation",cb.bind(null,e)),(0,_p.lua_register)(t,"DefineStartLocationLoc",db.bind(null,e)),(0,_p.lua_register)(t,"SetStartLocPrioCount",hb.bind(null,e)),(0,_p.lua_register)(t,"SetStartLocPrio",fb.bind(null,e)),(0,_p.lua_register)(t,"GetStartLocPrioSlot",mb.bind(null,e)),(0,_p.lua_register)(t,"GetStartLocPrio",pb.bind(null,e)),(0,_p.lua_register)(t,"SetGameTypeSupported",_b.bind(null,e)),(0,_p.lua_register)(t,"SetMapFlag",gb.bind(null,e)),(0,_p.lua_register)(t,"SetGamePlacement",bb.bind(null,e)),(0,_p.lua_register)(t,"SetGameSpeed",wb.bind(null,e)),(0,_p.lua_register)(t,"SetGameDifficulty",vb.bind(null,e)),(0,_p.lua_register)(t,"SetResourceDensity",Ab.bind(null,e)),(0,_p.lua_register)(t,"SetCreatureDensity",yb.bind(null,e)),(0,_p.lua_register)(t,"GetTeams",Sb.bind(null,e)),(0,_p.lua_register)(t,"GetPlayers",Tb.bind(null,e)),(0,_p.lua_register)(t,"IsGameTypeSupported",xb.bind(null,e)),(0,_p.lua_register)(t,"GetGameTypeSelected",Eb.bind(null,e)),(0,_p.lua_register)(t,"IsMapFlagSet",Lb.bind(null,e)),(0,_p.lua_register)(t,"GetGamePlacement",Ib.bind(null,e)),(0,_p.lua_register)(t,"GetGameSpeed",Ub.bind(null,e)),(0,_p.lua_register)(t,"GetGameDifficulty",Rb.bind(null,e)),(0,_p.lua_register)(t,"GetResourceDensity",Mb.bind(null,e)),(0,_p.lua_register)(t,"GetCreatureDensity",Cb.bind(null,e)),(0,_p.lua_register)(t,"GetStartLocationX",Bb.bind(null,e)),(0,_p.lua_register)(t,"GetStartLocationY",Pb.bind(null,e)),(0,_p.lua_register)(t,"GetStartLocationLoc",kb.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerTeam",Ob.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerStartLocation",Db.bind(null,e)),(0,_p.lua_register)(t,"ForcePlayerStartLocation",Fb.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerColor",Gb.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerAlliance",Nb.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerTaxRate",Vb.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerRacePreference",Hb.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerRaceSelectable",Yb.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerController",Kb.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerName",zb.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerOnScoreScreen",qb.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerTeam",Zb.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerStartLocation",jb.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerColor",Xb.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerSelectable",$b.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerController",Jb.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerSlotState",Wb.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerTaxRate",Qb.bind(null,e)),(0,_p.lua_register)(t,"IsPlayerRacePrefSet",ew.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerName",tw.bind(null,e)),(0,_p.lua_register)(t,"CreateTimer",nw.bind(null,e)),(0,_p.lua_register)(t,"DestroyTimer",aw.bind(null,e)),(0,_p.lua_register)(t,"TimerStart",rw.bind(null,e)),(0,_p.lua_register)(t,"TimerGetElapsed",iw.bind(null,e)),(0,_p.lua_register)(t,"TimerGetRemaining",sw.bind(null,e)),(0,_p.lua_register)(t,"TimerGetTimeout",lw.bind(null,e)),(0,_p.lua_register)(t,"PauseTimer",ow.bind(null,e)),(0,_p.lua_register)(t,"ResumeTimer",uw.bind(null,e)),(0,_p.lua_register)(t,"GetExpiredTimer",cw.bind(null,e)),(0,_p.lua_register)(t,"CreateGroup",dw.bind(null,e)),(0,_p.lua_register)(t,"DestroyGroup",hw.bind(null,e)),(0,_p.lua_register)(t,"GroupAddUnit",fw.bind(null,e)),(0,_p.lua_register)(t,"GroupRemoveUnit",mw.bind(null,e)),(0,_p.lua_register)(t,"GroupClear",pw.bind(null,e)),(0,_p.lua_register)(t,"GroupEnumUnitsOfType",_w.bind(null,e)),(0,_p.lua_register)(t,"GroupEnumUnitsOfPlayer",gw.bind(null,e)),(0,_p.lua_register)(t,"GroupEnumUnitsOfTypeCounted",bw.bind(null,e)),(0,_p.lua_register)(t,"GroupEnumUnitsInRect",ww.bind(null,e)),(0,_p.lua_register)(t,"GroupEnumUnitsInRectCounted",vw.bind(null,e)),(0,_p.lua_register)(t,"GroupEnumUnitsInRange",Aw.bind(null,e)),(0,_p.lua_register)(t,"GroupEnumUnitsInRangeOfLoc",yw.bind(null,e)),(0,_p.lua_register)(t,"GroupEnumUnitsInRangeCounted",Sw.bind(null,e)),(0,_p.lua_register)(t,"GroupEnumUnitsInRangeOfLocCounted",Tw.bind(null,e)),(0,_p.lua_register)(t,"GroupEnumUnitsSelected",xw.bind(null,e)),(0,_p.lua_register)(t,"GroupImmediateOrder",Ew.bind(null,e)),(0,_p.lua_register)(t,"GroupImmediateOrderById",Lw.bind(null,e)),(0,_p.lua_register)(t,"GroupPointOrder",Iw.bind(null,e)),(0,_p.lua_register)(t,"GroupPointOrderLoc",Uw.bind(null,e)),(0,_p.lua_register)(t,"GroupPointOrderById",Rw.bind(null,e)),(0,_p.lua_register)(t,"GroupPointOrderByIdLoc",Mw.bind(null,e)),(0,_p.lua_register)(t,"GroupTargetOrder",Cw.bind(null,e)),(0,_p.lua_register)(t,"GroupTargetOrderById",Bw.bind(null,e)),(0,_p.lua_register)(t,"ForGroup",Pw.bind(null,e)),(0,_p.lua_register)(t,"FirstOfGroup",kw.bind(null,e)),(0,_p.lua_register)(t,"CreateForce",Ow.bind(null,e)),(0,_p.lua_register)(t,"DestroyForce",Dw.bind(null,e)),(0,_p.lua_register)(t,"ForceAddPlayer",Fw.bind(null,e)),(0,_p.lua_register)(t,"ForceRemovePlayer",Gw.bind(null,e)),(0,_p.lua_register)(t,"ForceClear",Nw.bind(null,e)),(0,_p.lua_register)(t,"ForceEnumPlayers",Vw.bind(null,e)),(0,_p.lua_register)(t,"ForceEnumPlayersCounted",Hw.bind(null,e)),(0,_p.lua_register)(t,"ForceEnumAllies",Yw.bind(null,e)),(0,_p.lua_register)(t,"ForceEnumEnemies",Kw.bind(null,e)),(0,_p.lua_register)(t,"ForForce",zw.bind(null,e)),(0,_p.lua_register)(t,"Rect",qw.bind(null,e)),(0,_p.lua_register)(t,"RectFromLoc",Zw.bind(null,e)),(0,_p.lua_register)(t,"RemoveRect",jw.bind(null,e)),(0,_p.lua_register)(t,"SetRect",Xw.bind(null,e)),(0,_p.lua_register)(t,"SetRectFromLoc",$w.bind(null,e)),(0,_p.lua_register)(t,"MoveRectTo",Jw.bind(null,e)),(0,_p.lua_register)(t,"MoveRectToLoc",Ww.bind(null,e)),(0,_p.lua_register)(t,"GetRectCenterX",Qw.bind(null,e)),(0,_p.lua_register)(t,"GetRectCenterY",ev.bind(null,e)),(0,_p.lua_register)(t,"GetRectMinX",tv.bind(null,e)),(0,_p.lua_register)(t,"GetRectMinY",nv.bind(null,e)),(0,_p.lua_register)(t,"GetRectMaxX",av.bind(null,e)),(0,_p.lua_register)(t,"GetRectMaxY",rv.bind(null,e)),(0,_p.lua_register)(t,"CreateRegion",iv.bind(null,e)),(0,_p.lua_register)(t,"RemoveRegion",sv.bind(null,e)),(0,_p.lua_register)(t,"RegionAddRect",lv.bind(null,e)),(0,_p.lua_register)(t,"RegionClearRect",ov.bind(null,e)),(0,_p.lua_register)(t,"RegionAddCell",uv.bind(null,e)),(0,_p.lua_register)(t,"RegionAddCellAtLoc",cv.bind(null,e)),(0,_p.lua_register)(t,"RegionClearCell",dv.bind(null,e)),(0,_p.lua_register)(t,"RegionClearCellAtLoc",hv.bind(null,e)),(0,_p.lua_register)(t,"Location",fv.bind(null,e)),(0,_p.lua_register)(t,"RemoveLocation",mv.bind(null,e)),(0,_p.lua_register)(t,"MoveLocation",pv.bind(null,e)),(0,_p.lua_register)(t,"GetLocationX",_v.bind(null,e)),(0,_p.lua_register)(t,"GetLocationY",gv.bind(null,e)),(0,_p.lua_register)(t,"GetLocationZ",bv.bind(null,e)),(0,_p.lua_register)(t,"IsUnitInRegion",wv.bind(null,e)),(0,_p.lua_register)(t,"IsPointInRegion",vv.bind(null,e)),(0,_p.lua_register)(t,"IsLocationInRegion",Av.bind(null,e)),(0,_p.lua_register)(t,"GetWorldBounds",yv.bind(null,e)),(0,_p.lua_register)(t,"CreateTrigger",Sv.bind(null,e)),(0,_p.lua_register)(t,"DestroyTrigger",Tv.bind(null,e)),(0,_p.lua_register)(t,"ResetTrigger",xv.bind(null,e)),(0,_p.lua_register)(t,"EnableTrigger",Ev.bind(null,e)),(0,_p.lua_register)(t,"DisableTrigger",Lv.bind(null,e)),(0,_p.lua_register)(t,"IsTriggerEnabled",Iv.bind(null,e)),(0,_p.lua_register)(t,"TriggerWaitOnSleeps",Uv.bind(null,e)),(0,_p.lua_register)(t,"IsTriggerWaitOnSleeps",Rv.bind(null,e)),(0,_p.lua_register)(t,"GetFilterUnit",Mv.bind(null,e)),(0,_p.lua_register)(t,"GetEnumUnit",Cv.bind(null,e)),(0,_p.lua_register)(t,"GetFilterDestructable",Bv.bind(null,e)),(0,_p.lua_register)(t,"GetEnumDestructable",Pv.bind(null,e)),(0,_p.lua_register)(t,"GetFilterItem",kv.bind(null,e)),(0,_p.lua_register)(t,"GetEnumItem",Ov.bind(null,e)),(0,_p.lua_register)(t,"GetFilterPlayer",Dv.bind(null,e)),(0,_p.lua_register)(t,"GetEnumPlayer",Fv.bind(null,e)),(0,_p.lua_register)(t,"GetTriggeringTrigger",Gv.bind(null,e)),(0,_p.lua_register)(t,"GetTriggerEventId",Nv.bind(null,e)),(0,_p.lua_register)(t,"GetTriggerEvalCount",Vv.bind(null,e)),(0,_p.lua_register)(t,"GetTriggerExecCount",Hv.bind(null,e)),(0,_p.lua_register)(t,"ExecuteFunc",Yv.bind(null,e)),(0,_p.lua_register)(t,"And",Kv.bind(null,e)),(0,_p.lua_register)(t,"Or",zv.bind(null,e)),(0,_p.lua_register)(t,"Not",qv.bind(null,e)),(0,_p.lua_register)(t,"Condition",Zv.bind(null,e)),(0,_p.lua_register)(t,"DestroyCondition",jv.bind(null,e)),(0,_p.lua_register)(t,"Filter",Xv.bind(null,e)),(0,_p.lua_register)(t,"DestroyFilter",$v.bind(null,e)),(0,_p.lua_register)(t,"DestroyBoolExpr",Jv.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterVariableEvent",Wv.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterTimerEvent",Qv.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterTimerExpireEvent",eA.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterGameStateEvent",tA.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterDialogEvent",nA.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterDialogButtonEvent",aA.bind(null,e)),(0,_p.lua_register)(t,"GetEventGameState",rA.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterGameEvent",iA.bind(null,e)),(0,_p.lua_register)(t,"GetWinningPlayer",sA.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterEnterRegion",lA.bind(null,e)),(0,_p.lua_register)(t,"GetTriggeringRegion",oA.bind(null,e)),(0,_p.lua_register)(t,"GetEnteringUnit",uA.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterLeaveRegion",cA.bind(null,e)),(0,_p.lua_register)(t,"GetLeavingUnit",dA.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterTrackableHitEvent",hA.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterTrackableTrackEvent",fA.bind(null,e)),(0,_p.lua_register)(t,"GetTriggeringTrackable",mA.bind(null,e)),(0,_p.lua_register)(t,"GetClickedButton",pA.bind(null,e)),(0,_p.lua_register)(t,"GetClickedDialog",_A.bind(null,e)),(0,_p.lua_register)(t,"GetTournamentFinishSoonTimeRemaining",gA.bind(null,e)),(0,_p.lua_register)(t,"GetTournamentFinishNowRule",bA.bind(null,e)),(0,_p.lua_register)(t,"GetTournamentFinishNowPlayer",wA.bind(null,e)),(0,_p.lua_register)(t,"GetTournamentScore",vA.bind(null,e)),(0,_p.lua_register)(t,"GetSaveBasicFilename",AA.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterPlayerEvent",yA.bind(null,e)),(0,_p.lua_register)(t,"GetTriggerPlayer",SA.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterPlayerUnitEvent",TA.bind(null,e)),(0,_p.lua_register)(t,"GetLevelingUnit",xA.bind(null,e)),(0,_p.lua_register)(t,"GetLearningUnit",EA.bind(null,e)),(0,_p.lua_register)(t,"GetLearnedSkill",LA.bind(null,e)),(0,_p.lua_register)(t,"GetLearnedSkillLevel",IA.bind(null,e)),(0,_p.lua_register)(t,"GetRevivableUnit",UA.bind(null,e)),(0,_p.lua_register)(t,"GetRevivingUnit",RA.bind(null,e)),(0,_p.lua_register)(t,"GetAttacker",MA.bind(null,e)),(0,_p.lua_register)(t,"GetRescuer",CA.bind(null,e)),(0,_p.lua_register)(t,"GetDyingUnit",BA.bind(null,e)),(0,_p.lua_register)(t,"GetKillingUnit",PA.bind(null,e)),(0,_p.lua_register)(t,"GetDecayingUnit",kA.bind(null,e)),(0,_p.lua_register)(t,"GetConstructingStructure",OA.bind(null,e)),(0,_p.lua_register)(t,"GetCancelledStructure",DA.bind(null,e)),(0,_p.lua_register)(t,"GetConstructedStructure",FA.bind(null,e)),(0,_p.lua_register)(t,"GetResearchingUnit",GA.bind(null,e)),(0,_p.lua_register)(t,"GetResearched",NA.bind(null,e)),(0,_p.lua_register)(t,"GetTrainedUnitType",VA.bind(null,e)),(0,_p.lua_register)(t,"GetTrainedUnit",HA.bind(null,e)),(0,_p.lua_register)(t,"GetDetectedUnit",YA.bind(null,e)),(0,_p.lua_register)(t,"GetSummoningUnit",KA.bind(null,e)),(0,_p.lua_register)(t,"GetSummonedUnit",zA.bind(null,e)),(0,_p.lua_register)(t,"GetTransportUnit",qA.bind(null,e)),(0,_p.lua_register)(t,"GetLoadedUnit",ZA.bind(null,e)),(0,_p.lua_register)(t,"GetSellingUnit",jA.bind(null,e)),(0,_p.lua_register)(t,"GetSoldUnit",XA.bind(null,e)),(0,_p.lua_register)(t,"GetBuyingUnit",$A.bind(null,e)),(0,_p.lua_register)(t,"GetSoldItem",JA.bind(null,e)),(0,_p.lua_register)(t,"GetChangingUnit",WA.bind(null,e)),(0,_p.lua_register)(t,"GetChangingUnitPrevOwner",QA.bind(null,e)),(0,_p.lua_register)(t,"GetManipulatingUnit",ey.bind(null,e)),(0,_p.lua_register)(t,"GetManipulatedItem",ty.bind(null,e)),(0,_p.lua_register)(t,"GetOrderedUnit",ny.bind(null,e)),(0,_p.lua_register)(t,"GetIssuedOrderId",ay.bind(null,e)),(0,_p.lua_register)(t,"GetOrderPointX",ry.bind(null,e)),(0,_p.lua_register)(t,"GetOrderPointY",iy.bind(null,e)),(0,_p.lua_register)(t,"GetOrderPointLoc",sy.bind(null,e)),(0,_p.lua_register)(t,"GetOrderTarget",ly.bind(null,e)),(0,_p.lua_register)(t,"GetOrderTargetDestructable",oy.bind(null,e)),(0,_p.lua_register)(t,"GetOrderTargetItem",uy.bind(null,e)),(0,_p.lua_register)(t,"GetOrderTargetUnit",cy.bind(null,e)),(0,_p.lua_register)(t,"GetSpellAbilityUnit",dy.bind(null,e)),(0,_p.lua_register)(t,"GetSpellAbilityId",hy.bind(null,e)),(0,_p.lua_register)(t,"GetSpellAbility",fy.bind(null,e)),(0,_p.lua_register)(t,"GetSpellTargetLoc",my.bind(null,e)),(0,_p.lua_register)(t,"GetSpellTargetX",py.bind(null,e)),(0,_p.lua_register)(t,"GetSpellTargetY",_y.bind(null,e)),(0,_p.lua_register)(t,"GetSpellTargetDestructable",gy.bind(null,e)),(0,_p.lua_register)(t,"GetSpellTargetItem",by.bind(null,e)),(0,_p.lua_register)(t,"GetSpellTargetUnit",wy.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterPlayerAllianceChange",vy.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterPlayerStateEvent",Ay.bind(null,e)),(0,_p.lua_register)(t,"GetEventPlayerState",yy.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterPlayerChatEvent",Sy.bind(null,e)),(0,_p.lua_register)(t,"GetEventPlayerChatString",Ty.bind(null,e)),(0,_p.lua_register)(t,"GetEventPlayerChatStringMatched",xy.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterDeathEvent",Ey.bind(null,e)),(0,_p.lua_register)(t,"GetTriggerUnit",Ly.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterUnitStateEvent",Iy.bind(null,e)),(0,_p.lua_register)(t,"GetEventUnitState",Uy.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterUnitEvent",Ry.bind(null,e)),(0,_p.lua_register)(t,"GetEventDamage",My.bind(null,e)),(0,_p.lua_register)(t,"GetEventDamageSource",Cy.bind(null,e)),(0,_p.lua_register)(t,"GetEventDetectingPlayer",By.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterFilterUnitEvent",Py.bind(null,e)),(0,_p.lua_register)(t,"GetEventTargetUnit",ky.bind(null,e)),(0,_p.lua_register)(t,"TriggerRegisterUnitInRange",Oy.bind(null,e)),(0,_p.lua_register)(t,"TriggerAddCondition",Dy.bind(null,e)),(0,_p.lua_register)(t,"TriggerRemoveCondition",Fy.bind(null,e)),(0,_p.lua_register)(t,"TriggerClearConditions",Gy.bind(null,e)),(0,_p.lua_register)(t,"TriggerAddAction",Ny.bind(null,e)),(0,_p.lua_register)(t,"TriggerRemoveAction",Vy.bind(null,e)),(0,_p.lua_register)(t,"TriggerClearActions",Hy.bind(null,e)),(0,_p.lua_register)(t,"TriggerSleepAction",Yy.bind(null,e)),(0,_p.lua_register)(t,"TriggerWaitForSound",Ky.bind(null,e)),(0,_p.lua_register)(t,"TriggerEvaluate",zy.bind(null,e)),(0,_p.lua_register)(t,"TriggerExecute",qy.bind(null,e)),(0,_p.lua_register)(t,"TriggerExecuteWait",Zy.bind(null,e)),(0,_p.lua_register)(t,"TriggerSyncStart",jy.bind(null,e)),(0,_p.lua_register)(t,"TriggerSyncReady",Xy.bind(null,e)),(0,_p.lua_register)(t,"GetWidgetLife",$y.bind(null,e)),(0,_p.lua_register)(t,"SetWidgetLife",Jy.bind(null,e)),(0,_p.lua_register)(t,"GetWidgetX",Wy.bind(null,e)),(0,_p.lua_register)(t,"GetWidgetY",Qy.bind(null,e)),(0,_p.lua_register)(t,"GetTriggerWidget",eS.bind(null,e)),(0,_p.lua_register)(t,"CreateDestructable",tS.bind(null,e)),(0,_p.lua_register)(t,"CreateDestructableZ",nS.bind(null,e)),(0,_p.lua_register)(t,"CreateDeadDestructable",aS.bind(null,e)),(0,_p.lua_register)(t,"CreateDeadDestructableZ",rS.bind(null,e)),(0,_p.lua_register)(t,"RemoveDestructable",iS.bind(null,e)),(0,_p.lua_register)(t,"KillDestructable",sS.bind(null,e)),(0,_p.lua_register)(t,"SetDestructableInvulnerable",lS.bind(null,e)),(0,_p.lua_register)(t,"IsDestructableInvulnerable",oS.bind(null,e)),(0,_p.lua_register)(t,"EnumDestructablesInRect",uS.bind(null,e)),(0,_p.lua_register)(t,"GetDestructableTypeId",cS.bind(null,e)),(0,_p.lua_register)(t,"GetDestructableX",dS.bind(null,e)),(0,_p.lua_register)(t,"GetDestructableY",hS.bind(null,e)),(0,_p.lua_register)(t,"SetDestructableLife",fS.bind(null,e)),(0,_p.lua_register)(t,"GetDestructableLife",mS.bind(null,e)),(0,_p.lua_register)(t,"SetDestructableMaxLife",pS.bind(null,e)),(0,_p.lua_register)(t,"GetDestructableMaxLife",_S.bind(null,e)),(0,_p.lua_register)(t,"DestructableRestoreLife",gS.bind(null,e)),(0,_p.lua_register)(t,"QueueDestructableAnimation",bS.bind(null,e)),(0,_p.lua_register)(t,"SetDestructableAnimation",wS.bind(null,e)),(0,_p.lua_register)(t,"SetDestructableAnimationSpeed",vS.bind(null,e)),(0,_p.lua_register)(t,"ShowDestructable",AS.bind(null,e)),(0,_p.lua_register)(t,"GetDestructableOccluderHeight",yS.bind(null,e)),(0,_p.lua_register)(t,"SetDestructableOccluderHeight",SS.bind(null,e)),(0,_p.lua_register)(t,"GetDestructableName",TS.bind(null,e)),(0,_p.lua_register)(t,"GetTriggerDestructable",xS.bind(null,e)),(0,_p.lua_register)(t,"CreateItem",ES.bind(null,e)),(0,_p.lua_register)(t,"RemoveItem",LS.bind(null,e)),(0,_p.lua_register)(t,"GetItemPlayer",IS.bind(null,e)),(0,_p.lua_register)(t,"GetItemTypeId",US.bind(null,e)),(0,_p.lua_register)(t,"GetItemX",RS.bind(null,e)),(0,_p.lua_register)(t,"GetItemY",MS.bind(null,e)),(0,_p.lua_register)(t,"SetItemPosition",CS.bind(null,e)),(0,_p.lua_register)(t,"SetItemDropOnDeath",BS.bind(null,e)),(0,_p.lua_register)(t,"SetItemDroppable",PS.bind(null,e)),(0,_p.lua_register)(t,"SetItemPawnable",kS.bind(null,e)),(0,_p.lua_register)(t,"SetItemPlayer",OS.bind(null,e)),(0,_p.lua_register)(t,"SetItemInvulnerable",DS.bind(null,e)),(0,_p.lua_register)(t,"IsItemInvulnerable",FS.bind(null,e)),(0,_p.lua_register)(t,"SetItemVisible",GS.bind(null,e)),(0,_p.lua_register)(t,"IsItemVisible",NS.bind(null,e)),(0,_p.lua_register)(t,"IsItemOwned",VS.bind(null,e)),(0,_p.lua_register)(t,"IsItemPowerup",HS.bind(null,e)),(0,_p.lua_register)(t,"IsItemSellable",YS.bind(null,e)),(0,_p.lua_register)(t,"IsItemPawnable",KS.bind(null,e)),(0,_p.lua_register)(t,"IsItemIdPowerup",zS.bind(null,e)),(0,_p.lua_register)(t,"IsItemIdSellable",qS.bind(null,e)),(0,_p.lua_register)(t,"IsItemIdPawnable",ZS.bind(null,e)),(0,_p.lua_register)(t,"EnumItemsInRect",jS.bind(null,e)),(0,_p.lua_register)(t,"GetItemLevel",XS.bind(null,e)),(0,_p.lua_register)(t,"GetItemType",$S.bind(null,e)),(0,_p.lua_register)(t,"SetItemDropID",JS.bind(null,e)),(0,_p.lua_register)(t,"GetItemName",WS.bind(null,e)),(0,_p.lua_register)(t,"GetItemCharges",QS.bind(null,e)),(0,_p.lua_register)(t,"SetItemCharges",eT.bind(null,e)),(0,_p.lua_register)(t,"GetItemUserData",tT.bind(null,e)),(0,_p.lua_register)(t,"SetItemUserData",nT.bind(null,e)),(0,_p.lua_register)(t,"CreateUnit",aT.bind(null,e)),(0,_p.lua_register)(t,"CreateUnitByName",rT.bind(null,e)),(0,_p.lua_register)(t,"CreateUnitAtLoc",iT.bind(null,e)),(0,_p.lua_register)(t,"CreateUnitAtLocByName",sT.bind(null,e)),(0,_p.lua_register)(t,"CreateCorpse",lT.bind(null,e)),(0,_p.lua_register)(t,"KillUnit",oT.bind(null,e)),(0,_p.lua_register)(t,"RemoveUnit",uT.bind(null,e)),(0,_p.lua_register)(t,"ShowUnit",cT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitState",dT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitX",hT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitY",fT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitPosition",mT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitPositionLoc",pT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitFacing",_T.bind(null,e)),(0,_p.lua_register)(t,"SetUnitFacingTimed",gT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitMoveSpeed",bT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitFlyHeight",wT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitTurnSpeed",vT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitPropWindow",AT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitAcquireRange",yT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitCreepGuard",ST.bind(null,e)),(0,_p.lua_register)(t,"GetUnitAcquireRange",TT.bind(null,e)),(0,_p.lua_register)(t,"GetUnitTurnSpeed",xT.bind(null,e)),(0,_p.lua_register)(t,"GetUnitPropWindow",ET.bind(null,e)),(0,_p.lua_register)(t,"GetUnitFlyHeight",LT.bind(null,e)),(0,_p.lua_register)(t,"GetUnitDefaultAcquireRange",IT.bind(null,e)),(0,_p.lua_register)(t,"GetUnitDefaultTurnSpeed",UT.bind(null,e)),(0,_p.lua_register)(t,"GetUnitDefaultPropWindow",RT.bind(null,e)),(0,_p.lua_register)(t,"GetUnitDefaultFlyHeight",MT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitOwner",CT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitColor",BT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitScale",PT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitTimeScale",kT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitBlendTime",OT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitVertexColor",DT.bind(null,e)),(0,_p.lua_register)(t,"QueueUnitAnimation",FT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitAnimation",GT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitAnimationByIndex",NT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitAnimationWithRarity",VT.bind(null,e)),(0,_p.lua_register)(t,"AddUnitAnimationProperties",HT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitLookAt",YT.bind(null,e)),(0,_p.lua_register)(t,"ResetUnitLookAt",KT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitRescuable",zT.bind(null,e)),(0,_p.lua_register)(t,"SetUnitRescueRange",qT.bind(null,e)),(0,_p.lua_register)(t,"SetHeroStr",ZT.bind(null,e)),(0,_p.lua_register)(t,"SetHeroAgi",jT.bind(null,e)),(0,_p.lua_register)(t,"SetHeroInt",XT.bind(null,e)),(0,_p.lua_register)(t,"GetHeroStr",$T.bind(null,e)),(0,_p.lua_register)(t,"GetHeroAgi",JT.bind(null,e)),(0,_p.lua_register)(t,"GetHeroInt",WT.bind(null,e)),(0,_p.lua_register)(t,"UnitStripHeroLevel",QT.bind(null,e)),(0,_p.lua_register)(t,"GetHeroXP",ex.bind(null,e)),(0,_p.lua_register)(t,"SetHeroXP",tx.bind(null,e)),(0,_p.lua_register)(t,"GetHeroSkillPoints",nx.bind(null,e)),(0,_p.lua_register)(t,"UnitModifySkillPoints",ax.bind(null,e)),(0,_p.lua_register)(t,"AddHeroXP",rx.bind(null,e)),(0,_p.lua_register)(t,"SetHeroLevel",ix.bind(null,e)),(0,_p.lua_register)(t,"GetHeroLevel",sx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitLevel",lx.bind(null,e)),(0,_p.lua_register)(t,"GetHeroProperName",ox.bind(null,e)),(0,_p.lua_register)(t,"SuspendHeroXP",ux.bind(null,e)),(0,_p.lua_register)(t,"IsSuspendedXP",cx.bind(null,e)),(0,_p.lua_register)(t,"SelectHeroSkill",dx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitAbilityLevel",hx.bind(null,e)),(0,_p.lua_register)(t,"DecUnitAbilityLevel",fx.bind(null,e)),(0,_p.lua_register)(t,"IncUnitAbilityLevel",mx.bind(null,e)),(0,_p.lua_register)(t,"SetUnitAbilityLevel",px.bind(null,e)),(0,_p.lua_register)(t,"ReviveHero",_x.bind(null,e)),(0,_p.lua_register)(t,"ReviveHeroLoc",gx.bind(null,e)),(0,_p.lua_register)(t,"SetUnitExploded",bx.bind(null,e)),(0,_p.lua_register)(t,"SetUnitInvulnerable",wx.bind(null,e)),(0,_p.lua_register)(t,"PauseUnit",vx.bind(null,e)),(0,_p.lua_register)(t,"IsUnitPaused",Ax.bind(null,e)),(0,_p.lua_register)(t,"SetUnitPathing",yx.bind(null,e)),(0,_p.lua_register)(t,"ClearSelection",Sx.bind(null,e)),(0,_p.lua_register)(t,"SelectUnit",Tx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitPointValue",xx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitPointValueByType",Ex.bind(null,e)),(0,_p.lua_register)(t,"UnitAddItem",Lx.bind(null,e)),(0,_p.lua_register)(t,"UnitAddItemById",Ix.bind(null,e)),(0,_p.lua_register)(t,"UnitAddItemToSlotById",Ux.bind(null,e)),(0,_p.lua_register)(t,"UnitRemoveItem",Rx.bind(null,e)),(0,_p.lua_register)(t,"UnitRemoveItemFromSlot",Mx.bind(null,e)),(0,_p.lua_register)(t,"UnitHasItem",Cx.bind(null,e)),(0,_p.lua_register)(t,"UnitItemInSlot",Bx.bind(null,e)),(0,_p.lua_register)(t,"UnitInventorySize",Px.bind(null,e)),(0,_p.lua_register)(t,"UnitDropItemPoint",kx.bind(null,e)),(0,_p.lua_register)(t,"UnitDropItemSlot",Ox.bind(null,e)),(0,_p.lua_register)(t,"UnitDropItemTarget",Dx.bind(null,e)),(0,_p.lua_register)(t,"UnitUseItem",Fx.bind(null,e)),(0,_p.lua_register)(t,"UnitUseItemPoint",Gx.bind(null,e)),(0,_p.lua_register)(t,"UnitUseItemTarget",Nx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitX",Vx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitY",Hx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitLoc",Yx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitFacing",Kx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitMoveSpeed",zx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitDefaultMoveSpeed",qx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitState",Zx.bind(null,e)),(0,_p.lua_register)(t,"GetOwningPlayer",jx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitTypeId",Xx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitRace",$x.bind(null,e)),(0,_p.lua_register)(t,"GetUnitName",Jx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitFoodUsed",Wx.bind(null,e)),(0,_p.lua_register)(t,"GetUnitFoodMade",Qx.bind(null,e)),(0,_p.lua_register)(t,"GetFoodMade",eE.bind(null,e)),(0,_p.lua_register)(t,"GetFoodUsed",tE.bind(null,e)),(0,_p.lua_register)(t,"SetUnitUseFood",nE.bind(null,e)),(0,_p.lua_register)(t,"GetUnitRallyPoint",aE.bind(null,e)),(0,_p.lua_register)(t,"GetUnitRallyUnit",rE.bind(null,e)),(0,_p.lua_register)(t,"GetUnitRallyDestructable",iE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitInGroup",sE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitInForce",lE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitOwnedByPlayer",oE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitAlly",uE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitEnemy",cE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitVisible",dE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitDetected",hE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitInvisible",fE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitFogged",mE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitMasked",pE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitSelected",_E.bind(null,e)),(0,_p.lua_register)(t,"IsUnitRace",gE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitType",bE.bind(null,e)),(0,_p.lua_register)(t,"IsUnit",wE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitInRange",vE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitInRangeXY",AE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitInRangeLoc",yE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitHidden",SE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitIllusion",TE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitInTransport",xE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitLoaded",EE.bind(null,e)),(0,_p.lua_register)(t,"IsHeroUnitId",LE.bind(null,e)),(0,_p.lua_register)(t,"IsUnitIdType",IE.bind(null,e)),(0,_p.lua_register)(t,"UnitShareVision",UE.bind(null,e)),(0,_p.lua_register)(t,"UnitSuspendDecay",RE.bind(null,e)),(0,_p.lua_register)(t,"UnitAddType",ME.bind(null,e)),(0,_p.lua_register)(t,"UnitRemoveType",CE.bind(null,e)),(0,_p.lua_register)(t,"UnitAddAbility",BE.bind(null,e)),(0,_p.lua_register)(t,"UnitRemoveAbility",PE.bind(null,e)),(0,_p.lua_register)(t,"UnitMakeAbilityPermanent",kE.bind(null,e)),(0,_p.lua_register)(t,"UnitRemoveBuffs",OE.bind(null,e)),(0,_p.lua_register)(t,"UnitRemoveBuffsEx",DE.bind(null,e)),(0,_p.lua_register)(t,"UnitHasBuffsEx",FE.bind(null,e)),(0,_p.lua_register)(t,"UnitCountBuffsEx",GE.bind(null,e)),(0,_p.lua_register)(t,"UnitAddSleep",NE.bind(null,e)),(0,_p.lua_register)(t,"UnitCanSleep",VE.bind(null,e)),(0,_p.lua_register)(t,"UnitAddSleepPerm",HE.bind(null,e)),(0,_p.lua_register)(t,"UnitCanSleepPerm",YE.bind(null,e)),(0,_p.lua_register)(t,"UnitIsSleeping",KE.bind(null,e)),(0,_p.lua_register)(t,"UnitWakeUp",zE.bind(null,e)),(0,_p.lua_register)(t,"UnitApplyTimedLife",qE.bind(null,e)),(0,_p.lua_register)(t,"UnitIgnoreAlarm",ZE.bind(null,e)),(0,_p.lua_register)(t,"UnitIgnoreAlarmToggled",jE.bind(null,e)),(0,_p.lua_register)(t,"UnitResetCooldown",XE.bind(null,e)),(0,_p.lua_register)(t,"UnitSetConstructionProgress",$E.bind(null,e)),(0,_p.lua_register)(t,"UnitSetUpgradeProgress",JE.bind(null,e)),(0,_p.lua_register)(t,"UnitPauseTimedLife",WE.bind(null,e)),(0,_p.lua_register)(t,"UnitSetUsesAltIcon",QE.bind(null,e)),(0,_p.lua_register)(t,"UnitDamagePoint",eL.bind(null,e)),(0,_p.lua_register)(t,"UnitDamageTarget",tL.bind(null,e)),(0,_p.lua_register)(t,"IssueImmediateOrder",nL.bind(null,e)),(0,_p.lua_register)(t,"IssueImmediateOrderById",aL.bind(null,e)),(0,_p.lua_register)(t,"IssuePointOrder",rL.bind(null,e)),(0,_p.lua_register)(t,"IssuePointOrderLoc",iL.bind(null,e)),(0,_p.lua_register)(t,"IssuePointOrderById",sL.bind(null,e)),(0,_p.lua_register)(t,"IssuePointOrderByIdLoc",lL.bind(null,e)),(0,_p.lua_register)(t,"IssueTargetOrder",oL.bind(null,e)),(0,_p.lua_register)(t,"IssueTargetOrderById",uL.bind(null,e)),(0,_p.lua_register)(t,"IssueInstantPointOrder",cL.bind(null,e)),(0,_p.lua_register)(t,"IssueInstantPointOrderById",dL.bind(null,e)),(0,_p.lua_register)(t,"IssueInstantTargetOrder",hL.bind(null,e)),(0,_p.lua_register)(t,"IssueInstantTargetOrderById",fL.bind(null,e)),(0,_p.lua_register)(t,"IssueBuildOrder",mL.bind(null,e)),(0,_p.lua_register)(t,"IssueBuildOrderById",pL.bind(null,e)),(0,_p.lua_register)(t,"IssueNeutralImmediateOrder",_L.bind(null,e)),(0,_p.lua_register)(t,"IssueNeutralImmediateOrderById",gL.bind(null,e)),(0,_p.lua_register)(t,"IssueNeutralPointOrder",bL.bind(null,e)),(0,_p.lua_register)(t,"IssueNeutralPointOrderById",wL.bind(null,e)),(0,_p.lua_register)(t,"IssueNeutralTargetOrder",vL.bind(null,e)),(0,_p.lua_register)(t,"IssueNeutralTargetOrderById",AL.bind(null,e)),(0,_p.lua_register)(t,"GetUnitCurrentOrder",yL.bind(null,e)),(0,_p.lua_register)(t,"SetResourceAmount",SL.bind(null,e)),(0,_p.lua_register)(t,"AddResourceAmount",TL.bind(null,e)),(0,_p.lua_register)(t,"GetResourceAmount",xL.bind(null,e)),(0,_p.lua_register)(t,"WaygateGetDestinationX",EL.bind(null,e)),(0,_p.lua_register)(t,"WaygateGetDestinationY",LL.bind(null,e)),(0,_p.lua_register)(t,"WaygateSetDestination",IL.bind(null,e)),(0,_p.lua_register)(t,"WaygateActivate",UL.bind(null,e)),(0,_p.lua_register)(t,"WaygateIsActive",RL.bind(null,e)),(0,_p.lua_register)(t,"AddItemToAllStock",ML.bind(null,e)),(0,_p.lua_register)(t,"AddItemToStock",CL.bind(null,e)),(0,_p.lua_register)(t,"AddUnitToAllStock",BL.bind(null,e)),(0,_p.lua_register)(t,"AddUnitToStock",PL.bind(null,e)),(0,_p.lua_register)(t,"RemoveItemFromAllStock",kL.bind(null,e)),(0,_p.lua_register)(t,"RemoveItemFromStock",OL.bind(null,e)),(0,_p.lua_register)(t,"RemoveUnitFromAllStock",DL.bind(null,e)),(0,_p.lua_register)(t,"RemoveUnitFromStock",FL.bind(null,e)),(0,_p.lua_register)(t,"SetAllItemTypeSlots",GL.bind(null,e)),(0,_p.lua_register)(t,"SetAllUnitTypeSlots",NL.bind(null,e)),(0,_p.lua_register)(t,"SetItemTypeSlots",VL.bind(null,e)),(0,_p.lua_register)(t,"SetUnitTypeSlots",HL.bind(null,e)),(0,_p.lua_register)(t,"GetUnitUserData",YL.bind(null,e)),(0,_p.lua_register)(t,"SetUnitUserData",KL.bind(null,e)),(0,_p.lua_register)(t,"Player",zL.bind(null,e)),(0,_p.lua_register)(t,"GetLocalPlayer",qL.bind(null,e)),(0,_p.lua_register)(t,"IsPlayerAlly",ZL.bind(null,e)),(0,_p.lua_register)(t,"IsPlayerEnemy",jL.bind(null,e)),(0,_p.lua_register)(t,"IsPlayerInForce",XL.bind(null,e)),(0,_p.lua_register)(t,"IsPlayerObserver",$L.bind(null,e)),(0,_p.lua_register)(t,"IsVisibleToPlayer",JL.bind(null,e)),(0,_p.lua_register)(t,"IsLocationVisibleToPlayer",WL.bind(null,e)),(0,_p.lua_register)(t,"IsFoggedToPlayer",QL.bind(null,e)),(0,_p.lua_register)(t,"IsLocationFoggedToPlayer",eI.bind(null,e)),(0,_p.lua_register)(t,"IsMaskedToPlayer",tI.bind(null,e)),(0,_p.lua_register)(t,"IsLocationMaskedToPlayer",nI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerRace",aI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerId",rI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerUnitCount",iI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerTypedUnitCount",sI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerStructureCount",lI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerState",oI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerScore",uI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerAlliance",cI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerHandicap",dI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerHandicapXP",hI.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerHandicap",fI.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerHandicapXP",mI.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerTechMaxAllowed",pI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerTechMaxAllowed",_I.bind(null,e)),(0,_p.lua_register)(t,"AddPlayerTechResearched",gI.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerTechResearched",bI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerTechResearched",wI.bind(null,e)),(0,_p.lua_register)(t,"GetPlayerTechCount",vI.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerUnitsOwner",AI.bind(null,e)),(0,_p.lua_register)(t,"CripplePlayer",yI.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerAbilityAvailable",SI.bind(null,e)),(0,_p.lua_register)(t,"SetPlayerState",TI.bind(null,e)),(0,_p.lua_register)(t,"RemovePlayer",xI.bind(null,e)),(0,_p.lua_register)(t,"CachePlayerHeroData",EI.bind(null,e)),(0,_p.lua_register)(t,"SetFogStateRect",LI.bind(null,e)),(0,_p.lua_register)(t,"SetFogStateRadius",II.bind(null,e)),(0,_p.lua_register)(t,"SetFogStateRadiusLoc",UI.bind(null,e)),(0,_p.lua_register)(t,"FogMaskEnable",RI.bind(null,e)),(0,_p.lua_register)(t,"IsFogMaskEnabled",MI.bind(null,e)),(0,_p.lua_register)(t,"FogEnable",CI.bind(null,e)),(0,_p.lua_register)(t,"IsFogEnabled",BI.bind(null,e)),(0,_p.lua_register)(t,"CreateFogModifierRect",PI.bind(null,e)),(0,_p.lua_register)(t,"CreateFogModifierRadius",kI.bind(null,e)),(0,_p.lua_register)(t,"CreateFogModifierRadiusLoc",OI.bind(null,e)),(0,_p.lua_register)(t,"DestroyFogModifier",DI.bind(null,e)),(0,_p.lua_register)(t,"FogModifierStart",FI.bind(null,e)),(0,_p.lua_register)(t,"FogModifierStop",GI.bind(null,e)),(0,_p.lua_register)(t,"VersionGet",NI.bind(null,e)),(0,_p.lua_register)(t,"VersionCompatible",VI.bind(null,e)),(0,_p.lua_register)(t,"VersionSupported",HI.bind(null,e)),(0,_p.lua_register)(t,"EndGame",YI.bind(null,e)),(0,_p.lua_register)(t,"ChangeLevel",KI.bind(null,e)),(0,_p.lua_register)(t,"RestartGame",zI.bind(null,e)),(0,_p.lua_register)(t,"ReloadGame",qI.bind(null,e)),(0,_p.lua_register)(t,"SetCampaignMenuRace",ZI.bind(null,e)),(0,_p.lua_register)(t,"SetCampaignMenuRaceEx",jI.bind(null,e)),(0,_p.lua_register)(t,"ForceCampaignSelectScreen",XI.bind(null,e)),(0,_p.lua_register)(t,"LoadGame",$I.bind(null,e)),(0,_p.lua_register)(t,"SaveGame",JI.bind(null,e)),(0,_p.lua_register)(t,"RenameSaveDirectory",WI.bind(null,e)),(0,_p.lua_register)(t,"RemoveSaveDirectory",QI.bind(null,e)),(0,_p.lua_register)(t,"CopySaveGame",eU.bind(null,e)),(0,_p.lua_register)(t,"SaveGameExists",tU.bind(null,e)),(0,_p.lua_register)(t,"SyncSelections",nU.bind(null,e)),(0,_p.lua_register)(t,"SetFloatGameState",aU.bind(null,e)),(0,_p.lua_register)(t,"GetFloatGameState",rU.bind(null,e)),(0,_p.lua_register)(t,"SetIntegerGameState",iU.bind(null,e)),(0,_p.lua_register)(t,"GetIntegerGameState",sU.bind(null,e)),(0,_p.lua_register)(t,"SetTutorialCleared",lU.bind(null,e)),(0,_p.lua_register)(t,"SetMissionAvailable",oU.bind(null,e)),(0,_p.lua_register)(t,"SetCampaignAvailable",uU.bind(null,e)),(0,_p.lua_register)(t,"SetOpCinematicAvailable",cU.bind(null,e)),(0,_p.lua_register)(t,"SetEdCinematicAvailable",dU.bind(null,e)),(0,_p.lua_register)(t,"GetDefaultDifficulty",hU.bind(null,e)),(0,_p.lua_register)(t,"SetDefaultDifficulty",fU.bind(null,e)),(0,_p.lua_register)(t,"SetCustomCampaignButtonVisible",mU.bind(null,e)),(0,_p.lua_register)(t,"GetCustomCampaignButtonVisible",pU.bind(null,e)),(0,_p.lua_register)(t,"DoNotSaveReplay",_U.bind(null,e)),(0,_p.lua_register)(t,"DialogCreate",gU.bind(null,e)),(0,_p.lua_register)(t,"DialogDestroy",bU.bind(null,e)),(0,_p.lua_register)(t,"DialogClear",wU.bind(null,e)),(0,_p.lua_register)(t,"DialogSetMessage",vU.bind(null,e)),(0,_p.lua_register)(t,"DialogAddButton",AU.bind(null,e)),(0,_p.lua_register)(t,"DialogAddQuitButton",yU.bind(null,e)),(0,_p.lua_register)(t,"DialogDisplay",SU.bind(null,e)),(0,_p.lua_register)(t,"ReloadGameCachesFromDisk",TU.bind(null,e)),(0,_p.lua_register)(t,"InitGameCache",xU.bind(null,e)),(0,_p.lua_register)(t,"SaveGameCache",EU.bind(null,e)),(0,_p.lua_register)(t,"StoreInteger",LU.bind(null,e)),(0,_p.lua_register)(t,"StoreReal",IU.bind(null,e)),(0,_p.lua_register)(t,"StoreBoolean",UU.bind(null,e)),(0,_p.lua_register)(t,"StoreUnit",RU.bind(null,e)),(0,_p.lua_register)(t,"StoreString",MU.bind(null,e)),(0,_p.lua_register)(t,"SyncStoredInteger",CU.bind(null,e)),(0,_p.lua_register)(t,"SyncStoredReal",BU.bind(null,e)),(0,_p.lua_register)(t,"SyncStoredBoolean",PU.bind(null,e)),(0,_p.lua_register)(t,"SyncStoredUnit",kU.bind(null,e)),(0,_p.lua_register)(t,"SyncStoredString",OU.bind(null,e)),(0,_p.lua_register)(t,"HaveStoredInteger",DU.bind(null,e)),(0,_p.lua_register)(t,"HaveStoredReal",FU.bind(null,e)),(0,_p.lua_register)(t,"HaveStoredBoolean",GU.bind(null,e)),(0,_p.lua_register)(t,"HaveStoredUnit",NU.bind(null,e)),(0,_p.lua_register)(t,"HaveStoredString",VU.bind(null,e)),(0,_p.lua_register)(t,"FlushGameCache",HU.bind(null,e)),(0,_p.lua_register)(t,"FlushStoredMission",YU.bind(null,e)),(0,_p.lua_register)(t,"FlushStoredInteger",KU.bind(null,e)),(0,_p.lua_register)(t,"FlushStoredReal",zU.bind(null,e)),(0,_p.lua_register)(t,"FlushStoredBoolean",qU.bind(null,e)),(0,_p.lua_register)(t,"FlushStoredUnit",ZU.bind(null,e)),(0,_p.lua_register)(t,"FlushStoredString",jU.bind(null,e)),(0,_p.lua_register)(t,"GetStoredInteger",XU.bind(null,e)),(0,_p.lua_register)(t,"GetStoredReal",$U.bind(null,e)),(0,_p.lua_register)(t,"GetStoredBoolean",JU.bind(null,e)),(0,_p.lua_register)(t,"GetStoredString",WU.bind(null,e)),(0,_p.lua_register)(t,"RestoreUnit",QU.bind(null,e)),(0,_p.lua_register)(t,"InitHashtable",eR.bind(null,e)),(0,_p.lua_register)(t,"SaveInteger",tR.bind(null,e)),(0,_p.lua_register)(t,"SaveReal",nR.bind(null,e)),(0,_p.lua_register)(t,"SaveBoolean",aR.bind(null,e)),(0,_p.lua_register)(t,"SaveStr",rR.bind(null,e)),(0,_p.lua_register)(t,"SavePlayerHandle",iR.bind(null,e)),(0,_p.lua_register)(t,"SaveWidgetHandle",sR.bind(null,e)),(0,_p.lua_register)(t,"SaveDestructableHandle",lR.bind(null,e)),(0,_p.lua_register)(t,"SaveItemHandle",oR.bind(null,e)),(0,_p.lua_register)(t,"SaveUnitHandle",uR.bind(null,e)),(0,_p.lua_register)(t,"SaveAbilityHandle",cR.bind(null,e)),(0,_p.lua_register)(t,"SaveTimerHandle",dR.bind(null,e)),(0,_p.lua_register)(t,"SaveTriggerHandle",hR.bind(null,e)),(0,_p.lua_register)(t,"SaveTriggerConditionHandle",fR.bind(null,e)),(0,_p.lua_register)(t,"SaveTriggerActionHandle",mR.bind(null,e)),(0,_p.lua_register)(t,"SaveTriggerEventHandle",pR.bind(null,e)),(0,_p.lua_register)(t,"SaveForceHandle",_R.bind(null,e)),(0,_p.lua_register)(t,"SaveGroupHandle",gR.bind(null,e)),(0,_p.lua_register)(t,"SaveLocationHandle",bR.bind(null,e)),(0,_p.lua_register)(t,"SaveRectHandle",wR.bind(null,e)),(0,_p.lua_register)(t,"SaveBooleanExprHandle",vR.bind(null,e)),(0,_p.lua_register)(t,"SaveSoundHandle",AR.bind(null,e)),(0,_p.lua_register)(t,"SaveEffectHandle",yR.bind(null,e)),(0,_p.lua_register)(t,"SaveUnitPoolHandle",SR.bind(null,e)),(0,_p.lua_register)(t,"SaveItemPoolHandle",TR.bind(null,e)),(0,_p.lua_register)(t,"SaveQuestHandle",xR.bind(null,e)),(0,_p.lua_register)(t,"SaveQuestItemHandle",ER.bind(null,e)),(0,_p.lua_register)(t,"SaveDefeatConditionHandle",LR.bind(null,e)),(0,_p.lua_register)(t,"SaveTimerDialogHandle",IR.bind(null,e)),(0,_p.lua_register)(t,"SaveLeaderboardHandle",UR.bind(null,e)),(0,_p.lua_register)(t,"SaveMultiboardHandle",RR.bind(null,e)),(0,_p.lua_register)(t,"SaveMultiboardItemHandle",MR.bind(null,e)),(0,_p.lua_register)(t,"SaveTrackableHandle",CR.bind(null,e)),(0,_p.lua_register)(t,"SaveDialogHandle",BR.bind(null,e)),(0,_p.lua_register)(t,"SaveButtonHandle",PR.bind(null,e)),(0,_p.lua_register)(t,"SaveTextTagHandle",kR.bind(null,e)),(0,_p.lua_register)(t,"SaveLightningHandle",OR.bind(null,e)),(0,_p.lua_register)(t,"SaveImageHandle",DR.bind(null,e)),(0,_p.lua_register)(t,"SaveUbersplatHandle",FR.bind(null,e)),(0,_p.lua_register)(t,"SaveRegionHandle",GR.bind(null,e)),(0,_p.lua_register)(t,"SaveFogStateHandle",NR.bind(null,e)),(0,_p.lua_register)(t,"SaveFogModifierHandle",VR.bind(null,e)),(0,_p.lua_register)(t,"SaveAgentHandle",HR.bind(null,e)),(0,_p.lua_register)(t,"SaveHashtableHandle",YR.bind(null,e)),(0,_p.lua_register)(t,"LoadInteger",KR.bind(null,e)),(0,_p.lua_register)(t,"LoadReal",zR.bind(null,e)),(0,_p.lua_register)(t,"LoadBoolean",qR.bind(null,e)),(0,_p.lua_register)(t,"LoadStr",ZR.bind(null,e)),(0,_p.lua_register)(t,"LoadPlayerHandle",jR.bind(null,e)),(0,_p.lua_register)(t,"LoadWidgetHandle",XR.bind(null,e)),(0,_p.lua_register)(t,"LoadDestructableHandle",$R.bind(null,e)),(0,_p.lua_register)(t,"LoadItemHandle",JR.bind(null,e)),(0,_p.lua_register)(t,"LoadUnitHandle",WR.bind(null,e)),(0,_p.lua_register)(t,"LoadAbilityHandle",QR.bind(null,e)),(0,_p.lua_register)(t,"LoadTimerHandle",eM.bind(null,e)),(0,_p.lua_register)(t,"LoadTriggerHandle",tM.bind(null,e)),(0,_p.lua_register)(t,"LoadTriggerConditionHandle",nM.bind(null,e)),(0,_p.lua_register)(t,"LoadTriggerActionHandle",aM.bind(null,e)),(0,_p.lua_register)(t,"LoadTriggerEventHandle",rM.bind(null,e)),(0,_p.lua_register)(t,"LoadForceHandle",iM.bind(null,e)),(0,_p.lua_register)(t,"LoadGroupHandle",sM.bind(null,e)),(0,_p.lua_register)(t,"LoadLocationHandle",lM.bind(null,e)),(0,_p.lua_register)(t,"LoadRectHandle",oM.bind(null,e)),(0,_p.lua_register)(t,"LoadBooleanExprHandle",uM.bind(null,e)),(0,_p.lua_register)(t,"LoadSoundHandle",cM.bind(null,e)),(0,_p.lua_register)(t,"LoadEffectHandle",dM.bind(null,e)),(0,_p.lua_register)(t,"LoadUnitPoolHandle",hM.bind(null,e)),(0,_p.lua_register)(t,"LoadItemPoolHandle",fM.bind(null,e)),(0,_p.lua_register)(t,"LoadQuestHandle",mM.bind(null,e)),(0,_p.lua_register)(t,"LoadQuestItemHandle",pM.bind(null,e)),(0,_p.lua_register)(t,"LoadDefeatConditionHandle",_M.bind(null,e)),(0,_p.lua_register)(t,"LoadTimerDialogHandle",gM.bind(null,e)),(0,_p.lua_register)(t,"LoadLeaderboardHandle",bM.bind(null,e));(0,_p.lua_register)(t,"LoadMultiboardHandle",wM.bind(null,e)),(0,_p.lua_register)(t,"LoadMultiboardItemHandle",vM.bind(null,e)),(0,_p.lua_register)(t,"LoadTrackableHandle",AM.bind(null,e)),(0,_p.lua_register)(t,"LoadDialogHandle",yM.bind(null,e)),(0,_p.lua_register)(t,"LoadButtonHandle",SM.bind(null,e)),(0,_p.lua_register)(t,"LoadTextTagHandle",TM.bind(null,e)),(0,_p.lua_register)(t,"LoadLightningHandle",xM.bind(null,e)),(0,_p.lua_register)(t,"LoadImageHandle",EM.bind(null,e)),(0,_p.lua_register)(t,"LoadUbersplatHandle",LM.bind(null,e)),(0,_p.lua_register)(t,"LoadRegionHandle",IM.bind(null,e)),(0,_p.lua_register)(t,"LoadFogStateHandle",UM.bind(null,e)),(0,_p.lua_register)(t,"LoadFogModifierHandle",RM.bind(null,e)),(0,_p.lua_register)(t,"LoadHashtableHandle",MM.bind(null,e)),(0,_p.lua_register)(t,"HaveSavedInteger",CM.bind(null,e)),(0,_p.lua_register)(t,"HaveSavedReal",BM.bind(null,e)),(0,_p.lua_register)(t,"HaveSavedBoolean",PM.bind(null,e)),(0,_p.lua_register)(t,"HaveSavedString",kM.bind(null,e)),(0,_p.lua_register)(t,"HaveSavedHandle",OM.bind(null,e)),(0,_p.lua_register)(t,"RemoveSavedInteger",DM.bind(null,e)),(0,_p.lua_register)(t,"RemoveSavedReal",FM.bind(null,e)),(0,_p.lua_register)(t,"RemoveSavedBoolean",GM.bind(null,e)),(0,_p.lua_register)(t,"RemoveSavedString",NM.bind(null,e)),(0,_p.lua_register)(t,"RemoveSavedHandle",VM.bind(null,e)),(0,_p.lua_register)(t,"FlushParentHashtable",HM.bind(null,e)),(0,_p.lua_register)(t,"FlushChildHashtable",YM.bind(null,e)),(0,_p.lua_register)(t,"GetRandomInt",KM.bind(null,e)),(0,_p.lua_register)(t,"GetRandomReal",zM.bind(null,e)),(0,_p.lua_register)(t,"CreateUnitPool",qM.bind(null,e)),(0,_p.lua_register)(t,"DestroyUnitPool",ZM.bind(null,e)),(0,_p.lua_register)(t,"UnitPoolAddUnitType",jM.bind(null,e)),(0,_p.lua_register)(t,"UnitPoolRemoveUnitType",XM.bind(null,e)),(0,_p.lua_register)(t,"PlaceRandomUnit",$M.bind(null,e)),(0,_p.lua_register)(t,"CreateItemPool",JM.bind(null,e)),(0,_p.lua_register)(t,"DestroyItemPool",WM.bind(null,e)),(0,_p.lua_register)(t,"ItemPoolAddItemType",QM.bind(null,e)),(0,_p.lua_register)(t,"ItemPoolRemoveItemType",eC.bind(null,e)),(0,_p.lua_register)(t,"PlaceRandomItem",tC.bind(null,e)),(0,_p.lua_register)(t,"ChooseRandomCreep",nC.bind(null,e)),(0,_p.lua_register)(t,"ChooseRandomNPBuilding",aC.bind(null,e)),(0,_p.lua_register)(t,"ChooseRandomItem",rC.bind(null,e)),(0,_p.lua_register)(t,"ChooseRandomItemEx",iC.bind(null,e)),(0,_p.lua_register)(t,"SetRandomSeed",sC.bind(null,e)),(0,_p.lua_register)(t,"SetTerrainFog",lC.bind(null,e)),(0,_p.lua_register)(t,"ResetTerrainFog",oC.bind(null,e)),(0,_p.lua_register)(t,"SetUnitFog",uC.bind(null,e)),(0,_p.lua_register)(t,"SetTerrainFogEx",cC.bind(null,e)),(0,_p.lua_register)(t,"DisplayTextToPlayer",dC.bind(null,e)),(0,_p.lua_register)(t,"DisplayTimedTextToPlayer",hC.bind(null,e)),(0,_p.lua_register)(t,"DisplayTimedTextFromPlayer",fC.bind(null,e)),(0,_p.lua_register)(t,"ClearTextMessages",mC.bind(null,e)),(0,_p.lua_register)(t,"SetDayNightModels",pC.bind(null,e)),(0,_p.lua_register)(t,"SetSkyModel",_C.bind(null,e)),(0,_p.lua_register)(t,"EnableUserControl",gC.bind(null,e)),(0,_p.lua_register)(t,"EnableUserUI",bC.bind(null,e)),(0,_p.lua_register)(t,"SuspendTimeOfDay",wC.bind(null,e)),(0,_p.lua_register)(t,"SetTimeOfDayScale",vC.bind(null,e)),(0,_p.lua_register)(t,"GetTimeOfDayScale",AC.bind(null,e)),(0,_p.lua_register)(t,"ShowInterface",yC.bind(null,e)),(0,_p.lua_register)(t,"PauseGame",SC.bind(null,e)),(0,_p.lua_register)(t,"UnitAddIndicator",TC.bind(null,e)),(0,_p.lua_register)(t,"AddIndicator",xC.bind(null,e)),(0,_p.lua_register)(t,"PingMinimap",EC.bind(null,e)),(0,_p.lua_register)(t,"PingMinimapEx",LC.bind(null,e)),(0,_p.lua_register)(t,"EnableOcclusion",IC.bind(null,e)),(0,_p.lua_register)(t,"SetIntroShotText",UC.bind(null,e)),(0,_p.lua_register)(t,"SetIntroShotModel",RC.bind(null,e)),(0,_p.lua_register)(t,"EnableWorldFogBoundary",MC.bind(null,e)),(0,_p.lua_register)(t,"PlayModelCinematic",CC.bind(null,e)),(0,_p.lua_register)(t,"PlayCinematic",BC.bind(null,e)),(0,_p.lua_register)(t,"ForceUIKey",PC.bind(null,e)),(0,_p.lua_register)(t,"ForceUICancel",kC.bind(null,e)),(0,_p.lua_register)(t,"DisplayLoadDialog",OC.bind(null,e)),(0,_p.lua_register)(t,"SetAltMinimapIcon",DC.bind(null,e)),(0,_p.lua_register)(t,"DisableRestartMission",FC.bind(null,e)),(0,_p.lua_register)(t,"CreateTextTag",GC.bind(null,e)),(0,_p.lua_register)(t,"DestroyTextTag",NC.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagText",VC.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagPos",HC.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagPosUnit",YC.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagColor",KC.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagVelocity",zC.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagVisibility",qC.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagSuspended",ZC.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagPermanent",jC.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagAge",XC.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagLifespan",$C.bind(null,e)),(0,_p.lua_register)(t,"SetTextTagFadepoint",JC.bind(null,e)),(0,_p.lua_register)(t,"SetReservedLocalHeroButtons",WC.bind(null,e)),(0,_p.lua_register)(t,"GetAllyColorFilterState",QC.bind(null,e)),(0,_p.lua_register)(t,"SetAllyColorFilterState",eB.bind(null,e)),(0,_p.lua_register)(t,"GetCreepCampFilterState",tB.bind(null,e)),(0,_p.lua_register)(t,"SetCreepCampFilterState",nB.bind(null,e)),(0,_p.lua_register)(t,"EnableMinimapFilterButtons",aB.bind(null,e)),(0,_p.lua_register)(t,"EnableDragSelect",rB.bind(null,e)),(0,_p.lua_register)(t,"EnablePreSelect",iB.bind(null,e)),(0,_p.lua_register)(t,"EnableSelect",sB.bind(null,e)),(0,_p.lua_register)(t,"CreateTrackable",lB.bind(null,e)),(0,_p.lua_register)(t,"CreateQuest",oB.bind(null,e)),(0,_p.lua_register)(t,"DestroyQuest",uB.bind(null,e)),(0,_p.lua_register)(t,"QuestSetTitle",cB.bind(null,e)),(0,_p.lua_register)(t,"QuestSetDescription",dB.bind(null,e)),(0,_p.lua_register)(t,"QuestSetIconPath",hB.bind(null,e)),(0,_p.lua_register)(t,"QuestSetRequired",fB.bind(null,e)),(0,_p.lua_register)(t,"QuestSetCompleted",mB.bind(null,e)),(0,_p.lua_register)(t,"QuestSetDiscovered",pB.bind(null,e)),(0,_p.lua_register)(t,"QuestSetFailed",_B.bind(null,e)),(0,_p.lua_register)(t,"QuestSetEnabled",gB.bind(null,e)),(0,_p.lua_register)(t,"IsQuestRequired",bB.bind(null,e)),(0,_p.lua_register)(t,"IsQuestCompleted",wB.bind(null,e)),(0,_p.lua_register)(t,"IsQuestDiscovered",vB.bind(null,e)),(0,_p.lua_register)(t,"IsQuestFailed",AB.bind(null,e)),(0,_p.lua_register)(t,"IsQuestEnabled",yB.bind(null,e)),(0,_p.lua_register)(t,"QuestCreateItem",SB.bind(null,e)),(0,_p.lua_register)(t,"QuestItemSetDescription",TB.bind(null,e)),(0,_p.lua_register)(t,"QuestItemSetCompleted",xB.bind(null,e)),(0,_p.lua_register)(t,"IsQuestItemCompleted",EB.bind(null,e)),(0,_p.lua_register)(t,"CreateDefeatCondition",LB.bind(null,e)),(0,_p.lua_register)(t,"DestroyDefeatCondition",IB.bind(null,e)),(0,_p.lua_register)(t,"DefeatConditionSetDescription",UB.bind(null,e)),(0,_p.lua_register)(t,"FlashQuestDialogButton",RB.bind(null,e)),(0,_p.lua_register)(t,"ForceQuestDialogUpdate",MB.bind(null,e)),(0,_p.lua_register)(t,"CreateTimerDialog",CB.bind(null,e)),(0,_p.lua_register)(t,"DestroyTimerDialog",BB.bind(null,e)),(0,_p.lua_register)(t,"TimerDialogSetTitle",PB.bind(null,e)),(0,_p.lua_register)(t,"TimerDialogSetTitleColor",kB.bind(null,e)),(0,_p.lua_register)(t,"TimerDialogSetTimeColor",OB.bind(null,e)),(0,_p.lua_register)(t,"TimerDialogSetSpeed",DB.bind(null,e)),(0,_p.lua_register)(t,"TimerDialogDisplay",FB.bind(null,e)),(0,_p.lua_register)(t,"IsTimerDialogDisplayed",GB.bind(null,e)),(0,_p.lua_register)(t,"TimerDialogSetRealTimeRemaining",NB.bind(null,e)),(0,_p.lua_register)(t,"CreateLeaderboard",VB.bind(null,e)),(0,_p.lua_register)(t,"DestroyLeaderboard",HB.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardDisplay",YB.bind(null,e)),(0,_p.lua_register)(t,"IsLeaderboardDisplayed",KB.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardGetItemCount",zB.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSetSizeByItemCount",qB.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardAddItem",ZB.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardRemoveItem",jB.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardRemovePlayerItem",XB.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardClear",$B.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSortItemsByValue",JB.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSortItemsByPlayer",WB.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSortItemsByLabel",QB.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardHasPlayerItem",eP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardGetPlayerIndex",tP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSetLabel",nP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardGetLabelText",aP.bind(null,e)),(0,_p.lua_register)(t,"PlayerSetLeaderboard",rP.bind(null,e)),(0,_p.lua_register)(t,"PlayerGetLeaderboard",iP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSetLabelColor",sP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSetValueColor",lP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSetStyle",oP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSetItemValue",uP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSetItemLabel",cP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSetItemStyle",dP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSetItemLabelColor",hP.bind(null,e)),(0,_p.lua_register)(t,"LeaderboardSetItemValueColor",fP.bind(null,e)),(0,_p.lua_register)(t,"CreateMultiboard",mP.bind(null,e)),(0,_p.lua_register)(t,"DestroyMultiboard",pP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardDisplay",_P.bind(null,e)),(0,_p.lua_register)(t,"IsMultiboardDisplayed",gP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardMinimize",bP.bind(null,e)),(0,_p.lua_register)(t,"IsMultiboardMinimized",wP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardClear",vP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetTitleText",AP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardGetTitleText",yP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetTitleTextColor",SP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardGetRowCount",TP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardGetColumnCount",xP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetColumnCount",EP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetRowCount",LP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetItemsStyle",IP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetItemsValue",UP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetItemsValueColor",RP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetItemsWidth",MP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetItemsIcon",CP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardGetItem",BP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardReleaseItem",PP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetItemStyle",kP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetItemValue",OP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetItemValueColor",DP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetItemWidth",FP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSetItemIcon",GP.bind(null,e)),(0,_p.lua_register)(t,"MultiboardSuppressDisplay",NP.bind(null,e)),(0,_p.lua_register)(t,"SetCameraPosition",VP.bind(null,e)),(0,_p.lua_register)(t,"SetCameraQuickPosition",HP.bind(null,e)),(0,_p.lua_register)(t,"SetCameraBounds",YP.bind(null,e)),(0,_p.lua_register)(t,"StopCamera",KP.bind(null,e)),(0,_p.lua_register)(t,"ResetToGameCamera",zP.bind(null,e)),(0,_p.lua_register)(t,"PanCameraTo",qP.bind(null,e)),(0,_p.lua_register)(t,"PanCameraToTimed",ZP.bind(null,e)),(0,_p.lua_register)(t,"PanCameraToWithZ",jP.bind(null,e)),(0,_p.lua_register)(t,"PanCameraToTimedWithZ",XP.bind(null,e)),(0,_p.lua_register)(t,"SetCinematicCamera",$P.bind(null,e)),(0,_p.lua_register)(t,"SetCameraRotateMode",JP.bind(null,e)),(0,_p.lua_register)(t,"SetCameraField",WP.bind(null,e)),(0,_p.lua_register)(t,"AdjustCameraField",QP.bind(null,e)),(0,_p.lua_register)(t,"SetCameraTargetController",ek.bind(null,e)),(0,_p.lua_register)(t,"SetCameraOrientController",tk.bind(null,e)),(0,_p.lua_register)(t,"CreateCameraSetup",nk.bind(null,e)),(0,_p.lua_register)(t,"CameraSetupSetField",ak.bind(null,e)),(0,_p.lua_register)(t,"CameraSetupGetField",rk.bind(null,e)),(0,_p.lua_register)(t,"CameraSetupSetDestPosition",ik.bind(null,e)),(0,_p.lua_register)(t,"CameraSetupGetDestPositionLoc",sk.bind(null,e)),(0,_p.lua_register)(t,"CameraSetupGetDestPositionX",lk.bind(null,e)),(0,_p.lua_register)(t,"CameraSetupGetDestPositionY",ok.bind(null,e)),(0,_p.lua_register)(t,"CameraSetupApply",uk.bind(null,e)),(0,_p.lua_register)(t,"CameraSetupApplyWithZ",ck.bind(null,e)),(0,_p.lua_register)(t,"CameraSetupApplyForceDuration",dk.bind(null,e)),(0,_p.lua_register)(t,"CameraSetupApplyForceDurationWithZ",hk.bind(null,e)),(0,_p.lua_register)(t,"CameraSetTargetNoise",fk.bind(null,e)),(0,_p.lua_register)(t,"CameraSetSourceNoise",mk.bind(null,e)),(0,_p.lua_register)(t,"CameraSetTargetNoiseEx",pk.bind(null,e)),(0,_p.lua_register)(t,"CameraSetSourceNoiseEx",_k.bind(null,e)),(0,_p.lua_register)(t,"CameraSetSmoothingFactor",gk.bind(null,e)),(0,_p.lua_register)(t,"SetCineFilterTexture",bk.bind(null,e)),(0,_p.lua_register)(t,"SetCineFilterBlendMode",wk.bind(null,e)),(0,_p.lua_register)(t,"SetCineFilterTexMapFlags",vk.bind(null,e)),(0,_p.lua_register)(t,"SetCineFilterStartUV",Ak.bind(null,e)),(0,_p.lua_register)(t,"SetCineFilterEndUV",yk.bind(null,e)),(0,_p.lua_register)(t,"SetCineFilterStartColor",Sk.bind(null,e)),(0,_p.lua_register)(t,"SetCineFilterEndColor",Tk.bind(null,e)),(0,_p.lua_register)(t,"SetCineFilterDuration",xk.bind(null,e)),(0,_p.lua_register)(t,"DisplayCineFilter",Ek.bind(null,e)),(0,_p.lua_register)(t,"IsCineFilterDisplayed",Lk.bind(null,e)),(0,_p.lua_register)(t,"SetCinematicScene",Ik.bind(null,e)),(0,_p.lua_register)(t,"EndCinematicScene",Uk.bind(null,e)),(0,_p.lua_register)(t,"ForceCinematicSubtitles",Rk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraMargin",Mk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraBoundMinX",Ck.bind(null,e)),(0,_p.lua_register)(t,"GetCameraBoundMinY",Bk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraBoundMaxX",Pk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraBoundMaxY",kk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraField",Ok.bind(null,e)),(0,_p.lua_register)(t,"GetCameraTargetPositionX",Dk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraTargetPositionY",Fk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraTargetPositionZ",Gk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraTargetPositionLoc",Nk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraEyePositionX",Vk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraEyePositionY",Hk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraEyePositionZ",Yk.bind(null,e)),(0,_p.lua_register)(t,"GetCameraEyePositionLoc",Kk.bind(null,e)),(0,_p.lua_register)(t,"NewSoundEnvironment",zk.bind(null,e)),(0,_p.lua_register)(t,"CreateSound",qk.bind(null,e)),(0,_p.lua_register)(t,"CreateSoundFilenameWithLabel",Zk.bind(null,e)),(0,_p.lua_register)(t,"CreateSoundFromLabel",jk.bind(null,e)),(0,_p.lua_register)(t,"CreateMIDISound",Xk.bind(null,e)),(0,_p.lua_register)(t,"SetSoundParamsFromLabel",$k.bind(null,e)),(0,_p.lua_register)(t,"SetSoundDistanceCutoff",Jk.bind(null,e)),(0,_p.lua_register)(t,"SetSoundChannel",Wk.bind(null,e)),(0,_p.lua_register)(t,"SetSoundVolume",Qk.bind(null,e)),(0,_p.lua_register)(t,"SetSoundPitch",eO.bind(null,e)),(0,_p.lua_register)(t,"SetSoundPlayPosition",tO.bind(null,e)),(0,_p.lua_register)(t,"SetSoundDistances",nO.bind(null,e)),(0,_p.lua_register)(t,"SetSoundConeAngles",aO.bind(null,e)),(0,_p.lua_register)(t,"SetSoundConeOrientation",rO.bind(null,e)),(0,_p.lua_register)(t,"SetSoundPosition",iO.bind(null,e)),(0,_p.lua_register)(t,"SetSoundVelocity",sO.bind(null,e)),(0,_p.lua_register)(t,"AttachSoundToUnit",lO.bind(null,e)),(0,_p.lua_register)(t,"StartSound",oO.bind(null,e)),(0,_p.lua_register)(t,"StopSound",uO.bind(null,e)),(0,_p.lua_register)(t,"KillSoundWhenDone",cO.bind(null,e)),(0,_p.lua_register)(t,"SetMapMusic",dO.bind(null,e)),(0,_p.lua_register)(t,"ClearMapMusic",hO.bind(null,e)),(0,_p.lua_register)(t,"PlayMusic",fO.bind(null,e)),(0,_p.lua_register)(t,"PlayMusicEx",mO.bind(null,e)),(0,_p.lua_register)(t,"StopMusic",pO.bind(null,e)),(0,_p.lua_register)(t,"ResumeMusic",_O.bind(null,e)),(0,_p.lua_register)(t,"PlayThematicMusic",gO.bind(null,e)),(0,_p.lua_register)(t,"PlayThematicMusicEx",bO.bind(null,e)),(0,_p.lua_register)(t,"EndThematicMusic",wO.bind(null,e)),(0,_p.lua_register)(t,"SetMusicVolume",vO.bind(null,e)),(0,_p.lua_register)(t,"SetMusicPlayPosition",AO.bind(null,e)),(0,_p.lua_register)(t,"SetThematicMusicPlayPosition",yO.bind(null,e)),(0,_p.lua_register)(t,"SetSoundDuration",SO.bind(null,e)),(0,_p.lua_register)(t,"GetSoundDuration",TO.bind(null,e)),(0,_p.lua_register)(t,"GetSoundFileDuration",xO.bind(null,e)),(0,_p.lua_register)(t,"VolumeGroupSetVolume",EO.bind(null,e)),(0,_p.lua_register)(t,"VolumeGroupReset",LO.bind(null,e)),(0,_p.lua_register)(t,"GetSoundIsPlaying",IO.bind(null,e)),(0,_p.lua_register)(t,"GetSoundIsLoading",UO.bind(null,e)),(0,_p.lua_register)(t,"RegisterStackedSound",RO.bind(null,e)),(0,_p.lua_register)(t,"UnregisterStackedSound",MO.bind(null,e)),(0,_p.lua_register)(t,"AddWeatherEffect",CO.bind(null,e)),(0,_p.lua_register)(t,"RemoveWeatherEffect",BO.bind(null,e)),(0,_p.lua_register)(t,"EnableWeatherEffect",PO.bind(null,e)),(0,_p.lua_register)(t,"TerrainDeformCrater",kO.bind(null,e)),(0,_p.lua_register)(t,"TerrainDeformRipple",OO.bind(null,e)),(0,_p.lua_register)(t,"TerrainDeformWave",DO.bind(null,e)),(0,_p.lua_register)(t,"TerrainDeformRandom",FO.bind(null,e)),(0,_p.lua_register)(t,"TerrainDeformStop",GO.bind(null,e)),(0,_p.lua_register)(t,"TerrainDeformStopAll",NO.bind(null,e)),(0,_p.lua_register)(t,"AddSpecialEffect",VO.bind(null,e)),(0,_p.lua_register)(t,"AddSpecialEffectLoc",HO.bind(null,e)),(0,_p.lua_register)(t,"AddSpecialEffectTarget",YO.bind(null,e)),(0,_p.lua_register)(t,"DestroyEffect",KO.bind(null,e)),(0,_p.lua_register)(t,"AddSpellEffect",zO.bind(null,e)),(0,_p.lua_register)(t,"AddSpellEffectLoc",qO.bind(null,e)),(0,_p.lua_register)(t,"AddSpellEffectById",ZO.bind(null,e)),(0,_p.lua_register)(t,"AddSpellEffectByIdLoc",jO.bind(null,e)),(0,_p.lua_register)(t,"AddSpellEffectTarget",XO.bind(null,e)),(0,_p.lua_register)(t,"AddSpellEffectTargetById",$O.bind(null,e)),(0,_p.lua_register)(t,"AddLightning",JO.bind(null,e)),(0,_p.lua_register)(t,"AddLightningEx",WO.bind(null,e)),(0,_p.lua_register)(t,"DestroyLightning",QO.bind(null,e)),(0,_p.lua_register)(t,"MoveLightning",eD.bind(null,e)),(0,_p.lua_register)(t,"MoveLightningEx",tD.bind(null,e)),(0,_p.lua_register)(t,"GetLightningColorA",nD.bind(null,e)),(0,_p.lua_register)(t,"GetLightningColorR",aD.bind(null,e)),(0,_p.lua_register)(t,"GetLightningColorG",rD.bind(null,e)),(0,_p.lua_register)(t,"GetLightningColorB",iD.bind(null,e)),(0,_p.lua_register)(t,"SetLightningColor",sD.bind(null,e)),(0,_p.lua_register)(t,"GetAbilityEffect",lD.bind(null,e)),(0,_p.lua_register)(t,"GetAbilityEffectById",oD.bind(null,e)),(0,_p.lua_register)(t,"GetAbilitySound",uD.bind(null,e)),(0,_p.lua_register)(t,"GetAbilitySoundById",cD.bind(null,e)),(0,_p.lua_register)(t,"GetTerrainCliffLevel",dD.bind(null,e)),(0,_p.lua_register)(t,"SetWaterBaseColor",hD.bind(null,e)),(0,_p.lua_register)(t,"SetWaterDeforms",fD.bind(null,e)),(0,_p.lua_register)(t,"GetTerrainType",mD.bind(null,e)),(0,_p.lua_register)(t,"GetTerrainVariance",pD.bind(null,e)),(0,_p.lua_register)(t,"SetTerrainType",_D.bind(null,e)),(0,_p.lua_register)(t,"IsTerrainPathable",gD.bind(null,e)),(0,_p.lua_register)(t,"SetTerrainPathable",bD.bind(null,e)),(0,_p.lua_register)(t,"CreateImage",wD.bind(null,e)),(0,_p.lua_register)(t,"DestroyImage",vD.bind(null,e)),(0,_p.lua_register)(t,"ShowImage",AD.bind(null,e)),(0,_p.lua_register)(t,"SetImageConstantHeight",yD.bind(null,e)),(0,_p.lua_register)(t,"SetImagePosition",SD.bind(null,e)),(0,_p.lua_register)(t,"SetImageColor",TD.bind(null,e)),(0,_p.lua_register)(t,"SetImageRender",xD.bind(null,e)),(0,_p.lua_register)(t,"SetImageRenderAlways",ED.bind(null,e)),(0,_p.lua_register)(t,"SetImageAboveWater",LD.bind(null,e)),(0,_p.lua_register)(t,"SetImageType",ID.bind(null,e)),(0,_p.lua_register)(t,"CreateUbersplat",UD.bind(null,e)),(0,_p.lua_register)(t,"DestroyUbersplat",RD.bind(null,e)),(0,_p.lua_register)(t,"ResetUbersplat",MD.bind(null,e)),(0,_p.lua_register)(t,"FinishUbersplat",CD.bind(null,e)),(0,_p.lua_register)(t,"ShowUbersplat",BD.bind(null,e)),(0,_p.lua_register)(t,"SetUbersplatRender",PD.bind(null,e)),(0,_p.lua_register)(t,"SetUbersplatRenderAlways",kD.bind(null,e)),(0,_p.lua_register)(t,"SetBlight",OD.bind(null,e)),(0,_p.lua_register)(t,"SetBlightRect",DD.bind(null,e)),(0,_p.lua_register)(t,"SetBlightPoint",FD.bind(null,e)),(0,_p.lua_register)(t,"SetBlightLoc",GD.bind(null,e)),(0,_p.lua_register)(t,"CreateBlightedGoldmine",ND.bind(null,e)),(0,_p.lua_register)(t,"IsPointBlighted",VD.bind(null,e)),(0,_p.lua_register)(t,"SetDoodadAnimation",HD.bind(null,e)),(0,_p.lua_register)(t,"SetDoodadAnimationRect",YD.bind(null,e)),(0,_p.lua_register)(t,"StartMeleeAI",KD.bind(null,e)),(0,_p.lua_register)(t,"StartCampaignAI",zD.bind(null,e)),(0,_p.lua_register)(t,"CommandAI",qD.bind(null,e)),(0,_p.lua_register)(t,"PauseCompAI",ZD.bind(null,e)),(0,_p.lua_register)(t,"GetAIDifficulty",jD.bind(null,e)),(0,_p.lua_register)(t,"RemoveGuardPosition",XD.bind(null,e)),(0,_p.lua_register)(t,"RecycleGuardPosition",$D.bind(null,e)),(0,_p.lua_register)(t,"RemoveAllGuardPositions",JD.bind(null,e)),(0,_p.lua_register)(t,"Cheat",WD.bind(null,e)),(0,_p.lua_register)(t,"IsNoVictoryCheat",QD.bind(null,e)),(0,_p.lua_register)(t,"IsNoDefeatCheat",eF.bind(null,e)),(0,_p.lua_register)(t,"Preload",tF.bind(null,e)),(0,_p.lua_register)(t,"PreloadEnd",nF.bind(null,e)),(0,_p.lua_register)(t,"PreloadStart",aF.bind(null,e)),(0,_p.lua_register)(t,"PreloadRefresh",rF.bind(null,e)),(0,_p.lua_register)(t,"PreloadEndEx",iF.bind(null,e)),(0,_p.lua_register)(t,"PreloadGenClear",sF.bind(null,e)),(0,_p.lua_register)(t,"PreloadGenStart",lF.bind(null,e)),(0,_p.lua_register)(t,"PreloadGenEnd",oF.bind(null,e)),(0,_p.lua_register)(t,"Preloader",uF.bind(null,e)),(0,_p.lua_register)(t,"AutomationTestStart",cF.bind(null,e)),(0,_p.lua_register)(t,"AutomationTestEnd",dF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetTriggerPlayerMouseX",hF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetTriggerPlayerMouseY",fF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetTriggerPlayerMousePosition",mF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetTriggerPlayerMouseButton",pF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityTooltip",_F.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityActivatedTooltip",gF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityExtendedTooltip",bF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityActivatedExtendedTooltip",wF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityResearchTooltip",vF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityResearchExtendedTooltip",AF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityTooltip",yF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityActivatedTooltip",SF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityExtendedTooltip",TF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityActivatedExtendedTooltip",xF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityResearchTooltip",EF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityResearchExtendedTooltip",LF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityIcon",IF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityIcon",UF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityActivatedIcon",RF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityActivatedIcon",MF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityPosX",CF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityPosY",BF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityPosX",PF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityPosY",kF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityActivatedPosX",OF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityActivatedPosY",DF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityActivatedPosX",FF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetAbilityActivatedPosY",GF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitMaxHP",NF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetUnitMaxHP",VF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitMaxMana",HF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetUnitMaxMana",YF.bind(null,e)),(0,_p.lua_register)(t,"BlzDeleteHeroAbility",KF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetItemName",zF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetItemDescription",qF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetItemDescription",ZF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetItemTooltip",jF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetItemTooltip",XF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetItemExtendedTooltip",$F.bind(null,e)),(0,_p.lua_register)(t,"BlzGetItemExtendedTooltip",JF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetItemIconPath",WF.bind(null,e)),(0,_p.lua_register)(t,"BlzGetItemIconPath",QF.bind(null,e)),(0,_p.lua_register)(t,"BlzSetUnitName",eG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetHeroProperName",tG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitBaseDamage",nG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetUnitBaseDamage",aG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitDiceNumber",rG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetUnitDiceNumber",iG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitDiceSides",sG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetUnitDiceSides",lG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitAttackCooldown",oG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetUnitAttackCooldown",uG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectColorByPlayer",cG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectColor",dG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectAlpha",hG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectScale",fG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectPosition",mG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectHeight",pG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectTimeScale",_G.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectTime",gG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectOrientation",bG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectYaw",wG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectPitch",vG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectRoll",AG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectX",yG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectY",SG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectZ",TG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetSpecialEffectPositionLoc",xG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetLocalSpecialEffectX",EG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetLocalSpecialEffectY",LG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetLocalSpecialEffectZ",IG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitArmor",UG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetUnitArmor",RG.bind(null,e)),(0,_p.lua_register)(t,"BlzUnitHideAbility",MG.bind(null,e)),(0,_p.lua_register)(t,"BlzUnitDisableAbility",CG.bind(null,e)),(0,_p.lua_register)(t,"BlzUnitCancelTimedLife",BG.bind(null,e)),(0,_p.lua_register)(t,"BlzIsUnitSelectable",PG.bind(null,e)),(0,_p.lua_register)(t,"BlzIsUnitInvulnerable",kG.bind(null,e)),(0,_p.lua_register)(t,"BlzUnitInterruptAttack",OG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitCollisionSize",DG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityManaCost",FG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetAbilityCooldown",GG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetUnitAbilityCooldown",NG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitAbilityCooldown",VG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitAbilityCooldownRemaining",HG.bind(null,e)),(0,_p.lua_register)(t,"BlzEndUnitAbilityCooldown",YG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetUnitAbilityManaCost",KG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetUnitAbilityManaCost",zG.bind(null,e)),(0,_p.lua_register)(t,"BlzGetLocalUnitZ",qG.bind(null,e)),(0,_p.lua_register)(t,"BlzDecPlayerTechResearched",ZG.bind(null,e)),(0,_p.lua_register)(t,"BlzSetEventDamage",jG.bind(null,e))}class $G extends Bp{}class JG extends Bp{}class WG extends Bp{}var QG=n(137);class eN{constructor(e,t){this.sleep=0,this.L=(0,QG.lua_newthread)(e),this.expiredTimer=t.expiredTimer||null,this.triggerUnit=t.triggerUnit||null,this.triggeringTrigger=t.triggeringTrigger||null}}class tN extends Id.EventEmitter{constructor(){super(),this.map=null,this.handle=0,this.freeHandles=[],this.handles=[],this.name="",this.description="",this.players=[],this.actualPlayers=0,this.startLocations=[],this.constantHandles=function(){const e=[],t=[],n=[],a=[],r=[],i=[],s=[],l=[],o=[],u=[],c=[],d=[],h=[],f=[],m=[],p=[],_=[],g=[],b=[],w=[],v=[],A=[],y=[],S=[],T=[],x=[],E=[],L=[],I=[],U=[],R=[],M=[],C=[],B=[],P=[],k=[],O=[],D=[],F=[];for(let t=0;t<24;t++)e[t]=new h_(t);for(let e=0;e<8;e++)t[e]=new Pp(e);for(let e=0;e<4;e++)n[e]=new Hp(e);for(let e=0;e<10;e++)a[e]=new kp(e);for(let e=0;e<2;e++)r[e]=new A_(e);for(let e=0;e<7;e++)i[e]=new S_(e);for(let e=0;e<27;e++)s[e]=new T_(e);for(let e=0;e<24;e++)l[e]=new x_(e);for(let e=0;e<8;e++)o[e]=new L_(e);for(let e=0;e<4;e++)u[e]=new $G(e);for(let e=0;e<11;e++)c[e]=new JG(e);for(let e=11;e<63;e++)d[e]=new WG(e);for(let e=0;e<8;e++){const t=Math.pow(2,e);h[t]=new Op(t)}for(let e=0;e<6;e++)f[e]=new l_(e);for(let e=0;e<8;e++){const t=Math.pow(2,e);m[t]=new n_(t)}for(let e=0;e<20;e++){const t=Math.pow(2,e);p[t]=new a_(t)}for(let e=0;e<4;e++)_[e]=new f_(e);for(let e=0;e<3;e++)g[e]=new m_(e);for(let e=0;e<4;e++)b[e]=new s_(e);for(let e=0;e<4;e++)w[e]=new t_(e);for(let e=0;e<5;e++)v[e]=new e_(e);for(let e=0;e<3;e++)A[e]=new o_(e);for(let e=0;e<8;e++)y[e]=new u_(e);for(let e=0;e<2;e++)S[e]=new Fp(e);for(let e=2;e<3;e++)S[e]=new Gp(e);for(let e=0;e<26;e++)T[e]=new Np(e);for(let e=0;e<4;e++)x[e]=new Yp(e);for(let e=0;e<3;e++)E[e]=new Kp(e);for(let e=0;e<25;e++)L[e]=new Vp(e);for(let e=0;e<11;e++)I[e]=new qp(e);for(let e=11;e<18;e++)I[e]=new Zp(e);for(let e=18;e<52;e++)I[e]=new jp(e);for(let e=52;e<89;e++)I[e]=new Xp(e);for(let e=89;e<90;e++)I[e]=new Jp(e);for(let e=90;e<92;e++)I[e]=new Wp(e);for(let e=256;e<260;e++)I[e]=new qp(e);for(let e=261;e<269;e++)I[e]=new Zp(e);for(let e=269;e<278;e++)I[e]=new jp(e);for(let e=286;e<295;e++)I[e]=new Xp(e);for(let e=0;e<6;e++)U[e]=new $p(e);for(let e=0;e<27;e++)R[e]=new Qp(e);for(let e=0;e<9;e++)M[e]=new y_(e);for(let e=0;e<7;e++)C[e]=new c_(e);for(let e=0;e<6;e++)B[e]=new __(e);for(let e=0;e<1;e++)P[e]=new p_(e);for(let e=0;e<4;e++)k[e]=new g_(e);for(let e=0;e<3;e++){const t=Math.pow(2,e);O[t]=new v_(t)}for(let e=0;e<7;e++)D[e]=new b_(e);for(let e=0;e<2;e++)F[e]=new E_(e);return{playerColors:e,races:t,playerGameResults:n,allianceTypes:a,versions:r,attackTypes:i,damageTypes:s,weaponTypes:l,pathingTypes:o,mouseButtonTypes:u,animTypes:c,subAnimTypes:d,racePrefs:h,mapControls:f,gameTypes:m,mapFlags:p,placements:_,startLocPrios:g,mapDensities:b,gameDifficulties:w,gameSpeeds:v,playerSlotStates:A,volumeGroups:y,gameStates:S,playerStates:T,unitStates:x,aiDifficulties:E,playerScores:L,events:I,limitOps:U,unitTypes:R,itemTypes:M,cameraFields:C,blendModes:B,rarityControls:P,texMapFlags:k,fogStates:O,effectTypes:D,soundTypes:F}}(),this.timers=new Set,this.triggers=new Set,this.threads=new Set,this.currentThread=null,this.enumUnit=null,this.filterUnit=null,this.enumPlayer=null,this.t=0,this.L=(0,bp.AH)(),XG(this),(0,_p.lua_atnativeerror)(this.L,(e=>{const t=(0,_p.lua_touserdata)(e,-1);return(0,_p.lua_pushstring)(e,t.stack),1}));for(let e=0;e<28;e++)this.players[e]=this.addHandle(new Sp(e,28))}start(){this.t=performance.now()}step(){const e=performance.now(),t=.001*(e-this.t),n=this.timers,a=this.threads;for(const e of n)if(e.elapsed+=t,e.elapsed>=e.timeout){const t=new eN(this.L,{expiredTimer:e}),a=t.L;(0,_p.lua_rawgeti)(a,gp.LUA_REGISTRYINDEX,e.handlerFunc),this.threads.add(t),e.periodic?e.elapsed=0:n.delete(e)}for(const e of a)if(e.sleep-=t,e.sleep<=0){this.currentThread=e;const t=e.L,n=(0,wp.lua_resume)(t,this.L,0);n===gp.thread_status.LUA_OK?a.delete(e):n===gp.thread_status.LUA_YIELD?e.sleep=(0,bp.qZ)(t,1):(console.log("[JS] Something went wrong during execution"),console.log((0,gp.to_jsstring)((0,bp.bm)(t,-1))),(0,_p.lua_pop)(t,2))}this.t=e}addHandle(e){if(-1===e.handleId){let t;t=this.freeHandles.length?this.freeHandles.pop():this.handle++,this.handles[t]=e,e.handleId=t}return e}freeHandle(e){-1!==e.handleId&&(this.freeHandles.push(e.handleId),this.handles[e.handleId]=null,e.handleId=-1)}call(e){const t=this.L;"string"==typeof e?(0,_p.lua_getglobal)(t,e):"number"==typeof e&&(0,_p.lua_rawgeti)(t,gp.LUA_REGISTRYINDEX,e),(0,_p.lua_pcall)(t,0,0,0)&&(console.log("Something went wrong during execution"),console.log((0,gp.to_jsstring)((0,bp.bm)(t,-1))),(0,_p.lua_pop)(t,2))}run(e,t){const n=this.L;t&&(e=vp(e)),(0,bp.Tl)(n,(0,gp.to_luastring)(e))&&(console.log("Something went wrong during execution"),console.log((0,gp.to_jsstring)((0,bp.bm)(n,-1))),(0,_p.lua_pop)(n,2)),(0,_p.lua_pcall)(n,0,0,0)&&(console.log("Something went wrong during execution"),console.log((0,gp.to_jsstring)((0,bp.bm)(n,-1))),(0,_p.lua_pop)(n,2))}open(e){this.map=e;const t=e.getScriptFile();if(t){const e=t.text();if(e){const n=t.name.endsWith(".j");this.run(e,n)}}}}function nN(e,t){const n=e.readSafe(),a=[];e.read();const r=e.readSafe();if("nothing"!==r)for(a.push({type:r,name:e.readSafe()});","===e.read();)a.push({type:e.readSafe(),name:e.readSafe()});else e.read();const i=e.readSafe(),s=`\n/**\n * ${t?"constant ":""}native ${n} takes ${a.length?a.map((e=>`${e.type} ${e.name}`)).join(", "):"nothing"} returns ${i}\n */\nfunction ${n}(C: Context, L: lua_State) {\n  ${function(e){return e.map(((e,t)=>{const n=e.type;if("code"===n)return`let ${e.name} = luaL_ref(L, LUA_REGISTRYINDEX);`;{let a;return a="integer"===n?"luaL_checkinteger":"real"===n?"luaL_checknumber":"boolean"===n?"lua_toboolean":"string"===n?"luaL_checkstring":"lua_touserdata",`let ${e.name} = ${a}(L, ${t+1});`}})).join("\n")}(a)}\n  console.warn('${n} was called but is not implemented :(');\n  ${function(e){if("nothing"===e)return"return 0";{let t,n;if("integer"===e)t="lua_pushinteger",n="0";else if("real"===e)t="lua_pushnumber",n="0";else if("boolean"===e)t="lua_pushboolean",n="false";else if("string"===e)t="lua_pushstring",n="''";else{if("code"===e)throw"CODE??";t="lua_pushlightuserdata",n="{name: 'FAKE'}"}return`${t}(L, ${n});\nreturn 1;`}}(i)}\n}`;return{name:n,decl:s}}const aN={Context:tN,jass2lua:vp,types:h,compileNatives:function(e){const t=new xc(e),n=[],a=[];let r;for(;void 0!==(r=t.read());){let e=!1;if("constant"===r&&(e=!0,r=t.read()),"native"===r){const{name:r,decl:i}=nN(t,e);n.push(r),a.push(i)}}return`${a.join("\n")}\n${function(e){return`\n/**\n * Bind natives to the given context.\n */\nexport default function bind(C: Context) {\nlet L = C.L;\n${e.map((e=>`  lua_register(L, '${e}', ${e}.bind(null, C));`)).join("\n")}\n}`}(n)}\n`}};function rN(e,t,n){if(-1===n){const n=e.model.sequences;for(let e=0,a=n.length;e<a;e++){const a=n[e].interval;if(t>=a[0]&&t<=a[1])return e}}else{const a=e.model.globalSequences[n];if(t>=0&&t<=a)return n}return-1}function iN(e,t,n){let a=0;for(let r=0,i=e.length;r<i;r++){const i=e[r],s=Math.abs(i-t[r]),l=Math.abs(i-n[r]);s>a&&(a=s),l>a&&(a=l)}return a}function sN(e,t,n,a,r){const{globalSequenceId:i,interpolationType:s,values:l}=a;let o;o=-1===i?e.model.sequences[n].interval[0]:0;const u=t[0],c=t[t.length-1],d=r[u];if(0!==s&&d!==o){(function(e,t){for(let n=0,a=e.length;n<a;n++)if(e[n]!==t[n])return!1;return!0})(l[u],l[c])||e.addSevere(`Missing opening track for ${function(e,t,n){return-1===n?`sequence "${e.model.sequences[t].name}"`:`global sequence ${n}`}(e,n,i)} at frame ${o} where it is needed`)}if(t.length>2){let n=l[t[0]],a=l[t[1]];for(let i=2,s=t.length;i<s;i++){const s=l[t[i]],o=t[i-1],u=iN(n,a,s);0===u?e.addUnused(`Track ${o} at frame ${r[o]} has exactly the same value as tracks ${o-1} and ${o+1}`):u<.001&&e.addUnused(`Track ${o} at frame ${r[o]} has roughly the same value as tracks ${o-1} and ${o+1}`),n=a,a=s}}}function lN(e,t){let n;t instanceof qr?(e.assertWarning(t.frames.length>0,"Zero tracks"),n=t.frames):(e.assertError(t.tracks.length>0,"Zero tracks"),n=t.tracks);const a=t.globalSequenceId,r=[];if(-1===a){e.assertWarning(e.model.sequences.length>0,"This animation exists, but the model has no sequences");for(let t=0,n=e.model.sequences.length;t<n;t++)r.push([])}else{if(!pN(e,e.model.globalSequences,a,"global sequence"))return;r[a]=[]}if(function(e,t,n,a){let r=-1/0;for(let i=0,s=t.length;i<s;i++){const s=t[i];e.assertWarning(s>=0,`Track ${i} has a negative frame ${s}`),s===r?e.addWarning(`Track ${i} has the same frame ${s} as track ${i-1}`):s<r&&e.addSevere(`Track ${i} at frame ${s} is lower than the track before it at ${r}`);const l=rN(e,s,n);-1!==l?a[l].push(i):0!==s&&t.length>1&&(-1===n?e.addUnused(`Track ${i} at frame ${s} is not in any sequence`):e.addUnused(`Track ${i} at frame ${s} is not in global sequence ${n}`)),r=s}}(e,n,a,r),t instanceof qr)for(let a=0,i=r.length;a<i;a++){const i=r[a];i&&i.length>1&&sN(e,i,a,t,n)}}const oN=new Set(["attack","birth","cinematic","death","decay","dissipate","morph","portrait","sleep","spell","stand","walk","ready"]),uN=new Set([1,2,11,21,31,32,33,34,35,36,37]),cN=new Map([["KMTF","Texture ID"],["KMTA","Alpha"],["KMTE","Emissive Gain"],["KFC3","Fresnel Color"],["KFCA","Fresnel Opacity"],["KFTC","Fresnel Team Color"],["KTAT","Translation"],["KTAR","Rotation"],["KTAS","Scaling"],["KGAO","Alpha"],["KGAC","Color"],["KGTR","Translation"],["KGRT","Rotation"],["KGSC","Scaling"],["KLAS","Attenuation Start"],["KLAE","Attenuation End"],["KLAC","Color"],["KLAI","Intensity"],["KLBI","Ambient Intensity"],["KLBC","Ambient Color"],["KLAV","Visibility"],["KATV","Visibility"],["KPEE","Emission Rate"],["KPEG","Gravity"],["KPLN","Longitude"],["KPLT","Latitude"],["KPEL","Lifespan"],["KPES","Speed"],["KPEV","Visibility"],["KP2E","Emission Rate"],["KP2G","Gravity"],["KP2L","Latitude"],["KP2R","Variation"],["KP2N","Length"],["KP2W","Width"],["KP2S","Speed"],["KP2V","Visibility"],["KPPA","Alpha"],["KPPC","Color"],["KPPE","EmissionRate"],["KPPL","LifeSpan"],["KPPS","Speed"],["KPPV","Visibility"],["KRHA","Height Above"],["KRHB","Height Below"],["KRAL","Alpha"],["KRCO","Color"],["KRTX","Texture Slot"],["KRVS","Visibility"],["KCTR","Translation"],["KTTR","Rotation"],["KCRL","Target Translation"]]);function dN(e){return e instanceof Kr?"Extent":e instanceof zr?"Sequence":"number"==typeof e?"GlobalSequence":e instanceof ni?"Texture":e instanceof ti?"Material":e instanceof ei?"Layer":e instanceof ai?"TextureAnimation":e instanceof ri?"Geoset":e instanceof ii?"GeosetAnimation":e instanceof li?"Bone":e instanceof oi?"Light":e instanceof ui?"Helper":e instanceof ci?"Attachment":e instanceof di?"ParticleEmitter":e instanceof hi?"ParticleEmitter2":e instanceof fi?"ParticleEmitterPopcorn":e instanceof mi?"RibbonEmitter":e instanceof _i?"EventObject":e instanceof pi?"Camera":e instanceof gi?"CollisionShape":e instanceof bi?"FaceEffect":e instanceof qr?cN.get(e.name):(console.warn("Unknown object type",e),"Unknown")}function hN(e,t){let n=dN(e);return e instanceof qr||e instanceof Kr||(n+=` ${t}`),(e instanceof zr||e instanceof si||e instanceof pi)&&(n+=` - "${e.name}"`),(e instanceof ni||e instanceof bi)&&(e.path.length&&(n+=` - "${dr(e.path)}"`),e instanceof ni&&(1===e.replaceableId?n+=" - Team color":2===e.replaceableId?n+=" - Team glow":e.replaceableId>0&&(n+=` - Replaceable ID ${e.replaceableId}`))),n}function fN(e,t,n){const a=t.length;if(a){const r=t[0]instanceof Wr,i=t[0]instanceof si;for(let s=0;s<a;s++){const a=t[s];if(e.push(a,s),n&&n(e,a,s),r){fN(e,a.animations,bN)}if(i){const t=a,n=t.objectId,r=t.parentId;e.assertError(-1===r||gN(e,r),`Invalid parent ${r}`),e.assertError(n!==r,"Same object and parent")}e.pop()}}}function mN(e,t,n,a){return n>=0&&n<t.length?(e.addReference(t[n]),t[n]):void e.addError(`Invalid ${a} ${n}`)}function pN(e,t,n,a){return void 0!==mN(e,t,n,a)}function _N(e,t,n,a){const r=e.objects[n];var i,s;if(a&&e.assertError((s=255,(i=n)>=0&&i<=s),`Vertex ${t}: References bone ${n} but there can only be 256 bones in an HD model`),r)if(r instanceof li){const t=e.boneUsageMap.get(n)||0;e.boneUsageMap.set(n,t+1)}else e.addSevere(`Vertex ${t}: Attached to "${r.name}" which is not a bone`);else e.addError(`Vertex ${t}: Attached to object ${n} which does not exist`)}function gN(e,t){for(const n of e.objects)if(n.objectId===t)return!0;return!1}function bN(e,t){const n=t.name,a=t.interpolationType;e.assertWarning("KP2R"!==n,"Using a variation animation."),e.assertWarning("KP2G"!==n,"Using a gravity animation."),e.assertWarning("Visibility"!==cN.get(n)||0===a,"Interpolation type not set to None"),lN(e,t)}function wN(e){const t=e.nodes;for(let e=t.length-1;e>=0;e--){const n=t[e];"node"===n.type&&(n.errors||n.severe||n.warnings||n.unused||void 0!==n.uses&&!n.uses?wN(n):t.splice(e,1))}}function vN(e,t){e.push(t,0);const{max:n,min:a}=t;(n[0]-a[0]<0||n[1]-a[1]<0||n[2]-a[2]<0)&&e.addWarning("Negative extents"),e.pop()}class AN{constructor(e){this.objects=[],this.map=new Map,this.foundStand=!1,this.foundDeath=!1,this.boneUsageMap=new Map,this.model=e,this.current={type:"node",name:"",errors:0,severe:0,warnings:0,unused:0,nodes:[]},this.stack=[this.current],this.addObjects(e.sequences),this.addObjects(e.globalSequences),this.addObjects(e.textures),this.addObjects(e.materials),this.addObjects(e.textureAnimations),this.addObjects(e.geosets),this.addObjects(e.geosetAnimations),this.addObjects(e.bones),this.addObjects(e.lights),this.addObjects(e.helpers),this.addObjects(e.attachments),this.addObjects(e.particleEmitters),this.addObjects(e.particleEmitters2),this.addObjects(e.particleEmittersPopcorn),this.addObjects(e.ribbonEmitters),this.addObjects(e.cameras),this.addObjects(e.eventObjects),this.addObjects(e.collisionShapes),this.addObjects(e.faceEffects)}addObjects(e){if(e.length){const t=e[0]instanceof si;for(let n=0,a=e.length;n<a;n++){const a=e[n],r={type:"node",name:hN(a,n),errors:0,severe:0,warnings:0,unused:0,nodes:[]};t||(r.uses=0),this.map.set(a,r)}t&&this.objects.push(...e)}}push(e,t){let n=this.map.get(e);if(!n){n={type:"node",name:hN(e,t),errors:0,severe:0,warnings:0,unused:0,nodes:[]}}this.current.nodes.push(n),this.current=n,this.stack.unshift(n)}pop(){this.stack.shift(),this.current=this.stack[0]}addReference(e){const t=this.map.get(e);void 0!==t.uses&&(t.uses+=1)}addImplicitReference(){const e=this.current;void 0!==e.uses&&(e.uses+=1)}addError(e){this.current.nodes.push({type:"error",message:e});for(const e of this.stack)e.errors+=1}addSevere(e){this.current.nodes.push({type:"severe",message:e});for(const e of this.stack)e.severe+=1}addWarning(e){this.current.nodes.push({type:"warning",message:e});for(const e of this.stack)e.warnings+=1}addUnused(e){this.current.nodes.push({type:"unused",message:e});for(const e of this.stack)e.unused+=1}assertError(e,t){e||this.addError(t)}assertSevere(e,t){e||this.addSevere(t)}assertWarning(e,t){e||this.addWarning(t)}assertUnused(e,t){e||this.addUnused(t)}}function yN(e,t,n){const a=t.name.toLowerCase().trim().split("-")[0].split(/\s+/);let r=a[0];const i=t.interval,s=i[1]-i[0],l=e.model.sequences;for(let t=0;t<n;t++){const n=l[t],a=n.interval;800===e.model.version&&(i[0]===a[0]?e.addSevere(`This sequence starts at the same frame as sequence ${t} "${n.name}"`):i[0]<a[1]&&e.addSevere(`This sequence starts before sequence ${t} "${n.name}" ends`))}"alternate"===r&&(r=a[1]),"stand"===r&&(e.foundStand=!0),"death"===r&&(e.foundDeath=!0),e.addImplicitReference(),e.assertWarning(oN.has(r),`"${r}" is not a standard name`),e.assertWarning(0!==s,"Zero length"),e.assertWarning(s>-1,`Negative length: ${s}`),vN(e,t.extent)}function SN(e,t){e.assertWarning(0!==t,"Zero length"),e.assertWarning(t>=0,`Negative length: ${t}`)}function TN(e,t){const n=t.replaceableId,a=t.path.toLowerCase(),r=hr(a);e.assertError(""===a||".blp"===r||".tga"===r||".tif"===r||".dds"===r,`Corrupted path: "${a}"`),e.assertError(0===n||uN.has(n),`Unknown replaceable ID: ${n}`),e.assertWarning(""===a||0===n,`Path "${a}" and replaceable ID ${n} used together`)}function xN(e,t){const n=t.layers,a=t.shader;e.model.version>800&&e.assertWarning(""===a||"Shader_SD_FixedFunction"===a||"Shader_HD_DefaultUnit"===a,`Unknown shader: "${a}"`),n.length?fN(e,n,EN):e.addWarning("No layers")}function EN(e,t){const n=e.model.textures,a=e.model.textureAnimations;for(const a of function(e){for(const t of e.animations)if("KMTF"===t.name)return jm(t.values.map((e=>e[0])));return[e.textureId]}(t))pN(e,n,a,"texture");const r=t.textureAnimationId;-1!==r&&pN(e,a,r,"texture animation");const i=t.filterMode;e.assertWarning(i>=0&&i<=6,`Invalid filter mode: ${t.filterMode}`)}function LN(e,t,n){const a=e.model.geosetAnimations,r=mN(e,e.model.materials,t.materialId,"material");let i=!1;if(r&&"Shader_HD_DefaultUnit"===r.shader&&(i=!0),!i){const n=22299;e.assertSevere(t.vertices.length<n,"Too many vertices in one geoset: "+t.vertices.length/3)}if(function(e,t){if(e.model.version>800&&t.skin.length){e.assertWarning(0===t.vertexGroups.length,"This geoset has both skin/weights and vertex groups");const n=t.skin;for(let t=0,a=n.length/8;t<a;t++){const a=8*t,r=n[a],i=n[a+1],s=n[a+2],l=n[a+3],o=n[a+4],u=n[a+5],c=n[a+6],d=n[a+7];o>0&&_N(e,t,r,!0),u>0&&_N(e,t,i,!0),c>0&&_N(e,t,s,!0),d>0&&_N(e,t,l,!0);const h=o+u+c+d;0===h?e.addSevere(`Vertex ${t}: Not attached to anything`):255!==h&&e.addSevere(`Vertex ${t}: The weights are not normalized to 1`)}}else if(e.model.bones.length){const n=t.vertexGroups,a=t.matrixGroups,r=t.matrixIndices,i=[];for(let e=0,t=a.length,n=0;e<t;e++)i.push(r.subarray(n,n+a[e])),n+=a[e];for(let t=0,a=n.length;t<a;t++){const a=i[n[t]];if(a)for(const n of a)_N(e,t,n,!1);else{const a=n[t];255===a?e.addSevere(`Vertex ${t}: Not attached to anything`):e.addSevere(`Vertex ${t}: Attached to vertex group ${a} which does not exist`)}}}}(e,t),a.length){const t=[];for(let e=0,r=a.length;e<r;e++)a[e].geosetId===n&&t.push(e);e.assertWarning(t.length<=1,`Referenced by ${t.length} geoset animations: ${t.join(", ")}`)}t.faces.length?e.addImplicitReference():e.addWarning("Zero faces"),t.sequenceExtents.length!==e.model.sequences.length&&800===e.model.version&&e.addWarning(`Number of sequence extents (${t.sequenceExtents.length}) does not match the number of sequences (${e.model.sequences.length})`),vN(e,t.extent);for(const n of t.sequenceExtents)vN(e,n)}function IN(e,t){const n=e.model.geosets,a=t.geosetId;e.addImplicitReference(),pN(e,n,a,"geoset")}function UN(e,t,n){const a=e.model.geosets,r=e.model.geosetAnimations,i=t.geosetId,s=t.geosetAnimationId;if(-1!==i&&pN(e,a,i,"geoset"),-1!==s&&pN(e,r,s,"geoset animation")){const t=r[s];-1!==i&&t.alpha<.1&&!function(e,t){for(const n of e.animations)if(n.name===t)return!0;return!1}(t,"KGAO")&&e.addSevere(`Referencing geoset ${i} and geoset animation ${s} with a 0 alpha, the geoset may be invisible`)}e.assertWarning(e.boneUsageMap.get(n)>0,"There are no vertices attached to this bone")}function RN(e,t){const n=t.attenuation;e.assertWarning(n[0]>=80,`Minimum attenuation should probably be bigger than or equal to 80, but is ${n[0]}`),e.assertWarning(n[1]<=200,`Maximum attenuation should probably be smaller than or equal to 200, but is ${n[1]}`),e.assertWarning(n[1]-n[0]>0,"The maximum attenuation should be bigger than the minimum, but isn't")}function MN(e,t){const n=t.path.toLowerCase();e.assertError(n.endsWith(".mdl")||n.endsWith(".mdx"),"Invalid path")}function CN(e,t){const n=t.replaceableId;pN(e,e.model.textures,t.textureId,"texture");const a=t.filterMode;e.assertWarning(a>=0&&a<=4,`Invalid filter mode: ${t.filterMode}`),e.assertError(0===n||uN.has(n),`Invalid replaceable ID: ${n}`),1048576&t.flags&&e.assertSevere(0!==t.speed&&0!==t.latitude,"XY Quad emitters must have a non-zero speed and latitude"),e.assertSevere(t.timeMiddle>=0&&t.timeMiddle<=1,`Expected time middle to be between 0 and 1, got ${t.timeMiddle}`),t.squirt&&!function(e,t){for(const n of e.animations)if(n.name===t)return n}(t,"KP2E")&&e.addSevere("Using squirt without animating the emission rate")}function BN(e,t){const n=t.path;n.length&&e.assertError(n.endsWith(".pkfx"),`Corrupted path: "${n}"`)}function PN(e,t){pN(e,e.model.materials,t.materialId,"material")}function kN(e,t){lN(e,t)}function ON(e,t){e.addImplicitReference()}function DN(e,t){const n=t.path;n.length&&e.assertError(n.endsWith(".facefx")||n.endsWith(".facefx_ingame"),`Corrupted face effect path: "${n}"`),e.addImplicitReference()}function FN(e,t){return{vertices:new Float32Array([-e,t,0,-e,-t,0,e,-t,0,e,t,0]),uvs:new Float32Array([0,0,0,1,1,1,1,0]),faces:new Uint16Array([0,1,2,0,2,3]),edges:new Uint16Array([0,1,1,2,2,3,3,0]),boundingRadius:Math.hypot(e,t)}}function GN(){return FN(1,1)}function NN(e,t,n){return{vertices:new Float32Array([-e,-t,-n,-e,-t,n,-e,t,-n,-e,t,n,e,t,-n,e,t,n,e,-t,-n,e,-t,n]),uvs:new Float32Array([0,0,0,1,.25,0,.25,1,.5,0,.5,1,.75,0,.75,1]),faces:new Uint16Array([0,1,2,1,3,2,2,3,4,3,5,4,4,5,6,5,7,6,6,7,0,7,1,0,0,2,4,0,4,6,1,5,3,1,7,5]),edges:new Uint16Array([0,1,2,3,4,5,6,7,0,2,2,4,4,6,6,0,1,3,3,5,5,7,7,1]),boundingRadius:Math.hypot(e,t,n)}}function VN(){return NN(1,1,1)}function HN(e,t,n){const a=(t+1)*(n+1),r=new Float32Array(3*a),i=new Float32Array(2*a),s=new Uint16Array(t*n*6),l=new Uint16Array(t*n*6);for(let a=0,s=0,l=0;a<=t;a++){const o=a*Math.PI/t,u=Math.sin(o),c=Math.cos(o);for(let o=0;o<=n;o+=1,s+=3,l+=2){const d=2*o*Math.PI/n,h=Math.sin(d),f=Math.cos(d);r[s+0]=f*u*e,r[s+1]=h*u*e,r[s+2]=c*e,i[l+0]=o/n,i[l+1]=1-a/t}}for(let e=0,a=0;e<t;e++)for(let t=0;t<n;t+=1,a+=6){const r=e*(n+1)+t,i=r+n+1;s[a+0]=r,s[a+1]=i,s[a+2]=r+1,s[a+3]=i,s[a+4]=i+1,s[a+5]=r+1,l[a+0]=r,l[a+1]=i,l[a+2]=r,l[a+3]=r+1,l[a+4]=i,l[a+5]=i+1}return{vertices:r,uvs:i,faces:s,edges:l,boundingRadius:e}}function YN(e,t){return HN(1,e,t)}function KN(e,t,n){const a=2*((n=Math.max(n,3))+1)+2,r=new Float32Array(3*a),i=new Float32Array(2*a),s=new Uint16Array(12*n),l=new Uint16Array(10*n),o=2*Math.PI/n;let u=0,c=0;for(let a=0;a<n+1;a+=1,u+=6,c+=4){const s=Math.cos(o*a)*e,l=Math.sin(o*a)*e,d=a/n;r[u+0]=s,r[u+1]=l,r[u+2]=t,r[u+3]=s,r[u+4]=l,r[u+5]=-t,i[c+0]=d,i[c+1]=1,i[c+2]=d,i[c+3]=0}r[u+0]=0,r[u+1]=0,r[u+2]=t,r[u+3]=0,r[u+4]=0,r[u+5]=-t,i[c+0]=0,i[c+1]=1,i[c+2]=0,i[c+3]=0;for(let e=0,t=0,r=0;e<n;e+=1,t+=12,r+=10){const n=2*e;s[t+0]=n+0,s[t+1]=n+1,s[t+2]=(n+3)%(a-2),s[t+3]=n+0,s[t+4]=(n+3)%(a-2),s[t+5]=(n+2)%(a-2),s[t+6]=n+0,s[t+7]=(n+2)%(a-2),s[t+8]=a-2,s[t+9]=n+1,s[t+10]=(n+3)%(a-2),s[t+11]=a-1,l[r+0]=n+0,l[r+1]=n+1,l[r+2]=n+0,l[r+3]=(n+2)%(a-2),l[r+4]=n+1,l[r+5]=(n+3)%(a-2),l[r+6]=n+0,l[r+7]=a-2,l[r+8]=n+1,l[r+9]=a-1}return{vertices:r,uvs:i,faces:s,edges:l,boundingRadius:Math.hypot(e,t)}}function zN(e){return KN(1,1,e)}function qN(e,t,n,a){const r=2*Math.tan(e/2),i=r*n/2,s=n*t/2,l=r*a/2,o=a*t/2;return{vertices:new Float32Array([-s,-i,n,-s,i,n,-o,-l,a,-o,l,a,o,-l,a,o,l,a,s,-i,n,s,i,n]),uvs:new Float32Array([0,0,0,1,.25,0,.25,1,.5,0,.5,1,.75,0,.75,1]),faces:new Uint16Array([0,1,2,1,3,2,2,3,4,3,5,4,4,5,6,5,7,6,6,7,0,7,1,0,0,2,4,0,4,6,1,5,3,1,7,5]),edges:new Uint16Array([0,1,2,3,4,5,6,7,0,2,2,4,4,6,6,0,1,3,3,5,5,7,7,1]),boundingRadius:Math.hypot(o,l)}}function ZN(e,t,n,a){if(n.length)for(const[r,i]of n.entries())i.writeMdl(e,t.version),a.push({name:hN(i,r),source:e.buffer}),e.clear()}function jN(e,t,n,a){if(n.length){const r=dN(n[0])+"s",i=[];ZN(e,t,n,i),t.saveStaticObjectsBlock(e,r,n),a.push({name:r,source:e.buffer,nodes:i}),e.clear()}}const XN={sanityTest:function(e){const t=new AN(e);!function(e){const t=e.model.version;800!==t&&900!==t&&1e3!==t&&e.addWarning(`Unknown version: ${t}`),900===t&&e.addError("Version 900 is not supported by Warcrft 3"),""!==e.model.animationFile&&e.addWarning(`The animation file should probably be empty, currently set to: "${e.model.animationFile}"`),vN(e,e.model.extent)}(t),function(e){const t=e.model.sequences;t.length?(fN(e,t,yN),e.assertSevere(e.foundStand,'Missing "Stand" sequence'),e.assertSevere(e.foundDeath,'Missing "Death" sequence')):e.addWarning("No sequences")}(t),fN(t,e.globalSequences,SN),function(e){const t=e.model.textures;t.length?fN(e,t,TN):e.addWarning("No textures")}(t),fN(t,e.materials,xN),fN(t,e.textureAnimations),fN(t,e.geosets,LN),fN(t,e.geosetAnimations,IN),fN(t,e.bones,UN),fN(t,e.lights,RN),fN(t,e.helpers),function(e){const t=e.model.attachments;let n=!1;for(const a of t){const t=a.path;if(t.length){const n=t.toLowerCase();e.assertError(n.endsWith(".mdl")||n.endsWith(".mdx"),`Invalid path "${t}"`)}a.name.startsWith("Origin Ref")&&(n=!0)}n||e.addWarning("Missing the Origin attachment point")}(t),function(e){const t=e.model.pivotPoints,n=e.objects;e.assertWarning(t.length===n.length,`Expected ${n.length} pivot points, got ${t.length}`)}(t),fN(t,e.particleEmitters,MN),fN(t,e.particleEmitters2,CN),e.version>800&&fN(t,e.particleEmittersPopcorn,BN),fN(t,e.ribbonEmitters,PN),fN(t,e.eventObjects,kN),fN(t,e.cameras,ON),fN(t,e.collisionShapes),e.version>800&&(fN(t,e.faceEffects,DN),function(e){const t=e.model.bindPose,n=e.objects;t.length&&n.length&&e.assertWarning(t.length===n.length+1,`Expected ${n.length+1} matrices, got ${t.length}`)}(t));const n=t.stack[0];wN(n);const{nodes:a,errors:r,severe:i,warnings:s}=n;let{unused:l}=n;for(const e of a)"node"===e.type&&0===e.uses&&(l+=1);return{type:"node",nodes:a,errors:r,severe:i,warnings:s,unused:l}},createPrimitive:function(e,t,n){let a,r,i,s=1;n&&(a=n.lines,r=n.color,i=n.texture,n.twoSided&&(s|=16));const l=new yi,o=l.extent,u=t.boundingRadius;o.min.fill(-u),o.max.fill(u),o.boundsRadius=u;const c=new ni;c.path="PLACEHOLDER",l.textures[0]=c;const d=new ti,h=new ei;h.textureId=0,h.flags=s,d.layers[0]=h,l.materials[0]=d;const f=new ri;f.vertices=t.vertices,f.uvSets[0]=t.uvs,f.matrixGroups=new Uint32Array([1]),f.matrixIndices=new Uint32Array([0]),f.vertexGroups=new Uint8Array(t.vertices.length/3);let m=4,p=t.faces;if(a&&(m=1,p=t.edges),f.faceTypeGroups=new Uint32Array([m]),f.faceGroups=new Uint32Array([p.length]),f.faces=p,l.geosets[0]=f,r){const e=new ii;e.geosetId=0,e.color=r,l.geosetAnimations[0]=e}const _=new li;return _.objectId=0,l.bones[0]=_,e.load(l,(e=>e===l?l:i))},primitives:f,mdlStructure:function(e){const t=new Yr,n=[];if(e.saveVersionBlock(t),n.push({name:"Version",source:t.buffer}),t.clear(),e.saveModelBlock(t),n.push({name:"Model",source:t.buffer}),t.clear(),jN(t,e,e.sequences,n),e.globalSequences.length&&(e.saveGlobalSequenceBlock(t),n.push({name:"GlobalSequences",source:t.buffer}),t.clear()),jN(t,e,e.textures,n),e.materials.length){const a=[];for(const[n,r]of e.materials.entries()){const i=[];ZN(t,e,r.layers,i),r.writeMdl(t,e.version),a.push({name:`Material ${n}`,source:t.buffer,nodes:i}),t.clear()}e.saveStaticObjectsBlock(t,"Materials",e.materials),n.push({name:"Materials",source:t.buffer,nodes:a}),t.clear()}return jN(t,e,e.textureAnimations,n),ZN(t,e,e.geosets,n),ZN(t,e,e.geosetAnimations,n),ZN(t,e,e.bones,n),ZN(t,e,e.lights,n),ZN(t,e,e.helpers,n),ZN(t,e,e.attachments,n),e.pivotPoints.length&&(e.savePivotPointBlock(t),n.push({name:"PivotPoints",source:t.buffer}),t.clear()),ZN(t,e,e.particleEmitters,n),ZN(t,e,e.particleEmitters2,n),ZN(t,e,e.particleEmittersPopcorn,n),ZN(t,e,e.ribbonEmitters,n),ZN(t,e,e.cameras,n),ZN(t,e,e.eventObjects,n),ZN(t,e,e.collisionShapes,n),ZN(t,e,e.faceEffects,n),e.bindPose.length&&(e.saveBindPoseBlock(t),n.push({name:"BindPose",source:t.buffer}),t.clear()),{nodes:n}}};function $N(e,t,n,a,r){if(a.has(t.name)){const n=a.get(t.name).args;for(const[a,i]of t.parameters.entries()){const{type:t,value:s}=i;if(1===t){for(const t of e.variables)if(t.name===s){n[a]=t.type;break}}else if(2===t){if(i.subParameters){const e=i.subParameters,t=r.getFunction(e.type,e.name);if(t){const e=t.returnType;e&&"AnyType"!==e&&(n[a]=e)}}}else if(3===t)if(s.startsWith("TRIGSTER_")||s.includes("\\"))n[a]="string";else if("true"===s||"false"===s)n[a]="boolean";else if(!isNaN(parseFloat(s))){const e=parseFloat(s);isNaN(e)||(Number.isInteger(e)&&!s.includes(".")?n[a]="integer":n[a]="real")}}}for(const n of t.parameters)2===n.type&&n.subParameters&&$N(e,n.subParameters,t,a,r);if(t instanceof Fu)for(const n of t.ecas)$N(e,n,t,a,r)}class JN{constructor(e,t){this.preplacedObjects=new Map,this.changes=[],this.stack=[],this.triggerData=e,this.stringTable=t}push(e){this.stack.unshift(e)}pop(){this.stack.shift()}change(e,t,n){this.changes.push({type:e,reason:t,data:n,stack:this.stackToString()})}stackToString(){return this.stack.map((e=>e instanceof Du?e.value:e.name)).reverse().join(" > ")}getTriggerName(){for(const e of this.stack)if(e instanceof Gu)return e.name;return""}updateGUIReference(e,t){if(e.startsWith("gg_unit")||e.startsWith("gg_dest")){const n=this.preplacedObjects;n.get(e)||n.set(e,t)}}saveGUIReferences(e,t){const n=[];for(const[e,t]of this.preplacedObjects)t||n.push(e);if(n.length){const a=new Gu;a.name="PreplacedObjectReferences",a.isEnabled=1,a.isInitiallyOff=1;for(const e of n){const t=new Fu;t.type=2,t.isEnabled=1,e.startsWith("gg_unit")?t.name="RemoveUnit":e.startsWith("gg_dest")&&(t.name="RemoveDestructable");const n=new Du;n.type=1,n.value=e,t.parameters[0]=n,a.ecas.push(t)}e.push(a),t.push(new Cu),this.change("references","Saved references to preplaced objects lost due to conversions",n.join("\n"))}}}function WN(e){return function(e,t){const n=new Fu;n.type=2,n.name=t?"CommentString":"CustomScriptCode",n.isEnabled=1;const a=new Du;return a.type=3,a.value=e,n.parameters[0]=a,n}(e,!1)}function QN(e,t){const n=new Fu;return n.name=e.name,n.type=e.type,n.group=t,n.isEnabled=1,n.parameters.push(...e.parameters),n}function eV(e){const t=[];for(const n of e)if("CustomScriptCode"===n.name){const e=n.parameters[0].value;if(Ba(e)>239){const a=Pa(e,239),r=a.length,i=r-1;for(let e=0;e<r;e++){let r="";e>0&&(r+="*/"),r+=a[e],e<i&&(r+="/*");const s=WN(r);s.group=n.group,t.push(s)}}else t.push(n)}else t.push(n);return t}function tV(e){return e.split("").map((e=>e.charCodeAt(0)>127?"_":e)).join("").replace(/\s/g,"_")}const nV=new Set(["OperatorCompareBoolean","OperatorCompareAbilityId","OperatorCompareBuffId","OperatorCompareDestructible","OperatorCompareDestructableCode","OperatorCompareButton","OperatorCompareGameDifficulty","OperatorCompareGameSpeed","OperatorCompareHeroSkill","OperatorCompareInteger","OperatorCompareItem","OperatorCompareItemType","OperatorCompareItemCode","OperatorCompareMouseButton","OperatorCompareMeleeDifficulty","OperatorCompareOrderCode","OperatorComparePlayer","OperatorComparePlayerColor","OperatorComparePlayerControl","OperatorComparePlayerSlotStatus","OperatorCompareRace","OperatorCompareReal","OperatorCompareString","OperatorCompareTechCode","OperatorCompareTerrainType","OperatorCompareTrigger","OperatorCompareUnit","OperatorCompareUnitCode","OperatorInt","OperatorReal"]),aV=new Set(["EnumDestructablesInRectAllMultiple","EnumDestructablesInCircleBJMultiple","EnumItemsInRectBJMultiple","ForForceMultiple","ForGroupMultiple"]);function rV(e,t,n){const a=tV(t.name),r=[],i=[],s=[];for(const e of t.ecas)0===e.type?r.push(e):1===e.type?i.push(e):s.push(e);const l=[];if(r.length||i.length||s.length){const t=[],o=[],u=[],c=`gg_trg_${a}`,d=new Du;d.type=3,d.value=c,t.push(`set ${c} = CreateTrigger()`);for(const a of r){a.parameters.unshift(d);for(const r of iV(e,a,n))t.push(r.parameters[0].value)}if(i.length){t.push(`call TriggerAddCondition(${c}, Condition(function Trig_${a}_Conditions)`);for(const t of i)for(const a of iV(e,t,n))o.push(`if ${a.parameters[0].value} then\r\n return true\r\nendif`)}if(s.length){t.push(`call TriggerAddAction(${c}, function Trig_${a}_Actions)`);for(const t of s)for(const a of iV(e,t,n))u.push(a.parameters[0].value)}u.length&&l.push(`function Trig_${a}_Actions takes nothing returns nothing\r\n${u.join("\r\n")}\r\nendfunction`),o.length&&l.push(`function Trig_${a}_Conditions takes nothing returns boolean\r\n${o.join("\r\n")}\r\nreturn false\r\nendfunction`),l.push(`function InitTrig_${a} takes nothing returns nothing\r\n${t.join("\r\n")}\r\nendfunction`)}return l.join("\r\n")}function iV(e,t,n){const a=t.name,r=[],i=t.parameters,s=e.triggerData.getFunction(t.type,t.name);if(!s)throw new Error(`Could not find a function signature: ${a}. Stack: ${e.stackToString()}`);let{args:l,scriptName:o}=s;const u=l.length;let c=!1,d=!1,h=!1;const f=t;if(o=o||t.name,u){const e=l[u-1];"code"===e||aV.has(a)?c=!0:"boolexpr"===e?d=!0:"scriptcode"===e&&(h=!0)}if("IfThenElse"===a)r.push(`if ${sV(e,i[0],l[0],n)} then`),r.push(`call ${sV(e,i[1],l[1],n)}`),r.push("else"),r.push(`call ${sV(e,i[2],l[2],n)}`),r.push("endif");else if("OrMultiple"===a)r.push(f.ecas.slice().map((t=>iV(e,t,n).map((e=>e.parameters[0].value)))).join(" or "));else if("AndMultiple"===a)r.push(f.ecas.slice().map((t=>iV(e,t,n).map((e=>e.parameters[0].value)))).join(" and "));else if("ForLoopAMultiple"===a||"ForLoopBMultiple"===a||"ForLoopVarMultiple"===a){let t,s="A";if("ForLoopBMultiple"===a?s="B":"ForLoopVarMultiple"===a&&(s="Var"),"A"===s||"B"===s){t=`bj_forLoop${s}Index`;const a=`${t}End`;r.push(`set ${t} = ${sV(e,i[0],l[0],n)}`),r.push(`set ${a} = ${sV(e,i[1],l[1],n)}`),r.push("loop"),r.push(`exitwhen ${t} > ${a}`)}else t=sV(e,i[0],l[0],n),r.push(`set ${t} = ${sV(e,i[1],l[1],n)}`),r.push("loop"),r.push(`exitwhen ${t} > ${sV(e,i[2],l[2],n)}`);for(const t of f.ecas){const a=iV(e,t,n);for(const e of a)r.push(`${e.parameters[0].value}`)}r.push(`set ${t} = ${t} + 1`),r.push("endloop")}else if("IfThenElseMultiple"===a){let t;const a=[],i=[];for(const e of f.ecas)0===e.group?t=e:1===e.group?a.push(e):2===e.group&&i.push(e);t&&r.push(`if ${iV(e,t,n)[0].parameters[0].value} then`);for(const t of a){const a=iV(e,t,n);for(const e of a)r.push(`${e.parameters[0].value}`)}if(i.length){r.push("else");for(const t of i){const a=iV(e,t,n);for(const e of a)r.push(`${e.parameters[0].value}`)}}r.push("endif")}else if(c||d){const a=`Trig_${tV(e.getTriggerName())}_Func${n.length}`;let s=`function ${a}`,u="nothing",c="call",h=i.length-1;const m=t.name.endsWith("Multiple");d&&(s=`Filter(${s})`,u="boolean",c="return"),m&&(h=i.length);const p=n.length;n[p]="NOTHING";const _=[...i.slice(0,h).map(((t,a)=>sV(e,t,l[a],n))),s];let g;t instanceof Fu?r.push(`call ${o}(${_.join(", ")})`):r.push(`${o}(${_.join(", ")})`),g=m?f.ecas.map((t=>iV(e,t,n).map((e=>e.parameters[0].value)).join("\r\n"))).join("\r\n"):`${c} ${sV(e,i[h],l[h],n)}`,n[p]=`function ${a} takes nothing returns ${u}\r\n${g}\r\nendfunction`}else h?r.push(sV(e,f.parameters[0],"scriptcode",n)):"SetVariable"===a?r.push(`set ${sV(e,i[0],l[0],n)} = ${sV(e,i[1],l[1],n)}`):"OperatorString"===a?r.push(`${sV(e,i[0],l[0],n)} + ${sV(e,i[1],l[1],n)}`):nV.has(a)?r.push(`${sV(e,i[0],l[0],n)} ${sV(e,i[1],l[1],n)} ${sV(e,i[2],l[2],n)}`):"CommentString"===a?r.push(`// ${i[0].value}`):"GetBooleanAnd"===a?r.push(`(${sV(e,i[0],l[0],n)} and ${sV(e,i[1],l[1],n)})`):"GetBooleanOr"===a?r.push(`(${sV(e,i[0],l[0],n)} or ${sV(e,i[1],l[1],n)})`):t instanceof Fu?(0===t.type&&(l=["trigger",...l]),r.push(`call ${o}(${i.map(((t,a)=>sV(e,t,l[a],n))).join(", ")})`)):t instanceof Ou&&r.push(`${o}(${i.map(((t,a)=>sV(e,t,l[a],n))).join(", ")})`);return r.map((e=>WN(e)))}function sV(e,t,n,a){const{type:r,value:i}=t;if(0===r){const t=e.triggerData.getPreset(i);if(void 0===t)throw new Error(`Failed to find a preset: "${i}"`);return t}if(1===r){if(i.startsWith("gg_"))return e.updateGUIReference(i,!1),i;{let n=`udg_${i}`;return t.isArray&&t.arrayIndex&&(n+=`[${sV(e,t.arrayIndex,"integer",a)}]`),n}}if(2===t.type)return iV(e,t.subParameters,a)[0].parameters[0].value;if(3===t.type){const t=e.triggerData.getBaseType(n);if("string"===t&&"scriptcode"!==n){if(i.startsWith("TRIGSTR")&&e.stringTable){const t=e.stringTable.getString(i);if(void 0!==t)return`"${t.replace(/\r\n/g,"\\r\n")}"`;e.change("missingstring","Entry not found in the string table",i)}return`"${i.replace(/\\/g,"\\\\")}"`}return"integer"===t&&isNaN(parseInt(i))?`'${i}'`:i}return""}function lV(e,t,n){return sV(e,t,n,[])}function oV(e,t,n,a,r){const i=t.parameters,s=[];a.test&&s.push(a.test),a.tests&&s.push(...a.tests);for(const[t,a]of s)if(void 0===r[t]&&(r[t]=lV(e,i[t],n[t])),a!==r[t])return!1;return!0}function uV(e,t,n){if(t.name=n,t.type=e.triggerData.getFunctionType(n),t instanceof Ou){e.stack[1].value=n}}function cV(e,t,n,a){if(a.parameters){const r=t.parameters;t.parameters=a.parameters.map((t=>{if("number"==typeof t)return r[t];if("string"==typeof t){const n=new Du;return e.triggerData.getPreset(t)?n.type=0:n.type=3,n.value=t,n}{const e=t[0],a=t[1],i=t[2],s=n[e];let l,o;if("integer"===s)l="OperatorInt";else{if("real"!==s)throw new Error(`Attempted to use an operator on a non-number parameter of type "${s}`);l="OperatorReal"}o="+"===a?"OperatorAdd":"-"===a?"OperatorSubtract":"*"===a?"OperatorMultiply":"OperatorDivide";const u=new Du;u.value=l,u.type=2;const c=new Ou;c.name=l,c.type=3;const d=r[e],h=new Du;h.type=0,h.value=o;const f=new Du;return f.type=3,f.value=`${i}`,c.beginParameters=1,c.parameters=[d,h,f],u.subParameters=c,u}}))}}function dV(e){return function(t,n){const a=t.triggerData.getFunction(n.type,n.name);if(!a)return console.warn(`transformer failed to get the signature for the input function: ${n.name}`),!1;const r=a.args,i=[];for(const[a,s]of Object.entries(e)){let e;e=Array.isArray(s)?s:[s];for(const s of e)if(oV(t,n,r,s,i))return uV(t,n,a),cV(t,n,r,s),!0}return!1}}function hV(e,t){const n=e.stack[1],a=e.stack[2],r=a.parameters;if("OperatorCompareBoolean"!==a.name)return!1;let i;i=a.parameters[0]===n?r[2]:r[0];const s=lV(e,i,"boolean");if("true"!==s&&"false"!==s)return!1;a.name="OperatorComparePlayer";const l=t.parameters[1];return n.value="GetOwningPlayer",t.name="GetOwningPlayer",t.parameters.length=1,r[0]=n,r[1].value="true"===s?"OperatorEqualENE":"OperatorNotEqualENE",r[2]=l,!0}function fV(e,t){const n=e.stack[1],a=e.stack[2],r=a.parameters;if("OperatorCompareBoolean"!==a.name)return!1;let i;i=a.parameters[0]===n?r[2]:r[0];const s=lV(e,i,"boolean");if("true"!==s&&"false"!==s)return!1;a.name="OperatorCompareRace";const l=t.parameters[1];n.value="GetUnitRace",t.name="GetUnitRace",t.parameters.length=1,r[0]=n;const o="OperatorEqualENE"===r[1].value,u="true"===s;return r[1].value=o===u?"OperatorEqualENE":"OperatorNotEqualENE",r[1]=l,!0}function mV(e,t){if("OperatorCompareBoolean"!==e.stack[2].name)return!1;if("UNIT_TYPE_DEAD"!==lV(e,t.parameters[1],"unittype"))return!1;return e.stack[1].value="IsUnitDeadBJ",t.name="IsUnitDeadBJ",t.parameters.length=1,!0}let pV,_V=!1;function gV(e){return dV({[e]:{}})}function bV(e){return function(t){return dV({[t]:{parameters:e}})}}function wV(e,t){_V||function(){if(!_V){_V=!0;const e=bV([1,0]),t=bV([1,0,2]),n=bV([1,2,0]),a=bV([2,0,1]),r=bV([2,1,0]),i=bV([0,2,3,1]),s=bV([1,0,2,3]),l=bV([3,0,1,2]),o=bV([3,2,0,1]),u=bV([3,2,1,0]);pV={UnitId:gV("String2UnitIdBJ"),UnitId2String:gV("UnitId2StringBJ"),GetObjectName:gV("GetAbilityName"),Sin:dV({SinBJ:{parameters:[[0,"/",Math.PI/180]]}}),Cos:dV({CosBJ:{parameters:[[0,"/",Math.PI/180]]}}),Tan:dV({TanBJ:{parameters:[[0,"/",Math.PI/180]]}}),GetHandleId:gV("GetHandleIdBJ"),SubString:dV({SubStringBJ:{parameters:[0,[1,"+",1],2]}}),StringHash:gV("StringHashBJ"),GetLocalizedString:gV("StringIdentity"),SetMapFlag:dV({LockGameSpeedBJ:{tests:[[0,"MAP_LOCK_SPEED"],[1,"true"]],parameters:[]},UnlockGameSpeedBJ:{tests:[[0,"MAP_LOCK_SPEED"],[1,"false"]],parameters:[]}}),SetPlayerColor:dV({SetPlayerColorBJ:{parameters:[0,1,"PlayerChangeColorRetain"]}}),SetPlayerAlliance:i("SetPlayerAllianceBJ"),SetPlayerTaxRate:o("SetPlayerTaxRateBJ"),SetPlayerOnScoreScreen:e("SetPlayerOnScoreScreenBJ"),GetPlayerTaxRate:a("GetPlayerTaxRateBJ"),TimerStart:dV({StartTimerBJ:{test:[3,"null"],parameters:[0,2,1]}}),PauseTimer:dV({PauseTimerBJ:{parameters:["PauseResumePause",0]}}),ResumeTimer:dV({PauseTimerBJ:{parameters:["PauseResumeResume",0]}}),GroupAddUnit:e("GroupAddUnitSimple"),GroupRemoveUnit:e("GroupRemoveUnitSimple"),GroupImmediateOrderById:gV("GroupTrainOrderByIdBJ"),ForceAddPlayer:e("ForceAddPlayerSimple"),ForceRemovePlayer:e("ForceRemovePlayerSimple"),GetWorldBounds:gV("GetEntireMapRect"),TriggerRegisterTimerEvent:dV({TriggerRegisterTimerEventPeriodic:{test:[2,"true"],parameters:[0,1]},TriggerRegisterTimerEventSingle:{test:[2,"false"],parameters:[0,1]}}),TriggerRegisterTimerExpireEvent:gV("TriggerRegisterTimerExpireEventBJ"),TriggerRegisterGameStateEvent:dV({TriggerRegisterGameStateEventTimeOfDay:{test:[1,"GAME_STATE_TIME_OF_DAY"],parameters:[0,2,3]}}),TriggerRegisterDialogEvent:gV("TriggerRegisterDialogEventBJ"),TriggerRegisterGameEvent:dV({TriggerRegisterShowSkillEventBJ:{test:[1,"EVENT_GAME_SHOW_SKILL"],parameters:[0]},TriggerRegisterBuildSubmenuEventBJ:{test:[1,"EVENT_GAME_BUILD_SUBMENU"],parameters:[0]},TriggerRegisterGameLoadedEventBJ:{test:[1,"EVENT_GAME_LOADED"],parameters:[0]},TriggerRegisterGameSavedEventBJ:{test:[1,"EVENT_GAME_SAVE"],parameters:[0]}}),GetClickedButton:gV("GetClickedButtonBJ"),GetClickedDialog:gV("GetClickedDialogBJ"),TriggerRegisterPlayerEvent:dV({TriggerRegisterPlayerKeyEventBJ:[{test:[2,"EVENT_PLAYER_ARROW_LEFT_DOWN"],parameters:[0,1,"KeyEventTypeDepress","KeyEventKeyLeft"]},{test:[2,"EVENT_PLAYER_ARROW_RIGHT_DOWN"],parameters:[0,1,"KeyEventTypeDepress","KeyEventKeyRight"]},{test:[2,"EVENT_PLAYER_ARROW_DOWN_DOWN"],parameters:[0,1,"KeyEventTypeDepress","KeyEventKeyDown"]},{test:[2,"EVENT_PLAYER_ARROW_UP_DOWN"],parameters:[0,1,"KeyEventTypeDepress","KeyEventKeyUp"]},{test:[2,"EVENT_PLAYER_ARROW_LEFT_UP"],parameters:[0,1,"KeyEventTypeRelease","KeyEventKeyLeft"]},{test:[2,"EVENT_PLAYER_ARROW_RIGHT_UP"],parameters:[0,1,"KeyEventTypeRelease","KeyEventKeyRight"]},{test:[2,"EVENT_PLAYER_ARROW_DOWN_UP"],parameters:[0,1,"KeyEventTypeRelease","KeyEventKeyDown"]},{test:[2,"EVENT_PLAYER_ARROW_UP_UP"],parameters:[0,1,"KeyEventTypeRelease","KeyEventKeyUp"]}],TriggerRegisterPlayerMouseEventBJ:[{test:[2,"EVENT_PLAYER_MOUSE_DOWN"],parameters:[0,1,"MouseEventTypeDown"]},{test:[2,"EVENT_PLAYER_MOUSE_UP"],parameters:[0,1,"MouseEventTypeUp"]},{test:[2,"EVENT_PLAYER_MOUSE_MOVE"],parameters:[0,1,"MouseEventTypeMove"]}],TriggerRegisterPlayerEventVictory:{test:[2,"EVENT_PLAYER_VICTORY"],parameters:[0,1]},TriggerRegisterPlayerEventDefeat:{test:[2,"EVENT_PLAYER_DEFEAT"],parameters:[0,1]},TriggerRegisterPlayerEventLeave:{test:[2,"EVENT_PLAYER_LEAVE"],parameters:[0,1]},TriggerRegisterPlayerEventAllianceChanged:{test:[2,"EVENT_PLAYER_ALLIANCE_CHANGED"],parameters:[0,1]},TriggerRegisterPlayerEventEndCinematic:{test:[2,"EVENT_PLAYER_END_CINEMATIC"],parameters:[0,1]}}),TriggerRegisterPlayerUnitEvent:dV({TriggerRegisterPlayerUnitEventSimple:{test:[3,"null"],parameters:[0,1,2]}}),GetLearnedSkill:gV("GetLearnedSkillBJ"),GetKillingUnit:gV("GetKillingUnitBJ"),GetTransportUnit:gV("GetTransportUnitBJ"),GetLoadedUnit:gV("GetLoadedUnitBJ"),GetIssuedOrderId:gV("GetIssuedOrderIdBJ"),TriggerRegisterUnitStateEvent:dV({TriggerRegisterUnitLifeEvent:{test:[1,"UNIT_STATE_LIFE"],parameters:[0,2,3]},TriggerRegisterUnitManaEvent:{test:[1,"UNIT_STATE_MANA"],parameters:[0,2,3]}}),TriggerWaitForSound:gV("WaitForSoundBJ"),GetWidgetLife:gV("GetItemLifeBJ"),SetWidgetLife:gV("SetItemLifeBJ"),SetDestructableInvulnerable:gV("SetDestructableInvulnerableBJ"),IsDestructableInvulnerable:gV("IsDestructableInvulnerableBJ"),EnumDestructablesInRect:dV({EnumDestructablesInRectAll:{test:[1,"null"],parameters:[0,2]}}),SetDestructableMaxLife:gV("SetDestructableMaxLifeBJ"),QueueDestructableAnimation:gV("QueueDestructableAnimationBJ"),SetDestructableAnimation:gV("SetDestructableAnimationBJ"),SetDestructableAnimationSpeed:dV({SetDestAnimationSpeedPercent:{parameters:[0,[1,"*",100]]}}),ShowDestructable:e("ShowDestructableBJ"),GetTriggerDestructable:gV("GetDyingDestructable"),SetItemDropOnDeath:gV("SetItemDropOnDeathBJ"),SetItemDroppable:gV("SetItemDroppableBJ"),SetItemPlayer:gV("SetItemPlayerBJ"),SetItemInvulnerable:gV("SetItemInvulnerableBJ"),SetItemVisible:e("SetItemVisibleBJ"),IsItemOwned:dV({CheckItemStatus:{parameters:[0,"ItemStatusOwned"]}}),IsItemPowerup:dV({CheckItemStatus:{parameters:[0,"ItemStatusPowerup"]}}),IsItemSellable:dV({CheckItemStatus:{parameters:[0,"ItemStatusSellable"]}}),IsItemPawnable:dV({CheckItemStatus:{parameters:[0,"ItemStatusPawnable"]}}),IsItemIdPowerup:dV({CheckItemcodeStatus:{parameters:[0,"ItemcodeStatusPowerup"]}}),IsItemIdSellable:dV({CheckItemcodeStatus:{parameters:[0,"ItemcodeStatusSellable"]}}),IsItemIdPawnable:dV({CheckItemcodeStatus:{parameters:[0,"ItemcodeStatusPawnable"]}}),EnumItemsInRect:dV({EnumItemsInRectBJ:{test:[1,"null"],parameters:[0,2]}}),ShowUnit:dV({ShowUnitShow:{test:[1,"true"],parameters:[0]},ShowUnitHide:{test:[1,"false"],parameters:[0]}}),SetUnitState:dV({SetUnitLifeBJ:{test:[1,"UNIT_STATE_LIFE"],parameters:[0,2]},SetUnitManaBJ:{test:[1,"UNIT_STATE_MANA"],parameters:[0,2]}}),SetUnitFlyHeight:gV("SetUnitFlyHeightBJ"),SetUnitTurnSpeed:gV("SetUnitTurnSpeedBJ"),SetUnitAcquireRange:gV("SetUnitAcquireRangeBJ"),SetUnitCreepGuard:dV({LockGuardPosition:{test:[1,"true"],parameters:[0]}}),GetUnitDefaultPropWindow:gV("GetUnitDefaultPropWindowBJ"),SetUnitScale:dV({SetUnitScalePercent:{parameters:[0,[1,"*",100],[2,"*",100],[3,"*",100]]}}),SetUnitTimeScale:dV({SetUnitTimeScalePercent:{parameters:[0,[1,"*",100]]}}),SetUnitBlendTime:gV("SetUnitBlendTimeBJ"),QueueUnitAnimation:gV("QueueUnitAnimationBJ"),SetUnitAnimation:dV({ResetUnitAnimation:{test:[1,'"stand"'],parameters:[0]}}),AddUnitAnimationProperties:r("AddUnitAnimationPropertiesBJ"),SetHeroStr:dV({ModifyHeroStat:{test:[2,"true"],parameters:["HeroStatStr",0,"ModifyMethodSet",1]}}),SetHeroAgi:dV({ModifyHeroStat:{test:[2,"true"],parameters:["HeroStatAgi",0,"ModifyMethodSet",1]}}),SetHeroInt:dV({ModifyHeroStat:{test:[2,"true"],parameters:["HeroStatInt",0,"ModifyMethodSet",1]}}),GetHeroStr:dV({GetHeroStatBJ:{parameters:["HeroStatStr",0,1]}}),GetHeroAgi:dV({GetHeroStatBJ:{parameters:["HeroStatAgi",0,1]}}),GetHeroInt:dV({GetHeroStatBJ:{parameters:["HeroStatInt",0,1]}}),UnitModifySkillPoints:dV({ModifyHeroSkillPoints:{parameters:[0,"0",1]}}),AddHeroXP:t("AddHeroXPSwapped"),GetUnitAbilityLevel:e("GetUnitAbilityLevelSwapped"),DecUnitAbilityLevel:e("DecUnitAbilityLevelSwapped"),IncUnitAbilityLevel:e("IncUnitAbilityLevelSwapped"),SetUnitAbilityLevel:t("SetUnitAbilityLevelSwapped"),SetUnitExploded:gV("SetUnitExplodedBJ"),PauseUnit:e("PauseUnitBJ"),IsUnitPaused:gV("IsUnitPausedBJ"),SelectUnit:dV({SelectUnitAdd:{test:[1,"true"],parameters:[0]},SelectUnitRemove:{test:[1,"false"],parameters:[0]}}),UnitAddItem:e("UnitAddItemSwapped"),UnitRemoveItem:e("UnitRemoveItemSwapped"),UnitRemoveItemFromSlot:dV({UnitRemoveItemFromSlotSwapped:{parameters:[0,[1,"+",1]]}}),UnitItemInSlot:dV({UnitItemInSlotBJ:{parameters:[0,[1,"+",1]]}}),UnitInventorySize:gV("UnitInventorySizeBJ"),UnitDropItemSlot:dV({UnitDropItemSlotBJ:{parameters:[0,1,[2,"+",1]]}}),UnitDropItemTarget:gV("UnitDropItemTargetBJ"),GetUnitState:e("GetUnitStateSwap"),SetUnitUseFood:e("SetUnitUseFoodBJ"),IsUnitOwnedByPlayer:hV,IsUnitRace:fV,IsUnitType:mV,IsUnitHidden:gV("IsUnitHiddenBJ"),IsUnitIllusion:gV("IsUnitIllusionBJ"),IsUnitInTransport:gV("IsUnitInTransportBJ"),IsUnitLoaded:gV("IsUnitLoadedBJ"),UnitShareVision:a("UnitShareVisionBJ"),UnitSuspendDecay:e("UnitSuspendDecayBJ"),UnitAddType:e("UnitAddTypeBJ"),UnitRemoveType:e("UnitRemoveTypeBJ"),UnitAddAbility:e("UnitAddAbilityBJ"),UnitRemoveAbility:e("UnitRemoveAbilityBJ"),UnitRemoveBuffs:dV({UnitRemoveBuffsBJ:[{tests:[[1,"true"],[2,"false"]],parameters:["BuffTypePositive",0]},{tests:[[1,"false"],[2,"true"]],parameters:["BuffTypeNegative",0]},{tests:[[1,"true"],[2,"true"]],parameters:["BuffTypeAll",0]}]}),UnitRemoveBuffsEx:dV({UnitRemoveBuffsBJ:{tests:[[1,"true"],[2,"true"],[3,"false"],[4,"false"],[5,"false"],[6,"true"],[7,"false"]],parameters:["BuffTypeNonTLife",0]}}),UnitAddSleep:gV("UnitSetCanSleepBJ"),UnitCanSleep:gV("UnitCanSleepBJ"),UnitIsSleeping:gV("UnitIsSleepingBJ"),UnitWakeUp:gV("UnitWakeUpBJ"),UnitApplyTimedLife:r("UnitApplyTimedLifeBJ"),UnitPauseTimedLife:e("UnitPauseTimedLifeBJ"),UnitSetUsesAltIcon:e("UnitSetUsesAltIconBJ"),UnitDamageTarget:dV({UnitDamageTargetBJ:{tests:[[3,"true"],[4,"false"],[7,"WEAPON_TYPE_WHOKNOWS"]],parameters:[0,1,2,5,6]}}),IssueImmediateOrderById:gV("IssueTrainOrderByIdBJ"),AddResourceAmount:e("AddResourceAmountBJ"),WaygateActivate:e("WaygateActivateBJ"),WaygateIsActive:gV("WaygateIsActiveBJ"),AddItemToStock:s("AddItemToStockBJ"),AddUnitToStock:s("AddUnitToStockBJ"),RemoveItemFromStock:e("RemoveItemFromStockBJ"),RemoveUnitFromStock:e("RemoveUnitFromStockBJ"),Player:dV({ConvertedPlayer:{parameters:[[0,"+",1]]}}),SetPlayerHandicap:dV({SetPlayerHandicapBJ:{parameters:[0,[1,"*",100]]}}),SetPlayerHandicapXP:dV({SetPlayerHandicapXPBJ:{parameters:[0,[1,"*",100]]}}),SetPlayerTechMaxAllowed:n("SetPlayerTechMaxAllowedSwap"),GetPlayerTechMaxAllowed:e("GetPlayerTechMaxAllowedSwap"),SetPlayerTechResearched:n("SetPlayerTechResearchedSwap"),GetPlayerTechCount:dV({GetPlayerTechCountSimple:{test:[2,"true"],parameters:[1,0]}}),SetPlayerAbilityAvailable:r("SetPlayerAbilityAvailableBJ"),FogMaskEnable:dV({FogMaskEnableOn:{test:[0,"true"],parameters:[]},FogMaskEnableOff:{test:[0,"false"],parameters:[]}}),FogEnable:dV({FogEnableOn:{test:[0,"true"],parameters:[]},FogEnableOff:{test:[0,"false"],parameters:[]}}),SetCampaignMenuRace:dV({SetCampaignMenuRaceBJ:[{test:[0,"RACE_OTHER"],parameters:["CampaignIndexT"]},{test:[0,"RACE_HUMAN"],parameters:["CampaignIndexH"]},{test:[0,"RACE_UNDEAD"],parameters:["CampaignIndexU"]},{test:[0,"RACE_ORC"],parameters:["CampaignIndexO"]},{test:[0,"RACE_NIGHTELF"],parameters:["CampaignIndexN"]}]}),SetCampaignMenuRaceEx:dV({SetCampaignMenuRaceBJ:[{test:[0,"bj_CAMPAIGN_OFFSET_XN"],parameters:["CampaignIndexXN"]},{test:[0,"bj_CAMPAIGN_OFFSET_XH"],parameters:["CampaignIndexXH"]},{test:[0,"bj_CAMPAIGN_OFFSET_XU"],parameters:["CampaignIndexXU"]},{test:[0,"bj_CAMPAIGN_OFFSET_XO"],parameters:["CampaignIndexXO"]}]}),LoadGame:gV("LoadGameBJ"),RenameSaveDirectory:gV("RenameSaveDirectoryBJ"),RemoveSaveDirectory:gV("RemoveSaveDirectoryBJ"),CopySaveGame:gV("CopySaveGameBJ"),GetFloatGameState:dV({GetTimeOfDay:{test:[0,"GAME_STATE_TIME_OF_DAY"],parameters:[]}}),SetFloatGameState:dV({SetTimeOfDay:{test:[0,"GAME_STATE_TIME_OF_DAY"],parameters:[1]}}),SetCustomCampaignButtonVisible:dV({ShowCustomCampaignButton:{parameters:[[0,"+",1],1]}}),GetCustomCampaignButtonVisible:dV({IsCustomCampaignButtonVisibile:{parameters:[[0,"+",1]]}}),DialogClear:gV("DialogClearBJ"),DialogSetMessage:gV("DialogSetMessageBJ"),DialogDisplay:r("DialogDisplayBJ"),InitGameCache:gV("InitGameCacheBJ"),SaveGameCache:gV("SaveGameCacheBJ"),StoreInteger:u("StoreIntegerBJ"),StoreReal:u("StoreRealBJ"),StoreBoolean:u("StoreBooleanBJ"),StoreUnit:u("StoreUnitBJ"),StoreString:u("StoreStringBJ"),HaveStoredBoolean:dV({HaveStoredValue:{parameters:[2,"CacheValueTypeBoolean",1,0]}}),HaveStoredInteger:dV({HaveStoredValue:{parameters:[2,"CacheValueTypeInteger",1,0]}}),HaveStoredReal:dV({HaveStoredValue:{parameters:[2,"CacheValueTypeReal",1,0]}}),HaveStoredUnit:dV({HaveStoredValue:{parameters:[2,"CacheValueTypeUnit",1,0]}}),HaveStoredString:dV({HaveStoredValue:{parameters:[2,"CacheValueTypeString",1,0]}}),FlushGameCache:gV("FlushGameCacheBJ"),FlushStoredMission:e("FlushStoredMissionBJ"),GetStoredInteger:r("GetStoredIntegerBJ"),GetStoredReal:r("GetStoredRealBJ"),GetStoredBoolean:r("GetStoredBooleanBJ"),GetStoredString:r("GetStoredStringBJ"),InitHashtable:gV("InitHashtableBJ"),SaveInteger:u("SaveIntegerBJ"),SaveReal:u("SaveRealBJ"),SaveBoolean:u("SaveBooleanBJ"),SaveStr:u("SaveStringBJ"),SavePlayerHandle:u("SavePlayerHandleBJ"),SaveWidgetHandle:u("SaveWidgetHandleBJ"),SaveDestructableHandle:u("SaveDestructableHandleBJ"),SaveItemHandle:u("SaveItemHandleBJ"),SaveUnitHandle:u("SaveUnitHandleBJ"),SaveAbilityHandle:u("SaveAbilityHandleBJ"),SaveTimerHandle:u("SaveTimerHandleBJ"),SaveTriggerHandle:u("SaveTriggerHandleBJ"),SaveTriggerConditionHandle:u("SaveTriggerConditionHandleBJ"),SaveTriggerActionHandle:u("SaveTriggerActionHandleBJ"),SaveTriggerEventHandle:u("SaveTriggerEventHandleBJ"),SaveForceHandle:u("SaveForceHandleBJ"),SaveGroupHandle:u("SaveGroupHandleBJ"),SaveLocationHandle:u("SaveLocationHandleBJ"),SaveRectHandle:u("SaveRectHandleBJ"),SaveBooleanExprHandle:u("SaveBooleanExprHandleBJ"),SaveSoundHandle:u("SaveSoundHandleBJ"),SaveEffectHandle:u("SaveEffectHandleBJ"),SaveUnitPoolHandle:u("SaveUnitPoolHandleBJ"),SaveItemPoolHandle:u("SaveItemPoolHandleBJ"),SaveQuestHandle:u("SaveQuestHandleBJ"),SaveQuestItemHandle:u("SaveQuestItemHandleBJ"),SaveDefeatConditionHandle:u("SaveDefeatConditionHandleBJ"),SaveTimerDialogHandle:u("SaveTimerDialogHandleBJ"),SaveLeaderboardHandle:u("SaveLeaderboardHandleBJ"),SaveMultiboardHandle:u("SaveMultiboardHandleBJ"),SaveMultiboardItemHandle:u("SaveMultiboardItemHandleBJ"),SaveTrackableHandle:u("SaveTrackableHandleBJ"),SaveDialogHandle:u("SaveDialogHandleBJ"),SaveButtonHandle:u("SaveButtonHandleBJ"),SaveTextTagHandle:u("SaveTextTagHandleBJ"),SaveLightningHandle:u("SaveLightningHandleBJ"),SaveImageHandle:u("SaveImageHandleBJ"),SaveUbersplatHandle:u("SaveUbersplatHandleBJ"),SaveRegionHandle:u("SaveRegionHandleBJ"),SaveFogStateHandle:u("SaveFogStateHandleBJ"),SaveFogModifierHandle:u("SaveFogModifierHandleBJ"),LoadInteger:r("LoadIntegerBJ"),LoadReal:r("LoadRealBJ"),LoadBoolean:r("LoadBooleanBJ"),LoadStr:r("LoadStringBJ"),LoadPlayerHandle:r("LoadPlayerHandleBJ"),LoadWidgetHandle:r("LoadWidgetHandleBJ"),LoadDestructableHandle:r("LoadDestructableHandleBJ"),LoadItemHandle:r("LoadItemHandleBJ"),LoadUnitHandle:r("LoadUnitHandleBJ"),LoadAbilityHandle:r("LoadAbilityHandleBJ"),LoadTimerHandle:r("LoadTimerHandleBJ"),LoadTriggerHandle:r("LoadTriggerHandleBJ"),LoadTriggerConditionHandle:r("LoadTriggerConditionHandleBJ"),LoadTriggerActionHandle:r("LoadTriggerActionHandleBJ"),LoadTriggerEventHandle:r("LoadTriggerEventHandleBJ"),LoadForceHandle:r("LoadForceHandleBJ"),LoadGroupHandle:r("LoadGroupHandleBJ"),LoadLocationHandle:r("LoadLocationHandleBJ"),LoadRectHandle:r("LoadRectHandleBJ"),LoadBooleanExprHandle:r("LoadBooleanExprHandleBJ"),LoadSoundHandle:r("LoadSoundHandleBJ"),LoadEffectHandle:r("LoadEffectHandleBJ"),LoadUnitPoolHandle:r("LoadUnitPoolHandleBJ"),LoadItemPoolHandle:r("LoadItemPoolHandleBJ"),LoadQuestHandle:r("LoadQuestHandleBJ"),LoadQuestItemHandle:r("LoadQuestItemHandleBJ"),LoadDefeatConditionHandle:r("LoadDefeatConditionHandleBJ"),LoadTimerDialogHandle:r("LoadTimerDialogHandleBJ"),LoadLeaderboardHandle:r("LoadLeaderboardHandleBJ"),LoadMultiboardHandle:r("LoadMultiboardHandleBJ"),LoadMultiboardItemHandle:r("LoadMultiboardItemHandleBJ"),LoadTrackableHandle:r("LoadTrackableHandleBJ"),LoadDialogHandle:r("LoadDialogHandleBJ"),LoadButtonHandle:r("LoadButtonHandleBJ"),LoadTextTagHandle:r("LoadTextTagHandleBJ"),LoadLightningHandle:r("LoadLightningHandleBJ"),LoadImageHandle:r("LoadImageHandleBJ"),LoadUbersplatHandle:r("LoadUbersplatHandleBJ"),LoadRegionHandle:r("LoadRegionHandleBJ"),LoadFogStateHandle:r("LoadFogStateHandleBJ"),LoadFogModifierHandle:r("LoadFogModifierHandleBJ"),HaveSavedBoolean:dV({HaveSavedValue:{parameters:[2,"HashtableValueTypeBoolean",1,0]}}),HaveSavedInteger:dV({HaveSavedValue:{parameters:[2,"HashtableValueTypeInteger",1,0]}}),HaveSavedReal:dV({HaveSavedValue:{parameters:[2,"HashtableValueTypeReal",1,0]}}),HaveSavedString:dV({HaveSavedValue:{parameters:[2,"HashtableValueTypeString",1,0]}}),HaveSavedHandle:dV({HaveSavedValue:{parameters:[2,"HashtableValueTypeHandle",1,0]}}),FlushParentHashtable:gV("FlushParentHashtableBJ"),FlushChildHashtable:e("FlushChildHashtableBJ"),ChooseRandomCreep:gV("ChooseRandomCreepBJ"),ChooseRandomNPBuilding:gV("ChooseRandomNPBuildingBJ"),ChooseRandomItem:gV("ChooseRandomItemBJ"),ChooseRandomItemEx:e("ChooseRandomItemExBJ"),ResetTerrainFog:gV("ResetTerrainFogBJ"),SetTerrainFogEx:dV({SetTerrainFogExBJ:{parameters:[0,1,2,3,[4,"*",100],[5,"*",100],[6,"*",100]]}}),SetTimeOfDayScale:dV({SetTimeOfDayScalePercentBJ:{parameters:[[0,"*",100]]}}),PauseGame:dV({PauseGameOn:{test:[0,"true"],parameters:[]},PauseGameOff:{test:[0,"false"],parameters:[]}}),DestroyTextTag:gV("DestroyTextTagBJ"),SetTextTagPosUnit:gV("SetTextTagPosUnitBJ"),SetTextTagSuspended:gV("SetTextTagSuspendedBJ"),SetTextTagPermanent:gV("SetTextTagPermanentBJ"),SetTextTagAge:gV("SetTextTagAgeBJ"),SetTextTagLifespan:gV("SetTextTagLifespanBJ"),SetTextTagFadepoint:gV("SetTextTagFadepointBJ"),DestroyQuest:gV("DestroyQuestBJ"),QuestSetTitle:gV("QuestSetTitleBJ"),QuestSetDescription:gV("QuestSetDescriptionBJ"),QuestSetCompleted:gV("QuestSetCompletedBJ"),QuestSetDiscovered:gV("QuestSetDiscoveredBJ"),QuestSetFailed:gV("QuestSetFailedBJ"),QuestSetEnabled:e("QuestSetEnabledBJ"),QuestItemSetDescription:gV("QuestItemSetDescriptionBJ"),QuestItemSetCompleted:gV("QuestItemSetCompletedBJ"),DestroyDefeatCondition:gV("DestroyDefeatConditionBJ"),DefeatConditionSetDescription:gV("DefeatConditionSetDescriptionBJ"),FlashQuestDialogButton:gV("FlashQuestDialogButtonBJ"),DestroyTimerDialog:gV("DestroyTimerDialogBJ"),TimerDialogSetTitle:gV("TimerDialogSetTitleBJ"),TimerDialogDisplay:e("TimerDialogDisplayBJ"),DestroyLeaderboard:gV("DestroyLeaderboardBJ"),LeaderboardDisplay:e("LeaderboardDisplayBJ"),LeaderboardRemovePlayerItem:e("LeaderboardRemovePlayerItemBJ"),LeaderboardSortItemsByValue:dV({LeaderboardSortItemsBJ:{parameters:[0,"LeaderboardSortByValue",1]}}),LeaderboardSortItemsByPlayer:dV({LeaderboardSortItemsBJ:{parameters:[0,"LeaderboardSortByPlayer",1]}}),LeaderboardSortItemsByLabel:dV({LeaderboardSortItemsBJ:{parameters:[0,"LeaderboardSortByLabel",1]}}),LeaderboardHasPlayerItem:gV("LeaderboardHasPlayerItemBJ"),LeaderboardSetLabel:gV("LeaderboardSetLabelBJ"),PlayerGetLeaderboard:gV("PlayerGetLeaderboardBJ"),LeaderboardSetStyle:gV("LeaderboardSetStyleBJ"),DestroyMultiboard:gV("DestroyMultiboardBJ"),MultiboardDisplay:e("MultiboardDisplayBJ"),MultiboardMinimize:e("MultiboardMinimizeBJ"),CameraSetupGetField:e("CameraSetupGetFieldSwap"),CameraSetSmoothingFactor:gV("CameraSetSmoothingFactorBJ"),DisplayCineFilter:gV("DisplayCineFilterBJ"),ForceCinematicSubtitles:gV("ForceCinematicSubtitlesBJ"),SetSoundDistanceCutoff:gV("SetSoundDistanceCutoffBJ"),SetSoundPitch:gV("SetSoundPitchBJ"),AttachSoundToUnit:gV("AttachSoundToUnitBJ"),StopSound:dV({StopSoundBJ:{test:[1,"false"],parameters:[0,2]}}),KillSoundWhenDone:gV("KillSoundWhenDoneBJ"),SetMapMusic:dV({SetMapMusicIndexedBJ:{test:[1,"false"],parameters:[0,2]},SetMapMusicRandomBJ:{tests:[[1,"true"],[2,"0"]],parameters:[0]}}),ClearMapMusic:gV("ClearMapMusicBJ"),PlayMusic:gV("PlayMusicBJ"),StopMusic:gV("StopMusicBJ"),ResumeMusic:gV("ResumeMusicBJ"),PlayThematicMusic:gV("PlayThematicMusicBJ"),EndThematicMusic:gV("EndThematicMusicBJ"),VolumeGroupSetVolume:dV({VolumeGroupSetVolumeBJ:{parameters:[0,[1,"*",100]]}}),AddWeatherEffect:gV("AddWeatherEffectSaveLast"),RemoveWeatherEffect:gV("RemoveWeatherEffectBJ"),AddSpecialEffectLoc:e("AddSpecialEffectLocBJ"),AddSpecialEffectTarget:r("AddSpecialEffectTargetUnitBJ"),DestroyEffect:gV("DestroyEffectBJ"),DestroyLightning:gV("DestroyLightningBJ"),GetLightningColorA:gV("GetLightningColorABJ"),GetLightningColorR:gV("GetLightningColorRBJ"),GetLightningColorG:gV("GetLightningColorGBJ"),GetLightningColorB:gV("GetLightningColorBBJ"),SetLightningColor:gV("SetLightningColorBJ"),GetAbilityEffectById:gV("GetAbilityEffectBJ"),GetAbilitySoundById:gV("GetAbilitySoundBJ"),ShowImage:e("ShowImageBJ"),ShowUbersplat:e("ShowUbersplatBJ"),SetBlightRect:a("SetBlightRectBJ"),SetBlightLoc:l("SetBlightRadiusLocBJ"),SetDoodadAnimationRect:dV({SetDoodadAnimationRectBJ:{test:[3,"false"],parameters:[2,1,0]}})}}}();const n=pV[t.name];return n?n(e,t):function(e,t){const n=t.name;if(!function(e){return"GetTriggerPlayerMouseX"===e||"GetTriggerPlayerMouseY"===e||"GetTriggerPlayerMousePosition"===e||"GetTriggerPlayerMouseButton"===e||"SetAbilityTooltip"===e||"SetAbilityExtendedTooltip"===e||"SetAbilityResearchTooltip"===e||"SetAbilityResearchExtendedTooltip"===e||"GetAbilityTooltip"===e||"GetAbilityExtendedTooltip"===e||"GetAbilityResearchTooltip"===e||"GetAbilityResearchExtendedTooltip"===e||"SetAbilityIcon"===e||"GetAbilityIcon"===e||"GetAbilityPosX"===e||"GetAbilityPosY"===e||"SetAbilityPosX"===e||"SetAbilityPosY"===e||"GetUnitMaxHP"===e||"SetUnitMaxHP"===e||"GetUnitMaxMana"===e||"SetUnitMaxMana"===e||"SetItemName"===e||"SetItemDescription"===e||"GetItemDescription"===e||"SetItemTooltip"===e||"GetItemTooltip"===e||"SetItemExtendedTooltip"===e||"GetItemExtendedTooltip"===e||"SetItemIconPath"===e||"GetItemIconPath"===e||"SetUnitName"===e||"SetHeroProperName"===e||"GetUnitBaseDamage"===e||"SetUnitBaseDamage"===e||"GetUnitDiceNumber"===e||"SetUnitDiceNumber"===e||"GetUnitDiceSides"===e||"SetUnitDiceSides"===e||"GetUnitAttackCooldown"===e||"SetUnitAttackCooldown"===e||"SetSpcialEffectColorByPlayer"===e||"SetSpecialEffectColor"===e||"SetSpecialEffectAlpha"===e||"SetSpecialEffectScale"===e||"SetSpecialEffectPosition"===e||"SetSpecialEffectHeight"===e||"SetSpecialEffectTimeScale"===e||"SetSpecialEffectTime"===e||"SetSpecialEffectOrientation"===e||"SetSpecialEffectYaw"===e||"SetSpecialEffectPitch"===e||"SetSpecialEffectRoll"===e||"SetSpecialEffectX"===e||"SetSpecialEffectY"===e||"SetSpecialEffectZ"===e||"SetSpecialEffectPositionLoc"===e||"GetLocalSpecialEffectX"===e||"GetLocalSpecialEffectY"===e||"GetLocalSpecialEffectZ"===e||"GetUnitArmor"===e||"SetUnitArmor"===e||"UnitHideAbility"===e||"UnitDisableAbility"===e||"UnitCancelTimedLife"===e||"IsUnitSelectable"===e||"IsUnitInvulnerable"===e||"UnitInterruptAttack"===e||"GetUnitCollisionSize"===e||"GetAbilityManaCost"===e||"GetAbilityCooldown"===e||"SetUnitAbilityCooldown"===e||"GetUnitAbilityCooldown"===e||"GetUnitAbilityCooldownRemaining"===e||"EndUnitAbilityCooldown"===e||"GetUnitAbilityManaCost"===e||"SetEventDamage"===e||"PlaySpecialEffect"===e||"PlaySpecialEffectWithTimeScale"===e}(n))return!1;t.name=`Blz${n}`,t instanceof Ou&&(e.stack[1].value=`Blz${n}`);const a=t.parameters;return"GetAbilityIcon"!==n&&"SetAbilityIcon"!==n||3!==a.length||a.pop(),!0}(e,t)}let vV,AV=!1;function yV(e){return function(t,n){const a=new Ou;return a.name=e,a.type=t.triggerData.getFunctionType(e),n.value=e,n.type=2,n.subParameters=a,!0}}function SV(e,t){AV||AV||(AV=!0,vV={bj_forLoopAIndex:yV("GetForLoopIndexA"),bj_forLoopBIndex:yV("GetForLoopIndexB"),bj_queuedExecTotal:yV("QueuedTriggerCountBJ"),bj_mapInitialCameraBounds:yV("GetCameraBoundsMapRect"),bj_mapInitialPlayableArea:yV("GetPlayableMapRect"),bj_lastCreatedWeatherEffect:yV("GetLastCreatedWeatherEffect"),bj_lastCreatedTerrainDeformation:yV("GetLastCreatedTerrainDeformation"),bj_lastCreatedLightning:yV("GetLastCreatedLightningBJ"),bj_lastCreatedFogModifier:yV("GetLastCreatedFogModifier"),bj_lastCreatedImage:yV("GetLastCreatedImage"),bj_lastCreatedUbersplat:yV("GetLastCreatedUbersplat"),bj_lastPlayedSound:yV("GetLastPlayedSound"),bj_lastPlayedMusic:yV("GetLastPlayedMusic"),bj_useDawnDuskSounds:yV("IsDawnDuskEnabled"),bj_lastCreatedEffect:yV("GetLastCreatedEffectBJ"),bj_lastCreatedItem:yV("GetLastCreatedItem"),bj_lastRemovedItem:yV("GetLastRemovedItem"),bj_lastCreatedUnit:yV("GetLastCreatedUnit"),bj_lastReplacedUnit:yV("GetLastReplacedUnitBJ"),bj_lastCreatedDestructable:yV("GetLastCreatedDestructable"),bj_FORCE_ALL_PLAYERS:yV("GetPlayersAll"),bj_lastCreatedButton:yV("GetLastCreatedButtonBJ"),bj_lastCreatedQuest:yV("GetLastCreatedQuestBJ"),bj_lastCreatedQuestItem:yV("GetLastCreatedQuestItemBJ"),bj_lastCreatedDefeatCondition:yV("GetLastCreatedDefeatConditionBJ"),bj_lastStartedTimer:yV("GetLastCreatedTimerBJ"),bj_lastCreatedTimerDialog:yV("GetLastCreatedTimerDialogBJ"),bj_lastCreatedLeaderboard:yV("GetLastCreatedLeaderboard"),bj_lastCreatedMultiboard:yV("GetLastCreatedMultiboard"),bj_lastCreatedTextTag:yV("GetLastCreatedTextTag"),bj_lastTransmissionDuration:yV("GetLastTransmissionDurationBJ"),bj_lastCreatedGameCache:yV("GetLastCreatedGameCacheBJ"),bj_lastCreatedHashtable:yV("GetLastCreatedHashtableBJ"),bj_lastLoadedUnit:yV("GetLastRestoredUnitBJ"),bj_lastHauntedGoldMine:yV("GetLastHauntedGoldMine")});const n=vV[t.value];return!!n&&n(e,t)}function TV(e,t,n){e.push(t);const a=[],r=[];for(const e of t.ecas){const t=e.type;0===t||1===t?a.push(e):2===t&&r.push(e)}const i=[];for(const t of a){const a=xV(e,t,n);if(a.convert)return e.pop(),a;i.push(t)}for(const t of r){const a=xV(e,t,n);if(a.convert){const r=iV(e,t,n);e.change("inlinecustomscript",a.reason,r.map((e=>e.parameters[0].value)).join("\n")),i.push(...r)}else i.push(t)}return t.ecas=eV(i),e.pop(),{convert:!1,reason:""}}function xV(e,t,n){e.push(t);const a=EV(e,t,n);if(a.convert){const r=a.reason;if(!function(e){if("IfThenElse"===e.name){const t=e.parameters,n=QN(t[0].subParameters,0),a=QN(t[1].subParameters,1),r=QN(t[2].subParameters,2);return e.name="IfThenElseMultiple",e.parameters.length=0,e.ecas.push(n,a,r),!0}if("ForGroup"===e.name||"ForForce"===e.name){const t=QN(e.parameters[1].subParameters,0);return e.name=`${e.name}Multiple`,e.parameters.length=1,e.ecas.push(t),!0}return!1}(t))return e.pop(),a;{const a=EV(e,t,n);if(a.convert)return e.pop(),a;e.change("singletomultiple",r,t.name)}}const r=[];for(const a of t.ecas){const s=xV(e,a,n);if(s.convert){let l;if(i=t.name,0!==a.group||"AndMultiple"!==i&&"OrMultiple"!==i&&"IfThenElseMultiple"!==i)l=iV(e,a,n);else{let r,i,s=iV(e,a,n)[0].parameters[0].value;s.startsWith("call ")&&(s=s.slice(5)),"OrMultiple"===t.name?(r=s,i="true"):(r=`not (${s})`,i="false"),l=[WN(`if ${r} then`),WN(`return ${i}`),WN("endif")]}for(const e of l)e.group=a.group;e.change("inlinecustomscript",s.reason,l.map((e=>e.parameters[0].value)).join("\n")),r.push(...l)}else r.push(a)}var i;return t.ecas=eV(r),e.pop(),{convert:!1,reason:""}}function EV(e,t,n){const a=t.name;if(wV(e,t)&&e.change("inlinegui",a,t.name),!e.triggerData.isBaseFunction(t.type,t.name))return{convert:!0,reason:t.name};for(const a of t.parameters){if(0===a.type&&e.triggerData.isCustomPreset(a.value)){const t=a.value;if(!SV(e,a))return{convert:!0,reason:t};e.change("inlinepreset",t,a.value)}const t=LV(e,a,n);if(t.convert)return t}return{convert:!1,reason:""}}function LV(e,t,n){e.push(t);const a=t.type,r=t.value;if(1===a)r.startsWith("gg_")&&e.updateGUIReference(r,!0);else if(2===a){const a=function(e,t,n){e.push(t);const a=EV(e,t,n);if(a.convert)return e.pop(),a;return e.pop(),{convert:!1,reason:""}}(e,t.subParameters,n);if(a.convert)return e.pop(),a}const i=t.arrayIndex;if(i){const t=LV(e,i,n);if(t.convert)return e.pop(),t}return e.pop(),{convert:!1,reason:""}}function IV(e){return e.endsWith(".mdx")||e.endsWith(".mdl")}function UV(e){return e.endsWith(".blp")||e.endsWith(".dds")||e.endsWith(".tga")}function RV(e,t){t.length>6&&(IV(t)||UV(t)||function(e){return e.endsWith(".wav")||e.endsWith(".mp3")||e.endsWith(".slk")||e.endsWith(".txt")}(t))&&(t.endsWith(".mdl")&&(t=`${t.slice(0,-4)}.mdx`),e.push(t.replace(/\\\\/g,"\\")))}const MV={convertWeu:function(e,t,n){let a,r,i;try{a=e.readStringTable()}catch(e){return{ok:!1,error:`Failed to read the string table file: ${e}`}}if(!a)return{ok:!1,error:"The string table file doesn't exist"};const s=e.getScriptFile();if(s&&s.name.endsWith(".j"))try{t.addJassFunctions(s.text())}catch(e){}const l=new JN(t,a);try{r=function(e,t,n){let a;const r=new Map;let i,s,l=!0;for(;l;)try{a=e.readTriggers(t),l=!1}catch(e){if(e instanceof Error){const n=e.message;if(n.endsWith("Unknown signature")){const e=n.lastIndexOf('"'),a=n.lastIndexOf('"',e-1)+1,l=n.slice(a,e),[o,u]=l.split(":"),c=parseInt(u),d={args:[],scriptName:null,returnType:3===c?"AnyType":null};i=o.toLowerCase(),s=d,r.set(o,d),t.externalFunctions[c][i]=s}else i&&s&&(s.args.push("AnyType"),s.args.length>20&&(l=!1))}}if(r.size){if(a)for(const e of a.triggers)for(const n of e.ecas)$N(a,n,0,r,t);for(const[e,t]of r)n.change("unknownsignature","Unknown signature",`${e}(${t.args.join(", ")}) => ${t.returnType?t.returnType:"void"}`)}return a}(e,t,l)}catch(e){return{ok:!1,error:`Failed to read the triggers file: ${e}`}}if(!r)return{ok:!1,error:"The triggers file doesn't exist"};try{i=e.readCustomTextTriggers()}catch(e){return{ok:!1,error:`Failed to read the custom text triggers file: ${e}`}}if(!i)return{ok:!1,error:"The custom text triggers file doesn't exist"};const o=r.triggers,u=i.triggers,c=i.trigger;if(u.length<o.length)for(let e=0,t=o.length-u.length;e<t;e++)u.push(new Cu);for(let e=0,t=o.length;e<t;e++){const t=o[e],n=[];try{const a=TV(l,t,n);if(a.convert){l.push(t);let r=rV(l,t,n);n.length&&(r=`${n.join("\r\n")}\r\n${r}`),u[e].text=r,t.ecas.length=0,t.isCustom=1,l.change("convertedtrigger",a.reason,u[e].text),l.pop()}else if(n.length){const e=n.join("\r\n");c.text+=`// Callbacks generated for trigger "${t.name}" due to conversions\r\n${e}\r\n`,l.change("generatedcallbacks",t.name,e)}}catch(e){return{ok:!1,error:`Error at ${l.stackToString()}: ${e}`}}}l.saveGUIReferences(o,u),e.set("war3map.wtg",r.save()),e.set("war3map.wct",i.save());try{r=e.readTriggers(n)}catch(e){return{ok:!1,error:`Failed to validate the triggers file: ${e}`}}return r?{ok:!0,changes:l.changes}:{ok:!1,error:"Failed to re-read the triggers file"}},generateListfile:function(e){const t=["(listfile)","(signature)","(attributes)","war3map.w3e","war3map.w3i","war3map.wtg","war3map.wct","war3map.wts","war3map.j","scripts\\war3map.j","war3map.lua","scripts\\war3map.lua","war3map.shd","war3mapMap.blp","war3mapMap.b00","war3mapMap.tga","war3mapPreview.tga","war3map.mmp","war3mapPath.tga","war3map.wpm","war3map.doo","war3mapUnits.doo","war3map.w3r","war3map.w3c","war3map.w3s","war3map.w3u","war3map.w3t","war3map.w3a","war3map.w3b","war3map.w3d","war3map.w3q","war3mapMisc.txt","war3mapSkin.txt","war3mapExtra.txt","war3map.imp"];let n=e.get("(listfile)");if(n)try{const e=n.text().split(/\r\n/g);for(const n of e)t.push(n.trim())}catch(e){console.warn("(listfile)",e)}for(const a of[".w3u",".w3t",".w3b",".w3d",".w3a",".w3h",".w3q"])if(n=e.get("war3map"+a),n)try{const e=n.bytes();let r;r=".w3d"===a||".w3q"===a||".w3a"===a?new Ru:new Mu,r.load(e);const i=[r.originalTable,r.customTable];for(const e of i)for(const n of e.objects)for(const e of n.modifications)3===e.variableType&&RV(t,e.value)}catch(e){console.warn(n.name,e)}if(n=e.get("war3map.w3s"),n)try{const e=n.bytes(),a=new vc;a.load(e);for(const e of a.sounds)t.push(e.file)}catch(e){console.warn("war3map.w3s",e)}if(n=e.get("war3map.j")||e.get("Scripts\\war3map.j")||e.get("war3map.lua")||e.get("Scripts\\war3map.lua"),n)try{const e=n.text(),a=new xc(e);let r;for(;void 0!==(r=a.read());)'"'===r[0]&&RV(t,r.slice(1,-1))}catch(e){console.warn(n.name,e)}if(n=e.get("war3mapSkin.txt"),n)try{const e=n.text(),a=new wr;a.load(e);for(const e of a.sections.values())for(const n of e.values())for(const e of n.split(","))RV(t,e)}catch(e){console.warn("war3mapSkin.txt",e)}if(n=e.get("war3map.imp"),n)try{const e=n.bytes(),a=new Eu;a.load(e);for(const e of a.entries.keys())t.push(e)}catch(e){console.warn("war3map.imp",e)}if(n=e.get("war3map.w3i"),n)try{const e=n.bytes(),a=new Ju;a.load(e),RV(t,a.loadingScreenModel),RV(t,a.prologueScreenModel)}catch(e){console.warn("war3map.w3i",e)}for(let e=0,n=t.length;e<n;e++){const n=t[e];IV(n)&&t.push(`${n.slice(0,-4)}_portrait.mdx`)}for(let n=0,a=t.length;n<a;n++){const a=t[n];if(IV(a)){const n=e.get(a);if(n)try{const e=n.bytes(),a=new yi;a.load(e);for(const e of a.textures)e.path.length&&t.push(e.path);for(const e of a.attachments)RV(t,e.path);for(const e of a.particleEmitters)RV(t,e.path)}catch(e){console.warn(a,e)}}}for(let e=0,n=t.length;e<n;e++){const n=t[e];UV(n)&&t.push(`ReplaceableTextures\\CommandButtonsDisabled\\DIS${dr(n)}`)}return new Set(t)}},CV={version:"5.9.24",common:br,parsers:Ld,viewer:hp,utils:{blp:mp,dds:pp,MappedData:Hh,jass2:aN,mdlx:XN,w3x:MV}}})(),ModelViewer=a})();